/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class datetime
    open core

    predicates
        classInfo : core::classInfo.
        % @short Class information  predicate. 
        % @detail This predicate represents information predicate of this class.
        % @end

% year -> acc. no of leap years up to and incl. year
datAccLeap : (integer Y, integer N) determ (i,o).
% year, day_no_in_year --> month no
datDayInMonth : (integer Y,integer DayNo,integer Month) determ (i,i,o).
% internal date --> day no in week (Monday=1)
datWeekDay : (integer No,integer DayNo) procedure (i,o).
% DD MM YYYY -> day no in year (1 Jan = 1)
datDayNo : (integer DD,integer MM,integer YYYY,integer DayNo) determ (i,i,i,o).
% Year --> 1 (leap year) 0 (not leap year)
datLeapYear : (integer,integer) procedure (i,o).
% between MMM and month no
datMonthNo : (string,integer) determ (i,o) (o,i).
% from DD MM YYYY to internal date no 
datDMY_to_I : (integer,integer,integer,integer) determ (i,i,i,o).
% from internal date no to DD MM YYYY
datI_to_DMY : (integer,integer,integer,integer) determ (i,o,o,o).
% DD MM YYYY -> Pro/3 text
datS : (integer,integer,integer,string)  determ (i,i,i,o).
% Pro/3 text -> internal date no
datS_to_I : (string,integer) determ (i,o).
% text (any format) -> internal date no
datStrAny : (string,integer) determ (i,o).
% YY[YY] -> YYYY
datYYYY : (integer,integer) procedure (i,o).

timCmp : (integer,integer,integer,integer,integer) procedure (i,i,i,i,o).
timNow : (integer,integer) determ (o,o).
timDurText : (integer,integer,integer,integer,string) determ (i,i,i,i,o).

% succeeds if <T1> <opr> <T2> is true.
tsCmp : (string,integer_list,integer_list) determ.
% converts from timestamp integer list format to string format
tsStrIL : (integer_list,string) determ (i,o).
% returns current timestamp
tsNow : (integer_list) procedure (o).
% returns the difference between two time stamps in days, hours, minutes and seconds
tsDiff : (integer_list,integer_list,integer,integer,integer,integer) determ (i,i,o,o,o,o).
% returns difference between two time stamps in whole second *** CANNOT HANDLE MONTH CROSSINGS
tsDiffSecs : (integer_list,integer_list,integer) determ (i,i,o). 
% timestamp -> date-time text formats
tsStr : (integer_list,string) determ (i,o).
tsSQL : (integer_list,string) determ (i,o). 
tsXML : (integer_list,string) determ (i,o). 

tmrSet : (integer) determ.
tmrExpired : () determ.
end class datetime