/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class dirgraph : dirgraph
open core,termDomain

/*
dirgraph is a class of directed graph objects. Each node in the graph consists of one type-term and one name-term. 
Each edge has a status-term which may or may not be of significance. The graph can upon creation be marked as
acyclic, and attempts to introduce cycles will then fail (but not give error message). 
Note:
- There can be at most one edge from node A to node B (regardless of Status)
- Edges from a node to itself is NOT alowed.
*/

constructors
new : ().
new : (integer Acyclic).

predicates
classInfo : core::classInfo.
getName : (sterm,string) procedure (i,o).
copyGraph : (dirgraph,dirgraph) procedure (i,o).

end class dirgraph