/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

interface dirgraph
open core,termDomain

predicates

isAcyclic : () -> integer.
allNodes : () -> termSet.

get_nd : (sterm Name1,sterm Name2) nondeterm (o,o).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) nondeterm (i,o,o,o).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) nondeterm (o,o,i,o).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) nondeterm (i,i,o,o).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) nondeterm (o,o,i,i).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) nondeterm (o,o,o,o).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) nondeterm (i,o,o,o,o).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) nondeterm (i,i,o,o,i).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) nondeterm (o,o,i,i,i).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) nondeterm (o,o,i,o,i).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) nondeterm (o,o,o,o,i).
get_nd : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) nondeterm (o,o,o,o,o).

has : (sterm Status) determ.
has : (sterm Name1,sterm Name2) determ.
has : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) determ (i,i,i,i).
has : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) determ (i,o,o,o).
has : (sterm Type1,sterm Name1,sterm Type2,sterm Name2) determ (o,o,i,o).
has : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status) determ.
hasAsPred : (sterm,sterm) determ.
hasAsSucc : (sterm,sterm) determ.

add : (sterm,sterm) determ.
add : (sterm,sterm,sterm,sterm) determ.
add : (sterm,sterm,sterm,sterm,sterm) determ.

changeType : (sterm,sterm).
replace : (sterm FromType,sterm FromName,sterm ToType,sterm ToName).

setStatus : (sterm).
setStatus : (sterm,sterm).
setStatus : (sterm,sterm,sterm,sterm,sterm).
setStatusWherePred : (sterm,sterm,sterm).
setStatusWherePred : (sterm,sterm,sterm,sterm).
setStatusWhereSucc : (sterm,sterm,sterm).
setStatusWhereSucc : (sterm,sterm,sterm,sterm).

delete : (sterm Type1,sterm Name1,sterm Type2,sterm Name2).
delete : (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status).
deleteAll : ().
deleteAllWherePred : (sterm Type).
deleteAllWherePred : (sterm Type1,sterm Name1).
deleteAllWhereSucc : (sterm Type1).
deleteAllWhereSucc : (sterm Type1,sterm Name1).
deleteNode : (sterm Type,sterm Name).
deleteNodeType : (sterm).
deleteStartNodes : ().
deleteWhereStatus : (sterm).

complementSet : (termSet) -> termSet. % returns the complement of the given set
excludeSet : (termSet). % removes all members of the set from the graph
includeSet : (termSet). % reduces the graph to members of the set

% hiding node involves removing the node from the graph, but inserting edges between the node's
% predecessors and successors in its place, e.g. from:
% X->N   Y->N   N->A   N->B  to:
% X->A  X->B  Y->A  Y->B
%
submerge : (sterm Type,sterm Name,sterm Status). % set inserted edges with given Status
submergeP : (sterm Type,sterm Name). %  set inserted edges with predecessor's Status
submergeS : (sterm Type,sterm Name). % set inserted edges with successor's Status
% hide all nodes of given type
submergeType : (sterm Type). % set inserted edges with predecessor's Status
submergeType : (sterm Type,sterm Status). % set inserted edges with given Status
submergeTypeP : (sterm Type). %  set inserted edges with predecessor's Status
submergeTypeS : (sterm Type). % set inserted edges with successor's Status

acyclicNodes : () -> termSet.
cyclicNodes : () -> termSet.
cycleSet : (sterm,sterm,sterml) determ (i,i,o).

endNodeNames : () -> termSet.
endNodes : () -> termSet.
startNodeNames : () -> termSet.
startNodes : () -> termSet.

serial : () -> termSet.

succs : (sterm,sterm) -> termSet.
succsRec : (sterm,sterm) -> termSet determ.
succsRec : (integer,sterm,sterm) -> termSet determ.
preds : (sterm,sterm) -> termSet.
predsRec : (sterm,sterm) -> termSet determ.
predsRec : (integer,sterm,sterm) -> termSet determ.

cascadeStatusBack : (sterm). 
cascadeStatusForward : (sterm). 

drwVisio : (string SymbolFile,string OutputFile,string Annotation,visioSymbol_CALLBACK,visioLink_CALLBACK) determ.

% old:
drawVisioDetailed : (string HeaderFile,string OutFile) determ.
resetVisio : ().
setVisio : (integer_list,integer_list,sterml,string_list) determ.

end interface dirgraph