/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class guix
open core

predicates
classInfo : core::classInfo.

addWin : (integer WinClass,vpiDomains::windowHandle W) procedure.
addWin : (integer WinClass,string Name,vpiDomains::windowHandle W) procedure.
addWin : (integer WinClass,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo) procedure.
defaultText : (string Actual,string Default) -> string.
dropWin : (vpiDomains::windowHandle W) procedure.
getWinAll : (integer WinClass,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo,integer No) nondeterm (i,o,o,o,o,o).
getWinAll : (integer WinClass,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo,integer No) nondeterm (i,i,o,o,o,o).
getWinAll : (integer WinClass,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo,integer No) nondeterm (o,o,o,o,o,o).
getWinAll : (integer WinClass,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo,integer No) nondeterm (o,o,i,o,o,o).
getWinAll : (integer WinClass,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo,integer No) nondeterm (o,o,o,i,i,o).
getWinOfClas : (integer Clas) -> vpiDomains::windowHandle nondeterm.
getWinOfName : (string Name) -> vpiDomains::windowHandle nondeterm.
getWin : (vpiDomains::windowHandle W,integer No) determ (i,o) (o,i).
getWinName : (vpiDomains::windowHandle W) -> string determ.
getWinClas : (vpiDomains::windowHandle W) -> integer determ.
getWinNo : (vpiDomains::windowHandle W,integer Clas,integer SolNo,integer TabNo) determ (i,o,o,o).
setWin : (integer Clas,string Name,vpiDomains::windowHandle W,integer SolNo,integer TabNo,integer No) determ. 
succ : (vpiDomains::windowHandle) -> vpiDomains::windowHandle determ.
pred : (vpiDomains::windowHandle) -> vpiDomains::windowHandle determ.
existWin : (string Name) determ.
getCount : () -> integer.
setPixelAdjust : (integer,integer).
getPixelAdjust : (integer,integer) procedure (o,o).
ctlSetState : (vpiDomains::windowHandle W,core::integer_list Ctls,vpiDomains::wsFlags FL) procedure (i,i,i).
ctlDisable : (vpiDomains::windowHandle W,core::integer_list Ctls) procedure (i,i).
ctlEnable : (vpiDomains::windowHandle W,core::integer_list Ctls) procedure (i,i).
ctlInvisible : (vpiDomains::windowHandle W,core::integer_list Ctls) procedure (i,i).
ctlVisible : (vpiDomains::windowHandle W,core::integer_list Ctls) procedure (i,i).
guiCtlWins : (vpiDomains::windowHandle W,core::integer_list Ctls,vpiDomains::winlist) procedure (i,i,o).
guiCB_Get : (vpiDomains::windowHandle W,integer Ctl,integer OnOff) determ (i,i,o).
guiCB_Set : (vpiDomains::windowHandle W,integer Ctl,integer OnOff) determ.
guiRB_Get : (vpiDomains::windowHandle W,integer_list Ctls,integer_list Nos,integer N) determ (i,i,i,o).
guiRB_GetF : (vpiDomains::windowHandle W,integer_list Ctls,integer_list Nos,integer N) determ (i,i,i,o).
guiRB_Set : (vpiDomains::windowHandle W,integer_list Ctls) determ.
guiRB_SetN : (vpiDomains::windowHandle W,integer_list Ctls,integer_list Nos,integer N) determ.

lbtGet : (vpiDomains::windowHandle,integer,string) procedure (i,i,o).
lbtGetF : (vpiDomains::windowHandle,integer,string) determ (i,i,o).
lbtSel : (vpiDomains::windowHandle,integer,string) determ (i,i,i).
lbtSelF : (vpiDomains::windowHandle,integer,string) determ (i,i,i).
lbtSelectFirst : (vpiDomains::windowHandle,integer).
lbxAdd : (vpiDomains::windowHandle,integer,string) procedure (i,i,i).
lbxAddList : (vpiDomains::windowHandle,integer,string_list) procedure (i,i,i).
lbxClear : (vpiDomains::windowHandle,integer) procedure (i,i).
lbxDelSet : (vpiDomains::windowHandle,integer,integer_list) determ (i,i,i).
lbxDelSetS : (vpiDomains::windowHandle,integer,string_list) determ.
lbxDelS : (vpiDomains::windowHandle,integer,string) determ (i,i,i).
lbxDelIs : (vpiDomains::windowHandle,integer,integer_list) determ (i,i,i).
lbxGet : (vpiDomains::windowHandle,integer,string) determ (i,i,o).
lbxGetMulti : (vpiDomains::windowHandle,integer,string_list) procedure (i,i,o).
lbxGetAll : (vpiDomains::windowHandle,integer,string_list) procedure (i,i,o).
lbxPop : (vpiDomains::windowHandle,integer,string_list) procedure (i,i,i).
lbxSel : (vpiDomains::windowHandle,integer,string) determ (i,i,i).
lbxMultiSel : (vpiDomains::windowHandle,integer,string_list) determ (i,i,i).
lbxRem : (vpiDomains::windowHandle,integer) determ.
lbxRemReselect : (vpiDomains::windowHandle,integer).

pixels : (integer WinClass,string Text) -> integer determ.
pixelsLC : (integer WinClass,integer Width) -> integer determ.
pixelsUC : (integer WinClass,integer Width) -> integer determ.
pixelsDigits : (integer WinClass,integer Width) -> integer determ.

setStyle : (vpiDomains::windowHandle W,integer_list Ctls,integer_list Bolds) procedure (i,i,i).
txtGet : (vpiDomains::windowHandle W,integer I,string S) procedure (i,i,o).
txtGetI : (vpiDomains::windowHandle W,integer I,integer Int) determ (i,i,o).
txtGetI_M : (vpiDomains::windowHandle W,integer I,string Mess,integer Int) determ (i,i,i,o).
txtGetFx : (vpiDomains::windowHandle W,integer I,real R) determ (i,i,o).
txtGetFxM : (vpiDomains::windowHandle W,integer I,string Mess,real R) determ (i,i,i,o).
txtGets : (vpiDomains::windowHandle W,integer_list CtlList,string_list L) procedure (i,i,o).
txtSet : (vpiDomains::windowHandle W,integer I,string S) procedure (i,i,i).
txtSetI : (vpiDomains::windowHandle W,integer I,integer Val) procedure (i,i,i).

end class guix
