/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement outFile
open core

facts
fh : outputStream := erroneous.
name : string := "".
parameter : integer := 0.
query : string := "".

constants
className = "com/rudstrand/outFile/outFile".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

new(Name,Par,Query) :-
    name:=Name,
    parameter:=Par,
    sx::sxRemoveTail(Query,".",Q2),
    sx::sxGiveTail(Q2,"?",Q3),
    query:=Q3,
    fh:=outputStream_file::create(Name),
    !.
new(Name,Par) :-
    name:=Name,
    parameter:=Par,
    fh:=outputStream_file::create(Name),
    !.
new(Name) :-
    name:=Name,
    fh:=outputStream_file::create(Name),
    !.
    
write(S) :- fh:write(S),!.
write(S1,S2) :- S=string::concat(S1,S2),fh:write(S),!.
writenl(S) :- fh:write(S,"\n"),!.

writenlList([]) :- !.
writenlList([H|T]) :- writenl(H), writenlList(T),!.

writenlLst(List) :-
    L=List:get(),
    set::setRev(L,Lr),
    writenlList(Lr),
    !.
    
nl() :- fh:write("\n"),!.

close() :- fh:close(),!.
    
getName()=Name :- Name=name,!.       
getPar()=Par :- Par=parameter,!.
getQuery()=Par :- Par=query,!.

setQuery(Query) :- 
    sx::sxRemoveTail(Query,".",Q2),
    sx::sxGiveTail(Q2,"?",Q3),
    query:=Q3,
    !.
 
end implement outFile
