/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement pfeil
open core,termDomain

constants
className = "com/rudstrand/pfeil/pfeil".
classVersion = "1.0".

class predicates
spar : (string_list,string) procedure (i,o).
ipar : (integer_list,string) determ (i,o).
iparx : (integer_list,string) determ (i,o).
tpar : (sterml,string) determ (i,o).
tparx : (sterml,string) determ (i,o).

clauses
classInfo(className, classVersion).
% ------------------------------------------------------------------------------------------------------------
% syserr
% ------------------------------------------------------------------------------------------------------------
syserr(Loc,Error,Strings,Integers) :- syserr(Loc,Error,Strings,Integers,[]),!.
syserr(Loc,Error,Strings) :- syserr(Loc,Error,Strings,[],[]),!.
syserr(Loc,Error) :- syserr(Loc,Error,[],[],[]),!.

syserr(Loc,Error,Strings,Integers,Terms) :-
    spar(Strings,S2),
    ipar(Integers,S3),
    tpar(Terms,S4),
    Mess=string::concatList(["LOCATION:",Loc,"\nERROR:",Error,S2,S3,S4]),
    vpiCommonDialogs::note("*** SYSTEM ERROR ***",Mess),
	!.

errorHandler(Loc,Error) :-
    Se=toString(Error),
    syserr(Loc,Se),
	!,fail.

spar([],"") :- !.
spar(Strings,S) :- sx::sxlJoin(["\nSTRING-PARAMETERS:"|Strings],"\n",S),!.

ipar([],"") :- !.
ipar(L,S) :- iparx(L,S2), S=string::concat("\nINTEGER-PARAMETERS:",S2),!.

iparx([],"") :-
    !.
iparx([I|Is],S) :- 
    S2=toString(I),
    iparx(Is,S3),
    S=string::concat(S2,"; ",S3),
    !.

tpar([],"") :- !.
tpar(L,S) :- tparx(L,S2), S=string::concat("\nTERM-PARAMETERS:\n",S2),!.

tparx([],"") :-
    !.
tparx([I|Is],S) :- 
    S2=toString(I),
    tparx(Is,S3),
    S=string::concat(S2,"\n",S3),
    !.
end implement pfeil
