/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement rep
open core

facts
rname : string := "".
fname : string := "".
lines : string_list :=[]. % reversed sequence
printer : integer := 0. % 1=printer; 2=file/editor; 3=file (advice upon gen.); 4=file (no advice); 5=dummy (no printing)
width : integer :=0.

predicates
repOpenFile : (string).

constants
className = "com/rudstrand/rep/rep".
classVersion = "1.0".

clauses
classInfo(className, classVersion).
% -------------------------------------------------------------------------------------------------------------
% get...
% -------------------------------------------------------------------------------------------------------------
getName()=Name :- Name=rname,!.
getFileName()=Name :- Name=fname,!.
getWidth()=Width :- Width=width,!.
getPrinter()=Printer :- Printer=printer,!.
getLines()=L :- set::setRev(lines,L),!.    
% -------------------------------------------------------------------------------------------------------------
% open
% -------------------------------------------------------------------------------------------------------------
class predicates
repOptionX : (integer,integer) determ (i,o).
clauses

newReport(Report,Width) :-
    globalVars::get_i("server")=1,
	printer:=4,
	rname:=Report,
	repOpenFile("3rp"),
	width:=Width,
	!    
;
	Reply=vpiCommonDialogs::ask("","Report to:",["Printer","Editor/File","Cancel"]),
	repOptionX(Reply,Printer),
	printer:=Printer,
	rname:=Report,
	repOpenFile("3rp"),
	width:=Width,
	!
;	
	printer:=0, % cancel
    !.

newReport(Printer,Report,Width) :-
    Printer=5,
	printer:=Printer,
	!
;    
	printer:=Printer,
	rname:=Report,
	repOpenFile("3rp"),
	width:=Width,
    !.

newReport(Printer,Report,Width,Type) :-
    Printer=0,
	Reply=vpiCommonDialogs::ask("","Report to:",["Printer","Editor/File","Cancel"]),
	repOptionX(Reply,Print),
	printer:=Print,
	rname:=Report,
	repOpenFile(Type),
	width:=Width,
	!
;
	printer:=Printer,
	rname:=Report,
	repOpenFile(Type),
	width:=Width,
    !.
repOptionX(vpiCommonDialogs::resp_default,1) :- !.	
repOptionX(vpiCommonDialogs::resp_2,2) :- !.	
% -------------------------------------------------------------------------------------------------------------
% repCancelled
% -------------------------------------------------------------------------------------------------------------
cancelled() :- printer=0,!.
% -------------------------------------------------------------------------------------------------------------
% repOpenFile
% -------------------------------------------------------------------------------------------------------------
repOpenFile(_) :-
    printer=5,
    !
;    
    printer=1,
	Path=globalVars::get_s("std_path"),
	File=string::concat(Path,"\\report.tmp"),
	fname:=File,
	lines:=[],
	!.
repOpenFile(Type) :-
    printer=5,
    !
;    
    printer>1,
    Name=rname,
	Path=globalVars::get_s("std_path"),
	sx::concat([Path,"\\",Name,".",Type],File),
	fname:=File,
	lines:=[],
	!
;	
    Name=rname,
	sx::concat([Name,".3rp"],File),
	fname:=File,
	lines:=[],
	!.
% -------------------------------------------------------------------------------------------------------------
% repBlock
% -------------------------------------------------------------------------------------------------------------
repBlock(S,Indent,Width) :-
	S2=sx::replaceAll(S,"\n"," "),
	S3=sx::replaceAll(S2,"  "," "),
	sx::sxBlockNL(Indent,Width,S3,S4),
	repWL(0,S4),
	!.
% -------------------------------------------------------------------------------------
% textBlock
% -------------------------------------------------------------------------------------
textBlock(Indent,Heading,Text) :- textBlock(Indent,width,Heading,Text),!.

textBlock(Indent,Width,Heading,Text) :-
    L1=string::length(Heading),
    L2=string::length(Text),
    L12=Indent+L1+L2,
    L12<=Width,
    repWL(Indent,Heading,Text),
    !
; 
    L1=string::length(Heading),
    Front=Width-L1-Indent,
    string::front(Text,Front,F,T),
    repWL(Indent,Heading,F),
    L2=L1+Indent,
    repBlock(T,L2,Width),
    !.
% -------------------------------------------------------------------------------------------------------------
% repLine
% -------------------------------------------------------------------------------------------------------------
repLine(C) :-
    printer=5,
    !
;    
    W=width,
	sx::sx_ini(W,C,S),
	repWL(0,S),
	!.
% -------------------------------------------------------------------------------------------------------------
% repW...
% -------------------------------------------------------------------------------------------------------------
repWL(N,S) :-
    printer=5,
    !
;    
	sx::sx_ini(N,' ',B),
	R=string::concat(B,S,"\n"),
	L=lines,
	lines:=[R|L],
	!.
repWL(N,Sa,Sb) :-
	sx::concat([Sa,Sb],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc) :-
	sx::concat([Sa,Sb,Sc],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc,Sd) :-
	sx::concat([Sa,Sb,Sc,Sd],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc,Sd,Se) :-
	sx::concat([Sa,Sb,Sc,Sd,Se],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc,Sd,Se,Sf) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc,Sd,Se,Sf,Sg) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf,Sg],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh],S),
	repWL(N,S),
	!.
repWL(N,Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh,Si) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh,Si],S),
	repWL(N,S),
	!.
repW(N,S) :-
    printer=5,
    !
;    
	sx::sx_ini(N,' ',B),
	R=string::concat(B,S),
	L=lines,
	lines:=[R|L],
	!.
repW(N,Sa,Sb) :-
	sx::concat([Sa,Sb],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc) :-
	sx::concat([Sa,Sb,Sc],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc,Sd) :-
	sx::concat([Sa,Sb,Sc,Sd],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc,Sd,Se) :-
	sx::concat([Sa,Sb,Sc,Sd,Se],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc,Sd,Se,Sf) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc,Sd,Se,Sf,Sg) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf,Sg],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh],S),
	repW(N,S),
	!.
repW(N,Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh,Si) :-
	sx::concat([Sa,Sb,Sc,Sd,Se,Sf,Sg,Sh,Si],S),
	repW(N,S),
	!.
	
repList(_,[]) :-
    !.
repList(N,[H|T]) :-
    repWL(N,H),
    repList(N,T),
    !.  
% -------------------------------------------------------------------------------------------------------------
% close
% -------------------------------------------------------------------------------------------------------------
predicates
closeX : (string).
clauses

close() :- close(1).
close(1) :-
    printer=5,
    !
;    
	repLine(' '),
	repWL(0,"*** END OF REPORT ***"),
	L=lines,
	set::setRev(L,Lr),
	File=fname,
    fio::writeFile(-1,File,16,Lr),
    closeX(File),
    !.
close(-1) :-
	L=lines,
	set::setRev(L,Lr),
	File=fname,
    fio::writeFile(-1,File,16,Lr),
    closeX(File),
    !.
    
closeX(File) :-
    globalVars::get_i("server")=1,
    !
;
    printer=1,
	print::print_file_str(File,8,rname),
	!
;	
	printer=2,
	editorWindow::openFiles(-1,[File]),
	!
;
    printer=3,
    Name=fileName::getName(File),
    Name<>"Dummy",
    Mess=string::concat(File," generated!"),
    vpiCommonDialogs::note(Mess),
    !
;    
    !.
end implement rep
