/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class sx
open core,globalDomains

predicates
classInfo : core::classInfo.

sx10C : (string S,string S10comp) determ (i,o).
conFormatF : (real,string Format,string S) determ (i,i,o).
tokens : (string,string_list) procedure (i,o). % splits a string into token with string::frontToken
leftAdjust : (string,string) procedure (i,o).
leftAdjustList : (string_list,string_list) procedure (i,o).
% V5 compatible
frontstr : (integer N,string S,string Head,string Tail) determ (i,i,o,o).
frontchar : (string,char,string) determ (i,o,o) (i,i,i) (i,i,o).
frontchar  : (string,char,string) procedure (o,i,i).
fronttoken : (string,string,string) determ (i,o,o) (i,i,i) (i,i,o).
fronttoken  : (string,string,string) procedure (o,i,i).
searchchar : (string S,char C,integer I) determ (i,i,o).     
searchstring : (string S,string Sub,integer I) determ (i,i,o).     
substring : (string,integer,integer,string) procedure (i,i,i,o).

sxBlockNL : (integer,integer,string,string) determ (i,i,i,o).
sxBreak : (string S,string Break,string LeftOfBreak,string RightOfBreak) determ (i,i,o,o).
sxDefault : (string S,string Def,string Sr) procedure (i,i,o).
sxFrame : (string S,string Frame1,string Frame2,string Sr) procedure (i,i,i,o).
sxFrame : (string S,string Frame,string Sr) procedure (i,i,o).
sxGetInBrack : (string C,char LB,char RB,string InBrackets) determ (i,i,i,o).
sxGetInBrackS : (string C,string LB,string RB,string InBrackets) determ (i,i,i,o).
sxGiveHead : (string S,string Head,string Sr) procedure (i,i,o).
sxGiveTail : (string S,string Tail,string Sr) procedure (i,i,o).
sxRemoveHead : (string S,string Tail,string Sr) procedure (i,i,o).
sxRemoveTail : (string S,string Tail,string Sr) procedure (i,i,o).
sxStripFrontMarks : (string S,string_list Marks,string) procedure (i,i,o).
sx_ini : (integer Length,char Init,string S) procedure (i,i,o).
isLetter : (char) determ.
isLetterS : (string) determ.
isDigit : (char) determ.
isDigitS : (string) determ.
isBlank : (string) determ.
joinIntegers : (integer_list L,string Delim,string Res) procedure (i,i,o).
sxL_Pad : (string S,string Init,integer Length,string Sr) procedure (i,i,i,o).
makeIdentifier : (integer,integer,integer,string,integer,string,string) determ (i,i,i,i,i,i,o).
sxNormalize : (string S,string T) procedure (i,o).
pack : (string_list,string Delimiter) -> string.
unpack : (string,string Delimiter) -> string_list.
sxQuote : (string S,string Su) procedure (i,o).
sxUnquote : (string S,string Su) procedure (i,o).
sx_str_int : (string S,integer Length,integer Int) procedure (o,i,i).
sx_rev : (string S,string Sr) determ (i,o).
sxRevs : (string_list L,string_list Lr) determ (i,o).
sxR_Pad : (string S,string Pad,integer Length,string Sp) procedure (i,i,i,o).
sxStrip : (string S,string T) procedure (i,o).
sxStripComments : (string,string) determ (i,o).
sxTail : (integer Length,string S,string Front,string Tail) determ (i,i,o,o).
sxTrunc : (string S,integer L,string St) procedure (i,i,o).
sxUnpack : (string Packed,char Delimiter,string_list Unpacked) procedure (i,i,o). % packed strings (w/ char delimiter) --> string list 
sxUnpackS : (string Packed,string Delimiter,string_list Unpacked) procedure (i,i,o). % packed strings (w/ string delimiter) --> string list
unpackList : (string_list Packed,string Delimiter,string_list_list Unpacked) procedure (i,i,o). % list of packed strings (w/ string delimiter) --> list of string lists
sxRemChar : (string S,char Rep,string Sr) procedure (i,i,o).
sxRemStr : (string S,string Rep,string Sr) procedure (i,i,o).
sxSetFirstUpper : (string,string) determ (i,o).

sxlAddPrefix : (string_list L,string Prefix,string_list Lr) procedure (i,i,o).
sxlAddSuffix : (string_list L,string Suffix,string_list Lr) procedure (i,i,o).
concat : (string_list SL,string S) procedure (i,o).
sxl_count : (string_list,integer MaxLength,integer NStrings) determ (i,o,o).
sxlFrontStr : (integer,string_list,string_list,string_list) determ (i,i,o,o).

join : (string_list Elements,string Joiner) -> string.
joinIgnoreBlanks : (string_list Elements,string Joiner) -> string.
% old:
sxlJoin : (string_list L,string Delim,string Res) procedure (i,i,o).
sxlJoinB : (string_list L,string Delim,string Res) procedure (i,i,o).

sxlStripComments : (string_list,string_list) determ (i,o).
maxLength : (string_list) -> integer.
quoteList : (string_list S,string_list Su) procedure (i,o).
sxlRemBlanks : (string_list Li,string_list Lr) procedure (i,o).
setEOLs : (integer,string,string,string) procedure (i,i,i,o).
sxlSort : (string_list S,string_list Ss) procedure (i,o).
sxlSubst : (string_list,string,string,string_list) procedure (i,i,i,o).
sxlSubstList : (string_list S,string_list Froms,string_list Tos,string_list Subst) determ (i,i,i,o).
sxlSubstNR_List : (string_list,string_list,string_list,string_list) determ (i,i,i,o).
sxlTrim : (string_list S,string_list Ss) procedure (i,o).
unpackList2 : (string_list,string,string_list,string_list) determ (i,i,o,o).
unpackList3 : (string_list,string,string_list,string_list,string_list) determ (i,i,o,o,o).
unpackList4 : (string_list,string,string_list,string_list,string_list,string_list) determ (i,i,o,o,o,o).
unpackList5 : (string_list,string,string_list,string_list,string_list,string_list,string_list) determ (i,i,o,o,o,o,o).
unpackList6 : (string_list,string,string_list,string_list,string_list,string_list,string_list,string_list) determ (i,i,o,o,o,o,o,o).
unpackList7 : (string_list,string,string_list,string_list,string_list,string_list,string_list,string_list,string_list) determ (i,i,o,o,o,o,o,o,o).
sxSubstList : (string S,string_list Froms,string_list Tos,string Subst) determ (i,i,i,o).
sxSubstNR_List : (string,string_list,string_list,string) determ (i,i,i,o).


replaceAll : (string S,string From,string To) -> string. % unlike the vip predicate - this does not fail if no substitutions
replaceAllC : (string S,char From,char To) -> string. % character-variety
setFirstLower : (string) -> string determ.
setFirstUpper : (string) -> string determ.

% validates and converts
sxSignedInteger : (string,integer) determ (i,o).
sxUnsignedInteger : (string,integer) determ (i,o).
sxInteger : (string,integer) determ (i,o).
sxSignedFix : (string,real) determ (i,o).
sxUnsignedFix : (string,real) determ (i,o).
sxFix : (string,real) determ (i,o).
sxReal : (string,real) procedure (o,i).

getInt : (string S,integer Front,string Tail) determ (i,o,o). % splits a string of format -99..9AA..A into -99..9 and AA..A ('-' is optional and so is AA..A) 
sxAllDigits : (string S) determ.
movePoint : (integer N,real R,real Rm) determ (i,i,o). % moves the decimal point N pos. to the left (N<0) or right (N>0)
fixComma : (string Si,string So) determ (i,o).
fixExpConv : (string,string) procedure (i,o).
fixFormatR : (real R,integer NDec,integer UseComma,string Real) determ (i,i,i,o).
fixFormatI : (integer R,integer NDec,integer UseComma,string Real) determ (i,i,i,o).
fixFormatS : (string R,integer NDec,integer UseComma,string Real) determ (i,i,i,o).
toInt : (string S) -> integer determ. % fails if not valid integer which can include sign and commas
toIntList : (string_list S,integer_list I) determ (i,o). % fails if not valid integer which can include sign and commas
toReal : (string S) -> real determ. % fails if not valid real which can include sign and commas (decimal point is optional)
sxl_il : (string_list,integer_list) determ (i,o).
sxl_ilR : (string_list,integer_list) procedure (o,i).
end class sx