/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class termDomain
open core

domains
sterml = sterm*.
sterml_list = sterml*.
sterm  =   var(string);
		       cmp(string,sterml);
		       list(sterm,sterm);
		       nill;
		       atom(string);
		       int(integer);
		       str(string);
		       % chr(char); % not used in Pro/3 - formerly chr was char 
		       % Pro/3 additions:
		       fix(real);	
		       fstr(string Value,string Domain,string Format,integer Width);
		       % not used in the KB
		       fvar(string,string);                  
		       fint(integer,string);                 	
		       ffix(real,string).
visioSymbol_CALLBACK =  (sterm Type,sterm Name,string VType,string VName) determ (i,i,o,o).
visioLink_CALLBACK =  (sterm Type1,sterm Name1,sterm Type2,sterm Name2,sterm Status,string LName) procedure (i,i,i,i,i,o).

predicates
classInfo : core::classInfo.

isBasicTerm : (sterm) determ.
isBasicTermF : (sterm) determ.

toTermString : (sterm) -> string determ.
toTermStringIndirect : (string,sterm) -> string determ.
fromTermString : (string) -> sterm determ.
fromTermStringF : (string) -> sterm determ.
fromTermStringIndirect : (string) -> sterm determ.
fromTermStringIndirectF : (string) -> sterm determ.
isTermString : (string) determ. % superficial check if term-string
isValidTermString : (string) determ. % check if valid term-string (note: gives error notes)
isTermStringIndirect : (string) determ.

fSwitch : (sterm,sterm) determ (i,o). % from fxxx to xxx (includes fSwitch)
fstrSwitchR : (sterm,sterm) determ (o,i).
fstr_str : (sterm,string) determ (i,o). % fstr(S,...) -> S
cl_list : (sterml,sterm) determ (i,o). % [...] -> list(...)
cl_listR : (sterml,sterm) determ (o,i).
cla_list : (string_list,sterm) procedure (i,o). % [S,...] -> list(atom(S),...)
cla_listR : (string_list,sterm) determ (o,i).
cli_listR : (integer_list,sterm) determ (o,i).
cls_list : (string_list,sterm) determ (i,o). % [S,...] -> list(str(S),...)
cls_listR : (string_list,sterm) determ (o,i).
fterm : (sterm,string,string,integer,sterm) determ (i,i,i,i,o). % int(I),... -> fstr(I,"p3_din",...)
list_conc : (sterm,string) determ (i,o). % list(str(S1),list(str(S2),...)) -> S1 S2 ...
listBR : (sterm,sterml) determ (i,o) (o,i).
realType : (sterm,real) determ (i,o). 
intType : (sterm,integer) determ (i,o).
sterm_strR : (sterm,string) procedure (o,i).
str_slist : (sterml,string_list) determ (i,o). % [str(S1),fstr(S2,...),...] -> [S1,S2,...]
var_SLIST : (sterml,string_list) determ (i,o). % [var(S1),fvar(S2,...),...] -> [S1,S2,...]
var_SLIST_R : (sterml,string_list) procedure (o,i).
end class termDomain