/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement termSet
open core,termDomain

constants
className = "com/rudstrand/termSet/termSet".
classVersion = "1.0".

facts
st : (sterm) nondeterm.

clauses
classInfo(className, classVersion).

% -----------------------------------------------------------------------------------------------
%                                            CLASS PREDICATES
% -----------------------------------------------------------------------------------------------
new() :- retractall(st(_)),!.
% -----------------------------------------------------------------------------------------------
%                                            OBJECT PREDICATES
% -----------------------------------------------------------------------------------------------
add(T) :- st(T),!; assert(st(T)),!.
delete(T) :- retract(st(T)),!.
member(T) :- st(T),!.
get_nd()=T :- st(T).
% -----------------------------------------------------------------------------------------------
% addList
% -----------------------------------------------------------------------------------------------
addList([]) :- !.
addList([H|T]) :- add(H), addList(T),!.    
% -----------------------------------------------------------------------------------------------
% get
% -----------------------------------------------------------------------------------------------
predicates
getRemove : (sterml) procedure (o).
reassert : (sterml).
clauses

get()=L :-
    getRemove(L),
    reassert(L),
    !.
    
getRemove([H|T]) :-
    st(H),
    retract(st(H)),
    getRemove(T),
    !.
getRemove([]) :-
    !.
    
reassert([]) :-
    !.
reassert([H|T]) :-
    assert(st(H)),
    reassert(T),
    !.
% -----------------------------------------------------------------------------------------------
% size
% -----------------------------------------------------------------------------------------------
predicates
sizeX : (integer,sterml,integer) determ (i,i,o).
clauses

size()=N :-
    L=get(),
    sizeX(0,L,N),
    !.
    
sizeX(N,[],N) :-
    !.
sizeX(N,[_|T],M) :-
    NN=N+1,
    sizeX(NN,T,M),
    !.
% -----------------------------------------------------------------------------------------------
% subtract
% -----------------------------------------------------------------------------------------------
subtract(Set) :-
    T=Set:get_nd(),
    member(T),
    delete(T),
    fail
;
    !.
% -----------------------------------------------------------------------------------------------
% union
% -----------------------------------------------------------------------------------------------
union(Set) :- 
    T=Set:get_nd(),
    add(T),
    fail
;
    !.
end implement termSet
