/******************************************************************************

		Copyright (C) 1999-2003, Prolog Development Center A/S

 FileName:	TABLEED.PRE
 Purpose:	Table editor object based on GRID custom control. Global predicates.
 Written by:	Sergey Alexeev & Alexander Butovsky
 Version:	1.0
 Build:		009.981112
 Tested with:   Visual Prolog v.5.1 build 555a

    @short

    @detail

    @package vpi/tableed
    @overview
    @author PDC
    @version Mimas
    @end
******************************************************************************/
class vpiTableed
% Application must declare only one constant below before including
% this file in order to select one of the languages for dialogs
constants
    language_english : boolean = true().
	language_danish : boolean = false().
	language_russian  : boolean = false().

#if language_english = true() #then
constants
  %**************************
  % Popup menu Texts
  %**************************
  tableedit_con_undotext =	"Undo \tCtrl+Z".
  tableedit_con_redotext =	"Redo \tCtrl+Y".
  tableedit_con_copytext =	"Copy \tCtrl+C".
  tableedit_con_pastetext =	"Paste \tCtrl+V".
  tableedit_con_cuttext =	"Cut \tCtrl+X".
  tableedit_con_sortAtext =	"Sort ascending".
  tableedit_con_sortDtext =	"Sort descending".
  tableedit_con_filterStext =	"Filter by selection".
  tableedit_con_filterEtext =	"Filter excluding selection".
  tableedit_con_showRowstext =	"Show all rows".
  tableedit_con_insRowtext =	"Insert Row\tIns".
  tableedit_con_delRowtext =	"Delete Rows\tDel".

  tableedit_con_find : string =	"Find".
  tableedit_con_findnext =	"Find next \tShift+F3".
  tableedit_con_Notfind : string =	"The searching is finished".
  tableedit_con_Scope : string =	"Entire Scope"  .
  tableedit_con_FromPoiter : string =	"From Pointer".
  tableedit_con_Backward : string =	"Backward".
  tableedit_con_Forward : string =	"Forward".
  tableedit_con_Fromstart : string =	"From start".
  tableedit_con_Entirestring : string =	"Entire string".
  tableedit_con_Anypart : string =	"Any part".
  tableedit_con_Casesensitive : string =	"Case sensitive".
  tableedit_con_Columns : string =	"Columns:".
  tableedit_con_What : string =	"What:".
  tableedit_con_Origin : string =	"Origin".
  tableedit_con_Diretion : string =	"Direction".
  tableedit_con_Match : string =	"Match".
  tableedit_con_Cancel : string =	"Cancel".
  tableedit_con_ColumnNote : string =	"Choose a column for search".

  tableedit_con_noteTitle : string = "?".
#endif

#if language_danish = true() #then
constants
  %**************************
  % Popup menu Texts
  %**************************
  tableedit_con_undotext =	"Fortryd redigering \tCtrl+Z".
  tableedit_con_redotext =	"Gentag redigering \tCtrl+Y".
  tableedit_con_copytext =	"Kopier \tCtrl+C".
  tableedit_con_pastetext =	"Inds \tCtrl+V".
  tableedit_con_cuttext =	"Klip \tCtrl+X".
  tableedit_con_sortAtext =	"Sorter stigende".
  tableedit_con_sortDtext =	"Sorter faldende".
  tableedit_con_filterStext =	"Vis kun valgte vrdier".
  tableedit_con_filterEtext =	"Vis ikke valgte vrdier".
  tableedit_con_showRowstext =	"Vis alle rkker".
  tableedit_con_insRowtext =	"Indst Rkke\tIns".
  tableedit_con_delRowtext =	"Slet Rkke\tDel".

  tableedit_con_find =	"Find".
  tableedit_con_findnext =	"Find next \tShift+F3".
  tableedit_con_Notfind =	"The searching is finished".
  tableedit_con_Scope =	"Entire Scope"  .
  tableedit_con_FromPoiter =	"From Pointer".
  tableedit_con_Backward =	"Backward".
  tableedit_con_Forward =	"Forward".
  tableedit_con_Fromstart =	"From start".
  tableedit_con_Entirestring =	"Entire string".
  tableedit_con_Anypart =	"Any part".
  tableedit_con_Casesensitive =	"Case sensitive".
  tableedit_con_Columns =	"Columns:".
  tableedit_con_What =	"What:".
  tableedit_con_Origin =	"Origin".
  tableedit_con_Diretion =	"Direction".
  tableedit_con_Match =	"Match".
  tableedit_con_Cancel =	"Cancel".
  tableedit_con_ColumnNote =	"Choose a column for search".

  tableedit_con_noteTitle = "?".
#endif

#if language_russian = true() #then
constants
  %**************************
  % Popup menu Texts
  %**************************
  tableedit_con_undotext =	" \tCtrl+Z".
  tableedit_con_redotext =	" \tCtrl+Y".
  tableedit_con_copytext =	" \tCtrl+C".
  tableedit_con_pastetext =	" \tCtrl+V".
  tableedit_con_cuttext =	" \tCtrl+X".
  tableedit_con_sortAtext =	"  ".
  tableedit_con_sortDtext =	"  ".
  tableedit_con_filterStext =	"  ".
  tableedit_con_filterEtext =	"  ".
  tableedit_con_showRowstext =	"  ".
  tableedit_con_insRowtext =	" \tIns".
  tableedit_con_delRowtext =	" \tDel".

  tableedit_con_find =	"".
  tableedit_con_findnext =	"  \tShift+F3".
  tableedit_con_Notfind =	" .".
  tableedit_con_Scope =	""  .
  tableedit_con_FromPoiter =	" ".
  tableedit_con_Backward =	"".
  tableedit_con_Forward =	"".
  tableedit_con_Fromstart =	" ".
  tableedit_con_Entirestring =	"".
  tableedit_con_Anypart =	" ".
  tableedit_con_Casesensitive =	" ".
  tableedit_con_Columns =	":".
  tableedit_con_What =	" :".
  tableedit_con_Origin =	" ".
  tableedit_con_Diretion =	"".
  tableedit_con_Match =	"".
  tableedit_con_Cancel =	"".
  tableedit_con_ColumnNote =	"   .".

  tableedit_con_noteTitle = "?".
#endif


domains

tableedit_PICTUREMODE = fromfile(string DOSFileName);
			fromres(vpiDomains::resid ResId);
			none.

tableedit_DATA = tableedit_columndata*.
tableedit_COLUMNDATA = tableedit_celldata*.
tableedit_CELLDATA = i(integer);
		     ic(integer,vpiDomains::color);
		     l(core::integer32);
		     lc(core::integer32,vpiDomains::color);
		     r(real);
		     rc(real,vpiDomains::color);
		     s(string);
		     sc(string,vpiDomains::color);
		     p(tableedit_picturemode,core::booleanInt Stretch,string PictureText);
		     void;
		     voidc(vpiDomains::color).

% General properties of the Table editor.
% All properties are optional which means that if
% certain property is not listed then Table editor
% uses default value.
tableedit_PROPERTIES = tableedit_property*.
tableedit_PROPERTY = raised(core::booleanInt);				% Default: b_true
		     defcellcolor(vpiDomains::color);			% Default: color_LtGray
		     backcolor_tab(vpiDomains::color);				% Default: color_Gray
		     emptycolor(vpiDomains::color);				% Default: color_LtGray
		     titlebackcolor(vpiDomains::color);			% Default: color_LtGray
		     titleforecolor(vpiDomains::color);			% Default: color_Black
		     rowselector(vpiGrid::rowSelector,		% Default: grid_number,50,b_false NEW!
								% See GRID_ROW_SELECTOR domain in grid.dom
				 integer Width,
				 core::booleanInt ActiveRowPointer);
		     nonscrollcol(integer);			% Default: 0
		     sortedby(integer);				% Default: 1
		     allmarker(core::booleanInt);			% Default: b_false
		     areamarker(tableedit_markermode);		% Default: singular
		     colmarker(tableedit_markermode);		% Default: none
		     rowmarker(tableedit_markermode);		% Default: singular
		     insert_rows(core::booleanInt);			% Default: b_true
		     delete_rows(core::booleanInt);			% Default: b_true
		     filter_tab(core::booleanInt);				% Default: b_true
		     menu(vpiDomains::menuItem_list);			% Default: []
		     readonly_tab(core::booleanInt);				% Default: b_false
		     undo_redo(core::booleanInt);			% Default: b_true
		     paste(core::booleanInt);				% Default: b_true
		     cut(core::booleanInt);				% Default: b_true
		     headers(integer);				% Default: 0 rows
		     footers(integer);				% Default: 0 rows
		     callback(tableedit_callback);		% Default: internal dummy callback
		     compare(tableedit_compare);		% Default: internal dummy compare function
		     find(core::booleanInt);				% default b_true
		     bufferingmode(tableedit_buffering).		% Default: nobuffering

tableedit_BUFFERING =	nobuffering;
			buffering(tableedit_answerdata_func,integer RowBuffSize,integer MaxRows).

tableedit_ANSWERDATA_FUNC =  (vpiDomains::windowHandle TableEditWindow,
			    integer 		FromRow,
			    integer 		ToRow,
			    tableedit_data	Data)determ  (i,i,i,o).

tableedit_MARKERMODE = none;		% No marker
		       singular;	% Singular marker
		       singlearea;	% Single area marker
		       multiarea.		% Multi area marker


tableedit_COLUMNLIST = tableedit_column*.
tableedit_COLUMN = column(tableedit_columnproperties).

tableedit_FILTERS = tableedit_columnfilter*.
tableedit_COLUMNFILTER = columnfilter(integer Column,tableedit_orfilterlist).
tableedit_ORFILTERLIST = tableedit_orfilter*.
tableedit_ORFILTER = if_min(integer Limit);	% Visible values &gt;= Limit
		     if_max(integer Limit);	% Visible values &lt;= Limit
		     % Visible values from Lim1 to Lim2
		     if_range(integer Lim1,integer Lim2);
		     % Visible values are not equal Fval
		     if_not(integer Fval);

		     lf_min(core::integer32);
		     lf_max(core::integer32);
		     lf_range(core::integer32,core::integer32);
		     lf_not(core::integer32);

		     rf_min(real);
		     rf_max(real);
		     rf_range(real,real);
		     rf_not(real);

		     % Visible values are equal Fval
		     s_f(string Fval);
		     % Visible values are not equal Fval
		     s_f_not(string Fval);

		     fvoid;
		     fvoid_not.

% Individual column properties.
% All properties are optional which means that if
% certain property is not listed then column
% uses default value.
tableedit_COLUMNPROPERTIES = tableedit_columnproperty*.
tableedit_COLUMNPROPERTY = title(string);			% Default: ""
			   width(integer);			% Default: 100 pixels
			   backcolor(vpiDomains::color);			% Default: color_LtGray
			   forecolor(vpiDomains::color);			% Default: color_Black
			   alignment(vpiGrid::horAlignment);	% Default: grid_right_align
								% See GRID_HORALIGNMENT domain in grid.dom
			   maxlength(unsigned);			% Default: 0x7FFF
			   readonly(core::booleanInt);			% Default: b_false
			   filter(core::booleanInt);			% Default: b_true
			   filterlist(tableedit_orfilterlist);	% Default: []
			   resizable(core::booleanInt);			% Default: b_true
			   sortmode(tableedit_sortmode);	% Default: ascending([])
			   defaultvalue(tableedit_celldata);	% Default: void
			   validationrule(tableedit_rulelist);	% Default: []
			   validationtext(string);		% Default: ""
			   column_type(tableedit_type);		% Default: string
			   control(tableedit_control_type);	% Default: edit control
			   mandatory(core::booleanInt).			% Default: b_false

tableedit_TYPE = te_integer;	% INTEGER column type
		 te_real;	% REAL column type
		 te_long;	% LONG column type
		 te_string;	% STRING column type (default: STRING column type)
		 te_picture.	% picture column type

tableedit_CONTROL_TYPE = edit;
			 listbutton(core::string_list);
			 listedit(core::string_list);
			 custom(string ClassName,vpiDomains::wsflags Ctl_Flags,
                    	   vpiGrid::putCustomData,vpiGrid::getCustomData).
			% See GRID_PUT_CUSTOM_DATA,vpiGrid::getCustomData domains in grid.dom

tableedit_SORTMODE = ascending(core::integer_list);
		     descending(core::integer_list);
		     none.

tabaction =	row_marker_beg(integer Row);
		col_marker_beg(integer Column);
		area_marker_beg(integer Row,integer Column);
		all_marker_beg;
		edit_cell_beg(integer Row,integer Column);
		resize_column_beg(integer Column);
		resize_column_act(integer Column,integer Width);
		hscroll_create;
		vscroll_create;
		hscroll_destroy;
		vscroll_destroy.

tableedit_EVENT = action(tabaction);
		  marker(vpiGrid::marker,core::booleanInt MarkUnMark);% See GRID_MARKER domain in grid.dom
		  modified_event(integer Row,integer Column,
		  	tableedit_celldata OldValue,tableedit_celldata NewValue);
		  copy(integer FromRow,integer ToRow,integer FromColumn,integer ToColumn);
		  paste(integer FromRow,integer ToRow,integer FromColumn,integer ToColumn);
		  cut(integer FromRow,integer ToRow,integer FromColumn,integer ToColumn);
		  undo();
		  redo();
		  sort(integer Column,tableedit_sortmode);
		  filter(tableedit_filters);
		  insert_row(integer Row,tableedit_columndata);
		  delete_row(integer Row,tableedit_columndata);
		  find(string,tableedit_direction,integer Column,tableedit_match,core::booleanInt CaseSensitive,core::booleanInt FindNext);
		  menu(vpiDomains::menuTag,vpiGrid::marker); % See GRID_MARKER domain in grid.dom
		  copy_beg(integer FromRow,integer ToRow,integer FromColumn,integer ToColumn);
		  paste_beg(integer FromRow,integer ToRow,integer FromColumn,integer ToColumn);
		  cut_beg(integer FromRow,integer ToRow,integer FromColumn,integer ToColumn);
		  sort_beg(integer Column);
		  menu_beg(integer Row,integer Column);
		  filter_beg(tableedit_filters);
		  insert_row_beg(integer Row,tableedit_columndata RowData);
		  delete_row_beg(vpiGrid::lineList ListOfRowForDeleting); % See GRID_LINELIST domain in grid.dom
		  closerequest().

tableedit_CALLBACK =  (vpiDomains::windowHandle 	TableEditWindow,
			     tableedit_event	What)determ  (i,i).

tableedit_COMPARESTATUS = equal; %CellData1 = CellData2
			  more;  %CellData1 &gt; CellData2
			  less.   %CellData1 &lt; CellData2

tableedit_COMPARE =  (vpiDomains::windowHandle 	TableEditWindow,
			    integer 		Column,
			    tableedit_celldata	CellData1,
			    tableedit_celldata  CellData2,
			    tableedit_comparestatus Equal_More_Less)determ  (i,i,i,i,o).
tableedit_DIRECTION =	up;
			down;
			allup;
			alldown.

tableedit_MATCH = 	entire;
			from_start;
			any_part.

tableedit_RULELIST = tableedit_rule*.
tableedit_RULE = % String fields:
		 s_length(integer Length);	   % Number of chars
		 s_min(integer Min);		   % Number of chars: From ..
		 s_max(integer Max);		   % Number of chars: .. To
		 s_upper;			   % Upper case
		 s_lower;			   % Lower case
		 % Integer fields
 		 i_min(integer Min);		   % Value from ..
		 i_max(integer Max);		   % Value to ..
		 % Real fields
 		 r_min(real Min);		   % Value from ..
		 r_max(real Max);		   % Value to ..
		 % Long fields
 		 l_min(core::integer32 Min);		   % Value from ..
		 l_max(core::integer32 Max).		   % Value to ..


 predicates

 tableedit_init : (vpiDomains::windowHandle TableEditCustomControl,
		tableedit_properties,
		tableedit_columnlist,
		tableedit_data		InputData)procedure  (i,i,i,i).
	%
	%short
	%---- Init Table editor custom control ----
	%@detail
	/*
	Remarks:<br>
	TABLEEDIT_PROPERTIES = TABLEEDIT_PROPERTY*<br>
	TABLEEDIT_PROPERTY domain is described above in "General (table) properties of the Table editor custom control".<br>
	TABLEEDIT_COLUMNLIST = TABLEEDIT_COLUMN*<br>
	TABLEEDIT_COLUMN = column(TABLEEDIT_COLUMNPROPERTIES)<br>
	TABLEEDIT_COLUMNPROPERTIES = TABLEEDIT_COLUMNPROPERTY*<br>
	TABLEEDIT_COLUMNPROPERTY domain is described above in "Individual column properties of the Table editor custom control".<br>
	Invokes the Table editor custom control.<br>
	Predicate should be called by class event handler on e_Create event (see example bellow).<br>
	TableEditorWindow is the Table editor custom control window handle.<br>
	TableProperties  defines the general exterior of the Table editor control.<br>
	ColumnProperties defines the column exterior of the Table editor control.<br>
	buffering mode:<br>
	InputData - parameter is ignored for buffering mode, table editor uses special callback function for data requests from external database.<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%
	%@end


  tableedit_getproperties : (vpiDomains::windowHandle TableEditWindow) -> tableedit_properties procedure  (i).
	%
	%@short
	%---- Get entire list of Editor's properties ----
	%
	%@detail
	/*
	Get entire list of General properties from Table editor.<br>
	TABLEEDIT_PROPERTIES = TABLEEDIT_PROPERTY*<br>

	TABLEEDIT_PROPERTY domain is described above in "General (table) properties of the Table editor custom control".<br>

	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.

	%@end


 tableedit_setproperties : (vpiDomains::windowHandle TableEditWindow,tableedit_properties)procedure  (i,i).
	%
	%@short
	%---- Change some Editor's properties ----
	%@detail
	/*
	Change some General Editor's properties.<br>
	The predicate reset listed General properties of table editor and makes handling the table according to current properties (including sorting and filtration, etc; "undo-redo" data are lost).<br>
	TABLEEDIT_PROPERTIES = TABLEEDIT_PROPERTY*<br>
	TABLEEDIT_PROPERTY domain is described above in "General (table) properties of the Table editor custom control".<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getcolumnproperties : (vpiDomains::windowHandle TableEditWindow,integer Col) -> tableedit_columnproperties procedure  (i,i).
	%
	%@short
	%---- Get entire list of column's properties ----
	%
	%@detail
	/*
	Get entire list of  Column  properties from Table editor .<br>
	TABLEEDIT_COLUMNPROPERTIES = TABLEEDIT_COLUMNPROPERTY*<br>
	TABLEEDIT_COLUMNPROPERTY domain is described above in "Individual column properties of the Table editor custom control".<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setcolumnproperties : (vpiDomains::windowHandle TableEditWindow,integer Col,tableedit_columnproperties)procedure  (i,i,i).
	%
	%@short
	%---- Change some column's properties ----
	%
	%@detail
	/*
	Change some column  properties.<br>
	The predicate reset listed Column properties for a specified column of table editor and makes handling the table according to current properties (including sorting and filtration, etc; "undo-redo" data are lost).<br>
	TABLEEDIT_COLUMNPROPERTIES = TABLEEDIT_COLUMNPROPERTY*<br>
	TABLEEDIT_COLUMNPROPERTY domain is described above in "Individual column properties of the Table editor custom control".<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getmarker : (vpiDomains::windowHandle TableEditWindow) -> vpiGrid::marker procedure  (i).
	%
	%@short
	%---- Get marker ----<br>
	% See GRID_MARKER domain in grid.dom<br>
	%
	%@detail
	/*
	Get current marker.<br>
		The GRID_MARKER domain is shown below:<br>
	GRID_MARKER =<br>
		% Rows specified in LineList are marked<br>
		grid_row_marker(GRID_LINELIST LineList);<br>
		% Columns specified in ColumnList are marked<br>
		grid_col_marker(GRID_LINELIST ColumnList);<br>
		% Areas specified in AreaList are marked<br>
		grid_area_marker(GRID_AREALIST AreaList);<br>
		% All table are marked<br>
		grid_all_marker;<br>
		% The control is open in specified cell<br>
		grid_edit_cell(INTEGER	Row,
		INTEGER	Column);<br>
		% No marker<br>
		grid_no_marker<br>
	GRID_LINE=gl(INTEGER	FromRowColumn,
		INTEGER	ToRowColumn)<br>
	GRID_LINELIST=GRID_LINE*<br>
	GRID_AREA=ga(INTEGER	FromRow,<br>
		INTEGER	ToRow,<br>
		INTEGER	FromColumn,<br>
		INTEGER	ToColumn)<br>
	GRID_AREALIST=GRID_AREA*<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setmarker : (vpiDomains::windowHandle TableEditWindow,vpiGrid::marker)procedure  (i,i).
	%
	%@short
	%---- Set marker ----
	% See GRID_MARKER domain in grid.dom
	%
	%@detail
	/*
	Set specified marker.<br>
	For GRID_MARKER domain declaration see tableedit_GetMarker predicate above.<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getalldata : (vpiDomains::windowHandle TableEditWindow) -> tableedit_data procedure  (i).
	%
	%@short
	%---- Get entire data as 2-d list of TABLEEDIT_CELLDATA terms ----<br>
	%---- (The data in the table and filtered data)<br>
	%
	%@detail
	/*
	Get entire data as 2-d list of  TABLEEDIT_CELLDATA terms.<br>
	In the beginning of the list there are the data, being in the table, then data, filtered by  filtration (if the filtration was carried out).<br>
		The TABLEEDIT_DATA domain is shown below:<br>
	TABLEEDIT_DATA = TABLEEDIT_COLUMNDATA*<br>
	TABLEEDIT_COLUMNDATA = TABLEEDIT_CELLDATA*<br>
	TABLEEDIT_CELLDATA =<br>
		i(INTEGER);<br>
		ic(INTEGER,COLOR);<br>
		l(LONG);<br>
		lc(LONG,COLOR);<br>
		r(REAL);<br>
		rc(REAL,COLOR);<br>
		s(STRING);<br>
		sc(STRING,COLOR);<br>
		p(TABLEEDIT_PICTUREMODE PictureMode,<br>
		  BOOLEAN Stretch,<br>
		  STRING PictureText);<br>
		void;<br>
		voidc(COLOR).<br>
	Stretch: Strech on/off.<br>
	PictureText: Name of picture (should be unique).<br>
	TABLEEDIT_PICTUREMODE =<br>
		fromfile(STRING DOSFileName);<br>
		fromres(RESID ResId);<br>
		none<br>
	PictureMode: Table editor will accept pictures as either fromres(BMPResourceId) or fromfile(BMPFileName).<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getallvisibledata : (vpiDomains::windowHandle TableEditWindow) -> tableedit_data procedure  (i).
	%
	%@short
	%---- Get entire data as 2-d list of TABLEEDIT_CELLDATA terms ----
	%---- (Only data in the table)
	%@detail
	/*
	Get entire data as 2-d list of  TABLEEDIT_CELLDATA terms.<br>
	Get only data, being in the table.<br>
	For TABLEEDIT_DATA domain declaration see tableedit_GetAllData predicate above.<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setalldata : (vpiDomains::windowHandle TableEditWindow,tableedit_data)procedure  (i,i).
	%
	%@short
	%---- Reset all data ----
	% Set all data for nobuffering mode
	% Request data from database for buffering mode (ignore TABLEEDIT_DATA)
	%@detail
	/*
	Reset all data.<br>
	The predicate reset all data and makes handling of data, according to current properties (including sorting and filtration, "undo-redo" data are lost).<br>
	For TABLEEDIT_DATA domain declaration see tableedit_GetAllData predicate above.<br>
	buffering mode:<br>
	InputData - parameter is ignored for buffering mode, data request from external database and data buffer is refreshed.<br>
	Fail:<br>
	Never fails.<br>
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setactiverow : (vpiDomains::windowHandle TableEditWin,integer ActiveRow)procedure  (i,i).
	%
	%@short
	%---- Set active row ----
	%@detail
	/*
	The predicate makes  a specified row is active.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end


  tableedit_getactiverow : (vpiDomains::windowHandle TableEditWin) -> integer procedure  (i).
	%
	%@short
	%---- Get active row ----
	%@detail
	/*
	Get serial number of row which is active in the table.<br>
	If ActiveRowPointer in rowselector General property equal b_true, then the active row will be marked by the Active Row Pointer.<br>
	Row and column numbering directions - from top to bottom and from left to right. Numbering starts from 1.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_maxcol : (vpiDomains::windowHandle TableEditWin) -> integer procedure  (i).
	%
	%@short
	%---- Numer of columns calculation ----
	%@detail
	/*
	The predicate return number of columns in table.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_maxrows : (vpiDomains::windowHandle TableEditWin) -> integer procedure  (i).
	%
	%@short
	%---- Numer of rows calculation ----<br>
	%---- (The rows in the table and filtered rows(for nobuffering mode))<br>
	%@detail
	/*
	The predicate return number of rows in Table editor (rows, being in the table + filtered rows = all rows)<br>
	buffering mode:<br>
	The predicate return number of rows in external database, seting for table editor.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_buff_setmaxrows : (vpiDomains::windowHandle TableEditWin,integer MaxRows)procedure  (i,i).
	%
	%@short
	%---- Set Max rows for buffering mode<br>
	% --- ignore for NObuffering mode<br>
	%@detail
	/*
	Set number of rows in table editor for buffering mode. MaxRows should be equal to number of rows in external database.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%No errors.
	%@end

  tableedit_buff_invalidatearea : (vpiDomains::windowHandle TableEditWin,
					integer FrRow,
					integer ToRow,
					integer FRColumn,
					integer ToColumn)procedure  (i,i,i,i,i).

	%
	%@short
	% --- invalidate and request of new data from external database<br>
	% --- ignore for NObuffering mode<br>
	%@detail
	/*
	Area invalidate.<br>
	Ignore for NObuffering mode.<br>
	buffering mode:<br>
	invalidate area in range (FrRow,ToRow,FrColumn,ToColumn), request from external database and data buffer is refreshed.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_maxvisiblerows : (vpiDomains::windowHandle) -> integer procedure  (i).
	%
	%@short
	%---- Numer of rows calculation ----<br>
	%---- (Only rows in the table)<br>
	%@detail
	/*
	The predicate return number of rows, being in the table (without filtered rows).<br>
	buffering mode:<br>
	The predicate return number of rows in external database, seting for table editor.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getdata : (vpiDomains::windowHandle 	TableEditWindow,
				 integer	FromRow,
				 integer	ToRow,
				 integer	FromCol,
				 integer	ToCol) -> tableedit_data procedure  (i,i,i,i,i).
	%
	%@short
	%---- Get data for certain area as 2-d list of TABLEEDIT_CELLDATA terms ----
	%@detail
	/*
	Get data for certain area as 2-d list of  TABLEEDIT_CELLDATA terms.<br>
	Possible to get only data, being in the table.<br>
	For TABLEEDIT_DATA domain declaration see tableedit_GetAllData predicate above.<br>
	Row and column numbering directions - from top to bottom and from left to right. Numbering starts from 1.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setdata : (vpiDomains::windowHandle TableEditWindow,
		  integer	FromRow,
		  integer	ToRow,
		  integer	FromCol,
		  integer	ToCol,
		  tableedit_data)procedure  (i,i,i,i,i,i).
	%
	%@short
	%---- Set data for certain area as 2-d list of TABLEEDIT_CELLDATA terms ----
	%@detail
	/*
	Change data for specified table area as 2-d list of  TABLEEDIT_CELLDATA terms.<br>
	Row and column numbering directions - from top to bottom and from left to right. Numbering starts from 1. <br>
	FromRow, FromColumn - top / left corner. ToRow, ToColumn - bottom / right - limit corner.<br>
	For TABLEEDIT_DATA domain declaration see tableedit_GetAllData predicate above.<br>
	buffering mode:<br>
	On each changed cell is generated modified(...) callback.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getrowdata : (vpiDomains::windowHandle TableEditWindow,
			    integer	FromRow,
			    integer	ToRow) -> string procedure  (i,i,i).
	%
	%@short
	%---- Get clipboard format data from table (row range) ----<br>
	%  Clipboard data format is strings with column values<br>
	%  separated by tabs and rows separated by new line.<br>
	%@detail
	/*
	Fail:
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setrowdata : (vpiDomains::windowHandle TableEditWindow,
		     integer	FromRow,
		     string	Data)procedure  (i,i,i).
	%
	%@short
	%---- Set clipboard format data to table (from row) ----<br>
	% Ignore for buffering mode<br>
	%@detail
	/*
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setrowdata : (vpiDomains::windowHandle TableEditWindow,
		     integer	FromRow,
		     integer	ToRowLimit,
		     string	Data)procedure  (i,i,i,i).
	%
	%@short
	%---- Set clipboard format data to table (from row) ----<br>
	% Ignore for buffering mode<br>
	%@detail
	/*
	buffering mode:<br>
	On each changed cell is generated modified(...) callback.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getclipboarddata : (vpiDomains::windowHandle TableEditWindow,
				  integer	FromRow,
				  integer	ToRow,
				  integer	FromColumn,
				  integer	ToColumn) -> string procedure  (i,i,i,i,i).
	%
	%@short
	%---- Get clipboard format data from table (area range) ----
	%@detail
	/*
	Get clipboard format data from table (area range).<br>
	Clipboard data format is strings with cell values separated by tabs (\t) and rows separated by new line (\r\n).<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setclipboarddata : (vpiDomains::windowHandle TableEditWindow,
			   integer	FromRow,
			   integer	ToRow,
			   integer	FromColumn,
			   integer	ToColumn,
			   string	Data)procedure  (i,i,i,i,i,i).
	%
	%@short
	%---- Set clipboard format data to table ----<br>
	%---- (FromRow ToRowLimit  FromColumn ToColumnLimit) ----<br>
	%@detail
	/*
	Set clipboard format data to table (area range).<br>
	Clipboard data format is strings with cell values separated by tabs (\t) and rows separated by new line (\r\n).<br>
	FromRow, FromColumn - top / left corner. ToRow, ToColumn - bottom / right - limit corner.<br>
	buffering mode:<br>
	On each changed cell is generated modified(...) callback.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_getcelldata : (vpiDomains::windowHandle  TableEditWindow,
				 	 integer Row,
				 	 integer Col) -> tableedit_celldata procedure  (i,i,i).
	%
	%@short
	%---- Get data for certain cell as TABLEEDIT_CELLDATA term ----
	%@detail
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setcelldata : (vpiDomains::windowHandle TableEditWindow,
		      integer	Row,
		      integer	Col,
		      tableedit_celldata)procedure  (i,i,i,i).
	%
	%@short
	%---- Set data for certain cell as TABLEEDIT_CELLDATA term ----
	%@detail
	/*
	Set data to specified cell as TABLEEDIT_CELLDATA term.<br>
	For TABLEEDIT_CELLDATA domain declaration see tableedit_GetAllData predicate above.<br>
	buffering mode:<br>
	On  changed cell is generated modified(...) callback.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setcolumnfilter : (vpiDomains::windowHandle TableEditWindow,
			  integer	Columnm,
			  tableedit_orfilterlist)procedure  (i,i,i).
	%
	%@short
	%---- Set filer for column and handling<br>
	%---- (The filters in other columns remain same)<br>
	% ignore for buffering mode
	%@detail
	/*
	Predicate change filers for specified column and makes handling the table according to current filters ("undo-redo" data are lost).<br>
	The TABLEEDIT_ORFILTERLIST domain see above in "Individual column properties of the Table editor custom control".<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_resetfilters : (vpiDomains::windowHandle TableEditWindow,
				tableedit_filters)procedure  (i,i).
	%
	%@short
	%---- Reset filer for columns and handling<br>
	%----(Reset of given filters and destruction of the other filters)<br>
	% ignore for buffering mode
	%@detail
	/*
	Predicate set filers for specified columns, unset for other columns and makes handling the table according to current filters ("undo-redo" data are lost).<br>
		The TABLEEDIT_FILTERS domain is shown below:<br>
	TABLEEDIT_FILTERS = TABLEEDIT_COLUMNFILTER*<br>
	TABLEEDIT_COLUMNFILTER =<br>
		columnfilter(INTEGER Column, TABLEEDIT_ORFILTERLIST ColumnFilterList)<br>
	The TABLEEDIT_ORFILTERLIST domain see above in "Individual column properties of the Table editor custom control".<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@Exception
	%Illegal parameter value.
	%@end

 tableedit_sort : (vpiDomains::windowHandle TableEditWindow,
			integer	Column)procedure  (i,i).
	%
	%@short
	%---- Sort handling<br>
	%---- (According to the current order of sorting in a column)<br>
	% ignore for buffering mode
	%@detail
	/*
	Predicate makes sorting the table by column according to current sortmode(Mode) column property ("undo-redo" data are lost).<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_deleterows : (vpiDomains::windowHandle,vpiGrid::lineList)procedure  (i,i).
	%
	%@short
	% ignore for buffering mode<br>
	% delete rows contains in line list<br>
	% See GRID_LINELIST domain in grid.dom<br>
	%@detail
	/*
	Predicate delete from table specified in RowsList rows.<br>
		The GRID_LINELIST domain is shown below:<br>
	GRID_LINE=gl(INTEGER	FromRowColumn,<br>
		INTEGER	ToRowColumn)<br>
	GRID_LINELIST=GRID_LINE*<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_insertrows : (vpiDomains::windowHandle TableEditWindow,
				integer FromRow,
				tableedit_data)procedure  (i,i,i).
	%
	%@short
	%---- Insert given rows to table<br>
	% ignore for buffering mode<br>
	%@detail
	/*
	Insert InputData into the table starting from FromRow.<br>
	For TABLEEDIT_DATA domain declaration see tableedit_GetAllData predicate above.<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_insertrowstoend : (vpiDomains::windowHandle TableEditWindow,
				tableedit_data) -> integer procedure  (i,i).
	%
	%@short
	%---- Insert given rows to end of table (before footers)<br>
	% ignore for buffering mode<br>
	%@detail
	/*
	Insert InputData at the end of the table. End of the table is the position after the last row but before footer rows if exists.<br>
	Predicate returns row number where InputData is inserted.<br>
	For TABLEEDIT_DATA domain declaration see tableedit_GetAllData predicate above.<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_insertdefrowstoend : (vpiDomains::windowHandle TableEditWindow,
					integer	NumberOfRows) -> integer procedure  (i,i).
	%
	%@short
	%---- Insert number of default rows to end of table (before footers)<br>
	%---- (The rows form according to defaultvalue() column properties)<br>
	% ignore for buffering mode
	%@detail
	/*
	Insert at the end of the table certain number of default rows. End of the table is the position after the last row but before footer rows if exists.<br>
	Default row consists from default cell values, which are determined in defaultvalue(...) column properties.<br>
	NumberOfRows - number of default rows.<br>
	Predicate returns row number where default rows is inserted.<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

 tableedit_setvisitorder : (vpiDomains::windowHandle,vpiGrid::key,integer ShiftCtlAlt,vpiGrid::keyAction)procedure  (i,i,i,i).
	%
	%@short
	%---- Changes the action, performed by grid control when user presses Enter key<br>
	%---- or Tab key or exceeds the maximum number of symbols typing the data into the cell.<br>
	% See GRID_KEY,vpiGrid::keyAction domains in grid.dom
	%@detail
	/*
	Changes the action, performed by Table editor control when user presses Enter key or Tab key.<br>
	Get current action settings.<br>
	By default Tableeditor control moves the active cell:<br>
	.	down on Enter key,<br>
		to the right on Tab key and when the maximum number of symbols is exceeded,<br>
		up on Shift-Enter keys,<br>
		to the left on Shift-Tab keys.<br>
	Key argument is one of the:<br>
		grid_key_enter;<br>
		grid_key_tab;<br>
		grid_max_length<br>
	Action argument is one of the:<br>
		grid_left;<br>
		grid_right;<br>
		grid_up;<br>
		grid_down<br>
	Fail:<br>
	Never fails.
	*/
	%@exception
	%Illegal parameter value.
	%@end

  tableedit_find : (vpiDomains::windowHandle,string,tableedit_direction,integer Column,tableedit_match,core::booleanInt CaseSensitive) -> integer determ (i,i,i,i,i,i).
	%
	%@short
	% ---- Find position of specified string,fail if string not find<br>
	% ---- Fail for buffering mode<br>
	%@detail
	/*
	Find position of specified string.<br>
	TABLEEDIT_DIRECTION =	up;	%Find up from active row poiter<br>
		down;	%Find down from active row poiter<br>
		allup;	%Find entire table from the bottom to the top<br>
		alldown	%Find entire table from the top to the bottom<br>
	TABLEEDIT_MATCH =	entire;	% Entire string<br>
		from_start;	% match from start of the string<br>
		any_part	% any part of the string<br>
	buffering mode:<br>
	Actual only for nobuffering mode.<br>
	Fail:<br>
	tableedit_Find  fails if string is not found.
	*/
	%end

  tableedit_getvisitorder : (vpiDomains::windowHandle,vpiGrid::key,integer ShiftCtlAlt) -> vpiGrid::keyAction procedure (i,i,i).
	%
	%@short
	%---- Get current action settings.<br>
	% See GRID_KEY,vpiGrid::keyAction domains in grid.dom<br>
	%@detail
	/*
	Get current action settings.<br>
	See tableedit_SetVisitOrder for more details.<br>
	Fail:<br>
	tableedit_GetVisitOrder  fails if action is not assigned for the given Key and ShiftCtrlAlt combination.
	*/
	%@end

 tableedit_optimizecolumnswidth : (vpiDomains::windowHandle,core::booleanInt NotResizableResize)procedure  (i,i).
	%
	%@short
	%@detail
	/*
	Proportional stretch of columns, according to  window  width.<br>
	NotResizableResize = b_true - ignore resizable(b_false) column property.<br>
	Fail:<br>
	Never fails.
	*/
	%@end

  tableedit_getinvisiblemarkers : (vpiDomains::windowHandle) -> core::booleanInt procedure  (i).
	%
	%@short
	% Get state of markers (b_true - invisible, b_false - visible)
	%@detail
	/*
	Get state of markers.<br>
	b_false - The markers are visible.<br>
	b_true - The markers are invisible.<br>
	Fail:<br>
	Never fails.
	*/
	%@end

  tableedit_setinvisiblemarkers : (vpiDomains::windowHandle,core::booleanInt InvisibleVisible)procedure  (i,i).
	%
	%@short
	% Set state for markers (b_true - invisible, b_false - visible)
	%@detail
	/*
	Set state for markers (Visible / Invisible).<br>
	b_false - The markers are visible.<br>
	b_true - The markers are invisible.<br>
	Fail:<br>
	Never fails.
	*/
	%@end

 tableedit_handleevent : (vpiDomains::windowHandle,vpiDomains::event)determ  (i,i).
	%
	%@short
	%---- Global predicate handles all Table editor custom control events.
	%@detail
	/*
	Global predicate handles all Table editor custom control events.<br>
	Table editor class handler may call tableedit_HandleEvent on all events except for e_Create. See chapter  "Using Table editor custom control in application" for more details.<br>
	Fail:<br>
	Never fails.
	*/
	%@end

    predicates
        classInfo : core::classInfo.
        %
        % @short Class information predicate  for the  exception  class.
        %
        %
        % @detail This is the class information predicate for the  exception
        %  class.  The exception handling  system uses this predicate as
        % a class identifier, passing it to one of the parameters needed
        %  for raising or continuing exceptions.
        %
        % @end
        %

end class vpiTableed
