/*****************************************************************************

                    Copyright (C) 1999-2004, Prolog Development Center

 Written by: Thomas Linder Puls
******************************************************************************/

implement odbcBuffer_char
    inherits
        odbcDeferredBuffer
    supports
        odbcBufferChild

constants
    className = "Odbc/OdbcSupport/odbcBuffer_string".
    classVersion = "$JustDate: 2004-10-06 $$Revision: 2 $".

clauses
    classInfo(className, classVersion).

constants
    domainSize = sizeOfDomain(char).

clauses
    getPrologType() = odbc_native::sql_c_wchar.

facts
    longStringSize : unsigned.

clauses
    getSqlType() = odbc_native::sql_wvarchar :-
        getElementByteCount() < longStringSize,
        !.
    getSqlType() = odbc_native::sql_wlongvarchar.

clauses
    new(RowCount) :-
        longStringSize := 1024,
        ByteCount = (1+1)*domainSize,
        odbcDeferredBuffer::new(This, ByteCount, RowCount).

clauses
    constructValue(ValuePointer, _Length) = core::string(Value) :-
        String = uncheckedConvert(string, ValuePointer),
        ContextIndex = odbcProfile::contextOpen(),
        Value = string::createCopy(String),
        odbcProfile::contextClose(ContextIndex).

clauses
    explodeValue(core::string(Value), uncheckedConvert(pointer,Value), ByteSize) :-
        !,
        ByteSize = domainSize * string::length(Value).
    explodeValue(Value, _, _) :-
        odbc_exception::raise_wrongValueType(classInfo, Value, "string").

clauses
    getColumnSize() = ByteCount div domainSize :- %should be positive even for "" empty string
        ByteCount = getElementByteCount().

/*
    inherits
    odbcDeferredBuffer
    supports
    odbcBufferChild

constants
    className = "Odbc/OdbcSupport/odbcBuffer_char".
    classVersion = "$JustDate: 2004-10-06 $$Revision: 2 $".

clauses
    classInfo(className, classVersion).

constants
    domainSize = sizeOfDomain(char).

clauses
    getPrologType() = odbc_native::sql_c_wchar.

clauses
    getSqlType() = odbc_native::sql_wchar.

clauses
    new(RowCount) :-
        odbcDeferredBuffer::new(This, domainSize, RowCount).

domains
    pointerToValue = pointer(char).
clauses
    constructValue(ValuePointer, _Length) = core::char(Value) :-
        pointer(Value) = uncheckedConvert(pointerToValue, ValuePointer).

clauses
    explodeValue(core::char(Value), Pointer, domainSize) :-
        Pointer = uncheckedConvert(pointer, pointer(Value)),
        !.
    explodeValue(Value, _, _) :-
        odbc_exception::raise_wrongValueType(classInfo, Value, "char").
*/
end implement odbcBuffer_char
