/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement aboutDialog
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/aboutDialog".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.
            
    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
            V=globalVars::get_i("p3v"),
            Vs=toString(V),
            R=globalVars::get_i("p3r"),
            Rs=toString(R),
            B=globalVars::get_i("p3b"),
            Bs=toString(B),
            VRB=string::concat(Vs,".",Rs,".",Bs),
            guix::txtSet(thisWin,idc_about_version,VRB),
            S=globalVars::get_s("p3s"),
            guix::txtSet(thisWin,idc_about_status,S),
            D=globalVars::get_s("p3d"),
            guix::txtSet(thisWin,idc_about_date,D),
            !
        ;
            !.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlOK : vpiDomains::controlHandler.
    clauses
        onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            vpi::winDestroy(thisWin).
                        
    % This code is maintained by the VDE do not update it manually, 14:58:42-15.9.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "About Pro/3".
    rectangle : vpiDomains::rct = rct(122,26,238,146).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(36,106,80,118),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(4,34,44,46),"",u_DlgBase),idc_about_version,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(4,48,112,60),"",u_DlgBase),idc_about_status,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(48,34,112,46),"",u_DlgBase),idc_about_date,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Text,rct(4,22,112,32),"Pro/3",u_DlgBase),idct_pro3,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(4,62,112,72),"Copyright (c) 2006 Jens H. Holm",u_DlgBase),idct_copyright_c_2003_holm_pro_3,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(4,72,112,82),"All Rights Reserved",u_DlgBase),idct_all_rights_reserved,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(4,82,112,92),"www.ligaya.net/p3",u_DlgBase),idct_wwwrudstrandcom,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(4,92,112,102),"jens@ligaya.net",u_DlgBase),idct_pro3rudstrandcom,[wsf_AlignCenter]),
        icon(wdef(wc_Icon,rct(48,4,64,20),"",u_DlgBase),idc_aboutdialog_1,application_icon,[])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement aboutDialog
