/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement assistant
open core, vpiDomains, resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/assistant".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.

clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* show all messages */

    predicates
        onControlShowAll : vpiDomains::controlHandler.
    clauses
        onControlShowAll(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGetAll(thisWin,idc_msg,L),
	sx::sxlJoin(L,"\n",S),
	FileName=globalVars::get_s("kb_file"),
	fio::file_name(FileName,Path,_,_),
	sx::concat([Path,"Messages.3rp"],FF),
	file::writeString(FF,S),
	editorWindow::openFiles([FF]),
	!;!.
    
/* create */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_save,idc_update,idc_delete,idc_show_all,idc_dbs,idc_repop,idc_nodes,idc_msg,idc_topics,
  	                                    idc_query,idct_query,idc_annotation],[idc_edit]),
        guix::addWin(4,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
        File=fioExt::getPath("exe","pro3_Guide.xml"),
        guix::ctlVisible(thisWin,[idc_nodes]),
        guix::ctlInvisible(thisWin,[idc_topics]),
        file::existFile(File),
        S=file::readString(File,_),
        X=xmlTree::newTree(S),
        L2=X:getAllOfTag("title"),
        guix::lbxPop(thisWin,idc_topics,L2),
        %
        dlgIF::dlgExpBlock(0,48,Title,Conts),
        guix::ctlInvisible(thisWin,[idc_nodes]),
        guix::ctlVisible(thisWin,[idc_topics]),
        guix::txtSet(thisWin,idc_annotation,"Note!"),
        guix::lbtSel(thisWin,idc_topics,Title),
        guix::txtSet(thisWin,idc_edit,Conts),
        !
;
        !.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.
    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

/* refresh */
            
    predicates
        onControlrepop : vpiDomains::controlHandler.
    clauses
        onControlrepop(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	Nodes=pop::getNodesNL(),
	guix::lbxPop(thisWin,idc_nodes,Nodes),
	!;!.
	
/* save new anno */
	
    predicates
        onControlsave : vpiDomains::controlHandler.
    clauses
        onControlsave(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_nodes,S),
	sx::sxUnpackS(S,": ",L),
	L=[Type,Node],
	dbBase::kbID(Type,Kt,_,_),
	dbBase::kbSym_to_IF(Node,Kn),
	guix::txtGet(thisWin,idc_edit,Note),	
  	dbBase::recordInsert(2,"$DAT",0,0,cmp("p3_pIntd",[cmp("p3_eAnno",[atom(Kt),termDomain::str(Kn),termDomain::str(Note)])]),atom("true"),_),
	dbBase::nlSing("p3_iAnno",Ann),
	sx::concat([Ann,": ",S],S2),
	C2=vpi::winGetCtlHandle(thisWin,idc_nodes),
	vpi::lboxAdd(C2,S2),
  	sx::concat(["Annotation for ",Node," inserted"],Mess),
  	dlgIF::dlgNote(0,Mess),
	!;!.

/* update anno */

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_nodes,S),
  	sx::sxUnpackS(S,": ",L),
  	L=[Type,Node],
	dbBase::kbID(Type,Kt,_,_),
	dbBase::kbSym_to_IF(Node,Kn),
	dbExtension::kbGetAnnotationF(Kt,Kn,_,Loc),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,No,SubNo,_,_,_),
	guix::txtGet(thisWin,idc_edit,Note),
  	dbBase::recordDelete(Loc),
  	dbBase::recordInsert(2,Realm,No,SubNo,cmp("p3_pIntd",[cmp("p3_eAnno",[atom(Kt),termDomain::str(Kn),termDomain::str(Note)])]),atom("true"),_),
  	sx::concat(["Annotation for ",Node," updated"],Mess),
  	dlgIF::dlgNote(0,Mess),
	!;!.
	
/* delete anno */
	
    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_nodes,S),
  	sx::sxUnpackS(S,": ",L),
  	L=[Type,Node],
	dbBase::kbID(Type,Kt,_,_),
	dbBase::kbSym_to_IF(Node,Kn),
	dbExtension::kbGetAnnotationF(Kt,Kn,_,Loc),
  	dbBase::recordDelete(Loc),
  	guix::txtSet(thisWin,idc_edit,""),
  	sx::concat(["Annotation for ",Node," deleted"],Mess),
  	dlgIF::dlgNote(0,Mess),
	!;!.

/* display selected */

    predicates
        onControlnodes : vpiDomains::controlHandler.
    clauses
        onControlnodes(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=selchanged(),
  	guix::lbtGet(thisWin,idc_nodes,S),
  	sx::sxUnpackS(S,": ",L2),
  	L2=[Type,Node],
  	dbExtension::kbGetAnnoNL_F(Type,Node,Note1),
	Note2=sx::replaceAll(Note1,"\n"," "),
	Note3=sx::replaceAll(Note2,"  "," "),
	sx::sxBlockNL(0,48,Note3,Note),
  	guix::txtSet(thisWin,idc_edit,Note),
	!
  ;	
    CtrlInfo=selchanged(),
  	% node does not have annotation
  	guix::txtSet(thisWin,idc_edit,""),
	!;!.
	
% This code is maintained by the VDE do not update it manually, 11:05:07-29.3.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_ClipSiblings,wsf_ClipChildren,wsf_TitleBar,wsf_TopMost].
    rectangle : vpiDomains::rct = rct(100,80,872,443).
    menu : vpiDomains::menu = noMenu.
    title : string = "Assistant".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_Edit,rct(448,140,768,336),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_MultiLine,wsf_VScroll],idc_edit),
        _ = vpi::winCreateControl(wc_PushButton,rct(528,340,600,360),"Save New",Win,[wsf_Group,wsf_TabStop],idc_save),
        _ = vpi::winCreateControl(wc_PushButton,rct(448,340,520,360),"Update",Win,[wsf_Group,wsf_TabStop],idc_update),
        _ = vpi::winCreateControl(wc_PushButton,rct(616,340,688,360),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(448,116,768,356),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_nodes),
        _ = vpi::winCreateControl(wc_Text,rct(8,8,23,24)," ?",Win,[wsf_Simple],idct_query),
        _ = vpi::winCreateControl(wc_LBox,rct(8,32,440,332),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_msg),
        _ = vpi::winCreateControl(wc_PushButton,rct(696,340,768,360),"Refresh",Win,[wsf_Group,wsf_TabStop],idc_repop),
        _ = vpi::winCreateControl(wc_LBox,rct(448,32,768,96),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_dbs),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,336,440,360),"Display all messages",Win,[wsf_Group,wsf_TabStop],idc_show_all),
        _ = vpi::winCreateControl(wc_Text,rct(448,100,768,115),"Annotation",Win,[wsf_AlignCenter],idc_annotation),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(24,4,768,504),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll],idc_query),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(448,116,768,360),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_topics),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_show_all, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlShowAll(idc_show_all, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_repop, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrepop(idc_repop, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsave(idc_save, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_nodes, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnodes(idc_nodes, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code

end implement assistant
