/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement directories
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/directories".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.
            
    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
	Sa=globalVars::get_s("exe_path"),
	Skb=globalVars::get_s("kb_file"),
	fio::file_name(Skb,Pkb2,_,_),
	sx::sxRemoveTail(Pkb2,"\\",Pkb),
	Sd=globalVars::get_s("browser"),
	Se=globalVars::get_s("scan_path"),
	Sh=globalVars::get_s("std_path"),
	Ri=globalVars::get_s("inex"),
	sx::sxDefault(Se,Pkb,Sex),
	sx::sxDefault(Sh,Pkb,Shx),
	guix::txtSet(thisWin,idd_exe_path,Sa),
	guix::txtSet(thisWin,idd_std_path,Skb),
	guix::txtSet(thisWin,idd_browser,Sd),
	guix::txtSet(thisWin,idd_scan_path,Sex),
	guix::txtSet(thisWin,idd_other_path,Shx),
	guix::txtSet(thisWin,idc_inex,Ri),
	TF=tt::getFile(),
	guix::txtSet(thisWin,idc_trace_file,TF),
    CF=fileName::setExtension(Skb,"ini"),
	guix::txtSet(thisWin,idc_conf_file,CF),
	sx::sxGiveTail(Sa,"\\",Sa2),	
    SCF=string::concat(Sa2,"pro3.ini"),
	guix::txtSet(thisWin,idc_sconf_file,SCF),
  	WH=globalVars::get_i("wwwhlp"),
  	guix::guiRB_SetN(thisWin,[idc_use_files,idc_use_www],[-1,1],WH),
	sqlBase::getParameters(L12,_,_,L7,_,_,L10,L11),
	guix::txtSet(thisWin,idc_blank,L7),
	guix::txtSetI(thisWin,idc_tformat,L10),
	guix::txtSetI(thisWin,idc_max_sql,L11),
	guix::txtSetI(thisWin,idc_maxname,L12),
	guix::ctlDisable(thisWin,[idc_tformat,idc_maxname]),
  	!
 ;
 
    !.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

/* ok */

    predicates
        onControlOK : vpiDomains::controlHandler.
    clauses
        onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::txtGet(thisWin,idd_exe_path,Sa),
	guix::txtGet(thisWin,idd_browser,Sd),
	guix::txtGet(thisWin,idd_scan_path,Se),
	guix::txtGet(thisWin,idd_other_path,Sh),
	guix::txtGet(thisWin,idc_inex,Ri),
	sqlBase::getParameters(C,A,_,_,B,_,D,_),
	guix::txtGet(thisWin,idc_blank,L7),
	guix::txtGetI(thisWin,idc_max_sql,L11),
    sqlBase::setParameters(C,A,"",L7,B,"",D,L11),
	sx::sxRemoveTail(Sa,"\\",Sax),
	sx::sxRemoveTail(Se,"\\",Sex),
	sx::sxRemoveTail(Sh,"\\",Shx),
	globalVars::set_s("exe_path",Sax),
	globalVars::set_s("browser",Sd),
	globalVars::set_s("scan_path",Sex),
	globalVars::set_s("std_path",Shx),
	globalVars::set_s("inex",Ri),
  	guix::guiRB_Get(thisWin,[idc_use_files,idc_use_www],[-1,1],WH),
  	globalVars::set_i("wwwhlp",WH),
	vpi::winDestroy(thisWin),
	!
;	
	guix::txtGetI(thisWin,idc_max_sql,Max),
	Max<8000,
	dlgIF::dlgNote(0,"SQL text field max length should not be less than 8000!"),
	!
;	
	guix::txtGetI(thisWin,idc_tformat,F),
	F<1,
	dlgIF::dlgNote(0,"Term-string format must 1 or 2!"),
	!
;	
	guix::txtGetI(thisWin,idc_tformat,F),
	F>2,
	dlgIF::dlgNote(0,"Term-string format must 1 or 2!"),
	!
;	
	guix::txtGetI(thisWin,idc_maxname,F),
	F>128,
	dlgIF::dlgNote(0,"Max. length of SQL names must be in the range 16-128!"),
	!
;	
	guix::txtGetI(thisWin,idc_maxname,F),
	F<16,
	dlgIF::dlgNote(0,"Max. length of SQL names must be in the range 16-128!"),
	!
;
    !.

/* cancel */
                        
    predicates
        onControlCancel : vpiDomains::controlHandler.
    clauses
        onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            vpi::winDestroy(thisWin).

/* browser */

    predicates
        onControlbrowser : vpiDomains::controlHandler.
    clauses
        onControlbrowser(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	File=vpiCommonDialogs::getFileName("*.exe",["","*.exe"],"Internet Browser",[],"",_),
	File<>"",
	guix::txtSet(thisWin,idd_browser,File),
	!
;
    !.

/* help */

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            dlgIF::hlpWeb("w_dir"),
            !.

    % This code is maintained by the VDE do not update it manually, 14:57:46-15.9.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Directory, file and SQL Preferences".
    rectangle : vpiDomains::rct = rct(50,40,360,304).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(32,244,150,260),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(160,244,278,260),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(76,2,308,14),"",u_DlgBase),idd_exe_path,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(76,18,308,30),"",u_DlgBase),idd_std_path,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(76,138,308,150),"",u_DlgBase),idd_browser,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(76,34,308,46),"",u_DlgBase),idd_scan_path,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(76,50,308,62),"",u_DlgBase),idd_other_path,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_PushButton,rct(4,136,72,148),"Browser",u_DlgBase),idc_browser,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,230,112,240),"Use internet help",u_DlgBase),idc_use_www,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(116,230,224,240),"Use local help files",u_DlgBase),idc_use_files,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(76,212,308,224),"",u_DlgBase),idc_inex,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(116,72,308,84),"",u_DlgBase),idc_trace_file,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(116,88,308,100),"",u_DlgBase),idc_conf_file,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(116,104,308,116),"",u_DlgBase),idc_sconf_file,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(240,154,256,166),"",u_DlgBase),idc_blank,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(124,170,172,182),"",u_DlgBase),idc_max_sql,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(124,184,172,196),"",u_DlgBase),idc_tformat,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(124,156,172,168),"",u_DlgBase),idc_maxname,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Text,rct(4,4,72,14),"System root directory",u_DlgBase),idct_system_root_directory,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,20,72,30),"KB",u_DlgBase),idct_kb,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,52,72,62),"All other source files",u_DlgBase),idct_all_other_source_files,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,36,72,46),"Scan files",u_DlgBase),idct_scan_files,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,124,308,130),"All directories must exist before access is attempted - Pro/3 does not create new directories!",u_DlgBase),idct_all_directories_must_exist_before_access_is_attempted_pro3_does_not_create_new_directories,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,202,308,208),"Default realm names:",u_DlgBase),idct_default_realm_names,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,214,72,224),"Inexact rules",u_DlgBase),idct_inexact_rules,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,72,112,82),"Trace file",u_DlgBase),idct_trace_file,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,88,112,98),"KB configuration file",u_DlgBase),idct_conf_file,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,106,112,116),"Pro/3 configuration file",u_DlgBase),idct_configuration_file,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(176,156,234,166),"Blank-substitute",u_DlgBase),idct_blanksubstitute,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,170,120,180),"Max. SQL text field length",u_DlgBase),idct_sttable_name_prefix1,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,184,120,194),"Term-string format",u_DlgBase),idct_max_sql_text_field_length,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(176,182,308,198),"1=Pro/3 term-strings  2=Visual Prolog term-strings)",u_DlgBase),idct_termstring_format,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,156,120,166),"Max. SQL-name lengths",u_DlgBase),idct_max_sql_text_field_length1,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_browser, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlbrowser(idc_browser, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement directories
