/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement guide
open core, vpiDomains, resourceIdentifiers

constants
className = "com/rudstrand/TaskWindow/guide".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

class facts
displayed : (integer) nondeterm. % topics already displayed (topics are only displayed once except from menu).

facts
thisWin : vpiDomains::windowHandle := erroneous.
topic : integer := 0.

clauses
    show(Parent,Topic):-
       topic:=Topic,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0),
        !.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
    globalVars::set_i("explain",1),
    File=fioExt::getPath("exe","pro3_Guide.xml"),
    S=file::readString(File,_),
    X=xmlTree::newTree(S),
    L2=X:getAllOfTag("title"),
    guix::lbxPop(thisWin,idc_topics,L2),
    % select the current topic
    SNo=toString(topic),
    Title=X:getTagValueAfterTag("no",SNo,"title"),
    guix::lbtSel(thisWin,idc_topics,Title),
    Contents=X:getTagValueAfterTag("no",SNo,"content"),
    sx::sxNormalize(Contents,Conts),
    guix::txtSet(thisWin,idc_txt,Conts),
    assert(displayed(topic)),
    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

/* select title */

    predicates
        onControltopics : vpiDomains::controlHandler.
    clauses
        onControltopics(_CtrlID, _CtrlType, _CtrlWin,CtrlInfo) = handled(0) :-
        CtrlInfo=vpiDomains::selchanged,
        guix::lbtGet(thisWin,idc_topics,Title),
        Title<>"",
        File=fioExt::getPath("exe","pro3_Guide.xml"),
        file::existfile(File),
        S=file::readString(File,_),
        X=xmlTree::newTree(S),
        Contents=X:getTagValueAfterTag("title",Title,"content"),
        sx::sxNormalize(Contents,Conts),
        guix::txtSet(thisWin,idc_txt,Conts),
        !;!.

/* noted */

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            vpi::winDestroy(thisWin).

/* help */

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        dlgIF::hlpWeb("w_guide"),
        !;!.

    % This code is maintained by the VDE do not update it manually, 03:05:07-29.3.2005
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "Usage guide".
        rectangle : vpiDomains::rct = rct(50,40,361,193).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 8.

    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(76,138,148,150),"Noted!",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(172,138,244,150),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_LBoxButton,rct(4,2,308,152),"",u_DlgBase),idc_topics,[wsf_Group,wsf_TabStop,wsf_VScroll]),
            ctl(wdef(wc_LBox,rct(324,4,332,16),"",u_DlgBase),idc_nos,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Invisible]),
            ctl(wdef(wc_Text,rct(4,18,308,136),"",u_DlgBase),idc_txt,[wsf_AlignLeft])
            ].

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_topics, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControltopics(idc_topics, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code

alreadyDisplayed(N) :- displayed(N),!.
setDisplayed(N) :- displayed(N),!; assert(displayed(N)),!.
end implement guide
