/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexAndType
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexAndType".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer := -1.

clauses
new(Parent):-
      _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,windowFlags, eventHandler, 0).

getWin()=W:-W=thisWin.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[ idct_prior,idc_prior,idct_parameters,idc_parameters,idc_and,idc_context,idc_and_edit,
  	                   idc_general,idc_store,idct_out,idc_out,idc_rn,idc_rk,idc_realm,idc_add,idc_remove,idc_add_con,idc_remove_con,
  	                   idc_move_up,idc_move_down,idc_upc,idc_downc,idc_calld,idct_dom,idc_rdom,idc_edit_con],[]),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.

    predicates
        onControlgeneral : vpiDomains::controlHandler.
    clauses
        onControlgeneral(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtGet(thisWin,idc_rule_type,Typ),
    Dlg=inexGeneral::new(),
    Dlg:show(thisWin,Typ,Rule),
    L=globalVars::popRetPars(),
    L=[S],
    V=sx::toInt(S),
    set::setMax([declChanged,V],Changed),
    declChanged:=Changed,
	guix::ctlEnable(thisWin,[idc_add,idc_add_con,idc_store]),
	!;!.

    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::lbxGet(thisWin,idc_and,C),
  	guix::txtSet(thisWin,idc_calld,C),
	!;!.

    predicates
        onControlMoveDown : vpiDomains::controlHandler.
    clauses
        onControlMoveDown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlMoveUp : vpiDomains::controlHandler.
    clauses
        onControlMoveUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlAndEdit : vpiDomains::controlHandler.
    clauses
        onControlAndEdit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::lbxGet(thisWin,idc_and,C),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	set::setGet(["p3_iCand","p3_iCor","p3_iCnot","p3_iCcmb"],N,Typ),
  	set::setGet(["p3_iLand","p3_iLor","p3_iLnot","p3_iComb"],N,CallType),
  	guix::lbxRemReselect(thisWin,idc_and),
  	guix::lbxGetAll(thisWin,idc_and,CalledRules),
  	inexgui::readCalledRulesNL(CalledRules,CalledRulesNL),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule|CalledRulesNL],CallType,"p3_dcf",Pars,C),
	!;!.

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	Typ="p3_iCnot",
  	guix::lbxGetAll(thisWin,idc_and,Rules),
  	set::size(Rules,N),
  	N=1,
  	dlgIF::dlgNote(1,"Only one rule can be negated by a NOT-rule!"),
  	!
;  
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	set::setGet(["p3_iCand","p3_iCor","p3_iCnot","p3_iCcmb"],N,Typ),
  	set::setGet(["p3_iLand","p3_iLor","p3_iLnot","p3_iComb"],N,CallType),
  	guix::lbxGetAll(thisWin,idc_and,CalledRules),
  	inexgui::readCalledRulesNL(CalledRules,CalledRulesNL),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule|CalledRulesNL],CallType,"p3_dcf",Pars,""),
	!;!.

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::lbxRemReselect(thisWin,idc_and),
	!;!.

    predicates
        onControlcontext : vpiDomains::controlHandler.
    clauses
        onControlcontext(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) =handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControlupc : vpiDomains::controlHandler.
    clauses
        onControlupc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_context),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControldownc : vpiDomains::controlHandler.
    clauses
        onControldownc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_context),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlEditCon : vpiDomains::controlHandler.
    clauses
        onControlEditCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_context),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,Cal),
	!;!.

    predicates
        onControlRemoveCon : vpiDomains::controlHandler.
    clauses
        onControlRemoveCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::lbxRemReselect(thisWin,idc_context),
	!;!.

    predicates
        onControlAddCon : vpiDomains::controlHandler.
    clauses
        onControlAddCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,""),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) =handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	inexgui::wcrValidate(thisWin,Typ),
  	inexgui::wcrStore(thisWin,Typ,declChanged),
    guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.

    % This code is maintained by the VDE do not update it manually, 13:46:20-8.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,80,956,541).
        menu : vpiDomains::menu = noMenu.
        title : string = "AND/OR/NOT/COMBINATION-type Certainty Rule".

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_Edit,rct(8,124,203,148),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_prior),
            _ = vpi::winCreateControl(wc_Text,rct(8,106,203,121),"Prior probability",Win,[wsf_AlignCenter],idct_prior),
            _ = vpi::winCreateControl(wc_Text,rct(8,163,203,178),"Parameters",Win,[wsf_AlignCenter],idct_parameters),
            _ = vpi::winCreateControl(wc_LBox,rct(8,182,203,304),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_parameters),
            _ = vpi::winCreateControl(wc_Text,rct(231,49,848,64),"AND'ed rules",Win,[wsf_AlignCenter],idct_and_rules),
            _ = vpi::winCreateControl(wc_LBox,rct(231,93,848,222),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_and),
            _ = vpi::winCreateControl(wc_PushButton,rct(162,376,411,411),"Enter/Change General Rule Definition",Win,[wsf_Group,wsf_TabStop],idc_general),
            _ = vpi::winCreateControl(wc_PushButton,rct(446,376,695,411),"(Re-)Store Rule",Win,[wsf_Group,wsf_TabStop],idc_store),
            _ = vpi::winCreateControl(wc_Edit,rct(8,338,203,362),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_out),
            _ = vpi::winCreateControl(wc_Text,rct(8,319,203,334),"Return-value if out of context",Win,[wsf_AlignCenter],idct_out),
            _ = vpi::winCreateControl(wc_Edit,rct(8,5,406,29),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
            _ = vpi::winCreateControl(wc_Edit,rct(411,5,611,29),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
            _ = vpi::winCreateControl(wc_Edit,rct(617,4,852,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_realm),
            _ = vpi::winCreateControl(wc_PushButton,rct(231,67,372,91),"Add Call",Win,[wsf_Group,wsf_TabStop],idc_add),
            _ = vpi::winCreateControl(wc_PushButton,rct(380,67,521,91),"Remove Call",Win,[wsf_Group,wsf_TabStop],idc_remove),
            _ = vpi::winCreateControl(wc_Edit,rct(863,48,959,72),"Rule type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
            _ = vpi::winCreateControl(wc_Edit,rct(863,75,959,99),"critical update",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
            _ = vpi::winCreateControl(wc_PushButton,rct(678,67,759,91),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_move_up),
            _ = vpi::winCreateControl(wc_PushButton,rct(765,67,846,91),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_move_down),
            _ = vpi::winCreateControl(wc_Edit,rct(8,429,854,453),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_calld),
            _ = vpi::winCreateControl(wc_Edit,rct(863,101,959,125),"rdomk",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rdomk),
            _ = vpi::winCreateControl(wc_Edit,rct(8,67,203,91),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rdom),
            _ = vpi::winCreateControl(wc_Text,rct(8,50,203,65),"Return domain",Win,[wsf_AlignCenter],idct_dom),
            _ = vpi::winCreateControl(wc_LBox,rct(231,274,848,366),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Sort],idc_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(380,249,521,273),"Remove Context Call",Win,[wsf_Group,wsf_TabStop],idc_remove_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(231,249,372,273),"Add Context Call",Win,[wsf_Group,wsf_TabStop],idc_add_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(767,249,848,273),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_downc),
            _ = vpi::winCreateControl(wc_PushButton,rct(678,249,759,273),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_upc),
            _ = vpi::winCreateControl(wc_Text,rct(231,233,848,247),"Context",Win,[wsf_AlignCenter],idct_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(529,249,670,273),"Edit Context Call",Win,[wsf_Group,wsf_TabStop],idc_edit_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(529,67,670,91),"Edit Call",Win,[wsf_Group,wsf_TabStop],idc_and_edit),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_general, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlgeneral(idc_general, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveDown(idc_move_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveUp(idc_move_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_and_edit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAndEdit(idc_and_edit, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_context, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcontext(idc_context, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_upc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupc(idc_upc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_downc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldownc(idc_downc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlEditCon(idc_edit_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRemoveCon(idc_remove_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAddCon(idc_add_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexAndType
