/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexBayType
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexBayType".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer := -1.

clauses

new(Parent):-
     _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,windowFlags, eventHandler, 0).

getWin()=W:-W=thisWin.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idct_prior,idc_prior,idct_parameters,idc_parameters,idc_context,idct_dom,idc_rdom,
  	                   idc_general,idc_store,idct_out,idc_out,idc_rn,idc_rk,idc_realm,idc_add_con,idc_remove_con,
  	                   idc_and,idc_add,idc_remove,idc_move_up,idc_move_down,idc_edit_con,idc_edit,
  	                   idc_upc,idc_downc,idc_calld],[]),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.

    predicates
        onControlgeneral : vpiDomains::controlHandler.
    clauses
        onControlgeneral(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtGet(thisWin,idc_rule_type,Typ),
    Dlg=inexGeneral::new(),
    Dlg:show(thisWin,Typ,Rule),
    L=globalVars::popRetPars(),
    L=[S],
    V=sx::toInt(S),
    set::setMax([declChanged,V],Changed),
    declChanged:=Changed,
	guix::ctlEnable(thisWin,[idc_add,idc_add_con,idc_store]),
	!;!.

    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iBay","p3_dcf",Pars,""),
	!;!.

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_and),
	!;!.

    predicates
        onControledit : vpiDomains::controlHandler.
    clauses
        onControledit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_and),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iBay","p3_dcf",Pars,Cal),
	!;!.

    predicates
        onControlMoveUp : vpiDomains::controlHandler.
    clauses
        onControlMoveUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlMoveDown : vpiDomains::controlHandler.
    clauses
        onControlMoveDown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlcontext : vpiDomains::controlHandler.
    clauses
        onControlcontext(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControlEditCon : vpiDomains::controlHandler.
    clauses
        onControlEditCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_context),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,Cal),
	!;!.

    predicates
        onControlAddCon : vpiDomains::controlHandler.
    clauses
        onControlAddCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,""),
	!;!.

    predicates
        onControlRemoveCon : vpiDomains::controlHandler.
    clauses
        onControlRemoveCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_context),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	inexgui::wcrValidate(thisWin,Typ),
  	inexgui::wcrStore(thisWin,Typ,declChanged),
    guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.

    % This code is maintained by the VDE do not update it manually, 12:23:22-9.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(50,80,983,545).
        menu : vpiDomains::menu = noMenu.
        title : string = "Bayesian-type Certainty Rule".

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_Edit,rct(8,96,201,120),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_prior),
            _ = vpi::winCreateControl(wc_Text,rct(8,79,201,93),"Prior probability",Win,[wsf_AlignCenter],idct_prior),
            _ = vpi::winCreateControl(wc_Text,rct(8,134,201,150),"Parameters",Win,[wsf_AlignCenter],idct_parameters),
            _ = vpi::winCreateControl(wc_LBox,rct(8,151,201,259),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_parameters),
            _ = vpi::winCreateControl(wc_Text,rct(217,35,926,49),"Rules in bayesian combination",Win,[wsf_AlignCenter],idct_and_rules),
            _ = vpi::winCreateControl(wc_LBox,rct(218,79,927,229),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_and),
            _ = vpi::winCreateControl(wc_PushButton,rct(208,392,454,424),"Enter/Change General Rule Definition",Win,[wsf_Group,wsf_TabStop],idc_general),
            _ = vpi::winCreateControl(wc_PushButton,rct(501,392,747,424),"(Re-)Store Rule",Win,[wsf_Group,wsf_TabStop],idc_store),
            _ = vpi::winCreateControl(wc_Edit,rct(8,354,201,378),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_out),
            _ = vpi::winCreateControl(wc_Text,rct(8,338,201,352),"Return-value if out of context",Win,[wsf_AlignCenter],idct_out),
            _ = vpi::winCreateControl(wc_Edit,rct(8,4,406,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
            _ = vpi::winCreateControl(wc_Edit,rct(409,4,673,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
            _ = vpi::winCreateControl(wc_Edit,rct(679,4,927,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_realm),
            _ = vpi::winCreateControl(wc_PushButton,rct(217,52,322,76),"Add Call",Win,[wsf_Group,wsf_TabStop],idc_add),
            _ = vpi::winCreateControl(wc_PushButton,rct(325,52,430,76),"Remove Call",Win,[wsf_Group,wsf_TabStop],idc_remove),
            _ = vpi::winCreateControl(wc_Edit,rct(12,577,108,602),"rdomk",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rdomk),
            _ = vpi::winCreateControl(wc_PushButton,rct(651,52,756,76),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_move_down),
            _ = vpi::winCreateControl(wc_PushButton,rct(541,52,646,76),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_move_up),
            _ = vpi::winCreateControl(wc_Edit,rct(10,434,924,458),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_calld),
            _ = vpi::winCreateControl(wc_Edit,rct(112,579,208,604),"critical update",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
            _ = vpi::winCreateControl(wc_Edit,rct(8,51,201,75),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rdom),
            _ = vpi::winCreateControl(wc_Text,rct(8,35,201,49),"Return domain",Win,[wsf_AlignCenter],idct_dom),
            _ = vpi::winCreateControl(wc_PushButton,rct(433,52,538,76),"Edit Call",Win,[wsf_Group,wsf_TabStop],idc_edit),
            _ = vpi::winCreateControl(wc_LBox,rct(218,286,927,378),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Sort],idc_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(363,260,504,284),"Remove Context Call",Win,[wsf_Group,wsf_TabStop],idc_remove_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(219,260,360,284),"Add Context Call",Win,[wsf_Group,wsf_TabStop],idc_add_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(760,260,865,284),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_downc),
            _ = vpi::winCreateControl(wc_PushButton,rct(651,260,756,284),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_upc),
            _ = vpi::winCreateControl(wc_Text,rct(218,243,927,257),"Context",Win,[wsf_AlignCenter],idct_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(507,260,648,284),"Edit Context Call",Win,[wsf_Group,wsf_TabStop],idc_edit_con),
            _ = vpi::winCreateControl(wc_Edit,rct(16,292,112,316),"idc_rule_type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_general, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlgeneral(idc_general, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControledit(idc_edit, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveUp(idc_move_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveDown(idc_move_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_context, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcontext(idc_context, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlEditCon(idc_edit_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAddCon(idc_add_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRemoveCon(idc_remove_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexBayType
