/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement inexCall
    open core, vpiDomains, resourceIdentifiers
    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexCall".
        classVersion = "1.0".
    clauses
        classInfo(className, classVersion).
facts
        thisWin : vpiDomains::windowHandle := erroneous.
        parentWin : vpiDomains::windowHandle := erroneous.
        %callingType : string := "".
        excludeRules : string_list := [].
        callType : string := "".
        domain : string := "".
        callingPars : string_list := [].
        editCall : string := "".
         
clauses
        show(Parent,ExRules,CallType,Domain,Pars,EditCall):-
            parentWin:=Parent,
            %14.4.6callingType:=Type,
            excludeRules:=ExRules,
            callType:=CallType,
            domain:=Domain,
            callingPars:=Pars,
            editCall:=EditCall,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
  	%14.4.6Type=callingType,
  	%14.4.6dbBase::nlSing(Type,TypeNL),
  	%14.4.6guix::txtSet(thisWin,idc_rt,TypeNL),
  	%14.4.6guix::txtSet(thisWin,idc_typ,Type),
  	ExRules=excludeRules,
  	Domain=domain,
  	inexgui::wcrCallable(ExRules,Domain,CRules),
  	ExRules=[Rule|_],
  	guix::lbxPop(thisWin,idc_rules,CRules),
  	guix::txtSet(thisWin,idc_rn,Rule),
  	guix::txtSet(thisWin,idc_dom,Domain),
  	EditCall=editCall,
  	guix::txtSet(thisWin,idc_edit_call,EditCall),
  	CallType=callType,
  	guix::txtSet(thisWin,idc_calltype,CallType),
  	Pars=callingPars,
  	guix::lbxPop(thisWin,idc_pars,Pars),
  	guix::guiRB_SetN(thisWin,[idc_value,idc_call],[1,2],1),
  	guix::guiRB_SetN(thisWin,[idc_value2,idc_call2],[1,2],1),
  	inexgui::wcrCallInit(thisWin),
    !;!.
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.
    predicates
        onControlCancel : vpiDomains::controlHandler.
    clauses
        onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            vpi::winDestroy(thisWin).

    predicates
        onControlrules : vpiDomains::controlHandler.
    clauses
        onControlrules(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbtGet(thisWin,idc_rules,Rn),
  	dbBase::kbID(Rn,Rk,_,_),
 	dbExtension::dbuCR_GetTD(Rk,_,Dk),
	dbBase::nlSing(Dk,Dn),
	guix::txtSet(thisWin,idc_cdom,Dn),
	guix::txtSet(thisWin,idc_cdomk,Dk),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",Rk),
    dbBase::smClassDef(Rk,"h",_,DEs,_,_,_),
  	dbBase::nlSings(DEs,DEsN),
  	guix::lbxGetAll(thisWin,idc_pars,Ds),
  	inexgui::wcrParAss(DEsN,Ds,L),
  	guix::lbxPop(thisWin,idc_actpars,L),
  	inexgui::wcrParSel(thisWin,L),
  	guix::ctlEnable(thisWin,[idc_call,idc_value,idc_call2,idc_value2]),
	!;!.

    predicates
        onControlSetVal : vpiDomains::controlHandler.
    clauses
        onControlSetVal(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_actpars,P),
  	sx::sxUnpackS(P," =",L),
  	L=[Par|_],
  	guix::txtGet(thisWin,idc_val,V),
  	sx::sxStrip(V,Vs),
  	Vs<>"",
  	sx::concat([Par," = ",V],Pm),
  	guix::lbxGetAll(thisWin,idc_actpars,Ps),
  	set::setGet(Ps,No,P),
  	set::setReplace(Ps,No,Pm,Psm),
  	guix::lbxPop(thisWin,idc_actpars,Psm),
  	guix::lbxSel(thisWin,idc_actpars,Pm),
	!;!.

    predicates
        onControlop1 : vpiDomains::controlHandler.
    clauses
        onControlop1(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_op1,S),
  	set::member(S,["=","<>"]),
  	guix::ctlInvisible(thisWin,[idc_op2,idc_v2]),
  	guix::ctlVisible(thisWin,[idc_v1]),
	!
;
  	guix::lbtGet(thisWin,idc_op1,S),
  	S="default",
  	guix::ctlInvisible(thisWin,[idc_op2,idc_v2,idc_v1]),
	!
;
  	guix::ctlVisible(thisWin,[idc_v1,idc_op2,idc_v2]),
  	!;!.
  	
  	/* call-type qualifier */
  	
    predicates
        onControlcall : vpiDomains::controlHandler.
    clauses
        onControlcall(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_rules,Rn),
  	Rn<>"",
  	dbBase::kbID(Rn,Rk,_,_),
  	guix::txtGet(thisWin,idc_calltype,Rt),
  	Rt="p3_iComb",
  	guix::guiRB_SetN(thisWin,[idc_call,idc_value],[1,2],1),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_pars,Pars),
  	guix::txtGet(thisWin,idc_inc,S),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rk,Rule],"p3_iWgtC","p3_dnu",Pars,S),
	!
;
  	guix::lbtGet(thisWin,idc_rules,Rn),
  	Rn<>"",
  	dbBase::kbID(Rn,Rk,_,_),
  	guix::txtGet(thisWin,idc_calltype,Rt),
  	Rt="p3_iBay",
  	guix::guiRB_SetN(thisWin,[idc_call,idc_value],[1,2],1),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_pars,Pars),
  	guix::txtGet(thisWin,idc_inc,S),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rk,Rule],"p3_iIncC","p3_dinc",Pars,S),
	!;!.
	
    predicates
        onControlvalue : vpiDomains::controlHandler.
    clauses
        onControlvalue(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_call,idc_value],[1,2],2),
	!;!.

    predicates
        onControlcall2 : vpiDomains::controlHandler.
    clauses
        onControlcall2(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_call2,idc_value2],[1,2],1),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_pars,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iDecC","p3_ddec",Pars,""),
	!;!.
	
    predicates
        onControlvalue2 : vpiDomains::controlHandler.
    clauses
        onControlvalue2(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_call2,idc_value2],[1,2],2),
	!;!.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_rules,R),
	dbBase::kbID(R,K,_,_),
	dbBase::smClassDef(K,"h",_,DEs,_,_,_),
	set::size(DEs,N),
	guix::lbxGetAll(thisWin,idc_actpars,Pars),
	set::size(Pars,M),
	M<>N,
	C=vpi::winGetCtlHandle(thisWin,idc_rules),
	guix::lbxSel(thisWin,idc_rules,R),
	_=vpi::winSendEvent(thisWin,vpiDomains::e_Control(idc_general,wc_PushButton,C,vpiDomains::selchanged())),
	dlgIF::dlgNote(1,"Enter actual values for the called rule's parameter(s)!"),
	!
;
    W=parentWin,
  	inexgui::wcrRetCall(thisWin,W),
  	vpi::winDestroy(thisWin),
	!;!.

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpNo(60),
	!;!.

    % This code is maintained by the VDE do not update it manually, 22:03:14-14.4.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Calls".
    rectangle : vpiDomains::rct = rct(50,20,362,295).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,257,150,273),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(160,257,306,273),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(5,2,308,14),"",u_DlgBase),idc_rt,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(5,17,308,29),"",u_DlgBase),idc_rn,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_LBox,rct(320,56,399,71),"",u_DlgBase),idc_pars,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Invisible]),
        ctl(wdef(wc_LBoxButton,rct(5,53,214,248),"",u_DlgBase),idc_rules,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_Edit,rct(318,16,434,28),"Calling rule type (e.g. p3_iCand)",u_DlgBase),idc_typ,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Edit,rct(317,29,418,41),"Required domain",u_DlgBase),idc_dom,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_LBox,rct(5,76,308,142),"",u_DlgBase),idc_actpars,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight]),
        ctl(wdef(wc_PushButton,rct(5,143,88,155),"(Re-)set parameter value",u_DlgBase),idc_set_val,[wsf_Group,wsf_TabStop,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(90,143,308,155),"",u_DlgBase),idc_val,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(318,3,430,15),"Shortform for call type (e.g. AND)",u_DlgBase),idc_calltype,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Edit,rct(52,189,308,201),"",u_DlgBase),idc_v2,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_LBoxButton,rct(5,189,50,269),"",u_DlgBase),idc_op2,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_Edit,rct(52,176,308,188),"",u_DlgBase),idc_v1,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_LBoxButton,rct(5,176,50,263),"",u_DlgBase),idc_op1,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_RadioButton,rct(45,205,75,215),"Value",u_DlgBase),idc_value,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(76,204,103,214),"Call",u_DlgBase),idc_call,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(45,230,75,240),"Value",u_DlgBase),idc_value2,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(78,230,105,240),"Call",u_DlgBase),idc_call2,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(5,216,308,228),"",u_DlgBase),idc_inc,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(5,241,308,253),"",u_DlgBase),idc_dec,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(321,73,394,85),"Call to be edited",u_DlgBase),idc_edit_call,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Edit,rct(320,87,421,99),"called domain (k)",u_DlgBase),idc_cdomk,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Text,rct(5,66,308,74),"Parameters and their actual values",u_DlgBase),idct_parameters,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(5,166,308,174),"Condition",u_DlgBase),idct_cond,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(5,40,308,52),"",u_DlgBase),idc_ct,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(5,205,43,215),"",u_DlgBase),idct_increment,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(5,230,43,240),"",u_DlgBase),idct_decrement,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(215,54,309,64),"",u_DlgBase),idc_cdom,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_rules, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrules(idc_rules, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_set_val, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlSetVal(idc_set_val, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_op1, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlop1(idc_op1, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_call, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcall(idc_call, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_value, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlvalue(idc_value, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_call2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcall2(idc_call2, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_value2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlvalue2(idc_value2, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement inexCall
