/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexFuzzyType
open core,vpiDomains,resourceIdentifiers

constants
className = "com/rudstrand/TaskWindow/Inexactrules/inexFuzzyType".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer := -1. % -1/1 IR declaration has been changed (or is new)

clauses
new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

getWin()=W:-W=thisWin.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_and,idc_store,idc_rn,idc_rk,idc_realm,idc_adds,idc_removes,idc_move_ups,idc_move_downs,idc_de2s,
  	                   idc_look_up,idc_refresh,idc_down,idc_up,idc_remove,idc_add,idc_de1s,idc_entity_36,idc_complement,
  	                   idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun,idc_edit,idc_calld],[]),
        DEs=pop::getSM_NL("a",[]),
        guix::lbxPop(thisWin,idc_de2s,DEs),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControlMoveDowns : vpiDomains::controlHandler.
    clauses
        onControlMoveDowns(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlMoveUps : vpiDomains::controlHandler.
    clauses
        onControlMoveUps(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlremoves : vpiDomains::controlHandler.
    clauses
        onControlremoves(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_and),
	!;!.

    predicates
        onControledit : vpiDomains::controlHandler.
    clauses
        onControledit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
	guix::guiRB_Get(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],N),
	set::setGet(["p3_iCoC","p3_iInC","p3_iInC","p3_iInC","p3_iInC","p3_iUnC","p3_iUnC","p3_iUnC","p3_iUnC"],N,Typ),
  	guix::lbxGetAll(thisWin,idc_de1s,Pars),
  	guix::lbxRemReselect(thisWin,idc_and),
  	guix::lbxGetAll(thisWin,idc_and,CalledRules),
  	inexgui::readCalledRulesNL(CalledRules,CalledRulesNL),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule|CalledRulesNL],Typ,"p3_dmg",Pars,Cal),
	!;!.

    predicates
        onControladds : vpiDomains::controlHandler.
    clauses
        onControladds(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_Get(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],N),
	N=1,
  	guix::lbxGetAll(thisWin,idc_and,Rules),
  	set::size(Rules,M),
  	M=1,
  	dlgIF::dlgNote(1,"Only one set can be complemented!"),
  	!
;  
  	guix::txtGet(thisWin,idc_rn,Rule),
	guix::guiRB_Get(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],N),
	set::setGet(["p3_iCoC","p3_iInC","p3_iInC","p3_iInC","p3_iInC","p3_iUnC","p3_iUnC","p3_iUnC","p3_iUnC"],N,Typ),
  	guix::lbxGetAll(thisWin,idc_de1s,Pars),
  	guix::lbxGetAll(thisWin,idc_and,CalledRules),
  	inexgui::readCalledRulesNL(CalledRules,CalledRulesNL),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule|CalledRulesNL],Typ,"p3_dmg",Pars,""),
	!;!.

    predicates
        onControlrefresh : vpiDomains::controlHandler.
    clauses
        onControlrefresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    DEs=pop::getSM_NL("a",[]),
    guix::lbxPop(thisWin,idc_de2s,DEs),
	!;!.

    predicates
        onControlLookUp : vpiDomains::controlHandler.
    clauses
        onControlLookUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	dbBase::kbID_F(DE,_,Clas,_),
	Clas="p3_iDET",	
	W=guix::getWinOfClas(1),
    Obj=sentencemodel::new(W,1),
    Wd=Obj:getWin(),
    sentencemodel::displayDE(Wd,DE),
	!
;
	W=guix::getWinOfClas(1),
    _=sentencemodel::new(W,1),
	!;!.

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	guix::lbxGetAll(thisWin,idc_de1s,DEs),
	not(set::member(DE,DEs)),
	guix::lbxAdd(thisWin,idc_de1s,DE),
    declChanged:=1,
	!;!.

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_de1s),
    declChanged:=1,
	!;!.

    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
    declChanged:=1,
	!;!.

    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
    declChanged:=1,
	!;!.

    predicates
        onControldun : vpiDomains::controlHandler.
    clauses
        onControldun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],9),
	!;!.

    predicates
        onControlbun : vpiDomains::controlHandler.
    clauses
        onControlbun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],8),
	!;!.

    predicates
        onControlaun : vpiDomains::controlHandler.
    clauses
        onControlaun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],7),
	!;!.

    predicates
        onControlun : vpiDomains::controlHandler.
    clauses
        onControlun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],6),
	!;!.

    predicates
        onControldsec : vpiDomains::controlHandler.
    clauses
        onControldsec(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],5),
	!;!.

    predicates
        onControlbsec : vpiDomains::controlHandler.
    clauses
        onControlbsec(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],4),
	!;!.

    predicates
        onControlasec : vpiDomains::controlHandler.
    clauses
        onControlasec(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],3),
	!;!.

    predicates
        onControlsec : vpiDomains::controlHandler.
    clauses
        onControlsec(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],2),
	!;!.

    predicates
        onControlcomplement : vpiDomains::controlHandler.
    clauses
        onControlcomplement(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],1),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_Get(thisWin,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],N),
	set::setGet(["p3_iZnot","p3_iZsand","p3_iZaand","p3_iZband","p3_iZdand","p3_iZsor","p3_iZaor","p3_iZbor","p3_iZdor"],N,Typ),
  	inexgui::wcrValidate(thisWin,Typ),
  	inexgui::wcrStore(thisWin,Typ,declChanged),
  	guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

    % This code is maintained by the VDE do not update it manually, 12:36:16-22.6.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_SizeBorder,wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,40,742,599).
    menu : vpiDomains::menu = noMenu.
    title : string = "Complement/Intersection/Union-type Fuzzy Set Rule".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBox,rct(10,340,624,480),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_and),
        _ = vpi::winCreateControl(wc_PushButton,rct(208,488,452,519),"(Re-)Store Set",Win,[wsf_Group,wsf_TabStop],idc_store),
        _ = vpi::winCreateControl(wc_Edit,rct(11,5,632,29),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
        _ = vpi::winCreateControl(wc_Edit,rct(11,31,314,55),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
        _ = vpi::winCreateControl(wc_Edit,rct(322,31,632,55),"",Win,[wsf_UpperCase,wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_realm),
        _ = vpi::winCreateControl(wc_PushButton,rct(9,315,103,339),"Add Set",Win,[wsf_Group,wsf_TabStop],idc_adds),
        _ = vpi::winCreateControl(wc_PushButton,rct(106,315,200,339),"Remove Set",Win,[wsf_Group,wsf_TabStop],idc_removes),
        _ = vpi::winCreateControl(wc_Edit,rct(665,7,761,31),"Rule type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
        _ = vpi::winCreateControl(wc_Edit,rct(665,34,761,58),"critical update",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
        _ = vpi::winCreateControl(wc_PushButton,rct(300,315,394,339),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_move_ups),
        _ = vpi::winCreateControl(wc_PushButton,rct(398,315,492,339),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_move_downs),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(334,79,523,348),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_de2s),
        _ = vpi::winCreateControl(wc_PushButton,rct(366,105,524,129),"Look up data element",Win,[wsf_Group,wsf_TabStop],idc_look_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(366,161,524,185),"Refresh data elements",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        _ = vpi::winCreateControl(wc_PushButton,rct(252,161,331,185),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_down),
        _ = vpi::winCreateControl(wc_PushButton,rct(252,133,331,157),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(253,106,332,130),"Remove --->",Win,[wsf_Group,wsf_TabStop],idc_remove),
        _ = vpi::winCreateControl(wc_PushButton,rct(252,80,331,104),"<--- Add",Win,[wsf_Group,wsf_TabStop],idc_add),
        _ = vpi::winCreateControl(wc_LBox,rct(91,79,250,185),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_de1s),
        _ = vpi::winCreateControl(wc_Text,rct(90,62,520,77),"Parameters",Win,[wsf_AlignCenter],idc_entity_36),
        _ = vpi::winCreateControl(wc_RadioButton,rct(9,219,114,239),"Complement",Win,[wsf_TabStop,wsf_Auto],idc_complement),
        _ = vpi::winCreateControl(wc_RadioButton,rct(117,218,343,238),"Standard Intersection",Win,[wsf_TabStop,wsf_Auto],idc_sec),
        _ = vpi::winCreateControl(wc_RadioButton,rct(117,241,343,261),"Algebraic Product Intersection",Win,[wsf_TabStop,wsf_Auto],idc_asec),
        _ = vpi::winCreateControl(wc_RadioButton,rct(117,264,343,284),"Bounded Difference Intersection",Win,[wsf_TabStop,wsf_Auto],idc_bsec),
        _ = vpi::winCreateControl(wc_RadioButton,rct(117,288,343,308),"Drastic Intersection",Win,[wsf_TabStop,wsf_Auto],idc_dsec),
        _ = vpi::winCreateControl(wc_RadioButton,rct(346,217,505,237),"Standard Union",Win,[wsf_TabStop,wsf_Auto],idc_un),
        _ = vpi::winCreateControl(wc_RadioButton,rct(346,241,505,261),"Algebraic Sum Union",Win,[wsf_TabStop,wsf_Auto],idc_aun),
        _ = vpi::winCreateControl(wc_RadioButton,rct(346,265,505,285),"Bounded Sum Union",Win,[wsf_TabStop,wsf_Auto],idc_bun),
        _ = vpi::winCreateControl(wc_RadioButton,rct(346,288,505,308),"Drastic Union",Win,[wsf_TabStop,wsf_Auto],idc_dun),
        _ = vpi::winCreateControl(wc_PushButton,rct(203,315,297,339),"Edit Set",Win,[wsf_Group,wsf_TabStop],idc_edit),
        _ = vpi::winCreateControl(wc_Text,rct(8,197,622,212),"Contributing sets",Win,[wsf_AlignCenter],idc_fuzzy_set_ordered_weighted_average_28),
        _ = vpi::winCreateControl(wc_Edit,rct(9,528,623,552),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_calld),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_move_downs, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveDowns(idc_move_downs, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_move_ups, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveUps(idc_move_ups, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_removes, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremoves(idc_removes, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_edit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControledit(idc_edit, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_adds, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladds(idc_adds, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrefresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlLookUp(idc_look_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_dun, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldun(idc_dun, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_bun, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlbun(idc_bun, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_aun, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlaun(idc_aun, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_un, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlun(idc_un, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_dsec, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldsec(idc_dsec, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_bsec, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlbsec(idc_bsec, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_asec, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlasec(idc_asec, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sec, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsec(idc_sec, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_complement, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcomplement(idc_complement, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement inexFuzzyType
