/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexGeneral
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexGeneral".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
parentWin : vpiDomains::windowHandle := erroneous.
ruleType : string := "".
rule : string := "".
declChanged : integer := -1. % -1/1 changes have been made
            
clauses
        show(Parent,Typ,Rule):-
        parentWin:=Parent,
        ruleType:=Typ,
        rule:=Rule,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
    Typ=ruleType,
  	dbBase::nlSing(Typ,TypNL),
  	guix::txtSet(thisWin,idc_typ,Typ),
  	guix::txtSet(thisWin,idc_rt,TypNL),
  	Rule=rule,
  	guix::txtSet(thisWin,idc_rn,Rule),
	Parent=parentWin,
	inexgui::wcrDisplayGeneral(thisWin,Parent,Typ),
	declChanged:=-1,
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlCancel : vpiDomains::controlHandler.
    clauses
        onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            globalVars::pushRetPars(["-1"]),
            vpi::winDestroy(thisWin).

    predicates
        onControldom : vpiDomains::controlHandler.
    clauses
        onControldom(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbtGet(thisWin,idc_dom,Dom),
  	dbBase::kbID(Dom,DomK,_,_),
	DomK="p3_dmg",
  	guix::txtSet(thisWin,idc_domk,DomK),
  	guix::txtSet(thisWin,idc_out,""),
	guix::ctlInvisible(thisWin,[idct_prior,idc_prior,idc_out,idc_out]),
	declChanged:=1,
	!
;
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbtGet(thisWin,idc_dom,Dom),
  	dbBase::kbID(Dom,DomK,_,_),
	set::member(DomK,["p3_dcf","p3_dpr"]),
  	guix::txtSet(thisWin,idc_domk,DomK),
  	guix::txtSet(thisWin,idc_out,""),
	guix::ctlVisible(thisWin,[idct_prior,idc_prior]),
	declChanged:=1,
	!
;
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbtGet(thisWin,idc_dom,Dom),
  	dbBase::kbID(Dom,DomK,_,_),
  	guix::txtSet(thisWin,idc_domk,DomK),
  	guix::txtSet(thisWin,idc_out,""),
  	guix::txtSet(thisWin,idc_prior,"0.5"),
	guix::ctlInvisible(thisWin,[idct_prior,idc_prior]),
	declChanged:=1,
	!;!.

    predicates
        onControlAddDe : vpiDomains::controlHandler.
    clauses
        onControlAddDe(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	DEs=vpi::lboxGetAll(C),
	not(set::member(DE,DEs)),
	vpi::lboxAdd(C,DE),
	declChanged:=1,
	!;!.

    predicates
        onControlrem : vpiDomains::controlHandler.
    clauses
        onControlrem(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxRemReselect(thisWin,idc_de1s),
	declChanged:=1,
	!;!.

    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	declChanged:=1,
	!;!.

    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	declChanged:=1,
	!;!.

    predicates
        onControlrefresh : vpiDomains::controlHandler.
    clauses
        onControlrefresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	DEs=pop::getSM("a",[]),
	guix::lbxPop(thisWin,idc_de2s,DEs),
	!.

    predicates
        onControlLookUp : vpiDomains::controlHandler.
    clauses
        onControlLookUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	dbBase::kbID_F(DE,_,Clas,_),
	Clas="p3_iDET",	
	W=guix::getWinOfClas(1),
    Obj=sentencemodel::new(W,1),
    Wd=Obj:getWin(),
    sentencemodel::displayDE(Wd,DE),
	!
;
	W=guix::getWinOfClas(1),
    _=sentencemodel::new(W,-1),
	!;!.

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpNo(60),
	!.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	Parent=parentWin,
  	guix::txtGet(thisWin,idc_typ,Typ),
  	inexgui::wcrRetGeneral(thisWin,Parent,Typ),
  	P=toString(declChanged),
  	globalVars::pushRetPars([P]),
  	vpi::winDestroy(thisWin),
	!
;
	!.

    % This code is maintained by the VDE do not update it manually, 19:08:34-7.12.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "General Rule Specifications".
    rectangle : vpiDomains::rct = rct(50,40,313,205).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(27,151,123,163),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(146,151,242,163),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(167,45,198,57),"",u_DlgBase),idc_prior,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(103,63,256,75),"",u_DlgBase),idc_out,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_LBox,rct(6,93,87,145),"",u_DlgBase),idc_de1s,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight]),
        ctl(wdef(wc_PushButton,rct(88,133,134,145),"Move Down",u_DlgBase),idc_down,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(88,119,134,131),"Move Up",u_DlgBase),idc_up,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(88,106,134,118),"Remove --->",u_DlgBase),idc_rem,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(88,93,134,105),"<--- Add",u_DlgBase),idc_add_de,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_LBoxEdit,rct(137,106,255,246),"",u_DlgBase),idc_de2s,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_Edit,rct(269,19,341,31),"Parent window handle",u_DlgBase),idc_pw,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Edit,rct(270,4,339,16),"Rule type (e.g. \"p3_iCand\"",u_DlgBase),idc_typ,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Edit,rct(4,2,258,14),"",u_DlgBase),idc_rt,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(4,16,258,28),"",u_DlgBase),idc_rn,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_LBoxButton,rct(4,49,100,184),"",u_DlgBase),idc_dom,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_Edit,rct(271,49,319,61),"critical",u_DlgBase),idc_x,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_Edit,rct(270,35,318,47),"dom",u_DlgBase),idc_domk,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
        ctl(wdef(wc_PushButton,rct(154,119,233,131),"Look up data element",u_DlgBase),idc_look_up,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(154,133,233,145),"Refresh data elements",u_DlgBase),idc_refresh,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Text,rct(111,46,165,56),"Prior probability:",u_DlgBase),idct_prior,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,64,100,74),"Return-value if out of context:",u_DlgBase),idct_out,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(137,95,255,105),"Select new parameters:",u_DlgBase),idct_select_new_parameters,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,37,54,47),"Return domain:",u_DlgBase),idct_dom,[wsf_AlignLeft]),
        ctl(wdef(wc_GroupBox,rct(5,80,257,147),"Input parameters",u_DlgBase),idc_input_parameters,[])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_dom, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldom(idc_dom, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_add_de, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAddDe(idc_add_de, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_rem, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrem(idc_rem, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrefresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlLookUp(idc_look_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement inexGeneral
