/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexMapType
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexMapType".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer := -1. % -1/1 IR decl changed (or is new)

clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

getWin()=W:-W=thisWin.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idct_prior,idc_prior,idct_def,idc_def,idct_parameters,idc_parameters,idc_qdom,idc_rdom,
  	                   idc_general,idc_store,idct_out,idc_out,idc_rn,idc_rk,idc_realm,
  	                   idc_add_con,idc_remove_con,idc_upc,idc_downc,idc_edit_con,idc_context,
  	                   idc_calld,
  	                   idc_nmap,idc_dmap,idc_map,idc_mapc,idct_map_from,idct_map_to,idc_add,idc_and,idct_note,
  	                   idc_no_map],[]),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

    predicates
        onControlgeneral : vpiDomains::controlHandler.
    clauses
        onControlgeneral(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
    Dlg=inexGeneral::new(),
    Dlg:show(thisWin,"p3_iCmap",Rule),
    L=globalVars::popRetPars(),
    L=[S],
    V=sx::toInt(S),
    set::setMax([declChanged,V],Changed),
    declChanged:=Changed,
	guix::ctlEnable(thisWin,[idc_add,idc_add_con,idc_store]),
	!;!.

/* enter or change the single map-call */

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGetAll(thisWin,idc_and,Cals),
  	Cals=[Cal|_],
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtSet(thisWin,idc_calld,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_and),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iMapC","p3_dany",Pars,Cal),
  	!
;
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtSet(thisWin,idc_calld,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_and),
  	vpi::lboxClear(Ctl),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iMapC","p3_dany",Pars,""),
	!;!.

    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControlNoMap : vpiDomains::controlHandler.
    clauses
        onControlNoMap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],1),	
  	guix::lbxPop(thisWin,idc_map,[]),
  	guix::ctlDisable(thisWin,[idc_mapc]),
	guix::txtGet(thisWin,idc_rdomk,RDom),
	guix::txtGet(thisWin,idc_qdomk,QDom),
	RDom=QDom,
	inexgui::wcrHidePrior(thisWin,RDOm),
	declChanged:=1,
	!
;
	guix::txtGet(thisWin,idc_qdomk,QDom),
	guix::txtSet(thisWin,idc_rdomk,QDom),
	dbBase::nlSing(QDom,Dom),
	guix::txtSet(thisWin,idc_rdom,Dom),
	inexgui::wcrHidePrior(thisWin,QDOm),
	declChanged:=1,
	!;!.

    predicates
        onControldmap : vpiDomains::controlHandler.
    clauses
        onControldmap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],2),	
  	guix::lbxPop(thisWin,idc_map,[]),
  	guix::ctlEnable(thisWin,[idc_mapc]),
	!;!.

    predicates
        onControlnmap : vpiDomains::controlHandler.
    clauses
        onControlnmap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],3),	
  	guix::lbxPop(thisWin,idc_map,[]),
  	guix::ctlEnable(thisWin,[idc_mapc]),
	!;!.

    predicates
        onControlmapc : vpiDomains::controlHandler.
    clauses
        onControlmapc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::guiRB_Get(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],N),	
  	set::setGet(["","DISCRETE-VALUE MAPPING","NUMERICAL MAPPING"],N,MapType),
  	guix::txtGet(thisWin,idc_rdomk,TDom),
  	guix::txtGet(thisWin,idc_qdomk,FDom),
  	guix::lbxGetAll(thisWin,idc_map,L),
    Dlg=inexMapping::new(),
    Dlg:show(thisWin,"p3_iCmap",Rule,MapType,FDom,TDom,L),
	!;!.

    predicates
        onControlcontext : vpiDomains::controlHandler.
    clauses
        onControlcontext(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_context,ConCall),
  	guix::txtSet(thisWin,idc_calld,ConCall),
	!;!.

    predicates
        onControlAddCon : vpiDomains::controlHandler.
    clauses
        onControlAddCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,""),
	!.

    predicates
        onControlEditCon : vpiDomains::controlHandler.
    clauses
        onControlEditCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_context),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,Cal),
	!;!.

    predicates
        onControlRemoveCon : vpiDomains::controlHandler.
    clauses
        onControlRemoveCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_context),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	inexgui::wcrValidate(thisWin,"p3_iCmap"),
  	inexgui::wcrStore(thisWin,"p3_iCmap",declChanged),
  	guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.

    % This code is maintained by the VDE do not update it manually, 20:10:38-7.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,80,940,633).
        menu : vpiDomains::menu = noMenu.
        title : string = "Map-type Rule".

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_Edit,rct(8,84,202,108),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_prior),
            _ = vpi::winCreateControl(wc_Text,rct(8,64,202,79),"Prior probability",Win,[wsf_AlignCenter],idct_prior),
            _ = vpi::winCreateControl(wc_Text,rct(8,204,202,219),"Parameters",Win,[wsf_AlignCenter],idct_parameters),
            _ = vpi::winCreateControl(wc_LBox,rct(8,224,202,340),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_parameters),
            _ = vpi::winCreateControl(wc_PushButton,rct(163,481,419,515),"Enter/Change General Rule Definition",Win,[wsf_Group,wsf_TabStop],idc_general),
            _ = vpi::winCreateControl(wc_PushButton,rct(437,481,693,515),"(Re-)Store Rule",Win,[wsf_Group,wsf_TabStop],idc_store),
            _ = vpi::winCreateControl(wc_Edit,rct(8,448,202,472),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_out),
            _ = vpi::winCreateControl(wc_Text,rct(8,424,202,439),"Return-value if out of context",Win,[wsf_AlignCenter],idct_out),
            _ = vpi::winCreateControl(wc_Edit,rct(8,4,372,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
            _ = vpi::winCreateControl(wc_Edit,rct(376,4,597,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
            _ = vpi::winCreateControl(wc_Edit,rct(603,4,835,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_realm),
            _ = vpi::winCreateControl(wc_Text,rct(208,92,409,112),"Default value for mapped rule:",Win,[wsf_AlignLeft],idct_def),
            _ = vpi::winCreateControl(wc_Edit,rct(416,92,823,116),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_def),
            _ = vpi::winCreateControl(wc_Edit,rct(572,195,829,219),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rdom),
            _ = vpi::winCreateControl(wc_LBox,rct(208,224,825,340),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_map),
            _ = vpi::winCreateControl(wc_PushButton,rct(681,168,828,192),"Enter/Change Map",Win,[wsf_Group,wsf_TabStop],idc_mapc),
            _ = vpi::winCreateControl(wc_RadioButton,rct(359,172,504,192),"Numerical Mapping",Win,[wsf_TabStop,wsf_Auto],idc_nmap),
            _ = vpi::winCreateControl(wc_RadioButton,rct(507,172,679,192),"Discrete-value Mapping",Win,[wsf_TabStop,wsf_Auto],idc_dmap),
            _ = vpi::winCreateControl(wc_Edit,rct(136,568,232,592),"critical",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
            _ = vpi::winCreateControl(wc_LBox,rct(208,60,825,86),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_and),
            _ = vpi::winCreateControl(wc_PushButton,rct(392,32,593,56),"Add/Change Mapped Rule",Win,[wsf_Group,wsf_TabStop],idc_add),
            _ = vpi::winCreateControl(wc_Text,rct(208,199,271,219),"Map from",Win,[wsf_AlignLeft],idct_map_from),
            _ = vpi::winCreateControl(wc_Edit,rct(277,196,534,220),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_qdom),
            _ = vpi::winCreateControl(wc_Text,rct(538,198,559,218),"to",Win,[wsf_AlignLeft],idct_map_to),
            _ = vpi::winCreateControl(wc_Edit,rct(16,572,112,596),"q domain",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_qdomk),
            _ = vpi::winCreateControl(wc_Edit,rct(256,568,352,592),"Ret domain",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rdomk),
            _ = vpi::winCreateControl(wc_RadioButton,rct(208,172,353,192),"No Mapping",Win,[wsf_TabStop],idc_no_map),
            _ = vpi::winCreateControl(wc_Text,rct(304,132,719,147),"Note that the default value must be mappable!",Win,[wsf_AlignCenter],idct_note),
            _ = vpi::winCreateControl(wc_Edit,rct(8,522,832,546),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_calld),
            _ = vpi::winCreateControl(wc_Text,rct(208,151,825,166),"Mapping",Win,[wsf_AlignCenter],idct_map),
            _ = vpi::winCreateControl(wc_LBox,rct(208,391,825,471),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Sort],idc_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(361,365,502,389),"Remove Context Call",Win,[wsf_Group,wsf_TabStop],idc_remove_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(208,365,349,389),"Add Context Call",Win,[wsf_Group,wsf_TabStop],idc_add_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(748,365,829,389),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_downc),
            _ = vpi::winCreateControl(wc_PushButton,rct(659,365,740,389),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_upc),
            _ = vpi::winCreateControl(wc_Text,rct(208,348,825,362),"Context",Win,[wsf_AlignCenter],idct_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(510,365,651,389),"Edit Context Call",Win,[wsf_Group,wsf_TabStop],idc_edit_con),
            _ = vpi::winCreateControl(wc_Edit,rct(16,132,112,156),"idc_rule_type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_general, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlgeneral(idc_general, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_no_map, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlNoMap(idc_no_map, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_dmap, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldmap(idc_dmap, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_nmap, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnmap(idc_nmap, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_mapc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlmapc(idc_mapc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_context, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcontext(idc_context, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAddCon(idc_add_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlEditCon(idc_edit_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRemoveCon(idc_remove_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexMapType
