/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement inexMapping
    open core, vpiDomains, resourceIdentifiers
    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexMapping".
        classVersion = "1.0".
    clauses
        classInfo(className, classVersion).
    facts
        thisWin : vpiDomains::windowHandle := erroneous.
        parentWin : vpiDomains::windowHandle := erroneous.
        ruleType : string := "".
        callingRule : string := "".
        mapType : string := "".
        fromDomain : string := "".
        toDomain : string := "".
        maps : string_list := [].
            
    clauses
        show(Parent,Typ,Rule,MapType,FDom,TDom,Maps):-
            ruleType:=Typ,
            parentWin:=Parent,
            callingRule:=Rule,
            mapType:=MapType,
            fromDomain:=FDom,
            toDomain:=TDom,
            maps:=Maps,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
		Rule=callingRule,
		guix::txtSet(thisWin,idc_rn,Rule),
		Maps=maps,
		guix::lbxPop(thisWin,idc_map,Maps),
		Typ=ruleType,
        dbBase::nlSing(Typ,TypNL),
        guix::txtSet(thisWin,idc_rt,TypNL),
        FDom=fromDomain,
        guix::txtSet(thisWin,idc_qdomk,FDom),
        dbBase::nlSing(FDom,Fn),
        guix::txtSet(thisWin,idc_qdom,Fn),
        TDom=toDomain,
        guix::txtSet(thisWin,idc_rdomk,TDom),
        dbBase::nlSing(TDom,Tn),
        guix::txtSet(thisWin,idc_rdom,Tn),
		MapType=mapType,
		guix::txtSet(thisWin,idc_maptype,MapType),
		!;!.
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.
    predicates
        onControlCancel : vpiDomains::controlHandler.
    clauses
        onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            vpi::winDestroy(thisWin).
    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_from,From),
  	guix::txtGet(thisWin,idc_qdomk,Df),
	syn::sbGetDE_Val(Df,From,PR),
	transpr::proPR_Term(PR,_),
  	guix::txtGet(thisWin,idc_to,To),
  	guix::txtGet(thisWin,idc_rdomk,Dt),
	syn::sbGetDE_Val(Dt,To,PR2),
	transpr::proPR_Term(PR2,_),
	sx::concat([From," ---> ",To],S),
	C=vpi::winGetCtlHandle(thisWin,idc_map),
	L=vpi::lboxGetAll(C),
	not(set::member(S,L)),
	vpi::lboxAdd(C,S),
	!;!.
    predicates
        onControlrem : vpiDomains::controlHandler.
    clauses
        onControlrem(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxRemReselect(thisWin,idc_map),
	!;!.
    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_map),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.
    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_map),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.
    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpNo(60),
	!;!.
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGetAll(thisWin,idc_map,L),
  	L=[],
  	PW=parentWin,
  	guix::guiRB_SetN(PW,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],1),	
  	vpi::winDestroy(thisWin),
	!
;
  	guix::lbxGetAll(thisWin,idc_map,L),
  	PW=parentWin,
  	guix::lbxPop(PW,idc_map,L),
  	vpi::winDestroy(thisWin),
	!;!.
    % This code is maintained by the VDE do not update it manually, 09:28:49-18.1.2005
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "Mapping".
        rectangle : vpiDomains::rct = rct(50,40,306,220).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 8.
    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(6,165,126,177),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(131,165,251,177),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_LBox,rct(39,60,252,146),"",u_DlgBase),idc_map,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight]),
            ctl(wdef(wc_PushButton,rct(206,147,252,159),"Move Down",u_DlgBase),idc_down,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(150,147,196,159),"Move Up",u_DlgBase),idc_up,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(95,147,141,159),"Remove",u_DlgBase),idc_rem,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(39,147,85,159),"Add",u_DlgBase),idc_add,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(4,16,109,28),"",u_DlgBase),idc_rt,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(112,16,251,28),"",u_DlgBase),idc_rn,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(7,182,79,194),"Parent window handle",u_DlgBase),idc_pw,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Edit,rct(39,47,131,59),"",u_DlgBase),idc_from,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_Edit,rct(39,32,131,44),"",u_DlgBase),idc_qdom,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(158,32,251,44),"",u_DlgBase),idc_rdom,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(158,47,252,59),"",u_DlgBase),idc_to,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_Edit,rct(4,2,142,14),"",u_DlgBase),idc_maptype,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(85,182,132,194),"From domain",u_DlgBase),idc_qdomk,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Edit,rct(136,182,170,194),"To domain",u_DlgBase),idc_rdomk,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Text,rct(5,49,38,59),"Map from:",u_DlgBase),idct_from,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(133,49,157,59),"Map to:",u_DlgBase),idct_to,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(144,3,155,13),"for",u_DlgBase),idct_for,[wsf_AlignLeft])
            ].
    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_rem, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrem(idc_rem, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexMapping
