/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexNew
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexNew".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
        thisWin : vpiDomains::windowHandle := erroneous.
        parentWin : vpiDomains::windowHandle := erroneous.
        newRule : integer :=0.
        ruleType : string := "".
            
    clauses
        show(Parent,New,Type):-
            parentWin:=Parent,
            newRule:=New,
            ruleType:=Type,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
    Typ=ruleType,
    guix::txtSet(thisWin,idc_typek,Typ),
  	dbBase::nlSing(Typ,TypNL),
  	guix::txtSet(thisWin,idc_type,TypNL),
  	New=newRule,
  	guix::txtSetI(thisWin,idc_new,New),
  	Ri=globalVars::get_s("inex"),
  	guix::txtSet(thisWin,idc_realm,Ri),
  	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlCancel : vpiDomains::controlHandler.
    clauses
        onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
            vpi::winDestroy(thisWin).

    predicates
        onControlrule : vpiDomains::controlHandler.
    clauses
        onControlrule(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::losefocus(),
  	guix::txtGet(thisWin,idc_rule,S),
	dbExtension::kbDefName("c",S,K),
	guix::txtSet(thisWin,idc_kb,K),
	!;!.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGetI(thisWin,idc_new,New),
  	Parent=parentWin,
	inexgui::wcrNew(thisWin,Parent,New),
	vpi::winDestroy(thisWin),
	!;!.

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpNo(60),
	!;!.

    % This code is maintained by the VDE do not update it manually, 21:02:20-17.1.2005
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "New Inexact Reasoning Rule".
        rectangle : vpiDomains::rct = rct(50,40,310,114).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "MS Sans Serif".
        dialogFontSize = 8.

    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(4,59,114,71),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(145,59,256,71),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(4,2,256,14),"",u_DlgBase),idc_type,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(39,43,256,55),"",u_DlgBase),idc_realm,[wsf_UpperCase,wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_Edit,rct(39,29,256,41),"",u_DlgBase),idc_kb,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_Edit,rct(39,15,256,27),"",u_DlgBase),idc_rule,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_Edit,rct(4,85,52,97),"new",u_DlgBase),idc_new,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Edit,rct(55,85,103,97),"typek",u_DlgBase),idc_typek,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Edit,rct(106,85,154,97),"parent",u_DlgBase),idc_parent,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Text,rct(4,44,37,54),"Realm",u_DlgBase),idct_realm,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(4,31,37,41),"KB name",u_DlgBase),idct_kb_name,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(4,18,37,28),"NL name",u_DlgBase),idct_nl_name,[wsf_AlignLeft])
            ].

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_rule, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrule(idc_rule, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexNew
