/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexOWA_Type
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexOWA_Type".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer :=-1.

clauses
new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

getWin()=W:-W=thisWin.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_and,idc_store,idc_rn,idc_rk,idc_realm,idc_adds,idc_removes,idc_move_ups,idc_move_downs,idc_de2s,
  	                   idc_look_up,idc_refresh,idc_down,idc_up,idc_remove,idc_add,idc_de1s,idc_entity_36,idc_edits,idc_calld],[]),
        DEs=pop::getSM_NL("a",[]),
        guix::lbxPop(thisWin,idc_de2s,DEs),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	guix::lbxGetAll(thisWin,idc_de1s,DEs),
	not(set::member(DE,DEs)),
	guix::lbxAdd(thisWin,idc_de1s,DE),
    declChanged:=1,
	!;!.

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_de1s),
    declChanged:=1,
	!.

    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
    declChanged:=1,
	!;!.

    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
    declChanged:=1,
	!;!.

    predicates
        onControlrefresh : vpiDomains::controlHandler.
    clauses
        onControlrefresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    DEs=pop::getSM_NL("a",[]),
	guix::lbxPop(thisWin,idc_de2s,DEs),
	!.

    predicates
        onControlLookUp : vpiDomains::controlHandler.
    clauses
        onControlLookUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	dbBase::kbID_F(DE,_,Clas,_),
	Clas="p3_iDET",	
	W=guix::getWinOfClas(1),
    Obj=sentencemodel::new(W,1),
    Wd=Obj:getWin(),
    sentencemodel::displayDE(Wd,DE),
	!
;
	W=guix::getWinOfClas(1),
    _=sentencemodel::new(W,1),
	!;!.

    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtSet(thisWin,idc_and,Cal),
	!;!.

    predicates
        onControlMoveDowns : vpiDomains::controlHandler.
    clauses
        onControlMoveDowns(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlMoveUps : vpiDomains::controlHandler.
    clauses
        onControlMoveUps(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_and),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlremoves : vpiDomains::controlHandler.
    clauses
        onControlremoves(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_and),
	!.

    predicates
        onControledits : vpiDomains::controlHandler.
    clauses
        onControledits(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_de1s,Pars),
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::lbxRemReselect(thisWin,idc_and),
  	guix::lbxGetAll(thisWin,idc_and,CalledRules),
  	inexgui::readCalledRulesNL(CalledRules,CalledRulesNL),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule|CalledRulesNL],"p3_iOwaC","p3_dmg",Pars,Cal),
	!;!.

    predicates
        onControladds : vpiDomains::controlHandler.
    clauses
        onControladds(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_de1s,Pars),
  	guix::lbxGetAll(thisWin,idc_and,CalledRules),
  	inexgui::readCalledRulesNL(CalledRules,CalledRulesNL),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule|CalledRulesNL],"p3_iOwaC","p3_dmg",Pars,""),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	inexgui::wcrValidate(thisWin,"p3_iZowa"),
  	inexgui::wcrStore(thisWin,"p3_iZowa",declChanged),
  	guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

    % This code is maintained by the VDE do not update it manually, 22:00:30-6.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,80,829,578).
        menu : vpiDomains::menu = noMenu.
        title : string = "Ordered Weighted Averages-type Fuzzy Set Rule ".

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_LBox,rct(8,248,720,419),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_and),
            _ = vpi::winCreateControl(wc_PushButton,rct(251,428,495,462),"(Re-)Store Set",Win,[wsf_Group,wsf_TabStop],idc_store),
            _ = vpi::winCreateControl(wc_Edit,rct(9,4,721,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
            _ = vpi::winCreateControl(wc_Edit,rct(9,30,371,54),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
            _ = vpi::winCreateControl(wc_Edit,rct(375,30,721,54),"",Win,[wsf_UpperCase,wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_realm),
            _ = vpi::winCreateControl(wc_PushButton,rct(8,221,102,245),"Add Set",Win,[wsf_Group,wsf_TabStop],idc_adds),
            _ = vpi::winCreateControl(wc_PushButton,rct(105,221,199,245),"Remove Set",Win,[wsf_Group,wsf_TabStop],idc_removes),
            _ = vpi::winCreateControl(wc_Edit,rct(763,61,859,85),"Rule type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
            _ = vpi::winCreateControl(wc_Edit,rct(760,26,856,50),"critical update",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
            _ = vpi::winCreateControl(wc_PushButton,rct(299,221,393,245),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_move_ups),
            _ = vpi::winCreateControl(wc_PushButton,rct(397,221,491,245),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_move_downs),
            _ = vpi::winCreateControl(wc_LBoxEdit,rct(387,84,576,353),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_de2s),
            _ = vpi::winCreateControl(wc_PushButton,rct(419,110,577,134),"Look up data element",Win,[wsf_Group,wsf_TabStop],idc_look_up),
            _ = vpi::winCreateControl(wc_PushButton,rct(419,166,577,190),"Refresh data elements",Win,[wsf_Group,wsf_TabStop],idc_refresh),
            _ = vpi::winCreateControl(wc_PushButton,rct(305,166,384,190),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_down),
            _ = vpi::winCreateControl(wc_PushButton,rct(305,138,384,162),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_up),
            _ = vpi::winCreateControl(wc_PushButton,rct(306,111,385,135),"Remove --->",Win,[wsf_Group,wsf_TabStop],idc_remove),
            _ = vpi::winCreateControl(wc_PushButton,rct(305,85,384,109),"<--- Add",Win,[wsf_Group,wsf_TabStop],idc_add),
            _ = vpi::winCreateControl(wc_LBox,rct(144,84,303,190),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_de1s),
            _ = vpi::winCreateControl(wc_Text,rct(144,64,574,82),"Parameters",Win,[wsf_AlignCenter],idc_entity_36),
            _ = vpi::winCreateControl(wc_Edit,rct(8,466,720,490),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_calld),
            _ = vpi::winCreateControl(wc_Text,rct(9,199,721,217),"Contributing sets",Win,[wsf_AlignCenter],idc_fuzzy_set_ordered_weighted_average_28),
            _ = vpi::winCreateControl(wc_PushButton,rct(202,221,296,245),"Edit Set",Win,[wsf_Group,wsf_TabStop],idc_edits),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrefresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlLookUp(idc_look_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_downs, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveDowns(idc_move_downs, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_ups, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveUps(idc_move_ups, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_removes, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremoves(idc_removes, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edits, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControledits(idc_edits, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_adds, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladds(idc_adds, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexOWA_Type
