/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement inexQueryType
    open core, vpiDomains, resourceIdentifiers
    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexQueryType".
        classVersion = "1.0".
    clauses
        classInfo(className, classVersion).
facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer := -1. % -1/1 IR decl changed (or is new)

clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
getWin()=W:-W=thisWin.
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idct_prior,idc_prior,idct_def,idc_def,idct_parameters,idc_parameters,idc_context,idct_dom,idc_rdom,
  	                   idc_general,idc_store,idct_out,idc_out,idc_rn,idc_rk,idc_realm,idc_add_con,idc_remove_con,idc_qdom,idct_qdom,
  	                   idc_query,idc_no_map,idc_nmap,idc_dmap,idc_map,idc_mapc,idc_run,idc_val,
  	                   idc_upc,idc_downc,idc_calld,idc_edit_con],[]),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.
            
    predicates
        onControlgeneral : vpiDomains::controlHandler.
    clauses
        onControlgeneral(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtGet(thisWin,idc_rule_type,Typ),
    Dlg=inexGeneral::new(),
    Dlg:show(thisWin,Typ,Rule),
    L=globalVars::popRetPars(),
    L=[S],
    V=sx::toInt(S),
    set::setMax([declChanged,V],Changed),
    declChanged:=Changed,
	!;!.

    predicates
        onControlqdom : vpiDomains::controlHandler.
    clauses
        onControlqdom(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_qdom,Dom),
  	dbBase::kbID(Dom,DomK,_,_),
  	guix::txtSet(thisWin,idc_qdomk,DomK),
	!;!.

    predicates
        onControlval : vpiDomains::controlHandler.
    clauses
        onControlval(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_query,Q),
	guix::txtGet(thisWin,idc_realm,Realm),
	guix::txtGet(thisWin,idc_rk,RuleK),
	guix::txtGet(thisWin,idc_rn,RuleN),
	inexgui::wcrSyntagmIns(RuleN,RuleK,Realm),
	irBase::wcrTransQuery(Q,_,QDom),
	guix::txtSet(thisWin,idc_qdomk,QDom),
	dbBase::nlSing(QDom,Dom),
	guix::lbxPop(thisWin,idc_qdom,[Dom]),
	guix::lbtSel(thisWin,idc_qdom,Dom),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

    predicates
        onControlrun : vpiDomains::controlHandler.
    clauses
        onControlrun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_query,Qu),
	sx::sxStrip(Qu,Q2),
	sx::sxGiveTail(Q2,"?",Q),
	dbBase::nlSing("p3_iIsTr",NL),
	sx::searchstring(Q,NL,Pos),
	Pos=1,
	% is it true that ... query
    P=globalVars::get_s("std_path"),
    sx::makeIdentifier(1,3,2,Q2,64,"",Name),
    Opt=globalVars::get_i("f_outq"),
    fioExt::file_type(Opt,Ext),
    FName=string::concat(P,"\\",Name,".",Ext),
    File=outFile::new(FName,Opt),
	proc::runQueryNL_F(File,Q),
	proc::showResponse(1,File),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;  
    vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_query,Qu),
	sx::sxStrip(Qu,Q2),
	sx::sxGiveTail(Q2,"?",Q),
	dbBase::nlForm("p3_iWha","p3_iNIL",What),
	sx::concat([What,"=",Q],Sq),
    P=globalVars::get_s("std_path"),
    sx::makeIdentifier(1,3,2,Q2,64,"",Name),
    Opt=globalVars::get_i("f_outq"),
    fioExt::file_type(Opt,Ext),
    FName=string::concat(P,"\\",Name,".",Ext),
    File=outFile::new(FName,Opt),
	proc::runQueryNL_F(File,Sq),
	proc::showResponse(1,File),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

    predicates
        onControlcontext : vpiDomains::controlHandler.
    clauses
        onControlcontext(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
        CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_context,ConCall),
  	guix::txtSet(thisWin,idc_calld,ConCall),
	!;!.

    predicates
        onControlupc : vpiDomains::controlHandler.
    clauses
        onControlupc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_context),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControldownc : vpiDomains::controlHandler.
    clauses
        onControldownc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_context),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlEditCon : vpiDomains::controlHandler.
    clauses
        onControlEditCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_context),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,Cal),
	!;!.
    predicates
        onControlRemoveCon : vpiDomains::controlHandler.
    clauses
        onControlRemoveCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_context),
	!;!.

    predicates
        onControlAddCon : vpiDomains::controlHandler.
    clauses
        onControlAddCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,""),
	!;!.

    predicates
        onControldmap : vpiDomains::controlHandler.
    clauses
        onControldmap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGetAll(thisWin,idc_qdom,L),
	L=[],
  	dlgIF::dlgNote(0,"Validate query first!"),
  	!
;
  	guix::guiRB_SetN(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],2),	
  	guix::lbxPop(thisWin,idc_map,[]),
  	guix::ctlEnable(thisWin,[idc_mapc]),
  	!;!.

    predicates
        onControlnmap : vpiDomains::controlHandler.
    clauses
        onControlnmap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGetAll(thisWin,idc_qdom,L),
	L=[],
  	dlgIF::dlgNote(0,"Validate query first!"),
  	!
;
  	guix::guiRB_SetN(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],3),	
  	guix::lbxPop(thisWin,idc_map,[]),
  	guix::ctlEnable(thisWin,[idc_mapc]),
	!;!.

    predicates
        onControlNoMap : vpiDomains::controlHandler.
    clauses
        onControlNoMap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],1),	
  	guix::lbxPop(thisWin,idc_map,[]),
  	guix::ctlDisable(thisWin,[idc_mapc]),
	guix::txtGet(thisWin,idc_rdomk,RDom),
	guix::txtGet(thisWin,idc_qdomk,QDom),
	RDom=QDom,
	!
;
	guix::txtGet(thisWin,idc_qdomk,QDom),
	guix::txtSet(thisWin,idc_rdomk,QDom),
	dbBase::nlSing(QDom,Dom),
	guix::txtSet(thisWin,idc_rdom,Dom),
	guix::txtSet(thisWin,idc_x,"x"),	  	
	!;!.

    predicates
        onControlmapc : vpiDomains::controlHandler.
    clauses
        onControlmapc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::guiRB_Get(thisWin,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],N),
  	set::setGet(["","DISCRETE-VALUE MAPPING","NUMERICAL MAPPING"],N,MapType),
  	guix::txtGet(thisWin,idc_qdomk,FDomK),
  	guix::txtGet(thisWin,idc_rdomk,TDomK),
  	guix::lbxGetAll(thisWin,idc_map,L),
    Dlg=inexMapping::new(),
    Dlg:show(thisWin,Typ,Rule,MapType,FDomK,TDomK,L),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	inexgui::wcrValidate(thisWin,Typ),
  	inexgui::wcrStore(thisWin,Typ,declChanged),
  	guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.
    % This code is maintained by the VDE do not update it manually, 15:20:07-9.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,50,950,626).
        menu : vpiDomains::menu = noMenu.
        title : string = "Data Rule".
    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_Edit,rct(10,56,201,80),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_prior),
            _ = vpi::winCreateControl(wc_Text,rct(10,39,201,53),"Prior probability",Win,[wsf_AlignCenter],idct_prior),
            _ = vpi::winCreateControl(wc_Text,rct(10,217,201,231),"Parameters",Win,[wsf_AlignCenter],idct_parameters),
            _ = vpi::winCreateControl(wc_LBox,rct(10,232,201,356),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_parameters),
            _ = vpi::winCreateControl(wc_LBox,rct(219,401,836,493),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Sort],idc_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(160,505,438,534),"Enter/Change General Rule Definition",Win,[wsf_Group,wsf_TabStop],idc_general),
            _ = vpi::winCreateControl(wc_PushButton,rct(462,505,740,534),"(Re-)Store Rule",Win,[wsf_Group,wsf_TabStop],idc_store),
            _ = vpi::winCreateControl(wc_Edit,rct(10,469,201,493),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_out),
            _ = vpi::winCreateControl(wc_Text,rct(10,453,201,467),"Return-value if out of context",Win,[wsf_AlignCenter],idct_out),
            _ = vpi::winCreateControl(wc_Edit,rct(9,4,373,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
            _ = vpi::winCreateControl(wc_Edit,rct(384,4,601,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
            _ = vpi::winCreateControl(wc_Edit,rct(608,4,843,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_realm),
            _ = vpi::winCreateControl(wc_PushButton,rct(368,376,509,400),"Remove Context Call",Win,[wsf_Group,wsf_TabStop],idc_remove_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(219,376,360,400),"Add Context Call",Win,[wsf_Group,wsf_TabStop],idc_add_con),
            _ = vpi::winCreateControl(wc_Edit,rct(854,15,950,39),"Rule type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
            _ = vpi::winCreateControl(wc_Text,rct(220,156,377,176),"Default value:",Win,[wsf_AlignLeft],idct_def),
            _ = vpi::winCreateControl(wc_Edit,rct(380,152,632,176),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_def),
            _ = vpi::winCreateControl(wc_Edit,rct(10,126,201,150),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rdom),
            _ = vpi::winCreateControl(wc_Text,rct(10,110,201,124),"Return domain",Win,[wsf_AlignCenter],idct_dom),
            _ = vpi::winCreateControl(wc_Edit,rct(216,80,833,146),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_MultiLine],idc_query),
            _ = vpi::winCreateControl(wc_LBox,rct(219,232,836,356),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_map),
            _ = vpi::winCreateControl(wc_PushButton,rct(662,206,836,230),"Enter/Change Map",Win,[wsf_Group,wsf_TabStop],idc_mapc),
            _ = vpi::winCreateControl(wc_PushButton,rct(739,152,837,176),"Run query",Win,[wsf_Group,wsf_TabStop],idc_run),
            _ = vpi::winCreateControl(wc_Text,rct(220,59,273,79),"Domain:",Win,[wsf_AlignLeft],idct_qdom),
            _ = vpi::winCreateControl(wc_RadioButton,rct(219,210,316,230),"No Mapping",Win,[wsf_TabStop],idc_no_map),
            _ = vpi::winCreateControl(wc_RadioButton,rct(320,210,468,230),"Numerical Mapping",Win,[wsf_TabStop,wsf_Auto],idc_nmap),
            _ = vpi::winCreateControl(wc_RadioButton,rct(478,210,645,230),"Discrete-value Mapping",Win,[wsf_TabStop,wsf_Auto],idc_dmap),
            _ = vpi::winCreateControl(wc_Edit,rct(853,43,949,67),"q dom",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_qdomk),
            _ = vpi::winCreateControl(wc_Edit,rct(852,71,948,95),"critical",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
            _ = vpi::winCreateControl(wc_Edit,rct(850,98,946,122),"ret dom",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rdomk),
            _ = vpi::winCreateControl(wc_PushButton,rct(755,376,836,400),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_downc),
            _ = vpi::winCreateControl(wc_PushButton,rct(666,376,747,400),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_upc),
            _ = vpi::winCreateControl(wc_Edit,rct(8,545,846,569),"",Win,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft],idc_calld),
            _ = vpi::winCreateControl(wc_PushButton,rct(636,152,734,176),"Validate query",Win,[wsf_Group,wsf_TabStop],idc_val),
            _ = vpi::winCreateControl(wc_LBoxButton,rct(277,56,496,463),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_qdom),
            _ = vpi::winCreateControl(wc_Text,rct(216,36,833,53),"Query",Win,[wsf_AlignCenter],idct_query),
            _ = vpi::winCreateControl(wc_Text,rct(218,190,835,207),"Map",Win,[wsf_AlignCenter],idct_map),
            _ = vpi::winCreateControl(wc_Text,rct(219,360,836,374),"Context",Win,[wsf_AlignCenter],idct_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(517,376,658,400),"Edit Context Call",Win,[wsf_Group,wsf_TabStop],idc_edit_con),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_general, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlgeneral(idc_general, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_qdom, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlqdom(idc_qdom, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_val, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlval(idc_val, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_run, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrun(idc_run, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_context, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcontext(idc_context, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_upc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupc(idc_upc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_downc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldownc(idc_downc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlEditCon(idc_edit_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRemoveCon(idc_remove_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAddCon(idc_add_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_dmap, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldmap(idc_dmap, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_nmap, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnmap(idc_nmap, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_no_map, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlNoMap(idc_no_map, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_mapc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlmapc(idc_mapc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexQueryType
