/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexQuestion
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Inexactrules/inexQuestion".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.
        question : string :="".
        rule : string :="".
        altsNL : string_list :=[].
        domain : string :="".
        default : string :="".
            
    clauses
        show(Parent,Question,Rule,AltsNL,Dom,Def):-
            question:=Question,
            rule:=Rule,
            altsNL:=AltsNL,
            domain:=Dom,
            default:=Def,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
    AltsNL=altsNL,
    AltsNL=[],
    guix::lbxPop(thisWin,idc_list,AltsNL),
    Rule=rule,
	guix::txtSet(thisWin,idc_rulek,Rule),
  	dbBase::nlSing(Rule,RuleNL),
  	guix::txtSet(thisWin,idc_rule,RuleNL),
  	guix::txtSet(thisWin,idc_dom,domain),
	guix::txtSet(thisWin,idc_question,question),
	dbExtension::kbGetAnnotationBlank("p3_iIR",Rule,Anno),
	guix::txtSet(thisWin,idc_anno,Anno),
	guix::txtSet(thisWin,idc_default,default),
  	guix::ctlInvisible(thisWin,[idc_list]),
  	!
;
    AltsNL=altsNL,
    guix::lbxPop(thisWin,idc_list,AltsNL),
    Rule=rule,
	guix::txtSet(thisWin,idc_rulek,Rule),
  	dbBase::nlSing(Rule,RuleNL),
  	guix::txtSet(thisWin,idc_rule,RuleNL),
  	guix::txtSet(thisWin,idc_dom,domain),
	guix::txtSet(thisWin,idc_question,question),
	dbExtension::kbGetAnnotationBlank("p3_iIR",Rule,Anno),
	guix::txtSet(thisWin,idc_anno,Anno),
	guix::txtSet(thisWin,idc_default,default),
	guix::ctlInvisible(thisWin,[idc_edit]),
    !;
    !.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
    onControlidc_stop : vpiDomains::controlHandler.
    clauses
    onControlidc_stop(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    vpiCommonDialogs::ask("Please confirm","Do you really want to stop evaluation of the inexact rule network (and related query)?",["Yes","No"])=vpiCommonDialogs::resp_default,
    ir::setBreak(1),
  	globalVars::pushRetPars(["0"]),
    vpi::winDestroy(thisWin),
    !;!.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGetAll(thisWin,idc_list,L),
  	L=[],
  	guix::txtGet(thisWin,idc_edit,Si),
  	Si="", % use default
  	globalVars::pushRetPars(["1",default]),
  	vpi::winDestroy(thisWin),
	!
;
  	guix::lbxGetAll(thisWin,idc_list,L),
  	L=[],
  	guix::txtGet(thisWin,idc_edit,S),
  	globalVars::pushRetPars(["2",S]),
  	vpi::winDestroy(thisWin),
	!
;
  	guix::lbxGet(thisWin,idc_list,S),
  	globalVars::pushRetPars(["2",S]),
  	vpi::winDestroy(thisWin),
  	!
;
  	globalVars::pushRetPars(["1",default]),
  	vpi::winDestroy(thisWin),
	!;!.

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpNo(60),
	!;!.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
  	globalVars::pushRetPars(["1",default]),
  	vpi::winDestroy(thisWin),
	!.

% This code is maintained by the VDE do not update it manually, 12:14:55-25.5.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Question (inexact rule)".
    rectangle : vpiDomains::rct = rct(50,40,327,290).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,236,88,248),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(96,236,180,248),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(4,52,273,64),"",u_DlgBase),idc_edit,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_LBox,rct(4,65,273,173),"",u_DlgBase),idc_list,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight]),
        ctl(wdef(wc_Edit,rct(4,3,142,15),"",u_DlgBase),idc_rule,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(146,3,273,15),"",u_DlgBase),idc_dom,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(4,19,273,48),"",u_DlgBase),idc_question,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_MultiLine]),
        ctl(wdef(wc_Edit,rct(50,176,273,188),"",u_DlgBase),idc_default,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(4,192,273,230),"",u_DlgBase),idc_anno,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_MultiLine]),
        ctl(wdef(wc_Edit,rct(292,4,326,16),"_rulek",u_DlgBase),idc_rulek,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(293,17,326,29),"_ans",u_DlgBase),idc_ans,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(293,32,326,44),"_anstyp",u_DlgBase),idc_anstyp,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_PushButton,rct(188,236,272,248),"Stop",u_DlgBase),idc_stop,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Text,rct(4,178,47,188),"Default value",u_DlgBase),idct_default_value,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_stop, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_stop(idc_stop, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement inexQuestion
