/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inexSwitchType
open core, vpiDomains, resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/Inexactrules/inexSwitchType".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
declChanged : integer := -1. % -1/1 IR decl changed (or is new)

clauses
new(Parent):-
    _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,windowFlags, eventHandler, 0).

getWin()=W:-W=thisWin.

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idct_prior,idc_prior,idct_def,idc_def,idct_parameters,idc_parameters,idc_context,idc_qdom,idc_rdom,
  	                   idc_general,idc_store,idct_out,idc_out,idc_rn,idc_rk,idc_realm,idc_add_con,idc_remove_con,
  	                   idc_map,idc_add,idc_and,idc_rem,idc_addcrit,idct_map_from,idc_edit_con,idc_switch_edit,
  	                   idc_move_up,idc_move_down,idc_upc,idc_downc,idct_default,
  	                   idc_calld],[]),
        guix::addWin(61,thisWin),
        declChanged:=-1,
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.

    predicates
        onControlgeneral : vpiDomains::controlHandler.
    clauses
        onControlgeneral(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtGet(thisWin,idc_rule_type,Typ),
    Dlg=inexGeneral::new(),
    Dlg:show(thisWin,Typ,Rule),
    L=globalVars::popRetPars(),
    L=[S],
    V=sx::toInt(S),
    set::setMax([declChanged,V],Changed),
    declChanged:=Changed,
	guix::ctlEnable(thisWin,[idc_add,idc_add_con,idc_store]),
	!;!.

    predicates
        onControlparameters : vpiDomains::controlHandler.
    clauses
        onControlparameters(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
	guix::lbtGet(thisWin,idc_parameters,DE),
	dbBase::kbID(DE,K,_,_),
	dbBase::smClassDef(K,"a",_,_,Dom,_,_),
	dbBase::nlSing(Dom,DomNL),
	guix::txtSet(thisWin,idc_qdom,DomNL),
	guix::txtSet(thisWin,idc_qdomk,Dom),
	guix::ctlEnable(thisWin,[idc_def,idc_add]),
	!;!.

    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_and,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControladdcrit : vpiDomains::controlHandler.
    clauses
        onControladdcrit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGetAll(thisWin,idc_and,Cals),
  	Cals=[Cal],
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtSet(thisWin,idc_calld,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_and),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iSwiCr","p3_dany",Pars,Cal),
  	!
;
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::txtSet(thisWin,idc_calld,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_and),
  	vpi::lboxClear(Ctl),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iSwiCr","p3_dany",Pars,""),
	!;!.

    predicates
        onControlmap : vpiDomains::controlHandler.
    clauses
        onControlmap(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_map,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	Typ="p3_iCswc",
  	guix::lbxGetAll(thisWin,idc_and,L),
  	L=[],
  	dlgIF::dlgNote(0,"Enter the switch criterion first!"),
  	!
;
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	Typ="p3_iCswp",
  	not(guix::lbxGet(thisWin,idc_parameters,_)),
  	dlgIF::dlgNote(0,"Select the switch parameter in the parameters listbox first!"),
  	!
;
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::txtGet(thisWin,idc_rdomk,Dom),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iSwi",Dom,Pars,""),
	!;!.

    predicates
        onControlSwitchEdit : vpiDomains::controlHandler.
    clauses
        onControlSwitchEdit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_map,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::txtGet(thisWin,idc_rdomk,Dom),
  	guix::lbxRemReselect(thisWin,idc_map),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iSwi",Dom,Pars,Cal),
	!;!.

    predicates
        onControlrem : vpiDomains::controlHandler.
    clauses
        onControlrem(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_map),
	!;!.

    predicates
        onControlMoveDown : vpiDomains::controlHandler.
    clauses
        onControlMoveDown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_map),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlMoveUp : vpiDomains::controlHandler.
    clauses
        onControlMoveUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_map),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlcontext : vpiDomains::controlHandler.
    clauses
        onControlcontext(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtSet(thisWin,idc_calld,Cal),
	!;!.

    predicates
        onControlupc : vpiDomains::controlHandler.
    clauses
        onControlupc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_context),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControldownc : vpiDomains::controlHandler.
    clauses
        onControldownc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_context),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlAddCon : vpiDomains::controlHandler.
    clauses
        onControlAddCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,""),
	!;!.

    predicates
        onControlEditCon : vpiDomains::controlHandler.
    clauses
        onControlEditCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_context,Cal),
  	guix::txtGet(thisWin,idc_rn,Rule),
  	guix::lbxGetAll(thisWin,idc_parameters,Pars),
  	guix::lbxRemReselect(thisWin,idc_context),
    Dlg=inexCall::new(),
    Dlg:show(thisWin,[Rule],"p3_iCon","p3_dany",Pars,Cal),
	!;!.

    predicates
        onControlRemoveCon : vpiDomains::controlHandler.
    clauses
        onControlRemoveCon(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_context),
	!;!.

    predicates
        onControlstore : vpiDomains::controlHandler.
    clauses
        onControlstore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_rule_type,Typ),
  	inexgui::wcrValidate(thisWin,Typ),
  	inexgui::wcrStore(thisWin,Typ,declChanged),
  	guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!;!.

    % This code is maintained by the VDE do not update it manually, 20:28:58-7.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,80,1005,638).
        menu : vpiDomains::menu = noMenu.
        title : string = "Switch-type Rule".

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_Edit,rct(9,81,200,105),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_prior),
            _ = vpi::winCreateControl(wc_Text,rct(9,63,200,79),"Prior probability",Win,[wsf_AlignCenter],idct_prior),
            _ = vpi::winCreateControl(wc_Text,rct(9,171,200,187),"Parameters",Win,[wsf_AlignCenter],idct_parameters),
            _ = vpi::winCreateControl(wc_LBox,rct(9,191,200,317),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_parameters),
            _ = vpi::winCreateControl(wc_PushButton,rct(174,479,428,514),"Enter/Change General Rule Definition",Win,[wsf_Group,wsf_TabStop],idc_general),
            _ = vpi::winCreateControl(wc_PushButton,rct(478,479,732,514),"(Re-)Store Rule",Win,[wsf_Group,wsf_TabStop],idc_store),
            _ = vpi::winCreateControl(wc_Edit,rct(8,4,428,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rn),
            _ = vpi::winCreateControl(wc_Edit,rct(433,4,676,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rk),
            _ = vpi::winCreateControl(wc_Edit,rct(680,4,898,28),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_realm),
            _ = vpi::winCreateControl(wc_Text,rct(219,94,400,114),"Default criterion-rule value:",Win,[wsf_AlignLeft],idct_def),
            _ = vpi::winCreateControl(wc_Edit,rct(408,92,650,116),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_def),
            _ = vpi::winCreateControl(wc_Edit,rct(9,350,200,374),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rdom),
            _ = vpi::winCreateControl(wc_LBox,rct(219,191,898,317),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_map),
            _ = vpi::winCreateControl(wc_Edit,rct(930,108,953,132),"critical",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_x),
            _ = vpi::winCreateControl(wc_LBox,rct(219,63,895,89),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_and),
            _ = vpi::winCreateControl(wc_PushButton,rct(455,37,636,61),"Add/Change Criterion Rule",Win,[wsf_Group,wsf_TabStop],idc_addcrit),
            _ = vpi::winCreateControl(wc_Text,rct(9,331,200,347),"Return domain",Win,[wsf_AlignCenter],idct_map_from),
            _ = vpi::winCreateControl(wc_Edit,rct(655,92,898,116),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_qdom),
            _ = vpi::winCreateControl(wc_Edit,rct(930,42,954,70),"q domain",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_qdomk),
            _ = vpi::winCreateControl(wc_Edit,rct(930,78,949,102),"Ret domain",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rdomk),
            _ = vpi::winCreateControl(wc_Edit,rct(925,12,961,36),"rule type",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule_type),
            _ = vpi::winCreateControl(wc_Text,rct(219,150,898,164),"Switch Calls",Win,[wsf_AlignCenter],idct_switch_calls),
            _ = vpi::winCreateControl(wc_PushButton,rct(220,166,342,190),"Add Switch",Win,[wsf_Group,wsf_TabStop],idc_add),
            _ = vpi::winCreateControl(wc_PushButton,rct(359,166,481,190),"Remove Switch",Win,[wsf_Group,wsf_TabStop],idc_rem),
            _ = vpi::winCreateControl(wc_PushButton,rct(637,166,759,190),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_move_up),
            _ = vpi::winCreateControl(wc_PushButton,rct(776,166,898,190),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_move_down),
            _ = vpi::winCreateControl(wc_Edit,rct(9,439,200,463),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_out),
            _ = vpi::winCreateControl(wc_Text,rct(9,420,200,436),"Return-value if out of context",Win,[wsf_AlignCenter],idct_out),
            _ = vpi::winCreateControl(wc_Text,rct(321,119,807,136),"The default criterion-rule value must be switch-able!",Win,[wsf_AlignCenter],idct_default),
            _ = vpi::winCreateControl(wc_Edit,rct(10,526,897,550),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_calld),
            _ = vpi::winCreateControl(wc_LBox,rct(220,371,899,463),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Sort],idc_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(365,345,506,369),"Remove Context Call",Win,[wsf_Group,wsf_TabStop],idc_remove_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(224,345,365,369),"Add Context Call",Win,[wsf_Group,wsf_TabStop],idc_add_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(776,345,898,369),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_downc),
            _ = vpi::winCreateControl(wc_PushButton,rct(653,345,775,369),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_upc),
            _ = vpi::winCreateControl(wc_Text,rct(219,329,898,343),"Context",Win,[wsf_AlignCenter],idct_context),
            _ = vpi::winCreateControl(wc_PushButton,rct(509,345,650,369),"Edit Context Call",Win,[wsf_Group,wsf_TabStop],idc_edit_con),
            _ = vpi::winCreateControl(wc_PushButton,rct(498,166,620,190),"Edit Switch",Win,[wsf_Group,wsf_TabStop],idc_switch_edit),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_general, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlgeneral(idc_general, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_parameters, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlparameters(idc_parameters, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_addcrit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladdcrit(idc_addcrit, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_map, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlmap(idc_map, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_switch_edit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlSwitchEdit(idc_switch_edit, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_rem, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrem(idc_rem, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveDown(idc_move_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_move_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveUp(idc_move_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_context, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcontext(idc_context, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_upc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupc(idc_upc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_downc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldownc(idc_downc, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAddCon(idc_add_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlEditCon(idc_edit_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove_con, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRemoveCon(idc_remove_con, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_store, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstore(idc_store, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement inexSwitchType
