/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement inexgui
open core,termDomain,resourceIdentifiers,globalDomains

constants
className = "com/rudstrand/TaskWindow/Inexactrules/inexgui".
classVersion = "1.0".

class predicates
wcrDisplayCall : (sterm,string) determ (i,o).
wcrDoms : (string_list) procedure (o).
wcrDomsNL : (string_list) procedure (o).
wcrGetParameters : (string,string,sterm) determ (i,i,o).
wcrDisplayAnd : (string,vpiDomains::windowHandle,integer,string,string,string) determ (i,i,i,i,i,i).
wcrDisplayBay : (vpiDomains::windowHandle,integer,string,string,string) determ (i,i,i,i,i).
wcrDisplayBayDetails : (vpiDomains::windowHandle,sterm,sterm) determ.
wcrDisplayFZ : (string,vpiDomains::windowHandle,integer,string,string,string) determ (i,i,i,i,i,i).
wcrDisplayMap : (vpiDomains::windowHandle,integer,string,string,string) determ.
wcrDisplaySwitch : (vpiDomains::windowHandle,string,integer,string,string,string) determ (i,i,i,i,i,i).
wcrDisplayPar : (vpiDomains::windowHandle,string,integer,string,string,string) determ (i,i,i,i,i,i).
wcrDisplayPrior : (vpiDomains::windowHandle,string,real).
wcrDisplayQ : (string,vpiDomains::windowHandle,integer,string,string,string) determ (i,i,i,i,i,i).
wcrGetPar : (string_list,sterml) determ (i,o).
nlValue : (sterm,string,string,string) procedure (i,i,i,o).
wcrReadBayCall : (string,sterm) determ (i,o).
wcrReadOwaCall : (string,sterm) determ (i,o).
wcrReadBayDetails : (vpiDomains::windowHandle,string) determ (i,o).
wcrReadWeightDetails : (vpiDomains::windowHandle,string) determ (i,o).
wcrReadCall : (string,sterm) determ (i,o).
wcrReadCallF : (string,sterm) determ (i,o).
wcrReadWeights : (vpiDomains::windowHandle,string) determ (i,o).
wcrReadPar : (vpiDomains::windowHandle,string,string) determ (i,i,o).
wcrDisplayBayCalls : (sterml,string_list) determ (i,o).
wcrDisplayOWA_Calls : (sterml,string_list) determ (i,o).
wcrDisplayCalls : (sterml,string_list) determ (i,o).
wcrDisplayPars : (sterml,string_list) determ (i,o).
wcrDisplayContext : (vpiDomains::windowHandle,sterm,sterm) determ (i,i,i).
wcrDispSwiText : (vpiDomains::windowHandle,string,sterm,sterm,sterm,sterm) determ (i,i,i,i,i,i).
wcrDeleteExisting : (string,string) procedure (i,o).
wcrGetCallDetails : (vpiDomains::windowHandle,string,string,string,string) determ (i,i,i,i,o).
wcrGetDefault : (vpiDomains::windowHandle,string,sterm) determ (i,i,o).
wcrGetMap : (vpiDomains::windowHandle,string,string,sterm) determ (i,i,i,o).
wcrGetSwiCon : (string_list,string,sterml) determ (i,i,o).
wcrGetSwiC : (string,string,sterm,sterm,sterm,sterm) determ (i,i,o,o,o,o).
wcrGetSwiD : (string,string,sterm,sterm) determ (i,i,o,o).	
wcrMap : (vpiDomains::windowHandle,string,string,sterm) determ (i,i,i,i).
wcrMapN : (string,string,string_list,sterml,sterml) determ (i,i,i,o,o).
wcrMapD : (string,string,string_list,sterml,sterml) determ (i,i,i,o,o).
wcrBayDet : (sterm,string) determ (i,o).
wcrSM : (string,string,sterml,sterml,string_list) determ (i,i,i,i,o).
wcrStoreContext : (vpiDomains::windowHandle,sterm,sterm) determ (i,o,o).
wcrReadBayCalls : (string_list,sterml) determ (i,o).
wcrReadBC : (string,sterm) determ (i,o).
wcrReadOwaCalls : (string_list,sterml) determ (i,o).
wcrReadCalls : (string_list,sterml) determ (i,o).
wcrStoreParams : (string_list,sterm) determ (i,o).
storeDeclaration : (integer,string,string,string_list) determ.
wcrDisplayParCalls : (string,sterml,string_list) determ (i,i,o).
wcrDisplayContextCalls : (sterml,string_list) determ (i,o).
wcrDisplaySwitchCalls : (string,sterml,string_list) determ (i,i,o).

clauses
classInfo(className, classVersion).
% ----------------------------------------------------------------------------------------------
% getAssociation/All
% ----------------------------------------------------------------------------------------------
class predicates
getAss : (lst).
clauses

getAssociation(Rule,AssPar,Ass) :-
    AssPar>0,
    dbBase::chainSentences("x",LT,_),
    LT=cmp(_,[cmp("p3_eIrAs",[atom(Rule),AssVal,atom(Dom),str(Format),int(AssPar)])]),
    nl::conValX_F(AssVal,Dom,Format,Ass),
    !.
getAssociation(_,_,"") :- 
    !.
    
getAssociationsAll(L) :-
    List=lst::new(1),
    getAss(List),
    L=List:get(),
    !.
    
getAss(L) :-
    dbBase::chainSentences("x",LT,_),
        LT=cmp(_,[cmp("p3_eIrAs",[_,_,_,_,int(AssPar)])]),
        S=toString(AssPar),
        L:add(S),
        fail
;
    !.
% ----------------------------------------------------------------------------------------------
% crrPopST
% ----------------------------------------------------------------------------------------------
crrPopST(Ctl) :-
	dbBase::chainSentences("r",LT),
	   LT=cmp("r",[cmp("u",[str(STk)|_])]),
	   dbBase::stNL(STk,NL),
	   L=vpi::lboxGetAll(Ctl),
	   not(set::member(NL,L)),
	   vpi::lboxAdd(Ctl,NL),
	   fail
;
	!.
% --------------------------------------------------------------------------------------------
% wcrCallable
% --------------------------------------------------------------------------------------------
class predicates
wcrCallableX : (string_list,string,string_list) determ (i,i,o).
clauses
wcrCallable(Rules,Domain,L) :-
	Domain="p3_dany",
	AllRules=pop::getCRsNL(),
	sx::sxlAddPrefix(Rules,"*",PRules),
	set::conc([Rules,PRules],Rs),	
	set::setRemSub(Rs,AllRules,L),
	!
;
	AllRules=pop::getCRsNL(),
	sx::sxlAddPrefix(Rules,"*",PRules),
	set::conc([Rules,PRules],Rs),	
	set::setRemSub(Rs,AllRules,Rules2),
	wcrCallableX(Rules2,Domain,L),
	!.
wcrCallableX([],_,[]) :-
	!.
wcrCallableX([R|Rs],Dom,L) :-
	Dom="p3_dnu",
	sx::sxStrip(R,Rx),
	dbBase::kbID(Rx,K,_,_),
	dbExtension::dbuCR_GetTD(K,_,D),
	dom::domNum(D),
	wcrCallableX(Rs,Dom,L2),
	L=[Rx|L2],
	!
;
	set::member(Dom,["p3_dpr","p3_dcf"]),
	sx::sxStrip(R,Rx),
	dbBase::kbID(Rx,K,_,_),
	dbExtension::dbuCR_GetTD(K,_,D),
	set::member(D,["p3_dpr","p3_dcf"]),
	wcrCallableX(Rs,Dom,L2),
	L=[Rx|L2],
	!
;
	sx::sxStrip(R,Rx),
	dbBase::kbID(Rx,K,_,_),
	dbExtension::dbuCR_GetTD(K,_,D),
	D=Dom,
	wcrCallableX(Rs,Dom,L2),
	L=[Rx|L2],
	!
;
	wcrCallableX(Rs,Dom,L),
	!.
% --------------------------------------------------------------------------------------------
% wcrCallInit
% --------------------------------------------------------------------------------------------
class predicates
wcrCallControls : (vpiDomains::windowHandle,string,string) determ (i,i,i).
wcrCallType : (string,string) determ (i,o).
wcrCallProperDisplay : (vpiDomains::windowHandle,string) determ (i,i).
wcrCall_BO : (integer,vpiDomains::windowHandle,sterm) determ (i,i,i).
clauses

wcrCallInit(W) :-
	guix::txtGet(W,idc_edit_call,C),
	sx::sxUnpackS(C," :: ",L),
	L=[Cp,_],
	wcrReadCallF(Cp,_),
	guix::txtGet(W,idc_calltype,S),
  	wcrCallType(S,Sn),
  	guix::txtSet(W,idc_ct,Sn),
	wcrCallControls(W,S,C),
	!
;
	guix::txtGet(W,idc_edit_call,C),
	sx::sxUnpackS(C," :: ",L),
	L=[_,Cp],
	wcrReadCallF(Cp,_),
	guix::txtGet(W,idc_calltype,S),
  	wcrCallType(S,Sn),
  	guix::txtSet(W,idc_ct,Sn),
	wcrCallControls(W,S,C),
	!
;
	guix::txtGet(W,idc_calltype,S),
  	wcrCallType(S,Sn),
  	guix::txtSet(W,idc_ct,Sn),
	guix::txtGet(W,idc_edit_call,C),
	wcrCallControls(W,S,C),
	!.
	
wcrCallControls(W,S,C) :-
	set::member(S,["p3_iComb","p3_iLand","p3_iLor","p3_iLnot","p3_iSwiCr","p3_iIncC","p3_iDecC","p3_iMapC","p3_WgtC","p3_iPCal","p3_iCoC","p3_iInC","p3_iUnC"]),
	guix::ctlInvisible(W,[idct_cond,idc_op1,idc_v1,idc_op2,idc_v2,
	                idct_increment,idc_value,idc_call,idc_inc,
	                idct_decrement,idc_value2,idc_call2,idc_dec]),
	C<>"",
	wcrCallProperDisplay(W,C),
	!
;
	S="p3_iSwi",
	guix::ctlInvisible(W,[idct_increment,idc_value,idc_call,idc_inc,
	                idct_decrement,idc_value2,idc_call2,idc_dec]),
	guix::txtSet(W,idct_cond,"Switch Condition"),
	guix::lbxPop(W,idc_op1,["=","<>","<","<=",">",">=","default"]),
	guix::lbxPop(W,idc_op2,["<","<=",">",">="]),
	C<>"",
	sx::searchstring(C," :: ",P),
	Pf=P-1,
	sx::frontstr(Pf,C,Cs,_),
	Pt=P+3,
	sx::frontstr(Pt,C,_,Cp),
	wcrCallProperDisplay(W,Cp),
	guix::txtGet(W,idc_rn,Rule),
	dbBase::kbID(Rule,Rk,_,_),
	dbExtension::dbuCR_SwitchValDom(Rk,Dom),
	wcrGetSwiC(Cs,Dom,Oa,Va,Ob,Vb),
	wcrDispSwiText(W,Dom,Oa,Va,Ob,Vb),
	!
;
	S="p3_iCon",
	guix::ctlInvisible(W,[idct_increment,idc_value,idc_call,idc_inc,
	                idct_decrement,idc_value2,idc_call2,idc_dec]),
	guix::txtSet(W,idct_cond,"Context Condition"),
	guix::lbxPop(W,idc_op1,["=","<>","<","<=",">",">="]),
	guix::lbxPop(W,idc_op2,["<","<=",">",">="]),
	C<>"",
	sx::searchstring(C," :: ",P),
	Pf=P-1,
	sx::frontstr(Pf,C,Cs,_),
	Pt=P+3,
	sx::frontstr(Pt,C,_,Cp),
	wcrCallProperDisplay(W,Cp),
	guix::txtGet(W,idc_cdomk,Dom),
	wcrGetSwiC(Cs,Dom,Oa,Va,Ob,Vb),
	wcrDispSwiText(W,Dom,Oa,Va,Ob,Vb),
	!
;
	S="p3_iPCal",
	guix::ctlInvisible(W,[idc_op1,idc_op2,idc_v2,
	                idct_increment,idc_value,idc_call,idc_inc,
	                idct_decrement,idc_value2,idc_call2,idc_dec]),
	guix::txtSet(W,idct_cond,"Variable to receive the returned value"),
	C<>"",
	sx::searchstring(C," :: ",P),
	Pf=P-1,
	sx::frontstr(Pf,C,Cv,_),
	Pt=P+3,
	sx::frontstr(Pt,C,_,Cp),
	wcrCallProperDisplay(W,Cp),
	guix::txtSet(W,idc_v1,Cv),
	!
;	
	S="p3_iBay",
	guix::ctlInvisible(W,[idct_cond,idc_op1,idc_v1,idc_op2,idc_v2]),
	guix::txtSet(W,idct_increment,"Increment:"),
	guix::txtSet(W,idct_decrement,"Decrement:"),
	C<>"",
	sx::searchstring(C," :: ",P),
	Pf=P-1,
	sx::frontstr(Pf,C,Cp,_),
	wcrCallProperDisplay(W,Cp),
	wcrReadBayCall(C,Bay),
	Bay=cmp(_,[Inc,Dec|_]),
	wcrCall_BO(1,W,Inc),
	wcrCall_BO(2,W,Dec),
	!
;	
	S="p3_iOwaC",
	guix::ctlInvisible(W,[idct_cond,idc_op1,idc_v1,idc_op2,idc_v2,idct_decrement,idc_value2,idc_call2,idc_dec]),
	guix::txtSet(W,idct_increment,"Weight:"),
	C<>"",
	sx::searchstring(C," :: ",P),
	Pf=P-1,
	sx::frontstr(Pf,C,Cp,_),
	wcrCallProperDisplay(W,Cp),
	wcrReadOwaCall(C,Owa),
	Owa=cmp(_,[V|_]),
	wcrCall_BO(1,W,V),
	!
;
	C="",
	!.
wcrCall_BO(1,W,V) :-
	realType(V,R),
	sx::fixFormatR(R,3,0,S),
	guix::txtSet(W,idc_inc,S),
	guix::guiRB_SetN(W,[idc_call,idc_value],[1,2],2),
	!
;
	wcrDisplayCall(V,S),
	guix::txtSet(W,idc_inc,S),
	guix::guiRB_SetN(W,[idc_call,idc_value],[1,2],1),
	!.
wcrCall_BO(2,W,V) :-
	realType(V,R),
	sx::fixFormatR(R,3,0,S),
	guix::txtSet(W,idc_dec,S),
	guix::guiRB_SetN(W,[idc_call2,idc_value2],[1,2],2),
	!
;
	wcrDisplayCall(V,S),
	guix::txtSet(W,idc_dec,S),
	guix::guiRB_SetN(W,[idc_call2,idc_value2],[1,2],1),
	!.
wcrCallProperDisplay(W,C) :-
	wcrReadCall(C,T),
	T=cmp(R,[cmp("p3_iAps",Pars)]),
	dbBase::nlSingF(R,Rn),
	wcrDisplayPars(Pars,ActPars),
	guix::lbtSel(W,idc_rules,Rn),
	guix::lbxPop(W,idc_actpars,ActPars),
	dbExtension::dbuCR_GetTD(R,_,D),
	guix::txtSet(W,idc_cdomk,D),
	dbBase::nlSing(D,Dn),
	guix::txtSet(W,idc_cdom,Dn),
	!.
% --------------------------------------------------------------------------------------------
% wcrCallType
% --------------------------------------------------------------------------------------------
wcrCallType("p3_iComb","Select a rule to be included in combination:") :- !.
wcrCallType("p3_iLand","Select a rule to be AND'ed:") :- !.
wcrCallType("p3_iLor","Select a rule to be OR'ed:") :- !.
wcrCallType("p3_iLnot","Select the rule to be negated:") :- !.
wcrCallType("p3_iSwi","Select a rule to be selected through switching:") :- !.
wcrCallType("p3_iSwiCr","Select the rule which will return a value used as the criterion for switching:") :- !.
wcrCallType("p3_iBay","Select a rule to be included in the bayesian combination:") :- !.
wcrCallType("p3_iIncC","Select the rule which will return the increment value:") :- !.
wcrCallType("p3_iDecC","Select the rule which will return the decrement value:") :- !.
wcrCallType("p3_iMapC","Select the rule to be mapped:") :- !.
wcrCallType("p3_iCon","Select a rule to be included in the context specification:") :- !.
wcrCallType("p3_iWgtC","Select the rule which will return the weighting value:") :- !.
wcrCallType("p3_iOwaC","Select the rule to be included In the ordered weighted averaging:") :- !.
wcrCallType("p3_iUnC","Select the rule to be included in the union:") :- !.
wcrCallType("p3_iInC","Select the rule to be included in the intersection:") :- !.
wcrCallType("p3_iCoC","Select the rule to be complemeted:") :- !.
wcrCallType("p3_iPCal","Select the parameterized rule which will return this rule's value:") :- !.
wcrCallType("p3_PCal","Select a rule which will return an actual parameter:") :- !.
wcrCallType(Typ,S) :-
	dbBase::nlSingF(Typ,S2),
	sx::concat(["Select for ",S2],S),
	!.
% --------------------------------------------------------------------------------------------
% wcrChain
% --------------------------------------------------------------------------------------------
wcrChain(W,Chain) :-
	guix::lbxGet(W,idc_rules,Rule2),
	Rule2<>"",
  	sx::sxBreak(Rule2," :: ",Rule3,_),
	wcrStrip(Rule3,Rule),
	dbBase::kbID(Rule,RuleK,_,_),
	dbExtension::dbuCR_Get(RuleK,Body,_,_),
	Body=cmp(Chain,_),
	!.
% --------------------------------------------------------------------------------------------
% wcrContext
% --------------------------------------------------------------------------------------------
wcrDisplayContext(W,nill,_) :-
	guix::txtSet(W,idc_out,""),
	guix::ctlInvisible(W,[idct_out,idc_out]),
	!.
wcrDisplayContext(W,Context,Out) :-
	Context=cmp(_,ConCalls),
	wcrDisplayContextCalls(ConCalls,Con),
	guix::lbxPop(W,idc_context,Con),
	guix::txtGet(W,idc_rdomk,Dom),
	nlValue(Out,Dom,"",S),
	guix::txtSet(W,idc_out,S),
	guix::ctlVisible(W,[idct_out,idc_out]),
	!.
% --------------------------------------------------------------------------------------------
% wcrDeleteExisting
% --------------------------------------------------------------------------------------------
wcrDeleteExisting(Rule,Mess) :-
    dbBase::getIrDefF(Rule,_,Loc),
    dbBase::recordDelete(Loc),
    Mess="Inexact rule updated!",
    !
;
	Mess="New inexact rule stored!",
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayAnd
% --------------------------------------------------------------------------------------------
class predicates
wcrDisplayAndType : (string,vpiDomains::windowHandle) determ (i,i).
clauses

wcrDisplayAnd(Typ,W,New,RuleN,RuleK,Realm) :-
	New=1,
	wcrDisplayAndType(Typ,W),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	New=0,
	wcrDisplayAndType(Typ,W),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	guix::lbxPop(W,idc_parameters,Pars),
	!
;
	New=-1,
  	set::member(Typ,["p3_iCand","p3_iCor","p3_iCcmb"]),
	wcrDisplayAndType(Typ,W),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(RuleK,Body,_,_),
	Body=cmp(_,[_,
	            cmp(_,Calls),
	            fix(Prior),
	            Out,
	            Context]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayCalls(Calls,Ands),
	guix::lbxPop(W,idc_and,Ands),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	sx::fixFormatR(Prior,2,0,SPrior),
	guix::txtSet(W,idc_prior,SPrior),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::ctlEnable(W,[idc_store]),
	!
;
	New=-1,
  	Typ="p3_iCnot",
	wcrDisplayAndType(Typ,W),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(RuleK,Body,_,_),
	Body=cmp(_,[_,
	            Cal,
	            fix(Prior),
	            Out,
	            Context]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayCalls([Cal],Ands),
	guix::lbxPop(W,idc_and,Ands),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	sx::fixFormatR(Prior,2,0,SPrior),
	guix::txtSet(W,idc_prior,SPrior),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::ctlEnable(W,[idc_store]),
	!.
	
wcrDisplayAndType(Typ,W) :-
	guix::txtSet(W,idc_rule_type,Typ),
	Typ="p3_iCand",
	!
;
	Typ="p3_iCor",
	guix::txtSet(W,idct_and_rules,"OR'ed rules"),
	!
;
	Typ="p3_iCcmb",
	guix::txtSet(W,idct_and_rules,"Combined rules"),
	!
;
	Typ="p3_iCnot",
	guix::txtSet(W,idct_and_rules,"Negated rule"),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayBay
% --------------------------------------------------------------------------------------------
wcrDisplayBay(W,New,RuleN,RuleK,Realm) :-
	New=1,
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
	guix::txtSet(W,idc_rule_type,"p3_iCbay"),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	New=0,
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rule_type,"p3_iCbay"),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	dbBase::nlSings(DEsK,Pars),
	guix::lbxPop(W,idc_parameters,Pars),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	!
;
	New=-1,
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(RuleK,Body,_,_),
	Body=cmp(_,[_,
	            cmp(_,Calls),
	            fix(Prior),
	            Out,
	            Context]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayBayCalls(Calls,Cs),
	guix::lbxPop(W,idc_and,Cs),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	sx::fixFormatR(Prior,2,0,SPrior),
	guix::txtSet(W,idc_prior,SPrior),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::txtSet(W,idc_rule_type,"p3_iCbay"),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayBayCalls
% --------------------------------------------------------------------------------------------
wcrDisplayBayCalls([],[]) :-
	!.
wcrDisplayBayCalls([Cal|Cs],[SW|SWs]) :-
	Cal=cmp(R,[Inc,Dec,P]),
	wcrDisplayCall(cmp(R,[P]),Sc),
	wcrBayDet(Inc,Si),
	wcrBayDet(Dec,Sd),
	sx::concat([Sc," :: INC: ",Si," DEC: ",Sd],SW),
	wcrDisplayBayCalls(Cs,SWs),
	!.
wcrBayDet(fix(F),S) :-
	sx::fixFormatR(F,2,0,S),
	!.
wcrBayDet(C,S) :-
	wcrDisplayCall(C,S),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayOWA_Calls
% --------------------------------------------------------------------------------------------
wcrDisplayOWA_Calls([],[]) :-
	!.
wcrDisplayOWA_Calls([C|Cs],[S|L]) :-
	C=cmp(R,[Wg,P]),
	wcrDisplayCall(cmp(R,[P]),Sc),
	wcrBayDet(Wg,Si),
	sx::concat([Sc," :: WEIGHT: ",Si],S),
	wcrDisplayOWA_Calls(Cs,L),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayCall/Calls
% --------------------------------------------------------------------------------------------
wcrDisplayCalls([],[]) :-
	!.
wcrDisplayCalls([C|Cs],[S|L]) :-
	wcrDisplayCall(C,S),
	wcrDisplayCalls(Cs,L),
	!.
wcrDisplayCall(C,S) :-
	C=cmp(R,[cmp("p3_iAps",Pars)]),
	dbBase::nlSingF(R,Rn),
	wcrDisplayPars(Pars,ParsL),
	dbBase::joinNL(ParsL,S2),
	sx::concat([Rn," [",S2,"]"],S),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayFZ
% --------------------------------------------------------------------------------------------
class predicates
wcrDisplayFZ_Type : (string,vpiDomains::windowHandle) determ (i,i).
clauses
wcrDisplayFZ(Typ,W,New,RuleN,RuleK,Realm) :-
	New=1,
	wcrDisplayFZ_Type(Typ,W),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	!
;
	New=0,
	wcrDisplayFZ_Type(Typ,W),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbBase::smClassDef(RuleK,"h",_,DEsK,_,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::lbxPop(W,idc_de1s,Pars),
	!
;
	New=-1,
	Typ="p3_iZowa",
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(RuleK,Body,_,_),
	Body=cmp(_,[_,
	            cmp(Subtyp,Calls)]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,_,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayFZ_Type(Subtyp,W),
	wcrDisplayOWA_Calls(Calls,Ands),
	guix::lbxPop(W,idc_and,Ands),
	guix::lbxPop(W,idc_de1s,Pars),
	guix::ctlEnable(W,[idc_store]),
	!
;
	New=-1,
	Typ<>"p3_iZowa",
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(RuleK,Body,_,_),
	Body=cmp(_,[_,
	            cmp(Subtyp,Calls)]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,_,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayFZ_Type(Subtyp,W),
	wcrDisplayCalls(Calls,Ands),
	guix::lbxPop(W,idc_and,Ands),
	guix::lbxPop(W,idc_de1s,Pars),
	guix::ctlEnable(W,[idc_store]),
	!.
	
wcrDisplayFZ_Type(Typ,W) :-
    guix::txtSet(W,idc_rule_type,Typ),
	Typ="p3_iZowa",
	!
;
	Typ="p3_iZand",
	wcrDisplayFZ_Type("p3_iZsand",W),
	!
;
	Typ="p3_iZor",
	wcrDisplayFZ_Type("p3_iZsor",W),
	!
;
	set::setGet(["p3_iZnot","p3_iZsand","p3_iZaand","p3_iZband","p3_iZdand","p3_iZsor","p3_iZaor","p3_iZbor","p3_iZdor"],N,Typ),
	guix::guiRB_SetN(W,[idc_complement,idc_sec,idc_asec,idc_bsec,idc_dsec,idc_un,idc_aun,idc_bun,idc_dun],[1,2,3,4,5,6,7,8,9],N),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayPars
% --------------------------------------------------------------------------------------------
wcrDisplayPars([],[]) :-
	!.
wcrDisplayPars([P|Ps],[S|L]) :-
	P=cmp(_,[atom(D),V]),
	dbBase::smClassDef(D,"a",_,_,Dom,Frm,_),
	dbBase::nlSingF(D,Dn),
	nlValue(V,Dom,Frm,Vs),
	sx::concat([Dn," = ",Vs],S),
	wcrDisplayPars(Ps,L),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayGeneral
% --------------------------------------------------------------------------------------------
class predicates
wcrDisplayGen : (vpiDomains::windowHandle,vpiDomains::windowHandle,string) determ (i,i,i).
wcrDisplayGenPrior : (vpiDomains::windowHandle,vpiDomains::windowHandle).
clauses
wcrDisplayGeneral(W,PW,Typ) :-
  	set::member(Typ,["p3_iZand","p3_iZor","p3_iZnot","p3_iZowa"]),
  	dbBase::nlSing("p3_dmg",Dom),
	guix::lbxPop(W,idc_dom,[Dom]),
	DEs=pop::getSM_NL("a",[]),
	guix::lbxPop(W,idc_de2s,DEs),
	wcrDisplayGen(W,PW,Typ),
	!
;
  	set::member(Typ,["p3_iCand","p3_iCor","p3_iCnot","p3_iCbay","p3_iCcmb"]),
  	dbBase::nlSings(["p3_dcf","p3_dpr"],L),
	guix::lbxPop(W,idc_dom,L),
	DEs=pop::getSM_NL("a",[]),
	guix::lbxPop(W,idc_de2s,DEs),
	guix::txtGet(PW,idc_out,Out),
	guix::txtSet(W,idc_out,Out),
	guix::txtGet(PW,idc_prior,Prior),
	guix::txtSet(W,idc_prior,Prior),
	wcrDisplayGen(W,PW,Typ),
	!
;
	wcrDomsNL(L),
	guix::lbxPop(W,idc_dom,L),
	DEs=pop::getSM_NL("a",[]),
	guix::lbxPop(W,idc_de2s,DEs),
	guix::txtGet(PW,idc_out,Out),
	guix::txtSet(W,idc_out,Out),
	guix::txtGet(PW,idc_prior,Prior),
	guix::txtSet(W,idc_prior,Prior),
	wcrDisplayGen(W,PW,Typ),
	!.
wcrDisplayGen(W,PW,Typ) :-
  	guix::txtGet(PW,idc_rdom,Dom),
  	guix::lbtSel(W,idc_dom,Dom),
  	guix::txtGet(PW,idc_rdomk,K),
  	guix::txtSet(W,idc_domk,K),
  	guix::lbxGetAll(PW,idc_parameters,Pars),
  	guix::lbxPop(W,idc_de1s,Pars),
	wcrDisplayGenPrior(W,PW),
	!
;
	dlgIF::feil("wcrDisplayGen",[Typ],[],nill),!,fail.
wcrDisplayGenPrior(W,PW) :-
	guix::txtGet(PW,idc_rdomk,D),
	D="p3_dmg",
	guix::ctlInvisible(W,[idct_prior,idc_prior,idct_out,idc_out]),
	guix::txtSet(W,idc_prior,"0.50"),
	!
;
	guix::txtGet(PW,idc_rdomk,D),
	set::member(D,["p3_dcf","p3_dpr"]),
	guix::txtGet(PW,idc_prior,S),
	guix::txtSet(W,idc_prior,S),
	!
;
	guix::ctlInvisible(W,[idct_prior,idc_prior]),
	guix::txtSet(W,idc_prior,"0.50"),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayMap
% --------------------------------------------------------------------------------------------
wcrDisplayMap(W,New,Rn,Rk,Realm) :-
	New=1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
	wcrMap(W,"","",nill),
	guix::ctlDisable(W,[idc_add,idc_store,idc_def,idc_map,idc_mapc]),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	New=0,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	wcrMap(W,"","",nill),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	guix::ctlDisable(W,[idc_add,idc_store,idc_def,idc_map,idc_mapc]),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	!
;
	New=-1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(Rk,Body,_,_),
	Body=cmp(_,[_,
	            Cal,
	            Map,
	            fix(Prior),
	            Out,
	            Def,
	            Context]),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayCalls([Cal],Ands),
	guix::lbxPop(W,idc_and,Ands),
	Cal=cmp(CRk,_),
	dbExtension::dbuCR_GetTD(CRk,_,MDom),
	guix::txtSet(W,idc_qdomk,MDom),
	dbBase::nlSing(MDom,MDomNL),
	guix::txtSet(W,idc_qdom,MDomNL),
	wcrMap(W,MDom,RDom,Map),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	wcrDisplayPrior(W,RDom,Prior),
	nlValue(Def,MDom,"",SDef),
	guix::txtSet(W,idc_def,SDef),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	wcrHidePrior(W,RDom),
	!
;
	dlgIF::feil("wcrDisplayMap",[Rn,Rk,Realm],[New],nill),!,fail.
% --------------------------------------------------------------------------------------------
% wcrDisplayPar
% --------------------------------------------------------------------------------------------
wcrDisplayPar(W,Typ,New,Rn,Rk,Realm) :-
	New=1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
	guix::txtSet(W,idc_rule_type,Typ),
	guix::ctlDisable(W,[idc_store]),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	New=0,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rule_type,Typ),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::ctlDisable(W,[idc_store]),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	!
;
	New=-1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(Rk,Body,_,_),
	Body=cmp(_,[_,
	            Cal,
	            cmp(_,Calls),
	            fix(Prior),
	            Out,
	            Context]),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayCalls([Cal],Ands),
	guix::lbxPop(W,idc_and,Ands),
	wcrDisplayParCalls(Rn,Calls,L),
  	guix::lbxPop(W,idc_map,L),
	guix::txtSet(W,idc_rdomk,RDom),
	guix::txtSet(W,idc_rule_type,Typ),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	wcrDisplayPrior(W,RDom,Prior),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	wcrHidePrior(W,RDom),
	!
;
	dlgIF::feil("wcrDisplayPar",[Rn,Rk,Realm],[New],nill),!,fail.
% --------------------------------------------------------------------------------------------
% wcrDisplayPrior
% --------------------------------------------------------------------------------------------
wcrDisplayPrior(W,RDom,Prior) :-
	set::member(RDom,["p3_dcf","p3_dpr"]),
	sx::fixFormatR(Prior,2,0,SPrior),
	guix::txtSet(W,idc_prior,SPrior),
	guix::ctlVisible(W,[idct_prior,idc_prior]),
	!
;
	guix::txtSet(W,idc_prior,"0.0"),
	guix::ctlInvisible(W,[idct_prior,idc_prior]),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayQ
% --------------------------------------------------------------------------------------------
class predicates
wcrDisplayQType : (string,vpiDomains::windowHandle,sterm,string) determ (i,i,i,i).
clauses

wcrDisplayQ(Typ,W,New,RuleN,RuleK,Realm) :-
	New=1, % new rule (no decl exists)
	wcrDisplayQType(Typ,W,nill,""),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	wcrMap(W,"","",nill),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	New=0, % new rule (decl exists)
	wcrDisplayQType(Typ,W,nill,""),
	guix::txtSet(W,idc_rule_type,Typ),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdomk,RDom),
	guix::txtSet(W,idc_rdom,RDomNL),
	guix::lbxPop(W,idc_parameters,Pars),
	wcrMap(W,"","",nill),
	!
;
	New=-1,
  	set::member(Typ,["p3_iCqry","p3_iCqst"]),
	wcrDomsNL(L),
	guix::lbxPop(W,idc_qdom,L),
	guix::txtSet(W,idc_rule_type,Typ),
	guix::txtSet(W,idc_rn,RuleN),
	guix::txtSet(W,idc_rk,RuleK),
	guix::txtSet(W,idc_realm,Realm),
	dbExtension::dbuCR_GetF(RuleK,Body,_,_),
	Body=cmp(_,[_,
	            cmp(_,[atom(QDom),Q]),
	            Map,
	            fix(Prior),
	            Out,
	            Def,
	            Context]),
	dbBase::smClassDef(RuleK,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayQType(Typ,W,Q,QDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdomk,RDom),
	guix::txtSet(W,idc_rdom,RDomNL),
	dbBase::nlSing(QDom,QDomNL),
	guix::txtSet(W,idc_qdomk,QDom),
	guix::lbtSel(W,idc_qdom,QDomNL),
	wcrMap(W,QDom,RDom,Map),
	wcrDisplayPrior(W,RDom,Prior),
	nlValue(Def,QDom,"",SDef),
	guix::txtSet(W,idc_def,SDef),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	!
;
	dlgIF::feil("wcrDisplayQ",[Typ,RuleN,RuleK,Realm],[New],nill),!,fail.
wcrDisplayQType(Typ,W,Q,QDom) :-
	Typ="p3_iCqry",
	Q=nill,
	guix::txtSet(W,idc_query,""),
	guix::ctlDisable(W,[idc_qdom]),
	guix::txtSet(W,idc_qdomk,""),
	!
;
	Typ="p3_iCqry",
	nl::conQuery(Q,NL2),
	sx::sxBlockNL(0,120,NL2,NL),
	guix::txtSet(W,idc_query,NL),
	guix::txtSet(W,idc_qdomk,QDom),
	wcrDomsNL(L),
	guix::lbxPop(W,idc_qdom,L),
	dbBase::nlSing(QDom,QDomNL),
	guix::lbtSel(W,idc_qdom,QDomNL),
	guix::ctlDisable(W,[idc_qdom]),
	!
;
	Typ="p3_iCqst",
	Q=nill,
	guix::txtSet(W,idct_query,"Question:"),
	guix::txtSet(W,idct_def,"Default question value:"),
	guix::txtSet(W,idc_query,""),
	wcrDomsNL(L),
	guix::lbxPop(W,idc_qdom,L),
	dbBase::nlSing("p3_dcf",Cf),
	guix::lbtSel(W,idc_qdom,Cf),
	guix::txtSet(W,idc_qdomk,"p3_dcf"),
	guix::ctlInvisible(W,[idc_run,idc_val]),
	!
;
	Typ="p3_iCqst",
	guix::txtSet(W,idct_query,"Question:"),
	wcrDomsNL(L),
	guix::lbxPop(W,idc_qdom,L),
	dbBase::nlSing(QDom,QDomNL),
	guix::txtSet(W,idc_qdomk,QDom),
	guix::lbtSel(W,idc_qdom,QDomNL),
	Q=str(Qs),
	irBase::wcrQuestionToNL(Qs,NL2),
	sx::sxBlockNL(0,120,NL2,NL),
	guix::txtSet(W,idc_query,NL),
	guix::ctlInvisible(W,[idc_run,idc_val]),
	!
;
	dlgIF::feil("wcrDisplayQType",[QDom],[],Q),!,fail.
% --------------------------------------------------------------------------------------------
% wcrDisplaySwitch
% --------------------------------------------------------------------------------------------
wcrDisplaySwitch(W,Typ,New,Rn,Rk,Realm) :-
	Typ="p3_iCswp",
	New=1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
	guix::txtSet(W,idc_def,""),
	guix::txtSet(W,idct_default,"Default parameter-value must be switch-able!"),
	guix::txtSet(W,idct_def,"Default parameter-value:"),
	guix::ctlDisable(W,[idc_store]),
	guix::ctlEnable(W,[idc_parameters]),
  	guix::ctlInvisible(W,[idct_out,idc_out,idc_and,idc_addcrit]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	Typ="p3_iCswc",
	New=1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_rdomk,"p3_dcf"),
	dbBase::nlSing("p3_dcf",Cf),
	guix::txtSet(W,idc_rdom,Cf),
	guix::txtSet(W,idc_rule_type,Typ),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	Typ="p3_iCswp",
	New=0,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	guix::txtSet(W,idc_def,""),
	guix::txtSet(W,idct_default,"Default parameter-value must be switch-able!"),
	guix::txtSet(W,idct_def,"Default parameter-value:"),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::txtSet(W,idc_rdomk,RDom),
	guix::txtSet(W,idc_rule_type,Typ),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	guix::ctlDisable(W,[idc_store]),
	guix::ctlEnable(W,[idc_parameters]),
  	guix::ctlInvisible(W,[idct_out,idc_out,idc_and,idc_addcrit]),
	C=vpi::winGetCtlHandle(W,idc_general),
	_=vpi::winSendEvent(W,vpiDomains::e_Control(idc_general,vpiDomains::wc_PushButton,C,vpiDomains::selchanged())),
	!
;
	Typ="p3_iCswc",
	New=0,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_prior,"0.50"),
	guix::txtSet(W,idc_out,""),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	guix::lbxPop(W,idc_parameters,Pars),
	guix::txtSet(W,idc_rule_type,Typ),
  	guix::ctlInvisible(W,[idct_out,idc_out]),
	!
;
	Typ="p3_iCswp",
	New=-1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_rule_type,Typ),
	dbExtension::dbuCR_GetF(Rk,Body,_,_),
	Body=cmp(_,[_,
	            atom(DE),
	            cmp(_,Calls),
	            fix(Prior),
	            Out,
	            Def,
	            Context]),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::smClassDef(DE,"a",_,_,MDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	guix::lbxPop(W,idc_parameters,Pars),
	dbBase::nlSing(DE,DEn),
	guix::txtSet(W,idc_qdomk,MDom),
	dbBase::nlSing(MDom,MDomNL),
	guix::txtSet(W,idc_qdom,MDomNL),
	wcrDisplaySwitchCalls(MDom,Calls,L),
  	guix::lbxPop(W,idc_map,L),
	guix::txtSet(W,idc_rdomk,RDom),
	guix::txtSet(W,idc_rule_type,Typ),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	wcrDisplayPrior(W,RDom,Prior),
	nlValue(Def,MDom,"",SDef),
	guix::txtSet(W,idc_def,SDef),
	wcrDisplayContext(W,Context,Out),
	guix::ctlEnable(W,[idc_parameters]),
	guix::lbxSel(W,idc_parameters,DEn),
	guix::ctlInvisible(W,[idc_and,idc_addcrit]),
	!
;
	Typ="p3_iCswc",
	New=-1,
	guix::txtSet(W,idc_rn,Rn),
	guix::txtSet(W,idc_rk,Rk),
	guix::txtSet(W,idc_realm,Realm),
	guix::txtSet(W,idc_rule_type,Typ),
	dbExtension::dbuCR_GetF(Rk,Body,_,_),
	Body=cmp(_,[_,
	            Cal,
	            cmp(_,Calls),
	            fix(Prior),
	            Out,
	            Def,
	            Context]),
	dbBase::smClassDef(Rk,"h",_,DEsK,RDom,_,_),
	dbBase::nlSings(DEsK,Pars),
	wcrDisplayCalls([Cal],Ands),
	guix::lbxPop(W,idc_and,Ands),
	Cal=cmp(CRk,_),
	dbExtension::dbuCR_GetTD(CRk,_,MDom),
	guix::txtSet(W,idc_qdomk,MDom),
	dbBase::nlSing(MDom,MDomNL),
	guix::txtSet(W,idc_qdom,MDomNL),
	wcrDisplaySwitchCalls(MDom,Calls,L),
  	guix::lbxPop(W,idc_map,L),
	guix::txtSet(W,idc_rdomk,RDom),
	dbBase::nlSing(RDom,RDomNL),
	guix::txtSet(W,idc_rdom,RDomNL),
	wcrDisplayPrior(W,RDom,Prior),
	nlValue(Def,MDom,"",SDef),
	guix::txtSet(W,idc_def,SDef),
	wcrDisplayContext(W,Context,Out),
	guix::lbxPop(W,idc_parameters,Pars),
	!
;
	dlgIF::feil("wcrDisplaySwitch",[Rn,Rk,Realm],[New],nill),!,fail.
% --------------------------------------------------------------------------------------------
% wcrDisplaySwitchCalls
% --------------------------------------------------------------------------------------------
class predicates	
wcrSwiConText : (string,sterm,sterm,sterm,sterm,string) determ (i,i,i,i,i,o).
clauses

wcrDisplaySwitchCalls(_,[],[]) :-
	!.
wcrDisplaySwitchCalls(QDom,[Cal|Cs],[SW|SWs]) :-
	Cal=cmp(R,[A,B,C,D,P]),
	wcrDisplayCall(cmp(R,[P]),Sc),
	wcrSwiConText(QDom,A,B,C,D,S2),
	sx::concat([S2," :: ",Sc],SW),
	wcrDisplaySwitchCalls(QDom,Cs,SWs),
	!.

wcrDisplayContextCalls([],[]) :-
	!.
wcrDisplayContextCalls([Cal|Cs],[SW|SWs]) :-
	Cal=cmp(R,[A,B,C,D,P]),
	wcrDisplayCall(cmp(R,[P]),Sc),
	dbExtension::dbuCR_GetTD(R,_,Dom),
	wcrSwiConText(Dom,A,B,C,D,S2),
	sx::concat([S2," :: ",Sc],SW),
	wcrDisplayContextCalls(Cs,SWs),
	!.

wcrSwiConText(_,nill,_,nill,_,"default") :-
	!.
wcrSwiConText(Dom,atom(Op),V,nill,_,S) :-
	nlValue(V,Dom,"",Vn),
	sx::concat([Op,Vn],S),
	!.
wcrSwiConText(Dom,atom(Op),V,atom(Op2),V2,S) :-
	nlValue(V,Dom,"",Vn),
	nlValue(V2,Dom,"",Vn2),
	sx::concat([Op,Vn," & ",Op2,Vn2],S),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayParCalls
% --------------------------------------------------------------------------------------------
wcrDisplayParCalls(_,[],[]) :-
	!.
wcrDisplayParCalls(CallingRule,[Cal|Cs],[SW|SWs]) :-
	Cal=cmp(R,[var(V),P]),
	wcrDisplayCall(cmp(R,[P]),Sc),
	sx::concat([V," :: ",Sc],SW),
	wcrDisplayParCalls(CallingRule,Cs,SWs),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplaySwiText
% --------------------------------------------------------------------------------------------
wcrDispSwiText(W,_,nill,_,nill,_) :-
	guix::lbtSel(W,idc_op1,"default"),
	guix::ctlInvisible(W,[idc_v1,idc_v2,idc_op2]),
	!.
wcrDispSwiText(W,Dom,atom(Op1),V1,nill,_) :-
	guix::lbtSel(W,idc_op1,Op1),
	nlValue(V1,Dom,"",Vn),
	guix::txtSet(W,idc_v1,Vn),
	guix::ctlInvisible(W,[idc_v2,idc_op2]),
	!.
wcrDispSwiText(W,Dom,atom(Op1),V1,atom(Op2),V2) :-
	guix::lbtSel(W,idc_op1,Op1),
	nlValue(V1,Dom,"",Vn),
	guix::lbtSel(W,idc_op2,Op2),
	nlValue(V2,Dom,"",Vn2),
	guix::txtSet(W,idc_v1,Vn),
	guix::txtSet(W,idc_v2,Vn2),
	!.
% --------------------------------------------------------------------------------------------
% wcrDoms/NL
% --------------------------------------------------------------------------------------------
wcrDoms(["p3_din","p3_dnu","p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg","p3_dli","p3_dts","p3_dif","p3_dxd","p3_dxt","p3_dxdt","p3_dxdr"]) :- !.
wcrDomsNL(L) :-
	wcrDoms(K),
	dbBase::nlSings(K,L),
	!.
% --------------------------------------------------------------------------------------------
% wcrGetDefault
% --------------------------------------------------------------------------------------------
wcrGetDefault(W,Dom,Def) :-
	guix::txtGet(W,idc_def,S),
	wcrCheckVal("DEFAULT VALUE",Dom,S,Def),
	!.
% --------------------------------------------------------------------------------------------
% wcrGetMap
% --------------------------------------------------------------------------------------------
wcrGetMap(W,RDom,QDom,Map) :-
  	guix::guiRB_Get(W,[idc_no_map,idc_nmap,idc_dmap],[1,2,3],RType),
  	RType=1,
  	Map=nill,
	!
;
  	guix::guiRB_Get(W,[idc_no_map,idc_nmap,idc_dmap],[1,2,3],RType),
  	RType=2,
  	guix::lbxGetAll(W,idc_map,Cs),
	wcrMapN(RDom,QDom,Cs,Vals,Maps),
	Map=cmp("p3_iNmap",[cmp("p3_iVls",Vals),cmp("p3_iCfs",Maps)]),
	!
;		
  	guix::guiRB_Get(W,[idc_no_map,idc_nmap,idc_dmap],[1,2,3],RType),
  	RType=3,
  	guix::lbxGetAll(W,idc_map,Cs),
	wcrMapD(RDom,QDom,Cs,Vals,Maps),
	Map=cmp("p3_iDmap",[cmp("p3_iVls",Vals),cmp("p3_iCfs",Maps)]),
	!.
% --------------------------------------------------------------------------------------------
% wcrGetParameters
% --------------------------------------------------------------------------------------------
class predicates
wcrAdjustCallPars : (sterml,sterml) determ (i,o).
wcrAdjustVal : (sterm,sterm) determ (i,o).
clauses

wcrGetParameters(Rule,S,Pars) :-
	dbBase::smClassDef(Rule,"h",_,DEs,_,_,_),
	DEs=[],
	S="",
	Pars=cmp("p3_iAps",[]),
	!
;
	dbBase::smClassDefTree(Rule,"h",DefR),
	DefR=cmp("REL_TYPE",[_,_,cmp("FPAR",DE_Defs)]),
	transnl::parParameters(S,DE_Defs,ParList2),
	wcrAdjustCallPars(ParList2,ParList),
	Pars=cmp("p3_iAps",ParList),
	!.
	
wcrAdjustCallPars([],[]) :-
	!.
wcrAdjustCallPars([H|T],[Hm|Tm]) :-
	H=cmp(A,[fvar(D,_),R]),
	wcrAdjustVal(R,Rm),
	Hm=cmp(A,[atom(D),Rm]),
	wcrAdjustCallPars(T,Tm),
	!
;
	dlgIF::feil("wcrAdjustCallPars",[],[],H),!,fail.
wcrAdjustVal(R,Rm) :-
	R=fstr(V,Dom,_,_),
	dom::domAtom(Dom),
	Rm=atom(V),
	!
;	
	R=fstr(V,Dom,_,_),
	dom::domStr(Dom),
	Rm=str(V),
	!
;	
	R=fstr(V,Dom,_,_),
	dom::domInt(Dom),
	Vi=sx::toInt(V),
	Rm=int(Vi),
	!
;	
	R=fstr(V,Dom,_,_),
	dom::domFix(Dom),
	Vf=sx::toReal(V),
	Rm=fix(Vf),
	!
;	
	R=fvar(V,_),
	Rm=var(V),
	!
;	
	R=fint(V,_),
	Rm=int(V),
	!
;	
	R=ffix(V,_),
	Rm=fix(V),
	!
;	
	R=str(_),
	Rm=R,
	!
;	
	R=atom(_),
	Rm=R,
	!
;	
	R=int(_),
	Rm=R,
	!
;	
	R=fix(_),
	Rm=R,
	!
;	
	R=var(_),
	Rm=R,
	!
;	
	dlgIF::feil("wcrAdjustVal",[],[],R),!,fail.
% --------------------------------------------------------------------------------------------
% wcrGetPar
% --------------------------------------------------------------------------------------------
wcrGetPar([],[]) :-
	!.
wcrGetPar([C|Calls],[H|T]) :-
	sx::searchstring(C," :: ",P),
	Q=P+3,
	sx::frontstr(Q,C,S2,S3),
	sx::sxTail(4,S2,V,_),
	sx::frontstr(1,V,F,R),
	Fu=string::toUppercase(F),
	W=string::concat(Fu,R),
	wcrReadCall(S3,Tc),
	Tc=cmp(Rk,[Pars]),
	H=cmp(Rk,[var(W),Pars]),
	wcrGetPar(Calls,T),
	!.
% --------------------------------------------------------------------------------------------
% wcrGetRulePars
% --------------------------------------------------------------------------------------------
wcrGetRulePars([],[]) :-
	!.
wcrGetRulePars([H|T],[Par|Ps]) :-
	sx::searchstring(H," :: ",P),
	Q=P-1,
	sx::frontstr(Q,H,Par,_),
	wcrGetRulePars(T,Ps),
	!.
% --------------------------------------------------------------------------------------------
% wcrGetSwi
% --------------------------------------------------------------------------------------------
% parameters:
% 1	in	list of switch or context calls (text format)
% 2	in	switch: domain of condition values
% 		context: n/a
% 3	out	list PR-format calls
%
wcrGetSwiCon([],_,[]) :-
	!.
wcrGetSwiCon([C|Calls],QDom,[H|T]) :-
	QDom="",
	sx::searchstring(C," :: ",P),
	Q=P+3,
	sx::frontstr(Q,C,S2,S3),
	wcrReadCall(S3,Tc),
	Tc=cmp(Rk,[Pars]),
	dbExtension::dbuCR_GetTD(Rk,_,Dom),
	sx::sxTail(4,S2,S4,_),
	wcrGetSwiC(S4,Dom,Oa,Va,Ob,Vb),
	H=cmp(Rk,[Oa,Va,Ob,Vb,Pars]),
	wcrGetSwiCon(Calls,QDom,T),
	!
;
	sx::searchstring(C," :: ",P),
	Q=P+3,
	sx::frontstr(Q,C,S2,S3),
	sx::sxTail(4,S2,S4,_),
	wcrGetSwiC(S4,QDom,Oa,Va,Ob,Vb),
	wcrReadCall(S3,Tc),
	Tc=cmp(Rk,[Pars]),
	H=cmp(Rk,[Oa,Va,Ob,Vb,Pars]),
	wcrGetSwiCon(Calls,QDom,T),
	!.
wcrGetSwiC(S,Dom,Oa,Va,Ob,Vb) :-
	S="default",
	Oa=nill,
	Va=nill,
	Ob=nill,
	Vb=nill,
	!
;
	sx::searchstring(S," & ",P),
	R=P-1,
	sx::frontstr(R,S,A,_),
	Q=P+2,
	sx::frontstr(Q,S,_,B),
	wcrGetSwiD(Dom,A,Oa,Va),
	wcrGetSwiD(Dom,B,Ob,Vb),
	!	
;
	wcrGetSwiD(Dom,S,Oa,Va),
	Ob=nill,
	Vb=nill,
	!.
	
wcrGetSwiD(Dom,S,Op,V) :-
	sx::frontstr(2,S,F,T),
	set::member(F,["<=",">=","<>"]),
	wcrCheckVal("CONDITION",Dom,T,V),
	Op=atom(F),
	!
;
	sx::frontstr(1,S,F,T),
	wcrCheckVal("CONDITION",Dom,T,V),
	Op=atom(F),
	!.
% --------------------------------------------------------------------------------------------
% wcrMap/N/D
% --------------------------------------------------------------------------------------------
wcrHidePrior(W,Dom) :-
	set::member(Dom,["p3_dcf","p3_dpr"]),
	guix::ctlVisible(W,[idct_prior,idc_prior]),
	!
;
	guix::ctlInvisible(W,[idct_prior,idc_prior]),
	!.
% --------------------------------------------------------------------------------------------
% wcrMap/N/D
% --------------------------------------------------------------------------------------------
wcrMap(W,FDom,TDom,Map) :-
	Map=cmp("p3_iNmap",[cmp(_,Vals),cmp(_,Maps)]),
	wcrSM(FDom,TDom,Vals,Maps,L),
  	guix::guiRB_SetN(W,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],3),	
  	guix::lbxPop(W,idc_map,L),
  	guix::ctlEnable(W,[idc_mapc]),
	!
;	
	Map=cmp("p3_iDmap",[cmp(_,Vals),cmp(_,Maps)]),
	wcrSM(FDom,TDom,Vals,Maps,L),
  	guix::guiRB_SetN(W,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],2),	
  	guix::lbxPop(W,idc_map,L),
  	guix::ctlEnable(W,[idc_mapc]),
	!
;
	Map=nill,
  	guix::guiRB_SetN(W,[idc_no_map,idc_dmap,idc_nmap],[1,2,3],1),	
  	guix::lbxPop(W,idc_map,[]),
  	guix::ctlDisable(W,[idc_mapc]),
	!.
wcrMapN(_,_,[],[],[]) :-
	!.
wcrMapN(RDom,QDom,[C|Cs],[Val|Vals],[Map|Maps]) :-
	sx::sxUnpackS(C," ---> ",L),
	L=[From,To],
	wcrCheckVal("MAP",QDom,From,Val),
	wcrCheckVal("MAP",RDom,To,Map),
	!,wcrMapN(RDom,QDom,Cs,Vals,Maps),
	!.
wcrMapD(_,_,[],[],[]) :-
	!.
wcrMapD(RDom,QDom,[C|Cs],[Val|Vals],[Map|Maps]) :-
	sx::sxUnpackS(C," ---> ",L),
	L=[From,To],
	wcrCheckVal("MAP",QDom,From,Val),
	wcrCheckVal("MAP",RDom,To,Map),
	!,wcrMapD(RDom,QDom,Cs,Vals,Maps),
	!.
% --------------------------------------------------------------------------------------------
% wcrNew
% --------------------------------------------------------------------------------------------
class predicates
wcrNewX : (vpiDomains::windowHandle,string,string,integer) determ.
clauses

wcrNew(W,PW,New) :- 
	guix::txtGet(W,idc_rule,R),
	guix::txtGet(W,idc_kb,K),
	dbBase::kbID_F(R,Id,Clas,_),
	K=Id,
	Clas="p3_iIR",
    not(dbBase::getIrDefF(K,_,_)),
    % declaration exists already
    wcrNewX(W,R,K,0),   
    !
;
	guix::txtGet(W,idc_rule,R),
	dbBase::kbID_F(R,_,Clas,_),
	dbBase::nlSingF(Clas,NL),
	sx::concat(["The NL-name is already in use for '",NL,"' node!"],Mess),
	dlgIF::dlgNote(0,Mess),!,fail
; 
	guix::txtGet(W,idc_kb,K),
	dbBase::nlSingF(K,NL),
	sx::concat(["The KB-name is already in use for node '",NL,"'!"],Mess),
	dlgIF::dlgNote(0,Mess),!,fail
;
	New=-1, % copy rule
	guix::txtGet(W,idc_rule,R),
	guix::txtGet(W,idc_kb,K),
	guix::txtGet(W,idc_realm,Realm),
	guix::txtSet(PW,idc_rule,R),
	guix::txtSet(PW,idc_kb,K),
	guix::txtSet(PW,idc_realm,Realm),
	!
;	
	guix::txtGet(W,idc_rule,R),
	guix::txtGet(W,idc_kb,K),
    wcrNewX(W,R,K,1),
    !.
    
wcrNewX(W,R,K,NewDec) :-
	guix::txtGet(W,idc_typek,Typ),
	Typ="p3_iCbay",
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexBayType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (certainty rule)"),
    vpi::winSetText(IW,Title),
	wcrDisplayBay(IW,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	set::member(Typ,["p3_iCand","p3_iCor","p3_iCnot","p3_iCcmb"]),
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexAndType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (certainty rule)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
	wcrDisplayAnd(Typ,IW,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	set::member(Typ,["p3_iZand","p3_iZor","p3_iZnot"]),
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexFuzzyType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (fuzzy set)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
	wcrDisplayFZ(Typ,IW,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	Typ="p3_iZowa",
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexOWA_type::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (fuzzy set)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
	wcrDisplayFZ(Typ,IW,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	Typ="p3_iCpar",
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexParType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (support rule)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
	wcrDisplayPar(IW,Typ,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	set::member(Typ,["p3_iCswc","p3_iCswp"]),
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexSwitchType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (support rule)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
	wcrDisplaySwitch(IW,Typ,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	Typ="p3_iCmap",
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexMapType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (support rule)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
    wcrDisplayMap(IW,NewDec,R,K,Realm),
	!
;
	guix::txtGet(W,idc_typek,Typ),
	set::member(Typ,["p3_iCqry","p3_iCqst"]),
	guix::txtGet(W,idc_realm,Realm),
	TW=guix::getWinOfClas(1),
    IR=inexQueryType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (data rule)"),
    vpi::winSetText(IW,Title),
    guix::txtSet(IW,idc_rule_type,Typ),
	wcrDisplayQ(Typ,IW,NewDec,R,K,Realm),
	!.
% --------------------------------------------------------------------------------------------
% wcrParAss
% --------------------------------------------------------------------------------------------
wcrParAss([],_,[]) :-
	!.
wcrParAss([DE|DEs],Ds,[H|L]) :-
	set::member(DE,Ds),
	dbBase::nlSing("p3_iThis",Ths),
  	sx::concat([DE," = ",Ths," ",DE],H),
  	wcrParAss(DEs,Ds,L),
  	!
;
  	sx::concat([DE," ="],H),
  	wcrParAss(DEs,Ds,L),
  	!.
% --------------------------------------------------------------------------------------------
% wcrParSel
% --------------------------------------------------------------------------------------------
wcrParSel(_,[]) :-
	!.
wcrParSel(W,[H|_]) :-
	guix::lbxSel(W,idc_actpars,H),
  	guix::ctlEnable(W,[idc_set_val,idc_val]),
  	!.
% --------------------------------------------------------------------------------------------
% wcrReadBayCall/Calls
% --------------------------------------------------------------------------------------------
wcrReadBayCalls([],[]) :-
	!.
wcrReadBayCalls([C|Cs],[H|T]) :-
	wcrReadBayCall(C,H),
	wcrReadBayCalls(Cs,T),
	!.
wcrReadBayCall(C,H) :-
	sx::searchstring(C," :: ",P),
	P3=P-1,
	sx::frontstr(P3,C,Scal,_),
	wcrReadCall(Scal,BCall),
	BCall=cmp(R,[Pars]),
	P2=P+3,
	sx::frontstr(P2,C,_,Sdet),
	sx::searchstring(Sdet," DEC: ",P4),
	P5=P4-1,
	sx::frontstr(P5,Sdet,S2,_),
	sx::frontstr(5,S2,_,Sinc),
	P6=P4+5,
	sx::frontstr(P6,Sdet,_,Sdec),
	wcrReadBC(SInc,Inc),
	wcrReadBC(Sdec,Dec),
	H=cmp(R,[Inc,Dec,Pars]),
	!.
wcrReadBC(S,T) :-
	sx::sxUnsignedFix(S,R),
	T=fix(R),
	!
;
	wcrReadCall(S,T),
	!.
% --------------------------------------------------------------------------------------------
% readCalledRulesNL
% --------------------------------------------------------------------------------------------
readCalledRulesNL([],[]) :-
    !.
readCalledRulesNL([C|Cs],[R|Rs]) :-
	%sx::searchstring(C," :: ",P),
	%P3=P-1,
	%sx::frontstr(P3,C,Scal,_),
	sx::sxUnpackS(C," :: ",L),
	L=[Scal|_],
	wcrReadCall(Scal,BCall),
	BCall=cmp(Rk,_),
	dbBase::nlSing(Rk,R),
    readCalledRulesNL(Cs,Rs),
    !.
% --------------------------------------------------------------------------------------------
% wcrReadOwaCall/Calls
% --------------------------------------------------------------------------------------------
wcrReadOwaCalls([],[]) :-
	!.
wcrReadOwaCalls([C|Cs],[H|T]) :-
	wcrReadOwaCall(C,H),
	wcrReadOwaCalls(Cs,T),
	!.
wcrReadOwaCall(C,H) :-
	sx::searchstring(C," :: ",P),
	P3=P-1,
	sx::frontstr(P3,C,Scal,_),
	wcrReadCall(Scal,BCall),
	BCall=cmp(R,[Pars]),
	P2=P+11,
	sx::frontstr(P2,C,_,Sw),
	wcrReadBC(Sw,Ti),
	H=cmp(R,[Ti,Pars]),
	!.
% --------------------------------------------------------------------------------------------
% wcrDisplayBayDetails
% --------------------------------------------------------------------------------------------
class predicates
wcrDB_I : (vpiDomains::windowHandle,sterm) determ.
wcrDB_D : (vpiDomains::windowHandle,sterm) determ.
clauses
	
wcrDisplayBayDetails(W,Inc,Dec) :-
	wcrDB_I(W,Inc),
	wcrDB_D(W,Dec),
	!.

wcrDB_I(W,V) :-
	V=fix(F),
	sx::fixFormatR(F,2,0,S),
	guix::txtSet(W,idc_inc,S),
  	guix::guiRB_SetN(W,[idc_call,idc_value],[1,2],2),
  	guix::ctlEnable(W,[idc_inc]),
  	!
;
	wcrDisplayCall(V,S),
	guix::txtSet(W,idc_inc,S),
  	guix::guiRB_SetN(W,[idc_call,idc_value],[1,2],1),
	guix::ctlDisable(W,[idc_inc]),
	!.		

wcrDB_D(W,V) :-
	V=fix(F),
	sx::fixFormatR(F,2,0,S),
	guix::txtSet(W,idc_dec,S),
  	guix::guiRB_SetN(W,[idc_call2,idc_value2],[1,2],2),
  	guix::ctlEnable(W,[idc_dec]),
  	!
;
	wcrDisplayCall(V,S),
	guix::txtSet(W,idc_dec,S),
  	guix::guiRB_SetN(W,[idc_call2,idc_value2],[1,2],1),
	guix::ctlDisable(W,[idc_dec]),
	!.		
% --------------------------------------------------------------------------------------------
% wcrReadBayDetails
% --------------------------------------------------------------------------------------------
class predicates
wcrReadInc : (integer,string) determ (i,i).
wcrReadDec : (integer,string) determ (i,i).
clauses
wcrReadBayDetails(W,S) :-
	guix::guiRB_Get(W,[idc_call,idc_value],[1,2],N),
	guix::guiRB_Get(W,[idc_call2,idc_value2],[1,2],N2),
	guix::txtGet(W,idc_inc,Si),
	guix::txtGet(W,idc_dec,Sd),
	wcrReadInc(N,Si),
	wcrReadDec(N2,Sd),
	sx::concat(["INC: ",Si," DEC: ",Sd],S),
	!.
	
wcrReadInc(N,S) :-
	N=1,
	!
;
	N=2,
	wcrCheckVal("INCREMENT","p3_dinc",S,_),
	!.
wcrReadDec(N,S) :-
	N=1,
	!
;
	N=2,
	wcrCheckVal("DECREMENT","p3_ddec",S,_),
	!.
% --------------------------------------------------------------------------------------------
% wcrReadWeightDetails
% --------------------------------------------------------------------------------------------
wcrReadWeightDetails(W,S) :-
	guix::guiRB_Get(W,[idc_call,idc_value],[1,2],N),
	N=1,
	guix::txtGet(W,idc_inc,Si),
	sx::concat(["WEIGHT: ",Si],S),
	!
;
	guix::guiRB_Get(W,[idc_call,idc_value],[1,2],N),
	N=2,
	guix::txtGet(W,idc_inc,Si),
	wcrCheckVal("WEIGHT","p3_dnu",Si,_),
	sx::concat(["WEIGHT: ",Si],S),
	!.
% --------------------------------------------------------------------------------------------
% wcrReadCall/s
% --------------------------------------------------------------------------------------------
wcrReadCalls([],[]) :-
	!.
wcrReadCalls([C|Cs],[H|T]) :-
	wcrReadCall(C,H),
	wcrReadCalls(Cs,T),
	!.
	
wcrReadCall(C,Cal) :-
	wcrReadCallF(C,Cal),
	!
;
    Mess=string::concat("Invalid rule-call format (missing or bad parameters): ",C),
	dlgIF::dlgNote(0,Mess),
	!,fail.
wcrReadCallF(C,cmp(RuleK,[Pars])) :-
	sx::sxUnpackS(C,"[",L2),
	L2=[S2,S3],
	sx::sxStrip(S2,Rule),
	dbBase::kbID_F(Rule,RuleK,_,_),
	sx::searchchar(S3,']',P),
	N=P-1,
	sx::frontstr(N,S3,Spars,_),
	wcrGetParameters(RuleK,Spars,Pars),
	!.
% --------------------------------------------------------------------------------------------
% wcrReadWeights
% --------------------------------------------------------------------------------------------
class predicates
wcrReadW : (integer,string) determ (i,i).
clauses
wcrReadWeights(W,S) :-
	guix::guiRB_Get(W,[idc_call,idc_value],[1,2],N),
	guix::txtGet(W,idc_inc,Sw),
	wcrReadW(N,Sw),
	sx::concat(["WEIGHT: ",Sw],S),
	!.
	
wcrReadW(N,S) :-
	N=1,
	!
;
	N=2,
	wcrCheckVal("WEIGHT","p3_dnu",S,_),
	!.
% --------------------------------------------------------------------------------------------
% wcrReadPar
% --------------------------------------------------------------------------------------------
wcrReadPar(W,Cal,S) :-
	guix::txtGet(W,idc_v1,V),
	V="",
	dlgIF::dlgNote(0,"Enter a variable name for the return value of this call!"),
	!,fail
;
	guix::txtGet(W,idc_v1,V),
	sx::frontstr(1,V,F,Vt),
	Fu=string::toUppercase(F),
	sx::concat([Fu,Vt," :: ",Cal],S),
	!.
% --------------------------------------------------------------------------------------------
% wcrGetCallDetails
% --------------------------------------------------------------------------------------------
class predicates
wcrReadSwitchCon : (vpiDomains::windowHandle,string,string,string,string) determ (i,i,i,i,o).	
wcrSw : (vpiDomains::windowHandle,string,string,string) determ (i,i,i,o).
wcrCon : (vpiDomains::windowHandle,string,string,string) determ (i,i,i,o).
clauses

wcrGetCallDetails(W,CallType,Cal,Dom,S) :-
	set::member(CallType,["p3_iSwi","p3_iCon"]),
	!,wcrReadSwitchCon(W,Dom,CallType,Cal,S),
	!
;
	CallType="p3_iBay",
	guix::txtGet(W,idc_inc,S),
	S="",
	!,dlgIF::dlgNote(0,"Enter an increment value!"),!,fail
;	
	CallType="p3_iBay",
	!,wcrReadBayDetails(W,Sd),
	sx::concat([Cal," :: ",Sd],S),
	!
;	
	CallType="p3_iPCal",
	!,guix::txtGet(W,idc_v1,Sp),
	vars::varSimple(Sp),
	sx::concat([Sp," :: ",Cal],S),
	!
;
	CallType="p3_iOwaC",
	!,wcrReadWeightDetails(W,Sw),
	sx::concat([Cal," :: ",Sw],S),
	!
;
	S=Cal,
	!.
wcrReadSwitchCon(W,Dom,CallType,Cal,S) :-
	not(guix::lbtGet(W,idc_op1,_)),
	dlgIF::dlgNote(0,"You select condition operator(s) and value(s)!"),
	!,fail
;
	CallType="p3_iSwi",
	wcrSw(W,Dom,Cal,S),
	!
;
	CallType="p3_iCon",
	wcrCon(W,Dom,Cal,S),
	!.
	
wcrSw(W,Dom,Cal,S) :-
	guix::lbtGet(W,idc_op1,Op1),
	Op1="default",
	S=string::concat("default :: ",Cal),
	!
;
	guix::lbtGet(W,idc_op2,Op2),
	sx::sxStrip(Op2,Op2s),
	Op2s="",
	guix::lbtGet(W,idc_op1,Op1),
	guix::txtGet(W,idc_v1,V1),
	wcrCheckVal("SWITCH CONDITION",Dom,V1,T1),
	nlValue(T1,Dom,"",S2),
	sx::concat([Op1,S2," :: ",Cal],S),
	!
;
	guix::lbtGet(W,idc_op1,Op1),
	guix::txtGet(W,idc_v1,V1),
	guix::lbtGet(W,idc_op2,Op2),
	guix::txtGet(W,idc_v2,V2),
	wcrCheckVal("SWITCH CONDITION",Dom,V1,T1),
	nlValue(T1,Dom,"",S2),
	wcrCheckVal("SWITCH CONDITION",Dom,V2,T2),
	nlValue(T2,Dom,"",S3),
	sx::concat([Op1,S2," & ",Op2,S3," :: ",Cal],S),
	!.
	
wcrCon(W,Dom,Cal,S) :-
	guix::lbtGet(W,idc_op2,Op2),
	sx::sxStrip(Op2,Op2s),
	Op2s="",
	guix::lbtGet(W,idc_op1,Op1),
	guix::txtGet(W,idc_v1,V1),
	wcrCheckVal("CONTEXT REQUIREMENT",Dom,V1,T1),
	nlValue(T1,Dom,"",S2),
	sx::concat([Op1,S2," :: ",Cal],S),
	!
;
	guix::lbtGet(W,idc_op1,Op1),
	guix::txtGet(W,idc_v1,V1),
	guix::lbtGet(W,idc_op2,Op2),
	guix::txtGet(W,idc_v2,V2),
	wcrCheckVal("CONTEXT REQUIREMENT",Dom,V1,T1),
	nlValue(T1,Dom,"",S2),
	wcrCheckVal("CONTEXT REQUIREMENT",Dom,V2,T2),
	nlValue(T2,Dom,"",S3),
	sx::concat([Op1,S2," & ",Op2,S3," :: ",Cal],S),
	!.
% --------------------------------------------------------------------------------------------
% wcrRetCall
% --------------------------------------------------------------------------------------------
class predicates
wcrRetCallTyp : (vpiDomains::windowHandle,string,string) determ.
wcrRetCallPars : (string_list,integer) determ (i,o).
clauses
% returns the call information selected in the call-dialog to the parent window
%
wcrRetCall(W,Parent) :-
  	guix::txtGet(W,idc_calltype,CallType),
  	CallType="p3_iSwi", % call switch
  	!,
  	guix::txtGet(Parent,idc_qdomk,Dom),
	guix::lbtGet(W,idc_rules,R),
	guix::lbxGetAll(W,idc_actpars,Pars),
	wcrRetCallPars(Pars,Errs),
	Errs=0,
	dbBase::joinNL(Pars,ParsN),
	sx::concat([R," [",ParsN,"]"],Cal),
	wcrGetCallDetails(W,CallType,Cal,Dom,S),
  	wcrRetCallTyp(Parent,CallType,S),
  	!
;  
  	guix::txtGet(W,idc_calltype,CallType),
	guix::lbtGet(W,idc_rules,R),
	guix::lbxGetAll(W,idc_actpars,Pars),
	wcrRetCallPars(Pars,Errs),
	Errs=0,
	dbBase::joinNL(Pars,ParsN),
	sx::concat([R," [",ParsN,"]"],Cal),
	guix::txtGet(W,idc_cdomk,Dom),
	wcrGetCallDetails(W,CallType,Cal,Dom,S),
  	wcrRetCallTyp(Parent,CallType,S),
  	!.

wcrRetCallTyp(PW,CallType,Cal) :-
	set::member(CallType,["p3_iIncC","p3_iWgtC"]),
	guix::txtSet(PW,idc_inc,Cal),
	!
;
	CallType="p3_iDecC",
	guix::txtSet(PW,idc_dec,Cal),
	!
;
	set::member(CallType,["p3_iMapC","p3_iSwiCr"]),
	wcrReadCall(Cal,T),
	T=cmp(R,_),
	dbExtension::dbuCR_GetTD(R,_,Dom),
	dbBase::nlSing(Dom,DomNL),
	guix::txtSet(PW,idc_qdomk,Dom),
	guix::txtSet(PW,idc_qdom,DomNL),
	guix::lbxPop(PW,idc_and,[Cal]),
	guix::ctlEnable(PW,[idc_def]),
	!
;
	set::member(CallType,["p3_iCpar","p3_iMapC","p3_iBay","p3_iOwaC","p3_iLnot","p3_iZnot","p3_iCoC","p3_iLand","p3_iLor","p3_iComb","p3_iInC","p3_iUnC"]), %@@ p3_iZnot used??
	guix::lbxAdd(PW,idc_and,Cal),
	!
;
	set::member(CallType,["p3_iSwi","p3_iPCal"]),
	guix::lbxAdd(PW,idc_map,Cal),
	!
;
	CallType="p3_iCon",
	guix::lbxAdd(PW,idc_context,Cal),
	guix::ctlVisible(PW,[idct_out,idc_out]),
	!
;
	dlgIF::feil("wcrRetCallTyp",["Unknown call-type",CallType,Cal],[],nill),!,fail.
	
wcrRetCallPars([],0) :-
	!.
wcrRetCallPars([P|Ps],Errors) :-
	sx::searchstring(P," = ",_),
	sx::sxUnpackS(P," = ",L),
	L=[_,_|_],
	wcrRetCallPars(Ps,Errors),
	!
;
	sx::sxTail(2,P,Pf,_),
	sx::concat(["A value must be assigned to parameter '",Pf,"'!"],Mess),
	dlgIF::dlgNote(0,Mess),
	wcrRetCallPars(Ps,Errs),
	Errors=Errs+1,
	!.
% --------------------------------------------------------------------------------------------
% wcrRetGeneral
% --------------------------------------------------------------------------------------------
class predicates
wcrRetGen : (vpiDomains::windowHandle,vpiDomains::windowHandle,string) determ (i,i,i).
wcrRetPrior : (vpiDomains::windowHandle,vpiDomains::windowHandle,string).
clauses
wcrRetGeneral(W,PW,Typ) :-
	guix::txtGet(W,idc_domk,Dom),
	set::member(Dom,["p3_dcf","p3_dpr"]),
  	guix::txtGet(W,idc_prior,S),
  	not(wcrCheckVal("PRIOR PROBABILITY","p3_dpr",S,_)),
  	!,fail
;
  	guix::txtGet(W,idc_out,Out),
  	Out="",
	guix::lbxGetAll(W,idc_de1s,DEs),
	guix::lbxPop(PW,idc_parameters,DEs),
	guix::txtSet(PW,idc_out,Out),
	guix::txtGet(W,idc_prior,Prior),
	guix::txtSet(PW,idc_prior,Prior),
	wcrRetGen(W,PW,Typ),
	!
;
  	guix::txtGet(W,idc_out,Out),
  	guix::txtGet(W,idc_domk,Dom),
  	wcrCheckVal("OUT OF CONTEXT",Dom,Out,_),
	guix::lbxGetAll(W,idc_de1s,DEs),
	guix::lbxPop(PW,idc_parameters,DEs),
	guix::txtSet(PW,idc_out,Out),
	guix::txtGet(W,idc_prior,Prior),
	guix::txtSet(PW,idc_prior,Prior),
	wcrRetGen(W,PW,Typ),
	!.
wcrRetGen(W,PW,Typ) :-
  	Typ="p3_iCqst",
  	!,guix::lbtGet(W,idc_dom,Dom),
  	dbBase::kbID(Dom,DomK,_,_),
  	guix::txtSet(PW,idc_rdom,Dom),
  	guix::txtSet(PW,idc_rdomk,DomK),
  	guix::lbtSel(PW,idc_qdom,Dom),
  	guix::txtSet(PW,idc_qdomk,DomK),
  	wcrRetPrior(W,PW,DomK),
  	!
;
  	set::member(Typ,["p3_iCqry","p3_iCmap","p3_iCswc","p3_iCswp","p3_iCpar","p3_iCand","p3_iCnot","p3_iCor","p3_iCbay","p3_iCcmb"]),
  	!,guix::lbtGet(W,idc_dom,Dom),
  	dbBase::kbID(Dom,DomK,_,_),
  	guix::txtSet(PW,idc_rdom,Dom),
  	guix::txtSet(PW,idc_rdomk,DomK),
  	wcrRetPrior(W,PW,DomK),
  	!
;
	!.
wcrRetPrior(W,PW,DomK) :-
	set::member(DomK,["p3_dcf","p3_dpr"]),
	guix::txtGet(W,idc_prior,Prior),
	guix::txtSet(PW,idc_prior,Prior),
	guix::ctlVisible(PW,[idct_prior,idc_prior]),
	!
;
	guix::txtSet(PW,idc_prior,"0.50"),
	guix::ctlInvisible(PW,[idct_prior,idc_prior]),
	!.
% --------------------------------------------------------------------------------------------
% wcrSaveCopy
% --------------------------------------------------------------------------------------------
class predicates
wcrSaveCopyX : (vpiDomains::windowHandle,sterm,string,string_list) determ.
clauses

% parameters:
% 3 in left term
% 3 in domain (if)
% 4 in parameters (nl)
%
wcrSaveCopy(W,Chain,LT,Dom,Pars) :-
	dbBase::accessErrorChain(Chain),
	!,fail
;  	
	dbBase::accessErrorChain("v"),
	!,fail
;	
	wcrSaveCopyX(W,LT,Dom,Pars),
	!.

wcrSaveCopyX(W,LT,Dom,Pars) :-
	guix::txtGet(W,idc_rule,RuleN),
	guix::txtGet(W,idc_realm,Realm),
	guix::txtGet(W,idc_kb,RuleK),
	wcrSyntagmIns(RuleN,RuleK,Realm),
  	storeDeclaration(-1,RuleK,Dom,Pars),
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(RuleK,"Stored a copy of selected inexact rule!"),
	!.
% --------------------------------------------------------------------------------------------
% wcrSM
% --------------------------------------------------------------------------------------------
wcrSM(_,_,[],[],[]) :-
	!.	
wcrSM(FDom,TDom,[Vf|FT],[Vt|MT],[S|L]) :-
	nlValue(Vf,FDom,"",Sf),
	nlValue(Vt,TDom,"",St),
	sx::concat([Sf," ---> ",St],S),
	wcrSM(FDom,TDom,FT,MT,L),
	!.
wcrSM(F,T,A,B,_) :-
	dlgIF::feil("wcrSM",[F,T],[],cmp("",[cmp("",A),cmp("",B)])),!,fail.		
% --------------------------------------------------------------------------------------------
% wcrStore
% --------------------------------------------------------------------------------------------
class predicates
wcrStoreQ : (vpiDomains::windowHandle,string,string,sterm,string) determ (i,i,i,o,o).
clauses

wcrStore(W,Typ,DeclChanged) :-
	set::member(Typ,["p3_iZnot","p3_iZsand","p3_iZaand","p3_iZband","p3_iZdand","p3_iZsor","p3_iZaor","p3_iZbor","p3_iZdor"]),
	irBase::wcrSetType(Typ,SetType),
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::lbxGetAll(W,idc_and,Lc),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	wcrReadCalls(Lc,Calls),
  	guix::lbxGetAll(W,idc_de1s,Pars),
  	storeDeclaration(DeclChanged,Rk,"p3_dmg",Pars),
	LT=cmp(SetType,[atom(Rk),
	            cmp(Typ,Calls)]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	set::member(Typ,["p3_iCqry","p3_iCqst"]),
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
	wcrSyntagmIns(Rn,Rk,Realm), 
	guix::txtGet(W,idc_query,Q),
	wcrStoreQ(W,Typ,Q,Qt,QDom),
  	wcrGetMap(W,RDom,QDom,Map),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
	wcrGetDefault(W,QDom,Def),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
  	set::setGet(["p3_iCqry","p3_iCqst"],N,Typ),
  	set::setGet(["p3_iQry","p3_iQst"],N,Hdr),
	LT=cmp("p3_iCdat",[atom(Rk),
	                   cmp(Hdr,[atom(QDom),Qt]),
	                   Map,
	                   fix(Prior),
	                   Out,
	                   Def,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iCnot",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
  	guix::lbxGetAll(W,idc_and,Lc),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	wcrReadCalls(Lc,Calls),
  	Calls=[Cal],
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp(Typ,[atom(Rk),
	            Cal,
	            fix(Prior),
	            Out,
	            Context]),
	wcrDeleteExisting(Rk,Mess),
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	set::member(Typ,["p3_iCand","p3_iCor","p3_iCcmb"]),
	set::setGet(["p3_iCand","p3_iCor","p3_iCcmb"],N,Typ),
	set::setGet(["p3_iLand","p3_iLor","p3_iComb"],N,Log),
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
  	guix::lbxGetAll(W,idc_and,Lc),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	wcrReadCalls(Lc,Calls),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp(Typ,[atom(Rk),
	            cmp(Log,Calls),
	            fix(Prior),
	            Out,
	            Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	set::member(Typ,["p3_iCqry","p3_iCqst"]),
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
	wcrSyntagmIns(Rn,Rk,Realm), 
	guix::txtGet(W,idc_query,Q),
	wcrStoreQ(W,Typ,Q,Qt,QDom),
  	wcrGetMap(W,RDom,QDom,Map),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
	wcrGetDefault(W,QDom,Def),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
  	set::setGet(["p3_iCqry","p3_iCqst"],N,Typ),
  	set::setGet(["p3_iQry","p3_iQst"],N,Hdr),
	LT=cmp("p3_iCdat",[atom(Rk),
	                   cmp(Hdr,[atom(QDom),Qt]),
	                   Map,
	                   fix(Prior),
	                   Out,
	                   Def,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iCmap",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_qdomk,QDom),
  	guix::lbxGetAll(W,idc_and,Lc),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	wcrReadCalls(Lc,Calls),
  	Calls=[Cal],
  	wcrGetMap(W,RDom,QDom,Map),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
	wcrGetDefault(W,QDom,Def),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp("p3_iCmap",[atom(Rk),
	                   Cal,
	                   Map,
	                   fix(Prior),
	                   Out,
	                   Def,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iCswc",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_qdomk,QDom),
  	guix::lbxGetAll(W,idc_and,Lc),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	wcrReadCalls(Lc,Calls),
  	Calls=[Cal],
 	guix::lbxGetAll(W,idc_map,SCalls),
  	wcrGetSwiCon(SCalls,QDom,TCalls),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
	wcrGetDefault(W,QDom,Def),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp("p3_iCswi",[atom(Rk),
	                   Cal,
	                   cmp("p3_iSwi",TCalls),
	                   fix(Prior),
	                   Out,
	                   Def,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iCswp",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_qdomk,QDom),
	guix::lbtGet(W,idc_parameters,DE),
	dbBase::kbID(DE,Dk,_,_),
	wcrSyntagmIns(Rn,Rk,Realm), 
 	guix::lbxGetAll(W,idc_map,SCalls),
  	wcrGetSwiCon(SCalls,QDom,TCalls),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
	wcrGetDefault(W,QDom,Def),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp("p3_iCswi",[atom(Rk),
	                   atom(Dk),
	                   cmp("p3_iSwi",TCalls),
	                   fix(Prior),
	                   Out,
	                   Def,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iCpar",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::lbxGetAll(W,idc_and,Lc),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	wcrReadCalls(Lc,Calls),
  	Calls=[Cal],
 	guix::lbxGetAll(W,idc_map,SCalls),
  	wcrGetPar(SCalls,TCalls),
  	guix::txtGet(W,idc_prior,SPrior),
	sx::sxFix(SPrior,Prior),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp("p3_iCpar",[atom(Rk),
	                   Cal,
	                   cmp("p3_iPCal",TCalls),
	                   fix(Prior),
	                   Out,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iCbay",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_prior,SPrior),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	guix::lbxGetAll(W,idc_and,Lc),
  	wcrReadBayCalls(Lc,Calls),
	sx::sxFix(SPrior,Prior),
  	wcrStoreContext(W,Context,Out),
  	guix::lbxGetAll(W,idc_parameters,Pars),
  	storeDeclaration(DeclChanged,Rk,RDom,Pars),
	LT=cmp("p3_iCbay",[atom(Rk),
	                   cmp("p3_iBay",Calls),
	                   fix(Prior),
	                   Out,
	                   Context]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
	Typ="p3_iZowa",
  	guix::txtGet(W,idc_rk,Rk),
  	guix::txtGet(W,idc_rn,Rn),
  	guix::txtGet(W,idc_realm,Realm),
	wcrSyntagmIns(Rn,Rk,Realm), 
  	guix::lbxGetAll(W,idc_and,Lc),
  	wcrReadOwaCalls(Lc,Calls),
  	guix::lbxGetAll(W,idc_de1s,Pars),
  	storeDeclaration(DeclChanged,Rk,"p3_dmg",Pars),
	LT=cmp(Typ,[atom(Rk),
	            cmp(Typ,Calls)]),
	wcrDeleteExisting(Rk,Mess),	                  
	dbBase::recordInsert(6,Realm,0,0,LT,nill),
	inexrules::addNew(Rk,Mess),
	!
;
    dbBase::nlSingF(Typ,TypNL),
    Mess=string::concat("Failed to store inexact rule of type: ",TypNL),
	dlgIF::dlgNote(0,Mess),
	!,fail
;
    Mess=string::concat("Failed to store inexact rule of type: ",Typ),
	dlgIF::dlgNote(0,Mess),
	!,fail.

wcrStoreQ(W,Typ,Qs,Qt,Dom) :-
	Typ="p3_iCqry",
	irBase::wcrTransQuery(Qs,Qt,Dom),
	!
;
	Typ="p3_iCqst",
	irBase::wcrTransQuestion(Qs,Qt),
	guix::lbtGet(W,idc_qdom,DomN),
	dbBase::kbID(DomN,Dom,_,_),
	!.
% --------------------------------------------------------------------------------------------
% storeDeclaration
% --------------------------------------------------------------------------------------------
storeDeclaration(DeclChanged,Rule,Dom,Pars) :-
    DeclChanged=-1,
	dbBase::smClassDefF(Rule,"h",_,_,_,_,_), % exists already
    !
;    
    DeclChanged=-1, 
    % does not exist
    wcrStoreParams(Pars,Params),
    Seg=dbBase::getCurrentSegment(),
    Def=cmp("q",[cmp("h",[atom(Rule),atom(Dom),Params]),str(Seg)]),
	dbBase::recordInsert(2,"$SM",0,0,Def,atom("true")),
    !
;    
    DeclChanged=1,
    Loc=dbBase::smRefF(Rule),
    dbBase::recordDelete(Loc),
    wcrStoreParams(Pars,Params),
    Seg=dbBase::getCurrentSegment(),
    Def=cmp("q",[cmp("h",[atom(Rule),atom(Dom),Params]),str(Seg)]),
	dbBase::recordInsert(2,"$SM",0,0,Def,atom("true")),
    !
;    
    DeclChanged=1,
    not(dbBase::smClassDefF(Rule,"h",_,_,_,_,_)),
    wcrStoreParams(Pars,Params),
    Seg=dbBase::getCurrentSegment(),
    Def=cmp("q",[cmp("h",[atom(Rule),atom(Dom),Params]),str(Seg)]),
	dbBase::recordInsert(2,"$SM",0,0,Def,atom("true")),
    !
;    
    dlgIF::dlgNote(3,"Unable to store inexact rule declaration"),!,fail.
% --------------------------------------------------------------------------------------------
% wcrStoreContext
% --------------------------------------------------------------------------------------------
wcrStoreContext(W,nill,nill) :-
  	guix::lbxGetAll(W,idc_context,Lcx),
	Lcx=[],
	!.

wcrStoreContext(W,Con,Out) :-
	guix::txtGet(W,idc_rdomk,Dom),
	guix::txtGet(W,idc_out,S),
	wcrCheckVal("OUT OF CONTEXT",Dom,S,Out),
  	guix::lbxGetAll(W,idc_context,L),
  	wcrGetSwiCon(L,"",T),
	Con=cmp("p3_iCon",T),
	!
;
	dlgIF::dlgNote(0,"Out-of-context value invalid!"),
	!,fail.
% --------------------------------------------------------------------------------------------
% wcrStoreParams
% --------------------------------------------------------------------------------------------
wcrStoreParams([],nill) :-
	!.
wcrStoreParams([P|Ps],list(atom(Pk),T)) :-
	dbBase::kbID(P,Pk,_,_),
	wcrStoreParams(Ps,T),
	!.
% --------------------------------------------------------------------------------------------
% wcrStrip
% --------------------------------------------------------------------------------------------
wcrStrip(PName,Name) :-
	sx::frontchar(PName,'*',Name),
	vpiCommonDialogs::note("Note that this inexact rule is suspended","Suspended rules are generally referring to deleted or changed knowledge. This will usually cause errors!"),
	!
;
	Name=PName,
	!.
% --------------------------------------------------------------------------------------------
% wcrSyntagmIns
% --------------------------------------------------------------------------------------------
wcrSyntagmIns(Name,KbName,Realm) :-
	dbBase::kbID_F(Name,K,Clas,_),
	K=KbName,
	Clas="p3_iIR",
	! % exists already - Ok
;
	dbBase::kbID_F(Name,K,Clas,_), 
	K<>KbName,
	dbBase::nlTry(Clas,ClasNL),
	sx::concat(["The name is already in use for '",K,"' (",ClasNL,")"],Mess),
	dlgIF::dlgNote(0,Mess),
	!,fail
;
	dbBase::kbID_F(Name,_,Clas,_), 
	Clas<>"p3_iIR",
	dbBase::nlTry(Clas,ClasNL),
	sx::concat(["The syntagm is already in use for '",ClasNL,"'"],Mess),
	dlgIF::dlgNote(0,Mess),
	!,fail
;	
	Context=dbBase::getContext(),
	Context=[Segment|_],
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(Name,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(KbName),termDomain::atom("p3_iIR"),
  	                                      termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Segment)]),atom("true")),
	!.
% ----------------------------------------------------------------------------------------------
% wcrTreeXML
% ----------------------------------------------------------------------------------------------
class predicates
wcrMakeList : (vpiTree::tree,string_list) determ (i,o).
wcrMakeListX : (vpiTree::tree_list,string_list) determ (i,o).
clauses
% saves a CR root and its tree to xml format
%
wcrTreeXML(Form,Rule) :-
	dbExtension::dbuCR_Get(Rule,Body,_,_),
	ir::loadRule(0,Body),
	ir::crtMakeTree(Rule,0,Tree),
	inexgui::wcrMakeList(Tree,Rules2),
	set::distinct(Rules2,Rules3),
	set::setRev(Rules3,Rules),
	ir::crtRetract,
	Path=globalVars::get_s("std_path"),
	dbBase::nlTry(Rule,RuleNL),
	sx::concat([RuleNL,"_tree"],S2),
	fioExt::filGenName(3,Path,S2,"xml",OutFile),
	File=outFile::new(OutFile),
	xmlP3::xmlKnowA(A),
	File:write(A),
	Count=count::newCounter(0),
	bck::bckCRs(File,Form,Rules,Count),
	N=Count:get(),
	xmlP3::xmlKnowB(B),
	File:write(B),
	File:close(),
	Ns=toString(N),
	sx::concat(["Generated certainty rule tree with ",Ns," rules as XML-file (in re-input order sequence)",OutFile],Mess),
	dlgIF::dlgNote(0,Mess),
	!.
wcrMakeList(vpiTree::tree(S,_,L,_),[Rule|Rules]) :-
	p3Tree::dtTreeNode(S,_,Rule,_),
	wcrMakeListX(L,Rules),
	!.
	
wcrMakeListX([],[]) :-
	!.
wcrMakeListX([H|T],Rules) :-
	wcrMakeList(H,Rules2),
	wcrMakeListX(T,Rules3),
	set::conc([Rules3,Rules2],Rules),
	!.
% --------------------------------------------------------------------------------------------
% wcrUpdateRule
% --------------------------------------------------------------------------------------------
wcrUpdateRule(Typ,RuleN,RuleK,Realm) :-
  	Typ="p3_iZowa",
	W=guix::getWinOfClas(1),
    IR=inexOWA_type::new(W),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (fuzzy set)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayFZ(Typ,IW,-1,RuleN,RuleK,Realm),
	!
;
  	set::member(Typ,["p3_iZand","p3_iZor","p3_iZnot"]),
	W=guix::getWinOfClas(1),
    IR=inexFuzzyType::new(W),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (fuzzy set)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayFZ(Typ,IW,-1,RuleN,RuleK,Realm),
	!
;
  	set::member(Typ,["p3_iCand","p3_iCor","p3_iCnot","p3_iCcmb"]),
	W=guix::getWinOfClas(1),
    IR=inexAndType::new(W),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (certainty rule)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayAnd(Typ,IW,-1,RuleN,RuleK,Realm),
	!
;
  	set::member(Typ,["p3_iCqry","p3_iCqst"]),
	W=guix::getWinOfClas(1),
    IR=inexQueryType::new(W),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (data rule)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayQ(Typ,IW,-1,RuleN,RuleK,Realm),
	!
;
	Typ="p3_iCmap",
	W=guix::getWinOfClas(1),
    IR=inexMapType::new(W),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (support rule)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayMap(IW,-1,RuleN,RuleK,Realm),
  	!
;
	Typ="p3_iCbay",
	TW=guix::getWinOfClas(1),
    IR=inexBayType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (certainty rule)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayBay(IW,-1,RuleN,RuleK,Realm),
  	!
;
	set::member(Typ,["p3_iCswc","p3_iCswp"]),
	TW=guix::getWinOfClas(1),
    IR=inexSwitchType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (support rule)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplaySwitch(IW,Typ,-1,RuleN,RuleK,Realm),
  	!
;
	Typ="p3_iCpar",
	TW=guix::getWinOfClas(1),
    IR=inexParType::new(TW),
    IW=IR:getWin(),
    dbBase::nlSing(Typ,Sr),
    Title=string::concat(Sr," (support rule)"),
    vpi::winSetText(IW,Title),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIR",RuleK),
	wcrDisplayPar(IW,Typ,-1,RuleN,RuleK,Realm),
  	!
;
	dlgIF::feil("wcrUpdateRule",[Typ],[],nill),!,fail.
% --------------------------------------------------------------------------------------------
% wcrValidate
% --------------------------------------------------------------------------------------------
class predicates
wcrInvalidContext : (string_list) determ (i).
clauses
wcrValidate(W,Typ) :-
	Typ="p3_iZnot",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"At least one set::set must be complemented!"),!,fail
;
	Typ="p3_iZnot",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N>1,
	dlgIF::dlgNote(0,"Only one set::set can be complemented!"),!,fail
;
	set::member(Typ,["p3_iZsand","p3_iZaand","p3_iZband","p3_iZdand","p3_iZsor","p3_iZaor","p3_iZbor","p3_iZdor"]),
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<2,
	dlgIF::dlgNote(0,"At least two set::sets must be specified for intersection or union operations!"),!,fail
;
	Typ="p3_iZowa",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<2,
	dlgIF::dlgNote(0,"At least two rules must be combined!"),!,fail
;
	set::member(Typ,["p3_iZnot","p3_iZsand","p3_iZaand","p3_iZband","p3_iZdand","p3_iZsor","p3_iZaor","p3_iZbor","p3_iZdor","p3_iZowa"]),
	!
;
	Typ="p3_iCcmb",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<2,
	dlgIF::dlgNote(0,"At least two rules must be combined!"),!,fail
;
	Typ="p3_iCand",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<2,
	dlgIF::dlgNote(0,"At least two rules must be AND'ed!"),!,fail
;
	Typ="p3_iCor",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<2,
	dlgIF::dlgNote(0,"At least two rules must be OR'ed!"),!,fail
;
	Typ="p3_iCbay",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"At least one rules must be called by the bayesian rule!"),!,fail
;
	Typ="p3_iCpar",
	guix::lbxGetAll(W,idc_map,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"At least one parameter-rule must be called!"),!,fail
;
	Typ="p3_iCpar",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"The main rule to be called is not specified!"),!,fail
;
	set::member(Typ,["p3_iCswc","p3_iCswp"]),
	guix::lbxGetAll(W,idc_map,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"At least one rule must be included in the switch-table!"),!,fail
;
	Typ="p3_iCswc",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"The criterion-rule is not specified!"),!,fail
;
	Typ="p3_iCmap",
	guix::lbxGetAll(W,idc_and,L),
	set::size(L,N),
	N<1,
	dlgIF::dlgNote(0,"At least one entry must be included in the map-table!"),!,fail
;
	set::member(Typ,["p3_iCqry","p3_iCqst","p3_icMap","p3_iCswc","p3_iCswp"]),
  	guix::txtGet(W,idc_qdomk,QDom),
  	guix::txtGet(W,idc_def,S),
	not(wcrCheckVal("DEFAULT VALUE",QDom,S,_)),
	!,fail
;
	not(set::member(Typ,["p3_iZowa","p3_iZnot","p3_iZsand","p3_iZaand","p3_iZband","p3_iZdand","p3_iZsor","p3_iZaor","p3_iZbor","p3_iZdor"])),
	guix::lbxGetAll(W,idc_context,L),
	set::size(L,N),
	N>0,
  	guix::txtGet(W,idc_rdomk,RDom),
  	guix::txtGet(W,idc_out,S),
	not(wcrCheckVal("OUT OF CONTEXT",RDom,S,_)),
	!,fail
;
	Typ="p3_iCswp",
	guix::lbtGet(W,idc_parameters,DE),
	dbBase::kbID_F(DE,_,_,_),
	!
;
	Typ="p3_iCswp",
	dlgIF::dlgNote(0,"Select the parameter used as switch criterion!"),!,fail
;
	% no errors found
	!.
% succeeds only if ERRORS in context (fails if context is valid!)
%
wcrInvalidContext([]) :-
	!,fail.
wcrInvalidContext([C|Cs]) :-
	sx::sxUnpackS(C," <--- ",L2),
	L2=[Range|_],
	sx::sxUnpackS(Range,"...",L3),
	L3=[_,_],
	% valid
	!,wcrInvalidContext(Cs),
	!
;
	dlgIF::dlgNote(0,"Context call without valid minimum/maximum certainty factor information!"),
	!.
% ----------------------------------------------------------------------------------------------
% wcrCheckVal
% ----------------------------------------------------------------------------------------------
wcrCheckVal(Loc,Dom,S,Val) :-
    dom::domStr(Dom),
    sx::sxQuote(S,Sq),
    Val=str(Sq),
    dom::domValCompatF(Dom,Val),
    !
;    
    dom::domAtom(Dom),
    dbBase::kbID_F(S,A,_,_),
    Val=atom(A),
    dom::domValCompatF(Dom,Val),
    !
;
    dom::domInt(Dom),
    Int=sx::toInt(S),
    Val=int(Int),
    dom::domValCompatF(Dom,Val),
    !
;    
    dom::domNum(Dom),
    Num=sx::toReal(S),
    Val=fix(Num),
    dom::domValCompatF(Dom,Val),
    !
;
	dbBase::nlSing(Dom,DomN),
	sx::concat(["Value for ",Loc," '",S,"' is invalid, out-of-range or incompatible with ",DomN," domain!"],Mess),
	dlgIF::dlgNote(0,Mess),
	!,fail.
% ----------------------------------------------------------------------------------------------
% nlValue
% ----------------------------------------------------------------------------------------------
nlValue(V,Dom,Frm,Nl) :-
	nl::conValX_F(V,Dom,Frm,Nl),
	!
;
	nl::conValX_F(V,"p3_dany","",Nl),
	dbBase::nlTry(Dom,DomNl),
	Mess=string::concat("Internal value could not be translated to NL-format for domain: ",DomNl,"!"), 
	dlgIF::dlgNote(0,Mess),
	!
;   
    Nl="** TRANSLATION ERROR **",
    S=termDomain::toTermString(V),
	Mess=string::concat("Term: ",S," could not be translated to NL-format for domain: ",Dom,"!"), 
	dlgIF::dlgNote(0,Mess),
	!
;	
    Nl="** TRANSLATION ERROR **",
	Mess=string::concat("Term could not be translated to NL-format for domain: ",Dom,"!"), 
	dlgIF::dlgNote(0,Mess),
	!.
end implement inexgui
