/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement inexrules
open core, vpiDomains, resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/Inexactrules/inexrules".
classVersion = "1.0".

facts
thisWin : vpiDomains::windowHandle := erroneous.

predicates
getSubType : (string) -> string_list determ.
getSubDom : (string_list,string_list,string_list) determ (i,i,o).
getSub : (string_list,string,string_list) determ (i,i,o).

class predicates
removeRule : (string_list,string,string_list) determ (i,i,o).
updateMainWindow : (string,string) determ.

clauses
classInfo(className, classVersion).

        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* create, destroy */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_refresh,idc_rules,idc_kb,idc_new_rule,idc_update,idc_delete,idc_or,idc_not,idc_query,idc_xml_pr,idc_par,idc_graph,
  	                   idc_realm,idc_rule,idc_bayesian,idc_all_types,idc_and,idc_deps,idc_record,idc_view_text,idc_combination,idc_delete_dec,idc_delete_term,
  	                   idc_question,idc_par_switch,idc_switch,idc_map,idc_3cr,idc_t3cr,idc_rule_network,idc_xml_tpr,idc_copy,
  	                   idc_all_cr,idc_all_fz,idc_intersections,idc_unions,idc_complements,idc_owa,idc_support],[]),
        guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],1),
        Rules=pop::getCRsDomNL(),
        guix::lbxPop(thisWin,idc_all,Rules),
        guix::lbxPop(thisWin,idc_rules,Rules),
        guix::ctlDisable(thisWin,[idc_copy,idc_update,idc_delete,idc_3cr,idc_xml_pr,idc_deps,idc_record,idc_view_text,idc_3cr,idc_t3cr,idc_rule_network,idc_xml_tpr]),
        guix::addWin(60,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.
  	    
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
        guix::dropWin(thisWin),
        thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin).

/* rule selected */

    predicates
        onControlrules : vpiDomains::controlHandler.
    clauses
        onControlrules(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	sentencemodel::dmAnnoDisplayAsst("p3_iIRdec",K),
  	guix::ctlEnable(thisWin,[idc_update,idc_delete,idc_3cr,idc_xml_pr,idc_deps,idc_record,idc_view_text,idc_3cr,idc_t3cr,idc_rule_network,idc_xml_tpr,idc_copy]),
	!;!.

/* new rule */

    predicates
        onControlNewRule : vpiDomains::controlHandler.
    clauses
        onControlNewRule(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_Get(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],N),
  	N<4,
	dlgIF::dlgNote(0,"Select rule-type first!"),
	!
;
  	guix::guiRB_Get(thisWin,[idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15],N),
  	set::setGet(["p3_iCbay","p3_iCand","p3_iCor","p3_iCnot","p3_iCqry","p3_iCswc","p3_iCmap","p3_iCqst","p3_iCswp","p3_iCcmb","p3_iZand","p3_iZor","p3_iZnot","p3_iZowa","p3_iCpar"],N,Typ),
    Dlg = inexNew::new(), 
    Dlg:show(thisWin,1,Typ),
	!;!.

/* copy rule */

    predicates
        onControlcopy : vpiDomains::controlHandler.
    clauses
        onControlcopy(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	guix::txtSet(thisWin,idc_rule,""),
  	dbBase::getIrDefF(K,Body,_),
    Dlg = inexNew::new(),
    Dlg:show(thisWin,-1,""),
 	guix::txtGet(thisWin,idc_rule,R),
 	R<>"", % the name-assigning dialog was completed
	Body=cmp(Chain,[atom(_)|T]),
	guix::txtGet(thisWin,idc_kb,NK),
	dbBase::smClassDef(K,"h",_,DEs,Dom,_,_),
	dbBase::nlSings(DEs,DEsNL),
	inexgui::wcrSaveCopy(thisWin,Chain,cmp(Chain,[atom(NK)|T]),Dom,DEsNL),
	!;!.

/* delete rule */

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	inexgui::wcrChain(thisWin,Chain),
	not(dbBase::accessErrorChain(Chain)),
	not(dbBase::accessErrorChain("v")),
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	dbBase::getIrDef(K,_,Loc),
  	dbBase::recordDelete(Loc),
	guix::lbxDelS(thisWin,idc_rules,Rule2),
	dlgIF::dlgNote(0,"Inexact rule definition deleted!"),
	!;!.

predicates
    onControlidc_delete_dec : vpiDomains::controlHandler.
clauses
    onControlidc_delete_dec(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	inexgui::wcrChain(thisWin,Chain),
	not(dbBase::accessErrorChain(Chain)),
	not(dbBase::accessErrorChain("q")),
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	dbBase::getIrDef(K,_,Loc),
	dbBase::recordDelete(Loc),
	guix::lbxDelS(thisWin,idc_rules,Rule2),
	Loc2=dbBase::smRef(K),
	dbBase::recordDelete(Loc2),
	dlgIF::dlgNote(0,"Inexact rule declaration and definition deleted!"),
	!;!.

predicates
    onControlidc_delete_term : vpiDomains::controlHandler.
clauses
    onControlidc_delete_term(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	inexgui::wcrChain(thisWin,Chain),
	not(dbBase::accessErrorChain(Chain)),
	not(dbBase::accessErrorChain("q")),
	not(dbBase::accessErrorChain("v")),
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	dbBase::getIrDef(K,_,Loc),
	dbBase::recordDelete(Loc),
	guix::lbxDelS(thisWin,idc_rules,Rule2),
	Loc2=dbBase::smRef(K),
	dbBase::recordDelete(Loc2),
	dbBase::syntagmDelete(K),
	dlgIF::dlgNote(0,"Inexact rule declaration, definition and terminology deleted!"),
	!;!.

/* update rule */

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
	dbBase::kbID(Rule,K,_,_),
	dbBase::getIrDefF(K,_,Loc),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,_,_),
	dbBase::irType(K,_,Typ),
	inexgui::wcrUpdateRule(Typ,Rule,K,Realm),
	!;!.

/* dependents */

    predicates
        onControldeps : vpiDomains::controlHandler.
    clauses
        onControldeps(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,Id,_,_),
	dep::chkGetAllDirectDeps(cmp("n",[int(16),termDomain::str(Id)]),_,SDeps),
    dep::nodIF_no(K,16),
	dbBase::nlSing(K,NL),
	sx::concat([NL," ",Rule3],S),
    Dlg=dependents::new(),
    Dlg:setPars(SDeps,S,0),
    W=guix::getWinOfClas(1),
    Dlg:show(W),
	!;!.

/* -> text */

predicates
    onControlidc_view_text : vpiDomains::controlHandler.
clauses
    onControlidc_view_text(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	irReport::reportRule(K),
	!;!.

/* -> xml */

    predicates
        onControlCr : vpiDomains::controlHandler.
    clauses
        onControlCr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
	dbBase::getIrDefF(K,Body,Loc),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,_,_),
	xmlP3::xmlFromCR("NL",Realm,Body,X2),
	xmlP3::xmlKnowledge(X2,X),
	Path=globalVars::get_s("std_path"),
	fioExt::filGenName(3,Path,Rule,"XML",OutFile),
	file::writeString(OutFile,X),
	editorWindow::openFiles([OutFile]),
	!;!.

/* -> xml/pr */

    predicates
        onControlXmlPr : vpiDomains::controlHandler.
    clauses
        onControlXmlPr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
	dbBase::getIrDefF(K,Body,Loc),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,_,_),
	xmlP3::xmlFromCR("PR",Realm,Body,X2),
	xmlP3::xmlKnowledge(X2,X),
	Path=globalVars::get_s("std_path"),
	fioExt::filGenName(3,Path,Rule,"XML",OutFile),
	file::writeString(OutFile,X),
	editorWindow::openFiles([OutFile]),
	!;!.
/* -> xml (all) */
    predicates
        onControlt3cr : vpiDomains::controlHandler.
    clauses
        onControlt3cr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
	vpi::cursorSetWait(),
	inexgui::wcrTreeXML("NL",K),
    vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.
/* -> xml/pr (all) */
    predicates
        onControlXmlTpr : vpiDomains::controlHandler.
    clauses
        onControlXmlTpr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
	vpi::cursorSetWait(),
	inexgui::wcrTreeXML("PR",K),
    vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* -> rule tree */

    predicates
        onControlRuleNetwork : vpiDomains::controlHandler.
    clauses
        onControlRuleNetwork(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
  	Dlg=associationparameter::new(),
  	Dlg:show(thisWin),
  	Pars=globalVars::popRetPars(),
  	Pars=[Ps],
  	AssPar=sx::toInt(Ps),
	vpi::cursorSetWait(),
    ir::crtTree(K,AssPar,_),
	!;!.

/* -> rule graph */

predicates
    onControlidc_graph : vpiDomains::controlHandler.
clauses
    onControlidc_graph(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
	p3Tree::dtDepTreeTitle(1,1,Rule,Note),
	p3Tree::dtDepTreeTitleLong(1,1,Rule,Title),
	dep::drawDeps(Title,Note,"p3_pDP",3,0,0,1,0,0,cmp("n",[int(15),termDomain::str(K)]),"ALL"),
	!;!.

/* view record */

    predicates
        onControlrecord : vpiDomains::controlHandler.
    clauses
        onControlrecord(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
 	guix::lbxGet(thisWin,idc_rules,Rule2),
  	sx::sxRemoveHead(Rule2,"*",Rule2s),
  	sx::sxBreak(Rule2s," :: ",Rule3,_),
	inexgui::wcrStrip(Rule3,Rule),
  	dbBase::kbID(Rule,K,_,_),
	dbBase::getIrDefF(K,_,Loc),
	W=guix::getWinOfClas(1),
	RecordWindow=record::new(W),
	Wr=RecordWindow:getWin(),
	record::kbaWinDisplay(Wr,Loc),
	!;!.

/* rule type radio buttons */

    predicates
        onControlAllTypes : vpiDomains::controlHandler.
    clauses
        onControlAllTypes(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],1),
    guix::lbxGetAll(thisWin,idc_all,Rules),
    guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlAllFz : vpiDomains::controlHandler.
    clauses
        onControlAllFz(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],3),
    Rules=getSubType("p3_iFZ"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlAllCr : vpiDomains::controlHandler.
    clauses
        onControlAllCr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],2),
    Rules=getSubType("p3_iCR"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.    
    predicates
        onControlsupport : vpiDomains::controlHandler.
    clauses
        onControlsupport(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],4),
	Rules2=getSubType("p3_iCdat"),
    Rules3=getSubType("p3_iCswc"),
    Rules4=getSubType("p3_iCswp"),
    Rules5=getSubType("p3_iCpar"),
    Rules6=getSubType("p3_iCmap"),
	set::conc([Rules2,Rules3,Rules4,Rules5,Rules6],Rules),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlpar : vpiDomains::controlHandler.
    clauses
        onControlpar(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],19),
	Rules=getSubType("p3_iCpar"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlcombination : vpiDomains::controlHandler.
    clauses
        onControlcombination(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],14),
	Rules=getSubType("p3_iCcmb"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlswitch : vpiDomains::controlHandler.
    clauses
        onControlswitch(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],10),
	Rules=getSubType("p3_iCswc"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlParSwitch : vpiDomains::controlHandler.
    clauses
        onControlParSwitch(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],13),
	Rules=getSubType("p3_iCswp"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlmap : vpiDomains::controlHandler.
    clauses
        onControlmap(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],11),
	Rules=getSubType("p3_iCmap"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlquery : vpiDomains::controlHandler.
    clauses
        onControlquery(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],9),
	Rules=getSubType("p3_iCqry"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlquestion : vpiDomains::controlHandler.
    clauses
        onControlquestion(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],12),
	Rules=getSubType("p3_iCqst"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlnot : vpiDomains::controlHandler.
    clauses
        onControlnot(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],8),
	Rules=getSubType("p3_iCnot"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlor : vpiDomains::controlHandler.
    clauses
        onControlor(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],7),
	Rules=getSubType("p3_iCor"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],6),
	Rules=getSubType("p3_iCand"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlbayesian : vpiDomains::controlHandler.
    clauses
        onControlbayesian(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],5),
	Rules=getSubType("p3_iCbay"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlowa : vpiDomains::controlHandler.
    clauses
        onControlowa(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],18),
	Rules=getSubType("p3_iZowa"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlcomplements : vpiDomains::controlHandler.
    clauses
        onControlcomplements(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],17),
	Rules=getSubType("p3_iZnot"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlunions : vpiDomains::controlHandler.
    clauses
        onControlunions(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],16),
	Rules=getSubType("p3_iZor"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.
    predicates
        onControlintersections : vpiDomains::controlHandler.
    clauses
        onControlintersections(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_all_types,idc_all_cr,idc_all_fz,idc_support,idc_bayesian,idc_and,idc_or,idc_not,idc_query,idc_switch,idc_map,idc_question,idc_par_switch,idc_combination,idc_intersections,idc_unions,idc_complements,idc_owa,idc_par],[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19],15),
	Rules=getSubType("p3_iZand"),
	guix::lbxPop(thisWin,idc_rules,Rules),
	!;!.

predicates
    onControlidc_refresh : vpiDomains::controlHandler.
clauses
    onControlidc_refresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        vpi::cursorSetWait(),
        Rules=pop::getCRsDomNL(),
        guix::lbxPop(thisWin,idc_all,Rules),
        guix::lbxPop(thisWin,idc_rules,Rules),
        vpi::cursorSet(thisWin,cursor_Arrow),
        !;!.

% This code is maintained by the VDE do not update it manually, 00:01:15-12.4.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,55,979,623).
    menu : vpiDomains::menu = noMenu.
    title : string = "Inexact Rules".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,120,209,138),"Bayes-rules",Win,[wsf_TabStop,wsf_Auto],idc_bayesian),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,56,209,74),"AND-rules",Win,[wsf_TabStop,wsf_Auto],idc_and),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,76,209,94),"OR-rules",Win,[wsf_TabStop,wsf_Auto],idc_or),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,100,209,118),"NOT-rules",Win,[wsf_TabStop,wsf_Auto],idc_not),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,364,209,382),"Queries",Win,[wsf_TabStop,wsf_Auto],idc_query),
        _ = vpi::winCreateControl(wc_RadioButton,rct(7,4,208,24),"All Rules/Sets",Win,[wsf_Auto,wsf_TabStop],idc_all_types),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,324,209,342),"Call Switches",Win,[wsf_TabStop,wsf_Auto],idc_switch),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,280,209,300),"All Support Rules",Win,[wsf_Auto,wsf_TabStop],idc_support),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,384,209,402),"Questions",Win,[wsf_TabStop,wsf_Auto],idc_question),
        _ = vpi::winCreateControl(wc_LBox,rct(216,4,872,452),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_rules),
        _ = vpi::winCreateControl(wc_PushButton,rct(216,512,368,536),"New Rule",Win,[wsf_Group,wsf_TabStop],idc_new_rule),
        _ = vpi::winCreateControl(wc_PushButton,rct(544,456,699,480),"View Record",Win,[wsf_Group,wsf_TabStop],idc_record),
        _ = vpi::winCreateControl(wc_PushButton,rct(216,540,368,564),"Display Rule Tree",Win,[wsf_Group,wsf_TabStop],idc_rule_network),
        _ = vpi::winCreateControl(wc_PushButton,rct(712,540,867,564),"XML (PR-based) entire tree",Win,[wsf_Group,wsf_TabStop],idc_xml_tpr),
        _ = vpi::winCreateControl(wc_PushButton,rct(712,512,867,536),"XML (NL-based) entire tree",Win,[wsf_Group,wsf_TabStop],idc_t3cr),
        _ = vpi::winCreateControl(wc_PushButton,rct(544,540,699,564),"XML (PR-based)",Win,[wsf_Group,wsf_TabStop],idc_xml_pr),
        _ = vpi::winCreateControl(wc_PushButton,rct(544,512,699,536),"XML (NL-based)",Win,[wsf_Group,wsf_TabStop],idc_3cr),
        _ = vpi::winCreateControl(wc_PushButton,rct(712,456,867,480),"Display Dependents",Win,[wsf_Group,wsf_TabStop],idc_deps),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,484,200,508),"Delete Definition",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_PushButton,rct(216,456,536,492),"View/Update Rule",Win,[wsf_Group,wsf_TabStop],idc_update),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,304,209,322),"Parameter Switches",Win,[wsf_TabStop,wsf_Auto],idc_par_switch),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,512,536,536),"Copy Rule",Win,[wsf_Group,wsf_TabStop],idc_copy),
        _ = vpi::winCreateControl(wc_Edit,rct(881,62,977,86),"rule",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_rule),
        _ = vpi::winCreateControl(wc_Edit,rct(881,9,977,33),"realm",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_realm),
        _ = vpi::winCreateControl(wc_Edit,rct(881,35,977,59),"kb",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_kb),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,140,209,158),"Combination-rules",Win,[wsf_TabStop,wsf_Auto],idc_combination),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,32,209,52),"All Certainty Rules",Win,[wsf_TabStop,wsf_Auto],idc_all_cr),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,168,209,188),"All Fuzzy Sets",Win,[wsf_TabStop,wsf_Auto],idc_all_fz),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,192,209,210),"Intersections",Win,[wsf_TabStop,wsf_Auto],idc_intersections),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,212,209,230),"Unions",Win,[wsf_TabStop,wsf_Auto],idc_unions),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,232,209,250),"Complements",Win,[wsf_TabStop,wsf_Auto],idc_complements),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,252,209,270),"Ordered Weighted Averages",Win,[wsf_TabStop,wsf_Auto],idc_owa),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,404,209,422),"Maps",Win,[wsf_TabStop,wsf_Auto],idc_map),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,344,209,362),"Parameter Rules",Win,[wsf_TabStop,wsf_Auto],idc_par),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,512,200,536),"Delete Definition + Declaration",Win,[wsf_Group,wsf_TabStop],idc_delete_dec),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,540,200,564),"Delete Def + Decl + Terminology",Win,[wsf_Group,wsf_TabStop],idc_delete_term),
        _ = vpi::winCreateControl(wc_LBox,rct(8,452,40,480),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Invisible],idc_all),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,540,536,564),"Generate Rule Graph",Win,[wsf_Group,wsf_TabStop],idc_graph),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,428,208,452),"Refresh",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        _ = vpi::winCreateControl(wc_PushButton,rct(544,484,699,508),"View Text",Win,[wsf_Group,wsf_TabStop],idc_view_text),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_rules, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrules(idc_rules, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_new_rule, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlNewRule(idc_new_rule, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_copy, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcopy(idc_copy, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_deps, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldeps(idc_deps, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_3cr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCr(idc_3cr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_xml_pr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlXmlPr(idc_xml_pr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_t3cr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlt3cr(idc_t3cr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_xml_tpr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlXmlTpr(idc_xml_tpr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_rule_network, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRuleNetwork(idc_rule_network, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_record, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrecord(idc_record, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_all_types, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAllTypes(idc_all_types, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_all_fz, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAllFz(idc_all_fz, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_all_cr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAllCr(idc_all_cr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_support, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsupport(idc_support, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_par, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlpar(idc_par, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_combination, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcombination(idc_combination, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_switch, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlswitch(idc_switch, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_par_switch, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlParSwitch(idc_par_switch, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_map, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlmap(idc_map, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_query, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlquery(idc_query, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_question, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlquestion(idc_question, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_or, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlor(idc_or, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_bayesian, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlbayesian(idc_bayesian, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_owa, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlowa(idc_owa, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_complements, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcomplements(idc_complements, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_unions, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlunions(idc_unions, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_intersections, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlintersections(idc_intersections, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_not, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnot(idc_not, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete_dec, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_delete_dec(idc_delete_dec, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete_term, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_delete_term(idc_delete_term, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_graph, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_graph(idc_graph, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_refresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_view_text, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_view_text(idc_view_text, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code

addNew(R,Mess) :-
	dbBase::smDef(R,_,_,_,Dom,_,_),
	dbBase::nlSing(Dom,S2),
	dbBase::nlSing(R,S3),
    dbBase::irType(R,_,Typ),
	dbBase::nlSing(Typ,S4),	
	sx::concat([S3," :: ",S4," (",S2,")"],New),
	updateMainWindow(S3,New),
	dlgIF::dlgNote(0,Mess),
	!.

updateMainWindow(Rule,New) :-
	CW=guix::getWinOfClas(60), % @@ assumes only one open
    guix::lbxGetAll(CW,idc_all,L1),
    removeRule(L1,Rule,L1r),
    guix::lbxPop(CW,idc_all,[New|L1r]),
    guix::lbxGetAll(CW,idc_rules,L2),
    removeRule(L2,Rule,L2r),
    guix::lbxPop(CW,idc_rules,[New|L2r]),
    !.
    
removeRule([],_,[]) :-
    !.
removeRule([H|T],R,T) :-
    sx::sxUnpackS(H," :: ",L),
    L=[R|_],
    !.
removeRule([H|T],R,[H|Tr]) :-
    removeRule(T,R,Tr),
    !.
    
getSubType(Type)=Rules :-
	Type="p3_iCR",
	dbBase::nlSing("p3_dcf",D1),
	dbBase::nlSing("p3_dpr",D2),
	guix::lbxGetAll(thisWin,idc_all,Rs),
	getSubDom(Rs,[D1,D2],Rules),
	!
;
	Type="p3_iFZ",
	dbBase::nlSing("p3_dmg",D1),
	guix::lbxGetAll(thisWin,idc_all,Rs),
	getSubDom(Rs,[D1],Rules),
	!
;	
    dbBase::nlSing(Type,Typ),
	guix::lbxGetAll(thisWin,idc_all,Rs),
    getSub(Rs,Typ,Rules),
    !.
    
getSub([],_,[]) :-
    !.
getSub([H|T],Type,Rules) :-
    sx::sxGetInBrackS(H," :: "," (",Typ),
    Typ=Type,
    getSub(T,Type,Rs),
    Rules=[H|Rs],
    !
;    
    getSub(T,Type,Rules),
    !.
    
getSubDom([],_,[]) :-
    !.
getSubDom([H|T],Types,Rules) :-
    sx::sxGetInBrackS(H," (",")",Typ),
    set::member(Typ,Types),
    getSubDom(T,Types,Rs),
    Rules=[H|Rs],
    !
;    
    getSubDom(T,Types,Rules),
    !.
end implement inexrules
