/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement reasoning
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains
constants
    className = "com/rudstrand/TaskWindow/Inexactrules/reasoning".
    classVersion = "1.0".
clauses
    classInfo(className, classVersion).
facts
    thisWin : vpiDomains::windowHandle := erroneous.
clauses
    new(Parent):-
        _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                            windowFlags, eventHandler, 0).
predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event),
        !.
    eventHandler(Win, e_Menu(Id, CAS)) = Result :-
        Parent = vpi::winGetParent(Win),
        Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).
predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling():-
    vpi::cursorSetWait(),
    guix::setStyle(thisWin,[idc_st,idc_ok,idct_sentence_type,idct_data_element_type,idc_de,idct_parameters,idc_par,idc_tree_short,idc_tree_long,idc_report],[]),
    guix::ctlDisable(thisWin,[idc_ok]),
    Ctl=vpi::winGetCtlHandle(thisWin,idc_st),
    inexgui::crrPopST(Ctl),
    guix::guiRB_SetN(thisWin,[idc_tree_short,idc_tree_long,idc_report],[1,2,3],1),
    guix::addWin(63,thisWin),
    vpi::cursorSet(thisWin,cursor_Arrow),
    !;!.
predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        guix::dropWin(thisWin),
        thisWin := erroneous.
predicates
    onSizeChanged : vpiDomains::sizeHandler.
clauses
    onSizeChanged(_Width, _Height) = defaultHandling():-
        vpiToolbar::resize(thisWin).
predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses        
    onCloseRequest() = defaultHandling():-
    guix::dropWin(thisWin),
    vpi::winDestroy(thisWin),
    !.

predicates
onControlst : vpiDomains::controlHandler.
clauses

onControlst(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
	vpi::cursorSetWait(),
	C=vpi::winGetCtlHandle(thisWin,idc_de),
	vpi::lboxClear(C),
	guix::lbtGet(thisWin,idc_st,STn),
	%
	Cc=vpi::winGetCtlHandle(thisWin,idc_de),
	Cd=vpi::winGetCtlHandle(thisWin,idc_par),
	vpi::lboxClear(Cc),
	vpi::lboxClear(Cd),
	% load all DEs for this sentence type
	dbBase::stNL_KB(STn,STk),
	dbBase::chainSentences("r",LT),
	LT=cmp(_,[cmp("u",[termDomain::str(ST),termDomain::atom(Arg),termDomain::atom(DE)|_])]),
	ST=STk,
	vars::varFuncPar(Arg,DE,Par),
	vpi::lboxAdd(Cc,Par),
	fail
;
    CtrlInfo=vpiDomains::selchanged(),
	C=vpi::winGetCtlHandle(thisWin,idc_de),
	DEs=vpi::lboxGetAll(C),
	set::distinct(DEs,DEd),
	dbBase::nlSings(DEd,DEns),
	vpi::lboxClear(C),
	vpi::lboxAdd(C,DEns),
	C2=vpi::winGetCtlHandle(thisWin,idc_par),
	vpi::lboxClear(C2),
	guix::ctlDisable(thisWin,[idc_ok]),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

predicates
onControlde : vpiDomains::controlHandler.
clauses

onControlde(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
	vpi::cursorSetWait(),
	C=vpi::winGetCtlHandle(thisWin,idc_par),
	vpi::lboxClear(C),
	guix::lbtGet(thisWin,idc_st,STn),
	guix::lbtGet(thisWin,idc_de,DEn),
	% load all parameters for this rule
	dbBase::stNL_KB(STn,STk),
	sx::sxUnpack(DEn,':',L),
	L=[Arg,DE],
	dbBase::kbID(Arg,ArgK,_,_),
	dbBase::kbID(DE,DEk,_,_),
	dbBase::chainSentences("r",LT),
	LT=cmp(_,[cmp("u",[termDomain::str(S),termDomain::atom(A),termDomain::atom(D),termDomain::str(ParS)|_])]),
	S=STk,
	D=DEk,
	A=ArgK,
	ParT=termDomain::fromTermStringIndirect(ParS),
	nl::conValL(ParT,"p3_dany","",Vals),
	dbBase::joinNL(Vals,SVals),
	vpi::lboxAdd(C,SVals),
	fail
;	
	vpi::cursorSet(thisWin,cursor_Arrow),
	!.

predicates
onControlpar : vpiDomains::controlHandler.
clauses

onControlpar(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
    guix::ctlEnable(thisWin,[idc_ok]),
    !;!.
	
predicates
onControlok : vpiDomains::controlHandler.
clauses

onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
    guix::guiRB_Get(thisWin,[idc_tree_short,idc_tree_long,idc_report],[1,2,3],N),
    N<3,
    NL=N-1,
	guix::lbtGet(thisWin,idc_st,STn),
	guix::lbtGet(thisWin,idc_de,DEn),
	guix::lbtGet(thisWin,idc_par,SP),
	dbBase::stNL_KB(STn,STk),
	sx::sxUnpack(DEn,':',L),
	L=[Arg,DE],
	dbBase::kbID(Arg,ArgK,_,_),
	dbBase::kbID(DE,DEk,_,_),
	dbBase::chainSentences("r",LT),
	LT=cmp("r",[cmp("u",[termDomain::str(S),termDomain::atom(A),termDomain::atom(D),termDomain::str(ParS),termDomain::str(TreeTs)])]),
	S=STk,
	D=DEk,
	A=ArgK,
	ParT=termDomain::fromTermStringIndirect(ParS),
	nl::conValL(ParT,"p3_dany","",Vals),
	dbBase::joinNL(Vals,SVals),
	SVals=SP,
	TreeT=termDomain::fromTermStringIndirect(TreeTs),
	Tree2=conversion::toTree(TreeT),
	sx::concat(["Inexact rule reasoning: ",DEn," in ",STn," for (",SP,")"],Title),
	p3Tree::dtTransTree(NL,Tree2,Tree),
	p3Tree::drwOpenTree(Title,45,Tree,vpiTree::tree_DirRight,_),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;	
    guix::guiRB_Get(thisWin,[idc_tree_short,idc_tree_long,idc_report],[1,2,3],N),
    N=3,
	guix::lbtGet(thisWin,idc_st,STn),
	guix::lbtGet(thisWin,idc_de,DEn),
	guix::lbtGet(thisWin,idc_par,SP),
	dbBase::stNL_KB(STn,STk),
	sx::sxUnpack(DEn,':',L),
	L=[Arg,DE],
	dbBase::kbID(Arg,ArgK,_,_),
	dbBase::kbID(DE,DEk,_,_),
	dbBase::chainSentences("r",LT),
	LT=cmp("r",[cmp("u",[termDomain::str(S),termDomain::atom(A),termDomain::atom(D),termDomain::str(ParS),termDomain::str(TreeTs)])]),
	S=STk,
	D=DEk,
	A=ArgK,
	ParT=termDomain::fromTermStringIndirect(ParS),
	nl::conValL(ParT,"p3_dany","",Vals),
	dbBase::joinNL(Vals,SVals),
	SVals=SP,
	TreeT=termDomain::fromTermStringIndirect(TreeTs),
	Tree2=conversion::toTree(TreeT),
	%sx::concat(["Inexact rule reasoning: ",DEn," in ",STn," for (",SP,")"],Title),
	irReport::reportReasoning(Tree2),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.
	
    % This code is maintained by the VDE do not update it manually, 11:11:54-15.4.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,558,299).
    menu : vpiDomains::menu = noMenu.
    title : string = "Inexact rule reasoning".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBoxButton,rct(125,59,455,388),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_par),
        _ = vpi::winCreateControl(wc_Text,rct(8,60,121,80),"Parameters",Win,[wsf_AlignLeft],idct_parameters),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(125,32,455,390),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_de),
        _ = vpi::winCreateControl(wc_Text,rct(9,34,122,54),"Data element type",Win,[wsf_AlignLeft],idct_data_element_type),
        _ = vpi::winCreateControl(wc_Text,rct(8,7,121,27),"Sentence type",Win,[wsf_AlignLeft],idct_sentence_type),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(125,4,455,387),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_st),
        _ = vpi::winCreateControl(wc_PushButton,rct(144,184,328,212),"&OK",Win,[wsf_Group,wsf_TabStop],idc_ok),
        _ = vpi::winCreateControl(wc_RadioButton,rct(16,104,240,124),"Reasoning tree (short format)",Win,[wsf_Auto,wsf_TabStop,wsf_Group],idc_tree_short),
        _ = vpi::winCreateControl(wc_RadioButton,rct(16,128,240,148),"Reasoning tree (long format)",Win,[wsf_Auto,wsf_TabStop],idc_tree_long),
        _ = vpi::winCreateControl(wc_RadioButton,rct(16,152,240,172),"Reasoning report",Win,[wsf_Auto,wsf_TabStop],idc_report),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_st, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlst(idc_st, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_de, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlde(idc_de, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_par, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlpar(idc_par, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement reasoning
