/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement license
    open core, vpiDomains, resourceIdentifiers
    constants
        className = "com/rudstrand/TaskWindow/license".
        classVersion = "1.0".
    clauses
        classInfo(className, classVersion).
    facts
        thisWin : vpiDomains::windowHandle := erroneous.
            
    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
  	P=globalVars::get_s("exe_path"),
  	sx::concat([P,"\\exe\\license.txt"],FF),
  	file::existfile(FF),
	SL=file::readString(FF,_),
	sx::sxUnpack(SL,'\n',L),
	guix::lbxPop(thisWin,idd_text,L),
	!
;
	vpi::winDestroy(thisWin),
	vpiCommonDialogs::note("Cannot find licensing information file!"),
	W=guix::getWinOfClas(1),
	_=vpi::winSendEvent(W,vpiDomains::e_CloseRequest),
	!;!.
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.
    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling() :-
            vpi::winDestroy(thisWin).
    predicates
        onControlcancel : vpiDomains::controlHandler.
    clauses
        onControlcancel(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
            vpi::winDestroy(thisWin),
            W=guix::getWinOfClas(1),
            _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest),
            !;!.
            
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
            vpi::winDestroy(thisWin).
    % This code is maintained by the VDE do not update it manually, 15:35:39-3.1.2005
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "License".
        rectangle : vpiDomains::rct = rct(50,40,436,264).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 8.
    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(36,202,185,220),"Yes I Accept the Licencing Agreement",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(196,202,345,220),"No I do not Accept the Licencing Agreement",u_DlgBase),idc_cancel,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_LBox,rct(5,3,382,193),"",u_DlgBase),idd_text,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight])
            ].
    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement license
