/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement login
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/Login/login".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
    thisWin : vpiDomains::windowHandle := erroneous.
    userName : string := "".
    resourceName : string := "".
    userChange : integer := 0.

clauses
    show(Parent,User,Res,UserChange):-
        userName:=User,
        resourceName:=Res,
        userChange:=UserChange,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    guix::txtSet(thisWin,idc_username,userName),
    guix::txtSet(thisWin,idc_resource,resourceName),
    userChange=-1,
    guix::ctlDisable(thisWin,[idc_username]),
    !
;
    !.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        guix::txtGet(thisWin,idc_username,User),
        guix::txtGet(thisWin,idc_password,Pass),
        globalVars::pushRetPars([User,Pass]),
        vpi::winDestroy(thisWin).

predicates
    onControlCancel : vpiDomains::controlHandler.
clauses
    onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        globalVars::pushRetPars([]),
        vpi::winDestroy(thisWin).

predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses
    onCloseRequest() = defaultHandling() :-
        globalVars::pushRetPars([]),
        vpi::winDestroy(thisWin).

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    dlgIF::hlpWeb("Documentation"),
    !.

% This code is maintained by the VDE do not update it manually, 09:56:29-31.5.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Login".
    rectangle : vpiDomains::rct = rct(50,40,210,114).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,58,52,70),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(56,58,104,70),"Cancel",u_DlgBase),idc_cancel,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(108,58,156,70),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(48,18,156,30),"",u_DlgBase),idc_username,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(48,36,156,48),"",u_DlgBase),idc_password,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Password]),
        ctl(wdef(wc_Edit,rct(4,2,156,14),"",u_DlgBase),idc_resource,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Text,rct(4,20,44,30),"Username",u_DlgBase),idct_username,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,38,44,48),"Password",u_DlgBase),idct_password,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement login
