/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement lookup
open core,vpiDomains,resourceIdentifiers,globalDomains

    constants
        className = "com/rudstrand/TaskWindow/lookup".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.

    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
        guix::setStyle(thisWin,[idc_rec,idct_record,idc_look_up],[]),
        guix::addWin(114,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.
        
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling() :-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !;!.

    predicates
        onControlLookUp : vpiDomains::controlHandler.
    clauses
        onControlLookUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        guix::txtGet(thisWin,idc_rec,SLoc),
        SLoc<>"",
        Loc=dbBase::dbRefR(SLoc),
	    W=guix::getWinOfClas(1),
	    RecordWindow=record::new(W),
	    Wr=RecordWindow:getWin(),
	    record::kbaWinDisplay(Wr,Loc),
	    !
;	
	    dlgIF::dlgNote(1,"Unable to display record"),
	    !.
       
    % This code is maintained by the VDE do not update it manually, 13:43:23-14.10.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,591,151).
    menu : vpiDomains::menu = noMenu.
    title : string = "Lookup".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_Edit,rct(120,4,486,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_rec),
        _ = vpi::winCreateControl(wc_Text,rct(8,8,112,28),"Record address",Win,[wsf_AlignLeft],idct_record),
        _ = vpi::winCreateControl(wc_PushButton,rct(96,36,404,65),"Look Up",Win,[wsf_Group,wsf_TabStop],idc_look_up),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlLookUp(idc_look_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement lookup
