/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement outputPreferences
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/outputPreferences".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.

class predicates            
outFormat : (integer,integer,integer) procedure (i,o,o) (o,i,i).

    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
  	Ato=globalVars::get_i("f_atom"),
  	guix::guiRB_SetN(thisWin,[idc_atmpost,idc_atmpre,idc_normal],[1,2,3],Ato),
  	Deeq=globalVars::get_i("f_deeq"),
	guix::guiCB_Set(thisWin,idc_useeq,Deeq),
  	Solid=globalVars::get_i("solidcol"),
	guix::guiCB_Set(thisWin,idc_solid,Solid),
  	Pran=globalVars::get_i("pran"),
	guix::guiCB_Set(thisWin,idc_include_anno,Pran),
  	Trcm=globalVars::get_i("f_trcm"),
	guix::guiCB_Set(thisWin,idc_compress,Trcm),
    Opt=globalVars::get_i("f_outq"),
    outFormat(Opt,OptA,OneF),
  	guix::guiRB_SetN(thisWin,[idc_none,idc_nl,idc_nl_conversational,idc_table_w_header,idc_table_wout_header,
  	                 idc_spreadsheet_export_wheaders,idc_spreadsheet_export_wout_headers,
  	                 idc_table_window,idc_pr,idc_xmlnl,idc_xmlpr],[0,1,2,3,4,5,6,8,9,10,11],OptA),
	guix::guiCB_Set(thisWin,idc_all_out,OneF),
	Delim=globalVars::get_s("delim"),
	guix::txtSet(thisWin,idc_delim,Delim),
  	LF=globalVars::get_i("f_wrap"),
	guix::guiCB_Set(thisWin,idc_linewrapping,LF),
	MaxRow=globalVars::get_i("maxrow"),
	guix::txtSetI(thisWin,idc_maxrow,MaxRow),
	Col1=globalVars::get_i("col_shead"),
	Col2=globalVars::get_i("col_str"),
	Col3=globalVars::get_i("col_int"),
	Col4=globalVars::get_i("col_fix"),
	Col5=globalVars::get_i("col_atom"),
	Dx=globalVars::get_i("deltax"),
	Dy=globalVars::get_i("deltay"),
	guix::txtSetI(thisWin,idc_shead,Col1),
	guix::txtSetI(thisWin,idc_str,Col2),
	guix::txtSetI(thisWin,idc_int,Col3),
	guix::txtSetI(thisWin,idc_fix,Col4),
	guix::txtSetI(thisWin,idc_atom,Col5),
	guix::txtSetI(thisWin,idc_dx,Dx),
	guix::txtSetI(thisWin,idc_dy,Dy),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

/* ok */

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::txtGetI(thisWin,idc_maxrow,MaxRow),
    MaxRow<10,
    dlgIF::dlgNote(1,"Min. value for max. visible rows is 10!"),
    !
;        
  	guix::guiRB_Get(thisWin,[idc_none,idc_nl,idc_nl_conversational,idc_table_w_header,idc_table_wout_header,
  	                 idc_spreadsheet_export_wheaders,idc_spreadsheet_export_wout_headers,
  	                 idc_table_window,idc_pr,idc_xmlnl,idc_xmlpr],[0,1,2,3,4,5,6,8,9,10,11],N2),
	guix::guiCB_Get(thisWin,idc_include_anno,N51),
  	globalVars::set_i("pran",N51),
	guix::guiCB_Get(thisWin,idc_compress,N52),
  	globalVars::set_i("f_trcm",N52),
	guix::guiCB_Get(thisWin,idc_useeq,N18),
  	globalVars::set_i("f_deeq",N18),
	guix::guiCB_Get(thisWin,idc_all_out,N17),
  	Opt=N17*(-1)*N2,
  	globalVars::set_i("f_outq",Opt),
 	guix::guiRB_Get(thisWin,[idc_atmpost,idc_atmpre,idc_normal],[1,2,3],N21),
  	globalVars::set_i("f_atom",N21),
  	guix::txtGet(thisWin,idc_delim,Delim),
  	globalVars::set_s("delim",Delim),
	guix::guiCB_Get(thisWin,idc_linewrapping,LF),
  	globalVars::set_i("f_wrap",LF),
	guix::guiCB_Get(thisWin,idc_solid,Solid),
  	globalVars::set_i("solidcol",Solid),
    guix::txtGetI(thisWin,idc_maxrow,MaxRow),
    globalVars::set_i("maxrow",MaxRow),
	guix::txtGetI(thisWin,idc_shead,Col1),
	guix::txtGetI(thisWin,idc_str,Col2),
	guix::txtGetI(thisWin,idc_int,Col3),
	guix::txtGetI(thisWin,idc_fix,Col4),
	guix::txtGetI(thisWin,idc_atom,Col5),
	guix::txtGetI(thisWin,idc_dx,Dx),
	guix::txtGetI(thisWin,idc_dy,Dy),
	globalVars::set_i("col_shead",Col1),
	globalVars::set_i("col_str",Col2),
	globalVars::set_i("col_int",Col3),
	globalVars::set_i("col_fix",Col4),
	globalVars::set_i("col_atom",Col5),
	globalVars::set_i("deltax",Dx),
	globalVars::set_i("deltay",Dy),
	guix::setPixelAdjust(Dx,Dy),
	vpi::winDestroy(thisWin),
	!;!.

/* help */

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        dlgIF::hlpWeb("w_outpref"),
        !;!.

    % This code is maintained by the VDE do not update it manually, 09:53:37-9.9.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Output Format Preferences".
    rectangle : vpiDomains::rct = rct(50,40,480,230).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(136,170,208,186),"OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(240,170,312,186),"Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,12,128,20),"None",u_DlgBase),idc_none,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(4,22,128,30),"NL",u_DlgBase),idc_nl,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,32,128,40),"NL (conversational)",u_DlgBase),idc_nl_conversational,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,42,128,52),"Tabular text (with header)",u_DlgBase),idc_table_w_header,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,54,128,64),"Tabular text (without header)",u_DlgBase),idc_table_wout_header,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,66,128,74),"Delimited (with header)",u_DlgBase),idc_spreadsheet_export_wheaders,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,78,128,86),"Delimited (without header)",u_DlgBase),idc_spreadsheet_export_wout_headers,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,106,128,114),"Table window",u_DlgBase),idc_table_window,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,134,128,142),"PR",u_DlgBase),idc_pr,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,144,128,154),"XML/NL",u_DlgBase),idc_xmlnl,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,156,128,166),"XML/PR",u_DlgBase),idc_xmlpr,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(48,90,62,102),"",u_DlgBase),idc_delim,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_CheckBox,rct(132,42,256,52),"All output to one file",u_DlgBase),idc_all_out,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(132,2,266,12),"Use '=' between DEs and values",u_DlgBase),idc_useeq,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(132,26,170,36),"Prefixed",u_DlgBase),idc_atmpre,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(172,26,206,36),"Normal",u_DlgBase),idc_normal,[wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_RadioButton,rct(208,26,248,36),"Postfixed",u_DlgBase),idc_atmpost,[wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(132,56,256,66),"Compress trees",u_DlgBase),idc_compress,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(132,70,256,80),"Include annotations in print-outs",u_DlgBase),idc_include_anno,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(132,84,256,94),"Line-wrapping in text editor",u_DlgBase),idc_linewrapping,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(96,118,128,130),"",u_DlgBase),idc_maxrow,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_CheckBox,rct(132,110,256,120),"Solid colors in graphs",u_DlgBase),idc_solid,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(356,2,416,14),"",u_DlgBase),idc_shead,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(356,16,416,28),"",u_DlgBase),idc_str,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(356,30,416,42),"",u_DlgBase),idc_int,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(356,44,416,56),"",u_DlgBase),idc_fix,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(356,58,416,70),"",u_DlgBase),idc_atom,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(336,86,374,94),"",u_DlgBase),idc_dx,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(336,98,374,106),"",u_DlgBase),idc_dy,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Text,rct(4,2,130,10),"Output Format",u_DlgBase),idct_output_format,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(12,90,42,100),"Delimiter",u_DlgBase),idct_delimiter,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(132,16,266,24),"Atomic entity format",u_DlgBase),idct_atomic_entity_format,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(12,118,92,128),"Max. no  of visible rows",u_DlgBase),idct_max_no_of_visible_rows,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,4,350,14),"Table sub-header color",u_DlgBase),idct_table_subheader_color,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,18,350,28),"Default cell color",u_DlgBase),idct_default_cell_color,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,32,350,42),"Integer cell color",u_DlgBase),idct_integer_cell_color,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,46,350,56),"Number cell color",u_DlgBase),idct_number_cell_color,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,60,350,70),"Identifier cell color",u_DlgBase),idct_identifier_cell_color,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,86,332,94),"Pixel x-adjuster",u_DlgBase),idct_pixel_xadjuster,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(276,98,332,106),"Pixel y-adjuster",u_DlgBase),idct_pixel_yadjuster,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(376,86,396,94),"%",u_DlgBase),idct_p1,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(376,98,396,106),"%",u_DlgBase),idct_p2,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code

outFormat(Opt,OptA,OneF) :-
    bound(Opt),
    Opt<0,
    OptA=-Opt,
    OneF=1,
    !
;
    bound(Opt),
    OptA=Opt,
    OneF=-1,
    !
;
    bound(OptA), bound(OneF),
    Opt=OptA*(-1)*OneF,
    !.
    
end implement outputPreferences
