/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement processingPreferences
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/ProcessingPreferences/processingPreferences".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.

    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
  	Dup=globalVars::get_i("dup_chk"),
	guix::guiCB_Set(thisWin,idc_duplicates,Dup),
  	Chk=dep::getIntegrityCheck(),
	guix::guiCB_Set(thisWin,idc_integrity_violations,Chk),
  	Oth=globalVars::get_i("oth_chk"),
	guix::guiCB_Set(thisWin,idc_check_other,Oth),
  	Prefs=globalVars::get_i("prefsave"),
	guix::guiCB_Set(thisWin,idc_save_preferences,Prefs),
   	Expl=globalVars::get_i("explain"),
	guix::guiCB_Set(thisWin,idc_explain,Expl),
 	CRLog=globalVars::get_i("crlog"),
	guix::guiCB_Set(thisWin,idc_cr_log,CRLog),
 	CRDet=globalVars::get_i("crdet"),
	guix::guiCB_Set(thisWin,idc_cr_det,CRDet),
  	Idfpop=globalVars::get_i("idfpop"),
	guix::guiCB_Set(thisWin,idc_populate_rule,Idfpop),
  	Backup=globalVars::get_i("backup"),
	guix::guiCB_Set(thisWin,idc_kb_backup,Backup),
  	U3pr=globalVars::get_i("uc_3pr"),
	guix::guiCB_Set(thisWin,idc_3pr,U3pr),
  	U3nl=globalVars::get_i("uc_3nl"),
	guix::guiCB_Set(thisWin,idc_3nl,U3nl),
  	U3dl=globalVars::get_i("uc_3dl"),
	guix::guiCB_Set(thisWin,idc_3dl,U3dl),
  	Uxml=globalVars::get_i("uc_xml"),
	guix::guiCB_Set(thisWin,idc_xml,Uxml),
	%
	P3des=globalVars::get_i("p3des"),
	guix::guiCB_Set(thisWin,idc_p3des,P3des),
	RulSta=globalVars::get_i("rulsta"),
  	guix::guiRB_SetN(thisWin,[idc_save_inactive,idc_save_active],[-1,1],RulSta),
	Ram=globalVars::get_i("sdbram"),
  	guix::guiRB_SetN(thisWin,[idc_sdb_disk,idc_sdb_dyn,idc_sdb_ram],[0,1,2],Ram),
	Hour=globalVars::get_i("tzonh"),
	guix::txtSetI(thisWin,idc_hours,Hour),
	Min=globalVars::get_i("tzonm"),
	guix::txtSetI(thisWin,idc_min,Min),
  	Date=globalVars::get_i("f_date"),
  	guix::guiRB_SetN(thisWin,[idc_internal,idc_external,idc_yyyymmdd],[0,1,2],Date),
  	Daty=globalVars::get_i("f_daty"),
  	guix::guiRB_SetN(thisWin,[idc_yy,idc_yyyy],[0,1],Daty),
  	Datm=globalVars::get_i("f_datm"),
  	guix::guiRB_SetN(thisWin,[idc_mm,idc_mmm],[0,1],Datm),
  	Sep=globalVars::get_s("f_dats"),
  	guix::txtSet(thisWin,idc_sep,Sep),
	Y2K=globalVars::get_i("f_yyyy"),
	guix::txtSetI(thisWin,idc_y2k,Y2K),
	Rescan=globalVars::get_i("re_scan"),
	guix::txtSetI(thisWin,idc_rescan,Rescan),
	%
  	guix::lbxPop(thisWin,idc_level,["0","1","2","3","4","5"]),
  	L=tt::getLevel(),
  	L1=set::max([L,1]),
  	L2=set::min([L1,5]),
	S=toString(L2),
	guix::lbtSel(thisWin,idc_level,S),
  	Cls=tt::getClose(),
	guix::guiCB_Set(thisWin,idc_close_file,Cls),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

/* ok */

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_Get(thisWin,[idc_save_inactive,idc_save_active],[-1,1],RulSta),
  	globalVars::set_i("rulsta",RulSta),
  	guix::guiRB_Get(thisWin,[idc_internal,idc_external,idc_yyyymmdd],[0,1,2],N1),
  	globalVars::set_i("f_date",N1),
  	guix::guiRB_Get(thisWin,[idc_yy,idc_yyyy],[0,1],Daty),
  	globalVars::set_i("f_daty",Daty),
  	guix::guiRB_Get(thisWin,[idc_mm,idc_mmm],[0,1],Datm),
  	globalVars::set_i("f_datm",Datm),
  	guix::txtGet(thisWin,idc_sep,Sep),
  	globalVars::set_s("f_dats",Sep),
  	guix::txtGetI(thisWin,idc_y2k,Y2K),
	globalVars::set_i("f_yyyy",Y2K),
	guix::txtGetI(thisWin,idc_rescan,Resc),
	globalVars::set_i("re_scan",Resc),
	%
	guix::txtGetI(thisWin,idc_hours,Hour),
	globalVars::set_i("tzonh",Hour),
	guix::txtGetI(thisWin,idc_min,Min),
	globalVars::set_i("tzonm",Min),
	guix::guiCB_Get(thisWin,idc_3pr,U3pr),
  	globalVars::set_i("uc_3pr",U3pr),
	guix::guiCB_Get(thisWin,idc_3nl,U3nl),
  	globalVars::set_i("uc_3nl",U3nl),
	guix::guiCB_Get(thisWin,idc_3dl,U3dl),
  	globalVars::set_i("uc_3dl",U3dl),
	guix::guiCB_Get(thisWin,idc_xml,Uxml),
  	globalVars::set_i("uc_xml",Uxml),
	guix::guiCB_Get(thisWin,idc_save_preferences,Prefs),
  	globalVars::set_i("prefsave",Prefs),
	guix::guiCB_Get(thisWin,idc_explain,Expl),
  	globalVars::set_i("explain",Expl),
	guix::guiCB_Get(thisWin,idc_populate_rule,Idfpop),
  	globalVars::set_i("idfpop",Idfpop),
	guix::guiCB_Get(thisWin,idc_cr_log,CRLog),
  	globalVars::set_i("crlog",CRLog),
	guix::guiCB_Get(thisWin,idc_cr_det,CRDet),
  	globalVars::set_i("crdet",CRDet),
	guix::guiCB_Get(thisWin,idc_integrity_violations,Chk),
  	dep::setIntegrityCheck(Chk),
	guix::guiCB_Get(thisWin,idc_duplicates,Dup),
  	globalVars::set_i("dup_chk",Dup),
	guix::guiCB_Get(thisWin,idc_check_other,Oth),
  	globalVars::set_i("oth_chk",Oth),
	guix::guiCB_Get(thisWin,idc_p3des,P3des),
  	globalVars::set_i("p3des",P3des),
	guix::guiCB_Get(thisWin,idc_kb_backup,Backup),
  	globalVars::set_i("backup",Backup),
  	guix::guiRB_Get(thisWin,[idc_sdb_disk,idc_sdb_dyn,idc_sdb_ram],[0,1,2],Ram),
	globalVars::set_i("sdbram",Ram),
	guix::lbtGet(thisWin,idc_level,S),
	L=sx::toInt(S),
   	tt::setLevel(L),
	guix::guiCB_Get(thisWin,idc_close_file,Clos),
  	tt::setClose(Clos),
  	vpi::winDestroy(thisWin),
  	!;!.

/* help */

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        dlgIF::hlpWeb("w_procopt"),
        !;!.

    % This code is maintained by the VDE do not update it manually, 17:18:58-25.1.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Processing Preferences".
    rectangle : vpiDomains::rct = rct(50,40,426,311).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(68,252,139,269),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(168,252,239,269),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,2,146,12),"Check update/delete integrity violations ",u_DlgBase),idc_integrity_violations,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(4,15,146,25),"Check for duplicate sentences",u_DlgBase),idc_duplicates,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(4,27,146,37),"Check for other errors",u_DlgBase),idc_check_other,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_RadioButton,rct(4,110,92,120),"Save as Inactive",u_DlgBase),idc_save_inactive,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(4,122,92,132),"Save as Active",u_DlgBase),idc_save_active,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(208,154,256,166),"",u_DlgBase),idc_hours,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(208,170,256,182),"",u_DlgBase),idc_min,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_CheckBox,rct(4,138,132,148),"Store inexact rule reasoning trees",u_DlgBase),idc_cr_log,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,220,324,230),"Populate rule editor identifier boxes only with true identifiers (else with all)",u_DlgBase),idc_populate_rule,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_Edit,rct(220,192,268,204),"",u_DlgBase),idc_rescan,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_CheckBox,rct(4,208,124,218),"Save preference settings at exit",u_DlgBase),idc_save_preferences,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(128,208,248,218),"Show Usage Guide",u_DlgBase),idc_explain,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_RadioButton,rct(156,16,229,26),"in RAM",u_DlgBase),idc_sdb_ram,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(156,28,229,38),"dynamic RAM/disk",u_DlgBase),idc_sdb_dyn,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(156,40,229,50),"on disk",u_DlgBase),idc_sdb_disk,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(236,16,309,26),"always in RAM",u_DlgBase),idc_main_ram,[wsf_Auto,wsf_TabStop,wsf_Group,wsf_Disabled,wsf_Invisible]),
        ctl(wdef(wc_RadioButton,rct(236,28,309,38),"dynamic RAM/disk",u_DlgBase),idc_main_dyn,[wsf_Auto,wsf_TabStop,wsf_Disabled,wsf_Invisible]),
        ctl(wdef(wc_RadioButton,rct(236,40,309,50),"always on disk",u_DlgBase),idc_main_disk,[wsf_Auto,wsf_TabStop,wsf_Disabled,wsf_Invisible]),
        ctl(wdef(wc_RadioButton,rct(156,68,204,78),"External",u_DlgBase),idc_external,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(208,68,262,78),"YYYYMMDD",u_DlgBase),idc_yyyymmdd,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(264,68,308,78),"Internal",u_DlgBase),idc_internal,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(156,96,189,106),"YYYY",u_DlgBase),idc_yyyy,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(192,96,215,106),"YY",u_DlgBase),idc_yy,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(255,96,276,108),"",u_DlgBase),idc_y2k,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_RadioButton,rct(157,112,189,122),"MMM",u_DlgBase),idc_mmm,[wsf_Auto,wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(192,112,215,122),"mm",u_DlgBase),idc_mm,[wsf_Auto,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(195,124,209,136),"",u_DlgBase),idc_sep,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_CheckBox,rct(4,194,119,203),"Close trace file after each write",u_DlgBase),idc_close_file,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_LBoxButton,rct(48,178,74,267),"",u_DlgBase),idc_level,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_CheckBox,rct(252,208,372,218),"Automatic KB backup",u_DlgBase),idc_kb_backup,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(316,16,364,26),"3nl-files",u_DlgBase),idc_3nl,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(316,28,364,38),"3pr-files",u_DlgBase),idc_3pr,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(316,40,364,50),"xml-files",u_DlgBase),idc_xml,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(316,52,364,62),"3dl-files",u_DlgBase),idc_3dl,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,232,324,242),"Populate sentence model DE listbox with Pro/3 standard DEs (else only DEs in current context)",u_DlgBase),idc_p3des,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,150,132,160),"Store inexact rule reasoning details",u_DlgBase),idc_cr_det,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Text,rct(156,82,276,92),"if external:",u_DlgBase),idct_if_external,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(157,126,191,136),"Separator",u_DlgBase),idct_separator,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(232,97,250,107),"Y2K",u_DlgBase),idct_y2k,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(156,2,229,12),"Work DB",u_DlgBase),idct_work_db,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(236,2,309,12),"Main DB",u_DlgBase),idct_main_db,[wsf_AlignCenter,wsf_Invisible]),
        ctl(wdef(wc_Text,rct(156,194,215,204),"Re-scan threshold",u_DlgBase),idct_rescan_threshold,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(156,154,204,164),"Hours",u_DlgBase),idct_hours,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(156,170,204,180),"Minutes",u_DlgBase),idct_minutes,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,98,92,108),"Sentence rules:",u_DlgBase),idct_sentence_rules,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(156,140,256,150),"Time zone",u_DlgBase),idct_time_zone,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(156,56,308,66),"Input/output format for internal date domain",u_DlgBase),idct_internal_date_format,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(4,178,46,188),"Trace level",u_DlgBase),idct_trace_level,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(422,202,441,211),"secs.",u_DlgBase),idct_mm,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(316,2,364,12),"UNICODE",u_DlgBase),idct_unicode,[wsf_AlignCenter])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement processingPreferences
