/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement record
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/record".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.

class predicates
kbaEnable : (vpiDomains::windowHandle).
kbaUpdateStructure : (vpiDomains::windowHandle) determ.
kbaUpdateNL : (vpiDomains::windowHandle,integer) procedure.

clauses
new(Parent) :- _=vpi::winCreate(windowType, rectangle, title, menu, Parent,windowFlags, eventHandler, 0).
getWin()=W:-W=thisWin,!.

predicates
eventHandler : vpiDomains::ehandler.

clauses
eventHandler(Win, Event) = Result :-
     Result = generatedEventHandler(Win, Event),
     !.
eventHandler(Win, e_Menu(Id, CAS)) = Result :-
     Parent = vpi::winGetParent(Win),
     Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* -> nl */

    predicates
        onControlnl : vpiDomains::controlHandler.
    clauses
        onControlnl(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::guiRB_SetN(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],1),
	guix::txtGetI(thisWin,idc_rectype,Typ),
	dbBase::recordType(Typ,TypM,_,_),
	kbaUpdateNL(thisWin,TypM),
	kbaUpdateStructure(thisWin),
	!;!.

/* -> xml/nl */

    predicates
        onControlXmlNl : vpiDomains::controlHandler.
    clauses
        onControlXmlNl(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::guiRB_SetN(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],2),
	guix::txtGetI(thisWin,idc_rectype,Typ),
	dbBase::recordType(Typ,TypM,_,_),
	kbaUpdateNL(thisWin,TypM),
	kbaUpdateStructure(thisWin),
	!;!.

/* -> xml/pr */

    predicates
        onControlXmlPr : vpiDomains::controlHandler.
    clauses
        onControlXmlPr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::guiRB_SetN(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],3),
	guix::txtGetI(thisWin,idc_rectype,Typ),
	dbBase::recordType(Typ,TypM,_,_),
	kbaUpdateNL(thisWin,TypM),
	kbaUpdateStructure(thisWin),
	!;!.

/* -> xml/pr */

    predicates
    onControlidc_termstring : vpiDomains::controlHandler.
clauses
    onControlidc_termstring(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::guiRB_SetN(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],4),
	guix::txtGetI(thisWin,idc_rectype,Typ),
	dbBase::recordType(Typ,TypM,_,_),
	kbaUpdateNL(thisWin,TypM),
	kbaUpdateStructure(thisWin),
	!;!.

/* -> if */

    predicates
        onControlToIf : vpiDomains::controlHandler.
    clauses

        onControlToIf(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	guix::guiRB_Get(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	Form=4,
	guix::txtGet(thisWin,kbt_7,NL),
	Term=sqlBase::sqlToTerm(NL),
	Term=cmp(_,[Ls,Rs]),
	nl::cprTerm(Ls,Lp),
	nl::cprTerm(Rs,Rp),
	guix::txtSet(thisWin,kbt_6,Lp),
	guix::txtSet(thisWin,kbt_14,Rp),
	kbaUpdateStructure(thisWin),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!
;	
	guix::guiRB_Get(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	Form=1,
	guix::txtGetI(thisWin,idc_rectype,RT),
	dbBase::recordType(RT,BRT,_,_),
	set::member(BRT,[1,2]),
	guix::txtGet(thisWin,kbt_7,NL),
	transnl::parTranslate(NL,Term,_),
	nl::cprTerm(Term,Lp),
	guix::txtSet(thisWin,kbt_6,Lp),
	guix::txtSet(thisWin,kbt_14,"true"),
	kbaUpdateStructure(thisWin),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!
;
	guix::guiRB_Get(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	Form=1,
	guix::txtGetI(thisWin,idc_rectype,RT),
	dbBase::recordType(RT,BRT,_,_),
	set::member(BRT,[3,4,5]),
	guix::txtGet(thisWin,kbt_7,NL),
	transnl::parTranslate(NL,Term,_),
	Term=cmp(_,[Ls,Rs]),
	nl::cprTerm(Ls,Lp),
	nl::cprTerm(Rs,Rp),
	guix::txtSet(thisWin,kbt_6,Lp),
	guix::txtSet(thisWin,kbt_14,Rp),
	kbaUpdateStructure(thisWin),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!
;
	guix::guiRB_Get(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	set::member(Form,[2,3]),
	guix::txtGet(thisWin,kbt_7,X),
	XML=xmlTree::newTree(X),
	Tree=XML:get(),
	Tree=cmp("sentence",_),
	xmlP3::xmlToSentence(Tree,Term,Realm,No),
	guix::txtSet(thisWin,kbt_1,Realm),
	guix::txtSetI(thisWin,kbt_2,No),
	nl::cprTerm(Term,S),
	guix::txtSet(thisWin,kbt_6,S),
	guix::txtSet(thisWin,kbt_14,"true"),
	kbaUpdateStructure(thisWin),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
	guix::guiRB_Get(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	set::member(Form,[2,3]),
	guix::txtGet(thisWin,kbt_7,X),
	XML=xmlTree::newTree(X),
	Tree=XML:get(),
	Tree=cmp("sentenceRule",[cmp("Attributes",Atts),SR]),
	xmlP3::xmlToRule(SR,RuleTree),
	transrt::rlgPR(RuleTree,PRs),
	PRs=[PR],
	transpr::proPR_Term(PR,Term),
	Term=cmp(_,[Ls,Rs]),
	nl::cprTerm(Ls,Lp),
	nl::cprTerm(Rs,Rp),
	guix::txtSet(thisWin,kbt_6,Lp),
	guix::txtSet(thisWin,kbt_14,Rp),
	kbaUpdateStructure(thisWin),
	xmlGeneric::xmlGetAttr("realm",Atts,Realm),
	xmlGeneric::xmlGetAttr("realmNo",Atts,RealmNo),
	xmlGeneric::xmlGetAttr("realmSubNo",Atts,RealmSubNo),
	guix::txtSet(thisWin,kbt_1,Realm),
	guix::txtSet(thisWin,kbt_2,RealmNo),
	guix::txtSet(thisWin,kbt_16,RealmSubNo),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
	guix::guiRB_Get(thisWin,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Frm),
	set::member(Frm,[2,3]),
	guix::txtGet(thisWin,kbt_7,X),
	XML=xmlTree::newTree(X),
	Tree=XML:get(),
	Tree=cmp("inexactRule",[cmp("Attributes",Atts),CR]),
	xmlGeneric::xmlGetAttr("format",Atts,Form),
	xmlGeneric::xmlGetAttr("realm",Atts,Realm),
	guix::txtSet(thisWin,kbt_1,Realm),
	xmlP3::xmlToCR_Rule(Form,CR,Term,_),
	nl::cprTerm(Term,Lp),
	nl::cprTerm(nill(),Rp),
	guix::txtSet(thisWin,kbt_6,Lp),
	guix::txtSet(thisWin,kbt_14,Rp),
	kbaUpdateStructure(thisWin),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
	vpi::cursorSet(thisWin,cursor_Arrow),
	dlgIF::dlgNote(2,"Record text is invalid!"),
	!;!.

/* update */

    predicates
        onControlKbt13 : vpiDomains::controlHandler.
    clauses

        onControlKbt13(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,kbt_15,SLoc),
	Loc=dbBase::dbRefR(SLoc),
	guix::txtGet(thisWin,kbt_1,Dlg),
	guix::txtGetI(thisWin,kbt_2,No),
	guix::txtGetI(thisWin,kbt_16,SubNo),
	guix::txtGet(thisWin,kbt_6,LTerms),
	guix::txtGet(thisWin,kbt_14,RTerms),
	PR=string::concat(LTerms,":-",RTerms),
	transpr::proPR_Term(PR,Term),
	Term=cmp(_,[LTrm,RTrm]),
	guix::txtGetI(thisWin,idc_rectype,RT),
	dbBase::recordDelete(Loc),
	dbBase::recordInsert(RT,Dlg,No,SubNo,LTrm,RTrm,NewLoc),
	kbaWinDisplay(thisWin,NewLoc),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	dlgIF::dlgNote(0,"Record updated!"),
	!
;
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	dlgIF::dlgNote(3,"Record NOT updated!"),
	!.	

/* delete */

    predicates
        onControlKbt12 : vpiDomains::controlHandler.
    clauses
        onControlKbt12(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,kbt_15,SLoc),
	Loc=dbBase::dbRefR(SLoc),
	dbBase::recordDelete(Loc),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
    guix::dropWin(thisWin),
    vpi::winDestroy(thisWin),
	dlgIF::dlgNote(0,"Record deleted!"),
	!
;
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	dlgIF::dlgNote(3,"Record NOT deleted!"),
	!.	

/* view as text */

    predicates
        onControlKbt21 : vpiDomains::controlHandler.
    clauses

        onControlKbt21(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::txtGet(thisWin,kbt_6,S2),
  	guix::txtGet(thisWin,kbt_14,S3),
  	guix::txtGet(thisWin,kbt_7,S4),
  	guix::lbxGetAll(thisWin,idc_out,L),
  	sx::sxlJoin(L,"\n",S5),
	sx::concat([S2,"\n:-\n",S3,"\n\n",S4,"\n\n",S5],S),
	Path=globalVars::get_s("std_path"),
	fioExt::filGenName(2,Path,"Record","3rp",OutFile),
	file::writeString(OutFile,S),	
	editorWindow::openFiles([OutFile]),
	!;!.

/* view in window */

    predicates
        onControlRuleEditor : vpiDomains::controlHandler.
    clauses
        onControlRuleEditor(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::txtGetI(thisWin,idc_rectype,RT),
  	dbBase::recordType(RT,BRT,_,_),
  	BRT<=2,
	guix::txtGet(thisWin,kbt_15,SLoc),
	Loc=dbBase::dbRefR(SLoc),
    sentence::displayRef(Loc),
	!
;
  	guix::txtGetI(thisWin,idc_rectype,RT),
  	dbBase::recordType(RT,BRT,_,_),
  	set::member(BRT,[3,5]),
	guix::txtGet(thisWin,kbt_15,SLoc),
	Loc=dbBase::dbRefR(SLoc),
    ruleeditor::rtrTreeDisplayRec(Loc),
	!
;
  	guix::txtGetI(thisWin,idc_rectype,RT),
  	dbBase::recordType(RT,BRT,_,_),
  	BRT=6,
	guix::txtGet(thisWin,kbt_15,SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,LS,_),
	LS=cmp(_,[atom(Rk)|_]),
	dbBase::nlSingF(Rk,R),
	dbBase::irType(Rk,_,CTyp),
	inexgui::wcrUpdateRule(CTyp,R,Rk,Realm),
	!
;
	dlgIF::dlgNote(1,"Unable to display this record!"),
	!.

/* create/destroy */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
  	guix::setStyle(thisWin,[idct_dialog,idct_term_class,idct_date,idct_address,idc_inactive,
  	                   idct_kb_term_1,idc_suspended,idc_out,
  	                   idc_rule_editor,idct_sentence_no,idc_rectype,idc_stype,
  	                   kbt_12,kbt_13,kbt_21,idct_rectype,kbt_1,kbt_2,kbt_3,kbt_4,kbt_6,kbt_7,idc_nl,idc_xml_nl,
  	                   idc_xml_pr,idc_termstring,idc_to_if,kbt_14,kbt_15,kbt_16],[]),
    guix::addWin(31,thisWin),
	!.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling() :-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
% This code is maintained by the VDE do not update it manually, 14:16:42-1.11.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_SizeBorder,wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(10,35,1007,599).
    menu : vpiDomains::menu = noMenu.
    title : string = "Record".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_Text,rct(5,4,376,16),"Realm",Win,[wsf_AlignCenter],idct_dialog),
        _ = vpi::winCreateControl(wc_Text,rct(389,4,538,20),"Sentence/Sub No",Win,[wsf_AlignCenter],idct_sentence_no),
        _ = vpi::winCreateControl(wc_Text,rct(544,4,808,20),"Chain",Win,[wsf_AlignCenter],idct_term_class),
        _ = vpi::winCreateControl(wc_Text,rct(544,100,592,120),"Date",Win,[wsf_AlignCenter],idct_date),
        _ = vpi::winCreateControl(wc_Edit,rct(8,24,376,48),"",Win,[wsf_UpperCase,wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],kbt_1),
        _ = vpi::winCreateControl(wc_Edit,rct(392,24,472,48),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],kbt_2),
        _ = vpi::winCreateControl(wc_Edit,rct(544,24,808,48),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly],kbt_3),
        _ = vpi::winCreateControl(wc_Edit,rct(600,100,808,124),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_ReadOnly,wsf_AutoHScroll],kbt_4),
        _ = vpi::winCreateControl(wc_Edit,rct(8,56,533,168),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_MultiLine,wsf_AutoVScroll],kbt_6),
        _ = vpi::winCreateControl(wc_PushButton,rct(648,532,720,561),"Delete",Win,[wsf_Group,wsf_TabStop],kbt_12),
        _ = vpi::winCreateControl(wc_PushButton,rct(544,532,632,561),"Update",Win,[wsf_Group,wsf_TabStop],kbt_13),
        _ = vpi::winCreateControl(wc_Edit,rct(5,189,538,318),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_MultiLine,wsf_AutoVScroll,wsf_VScroll],kbt_14),
        _ = vpi::winCreateControl(wc_Text,rct(544,52,808,68),"KB Address",Win,[wsf_AlignCenter],idct_address),
        _ = vpi::winCreateControl(wc_Edit,rct(544,72,808,96),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly],kbt_15),
        _ = vpi::winCreateControl(wc_PushButton,rct(736,532,864,561),"View in text editor",Win,[wsf_Group,wsf_TabStop],kbt_21),
        _ = vpi::winCreateControl(wc_Edit,rct(480,24,536,48),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],kbt_16),
        _ = vpi::winCreateControl(wc_Text,rct(5,167,15,185),":-",Win,[wsf_AlignLeft],idct_kb_term_1),
        _ = vpi::winCreateControl(wc_CheckBox,rct(920,24,992,44),"Inactive",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_inactive),
        _ = vpi::winCreateControl(wc_CheckBox,rct(816,24,912,44),"Suspended",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_suspended),
        _ = vpi::winCreateControl(wc_PushButton,rct(872,532,992,561),"View",Win,[wsf_Group,wsf_TabStop],idc_rule_editor),
        _ = vpi::winCreateControl(wc_Edit,rct(920,48,992,72),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_rectype),
        _ = vpi::winCreateControl(wc_Edit,rct(4,353,537,557),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_MultiLine,wsf_AutoVScroll,wsf_VScroll],kbt_7),
        _ = vpi::winCreateControl(wc_LBox,rct(544,132,990,528),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_out),
        _ = vpi::winCreateControl(wc_RadioButton,rct(4,328,100,348),"NL",Win,[wsf_TabStop,wsf_Auto],idc_nl),
        _ = vpi::winCreateControl(wc_RadioButton,rct(104,328,200,348),"XML/NL",Win,[wsf_TabStop,wsf_Auto],idc_xml_nl),
        _ = vpi::winCreateControl(wc_RadioButton,rct(208,328,304,348),"XML/PR",Win,[wsf_TabStop,wsf_Auto],idc_xml_pr),
        _ = vpi::winCreateControl(wc_PushButton,rct(416,324,538,348),"Translate to IF",Win,[wsf_Group,wsf_TabStop],idc_to_if),
        _ = vpi::winCreateControl(wc_Text,rct(816,4,992,20),"",Win,[wsf_AlignCenter],idc_stype),
        _ = vpi::winCreateControl(wc_Text,rct(816,48,912,68),"Record type",Win,[wsf_AlignCenter],idct_rectype),
        _ = vpi::winCreateControl(wc_RadioButton,rct(312,328,408,348),"Term-string",Win,[wsf_Auto,wsf_TabStop],idc_termstring),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_nl, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnl(idc_nl, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_xml_nl, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlXmlNl(idc_xml_nl, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_xml_pr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlXmlPr(idc_xml_pr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_to_if, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlToIf(idc_to_if, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kbt_13, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKbt13(kbt_13, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kbt_12, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKbt12(kbt_12, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kbt_21, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKbt21(kbt_21, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_rule_editor, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRuleEditor(idc_rule_editor, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_termstring, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_termstring(idc_termstring, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
% --------------------------------------------------------------------------
% kbaWinDisplay
% --------------------------------------------------------------------------
class predicates
kbaTranslations : (vpiDomains::windowHandle,integer) determ.
clauses

kbaWinDisplay(W,Loc) :-
	dbBase::getRecord(Loc,RecType,_,_,_,DtS,Dlg,No,SubNo,_,LSide,RSide),
	LSide=cmp(Chain,_),
	dbBase::recordType(RecType,BRT,Inact,Susp),
	guix::txtSet(W,kbt_1,Dlg),
	guix::txtSetI(W,kbt_2,No),
	guix::txtSet(W,kbt_3,Chain),
	guix::txtSet(W,kbt_4,DtS),
	nl::cprTerm(LSide,LPR),
	guix::txtSet(W,kbt_6,LPR),
	nl::cprTerm(RSide,RPR),
	guix::txtSet(W,kbt_14,RPR),
	RefS=dbBase::dbRef(Loc),
	guix::txtSet(W,kbt_15,RefS),
	guix::txtSetI(W,kbt_16,SubNo),
	guix::txtSetI(W,idc_rectype,RecType),
    InactR=-Inact,
	guix::guiCB_Set(W,idc_inactive,InactR),
	guix::guiCB_Set(W,idc_suspended,Susp),
	kbaEnable(W),
	set::setGet(["DERIVED SENTENCE","SENTENCE","SENTENCE RULE","FUNCTION","DERIVED RULE","CERTAINTY RULE"],BRT,SType),
	guix::txtSet(W,idc_stype,SType),
	kbaUpdateStructure(W),
	kbaTranslations(W,BRT),
	kbaUpdateNL(W,BRT),
	!.
    
kbaTranslations(W,RecType) :-
	RecType<=2,
	guix::guiRB_SetN(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],1),
	guix::ctlEnable(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring]),
	!
;
	set::member(RecType,[3,5]),
	guix::guiRB_SetN(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],3),
	guix::ctlEnable(W,[idc_xml_pr,idc_termstring]),
	guix::ctlDisable(W,[idc_nl,idc_xml_nl]),
	!
;
	RecType=4,
	guix::guiRB_SetN(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],1),
	guix::ctlEnable(W,[idc_nl,idc_termstring]),
	guix::ctlDisable(W,[idc_xml_nl,idc_xml_pr]),
	!
;
	RecType=6,
	guix::guiRB_SetN(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],2),
	guix::ctlEnable(W,[idc_xml_nl,idc_xml_pr,idc_termstring]),
	guix::ctlDisable(W,[idc_nl]),
	!.
% --------------------------------------------------------------------------
% kbaEnable
% --------------------------------------------------------------------------
kbaEnable(W) :-
	guix::txtGetI(W,idc_rectype,R),
	dbBase::recordType(R,B,_,_),
	set::member(B,[3,5]),
	guix::ctlEnable(W,[idc_rule_editor,idc_inactive]),
	!
;	
	guix::txtGetI(W,idc_rectype,R),
	dbBase::recordType(R,B,_,_),
	set::member(B,[1,2,6]),
	guix::ctlEnable(W,[idc_rule_editor]),
	guix::ctlDisable(W,[idc_inactive]),
	!
;	
	guix::ctlDisable(W,[idc_rule_editor,idc_inactive]),
	!.
% --------------------------------------------------------------------------
% kbaUpdateNL
% --------------------------------------------------------------------------
% updates the NL/XML field from the IF field
%
kbaUpdateNL(W,RecType) :-
	guix::guiRB_Get(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	Form=4,
	guix::txtGet(W,kbt_6,LTerms),
	guix::txtGet(W,kbt_14,RTerms),
	sx::concat([LTerms,":-",RTerms],PR),
	transpr::proPR_Term(PR,Term),
	X=sqlBase::sqlToString(Term),
	guix::txtSet(W,kbt_7,X),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	set::member(RecType,[1,2,4]),
	guix::guiRB_Get(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	Form=1,
	% generate NL
	guix::txtGet(W,kbt_6,LTerms),
	guix::txtGet(W,kbt_14,RTerms),
	sx::concat([LTerms,":-",RTerms],PR),
	transpr::proPR_Term(PR,Term),
	nl::conRecord(RecType,Term,NL),
	guix::txtSet(W,kbt_7,NL),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	set::member(RecType,[1,2]),
	guix::guiRB_Get(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	Form>1,
	% generate XML
	F2=Form-1,
	set::setGet(["NL","PR"],F2,Frm),
	guix::txtGet(W,kbt_6,LT),
	transpr::proPR_Term(LT,Term),
	guix::txtGet(W,kbt_1,Realm),
	guix::txtGetI(W,kbt_2,No),
	xmlP3::xmlFromSentence(Frm,Realm,No,Term,X),
	guix::txtSet(W,kbt_7,X),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	set::member(RecType,[3,5]),
	guix::txtGet(W,kbt_1,Realm),
	guix::txtGet(W,kbt_2,No),
	guix::txtGet(W,kbt_16,SubNo),
	guix::txtGet(W,kbt_6,LTerms),
	guix::txtGet(W,kbt_14,RTerms),
	sx::concat([LTerms,":-",RTerms],PR),
	transpr::proPR_Term(PR,Term),
	guix::txtGetI(W,idc_rectype,RT),
	rt::rcnTree(RT,Term,Rule,_,_),
	Rule=cmp(Typ,_),
	rub::rubRuleType(Typ,Type,_),
	SType=toString(Type),
	xmlP3::xmlSentenceRule(SType,Realm,No,SubNo,Rule,X),
	guix::txtSet(W,kbt_7,X),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	vpi::cursorSetWait(),
	RecType=6,
	guix::txtGet(W,kbt_1,Realm),
	guix::guiRB_Get(W,[idc_nl,idc_xml_nl,idc_xml_pr,idc_termstring],[1,2,3,4],Form),
	F2=Form-1,
	set::setGet(["NL","PR"],F2,Frm),
	guix::txtGet(W,kbt_6,LTerms),
	guix::txtGet(W,kbt_14,RTerms),
	sx::concat([LTerms,":-",RTerms],PR),
	transpr::proPR_Term(PR,Term),
	Term=cmp(":-",[LT,nill]),
	xmlP3::xmlFromCR(Frm,Realm,LT,X),
	guix::txtSet(W,kbt_7,X),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	dlgIF::dlgNote(2,"Translation failed or record is blank"),
	!.	
% --------------------------------------------------------------------------
% kbaUpdateStructure
% --------------------------------------------------------------------------
% updates the structure field from the IF field
%
kbaUpdateStructure(W) :-
	guix::txtGet(W,kbt_6,LTerms),
	guix::txtGet(W,kbt_14,RTerms),
	sx::concat([LTerms,":-",RTerms],PR),
	transpr::proPR_Term(PR,Term),
	struc::treStructText("",Term,S),
	sx::sxUnpack(S,'\n',L),
	guix::lbxPop(W,idc_out,L),
	!.
end implement record
