/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement records
open core, vpiDomains,resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/records".
classVersion = "1.0".

facts
thisWin : vpiDomains::windowHandle := erroneous.

class predicates
recPack : (dbLoc,integer,string,string,integer,integer,sterm,sterm,string) determ (i,i,i,i,i,i,i,i,o).

predicates
eventHandler : vpiDomains::ehandler.
deleteRealm : (string) determ.
kbaDisplayFirst : (vpiDomains::windowHandle,string) determ.
kbaDisplayNext : (vpiDomains::windowHandle,vpiDomains::windowHandle,integer,string) determ.
kbaDisplayPrev : (vpiDomains::windowHandle,vpiDomains::windowHandle,integer,string) determ.

clauses
new(Parent):-
   _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

classInfo(className, classVersion).

eventHandler(Win, Event) = Result :-
      Result = generatedEventHandler(Win, Event),
      !.
eventHandler(Win, e_Menu(Id, CAS)) = Result :-
      Parent = vpi::winGetParent(Win),
      Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* realms / chains */

    predicates
        onControlKba1 : vpiDomains::controlHandler.
    clauses
        onControlKba1(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[kba_1,kba_2],[1,2],1),
	vpi::cursorSetWait(),
    List=pop::getRealms(),
	guix::lbxPop(thisWin,kba_realms,List),
	C6=vpi::winGetCtlHandle(thisWin,kba_6),
	vpi::lboxClear(C6),
	guix::ctlDisable(thisWin,[kba_12,kba_6,kba_8,kba_7,idc_up,idc_down]),  	                   
	guix::ctlEnable(thisWin,[kba_realms]),  	                   
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

    predicates
        onControlKba2 : vpiDomains::controlHandler.
    clauses
        onControlKba2(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[kba_1,kba_2],[1,2],2),
	vpi::cursorSetWait(),
    List=pop::getChainsNL_WithKB_File(),
	guix::lbxPop(thisWin,kba_realms,List),
	C6=vpi::winGetCtlHandle(thisWin,kba_6),
	vpi::lboxClear(C6),
	guix::ctlDisable(thisWin,[kba_12,kba_6,kba_8,kba_7,idc_up,idc_down]),  	                   
	guix::ctlEnable(thisWin,[kba_realms]),  	                   
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* selection of realm/chain */

    predicates
        onControlKbaRealms : vpiDomains::controlHandler.
    clauses
        onControlKbaRealms(_CtrlID, _CtrlType, _CtrlWin,CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged,
	vpi::cursorSetWait(),
	LB=vpi::winGetCtlHandle(thisWin,kba_6),
	guix::lbxGet(thisWin,kba_realms,Realm),
	kbaDisplayFirst(thisWin,Realm),
	guix::ctlDisable(thisWin,[kba_8,kba_7]),  	                   
	guix::ctlEnable(thisWin,[kba_12,kba_6]),
    vpi::lboxResume(LB),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* up/down */

    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	LB=vpi::winGetCtlHandle(thisWin,kba_6),
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=1,
	guix::lbxGet(thisWin,kba_realms,S),
	kbaDisplayPrev(thisWin,LB,N,S),
	guix::ctlDisable(thisWin,[kba_8,kba_7]),  
    vpi::lboxResume(LB),
    !
;		                   
	LB=vpi::winGetCtlHandle(thisWin,kba_6),
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=2,
	guix::lbxGet(thisWin,kba_realms,S),
	L=sx::unpack(S," "),
	L=[Chain|_],
	kbaDisplayPrev(thisWin,LB,N,Chain),
	guix::ctlDisable(thisWin,[kba_8,kba_7]),  
    vpi::lboxResume(LB),
	!;!.
	
    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	LB=vpi::winGetCtlHandle(thisWin,kba_6),
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=1,
	guix::lbxGet(thisWin,kba_realms,S),
	kbaDisplayNext(thisWin,LB,N,S),
    vpi::lboxResume(LB),
	!
;	
	LB=vpi::winGetCtlHandle(thisWin,kba_6),
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=2,
	guix::lbxGet(thisWin,kba_realms,S),
	L=sx::unpack(S," "),
	L=[Chain|_],
	kbaDisplayNext(thisWin,LB,N,Chain),
    vpi::lboxResume(LB),
	!;!.

/* delete realm/chain */

    predicates
        onControlKba12 : vpiDomains::controlHandler.
    clauses
        onControlKba12(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	% delete record group (realm)
	vpi::cursorSetWait(),
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=1,
	guix::lbxGet(thisWin,kba_realms,Realm2),
	deleteRealm(Realm2),
	Ctl6=vpi::winGetCtlHandle(thisWin,kba_6),
	vpi::lboxClear(Ctl6),
	guix::lbxDelS(thisWin,kba_realms,Realm2),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	sx::concat(["Deleted realm ",Realm2,"."],Mess),
	dlgIF::msgS(Mess),
	guix::ctlDisable(thisWin,[kba_8,kba_7]),  	                   
	!
;	
	% delete record group (chain)
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=2,
	guix::lbxGet(thisWin,kba_realms,Ch),
	sx::sxUnpack(Ch,' ',L),
	L=[Chain|_],
	dbBase::chainReadOnlyWarning(Chain),
	!
;
	% delete record group (chain)
	guix::guiRB_Get(thisWin,[kba_1,kba_2],[1,2],N), 
	N=2,
	guix::lbxGet(thisWin,kba_realms,Ch),
	sx::sxUnpack(Ch,' ',L),
	L=[Chain|_],
	dbBase::chainDelete(Chain),
	Ctl6=vpi::winGetCtlHandle(thisWin,kba_6),
	vpi::lboxClear(Ctl6),
	guix::lbxDelS(thisWin,kba_realms,Ch),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	sx::concat(["Deleted chain ",Ch,"."],Mess),
	dlgIF::msgS(Mess),
	guix::ctlDisable(thisWin,[kba_8,kba_7]),  	                   
	!
;
	dlgIF::dlgNote(1,"No realm/chain selected"),
	!.

/* selection of record */

    predicates
        onControlKba6 : vpiDomains::controlHandler.
    clauses
        onControlKba6(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=vpiDomains::selchanged,
    guix::ctlEnable(thisWin,[kba_7,kba_8]),
    CtrlInfo=vpiDomains::activated,
	guix::lbxGet(thisWin,kba_6,S),
	sx::sxGetInBrack(S,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
	W=guix::getWinOfClas(1),
	RecordWindow=record::new(W),
	Wr=RecordWindow:getWin(),
	record::kbaWinDisplay(Wr,Loc),
    !;!.

/* view record */

    predicates
        onControlKba7 : vpiDomains::controlHandler.
    clauses
        onControlKba7(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::lbxGet(thisWin,kba_6,S),
	sx::sxGetInBrack(S,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
	W=guix::getWinOfClas(1),
	RecordWindow=record::new(W),
	Wr=RecordWindow:getWin(),
	record::kbaWinDisplay(Wr,Loc),
	!
;	
	dlgIF::dlgNote(4,"Unable to display record"),
	!.

/* delete record */

    predicates
        onControlKba8 : vpiDomains::controlHandler.
    clauses
        onControlKba8(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	% delete record
	guix::lbxGet(thisWin,kba_6,S),
	sx::sxGetInBrack(S,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
	vpi::cursorSetWait(),
	dbBase::recordDelete(Loc), 
	Ctl=vpi::winGetCtlHandle(thisWin,kba_6),
	vpi::lboxSuspend(Ctl),
	guix::lbxDelS(thisWin,kba_6,S),
	vpi::lboxResume(Ctl),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	dlgIF::msgS("Deleted record!"),
	!
;
	dlgIF::dlgNote(0,"No records selected for deletion!"),
	!.

/* create/destroy */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[kba_1,kba_2,kba_realms,kba_6,kba_7,kba_8,kba_12,idc_up,idc_down,kba_realms,kba_6,idc_range,idc_max],[]),
        guix::ctlDisable(thisWin,[kba_12,kba_6,kba_8,kba_7,idc_up,idc_down]),
        guix::addWin(30,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
	    C3=vpi::winGetCtlHandle(thisWin,kba_realms),
  	    _=vpi::winSendEvent(thisWin,e_Control(kba_1,vpiDomains::w_TopLevel,C3,vpiDomains::activated())),
  	    !.
  	    
    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling() :-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
    % This code is maintained by the VDE do not update it manually, 11:19:28-17.5.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(5,35,997,620).
    menu : vpiDomains::menu = noMenu.
    title : string = "Records".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,8,160,26),"List realms",Win,[wsf_TabStop,wsf_Auto],kba_1),
        _ = vpi::winCreateControl(wc_RadioButton,rct(200,8,352,26),"List chains",Win,[wsf_TabStop,wsf_Auto],kba_2),
        _ = vpi::winCreateControl(wc_PushButton,rct(144,556,352,580),"View Record",Win,[wsf_Group,wsf_TabStop],kba_7),
        _ = vpi::winCreateControl(wc_PushButton,rct(408,556,616,580),"Delete Record",Win,[wsf_Group,wsf_TabStop],kba_8),
        _ = vpi::winCreateControl(wc_PushButton,rct(672,556,880,580),"Delete Realm/Chain",Win,[wsf_Group,wsf_TabStop],kba_12),
        _ = vpi::winCreateControl(wc_PushButton,rct(576,4,784,28),"Scroll Records Down",Win,[wsf_Group,wsf_TabStop],idc_down),
        _ = vpi::winCreateControl(wc_PushButton,rct(360,4,568,28),"Scroll Records Up",Win,[wsf_Group,wsf_TabStop],idc_up),
        _ = vpi::winCreateControl(wc_Edit,rct(816,4,920,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_range),
        _ = vpi::winCreateControl(wc_Edit,rct(928,4,981,28),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_max),
        _ = vpi::winCreateControl(wc_LBox,rct(360,32,984,548),"",Win,[wsf_Group,wsf_TabStop,wsf_Sort,wsf_NoIntegralHeight,wsf_VScroll],kba_6),
        _ = vpi::winCreateControl(wc_Edit,rct(864,492,891,516),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_first),
        _ = vpi::winCreateControl(wc_Edit,rct(896,488,924,512),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_Invisible],idc_last),
        _ = vpi::winCreateControl(wc_LBox,rct(8,32,352,548),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],kba_realms),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(kba_1, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKba1(kba_1, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kba_2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKba2(kba_2, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kba_realms, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKbaRealms(kba_realms, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kba_12, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKba12(kba_12, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kba_7, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKba7(kba_7, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kba_8, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKba8(kba_8, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(kba_6, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlKba6(kba_6, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code

kbaDisplayFirst(W,S) :-
    guix::guiRB_Get(W,[kba_1,kba_2],[1,2],Type),
    Type=1, % realm
	vpi::cursorSetWait(),
	dbExtension::realmRemovePrefix(S,Realm,Id),
	N=dbBase::realmCount(Id,Realm),
	Ns=toString(N),
	guix::txtSetI(W,idc_last,N),
	sx::concat(["[",Ns,"]"],Max),
	guix::txtSet(W,idc_max,Max),
	guix::txtSetI(W,idc_first,-99),
	Ctl=vpi::winGetCtlHandle(W,kba_6),
	kbaDisplayNext(W,Ctl,Type,S),
	vpi::cursorSet(W,cursor_Arrow),
	!
;
    guix::guiRB_Get(W,[kba_1,kba_2],[1,2],Type),
    Type=2, % chain
	vpi::cursorSetWait(),
	sx::sxUnpackS(S," ",L),
	L=[Chain|_],
	N=dbBase::chainCount(Chain),
	Ns=toString(N),
	guix::txtSetI(W,idc_last,N),
	sx::concat(["[",Ns,"]"],Max),
	guix::txtSet(W,idc_max,Max),
	guix::txtSetI(W,idc_first,-99),
	Ctl=vpi::winGetCtlHandle(W,kba_6),
	kbaDisplayNext(W,Ctl,Type,Chain),
	vpi::cursorSet(W,cursor_Arrow),
	!
;
	dlgIF::feil("kbaDisplayFirst",[],[],nill),
	!,fail.	
% --------------------------------------------------------------------------
% kbaDisplayNext/Prev
% --------------------------------------------------------------------------
class predicates
kbaDisX : (vpiDomains::windowHandle,vpiDomains::windowHandle,integer,integer,integer,string).
kbaDisY : (vpiDomains::windowHandle,integer,integer,integer,string).
clauses

% parameters:
% 1	in	listbox control handle
% 2	in	1=realm; 2=chain
% 3	in	ream/chain
%
kbaDisplayNext(Win,LB,Type,S) :-
    % #records <= 100
	guix::txtGetI(Win,idc_last,Max), % #records in realm/chain
	Max<=100,
	guix::ctlDisable(Win,[idc_down,idc_up]),
	kbaDisX(Win,LB,1,Max,Type,S),
	!
;	
    % middle view
	guix::txtGetI(Win,idc_first,First), % record# in row 1
	guix::txtGetI(Win,idc_last,Max),
    NewFirst=First+100,
	Last=NewFirst+99,
	Last<Max,
	guix::ctlEnable(Win,[idc_down,idc_up]),
	kbaDisX(Win,LB,NewFirst,Last,Type,S),
	!
;	
    % bottom view
	guix::txtGetI(Win,idc_first,First),
	guix::txtGetI(Win,idc_last,Max),
	NewFirst=First+100,
	guix::ctlEnable(Win,[idc_up]),
	guix::ctlDisable(Win,[idc_down]),
	kbaDisX(Win,LB,NewFirst,Max,Type,S),
	!.

kbaDisplayPrev(Win,LB,Type,S) :-
    % top view
	guix::txtGetI(Win,idc_first,First),
	First=101,
	guix::ctlDisable(Win,[idc_up]),
	guix::ctlEnable(Win,[idc_down]),
	kbaDisX(Win,LB,1,100,Type,S),
	!
;	
	guix::txtGetI(Win,idc_first,First),
	NewFirst=First-100,
	Last=NewFirst+99,
	guix::ctlEnable(Win,[idc_up,idc_down]),
	kbaDisX(Win,LB,NewFirst,Last,Type,S),
	!.

kbaDisX(Win,Ctl,F,L,Type,H) :- 
	Fs=toString(F),
	guix::txtSet(Win,idc_first,Fs),
	Ls=toString(L),
	sx::concat([Fs,"..",Ls],Range),
	guix::txtSet(Win,idc_range,Range),
	kbaDisY(Ctl,F,L,Type,H),
	!.

kbaDisY(Ctl,F,L,Type,H) :-
	Type=1, % realm
	dbExtension::realmRemovePrefix(H,Realm,Id),
	vpi::lboxClear(Ctl),
	vpi::lboxSuspend(Ctl),
	Cnt=count::newCounter(0),
	Loc=dbBase::realmRecords_nd(Id,Realm),
        Cnt:inc(N),
        N>=F,
        dbBase::getRecord(Loc,RT,_,_,_,Time,_,No,SubNo,_,LTerm,RTerm),
        recPack(Loc,RT,Time,Realm,No,SubNo,LTerm,RTerm,S),
	    vpi::lboxAdd(Ctl,-1,S),
	    N=L,
	vpi::lboxResume(Ctl),
	!	
;
	Type=2, % chain
	vpi::lboxClear(Ctl),
	vpi::lboxSuspend(Ctl),
	Cnt=count::newCounter(0),
	dbBase::chainTerms(H,_,_,Loc),
        Cnt:inc(N),
        N>=F,
        dbBase::getRecord(Loc,RT,_,_,_,Time,Realm,No,SubNo,_,LTerm,RTerm),
        recPack(Loc,RT,Time,Realm,No,SubNo,LTerm,RTerm,S),
	    vpi::lboxAdd(Ctl,-1,S),
	    N=L,
	vpi::lboxResume(Ctl),
	!	
;
	!.
% --------------------------------------------------------------------------
% deleteRealm
% --------------------------------------------------------------------------
deleteRealm(Realm2) :-
    dbExtension::realmRemovePrefix(Realm2,Realm,Id),
	dbBase::realmDelete(Id,Realm),
	!. 
% --------------------------------------------------------------------------
% recPack/Unpack
% --------------------------------------------------------------------------
recPack(Loc,RT,Time,Realm,No,SubNo,LTerm,RTerm,S) :-
    LTerm=cmp(Chain,_),
    Id=dbBase::dbIdChain(Chain),
    RefS=dbBase::dbRef(Loc),    
    RTs=toString(RT),
    NoS=toString(No),
    SubNoS=toString(SubNo),
    LTm=toString(LTerm),
    RTm=toString(RTerm),
    S=string::concatList([RTs," [",RefS,"] ",Chain," ",Time," ",Id,":",Realm,"|",NoS,"|",SubNoS," ",RTm,":-",LTm]),
    !.
end implement records
