/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement saveAsRealm
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/saveAsRealm".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
parAddress : string := "".
            
class predicates
rdgSaveAs : (string,string,string,string,string,string) determ (i,i,i,i,i,i).

predicates
usePars : () determ.

clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
eventHandler : vpiDomains::ehandler.

clauses
eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

predicates
onCreate : vpiDomains::createHandler.

clauses
onCreate(_CreationData) = defaultHandling() :-
    usePars,
    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,idc_realm,Realm),
	guix::txtGet(thisWin,idc_no,SNo),
	guix::txtGet(thisWin,idc_new_realm,NRealm),
	guix::txtGet(thisWin,idc_new_no,NSNo),
	guix::txtGet(thisWin,idc_address,SLoc),
	guix::txtGet(thisWin,idc_chain,Chain),
	rdgSaveAs(Realm,SNo,SLoc,NRealm,NSNo,Chain),
	vpi::winDestroy(thisWin),
	!;!.	

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpWeb("Documentation"),
	!;!.

    % This code is maintained by the VDE do not update it manually, 10:16:19-21.11.2004
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "Save rule as".
        rectangle : vpiDomains::rct = rct(50,40,334,114).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 8.

    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(4,54,135,70),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(148,54,279,70),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(60,16,180,28),"",u_DlgBase),idc_realm,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(188,16,215,28),"",u_DlgBase),idc_no,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(224,16,280,28),"",u_DlgBase),idc_address,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(60,36,181,48),"",u_DlgBase),idc_new_realm,[wsf_UpperCase,wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_Edit,rct(188,36,215,48),"",u_DlgBase),idc_new_no,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
            ctl(wdef(wc_Edit,rct(4,2,19,14),"",u_DlgBase),idc_chain,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_Invisible]),
            ctl(wdef(wc_Text,rct(60,2,83,12),"Realm",u_DlgBase),idct_realm,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(4,18,54,28),"Save as Realm",u_DlgBase),idct_save_as_realm,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(188,2,198,12),"No",u_DlgBase),idct_no,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(224,2,251,12),"Address",u_DlgBase),idct_address,[wsf_AlignLeft])
            ].

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
% ----------------------------------------------------------------------------------------------
% setPars;usePars
% ----------------------------------------------------------------------------------------------
setPars(Loc) :-
    SLoc=dbBase::dbRef(Loc),
    parAddress:=SLoc,
    !.

usePars() :-
    Loc=dbBase::dbRefR(parAddress),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,No,_,_,LTerm,_),
    guix::txtSet(thisWin,idc_realm,Realm),
    guix::txtSet(thisWin,idc_new_realm,Realm),
    SNo=toString(No),
    guix::txtSet(thisWin,idc_no,SNo),
    LTerm=cmp(Chain,_),
    guix::txtSet(thisWin,idc_chain,Chain),
    SLoc=dbBase::dbRef(Loc),
    guix::txtSet(thisWin,idc_address,SLoc),
    !.
% ----------------------------------------------------------------------------------------------
% rdgSaveAs
% ----------------------------------------------------------------------------------------------
rdgSaveAs(Realm,SNo,_,Realm,SNo,_) :-
	dlgIF::dlgNote(0,"Enter new realm and/or sentence no to save to"),!,fail. 
rdgSaveAs(_,_,SLoc,NRealm,NSNo,Chain) :-
	rdgRealmError(1,NRealm,NSNo),
	!,fail
;
	dbBase::chainReadOnlyWarning(Chain),
	!
;
	No=sx::toInt(NSNo),
	Loc=dbBase::dbRefR(SLoc),
	dbBase::getRecord(Loc,RecType,_,_,_,_,_,_,_,_,LTerm,RTerm),
	dbExtension::dbaCheckRuleReplace(NRealm,No),
	dbBase::recordInsert(RecType,NRealm,No,0,LTerm,RTerm,_),
	!.
% ----------------------------------------------------------------------------------------------
% rdgRealmError
% ----------------------------------------------------------------------------------------------
rdgRealmError(CheckUnique,Realm,SNo) :-
	Realm="",
	dlgIF::dlgNote(0,"Realm name cannot be blank"),
	!
;
	sx::frontchar(Realm,'$',_),
	dlgIF::dlgNote(0,"Realm name cannot start with $"),
	!
;	
	L=globalVars::get_i("max_rln"),
	N=string::length(Realm),
	N>L,
	dlgIF::dlgNote(0,"Realm name too long"),
	!
;
	CheckUnique=1,
	No=sx::toInt(SNo),
    dbBase::realmNoCount(Realm,No)>0,
	sx::concat(["Record ",Realm,"|",SNo," exists already"],S1),
	Reply=vpiCommonDialogs::ask(S1,"Do you want to replace it upon saving the new rule?",["Yes","No"]),
	Reply<>vpiCommonDialogs::resp_default,
	!
;
	!,fail.	
end implement saveAsRealm
