/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement sentences
open core,vpiDomains,resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/sentences".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.

predicates
allSTs : () determ.
dbSpecific : ().

clauses
new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
predicates
        eventHandler : vpiDomains::ehandler.
clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* external chairns */

    predicates
        onControlexternals : vpiDomains::controlHandler.
    clauses
        onControlexternals(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiCB_Get(thisWin,idc_externals,V),
    V=1,
    guix::guiCB_Set(thisWin,idc_externals,-1),
	Ps=pop::getSM("p"),
	dbBase::getExtChains(Rc,Wc),
	set::conc([Rc,Wc],Ec),
	set::setRemSub(Ec,Ps,Psl),
	dbBase::nlSings(Psl,Psln),
	guix::lbxPop(thisWin,fbio_relation,["ALL"|Psln]),
	guix::lbxPop(thisWin,fbio_st,[]),
	!
;	
    guix::guiCB_Get(thisWin,idc_externals,V),
    V=-1,
    guix::guiCB_Set(thisWin,idc_externals,1),
	Ps=pop::getSM("p"),
	dbBase::nlSings(Ps,Psln),
	guix::lbxPop(thisWin,fbio_relation,["ALL"|Psln]),
	guix::lbxPop(thisWin,fbio_st,[]),
	!;!.

/* select SG */

    predicates
        onControlFbioRelation : vpiDomains::controlHandler.
    clauses
        onControlFbioRelation(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=vpiDomains::selchanged,
	vpi::cursorSetWait(),
	guix::ctlDisable(thisWin,[fbio_argm_1,fbio_argm_2,fbio_delete_st_derived_only,fbio_delete_st_all,fbio_new_st,
	                  fbio_delete_sg_derived_only,fbio_delete_sg_all,fbio_list,idc_browse,fbio_new,
	                  fbio_new_st,idc_counts,idc_deps,idc_dets]),
	guix::txtSet(thisWin,idc_inp,""),
	guix::txtSet(thisWin,idc_der,""),
	guix::txtSet(thisWin,idc_tot,""),
	guix::lbxGet(thisWin,fbio_relation,R),
	R="ALL",
	allSTs,
	!
;        
    CtrlInfo=vpiDomains::selchanged,
	guix::txtSet(thisWin,idc_inp,""),
	guix::txtSet(thisWin,idc_der,""),
	guix::txtSet(thisWin,idc_tot,""),
	guix::lbxGet(thisWin,fbio_relation,R),
	dbBase::kbID(R,Rel,_,_),
	dbBase::smClassDef(Rel,"p",Card,_,_,_,_),
	Card=2,
	set::setGet(["UNARY","BINARY"],Card,CardS),
	guix::txtSet(thisWin,fbio_cardinality,CardS),
	guix::ctlEnable(thisWin,[fbio_delete_sg_derived_only,fbio_delete_sg_all,fbio_new_st,fbio_argm_1,fbio_argm_2]),
	guix::ctlDisable(thisWin,[idc_counts,fbio_delete_st_derived_only,fbio_delete_st_all,fbio_list,idc_browse,fbio_new,idc_deps,idc_dets]),
	% populate the ST combo
    Context=dbBase::getContext(),
	STs=pop::getSentenceSTs(Rel,Context),
	dbBase::nlTrys(STs,STsn),
	guix::lbxPop(thisWin,fbio_st,STsn),
	sentencemodel::dmAnnoDisplayAsst("p3_iPT",Rel),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!
;	
    CtrlInfo=vpiDomains::selchanged,
	guix::lbxGet(thisWin,fbio_relation,R),
	dbBase::kbID(R,Rel,_,_),
	dbBase::smClassDef(Rel,"p",Card,_,_,_,_),
	Card=1,
	set::setGet(["UNARY","BINARY"],Card,CardS),
	guix::txtSet(thisWin,fbio_cardinality,CardS),
	guix::ctlEnable(thisWin,[fbio_delete_sg_derived_only,fbio_delete_sg_all,fbio_new_st,fbio_argm_1]),
	guix::ctlDisable(thisWin,[idc_counts,fbio_delete_st_derived_only,fbio_delete_st_all,fbio_list,idc_browse,fbio_new,idc_deps,idc_dets]),
	% populate the ST combo
    Context=dbBase::getContext(),
	STs=pop::getSentenceSTs(Rel,Context),
	dbBase::nlTrys(STs,STsn),
	guix::lbxPop(thisWin,fbio_st,STsn),
	sentencemodel::dmAnnoDisplayAsst("p3_iPT",Rel),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* select ST */

    predicates
        onControlFbioSt : vpiDomains::controlHandler.
    clauses
        onControlFbioSt(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,fbio_st,ST),
	sentencemodel::dmAnnoDisplayAsstNL("p3_iST",ST),
	guix::ctlEnable(thisWin,[idc_counts,fbio_delete_st_derived_only,fbio_delete_st_all,fbio_list,idc_browse,fbio_new,idc_deps,idc_dets]),
	!
;	
    CtrlInfo=activated,
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1],
	frmTabWin(1,P,E1,""),
	!
;	
    CtrlInfo=activated,
	vpi::cursorSetWait(),
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1,E2],
	frmTabWin(2,P,E1,E2),
    !;!.
    
/* deletions */

    predicates
        onControlFbioDeleteSgAll : vpiDomains::controlHandler.
    clauses
        onControlFbioDeleteSgAll(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGet(thisWin,fbio_relation,SG),
	SG<>"",
	dbBase::kbID(SG,SGid,_,_),
	vpi::cursorSetWait(),
	dbBase::chainDeleteSentences(0,SGid,N),
	Ctl=vpi::winGetCtlHandle(thisWin,fbio_st),
	guix::lbxDelS(thisWin,fbio_relation,SG),
	vpi::lboxClear(Ctl),
	Ns=toString(N),
	S=string::concat("Deleted ",Ns," sentences!"),
	dlgIF::dlgNote(0,S),
	!;!.

    predicates
        onControlFbioDeleteSgDerivedOnly : vpiDomains::controlHandler.
    clauses
        onControlFbioDeleteSgDerivedOnly(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGet(thisWin,fbio_relation,SG),
	SG<>"",
	dbBase::kbID(SG,SGid,_,_),
	vpi::cursorSetWait(),
	dbBase::chainDeleteSentences(1,SGid,N),
	Ctl=vpi::winGetCtlHandle(thisWin,fbio_st),
	guix::lbxDelS(thisWin,fbio_relation,SG),
	vpi::lboxClear(Ctl),
	Ns=toString(N),
	S=string::concat("Deleted ",Ns," sentences!"),
	dlgIF::dlgNote(0,S),
	!;!.

    predicates
        onControlFbioDeleteStAll : vpiDomains::controlHandler.
    clauses
        onControlFbioDeleteStAll(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
    dbBase::stTypeDelete(0,STk,N),
	guix::lbxDelS(thisWin,fbio_st,ST),
    Ns=toString(N),
    Mess=string::concat("Deleted ",Ns," sentences!"),
    dlgIF::dlgNote(0,Mess),
    !;!.

    predicates
        onControlFbioDeleteStDerivedOnly : vpiDomains::controlHandler.
    clauses
        onControlFbioDeleteStDerivedOnly(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
    dbBase::stTypeDelete(1,STk,N),
    Ns=toString(N),
    Mess=string::concat("Deleted ",Ns," derived sentences!"),
    dlgIF::dlgNote(0,Mess),
    !;!.

/* list */

    predicates
        onControlFbioList : vpiDomains::controlHandler.
    clauses
        onControlFbioList(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	% list sentences (table window)
	vpi::cursorSetWait(),
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1,E2],
	frmTabWin(2,P,E1,E2),
	!
;	
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1],
	frmTabWin(1,P,E1,""),
	!
;	
	dlgIF::dlgNote(0,"Select a sentence type!"),
	!.	

/* browse */

predicates
    onControlidc_browse : vpiDomains::controlHandler.
clauses
    onControlidc_browse(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	guix::lbxGet(thisWin,fbio_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
	browse(STk),
	!
;	
	dlgIF::dlgNote(0,"Select a sentence type!"),
	!.	

/* dependents and determinants */

    predicates
        onControldeps : vpiDomains::controlHandler.
    clauses
        onControldeps(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-	
	not(guix::lbtGetF(thisWin,fbio_st,_)),
	dlgIF::dlgNote(0,"Select sentence type!"),
    !
;        
	vpi::cursorSetWait(),
	guix::lbtGetF(thisWin,fbio_st,ST),
	dbBase::stNL_KB(ST,STk),
	p3Tree::dtDepTreeOpen(1,2,1,-1,1,1,1,1,cmp("n",[int(2),termDomain::str(STk)]),"6"), 
	!
;
	dlgIF::dlgNote(0,"This sentence type has no dependents!"),
	!.	
    predicates
        onControldets : vpiDomains::controlHandler.
    clauses
        onControldets(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	not(guix::lbtGetF(thisWin,fbio_st,_)),
	dlgIF::dlgNote(0,"Select sentence type!"),
    !
;        
	vpi::cursorSetWait(),
	guix::lbtGetF(thisWin,fbio_st,ST),
	dbBase::stNL_KB(ST,STk),
	p3Tree::dtDepTreeOpen(1,1,1,-1,1,1,1,1,cmp("n",[int(2),termDomain::str(STk)]),"6"), 
	!
;
	dlgIF::dlgNote(0,"This sentence type has no determinants!"),
	!.	

/* ST counts */

    predicates
        onControlcounts : vpiDomains::controlHandler.
    clauses
        onControlcounts(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	guix::lbtGetF(thisWin,fbio_st,ST),
	dbBase::stNL_KB(ST,STk),
	dbBase::stCount(STk,N1,N2),
	N3=N1+N2,
	guix::txtSetI(thisWin,idc_inp,N2),
	guix::txtSetI(thisWin,idc_der,N1),
	guix::txtSetI(thisWin,idc_tot,N3),
	!
;	
	guix::lbtGetF(thisWin,fbio_relation,SG),
	dbBase::kbID(SG,SGk,_,_),
	dbExtension::kbSG_Count(SGk,N1,N2),
	N3=N1+N2,
	guix::txtSetI(thisWin,idc_inp,N2),
	guix::txtSetI(thisWin,idc_der,N1),
	guix::txtSetI(thisWin,idc_tot,N3),
	!
;
	dlgIF::dlgNote(0,"Select sentence group first!"),
	!.	

/* new sentence (existing ST) */

    predicates
        onControlFbioNew : vpiDomains::controlHandler.
    clauses
        onControlFbioNew(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	% input new sentences
	guix::lbtGet(thisWin,fbio_st,S),
	S<>"",
	dbBase::stNL_KB(S,STk),
	sentence::openWin(STk,1),
	!
;
	dlgIF::dlgNote(0,"No sentence type selected"),
	!.	

/* new sentence (new ST) */

    predicates
        onControlFbioNewSt : vpiDomains::controlHandler.
    clauses
        onControlFbioNewSt(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,fbio_cardinality,CardS),
	set::setGet(["UNARY","BINARY"],Card,CardS),
	Card=1,
	guix::lbtGetF(thisWin,fbio_argm_1,E1nl),
	guix::lbtGetF(thisWin,fbio_relation,Pnl),
	dbBase::kbID(Pnl,P,_,_),
	dbBase::kbID(E1nl,E1,_,_),
	sx::sxlJoin([P,E1],"|",STk),
	sentence::openWin(STk,-1),
	!
;	
	guix::txtGet(thisWin,fbio_cardinality,CardS),
	set::setGet(["UNARY","BINARY"],Card,CardS),
	Card=2,
	guix::lbtGetF(thisWin,fbio_argm_1,E1nl),
	guix::lbtGetF(thisWin,fbio_argm_2,E2nl),
	guix::lbtGetF(thisWin,fbio_relation,Pnl),
	dbBase::kbID(Pnl,P,_,_),
	dbBase::kbID(E1nl,E1,_,_),
	dbBase::kbID(E2nl,E2,_,_),
	sx::sxlJoin([P,E1,E2],"|",STk),
	sentence::openWin(STk,-1),
	!
;
	dlgIF::dlgNote(0,"Select entity type arguments first!"),
	!.	

/* create, destroy */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
	guix::addWin(10,thisWin),
  	guix::setStyle(thisWin,[fbio_relation,fbio_cardinality,
  	                   fbio_st,fbio_list,fbio_new,fbio_type,idc_browse,
  	                   fbio_form_2,fbio_argm_1,idct_1st,idc_2nd,
  	                   fbio_argm_2,idc_sentences_19,
  	                   fbio_delete_st_derived_only,fbio_delete_sg_derived_only,
  	                   idc_counts,idc_inp,idc_der,idc_tot,idct_inp,idct_der,idct_tot,
  	                   fbio_delete_st_all,fbio_delete_sg_all,fbio_new_st,idc_deps,idc_dets,idc_externals],[]),	
	vpi::cursorSetWait(),
	% populates the sentence group combo
	Ps=pop::getSM("p"),
	dbBase::getExtChains(Rc,Wc),
	set::conc([Rc,Wc],Ec),
	set::setRemSub(Ec,Ps,Psl),
	dbBase::nlSings(Psl,Psln),
	guix::lbxPop(thisWin,fbio_relation,["ALL"|Psln]),
	% populates the argument list boxes
	vpi::cursorSetWait(),
	Ents2=pop::getSM("e"),
	dbBase::nlSings(Ents2,Ents),
	guix::lbxPop(thisWin,fbio_argm_1,Ents),
	guix::lbxPop(thisWin,fbio_argm_2,Ents),
    % populates all STs
	vpi::cursorSetWait(),
    allSTs,
	guix::ctlDisable(thisWin,[fbio_argm_1,fbio_argm_2,fbio_delete_st_derived_only,fbio_delete_st_all,fbio_new_st,
	                  fbio_delete_sg_derived_only,fbio_delete_sg_all,fbio_list,idc_browse,fbio_new,
	                  fbio_new_st,idc_counts,idc_deps,idc_dets]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	dbSpecific,
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

% This code is maintained by the VDE do not update it manually, 10:06:30-28.4.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,25,640,620).
    menu : vpiDomains::menu = noMenu.
    title : string = "Sentences".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBoxButton,rct(136,4,376,544),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],fbio_relation),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,192,536,216),"List Sentences",Win,[wsf_Group,wsf_TabStop],fbio_list),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,332,536,356),"New Sentence",Win,[wsf_Group,wsf_TabStop],fbio_new),
        _ = vpi::winCreateControl(wc_Edit,rct(592,560,619,584),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly,wsf_Invisible,wsf_Disabled],fbio_type),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(312,544,523,636),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],fbio_argm_1),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(312,568,523,628),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],fbio_argm_2),
        _ = vpi::winCreateControl(wc_Edit,rct(384,4,536,24),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly],fbio_cardinality),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,164,536,188),"Delete ST (derived only)",Win,[wsf_Group,wsf_TabStop],fbio_delete_st_derived_only),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,136,536,160),"Delete ST (all)",Win,[wsf_Group,wsf_TabStop],fbio_delete_st_all),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,108,536,132),"Delete SG (derived only)",Win,[wsf_Group,wsf_TabStop],fbio_delete_sg_derived_only),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,80,536,104),"Delete SG (all)",Win,[wsf_Group,wsf_TabStop],fbio_delete_sg_all),
        _ = vpi::winCreateControl(wc_LBox,rct(8,80,376,540),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],fbio_st),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,552,160,576),"Enter new type",Win,[wsf_Group,wsf_TabStop],fbio_new_st),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,416,536,440),"Show sentence counts",Win,[wsf_Group,wsf_TabStop],idc_counts),
        _ = vpi::winCreateControl(wc_Text,rct(387,452,443,472),"Inputted",Win,[wsf_AlignLeft],idct_inp),
        _ = vpi::winCreateControl(wc_Text,rct(387,484,443,504),"Derived",Win,[wsf_AlignLeft],idct_der),
        _ = vpi::winCreateControl(wc_Text,rct(387,516,443,536),"Total",Win,[wsf_AlignLeft],idct_tot),
        _ = vpi::winCreateControl(wc_Edit,rct(451,448,532,472),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_inp),
        _ = vpi::winCreateControl(wc_Edit,rct(451,480,532,504),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_der),
        _ = vpi::winCreateControl(wc_Edit,rct(451,512,532,536),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_tot),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,360,536,384),"Show dependents",Win,[wsf_Group,wsf_TabStop],idc_deps),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,388,536,412),"Show determinants",Win,[wsf_Group,wsf_TabStop],idc_dets),
        _ = vpi::winCreateControl(wc_CheckBox,rct(136,32,297,52),"Incl. external chains",Win,[wsf_Group,wsf_TabStop],idc_externals),
        _ = vpi::winCreateControl(wc_Text,rct(8,56,376,76),"Sentence types",Win,[wsf_AlignCenter],fbio_form_2),
        _ = vpi::winCreateControl(wc_Text,rct(168,544,304,564),"1st entity argument",Win,[wsf_AlignLeft],idct_1st),
        _ = vpi::winCreateControl(wc_Text,rct(168,568,304,588),"2nd entity argument",Win,[wsf_AlignLeft],idc_2nd),
        _ = vpi::winCreateControl(wc_Text,rct(8,4,128,24),"Sentence groups:",Win,[wsf_AlignLeft],idc_sentences_19),
        _ = vpi::winCreateControl(wc_PushButton,rct(384,220,536,244),"Browse Sentences",Win,[wsf_Group,wsf_TabStop],idc_browse),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_externals, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlexternals(idc_externals, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_relation, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioRelation(fbio_relation, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_st, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioSt(fbio_st, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_list, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioList(fbio_list, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_delete_sg_all, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioDeleteSgAll(fbio_delete_sg_all, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_delete_sg_derived_only, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioDeleteSgDerivedOnly(fbio_delete_sg_derived_only, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_delete_st_derived_only, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioDeleteStDerivedOnly(fbio_delete_st_derived_only, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_deps, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldeps(idc_deps, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_dets, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldets(idc_dets, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_counts, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcounts(idc_counts, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_new, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioNew(fbio_new, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_new_st, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioNewSt(fbio_new_st, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(fbio_delete_st_all, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlFbioDeleteStAll(fbio_delete_st_all, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_browse, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_browse(idc_browse, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
    
% ---------------------------------------------------------------------------
% browse
% ---------------------------------------------------------------------------
browse(St) :-
    dbBase::stSentence_nd(St,_,Loc),
    sentence::displayRef(Loc),
    !.
% ---------------------------------------------------------------------------
% frmTabWin
% ---------------------------------------------------------------------------
class predicates
pr_ent : (string,string) determ (i,o).
pr_rel_attrs : (string,sterm,string) determ (i,i,o).
clauses

frmTabWin(1,Rel,Ent1,_) :-
	dbBase::smClassDefTree(Rel,"p",RelDef),
	pr_rel_attrs(Rel,RelDef,S1),
	pr_ent(Ent1,S2),
	sx::concat([Rel,"(",S2,S1,")."],Pr),
	transpr::proPR_Term(Pr,Term),
	proc::processQuery("eq",Term,Pr),
	!
;
    !.
frmTabWin(2,Rel,Ent1,Ent2) :-
	dbBase::smClassDefTree(Rel,"p",RelDef),
	pr_rel_attrs(Rel,RelDef,S1),
	pr_ent(Ent1,S2),
	pr_ent(Ent2,S3),
	sx::concat([Rel,"(",S2,",",S3,S1,")."],Pr),
	transpr::proPR_Term(Pr,Term),
	proc::processQuery("eq",Term,Pr),
	!
;
    !.
frmTabWin(C,R,E1,E2) :- 
    dlgIF::feil("frmTabWin",[R,E1,E2],[C],nill),!,fail.

pr_ent(Ent,S) :-
	dbBase::smClassDefTree(Ent,"e",Def),
	Def=cmp(_,[_,cmp("ATTRS",AttDefs)]),
	vars::varGenPrefix(Ent,EntPf),
	vars::varDE_Vars(EntPf,AttDefs,AttVars1),
	var_SLIST(AttVars1,AttVars),
	sx::sxlJoin(AttVars,",",S1),
	sx::concat([Ent,"(",S1,")"],S),!
;
	dlgIF::feil("pr_ent",[Ent],[],nill),!,fail.

pr_rel_attrs(Rel,Def,S) :-	
	Def=cmp(_,[_,_]),
	S="",
	! 
;	
	Def=cmp(_,[_,_,cmp("ATTRS",AttDefs)]), 
	vars::varGenPrefix(Rel,RelPf),
	vars::varDE_Vars(RelPf,AttDefs,AttVars1),
	var_SLIST(AttVars1,AttVars),
	sx::sxlJoin(AttVars,",",S1),
	S=string::concat(",",S1),
	!
;
	dlgIF::feil("pr_rel_attrs",[Rel],[],Def),!,fail.
% ---------------------------------------------------------------------------
% allSTs
% ---------------------------------------------------------------------------
allSTs() :-
    guix::guiCB_Get(thisWin,idc_externals,V),
    V=1,
    STs=pop::getSentenceSTs(),
	dbBase::nlSings(STs,STsfn),
	guix::lbxPop(thisWin,fbio_st,STsfn),
	guix::lbxMultiSel(thisWin,fbio_relation,[]),
	guix::ctlDisable(thisWin,[fbio_delete_sg_derived_only,fbio_delete_sg_all,fbio_new_st,fbio_argm_1,fbio_argm_2]),
	!
;	
    guix::guiCB_Get(thisWin,idc_externals,V),
    V=-1,
	Ps=pop::getSM("p"),
	dbBase::getExtChains(Rc,Wc),
	set::conc([Rc,Wc],Ec),
	set::setRemSub(Ec,Ps,Psl),
    STs=pop::getSentenceSTs(),
    pop::filterSTs(STs,Psl,STsf),
	dbBase::nlSings(STsf,STsfn),
	guix::lbxPop(thisWin,fbio_st,STsfn),
	guix::lbxMultiSel(thisWin,fbio_relation,[]),
	guix::ctlDisable(thisWin,[fbio_delete_sg_derived_only,fbio_delete_sg_all,fbio_new_st,fbio_argm_1,fbio_argm_2]),
	!.

dbSpecific() :-
    dbBase::kbIsSql,
    guix::ctlDisable(thisWin,[idc_externals]),
    !
;
    not(dbBase::kbIsSql),
    guix::guiCB_Set(thisWin,idc_externals,-1),
    !
;
    !.
end implement sentences
