/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement allabout
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/allabout".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.

class facts
currentST : string := "".
currentNo : integer := 0.

clauses
new(Parent):-
      _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,windowFlags, eventHandler, 0).

predicates
eventHandler : vpiDomains::ehandler.

class predicates
writeRecs : (rep,integer,integer,integer,lst) determ.
writeRecsServer : (odbcConnection,integer,lst) determ.
writeRecsMulti : (outFile,integer,integer,string,lst) determ.
writeRecTables : (lst) determ.
writeRecTablesServer : (odbcConnection,lst) determ.
fetchRecordMetaData : (dbLoc,string) determ (i,o).
dlgAllFilter : (lst,string,sterm,dbLoc,integer_list,integer) determ.
dlgTranslate : (integer,string,string,sterm) determ (i,i,i,o).

clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_ok,idc_term,idct_term,idc_sent,idc_record,idc_ia1,idc_ia2,idc_suspended,idc_i1,
                                        idc_i2,idc_i3,idc_i5,idc_i6,idc_i4,idc_term_search,idc_string_search,idc_trans_rec],[]),
        guix::addWin(34,thisWin),
        %dom::domList(Doms),
        %dbBase::nlSings(Doms,NDoms),
        %guix::lbxPop(thisWin,idc_domain,NDoms),
        %guix::ctlDisable(thisWin,[idc_domain,idc_sterm]),
        guix::guiRB_SetN(thisWin,[idc_record,idc_sent],[1,2],1),
        guix::guiCB_Set(thisWin,idc_i1,1),
        guix::guiCB_Set(thisWin,idc_i2,1),
        guix::guiCB_Set(thisWin,idc_i3,1),
        guix::guiCB_Set(thisWin,idc_i4,1),
        guix::guiCB_Set(thisWin,idc_i5,1),
        guix::guiCB_Set(thisWin,idc_i6,1),
        %guix::guiCB_Set(thisWin,idc_trans_rec,-1),
        guix::guiRB_SetN(thisWin,[idc_term_search,idc_string_search],[1,2],1),
        vpi::cursorSet(thisWin,cursor_Arrow),
        !;!.
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.
    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.
            
/*
    predicates
        onControlTransRec : vpiDomains::controlHandler.
    clauses
        onControlTransRec(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_trans_rec,TransRec),
	TransRec=1,
	!;!.
    predicates
        onControlStringSearch : vpiDomains::controlHandler.
    clauses
        onControlStringSearch(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_term_search,idc_string_search],[1,2],2),
	guix::ctlDisable(thisWin,[idc_translate,idc_domain,idc_sterm]),
	!;!.
    predicates
        onControlTermSearch : vpiDomains::controlHandler.
    clauses
        onControlTermSearch(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_term_search,idc_string_search],[1,2],1),
	guix::ctlEnable(thisWin,[idc_translate]),
	!;!.
*/	
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
  	guix::guiRB_Get(thisWin,[idc_term_search,idc_string_search],[0,1],StringSearch),
  	StringSearch=0,
  	guix::guiRB_Get(thisWin,[idc_sent,idc_record],[0,1],RepMode),
	guix::txtGet(thisWin,idc_term,S),
	S<>"",
	dlgTranslate(-1,"",S,Term),	
	guix::guiCB_Get(thisWin,idc_ia1,Sia1),
	guix::guiCB_Get(thisWin,idc_ia2,Sia2),
	guix::guiCB_Get(thisWin,idc_i1,Si1),
	guix::guiCB_Get(thisWin,idc_i2,Si2),
	guix::guiCB_Get(thisWin,idc_i3,Si3),
	guix::guiCB_Get(thisWin,idc_i4,Si4),
	guix::guiCB_Get(thisWin,idc_i5,Si5),
	guix::guiCB_Get(thisWin,idc_i6,Si6),
	guix::guiCB_Get(thisWin,idc_suspended,Suspended),
	guix::guiCB_Get(thisWin,idc_trans_rec,TransRec),
	L=lst::new(),
	fetchRecords(L,"",Term,RepMode,Sia1,Sia2,Si1,Si2,Si3,Si4,Si5,Si6,-1,Suspended),	
	reportRecords(RepMode,TransRec,L,"",Term),
	!
;
  	guix::guiRB_Get(thisWin,[idc_term_search,idc_string_search],[0,1],StringSearch),
  	StringSearch=1,
  	guix::guiRB_Get(thisWin,[idc_sent,idc_record],[0,1],RepMode),
	guix::txtGet(thisWin,idc_term,S),
	S<>"",
	guix::guiCB_Get(thisWin,idc_ia1,Sia1),
	guix::guiCB_Get(thisWin,idc_ia2,Sia2),
	guix::guiCB_Get(thisWin,idc_i1,Si1),
	guix::guiCB_Get(thisWin,idc_i2,Si2),
	guix::guiCB_Get(thisWin,idc_i3,Si3),
	guix::guiCB_Get(thisWin,idc_i4,Si4),
	guix::guiCB_Get(thisWin,idc_i5,Si5),
	guix::guiCB_Get(thisWin,idc_i6,Si6),
	guix::guiCB_Get(thisWin,idc_suspended,Suspended),
	guix::guiCB_Get(thisWin,idc_trans_rec,TransRec),
	L=lst::new(),
	fetchRecords(L,S,nill,RepMode,Sia1,Sia2,Si1,Si2,Si3,Si4,Si5,Si6,-1,Suspended),	
	reportRecords(RepMode,TransRec,L,S,nill),
	!;!.
	
    predicates
        onControlsent : vpiDomains::controlHandler.
    clauses
        onControlsent(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Set(thisWin,idc_ia1,1),
	guix::guiCB_Set(thisWin,idc_ia2,1),
	guix::guiCB_Set(thisWin,idc_trans_rec,1),
	guix::ctlDisable(thisWin,[idc_trans_rec]),
	!;!.
    predicates
        onControlrecord : vpiDomains::controlHandler.
    clauses
        onControlrecord(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Set(thisWin,idc_i1,1),
	guix::guiCB_Set(thisWin,idc_i2,1),
	guix::guiCB_Set(thisWin,idc_i3,1),
	guix::guiCB_Set(thisWin,idc_i4,1),
	guix::guiCB_Set(thisWin,idc_i5,1),
	guix::guiCB_Set(thisWin,idc_i6,1),
	guix::ctlEnable(thisWin,[idc_trans_rec]),
	!;!.
/*
    predicates
        onControlterm : vpiDomains::controlHandler.
    clauses
        onControlterm(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=modified(),
	guix::guiCB_Get(thisWin,idc_translate,Checked),
	Checked=1,
	guix::txtSet(thisWin,idc_sterm,""),
	!
;
    CtrlInfo=modified(),
	guix::txtGet(thisWin,idc_term,S),
	guix::txtSet(thisWin,idc_sterm,S),
	!;!.
    predicates
        onControldomain : vpiDomains::controlHandler.
    clauses
        onControldomain(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=selchanged(),
	guix::lbtGet(thisWin,idc_domain,Selected),
	dbBase::kbID(Selected,Dom,_,_),
	guix::txtGet(thisWin,idc_term,S),
	S<>"",
	dlgTranslate(1,Dom,S,Term),	
	T=toString(Term),	
	guix::txtSet(thisWin,idc_sterm,T),
	!;!.
    predicates
        onControltranslate : vpiDomains::controlHandler.
    clauses
        onControltranslate(_CtrlID, _CtrlType, _CtrlWin,_CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_translate,Checked),
	Checked=1,
	guix::ctlEnable(thisWin,[idc_domain]),
	guix::txtSet(thisWin,idc_sterm,""),
	!
;	
	guix::guiCB_Get(thisWin,idc_translate,Checked),
	Checked=-1,
	guix::ctlDisable(thisWin,[idc_domain]),
	guix::txtSet(thisWin,idc_sterm,""),
	!;!.
*/	
    % This code is maintained by the VDE do not update it manually, 17:27:35-18.10.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,491,435).
    menu : vpiDomains::menu = noMenu.
    title : string = "All about ...".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_PushButton,rct(112,312,270,348),"OK",Win,[wsf_Default,wsf_Group,wsf_TabStop],idc_ok),
        _ = vpi::winCreateControl(wc_Edit,rct(56,28,385,52),"",Win,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft],idc_term),
        _ = vpi::winCreateControl(wc_Text,rct(8,33,50,51),"Term",Win,[wsf_AlignLeft],idct_term),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,60,178,80),"Sentence output",Win,[wsf_TabStop,wsf_Auto],idc_sent),
        _ = vpi::winCreateControl(wc_RadioButton,rct(215,60,385,80),"Record output",Win,[wsf_TabStop,wsf_Auto],idc_record),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,100,178,120),"Derived sentences",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_ia1),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,126,178,146),"Inputted sentences",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_ia2),
        _ = vpi::winCreateControl(wc_CheckBox,rct(108,283,304,301),"Include suspended records",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_suspended),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,98,385,118),"Derived sentences",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_i1),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,122,385,142),"Inputted sentences",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_i2),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,146,385,166),"Sentence rules",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_i3),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,170,385,190),"Derived sentence rules",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_i5),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,194,385,214),"Inexact rules",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_i6),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,220,385,240),"Functions",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_i4),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,4,186,24),"Term search",Win,[wsf_TabStop,wsf_Auto],idc_term_search),
        _ = vpi::winCreateControl(wc_RadioButton,rct(207,4,385,24),"String search",Win,[wsf_TabStop,wsf_Auto],idc_string_search),
        _ = vpi::winCreateControl(wc_CheckBox,rct(215,255,385,273),"Translate found records",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_trans_rec),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sent, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsent(idc_sent, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_record, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrecord(idc_record, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
% ---------------------------------------------------------------------------------------------------------------
% fetchRecords
% ---------------------------------------------------------------------------------------------------------------
fetchRecords(Arr,S,Term,0,Sia1,Sia2,_,_,_,_,_,_,_,Suspended) :-	
	Sel=[Sia1,Sia2,0,0,0,0,0],
	dbBase::chains_nd(1,Chain),
	dbBase::chainTerms(Chain,_,_,Loc),
	dlgAllFilter(Arr,S,Term,Loc,Sel,Suspended),
	fail
;
	!.	
fetchRecords(Arr,S,Term,1,_,_,Si1,Si2,Si3,Si4,Si5,Si6,Si7,Suspended) :-	
	Sel=[Si1,Si2,Si3,Si4,Si5,Si6,Si7],
	dbBase::chains_nd(1,Chain),
	dbBase::chainTerms(Chain,_,_,Loc),
	dlgAllFilter(Arr,S,Term,Loc,Sel,Suspended),
	fail
;
	!.
% ---------------------------------------------------------------------------------------------------------------
% fetchRecordMetaData
% ---------------------------------------------------------------------------------------------------------------
fetchRecordMetaData(Loc,S) :-
    dbBase::getRecord(Loc,RecType,_,_,_,Time,Realm,SentNo,SubNo,_,_,_),
	SLoc=dbBase::dbRef(Loc),
	S3=toString(RecType),
	S4=toString(SentNo),
	S5=toString(SubNo),
	sx::concat(["[",SLoc,"] Record type=",S3," ",Realm,"|",S4,"|",S5," ",Time],S),
	!.
% ---------------------------------------------------------------------------------------------------------------
% dlgAllFilter
% ---------------------------------------------------------------------------------------------------------------
dlgAllFilter(Arr,"",Term,Loc,Sel,1) :-
    dbBase::getRecord(Loc,_,B,_,_,_,_,_,_,ST,LT,RT),
	set::setGet(Sel,B,V),
	V=1,
	struc::treHasElement(cmp(":-",[LT,RT]),Term),
	fetchRecordMetaData(Loc,Meta),
	sx::concat([ST,"||",Meta],S),
	Arr:add(S),
	!.
dlgAllFilter(Arr,"",Term,Loc,Sel,-1) :-
    dbBase::getRecord(Loc,_,B,_,Susp,_,_,_,_,ST,LT,RT),
	Susp<>1,
	set::setGet(Sel,B,V),
	V=1,
	struc::treHasElement(cmp(":-",[LT,RT]),Term),
	fetchRecordMetaData(Loc,Meta),
	sx::concat([ST,"||",Meta],S),
	Arr:add(S),
	!.
dlgAllFilter(Arr,S,nill,Loc,Sel,1) :-
    dbBase::getRecord(Loc,_,B,_,_,_,_,_,_,ST,LT,RT),
	set::setGet(Sel,B,V),
	V=1,
	struc::treHasString(cmp(":-",[LT,RT]),S),
	fetchRecordMetaData(Loc,Meta),
	sx::concat([ST,"||",Meta],Sr),
	Arr:add(Sr),
	!.
dlgAllFilter(Arr,S,nill,Loc,Sel,-1) :-
    dbBase::getRecord(Loc,_,B,_,Susp,_,_,_,_,ST,LT,RT),
	Susp<>1,
	Susp=-1,
	set::setGet(Sel,B,V),
	V=1,
	struc::treHasString(cmp(":-",[LT,RT]),S),
	fetchRecordMetaData(Loc,Meta),
	sx::concat([ST,"||",Meta],Sr),
	Arr:add(Sr),
	!.
% ---------------------------------------------------------------------------------------------------------------
% reportRecords
% ---------------------------------------------------------------------------------------------------------------
% parameters:
% 1 in 1/0 report mode (vs. sentence mode)
% 2 in  1/-1 translate records
% 3 in  records (lst)
% 4 in  all-about subject
% 5 in  all-about term
%

% report-mode/no file given:
%
reportRecords(1,TransRec,Arr,S,nill) :-
	Out2=globalVars::get_i("f_outq"),
	Out3=math::abs(Out2),
	sx::concat(["All about ",S],H),
    sx::makeIdentifier(1,3,2,H,64,"",Hn),
    Rep=rep::newReport(Hn,70),
    Rep:getPrinter()<>0,
	set::setGet([1,1,1,1,1,1,1,1,9,10,11],Out3,Out),
	Rep:repWL(0,"All about: ",S),
	Rep:repLine('-'),
			L=Arr:getCount(),
			S2=toString(L),
			sx::concat([S2," records found!"],S3),
			dlgIF::msgS(S3),
	writeRecs(Rep,1,TransRec,Out,Arr),
	Rep:close(),
	!.
reportRecords(1,TransRec,Arr,_,Term) :-
	Out2=globalVars::get_i("f_outq"),
	STerm=toString(Term),
	sx::concat(["All about ",STerm],H),
    sx::makeIdentifier(1,3,2,H,64,"",Hn),
    Rep=rep::newReport(Hn,70),
    Rep:getPrinter()<>0,
	Out3=math::abs(Out2),
	set::setGet([1,1,1,1,1,1,1,1,9,10,11],Out3,Out),
	Rep:repWL(0,"All about: ",STerm),
	Rep:repLine('-'),
			L=Arr:getCount(),
			S2=toString(L),
			sx::concat([S2," records found!"],S3),
			dlgIF::msgS(S3),
	writeRecs(Rep,1,TransRec,Out,Arr),
	Rep:close(),
	!.
% sentence-mode/no file given:	
%
reportRecords(0,TransRec,Arr,S,Term) :-
    Term=nill,
	Out2=globalVars::get_i("f_outq"),
	Out2<0,
	Out3=-Out2,
	sx::concat(["All about ",S],H),
    sx::makeIdentifier(1,3,2,H,64,"",Hn),
    Rep=rep::newReport(Hn,70),
    Rep:getPrinter()<>0,
	set::setGet([1,1,1,1,1,1,1,1,9,10,11],Out3,Out),
			L=Arr:getCount(),
			S2=toString(L),
			sx::concat([S2," records found!"],S3),
			dlgIF::msgS(S3),
	writeRecs(Rep,-1,TransRec,Out,Arr),
	Rep:close(),
	!
;
    not(Term=nill),
	Out2=globalVars::get_i("f_outq"),
	Out2<0,
	Out3=-Out2,
	STerm=toString(Term),
	sx::concat(["All about ",STerm],H),
    sx::makeIdentifier(1,3,2,H,64,"",Hn),
    Rep=rep::newReport(Hn,70),
    Rep:getPrinter()<>0,
	set::setGet([1,1,1,1,1,1,1,1,9,10,11],Out3,Out),
			L=Arr:getCount(),
			S2=toString(L),
			sx::concat([S2," records found!"],S3),
			dlgIF::msgS(S3),
	writeRecs(Rep,-1,TransRec,Out,Arr),
	Rep:close(),
	!.
reportRecords(0,_,Arr,_,_) :-
	Opt=globalVars::get_i("f_outq"),
	Opt2=math::abs(Opt),
	Opt2=8,
	writeRecTables(Arr),
	!
;	
	% multiwindow output
	Out2=globalVars::get_i("f_outq"),
	set::setGet([1,1,1,1,1,1,1,8,9,10,11],Out2,Out),
	set::member(Out,[1,9,10,11]),
    L=Arr:top(),
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,_,_),
	dbBase::stNL(STk,STn),
   	P=globalVars::get_s("std_path"),
   	fioExt::file_type(Out,Type),
    fioExt::makeFileName(STn,Type,Name),
    FileName=string::concat(P,"\\",Name),   	
	File=outFile::new(FileName,Out),
	writeRecsMulti(File,Out,-1,STk,Arr),
	!.
reportRecords(QFile,TransRec,Arr) :-
	Out2=globalVars::get_i("f_outq"),
	Out2<0,
	Out3=-Out2,
    set::setGet([1,1,1,1,1,1,1,1,9,10,11],Out3,Out),
			L=Arr:getCount(),
			S2=toString(L),
			sx::concat([S2," records found!"],S3),
			dlgIF::msgS(S3),
   	P=globalVars::get_s("std_path"),
   	fioExt::file_type(Out,Type),
    FileName=string::concat(P,"\\Temp.",Type),   	
	File=rep::newReport(FileName,70),
	writeRecs(File,-1,TransRec,Out,Arr),
	File:close(),
    Recs=fio::readFile(FileName),
    QFile:writenlList(Recs),
	!.

reportRecordsODBC(ODBC,Opt,Arr) :-
	Opt=8,
	writeRecTablesServer(ODBC,Arr),
	!
;	
	Opt<>8,
	writeRecsServer(ODBC,Opt,Arr),
	!.
% ---------------------------------------------------------------------------------------------------------------
% writeRecs
% ---------------------------------------------------------------------------------------------------------------
class predicates
writeRecords : (rep,integer,integer,integer,string) determ.
clauses

% parameters:
% 1 in  rep
% 2 in  -1/1 incl. record meta data
% 3 in  -1/1 translate
% 4 in  output format
% 5	in	record-list
%
writeRecs(Rep,Meta,Trans,Form,List) :-
    currentNo:=List:getCount(),
    programControl::repeat,
        List:getNext(currentNo,L,Count),
        currentNo:=Count,
        writeRecords(Rep,Meta,Trans,Form,L),
        Count=-1,
        !.

writeRecords(_,_,_,_,"") :-
	!.
writeRecords(Rep,1,-1,_,L) :-
	% untranslated
	sx::sxUnpackS(L,"||",La),
	set::size(La,N),
	N=2,
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,_,LT,RT),
	S=toString(cmp(":-",[LT,RT])),
	Rep:repWL(0,Lc,":"),
	sx::sxBlockNL(0,70,S,BS),
	Rep:repWL(0,BS),
	Rep:repLine(' '),
	!.
writeRecords(Rep,1,_,1,L) :-
	% NL 
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,R,_,_,_,_,_,_,_,_,LT,RT),
	nl::conRecord(R,cmp(":-",[LT,RT]),S),
	Rep:repWL(0,Lc,":"),
	sx::sxBlockNL(0,70,S,BS),
	Rep:repWL(0,BS),
	Rep:repLine(' '),
	!.
writeRecords(Rep,1,_,9,L) :-
	% PR
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,_,LT,RT),
	nl::cprRecord(LT,RT,S),
	Rep:repWL(0,Lc,":"),
	sx::sxBlockNL(0,70,S,BS),
	Rep:repWL(0,BS),
	!.
writeRecords(Rep,-1,-1,_,L) :-
	% untranslated
	sx::sxUnpackS(L,"||",La),
	set::size(La,N),
	N=2,
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,_,LT,RT),
	S=toString(cmp(":-",[LT,RT])),
	S=toString(cmp(":-",[LT,RT])),
	Rep:repWL(0,S),
	!.
writeRecords(Rep,-1,_,1,L) :-
	% NL 
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,R,_,_,_,_,_,_,_,_,LT,RT),
	nl::conRecord(R,cmp(":-",[LT,RT]),S),
	Rep:repWL(0,S),
	!.
writeRecords(Rep,-1,_,9,L) :-
	% PR
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,_,LT,RT),
	nl::cprRecord(LT,RT,S),
	Rep:repWL(0,S),
	!.
% ---------------------------------------------------------------------------------------------------------------
% writeRecsServer
% ---------------------------------------------------------------------------------------------------------------
class predicates
writeRecordsServer : (odbcConnection,string,integer,integer,string) determ.
clauses

% parameters:
% 1 in  output format
% 2	in	record-list
%
writeRecsServer(ODBC,Form,List) :-
    C=count::new(0),
    R=globalVars::get_i("request_no"),
    Rs=toString(R),
    currentNo:=List:getCount(),
    programControl::repeat,
        List:getNext(currentNo,L,Count),
        currentNo:=Count,
        writeRecordsServer(ODBC,Rs,Count,Form,L),
        C:inc(Max),
        Count=-1,
        SMax=toString(Max),
        S=string::concatList(["update p3request set no_of_solutions=",SMax," where request_no=",Rs]),
        sqlTools::executeDirect(ODBC,S),
        !.

writeRecordsServer(_,_,_,_,"") :-
	!.
writeRecordsServer(ODBC,Rs,N,1,L) :-
	% NL 
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,R,_,_,_,_,_,_,_,_,LT,RT),
	nl::conRecord(R,cmp(":-",[LT,RT]),S2),
    Ns=toString(N),
    S=string::concatList(["insert into p3response (request_no,line_no,line) values (",Rs,",",Ns,",'",S2,"')"]),
    sqlTools::executeDirect(ODBC,S),
	!.
writeRecordsServer(ODBC,Rs,N,9,L) :-
	% PR
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,_,LT,RT),
	S=toString(cmp(":-",[LT,RT])),
	nl::cprRecord(LT,RT,S2),
    Ns=toString(N),
    S=string::concatList(["insert into p3response (request_no,line_no,line) values (",Rs,",",Ns,",'",S2,"')"]),
    sqlTools::executeDirect(ODBC,S),
	!.
% ---------------------------------------------------------------------------------------------------------------
% writeRecsMulti
% ---------------------------------------------------------------------------------------------------------------
class predicates
writeRecordsMulti : (outFile,integer,integer,string) determ.
clauses

% parameters:
% 1 in  
% 3	in	single window output: blank
%		multiwindow output: current ST (@ at first call)
%
writeRecsMulti(File,Out,TT,ST,List) :-
    currentST:=ST,
    currentNo:=List:getCount(),
    programControl::repeat,
        List:getNext(currentNo,L,Count),
        currentNo:=Count,
        writeRecordsMulti(File,Out,TT,L),
        Count=-1,
        !.

writeRecordsMulti(File,_,_,"") :-
	FileName=File:getName(),
	File:close(),
	editorWindow::openFiles([FileName]),
	!.
writeRecordsMulti(File,Out,TT,L) :-
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,_,_),
	STk<>currentST, % new ST
	currentST:=STk,
	FileName=File:getName(),
	File:close(),
	editorWindow::openFiles([FileName]),
	dbBase::stNL(STk,STn),
   	P=globalVars::get_s("std_path"),
   	fioExt::file_type(Out,Type),
    fioExt::makeFileName(STn,Type,Name),
    NFileName=string::concat(P,"\\",Name),   	
	NextFile=outFile::new(NFileName,Out),
	writeRecordsMulti(NextFile,Out,TT,L),
	!
;
	Out=1, % NL
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,R,_,_,_,_,_,_,_,STk,LT,RT),
	STk=currentST,
	nl::conRecord(R,cmp(":-",[LT,RT]),S),
	File:writenl(S),
	!
;
	Out=9, % PR
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,LT,RT),
	STk=currentST,
	nl::cprRecord(LT,RT,Sb),
	File:writenl(Sb),
	!.
% ---------------------------------------------------------------------------------------------------------------
% writeRecTables
% ---------------------------------------------------------------------------------------------------------------
class predicates
writeRecordsTables : (string) determ.
clauses

writeRecTables(List) :-
    currentST:="",
    currentNo:=List:getCount(),
    programControl::repeat,
        List:getNext(currentNo,L,Count),
        currentNo:=Count,
        writeRecordsTables(L),
        Count=-1,
        !.

writeRecordsTables("") :-
	SR=globalVars::get_i("solint"),
    stb::openTableWindow(SR,1),
    !.
writeRecordsTables(L) :-
	currentST="",
	% table windows
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,_,_),
    globalVars::decr("solint",_,SR),
	table::tabGenEmpty(SR,1,STk),
	currentST:=STk,
	writeRecordsTables(L),
	!
;
	% table windows
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,_,_),
	STk<>currentST,
	SR=globalVars::get_i("solint"),
    stb::openTableWindow(SR,1),
    globalVars::decr("solint",_,SRn),
	table::tabGenEmpty(SRn,1,STk),
	currentST:=STk,
	writeRecordsTables(L),
	!
;
	% table windows
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,LT,_),
	STk=currentST,
	SR=globalVars::get_i("solint"),
	table::tabGenCellsIF(SR,1,LT),
	!.
% ---------------------------------------------------------------------------------------------------------------
% writeRecTablesServer
% ---------------------------------------------------------------------------------------------------------------
class predicates
writeRecordsTablesServer : (count,odbcConnection,string) determ.
clauses

writeRecTablesServer(ODBC,List) :-
    currentST:="",
    currentNo:=List:getCount(),
    TableCount=count::new(0),
    programControl::repeat,
        List:getNext(currentNo,L,Count),
        currentNo:=Count,
        writeRecordsTablesServer(TableCount,ODBC,L),
        Count=-1,
        N=TableCount:get(),
        Ns=toString(N),
        R=globalVars::get_i("request_no"),
        Rs=toString(R),
        S=string::concatList(["update p3request set no_of_solutions=",Ns," where request_no=",Rs]),
        sqlTools::executeDirect(ODBC,S),
        !.

writeRecordsTablesServer(TableCount,ODBC,"") :-
	SR=globalVars::get_i("solint"),
	TableCount:inc(TableNo),
	proc::proOpenTableODBC(ODBC,SR,1,TableNo),
    !.
writeRecordsTablesServer(TableCount,ODBC,L) :-
	currentST="",
	% table windows
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,_,_),
    globalVars::decr("solint",_,SR),
	table::tabGenEmpty(SR,1,STk),
	currentST:=STk,
	writeRecordsTablesServer(TableCount,ODBC,L),
	!
;
	% table windows
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,_,_),
	STk<>currentST,
	SR=globalVars::get_i("solint"),
	TableCount:inc(TableNo),
	proc::proOpenTableODBC(ODBC,SR,1,TableNo),   
    globalVars::decr("solint",_,SRn),
	table::tabGenEmpty(SRn,1,STk),
	currentST:=STk,
	writeRecordsTablesServer(TableCount,ODBC,L),
	!
;
	% table windows
	sx::sxUnpackS(L,"||",La),
	La=[_,Lc],
	sx::sxGetInBrack(Lc,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,_,_,_,STk,LT,_),
	STk=currentST,
	SR=globalVars::get_i("solint"),
	table::tabGenCellsIF(SR,1,LT),
	!.
% ---------------------------------------------------------------------------------------------------------------
% dlgTranslate
% ---------------------------------------------------------------------------------------------------------------
dlgTranslate(1,D,S,Term) :- 
	dbExtension::kbScanTerm(D,S,Term),
	!
;
	dlgIF::dlgNote(1,"Translation of term failed"),!,fail.
dlgTranslate(-1,_,S,Term) :-
	Term=toTerm(S),
	!
;
	dlgIF::dlgNote(1,"Invalid search term structure"),!,fail.
end implement allabout
