/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement annotation
open core, vpiDomains, resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/annotation/annotation".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
allNodes : string_list := []. % all nodes
allAnnos : string_list := []. % all annotations

predicates
dmRepop : (vpiDomains::windowHandle,string) determ.

clauses
    new(Parent):-
        _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                            windowFlags, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
	vpi::cursorSetWait(),
   	guix::setStyle(thisWin,[idc_nodetype,idc_edit,idc_save,idc_update,idc_delete,idct_node_type,idct_node,idc_nodes,idc_node,idc_sel,idc_refresh],[]),
	guix::addWin(111,thisWin),
   	guix::ctlDisable(thisWin,[idc_save,idc_update,idc_delete]),
	Lang=globalVars::get_s("lang"),
    cache::loadTmConditionally(Lang),
	dep::nodTypes(_,L3u),
	set::distinct(L3u,L3),
	dbBase::nlSing("p3_iAll",All),
	L2=pop::getAnnoNL(),
	L4=pop::getNodesNL(),
	guix::lbxPop(thisWin,idc_nodetype,[All|L3]),
	guix::lbxPop(thisWin,idc_node,L2),
	guix::lbxPop(thisWin,idc_nodes,L4),
	allNodes:=L4,
	allAnnos:=L2,
    !;!.

    predicates
    onControlidc_refresh : vpiDomains::controlHandler.
clauses
    onControlidc_refresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	Lang=globalVars::get_s("lang"),
    cache::loadTmConditionally(Lang),
	dep::nodTypes(_,L3u),
	set::distinct(L3u,L3),
	dbBase::nlSing("p3_iAll",All),
	L2=pop::getAnnoNL(),
	L4=pop::getNodesNL(),
	guix::lbxPop(thisWin,idc_nodetype,[All|L3]),
	guix::lbxPop(thisWin,idc_node,L2),
	guix::lbxPop(thisWin,idc_nodes,L4),
	allNodes:=L4,
	allAnnos:=L2,
   	guix::ctlDisable(thisWin,[idc_save,idc_update,idc_delete]),
    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin).

/* all nodes of type */
        
    predicates
        onControlnodetype : vpiDomains::controlHandler.
    clauses
        onControlnodetype(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=selchanged(),
  	guix::lbtGet(thisWin,idc_nodetype,Type),
	dmRepop(thisWin,Type),
  	!;!.

/* select node */
        
    predicates
        onControlnodes : vpiDomains::controlHandler.
    clauses
        onControlnodes(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=selchanged(),
  	guix::lbtGet(thisWin,idc_nodes,S),
  	C=vpi::winGetCtlHandle(thisWin,idc_node),
  	L=vpi::lboxGetAll(C),
  	set::member(S,L),
	% node has annotation
	guix::lbtSel(thisWin,idc_node,S),
	%guix::txtSet(thisWin,idc_node,S),
  	sx::sxUnpackS(S,": ",L2),
  	L2=[Type,Node],
  	dbExtension::kbGetAnnoNL(Type,Node,Note),
  	guix::txtSet(thisWin,idc_edit,Note),
  	guix::ctlEnable(thisWin,[idc_update,idc_delete]),
	guix::ctlDisable(thisWin,[idc_save]),
	!
  ;	
    CtrlInfo=selchanged(),
  	% node does not have annotation
  	guix::txtSet(thisWin,idc_edit,""),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_node),
	vpi::lboxGetSel(Ctl,_,ISels),
	ISels=[Selected],
	vpi::lboxSetSel(Ctl,Selected,b_False),
  	guix::ctlDisable(thisWin,[idc_update,idc_delete]),
	guix::ctlEnable(thisWin,[idc_save]),
	!;!.

/* select annotated node */

    predicates
        onControlnode : vpiDomains::controlHandler.
    clauses
        onControlnode(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=selchanged(),
  	guix::lbtGet(thisWin,idc_node,S),
  	sx::sxUnpackS(S,": ",L),
  	L=[Type,Node],
  	dbExtension::kbGetAnnoNL_F(Type,Node,Note),
  	guix::txtSet(thisWin,idc_edit,Note),
  	guix::ctlEnable(thisWin,[idc_update,idc_delete]),
	guix::ctlDisable(thisWin,[idc_save]),
	!
;	
    CtrlInfo=selchanged(),
  	guix::txtSet(thisWin,idc_edit,""),
  	guix::ctlDisable(thisWin,[idc_update,idc_delete]),
	guix::ctlEnable(thisWin,[idc_save]),
	!;!.

    predicates
        onControlsave : vpiDomains::controlHandler.
    clauses
        onControlsave(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_nodes,S),
	sx::sxUnpackS(S,": ",L),
	L=[Type,Node],
	dbBase::kbID(Type,Kt,_,_),
	dbBase::kbSym_to_IF(Node,Kn),
	guix::txtGet(thisWin,idc_edit,Note),	
  	dbBase::recordInsert(2,"$DAT",0,0,cmp("p3_pIntd",[cmp("p3_eAnno",[atom(Kt),termDomain::str(Kn),termDomain::str(Note)])]),atom("true"),_),
	C2=vpi::winGetCtlHandle(thisWin,idc_node),
	vpi::lboxAdd(C2,S),
	allAnnos:=[S|allAnnos],
	dbBase::nlSing("p3_iAnno",Ann),
	sx::concat([Ann,": ",S],S2),
    allNodes:=[S2|allNodes],
    guix::lbxPop(thisWin,idc_nodes,allNodes),
  	sx::concat(["Annotation for ",Node," inserted"],Mess),
	guix::ctlDisable(thisWin,[idc_save,idc_update,idc_delete]),
  	dlgIF::dlgNote(0,Mess),
	!;!.	

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_node,S),
  	sx::sxUnpackS(S,": ",L),
  	L=[Type,Node],
	dbBase::kbID(Type,Kt,_,_),
	dbBase::kbSym_to_IF(Node,Kn),
	dbExtension::kbGetAnnotation(Kt,Kn,_,Loc),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,No,SubNo,_,_,_),
	guix::txtGet(thisWin,idc_edit,Note),
  	dbBase::recordDelete(Loc),
  	dbBase::recordInsert(2,Realm,No,SubNo,cmp("p3_pIntd",[cmp("p3_eAnno",[atom(Kt),termDomain::str(Kn),termDomain::str(Note)])]),atom("true"),_),
  	sx::concat(["Annotation for ",Node," updated"],Mess),
  	dlgIF::dlgNote(0,Mess),
	!;!.

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbtGet(thisWin,idc_node,S),
  	sx::sxUnpackS(S,": ",L),
  	L=[Type,Node],
	dbBase::kbID(Type,Kt,_,_),
	dbBase::kbSym_to_IF(Node,Kn),
	dbExtension::kbGetAnnotation(Kt,Kn,_,Loc),
  	dbBase::recordDelete(Loc),
	guix::txtSet(thisWin,idc_edit,""),
	guix::lbxDelS(thisWin,idc_node,S),
  	sx::concat(["Annotation for ",Node," deleted"],Mess),
  	dlgIF::dlgNote(0,Mess),
	!;!.

% This code is maintained by the VDE do not update it manually, 15:54:08-24.10.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,630,571).
    menu : vpiDomains::menu = noMenu.
    title : string = "Annotations".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBoxButton,rct(136,4,514,456),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_nodetype),
        _ = vpi::winCreateControl(wc_Edit,rct(10,152,520,449),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_MultiLine],idc_edit),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,460,128,484),"Save New",Win,[wsf_Group,wsf_TabStop],idc_save),
        _ = vpi::winCreateControl(wc_PushButton,rct(138,460,258,484),"Update",Win,[wsf_Group,wsf_TabStop],idc_update),
        _ = vpi::winCreateControl(wc_PushButton,rct(268,460,388,484),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_Text,rct(10,7,132,27),"Node types",Win,[wsf_AlignLeft],idct_node_type),
        _ = vpi::winCreateControl(wc_Text,rct(10,105,520,122),"All knowledge nodes with annotations",Win,[wsf_AlignCenter],idct_node),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(8,60,518,488),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_nodes),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(8,124,518,500),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_node),
        _ = vpi::winCreateControl(wc_Text,rct(8,40,518,60),"Nodes of selected type",Win,[wsf_AlignCenter],idc_sel),
        _ = vpi::winCreateControl(wc_PushButton,rct(400,460,520,484),"Refresh",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_nodetype, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnodetype(idc_nodetype, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_nodes, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnodes(idc_nodes, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_node, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnode(idc_node, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsave(idc_save, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_refresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
% --------------------------------------------------------------------------------------------
% dmRepop
% --------------------------------------------------------------------------------------------
class predicates
dmRepopX : (string,string_list,string_list) determ (i,i,o).
clauses

dmRepop(W,Type) :- 
	dbBase::nlSing("p3_iAll",All),
	Type=All,
	guix::lbxPop(W,idc_nodes,allNodes),
	guix::lbxPop(W,idc_node,allAnnos),
	!
;	
	Prefix=string::concat(Type,": "),
	dmRepopX(Prefix,allNodes,L2),
	guix::lbxPop(W,idc_nodes,L2),
	dmRepopX(Prefix,allAnnos,L3),
	guix::lbxPop(W,idc_node,L3),
	!.

dmRepopX(_,[],[]) :-
	!.
dmRepopX(Prefix,[H|T],[H|Tm]) :-
	sx::searchstring(H,Prefix,P),
	P=1,
	dmRepopX(Prefix,T,Tm),
	!.
dmRepopX(Prefix,[_|T],Tm) :-
	dmRepopX(Prefix,T,Tm),
	!.
end implement annotation
