/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement backup
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/backup".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.

    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_terminology,idc_sentence_model,idc_functions,idc_sr,idc_query,idc_cr,idc_cr_nl,
  	                   idc_annotations,idc_application_sentences,idct_info1,idct_info2,idc_ok,idc_tl_xml,idc_tl_nl,idc_inpfac,
  	                   idc_term_xml,idc_term_nl,idc_sm_xml,idc_sm_nl,idc_ann_nl,idc_ann_xml,idc_ch_xml,idc_ch_nl,
  	                   idct_txt_1,idc_txt_2,idc_as_xml,idc_as_nl,idc_func_xml,idc_layout,idc_chains],[]),
        guix::addWin(116,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
	!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
	guix::dropWin(thisWin),
	vpi::winDestroy(thisWin),
    !.
    
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_terminology,Btm),
	guix::guiCB_Get(thisWin,idc_term_xml,Txml),
	guix::guiCB_Get(thisWin,idc_term_nl,Tnl),
	guix::guiCB_Get(thisWin,idc_sentence_model,Bsm),
	guix::guiCB_Get(thisWin,idc_sm_xml,Sxml),
	guix::guiCB_Get(thisWin,idc_sm_nl,Snl),
	guix::guiCB_Get(thisWin,idc_annotations,Ban),
	guix::guiCB_Get(thisWin,idc_ann_xml,ANxml),
	guix::guiCB_Get(thisWin,idc_ann_nl,ANnl),
	guix::guiCB_Get(thisWin,idc_functions,Bfu),
	guix::guiCB_Get(thisWin,idc_func_xml,Fxml),
	guix::guiCB_Get(thisWin,idc_application_sentences,Bas),
	guix::guiCB_Get(thisWin,idc_as_xml,ASxml),
	guix::guiCB_Get(thisWin,idc_as_nl,ASnl),
	guix::guiCB_Get(thisWin,idc_sr,Bsr),
	guix::guiCB_Get(thisWin,idc_query,Bqr),
	guix::guiCB_Get(thisWin,idc_cr,Bcr),
	guix::guiCB_Get(thisWin,idc_cr_nl,Bcrnl),
	guix::guiCB_Get(thisWin,idc_inpfac,Inpfac),
	guix::guiCB_Get(thisWin,idc_layout,Btl),
	guix::guiCB_Get(thisWin,idc_tl_xml,TLxml),
	guix::guiCB_Get(thisWin,idc_tl_nl,TLnl),
	guix::guiCB_Get(thisWin,idc_chains,Bch),
	guix::guiCB_Get(thisWin,idc_ch_xml,CHxml),
	guix::guiCB_Get(thisWin,idc_ch_nl,CHnl),
	bck::bckRun(Btm,Txml,Tnl,Bsm,Sxml,Snl,Ban,ANxml,ANnl,Bfu,Fxml,1,Bas,ASxml,ASnl,Bsr,Bqr,Bcr,Bcrnl,Btl,TLxml,TLnl,Bch,CHxml,CHnl,Inpfac),
	guix::dropWin(thisWin),
	vpi::winDestroy(thisWin),
	!;!.

    % This code is maintained by the VDE do not update it manually, 22:51:40-15.10.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,454,503).
    menu : vpiDomains::menu = noMenu.
    title : string = "Source Backup".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,112,217,132),"Terminology",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_terminology),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,136,217,156),"Sentence model",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_sentence_model),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,208,217,228),"Functions",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_functions),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,160,217,180),"Annotations",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_annotations),
        _ = vpi::winCreateControl(wc_Text,rct(9,4,348,54),"Note that backups always exclude knowledge in PRO3xxx realms (Pro/3 standard knowlege). This is always available in the standard knowledge files.",Win,[wsf_AlignLeft],idct_info1),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,304,217,324),"Application sentences",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_application_sentences),
        _ = vpi::winCreateControl(wc_Text,rct(8,58,347,109),"Function/Inexact rule declarations are backed up with the function/inexact rule definitions (not with the sentence model backup). ",Win,[wsf_AlignLeft],idct_info2),
        _ = vpi::winCreateControl(wc_PushButton,rct(88,384,256,416),"OK",Win,[wsf_Group,wsf_TabStop],idc_ok),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,280,217,300),"Sentence rules",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_sr),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,184,217,204),"Queries and query menus",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_query),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,232,217,252),"Inexact rules",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_cr),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,232,333,252),"NL",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_cr_nl),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,304,277,324),"XML",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_as_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,304,333,324),"NL",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_as_nl),
        _ = vpi::winCreateControl(wc_Text,rct(224,232,277,252),"XML",Win,[wsf_AlignLeft],idct_txt_1),
        _ = vpi::winCreateControl(wc_Text,rct(224,280,277,300),"XML",Win,[wsf_AlignLeft],idc_txt_2),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,112,333,132),"NL",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_term_nl),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,112,277,132),"XML",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_term_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,136,333,156),"NL",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_sm_nl),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,136,277,156),"XML",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_sm_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,160,333,180),"NL",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_ann_nl),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,160,277,180),"XML",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_ann_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,208,277,228),"XML",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_func_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,328,217,348),"Table layouts",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_layout),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,352,217,372),"Public chain declarations",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_chains),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,328,333,348),"NL",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_tl_nl),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,328,277,348),"XML",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_tl_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(280,352,333,372),"NL",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_ch_nl),
        _ = vpi::winCreateControl(wc_CheckBox,rct(224,352,277,372),"XML",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_ch_xml),
        _ = vpi::winCreateControl(wc_CheckBox,rct(8,256,217,276),"Input facilities",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_inpfac),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement backup
