/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement createcluster
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/createcluster".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
    thisWin : vpiDomains::windowHandle := erroneous.

clauses
    show(Parent):-
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
eventHandler : vpiDomains::ehandler.
create : (string,string) determ.
displayCluster : (string,string) determ.

clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    Db=sqlBase::getDb(),
    Kb=sqlBase::getKb(),
    displayCluster(Db,Kb),
    !;!.
    
predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    Db=sqlBase::getDb(),
    Kb=sqlBase::getKb(),
    create(Db,Kb),
    vpi::winDestroy(thisWin),
    !;!.

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	dlgIF::hlpWeb("w_Cluster"),
	!;!.

predicates
    onControlidc_reset : vpiDomains::controlHandler.
clauses
    onControlidc_reset(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::txtGet(thisWin,idc_cluster,Cluster),
    Cluster<>"",
    Reply=vpiCommonDialogs::ask("Please confirm","Do you want to empty the cluster's open share?",["Yes","No"]),
    cluster::reset(Cluster,Reply),
    guix::ctlDisable(thisWin,[idc_no,idc_cluster,idc_stream,idc_share,idc_ok,idc_reset]),    
    dlgIF::dlgNote(0,"Cluster has been reset!"),
    !;!.

% This code is maintained by the VDE do not update it manually, 12:01:43-29.5.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Create/View/Update Cluster".
    rectangle : vpiDomains::rct = rct(50,40,358,265).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(36,210,112,222),"Create",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(196,210,272,222),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(72,32,200,44),"",u_DlgBase),idc_share,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(72,46,200,58),"",u_DlgBase),idc_stream,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(72,18,144,30),"",u_DlgBase),idc_cluster,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_LBox,rct(4,76,304,206),"",u_DlgBase),idc_members,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight]),
        ctl(wdef(wc_Edit,rct(72,4,108,16),"",u_DlgBase),idc_no,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_PushButton,rct(116,210,192,222),"Reset",u_DlgBase),idc_reset,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Text,rct(4,32,68,42),"Publishing net",u_DlgBase),idct_open_shares_publishing_net,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,46,68,56),"Knowledge stream",u_DlgBase),idct_knowledge_stream,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,18,68,28),"Cluster",u_DlgBase),idct_cluster,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,68,304,76),"Members",u_DlgBase),idct_knowledge_stream1,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(4,4,68,14),"Member#",u_DlgBase),idct_member,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(204,46,306,64),"Stream table must be qualified with SQL database name!",u_DlgBase),idct_table_must_be_qualified_with_an_sql_database_name,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(204,34,306,44),"where open share is contained",u_DlgBase),idct_where_open_share_is_contained,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_reset, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_reset(idc_reset, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code

% ----------------------------------------------------------------------------------------------
% createCluster
% ----------------------------------------------------------------------------------------------
create(Db,Kb) :-
    guix::txtGet(thisWin,idc_cluster,Cluster),
    Cluster="",
    dlgIF::dlgNote(0,"Enter a name for the new cluster!"),
    !,fail
;    
    guix::txtGet(thisWin,idc_share,Net),
    not(sqlSt::getNet(Net,_,_,_,_)),
    dlgIF::dlgNote(0,"Enter an existing publishing net (where open share is contained)!"),
    !,fail
;    
    guix::txtGet(thisWin,idc_share,Net),
    sqlSt::getNet(Net,Share,_,_,_),
    Share=0,
    dlgIF::dlgNote(0,"The entered publishing net does not contain an open share!"),
    !,fail
;
    guix::txtGet(thisWin,idc_cluster,Cluster),
    Con=sqlBase::getConnection(),
    Sql=string::concat("select knowledge_stream from p3publications.cluster where cluster_name='",Cluster,"'"),
    Select=sqlSelect::new(Con,Sql),
    N=Select:getNRows(),
    N>0,
    dlgIF::dlgNote(0,"Cluster with this name already exists!"),
    !,fail
;
    guix::txtGet(thisWin,idc_cluster,Cluster),
    guix::txtGet(thisWin,idc_share,Share),
    guix::txtGet(thisWin,idc_stream,Stream),
	datetime::tsNow(Ts),
    datetime::tsSQL(Ts,T),
    Con=sqlBase::getConnection(),
    Sql1=string::concatList(["insert p3publications.cluster (cluster_name,net_name,knowledge_stream) values ('",Cluster,"','",Share,"','",Stream,"')"]),
    sqlTools::executeDirect(Con,Sql1),    
    Sql2=string::concatList(["insert p3publications.cluster_member (cluster_name,kb,member_no,last_share,last_derivation,complete) values ('",Cluster,"','",Db,".",Kb,"',0,'",T,"','",T,"',0)"]),
    sqlTools::executeDirect(Con,Sql2),
    dlgIF::dlgNote(0,"Cluster created!"),
    guix::ctlDisable(thisWin,[idc_no,idc_cluster,idc_stream,idc_share,idc_ok]),    
    !.    
% ----------------------------------------------------------------------------------------------
% displayCluster
% ----------------------------------------------------------------------------------------------
displayCluster(Db,Kb) :-
    Con=sqlBase::getConnection(),
    % check if cluster member
    Sql1=string::concat("select cluster_name,member_no from p3publications.cluster_member where kb='",Db,".",Kb,"'"),
    Select1=sqlSelect::new(Con,Sql1),
    N1=Select1:getNRows(),
    N1>0,
    guix::ctlEnable(thisWin,[idc_reset]),
    guix::ctlDisable(thisWin,[idc_ok,idc_cluster,idc_stream,idc_share]),
    Cluster=Select1:getS(1,1),
    No=Select1:getI(1,2),
    guix::txtSet(thisWin,idc_cluster,Cluster),
    guix::txtSetI(thisWin,idc_no,No),
    %
    Sql2=string::concat("select knowledge_stream,net_name from p3publications.cluster where cluster_name='",Cluster,"'"),
    Select2=sqlSelect::new(Con,Sql2),
    N2=Select2:getNRows(),
    N2>0,
    Stream=Select2:getS(1,1),
    Share=Select2:getS(1,2),
    guix::txtSet(thisWin,idc_stream,Stream),
    guix::txtSet(thisWin,idc_share,Share),
    %
    Sql3=string::concat("select kb,member_no,last_share,last_derivation,complete from p3publications.cluster_member where cluster_name='",Cluster,"' order by member_no"),
    Select3=sqlSelect::new(Con,Sql3),
    N3=Select3:getNRows(),
    N3>0,
    Nc=programControl::sequence_nd(1,N3,1),
        Kbm=Select3:getS(Nc,1),
        No1=Select3:getI(Nc,2),
        LastS=Select3:getDT(Nc,3),
        LastD=Select3:getDT(Nc,4),
        Comp=Select3:getI(Nc,5),
        Nos=toString(No1),
        set::setGet([0,1],Ix,Comp),
        set::setGet(["COMPLETE","NOT COMPLETE"],Ix,S2),
        S=string::concatList(["#",Nos," ",Kbm," ",LastS,"/",LastD," ",S2]),
        guix::lbxAdd(thisWin,idc_members,S),
        Nc=1,
        fail
;
    Con=sqlBase::getConnection(),
    Sql1=string::concat("select cluster_name,member_no from p3publications.cluster_member where kb='",Db,".",Kb,"'"),
    Select1=sqlSelect::new(Con,Sql1),
    N1=Select1:getNRows(),
    N1=0,
    % not a cluster member
    guix::ctlEnable(thisWin,[idc_cluster,idc_stream,idc_share,idc_ok]),
    guix::ctlDisable(thisWin,[idc_no,idc_reset]),
    guix::txtSet(thisWin,idc_no,"0"),
    !.        
end implement createcluster
