/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement dependents
open core,vpiDomains,resourceIdentifiers,termDomain,globalDomains

constants
        className = "com/rudstrand/TaskWindow/dependents".
        classVersion = "1.0".

clauses
        classInfo(className, classVersion).

facts
        thisWin : vpiDomains::windowHandle := erroneous.
        depList : string_list := [].
        mode : integer := 0. 
        node : string := "".
            
predicates
usePars : () determ.
chkSD_Node : (integer,string_list) determ (i,i).
nodeToNLR : (string,sterm) determ (i,o).

clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
        eventHandler : vpiDomains::ehandler.
clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

/* report */

    predicates
        onControlreport : vpiDomains::controlHandler.
    clauses
        onControlreport(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,idc_node,Node),
	guix::lbxGetAll(thisWin,idc_deps,Deps),
	sx::sxlJoin(Deps,"\n",S2),
	S=string::concat("Dependents of '",Node,"':\n\n",S2),
	file::writeString("Dependents.3rp",S),
	W=guix::getWinOfClas(1),
    _=editorWindow::new(W,"Dependents.3rp",-1),
	!;!.

/* delete */

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
  	guix::lbxGetMulti(thisWin,idc_deps,L),
  	set::size(L,N),
  	N>0,
  	chkSD_Node(2,L),
 	guix::lbxDelSetS(thisWin,idc_deps,L),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
  	guix::lbxGetMulti(thisWin,idc_deps,L2),
  	set::size(L2,N2),
  	N2=0,
  	_=vpi::winSendEvent(thisWin,e_CloseRequest),
	!;!.

/* ignore */

    predicates
        onControlignore : vpiDomains::controlHandler.
    clauses
        onControlignore(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	Reply=vpiCommonDialogs::ask("This can result in KB integrity problems - OK?",["Yes","No"]),
  	Reply=vpiCommonDialogs::resp_default,
	globalVars::pushRetPars(["0"]), % delete!
	vpi::winDestroy(thisWin),
	!;!.

/* suspend */

    predicates
        onControlsuspend : vpiDomains::controlHandler.
    clauses
        onControlsuspend(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
  	guix::lbxGetMulti(thisWin,idc_deps,L),
  	set::size(L,N),
  	N>0,
  	chkSD_Node(1,L),
 	guix::lbxDelSetS(thisWin,idc_deps,L),
	vpi::cursorSet(thisWin,vpiDomains::cursor_arrow),
  	guix::lbxGetMulti(thisWin,idc_deps,L2),
  	set::size(L2,N2),
  	N2=0,
  	_=vpi::winSendEvent(thisWin,vpiDomains::e_CloseRequest),
	!;!.

/* ok */

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	_=vpi::winSendEvent(thisWin,vpiDomains::e_CloseRequest),
	!;!.

/* cancel */

    predicates
        onControlcancel : vpiDomains::controlHandler.
    clauses
        onControlcancel(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	globalVars::pushRetPars(["1"]), % cancel delete!
	vpi::winDestroy(thisWin),
	!;!.

/* help */

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpWeb("integrity"),
	!;!.

/* create/close */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
    usePars,
    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling() :-
    mode=0,
	vpi::winDestroy(thisWin),
	!
;
	guix::lbxGetAll(thisWin,idc_deps,L),
	set::size(L,N),
	N=0,
	globalVars::pushRetPars(["0"]), % delete!
  	vpi::winDestroy(thisWin),
	!
;	
	guix::lbxGetAll(thisWin,idc_deps,L),
	set::size(L,N),
	N>0,
	Reply=vpiCommonDialogs::ask("There are still undeleted/unsuspended dependents - original delete/update cannot be processed. Quit delete/update?",["Yes","No"]),
	Reply=vpiCommonDialogs::resp_default,
	globalVars::pushRetPars(["1"]), % cancel delete!
  	vpi::winDestroy(thisWin),
	!;!.

    % This code is maintained by the VDE do not update it manually, 17:08:55-18.1.2005
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "Structural dependents".
        rectangle : vpiDomains::rct = rct(50,40,364,316).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 8.

    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(273,261,310,273),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(4,2,309,14),"",u_DlgBase),idc_node,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly]),
            ctl(wdef(wc_LBox,rct(4,36,310,243),"",u_DlgBase),idc_deps,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_MultiSelect]),
            ctl(wdef(wc_PushButton,rct(2,261,61,273),"Suspend Selected",u_DlgBase),idc_suspend,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(63,261,114,273),"Delete Selected",u_DlgBase),idc_delete,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(233,261,270,273),"Cancel",u_DlgBase),idc_cancel,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(155,261,192,273),"Ok",u_DlgBase),idc_ok,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(174,214,186,226),"",u_DlgBase),idc_mode,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_PushButton,rct(116,261,153,273),"Ignore",u_DlgBase),idc_ignore,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(194,261,231,273),"Report",u_DlgBase),idc_report,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Text,rct(3,16,310,34),"You are changing or deleting the above knowledge node. The knowledge nodes under must first be deleted or suspended to avoid potential KB integrity problems.",u_DlgBase),idct_the_foll,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(2,244,310,260),"Note! Classes of sentences (i.e. of a certain sentence type or group), cannot be suspended and will be deleted even when 'Suspend Selected' is pressed.",u_DlgBase),idct_info,[wsf_AlignLeft])
            ].

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_report, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlreport(idc_report, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ignore, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlignore(idc_ignore, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_suspend, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsuspend(idc_suspend, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
% ----------------------------------------------------------------------------------------------
% setPars;usePars
% ----------------------------------------------------------------------------------------------
setPars(Deps,Node,Mode) :-
    depList:=Deps,
    node:=Node,
    mode:=Mode,
    !.
    
usePars() :-
    mode=1,    
    depList=[],
	globalVars::pushRetPars(["0"]), % delete! 
  	vpi::winDestroy(thisWin),
	!
;
    mode=1,    
    L=depList,
    guix::lbxPop(thisWin,idc_deps,L),
	guix::lbxMultiSel(thisWin,idc_deps,L),
	Node=node,
	guix::txtSet(thisWin,idc_node,Node),
	!
;
    mode=0,
    L=depList,
    guix::lbxPop(thisWin,idc_deps,L),
	Node=node,
	guix::txtSet(thisWin,idc_node,Node),
  	guix::ctlInvisible(thisWin,[idct_the_foll,idct_info,idc_suspend,idc_delete,idc_ignore,idc_ok]),
	!.
% ----------------------------------------------------------------------------------------------
% chkSD_Node
% ----------------------------------------------------------------------------------------------
class predicates
chkDel : (integer,dbLoc) determ (i,i).
chk_SD_2 : (integer,sterm) determ (i,i).
chkChain : (string) determ (i).
clauses
% parameters:
% 1	in	1=suspend, 2=delete
% 2	in	node of underlying records to be suspended/deleted
%
chkSD_Node(_,[]) :-
	!.
chkSD_Node(SD,[Dep|Deps]) :-
	nodeToNLR(Dep,Node),
	chk_SD_2(SD,Node),
	chkSD_Node(SD,Deps),
	!.
	
chk_SD_2(SD,cmp(_,[int(T),termDomain::str(N)])) :-
    set::member(T,[0,21,22,24]),
    !
;
	T=1, % predicate type
	Loc=dbBase::smRefF(N),
	chkChain("q"),
	chkDel(SD,Loc),
	!
;
	set::member(T,[2,11,12]), % ST
	sx::sxUnpack(N,'|',L),
	L=[Chain|_],
	chkChain(Chain),
	dbBase::stTypeDelete(0,N,_),
	!
;
	T=3, % SR
	sx::sxUnpack(N,'|',L),
	L=[Ck,R,Ras,Rbs|_],
	chkChain(Ck),
	Ra=sx::toInt(Ras),
	Rb=sx::toInt(Rbs),
	Loc=dbBase::srLocF(Ck,R,Ra,Rb),
	chkDel(SD,Loc),
	!
;
	T=13, % DE
	Loc=dbBase::smRefF(N),
	chkChain("q"),
	chkDel(SD,Loc),
	!
;
	T=14, % ET
	Loc=dbBase::smRef(N),
	chkChain("q"),
	chkDel(SD,Loc),
	!
;
	T=15, % IR def
	dbBase::getIrDefF(N,LT,Loc),
	LT=cmp(Chain,_),
	chkChain(Chain),
	chkDel(SD,Loc),
	!
;
	T=16, % IR dec
	Loc=dbBase::smRefF(N),
	chkChain("q"),
	chkDel(SD,Loc),
	!
;
	T=17, % F dec
	Loc=dbBase::smRefF(N),
	chkChain("q"),
	chkDel(SD,Loc),
	!
;
	T=17,
	SD=2,
	Loc=dbBase::smRefF(N),
	chkChain("q"),
	chkChain(N),
	chkDel(SD,Loc),
	dbBase::chainDelete(N),
	!
;
	T=19, % FB
	SD=1,
	chkChain(N),
	dbBase::chainExists(N),
	dbBase::chainSuspend(N),
	!
;
	T=19, % FB
	SD=2,
	chkChain(N),
	dbBase::chainExists(N),
	dbBase::chainDelete(N),
	!
;
	T=25, % series fac
	Loc=irBase::seriesLocF(N),
	chkChain("p3_pIRinp"),
	dbBase::recordDelete(Loc),
	!
;
	T=26, %  cluster fac
	sx::sxUnpack(N,'|',L),
	L=[R,P],
	Loc=irBase::clusterLocF(R,P),
	chkChain("p3_pIRinp"),
	dbBase::recordDelete(Loc),
	!
;
	T=27, %  table lay
	Loc=dbExtension::tableLayoutLoc(N),
	chkChain("y"),
	dbBase::recordDelete(Loc),
	!
;
	T=28, % kb query
	Tag=sx::toInt(N),
	dbExtension::kbQueryF(Tag,_,_,_,Loc),
	chkChain("y"),
	dbBase::recordDelete(Loc),
	!
;
	T=29, % kb query cluster
	Tag=sx::toInt(N),
	dbExtension::kbQueryF(Tag,_,_,_,Loc),
	chkChain("y"),
	dbBase::recordDelete(Loc),
	!
;
	T=30, % kb query menu
	Tag=sx::toInt(N),
	Loc=dbExtension::kbQueryMenuLocF(Tag),
	chkChain("y"),
	dbBase::recordDelete(Loc),
	!
;
	T=31, % kb query parameter
	dbExtension::kbQueryParF(N,_,_,_,Loc),
	chkChain("y"),
	dbBase::recordDelete(Loc),
	!
;	
    set::member(T,[1,3,13,14,15,16,17,18,19,25,26,27,28,29,30,31]),
    !
;
    Ns=toString(N),
    Mess=string::concat("Unrecognized knowledge graph node type: ",Ns),
	dlgIF::dlgNote(3,Mess),!,fail.	
	
chkDel(1,Loc) :-
    dbBase::recordSuspend(Loc),
	!.
chkDel(2,Loc) :-
	dbBase::recordDelete(Loc),
	!.
chkChain(N) :-
	dbBase::accessErrorChain(N),
	!,fail
;
	!.

% 29.4.4 Note that kbSYM_to_IF fails when translating a SR node name if the realm name also happens to be a NL-name.
%        This is now handled by the special clauses for Ts=3
%
nodeToNLR(SNode,Node) :-
	sx::sxUnpack(SNode,'-',L),
	L=[STyp|_],
	Ts=sx::toInt(STyp),
	Ts=3,
	N3=string::length(STyp)+1,
	sx::frontstr(N3,SNode,_,S2),
	sx::searchchar(S2,':',P),
	P2=P+1,
	sx::frontstr(P2,S2,_,S3),
	sx::sxUnquote(S3,S3u),
	sx::sxUnpack(S3u,'|',L2),
	L2=[NL,B,C,D],
	dbBase::kbID(NL,K,_,_),
	sx::sxlJoin([K,B,C,D],"|",Nd),
	Node=cmp("n",[int(Ts),termDomain::str(Nd)]),
	!
;
	sx::sxUnpackS(SNode,"-",L),
	L=[STyp|_],
	Ts=sx::toInt(STyp),
	Ts<>3,
	N3=string::length(STyp)+1,
	sx::frontstr(N3,SNode,_,S2),
	sx::searchchar(S2,':',P),
	P2=P+1,
	sx::frontstr(P2,S2,_,S3),
	dbBase::kbSym_to_IF(S3,Nd),
	Node=cmp("n",[int(Ts),termDomain::str(Nd)]),
	!
;
	sx::sxUnpackS(SNode,"-",L),
	L=[STyp|_],
	Ts=sx::toInt(STyp),
	Ts=3,
	N3=string::length(STyp)+1,
	sx::frontstr(N3,SNode,_,S2),
	sx::sxUnquote(S2,S2u),
	sx::sxUnpack(S2u,'|',L2),
	L2=[NL,B,C,D],
	dbBase::kbID(NL,K,_,_),
	sx::sxlJoin([K,B,C,D],"|",Nd),
	Node=cmp("n",[int(Ts),termDomain::str(Nd)]),
	!
;
	sx::sxUnpackS(SNode,"-",L),
	L=[STyp|_],
	Ts=sx::toInt(STyp),
	Ts<>3,
	N3=string::length(STyp)+1,
	sx::frontstr(N3,SNode,_,S2),
	dbBase::kbSym_to_IF(S2,Nd),
	Node=cmp("n",[int(Ts),termDomain::str(Nd)]),
	!
;
	dlgIF::feil("nodeToNLR",[SNode],[],nill),!,fail.
	
end implement dependents
