/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement derivation
open core,vpiDomains,resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/derivation".
classVersion = "1.0".

facts
thisWin : vpiDomains::windowHandle := erroneous.

predicates
eventHandler : vpiDomains::ehandler.
setEst : (integer,integer,integer) determ.    

clauses
classInfo(className,classVersion).

new(Parent):-
    _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                        windowFlags, eventHandler, 0).

eventHandler(Win, Event) = Result :-
    Result = generatedEventHandler(Win, Event),
    !.
eventHandler(Win, e_Menu(Id, CAS)) = Result :-
    Parent = vpi::winGetParent(Win),
    Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* print */

    predicates
        onControlprint : vpiDomains::controlHandler.
    clauses
        onControlprint(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGetAll(thisWin,idc_sts,L),
  	sx::sxlJoin(L,"\n",S),
	Path=globalVars::get_s("std_path"),
	fioExt::filGenName(2,Path,"Derivation","3RP",OutFile),
	file::writeString(OutFile,S),
	editorWindow::openFiles([OutFile]),
	!;!.

/* del. all der. */

    predicates
        onControlDeleteAllDerivedSentences : vpiDomains::controlHandler.
    clauses
        onControlDeleteAllDerivedSentences(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
    dlgIF::msgStatus("Deleting all derived sentences..."),
	dbBase::sentenceDerivedDelete(-1),
	der::depList(1,L,N,Secs,All),
	setEst(N,Secs,All),
	der::derPop(thisWin,L),
	guix::ctlDisable(thisWin,[idc_delete_all_derived_sentences,idc_regenerate_dependency_graph,idc_regenerate_indexes]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* regen. dep. graph */

    predicates
        onControlRegenerateDependencyGraph : vpiDomains::controlHandler.
    clauses
        onControlRegenerateDependencyGraph(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::msgStatus("Regenerating dependency graph..."),
	dep::regenDependencyGraph,
	der::depList(1,L,N,Secs,All),
	setEst(N,Secs,All),
	der::derPop(thisWin,L),
	guix::ctlDisable(thisWin,[idc_regenerate_dependency_graph]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* regen. indexes */

    predicates
        onControlRegenerateIndexes : vpiDomains::controlHandler.
    clauses
        onControlRegenerateIndexes(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	dbBase::indexRegen,
	guix::ctlDisable(thisWin,[idc_regenerate_indexes]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

predicates
    onControlidc_sts : vpiDomains::controlHandler.
clauses
    onControlidc_sts(_CtrlID, _CtrlType, _CtrlWin,CtrlInfo) = handled(0) :-
    CtrlInfo=vpiDomains::selchanged(),
  	guix::lbxGet(thisWin,idc_sts,ST),
    string::front(ST,33,_,ST2),
    L=sx::unpack(ST2," ["),
    L=[STn|_],
	sentencemodel::dmAnnoDisplayAsstNL("p3_iST",STn),
	!;!.

/* stop */

    predicates
        onControlStopPoint : vpiDomains::controlHandler.
    clauses
        onControlStopPoint(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxGet(thisWin,idc_sts,ST),
  	guix::lbxGetAll(thisWin,idc_sts,STs),
  	der::derStop(ST,STs,STsm),
  	guix::lbxPop(thisWin,idc_sts,STsm),
	!;!.

/* move down */

    predicates
        onControlMoveDown : vpiDomains::controlHandler.
    clauses
        onControlMoveDown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_sts),
	vpi::lboxGetSel(C,STs,Nos),
	STs=[ST],
	Nos=[No],
	All=vpi::lboxGetAll(C),
	set::size(All,N),
	No<(N-1),
	sx::frontstr(4,ST,SSeq,_),
	Seq=sx::toInt(SSeq),
	Seq2=Seq+1,	
	All=vpi::lboxGetAll(C),
	der::derSwap(Seq,Seq2,All,AllM),
	guix::lbxPop(thisWin,idc_sts,AllM),	
	M=No+1,
	vpi::lboxSetSel(C,M,b_true),
	!;!.

/* move up */

    predicates
        onControlMoveUp : vpiDomains::controlHandler.
    clauses
        onControlMoveUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_sts),
	vpi::lboxGetSel(C,STs,Nos),
	STs=[ST],
	Nos=[No],
	No>0,
	sx::frontstr(4,ST,SSeq,_),
	Seq=sx::toInt(SSeq),
	Seq2=Seq-1,
	All=vpi::lboxGetAll(C),
	der::derSwap(Seq,Seq2,All,AllM),
	guix::lbxPop(thisWin,idc_sts,AllM),	
	M=No-1,
	vpi::lboxSetSel(C,M,b_true),
	!;!.

/* refresh subscriptions */

predicates
    onControlidc_subscribe : vpiDomains::controlHandler.
clauses
    onControlidc_subscribe(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	sqlSt::subscribeAll,
	der::depList(1,L,N,Secs,All),
	setEst(N,Secs,All),
	der::derPop(thisWin,L),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* start */

    predicates
        onControlstart : vpiDomains::controlHandler.
    clauses
        onControlstart(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	tt::getLevel()>1,
	vpiCommonDialogs::resp_default<>vpiCommonDialogs::ask("Please confirm","Do you really want to perform this operation with trace level greater than 1?",["Yes","No"]),
    !
;    
    der::checkIRR_Delete,
	vpi::cursorSetWait(),
                    tt::startProfile("Derivation"),
  	guix::lbxGetAll(thisWin,idc_sts,STs),
  	der::derST_List(STs,L),
  	set::size(L,N),
  	N>0,
	vpi::cursorSetWait(),
	guix::ctlDisable(thisWin,[idc_start,idc_terminate,idc_continue,idc_stop_point,idc_rederive_all,idc_move_up,idc_move_down,
	                 idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences]),
			Rep=rep::newReport(2,"Derived Sentences",70),
			datetime::tsNow(Ts),
			dlgIF::msgStatus("Generating derivation graph..."),
	der::genDerivationGraph,
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE DELETED"), 
			Rep:repWL(0,""),
	der::depDeleteSTs(Rep,thisWin,L),
	globalVars::get_i("quit_flag")=0,
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE DERIVED"), 
			Rep:repWL(0,""),
	der::depDeriveSTs(Rep,thisWin,L,SumST,SumSol),
	dep::cascadeStatusBack("p3_pDP",1),
	der::depDeriveEnd(Rep,Ts,SumST,SumSol),
			Rep:close(),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
	   		Nts=toString(SumST),
	   		Nss=toString(SumSol),
	   		sx::concat([Nss," sentences of ",Nts," types derived - elapsed time ",DiffS,"."],Mess),
			dlgIF::msgStatus(Mess),
                    tt::stopProfile,
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!
;
	dlgIF::msgStatus("Nothing to derive!"),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* continue */

    predicates
        onControlcontinue : vpiDomains::controlHandler.
    clauses
        onControlcontinue(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
  	guix::lbxGetAll(thisWin,idc_sts,STs),
  	der::derST_ListContinue(STs,L,L2),
  	set::size(L,N),
  	N>0,
  	guix::lbxPop(thisWin,idc_sts,L2),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_sts),
	vpi::winUpdate(Ctl),
			Rep=rep::newReport(2,"Derived Sentences",70),
			datetime::tsNow(Ts),
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE DELETED"),
			Rep:repWL(0,""),
	der::depDeleteSTs(Rep,thisWin,L),
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE DERIVED"),
			Rep:repWL(0,""),
	der::depDeriveSTs(Rep,thisWin,L,SumST,SumSol),
	der::depDeriveEnd(Rep,Ts,SumST,SumSol),
			Rep:close(),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
	   		Nts=toString(SumST),
	   		Nss=toString(SumSol),
	   		sx::concat([Nss," sentences of ",Nts," types derived - elapsed time ",DiffS,"."],Mess),
			dlgIF::msgStatus(Mess),
	guix::ctlEnable(thisWin,[idc_terminate]),
	guix::ctlDisable(thisWin,[idc_start,idc_stop_point,idc_rederive_all,
	                 idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!
;
	dlgIF::msgStatus("Nothing to derive!"),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* terminate */

    predicates
        onControlterminate : vpiDomains::controlHandler.
    clauses
        onControlterminate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::dropWin(thisWin),
    dep::depSMM_Regen,
  	vpi::winDestroy(thisWin),
	!;!.

/* reder. all */

    predicates
        onControlRederiveAll : vpiDomains::controlHandler.
    clauses
        onControlRederiveAll(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::ctlDisable(thisWin,[idc_regenerate_dependency_graph,idc_start,idc_continue]),
			datetime::tsNow(Ts),
			Rep=rep::newReport(2,"Rederived Sentences",70),
			dlgIF::msgStatus("Deleting inexact rule reasoning records ..."),
    dbBase::chainDelete("r"),
			dlgIF::msgStatus("Deleting all derived sentences..."),
	dbBase::sentenceDerivedDelete(-1),
	dep::regenDependencyGraph,
	der::depList(1,L,N,Secs,All),
	setEst(N,Secs,All),
	der::derPop(thisWin,L),
			dlgIF::msgStatus("Deriving sentences..."),
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE"), 
			Rep:repWL(0,""),
	der::depDeriveSTs(Rep,thisWin,L,SumST,SumSol),
	der::depDeriveEnd(Rep,Ts,SumST,SumSol),
			Rep:close(),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
	   		Nts=toString(SumST),
	   		Nss=toString(SumSol),
	   		sx::concat(["Full re-derivation of ",Nss," sentences of ",Nts," types with elapsed time ",DiffS,"."],Mess),
			dlgIF::msgS(Mess),
			dlgIF::msgStatus(""),
	guix::ctlEnable(thisWin,[idc_terminate]),
	guix::ctlDisable(thisWin,[idc_start,idc_stop_point,idc_rederive_all,idc_terminate,idc_continue,idc_move_up,idc_move_down,
	                                   idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* create/destroy/help */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
	vpi::cursorSetWait(),
	guix::addWin(32,thisWin),
    guix::setStyle(thisWin,[idc_sts,idc_stop_point,idc_start,idc_rederive_all,idc_count,idc_level,idc_subscribe,
      	                            idc_continue,idc_terminate,idc_print,idc_move_up,idc_move_down,idc_nsents,idc_time,idct_est1,idct_est2,
  	                                idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences],[]),
            dlgIF::msgStatus("Determining derivation plan..."),
	der::depList(1,L,N,Secs,All),
	setEst(N,Secs,All),
	der::derPop(thisWin,L),
	guix::ctlDisable(thisWin,[idc_continue,idc_terminate]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	guix::ctlDisable(thisWin,[idc_subscribe]),
	dbBase::kbIsSql,
	guix::ctlEnable(thisWin,[idc_subscribe]),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.
    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
  	guix::dropWin(thisWin),
  	vpi::winDestroy(thisWin),
	!.

% This code is maintained by the VDE do not update it manually, 09:20:14-8.6.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(5,80,1004,580).
    menu : vpiDomains::menu = noMenu.
    title : string = "Sentence Derivation".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBox,rct(8,5,736,496),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Sort],idc_sts),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,44,993,68),"Set STOP-point",Win,[wsf_Group,wsf_TabStop],idc_stop_point),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,224,993,248),"Start derivation",Win,[wsf_Group,wsf_TabStop],idc_start),
        _ = vpi::winCreateControl(wc_Edit,rct(968,468,994,492),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_level),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,254,993,278),"Resume derivation",Win,[wsf_Group,wsf_TabStop],idc_continue),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,284,993,308),"End derivation",Win,[wsf_Group,wsf_TabStop],idc_terminate),
        _ = vpi::winCreateControl(wc_Edit,rct(832,468,955,492),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_count),
        _ = vpi::winCreateControl(wc_Edit,rct(872,280,929,304),"idc_stat",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_Invisible],idc_stat),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,438,993,462),"Rederive all sentences",Win,[wsf_Group,wsf_TabStop],idc_rederive_all),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,380,993,404),"Regenerate indexes",Win,[wsf_Group,wsf_TabStop],idc_regenerate_indexes),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,410,993,434),"Regenerate dependency graph",Win,[wsf_Group,wsf_TabStop],idc_regenerate_dependency_graph),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,350,993,374),"Delete all derived sentences",Win,[wsf_Group,wsf_TabStop],idc_delete_all_derived_sentences),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,320,993,344),"Text editor (print)",Win,[wsf_Group,wsf_TabStop],idc_print),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,74,993,98),"Move up",Win,[wsf_Group,wsf_TabStop],idc_move_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,103,993,127),"Move down",Win,[wsf_Group,wsf_TabStop],idc_move_down),
        _ = vpi::winCreateControl(wc_Text,rct(744,140,874,160),"Est. #sentences:",Win,[wsf_AlignLeft],idct_est1),
        _ = vpi::winCreateControl(wc_Text,rct(744,168,874,188),"Est. derivation time:",Win,[wsf_AlignLeft],idct_est2),
        _ = vpi::winCreateControl(wc_Edit,rct(880,140,992,164),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_nsents),
        _ = vpi::winCreateControl(wc_Edit,rct(880,168,992,192),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_time),
        _ = vpi::winCreateControl(wc_PushButton,rct(744,4,993,28),"Refresh Subscriptions",Win,[wsf_Group,wsf_TabStop],idc_subscribe),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_print, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlprint(idc_print, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete_all_derived_sentences, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlDeleteAllDerivedSentences(idc_delete_all_derived_sentences, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_regenerate_dependency_graph, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRegenerateDependencyGraph(idc_regenerate_dependency_graph, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_regenerate_indexes, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRegenerateIndexes(idc_regenerate_indexes, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_stop_point, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlStopPoint(idc_stop_point, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_move_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveDown(idc_move_down, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_move_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMoveUp(idc_move_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_start, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlstart(idc_start, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_continue, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlcontinue(idc_continue, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_terminate, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlterminate(idc_terminate, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_rederive_all, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlRederiveAll(idc_rederive_all, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_subscribe, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_subscribe(idc_subscribe, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sts, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_sts(idc_sts, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
    
setEst(N,Secs,All) :-
    Ix=All+1,
    set::setGet(["*",""],Ix,Suf),
    Ns=toString(N),
    SecsS=toString(Secs),
    Dur=string::concat("PT",SecsS,"S"),
    xmlGeneric::durationShort(Dur,DurN),
    Nss=string::concat(Ns,Suf),
    Ds=string::concat(DurN,Suf),
    guix::txtSet(thisWin,idc_nsents,Nss),
    guix::txtSet(thisWin,idc_time,Ds),
    !.
end implement derivation
