/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement filescanner
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/filescanner".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.
            
    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
  	globalVars::get_i("fs_typ")=2,
  	guix::guiRB_SetN(thisWin,[idc_write,idc_write_one],[2,3],2),
  	F=globalVars::get_s("fscan"),
  	guix::txtSet(thisWin,idc_filename,F),
  	FSF=globalVars::get_s("fs_ft"),
  	guix::txtSet(thisWin,idc_file_type,FSF),
  	FSM=globalVars::get_s("fs_of"),
  	guix::txtSet(thisWin,idc_path,FSM),
	guix::ctlDisable(thisWin,[idc_filename,idc_path]),
	!
;
  	globalVars::get_i("fs_typ")=3,
  	guix::guiRB_SetN(thisWin,[idc_write,idc_write_one],[2,3],3),
  	FSF=globalVars::get_s("fs_ft"),
  	guix::txtSet(thisWin,idc_filename,FSF),
  	guix::txtSet(thisWin,idc_file_type,""),
  	guix::txtSet(thisWin,idc_path,""),
	guix::ctlDisable(thisWin,[idc_file_type,idc_path]),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_Get(thisWin,[idc_write,idc_write_one],[2,3],FST),
	FST=2,
  	globalVars::set_i("fs_typ",FST),
  	guix::txtGet(thisWin,idc_file_type,FSF),
  	globalVars::set_s("fs_ft",FSF),
  	guix::txtGet(thisWin,idc_path,FSPa),
  	sx::sxRemoveTail(FSPa,"\\",FSP),
  	globalVars::set_s("fs_of",FSP),
	vpi::winDestroy(thisWin),
	!
;	
  	guix::guiRB_Get(thisWin,[idc_write,idc_write_one],[2,3],FST),
	FST=3,
  	globalVars::set_i("fs_typ",FST),
  	guix::txtGet(thisWin,idc_filename,FSD),
  	globalVars::set_s("fs_ft",FSD),
	vpi::winDestroy(thisWin),
	!;!.

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpWeb("FileScanner"),
	!.

    predicates
        onControlwrite : vpiDomains::controlHandler.
    clauses
        onControlwrite(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_write,idc_write_one],[2,3],2),
	guix::ctlDisable(thisWin,[idc_filename]),
	guix::ctlEnable(thisWin,[idc_file_type,idc_path]),
	!;!.

    predicates
        onControlWriteOne : vpiDomains::controlHandler.
    clauses
        onControlWriteOne(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_write,idc_write_one],[2,3],3),
  	P=globalVars::get_s("fs_of"),
  	guix::txtSet(thisWin,idc_filename,P),
	guix::ctlDisable(thisWin,[idc_file_type,idc_path]),
	guix::ctlEnable(thisWin,[idc_filename]),
	!;!.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            vpi::winDestroy(thisWin),
            !.

    % This code is maintained by the VDE do not update it manually, 17:05:29-30.6.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "File Scanner".
    rectangle : vpiDomains::rct = rct(50,40,295,132).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(28,76,114,88),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(132,76,219,88),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(4,2,107,12),"Write to corresponding files",u_DlgBase),idc_write,[wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_Edit,rct(100,16,143,28),"",u_DlgBase),idc_file_type,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_RadioButton,rct(4,45,107,55),"Write to one file",u_DlgBase),idc_write_one,[wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_Edit,rct(100,58,243,70),"",u_DlgBase),idc_filename,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(100,30,243,42),"",u_DlgBase),idc_path,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,16,92,26),"File type (generated files)",u_DlgBase),idct_file_type,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,60,92,70),"File name (generated file)",u_DlgBase),idct_file_name,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,31,92,41),"Path (generated files)",u_DlgBase),idct_path,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_write, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlwrite(idc_write, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_write_one, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlWriteOne(idc_write_one, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement filescanner
