/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement function
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/function".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
smChange : integer := -1.

predicates
dmFuncTypeGet : (vpiDomains::windowHandle,string) procedure (i,o).
dmFuncTypeSet : (vpiDomains::windowHandle,string) determ.
dmFuncSentences : (string_list,string_list) determ (i,o).
dmInsBody : (string,string,string_list) determ.
dmInsBodyX : (string,string,string_list,count) determ.

    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
        getWin()=W :- W=thisWin.
         

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
	vpi::cursorSetWait(),
	guix::addWin(62,thisWin),
    guix::setStyle(thisWin,[idc_syntagm,idc_kb,idc_de1s,idc_de2s,idc_save,idc_delete,idc_refresh,
  	                   idct_realm,idc_realm,
  	                   idc_domain,idc_deterministic,idc_add,idc_remove,
  	                   idc_segment,idc_update,idc_body,idc_statement,idc_up,idc_rem,idc_xml_nl,idc_xml_pr,
  	                   idc_edit,idc_insert,idc_remove,idc_insert_top,idc_insert_bottom,idc_down,
  	                   idct_kb_identifier,idct_segment,idct_domain,idc_deps,idct_function_body,idc_look_up,
  	                   idct_data_element_selectdeselect,idc_ml_up,idc_ml_down,idc_under],[]),
	% populate the domain, parameter domains, syntagm and segment list boxes		     
	Context=dbBase::getContext(),
	dom::domList(Doms),
	dbBase::nlSings(Doms,NDoms),
	guix::lbxPop(thisWin,idc_domain,NDoms),
	dbBase::nlSing("p3_din",InDom),
	guix::lbtSel(thisWin,idc_domain,InDom),
	Ff=pop::getSM_NL("f"),
	Fg=pop::getSM_NL("g"),
	set::conc([Ff,Fg],Fs),
	guix::lbxPop(thisWin,idc_syntagm,Fs),
	Context=[C|_],
	guix::lbxPop(thisWin,idc_segment,Context),
	guix::lbtSel(thisWin,idc_segment,C),
	DEs=pop::getSM_NL("a",[]),
	guix::lbxPop(thisWin,idc_de2s,DEs),
	smChange:=-1,
	guix::ctlDisable(thisWin,[idc_save,idc_update,idc_delete]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            cache::loadTmConditionally,
            cache::loadSmConditionally,
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onControlXmlPr : vpiDomains::controlHandler.
    clauses
        onControlXmlPr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,idc_kb,Func),
	guix::txtGet(thisWin,idc_realm,Realm),
	xmlP3::xmlFromFunc("PR",Realm,Func,X2),
	xmlP3::xmlKnowledge(X2,X),
	dbBase::nlTry(Func,FuncNL),
	Path=globalVars::get_s("std_path"),
	fioExt::filGenName(3,Path,FuncNL,"xml",OutFile),
	file::writeString(OutFile,X),	
	editorWindow::openFiles([OutFile]),
	!;!.

    predicates
        onControlXmlNl : vpiDomains::controlHandler.
    clauses
        onControlXmlNl(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,idc_kb,Func),
	guix::txtGet(thisWin,idc_realm,Realm),
	xmlP3::xmlFromFunc("NL",Realm,Func,X2),
	xmlP3::xmlKnowledge(X2,X),
	dbBase::nlTry(Func,FuncNL),
	Path=globalVars::get_s("std_path"),
	fioExt::filGenName(3,Path,FuncNL,"xml",OutFile),
	file::writeString(OutFile,X),	
	editorWindow::openFiles([OutFile]),
	!;!.

    predicates
        onControldeps : vpiDomains::controlHandler.
    clauses
        onControldeps(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,idc_kb,Id),
	dbBase::nlSing(Id,FNL),
	dep::chkGetAllDirectDeps(cmp("n",[int(17),termDomain::str(Id)]),_,SDeps),
    dep::nodIF_no(K,17),
	dbBase::nlSing(K,NL),
	sx::concat([NL," ",FNL],S),
    Dlg=dependents::new(),
    Dlg:setPars(SDeps,S,0),
    W=guix::getWinOfClas(1),
    Dlg:show(W),
	!;!.

    predicates
        onControlsegment : vpiDomains::controlHandler.
    clauses
        onControlsegment(_CtrlID, _CtrlType, CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::losefocus(),
	guix::txtGet(thisWin,idc_segment,Seg),
	sx::sxStrip(Seg,Segment),
	Segment<>"",
	vpi::lboxAdd(CtrlWin,Segment),
	guix::lbtSel(thisWin,idc_segment,Segment),
	!
;
	dlgIF::dlgNote(1,"Enter/select a non-blank segment name"),
	!.	

    predicates
        onControlsyntagm : vpiDomains::controlHandler.
    clauses
        onControlsyntagm(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
	vpi::cursorSetWait(),
	guix::lbtGet(thisWin,idc_syntagm,Syntagm2),
	sx::sxStripFrontMarks(Syntagm2,["*","+"],Syntagm),
	dbBase::kbID(Syntagm,KbId,_,_),
	guix::txtSet(thisWin,idc_kb,KbId),
	smChange:=-1,
	dbBase::smDefF(KbId,Clas,_,DEs,Dom,_,_),
	Segment=dbBase::smSegment(KbId),
	set::member(Clas,["f","g"]),
	dmFuncTypeSet(thisWin,Clas),
	Loc=dbBase::smRef(KbId),
	SLoc=dbBase::dbRef(Loc),
	dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,_,_),
	guix::txtSet(thisWin,idc_ref,SLoc),
	guix::txtSet(thisWin,idc_realm,Realm),
	% segment
	guix::lbtSel(thisWin,idc_segment,Segment),
	% domain
	dbBase::nlForm(Dom,"p3_iNIL",DomNL),
	guix::lbtSel(thisWin,idc_domain,DomNL),
	dbBase::nlSings(DEs,Selected),
	guix::lbxPop(thisWin,idc_de1s,Selected),
	% body
	vpi::cursorSetWait(),
	dbExtension::functionBodies(KbId,Bodies1),
	dmFuncSentences(Bodies1,Bodies2),
	guix::lbxPop(thisWin,idc_body,Bodies2),
	guix::txtSet(thisWin,idc_statement,""),
	%
	sentencemodel::dmAnnoDisplayAsst("p3_iFncD",KbId),
  	guix::ctlEnable(thisWin,[idc_deps,idc_kb,idc_de1s,idc_de2s,idc_segment,idc_body,idc_save,idc_update,idc_xml_nl,idc_xml_pr,idc_delete]),
	guix::ctlDisable(thisWin,[idc_save]),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;	
    CtrlInfo=vpiDomains::modified(),
	guix::txtGet(thisWin,idc_syntagm,Syntagm),
	dbExtension::kbDefName("f",Syntagm,Kb),
	guix::txtSet(thisWin,idc_kb,Kb),
  	guix::ctlEnable(thisWin,[idc_kb,idc_de1s,idc_de2s,idc_segment,idc_body,idc_save,idc_delete]),
	guix::ctlDisable(thisWin,[idc_update,idc_xml_nl,idc_xml_pr,idc_deps,idc_delete]),
	!;!.

    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	DEs=vpi::lboxGetAll(C),
	not(set::member(DE,DEs)),
	vpi::lboxAdd(C,DE),
	smChange:=1,
	!;!.

    predicates
        onControlrem : vpiDomains::controlHandler.
    clauses
        onControlrem(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de1s,DE),
	guix::lbxDelS(thisWin,idc_de1s,DE),
	smChange:=1,
	!;!.

    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	smChange:=1,
	!;!.

    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	smChange:=1,
	!;!.

    predicates
        onControlLookUp : vpiDomains::controlHandler.
    clauses
        onControlLookUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	W=guix::getWinOfClas(1),
    Obj=sentencemodel::new(W,1),
    Wd=Obj:getWin(),
    sentencemodel::displayDE(Wd,DE),
	!;!.

    predicates
        onControlrefresh : vpiDomains::controlHandler.
    clauses
        onControlrefresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    DEs=pop::getSM_NL("a",[]),
	guix::lbxPop(thisWin,idc_de2s,DEs),
	!;!.

    predicates
        onControlMlUp : vpiDomains::controlHandler.
    clauses
        onControlMlUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ls,Nos),
	Ls=[L],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,L),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlMlDown : vpiDomains::controlHandler.
    clauses
        onControlMlDown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ls,Nos),
	Ls=[L],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,L),
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlunder : vpiDomains::controlHandler.
    clauses
        onControlunder(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,_,Nos),
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	guix::txtGet(thisWin,idc_statement,S),
	M=No+1,
	vpi::lboxAdd(C,M,S),
	vpi::lboxSetSel(C,M,b_true),
	!
;	
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,_,Nos),
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No=(N-1),
	guix::txtGet(thisWin,idc_statement,S),
	vpi::lboxAdd(C,-1,S),
	M=No+1,
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlInsertBottom : vpiDomains::controlHandler.
    clauses
        onControlInsertBottom(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	guix::txtGet(thisWin,idc_statement,S),
	vpi::lboxAdd(C,-1,S),
	guix::txtSet(thisWin,idc_statement,""),
	N=vpi::lboxCountAll(C),
	M=N-1,
	vpi::lboxSetSel(C,M,b_true),
	!;!.

    predicates
        onControlInsertTop : vpiDomains::controlHandler.
    clauses
        onControlInsertTop(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	guix::txtGet(thisWin,idc_statement,S),
	vpi::lboxAdd(C,0,S),
	guix::txtSet(thisWin,idc_statement,""),
	vpi::lboxSetSel(C,0,b_true),
	!;!.

    predicates
        onControlinsert : vpiDomains::controlHandler.
    clauses
        onControlinsert(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ss,_),
	Ss=[],
	guix::txtGet(thisWin,idc_statement,S),
	vpi::lboxAdd(C,S),
	N=vpi::lboxCountAll(C),
	M=N-1,
	vpi::lboxSetSel(C,M,b_true),
	!
;	
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,_,Is),
	set::size(Is,N),
	set::setGet(Is,N,Index),
	M=Index+1,
	guix::txtGet(thisWin,idc_statement,S),
	vpi::lboxAdd(C,M,S),
	vpi::lboxSetSel(C,M,b_true),
	guix::txtSet(thisWin,idc_statement,""),
	!;!.

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ss,_),
	Ss=[],
	dlgIF::dlgNote(1,"No statement selected"),
	!
;
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,_,Is),
	guix::lbxDelIs(thisWin,idc_body,Is),
	!;!.

    predicates
        onControledit : vpiDomains::controlHandler.
    clauses
        onControledit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ss,_),
	Ss=[],
	dlgIF::dlgNote(1,"No statement selected"),
	!
;
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ss,_),
	Ss=[_,_|_],
	dlgIF::dlgNote(1,"Only one statement can be edited at a time"),
	!
;
	C=vpi::winGetCtlHandle(thisWin,idc_body),
	vpi::lboxGetSel(C,Ss,Is),
	Ss=[S],
	guix::txtSet(thisWin,idc_statement,S),
	guix::lbxDelIs(thisWin,idc_body,Is),
	Is=[Sel],
	N=Sel-1,
	vpi::lboxSetSel(C,N,b_true),
	!;!.

/* save new */

    predicates
        onControlsave : vpiDomains::controlHandler.
    clauses
        onControlsave(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_realm,R),
  	R="",
  	dlgIF::dlgNote(1,"Enter realm name!"),
  	!
;
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_syntagm,NL),
	guix::txtGet(thisWin,idc_kb,KbId),
	guix::lbxGetAll(thisWin,idc_body,Body),
 	guix::txtGet(thisWin,idc_realm,Realm),
	sentencemodel::save(thisWin,5,KbId,NL,Realm),
	dmInsBody("3nl",Realm,Body),
   	guix::ctlDisable(thisWin,[idc_kb,idc_de1s,idc_de2s,
  	              idc_segment,idc_body,idc_save,idc_update,idc_xml_nl,idc_xml_pr,idc_delete]),
	dlgIF::dlgNote(0,"Function definition inserted!"),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* update */

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::txtGet(thisWin,idc_realm,R),
  	R="",
  	dlgIF::dlgNote(1,"Enter realm name!"),
  	!
;
	vpi::cursorSetWait(),
	smChange=1,
	guix::txtSet(thisWin,idc_integrity,"x"),
	guix::txtGet(thisWin,idc_syntagm,NL),
	guix::txtGet(thisWin,idc_kb,KbId),
	guix::lbxGetAll(thisWin,idc_body,Body),
 	guix::txtGet(thisWin,idc_realm,Realm),
	dbBase::chainDelete(KbId),
	sentencemodel::update(thisWin,5,KbId,NL,Realm),
	dmInsBody("3nl",Realm,Body),
	dlgIF::dlgNote(0,"Function definition updated!"),
	smChange:=-1,
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
	vpi::cursorSetWait(),
	smChange=-1,
	guix::txtSet(thisWin,idc_integrity,""),
	guix::txtGet(thisWin,idc_syntagm,NL),
	guix::txtGet(thisWin,idc_kb,KbId),
	guix::lbxGetAll(thisWin,idc_body,Body),
 	guix::txtGet(thisWin,idc_realm,Realm),
	dbBase::chainDelete(KbId),
	sentencemodel::update(thisWin,5,KbId,NL,Realm),
	dmInsBody("3nl",Realm,Body),
	dlgIF::dlgNote(0,"Function definition updated!"), 
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
	dlgIF::dlgNote(1,"No write-access to this chain"),
	!.
	
/* delete */
	
    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_kb,KbId),
	sentencemodel::delete(thisWin),
	dbBase::chainDelete(KbId),
	dlgIF::dlgNote(0,"Function declaration and definition deleted!"),
    guix::lbxRemReselect(thisWin,idc_syntagm),
    guix::txtSet(thisWin,idc_kb,""),
  	guix::ctlDisable(thisWin,[idc_kb,idc_de1s,idc_de2s,idc_segment,idc_body,idc_save,idc_update,idc_xml_nl,idc_xml_pr,idc_delete]),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
	dlgIF::dlgNote(1,"No write-access to this chain"),!.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

    % This code is maintained by the VDE do not update it manually, 19:18:06-3.2.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(10,40,994,627).
        menu : vpiDomains::menu = noMenu.
        title : string = "Function".
    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_LBoxEdit,rct(8,4,477,593),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_syntagm),
            _ = vpi::winCreateControl(wc_Text,rct(10,34,76,52),"KB name",Win,[wsf_AlignLeft],idct_kb_identifier),
            _ = vpi::winCreateControl(wc_Edit,rct(78,31,349,55),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_kb),
            _ = vpi::winCreateControl(wc_LBox,rct(9,256,198,479),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight,wsf_Disabled],idc_de1s),
            _ = vpi::winCreateControl(wc_Text,rct(9,235,475,252),"Input parameters",Win,[wsf_AlignLeft],idct_data_element_selectdeselect),
            _ = vpi::winCreateControl(wc_PushButton,rct(9,559,164,583),"Save New",Win,[wsf_Group,wsf_TabStop],idc_save),
            _ = vpi::winCreateControl(wc_PushButton,rct(495,559,650,583),"Update",Win,[wsf_Group,wsf_TabStop],idc_update),
            _ = vpi::winCreateControl(wc_PushButton,rct(657,559,812,583),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
            _ = vpi::winCreateControl(wc_LBoxEdit,rct(78,84,349,593),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_segment),
            _ = vpi::winCreateControl(wc_Text,rct(9,86,75,104),"Segment",Win,[wsf_AlignLeft],idct_segment),
            _ = vpi::winCreateControl(wc_Text,rct(9,207,75,225),"Domain",Win,[wsf_AlignLeft],idct_domain),
            _ = vpi::winCreateControl(wc_LBoxButton,rct(78,200,349,609),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll],idc_domain),
            _ = vpi::winCreateControl(wc_PushButton,rct(1100,133,1186,157),"Insert after Bar",Win,[wsf_Group,wsf_TabStop],idc_insert),
            _ = vpi::winCreateControl(wc_Edit,rct(392,140,472,164),"integrity",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_Invisible],idc_integrity),
            _ = vpi::winCreateControl(wc_CheckBox,rct(365,31,475,51),"Deterministic",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_deterministic),
            _ = vpi::winCreateControl(wc_PushButton,rct(817,559,972,583),"Display dependents",Win,[wsf_Group,wsf_TabStop],idc_deps),
            _ = vpi::winCreateControl(wc_Text,rct(9,59,75,79),"Realm",Win,[wsf_AlignLeft],idct_realm),
            _ = vpi::winCreateControl(wc_Edit,rct(78,58,349,82),"",Win,[wsf_UpperCase,wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_realm),
            _ = vpi::winCreateControl(wc_Edit,rct(408,116,472,140),"ref",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_ref),
            _ = vpi::winCreateControl(wc_LBoxEdit,rct(283,257,474,595),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_de2s),
            _ = vpi::winCreateControl(wc_PushButton,rct(283,314,474,338),"Refresh data elements",Win,[wsf_Group,wsf_TabStop],idc_refresh),
            _ = vpi::winCreateControl(wc_PushButton,rct(200,341,279,365),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_down),
            _ = vpi::winCreateControl(wc_PushButton,rct(200,314,279,338),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_up),
            _ = vpi::winCreateControl(wc_PushButton,rct(200,285,279,309),"Remove --->",Win,[wsf_Group,wsf_TabStop],idc_rem),
            _ = vpi::winCreateControl(wc_PushButton,rct(200,256,279,280),"<--- Add",Win,[wsf_Group,wsf_TabStop],idc_add),
            _ = vpi::winCreateControl(wc_Text,rct(485,6,978,26),"Function definition:",Win,[wsf_AlignCenter],idct_function_body),
            _ = vpi::winCreateControl(wc_LBox,rct(484,30,977,497),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_body),
            _ = vpi::winCreateControl(wc_Edit,rct(232,527,974,555),"",Win,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft],idc_statement),
            _ = vpi::winCreateControl(wc_PushButton,rct(447,501,551,525),"Edit Line",Win,[wsf_Group,wsf_TabStop],idc_edit),
            _ = vpi::winCreateControl(wc_PushButton,rct(553,501,657,525),"Remove Line",Win,[wsf_Group,wsf_TabStop],idc_remove),
            _ = vpi::winCreateControl(wc_PushButton,rct(659,501,763,525),"Insert at Top",Win,[wsf_Group,wsf_TabStop],idc_insert_top),
            _ = vpi::winCreateControl(wc_PushButton,rct(871,501,975,525),"Insert at Bottom",Win,[wsf_Group,wsf_TabStop],idc_insert_bottom),
            _ = vpi::winCreateControl(wc_PushButton,rct(235,501,339,525),"Move Line Down",Win,[wsf_Group,wsf_TabStop],idc_ml_down),
            _ = vpi::winCreateControl(wc_PushButton,rct(341,501,445,525),"Move Line Up",Win,[wsf_Group,wsf_TabStop],idc_ml_up),
            _ = vpi::winCreateControl(wc_PushButton,rct(765,501,869,525),"Insert Under",Win,[wsf_Group,wsf_TabStop],idc_under),
            _ = vpi::winCreateControl(wc_PushButton,rct(171,559,326,583),"XML (NL-based)",Win,[wsf_Group,wsf_TabStop],idc_xml_nl),
            _ = vpi::winCreateControl(wc_PushButton,rct(333,559,488,583),"XML (PR-based)",Win,[wsf_Group,wsf_TabStop],idc_xml_pr),
            _ = vpi::winCreateControl(wc_PushButton,rct(283,285,474,309),"Look up data element",Win,[wsf_Group,wsf_TabStop],idc_look_up),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_xml_pr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlXmlPr(idc_xml_pr, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_xml_nl, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlXmlNl(idc_xml_nl, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_deps, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldeps(idc_deps, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_segment, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsegment(idc_segment, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_syntagm, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsyntagm(idc_syntagm, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_rem, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrem(idc_rem, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlLookUp(idc_look_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrefresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ml_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMlUp(idc_ml_up, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ml_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlMlDown(idc_ml_down, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_under, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlunder(idc_under, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_insert_bottom, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlInsertBottom(idc_insert_bottom, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_insert_top, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlInsertTop(idc_insert_top, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_insert, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlinsert(idc_insert, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_edit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControledit(idc_edit, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsave(idc_save, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
% --------------------------------------------------------------------------------------------
% dmFuncTypeSet;Get
% --------------------------------------------------------------------------------------------
dmFuncTypeSet(W,"f") :- guix::guiCB_Set(W,idc_deterministic,1),!.
dmFuncTypeSet(W,"g") :- guix::guiCB_Set(W,idc_deterministic,0),!.
dmFuncTypeGet(W,Typ) :- 
	guix::guiCB_Get(W,idc_deterministic,Checked),
	Checked=1,
	Typ="f",!
;
	Typ="g",!.	
% --------------------------------------------------------------------------------------------
% dmFuncSentences
% --------------------------------------------------------------------------------------------
dmFuncSentences([],[]) :-
	!.
dmFuncSentences([B|Bs],L) :-
    dbBase::nlSing("p3_iIdefb",Sx2),
    Sx=string::concat(Sx2," "),
	sx::sxUnpackS(B,Sx,L2),
	L2=[H,T],
	sx::sxUnpack(T,';',L3),
	Hs=string::concat(H,Sx),
	sx::sxlRemBlanks(L3,L4),
	sx::sxlAddSuffix(L4,";",L5),
	set::setRev(L5,L6),
	L6=[H6|T6],
	sx::sxTail(1,H6,H7,_),
	set::setRev([H7|T6],L7),
	dmFuncSentences(Bs,Ls),
	set::conc([[Hs],L7,[""],Ls],L),
	!
;
	dmFuncSentences(Bs,L),
	!.
% --------------------------------------------------------------------------------------------
% dmInsBody
% --------------------------------------------------------------------------------------------
dmInsBody(Form,Realm,B) :-
	sx::sxlJoin(B," ",S),
	sx::sxStrip(S,Ss),
	sx::sxUnpack(SS,'!',L),
	C=count::new(0),
	dmInsBodyX(Form,Realm,L,C),
	!
;	
	dlgIF::dlgNote(1,"Invalid function definitions - function has been stored without or with incomplete definition!"),
	!,fail.
	
dmInsBodyX(_,_,[],_) :- 
	!.
dmInsBodyX(Type,Realm,[B|L],C) :-
    string::trim(B)="",
	dmInsBodyX(Type,Realm,L,C),
    !
;    
    proc::proText(Type,Realm,[B],C),
			tt::tt_s(2,"Added function definition to the KB",B),			
	dmInsBodyX(Type,Realm,L,C),
	!.
end implement function
