/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement kbInit
open core, vpiDomains, resourceIdentifiers

constants
className = "com/rudstrand/TaskWindow/kbInit".
classVersion = "1.0".

facts
thisWin : vpiDomains::windowHandle := erroneous.
mode : integer:=0. % 0=KB init, 1=KB export, 2=view
            
clauses
classInfo(className, classVersion).

        show(Parent,Mode):-
        mode:=Mode,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
    mode=1,
	sqlBase::getParameters(L4,L5,_,L7,L8,_,L10,L11),
	guix::txtSetI(thisWin,idc_sql_lengths,L4),
	guix::txtSet(thisWin,idc_chain_prefix,L5),
	guix::txtSet(thisWin,idc_blank,L7),
	guix::txtSetI(thisWin,idc_max_sql,L11),
	guix::txtSetI(thisWin,idc_tformat,L10),
	Max=sqlBase::getMaxLength(),
	guix::txtSetI(thisWin,idc_max_sql,Max),
  	guix::guiRB_SetN(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],L8),
  	guix::guiRB_SetN(thisWin,[idc_3kb,idc_sql],[1,2],2),
	guix::ctlDisable(thisWin,[idc_sql,idc_3kb,idc_kb_max_tok,idc_kb_max_kbn,idc_max_rln,idc_kb_id]),
	!
;    
    mode=2,
	L1=globalVars::get_i("max_tok"),
	L2=globalVars::get_i("max_kbn"),
	L3=globalVars::get_i("max_rln"),
	sqlBase::getParameters(L4,L5,_,L7,L8,_,L10,L11),
	guix::txtSetI(thisWin,idc_kb_max_tok,L1),
	guix::txtSetI(thisWin,idc_kb_max_kbn,L2),
	guix::txtSetI(thisWin,idc_max_rln,L3),
	guix::txtSetI(thisWin,idc_sql_lengths,L4),
	guix::txtSet(thisWin,idc_chain_prefix,L5),
	guix::txtSet(thisWin,idc_blank,L7),
	guix::txtSetI(thisWin,idc_max_sql,L11),
	guix::txtSetI(thisWin,idc_tformat,L10),
  	guix::guiRB_SetN(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],L8),
  	Id=dbBase::dbId(),
  	guix::txtSet(thisWin,idc_kb_id,Id),
	guix::ctlDisable(thisWin,[idc_sql,idc_3kb,idc_kb_max_tok,idc_kb_max_kbn,idc_max_rln,idc_kb_id,idc_chain_prefix,idc_blank,idc_sql_lengths,idc_mixed,idc_lower,idc_upper,idc_tformat]),
	!
;   % KB initialization         
  	dlgIF::dlgExp(21),
  	dbBase::kbIsSql,
  	guix::guiRB_SetN(thisWin,[idc_3kb,idc_sql],[1,2],2),
  	guix::txtSet(thisWin,idc_kb_id,"X"),
  	guix::ctlDisable(thisWin,[idc_kb_id]),
    fail
;
  	not(dbBase::kbIsSql),
  	guix::guiRB_SetN(thisWin,[idc_3kb,idc_sql],[1,2],1),
  	guix::txtSet(thisWin,idc_kb_id,"A"),
  	guix::ctlDisable(thisWin,[idc_sql_lengths,idc_chain_prefix,idc_blank,idc_max_sql,idc_tformat]),
    fail
;    
	L1=globalVars::get_i("max_tok"),
	L2=globalVars::get_i("max_kbn"),
	L3=globalVars::get_i("max_rln"),
	sqlBase::getParameters(L4,L5,_,L7,L8,_,L10,L11),
	guix::txtSetI(thisWin,idc_kb_max_tok,L1),
	guix::txtSetI(thisWin,idc_kb_max_kbn,L2),
	guix::txtSetI(thisWin,idc_max_rln,L3),
	guix::txtSetI(thisWin,idc_sql_lengths,L4),
	guix::txtSet(thisWin,idc_chain_prefix,L5),
	guix::txtSet(thisWin,idc_blank,L7),
	guix::txtSetI(thisWin,idc_tformat,L10),
	guix::txtSetI(thisWin,idc_max_sql,L11),
  	guix::guiRB_SetN(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],L8),
	globalVars::get_i("knowopen")>0,
	guix::ctlDisable(thisWin,[idc_sql,idc_3kb,idc_kb_max_tok,idc_kb_max_kbn,idc_max_rln,idc_kb_id,idc_chain_prefix,idc_blank,idc_sql_lengths,idc_tformat]),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    mode=2,
	globalVars::pushRetPars(["0"]), 
  	vpi::winDestroy(thisWin),
  	!   
;        
  	guix::guiRB_Get(thisWin,[idc_3kb,idc_sql],[1,2],Type),
  	Type=1,
	guix::txtGetI_M(thisWin,idc_kb_max_tok,"Enter an integer between 16 and 128!",L1),
	L1>=16, L1<=128,
	guix::txtGetI_M(thisWin,idc_kb_max_kbn,"Enter an integer between 12 and 64!",L2),
	L2>=12, L2<=64,
	guix::txtGetI_M(thisWin,idc_max_rln,"Enter an integer between 8 and 64!",L3),
	L3>8, L3<=64,
	guix::txtGet(thisWin,idc_kb_id,S4),
	string::length(S4)=1,
	S4<>"Z",
	S4<>"X",
	globalVars::set_i("max_tok",L1),
	globalVars::set_i("max_kbn",L2),
	globalVars::set_i("max_rln",L3),
	init::dbaIxSetLengths,
	globalVars::set_s("kb_id",S4),
	globalVars::pushRetPars(["1"]), % INITIALIZATION CONFIRMED
  	vpi::winDestroy(thisWin),
  	!
;
    mode=1,
	guix::txtGetI_M(thisWin,idc_max_sql,"Enter an integer in the range 8000-24000!",Max),
	Max>=8000,
	guix::txtGetI_M(thisWin,idc_sql_lengths,"Enter an integer between 16 and 64!",L11),
	L11>15, L11<=64,
	guix::txtGet(thisWin,idc_chain_prefix,S12),
	guix::txtGet(thisWin,idc_blank,Usc),
	guix::txtGetI(thisWin,idc_tformat,TFormat),
	guix::txtGetI(thisWin,idc_max_sql,TLength),
  	guix::guiRB_Get(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],Case),
	sqlBase::setParameters(L11,S12,"",Usc,Case,"",TFormat,TLength),
	sqlBase::setMaxLength(Max),
	globalVars::pushRetPars(["1"]), % INITIALIZATION CONFIRMED
  	vpi::winDestroy(thisWin),
  	!
;
    mode=0,
	guix::txtGetI_M(thisWin,idc_max_sql,"Enter an integer in the range 8000-24000!",Max),
	Max>=8000,
  	guix::guiRB_Get(thisWin,[idc_3kb,idc_sql],[1,2],Type),
  	Type=2,
	guix::txtGetI_M(thisWin,idc_kb_max_tok,"Enter an integer between 16 and 128!",L1),
	L1>=16, L1<=128,
	guix::txtGetI_M(thisWin,idc_kb_max_kbn,"Enter an integer between 12 and 64!",L2),
	L2>=12, L2<=64,
	guix::txtGetI_M(thisWin,idc_max_rln,"Enter an integer between 8 and 64!",L3),
	L3>8, L3<=64,
	guix::txtGetI_M(thisWin,idc_sql_lengths,"Enter an integer between 16 and 64!",L11),
	L11>15, L11<=64,
	guix::txtGetI_M(thisWin,idc_tformat,"Enter 1 or 2!",L12),
	L12>=1, L12<=2,
	guix::txtGet(thisWin,idc_chain_prefix,S12),
	guix::txtGet(thisWin,idc_blank,Usc),
	globalVars::set_i("max_tok",L1),
	globalVars::set_i("max_kbn",L2),
	globalVars::set_i("max_rln",L3),
	init::dbaIxSetLengths,
	globalVars::set_s("kb_id","X"),
  	guix::guiRB_Get(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],Case),
	sqlBase::setParameters(L11,S12,"",Usc,Case,"",L12,Max),
	globalVars::pushRetPars(["1"]), % INITIALIZATION CONFIRMED
  	vpi::winDestroy(thisWin),
  	!
;
  	guix::guiRB_Get(thisWin,[idc_3kb,idc_sql],[1,2],Type),
  	Type=1,
	dlgIF::dlgNote(0,"Max. token length: 16-128, KB-name length: 12-64, realm name length: 8-64, KB id: 1 ('Z' and 'X' are reserved)."),
	!
;
  	guix::guiRB_Get(thisWin,[idc_3kb,idc_sql],[1,2],Type),
  	Type=2,
	dlgIF::dlgNote(0,"Max. token length: 16-128, KB-name length: 12-64, realm name length: 8-64, KB id: 1 ('Z' and 'X' are reserved). SQL field length >=9000."),
	!;!.
                        
    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    dlgIF::hlpWeb("w_InitPars"),
	!.

    predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses
    onCloseRequest() = defaultHandling() :-
    globalVars::pushRetPars(["0"]),
    !.

predicates
    onControlidc_3kb : vpiDomains::controlHandler.
clauses
    onControlidc_3kb(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_3kb,idc_sql],[1,2],1),
  	guix::ctlEnable(thisWin,[idc_kb_id]),
  	guix::ctlDisable(thisWin,[idc_sql_lengths,idc_chain_prefix,idc_blank]),
  	!;!.

predicates
    onControlidc_sql : vpiDomains::controlHandler.
clauses
    onControlidc_sql(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_3kb,idc_sql],[1,2],2),
  	guix::ctlDisable(thisWin,[idc_kb_id]),
  	guix::ctlEnable(thisWin,[idc_sql_lengths,idc_chain_prefix,idc_blank]),
  	!;!.

predicates
    onControlidc_mixed : vpiDomains::controlHandler.
clauses
    onControlidc_mixed(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],1),
  	!;!.

predicates
    onControlidc_lower : vpiDomains::controlHandler.
clauses
    onControlidc_lower(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],2),
  	!;!.

predicates
    onControlidc_upper : vpiDomains::controlHandler.
clauses
    onControlidc_upper(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_mixed,idc_lower,idc_upper],[1,2,3],3),
  	!;!.

% This code is maintained by the VDE do not update it manually, 22:04:09-4.5.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "KB Initialization Parameters".
    rectangle : vpiDomains::rct = rct(50,40,317,217).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(64,158,128,174),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(136,158,200,174),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(88,40,119,52),"",u_DlgBase),idc_kb_max_kbn,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(88,24,119,36),"",u_DlgBase),idc_kb_max_tok,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(88,56,119,68),"",u_DlgBase),idc_max_rln,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
        ctl(wdef(wc_Edit,rct(88,72,104,84),"",u_DlgBase),idc_kb_id,[wsf_UpperCase,wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_RadioButton,rct(4,2,120,12),"3KB-type database",u_DlgBase),idc_3kb,[wsf_TabStop,wsf_Group]),
        ctl(wdef(wc_RadioButton,rct(128,2,264,12),"SQL-type database",u_DlgBase),idc_sql,[wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(216,18,264,30),"",u_DlgBase),idc_sql_lengths,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(216,32,264,44),"",u_DlgBase),idc_chain_prefix,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_RadioButton,rct(128,62,228,72),"Mixed case names",u_DlgBase),idc_mixed,[wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(128,74,228,84),"Lowercase names",u_DlgBase),idc_lower,[wsf_TabStop]),
        ctl(wdef(wc_RadioButton,rct(128,86,228,96),"Uppercase names",u_DlgBase),idc_upper,[wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(216,46,232,58),"",u_DlgBase),idc_blank,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(220,100,264,112),"",u_DlgBase),idc_max_sql,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(220,116,236,128),"",u_DlgBase),idc_tformat,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Text,rct(4,24,84,34),"Max. token length",u_DlgBase),idct_max_token_length,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,40,85,50),"Max. KB name length",u_DlgBase),idct_max_kb_identifier_length,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,56,84,66),"Max. realm name length",u_DlgBase),idct_max_realm_name_length,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,72,84,82),"Database identifier",u_DlgBase),idct_internal_name_for_this_kb,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(128,32,212,42),"Chain-table name prefix",u_DlgBase),idct_chaintable_prefix,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(128,18,212,28),"Max. SQL-name lengths",u_DlgBase),idct_max_sqlname_lengths,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(128,48,212,58),"Blank-substitute",u_DlgBase),idct_blanksubstitute,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(128,100,215,110),"Max. term-string length",u_DlgBase),idct_max_sql_text_field_length,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(128,116,212,126),"Term-string Format",u_DlgBase),idct_sttable_name_prefix2,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(128,132,264,150),"1=Pro/3 term-strings  2=Visual Prolog term-strings",u_DlgBase),idct_termstring_format,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_3kb, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_3kb(idc_3kb, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sql, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_sql(idc_sql, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_mixed, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_mixed(idc_mixed, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_lower, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_lower(idc_lower, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_upper, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_upper(idc_upper, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement kbInit
