/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement knowdeps
open core, vpiDomains, resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/knowdeps".
classVersion = "1.0".

facts
thisWin : vpiDomains::windowHandle := erroneous.

class predicates
popNodes : (vpiDomains::windowHandle) determ.

clauses
classInfo(className, classVersion).

        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
   	guix::setStyle(thisWin,[idc_ok,idc_entire,idc_sub,idc_node,idct_1,idc_levels,idct_no_of_dependency_levels,idc_dep,idc_det,
  	                   idc_exclude_pro3_functions,
  	                   idc_sentence_rules,idc_certainty_rules,idc_functions,
  	                   idc_dep_graph,idc_der_graph,idct_n1,idc_txt1,idc_txt2,idc_txt3,idc_txt9,idc_txt8,idc_txt7,
  	                   idc_xsl,idc_tree,idc_STs],[]),
	guix::addWin(46,thisWin),
  	guix::ctlDisable(thisWin,[idc_ok,idc_tree,idc_xsl,idc_dep,idc_det,idc_node,idc_levels]),
	guix::guiRB_Set(thisWin,[idc_dep_graph,idc_der_graph]),
	guix::guiCB_Set(thisWin,idc_STs,1),
	guix::guiCB_Set(thisWin,idc_sentence_rules,1),
	guix::guiCB_Set(thisWin,idc_certainty_rules,0),
	guix::guiCB_Set(thisWin,idc_functions,0),
	guix::guiCB_Set(thisWin,idc_exclude_pro3_functions,1),
  	guix::ctlDisable(thisWin,[idc_exclude_pro3_functions]),
	guix::lbxPop(thisWin,idc_levels,["ALL","2","3","4","5","6","7","8","9"]),
	!;!.
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            guix::dropWin(thisWin),
            thisWin := erroneous.
    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.
    predicates
        onControlsub : vpiDomains::controlHandler.
    clauses
        onControlsub(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
  	popNodes(thisWin),
	guix::guiRB_SetN(thisWin,[idc_sub,idc_entire],[1,2],1),
  	guix::guiRB_SetN(thisWin,[idc_tree,idc_xsl],[1,2,3],1),
	guix::guiRB_SetN(thisWin,[idc_dep,idc_det],[1,2],2),
	guix::lbtSel(thisWin,idc_levels,"5"),
  	guix::ctlEnable(thisWin,[idc_node,idc_levels,idc_det,idc_dep,idc_tree,idc_xsl,idc_ok]),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.
    predicates
        onControlentire : vpiDomains::controlHandler.
    clauses
        onControlentire(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiRB_SetN(thisWin,[idc_sub,idc_entire],[1,2],2),
  	guix::guiRB_SetN(thisWin,[idc_tree,idc_xsl],[1,2],2),
  	guix::ctlDisable(thisWin,[idc_tree,idc_node,idc_levels,idc_det,idc_dep]),
  	guix::ctlEnable(thisWin,[idc_xsl,idc_ok]),
	!;!.
    predicates
        onControltree : vpiDomains::controlHandler.
    clauses
        onControltree(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_tree,idc_xsl],[1,2,3],1),
	!;!.
    predicates
        onControlxsl : vpiDomains::controlHandler.
    clauses
        onControlxsl(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_tree,idc_xsl],[1,2],2),
	!;!.
    predicates
        onControlDerGraph : vpiDomains::controlHandler.
    clauses
        onControlDerGraph(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_der_graph,idc_dep_graph],[1,2],1),
	!;!.
    predicates
        onControlDepGraph : vpiDomains::controlHandler.
    clauses
        onControlDepGraph(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_der_graph,idc_dep_graph],[1,2],2),
	!;!.
    predicates
        onControldep : vpiDomains::controlHandler.
    clauses
        onControldep(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_det,idc_dep],[1,2],2),
	!;!.
    predicates
        onControldet : vpiDomains::controlHandler.
    clauses
        onControldet(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_det,idc_dep],[1,2],1),
	!;!.
    predicates
        onControlnode : vpiDomains::controlHandler.
    clauses
        onControlnode(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::ctlEnable(thisWin,[idc_ok]),
	!;!.
    predicates
        onControlfunctions : vpiDomains::controlHandler.
    clauses
        onControlfunctions(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_functions,C2),
	C2=1,
  	guix::ctlEnable(thisWin,[idc_exclude_pro3_functions]),
	!
;
  	guix::ctlDisable(thisWin,[idc_exclude_pro3_functions]),
	!;!.
    predicates
        onControlsts : vpiDomains::controlHandler.
    clauses
        onControlsts(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_sts,C2),
	C2=1,
	!;!.
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::guiCB_Get(thisWin,idc_STs,C1),
	guix::guiCB_Get(thisWin,idc_sentence_rules,C3),
	guix::guiCB_Get(thisWin,idc_certainty_rules,C4),
	guix::guiCB_Get(thisWin,idc_functions,C5),
	set::setMax([C1,C3,C4,C5],Max),
	Max=-1,
	dlgIF::dlgNote(1,"Select at least one type of knowledge nodes to be included in the tree/graph!"),
	!
;
	% tree
  	guix::guiRB_Get(thisWin,[idc_tree,idc_xsl],[1,2,3],Choice),
  	Choice=1,
	guix::guiCB_Get(thisWin,idc_STs,C1),
	guix::guiCB_Get(thisWin,idc_sentence_rules,C3),
	guix::guiCB_Get(thisWin,idc_certainty_rules,C4),
	guix::guiCB_Get(thisWin,idc_functions,C5),
	guix::guiCB_Get(thisWin,idc_exclude_pro3_functions,C6),
	guix::guiRB_Get(thisWin,[idc_det,idc_dep],[1,2],DirTyp),
	guix::guiRB_Get(thisWin,[idc_dep_graph,idc_der_graph],[1,2],GraphTyp),
	guix::lbtGet(thisWin,idc_levels,SLev),
	guix::lbtGet(thisWin,idc_node,SNode),
	SNode<>"",
	getNode(SNode,Node),
	p3Tree::dtDepTreeOpen(GraphTyp,DirTyp,C1,-1,C3,C4,C5,C6,Node,SLev), % 1=dep.graph 2=der.graph
	vpi::cursorSet(thisWin,cursor_Arrow),
	!
;
    % visio (sub-graph)
  	guix::guiRB_Get(thisWin,[idc_tree,idc_xsl],[1,2],Choice),
  	Choice=2,
  	guix::guiRB_Get(thisWin,[idc_sub,idc_entire],[1,2],Typ),
  	Typ=1,
	guix::guiCB_Get(thisWin,idc_STs,C1),
	guix::guiCB_Get(thisWin,idc_sentence_rules,C3),
	guix::guiCB_Get(thisWin,idc_certainty_rules,C4),
	guix::guiCB_Get(thisWin,idc_functions,C5),
	guix::guiCB_Get(thisWin,idc_exclude_pro3_functions,C6),
	guix::guiRB_Get(thisWin,[idc_det,idc_dep],[1,2],DirTyp),
	guix::guiRB_Get(thisWin,[idc_dep_graph,idc_der_graph],[1,2],GraphTyp),
	set::setGet(["p3_pDP","p3_pDR"],GraphTyp,Graph),
	guix::lbtGet(thisWin,idc_levels,SLev),
	guix::lbtGet(thisWin,idc_node,SNode),
	getNode(SNode,Node),
	p3Tree::dtDepTreeTitle(GraphTyp,DirTyp,SNode,Note),
	p3Tree::dtDepTreeTitleLong(GraphTyp,DirTyp,SNode,Title),
	dep::drawDeps(Title,Note,Graph,DirTyp,C1,C3,C4,C5,C6,Node,SLev),
    !
;
    % visio (entire graph)
  	guix::guiRB_Get(thisWin,[idc_tree,idc_xsl],[1,2],Choice),
  	Choice=2,
  	guix::guiRB_Get(thisWin,[idc_sub,idc_entire],[1,2],Typ),
  	Typ=2,
	guix::guiCB_Get(thisWin,idc_STs,C1),
	guix::guiCB_Get(thisWin,idc_sentence_rules,C3),
	guix::guiCB_Get(thisWin,idc_certainty_rules,C4),
	guix::guiCB_Get(thisWin,idc_functions,C5),
	guix::guiCB_Get(thisWin,idc_exclude_pro3_functions,C6),
	guix::guiRB_Get(thisWin,[idc_dep_graph,idc_der_graph],[1,2],GraphTyp),
	set::setGet(["p3_pDP","p3_pDR"],GraphTyp,Graph),
	p3Tree::dtDepTreeTitle(GraphTyp,0,"",Note),
	p3Tree::dtDepTreeTitleLong(GraphTyp,0,"",Title),
	dep::drawDeps(Title,Note,Graph,0,C1,C3,C4,C5,C6,nill,""),
	!;!.
	
    % This code is maintained by the VDE do not update it manually, 00:18:11-16.6.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_SizeBorder,wsf_TitleBar,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren,wsf_Minimize].
    rectangle : vpiDomains::rct = rct(100,40,515,620).
    menu : vpiDomains::menu = noMenu.
    title : string = "Knowledge Dependency Graphs and Trees".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_PushButton,rct(104,548,302,576),"Generate drawing",Win,[wsf_Default,wsf_Group,wsf_TabStop],idc_ok),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(80,335,408,581),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_node),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(211,460,262,568),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_levels),
        _ = vpi::winCreateControl(wc_Text,rct(78,460,209,478),"Depth of tree/graph",Win,[wsf_AlignLeft],idct_no_of_dependency_levels),
        _ = vpi::winCreateControl(wc_RadioButton,rct(80,415,408,435),"Knowledge nodes DEPENDING on sentence type",Win,[wsf_TabStop],idc_dep),
        _ = vpi::winCreateControl(wc_RadioButton,rct(79,438,407,458),"Knowledge nodes DETERMINING sentence type",Win,[wsf_TabStop],idc_det),
        _ = vpi::winCreateControl(wc_CheckBox,rct(9,102,135,120),"Sentence rules",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_sentence_rules),
        _ = vpi::winCreateControl(wc_CheckBox,rct(137,102,263,120),"Inexact rules",Win,[wsf_Auto,wsf_Group,wsf_TabStop],idc_certainty_rules),
        _ = vpi::winCreateControl(wc_CheckBox,rct(137,81,263,99),"Functions",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_functions),
        _ = vpi::winCreateControl(wc_RadioButton,rct(80,28,242,48),"Draw dependency graph",Win,[wsf_TabStop],idc_dep_graph),
        _ = vpi::winCreateControl(wc_RadioButton,rct(248,28,410,48),"Draw derivation graph",Win,[wsf_TabStop],idc_der_graph),
        _ = vpi::winCreateControl(wc_Text,rct(9,489,409,540),"Note! No tree window will be opened if no  dependents/determinants are found. You can cascade ungenerated dependencies before drawing.",Win,[wsf_AlignLeft],idct_n1),
        _ = vpi::winCreateControl(wc_Text,rct(10,4,410,24),"Select the TYPE OF GRAPH you want to draw:",Win,[wsf_AlignLeft],idc_txt1),
        _ = vpi::winCreateControl(wc_Text,rct(8,52,408,72),"Then select the knowledge node types to be included:",Win,[wsf_AlignLeft],idc_txt2),
        _ = vpi::winCreateControl(wc_Text,rct(81,361,409,412),"Select whether you want to draw nodes depending on the selected sentence type, or nodes determining the selected sentences type:",Win,[wsf_AlignLeft],idc_txt3),
        _ = vpi::winCreateControl(wc_RadioButton,rct(112,200,255,220),"Tree",Win,[wsf_TabStop],idc_tree),
        _ = vpi::winCreateControl(wc_RadioButton,rct(264,200,407,220),"VISIO import",Win,[wsf_TabStop],idc_xsl),
        _ = vpi::winCreateControl(wc_Text,rct(8,228,406,290),"'Tree' shows the graph as a tree with the selected knowledge node as root. 'XML graph export' generates a generic export-file. 'VISIO import' transforms this export to a Visio import text-file (requires XALAN and the java run-time environment).",Win,[wsf_AlignLeft],idct_1),
        _ = vpi::winCreateControl(wc_RadioButton,rct(112,148,255,168),"Entire graph",Win,[wsf_TabStop],idc_entire),
        _ = vpi::winCreateControl(wc_RadioButton,rct(264,148,407,168),"Sub-graph",Win,[wsf_TabStop],idc_sub),
        _ = vpi::winCreateControl(wc_CheckBox,rct(265,81,409,99),"Exclude Pro/3 functions",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_exclude_pro3_functions),
        _ = vpi::winCreateControl(wc_CheckBox,rct(9,81,135,99),"Sentence types",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_sts),
        _ = vpi::winCreateControl(wc_Text,rct(8,172,408,192),"Then select HOW you want to draw:",Win,[wsf_AlignLeft],idc_txt9),
        _ = vpi::winCreateControl(wc_Text,rct(8,124,408,144),"Then select the SCOPE of the drawing:",Win,[wsf_AlignLeft],idc_txt8),
        _ = vpi::winCreateControl(wc_Text,rct(8,312,408,332),"Then specify the sub-graph (by its root-node):",Win,[wsf_AlignLeft],idc_txt7),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_sub, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsub(idc_sub, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_entire, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlentire(idc_entire, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_tree, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControltree(idc_tree, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_xsl, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlxsl(idc_xsl, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_der_graph, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlDerGraph(idc_der_graph, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_dep_graph, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlDepGraph(idc_dep_graph, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_dep, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldep(idc_dep, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_det, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldet(idc_det, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_node, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnode(idc_node, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_functions, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlfunctions(idc_functions, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sts, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsts(idc_sts, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
% -----------------------------------------------------------------------------------------------
% popNodes
% -----------------------------------------------------------------------------------------------
class predicates
popNodesX : (sterml,string_list) determ (i,o).
getNode : (string,sterm) determ (i,o).
clauses

popNodes(W) :-
	guix::guiCB_Get(W,idc_STs,ST),
	guix::guiCB_Get(W,idc_sentence_rules,SR),
	guix::guiCB_Get(W,idc_certainty_rules,CR),
	guix::guiCB_Get(W,idc_functions,FU),
	guix::guiCB_Get(W,idc_exclude_pro3_functions,XP3F),
	guix::guiRB_Get(W,[idc_dep_graph,idc_der_graph],[1,2],GraphTyp),
	set::setGet(["p3_pDP","p3_pDR"],GraphTyp,Graph),
	GR=gra::newGraph(Graph),
	GR:filter(ST,SR,CR,FU,XP3F),
	Graphs=GR:get(),
	popNodesX(Graphs,L2),
	set::distinct(L2,L),
	guix::lbxPop(W,idc_node,L),
	!.
	
popNodesX([],[]) :-
	!.
popNodesX([G|Gs],[N2,N3|Ls]) :-
	G=cmp(_,[cmp(_,[int(T2),termDomain::str(S2)]),cmp(_,[int(T3),termDomain::str(S3)])]),
	dbBase::nlTry(S2,S2n),
	set::setGet(["","","","","","","","","","","","","","","[C] ","","","","[F] "],T2,P2),	
	dbBase::nlTry(S3,S3n),
	set::setGet(["","","","","","","","","","","","","","","[C] ","","","","[F] "],T3,P3),	
	N2=string::concat(P2,S2n),
	N3=string::concat(P3,S3n),
	popNodesX(Gs,Ls),
	!.
getNode(S,Node) :-
	sx::frontstr(4,S,F,T),
	F="[F] ",
	dbBase::kbID(T,K,_,_),
	Node=cmp("n",[int(19),termDomain::str(K)]),
	!
;
	sx::frontstr(4,S,F,T),
	F="[C] ",
	dbBase::kbID(T,K,_,_),
	Node=cmp("n",[int(15),termDomain::str(K)]),
	!
;
	sx::sxUnpack(S,'|',L),
	set::size(L,N),
	N=4,
	L=[H|T],
	dbBase::kbID(H,K,_,_),
	sx::sxlJoin([K|T],"|",RK),
	Node=cmp("n",[int(3),termDomain::str(RK)]),
	!
;
	dbBase::kbID_F(S,K,Sc,_),
	Sc="p3_iPT",
	Node=cmp("n",[int(1),termDomain::str(K)]),
	!
;
	dbBase::stNL_KB(S,K),
	Node=cmp("n",[int(2),termDomain::str(K)]),
	!
;
	dbBase::kbSTX_NL_KB(S,K),
	Node=cmp("n",[int(5),termDomain::str(K)]),
	!
;
	dlgIF::feil("getNode",["Unrecognized graph node",S],[],nill),!,fail.
end implement knowdeps
