/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement newRule
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/newRule/newRule".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
realm : string := "".
        
clauses
show(Parent,Realm):-
    realm:=Realm,
    _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
eventHandler : vpiDomains::ehandler.
rdgCreateConc : (string,string,string,sterm) determ (i,i,i,o).
rdgDelete3RE : (integer,string,string).
rdgGetRealm : (string,string,string) determ (i,o,o).
rdgGetST : (vpiDomains::windowHandle,string,string,string,string) determ (i,o,o,o,o).
rdgRuleTypeDisable : (vpiDomains::windowHandle,integer) determ (i,i).

clauses

eventHandler(Win, Event) = Result :- Result = generatedEventHandler(Win, Event).

/* unary/binary */

    predicates
        onControlBinarySentence : vpiDomains::controlHandler.
    clauses
        onControlBinarySentence(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_unary_sentence,idc_binary_sentence],[1,2],2),
	vpi::cursorSetWait(),
	BPsk=pop::getBinaryPreds(),
	dbBase::nlSings(BPsk,BPs),
	guix::lbxPop(thisWin,idc_pred,BPs),
	guix::ctlEnable(thisWin,[idc_pred,idc_ent1,idc_ent2]),
	vpi::cursorSetWait(),!;!.
    predicates
        onControlUnarySentence : vpiDomains::controlHandler.
    clauses
        onControlUnarySentence(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_unary_sentence,idc_binary_sentence],[1,2],1),
	vpi::cursorSetWait(),
	UPsk=pop::getUnaryPreds(),
	dbBase::nlSings(UPsk,UPs),
	guix::lbxPop(thisWin,idc_pred,UPs),
	guix::ctlEnable(thisWin,[idc_pred,idc_ent1]),
	guix::ctlDisable(thisWin,[idc_ent2]),
	vpi::cursorSetWait(),!;!.
/* PT/ET selection/ST counts */
    predicates
        onControlpred : vpiDomains::controlHandler.
    clauses
        onControlpred(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::ctlEnable(thisWin,[idc_ok]),
	guix::txtSet(thisWin,idc_inp_sent,""),
	guix::txtSet(thisWin,idc_der_sent,""),
	guix::txtSet(thisWin,idc_rule_conc,""),
	!;!.
    predicates
        onControlent1 : vpiDomains::controlHandler.
    clauses
        onControlent1(_CtrlID, _CtrlType, _CtrlWin,CtrlInfo) = handled(0):-
        CtrlInfo=vpiDomains::selchanged,
	guix::txtSet(thisWin,idc_inp_sent,""),
	guix::txtSet(thisWin,idc_der_sent,""),
	guix::txtSet(thisWin,idc_rule_conc,""),
	guix::ctlEnable(thisWin,[idc_display_counts]),
	!
;
        CtrlInfo=vpiDomains::modified,
	guix::txtSet(thisWin,idc_inp_sent,""),
	guix::txtSet(thisWin,idc_der_sent,""),
	guix::txtSet(thisWin,idc_rule_conc,""),
	guix::ctlDisable(thisWin,[idc_display_counts]),
	!;!.
	
    predicates
        onControlent2 : vpiDomains::controlHandler.
    clauses
        onControlent2(_CtrlID, _CtrlType, _CtrlWin,CtrlInfo) = handled(0):-
        CtrlInfo=vpiDomains::selchanged,
	guix::txtSet(thisWin,idc_inp_sent,""),
	guix::txtSet(thisWin,idc_der_sent,""),
	guix::txtSet(thisWin,idc_rule_conc,""),
	!
;
        CtrlInfo=vpiDomains::modified,
	guix::txtSet(thisWin,idc_inp_sent,""),
	guix::txtSet(thisWin,idc_der_sent,""),
	guix::txtSet(thisWin,idc_rule_conc,""),
	guix::ctlDisable(thisWin,[idc_display_counts]),
	!;!.
    predicates
        onControlDisplayCounts : vpiDomains::controlHandler.
    clauses
        onControlDisplayCounts(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rdgGetST(thisWin,Card,P,Ea,Eb),
	Card="2",
	dbBase::kbID(P,Pk,_,_),
	dbBase::kbID(Ea,Eak,_,_),
	dbBase::kbID(Eb,Ebk,_,_),
	sx::sxlJoin([Pk,Eak,Ebk],"|",ST),
	dbBase::stCount(ST,N2,N3),
	dbExtension::kbST_RuleCount(ST,N4),
	N2s=toString(N2),
	N3s=toString(N3),
	N4s=toString(N4),
	guix::txtSet(thisWin,idc_inp_sent,N3s),
	guix::txtSet(thisWin,idc_der_sent,N2s),
	guix::txtSet(thisWin,idc_rule_conc,N4s),
	!
;	
	rdgGetST(thisWin,Card,P,Ea,_),
	Card="1",
	dbBase::kbID(P,Pk,_,_),
	dbBase::kbID(Ea,Eak,_,_),
	sx::sxlJoin([Pk,Eak],"|",ST),
	dbBase::stCount(ST,N2,N3),
	dbExtension::kbST_RuleCount(ST,N4),
	N2s=toString(N2),
	N3s=toString(N3),
	N4s=toString(N4),
	guix::txtSet(thisWin,idc_inp_sent,N3s),
	guix::txtSet(thisWin,idc_der_sent,N2s),
	guix::txtSet(thisWin,idc_rule_conc,N4s),
	!;!.
/* ok */
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::txtGet(thisWin,idc_name,Realm),
	guix::txtGet(thisWin,idc_lno,SNo),
	saveAsRealm::rdgRealmError(1,Realm,SNo),
	!
;
	rdgGetST(thisWin,_,P,Ea,Eb),
  	guix::guiRB_Get(thisWin,[idc_simple_implication,idc_set_implication,idc_generalization,idc_selection,idc_cr_call,idc_sel_min,idc_sel_max,idc_sel_acc,idc_sel_ip,idc_sel_ipxd,idc_ranking,idc_correlation],[1,21,4,61,22,62,63,64,65,68,66,67],RuleType),
	guix::txtGet(thisWin,idc_name,Realm),
	guix::txtGetI(thisWin,idc_lno,No),
	rdgCreateConc(P,Ea,Eb,Conc),
	rub::rubRuleType(SRT,RuleType,TypeK),
	Rule=cmp(SRT,[Conc,nill]), % conc-cond will be reversed by rt::rcnCleanRule
	rt::rcnCleanRule(-1,TypeK,Rule,Tree,DEs),
	SType=toString(RuleType),
	ruleeditor::rtrTreeDisplay(Tree,SType,DEs,Realm,No,0),
	vpi::winDestroy(thisWin),
	!;!.

/* help */

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dlgIF::hlpWeb("NewSentenceRule"),
	!;!.
	
/* create */
	
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
	vpi::cursorSetWait(),
	EntsK=pop::getSM("e"),
	dbBase::nlSings(EntsK,Ents),
	guix::lbxPop(thisWin,idc_ents,Ents),
	guix::lbxPop(thisWin,idc_ent1,Ents),
	guix::lbxPop(thisWin,idc_ent2,Ents),
  	guix::guiRB_SetN(thisWin,[idc_unary_sentence,idc_binary_sentence],[1,2],1),
	vpi::cursorSetWait(),
	UPsK=pop::getUnaryPreds(),
	dbBase::nlSings(UPsK,UPs),
	guix::lbxPop(thisWin,idc_pred,UPs),
	guix::ctlEnable(thisWin,[idc_pred,idc_ent1]),
	guix::ctlDisable(thisWin,[idc_ent2]),
	guix::txtSet(thisWin,idc_name,realm),
	guix::lbxPop(thisWin,idc_lno,["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20"]),
	%guix::lbtSel(thisWin,idc_lno,"1"),  	
	guix::guiRB_SetN(thisWin,[idc_simple_implication,idc_set_implication,idc_generalization,idc_selection],[1,2,3,4],1),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_name),
	vpi::winSetFocus(Ctl),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    % This code is maintained by the VDE do not update it manually, 10:45:30-12.3.2005
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "New Sentence Rule".
        rectangle : vpiDomains::rct = rct(50,40,454,224).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 10.

    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_Edit,rct(4,38,172,50),"",u_DlgBase),idc_name,[wsf_UpperCase,wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_LBoxEdit,rct(176,38,213,172),"",u_DlgBase),idc_lno,[wsf_Group,wsf_TabStop,wsf_VScroll]),
            ctl(wdef(wc_RadioButton,rct(4,66,83,76),"Simple implication",u_DlgBase),idc_simple_implication,[wsf_Auto,wsf_TabStop,wsf_Group]),
            ctl(wdef(wc_RadioButton,rct(4,79,83,89),"Generalization",u_DlgBase),idc_generalization,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(4,102,83,112),"Inexact rule calls",u_DlgBase),idc_cr_call,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(4,126,83,136),"Numeric interpolation",u_DlgBase),idc_sel_ip,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(4,138,83,148),"Date interpolation",u_DlgBase),idc_sel_ipxd,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,66,212,77),"Statistical procedure on sets",u_DlgBase),idc_set_implication,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,78,212,89),"Value accumulation ",u_DlgBase),idc_sel_acc,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,90,212,100),"Ranking",u_DlgBase),idc_ranking,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,102,212,112),"Correlation",u_DlgBase),idc_correlation,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,114,212,124),"Selection of unique sentences",u_DlgBase),idc_selection,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,126,212,136),"Selection of max. value sentences",u_DlgBase),idc_sel_max,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(88,138,212,148),"Selection of min. value sentences",u_DlgBase),idc_sel_min,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_RadioButton,rct(220,26,303,35),"Unary sentence type",u_DlgBase),idc_unary_sentence,[wsf_Auto,wsf_TabStop,wsf_Group]),
            ctl(wdef(wc_RadioButton,rct(317,26,400,35),"Binary sentence type",u_DlgBase),idc_binary_sentence,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_LBoxEdit,rct(220,49,400,240),"",u_DlgBase),idc_ent1,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
            ctl(wdef(wc_LBoxButton,rct(220,62,400,252),"",u_DlgBase),idc_pred,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
            ctl(wdef(wc_LBoxEdit,rct(220,75,400,250),"",u_DlgBase),idc_ent2,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
            ctl(wdef(wc_PushButton,rct(220,128,274,140),"Display Counts",u_DlgBase),idc_display_counts,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(356,109,400,121),"",u_DlgBase),idc_inp_sent,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(356,126,400,138),"",u_DlgBase),idc_der_sent,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_Edit,rct(356,146,400,158),"",u_DlgBase),idc_rule_conc,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
            ctl(wdef(wc_PushButton,rct(84,164,182,182),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(228,164,326,182),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_LBox,rct(8,196,14,206),"",u_DlgBase),idc_ents,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible]),
            ctl(wdef(wc_Text,rct(4,16,212,35),"Enter the realm name and record number by which you want to remember the rule:",u_DlgBase),idct_realm,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(276,110,352,120),"No. of inputted sent.",u_DlgBase),idct_inp_sentences,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(276,128,352,138),"No. of derived sent.",u_DlgBase),idct_der_sentences,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(276,144,352,160),"No. of rules concluding this sent. type",u_DlgBase),idct_rule_conclusions,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(220,14,400,24),"Is the conclusion a unary or a binary sentence type?",u_DlgBase),idc_new_rule_7,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(220,38,400,48),"Specify the sentence type the rule will conclude:",u_DlgBase),idc_new_rule_10,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(220,88,400,106),"You can check some existing counts for this sentence type (for your information):",u_DlgBase),idc_new_rule_30,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(4,54,212,64),"The method the rule will be using",u_DlgBase),idct_the_method_the_rule_will_be_using,[wsf_AlignCenter]),
            ctl(wdef(wc_Text,rct(4,2,212,12),"The identification of the rule",u_DlgBase),idct_the_identification_of_the_rule,[wsf_AlignCenter]),
            ctl(wdef(wc_Text,rct(220,2,400,12),"The rule's conclusion",u_DlgBase),idct_the_rules_conclusion,[wsf_AlignCenter])
            ].

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_binary_sentence, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlBinarySentence(idc_binary_sentence, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_unary_sentence, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlUnarySentence(idc_unary_sentence, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_pred, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlpred(idc_pred, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ent1, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlent1(idc_ent1, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ent2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlent2(idc_ent2, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_display_counts, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlDisplayCounts(idc_display_counts, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
% ----------------------------------------------------------------------------------------------
% rdgCreateConc
% ----------------------------------------------------------------------------------------------
class predicates
rdgCreateArg : (string,integer,sterm) determ (i,i,o).
rdgCreateArgDEs : (string,string_list,sterml) determ (i,i,o).
rdgCreateConcX : (string,string,string,sterm) determ (i,i,i,o).
rdgConcAdj : (sterm,sterm) procedure (i,o).	
clauses
rdgCreateConc(P,Ea,Eb,Conc) :-
	rdgCreateConcX(P,Ea,Eb,Conc2),
	rdgConcAdj(Conc2,Conc),
	!.
	
rdgConcAdj(cmp(A,[B,nill,C]),cmp(A,[B,C])) :- !.
rdgConcAdj(cmp(A,[B,nill]),cmp(A,[B])) :- !.
rdgConcAdj(C,C) :- !.

rdgCreateConcX(P,Ea,"",Conc) :-
	sx::frontstr(1,Ea,Fa,_),
	Fau=string::toUpperCase(Fa),
	Fa=Fau,
	!,
	dbBase::kbID(P,Pk,_,_),
	rdgCreateArg(Pk,0,ArgP),
	sx::concat([Pk,"|",Ea],ST),
	Conc=cmp(ST,[var(Ea),ArgP]),
	!
;
	dbBase::kbID(P,Pk,_,_),
	dbBase::kbID(Ea,Eak,_,_),
	rdgCreateArg(Pk,0,ArgP),
	rdgCreateArg(Eak,1,ArgEa),
	sx::concat([Pk,"|",Eak],ST),
	Conc=cmp(ST,[ArgEa,ArgP]),
	!.
rdgCreateConcX(P,Ea,Eb,Conc) :-
	sx::frontstr(1,Ea,Fa,_),
	Fau=string::toUpperCase(Fa),
	Fa=Fau,
	sx::frontstr(1,Eb,Fb,_),
	Fbu=string::toUpperCase(Fb),
	Fb=Fbu,
	!,
	dbBase::kbID(P,Pk,_,_),
	rdgCreateArg(Pk,0,ArgP),
	sx::concat([Pk,"|",Ea,"|",Eb],ST),
	Conc=cmp(ST,[var(Ea),ArgP,var(Eb)]),
	!
;
	sx::frontstr(1,Ea,Fa,_),
	Fau=string::toUpperCase(Fa),
	Fa=Fau,
	!,
	dbBase::kbID(P,Pk,_,_),
	rdgCreateArg(Pk,0,ArgP),
	dbBase::kbID(Eb,Ebk,_,_),
	rdgCreateArg(Ebk,2,ArgEb),
	sx::concat([Pk,"|",Ea,"|",Ebk],ST),
	Conc=cmp(ST,[var(Ea),ArgP,ArgEb]),
	!
;
	sx::frontstr(1,Eb,Fb,_),
	Fbu=string::toUpperCase(Fb),
	Fb=Fbu,
	!,
	dbBase::kbID(P,Pk,_,_),
	rdgCreateArg(Pk,0,ArgP),
	dbBase::kbID(Ea,Eak,_,_),
	rdgCreateArg(Eak,1,ArgEa),
	sx::concat([Pk,"|",Eak,"|",Eb],ST),
	Conc=cmp(ST,[ArgEa,ArgP,var(Eb)]),
	!
;
	dbBase::kbID(P,Pk,_,_),
	rdgCreateArg(Pk,0,ArgP),
	dbBase::kbID(Ea,Eak,_,_),
	rdgCreateArg(Eak,1,ArgEa),
	dbBase::kbID(Eb,Ebk,_,_),
	rdgCreateArg(Ebk,2,ArgEb),
	sx::concat([Pk,"|",Eak,"|",Ebk],ST),
	Conc=cmp(ST,[ArgEa,ArgP,ArgEb]),
	!.
rdgCreateArg(Ak,No,Arg) :-
	No=0,
	dbBase::kbPredDEs(Ak,DEs,_),
	set::size(DEs,M),
	M>0,
	vars::varPrefix(No,Ak,Prefix),
	rdgCreateArgDEs(Prefix,DEs,ADEs),
	SNo=toString(No),
	sx::concat([Ak,"[",SNo,"]"],A),
	Arg=cmp(A,ADEs),
	!
;
	No=0,
	Arg=nill,
	!
;
	No>0,
	dbBase::kbEntityDEs(Ak,DEs,_),
	vars::varPrefix(No,Ak,Prefix),
	rdgCreateArgDEs(Prefix,DEs,ADEs),
	SNo=toString(No),
	sx::concat([Ak,"[",SNo,"]"],A),
	Arg=cmp(A,ADEs),
	!.
	
rdgCreateArgDEs(_,[],[]) :-
	!.
rdgCreateArgDEs(Prefix,[DE|DEs],[ADE|ADEs]) :-
	sx::concat([Prefix,DE],V),
	ADE=cmp(V,[cmp("=",[nill])]),
	rdgCreateArgDEs(Prefix,DEs,ADEs),
	!.
% ----------------------------------------------------------------------------------------------
% rdgDelete3RE
% ----------------------------------------------------------------------------------------------
rdgDelete3RE(Conditional,Realm,SNo) :-
	Conditional=1,
	Path=globalVars::get_s("std_path"),
	sx::concat([Path,Realm,"-",SNo,".3RE"],OutFile),
	file::existfile(OutFile),
	sx::concat(["Do you want to delete source file ",OutFile,"?"],Mess),
	Reply=vpiCommonDialogs::ask(Mess,"Please confirm",["Yes","No"]),
	Reply=vpiCommonDialogs::resp_default,
	file::delete(OutFile),
	!
;
	Conditional=-1,
	Path=globalVars::get_s("std_path"),
	sx::concat([Path,Realm,"-",SNo,".3RE"],OutFile),
	file::existfile(OutFile),
	file::delete(OutFile),
	!
;
	!.
% ----------------------------------------------------------------------------------------------
% rdgGetRealm
% ----------------------------------------------------------------------------------------------
rdgGetRealm(S,Realm,SNo) :-
	% SG-rule
	sx::sxUnpackS(S,": ",Lr),
	Lr=[RealmData,S5],
	dbExtension::dbuSentenceR(Realm,SentNo,SubNo,RealmData),
	sx::searchchar(S5,'[',P5),
	N5=P5-1,
	sx::frontstr(N5,S5,Pn,_),
	dbBase::kbID_F(Pn,_,Clas,_),
	Clas="p3_iPT",
	SubNo>0,
	No=SentNo*1000+SubNo,
	SNo=toString(No),
	!
;	
	% SG-rule
	sx::sxUnpackS(S,": ",Lr),
	Lr=[RealmData,S5],
	dbExtension::dbuSentenceR(Realm,SentNo,SubNo,RealmData),
	sx::searchchar(S5,'[',P5),
	N5=P5-1,
	sx::frontstr(N5,S5,Pn,_),
	dbBase::kbID_F(Pn,_,Clas,_),
	Clas="p3_iPT",
	SubNo=0,
	SNo=toString(SentNo),
	!
;	
	% ST-rule
	sx::sxUnpackS(S,": ",Lr),
	Lr=[RealmData,_],
	dbExtension::dbuSentenceR(Realm,SentNo,SubNo,RealmData),
	SubNo>0,
	No=SentNo*1000+SubNo,
	SNo=toString(No),
	!
;	
	% ST-rule
	sx::sxUnpackS(S,": ",Lr),
	Lr=[RealmData,_],
	dbExtension::dbuSentenceR(Realm,SentNo,SubNo,RealmData),
	SubNo=0,
	SNo=toString(SentNo),
	!.
% ----------------------------------------------------------------------------------------------
% rdgGetST
% ----------------------------------------------------------------------------------------------
rdgGetST(Win,Card,P,Ea,Eb) :-
	guix::txtGet(Win,idc_ent1,Ea),
	Ea="",
	dlgIF::dlgNote(1,"Entity argument must be specified"),
	Ctl=vpi::winGetCtlHandle(Win,idc_ent1),
	vpi::winSetFocus(Ctl),
	!,fail
;
  guix::guiRB_Get(Win,[idc_unary_sentence,idc_binary_sentence],[1,2],N),
  	N=2,
	guix::txtGet(Win,idc_ent2,Eb),
	Eb="",
	dlgIF::dlgNote(1,"Second entity argument must be specified"),
	Ctl=vpi::winGetCtlHandle(Win,idc_ent2),
	vpi::winSetFocus(Ctl),
	!,fail
;
	guix::txtGet(Win,idc_ent1,Ea),
	not(rub::rubIsVar(Ea,_,_)),
	guix::lbxGetAll(Win,idc_ents,Es),
	not(set::member(Ea,Es)),
	dlgIF::dlgNote(1,"Entity argument is invalid"),
	Ctl=vpi::winGetCtlHandle(Win,idc_ent1),
	vpi::winSetFocus(Ctl),
	!,fail
;
  guix::guiRB_Get(Win,[idc_unary_sentence,idc_binary_sentence],[1,2],N),
  	N=2,
	guix::txtGet(Win,idc_ent2,Ea),
	not(rub::rubIsVar(Ea,_,_)),
	guix::lbxGetAll(Win,idc_ents,Es),
	not(set::member(Ea,Es)),
	dlgIF::dlgNote(1,"Entity argument is invalid"),
	Ctl=vpi::winGetCtlHandle(Win,idc_ent2),
	vpi::winSetFocus(Ctl),
	!,fail
;
  guix::guiRB_Get(Win,[idc_unary_sentence,idc_binary_sentence],[1,2],N),
  	N=2,
	guix::lbtGetF(Win,idc_pred,P),
	guix::txtGet(Win,idc_ent1,Ea),
	guix::txtGet(Win,idc_ent2,Eb),
	Card="2",
	!
;	
  guix::guiRB_Get(Win,[idc_unary_sentence,idc_binary_sentence],[1,2],N),
  	N=1,
	guix::lbtGetF(Win,idc_pred,P),
	guix::txtGet(Win,idc_ent1,Ea),
	Eb="",
	Card="1",
	!.
% ----------------------------------------------------------------------------------------------
% rdgRuleTypeDisable
% ----------------------------------------------------------------------------------------------
% ref. rubRuleType
%
rdgRuleTypeDisable(REW,N) :-
	set::member(N,[1,4,7]),
	guix::ctlInvisible(REW,[idc_ctrl,idc_procedure]),
	!
;
	N=22,
	guix::ctlInvisible(REW,[idc_procedure]),
	!
;
	N=21,
	Procs=["p3_rCnt","p3_rSum","p3_rAvg","p3_rMea","p3_rSdv","p3_rMin","p3_rMax","p3_rStv","p3_rEtv","p3_rStim","p3_rEtim","p3_rMit","p3_rMat","p3_rTS"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=61,
	Procs=["p3_rUn","p3_rAssg"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=62,
	Procs=["p3_rMin","p3_rAssg"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=63,
	Procs=["p3_rMax","p3_rAssg"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=64,
	Procs=["p3_rAcc"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=65,
	Procs=["p3_rCip","p3_rLow","p3_rMnVa","p3_rUpp","p3_rDf"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=66,
	Procs=["p3_rRank","p3_rRnks","p3_rSort","p3_rAssg"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=67,
	Procs=["p3_rCorr","p3_rAssg"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	N=68,
	Procs=["p3_rCipxd","p3_rLow","p3_rMnVa","p3_rUpp","p3_rDf"],
	dbBase::nlSings(Procs,L),
	guix::lbxPop(REW,idc_procs,L),
	guix::ctlInvisible(REW,[idc_ctrl]),
	!
;
	dlgIF::feil("rdgRuleTypeDisable",["Unknown rule type"],[N],nill),!,fail.
end implement newRule
