/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement publicchains
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/publicchains".
        classVersion = "1.0".

class predicates    
wwAddChains : (integer,string_list,string_list) determ (i,i,o).
wwGetChains : (string_list,string_list,string_list) determ (i,o,o).
clauses

        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.

    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* update */

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dbBase::chainDelete("p3_pIpch"),
	guix::lbxGetAll(thisWin,idc_schains,Chains),
	wwGetChains(Chains,Cr,Cw),
	dbaBase::database(DB,_,_,0),
	dbaUtil::dbuPubChainsIns(DB,"p3_iRo",Cr),
	dbaUtil::dbuPubChainsIns(DB,"p3_iRw",Cw),
	guix::dropWin(thisWin),
	vpi::winDestroy(thisWin),
	!;!.

/* add public chains */

    predicates
        onControlselect : vpiDomains::controlHandler.
    clauses
        onControlselect(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_writeable,CB),
	guix::lbxGetAll(thisWin,idc_chains,Ca),
	guix::lbxGetMulti(thisWin,idc_chains,Chains),
	set::setRemSub(Chains,Ca,Car),
	guix::lbxPop(thisWin,idc_chains,Car),
	guix::lbxGetAll(thisWin,idc_schains,SChains),
	wwAddChains(CB,Chains,L),
	set::conc([L,SChains],L2),
	guix::lbxPop(thisWin,idc_schains,L2),
	!;!.

/* remove public chains */

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbxGetMulti(thisWin,idc_schains,Ls),
	guix::lbxGetAll(thisWin,idc_schains,La),
	set::setRemSub(Ls,La,Lm),
	guix::lbxPop(thisWin,idc_schains,Lm),
	guix::lbxGetAll(thisWin,idc_chains,Lc),
	sx::sxlFrontStr(7,Ls,_,Ls2),
	set::conc([Ls2,Lc],Lc3),
	guix::lbxPop(thisWin,idc_chains,Lc3),
	!;!.

    /* create, destroy */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
  	guix::setStyle(thisWin,[idc_chains,idc_schains,idc_select,idc_ok,idc_writeable,idct_public_chains,idct_chains_in_the_db,idc_remove,idc_txt1],[]),
    guix::addWin(31,thisWin),
    dbaBase::database(DB,_,_,0),
    Ci=pop::getChains(),
    Ce=pop::getChainsExt(-1),
	Cpr=pop::getChainsPubDB(DB,0),
	Cpw=pop::getChainsPubDB(DB,1),
	set::conc([Ce,Cpr,Cpw,["x","z","p3_pDP","p3_pDR","p3_pSM","p3_pIpch","p3_pIxdb","p3_iCand","p3_iCor","p3_iCnot","p3_iCbay","p3_iCswi","p3_iCdat","p3_iCmap"]],Rem),
	set::setRemSub(Rem,Ci,Cim),
	dbBase::nlSings(Cim,Cin),
	guix::lbxPop(thisWin,idc_chains,Cin),
	dbBase::nlSings(Cpr,Cprn),
	sx::sxlAddPrefix(Cprn,"READ:  ",Cp2),
	dbBase::nlSings(Cpw,Cpwn),
	sx::sxlAddPrefix(Cpwn,"WRITE: ",Cp3),
	set::conc([Cp2,Cp3],Cp),
	guix::lbxPop(thisWin,idc_schains,Cp),
	guix::addWin(115,"",thisWin),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
            guix::dropWin(thisWin),
            vpi::winDestroy(thisWin),
            !.

    % This code is maintained by the VDE do not update it manually, 12:29:13-5.1.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,40,449,614).
        menu : vpiDomains::menu = noMenu.
        title : string = "Public Chains".

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_PushButton,rct(96,532,264,569),"Update",Win,[wsf_Group,wsf_TabStop],idc_ok),
            _ = vpi::winCreateControl(wc_LBox,rct(8,27,342,224),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_MultiSelect],idc_chains),
            _ = vpi::winCreateControl(wc_LBox,rct(8,284,342,456),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_MultiSelect],idc_schains),
            _ = vpi::winCreateControl(wc_CheckBox,rct(208,232,343,252),"Public write-able",Win,[wsf_Group,wsf_TabStop,wsf_Auto],idc_writeable),
            _ = vpi::winCreateControl(wc_PushButton,rct(8,232,204,256),"Make selected chains public",Win,[wsf_Group,wsf_TabStop],idc_select),
            _ = vpi::winCreateControl(wc_Text,rct(11,4,345,24),"Internal chains",Win,[wsf_AlignCenter],idct_chains_in_the_db),
            _ = vpi::winCreateControl(wc_Text,rct(8,260,342,280),"Public chains",Win,[wsf_AlignCenter],idct_public_chains),
            _ = vpi::winCreateControl(wc_PushButton,rct(47,501,311,525),"Make selected chains internal",Win,[wsf_Group,wsf_TabStop],idc_remove),
            _ = vpi::winCreateControl(wc_Text,rct(10,464,344,496),"Public chains are prefixed with either R| or W| for read-only and write-able chains.",Win,[wsf_AlignLeft],idc_txt1),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_select, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlselect(idc_select, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code

% --------------------------------------------------------------------------
% wwAddChains
% --------------------------------------------------------------------------
wwAddChains(_,[],[]) :-
	!.
wwAddChains(-1,[Chain|Chains],[S|L]) :-
	S=string::concat("READ:  ",Chain),
	wwAddChains(-1,Chains,L),
	!.
wwAddChains(1,[Chain|Chains],[S|L]) :-
	S=string::concat("WRITE: ",Chain),
	wwAddChains(1,Chains,L),
	!.
% --------------------------------------------------------------------------
% wwGetChains
% --------------------------------------------------------------------------
wwGetChains([],[],[]) :-
	!.
wwGetChains([Chain|Chains],[Tk|Cr],Cw) :-
	sx::frontstr(7,Chain,F,T),
	F="READ:  ",
	dbBase::kbID(T,Tk,_,_),
	wwGetChains(Chains,Cr,Cw),
	!.
wwGetChains([Chain|Chains],Cr,[Tk|Cw]) :-
	sx::frontstr(7,Chain,F,T),
	F="WRITE: ",
	dbBase::kbID(T,Tk,_,_),
	wwGetChains(Chains,Cr,Cw),
	!.
end implement publicchains
