/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement queryParameter
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/queryParameters/queryParameter".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
    thisWin : vpiDomains::windowHandle := erroneous.
    query : string :="".
    domain : string :="".
    format : string :="".
    parName : string :="".

clauses
    show(Parent,Query,Domain,Format,Title):-
        query:=Query,
        domain:=Domain,
        format:=Format,
        parName:=Title,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    guix::txtSet(thisWin,idc_query,query),
    guix::txtSet(thisWin,idc_domain,domain),
    guix::txtSet(thisWin,idc_format,format),
    guix::txtSet(thisWin,idc_parameter,parName),
    !.
    
predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        guix::txtGet(thisWin,idc_domain,D),
        dbBase::kbID(D,Dom,_,_),
        dom::domStr(Dom),        
        guix::txtGet(thisWin,idc_value,S),
        St=string::trim(S),
        sx::sxQuote(St,Stq),
        globalVars::pushRetPars([Stq]),
        vpi::winDestroy(thisWin),
        !
;        
        guix::txtGet(thisWin,idc_domain,D),
        dbBase::kbID(D,Dom,_,_),
        dom::domAtom(Dom),        
        guix::txtGet(thisWin,idc_value,S),
        St=string::trim(S),
        dbBase::kbID(St,_,_,_),
        globalVars::pushRetPars([St]),
        vpi::winDestroy(thisWin),
        !
;        
        guix::txtGet(thisWin,idc_domain,D),
        dbBase::kbID(D,Dom,_,_),
        dom::domInt(Dom),        
        guix::txtGet(thisWin,idc_value,S),
        St=string::trim(S),
        Sti=sx::toInt(St),
        dom::domValCompat(Dom,termDomain::int(Sti)),
        globalVars::pushRetPars([St]),
        vpi::winDestroy(thisWin),
        !
;        
        guix::txtGet(thisWin,idc_domain,D),
        dbBase::kbID(D,Dom,_,_),
        dom::domNum(Dom),        
        guix::txtGet(thisWin,idc_value,S),
        St=string::trim(S),
        Sti=sx::toReal(St),
        dom::domValCompat(Dom,termDomain::fix(Sti)),
        globalVars::pushRetPars([St]),
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlCancel : vpiDomains::controlHandler.
clauses
    onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        globalVars::set_i("quit_flag",1),
	    sdb::sdbSetStatus,
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    dlgIF::hlpNo(70),
    !.
    
predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses
    onCloseRequest() = defaultHandling() :-
        globalVars::set_i("quit_flag",1),
	    sdb::sdbSetStatus,
        vpi::winDestroy(thisWin),
        !;!.

% This code is maintained by the VDE do not update it manually, 14:26:59-30.5.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Query Parameter".
    rectangle : vpiDomains::rct = rct(50,40,282,123).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,68,76,80),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(80,68,152,80),"Cancel",u_DlgBase),idc_cancel,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(156,68,228,80),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(44,4,228,16),"",u_DlgBase),idc_query,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(44,32,168,44),"",u_DlgBase),idc_domain,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(204,32,228,44),"",u_DlgBase),idc_format,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(44,48,228,60),"",u_DlgBase),idc_value,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
        ctl(wdef(wc_Edit,rct(44,18,228,30),"",u_DlgBase),idc_parameter,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Text,rct(4,6,40,16),"Query",u_DlgBase),idct_query,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,34,40,44),"Domain",u_DlgBase),idct_domain,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(172,34,200,44),"Format",u_DlgBase),idct_format,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,50,40,60),"Value",u_DlgBase),idct_domain1,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,20,40,30),"Parameter",u_DlgBase),idct_query1,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement queryParameter
