/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement querylistparameter
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/queryParameters/querylistparameter".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
    thisWin : vpiDomains::windowHandle := erroneous.
    query : string :="".
    domain : string :="".
    format : string :="".
    parName : string :="".
    alternatives : string_list :=[].

clauses
    show(Parent,Query,Domain,Format,Title,Alts):-
        query:=Query,
        domain:=Domain,
        format:=Format,
        parName:=Title,
        alternatives:=Alts,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling():-
    guix::txtSet(thisWin,idc_query,query),
    guix::txtSet(thisWin,idc_domain,domain),
    guix::txtSet(thisWin,idc_format,format),
    guix::txtSet(thisWin,idc_parameter,parName),
    guix::lbxPop(thisWin,idc_value,alternatives),
    !.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses
    onCloseRequest() = defaultHandling():-
        globalVars::set_i("quit_flag",1),
	    sdb::sdbSetStatus,
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlidc_ok : vpiDomains::controlHandler.
clauses
    onControlidc_ok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        guix::lbxGet(thisWin,idc_value,S),
        St=string::trim(S),
        globalVars::pushRetPars([St]),
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    dlgIF::hlpNo(70),
    !.

predicates
    onControlidc_cancel : vpiDomains::controlHandler.
clauses
    onControlidc_cancel(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        globalVars::set_i("quit_flag",1),
	    sdb::sdbSetStatus,
        vpi::winDestroy(thisWin),
        !;!.

% This code is maintained by the VDE do not update it manually, 16:08:03-30.5.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Query Parameter".
    rectangle : vpiDomains::rct = rct(50,40,281,204).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_Edit,rct(44,4,228,16),"",u_DlgBase),idc_query,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(44,36,160,48),"",u_DlgBase),idc_domain,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Edit,rct(196,36,228,48),"",u_DlgBase),idc_format,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_PushButton,rct(4,150,76,162),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(80,150,152,162),"Cancel",u_DlgBase),idc_cancel,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(156,150,228,162),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_LBox,rct(44,52,228,146),"",u_DlgBase),idc_value,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight]),
        ctl(wdef(wc_Edit,rct(44,18,228,30),"",u_DlgBase),idc_parameter,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled]),
        ctl(wdef(wc_Text,rct(4,6,32,16),"Query",u_DlgBase),idct_query,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,34,32,44),"Domain",u_DlgBase),idct_domain,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(164,38,192,48),"Format",u_DlgBase),idct_format,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,52,32,62),"Value",u_DlgBase),idct_domain1,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(4,20,40,30),"Parameter",u_DlgBase),idct_query1,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_ok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_cancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement querylistparameter
