/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement sentencerep
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/reports/sentencerep".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.
            
    clauses
        show(Parent):-
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling().

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        vpi::winDestroy(thisWin),
        !.

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::guiCB_Get(thisWin,idc_show_sentence_groups,P2),
	guix::guiCB_Get(thisWin,idc_show_sentence_rules,P3),
	guix::guiCB_Get(thisWin,idc_show_kb_names,P4),
	guix::guiCB_Get(thisWin,idc_show_sample,P5),
	guix::guiCB_Get(thisWin,idc_dets,P6),
	guix::guiCB_Get(thisWin,idc_anno,P7),
	guix::guiCB_Get(thisWin,idc_derive,P8),
	vpi::winDestroy(thisWin),
	p3rep::repSent(P3,P2,P4,P5,P6,P7,P8),
	!;!.

    % This code is maintained by the VDE do not update it manually, 10:41:39-2.4.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Sentence Report Parameters".
    rectangle : vpiDomains::rct = rct(50,40,177,144).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(44,88,84,100),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,2,124,12),"Show sentence groups",u_DlgBase),idc_show_sentence_groups,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(4,14,124,24),"Show sentence rules",u_DlgBase),idc_show_sentence_rules,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(4,26,124,36),"Show KB names",u_DlgBase),idc_show_kb_names,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(4,38,124,48),"Show sample sentence",u_DlgBase),idc_show_sample,[wsf_Group,wsf_TabStop,wsf_Auto]),
        ctl(wdef(wc_CheckBox,rct(4,50,124,60),"Show determinant sentence types",u_DlgBase),idc_dets,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,62,124,72),"Show derivation information",u_DlgBase),idc_derive,[wsf_Auto,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_CheckBox,rct(4,74,124,84),"Show annotations",u_DlgBase),idc_anno,[wsf_Auto,wsf_Group,wsf_TabStop])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement sentencerep
