/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement ruleEditor
open core,vpiDomains,resourceIdentifiers,termDomain,globalDomains

constants
className = "com/rudstrand/TaskWindow/ruleEditor".
classVersion = "1.0".

facts
thisWin : vpiDomains::windowHandle := erroneous.
treeWin : vpiDomains::windowHandle := erroneous.
rule : sterm := nill.

class facts
winCount : integer:=0.

predicates
filterContext : (string_list,string_list,string_list) determ (i,i,o).
rtrCompPopSelection : (integer) determ.	
rubInCond : (integer_list,integer) procedure (i,o).
rtrCompInsert : (integer) determ.
rtrTreeRedraw : (integer,integer,integer) determ.
rtrProcessElement : (integer,string) determ.
redAutoAssign : ().
rubNodeNew : (integer,integer,sterm) determ.
rtrSetST : (sterm,string) procedure (i,o).
setDomain : (integer_list,string_list).
unknownST : (string).

clauses
classInfo(className, classVersion).
getWin()=W:-W=thisWin.

new(Parent):-
            N=winCount+1,
            winCount:=N,
            W=vpi::winCreate(windowType, rectangle, title, menu, Parent,windowFlags, eventHandler, 0),
            guix::addWin(40,"",W,N,0).

getCount()=N :- N=winCount.

setPars(Rule,SType,DEs,DEsConc,Realm,No,SubNo,Tree) :-
    rule:=Rule,
	rtrSetST(Rule,ST),
	guix::txtSet(thisWin,idc_st,ST),
  	guix::lbxPop(thisWin,idc_des,DEs),
  	guix::lbxPop(thisWin,idc_des_conc,DEsConc),
  	guix::txtSet(thisWin,idc_realm,Realm),
	SNo=toString(No),
  	guix::txtSet(thisWin,idc_sno,SNo),
  	guix::txtSetI(thisWin,idc_sbno,SubNo),
  	guix::txtSet(thisWin,idc_ruletype,SType),
  	Type=sx::toInt(SType),
	ruled::rdgRuleTypeDisable(thisWin,Type),
  	sx::concat([Realm," [",SNo,"]"],WinName),
  	RE_Name=string::concat("Rule editor: ",WinName),
  	vpi::winSetText(thisWin,RE_Name),
	RT_Name=string::concat("Sentence rule: ",WinName),
	p3Tree::drwOpenTree(RT_Name,41,Tree,vpiTree::tree_DirRight,W),
	treeWin:=W, 
	rub::rubNodeSetCurr(W,2),
	vpi::winBringToTop(W),
	vpi::winBringToTop(thisWin),
	!.
rtrSetST(Rule,ST) :-
	Rule=cmp(_,[cmp(ST,[cmp(_,_),cmp(_,_)|_]),_]),
	!
;
	Rule=cmp(_,[cmp(ST,[cmp(_,_)|_]),_]),
	!
;
	ST="",
	!.
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* component radio buttons */

    predicates
        onControlde : vpiDomains::controlHandler.
    clauses
        onControlde(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],7),
  	guix::ctlEnable(thisWin,[idc_st_counts]),
  	guix::ctlDisable(thisWin,[idc_long]),
  	rtrCompPopSelection(7),!;!.
    predicates
        onControlvar : vpiDomains::controlHandler.
    clauses
        onControlvar(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],6),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(6),!;!.
    predicates
        onControllit : vpiDomains::controlHandler.
    clauses
        onControllit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],5),
  	guix::ctlDisable(thisWin,[idc_st_counts]),
  	guix::ctlEnable(thisWin,[idc_long]),
  	rtrCompPopSelection(5),!;!.
    predicates
        onControlvrc : vpiDomains::controlHandler.
    clauses
        onControlvrc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],4),
  	guix::ctlDisable(thisWin,[idc_st_counts]),
  	guix::ctlEnable(thisWin,[idc_long]),
  	rtrCompPopSelection(4),!;!.
    predicates
        onControlusc : vpiDomains::controlHandler.
    clauses
        onControlusc(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],1),
  	guix::ctlEnable(thisWin,[idc_long]),
  	rtrCompPopSelection(1),!;!.
    predicates
        onControlsidf : vpiDomains::controlHandler.
    clauses
        onControlsidf(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],11),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(11),
  	!;!.
    predicates
        onControlidf : vpiDomains::controlHandler.
    clauses
        onControlidf(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],10),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(10),
  	!;!.
    predicates
        onControlsfun : vpiDomains::controlHandler.
    clauses
        onControlsfun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],9),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(9),!;!.
    predicates
        onControlctrl : vpiDomains::controlHandler.
    clauses
        onControlctrl(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],12),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(12),!;!.
    predicates
        onControlfun : vpiDomains::controlHandler.
    clauses
        onControlfun(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,13],8),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(8),!;!.
    predicates
        onControlprocedure : vpiDomains::controlHandler.
    clauses
        onControlprocedure(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,14],14),
  	guix::ctlDisable(thisWin,[idc_st_counts,idc_long]),
  	rtrCompPopSelection(14),!;!.

/* insert component */

    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_Get(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,14],Comp),
	vpi::cursorSetWait(),
	rtrCompInsert(Comp),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* long text (cannot be handled directly in the idc_ledit text edit list */

    predicates
    onControlidc_long : vpiDomains::controlHandler.
    clauses
    onControlidc_long(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    Dlg=longlist::new(),
  	guix::guiRB_Get(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,4,5,6,7,8,9,10,11,12,14],Comp),
  	set::setGet(["SENTENCE CONDITION","VARIABLE CONDITION","LITERAL","","","","","","","",""],Comp,Title),
  	guix::lbxGetAll(thisWin,idc_ledit,L),
    Dlg:show(thisWin,Title,L),
    P1=globalVars::popRetPars(),
    P1=["1",S],
    P2=globalVars::popRetPars(),
    guix::lbxPop(thisWin,idc_ledit,P2),
    guix::lbtSel(thisWin,idc_ledit,S),
    rtrCompInsert(Comp),
    !;!.
    
/* delete component */

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	rub::rubNIS_Current(thisWin,No,_,Nis,Nas),
	rub::rubNodeDelete(rule,No,Nis,Nas,RuleD),
	rule:=RuleD,
	rtrTreeRedraw(No,-1,-1), % @@ could be optimized to cater for simple deletions
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.
/* auto-assign */
    predicates
        onControlAutoAssign : vpiDomains::controlHandler.
    clauses
        onControlAutoAssign(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	redAutoAssign(),
	guix::txtGet(thisWin,idc_nodeno,SNo), 
	No=sx::toInt(SNo),
	rtrTreeRedraw(No,-1,1),
	!;!.
/* sentence counts */
    predicates
        onControlStCounts : vpiDomains::controlHandler.
    clauses
        onControlStCounts(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
  	guix::guiRB_Get(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,3,4,5,6,7,8,9,10,11,12,13],Comp),
	Comp=1,	
	ruled::redGetST(thisWin,_,Pk,Eak,Ebk,Va,Vb),
	Va="",
	Vb="",
	sx::sxlJoin([Pk,Eak,Ebk],"|",ST),
	dbBase::stCount(ST,N2,N3),
	dbExtension::kbST_RuleCount(ST,N4),
	N2s=toString(N2),
	N3s=toString(N3),
	N4s=toString(N4),
	sx::concat([N3s,"/",N2s,"(",N4s,")"],S),
	guix::txtSet(thisWin,idc_counts,S),
	!
;	
	dlgIF::dlgNote(0,"No sentence type selected - or sentence type has argument variables"),
	!.
/* assignment/comparison operators */
    predicates
        onControlequal : vpiDomains::controlHandler.
    clauses
        onControlequal(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	rtrProcessElement(2,"="),!;!.
    predicates
        onControlequaln : vpiDomains::controlHandler.
    clauses
        onControlequaln(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	rtrProcessElement(2,"=*"),!;!.
    predicates
        onControllt : vpiDomains::controlHandler.
    clauses
        onControllt(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	rtrProcessElement(2,"<"),!;!.
    predicates
        onControlle : vpiDomains::controlHandler.
    clauses
        onControlle(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(2,"<="),!;!.
    predicates
        onControlgt : vpiDomains::controlHandler.
    clauses
        onControlgt(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(2,">"),!;!.
    predicates
        onControlge : vpiDomains::controlHandler.
    clauses
        onControlge(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(2,">="),!;!.
    predicates
        onControlne : vpiDomains::controlHandler.
    clauses
        onControlne(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(2,"<>"),!;!.
    predicates
        onControllike : vpiDomains::controlHandler.
    clauses
        onControllike(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(2,"like"),!;!.
    predicates
        onControlunlike : vpiDomains::controlHandler.
    clauses
        onControlunlike(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(2,"unlike"),!;!.
/* arithmetical operators */
    predicates
        onControlplus : vpiDomains::controlHandler.
    clauses
        onControlplus(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"+"),!;!.
    predicates
        onControlminus : vpiDomains::controlHandler.
    clauses
        onControlminus(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"-"),!;!.
    predicates
        onControlmult : vpiDomains::controlHandler.
    clauses
        onControlmult(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"*"),!;!.
    predicates
        onControldiv : vpiDomains::controlHandler.
    clauses
        onControldiv(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"/"),!;!.
    predicates
        onControlidiv : vpiDomains::controlHandler.
    clauses
        onControlidiv(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"div"),!;!.
    predicates
        onControlmod : vpiDomains::controlHandler.
    clauses
        onControlmod(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"mod"),!;!.
    predicates
        onControlexp : vpiDomains::controlHandler.
    clauses
        onControlexp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(3,"^"),!;!.
/* # */
    predicates
        onControlSolutionSetSize : vpiDomains::controlHandler.
    clauses
        onControlSolutionSetSize(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(7,""),!;!.
/* true/not */
    predicates
        onControltrue : vpiDomains::controlHandler.
    clauses
        onControltrue(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(5,""),!;!.
    predicates
        onControlnot : vpiDomains::controlHandler.
    clauses
        onControlnot(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(6,""),!;!.
/* and/or */
    predicates
        onControland : vpiDomains::controlHandler.
    clauses
        onControland(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(1,"&"),!;!.
    predicates
        onControlor : vpiDomains::controlHandler.
    clauses
        onControlor(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rtrProcessElement(1,"v"),!;!.
/* over/under */
    predicates
        onControlover : vpiDomains::controlHandler.
    clauses
        onControlover(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rub::rubNIS_Current(thisWin,No,_,Nis,_),
	rub::rubValidateInsNIL(Nis),
	rubNodeNew(1,No,nill),
	Next=No+1,
	rtrTreeRedraw(Next,-1,1),
	!;!.	
    predicates
        onControlunder : vpiDomains::controlHandler.
    clauses
        onControlunder(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	rub::rubNIS_Current(thisWin,No,_,Nis,_),
	rub::rubValidateInsNIL(Nis),
	rubNodeNew(2,No,nill),
	Next=No+1,
	rtrTreeRedraw(Next,-1,1),
	!;!.

/* print */

    predicates
        onControlprn : vpiDomains::controlHandler.
    clauses
        onControlprn(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    W=guix::getWinOfClas(1),    
	_=vpi::winSendEvent(W,e_Menu(id_file_print,0)),
	!;!.

/* gen. PR */

    predicates
        onControlGeneratePr : vpiDomains::controlHandler.
    clauses
        onControlGeneratePr(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	ruled::rtrIF(rule,Rule2),
	transrt::rlgPR(Rule2,PRs),
	sx::sxlJoin(PRs,". ",PRm), % used to be ! (14.8.3)
	PR=string::concat(PRm,"."),
	Path=globalVars::get_s("std_path"),
	guix::txtGet(thisWin,idc_realm,Name),
	fioExt::filGenName(2,Path,Name,"3pr",OutFile),
	file::writeString(OutFile,PR),	
	editorWindow::openFiles([OutFile]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* gen. IF i.e. store in KB */

    predicates
        onControlGenerateIf : vpiDomains::controlHandler.
    clauses
        onControlGenerateIf(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	ruled::isAcyclic(rule,thisWin),
	guix::txtGet(thisWin,idc_realm,Realm),
	guix::txtGet(thisWin,idc_sno,SNo),
	guix::txtGet(thisWin,idc_sbno,SubNo),
	ruled::rtrCheckReplace(Realm,SNo,SubNo),
	vpi::cursorSetWait(),
  	ruled::rtrSaveKB(rule,thisWin),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
  	!;!.

/* gen. XML */

    predicates
        onControlSave3Re : vpiDomains::controlHandler.

    clauses
        onControlSave3Re(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	ruled::rtrSaveXML(rule,thisWin,1),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

/* get focus */

    predicates
        onGetFocus : vpiDomains::getFocusHandler.

    clauses
        onGetFocus() = defaultHandling() :-
    sdb::sdbSetStatus,
	rub::rubNodeGetCurr(thisWin,No,NodeText,PNo,PText),
	guix::txtSetI(thisWin,idc_nodeno,No),
	guix::txtSet(thisWin,idc_nodetext,NodeText),
	guix::txtSetI(thisWin,idc_pno,PNo),
	guix::txtSet(thisWin,idc_ptext,PText),
	rub::rubNIS_Trace(thisWin,1,No,rule,[],Types,[],Names),
	setDomain(Types,Names),
	!;!.

/* create */

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling() :-
  	guix::setStyle(thisWin,
  	   [idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_true,idc_not,idc_and,idc_or,idc_dom,
  	    idc_solution_set_size,idc_st_counts,idc_counts,idc_delete,idc_auto_assign,idc_over,idc_under,idc_prn,
  	    idc_equal,idc_equaln,idc_ge,idc_gt,idc_le,idc_lt,idc_ne,idc_like,idc_unlike,idc_long,
  	    idc_plus,idc_minus,idc_div,idc_idiv,idc_mult,idc_exp,idc_mod,idc_ledit,idc_lbut1,
  	    idc_ok,idc_generate_pr,idc_generate_if,idc_save_3re,idc_procedure],[]),		   
	guix::ctlInvisible(thisWin,[idc_ledit,idc_lbut1]),
	%
	vpi::cursorSetWait(),
	STsC=pop::getSTs(),
	dbBase::nlSings(STsC,STsNL),
	guix::lbxPop(thisWin,idc_unary_preds,STsNL),
	%
	NDoms=dom::nlList(),
	guix::lbxPop(thisWin,idc_dom,NDoms),
	dbBase::nlSing("p3_din",InDom),
	guix::lbtSel(thisWin,idc_dom,InDom),
	%
	CRulesK=pop::getCRs(),
	dbBase::nlSings(CRulesK,CRules),
	guix::lbxPop(thisWin,idc_crules,CRules),
	%
	Ffa=pop::getSM("f",[]),
	Fga=pop::getSM("g",[]),
	set::conc([Ffa,Fga],Fa),
	Ff3=pop::getSM("f",["Pro/3"]),
	Fg3=pop::getSM("g",["Pro/3"]),
	set::conc([Ff3,Fg3],F3),
    set::setRemSub(F3,Fa,Fk),
	dbBase::nlSings(Fk,Fkn),
	dbBase::nlSings(F3,F3n),
	guix::lbxPop(thisWin,idc_funcs,Fkn),
	guix::lbxPop(thisWin,idc_sfuncs,F3n),
	%
	ruled::rtrPopIds(IfsS,IfsK),
	guix::lbxPop(thisWin,idc_ids,IfsK),
	guix::lbxPop(thisWin,idc_sids,IfsS),
	%
  	guix::guiRB_SetN(thisWin,[idc_usc,idc_vrc,idc_lit,idc_var,idc_de,idc_fun,idc_sfun,idc_idf,idc_sidf,idc_ctrl,idc_procedure],[1,3,4,5,6,7,8,9,10,11,12,14],1),
  	rtrCompPopSelection(1),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
    !;!.

/* close */

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
	guix::dropWin(thisWin),
	guix::dropWin(treeWin),
	vpi::winDestroy(treeWin),
	vpi::winDestroy(thisWin),
	!;!.
    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

% This code is maintained by the VDE do not update it manually, 13:22:38-28.6.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_ClipSiblings,wsf_ClipChildren,wsf_Close].
    rectangle : vpiDomains::rct = rct(100,80,351,393).
    menu : vpiDomains::menu = noMenu.
    title : string = "Rule editor".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_PushButton,rct(88,266,161,285),"PR",Win,[wsf_Group,wsf_TabStop],idc_generate_pr),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,287,246,309),"Store",Win,[wsf_Group,wsf_TabStop],idc_generate_if),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,134,120,152),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,154,120,172),"Auto Assign",Win,[wsf_Group,wsf_TabStop],idc_auto_assign),
        _ = vpi::winCreateControl(wc_LBox,rct(557,9,567,39),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_unary_preds),
        _ = vpi::winCreateControl(wc_Edit,rct(450,37,526,61),"idc_pred",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_pred),
        _ = vpi::winCreateControl(wc_Edit,rct(363,111,445,135),"idc_realm",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_realm),
        _ = vpi::winCreateControl(wc_Edit,rct(368,166,448,190),"idc_sno",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_sno),
        _ = vpi::winCreateControl(wc_Edit,rct(352,6,441,30),"idc_ruletype",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_ruletype),
        _ = vpi::winCreateControl(wc_Edit,rct(271,57,346,81),"idc_crule",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_crule),
        _ = vpi::winCreateControl(wc_LBox,rct(557,46,574,76),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_ents),
        _ = vpi::winCreateControl(wc_PushButton,rct(40,242,73,262),"&&",Win,[wsf_Group,wsf_TabStop],idc_and),
        _ = vpi::winCreateControl(wc_PushButton,rct(75,242,108,262),"v",Win,[wsf_Group,wsf_TabStop],idc_or),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,203,36,218),"#",Win,[wsf_Group,wsf_TabStop],idc_solution_set_size),
        _ = vpi::winCreateControl(wc_LBox,rct(556,81,572,111),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_funcs),
        _ = vpi::winCreateControl(wc_Edit,rct(360,60,443,84),"idc_nodeno",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_nodeno),
        _ = vpi::winCreateControl(wc_Edit,rct(270,168,364,192),"idc_nodetext",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_nodetext),
        _ = vpi::winCreateControl(wc_Edit,rct(350,32,423,56),"idc_pno",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_pno),
        _ = vpi::winCreateControl(wc_Edit,rct(451,6,524,30),"idc_ptext",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_ptext),
        _ = vpi::winCreateControl(wc_LBox,rct(557,152,573,182),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_des),
        _ = vpi::winCreateControl(wc_PushButton,rct(40,223,60,239),"+",Win,[wsf_Group,wsf_TabStop],idc_plus),
        _ = vpi::winCreateControl(wc_PushButton,rct(55,223,75,239),"-",Win,[wsf_Group,wsf_TabStop],idc_minus),
        _ = vpi::winCreateControl(wc_PushButton,rct(73,223,93,239),"*",Win,[wsf_Group,wsf_TabStop],idc_mult),
        _ = vpi::winCreateControl(wc_PushButton,rct(95,223,115,239),"/",Win,[wsf_Group,wsf_TabStop],idc_div),
        _ = vpi::winCreateControl(wc_PushButton,rct(167,223,187,239),"^",Win,[wsf_Group,wsf_TabStop],idc_exp),
        _ = vpi::winCreateControl(wc_PushButton,rct(115,223,135,239),"/i",Win,[wsf_Group,wsf_TabStop],idc_idiv),
        _ = vpi::winCreateControl(wc_PushButton,rct(136,223,167,239),"mod",Win,[wsf_Group,wsf_TabStop],idc_mod),
        _ = vpi::winCreateControl(wc_PushButton,rct(174,203,205,219),"unlike",Win,[wsf_Group,wsf_TabStop],idc_unlike),
        _ = vpi::winCreateControl(wc_PushButton,rct(143,203,174,219),"like",Win,[wsf_Group,wsf_TabStop],idc_like),
        _ = vpi::winCreateControl(wc_PushButton,rct(122,203,142,219),"<>",Win,[wsf_Group,wsf_TabStop],idc_ne),
        _ = vpi::winCreateControl(wc_PushButton,rct(102,203,122,219),">",Win,[wsf_Group,wsf_TabStop],idc_gt),
        _ = vpi::winCreateControl(wc_PushButton,rct(81,203,101,219),">=",Win,[wsf_Group,wsf_TabStop],idc_ge),
        _ = vpi::winCreateControl(wc_PushButton,rct(60,203,80,219),"<=",Win,[wsf_Group,wsf_TabStop],idc_le),
        _ = vpi::winCreateControl(wc_PushButton,rct(40,203,60,219),"<",Win,[wsf_Group,wsf_TabStop],idc_lt),
        _ = vpi::winCreateControl(wc_PushButton,rct(30,179,55,197),"=*",Win,[wsf_Group,wsf_TabStop],idc_equaln),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,179,27,197),"=",Win,[wsf_Group,wsf_TabStop],idc_equal),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(2,84,248,473),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_Invisible],idc_lbut1),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(2,84,248,528),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_Invisible],idc_ledit),
        _ = vpi::winCreateControl(wc_PushButton,rct(0,112,192,132),"Insert",Win,[wsf_Group,wsf_TabStop],idc_ok),
        _ = vpi::winCreateControl(wc_RadioButton,rct(2,51,120,66),"Variable condition",Win,[wsf_TabStop],idc_vrc),
        _ = vpi::winCreateControl(wc_RadioButton,rct(2,34,120,49),"Literal",Win,[wsf_TabStop],idc_lit),
        _ = vpi::winCreateControl(wc_RadioButton,rct(2,17,120,32),"Variable",Win,[wsf_TabStop],idc_var),
        _ = vpi::winCreateControl(wc_RadioButton,rct(2,0,120,15),"DE",Win,[wsf_TabStop,wsf_Group],idc_de),
        _ = vpi::winCreateControl(wc_RadioButton,rct(128,34,246,49),"Pro/3 function",Win,[wsf_TabStop],idc_sfun),
        _ = vpi::winCreateControl(wc_PushButton,rct(144,242,177,262),"^^",Win,[wsf_Group,wsf_TabStop],idc_over),
        _ = vpi::winCreateControl(wc_PushButton,rct(109,242,142,262),"vv",Win,[wsf_Group,wsf_TabStop],idc_under),
        _ = vpi::winCreateControl(wc_LBox,rct(557,115,573,145),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_des_conc),
        _ = vpi::winCreateControl(wc_RadioButton,rct(128,0,246,15),"Pro/3 identifier",Win,[wsf_TabStop],idc_sidf),
        _ = vpi::winCreateControl(wc_RadioButton,rct(128,51,246,66),"Function",Win,[wsf_TabStop],idc_fun),
        _ = vpi::winCreateControl(wc_RadioButton,rct(128,17,246,32),"Identifier",Win,[wsf_TabStop],idc_idf),
        _ = vpi::winCreateControl(wc_LBox,rct(536,109,552,139),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_ids),
        _ = vpi::winCreateControl(wc_LBox,rct(538,72,550,102),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_sfuncs),
        _ = vpi::winCreateControl(wc_LBox,rct(537,36,552,66),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_sids),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,219,36,234),"TRUE",Win,[wsf_Group,wsf_TabStop],idc_true),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,266,75,285),"XML",Win,[wsf_Group,wsf_TabStop],idc_save_3re),
        _ = vpi::winCreateControl(wc_PushButton,rct(2,235,36,250),"NOT",Win,[wsf_Group,wsf_TabStop],idc_not),
        _ = vpi::winCreateControl(wc_RadioButton,rct(125,69,243,84),"Inexact rule",Win,[wsf_TabStop],idc_ctrl),
        _ = vpi::winCreateControl(wc_LBox,rct(534,9,552,29),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_crules),
        _ = vpi::winCreateControl(wc_PushButton,rct(128,135,246,153),"ST population:",Win,[wsf_Group,wsf_TabStop],idc_st_counts),
        _ = vpi::winCreateControl(wc_Edit,rct(128,154,246,172),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_counts),
        _ = vpi::winCreateControl(wc_Edit,rct(272,84,353,108),"idc_nis",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_nis),
        _ = vpi::winCreateControl(wc_Edit,rct(269,197,365,221),"idc_nas",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_nas),
        _ = vpi::winCreateControl(wc_Edit,rct(272,112,357,136),"idc_impexp",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_impexp),
        _ = vpi::winCreateControl(wc_Edit,rct(269,30,337,54),"idc_sbno",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled,wsf_Invisible],idc_sbno),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(59,175,246,508),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll],idc_dom),
        _ = vpi::winCreateControl(wc_PushButton,rct(173,266,246,285),"Print",Win,[wsf_Group,wsf_TabStop],idc_prn),
        _ = vpi::winCreateControl(wc_Text,rct(270,7,340,27),"idc_st",Win,[wsf_AlignLeft],idc_st),
        _ = vpi::winCreateControl(wc_RadioButton,rct(2,69,120,84),"Sentence condition",Win,[wsf_TabStop],idc_usc),
        _ = vpi::winCreateControl(wc_LBox,rct(537,153,553,183),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Disabled,wsf_Invisible],idc_literals),
        _ = vpi::winCreateControl(wc_RadioButton,rct(128,69,246,84),"Procedure",Win,[wsf_TabStop],idc_procedure),
        _ = vpi::winCreateControl(wc_LBox,rct(271,224,367,252),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight],idc_procs),
        _ = vpi::winCreateControl(wc_PushButton,rct(213,229,246,262),"?",Win,[wsf_Group,wsf_TabStop],idc_help),
        _ = vpi::winCreateControl(wc_PushButton,rct(200,112,248,132),"Long",Win,[wsf_Group,wsf_TabStop],idc_long),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_de, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlde(idc_de, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_var, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlvar(idc_var, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_lit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControllit(idc_lit, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_vrc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlvrc(idc_vrc, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_usc, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlusc(idc_usc, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sidf, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsidf(idc_sidf, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_idf, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidf(idc_idf, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_sfun, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsfun(idc_sfun, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ctrl, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlctrl(idc_ctrl, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_fun, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlfun(idc_fun, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_procedure, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlprocedure(idc_procedure, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_auto_assign, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlAutoAssign(idc_auto_assign, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_st_counts, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlStCounts(idc_st_counts, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_equal, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlequal(idc_equal, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_equaln, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlequaln(idc_equaln, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_lt, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControllt(idc_lt, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_le, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlle(idc_le, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_gt, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlgt(idc_gt, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ge, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlge(idc_ge, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ne, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlne(idc_ne, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_like, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControllike(idc_like, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_unlike, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlunlike(idc_unlike, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_plus, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlplus(idc_plus, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_minus, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlminus(idc_minus, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_mult, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlmult(idc_mult, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_div, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldiv(idc_div, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_idiv, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidiv(idc_idiv, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_mod, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlmod(idc_mod, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_exp, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlexp(idc_exp, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_solution_set_size, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlSolutionSetSize(idc_solution_set_size, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_true, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControltrue(idc_true, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_not, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnot(idc_not, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_and, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControland(idc_and, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_or, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlor(idc_or, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_over, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlover(idc_over, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_under, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlunder(idc_under, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_prn, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlprn(idc_prn, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_generate_pr, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlGeneratePr(idc_generate_pr, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_generate_if, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlGenerateIf(idc_generate_if, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save_3re, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlSave3Re(idc_save_3re, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_long, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_long(idc_long, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_GetFocus()) = Result :-
        handled(Result) = onGetFocus().
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
% ----------------------------------------------------------------------------------------------
% rtrCompPopSelection
% ----------------------------------------------------------------------------------------------
rtrCompPopSelection(Comp) :-
	Comp=1,
	guix::lbxGetAll(thisWin,idc_unary_preds,STs),
	guix::lbxPop(thisWin,idc_ledit,STs),
	guix::ctlInvisible(thisWin,[idc_lbut1]),
	guix::ctlVisible(thisWin,[idc_ledit]),
	!
;
	Comp=4,
	rub::rubVariables(rule,0,Vars),
	guix::lbxPop(thisWin,idc_ledit,Vars),
	guix::ctlInvisible(thisWin,[idc_lbut1]),
	guix::ctlVisible(thisWin,[idc_ledit]),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_ledit),
	vpi::winSetFocus(Ctl),
	!
;		
	Comp=5,
	guix::ctlInvisible(thisWin,[idc_lbut1]),
	guix::lbxGetAll(thisWin,idc_literals,Lits),
	guix::lbxPop(thisWin,idc_ledit,Lits),
	guix::ctlVisible(thisWin,[idc_ledit]),	
	Ctl=vpi::winGetCtlHandle(thisWin,idc_ledit),
	vpi::winSetFocus(Ctl),
	!
;		
	Comp=6,
	rub::rubVariables(rule,0,Vars),
	guix::lbxPop(thisWin,idc_lbut1,Vars),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;	
	Comp=7,
	rub::rubNIS_Current(thisWin,_,_,Nis,_),
	rubInCond(Nis,N),
	guix::txtGetI(thisWin,idc_ruletype,Type),
	rub::rubDEs(N,Type,thisWin,DEs),
	guix::lbxPop(thisWin,idc_lbut1,DEs),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;	
	Comp=8,
	guix::lbxGetAll(thisWin,idc_funcs,Funcs),
	guix::lbxPop(thisWin,idc_lbut1,Funcs),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;
	Comp=9,
	guix::lbxGetAll(thisWin,idc_sfuncs,Funcs),
	guix::lbxPop(thisWin,idc_lbut1,Funcs),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;
	Comp=10,
	guix::lbxGetAll(thisWin,idc_ids,Funcs),
	guix::lbxPop(thisWin,idc_lbut1,Funcs),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;
	Comp=11,
	guix::lbxGetAll(thisWin,idc_sids,Funcs),
	guix::lbxPop(thisWin,idc_lbut1,Funcs),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;
	Comp=12,
	guix::lbxGetAll(thisWin,idc_crules,CRules),
	guix::lbxPop(thisWin,idc_lbut1,CRules),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
/*
;
	Comp=13,
	rub::rubNIS_Current(thisWin,_,_,Nis,_),
	rubInCond(Nis,N),
	guix::txtGetI(thisWin,idc_ruletype,Type),
	rub::rubCDEs(N,Type,thisWin,DEs),
	guix::lbxPop(thisWin,idc_lbut1,DEs),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!
*/		
;
	Comp=14,
	guix::lbxGetAll(thisWin,idc_procs,CRules),
	guix::lbxPop(thisWin,idc_lbut1,CRules),
	guix::ctlInvisible(thisWin,[idc_ledit]),
	guix::ctlVisible(thisWin,[idc_lbut1]),
	!	
;
	dlgIF::feil("rtrCompPopSelection",[],[Comp],nill),!,fail.		
% ----------------------------------------------------------------------------------------------
% rubInCond
% ----------------------------------------------------------------------------------------------
rubInCond(Nis,N) :-
	set::member(1,Nis),
	N=1,
	!
;
	N=2,
	!.
% ----------------------------------------------------------------------------------------------
% rtrCompInsert
% ----------------------------------------------------------------------------------------------
predicates
rtrCompVal : (string,string,sterm) determ (i,i,o).	
rtrCompInsertX : (integer) determ.
rtrCompInsertParams : (sterml,sterml) determ (i,o).
rtrCompMess : (integer,string) determ (i,o).
rtrInsVal : (integer,integer_list) determ (i,i).
rtrValPred : (string,string) determ (i,i).
rtrValST : (vpiDomains::windowHandle,string,string,string) determ (i,i,i,i).	  	
clauses
% processes insertion of new component at a nill-node (selected with Insert-button)
%
rtrCompInsert(Comp) :-
	guix::txtGet(thisWin,idc_nis,S),
	sx::sxUnpack(S,'|',Ls),
	sx::sxl_il(Ls,Li),
	Li=[H|L],
	H=99,
	rtrInsVal(Comp,L),
	rtrCompInsertX(Comp),
	!.
rtrCompMess(1," sentence condition ") :- !.		
rtrCompMess(4," variable condition ") :- !.		
rtrCompMess(5," literal ") :- !.		
rtrCompMess(6," variable ") :- !.		
rtrCompMess(7," data element ") :- !.		
rtrCompMess(8," function (KE) call ") :- !.		
rtrCompMess(9," function (standard) call ") :- !.		
rtrCompMess(10," identifier (KE) ") :- !.		
rtrCompMess(11," identifier (standard) ") :- !.		
rtrCompMess(12," certainty rule ") :- !.		
rtrCompMess(14," procedure ") :- !.		
rtrCompMess(N,"** unknown rule element type **") :- dlgIF::feil("rtrCompMess",[],[N],nill),!,fail.		
rtrInsVal(Elm,L) :-
	Elm=1, % sc
	set::member(1,L), % in cond
	L=[H|_],
	set::member(H,[1,3,44]), % in cond main branch or under logopr
	!
;
	Elm=4, % vc
	set::member(1,L), % in cond
	L=[H|_],
	set::member(H,[1,3]), % in cond main branch or under logopr
	!
;
	set::member(Elm,[5,6,7,10,11]), % lit, var, de, id
	L=[P|_],
	set::member(P,[31,32,40,45]), % under oprass, oprcomp, oprexp, list head 
	!
;	
	set::member(Elm,[8,9]), % func
	set::member(1,L), % in cond
	L=[P|_],
	set::member(P,[31,40]), % under oprass, oprexp
	not(set::member(43,L)), % not under proc/func/cr
	not(set::member(45,L)), % not under a listhead
	!
;
	set::member(Elm,[12]), % cr
	set::member(2,L), % in conc
	L=[P|_],
	set::member(P,[31]), % under oprass
	not(set::member(43,L)), % not under proc/func/cr
	not(set::member(45,L)), % not under a listhead
	!
;
	set::member(Elm,[14]), % proc
	set::member(2,L), % in conc
	L=[P|_],
	set::member(P,[31,40]), % under oprass, oprexp
	not(set::member(43,L)), % not under proc/func/cr
	not(set::member(45,L)), % not under a listhead
	!
;
	rtrCompMess(Elm,S),
	sx::concat(["Current rule position is not a valid place for inserting ",S],Mess),
	dlgIF::dlgNote(0,Mess),
	!,fail.
% parameter:
% 1	in	element type
% 2	in	thisWin
% 3	in	element dialog window
%
rtrCompInsertX(1) :-
	ruled::redGetST(thisWin,Card,Pk,Eak,_,Va,_),
	Card=1,
	Eak="", % argument variable
	rub::rubGetDEsK(thisWin,1,Pk,"","",990,Ps,_,_),
	var_SLIST_R(VPs,Ps),	
	sx::concat([Pk,"[990]"],Pn),
	sx::sxlJoin([Pk,Va],"|",ST),
	NewSC2=cmp(ST,
	          [var(Va),
	           cmp(Pn,Vps)]),
	rub::rubSC_Adj(NewSC2,NewSC),
	ruled::rtrAddDEs(thisWin,NewSC),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,NewSC),
	rtrTreeRedraw(No,1,-1),
	!
;
	ruled::redGetST(thisWin,Card,Pk,Eak,_,Va,_),
	Card=1,
	Va="", % entity argument
	rub::rubGetDEsK(thisWin,1,Pk,Eak,"",990,Ps,Eas,_),
	var_SLIST_R(VEas,Eas),
	var_SLIST_R(VPs,Ps),	
	sx::concat([Pk,"[990]"],Pn),
	sx::concat([Eak,"[991]"],Ean),
	sx::sxlJoin([Pk,Eak],"|",ST),
	unknownST(ST),
	NewSC2=cmp(ST,
	          [cmp(Ean,VEas),
	           cmp(Pn,VPs)]),
	rub::rubSC_Adj(NewSC2,NewSC),
	ruled::rtrAddDEs(thisWin,NewSC),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,NewSC),
	rtrTreeRedraw(No,1,-1),
	!
;
	ruled::redGetST(thisWin,Card,Pk,Eak,Ebk,Va,Vb),
	Card=2,
	Eak="", % argument variable
	Ebk="", % argument variable
	rub::rubGetDEsK(thisWin,2,Pk,"","",990,Ps,_,_),
	var_SLIST_R(VPs,Ps),	
	sx::concat([Pk,"[990]"],Pn),
	sx::sxlJoin([Pk,Va,Vb],"|",ST),
	NewSC2=cmp(ST,
	          [var(Va),
	           cmp(Pn,VPs),
	           var(Vb)]),
	rub::rubSC_Adj(NewSC2,NewSC),
	ruled::rtrAddDEs(thisWin,NewSC),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,NewSC),
	rtrTreeRedraw(No,1,-1),
	!
;
	ruled::redGetST(thisWin,Card,Pk,Eak,Ebk,Va,Vb),
	Card=2,
	Eak="", % argument variable
	Vb="", % entity argument
	rub::rubGetDEsK(thisWin,2,Pk,"",Ebk,990,Ps,_,Ebs),
	var_SLIST_R(VPs,Ps),	
	var_SLIST_R(VEbs,Ebs),
	sx::concat([Pk,"[990]"],Pn),
	sx::concat([Ebk,"[992]"],Ebn),
	sx::sxlJoin([Pk,Va,Ebk],"|",ST),
	NewSC2=cmp(ST,
	          [var(Va),
	           cmp(Pn,VPs),
	           cmp(Ebn,VEbs)]),
	rub::rubSC_Adj(NewSC2,NewSC),
	ruled::rtrAddDEs(thisWin,NewSC),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,NewSC),
	rtrTreeRedraw(No,1,-1),
	!
;
	ruled::redGetST(thisWin,Card,Pk,Eak,Ebk,Va,Vb),
	Card=2,
	Va="", % entity argument
	Ebk="", % argument variable
	rub::rubGetDEsK(thisWin,2,Pk,Eak,"",990,Ps,Eas,_),
	var_SLIST_R(VPs,Ps),	
	var_SLIST_R(VEas,Eas),
	sx::concat([Pk,"[990]"],Pn),
	sx::concat([Eak,"[991]"],Ean),
	sx::sxlJoin([Pk,Eak,Vb],"|",ST),
	NewSC2=cmp(ST,
	          [cmp(Ean,VEas),
	           cmp(Pn,VPs),
	           var(Vb)]),
	rub::rubSC_Adj(NewSC2,NewSC),
	ruled::rtrAddDEs(thisWin,NewSC),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,NewSC),
	rtrTreeRedraw(No,1,-1),
	!
;
	ruled::redGetST(thisWin,Card,Pk,Eak,Ebk,Va,Vb),
	Card=2,
	Va="", % entity argument
	Vb="", % entity argument
	rub::rubGetDEsK(thisWin,2,Pk,Eak,Ebk,990,Ps,Eas,Ebs),
	var_SLIST_R(VEas,Eas),
	var_SLIST_R(VPs,Ps),	
	var_SLIST_R(VEbs,Ebs),
	sx::concat([Pk,"[990]"],Pn),
	sx::concat([Eak,"[991]"],Ean),
	sx::concat([Ebk,"[992]"],Ebn),
	sx::sxlJoin([Pk,Eak,Ebk],"|",ST),
	unknownST(ST),
	NewSC2=cmp(ST,
	          [cmp(Ean,VEas),
	           cmp(Pn,VPs),
	           cmp(Ebn,VEbs)]),
	rub::rubSC_Adj(NewSC2,NewSC),
	ruled::rtrAddDEs(thisWin,NewSC),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,NewSC),
	rtrTreeRedraw(No,1,-1),
	!.
rtrCompInsertX(4) :-
	guix::txtGet(thisWin,idc_ledit,Vx),
	sx::frontstr(1,Vx,F,T),
	Fu=string::toUpperCase(F),
	W=string::concat(Fu,T),
	rub::rubVariables(rule,0,Vars),
	set::member(W,Vars), % existing variable used in a new variable condition
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,cmp(W,[nill])),
	rtrTreeRedraw(No,-1,-1),
	!
;
	% new variable (condition)
	guix::txtGet(thisWin,idc_ledit,Vx),
	sx::frontstr(1,Vx,F,T),
	Fu=string::toUpperCase(F),
	W=string::concat(Fu,T),
	ruled::rtrCompDom(thisWin,Dom),
	rub::rubIsVar(W,_,_),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
	dom::domShortLong(SD,Dom),
	sx::concat([W," /",SD],V),
  	rubNodeNew(3,No,cmp(V,[nill])),
	rtrTreeRedraw(No,-1,-1),
	!.
rtrCompInsertX(5) :-
	% literal@@@
	guix::txtGet(thisWin,idc_ledit,V),
	guix::lbxGetAll(thisWin,idc_literals,All),
	set::distinct([V|All],NewAllB),
	sx::sxlRemBlanks(NewAllB,NewAll),
	guix::lbxPop(thisWin,idc_literals,NewAll),
    ruled::rtrCompDom(thisWin,Dom),
	rtrCompVal(Dom,V,Vi),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,Vi),
	rtrTreeRedraw(No,-1,1),
	!
;
	dlgIF::dlgNote(0,"Invalid literal. Strings must be enclosed in quotes."),
	!,fail.	
rtrCompInsertX(6) :-
	% variable
	guix::lbtGetF(thisWin,idc_lbut1,V),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,var(V)),
	rtrTreeRedraw(No,-1,-1),
	!.
rtrCompInsertX(7) :-
	% DE
	guix::lbtGetF(thisWin,idc_lbut1,V),
	guix::lbxGetAll(thisWin,idc_des,DEs),
	ruled::rtrGetDE_Var(V,DEs,DV),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,var(DV)),
	rtrTreeRedraw(No,-1,1),
	!.
rtrCompInsertX(Comp) :-
	set::member(Comp,[8,9]),
	% func w/out parameters
	guix::lbtGetF(thisWin,idc_lbut1,FP),
	dbBase::kbID(FP,F,_,_),
	dbBase::smDefTree(F,_,Def),
	Def=cmp("REL_TYPE",[cmp("REP",[_]),
	                    cmp("DOM",[_]),
	                    cmp("FPAR",ParDEs)]),
	set::size(ParDEs,NPars),
	NPars=0,
	Name=string::concat("[F] ",F),
	New=atom(Name),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,New),
	rtrTreeRedraw(No,-1,1),
	!
;
	set::member(Comp,[8,9]),
	% func w/ parameters
	guix::lbtGetF(thisWin,idc_lbut1,FP),
	dbBase::kbID(FP,F,_,_),
	dbBase::smDefTree(F,_,Def),
	Def=cmp("REL_TYPE",[cmp("REP",[_]),
	                    cmp("DOM",[_]),
	                    cmp("FPAR",ParDEs)]),
	rtrCompInsertParams(ParDEs,Pars),
	Name=string::concat("[F] ",F),
	New=cmp(Name,Pars),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,New),
	rtrTreeRedraw(No,-1,1),
	!
;
	set::member(Comp,[10,11]),
	% ident
	guix::lbtGetF(thisWin,idc_lbut1,Id),
	dbBase::kbID(Id,K,_,_),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,atom(K)),
	rtrTreeRedraw(No,-1,1),
	!.
rtrCompInsertX(12) :-
	% CR w/out params
	guix::lbtGetF(thisWin,idc_lbut1,FP),
	dbBase::kbID(FP,Rule,_,_),
	dbBase::smClassDef(Rule,"h",_,_,_,_,N),
	N=0,
	Name=string::concat("[C] ",Rule),
	New=atom(Name),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,New),
	rtrTreeRedraw(No,-1,1),
	!
;
	% CR w/ params
	guix::lbtGetF(thisWin,idc_lbut1,FP),
	dbBase::kbID(FP,Rule,_,_),
	dbBase::smClassDefTree(Rule,"h",Def),
	Def=cmp("REL_TYPE",[_,_,cmp("FPAR",Params)]),
	rtrCompInsertParams(Params,Pars),
	Name=string::concat("[C] ",Rule),
	New=cmp(Name,Pars),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,New),
	rtrTreeRedraw(No,-1,1),
	!.
rtrCompInsertX(14) :-
	% procedure with parameters
	guix::lbtGetF(thisWin,idc_lbut1,Rn),
	Rn<>"",
	dbBase::kbID(Rn,R,_,_),
	dbBase::smClassDefF(R,"i",_,_,_,_,Card),
	dbBase::smClassDefTree(R,"i",RDef),
	RDef=cmp("REL_TYPE",[_,_,cmp("FPAR",DE_Defs)]),
	Card>0,
	Rnp=string::concat("[P] ",R),
	rtrCompInsertParams(DE_Defs,Ps),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,cmp(Rnp,Ps)),
	rtrTreeRedraw(No,-1,1),
  	!
;
	% procedure without parameters
	guix::lbtGetF(thisWin,idc_lbut1,Rn),
	Rn<>"",
	dbBase::kbID(Rn,R,_,_),
	dbBase::smClassDefF(R,"i",_,_,_,_,Card),
	Card=0,
	Rnp=string::concat("[P] ",R),
  	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
	New=atom(Rnp),
  	rubNodeNew(3,No,New),
	rtrTreeRedraw(No,-1,1),
	!.
rtrCompInsertParams([],[]) :-
	!.
rtrCompInsertParams([fstr(DE,D,_,_)|Ps],[Par|Pars]) :-
	sx::sxTail(2,D,_,T),
	T="_l",
	Par=cmp(DE,[cmp("=",[nill])]),
	rtrCompInsertParams(Ps,Pars),!
;	
	Par=cmp(DE,[cmp("=",[nill])]),
	rtrCompInsertParams(Ps,Pars),!.

% parameters:
% 1 in  : current domain
% 2 in : literal (as string)
% 3 out : literal (as term)
% checks compatibility with currently selected domain
%
rtrCompVal(Dom,V,Vt) :-
    dom::listDomain(Dom,_),
    syn::sbGetDE_ValIF(Dom,V,Vt2),
    rt::rcnSimpleExpression(Vt2,Vt),
    !
;
    dom::domStr(Dom),
    sx::sxQuote(V,V2),
	Vt=termDomain::str(V2),
	dom::domValCompatF(Dom,Vt),
	!
;
    dom::domInt(Dom),
	Int=sx::toInt(V),
	Vt=termDomain::int(Int),
	dom::domValCompatF(Dom,Vt),
	!
;
    dom::domNum(Dom),
	F=sx::toReal(V),
	Vt=termDomain::fix(F),
	dom::domValCompatF(Dom,Vt),
	!
;	
    dom::domAtom(Dom),
	dbBase::kbID_F(V,KbId,_,_),
	Vt=termDomain::atom(KbId),
	dom::domValCompatF(Dom,Vt),
	!
;
    dbBase::nlSing(Dom,DomNL),
    Mess=string::concat("Literal is not compatible with current domain (",DomNL,"). Select another domain explicitly or implictly by making a data element or variable current node."),
    dlgIF::dlgNote(0,Mess),
    !,fail. 
	
rtrValST(thisWin,P,Ea,Eb) :-
  	guix::txtGet(thisWin,idc_ruletype,SType),
  	SType<>"7",
  	guix::txtGet(thisWin,idc_st,ST),
  	ST<>"",
  	sx::sxUnpack(ST,'|',L),
  	L=[CP,CEa,CEb],
  	CP=P,
  	CEa=Ea,
  	CEb=Eb,
  	dlgIF::dlgNote(0,"You cannot use the concluded sentence type as a condition"),
  	!,fail
;
  	guix::txtGet(thisWin,idc_ruletype,SType),
  	SType<>"7",
  	guix::txtGet(thisWin,idc_st,ST),
  	ST<>"",
  	sx::sxUnpack(ST,'|',L),
  	L=[CP,CEa],
  	CP=P,
  	CEa=Ea,
  	Eb="",
  	dlgIF::dlgNote(0,"You cannot use the concluded sentence type as a condition"),
  	!,fail
;
	!.
rtrValPred(P2,P3) :-
	P2=P3,
  	dlgIF::dlgNote(0,"You cannot use the concluded sentence group as a condition in an open argument rule"),
  	!,fail
;
	!.
% ----------------------------------------------------------------------------------------------
% rtrTreeRedraw
% ----------------------------------------------------------------------------------------------
rtrTreeRedraw(No,Renumber,Simple) :-
	Simple=1,
	ruled::rtrMakeTree(rule,Tree,RuleM),
	rule:=RuleM,		
	vpiTree::update(treeWin,Tree),
	rub::rubFirstNIL(RuleM,No,N),
	set::setMax([No,N],NewCurr),
	rub::rubNodeSetCurr(treeWin,NewCurr),
	vpi::winSetFocus(treeWin),
	vpi::winSetFocus(thisWin),
	!
;
	Simple=-1,
	rub::rubTreeClean(Renumber,thisWin,rule,Rule2),	
	ruled::rtrMakeTree(Rule2,Tree,RuleM),
	rule:=RuleM,		
	vpiTree::update(treeWin,Tree),
	rub::rubFirstNIL(RuleM,No,N),
	set::setMax([No,N],NewCurr),
	rub::rubNodeSetCurr(treeWin,NewCurr),
	vpi::winSetFocus(treeWin),
	vpi::winSetFocus(thisWin),
	!.
% ----------------------------------------------------------------------------------------------
% rtrProcessElement
% ----------------------------------------------------------------------------------------------
predicates
rtrInsElm : (integer,string,integer,integer_list) determ.
rtrInsLogOpr : (string,integer) determ.
rtrInsCmpAss : (string,integer) determ.
rtrInsCmpAssY : (integer,sterm,string,sterm) determ.
rtrInsOpr : (string,sterm) determ (i,o).	
rtrElmMess : (integer,string) determ (i,i).
clauses
% parameters:
% 1	in	rule editor win
% 2	in	element type (ref. rtrElmMess)
% 3	in	element
%
rtrElmMess(1," logical operator ") :- !.
rtrElmMess(2," assignment/comparison operator ") :- !.
rtrElmMess(3," arithmetical operator ") :- !.
rtrElmMess(5," 'true' ") :- !.
rtrElmMess(6," 'not' ") :- !.
rtrElmMess(7," solution set size ") :- !.

rtrProcessElement(Type,Elm) :-
	rub::rubNIS_Current(thisWin,No,_,Nis,_),
	rtrInsElm(Type,Elm,No,Nis),
	rtrTreeRedraw(No,-1,1),
	!.

rtrInsElm(Type,Elm,No,Nis) :-
% inserting log.opr
	Type=1,
	set::member(2,Nis), 
	!,fail
;
	Type=1,
	Nis=[H|_],
	set::member(H,[3,10,20]),
	rtrInsLogOpr(Elm,No),
	!
;
	Type=1,
	Nis=[_,P|_],
	P=3,
	rtrInsLogOpr(Elm,No),
	!
;
	Type=1,
	Nis=[H,P|_],
	set::member(H,[31,32]),
	set::member(P,[19,21,20]),
	rtrInsLogOpr(Elm,No),
	!
;
% assignment/comparison operator
	Type=2,
	Nis=[H,P|_],
	H=99,
	P=20, % variable
	rtrInsCmpAss(Elm,No),
	!
;
	Type=2,
	Nis=[H|_],
	H=21, % DE
	rtrInsCmpAss(Elm,No),
	!
;
	Type=2,
	Nis=[H,P,GP|_],
	H=99,
	P=29,
	GP=21, % DE
	rtrInsCmpAss(Elm,No),
	!
;
% arithmetical operator
	Type=3,
	Nis=[H,P|_],
	H=99,
	set::member(P,[31,32,40]),
	rtrInsOpr(Elm,New),
  	rubNodeNew(3,No,New),
  	!
; 
% true
	Type=5,
	set::member(1,Nis),
	Nis=[H,P],
	H=99,
	P=1,
  	rubNodeNew(3,No,atom("true")),
  	!
;
% not
	Type=6,
	set::member(1,Nis),
	Nis=[H|_],
	set::member(H,[10,20]),
	rub::rubTreeGetCurr(rule,thisWin,Sub),
	ruled::rtrIF(Sub,SubI),
	New=cmp("not",[SubI]),
  	rubNodeNew(3,No,New),
  	!
;
% solution set size
	Type=7,
	set::member(1,Nis),	
	Nis=[H,P,GP|_],
	H=99,
	P=31,
	GP=20,
	New=cmp("p3_iSSS",[nill]),
  	rubNodeNew(3,No,New),
  	!.
rtrInsCmpAss(Opr,No) :-
	sx::sxTail(1,Opr,Ds,T),
	T="l",
	% list domain
	rub::rubTreeGetCurr(rule,thisWin,Sub),
	ruled::rtrIF(Sub,SubIF),
	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	sx::concat(["[",Ds,"]"],H),
	rtrInsCmpAssY(No,SubIF,Opr,cmp(H,[nill])),
	!
;	
	rub::rubTreeGetCurr(rule,thisWin,Sub),
	ruled::rtrIF(Sub,SubIF),
	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
	rtrInsCmpAssY(No,SubIF,Opr,nill),
	!.
	
rtrInsCmpAssY(No,Sub,Opr,Body) :-
	Sub=nill,
  	rubNodeNew(3,No,cmp(Opr,[Body])),
  	!
;	
	Sub=termDomain::var(V),
  	rubNodeNew(3,No,cmp(V,[cmp(Opr,[Body])])),
  	!
;	
	Sub=termDomain::atom(V),
  	rubNodeNew(3,No,cmp(V,[cmp(Opr,[Body])])),
  	!
;	
	Sub=termDomain::str(V),
  	rubNodeNew(3,No,cmp(V,[cmp(Opr,[Body])])),
  	!
;
	Sub=cmp(V,[]),
  	rubNodeNew(3,No,cmp(V,[cmp(Opr,[Body])])),
  	!
;
	dlgIF::feil("rtrInsCmpAssY",[Opr],[No],Sub),!,fail.
		
rtrInsLogOpr(Opr,No) :-
	rub::rubTreeGetCurr(rule,thisWin,Sub),
	ruled::rtrIF(Sub,SubK),
	New=cmp(Opr,[SubK,nill]),
	guix::txtGet(thisWin,idc_nodeno,SNo),
	No=sx::toInt(SNo),
  	rubNodeNew(3,No,New),
  	!.
rtrInsOpr(Opr,New) :-
	rub::rubOprType(Opr,_,_,N),
	N=1,
	New=cmp(Opr,[nill]),!
;
	rub::rubOprType(Opr,_,_,N),
	N=2,
	New=cmp(Opr,[nill,nill]),!
;
	rub::rubOprType(Opr,_,_,N),
	N=3,
	New=cmp(Opr,[nill,nill,nill]),
	!.
% ----------------------------------------------------------------------------------------------
% redAutoAssign
% ---------------------------------------------------------------------------
predicates
redAuto : (integer,sterm,string_list,sterm) procedure (i,i,i,o).
redAutos : (integer,sterml,string_list,sterml) determ (i,i,i,o).
redAutoArgs : (string_list,sterml,sterml) determ (i,i,o).
redAutoArg : (string_list,string,sterml,sterml) determ (i,i,i,o).
redGetMatch : (string_list,integer,string,string,integer) determ (i,i,i,o,o).
clauses
redAutoAssign() :-
	rub::rubNIS_Current(thisWin,No,_,Nis,_),
	Nis=[Node|_],
	set::member(Node,[10,11]),
	guix::lbxGetAll(thisWin,idc_des,DEs),
	guix::lbxGetAll(thisWin,idc_des_conc,ConcDEs),
	set::setRemSub(ConcDEs,DEs,CondDEs),
	redAuto(No,rule,CondDEs,RuleM),
	rule:=RuleM,
	!
;
	dlgIF::dlgNote(0,"Select a sentence condition node or an argument node within it"),
	!.	
	
redAuto(No,cmp(H,T),DEs,Tr) :-
	rub::rubNodeNo(cmp(H,T),N),
	N=No,
	sx::sxGetInBrack(H,'[',']',SArgNo),
	% argument
	redAutoArg(DEs,SArgNo,T,Tm),
	Tr=cmp(H,Tm),
	!
;
	rub::rubNodeNo(cmp(H,T),N),
	N=No,
	% ST
	redAutoArgs(DEs,T,Tm),
	Tr=cmp(H,Tm),
	!
;
	redAutos(No,T,DEs,T2),
	Tr=cmp(H,T2),
	!.
redAuto(_,C,_,C) :-
	!.
redAutos(_,[],_,[]) :-
	!.
redAutos(No,[H|T],DEs,[Hm|Tm]) :-
	redAuto(No,H,DEs,Hm),
	redAutos(No,T,DEs,Tm),
	!.
	
redAutoArgs(_,[],[]) :-
	!.
redAutoArgs(DEs,[C|Ts],[Tr|Tsr]) :-
	C=cmp(H,_),
	sx::sxUnpack(H,'}',L),
	L=[_,SNo],
	No=sx::toInt(SNo),
	redAuto(No,C,DEs,Tr),
	redAutoArgs(DEs,Ts,Tsr),
	!.
redAutoArg(_,_,[],[]) :-
	!.
redAutoArg(DEs,SArgNo,[H|T],[Hm|Tm]) :-
	H=var(V),
	sx::sxUnpack(V,'{',L2),
	L2=[DV|_],
	vars::varComps(DV,_,_,D),
	ArgNo=sx::toInt(SArgNo),
	redGetMatch(DEs,ArgNo,D,DM,Dist),
	Dist>0,
	C=cmp(DV,[cmp("=",[var(DM)])]),
	rub::rubNL(C,Hm),
	redAutoArg(DEs,SArgNo,T,Tm),
	!
;	
	H=cmp(V,[cmp(Op,[atom(RS)])]),
	sx::sxUnpack(RS,'{',L4),
	L4=["_"|_],
	sx::sxUnpack(Op,'{',L3),
	L3=[Op2|_],
	opr::oprEq(Op2),
	sx::sxUnpack(V,'{',L2),
	L2=[DV|_],
	vars::varComps(DV,_,_,D),
	ArgNo=sx::toInt(SArgNo),
	redGetMatch(DEs,ArgNo,D,DM,Dist),
	Dist>0,
	C=cmp(DV,[cmp("=",[var(DM)])]),
	rub::rubNL(C,Hm),
	redAutoArg(DEs,SArgNo,T,Tm),
	!
;	
	Hm=H,
	redAutoArg(DEs,SArgNo,T,Tm),
	!.
% ARGUMENT | NO | DE | DE_VAR | DENL[NO] or 
%
redGetMatch([],_,_,"",0) :-
	!.
redGetMatch([DE|DEs],ArgNo,D,DM,Dist) :-
	ArgNo<10,
	sx::sxUnpack(DE,'|',L),
	L=[_,SNo,Dk,V2,_],
	Dk=D,
	No=sx::toInt(SNo),
	N=No div 10,
	N>0,
	Dist2=9999-N,
	redGetMatch(DEs,ArgNo,D,V3,Dist3),
	set::setMax([Dist2,Dist3],Dist),
	set::setGet([Dist2,Dist3],Ix,Dist),
	set::setGet([V2,V3],Ix,DM),
	!
;
	ArgNo<10,
	sx::sxUnpack(DE,'|',L),
	Dk=D,
	L=[_,SNo,_,Dk,V2,_],
	No=sx::toInt(SNo),
	N=No div 10,
	N>0,
	Dist2=9999-N,
	redGetMatch(DEs,ArgNo,Dk,V3,Dist3),
	set::setMax([Dist2,Dist3],Dist),
	set::setGet([Dist2,Dist3],Ix,Dist),
	set::setGet([V2,V3],Ix,DM),
	!
;
	ArgNo>=10,
	sx::sxUnpack(DE,'|',L),
	L=[_,SNo,Dk,V2,_],
	Dk=D,
	No=sx::toInt(SNo),
	N=No div 10,
	N>0,
	Arg=ArgNo div 10,
	Dist2=Arg-N,
	Dist2>0,	
	redGetMatch(DEs,ArgNo,D,V3,Dist3),
	set::setMax([Dist2,Dist3],Dist),
	set::setGet([Dist2,Dist3],Ix,Dist),
	set::setGet([V2,V3],Ix,DM),
	!
;
	ArgNo>=10,
	sx::sxUnpack(DE,'|',L),
	Dk=D,
	L=[_,SNo,_,Dk,V2,_],
	No=sx::toInt(SNo),
	N=No div 10,
	N>0,
	Arg=ArgNo div 10,
	Dist2=Arg-N,
	Dist2>0,	
	redGetMatch(DEs,ArgNo,Dk,V3,Dist3),
	set::setMax([Dist2,Dist3],Dist),
	set::setGet([Dist2,Dist3],Ix,Dist),
	set::setGet([V2,V3],Ix,DM),
	!
;
	redGetMatch(DEs,ArgNo,D,DM,Dist),
	!.
% ---------------------------------------------------------------------------
% rubNodeNew
% ---------------------------------------------------------------------------
predicates
rubNodeNewX : (integer,sterm,integer,sterm,sterm) determ (i,i,i,i,o).
rubInsB : (integer,integer,sterm,sterm,sterm) determ (i,i,i,i,o).
rubInsA_X : (integer,integer,sterml,sterm,sterml) determ (i,i,i,i,o).
rubInsA : (integer,integer,sterm,sterm,sterm) determ (i,i,i,i,o).
rubInsB_X : (integer,integer,sterml,sterm,sterml) determ (i,i,i,i,o).
rubRep : (integer,integer,sterm,sterm,sterm) determ (i,i,i,i,o).
rubRepX : (integer,integer,sterml,sterm,sterml) determ (i,i,i,i,o).
clauses
% adds a new sub-tree (node) to the tree by insertion or replacement
% parameters:
% 1	in	rule editor window
% 2	in	1:insert over under same parent; 2:insert under under same parent; 3:insert as sub-tree
% 3	in	current no
% 4	in	new node (KB name)
%
rubNodeNew(Insert,No,Nw) :-
	rub::rubNL(Nw,New),
	rubNodeNewX(Insert,rule,No,New,NewRule),
	rule:=NewRule,
	!.
	
rubNodeNewX(1,Rule,No,New,NewRule) :-	
	rubInsB(1,No,Rule,New,NewRule),!.
rubNodeNewX(2,Rule,No,New,NewRule) :-	
	rubInsA(1,No,Rule,New,NewRule),!.
rubNodeNewX(3,Rule,No,New,NewRule) :-	
	rubRep(1,No,Rule,New,NewRule),!.
rubInsA(N,No,cmp(H,L),New,cmp(H,Lm)) :-	
	Next=N+1,	
	rubInsA_X(Next,No,L,New,Lm),!.
rubInsA_X(N,N,[H|T],New,[H,New|T]) :-
	!.
rubInsA_X(N,No,[H|T],New,[Hm|T]) :-
	rub::rubCountNodes(H,L),
	No<(N+L),
	rubInsA(N,No,H,New,Hm),!.
rubInsA_X(N,No,[H|T],New,[H|Tm]) :-
	rub::rubCountNodes(H,L),
	Next=N+L,
	rubInsA_X(Next,No,T,New,Tm),!.
rubInsB(N,No,cmp(H,L),New,cmp(H,Lm)) :-	
	Next=N+1,	
	rubInsB_X(Next,No,L,New,Lm),!.
rubInsB_X(N,N,[H|T],New,[New,H|T]) :-
	!.
rubInsB_X(N,No,[H|T],New,[Hm|T]) :-
	rub::rubCountNodes(H,L),
	No<(N+L),
	rubInsB(N,No,H,New,Hm),!.
rubInsB_X(N,No,[H|T],New,[H,New|T]) :-
	rub::rubCountNodes(H,L),
	Next=N+L,
	No=Next,!.
rubInsB_X(N,No,[H|T],New,[H|Tm]) :-
	rub::rubCountNodes(H,L),
	Next=N+L,
	No>=Next,
	rubInsB_X(Next,No,T,New,Tm),!.
rubRep(N,N,_,New,New) :-
	!.
rubRep(N,No,cmp(H,L),New,cmp(H,Lm)) :-	
	Next=N+1,	
	rubRepX(Next,No,L,New,Lm),!.
rubRepX(N,No,[H|T],New,[Hm|T]) :-
	rubRep(N,No,H,New,Hm),!.
rubRepX(N,No,[H|T],New,[H|Tm]) :-
	rub::rubCountNodes(H,L),
	Next=N+L,
	rubRepX(Next,No,T,New,Tm),!.	
% ---------------------------------------------------------------------------
% filterContext
% ---------------------------------------------------------------------------
filterContext(_,[],[]) :-
    !.
filterContext(Context,[ST|STs],[ST|T]) :-
    sx::sxUnpack(ST,'|',L),
    L=[P|_],
    pop::inContext(P,"p",Context),
    filterContext(Context,STs,T),
    !.
filterContext(Context,[_|STs],T) :-
    filterContext(Context,STs,T),
    !.
% ----------------------------------------------------------------------------------------------
% rtrTreeDisplayNL
% ----------------------------------------------------------------------------------------------
class predicates
rtrDisplayNL : (string,integer,string) determ (i,i,i).
clauses

rtrDisplayNLs(_,_,[]) :-
	!.
rtrDisplayNLs(Realm,N,[Rule|Rules]) :-
	Rule="",
	rtrDisplayNLs(Realm,N,Rules),
	!
;	
	rtrDisplayNL(Realm,N,Rule),
	Next=N+1,
	rtrDisplayNLs(Realm,Next,Rules),
	!.
rtrDisplayNL(Realm,No,S) :-
	St=string::concat(S,"!"),
	transnl::parSynTree(St,SynTr),
	rn::rnlST_RT(SynTr,Tree,SType,DE_Vars),
	rtrTreeDisplay(Tree,SType,DE_Vars,Realm,No,0),
	!.
% ----------------------------------------------------------------------------------------------
% rtrTreeDisplayXML
% ----------------------------------------------------------------------------------------------
class predicates
rtrDisplayXMLs : (sterml) determ (i).
clauses
rtrDisplayXML(X) :-
	%xmlGeneric::xmlToTree(X,Tree),
	XML=xmlTree::newTree(X),
	Tree=XML:get(),
			tt::tt_term(3,"XML Tree",Tree),
	Tree=cmp(_,[_|Trees]),
	rtrDisplayXMLs(Trees),
	!.
rtrDisplayXMLs([]) :-
	!.
rtrDisplayXMLs([T|Ts]) :-
	T=cmp("sentenceRule",[cmp("Attributes",Atts),SR]),
	xmlGeneric::xmlGetAttr("realmSubNo",Atts,SSubNo),
	SSubNo="0",
	xmlGeneric::xmlGetAttr("ruleType",Atts,SType),
	xmlGeneric::xmlGetAttr("realm",Atts,Realm),
	xmlGeneric::xmlGetAttr("realmNo",Atts,SNo),
	xmlP3::xmlToRule(SR,Rule),
			tt::tt_term(3,"Rule-tree (from XML)",Rule),
	RuleType=sx::toInt(SType),
	No=sx::toInt(SNo),
	SubNo=sx::toInt(SSubNo),
	rub::rubRuleType(_,RuleType,TypeK),
	Rule=cmp(Typ,[Cond,Conc]),
	RuleR=cmp(Typ,[Conc,Cond]),
	rt::rcnCleanRule(-1,TypeK,RuleR,Tree,DEs),
	rtrTreeDisplay(Tree,SType,DEs,Realm,No,SubNo),
	rtrDisplayXMLs(Ts),
	!.
% ----------------------------------------------------------------------------------------------
% rtrTreeDisplayRec
% ----------------------------------------------------------------------------------------------
rtrTreeDisplayRec(Loc) :-
	vpi::cursorSetWait(),
    dbBase::getRecord(Loc,RT,_,_,_,_,Realm,No,SubNo,_,Conc,Cond),
	rt::rcnTree(RT,cmp(":-",[Conc,Cond]),Rule,SType,DEs),
	rtrTreeDisplay(Rule,SType,DEs,Realm,No,SubNo),
	!.
% ----------------------------------------------------------------------------------------------
% rtrTreeDisplay
% ----------------------------------------------------------------------------------------------
% parameters:
% 3	in	list of DE variables
%
rtrTreeDisplay(RulePrep,SType,DEsPrep,Realm,No,SubNo) :-
  	rub::rubDE_Adjust(DEsPrep,DEs,DEsConc),
	rub::rubNL(RulePrep,Rule2),
				tt::tt_term(2,"Rule-tree (NL)",Rule2),
	ruled::rtrMakeTree(Rule2,Tree,Rule),
	Win=guix::getWinOfClas(1),
  	RED=ruleeditor::new(Win),
  	RED:setPars(Rule,SType,DEs,DEsConc,Realm,No,SubNo,Tree),
  	!.
% ----------------------------------------------------------------------------------------------
% unknownST
% ----------------------------------------------------------------------------------------------
unknownST(ST) :-
	dbBase::stExists(3,ST),
	!
;	
	dlgIF::dlgNote(0,"Note that this sentence type is unknown"),
	!.
% ----------------------------------------------------------------------------------------------
% setDomain
% ----------------------------------------------------------------------------------------------
% sets domain on the basis current node
%
setDomain([Type|_],[Name|_]) :-
    Type=21,
    vars::varComps(Name,_,_,DE),
    dbBase::smClassDef(DE,"a",_,_,Dom,_,_),
    dbBase::nlSing(Dom,Domain),
    guix::lbtSel(thisWin,idc_dom,Domain),
    !
;
    Type=21,
    dbBase::smClassDef(Name,"a",_,_,Dom,_,_),
    dbBase::nlSing(Dom,Domain),
    guix::lbtSel(thisWin,idc_dom,Domain),
    !
;
    Type=20,
    sx::sxUnpack(Name,'/',L),
    L=[_,Dom],
    Dom2=string::toLowercase(Dom),
    Dom3=string::concat("p3_d",Dom2),
    dbBase::nlSing(Dom3,Domain),
    guix::lbtSel(thisWin,idc_dom,Domain),
    !.
setDomain(_,_) :-
    !.
end implement ruleEditor
