/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement sentencemodel
open core,vpiDomains,resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/sentencemodel".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
allSegments : integer :=0. % -1/1 include elements from all segments

predicates
popDEs : ().

class predicates
displayElement : (vpiDomains::windowHandle) determ.
newElement : (vpiDomains::windowHandle) determ.

clauses
new(Parent,AllSegments):-
    allSegments:=AllSegments,
      _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                                   windowFlags, eventHandler, 0).
getWin()=W:-W=thisWin.

/* sm element type */

    predicates
        onControlDataElement : vpiDomains::controlHandler.
    clauses
        onControlDataElement(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        vpi::cursorSetWait(),
        L5=pop::getSM("a"),
        dbBase::nlSings(L5,All),
        guix::lbxPop(thisWin,idc_nl,All),
        guix::ctlInvisible(thisWin,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_de,idc_unary,idc_binary,
                                            idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save,
                                            idct_kbname,idct_segment,idc_deps,idc_segment,idct_plural,idc_plural]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],1),
        vpi::cursorSet(thisWin,cursor_Arrow),
        !;!.

    predicates
        onControlentity : vpiDomains::controlHandler.
    clauses
        onControlentity(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        vpi::cursorSetWait(),
        L5=pop::getSM("e"),
        dbBase::nlSings(L5,All),
        guix::lbxPop(thisWin,idc_nl,All),
        guix::lbxPop(thisWin,idc_de1s,[]),
        guix::lbxGetAll(thisWin,idc_a,Dab),
        guix::lbxPop(thisWin,idc_de2s,Dab),
        guix::txtSet(thisWin,idc_plural,""),
        guix::ctlInvisible(thisWin,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_de,idc_unary,idc_binary,
                                            idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save,
                                            idct_kbname,idct_segment,idc_deps,idc_segment]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],3),
        vpi::cursorSet(thisWin,cursor_Arrow),
        !;!.

    predicates
        onControlpredicate : vpiDomains::controlHandler.
    clauses
        onControlpredicate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        vpi::cursorSetWait(),
        L5=pop::getSM("p"),
        dbBase::nlSings(L5,All),
        guix::lbxPop(thisWin,idc_nl,All),
        guix::lbxPop(thisWin,idc_de1s,[]),
        guix::lbxGetAll(thisWin,idc_a,Dab),
        guix::lbxPop(thisWin,idc_de2s,Dab),
        guix::txtSet(thisWin,idc_plural,""),
        guix::guiRB_SetN(thisWin,[idc_unary,idc_binary],[1,2],1),
        guix::ctlInvisible(thisWin,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_de,idc_unary,idc_binary,
                                            idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save,
                                            idct_kbname,idct_segment,idc_deps,idc_segment]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],4),
        vpi::cursorSet(thisWin,cursor_Arrow),
        !;!.

    predicates
        onControlfunction : vpiDomains::controlHandler.
    clauses
        onControlfunction(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        vpi::cursorSetWait(),
        L5=pop::getSM("f"),
        L6=pop::getSM("g"),
        set::conc([L5,L6],AllK),
        dbBase::nlSings(AllK,All),
        guix::lbxPop(thisWin,idc_nl,All),
        guix::lbxPop(thisWin,idc_de1s,[]),
        guix::lbxGetAll(thisWin,idc_a,Dab),
        guix::lbxPop(thisWin,idc_de2s,Dab),
        guix::ctlInvisible(thisWin,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_de,idc_unary,idc_binary,
                                            idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save,
                                            idct_kbname,idct_segment,idc_deps,idc_segment]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],5),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
    onControlidc_ir : vpiDomains::controlHandler.
    clauses
    onControlidc_ir(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        vpi::cursorSetWait(),
        AllK=pop::getSM("h"),
        dbBase::nlSings(AllK,All),
        guix::lbxPop(thisWin,idc_nl,All),
        guix::lbxPop(thisWin,idc_de1s,[]),
        guix::lbxGetAll(thisWin,idc_a,Dab),
        guix::lbxPop(thisWin,idc_de2s,Dab),
        guix::ctlInvisible(thisWin,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_de,idc_unary,idc_binary,
                                            idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save,
                                            idct_kbname,idct_segment,idc_deps,idc_segment]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],6),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onControlall : vpiDomains::controlHandler.
    clauses
        onControlall(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        vpi::cursorSetWait(),
        guix::lbxGetAll(thisWin,idc_de2s,DEs),
        L3=pop::getSM("e"),
        L4=pop::getSM("p"),
        L5=pop::getSM("f"),
        L6=pop::getSM("g"),
        L7=pop::getSM("h"),
        set::conc([L3,L4,L5,L6,L7],AllK),
        dbBase::nlSings(AllK,All2),
        set::conc([All2,DEs],All),
        guix::lbxPop(thisWin,idc_nl,All),
        Lc=dbBase::getContext(),
        Lc=[H|_],
        guix::lbtSel(thisWin,idc_segment,H),
        guix::ctlInvisible(thisWin,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_de,idc_unary,idc_binary,
                                            idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save,
                                            idct_kbname,idct_segment,idc_deps,idc_segment]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],7),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

/* element selected/entered */

    predicates
        onControlnl : vpiDomains::controlHandler.
    clauses
        onControlnl(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::selchanged(),
    guix::txtSet(thisWin,idc_integrity,""),
    displayElement(thisWin),
    guix::ctlEnable(thisWin,[idc_update,idc_delete]),
    guix::ctlDisable(thisWin,[idc_save]),
    !
;
    CtrlInfo=vpiDomains::modified(),
    newElement(thisWin),
    guix::ctlDisable(thisWin,[idc_update,idc_delete]),
    guix::ctlEnable(thisWin,[idc_save]),
    !;!.
    
/* events which affect integrity */

    predicates
        onControlunary : vpiDomains::controlHandler.
    clauses
        onControlunary(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::txtSet(thisWin,idc_integrity,"x"),
    guix::guiRB_SetN(thisWin,[idc_unary,idc_binary],[1,2],1),
    !;!.

    predicates
        onControlbinary : vpiDomains::controlHandler.
    clauses
        onControlbinary(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::txtSet(thisWin,idc_integrity,"x"),
    guix::guiRB_SetN(thisWin,[idc_unary,idc_binary],[1,2],2),
    !;!.

    predicates
        onControldeterministic : vpiDomains::controlHandler.
    clauses
        onControldeterministic(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::txtSet(thisWin,idc_integrity,"x"),
    guix::guiCB_Get(thisWin,idc_deterministic,N),
    N=-1,
    guix::guiCB_Set(thisWin,idc_deterministic,1),
    !
;    
    guix::guiCB_Set(thisWin,idc_deterministic,-1),
    !;!.

    predicates
        onControldomain : vpiDomains::controlHandler.
    clauses
        onControldomain(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::txtSet(thisWin,idc_integrity,"x"),
    !;!.

/* DE buttons */

    predicates
        onControlde1s : vpiDomains::controlHandler.
    clauses
        onControlde1s(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=selchanged(),
	guix::lbtGet(thisWin,idc_de1s,DE),
	guix::lbtSelF(thisWin,idc_de2s,DE),
	!;!.
    
    predicates
        onControladd : vpiDomains::controlHandler.
    clauses
        onControladd(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	guix::lbxGetAll(thisWin,idc_de1s,DEs),
	not(set::member(DE,DEs)),
	guix::lbxAdd(thisWin,idc_de1s,DE),
	guix::txtSet(thisWin,idc_integrity,"x"),
	!;!.

    predicates
        onControlremove : vpiDomains::controlHandler.
    clauses
        onControlremove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	guix::lbxRemReselect(thisWin,idc_de1s),
	guix::txtSet(thisWin,idc_integrity,"x"),
	!;!.

    predicates
        onControlup : vpiDomains::controlHandler.
    clauses
        onControlup(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	guix::txtSet(thisWin,idc_integrity,"x"),
	!;!.

    predicates
        onControldown : vpiDomains::controlHandler.
    clauses
        onControldown(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	C=vpi::winGetCtlHandle(thisWin,idc_de1s),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N),
	No<(N-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	guix::txtSet(thisWin,idc_integrity,"x"),
	!;!.

    predicates
        onControlLookUp : vpiDomains::controlHandler.
    clauses
        onControlLookUp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	guix::lbtGet(thisWin,idc_de2s,DE),
	W=guix::getWinOfClas(1),
    Obj=sentencemodel::new(W,1),
    Wd=Obj:getWin(),
    displayDE(Wd,DE),
    R=vpi::winGetOuterRect(Wd),
    R=vpiDomains::rct(X,Y,XX,YY),
    Xm=X+300,
    Ym=Y+100,
    XXm=XX+300,
    YYm=YY+100,
    vpi::winMove(Wd,vpiDomains::rct(Xm,Ym,XXm,YYm)),
	!;!.

    predicates
        onControlrefresh : vpiDomains::controlHandler.
    clauses
        onControlrefresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        popDEs,
        guix::lbxGetAll(thisWin,idc_a,Dab),
        guix::lbxPop(thisWin,idc_de2s,Dab),
        !;!.

/* display dependents */

    predicates
        onControldeps : vpiDomains::controlHandler.
    clauses
        onControldeps(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::lbtGet(thisWin,idc_nl,NL),
    dbBase::kbID(NL,Id,Clas,_),
    jmod::swapS(Clas,"p3_iFunc","p3_iFncD",Swap2),
    jmod::swapS(Swap2,"p3_iIR","p3_iIRdec",Swap),
	dep::nodIF_No(Swap,DepType),
	T=cmp("n",[int(DepType),termDomain::str(Id)]),
	dep::chkGetAllDirectDeps(T,_,SDeps),
	dbBase::nlSing(Clas,TypN),
	sx::concat([TypN," ",NL],S),
    Dlg=dependents::new(),
    Dlg:setPars(SDeps,S,0),
    W=guix::getWinOfClas(1),
    Dlg:show(W),
	!;!.

/* save new */

    predicates
        onControlsave : vpiDomains::controlHandler.
    clauses
        onControlsave(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	dbBase::accessErrorChain("v"),
	!
;	
	dbBase::accessErrorChain("q"),
	!
;	
	guix::txtGet(thisWin,idc_nl,NL),
	guix::txtGet(thisWin,idc_kb,Id),
    guix::guiRB_Get(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    save(thisWin,N,Id,NL,"$SM"),
	guix::lbxAdd(thisWin,idc_nl,NL),
  	guix::ctlDisable(thisWin,[idc_save]),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* update */

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	dbBase::accessErrorChain("v"),
	!
;	
	dbBase::accessErrorChain("q"),
	!
;	
	guix::txtGet(thisWin,idc_nl,NL),
	guix::txtGet(thisWin,idc_kb,Id),
    guix::guiRB_Get(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    update(thisWin,N,Id,NL,"$SM"),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* delete */

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	dbBase::accessErrorChain("v"),
	!
;	
	dbBase::accessErrorChain("q"),
	!
;	
    delete(thisWin),
    dlgIF::dlgNote(0,"Sentence model element and related terminology deleted!"),
    guix::lbxRemReselect(thisWin,idc_nl),
  	guix::ctlInvisible(thisWin,[idc_update,idc_delete]),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

/* standard events */
    
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,
                                        idc_kb,idc_segment,idc_unary,idc_binary,idc_deterministic,idc_domain,idct_plural,idc_plural,
                                        idc_de1s,idc_de2s,idc_save,idc_delete,idct_format,idct_width,idc_format,idc_width,
                                        idc_update,idct_de,idct_segment,idct_kbname,idc_look_up,idc_all,
                                        idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_deps,idc_nl],[]),
        guix::guiRB_SetN(thisWin,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],7),
        guix::ctlInvisible(thisWin,[idct_de,idc_unary,idc_binary,idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,
                                            idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_save,idc_delete]),
        Lang=globalVars::get_s("lang"),
        cache::loadTmConditionally(Lang),
        cache::loadSmConditionally,
        popDEs,
        guix::lbxGetAll(thisWin,idc_a,L1),
        L3=pop::getSM("e"),
        L4=pop::getSM("p"),
        L5=pop::getSM("f"),
        L6=pop::getSM("g"),
        L7=pop::getSM("h"),
        set::conc([L3,L4,L5,L6,L7],AllK),
        dbBase::nlSings(AllK,All2),
        set::conc([All2,L1],All),
        guix::lbxPop(thisWin,idc_nl,All),
        Doms=dom::nlList(),
        guix::lbxPop(thisWin,idc_domain,Doms),
        Ls=pop::getSegments(),
        guix::lbxPop(thisWin,idc_segment,Ls),
        Lc=dbBase::getContext(),
        Lc=[H|_],
        guix::lbtSel(thisWin,idc_segment,H),
        guix::addWin(101,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            cache::loadTmConditionally,
            cache::loadSmConditionally,
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

% This code is maintained by the VDE do not update it manually, 16:53:29-25.1.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,50,570,590).
    menu : vpiDomains::menu = noMenu.
    title : string = "Sentence Model Element".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,68,176,88),"Data element",Win,[wsf_TabStop,wsf_Group],idc_data_element),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,92,176,112),"Entity",Win,[wsf_TabStop],idc_entity),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,116,176,136),"Predicate",Win,[wsf_TabStop],idc_predicate),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,140,176,160),"Function Declarations",Win,[wsf_TabStop],idc_function),
        _ = vpi::winCreateControl(wc_Edit,rct(112,216,464,240),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_kb),
        _ = vpi::winCreateControl(wc_Text,rct(8,216,104,236),"KB-name",Win,[wsf_AlignLeft],idct_kbname),
        _ = vpi::winCreateControl(wc_Text,rct(8,248,104,268),"Segment",Win,[wsf_AlignLeft],idct_segment),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,512,145,536),"Save New",Win,[wsf_Group,wsf_TabStop],idc_save),
        _ = vpi::winCreateControl(wc_PushButton,rct(168,512,305,536),"Update",Win,[wsf_Group,wsf_TabStop],idc_update),
        _ = vpi::winCreateControl(wc_PushButton,rct(328,512,465,536),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_PushButton,rct(328,480,465,504),"Display dependents",Win,[wsf_Group,wsf_TabStop],idc_deps),
        _ = vpi::winCreateControl(wc_PushButton,rct(192,420,350,444),"Look up data element",Win,[wsf_Group,wsf_TabStop],idc_look_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(192,448,350,472),"Refresh data elements",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        _ = vpi::winCreateControl(wc_PushButton,rct(192,384,271,408),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_down),
        _ = vpi::winCreateControl(wc_PushButton,rct(192,356,271,380),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(192,328,271,352),"Remove --->",Win,[wsf_Group,wsf_TabStop],idc_remove),
        _ = vpi::winCreateControl(wc_PushButton,rct(192,300,271,324),"<--- Add",Win,[wsf_Group,wsf_TabStop],idc_add),
        _ = vpi::winCreateControl(wc_LBox,rct(8,300,184,504),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_de1s),
        _ = vpi::winCreateControl(wc_Text,rct(8,280,464,296),"Data element types",Win,[wsf_AlignCenter],idct_de),
        _ = vpi::winCreateControl(wc_RadioButton,rct(184,140,256,160),"Unary",Win,[wsf_TabStop,wsf_Group],idc_unary),
        _ = vpi::winCreateControl(wc_RadioButton,rct(264,140,336,160),"Binary",Win,[wsf_TabStop],idc_binary),
        _ = vpi::winCreateControl(wc_CheckBox,rct(184,164,336,184),"Deterministic",Win,[wsf_Group,wsf_TabStop],idc_deterministic),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(184,68,464,536),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll],idc_domain),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(280,300,469,540),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_de2s),
        _ = vpi::winCreateControl(wc_Text,rct(184,104,232,124),"Format",Win,[wsf_AlignLeft],idct_format),
        _ = vpi::winCreateControl(wc_Edit,rct(240,104,360,128),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_format),
        _ = vpi::winCreateControl(wc_Text,rct(376,108,416,128),"Width",Win,[wsf_AlignLeft],idct_width),
        _ = vpi::winCreateControl(wc_Edit,rct(424,104,456,128),"",Win,[wsf_AlignCenter,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_width),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(8,4,464,508),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_nl),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,188,176,208),"All",Win,[wsf_TabStop],idc_all),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(112,244,464,536),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_segment),
        _ = vpi::winCreateControl(wc_Edit,rct(368,332,464,356),"idc_integrity",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_integrity),
        _ = vpi::winCreateControl(wc_Edit,rct(368,360,464,384),"idc_ref",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_ref),
        _ = vpi::winCreateControl(wc_Text,rct(8,36,88,56),"Plural form",Win,[wsf_AlignLeft],idct_plural),
        _ = vpi::winCreateControl(wc_Edit,rct(96,36,464,60),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_plural),
        _ = vpi::winCreateControl(wc_LBox,rct(496,8,528,36),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort,wsf_NoIntegralHeight,wsf_Invisible],idc_a),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,164,176,184),"Inexact Rule Declarations",Win,[wsf_TabStop],idc_ir),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_nl, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlnl(idc_nl, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_data_element, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlDataElement(idc_data_element, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_entity, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlentity(idc_entity, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_predicate, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlpredicate(idc_predicate, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_function, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlfunction(idc_function, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_all, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlall(idc_all, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControladd(idc_add, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlremove(idc_remove, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlup(idc_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldown(idc_down, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlLookUp(idc_look_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlrefresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_deps, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldeps(idc_deps, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsave(idc_save, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_binary, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlbinary(idc_binary, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_deterministic, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldeterministic(idc_deterministic, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_domain, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldomain(idc_domain, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_unary, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlunary(idc_unary, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_de1s, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlde1s(idc_de1s, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_ir, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_ir(idc_ir, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
% -----------------------------------------------------------------------------------------------
% displayElement
% -----------------------------------------------------------------------------------------------
class predicates
getPlural : (string,string) procedure (i,o).
clauses

displayElement(W):-
    guix::lbtGet(W,idc_nl,NL),
    dbBase::kbID(NL,Id,Clas,_),
    Clas="p3_iDET",
    guix::txtSet(W,idc_kb,Id),
    dbBase::smClassDefF(Id,"a",_,_,DomK,Form,Width),
    Loc=dbBase::smRef(Id),
    SRef=dbBase::dbRef(Loc),
    guix::txtSet(W,idc_ref,SRef),
    guix::txtSetI(W,idc_width,Width),
    guix::txtSet(W,idc_format,Form),
    dbBase::nlSing(DomK,Dom),
    guix::lbtSel(W,idc_domain,Dom),
    Segment=dbBase::smSegment(Id),
    guix::lbtSel(W,idc_segment,Segment),
	dmAnnoDisplayAsst("p3_iDET",Id),
    guix::ctlDisable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_update,idc_delete,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_plural,idct_plural,idct_de,idc_unary,idc_binary,idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_save]),
    guix::guiRB_SetN(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],1),
    !
;    
    guix::lbtGet(W,idc_nl,NL),
    dbBase::kbID(NL,Id,Clas,_),
    Clas="p3_iET",
    guix::txtSet(W,idc_kb,Id),
    dbBase::smClassDefF(Id,"e",_,DEsK,_,_,_),
    Loc=dbBase::smRef(Id),
    SRef=dbBase::dbRef(Loc),
    guix::txtSet(W,idc_ref,SRef),
	dbBase::nlSings(DEsK,DEs),
	guix::lbxPop(W,idc_de1s,DEs),
    guix::lbxGetAll(W,idc_a,DE2s),
    guix::lbxPop(W,idc_de2s,DE2s),
    Segment=dbBase::smSegment(Id),
    guix::lbtSel(W,idc_segment,Segment),
    getPlural(Id,Np),
    guix::txtSet(W,idc_plural,Np),
	dmAnnoDisplayAsst("p3_iET",Id),
    guix::ctlDisable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_plural,idct_plural,idc_update,idc_delete,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_unary,idc_binary,idc_deterministic,idc_save]),
    guix::guiRB_SetN(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],3),
    !
;    
    guix::lbtGet(W,idc_nl,NL),
    dbBase::kbID(NL,Id,Clas,_),
    Clas="p3_iPT",
    guix::txtSet(W,idc_kb,Id),
    dbBase::smClassDefF(Id,"p",Card,DEsK,_,_,_),
    Loc=dbBase::smRef(Id),
    SRef=dbBase::dbRef(Loc),
    guix::txtSet(W,idc_ref,SRef),
	dbBase::nlSings(DEsK,DEs),
	guix::lbxPop(W,idc_de1s,DEs),
    guix::lbxGetAll(W,idc_a,DE2s),
    guix::lbxPop(W,idc_de2s,DE2s),
    Segment=dbBase::smSegment(Id),
    guix::lbtSel(W,idc_segment,Segment),
    getPlural(Id,Np),
    guix::txtSet(W,idc_plural,Np),
    guix::guiRB_SetN(W,[idc_unary,idc_binary],[1,2],Card),
	dmAnnoDisplayAsst("p3_iPT",Id),
    guix::ctlDisable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_plural,idct_plural,idc_update,idc_delete,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_unary,idc_binary,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_deterministic,idc_save]),
    guix::guiRB_SetN(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],4),
    !
;    
    guix::lbtGet(W,idc_nl,NL),
    dbBase::kbID(NL,Id,Clas,_),
    Clas="p3_iFunc",
    guix::txtSet(W,idc_kb,Id),
    dbBase::smDefF(Id,Cls,_,DEsK,DomK,_,_),
    Loc=dbBase::smRef(Id),
    SRef=dbBase::dbRef(Loc),
    guix::txtSet(W,idc_ref,SRef),
    set::setGet(["g","","f"],No,Cls),
    set::setGet([-1,0,1],No,Det),
    guix::guiCB_Set(W,idc_deterministic,Det),
	dbBase::nlSings(DEsK,DEs),
	guix::lbxPop(W,idc_de1s,DEs),
    guix::lbxGetAll(W,idc_a,L1),
    guix::lbxPop(W,idc_de2s,L1),
    Segment=dbBase::smSegment(Id),
    guix::lbtSel(W,idc_segment,Segment),
    dbBase::nlSing(DomK,Dom),
    guix::lbtSel(W,idc_domain,Dom),
	dmAnnoDisplayAsst("p3_iFunc",Id),
    guix::ctlDisable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_update,idc_delete,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_domain,idc_deterministic,idc_down,idc_up,idc_refresh,idc_look_up,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_plural,idct_plural,idc_format,idct_format,idc_width,idct_width,idc_unary,idc_binary,idc_save]),
    guix::guiRB_SetN(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],5),
    !
;    
    guix::lbtGet(W,idc_nl,NL),
    dbBase::kbID(NL,Id,Clas,_),
    Clas="p3_iIR",
    guix::txtSet(W,idc_kb,Id),
    dbBase::smClassDefF(Id,"h",_,DEsK,DomK,_,_),
    Loc=dbBase::smRef(Id),
    SRef=dbBase::dbRef(Loc),
    guix::txtSet(W,idc_ref,SRef),
	dbBase::nlSings(DEsK,DEs),
	guix::lbxPop(W,idc_de1s,DEs),
    guix::lbxGetAll(W,idc_a,L1),
    guix::lbxPop(W,idc_de2s,L1),
    Segment=dbBase::smSegment(Id),
    guix::lbtSel(W,idc_segment,Segment),
    dbBase::nlSing(DomK,Dom),
    guix::lbtSel(W,idc_domain,Dom),
	dmAnnoDisplayAsst("p3_iFunc",Id),
    guix::ctlDisable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_update,idc_delete,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_domain,idc_down,idc_up,idc_refresh,idc_look_up,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_plural,idct_plural,idc_format,idct_format,idc_width,idct_width,idc_unary,idc_binary,idc_save,idc_deterministic]),
    guix::guiRB_SetN(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],6),
    !.
    
getPlural(K,N) :-
    dbBase::nlFormF(K,"p3_iPlu",N),
    !
;
    N="",
    !.
% -----------------------------------------------------------------------------------------------
% newElement
% -----------------------------------------------------------------------------------------------
newElement(W):-
    guix::guiRB_Get(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    N=7,
    dlgIF::dlgNote(0,"Select sentence model element type first!"),
    !
;    
    guix::guiRB_Get(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    N=1,
    guix::lbtGet(W,idc_nl,NL),
    dbExtension::kbDefName("a",NL,Id),
    guix::txtSet(W,idc_kb,Id),
    %
    guix::ctlEnable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_save,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_plural,idct_plural,idct_de,idc_unary,idc_binary,idc_deterministic,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_update,idc_delete]),
    !
;    
    guix::guiRB_Get(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    N=3,
    guix::lbtGet(W,idc_nl,NL),
    dbExtension::kbDefName("e",NL,Id),
    guix::txtSet(W,idc_kb,Id),
    guix::txtSet(W,idc_plural,NL),
    %
    guix::ctlEnable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_plural,idct_plural,idc_save,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_unary,idc_binary,idc_deterministic,idc_update,idc_delete]),
    !
;    
    guix::guiRB_Get(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    N=4,
    guix::lbtGet(W,idc_nl,NL),
    dbExtension::kbDefName("p",NL,Id),
    guix::txtSet(W,idc_kb,Id),
    guix::txtSet(W,idc_plural,NL),
    %
    guix::ctlEnable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_plural,idct_plural,idc_save,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_look_up,idc_unary,idc_binary,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_format,idct_format,idc_width,idct_width,idc_domain,idc_deterministic,idc_update,idc_delete]),
    !
;    
    guix::guiRB_Get(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    N=5,
    guix::lbtGet(W,idc_nl,NL),
    dbExtension::kbDefName("f",NL,Id),
    guix::txtSet(W,idc_kb,Id),
    %
    guix::ctlEnable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_save,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_domain,idc_deterministic,idc_down,idc_up,idc_refresh,idc_look_up,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_plural,idct_plural,idc_format,idct_format,idc_width,idct_width,idc_unary,idc_binary,idc_update,idc_delete]),
    !
;    
    guix::guiRB_Get(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_ir,idc_all],[1,3,4,5,6,7],N),
    N=6,
    guix::lbtGet(W,idc_nl,NL),
    dbExtension::kbDefName("c",NL,Id),
    guix::txtSet(W,idc_kb,Id),
    %
    guix::ctlEnable(W,[idc_kb]),
    guix::ctlVisible(W,[idc_save,idct_de,idc_de1s,idc_de2s,idc_add,idc_remove,idc_domain,idc_down,idc_up,idc_refresh,idc_look_up,idc_kb,idct_kbname,idc_deps,idct_segment,idc_segment]),
    guix::ctlInvisible(W,[idc_plural,idct_plural,idc_format,idct_format,idc_width,idct_width,idc_deterministic,idc_unary,idc_binary,idc_update,idc_delete]),
    !.
% --------------------------------------------------------------------------------------------
% dmAnnoDisplayAsst
% --------------------------------------------------------------------------------------------
class predicates
dmAnnoNameKB : (string,string,string) procedure (i,i,o).
dmAnnoNameNL : (string,string,string) procedure (i,i,o).
clauses

% parameters:
% 1	node type (KB name)
% 2	node name (KB rep)
%
dmAnnoDisplayAsstNL(Type,NL) :-
	dmAnnoNameKB(Type,NL,K),
	dmAnnoDisplayAsst(Type,K),
	!.
	
dmAnnoDisplayAsst(Type,K) :-
	W=guix::getWinOfClas(4),
  	guix::ctlVisible(W,[idc_nodes]),
  	guix::ctlInvisible(W,[idc_topics]),
  	guix::txtSet(W,idc_annotation,"Annotation"),
  	dbExtension::kbGetAnnotationBlank(Type,K,Note),
  	Note<>"",
	Note2=sx::replaceAll(Note,"\n"," "),
	Note3=sx::replaceAll(Note2,"  "," "),
	sx::sxBlockNL(0,50,Note3,Note4),
	dbBase::nlSingF(Type,TypeNL),
	dmAnnoNameNL(Type,K,N),
	sx::concat([TypeNL,": ",N],Name),
	guix::lbtSelF(W,idc_nodes,Name),
  	guix::txtSet(W,idc_edit,Note4),
  	!
;  	
  	dbExtension::kbGetAnnotationBlank(Type,K,_),
	W=guix::getWinOfClas(4),
	dbBase::nlSingF(Type,TypeNL),
	dmAnnoNameNL(Type,K,N),
	sx::concat([TypeNL,": ",N],Name),
	guix::lbtSelF(W,idc_nodes,Name),
  	guix::txtSet(W,idc_edit,""),
  	!
;
  	!.	
dmAnnoNameKB(Type,NL,K) :-  	
    set::member(Type,["p3_iRelm","p3_iDB","p3_iSegm","p3_iSR"]),
    K=NL,
    !
;
    Type="p3_iST",
    dbBase::stNL_KB(NL,K),
    !
;
    dbBase::kbID(NL,K,_,_),
    !
;
    K=NL,
    !.
dmAnnoNameNL(Type,K,NL) :-  	
    set::member(Type,["p3_iRelm","p3_iDB","p3_iSegm","p3_iSR"]),
    NL=K,
    !
;
    dbBase::nlTry(K,NL),
    !.
% --------------------------------------------------------------------------------------------
% displayDE
% --------------------------------------------------------------------------------------------
displayDE(W,DE) :-
    dbBase::kbID_F(DE,_,Type,_),
    Type="p3_iDET",
	guix::lbtSel(W,idc_nl,DE),	
    displayElement(W),
    !
;    
    guix::guiRB_SetN(W,[idc_data_element,idc_entity,idc_predicate,idc_function,idc_all],[1,2,3,4,5,6],1),
    !.
% --------------------------------------------------------------------------------------------
% update
% --------------------------------------------------------------------------------------------
update(W,N,Id,NL,Realm) :-
    guix::txtGet(W,idc_integrity,X),
    X="x",
    !,
    delete(W),
    save(W,N,Id,NL,Realm),
    !
;    
    Check=dep::getIntegrityCheck(),
    dep::setIntegrityCheck(-1),
    delete(W),
    save(W,N,Id,NL,Realm),
    dep::setIntegrityCheck(Check),
    !.    
% --------------------------------------------------------------------------------------------
% delete
% --------------------------------------------------------------------------------------------
delete(W) :-
    guix::txtGet(W,idc_ref,SRef),
    Loc=dbBase::dbRefR(SRef),
    dbBase::recordDelete(Loc),
    guix::txtGet(W,idc_kb,K),
    dbBase::syntagmDelete(K),
    !.
% --------------------------------------------------------------------------------------------
% save
% --------------------------------------------------------------------------------------------
save(W,N,Id,NL,Realm) :-
	dbBase::kbID_F(NL,_,_,_),
	dlgIF::dlgNote(0,"The NL-name is already in use!"),!,fail
;	
	dbBase::nlSingF(Id,_),
	dlgIF::dlgNote(0,"The KB-name is already in use!"),!,fail
;
    set::member(N,[2,3]),
	guix::lbxGetAll(W,idc_de1s,DEs),
	set::size(DEs,Nd),
	Nd=0,
    dlgIF::dlgNote(0,"This sentence model element type must have at least one data element type!"),!,fail    
;
    N=1,
    not(guix::txtGetI(W,idc_width,_)),
    dlgIF::dlgNote(0,"Enter a max. width (in no. of characters). The width is used when data element values are subject to sorting (including when used in a number of procedure calls)."),!,fail
;
    N=1,
    guix::lbtGet(W,idc_domain,Dom),
    Dom="",
	dlgIF::dlgNote(0,"Select a domain for this data element!"),!,fail
;
    N=1,
    guix::txtGet(W,idc_format,Form),
    guix::txtGetI(W,idc_width,Width),
    guix::lbtGet(W,idc_domain,Dom),
    dbBase::kbID_F(Dom,DomK,_,_),
    guix::lbtGet(W,idc_segment,Seg),
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iDET"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("q",[cmp("a",[termDomain::atom(Id),termDomain::atom(DomK),termDomain::str(Form),termDomain::int(Width)]),termDomain::str(Seg)]),atom("true"),Loc),
  	Ref=dbBase::dbRef(Loc),
  	guix::txtSet(W,idc_ref,Ref),
	dlgIF::dlgNote(0,"Data element type added to/updated in the sentence model!"),
  	!
;  	
    N=3,
    guix::lbtGet(W,idc_segment,Seg),
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	guix::txtGet(W,idc_plural,NLp),
	pscan::pscNL(NLp,Toks1p),
	pscan::str_tokens(Toks1p,Toks2p),
	cl_list(Toks2p,Toksp),
	guix::lbxGetAll(W,idc_de1s,DEs),
	set::size(DEs,Nd),
	Nd>0,
	dbBase::kbIDs(DEs,IDs),
	cla_list(IDs,DElist),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iET"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iET"),termDomain::atom("p3_iPlu"),Toksp]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("q",[cmp("e",[termDomain::atom(Id),DElist]),termDomain::str(Seg)]),atom("true"),Loc),
  	Ref=dbBase::dbRef(Loc),
  	guix::txtSet(W,idc_ref,Ref),
	dlgIF::dlgNote(0,"Entity type added to/updated in the sentence model!"),
  	!
;  	
    N=4,
    guix::lbtGet(W,idc_segment,Seg),
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	guix::txtGet(W,idc_plural,NLp),
	pscan::pscNL(NLp,Toks1p),
	pscan::str_tokens(Toks1p,Toks2p),
	cl_list(Toks2p,Toksp),
	guix::lbxGetAll(W,idc_de1s,DEs),
    guix::guiRB_Get(W,[idc_unary,idc_binary],[1,2],Card),
	dbBase::kbIDs(DEs,IDs),
	cla_list(IDs,DElist),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iPT"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iPT"),termDomain::atom("p3_iPlu"),Toksp]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("q",[cmp("p",[termDomain::atom(Id),termDomain::int(Card),DElist]),termDomain::str(Seg)]),atom("true"),Loc),
  	Ref=dbBase::dbRef(Loc),
  	guix::txtSet(W,idc_ref,Ref),
	dlgIF::dlgNote(0,"Predicate type added to/updated in the sentence model!"),
  	!
;  	
    N=5,
    guix::lbtGet(W,idc_segment,Seg),
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	guix::lbxGetAll(W,idc_de1s,DEs),
    guix::lbtGet(W,idc_domain,Dom),
    dbBase::kbID_F(Dom,DomK,_,_),
    guix::guiCB_Get(W,idc_deterministic,Det),
    set::setGet([-1,0,1],No,Det),
    set::setGet(["g","","f"],No,FType),
	dbBase::kbIDs(DEs,IDs),
	cla_list(IDs,DElist),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iFunc"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("q",[cmp(FType,[termDomain::atom(Id),termDomain::atom(DomK),DElist]),termDomain::str(Seg)]),atom("true"),Loc),
  	Ref=dbBase::dbRef(Loc),
  	guix::txtSet(W,idc_ref,Ref),
	dlgIF::dlgNote(0,"Function declaration added to/updated in the sentence model!"),
  	!
;  	
    N=6,
    guix::lbtGet(W,idc_segment,Seg),
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	guix::lbxGetAll(W,idc_de1s,DEs),
    guix::lbtGet(W,idc_domain,Dom),
    dbBase::kbID_F(Dom,DomK,_,_),
	dbBase::kbIDs(DEs,IDs),
	cla_list(IDs,DElist),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom("p3_iIR"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,Realm,0,0,cmp("q",[cmp("h",[termDomain::atom(Id),termDomain::atom(DomK),DElist]),termDomain::str(Seg)]),atom("true"),Loc),
  	Ref=dbBase::dbRef(Loc),
  	guix::txtSet(W,idc_ref,Ref),
	dlgIF::dlgNote(0,"Inexact rule declaration added to/updated in the sentence model!"),
  	!
;
     dlgIF::dlgNote(1,"Unable to store/update new sentence model element (invalid element)!"),
     !,fail.
% --------------------------------------------------------------------------------------------
% popDEs
% --------------------------------------------------------------------------------------------
popDEs() :-
    globalVars::get_i("p3des")=1,
    Ln=pop::getSM_NL("a",[]),
    guix::lbxPop(thisWin,idc_a,Ln),
    !
;
    allSegments=1,
    Ln=pop::getSM_NL("a",[]),
    guix::lbxPop(thisWin,idc_a,Ln),
    !
;
    Ln=pop::getSM_NL("a"),
    guix::lbxPop(thisWin,idc_a,Ln),
    !.
end implement sentencemodel
