/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement domain
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/sm/domain".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
message : string:="".

clauses
    show(Parent,Message):-
        message:=Message,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    Doms=dom::nlList(),
    guix::lbxPop(thisWin,idc_dom,Doms),
    guix::txtSet(thisWin,idc_mess,message),
    !;!.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
    thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::lbtGet(thisWin,idc_dom,Dom),
    dbBase::kbID(Dom,DomK,_,_),
	globalVars::pushRetPars([DomK]),
    vpi::winDestroy(thisWin),
    !;!.

predicates
    onControlCancel : vpiDomains::controlHandler.
clauses
    onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	globalVars::pushRetPars([""]),
    vpi::winDestroy(thisWin).

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	dlgIF::hlpWeb("domains"),
	!;!.

% This code is maintained by the VDE do not update it manually, 15:05:44-27.12.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Select domain".
    rectangle : vpiDomains::rct = rct(50,40,210,86).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,32,52,44),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(56,32,104,44),"Cancel",u_DlgBase),idc_cancel,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(108,32,156,44),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_LBoxButton,rct(4,16,156,264),"",u_DlgBase),idc_dom,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_Text,rct(4,2,156,12),"",u_DlgBase),idc_mess,[wsf_AlignCenter])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement domain
