/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement sm
open core,vpiDomains,resourceIdentifiers,termDomain

constants
className = "com/rudstrand/TaskWindow/sm/sm".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
et1 : integer:=-1. % -1:set via ST, 0:selected/unchanged, 1=selected/changed, 2=new
et2 : integer:=-1.
pt : integer :=-1.

predicates
popDEs : ().
getQdes : (integer) determ.
markChange : (integer,integer) determ.
saveSt : ().
setCounts : (string).
getSt : (string) determ (o).
checkNL : (string) determ.

clauses
new(Parent):-
        _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                           windowFlags, eventHandler, 0).

predicates
        eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event),
        !.
    eventHandler(Win, e_Menu(Id, CAS)) = Result :-
        Parent = vpi::winGetParent(Win),
        Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

/* select st */

predicates
    onControlidc_st : vpiDomains::controlHandler.
clauses
    onControlidc_st(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,idc_st,ST),
    ST="",
    !
;    
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,idc_st,ST),
	dbBase::stNL_KB(ST,STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1],
	dbBase::nlSing(P,Pn),
	dbBase::nlSing(E1,E1n),
	guix::lbtSel(thisWin,idc_et1,E1n),
	guix::lbtSel(thisWin,idc_pt,Pn),
    dbBase::smClassDefF(E1,"e",_,DEsK1,_,_,_),
	dbBase::nlSings(DEsK1,DEs1),
	guix::lbxPop(thisWin,idc_det1,DEs1),
	sx::sxlJoin(DEs1,";",QDEs1),
	guix::txtSet(thisWin,idc_qdes,QDEs1),
    dbBase::smClassDefF(P,"p",_,DEsKp,_,_,_),
	dbBase::nlSings(DEsKp,DEsp),
	guix::lbxPop(thisWin,idc_dpt,DEsp),
	setCounts(STk),
	sentencemodel::dmAnnoDisplayAsstNL("p3_iST",ST),
	et1:=-1,
	et2:=-1,
	pt:=-1,
	!
;
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,idc_st,ST),
	dbBase::stNL_KB(ST,STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1,E2],
	dbBase::nlSing(P,Pn),
	dbBase::nlSing(E1,E1n),
	guix::lbtSel(thisWin,idc_et1,E1n),
	dbBase::nlSing(E2,E2n),
	guix::lbtSel(thisWin,idc_et2,E2n),
	guix::lbtSel(thisWin,idc_pt,Pn),
    dbBase::smClassDefF(E1,"e",_,DEsK1,_,_,_),
	dbBase::nlSings(DEsK1,DEs1),
	sx::sxlJoin(DEs1,";",QDEs1),
	guix::txtSet(thisWin,idc_qdes,QDEs1),
	guix::lbxPop(thisWin,idc_det1,DEs1),
    dbBase::smClassDefF(E2,"e",_,DEsK2,_,_,_),
	dbBase::nlSings(DEsK2,DEs2),
	guix::lbxPop(thisWin,idc_det2,DEs2),
    dbBase::smClassDefF(P,"p",_,DEsKp,_,_,_),
	dbBase::nlSings(DEsKp,DEsp),
	guix::lbxPop(thisWin,idc_dpt,DEsp),
	setCounts(STk),
	sentencemodel::dmAnnoDisplayAsstNL("p3_iST",ST),
	et1:=-1,
	et2:=-1,
	pt:=-1,
	!;!.

/* select arguments */

predicates
    onControlidc_et1 : vpiDomains::controlHandler.
clauses
    onControlidc_et1(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,idc_et1,E),
    dbBase::kbID(E,Ek,_,_),
    dbBase::smClassDefF(Ek,"e",_,Dk,_,_,_),
	dbBase::nlSings(Dk,Dn),
	guix::lbxPop(thisWin,idc_det1,Dn),
	sx::sxlJoin(Dn,";",QDEs1),
	guix::txtSet(thisWin,idc_qdes,QDEs1),
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],1),
    et1:=0,
	!
;	
    CtrlInfo=modified(),
    guix::lbxSel(thisWin,idc_st,""),
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],1),
    et1:=2,
	!;!.

predicates
    onControlidc_et2 : vpiDomains::controlHandler.
clauses
    onControlidc_et2(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,idc_et2,E),
    dbBase::kbID(E,Ek,_,_),
    dbBase::smClassDefF(Ek,"e",_,Dk,_,_,_),
	dbBase::nlSings(Dk,Dn),
	guix::lbxPop(thisWin,idc_det2,Dn),
	sx::sxlJoin(Dn,";",QDEs1),
	guix::txtSet(thisWin,idc_qdes,QDEs1),
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],2),
    et2:=0,
	!
;	
    CtrlInfo=modified(),
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],2),
    et2:=2,
	!;!.

predicates
    onControlidc_pt : vpiDomains::controlHandler.
clauses
    onControlidc_pt(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=selchanged(),
    guix::lbxGet(thisWin,idc_pt,E),
    dbBase::kbID(E,Ek,_,_),
    dbBase::smClassDefF(Ek,"p",_,Dk,_,_,_),
	dbBase::nlSings(Dk,Dn),
	guix::lbxPop(thisWin,idc_dpt,Dn),
	sx::sxlJoin(Dn,";",QDEs1),
	guix::txtSet(thisWin,idc_qdes,QDEs1),
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],3),
    pt:=0,
	!
;	
    CtrlInfo=modified(),
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],3),
    pt:=2,
	!;!.

/* argument radio buttons */

predicates
    onControlidc_bet1 : vpiDomains::controlHandler.
clauses
    onControlidc_bet1(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],1),
    guix::lbxGet(thisWin,idc_et1,E),
    dbBase::kbID(E,Ek,_,_),
    dbBase::smClassDefF(Ek,"e",_,Dk,_,_,_),
	dbBase::nlSings(Dk,Dn),
	sx::sxlJoin(Dn,";",QDEs),
	guix::txtSet(thisWin,idc_qdes,QDEs),
	!;!.

predicates
    onControlidc_bet2 : vpiDomains::controlHandler.
clauses
    onControlidc_bet2(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],2),
    guix::lbxGet(thisWin,idc_et2,E),
    dbBase::kbID(E,Ek,_,_),
    dbBase::smClassDefF(Ek,"e",_,Dk,_,_,_),
	dbBase::nlSings(Dk,Dn),
	sx::sxlJoin(Dn,";",QDEs),
	guix::txtSet(thisWin,idc_qdes,QDEs),
	!;!.

predicates
    onControlidc_bpt : vpiDomains::controlHandler.
clauses
    onControlidc_bpt(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],3),
    guix::lbxGet(thisWin,idc_pt,E),
    dbBase::kbID(E,Ek,_,_),
    dbBase::smClassDefF(Ek,"p",_,Dk,_,_,_),
	dbBase::nlSings(Dk,Dn),
	sx::sxlJoin(Dn,";",QDEs),
	guix::txtSet(thisWin,idc_qdes,QDEs),
	!;!.

/* replace/supplement from quick entry list */

predicates
    onControlidc_replace : vpiDomains::controlHandler.
clauses
    onControlidc_replace(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    getQdes(1),
    !;!.
    

predicates
    onControlidc_supplement : vpiDomains::controlHandler.
clauses
    onControlidc_supplement(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    getQdes(-1),
    !;!.

/* data element selection */

predicates
    onControlidc_add : vpiDomains::controlHandler.
clauses
    onControlidc_add(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_Get(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],N),
    set::setGet([idc_det1,idc_det2,idc_dpt],N,Ctl),
	guix::lbtGet(thisWin,idc_de2s,DE),
	guix::lbxGetAll(thisWin,Ctl,DEs),
	not(set::member(DE,DEs)),
	guix::lbxAdd(thisWin,Ctl,DE),
	markChange(N,1),
	!;!.

predicates
    onControlidc_remove : vpiDomains::controlHandler.
clauses
    onControlidc_remove(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_Get(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],N),
    set::setGet([idc_det1,idc_det2,idc_dpt],N,Ctl),
  	guix::lbxRemReselect(thisWin,Ctl),
	markChange(N,1),
	!;!.

predicates
    onControlidc_up : vpiDomains::controlHandler.
clauses
    onControlidc_up(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_Get(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],N),
    set::setGet([idc_det1,idc_det2,idc_dpt],N,Ctl),
	C=vpi::winGetCtlHandle(thisWin,Ctl),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	No>0,
	vpi::lboxDelete(C,No),
	M=No-1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	markChange(N,1),
	!;!.

predicates
    onControlidc_down : vpiDomains::controlHandler.
clauses
    onControlidc_down(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    guix::guiRB_Get(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],N),
    set::setGet([idc_det1,idc_det2,idc_dpt],N,Ctl),
	C=vpi::winGetCtlHandle(thisWin,Ctl),
	vpi::lboxGetSel(C,DEs,Nos),
	DEs=[DE],
	Nos=[No],
	DEa=vpi::lboxGetAll(C),
	set::size(DEa,N2),
	No<(N2-1),
	vpi::lboxDelete(C,No),
	M=No+1,
	vpi::lboxAdd(C,M,DE),
	vpi::lboxSetSel(C,M,b_true),
	markChange(N,1),
	!;!.

predicates
    onControlidc_refresh : vpiDomains::controlHandler.
clauses
    onControlidc_refresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    popDEs,
    !;!.

predicates
    onControlidc_look_up : vpiDomains::controlHandler.
clauses
    onControlidc_look_up(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	guix::lbtGet(thisWin,idc_de2s,DE),
	W=guix::getWinOfClas(1),
    Obj=sentencemodel::new(W,1),
    Wd=Obj:getWin(),
    sentenceModel::displayDE(Wd,DE),
    R=vpi::winGetOuterRect(Wd),
    R=vpiDomains::rct(X,Y,XX,YY),
    Xm=X+300,
    Ym=Y+100,
    XXm=XX+300,
    YYm=YY+100,
    vpi::winMove(Wd,vpiDomains::rct(Xm,Ym,XXm,YYm)),
	!;!.

/* browse/list */

predicates
    onControlidc_browse : vpiDomains::controlHandler.
clauses
    onControlidc_browse(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	getSt(STk),
	sentences::browse(STk),
	!
;	
	dlgIF::dlgNote(0,"Select a sentence type!"),
	!.	

predicates
    onControlidc_list : vpiDomains::controlHandler.
clauses
    onControlidc_list(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
  	% list sentences (table window)
	vpi::cursorSetWait(),
	getSt(STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1,E2],
	sentences::frmTabWin(2,P,E1,E2),
	!
;	
	getSt(STk),
	sx::sxUnpack(STk,'|',L),
	L=[P,E1],
	sentences::frmTabWin(1,P,E1,""),
	!
;	
	dlgIF::dlgNote(0,"Select a sentence type!"),
	!.	

/* save/delete */

predicates
    onControlidc_save : vpiDomains::controlHandler.
clauses
    onControlidc_save(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    saveSt,
    !;!.

predicates
    onControlidc_delete : vpiDomains::controlHandler.
clauses
    onControlidc_delete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    pt=0,
    et1=0,
    et2=0,
	vpi::cursorSetWait(),
	guix::lbxGet(thisWin,idc_st,ST),
	ST<>"",
	dbBase::stNL_KB(ST,STk),
    dbBase::stTypeDelete(0,STk,N),
	guix::lbxDelS(thisWin,idc_st,ST),
    Ns=toString(N),
    Mess=string::concat("Deleted ",Ns," sentences!"),
    dlgIF::dlgNote(0,Mess),
    !
;
    dlgIF::dlgNote(0,"Select a sentence type from the upper listbox!"),
    !.

/* refresh */

predicates
    onControlidc_refresh2 : vpiDomains::controlHandler.
clauses
    onControlidc_refresh2(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        vpi::cursorSetWait(),
        popDEs,
        L3=pop::getSM_NL("e"),
        L4=pop::getSM_NL("p"),
        guix::lbxPop(thisWin,idc_et1,L3),
        guix::lbxPop(thisWin,idc_et2,L3),
        guix::lbxPop(thisWin,idc_pt,L4),
        Ps=pop::getSM("p"),
        dbBase::getExtChains(Rc,Wc),
        set::conc([Rc,Wc],Ec),
        set::setRemSub(Ec,Ps,Psl),
        STs=pop::getSentenceSTs(),
        pop::filterSTs(STs,Psl,STsf),
        dbBase::nlSings(STsf,STsfn),
        guix::lbxPop(thisWin,idc_st,[""|STsfn]),
        !;!.

/* create/destroy */

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
        vpi::cursorSetWait(),
        guix::setStyle(thisWin,[idc_de2s,idc_save,idc_delete,idc_add,idc_remove,idc_down,idc_up,idc_refresh,idc_et1,idc_et2,idc_pt,idc_st,idc_refresh2,
                                        idc_det1,idc_det2,idc_dpt,idc_bet1,idc_bet2,idc_bpt,idc_qdes,idc_quick,idc_replace,idc_supplement,idct_q,idc_look_up,
                                        idct_subject,idct_object,idct_predicate,idc_browse,idc_list,idct_status,idct_entered,idct_derived,idc_c1,idc_c2,idc_message],[]),
        guix::guiRB_SetN(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],1),
        Lang=globalVars::get_s("lang"),
        cache::loadTmConditionally(Lang),
        cache::loadSmConditionally,
        popDEs,
        L3=pop::getSM_NL("e"),
        L4=pop::getSM_NL("p"),
        guix::lbxPop(thisWin,idc_et1,L3),
        guix::lbxPop(thisWin,idc_et2,L3),
        guix::lbxPop(thisWin,idc_pt,L4),
        Ps=pop::getSM("p"),
        dbBase::getExtChains(Rc,Wc),
        set::conc([Rc,Wc],Ec),
        set::setRemSub(Ec,Ps,Psl),
        STs=pop::getSentenceSTs(),
        pop::filterSTs(STs,Psl,STsf),
        dbBase::nlSings(STsf,STsfn),
        guix::lbxPop(thisWin,idc_st,[""|STsfn]),
        guix::addWin(118,thisWin),
        vpi::cursorSet(thisWin,cursor_Arrow),
  	    !;!.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        cache::loadTmConditionally,
        cache::loadSmConditionally,
        thisWin := erroneous.

predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses
    onCloseRequest() = defaultHandling() :-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

predicates
    onSizeChanged : vpiDomains::sizeHandler.
clauses
    onSizeChanged(_Width, _Height) = defaultHandling():-
        vpiToolbar::resize(thisWin).

% This code is maintained by the VDE do not update it manually, 09:35:13-7.5.2006
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_SizeBorder,wsf_TitleBar,wsf_Maximize,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,826,616).
    menu : vpiDomains::menu = noMenu.
    title : string = "Sentence type".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBoxButton,rct(8,4,720,516),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_st),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(8,52,232,456),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_et1),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(240,52,488,456),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_pt),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(496,52,720,460),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_et2),
        _ = vpi::winCreateControl(wc_LBox,rct(8,80,232,288),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_det1),
        _ = vpi::winCreateControl(wc_LBox,rct(240,80,488,288),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_dpt),
        _ = vpi::winCreateControl(wc_LBox,rct(496,80,720,288),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_NoIntegralHeight],idc_det2),
        _ = vpi::winCreateControl(wc_RadioButton,rct(8,292,232,312),"Subject entity type data elements",Win,[wsf_TabStop],idc_bet1),
        _ = vpi::winCreateControl(wc_RadioButton,rct(496,292,720,312),"Object entity type data elements",Win,[wsf_TabStop],idc_bet2),
        _ = vpi::winCreateControl(wc_RadioButton,rct(240,292,488,312),"Predicate type data elements",Win,[wsf_TabStop],idc_bpt),
        _ = vpi::winCreateControl(wc_PushButton,rct(184,444,342,468),"Look up data element",Win,[wsf_Group,wsf_TabStop],idc_look_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(184,472,342,496),"Refresh data elements",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,476,87,500),"Move Down",Win,[wsf_Group,wsf_TabStop],idc_down),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,448,87,472),"Move Up",Win,[wsf_Group,wsf_TabStop],idc_up),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,420,87,444),"Remove",Win,[wsf_Group,wsf_TabStop],idc_remove),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,392,87,416),"Add",Win,[wsf_Group,wsf_TabStop],idc_add),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(96,392,344,692),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_de2s),
        _ = vpi::winCreateControl(wc_Text,rct(512,424,648,444),"Entered sentences",Win,[wsf_AlignLeft],idct_entered),
        _ = vpi::winCreateControl(wc_Text,rct(512,452,648,472),"Derived sentences",Win,[wsf_AlignLeft],idct_derived),
        _ = vpi::winCreateControl(wc_Text,rct(504,392,712,412),"Status",Win,[wsf_AlignCenter],idct_status),
        _ = vpi::winCreateControl(wc_Text,rct(512,476,720,496),"",Win,[wsf_AlignLeft],idc_message),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,508,144,532),"Save",Win,[wsf_Group,wsf_TabStop],idc_save),
        _ = vpi::winCreateControl(wc_PushButton,rct(152,508,288,532),"Delete Sentences",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_PushButton,rct(296,508,432,532),"List Sentences",Win,[wsf_Group,wsf_TabStop],idc_list),
        _ = vpi::winCreateControl(wc_PushButton,rct(440,508,576,532),"Browse Sentences",Win,[wsf_Group,wsf_TabStop],idc_browse),
        _ = vpi::winCreateControl(wc_Text,rct(8,316,232,336),"Data element types quick entry:",Win,[wsf_AlignLeft],idc_quick),
        _ = vpi::winCreateControl(wc_Edit,rct(8,340,720,364),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_qdes),
        _ = vpi::winCreateControl(wc_Edit,rct(656,420,720,444),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly],idc_c2),
        _ = vpi::winCreateControl(wc_Edit,rct(656,448,720,472),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_ReadOnly],idc_c1),
        _ = vpi::winCreateControl(wc_Text,rct(8,368,232,388),"Data element types selection:",Win,[wsf_AlignLeft],idct_q),
        _ = vpi::winCreateControl(wc_PushButton,rct(240,316,360,336),"Supplement",Win,[wsf_Group,wsf_TabStop],idc_supplement),
        _ = vpi::winCreateControl(wc_PushButton,rct(368,316,488,336),"Replace",Win,[wsf_Group,wsf_TabStop],idc_replace),
        _ = vpi::winCreateControl(wc_Text,rct(8,32,232,48),"SUBJECT",Win,[wsf_AlignCenter],idct_subject),
        _ = vpi::winCreateControl(wc_Text,rct(240,32,488,48),"PREDICATE",Win,[wsf_AlignCenter],idct_predicate),
        _ = vpi::winCreateControl(wc_Text,rct(496,32,720,48),"OBJECT",Win,[wsf_AlignCenter],idct_object),
        _ = vpi::winCreateControl(wc_PushButton,rct(584,508,720,532),"Refresh",Win,[wsf_Group,wsf_TabStop],idc_refresh2),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_st, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_st(idc_st, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_et1, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_et1(idc_et1, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_et2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_et2(idc_et2, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_pt, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_pt(idc_pt, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_bet1, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_bet1(idc_bet1, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_bet2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_bet2(idc_bet2, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_bpt, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_bpt(idc_bpt, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_replace, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_replace(idc_replace, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_supplement, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_supplement(idc_supplement, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_add, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_add(idc_add, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_remove, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_remove(idc_remove, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_up(idc_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_down, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_down(idc_down, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_refresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_look_up, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_look_up(idc_look_up, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_browse, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_browse(idc_browse, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_list, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_list(idc_list, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_save(idc_save, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_delete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh2, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_refresh2(idc_refresh2, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code

% --------------------------------------------------------------------------------------------
% getQdes
% --------------------------------------------------------------------------------------------
predicates
popQdes : (integer,integer,string_list).
validateQdes : (string_list,string_list) determ (i,o).
clauses

getQdes(Replace) :-
    guix::txtGet(thisWin,idc_qdes,S),
    sx::sxUnpack(S,';',L),
    sx::sxlTrim(L,Lt),
    validateQdes(Lt,Lv),
    guix::guiRB_Get(thisWin,[idc_bet1,idc_bet2,idc_bpt],[1,2,3],N),
    set::setGet([idc_det1,idc_det2,idc_dpt],N,Ctl),
    popQdes(Replace,Ctl,Lv),
    markChange(N,1),
    !.
    
validateQdes([],[]) :-
    !.
validateQdes([H|T],[Hv|Tv]) :-
    dbBase::kbID_F(H,_,Clas,_),
    Clas="p3_iDET",
    validateQdes(T,Tv),
    Hv=H,
    !
;    
    dbBase::kbID_F(H,_,Clas,_),
    Clas="p3_iDET",
    Mess=string::concat("Name '",H,"' is already used for another syntactic type!"),
    dlgIF::dlgNote(0,Mess),!,fail
;
    N2=string::concat("a ",H),
    dbBase::makeNewIdentifier(N2,"",K),
    Dlg = domain::new(),
    Message=string::concat("Please select domain for: ",H,"!"),
    Dlg:show(thisWin,Message),
	Par=globalVars::popRetPars(),
	Par=[Dom],
	Dom<>"",    
    Lc=dbBase::getContext(),
    Lc=[Seg|_],
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(H,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
  	dbBase::recordInsert(2,"$TRM",0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(K),termDomain::atom("p3_iDET"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,"$SM",0,0,cmp("q",[cmp("a",[termDomain::atom(K),termDomain::atom(Dom),termDomain::str(""),termDomain::int(16)]),termDomain::str(Seg)]),atom("true"),_),
    Mess=string::concat("Data element type: ",H," with KB-name: ",K," added to the KB!"),
	dlgIF::msgS(Mess),
    validateQdes(T,Tv),
    Hv=H,
    !.
    
popQdes(Replace,Ctl,L) :-
    Replace=1,
    guix::lbxPop(thisWin,Ctl,L),
    !
;
    guix::lbxGetAll(thisWin,Ctl,All),
    set::conc([All,L],New),
    set::distinct(New,NewD),
    guix::lbxPop(thisWin,Ctl,NewD),
    !.
% --------------------------------------------------------------------------------------------
% popDEs
% --------------------------------------------------------------------------------------------
popDEs() :-
    globalVars::get_i("p3des")=1,
    Ln=pop::getSM_NL("a",[]),
    guix::lbxPop(thisWin,idc_de2s,Ln),
    !
;
    Ln=pop::getSM_NL("a"),
    guix::lbxPop(thisWin,idc_de2s,Ln),
    !.
% --------------------------------------------------------------------------------------------
% markChange
% --------------------------------------------------------------------------------------------
markChange(A,New) :-
    A=1,
    set::setMax([et1,New],V),
    et1:=V,
    !
;    
    A=2,
    set::setMax([et2,New],V),
    et2:=V,
    !
;    
    A=3,
    set::setMax([pt,New],V),
    pt:=V,
    !.
% --------------------------------------------------------------------------------------------
% saveSt
% --------------------------------------------------------------------------------------------
predicates
saveStA : (integer,integer,integer,integer,integer) determ.
clauses

saveSt() :-
    pt=1, 
    guix::txtGet(thisWin,idc_pt,N),
    dbBase::kbID_F(N,K,_,_),
    dbBase::smClassDefF(K,"p",Card,_,_,_,_),
    guix::lbxGetAll(thisWin,idc_dpt,Dn),
    dbBase::kbIDs(Dn,Dk),
	cla_list(Dk,Dl),
    Lc=dbBase::getContext(),
    Lc=[Seg|_],
    Loc=dbBase::smRef(K),
    dbBase::recordDelete(Loc),
    dbBase::recordInsert(2,"$SM",0,0,cmp("q",[cmp("p",[termDomain::atom(K),termDomain::int(Card),Dl]),termDomain::str(Seg)]),atom("true"),_),
    Mess=string::concat("Updated predicate type: ",N,"!"),
	dlgIF::msgS(Mess),
    saveStA(Card,et1,idc_et1,idc_det1,1),
    dlgIF::dlgNote(0,"Sentence model updated!"),
    pt=1,
    et1=1,
    et2=1,
    cache::loadTmConditionally,
    cache::loadSmConditionally,
    !
;    
    pt=2, 
    guix::lbtGet(thisWin,idc_et2,E),
    E<>"",
    Card=2,
    guix::txtGet(thisWin,idc_pt,N),
    checkNL(N),
    N2=string::concat("p ",N),
    dbBase::makeNewIdentifier(N2,"",K),
    Lc=dbBase::getContext(),
    Lc=[Seg|_],
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(N,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
    guix::lbxGetAll(thisWin,idc_dpt,Dn),
    dbBase::kbIDs(Dn,Dk),
	cla_list(Dk,Dl),
  	dbBase::recordInsert(2,"$TRM",0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(K),termDomain::atom("p3_iPT"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
    dbBase::recordInsert(2,"$SM",0,0,cmp("q",[cmp("p",[termDomain::atom(K),termDomain::int(Card),Dl]),termDomain::str(Seg)]),atom("true"),_),
    Mess=string::concat("Predicate type: ",N," with KB-name: ",K," added to the KB!"),
	dlgIF::msgS(Mess),
    saveStA(Card,et1,idc_et1,idc_det1,1),
    saveStA(Card,et2,idc_et2,idc_det2,2),
    dlgIF::dlgNote(0,"Sentence model updated!"),
    pt=1,
    et1=1,
    et2=1,
    cache::loadTmConditionally,
    cache::loadSmConditionally,
    !
;    
    pt=2, 
    Card=1,
    guix::txtGet(thisWin,idc_pt,N),
    checkNL(N),
    N2=string::concat("p ",N),
    dbBase::makeNewIdentifier(N2,"",K),
    Lc=dbBase::getContext(),
    Lc=[Seg|_],
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(N,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
    guix::lbxGetAll(thisWin,idc_dpt,Dn),
    dbBase::kbIDs(Dn,Dk),
	cla_list(Dk,Dl),
  	dbBase::recordInsert(2,"$TRM",0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(K),termDomain::atom("p3_iPT"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
    dbBase::recordInsert(2,"$SM",0,0,cmp("q",[cmp("p",[termDomain::atom(K),termDomain::int(Card),Dl]),termDomain::str(Seg)]),atom("true"),_),
    Mess=string::concat("Predicate type: ",N," with KB-name: ",K," added to the KB!"),
	dlgIF::msgS(Mess),
    saveStA(Card,et1,idc_et1,idc_det1,1),
    saveStA(Card,et2,idc_et2,idc_det2,2),
    dlgIF::dlgNote(0,"Sentence model updated!"),
    pt=1,
    et1=1,
    cache::loadTmConditionally,
    cache::loadSmConditionally,
    !
;
    pt<1,
    Et=et1+et2,
    Et>0,
    guix::txtGet(thisWin,idc_pt,N),
    dbBase::kbID_F(N,K,_,_),
    dbBase::smClassDefF(K,"p",Card,_,_,_,_),
    saveStA(Card,et1,idc_et1,idc_det1,1),
    saveStA(Card,et2,idc_et2,idc_det2,2),
    dlgIF::dlgNote(0,"Sentence model updated!"),
    cache::loadTmConditionally,
    cache::loadSmConditionally,
    pt=1,
    et1=1,
    et2=1,
    !
;    
    !.
    
saveStA(1,_,_,_,2) :-
    !.
saveStA(_,Et,Ca,Cb,_) :-
    Et=1, 
    guix::txtGet(thisWin,Ca,N),
    dbBase::kbID_F(N,K,_,_),
    guix::lbxGetAll(thisWin,Cb,Dn),
    dbBase::kbIDs(Dn,Dk),
	cla_list(Dk,Dl),
    Lc=dbBase::getContext(),
    Lc=[Seg|_],
    Loc=dbBase::smRef(K),
    dbBase::recordDelete(Loc),
  	dbBase::recordInsert(2,"$SM",0,0,cmp("q",[cmp("e",[termDomain::atom(K),Dl]),termDomain::str(Seg)]),atom("true"),_),
    Mess=string::concat("Updated entity type: ",N,"!"),
	dlgIF::msgS(Mess),
    !
;    
    Et=2, 
    guix::txtGet(thisWin,Ca,N),
    checkNL(N),
    N2=string::concat("e ",N),
    dbBase::makeNewIdentifier(N2,"",K),
    Lc=dbBase::getContext(),
    Lc=[Seg|_],
    Lng=globalVars::get_s("lang"),
	pscan::pscNL(N,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
    guix::lbxGetAll(thisWin,Cb,Dn),
    dbBase::kbIDs(Dn,Dk),
	cla_list(Dk,Dl),
  	dbBase::recordInsert(2,"$TRM",0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(K),termDomain::atom("p3_iET"),termDomain::atom("p3_iSnu"),Toks]),termDomain::str(Seg)]),atom("true")),
  	dbBase::recordInsert(2,"$SM",0,0,cmp("q",[cmp("e",[termDomain::atom(K),Dl]),termDomain::str(Seg)]),atom("true"),_),
    Mess=string::concat("Entity type: ",N," with KB-name: ",K," added to the KB!"),
	dlgIF::msgS(Mess),
    !
;    
    Et<1,
    !.
% --------------------------------------------------------------------------------------------
% checkNL
% --------------------------------------------------------------------------------------------
checkNL(N) :-
    dbBase::kbID_F(N,Clas,_,_),
    dbBase::nlTry(Clas,ClasN),
    Mess=string::concat(N," is already used as NL-name for a(n) ",ClasN,"!"),
    dlgIF::dlgNote(0,Mess),
    !,fail
;
    !.
% --------------------------------------------------------------------------------------------
% setCounts
% --------------------------------------------------------------------------------------------
setCounts(STk) :-
	vpi::cursorSetWait(),
	dbBase::stCount(STk,N1,N2),
	guix::txtSetI(thisWin,idc_c2,N2),
	guix::txtSetI(thisWin,idc_c1,N1),
	!
;
	dlgIF::dlgNote(0,"Select sentence type from the upper listbox!"),
	!.	
% --------------------------------------------------------------------------------------------
% getSt
% --------------------------------------------------------------------------------------------
getSt(Stk) :-
	guix::lbtGetF(thisWin,idc_st,St),
	St<>"",
	dbBase::stNL_KB(St,Stk),
	!
;
    et1<2,
    et2<2,
    pt<2,
    guix::lbtGet(thisWin,idc_pt,N),
    dbBase::kbID_F(N,K,_,_),
    dbBase::smClassDefF(K,"p",Card,_,_,_,_),
    Card=2,
    guix::lbtGet(thisWin,idc_et1,E1),
    dbBase::kbID_F(E1,K1,_,_),
    guix::lbtGet(thisWin,idc_et2,E2),
    dbBase::kbID_F(E2,K2,_,_),
    Stk=string::concat(K,"|",K1,"|",K2),
    ! 
;      
    et1<2,
    pt<2,
    guix::lbtGet(thisWin,idc_pt,N),
    dbBase::kbID_F(N,K,_,_),
    dbBase::smClassDefF(K,"p",Card,_,_,_,_),
    Card=1,
    guix::lbtGet(thisWin,idc_et1,E1),
    dbBase::kbID_F(E1,K1,_,_),
    Stk=string::concat(K,"|",K1),
    !.
end implement sm
