/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement tableprint
    open core, vpiDomains, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/tableprint".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
name : string := "".
solNo : integer :=0.
tabNo : integer :=0.
            
    clauses
        show(Parent,Name,SolNo,TabNo):-
            name:=Name,
            solNo:=SolNo,
            tabNo:=TabNo,
            _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
            Name=name,
            SolNo=solNo,
            TabNo=tabNo,
            stb::stbH_Get(SolNo,TabNo,_,NRows,_,_,_,_),
            guix::txtSet(thisWin,idct_name,Name),
            guix::txtSetI(thisWin,idc_solno,SolNo),
            guix::txtSetI(thisWin,idc_tabno,TabNo),
            guix::txtSetI(thisWin,idc_from,1),
            guix::txtSetI(thisWin,idc_to,NRows),
            guix::guiRB_SetN(thisWin,[idc_tabular,idc_form],[1,2],1),
            guix::ctlDisable(thisWin,[idc_header,idc_trailer,idc_anno]),
            !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            thisWin := erroneous.

    predicates
        onControlhelp : vpiDomains::controlHandler.
    clauses
        onControlhelp(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        dlgIF::hlpWeb("w_tableprint"),
        !;!.
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
        guix::txtGet(thisWin,idct_name,Name),
        guix::txtGetI(thisWin,idc_from,From),
        guix::txtGetI(thisWin,idc_to,To),
        guix::txtGetI(thisWin,idc_solno,SolNo),
        guix::txtGetI(thisWin,idc_tabno,TabNo),
        guix::guiRB_Get(thisWin,[idc_tabular,idc_form],[1,2],N),
        guix::guiCB_Get(thisWin,idc_header,Header),
        guix::guiCB_Get(thisWin,idc_trailer,Trailer),
        guix::guiCB_Get(thisWin,idc_anno,Anno),
        fioExt::makeFileName(Name,"3rp",FileName),
        File=outFile::new(FileName),
        table::tabEditor(File,N,Name,SolNo,TabNo,From,To,Header,Trailer,Anno),
        File:close(),
        editorWindow::openFiles([FileName]),
        vpi::winDestroy(thisWin),
        !;
        vpi::winDestroy(thisWin),
        !.

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        vpi::winDestroy(thisWin),
        !.
        
    predicates
        onControltabular : vpiDomains::controlHandler.
    clauses
        onControltabular(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::ctlDisable(thisWin,[idc_header,idc_trailer,idc_anno]),
    !;!.

    predicates
        onControlform : vpiDomains::controlHandler.
    clauses
        onControlform(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    guix::ctlEnable(thisWin,[idc_header,idc_trailer,idc_anno]),
    !;!.

    % This code is maintained by the VDE do not update it manually, 17:14:55-27.12.2004
    constants
        dialogType : vpiDomains::wintype = wd_Modal.
        title : string = "Table printing".
        rectangle : vpiDomains::rct = rct(50,40,225,145).
        dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
        dialogFont = "Arial".
        dialogFontSize = 8.

    constants
        controlList : vpiDomains::windef_list =
            [
            dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                    dialogFont, dialogFontSize, dialogFlags),
            ctl(wdef(wc_PushButton,rct(4,90,80,102),"&OK",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_PushButton,rct(96,90,172,102),"&Help",u_DlgBase),idc_help,[wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(112,20,160,32),"",u_DlgBase),idc_to,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
            ctl(wdef(wc_Edit,rct(52,20,100,32),"",u_DlgBase),idc_from,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
            ctl(wdef(wc_RadioButton,rct(4,38,65,48),"Tabular format",u_DlgBase),idc_tabular,[wsf_Auto,wsf_TabStop,wsf_Group]),
            ctl(wdef(wc_RadioButton,rct(100,38,161,48),"Form format",u_DlgBase),idc_form,[wsf_Auto,wsf_TabStop]),
            ctl(wdef(wc_Edit,rct(184,26,232,38),"idc_solno",u_DlgBase),idc_solno,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible]),
            ctl(wdef(wc_Edit,rct(188,8,232,20),"idc_tabno",u_DlgBase),idc_tabno,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll]),
            ctl(wdef(wc_CheckBox,rct(112,50,160,60),"Header",u_DlgBase),idc_header,[wsf_Auto,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_CheckBox,rct(112,62,160,72),"Footer",u_DlgBase),idc_trailer,[wsf_Auto,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_CheckBox,rct(112,74,160,84),"Annotation",u_DlgBase),idc_anno,[wsf_Auto,wsf_Group,wsf_TabStop]),
            ctl(wdef(wc_Text,rct(4,20,40,30),"Line range",u_DlgBase),idct_from_line,[wsf_AlignLeft]),
            ctl(wdef(wc_Text,rct(4,2,172,12),"",u_DlgBase),idct_name,[wsf_AlignCenter])
            ].

    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlhelp(idc_help, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_tabular, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControltabular(idc_tabular, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_Control(idc_form, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlform(idc_form, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
end implement tableprint
