/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement kbname
open core, vpiDomains, resourceIdentifiers,termDomain,globalDomains
    constants
        className = "com/rudstrand/TaskWindow/terminology/kbname".
        classVersion = "1.0".
    clauses
        classInfo(className, classVersion).
    facts
        thisWin : vpiDomains::windowHandle := erroneous.
    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
	vpi::cursorSetWait(),
	guix::addWin(110,thisWin),
    guix::setStyle(thisWin,[idc_kb_name_1,idc_kb_name,idc_kb_segment,idc_save,idc_delete,idc_update,
  	                   idc_kb_class,idc_kb_form,idc_kb_type,idc_kb_nl,idc_kb_term,idc_refresh,
  	                   idct_kb_name,idct_syntactic_class,idct_realm,idc_realm,
  	                   idct_language,idct_segment,idct_nl,idct_type],[]),
	L=globalVars::get_s("lang"),
    cache::loadTmConditionally(L),
	Context=dbBase::getContext(),
	guix::lbxPop(thisWin,idc_kb_segment,Context),
	Names=pop::getKB_NameInfo(L,1,Context),
	guix::lbxPop(thisWin,idc_kb_name_1,Names),
	pop::getSyntaxClassesNL(L,Classes,Forms),
	guix::lbxPop(thisWin,idc_kb_class,Classes),
	guix::lbxPop(thisWin,idc_kb_form,Forms),
	guix::lbxPop(thisWin,idc_kb_type,["MAIN FORM","SYNONYM FORM"]),
	dbBase::nlForm(L,"p3_iNIL",LL),
	guix::txtSet(thisWin,idc_kb_term,LL),
	guix::ctlDisable(thisWin,[idc_save]),
	guix::ctlEnable(thisWin,[idc_update,idc_delete]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
	!;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            cache::loadTmConditionally,
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin),
        !.

predicates
    onControlidc_kb_name : vpiDomains::controlHandler.
clauses
    onControlidc_kb_name(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::modified(),
	guix::ctlEnable(thisWin,[idc_save]),
	guix::ctlDisable(thisWin,[idc_update,idc_delete]),
	!;!.

predicates
    onControlidc_kb_name_1 : vpiDomains::controlHandler.
clauses
    onControlidc_kb_name_1(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0) :-
    CtrlInfo=vpiDomains::selchanged(),
	guix::lbtGet(thisWin,idc_kb_name_1,S),
	sx::sxGetInBrack(S,'[',']',SLoc),
	Loc=dbBase::dbRefR(SLoc),
    dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,LT,_),
    LT=cmp(_,[cmp(Type,[_,termDomain::str(K),termDomain::atom(Clas),termDomain::atom(Form),Toks]),termDomain::str(Seg)]),
    set::setGet(["t","s"],Ix,Type),
    set::setGet(["MAIN FORM","SYNONYM FORM"],Ix,Typ),
    dbBase::nlSing(Clas,ClasNL),
    dbBase::nlSing(Form,FormNL),
    termDomain::list_conc(Toks,NL),
	guix::txtSet(thisWin,idc_realm,Realm),
	guix::txtSet(thisWin,idc_kb_name,K),
	guix::txtSet(thisWin,idc_kb_nl,NL),
	guix::lbtSel(thisWin,idc_kb_type,Typ),
	guix::lbtSel(thisWin,idc_kb_segment,Seg),
	guix::lbtSel(thisWin,idc_kb_class,ClasNL),
	guix::lbtSel(thisWin,idc_kb_form,FormNL),
	guix::txtSet(thisWin,idc_ref,SLoc),
	guix::ctlDisable(thisWin,[idc_save]),
	guix::ctlEnable(thisWin,[idc_update,idc_delete]),
	!;!.

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dbBase::chainAccess("v")=1,
	guix::txtGet(thisWin,idc_ref,SLoc),
    Loc=dbBase::dbRefR(SLoc),
	dbBase::recordDelete(Loc),
    guix::lbxRemReselect(thisWin,idc_kb_name_1),
	dlgIF::dlgNote(0,"Deleted KB name!"),
	!
;
	dbBase::chainAccess("v")=0,
	dlgIF::dlgNote(0,"No write-access to this chain!"),
	!
;
	dlgIF::dlgNote(0,"KB name delete failed!"),
	!.

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dbBase::chainAccess("v")=1,
	guix::lbtGet(thisWin,idc_kb_type,Typ),
	Typ="MAIN FORM",
	guix::txtGet(thisWin,idc_ref,SLoc),
    Loc=dbBase::dbRefR(SLoc),
	guix::txtGet(thisWin,idc_realm,Realm),
	Realm<>"",
	guix::txtGet(thisWin,idc_kb_name,Id),
	guix::txtGet(thisWin,idc_kb_nl,NL),
	guix::lbtGet(thisWin,idc_kb_class,Clas),
	guix::lbtGet(thisWin,idc_kb_form,Form),
	guix::lbtGet(thisWin,idc_kb_segment,Seg),
	dbBase::kbID(Clas,C,_,_),
	dbBase::kbID(Form,F,_,_),
	Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	dbBase::recordDelete(Loc),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom(C),termDomain::atom(F),Toks]),termDomain::str(Seg)]),atom("true"),Loc2),
	% replace list button entry
	guix::lbtGet(thisWin,idc_kb_name_1,S),
  	guix::lbxDelS(thisWin,idc_kb_name_1,S),
  	guix::txtGet(thisWin,idc_kb_term,L),
    SLoc2=dbBase::dbRef(Loc2), 
	sx::concat([Id," ",NL," ",Clas," ",Form," ",L," ",Seg," [",SLoc2,"]"],S2),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_kb_name_1),
	vpi::lboxadd(Ctl,S2),
	guix::txtSet(thisWin,idc_kb_name_1,S2),
	dlgIF::dlgNote(0,"KB name updated!"),
	!
;		
	dbBase::chainAccess("v")=1,
	guix::lbtGet(thisWin,idc_kb_type,Typ),
	Typ="SYNONYM FORM",
	guix::txtGet(thisWin,idc_ref,SLoc),
	Loc=dbBase::dbRefR(Sloc),
	guix::txtGet(thisWin,idc_realm,Realm),
	Realm<>"",
	guix::txtGet(thisWin,idc_kb_name,Id),
	guix::txtGet(thisWin,idc_kb_nl,NL),
	guix::lbtGet(thisWin,idc_kb_class,Clas),
	guix::lbtGet(thisWin,idc_kb_form,Form),
	guix::lbtGet(thisWin,idc_kb_segment,Seg),
	dbBase::kbID(Clas,C,_,_),
	dbBase::kbID(Form,F,_,_),
	Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	dbBase::recordDelete(Loc),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("s",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom(C),termDomain::atom(F),Toks]),termDomain::str(Seg)]),atom("true"),Loc2),
	% replace list button entry
	guix::lbtGet(thisWin,idc_kb_name_1,S),
  	guix::lbxDelS(thisWin,idc_kb_name_1,S),
  	guix::txtGet(thisWin,idc_kb_term,L),
  	SLoc2=dbBase::dbRef(Loc2),
	sx::concat([Id," (synonym) ",NL," ",Clas," ",Form," ",L," ",Seg," [",SLoc2,"]"],S2),
	Ctl=vpi::winGetCtlHandle(thisWin,idc_kb_name_1),
	vpi::lboxadd(Ctl,S2),
	guix::txtSet(thisWin,idc_kb_name_1,S2),
	dlgIF::dlgNote(0,"KB name updated!"),
	!
;
	dbBase::chainAccess("v")=0,
	dlgIF::dlgNote(0,"No write-access to this chain!"),
	!
;
	dlgIF::dlgNote(0,"KB name updated failed!"),
	!.
	
    predicates
        onControlsave : vpiDomains::controlHandler.
    clauses
        onControlsave(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	dbBase::chainAccess("v")=1,
	guix::lbtGet(thisWin,idc_kb_type,Typ),
	Typ="MAIN FORM",
	guix::txtGet(thisWin,idc_realm,Realm),
	Realm<>"",
	guix::txtGet(thisWin,idc_kb_name,Id),
	guix::txtGet(thisWin,idc_kb_nl,NL),
	guix::lbtGet(thisWin,idc_kb_class,Clas),
	guix::lbtGet(thisWin,idc_kb_form,Form),
	dbBase::kbID(Clas,C,_,_),
	dbBase::kbID(Form,F,_,_),
	guix::lbtGet(thisWin,idc_kb_segment,Seg),
	Lng=globalVars::get_s("lang"),
	%
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("t",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom(C),termDomain::atom(F),Toks]),termDomain::str(Seg)]),atom("true"),_),
	dlgIF::dlgNote(0,"New KB name main form recorded"),
	!
;	
	dbBase::chainAccess("v")=1,
	guix::lbtGet(thisWin,idc_kb_type,Typ),
	Typ="SYNONYM FORM",
	guix::txtGet(thisWin,idc_realm,Realm),
	Realm<>"",
	guix::txtGet(thisWin,idc_kb_name,Id),
	guix::txtGet(thisWin,idc_kb_nl,NL),
	guix::lbtGet(thisWin,idc_kb_class,Clas),
	guix::lbtGet(thisWin,idc_kb_form,Form),
	guix::lbtGet(thisWin,idc_kb_segment,Seg),
	dbBase::kbID(Clas,C,_,_),
	dbBase::kbID(Form,F,_,_),
	Lng=globalVars::get_s("lang"),
	%
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
  	dbBase::recordInsert(2,Realm,0,0,cmp("v",[cmp("s",[termDomain::atom(Lng),termDomain::str(Id),termDomain::atom(C),termDomain::atom(F),Toks]),termDomain::str(Seg)]),atom("true"),_),
	dlgIF::dlgNote(0,"New KB name synonym form recorded"),
	!
;
	dbBase::chainAccess("v")=0,
	dlgIF::dlgNote(0,"No write-access to this chain!"),
	!
;
	dlgIF::dlgNote(0,"KB name save failed!"),
	!.
	
    predicates
    onControlidc_refresh : vpiDomains::controlHandler.
clauses
    onControlidc_refresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	vpi::cursorSetWait(),
	L=globalVars::get_s("lang"),
    cache::loadTmConditionally(L),
	Context=dbBase::getContext(),
	guix::lbxPop(thisWin,idc_kb_segment,Context),
	Names=pop::getKB_NameInfo(L,1,Context),
	guix::lbxPop(thisWin,idc_kb_name_1,Names),
	pop::getSyntaxClassesNL(L,Classes,Forms),
	guix::lbxPop(thisWin,idc_kb_class,Classes),
	guix::lbxPop(thisWin,idc_kb_form,Forms),
	guix::lbxPop(thisWin,idc_kb_type,["MAIN FORM","SYNONYM FORM"]),
	dbBase::nlForm(L,"p3_iNIL",LL),
	guix::txtSet(thisWin,idc_kb_term,LL),
	guix::ctlDisable(thisWin,[idc_save]),
	guix::ctlEnable(thisWin,[idc_update,idc_delete]),
	vpi::cursorSet(thisWin,vpiDomains::cursor_Arrow),
    !;!.
    
% This code is maintained by the VDE do not update it manually, 20:48:34-14.11.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,812,359).
    menu : vpiDomains::menu = noMenu.
    title : string = "KB-names".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_Text,rct(8,72,88,90),"KB name",Win,[wsf_AlignLeft],idct_kb_name),
        _ = vpi::winCreateControl(wc_Text,rct(8,176,88,194),"Syntax class",Win,[wsf_AlignLeft],idct_syntactic_class),
        _ = vpi::winCreateControl(wc_Text,rct(8,216,88,234),"Segment",Win,[wsf_AlignLeft],idct_segment),
        _ = vpi::winCreateControl(wc_Text,rct(8,140,88,158),"NL",Win,[wsf_AlignLeft],idct_nl),
        _ = vpi::winCreateControl(wc_Edit,rct(112,72,340,96),"",Win,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft],idc_kb_name),
        _ = vpi::winCreateControl(wc_Edit,rct(112,140,702,164),"",Win,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft],idc_kb_nl),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(112,212,340,320),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_kb_segment),
        _ = vpi::winCreateControl(wc_PushButton,rct(80,248,207,272),"Save",Win,[wsf_Group,wsf_TabStop],idc_save),
        _ = vpi::winCreateControl(wc_PushButton,rct(224,248,351,272),"Update",Win,[wsf_Group,wsf_TabStop],idc_update),
        _ = vpi::winCreateControl(wc_PushButton,rct(368,248,495,272),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_Edit,rct(536,88,563,112),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible],idc_ref),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(112,176,340,388),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_kb_class),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(352,176,580,356),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_kb_form),
        _ = vpi::winCreateControl(wc_Text,rct(8,108,88,126),"Type",Win,[wsf_AlignLeft],idct_type),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(112,104,340,376),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_kb_type),
        _ = vpi::winCreateControl(wc_Edit,rct(432,212,704,236),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_realm),
        _ = vpi::winCreateControl(wc_Text,rct(344,212,424,230),"Realm",Win,[wsf_AlignLeft],idct_realm),
        _ = vpi::winCreateControl(wc_Edit,rct(480,8,708,32),"",Win,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft],idc_kb_term),
        _ = vpi::winCreateControl(wc_Text,rct(392,12,472,30),"Terminology",Win,[wsf_AlignLeft],idct_language),
        _ = vpi::winCreateControl(wc_PushButton,rct(512,248,639,272),"Refresh",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(8,40,704,520),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_kb_name_1),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsave(idc_save, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_refresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_kb_name, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_kb_name(idc_kb_name, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_kb_name_1, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_kb_name_1(idc_kb_name_1, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement kbname
