/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement language
    open core, vpiDomains, resourceIdentifiers
    constants
        className = "com/rudstrand/TaskWindow/terminology/language".
        classVersion = "1.0".
    clauses
        classInfo(className, classVersion).
    facts
        thisWin : vpiDomains::windowHandle := erroneous.
predicates
dmSetLanguage : ().
    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).
    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).
    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
   	guix::setStyle(thisWin,[idc_ok,idc_language],[]),
	guix::addWin(107,thisWin),
	dmSetLanguage,
	!.
    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            cache::loadTmConditionally,
            guix::dropWin(thisWin),
            thisWin := erroneous.
    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).
    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        cache::loadTmConditionally,
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin).
    predicates
        onControlok : vpiDomains::controlHandler.
    clauses
        onControlok(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	CCon=vpi::winGetCtlHandle(thisWin,idc_language),
	Lang=vpi::winGetText(CCon),
	dbBase::kbID(Lang,LangID,_,_),
	globalVars::set_s("lang",LangID),
		dbBase::nlForm(LangID,"p3_iNIL",NewLang),
		sx::concat(["current language is ",NewLang],Mess),
		dlgIF::msgS(Mess),
		tt::tt_s(1,"language",NewLang),
	dlgIF::dlgNote(0,"Close (and re-open if required) all data model windows!"),
	% replace the query menu
	TW=guix::getWinOfClas(1),
	Menu=vpi::menuGet(TW),
	Menu=vpiDomains::dynMenu([_|L]),
	dbExtension::kbQueryMenuTree(vpiDomains::dynMenu(L),QMenu),
	vpi::menuSet(TW,QMenu),
	vpi::cursorSet(thisWin,cursor_Arrow),
	guix::dropWin(thisWin),
	vpi::winDestroy(thisWin),
	!;!.
    % This code is maintained by the VDE do not update it manually, 16:05:42-30.1.2005
    constants
        windowType : vpiDomains::wintype = w_TopLevel.
        windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
        rectangle : vpiDomains::rct = rct(100,80,384,162).
        menu : vpiDomains::menu = noMenu.
        title : string = "Current terminology".
    predicates
        generatedEventHandler : vpiDomains::ehandler.
    clauses
        generatedEventHandler(Win, e_create(_)) = _ :-
            thisWin := Win,
            _ = vpi::winCreateControl(wc_LBoxEdit,rct(8,4,279,225),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_language),
            _ = vpi::winCreateControl(wc_PushButton,rct(67,37,231,75),"OK",Win,[wsf_Group,wsf_TabStop],idc_ok),
            fail.
        generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
            handled(Result) = onCreate(CreationData).
        generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
            handled(Result) = onSizeChanged(Width, Height).
        generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlok(idc_ok, CtrlType, CtrlWin, CtlInfo).
        generatedEventHandler(_Win, e_CloseRequest()) = Result :-
            handled(Result) = onCloseRequest().
        generatedEventHandler(_Win, e_Destroy()) = Result :-
            handled(Result) = onDestroy().
    % end of automatic code
% --------------------------------------------------------------------------------------------
% dmSetLanguage
% --------------------------------------------------------------------------------------------
predicates
dmSetLang3 : (string_list,string_list) determ (i,o).
dmSetLang4 : (vpiDomains::windowHandle,string,string_list).
clauses
dmSetLanguage() :-
	Lang=globalVars::get_s("lang"),
	Lngs=pop::getTerminologies(),
	not(Lngs=[]),
	dmSetLang3(Lngs,LngsNL),
	guix::lbxPop(thisWin,idc_language,LngsNL),
	C=vpi::winGetCtlHandle(thisWin,idc_language),
	dmSetLang4(C,Lang,LngsNL),
	!
;
	dlgIF::dlgNote(1,"No terminologies in KB"),!.	   
dmSetLang3([],[]) :- !.
dmSetLang3([L|Langs],[L_NL|LangsNL]) :-
	dbBase::nlForm(L,"p3_iNIL",L_NL),
	dmSetLang3(Langs,LangsNL),!.
dmSetLang4(C,Lang,Langs) :-
	dbBase::nlForm(Lang,"p3_iNIL",LangNL),
	set::member(LangNL,Langs),
	vpi::winSetText(C,LangNL),
	!
;
	!.	
end implement language
