/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement nlname
open core,vpiDomains,resourceIdentifiers,termDomain,globalDomains

    constants
        className = "com/rudstrand/TaskWindow/terminology/nlname".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).

    facts
        thisWin : vpiDomains::windowHandle := erroneous.

    clauses
        new(Parent):-
            _ = vpi::winCreate(windowType, rectangle, title, menu, Parent,
                               windowFlags, eventHandler, 0).

    predicates
        eventHandler : vpiDomains::ehandler.
    clauses
        eventHandler(Win, Event) = Result :-
            Result = generatedEventHandler(Win, Event),
            !.
        eventHandler(Win, e_Menu(Id, CAS)) = Result :-
            Parent = vpi::winGetParent(Win),
            Result = vpi::winSendEvent(Parent, e_Menu(Id, CAS)).

    predicates
        onCreate : vpiDomains::createHandler.
    clauses
        onCreate(_CreationData) = defaultHandling():-
	vpi::cursorSetWait(),
   	guix::setStyle(thisWin,[idc_refresh,idc_syntagm,idc_segment,idc_kbid,idc_save,idc_delete,idc_update,idc_class,idc_form,idc_type,idct_kbid,idct_segment,idct_class,
   	                                idct_form,idct_type,idct_realm,idc_realm],[]),
	guix::addWin(108,thisWin),
	Context=dbBase::getContext(),
	guix::lbxPop(thisWin,idc_segment,Context),
	Lang=globalVars::get_s("lang"),
    cache::loadTmConditionally(Lang),
	Ns=pop::getNLs(Lang,1,Context),
	guix::lbxPop(thisWin,idc_syntagm,Ns),
	pop::getSyntaxClassesNL(Lang,Classes,Forms),
	guix::lbxPop(thisWin,idc_class,Classes),
	guix::lbxPop(thisWin,idc_form,Forms),
	guix::lbxPop(thisWin,idc_type,["MAIN FORM","SYNONYM FORM"]),
	Segs=pop::getSegments(),
	guix::lbxPop(thisWin,idc_segment,Segs),
    !;!.
    
    predicates
    onControlidc_refresh : vpiDomains::controlHandler.
clauses
    onControlidc_refresh(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	Context=dbBase::getContext(),
	guix::lbxPop(thisWin,idc_segment,Context),
	Lang=globalVars::get_s("lang"),
    cache::loadTmConditionally(Lang),
	Ns=pop::getNLs(Lang,1,Context),
	guix::lbxPop(thisWin,idc_syntagm,Ns),
	pop::getSyntaxClassesNL(Lang,Classes,Forms),
	guix::lbxPop(thisWin,idc_class,Classes),
	guix::lbxPop(thisWin,idc_form,Forms),
	guix::lbxPop(thisWin,idc_type,["MAIN FORM","SYNONYM FORM"]),
	Segs=pop::getSegments(),
	guix::lbxPop(thisWin,idc_segment,Segs),
    !;!.

    predicates
        onDestroy : vpiDomains::destroyHandler.
    clauses
        onDestroy() = defaultHandling() :-
            cache::loadTmConditionally,
            guix::dropWin(thisWin),
            thisWin := erroneous.

    predicates
        onSizeChanged : vpiDomains::sizeHandler.
    clauses
        onSizeChanged(_Width, _Height) = defaultHandling():-
            vpiToolbar::resize(thisWin).

    predicates
        onCloseRequest : vpiDomains::closeRequestHandler.
    clauses
        onCloseRequest() = defaultHandling():-
        cache::loadTmConditionally,
        guix::dropWin(thisWin),
        vpi::winDestroy(thisWin).

    predicates
        onControlsyntagm : vpiDomains::controlHandler.
    clauses
        onControlsyntagm(_CtrlID, _CtrlType, _CtrlWin, CtrlInfo) = handled(0):-
    CtrlInfo=vpiDomains::modified(),
    guix::lbtGet(thisWin,idc_syntagm,NL),
    dbExtension::kbDefName("i",NL,Id),
    guix::txtSet(thisWin,idc_kbid,Id),
    Lc=dbBase::getContext(),
    Lc=[H|_],
    guix::lbtSel(thisWin,idc_segment,H),
  	guix::ctlEnable(thisWin,[idc_kbid,idc_save,idc_type]),
	guix::ctlDisable(thisWin,[idc_delete,idc_update]),
	!
;	
    CtrlInfo=vpiDomains::selchanged(),
	CSyntagm=vpi::winGetCtlHandle(thisWin,idc_syntagm),
	vpi::lboxGetSel(CSyntagm,Sel,_),
	Sel=[Syntagm],
	Loc=dbBase::kbIdLoc(Syntagm),
    dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,LT,_),
    LT=cmp(_,[cmp(Type,[_,termDomain::str(K),termDomain::atom(Clas),termDomain::atom(Form),_]),termDomain::str(Seg)]),
	set::setGet(["t","s"],Ix,Type),
	set::setGet(["MAIN FORM","SYNONYM FORM"],Ix,TypNL),
	guix::lbtSel(thisWin,idc_type,TypNL),
    SLoc=dbBase::dbRef(Loc),
	guix::txtSet(thisWin,idc_refs,SLoc),
	guix::txtSet(thisWin,idc_kbid,K),
	guix::lbtSel(thisWin,idc_segment,Seg),
	dbBase::nlForm(Clas,"p3_iNIL",ClasNL),
	guix::lbtSel(thisWin,idc_class,ClasNL),
	dbBase::nlForm(Form,"p3_iNIL",FormNL),
	guix::lbtSel(thisWin,idc_form,FormNL),
	guix::txtSet(thisWin,idc_realm,Realm),
  	guix::ctlEnable(thisWin,[idc_delete,idc_update]),
	guix::ctlDisable(thisWin,[idc_kbid,idc_save,idc_type]),
	!;!.

    predicates
        onControlsave : vpiDomains::controlHandler.
    clauses
        onControlsave(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_syntagm,NL),
	guix::lbtGet(thisWin,idc_type,Type1),
	set::setGet(["MAIN FORM","SYNONYM FORM"],Ix,Type1),
	set::setget(["t","s"],Ix,Ent),
	guix::lbtGet(thisWin,idc_class,Clas1),
	dbBase::kbID_F(Clas1,C,_,_),
	guix::lbtGet(thisWin,idc_form,Form1),
	dbBase::kbID_F(Form1,F,_,_),
	guix::txtGet(thisWin,idc_kbid,KbId),
	guix::txtGet(thisWin,idc_realm,Realm),
	guix::txtGet(thisWin,idc_segment,Seg),
	Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	Realm2=guix::defaultText(Realm,"$TRM"),
  	dbBase::recordInsert(2,Realm2,0,0,cmp("v",[cmp(Ent,[termDomain::atom(Lng),termDomain::str(KbId),termDomain::atom(C),termDomain::atom(F),Toks]),termDomain::str(Seg)]),atom("true"),_),
	CSyntagm=vpi::winGetCtlHandle(thisWin,idc_syntagm),
	vpi::lboxAdd(CSyntagm,NL),
	guix::lbtSel(thisWin,idc_syntagm,NL),
    _=vpi::winSendEvent(thisWin,vpiDomains::e_Control(idc_syntagm,vpiDomains::wc_LBox,CSyntagm,vpiDomains::selchanged())),
	dlgIF::dlgNote(0,"NL-name added to the KB!"),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

    predicates
        onControlupdate : vpiDomains::controlHandler.
    clauses
        onControlupdate(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::lbtGet(thisWin,idc_syntagm,NL),
	guix::lbtGet(thisWin,idc_type,Type1),
	set::setGet(["MAIN FORM","SYNONYM FORM"],Ix,Type1),
	set::setget(["t","s"],Ix,Ent),
	guix::lbtGet(thisWin,idc_class,Clas1),
	dbBase::kbID_F(Clas1,C,_,_),
	guix::lbtGet(thisWin,idc_form,Form1),
	dbBase::kbID_F(Form1,F,_,_),
	guix::txtGet(thisWin,idc_kbid,KbId),
	guix::txtGet(thisWin,idc_realm,Realm),
	guix::txtGet(thisWin,idc_segment,Seg),
	guix::txtGet(thisWin,idc_refs,SLoc),
	Loc=dbBase::dbRefR(SLoc),
	dbBase::recordDelete(Loc),
	Lng=globalVars::get_s("lang"),
	pscan::pscNL(NL,Toks1),
	pscan::str_tokens(Toks1,Toks2),
	cl_list(Toks2,Toks),
	Realm2=guix::defaultText(Realm,"$TRM"),
  	dbBase::recordInsert(2,Realm2,0,0,cmp("v",[cmp(Ent,[termDomain::atom(Lng),termDomain::str(KbId),termDomain::atom(C),termDomain::atom(F),Toks]),termDomain::str(Seg)]),atom("true"),Loc2),
  	SLoc2=dbBase::dbRef(Loc2),
  	guix::txtSet(thisWin,idc_refs,SLoc2),
	dlgIF::dlgNote(0,"NL-name updated!"),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

    predicates
        onControldelete : vpiDomains::controlHandler.
    clauses
        onControldelete(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
	vpi::cursorSetWait(),
	guix::txtGet(thisWin,idc_refs,SLoc),
	Loc=dbBase::dbRefR(SLoc),
	dbBase::recordDelete(Loc),
	dlgIF::dlgNote(0,"NL-name deleted!"),
    guix::lbxRemReselect(thisWin,idc_syntagm),
	vpi::cursorSet(thisWin,cursor_Arrow),
	!;!.

% This code is maintained by the VDE do not update it manually, 13:00:16-24.10.2005
constants
    windowType : vpiDomains::wintype = w_TopLevel.
    windowFlags : vpiDomains::wsflags = [wsf_TitleBar,wsf_Minimize,wsf_Close,wsf_ClipSiblings,wsf_ClipChildren].
    rectangle : vpiDomains::rct = rct(100,80,486,335).
    menu : vpiDomains::menu = noMenu.
    title : string = "NL-names".

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(9,5,377,488),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_syntagm),
        _ = vpi::winCreateControl(wc_PushButton,rct(8,224,88,248),"Save",Win,[wsf_Group,wsf_TabStop],idc_save),
        _ = vpi::winCreateControl(wc_PushButton,rct(104,224,184,248),"Update",Win,[wsf_Group,wsf_TabStop],idc_update),
        _ = vpi::winCreateControl(wc_PushButton,rct(200,224,280,248),"Delete",Win,[wsf_Group,wsf_TabStop],idc_delete),
        _ = vpi::winCreateControl(wc_Edit,rct(112,72,374,88),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Disabled],idc_kbid),
        _ = vpi::winCreateControl(wc_Text,rct(8,72,108,90),"KB name",Win,[wsf_AlignLeft],idct_kbid),
        _ = vpi::winCreateControl(wc_Text,rct(8,100,108,118),"Segment",Win,[wsf_AlignLeft],idct_segment),
        _ = vpi::winCreateControl(wc_LBoxEdit,rct(112,100,374,228),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_segment),
        _ = vpi::winCreateControl(wc_Text,rct(8,132,108,150),"Class",Win,[wsf_AlignLeft],idct_class),
        _ = vpi::winCreateControl(wc_Text,rct(8,168,108,186),"Form",Win,[wsf_AlignLeft],idct_form),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(112,132,374,420),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_class),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(112,164,374,396),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_form),
        _ = vpi::winCreateControl(wc_Edit,rct(8,268,22,292),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_Invisible,wsf_Disabled],idc_refs),
        _ = vpi::winCreateControl(wc_Text,rct(8,36,108,54),"Type",Win,[wsf_AlignLeft],idct_type),
        _ = vpi::winCreateControl(wc_LBoxButton,rct(112,36,374,116),"",Win,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort],idc_type),
        _ = vpi::winCreateControl(wc_Text,rct(8,196,108,214),"Realm",Win,[wsf_AlignLeft],idct_realm),
        _ = vpi::winCreateControl(wc_Edit,rct(112,200,374,216),"",Win,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll],idc_realm),
        _ = vpi::winCreateControl(wc_PushButton,rct(296,224,376,248),"Refresh",Win,[wsf_Group,wsf_TabStop],idc_refresh),
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Size(Width, Height)) = Result :-
        handled(Result) = onSizeChanged(Width, Height).
    generatedEventHandler(_Win, e_Control(idc_syntagm, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsyntagm(idc_syntagm, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_save, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlsave(idc_save, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_update, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlupdate(idc_update, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_delete, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControldelete(idc_delete, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_refresh, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_refresh(idc_refresh, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
    % end of automatic code
end implement nlname
