/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement associationparameter
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/tinyDialogs/associationparameter".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
    thisWin : vpiDomains::windowHandle := erroneous.

clauses
    show(Parent):-
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    inexgui::getAssociationsAll(L),
    set::size(L,N),
    N>0,
    guix::lbxPop(thisWin,idc_pars,L),
    !
;
    globalVars::pushRetPars(["0"]),
    vpi::winDestroy(thisWin),
    !.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        guix::lbtGetF(thisWin,idc_pars,Par),
        globalVars::pushRetPars([Par]),
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlCancel : vpiDomains::controlHandler.
clauses
    onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        globalVars::pushRetPars(["0"]),
        vpi::winDestroy(thisWin).

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    dlgIF::hlpNo(119),
    !;!.

% This code is maintained by the VDE do not update it manually, 15:26:47-21.2.2006
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Select Rule Drawing Association Parameter".
    rectangle : vpiDomains::rct = rct(50,40,218,94).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,40,52,52),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(60,40,108,52),"Cancel",u_DlgBase),idc_cancel,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(116,40,164,52),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_LBoxButton,rct(4,2,164,218),"",u_DlgBase),idc_pars,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement associationparameter
