/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement longList
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/tinyDialogs/longList".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
    thisWin : vpiDomains::windowHandle := erroneous.
    list : string_list := [].
    header : string := "".

clauses
    show(Parent,Title,List):-
        header:=Title,
        list:=List,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling():-
    guix::lbxPop(thisWin,idc_long,list),
    guix::txtSet(thisWin,idct_text,header),
    !.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    	guix::txtGet(thisWin,idc_long,S),
    	S<>"",
        guix::lbxGetAll(thisWin,idc_long,L),
        set::distinct([S|L],M),
    	globalVars::pushRetPars(M),        
    	globalVars::pushRetPars(["1",S]),
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlCancel : vpiDomains::controlHandler.
clauses
    onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    	globalVars::pushRetPars([""]),        
    	globalVars::pushRetPars(["0",""]),        
        vpi::winDestroy(thisWin),
        !.

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    dlgIF::hlpWeb("Documentation"),
    !.

% This code is maintained by the VDE do not update it manually, 13:53:07-28.6.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "longList".
    rectangle : vpiDomains::rct = rct(50,40,505,83).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "MS Sans Serif".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,30,124,42),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(164,30,284,42),"Cancel",u_DlgBase),idc_cancel,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(332,30,452,42),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_LBoxEdit,rct(4,14,452,110),"",u_DlgBase),idc_long,[wsf_Group,wsf_TabStop,wsf_VScroll,wsf_Sort]),
        ctl(wdef(wc_Text,rct(4,2,452,14),"",u_DlgBase),idct_text,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement longList
