/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement note
    open core, vpiDomains, resourceIdentifiers

constants
    className = "com/rudstrand/TaskWindow/tinyDialogs/note".
    classVersion = "1.0".

clauses
    classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
heading : string := "".
message : string := "".

clauses
    show(Parent,Title,Message):-
    heading:=Title,
    message:=Message,
        _ = vpi::winCreateDynDialog(Parent, controlList, eventHandler, 0).

predicates
    eventHandler : vpiDomains::ehandler.
clauses
    eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    guix::txtSet(thisWin,idc_note,message),
  	vpi::winSetText(thisWin,heading),
    !.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        globalVars::pushRetPars(["ok"]),
        vpi::winDestroy(thisWin).

predicates
    onControlidc_quit : vpiDomains::controlHandler.
clauses
    onControlidc_quit(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    globalVars::pushRetPars(["quit"]),
    vpi::winDestroy(thisWin),
    !.
    
predicates
    onControlidc_noshow : vpiDomains::controlHandler.
clauses
    onControlidc_noshow(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    globalVars::pushRetPars(["no"]),
    vpi::winDestroy(thisWin),
    !.

predicates
    onControlidc_not_any : vpiDomains::controlHandler.
clauses
    onControlidc_not_any(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0):-
    globalVars::pushRetPars(["no_any"]),
    vpi::winDestroy(thisWin),
    !.

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    dlgIF::hlpWeb("Documentation"),
    !.

% This code is maintained by the VDE do not update it manually, 11:15:44-23.9.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "Note".
    rectangle : vpiDomains::rct = rct(50,40,245,144).
    dialogFlags : vpiDomains::wsflags = [wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,58,192,74),"Noted",u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(136,90,192,102),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(4,76,132,88),"Do not show this message any more",u_DlgBase),idc_noshow,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(136,76,192,88),"Quit processing",u_DlgBase),idc_quit,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(4,90,132,102),"Do not show any messages any more",u_DlgBase),idc_not_any,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Text,rct(4,2,192,56),"",u_DlgBase),idc_note,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_quit, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_quit(idc_quit, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_noshow, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_noshow(idc_noshow, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_not_any, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_not_any(idc_not_any, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code
end implement note
