/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement questionseries
open core, vpiDomains, resourceIdentifiers

constants
className = "com/rudstrand/TaskWindow/winputfacility/questionseries".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

facts
thisWin : vpiDomains::windowHandle := erroneous.
alternatives : string_list := [].
default : string := "".
lines : integer := 0.
dom : string := "".
rule : string := "".
anno : string := "".

predicates
setAlternatives : (integer,integer) determ.
getAnswers : (integer,integer,integer,string_list,string_list) determ (i,i,i,o,o).

clauses
show(Parent,Ctls,Prompt,N,X,Y,Alts,Default,Rule,Domain,Anno):-
        alternatives:=Alts,
        default:=Default,
        lines:=N,
        dom:=Domain,
        rule:=Rule,
        anno:=Anno,
        Y2=Y+50,
        Rectangle=rct(50,40,X,Y2),
        C=dlgFont(wdef(dialogType,Rectangle,Prompt,u_DlgBase),dialogFont, dialogFontSize, dialogFlags),
        L=controlList,
        L=[_|T],
        set::conc([[C|T],Ctls],Cs),
        _ = vpi::winCreateDynDialog(Parent,Cs,eventHandler,0).

predicates
eventHandler : vpiDomains::ehandler.

clauses
eventHandler(Win, Event) = Result :-
        Result = generatedEventHandler(Win, Event).

predicates
    onCreate : vpiDomains::createHandler.
clauses
    onCreate(_CreationData) = defaultHandling() :-
    guix::txtSet(thisWin,idc_domain,dom),
    guix::txtSet(thisWin,idc_rule,rule),
	guix::txtSet(thisWin,idc_anno,anno),
    setAlternatives(lines,6002),
    !;!.

predicates
    onDestroy : vpiDomains::destroyHandler.
clauses
    onDestroy() = defaultHandling() :-
        thisWin := erroneous.

predicates
    onControlOK : vpiDomains::controlHandler.
clauses
    onControlOK(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
        getAnswers(1,lines,6002,Questions,Answers),
        globalVars::pushRetPars(Questions),
        globalVars::pushRetPars(Answers),
        globalVars::pushRetPars(["1"]),
        vpi::winDestroy(thisWin),
        !;!.

predicates
    onControlCancel : vpiDomains::controlHandler.
clauses
    onControlCancel(_Ctrl, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
    vpiCommonDialogs::ask("Please confirm","Do you really want to stop evaluation of the inexact rule network (and related query)?",["Yes","No"])=vpiCommonDialogs::resp_default,
    ir::setBreak(1),
  	globalVars::pushRetPars(["0"]),
    vpi::winDestroy(thisWin),
    !;!.

predicates
    onControlidc_help : vpiDomains::controlHandler.
clauses
    onControlidc_help(_CtrlID, _CtrlType, _CtrlWin, _CtrlInfo) = handled(0) :-
	dlgIF::hlpNo(60),
	!;!.

predicates
    onCloseRequest : vpiDomains::closeRequestHandler.
clauses
    onCloseRequest() = defaultHandling() :-
  	globalVars::pushRetPars(["0"]),
  	vpi::winDestroy(thisWin),
	!.

% This code is maintained by the VDE do not update it manually, 10:16:57-11.7.2005
constants
    dialogType : vpiDomains::wintype = wd_modal.
    title : string = "questionseries".
    rectangle : vpiDomains::rct = rct(50,40,352,108).
    dialogFlags : vpiDomains::wsflags = [wsf_Close,wsf_TitleBar].
    dialogFont = "Arial".
    dialogFontSize = 8.

constants
    controlList : vpiDomains::windef_list =
        [
        dlgFont(wdef(dialogType, rectangle, title, u_DlgBase),
                dialogFont, dialogFontSize, dialogFlags),
        ctl(wdef(wc_PushButton,rct(4,14,100,26),"&OK",u_DlgBase),idc_ok,[wsf_Border,wsf_Default,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(104,14,200,26),"Stop",u_DlgBase),idc_cancel,[wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_PushButton,rct(204,14,300,26),"&Help",u_DlgBase),idc_help,[wsf_Border,wsf_Group,wsf_TabStop]),
        ctl(wdef(wc_Edit,rct(4,28,300,66),"",u_DlgBase),idc_anno,[wsf_AlignLeft,wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_MultiLine,wsf_Disabled]),
        ctl(wdef(wc_Text,rct(4,2,60,12),"Answer domain:",u_DlgBase),idct_answer_domain,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(64,2,136,12),"",u_DlgBase),idc_domain,[wsf_AlignCenter]),
        ctl(wdef(wc_Text,rct(140,2,156,12),"Rule:",u_DlgBase),idct_rule,[wsf_AlignLeft]),
        ctl(wdef(wc_Text,rct(160,2,300,12),"",u_DlgBase),idc_rule,[wsf_AlignLeft])
        ].

predicates
    generatedEventHandler : vpiDomains::ehandler.
clauses
    generatedEventHandler(Win, e_create(_)) = _ :-
        thisWin := Win,
        fail.
    generatedEventHandler(_Win, e_Create(CreationData)) = Result :-
        handled(Result) = onCreate(CreationData).
    generatedEventHandler(_Win, e_Control(idc_ok, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlOK(idc_ok, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_cancel, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlCancel(idc_cancel, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_Control(idc_help, CtrlType, CtrlWin, CtlInfo)) = Result :-
            handled(Result) = onControlidc_help(idc_help, CtrlType, CtrlWin, CtlInfo).
    generatedEventHandler(_Win, e_CloseRequest()) = Result :-
        handled(Result) = onCloseRequest().
    generatedEventHandler(_Win, e_Destroy()) = Result :-
        handled(Result) = onDestroy().
% end of automatic code

setAlternatives(0,_) :-
    !.
setAlternatives(Line,No) :-
    alternatives=[],
    guix::txtSet(thisWin,No,default),
    Next=Line-1,
    NextNo=No+2,
    setAlternatives(Next,NextNo),
    !
;    
    guix::lbxPop(thisWin,No,alternatives),
    guix::lbtSel(thisWin,No,default),
    Next=Line-1,
    NextNo=No+2,
    setAlternatives(Next,NextNo),
    !.

getAnswers(N,Max,_,[],[]) :-
    N>Max,
    !.
getAnswers(N,Max,No,[Q|Qs],[A|As]) :-
    alternatives=[],
    M=No-1,
    guix::txtGet(thisWin,M,Q),
    guix::txtGet(thisWin,No,A),
    Next=N+1,
    NextNo=No+2,
    getAnswers(Next,Max,NextNo,Qs,As),
    !
;    
    M=No-1,
    guix::txtGet(thisWin,M,Q),
    guix::lbtGet(thisWin,No,A),
    Next=N+1,
    NextNo=No+2,
    getAnswers(Next,Max,NextNo,Qs,As),
    !.
end implement questionseries
