/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class dbExtension
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.

multiDb : () determ.
realmPrefix : (string Chain,string Realm) -> string PrefixedRealm.  
realmRemovePrefix : (string PrefixedRealm,string Realm,string Id) determ (i,o,o). % PrefixedRealm is with or without prefix
%
% retrieval of knowledge elements
%
functionBodies : (string Func,string_list BodiesNL) determ (i,o). % returns the bodies of a function (in NL)
functionStatements : (string NL_PR,string Func,string_list_list BodyStatements) determ (i,i,o).
kbQuery : (vpiDomains::menuTag,string,string,string,dbLoc) determ (i,o,o,o,o).
kbQueryF : (vpiDomains::menuTag,string,string,string,dbLoc) determ (i,o,o,o,o).
kbQueryMenuLoc : (vpiDomains::menuTag) -> dbLoc determ.
kbQueryMenuLocF : (vpiDomains::menuTag) -> dbLoc determ.
kbQueryMenuTree : (vpiDomains::menu,vpiDomains::menu) determ (i,o).
kbQueryMenuTreeF : (vpiDomains::menu,vpiDomains::menu) determ (i,o).
kbQueryPar : (string,string,string,string_list,dbLoc) determ (i,o,o,o,o).
kbQueryParF : (string,string,string,string_list,dbLoc) determ (i,o,o,o,o).
syntagmSets : (string Token,sterml TailTokens,sterml Sets) determ (i,i,o).
tableLayoutLoc : (string ST) -> dbLoc determ.
tableLayoutLocF : (string ST) -> dbLoc determ.
kbGetAnnotationNL_Blank : (string,string,string) procedure (i,i,o).
kbGetAnnotationBlank : (string,string,string) procedure (i,i,o).
kbGetAnnoF : (string,string,string) determ (i,i,o).
kbGetAnnoNL : (string,string,string) determ (i,i,o).
kbGetAnnoNL_F : (string,string,string) determ (i,i,o).
kbGetAnnotationF : (string,string,string,dbLoc) determ (i,i,o,o).
kbGetAnnotation : (string,string,string,dbLoc) determ (i,i,o,o).
%
% IR-related
%
% returns type (chain) and domain for a CR
dbuCR_GetTD : (string,string,string) determ (i,o,o).
dbuCR_Get : (string,sterm,sterml,integer) determ (i,o,o,o).
dbuCR_GetF : (string,sterm,sterml,integer) determ (i,o,o,o).
% returns chain characteristics
dbuChainType : (string,integer,integer,string) determ (i,o,o,o).
% returns the switch criterion domain
dbuCR_SwitchValDom : (string,string) determ (i,o).
getQuestion : (string QuestionRule,string Question,string QuestionDomain,sterm Default) determ (i,o,o,o).
%
% SR-related
%
% returns the integer rule type 
dbuSR_Type : (dbLoc,integer) procedure (i,o).
% converts between 'Realm/SentNo/SubNo' and components
dbuSentenceR : (string,integer,integer,string) determ (o,o,o,i).
%
%
%
updateDependencies : (integer,integer,sterm,sterm,string,integer) determ (i,i,i,i,i,o).
dbaDuplicate : (sterm) determ  ( i).
% returns record type text
dbuRT_Text : (integer,integer,string) determ (i,i,o).
% validates that all require meta/admin chains are in the KB
dbuCheckSTD : (integer) determ.
% atom(DE),... ---> fstr(DE,...
dbuDE_Defs : (sterml,sterml) determ (i,o).
% deletes all ir reasoning sentences
dbuDeleteReason : (integer N) determ (o).
% deletes an ST's reasoning sentences (if any)
dbuDeleteST_Reason : (string ST,integer N) determ (i,o).

kbDefName : (string Prefix,string NL,string KBname) procedure (i,i,o). % returns a proposed KB name for a given NL name and lower case prefix
kbPrintSent : (integer,integer,integer,dbLoc,string,string) determ (i,i,i,i,i,o).
kbScanTerm : (string,string,sterm) determ (i,i,o).
kbSG_Count : (string,integer,integer) determ (i,o,o).
kbST_RuleCount : (string ST,integer N) procedure (i,o).

dbaDeleteRule : (string,integer) determ (i,i).
dbaDeleteSubRule : (string,integer,integer) determ (i,i,i).
dbaCheckRuleReplace : (string,integer) determ (i,i).
dbaCheckSubRuleReplace : (string,integer,integer) determ (i,i,i).
end class dbExtension