/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

/* 3kb dependent */

class dbaBase
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.
dbaDeleteDerivedRules : (integer Mode) determ.
dbaDeleteDerivedFacts : (integer). % graphs and indexes are up-to-date when completed
/* predicates relating to database tables */
database : (chainDB KB,string KBfile,string KBid,integer No) nondeterm (o,o,o,o) (i,o,o,o) (o,i,o,o) (o,o,i,o) (o,o,o,i) (i,o,o,i) (i,i,i,i).	
addDatabase :  (chainDB KB,string KBfile,string KBid) determ.
addDatabaseAux :  (chainDB KB,string KBfile) determ.
getDatabases : (chainDB_list KBs,string_list Files,string_list Ids,integer_list Nos) determ (o,o,o,o).
dropDatabase : (chainDB).
extChain : (string ExternalChain,chainDB KB,integer Access) nondeterm (o,o,o) (i,i,i) (i,o,o) (o,i,o) (o,o,i) (i,o,i) (o,i,i).
addExtChain : (string ExternalChain,chainDB KB,integer Access).
getExtChains : (string_list ReadChains,string_list WriteChains) procedure (o,o).
getDB_ExtChains : (chainDB,string_list ReadChains,string_list WriteChains) procedure (i,o,o).
dropExtChain : (string).
pubChain : (string PublicChain,integer Access) nondeterm (i,i) (i,o) (o,i) (o,o).
addPubChain : (string PublicChain,integer Access).
multiDb : () determ.
% operations on class fact: btrsel:
getIx : (char Clas,string Name) -> chainDB::bt_selector determ.	
dbaUpdatedCh : (string).
dbaInsertRecord : (integer,string,integer,integer,sterm,sterm,chainDB::ref) determ  ( i,i,i,i,i,i,o).
dbaInsertTerm : (integer,string,integer,integer,sterm,chainDB::ref) determ (i,i,i,i,i,o).
dbaIxAll : (chainDB,integer,integer,string,integer,integer,sterm,chainDB::ref) determ  ( i,i,i,i,i,i,i,i).
dbaIxIns : (string,string,string,chainDB::ref) determ.
dbuRuleKey : (string,chainDB::ref,string) determ (i,i,o). % returns the RULE-index key for a given chain and ref
dbaDeleteRecord : (chainDB,chainDB::ref) determ.
dbaSuspendRecord : (chainDB,chainDB::ref) determ.
changedChain : (string Chain) nondeterm (o) (i).
dropTables : () procedure.
sameDB : (string,string) determ.
% converts between a db reference and a db address (format: ~X..X left-padded with blanks to width 12), accepts without width 12 and without leading ~ in the
% (o,i) mode 
dba_address : (chainDB::ref,string) procedure (i,o) determ (o,i).
dbaChains : (chainDB DB,string Chain) nondeterm (o,o).
dbaChainType : (string Chain,string Id,integer Type,integer Access) determ (i,o,o,o).
dbaMap : (string Chain,chainDB DB,integer Access) determ (i,o,o).
dbaMap : (string Chain,chainDB DB,integer Access,integer No) determ (i,o,o,o).
dbaMapST : (string ST,chainDB DB,integer Acccess) determ (i,o,o).
dbaMapTerm : (sterm Term,chainDB DB,integer Access) determ (i,o,o).
dbaRealmNoGet : (string,integer,dbLoc_list) determ (i,i,o).
dbaRealmSubNoGet : (string,integer,integer,dbLoc_list) determ (i,i,i,o).
dbaIndexesOps : (chainDB,char,integer) determ.
kbaAddress : (chainDB,chainDB::ref,string) determ (i,i,o).
kbaAddressR : (chainDB,chainDB::ref,string) determ (o,o,i).
dbaDeleteSG : (integer RecType,string SG,integer N) determ (i,i,o).  % graphs and indexes are up-to-date when completed
dbaDeleteST : (integer RecType,string ST,integer N) determ (i,i,o). % graphs and indexes are up-to-date when completed
dbaSuspendChain : (string).
chainExists : (string) determ.
dbaRealmExists : (string Realm,string_list KB_Files) procedure (i,o).
end class dbaBase