/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement dbaLib
open core,globalDomains

constants
className = "com/rudstrand/dbaLib/dbaLib".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

clauses
% -------------------- --------------------------------------------------------------------------
% chainTerms/All
% -----------------------------------------------------------------------------------------------
chainTerms(Chain,LT,RT) :- chainTerms(Chain,LT,RT,_).

chainTerms(Chain,LT,RT,Loc) :-
    dbaBase::dbaMap(Chain,DB,_),
	DB:chain_terms(Chain,Term,Ref),
        Term=clause(Type,_,_,_,_,LT,RT),
        AType=math::abs(Type),
        AType<10,
        Loc=cloc(DB,Ref).

chainTermsAll(Chain,LT,RT) :- chainTermsAll(Chain,LT,RT,_).

chainTermsAll(Chain,LT,RT,Loc) :- chainTermsAll(Chain,LT,RT,Loc,_).

chainTermsAll(Chain,LT,RT,Loc,Type) :-
    dbaBase::dbaMap(Chain,DB,_),
	DB:chain_terms(Chain,Term,Ref),
        Term=clause(Type,_,_,_,_,LT,RT),
        Loc=cloc(DB,Ref).
% -------------------- --------------------------------------------------------------------------
% realmRename
% -----------------------------------------------------------------------------------------------
class predicates
realmRenameX : (string,string,count).
clauses

realmRename(From,To,No) :-
    C=count::new(),
    realmRenameX(From,To,C),
    No=C:get(),
    dep::realmRename(From,To),
    !.
    
realmRenameX(From,To,C) :-
    dbaBase::database(DB,_,_,0),
	DB:db_chains(Chain),
        DB:chain_terms(Chain,Rec,Ref),
            Rec=clause(Z,_,SentNo,SubNo,From,LTerm,RTerm),
            datetime::tsNow(Ts),
            NewRec=clause(Z,Ts,SentNo,SubNo,To,LTerm,RTerm),
            ixsDelete(DB,Ref,Rec),
            DB:term_replace(Ref,NewRec),
            ixsInsert(DB,Ref,NewRec),
            C:inc,
            fail
;
    !.
% -------------------- --------------------------------------------------------------------------
% ixsInsert/Delete
% -----------------------------------------------------------------------------------------------
ixsInsert(DB,Ref,Rec) :-
    Rec=clause(Z,_,SentNo,SubNo,To,LTerm,_),
    dbaBase::dbaIxAll(DB,1,Z,To,SentNo,SubNo,LTerm,Ref),
    !.    
ixsDelete(DB,Ref,Rec) :-
    Rec=clause(Z,_,SentNo,SubNo,To,LTerm,_),
    dbaBase::dbaIxAll(DB,0,Z,To,SentNo,SubNo,LTerm,Ref),
    !.    
% -------------------- --------------------------------------------------------------------------
% stBasetypes
% -----------------------------------------------------------------------------------------------
class predicates
stBasetypesX : (lst,integer).
clauses

stBasetypes(BT)=L :-
    List=lst::new(1),
    stBasetypesX(List,BT),
    L=List:get(),
    !.
    
stBasetypesX(List,BT) :-    
    dbaBase::dbaChains(_,Chain),
        chainTermsAll(Chain,LT,_,_,Type),
            dbBase::recordType(Type,B,_,S),
            BT=B,
            S=-1,
            dbBase::kbTermSTp(LT,ST),
            List:add(ST),
            fail
;
    !.
% -------------------- --------------------------------------------------------------------------
% stList
% -----------------------------------------------------------------------------------------------
class predicates
stListX : (lst).
clauses

stList()=L :-
    List=lst::new(1),
    stListX(List),
    L=List:get(),
    !.
    
stListX(List) :-    
    dbaBase::dbaChains(_,Chain),
        chainTermsAll(Chain,LT,_,_,Type),
            dbBase::recordType(Type,B,_,S),
            S=-1,
            set::member(B,[1,2,3,5]),
            dbBase::kbTermSTp(LT,ST),
            List:add(ST),
            fail
;
    !.
end implement dbaLib
