/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class dep
open core,termDomain

predicates
classInfo : core::classInfo.
% integrity checking
setIntegrityCheck : (integer OnOff).
getIntegrityCheck : () -> integer OnOff.
smGraphCheckDelete : (integer,sterm,sterm) determ. % checks and reports deletion/suspension of dependent SM knowledge
% SM-graph update
setSmGraphUpdate : (integer OnOff).
smGraphUpdate : (integer,integer,sterm) determ (i,i,i). % updates SM graph upon record insert/delete
%
copy : (string,dirgraph) determ (i,o).
restore : (string,dirgraph) determ.
add : (string,sterm,sterm,sterm,sterm,sterm) determ.
changeType : (string,integer,integer) determ.
deleteAll : (string) determ.
deleteNode : (string,sterm) determ.
deleteWhereDep : (string,sterm) determ.
endNodes : (string,sterml) determ (i,o).
get_nd : (string,sterm,sterm,sterm,sterm) nondeterm (i,o,o,o,o).
get_nd : (string,sterm,sterm,sterm,sterm,sterm) nondeterm (i,o,o,o,o,o).
get_nd : (string,sterm,sterm,sterm,sterm,sterm) nondeterm (i,o,o,o,o,i).
graphsAreChanged : () determ.
hasNode : (string Graph,integer Type,string Name) determ.
hasET : (string ET) determ.
hasSTofSG : (string SG) determ.
isDependent : (string Graph,integer Type,string Name) determ.
isDeterminant : (string Graph,integer Type,string Name) determ.
loadGraphs : () determ.
realmRename : (string From,string To).
regenDependencyGraph : () determ.
saveGraphs : ().
subMergeTypes : (string,integer_list) determ.
serial : (string) -> termSet determ.
chainGraphIsChanged : (string) determ.
chainGraphSetChanged : (string) determ.

/* status */

initGraphs : ().
setStatus : (string,sterm,sterm) determ. % sets Status From-To for the entire graph
setStatusWhereDependent : (string,integer,sterm) determ.
setStatusWhereDeterminant : (string,integer,sterm) determ.
setStatusOpenSTs : (integer,string).
setDerived : (string,sterm,sterm) determ.
setUnderived : (string,sterm,sterm) determ.
cascadeStatusBack : (string,integer) determ.
cascadeStatusForward : (string,integer) determ.
deleteWhereStatus : (string,integer) determ.
deleteST_StartNodes : (). % DR only

depSetRuleStatusAll : (integer) determ (i).
derivationStatus : (integer) procedure (o).
updateDP_Graph : (integer,integer,sterm,sterm,string,integer) determ (i,i,i,i,i,o).
getSTs : (string Graph,string SGorBlank ,string_list STs) procedure (i,i,o). 
depIsDependent : (string,sterm,sterm) determ (i,i,i).
nodTypes : (string_list KBnames,string_list NLnames) determ (o,o).
depSMM_DelDerived : ().
smGraphInsert : (integer,string) determ (i,i).
depSMM_Regen : () determ.
depSMM_ResetST : (string).
nodIF_No : (string KBname,integer No) determ (i,o) (o,i).
nodIF_NoNL : (string NLname,integer No) determ (o,i).

insertDependencyCheckDet : (string,sterm,sterm,integer) determ.
insertDependency : (string,sterm,sterm,integer,integer) determ (i,i,i,i,o).
deleteDependency : (string,sterm,sterm) determ.

massSentenceUpdateStart : () determ.
massSentenceUpdateEnd : () determ.
massSentenceUpdateStarted : () determ.
massSentenceUpdateAbort : ().
sentenceChanged : (integer ChangeType,string ST).	

/* integrity checking */

chkGetAllDeps : (sterm,sterml,string_list) procedure (i,o,o).
chkGetAllDirectDeps : (sterm,sterml,string_list) procedure (i,o,o).

/* drawing */

drawDeps : (string,string,string,integer,integer,integer,integer,integer,integer,sterm,string) determ.
end class dep