/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement der
open core,termDomain,resourceIdentifiers,globalDomains

constants
className = "com/rudstrand/der/der".
classVersion = "1.0".

class predicates
storeDerivationStart : (string) determ.
storeDerivationEnd : (string,integer,integer).

depActivateRules : (integer,string).
depActivateRules : (rep,integer,integer,string).
depAssertDerivations : (string,sterm,integer,integer) determ (i,i,i,o).
depChangeRuleStat : (string,integer).
depDeriveFacts : (string,integer) determ (i,o).
depDR_Gen : (string_list,sterml,string,integer,integer,sterm,sterm) determ.
changeSG_Rules : ().
depGenQuery : (string,string) determ (i,o).
depGenReady : (string) determ.
depGetSourceSTs : (string,string_list) determ (i,o).	
depSetCount : (string_list,string,integer,string,string_list) determ (i,i,i,i,o).
derGetRow : (integer,string_list,string) determ (i,i,o).
depListOptimize : (string_list,string_list) determ (i,o).
isDependent : (string,string) determ.
publish : (string).
subscribe : ().

clauses
classInfo(className, classVersion).
% ----------------------------------------------------------------------------------------------
% depDeriveEnd
% ----------------------------------------------------------------------------------------------
depDeriveEnd(Rep,T1,NTypes,NSents) :-
	   	datetime::tsNow(T2),
	   	datetime::tsDiff(T1,T2,DD,HH,MM,SS),
	   	SNTypes=toString(NTypes),
	   	Sb=toString(NSents),
	   	sx::sxL_Pad(Sb," ",7,Sb2),
	   	datetime::timDurText(DD,HH,MM,SS,Sd),
		Rep:repWL(0,""),
		Rep:repWL(0,"   ",Sb2," ",Sd," involving ",SNTypes, " sentence types."),
	W=guix::getWinOfClas(1),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!.
% ----------------------------------------------------------------------------------------------
% depDeleteSTs                                                        
% ----------------------------------------------------------------------------------------------
class predicates
depDeleteST : (string) determ.
depDeleteST : (rep,string) determ.
clauses

depDeleteSTs([]) :-
	!.
depDeleteSTs([H|T]) :-
	globalVars::get_i("quit_flag")=1,
	!
;
	depDeleteST(H),
	depDeleteSTs(T),
	!.

depDeleteSTs(_,[]) :-
	!.
depDeleteSTs(Rep,[H|T]) :-
	globalVars::get_i("quit_flag")=1,
	!
;
	depDeleteST(Rep,H),
	depDeleteSTs(Rep,T),
	!.

depDeleteSTs(_,_,[]) :-
	!.
depDeleteSTs(Rep,W,[H|T]) :-
	globalVars::get_i("quit_flag")=1,
	!
;
	sx::substring(H,5,1,S),
	S="*",
	depDeleteSTs(Rep,W,T),
	!
;
	depReachedStop(-1,W,H),
	!
;
	depDeleteST(Rep,H),
	depDeleteSTs(Rep,W,T),
	!.

depDeleteST(ST) :-
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
	dbBase::stTypeDelete(1,STk,_),
	dbExtension::dbuDeleteST_Reason(STk,_),
	!.	

depDeleteST(Rep,ST) :-
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
	dbBase::stComps(STk,_,P,_,_),
	dbBase::chainAccess(P)=0,
	!
;
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
	% deleting
			datetime::tsNow(Ts2),
			dbBase::stKB_NL(STk,STn),
			sx::concat(["Deleting: ",STn],Mess2),
			dlgIF::msgS(Mess2),
	dbBase::stTypeDelete(1,STk,N),
	dbExtension::dbuDeleteST_Reason(STk,M),
	Ms=toString(M),
			datetime::tsNow(Te2),
	   		datetime::tsDiff(Ts2,Te2,DD,HH,MM,SS),
	   		datetime::timDurText(DD,HH,MM,SS,DiffS2),
	   		Ns=toString(N),
			sx::sxL_Pad(Ns," ",7,Ns2),
			Rep:repWL(0,"   ",Ns2," ",DiffS2," ",STn),
			Rep:repWL(0,"                    (",Ms," certainty rule reasoning sentences)"),
	!.	
% ----------------------------------------------------------------------------------------------
% publish                              
% ----------------------------------------------------------------------------------------------
publish(ST) :-
    sqlBase::hasConnection,
    sqlSt::publishSt(ST),
    !
;
    !.
% ----------------------------------------------------------------------------------------------
% depDeriveSTs                                                
% ----------------------------------------------------------------------------------------------
class predicates
depReachedStop : (integer,vpiDomains::windowHandle,string) determ (i,i,i).
depReachedStop2 : (string_list,string) determ (i,i).
depSetStatusST : (string,string_list,string,string_list,string) determ (i,i,i,o,o).
depDeriveST : (string) determ.
depDeriveST : (rep,string,integer) determ (i,i,o).
depDeriveST : (rep,vpiDomains::windowHandle,string,integer) determ (i,i,i,o).
depSetAsError : (vpiDomains::windowHandle,string) failure.
clauses

% interactive variety
%
depDeriveSTs(_,W,[],0,0) :-
    dep::cascadeStatusBack("p3_pDR",1),
    dep::depSMM_Regen,
	guix::ctlDisable(W,[idc_start,idc_stop_point,idc_rederive_all,idc_continue,idc_terminate,
	              idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences]),
	!.
depDeriveSTs(Rep,W,[H|T],SumST,SumSol) :-
	globalVars::get_i("quit_flag")=1,
	depSetAsError(W,H),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	dlgIF::msgStatus("Derivation stopped because of an error - you can now either resume or terminate the derivation."),
	guix::ctlEnable(W,[idc_terminate,idc_continue,idc_stop_point]),
	guix::ctlDisable(W,[idc_start,idc_rederive_all,
	              idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences]),
    SumSol=0,
    SumST=0,
	!
;
	sx::substring(H,5,1,S),
	S="*",
	depDeriveSTs(Rep,W,T,SumST,SumSol),
	!
;
	depReachedStop(1,W,H),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	dlgIF::msgStatus("Derivation stopped as scheduled - you can now either resume or terminate the derivation."),
	guix::ctlEnable(W,[idc_terminate,idc_continue,idc_stop_point]),
	guix::ctlDisable(W,[idc_start,idc_rederive_all,
	              idc_regenerate_dependency_graph,idc_regenerate_indexes,idc_delete_all_derived_sentences]),
    SumSol=0,
    SumST=0,
	!
;
	depDeriveST(Rep,W,H,NSol),
	sx::frontstr(5,H,_,STk),
	dep::setStatusWhereDependent("p3_pDP",1,cmp("n",[int(2),str(STk)])),
	% to avoid underived dependencies in the graph, it is also necessary to set status for possible SG nodes and nodes with open entity arguments
	sx::sxUnpack(STk,'|',L),
	L=[SG|_],
	dep::setStatusWhereDependent("p3_pDP",1,cmp("n",[int(1),str(SG)])),
	dep::setStatusOpenSTs(1,SG),
	depDeriveSTs(Rep,W,T,Sum1,Sum2),
	SumSol=Sum2+NSol,
	set::setMin([NSol,1],Min),
	SumST=Sum1+Min,
	!.

% optimized batch-type variety for server mode
% 
depDeriveSTs([]) :-
	!.
depDeriveSTs([H|T]) :-
	globalVars::get_i("quit_flag")=1,
	!
;
	depDeriveST(H),
	depDeriveSTs(T),
	!.

% batch-type variety
%
depDeriveSTs(_,[],0,0) :-
    dep::cascadeStatusBack("p3_pDR",1),
    dep::depSMM_Regen, %@@ optimization: not always needed
	!.
depDeriveSTs(Rep,[H|T],SumST,SumSol) :-
	globalVars::get_i("quit_flag")=1,
    SumSol=0,
    SumST=0,
	!
;
	sx::substring(H,5,1,S),
	S="*",
	depDeriveSTs(Rep,T,SumST,SumSol),
	!
;
	depDeriveST(Rep,H,NSol),
	sx::frontstr(5,H,_,STk),
    dep::setStatusWhereDependent("p3_pDP",1,cmp("n",[int(2),str(STk)])),
	% to avoid underived dependencies in the graph, it is also necessary to set status for possible SG nodes and nodes with open entity arguments
	sx::sxUnpack(STk,'|',L),
	L=[SG|_],
	dep::setStatusWhereDependent("p3_pDP",1,cmp("n",[int(1),str(SG)])),
	dep::setStatusOpenSTs(1,SG),
	depDeriveSTs(Rep,T,Sum1,Sum2),
	SumSol=Sum2+NSol,
	set::setMin([NSol,1],Min),
	SumST=Sum1+Min,
	!.

% interactive variety
%
depDeriveST(Rep,W,ST,NSol) :-
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
	dbBase::stComps(STk,_,P,_,_),
	dbBase::chainAccess(P)=0,
			dbBase::stKB_NL(ST,STn),
			sx::concat(["ST '",STn,"' NOT derived (no write access to chain)."],Mess),
			dlgIF::msgS(Mess),
    NSol=0,             
	!
;
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
			datetime::tsNow(Ts),
			dbBase::stKB_NL(STk,STn),
			sx::concat(["Deriving: ",STn],Mess),
			dlgIF::msgS(Mess),
			dlgIF::msgStatus(Mess),
			storeDerivationStart(STk),
			globalVars::get_i("solref")=N2,
			N3=N2+1,
			Sn=toString(N3),
			sx::concat([STn," (",Sn,")"],Sm),
			globalVars::set_s("ms1",Sm),
			globalVars::set_s("ms2",""),
	depActivateRules(Rep,1,1,STk),
	% generate all un-generated determinant sentence types (if any)
	depDeriveFacts(STk,NSol),
	% de-activate rules
	depActivateRules(Rep,1,-1,STk),
    publish(STn),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		Secs=DD*86400+HH*3600+MM*60+SS,
			storeDerivationEnd(STk,NSol,Secs),
			% msg to window
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
			guix::lbxGetAll(W,idc_sts,STs),
			sx::frontstr(4,ST,SNo,_),
			depSetCount(STs,SNo,NSol,DiffS,STsm),
			guix::lbxPop(W,idc_sts,STsm),
			Ctl2=vpi::winGetCtlHandle(W,idc_sts),
			vpi::winUpdate(Ctl2),
			% msg to report
	   		NSolS=toString(NSol),
			sx::sxL_Pad(NSolS," ",7,NSolS2),
			Rep:repWL(0,"   ",NSolS2," ",DiffS," ",STn),
            sdb::sdbSetStatus,	
	!.	

% batch variety
%
depDeriveST(Rep,ST,NSol) :-
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
	dbBase::stComps(STk,_,P,_,_),
	dbBase::chainAccess(P)=0,
			dbBase::stKB_NL(ST,STn),
			sx::concat(["ST '",STn,"' NOT derived (no write access to chain)."],Mess),
			dlgIF::msgS(Mess),
    NSol=0,             
	!
;
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
			datetime::tsNow(Ts),
			dbBase::stKB_NL(STk,STn), %@@ option to skip for better perf
			sx::concat(["Deriving: ",STn],Mess),
			dlgIF::msgS(Mess),
			dlgIF::msgStatus(Mess),
			storeDerivationStart(STk), %@@ option to skip for better perf
			globalVars::get_i("solref")=N2,
			N3=N2+1,
			Sn=toString(N3),
			sx::concat([STn," (",Sn,")"],Sm),
			globalVars::set_s("ms1",Sm),
			globalVars::set_s("ms2",""),
	depActivateRules(Rep,1,1,STk),
	% generate all un-generated determinant sentence types (if any)
	depDeriveFacts(STk,NSol),
	% de-activate rules
	depActivateRules(Rep,1,-1,STk),
    publish(STn),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		Secs=DD*86400+HH*3600+MM*60+SS,
			storeDerivationEnd(STk,NSol,Secs),
			% msg to window
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
			% msg to report
	   		NSolS=toString(NSol),
			sx::sxL_Pad(NSolS," ",7,NSolS2),
			Rep:repWL(0,"   ",NSolS2," ",DiffS," ",STn),
            sdb::sdbSetStatus,	
	!.	

% optimized batch variety for servermode
%
depDeriveST(ST) :-
	sx::frontstr(5,ST,_,STk2),
	sx::sxUnpackS(STk2," [",Ls),
	Ls=[STk|_],
	depActivateRules(1,STk),
	depDeriveFacts(STk,_),
	depActivateRules(-1,STk),
    dbBase::stKB_NL(STk,STn),
    publish(STn),
	!.	

% succeeds if given STn is marked as STOP
% parameters:
% 1	in	-1 while deleting; 1 while deriving
% 
depReachedStop(Deriving,W,ST) :-
	guix::lbxGetAll(W,idc_sts,L),
	sx::frontstr(4,ST,SNo,_),
	depReachedStop2(L,SNo),
	!
;
	Deriving=1,
	guix::lbxGetAll(W,idc_sts,L),
	sx::frontstr(4,ST,SNo,_),
	depSetStatusST("DERIVING",L,SNo,Lm,Active),
	guix::lbxPop(W,idc_sts,Lm),
	guix::lbxSel(W,idc_sts,Active),
	Ctl=vpi::winGetCtlHandle(W,idc_sts),
	vpi::winUpdate(Ctl),
	!,fail.
	
depReachedStop2([H|T],SNo) :-
	sx::frontstr(4,H,LNo,_),
	SNo=LNo,
	sx::substring(H,7,4,S),
	S="STOP",
	!
;
	depReachedStop2(T,SNo),
	!.
depSetStatusST(_,[],SNo,[],"") :-
	sx::concat(["Could not find ST no ",SNo," in derivation list (depDeriveSet)"],Mess),
	dlgIF::msgS(Mess),
	!.
depSetStatusST(Status,[H|T],SNo,[S|T],S) :-
	sx::frontstr(4,H,LNo,_),
	SNo=LNo,
	sx::frontstr(33,H,_,ST),
	sx::frontstr(6,H,S2,_),
	sx::sxR_Pad(Status," ",27,PStatus),
	sx::concat([S2,PStatus,ST],S),
	!.
depSetStatusST(Status,[H|T],SNo,[H|Tm],Active) :-
	depSetStatusST(Status,T,SNo,Tm,Active),
	!.
depSetAsError(W,ST) :-
	guix::lbxGetAll(W,idc_sts,L),
	sx::frontstr(4,ST,SNo,_),
	No=sx::toInt(SNo),
	M=No-1,
	Ms=toString(M),
	sx::sxL_Pad(Ms,"0",4,MNo),
	depSetStatusST("ERROR",L,MNo,Lm,Active),
	guix::lbxPop(W,idc_sts,Lm),
	guix::lbxSel(W,idc_sts,Active),
	Ctl=vpi::winGetCtlHandle(W,idc_sts),
	vpi::winUpdate(Ctl),
	!,fail.
% ----------------------------------------------------------------------------------------------
% depActivateRules     
% ----------------------------------------------------------------------------------------------
% activates/deactivates the given node's determinant rules
% parameter:
% 1	in	mode: 1=fact derivation; 0=derivation strategy report
% 2	in	1=activation; -1=deactivation
% 3	in	node
% always succeeds
%
depActivateRules(SetStatus,Node) :-
	dep::get_nd("p3_pDR",A1,A2,_,B2),
        A1=int(3),
        A2=str(Rule),
        B2=str(Node),
        depChangeRuleStat(Rule,SetStatus),
        fail
;
	!.	
	
depActivateRules(Rep,Mode,SetStatus,Node) :-
	Mode=1,
	dep::get_nd("p3_pDR",A1,A2,_,B2),
        A1=int(3),
        A2=str(Rule),
        B2=str(Node),
        depChangeRuleStat(Rule,SetStatus),
		tt::tt_i(2,"setting rule status",SetStatus),
		tt::tt_s(2,"rule ",Rule),
        fail
;
	Mode=0,	
	SetStatus=1,
	dep::get_nd("p3_pDR",A1,A2,_,B2),
        A1=int(3),
        A2=str(Rule),
        B2=str(Node),
        sx::sxUnpack(Rule,'|',L),
        L=[_|T],
        sx::sxlJoin(T,"|",Rule2),
        Rep:repWL(10,"Rule: ",Rule2),
        fail
;
	!.	
% ----------------------------------------------------------------------------------------------
% depAssertDerivations 
% ----------------------------------------------------------------------------------------------
class predicates
depInstTerm : (sterm,integer,integer,sterm) determ (i,i,i,o).
depInstTerms : (sterml,integer,integer,sterml) determ (i,i,i,o).
msgProgress : (count,integer,integer).
clauses

depAssertDerivations(ST,Term,SolRef,NSol) :-
    sx::sxUnpack(ST,'|',L),
    L=[P|_],
	dbBase::chainAccess(P)=0,
	NSol=0,
	dlgIF::feil("depAssertDerivations",["No write-access to this sentence type's chain: '",ST,"'"],[],nill),!
;
	sol::solSetSize(SolRef,NSol),
			Step1=NSol div 100,
			set::setMax([Step1,20],Step),
	Cnt=count::newCounter(0),
	sol::forallsol(SolRef,SolNo), 
	   depInstTerm(Term,SolRef,SolNo,InstTerm),
	   Cnt:inc(_),
	   msgProgress(Cnt,Step,NSol),
 	   dbBase::recordInsert(1,"$DER",0,0,InstTerm,atom("true")),
 	   fail  
;
	sol::solSetSize(SolRef,NSol),
	!.

msgProgress(_,0,_) :- 
	!.
msgProgress(Cnt,Step,Max) :-
	N=Cnt:get(),
	M=N mod Step,
	M=0,
	Perc=(N*100) div Max,
	Ma=globalVars::get_s("ms1"),
	Mb=globalVars::get_s("ms2"),
	sx::concat([Ma," ",Mb," sentence insertion"],Mess),
	dlgIF::msgPC(Mess,Perc),
	!
;
	!.	

depInstTerm(cmp(H,B),SolRef,SolNo,cmp(H,Bi)) :- 
	depInstTerms(B,SolRef,SolNo,Bi),!.
depInstTerm(var(Var),SolRef,SolNo,Val) :- 
	sol::solCompVar(SolRef,SolNo,Var,Val),!.
depInstTerm(Term,SolRef,SolNo,_) :- 
	dlgIF::feil("depInstTerm",[],[SolRef,SolNo],Term),!,fail.
depInstTerms([],_,_,[]) :- 
	!.
depInstTerms([H|T],SolRef,SolNo,[Hi|Ti]) :- 
	depInstTerm(H,SolRef,SolNo,Hi),
	depInstTerms(T,SolRef,SolNo,Ti),!.
% ----------------------------------------------------------------------------------------------
% depChangeRuleStat
% ----------------------------------------------------------------------------------------------
% parameters:
% 1	in	rule key
% 2	in	1=activate rule (-5 --> 5 or -3 --> 3)
%              -1=deactivate rule (5 --> -5 or 3 --> -3)
%
depChangeRuleStat(Rule,Stat) :- 
	Stat=1,
	sx::sxUnpack(Rule,'|',L),
	L=[Chain,Realm,N,M],
	Ni=sx::toInt(N),
	Mi=sx::toInt(M),
	Loc=dbBase::srLoc(Chain,Realm,Ni,Mi),
	dbBase::getRecord(Loc,Type,_,Susp,_,_,_,_,_,_,_,_),
	Susp<>0,
    Type>0,
	!
;	
	Stat=-1,
	sx::sxUnpack(Rule,'|',L),
	L=[Chain,Realm,N,M],
	Ni=sx::toInt(N),
	Mi=sx::toInt(M),
	Loc=dbBase::srLoc(Chain,Realm,Ni,Mi),
	dbBase::getRecord(Loc,Type,_,Susp,_,_,_,_,_,_,_,_),
	Susp<>0,
	Type<0,
	!
;	
	sx::sxUnpack(Rule,'|',L),
	L=[Chain,Realm,N,M],
	Ni=sx::toInt(N),
	Mi=sx::toInt(M),
	Loc=dbBase::srLoc(Chain,Realm,Ni,Mi),
	dbBase::getRecord(Loc,Type,_,Susp,_,_,_,_,_,_,_,_),
    Susp<>0,
    NewType=-Type,
    dbBase::recordSetType(Loc,NewType),
    !
;
	!.
% ----------------------------------------------------------------------------------------------
% depDeriveFacts                                                        
% ----------------------------------------------------------------------------------------------
depDeriveFacts(ST,NSol) :-
	depGenQuery(ST,Query),
	transpr::proPR_Term(Query,Term),
	proc::pie3_IF(Term,SolRef),
	depAssertDerivations(ST,Term,SolRef,NSol),
	sol::solSetDelAll,
	!
;			
	dlgIF::feil("depDeriveFacts",[ST],[],nill),!,fail.		
% ----------------------------------------------------------------------------------------------
% genDerivationGraph
% ----------------------------------------------------------------------------------------------
% generates the derivation graph
%
genDerivationGraph() :-
			Mess0="Deleting derived rules...",
			tt::tt_ss(1,Mess0),
			dlgIF::msgStatus(Mess0),
	vpi::cursorSetWait(),
	dbBase::srDerivedDelete(1),
			Mess4="Initializing derivation graph...",
			tt::tt_ss(1,Mess4),
			dlgIF::msgStatus(Mess4),
	dep::copy("p3_pDP",G),
    dep::restore("p3_pDR",G),
            Mess1="Removing inexact rules and functions...",
			tt::tt_ss(1,Mess1),
			dlgIF::msgStatus(Mess1),
    dep::subMergeTypes("p3_pDR",[15,19]),
			Mess2="Generating derived rules...",
			tt::tt_ss(1,Mess2),
			dlgIF::msgStatus(Mess2),
	changeSG_Rules,
			Mess3="Regenerated derivation graph!",
			tt::tt_ss(1,Mess3),
			dlgIF::msgS(Mess3),
			dlgIF::msgStatus(""),
    dep::chainGraphSetChanged("p3_pDR"),			
	W=guix::getWinOfClas(1),  
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!.
% ----------------------------------------------------------------------------------------------
% depDRGen
% ----------------------------------------------------------------------------------------------
class predicates
depDR_GenX : (string,string_list,sterm,string,integer,integer,sterm,sterm) determ.
depDR_GenIns : (string,integer,integer,sterm,sterm) determ.	
depDRSetStatus : (integer,string) determ (i,i).
depDR_Check2 : (string,string_list) determ.
clauses

depDR_Gen([],_,_,_,_,_,_) :- 
	!.
depDR_Gen([SG|SGs],[ArgVar|ArgVars],Realm,No,Sub,LS,RS) :-
	dbBase::chainAccess(SG)=0,
	depDR_Gen(SGs,ArgVars,Realm,No,Sub,LS,RS),
	!
;
	dep::getSTs("p3_pDP",SG,ST1s),
	depGetSourceSTs(SG,ST2s),
	set::conc([ST1s,ST2s],ST3s),
	set::distinct(ST3s,STs),
	depDR_Check2(SG,STs),
	depDR_GenX(SG,STs,ArgVar,Realm,No,Sub,LS,RS),
	depDR_Gen(SGs,ArgVars,Realm,No,Sub,LS,RS),
	!.
% generates the ST-rules replacing the SG-rule		
% parameters:
% 1	in	implied SG
% 2	in	implying STs (belonging to SG)
% 3	in	rule realm
% 4	in	rule sent.no
% 5	in	base sub.no for derived rules
% 6	in 	rule conc
% 7	in	rule conds	
%	
depDR_GenX(_,[],_,_,_,_,_,_) :- 
	!.
depDR_GenX(SG,[ST|STs],ArgVar,Realm,No,Sub,LS,RS) :-
	ArgVar=cmp(_,[var(V)]),
	dbBase::stComps(ST,_,_,Ent,_),
	dbBase::smClassDefTree(Ent,"e",EntDef),
	EntDef=cmp("ENT_TYPE",[_,cmp("ATTRS",DE_Defs)]),
	vars::varGenDE_VarsNo(Ent,11,DE_Defs,DE_Vars),
	struc::treReplace(LS,var(V),cmp(Ent,DE_Vars),LSm),
	struc::treReplace(RS,var(V),cmp(Ent,DE_Vars),RSm),
	Next=Sub+1,
	depDR_GenIns(Realm,No,Next,LSm,RSm),
	depDR_GenX(SG,STs,ArgVar,Realm,No,Next,LS,RS),!
;
	ArgVar=cmp(_,[var(V1),var(V2)]),
	dbBase::stComps(ST,_,_,Ent1,Ent2),
	dbBase::smClassDefTree(Ent1,"e",EntDef1),
	EntDef1=cmp("ENT_TYPE",[_,cmp("ATTRS",DE_Defs1)]),
	vars::varGenDE_VarsNo(Ent1,11,DE_Defs1,DE_Vars1),
	struc::treReplace(LS,var(V1),cmp(Ent1,DE_Vars1),LSm1),
	struc::treReplace(RS,var(V1),cmp(Ent1,DE_Vars1),RSm1),
	%
	dbBase::smClassDefTree(Ent2,"e",EntDef2),
	EntDef2=cmp("ENT_TYPE",[_,cmp("ATTRS",DE_Defs2)]),
	vars::varGenDE_VarsNo(Ent2,12,DE_Defs2,DE_Vars2),
	struc::treReplace(LSm1,var(V2),cmp(Ent2,DE_Vars2),LSm),
	struc::treReplace(RSm1,var(V2),cmp(Ent2,DE_Vars2),RSm),
	%	
	Next=Sub+1,
	depDR_GenIns(Realm,No,Next,LSm,RSm),
	depDR_GenX(SG,STs,ArgVar,Realm,No,Next,LS,RS),!
;
	ArgVar=cmp(_,[var(V),_]),
	dbBase::stComps(ST,_,_,Ent,_),
	dbBase::smClassDefTree(Ent,"e",EntDef),
	EntDef=cmp("ENT_TYPE",[_,cmp("ATTRS",DE_Defs)]),
	vars::varGenDE_VarsNo(Ent,11,DE_Defs,DE_Vars),
	struc::treReplace(LS,var(V),cmp(Ent,DE_Vars),LSm),
	struc::treReplace(RS,var(V),cmp(Ent,DE_Vars),RSm),
	Next=Sub+1,
	depDR_GenIns(Realm,No,Next,LSm,RSm),
	depDR_GenX(SG,STs,ArgVar,Realm,No,Next,LS,RS),!
;
	ArgVar=cmp(_,[_,var(V)]),
	dbBase::stComps(ST,_,_,_,Ent),
	dbBase::smClassDefTree(Ent,"e",EntDef),
	EntDef=cmp("ENT_TYPE",[_,cmp("ATTRS",DE_Defs)]),
	vars::varGenDE_VarsNo(Ent,11,DE_Defs,DE_Vars),
	struc::treReplace(LS,var(V),cmp(Ent,DE_Vars),LSm),
	struc::treReplace(RS,var(V),cmp(Ent,DE_Vars),RSm),
	Next=Sub+1,
	depDR_GenIns(Realm,No,Next,LSm,RSm),
	depDR_GenX(SG,STs,ArgVar,Realm,No,Next,LS,RS),!
;	
	dlgIF::feil("depDR_GenX",[SG,Realm,ST|STs],[No,Sub],cmp("",[LS,RS,ArgVar])),!,fail.

depDR_GenIns(Realm,No,Next,LS,RS) :-
	% insert rule
				tt::tt_ss(2,"inserts derived rule"),
				tt::tt_s(2,"realm",Realm),
				tt::tt_i(2,"no",No),
				tt::tt_i(2,"sub-no",Next),
				tt::tt_term(2,"rule",cmp(":-",[LS,RS])),
 	dbBase::recordInsert(-5,Realm,No,Next,LS,RS),
 	SNo=toString(No),
 	SSub=toString(Next),
 	LS=cmp(Chain,_),
 	sx::sxlJoin([Chain,Realm,SNo,SSub],"|",Rule),
	dep::updateDP_Graph(1,5,LS,RS,Rule,_),
 	%depDRSetStatus(Stat,Rule),
 	!.

% parameters:
% 1	in	status of original SG dependency
% 2	in	RULE-key for inserted ST-rule
%
depDRSetStatus(0,_) :- 
	!.
depDRSetStatus(1,Rule) :-
	dep::setStatusWhereDependent("p3_pDR",1,cmp("n",[int(3),str(Rule)])),
	!.
depDR_Check2(SG,STs) :-
	set::size(STs,N),
	N<100,
	!
;
	set::size(STs,N),
	N>=100,
	Sn=toString(N),
	sx::concat(["No of STs in SG '",SG,"' used in SG-rule exceeds 99 (",Sn,")"],Mess),
	dlgIF::feil("depDR_Check2",[Mess],[],nill),!,fail.	
% ----------------------------------------------------------------------------------------------
% changeSG_Rules
% ----------------------------------------------------------------------------------------------
class predicates
depDR_Check1 : (string_list,string,integer,integer) determ (i,i,i,i).
depDR_SG : (sterm,string_list,sterml) procedure (i,o,o).
depDR_SG_Rule : (string,string) determ (i,i).
clauses
% creates derivation graph entries corresponding to un-generated SG-rules
%
changeSG_Rules() :-
	dep::get_nd("p3_pDR",A1,A2,B1,B2,int(0)),
        A1=int(3),
        A2=str(Rule),
        B1=int(Typ),
        B2=str(SG),
        set::member(Typ,[1,5]), % SG, open SR
        depDR_SG_Rule(Rule,SG),
        fail
;
	!.
% rule --> SG
% 
depDR_SG_Rule(Rule,SGN) :-
	sx::sxUnpack(SGN,'|',L),
	L=[SG|_], % the concluded SG 
	dbBase::chainAccess(SG)=0,
	dlgIF::feil("depDR_SG_Rule",["No write-access to this sentence group (chain): '",SG,"'"],[],nill),!
;
				sx::concat(["replaces SG rule ",Rule," [",SGN,"]"],Mess),
				tt::tt_ss(2,Mess),
	% delete all dependencies involving the rule
	dep::deleteNode("p3_pDR",cmp("n",[int(3),str(Rule)])),
	% fetch rule record	
    sx::sxUnpack(Rule,'|',LRule),
    LRule=[Chain,R,N,M],
    Ni=sx::toInt(N),
    Mi=sx::toInt(M),
    Loc=dbBase::srLoc(Chain,R,Ni,Mi),
    dbBase::getRecord(Loc,_,_,_,_,_,Realm,No,Sub,_,LT,RT),
	depDR_SG(RT,ImplyingSGs,ArgVars),
	depDR_Check1(ImplyingSGs,SGN,No,Sub),	
	SubM=Sub*100,
	depDR_Gen(ImplyingSGs,ArgVars,Realm,No,SubM,LT,RT),
	!
;
	dlgIF::feil("depDR_SG_Rule",[Rule,SGN],[],nill),!,fail.	
% determines the implying SGs from the rule's RS and the argument variables (1 or 2) used for the SGs
% parameters:
% 1	in	rule RS
% 2	in	implying SGs
% 3	in	agument variables used for the SGs
%	
depDR_SG(cmp(",",[C1,C2]),SGs,Vars) :-
	depDR_SG(C1,SG1s,Vars1),
	depDR_SG(C2,SG2s,Vars2),
	set::conc([SG1s,SG2s],SGs),
	set::conc([Vars1,Vars2],Vars),
	!.
depDR_SG(cmp(SG,[var(V)|_]),[SG],[cmp("",[var(V)])]) :- 
	dbBase::smClassDefF(SG,"p",Card,_,_,_,_),
	Card=1,
	!.
depDR_SG(cmp(SG,[var(V1),var(V2)|_]),[SG],[cmp("",[var(V1),var(V2)])]) :- 
	dbBase::smClassDefF(SG,"p",Card,_,_,_,_),
	Card=2,
	!.
depDR_SG(cmp(SG,[var(V1)|_]),[SG],[cmp("",[var(V1),nill])]) :- 
	dbBase::smClassDefF(SG,"p",Card,_,_,_,_),
	Card=2,
	!.
depDR_SG(cmp(SG,[_,var(V2)|_]),[SG],[cmp("",[nill,var(V2)])]) :- 
	dbBase::smClassDefF(SG,"p",Card,_,_,_,_),
	Card=2,
	!.
depDR_SG(_,[],[]) :-
	!.

depDR_Check1([],SG,_,_) :-
	sx::concat(["No implying SGs found in SG-rule for SG '",SG,"'"],Mess),
	dlgIF::feil("depDR_Check1",[Mess],[],nill),!,fail.
depDR_Check1(_,SG,No,Sub) :-
	No<10,
	Sub<2,
	!
;
	No>9,
	Sn=toString(No),
	sx::concat(["Sentence no of SG-rule for SG '",SG,"' exceeds 9 (",Sn,")"],Mess),
	dlgIF::feil("depDR_Check1",[Mess],[],nill),!,fail
;
	Sub>2,
	Sn=toString(Sub),
	sx::concat(["Sentence sub-no of SG-rule for SG '",SG,"' not 0 or 1 (",Sn,")"],Mess),
	dlgIF::feil("depDR_Check1",[Mess],[],nill),!,fail.
% ----------------------------------------------------------------------------------------------
% depGenQuery                                                        
% ----------------------------------------------------------------------------------------------
class predicates
depGenQueryVars : (sterml,string_list) determ (i,o).
depGenQueryX : (string,integer,string_list,sterm,string,string) determ (i,i,i,i,i,o).
depGenQueryY : (string,integer,string_list,sterm,string) determ (i,i,i,i,o).	
clauses

depGenQuery(ST,Query) :-
	sx::searchchar(ST,'|',P),
	N=P-1,
	sx::frontstr(N,ST,Pred,_),
	sx::frontstr(P,ST,_,R),
	dbBase::smClassDef(Pred,"p",Card,DEs,_,_,_),
	dbBase::smClassDefTree(Pred,"p",PredDef),
	depGenQueryX(Pred,Card,DEs,PredDef,R,Query),
	!
;	
	dbBase::smClassDef(ST,"p",Card,DEs,_,_,_),
	dbBase::smClassDefTree(ST,"p",PredDef),
	depGenQueryY(ST,Card,DEs,PredDef,Query),
	!.
	
depGenQueryX(Pred,1,[],_,Ent,PR) :-
	dbBase::smClassDefTree(Ent,"e",EntDef),
	EntDef=cmp("ENT_TYPE",[_,cmp("ATTRS",AttDefs2)]),
	depGenQueryVars(AttDefs2,Vars3),
	sx::sxlJoin(Vars3,",",Vars4),
	sx::concat([Pred,"(",Ent,"(",Vars4,"))."],PR),
	!.
depGenQueryX(Pred,2,[],_,Ents,PR) :-
	sx::searchchar(Ents,'|',P),
	N=P-1,
	sx::frontstr(N,Ents,Ent1,_),
	sx::frontstr(P,Ents,_,Ent2),
	dbBase::smClassDefTree(Ent1,"e",EntDef1),
	EntDef1=cmp("ENT_TYPE",[_,cmp("ATTRS",AttDefs2)]),
	depGenQueryVars(AttDefs2,Vars3),
	sx::sxlJoin(Vars3,",",Vars4),
	dbBase::smClassDefTree(Ent2,"e",EntDef2),
	EntDef2=cmp("ENT_TYPE",[_,cmp("ATTRS",AttDefs3)]),
	depGenQueryVars(AttDefs3,Vars5),
	sx::sxlJoin(Vars5,",",Vars6),
	sx::concat([Pred,"(",Ent1,"(",Vars4,"),",Ent2,"(",Vars6,"))."],PR),
	!.
depGenQueryX(Pred,1,_,PredDef,Ent,PR) :-
	PredDef=cmp("REL_TYPE",[_,_,cmp("ATTRS",AttDefs1)]),
	depGenQueryVars(AttDefs1,Vars1),
	sx::sxlJoin(Vars1,",",Vars2),
	dbBase::smClassDefTree(Ent,"e",EntDef),
	EntDef=cmp("ENT_TYPE",[_,cmp("ATTRS",AttDefs2)]),
	depGenQueryVars(AttDefs2,Vars3),
	sx::sxlJoin(Vars3,",",Vars4),
	sx::concat([Pred,"(",Ent,"(",Vars4,"),",Vars2,")."],PR),
	!.
	
depGenQueryX(Pred,2,_,PredDef,Ents,PR) :-
	PredDef=cmp("REL_TYPE",[_,_,cmp("ATTRS",AttDefs1)]),
	depGenQueryVars(AttDefs1,Vars1),
	sx::sxlJoin(Vars1,",",Vars2),
	sx::searchchar(Ents,'|',P),
	N=P-1,
	sx::frontstr(N,Ents,Ent1,_),
	sx::frontstr(P,Ents,_,Ent2),
	dbBase::smClassDefTree(Ent1,"e",EntDef1),
	EntDef1=cmp("ENT_TYPE",[_,cmp("ATTRS",AttDefs2)]),
	depGenQueryVars(AttDefs2,Vars3),
	sx::sxlJoin(Vars3,",",Vars4),
	dbBase::smClassDefTree(Ent2,"e",EntDef2),
	EntDef2=cmp("ENT_TYPE",[_,cmp("ATTRS",AttDefs3)]),
	depGenQueryVars(AttDefs3,Vars5),
	sx::sxlJoin(Vars5,",",Vars6),
	sx::concat([Pred,"(",Ent1,"(",Vars4,"),",Ent2,"(",Vars6,"),",Vars2,")."],PR),
	!.
	
depGenQueryY(Pred,1,[],_,PR) :- 
    sx::concat([Pred,"(X)."],PR),
    !.
depGenQueryY(Pred,2,[],_,PR) :- sx::concat([Pred,"(X,Y)."],PR),
    !.
depGenQueryY(Pred,1,_,PredDef,PR) :-
	PredDef=cmp("REL_TYPE",[_,_,cmp("ATTRS",AttDefs1)]),
	depGenQueryVars(AttDefs1,Vars1),
	sx::sxlJoin(Vars1,",",Vars2),
	sx::concat([Pred,"(X,",Vars2,")."],PR),
	!.
depGenQueryY(Pred,2,_,PredDef,PR) :-
	PredDef=cmp("REL_TYPE",[_,_,cmp("ATTRS",AttDefs1)]),
	depGenQueryVars(AttDefs1,Vars1),
	sx::sxlJoin(Vars1,",",Vars2),
	sx::concat([Pred,"(X,Y,",Vars2,")."],PR),
	!.
	
depGenQueryVars([],[]) :- 
    !.
depGenQueryVars([_|T],[V|Vs]) :-
	vars::varGen(V),
	depGenQueryVars(T,Vs),
	!.
% ----------------------------------------------------------------------------------------------
% depGenReady
% ----------------------------------------------------------------------------------------------
class predicates
depUngen : (sterm) determ.
clauses
depGenReady(ST) :-
	% for all determinants
	dep::get_nd("p3_pDR",A1,A2,_,B2),
        B2=str(ST),
        Det=cmp("n",[A1,A2]),
        depUngen(Det),
        % determinants has status 'ungenerated'
        !,fail
;
	% ready!
	!.	
% succeeds if at least one dependency where Node is a dependent is ungenerated
% 
depUngen(Node) :-		
	% for all dependencies where Node is dependent
	Node=cmp(_,[N1,N2]),
	dep::get_nd("p3_pDR",_,_,B1,B2,S),
	    B1=N1,
	    B2=N2,
        S=int(0),
        !
;
	!,fail.
% ----------------------------------------------------------------------------------------------
% depGetSourceSTs 
% ----------------------------------------------------------------------------------------------
class predicates
depInsGS_X : (lst,string_list,string).
clauses
depGetSourceSTs(SG,STS) :-	
	Arr=lst::new(),
	AllSTs=pop::getSTs(SG,[]),
	depInsGS_X(Arr,AllSTs,SG),
	STs=Arr:get(),
	!
;
	dlgIF::feil("depGetSourceSTs",[SG],[],nill),!,fail.	
depInsGS_X(_,[],_) :- !.
depInsGS_X(Arr,[ST|STs],SG) :-
	sx::frontstr(6,ST,CountS,_),
	Count=sx::toInt(CountS),
	Count>0,
	sx::searchchar(ST,'[',P1),
	sx::frontstr(P1,ST,_,S1),
	sx::searchchar(S1,']',P2),
	N2=P2-1,
	sx::frontstr(N2,S1,Node,_),
	Arr:add(Node),
	depInsGS_X(Arr,STs,SG),
	!
;	
	depInsGS_X(Arr,STs,SG),
	!
;
    L=Arr:get(),
	dlgIF::feil("depInsGS_X",[ST|L],[],nill),!,fail.	
% ----------------------------------------------------------------------------------------------
% depSetCount                                                         
% ----------------------------------------------------------------------------------------------
depSetCount([],SNo,_,_,[]) :-
	sx::concat(["Could not find ST no ",SNo," in derivation list (depSetCount)"],Mess),
	dlgIF::msgS(Mess),
	!.
depSetCount([H|T],SNo,N,Time,[S|T]) :-
	sx::frontstr(4,H,LNo,_),
	SNo=LNo,
	sx::frontstr(33,H,_,ST),
	Ns=toString(N),
	sx::sxL_Pad(Ns,"0",7,NSent),
	sx::frontstr(6,H,S2,_),
	sx::concat([S2,"DERIVED   ",NSent," ",Time," ",ST],S),
	!.
depSetCount([H|T],SNo,N,Time,[H|Tm]) :-
	depSetCount(T,SNo,N,Time,Tm),
	!.
% ----------------------------------------------------------------------------------------------
% derPop
% ----------------------------------------------------------------------------------------------
class predicates
derPopX : (string_list,string_list) determ (i,o).
clauses
%
% the following format is used for the ST entries in the listbox
% 1-4           Derivation sequence number (1,2,...,9999)
% 5		'*' for non-derivation due to non-write access, else blank
% 6		blank
% 7-15		UNDERIVED, DERIVED, DERIVING, STOP
% 16		blank
% 17-23		sentence count max 9,999,999 (if derived, else blank)
% 24		blank
% 25-32		HH:MM:SS (if derived, else blank)
% 33		blank
% 34..255	ST (NL) [..]
% 
% sets the ST's listbox entry as DERIVING
%
derPop(W,L) :-
	derPopX(L,M),
	guix::lbxPop(W,idc_sts,M),
	!.
	
derPopX([],[]) :-
	!.
derPopX([H|T],[Hm|Tm]) :-
	sx::substring(H,5,1,S),
	S="*",
	sx::frontstr(5,H,Fr,ST2),
	sx::sxUnpackS(ST2," [",Ls),
	Ls=[ST,Tail],
	dbBase::nlSing(ST,STn),
	sx::concat([Fr," UNDERIVED                  ",STn," [",Tail],Hm),
	derPopX(T,Tm),
	!
;
	sx::frontstr(5,H,Fr,ST2),
	sx::sxUnpackS(ST2," [",Ls),
	Ls=[ST,Tail],
	dbBase::nlSing(ST,STn),
	sx::concat([Fr," UNDERIVED                  ",STn," [",Tail],Hm),
	derPopX(T,Tm),
	!.
% ----------------------------------------------------------------------------------------------
% derSet
% ----------------------------------------------------------------------------------------------
class predicates
derStopX : (string,string_list,string_list) determ (i,i,o).
clauses

derStop(ST,STs,STsm) :-
	sx::frontstr(4,ST,SNo,_),
	derStopX(SNo,STs,STsm),
	!.

derStopX(_,[],[]) :-
	dlgIF::dlgNote(0,"Only the first sentence type in each listed sentence group can be made a STOP-point (the very first sentence type cannot be made a STOP-point)."),
	!.
derStopX(SNo,[G,H|T],[G,Hm|T]) :-
	sx::frontstr(4,H,LNo,_),
	SNo=LNo,
	sx::substring(H,7,4,Status),
	Status<>"STOP",
	sx::frontstr(6,H,Fr,_),
	sx::frontstr(15,H,_,Tail),
	% check that G has a different SG than H
	sx::frontstr(33,H,_,STh2),
	sx::sxUnpackS(STh2," [",Ls),
	Ls=[STh,_],
	dbBase::stNL_KB(STh,SThk),
	sx::sxUnpack(SThk,'|',Lh),
	Lh=[Ph|_],
	sx::frontstr(33,G,_,STg2),
	sx::sxUnpackS(STg2," [",Ls2),
	Ls2=[STg,_],
	dbBase::stNL_KB(STg,STgk),
	sx::sxUnpack(STgk,'|',Lg),
	Lg=[Pg|_],
	Pg<>Ph,
	sx::concat([Fr,"STOP     ",Tail],Hm),
	!
;
	sx::frontstr(4,H,LNo,_),
	SNo=LNo,
	sx::substring(H,7,4,Status),
	Status="STOP",
	sx::frontstr(6,H,Fr,_),
	sx::frontstr(15,H,_,Tail),
	sx::concat([Fr,"UNDERIVED",Tail],Hm),
	!.
derStopX(SNo,[H|T],[H|Tm]) :-
	derStopX(SNo,T,Tm),
	!.
% ----------------------------------------------------------------------------------------------
% derST_List/Continue
% ----------------------------------------------------------------------------------------------
derST_List([],[]) :-
	!.
derST_List([H|T],[Hm|Tm]) :-
	sx::frontstr(5,H,Fr,_),
	sx::frontstr(33,H,_,STn2),
	sx::sxUnpackS(STn2,"[",Ls),
	Ls=[STn|_],
	dbBase::stNL_KB(STn,STk),
	Hm=string::concat(Fr,STk),
	derST_List(T,Tm),
	!.
	
derST_ListContinue([],[],[]) :-
	!.
derST_ListContinue([H|T],Tm,Tm2) :-
	sx::substring(H,7,7,S2),
	S2="DERIVED",
	derST_ListContinue(T,Tm,Tm3),
	Tm2=[H|Tm3],
	!
;
	sx::substring(H,7,4,S2),
	S2="STOP",
	derST_List(T,Tm3),
	sx::frontstr(5,H,Fr,_),
	sx::frontstr(33,H,_,STn2),
	sx::sxUnpackS(STn2," [",Ls),
	Ls=[STn,Tail],
	sx::concat([Fr," UNDERIVED                  ",STn," [",Tail],Hm2),
	dbBase::stNL_KB(STn,STk),
	Hm=string::concat(Fr,STk),
	Tm=[Hm|Tm3],
	Tm2=[Hm2|T],
	!
;
	sx::substring(H,7,9,S2),
	S2="UNDERIVED",
	derST_List(T,Tm3),
	sx::frontstr(5,H,Fr,_),
	sx::frontstr(33,H,_,STn2),
	sx::sxUnpackS(STn2," [",Ls),
	Ls=[STn,_],
	dbBase::stNL_KB(STn,STk),
	Hm=string::concat(Fr,STk),
	Tm=[Hm|Tm3],
	Tm2=[H|T],
	!.
% ----------------------------------------------------------------------------------------------
% derSwap
% ----------------------------------------------------------------------------------------------
% checks if list entries A and B can swap positions, and if so performs the swap
%
derSwap(A,B,STs,STsM) :-
	A>B,
	derGetRow(A,STs,Ar),
	derGetRow(B,STs,Br),
	sx::frontstr(33,Ar,_,STa2),
	sx::sxUnpackS(STa2," [",La),
	La=[STa,_],
	sx::frontstr(33,Br,_,STb2),
	sx::sxUnpackS(STb2," [",Lb),
	Lb=[STb,_],
	dbBase::stNL_KB(STa,STak),
	dbBase::stNL_KB(STb,STbk),
	isDependent(STbk,STak),
	dlgIF::dlgNote(0,"This move violates the derivation sequence logic!"),
	!,fail
;
	A<B,
	derGetRow(A,STs,Ar),
	derGetRow(B,STs,Br),
	sx::frontstr(33,Ar,_,STa2),
	sx::sxUnpackS(STa2," [",La),
	La=[STa,_],
	sx::frontstr(33,Br,_,STb2),
	sx::sxUnpackS(STb2," [",Lb),
	Lb=[STb,_],
	dbBase::stNL_KB(STa,STak),
	dbBase::stNL_KB(STb,STbk),
	isDependent(STbk,STak),
	dlgIF::dlgNote(0,"This move violates the derivation sequence logic!"),
	!,fail
;
	derGetRow(A,STs,Ar),
	derGetRow(B,STs,Br),
	set::setRemSub([Ar,Br],STs,STs2),
	sx::frontstr(4,Ar,Fa,Ta),
	sx::frontstr(4,Br,Fb,Tb),
	Ar2=string::concat(Fb,Ta),
	Br2=string::concat(Fa,Tb),
	STsM=[Ar2,Br2|STs2],	
	!.
% ----------------------------------------------------------------------------------------------
% derGetRow
% ----------------------------------------------------------------------------------------------
derGetRow(N,[Row|Rows],R) :-
	sx::frontstr(4,Row,F,_),
	N=sx::toInt(F),
	R=Row,
	!
;
	derGetRow(N,Rows,R),
	!.
% ----------------------------------------------------------------------------------------------
% checkIRR_Delete
% ----------------------------------------------------------------------------------------------
checkIRR_Delete() :-
    dbBase::chainExists("r"),
    dbBase::chainReadonlyWarning("r"),
    !
;
    dbBase::chainExists("r"),
	Reply=vpiCommonDialogs::ask("Please confirm (for faster derivation)","Do you want to delete all existing inexact rule reasoning sentences?",["Yes","No"]),
	Reply=vpiCommonDialogs::resp_default,
	vpi::cursorSetWait(),
	dbBase::chainDelete("r"),
	dlgIF::msgS("All inexact rule reasoning records deleted!"),
	W=guix::getWinOfClas(0),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	sdb::sdbSetStatus,
	!
;
    !.
% ----------------------------------------------------------------------------------------------
% rederiveAll
% ----------------------------------------------------------------------------------------------
class predicates
makeEst : (integer,integer,integer,string) procedure (i,i,i,o).    
clauses

rederiveAll(Rep,SumST,SumSol) :-
			datetime::tsNow(Ts),
			dlgIF::msgStatus("Deleting inexact rule reasoning records ..."),
    dbBase::chainDelete("r"),
			dlgIF::msgStatus("Deleting all derived sentences..."),
	dbBase::sentenceDerivedDelete(-1),
	subscribe,
	dep::regenDependencyGraph,
	depList(-1,L,N,Secs,All),
	makeEst(N,Secs,All,Mess),
			dlgIF::msgStatus(Mess),
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE"), 
			Rep:repWL(0,""),
	depDeriveSTs(Rep,L,SumST,SumSol),
	depDeriveEnd(Rep,Ts,SumST,SumSol),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
	   		Nts=toString(SumST),
	   		Nss=toString(SumSol),
	   		Mess2=string::concatList(["Full re-derivation of ",Nss," sentences of ",Nts," types with elapsed time ",DiffS,"."]),
			dlgIF::msgS(Mess2),
			dlgIF::msgStatus(""),
    !.

makeEst(N,Secs,All,S) :-
    All=1,
    SecsS=toString(Secs),
    Dur=string::concat("PT",SecsS,"S"),
    xmlGeneric::durationShort(Dur,DurN),
    N>0,
    Ns=toString(N),
    S=string::concat("Deriving an estimated ",Ns," sentences during a period of ",DurN,"..."),
    !
;    
    All<>1,
    SecsS=toString(Secs),
    Dur=string::concat("PT",SecsS,"S"),
    xmlGeneric::durationShort(Dur,DurN),
    Ns=toString(N),
    N>0,
    S=string::concat("Deriving an estimated minimum ",Ns," sentences during a minimum period of ",DurN,"..."),
    !
;
    S="Deriving sentences...",
    !.
% ----------------------------------------------------------------------------------------------
% rederive
% ----------------------------------------------------------------------------------------------
rederive() :-
	subscribe,
	depList(-1,L,_,_,_),
  	set::size(L,N),
  	N>0,
			Rep=rep::newReport(2,"Derived Sentences",70),
			datetime::tsNow(Ts),
			dlgIF::msgStatus("Generating derivation graph..."),
	der::genDerivationGraph,
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE DELETED"),
			Rep:repWL(0,""),
	der::depDeleteSTs(Rep,L),
	globalVars::get_i("quit_flag")=0,
			Rep:repWL(0,""),
			Rep:repWL(0,"#SENTENCES   TIME   SENTENCE TYPE DERIVED"),
			Rep:repWL(0,""),
	der::depDeriveSTs(Rep,L,SumST,SumSol),
    dep::setStatus("p3_pDP",int(0),int(1)),
	der::depDeriveEnd(Rep,Ts,SumST,SumSol),
			Rep:close(),
			datetime::tsNow(Te),
	   		datetime::tsDiff(Ts,Te,DD,HH,MM,SS),
	   		datetime::timDurText(DD,HH,MM,SS,DiffS),
	   		Nts=toString(SumST),
	   		Nss=toString(SumSol),
	   		sx::concat([Nss," sentences of ",Nts," types derived - elapsed time ",DiffS,"."],Mess),
			dlgIF::msgStatus(Mess),
    !
;
    !.   
% ----------------------------------------------------------------------------------------------
% subscribe                                                   
% ----------------------------------------------------------------------------------------------
subscribe() :-
    sqlBase::hasConnection,
	sqlSt::subscribeAll,
    !
;
    !.
% ----------------------------------------------------------------------------------------------
% depList                                                        
% ----------------------------------------------------------------------------------------------
class predicates
derivationList : (string_list,integer,integer,integer) determ (o,o,o,o).
derivationListX : (integer,integer,termSet,string_list,integer,integer,integer) determ (i,i,i,o,o,o,o).
getFromSet : (integer,termSet,sterm) determ (i,i,o).
makeST_String : (integer,string,string) procedure (i,i,o).
addEstimate : (string,string,integer,integer,integer,string) procedure (i,i,o,o,o,o).
clauses

% returns a sorted list of non-derived STs, on the format
% 1-4	sequence no left-padded with 0's (0001,0002,...)
% 5	'*' if no read access to ST (else blank)
% 6-..  ST (IF) [estimated #sentences and derivation time] ([..] optional tail)
% parameters:
% 0 in -1/1 add optional tail
% 1 out st derivation list
% 2 out est. #total sentences to be derived
% 3 out est. time for derivation
% 4 out 1=estimate includes all STs, 0=not
%      
depList(Add,L,N,Secs,All) :-
			dlgIF::msgStatus("Cascading dependency graph status..."),
    dep::cascadeStatusForward("p3_pDP",0),
			dlgIF::msgStatus("Initializing derivation graph..."),
	genDerivationGraph,
	dep::copy("p3_pDR",G),
			dlgIF::msgStatus("Determining derivation plan..."),
    vpi::cursorSetWait(),
	derivationList(L2,N,Secs,All),	
			dlgIF::msgStatus("Optimizing derivation plan ..."),
	dep::restore("p3_pDR",G),
	depListOptimize(L2,L3),
	stripTail(Add,L3,L),
            dlgIF::msgStatus("Ready to start derivation!"),
	!.

derivationList(L,N,Secs,All) :-
    dep::deleteWhereStatus("p3_pDR",1),
    dep::deleteST_StartNodes,
    ST_Terms=dep::serial("p3_pDR"),
    derivationListX(1,1,ST_Terms,L,N,Secs,All),
    !.
    
derivationListX(_,N,Set,[],0,0,1) :-
    not(getFromSet(N,Set,_)),
    !.
derivationListX(M,N,Set,[H|T],Ns,Secs,All) :-
    getFromSet(N,Set,Ht),
    Ht=cmp(_,[int(2),str(S)]),
    makeST_String(M,S,H2),
    addEstimate(S,H2,N1,Secs1,All1,H),
    MN=M+1,
    NN=N+1,
    derivationListX(MN,NN,Set,T,N2,Secs2,All2),
    Ns=N1+N2,
    Secs=Secs1+Secs2,
    All=All1*All2,
    !.
derivationListX(M,N,Set,T,Ns,Secs,All) :-
    getFromSet(N,Set,_),
    NN=N+1,
    derivationListX(M,NN,Set,T,Ns,Secs,All),
    !.
    
getFromSet(N,Set,T) :-
    T=Set:get_nd(),
        T=cmp(Ns,_),
        M=sx::toInt(Ns),
        N=M,
        !.
        
makeST_String(N,S,T) :-
	dbBase::chainAccess(S)=0,
    Ns=toString(N),
    sx::sxL_Pad(Ns,"0",4,Nsp),
    T=string::concat(Nsp,"*",S),
    !
;    
    Ns=toString(N),
    sx::sxL_Pad(Ns,"0",4,Nsp),
    T=string::concat(Nsp," ",S),
    !.

addEstimate(St,S,N,Secs,All,Sr) :-
    der::getDerivationStats(St,N,Secs,_,_,_),
    SecsS=toString(Secs),
    Dur=string::concat("PT",SecsS,"S"),
    xmlGeneric::durationShort(Dur,DurN),
    Ns=toString(N),
    Sr=string::concat(S," [",Ns," during ",DurN,"]"),
    All=1,
    !
;
    Sr=string::concat(S," [-]"),
    N=0,
    Secs=0,
    All=0,
    !.
% ----------------------------------------------------------------------------------------------
% depListOptimize                                                      
% ----------------------------------------------------------------------------------------------
class predicates
depListOptimizeX : (string_list,string_list) determ (i,o).
depL_Renumber : (integer,string_list,string_list) determ (i,i,o).	
depL_CanMoveUp : (string,string_list) determ (i,i).	
depL_SG : (string,string) determ (i,o).	
depL_SG_Exists : (string,string_list,string,string_list) determ (i,i,o,o).
depL_ST : (string,string) determ (i,o).	
stripTail : (integer,string_list,string_list) determ (i,i,o).
clauses

% adjusts the list of STs due for derivation, such that STs in the same SG are derived
% consequtively where possible
%
depListOptimize(L,Lm) :-
	depListOptimizeX(L,L2),
	depL_Renumber(1,L2,Lm),
	!.
	
depListOptimizeX([],[]) :-
	!.
depListOptimizeX([H],[H]) :-
	!.
depListOptimizeX([H,M|T],L) :-
	depL_SG(H,P),
	depL_SG(M,Q),
	P<>Q,
	depL_SG_Exists(P,T,P2,Tr),
	depL_ST(P2,ST),
	depL_CanMoveUp(ST,[M|Tr]),
	depListOptimizeX([P2,M|Tr],T2),
	L=[H|T2],
	!
;
	depListOptimizeX([M|T],T2),
	L=[H|T2],
	!.
	
% parameters:
% 1	in	row
% 2	out	SG (predicate) in row
%
depL_SG(R,SG) :-
    sx::sxUnpackS(R," [",Lr),
    Lr=[R2|_],
	sx::frontstr(5,R2,_,ST),
	sx::sxUnpack(ST,'|',L),
	L=[SGx|_],
	sx::sxStrip(SGx,SG),
	!.
	
% parameters:
% 1	in	row
% 2	out	ST in row
%
depL_ST(R,ST) :-
    sx::sxUnpackS(R," [",Lr),
    Lr=[R2|_],
	sx::frontstr(5,R2,_,STx),
	sx::sxStrip(STx,ST),
	!.
	
% parameters:
% 1	in	SG
% 2	in	rows
% 3	out	first row where SG exists
% 4	out	rows minus the row corr. to p#3
%
depL_SG_Exists(SG,[H|T],R,Tr) :-
	depL_SG(H,P),
	SG=P,
	R=H,
	Tr=T,
	!
;
	depL_SG_Exists(SG,T,R,T2),
	Tr=[H|T2],
	!.
	
depL_CanMoveUp(_,[]) :-
	!.
depL_CanMoveUp(ST,[H|T]) :-
	depL_ST(H,STx),
	not(isDependent(STx,ST)),
	depL_CanMoveUp(ST,T),
	!.	

depL_Renumber(_,[],[]) :-
	!.
depL_Renumber(N,[H|T],[Hm|Tm]) :-
	sx::frontstr(4,H,_,S2),
	Ns=toString(N),
	sx::sxL_Pad(Ns,"0",4,Ns2),
	Hm=string::concat(Ns2,S2),
	M=N+1,
	depL_Renumber(M,T,Tm),
	!.

stripTail(1,L,L) :-
    !.
stripTail(-1,[],[]) :-
    !.
stripTail(-1,[H|T],[Hs|Ts]) :-
    sx::sxUnpackS(H," [",L),
    L=[Hs,_],
    stripTail(-1,T,Ts),
    !.
% ----------------------------------------------------------------------------------------------
% isDependent                                        
% ----------------------------------------------------------------------------------------------
isDependent(STx,ST) :-
	dep::depIsDependent("p3_pDP",cmp("n",[int(2),str(STx)]),cmp("n",[int(2),str(ST)])),
	!
;	
	sx::sxUnpack(ST,'|',L),
	L=[P|_],
	dep::depIsDependent("p3_pDP",cmp("n",[int(2),str(STx)]),cmp("n",[int(1),str(P)])),
	!
;	
	sx::sxUnpack(STx,'|',Lx),
	Lx=[Px|_],
	dep::depIsDependent("p3_pDP",cmp("n",[int(1),str(Px)]),cmp("n",[int(2),str(ST)])),
	!
;
	sx::sxUnpack(ST,'|',L),
	L=[P|_],
	sx::sxUnpack(STx,'|',Lx),
	Lx=[Px|_],
	dep::depIsDependent("p3_pDP",cmp("n",[int(1),str(Px)]),cmp("n",[int(1),str(P)])),
	!.
% ----------------------------------------------------------------------------------------------
% getDerivationStats
% ----------------------------------------------------------------------------------------------
getDerivationStats(St,N,Secs,Start,End,Loc) :-
    dbBase::chainSentences("x",Lt,Loc),
        Lt=cmp(_,[cmp("p3_eStDer",[str(St),int(N),int(Secs),str(Start),str(End)])]),
        !.
% ----------------------------------------------------------------------------------------------
% storeDerivationStart/End
% ----------------------------------------------------------------------------------------------
storeDerivationStart(St) :-
    getDerivationStats(St,N,Secs,_,_,Loc),
    dbBase::recordDelete(Loc),
    xmlGeneric::timeNowXML(Start),
    SecsS=toString(Secs),
    Dur=string::concat("PT",SecsS,"S"),
    xmlGeneric::xmlDatetimeAdd(Start,Dur,EstEnd),
    LT=cmp("x",[cmp("p3_eStDer",[str(St),int(N),int(-1),str(Start),str(EstEnd)])]),
    dbBase::recordInsert(2,"$SYS",0,0,LT,atom("true")),
    !
;
    xmlGeneric::timeNowXML(Start),
    LT=cmp("x",[cmp("p3_eStDer",[str(St),int(-1),int(-1),str(Start),str("")])]),
    dbBase::recordInsert(2,"$SYS",0,0,LT,atom("true")),
    !.   

storeDerivationEnd(St,N,Secs) :-
    getDerivationStats(St,_,_,Start,_,Loc),
    dbBase::recordDelete(Loc),
    xmlGeneric::timeNowXML(End),
    LT=cmp("x",[cmp("p3_eStDer",[str(St),int(N),int(Secs),str(Start),str(End)])]),
    dbBase::recordInsert(2,"$SYS",0,0,LT,atom("true")),
    !
;
    Mess=string::concat("Could not find derivation statistics record for: ",St,"!"),
    dlgIF::dlgNote(2,Mess),!.
end implement der
