/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement draw
open core,termDomain

constants
className = "com/rudstrand/draw/draw".
classVersion = "1.0".

class predicates
filter : (dirgraph,integer,integer,integer,integer,integer) determ.
nodeName : visioSymbol_CALLBACK.
linkName : visioLink_CALLBACK.
irName : visioSymbol_CALLBACK.
removeP3F : (dirgraph,integer,integer).
colorSR : (string,string) determ (i,o).
colorST : (sterm,string) determ (i,o).
colorFN : (string,string) procedure (i,o).
colorIR : (string,string) determ (i,o).

clauses
classInfo(className, classVersion).
% ----------------------------------------------------------------------------------------------
% drawGraph
% ----------------------------------------------------------------------------------------------
class predicates
checkColors : (string,string) procedure (i,o).
clauses

% parameters:
% 4 in 0=entire graph, 1=determinants, 2=dependents, 3=IR graph
%
drawGraph(Title,Note,Graph,0,ST,SR,CR,FU,XP3F,_,_) :- 
	% entire graph
    filter(Graph,ST,SR,CR,FU,XP3F),
	EP=globalVars::get_s("exe_path"),
	FS=string::concat(EP,"\\exe\\VisioDP_Headers.txt"),
	checkColors(FS,FS2),
	fioExt::filCheckFile(-1,"Visio Stencil Header file ",FS2,FSr),
	SP=globalVars::get_s("std_path"),
	fioExt::makeFileName(Title,"txt",FileName),
	OS=string::concat(SP,"\\",Filename),
	xmlGeneric::timeNowXML(Tim),
	Kb=globalVars::get_s("kb_file"),
	Kbn=fileName::getName(Kb),
	Note2=string::concat(Note," ",Tim," ",Kbn),
    Graph:drwVisio(FSr,OS,Note2,nodeName,linkName),
	sx::concat(["VISIO export written to file ",OS,"!"],Mess),
	dlgIF::dlgNote(0,Mess),
	!.	
drawGraph(Title,Note,Graph,GraphType,ST,SR,CR,FU,XP3F,Node,"ALL") :- 
	drawGraph(Title,Note,Graph,GraphType,ST,SR,CR,FU,XP3F,Node,"999999"),
	!.
drawGraph(Title,Note,Graph,1,ST,SR,CR,FU,XP3F,cmp(_,[T,N]),Depth) :-
	vpi::cursorSetWait(),
	Levels=sx::toInt(Depth),
	filter(Graph,ST,SR,CR,FU,XP3F),
	Set=Graph:predsRec(Levels,T,N),
	Set:add(cmp("",[T,N])),
	Graph:includeSet(Set),
	EP=globalVars::get_s("exe_path"),
	FS=string::concat(EP,"\\exe\\VisioDP_Headers.txt"),
	checkColors(FS,FS2),
	fioExt::filCheckFile(-1,"Visio Stencil Header file ",FS2,FSr),
	SP=globalVars::get_s("std_path"),
	fioExt::makeFileName(Title,"txt",FileName),
	OS=string::concat(SP,"\\",Filename),
	xmlGeneric::timeNowXML(Tim),
	Kb=globalVars::get_s("kb_file"),
	Kbn=fileName::getName(Kb),
	Note2=string::concat(Note," ",Tim," ",Kbn),
    Graph:drwVisio(FSr,OS,Note2,nodeName,linkName),
	sx::concat(["VISIO export written to file ",OS,"!"],Mess),
	dlgIF::dlgNote(0,Mess),	
	!.
drawGraph(Title,Note,Graph,2,ST,SR,CR,FU,XP3F,cmp(_,[T,N]),Depth) :-
	vpi::cursorSetWait(),
	Levels=sx::toInt(Depth),
	filter(Graph,ST,SR,CR,FU,XP3F),
	Set=Graph:succsRec(Levels,T,N),
	Set:add(cmp("",[T,N])),
	Graph:includeSet(Set),
	EP=globalVars::get_s("exe_path"),
	FS=string::concat(EP,"\\exe\\VisioDP_Headers.txt"),
	checkColors(FS,FS2),
	fioExt::filCheckFile(-1,"Visio Stencil Header file ",FS2,FSr),
	SP=globalVars::get_s("std_path"),
	fioExt::makeFileName(Title,"txt",FileName),
	OS=string::concat(SP,"\\",Filename),
	xmlGeneric::timeNowXML(Tim),
	Kb=globalVars::get_s("kb_file"),
	Kbn=fileName::getName(Kb),
	Note2=string::concat(Note," ",Tim," ",Kbn),
    Graph:drwVisio(FSr,OS,Note2,nodeName,linkName),
	sx::concat(["VISIO export written to file ",OS,"!"],Mess),
	dlgIF::dlgNote(0,Mess),	
	!.
drawGraph(Title,Note,Graph,3,_,_,_,_,_,cmp(_,[T,N]),_) :-
	vpi::cursorSetWait(),
	filter(Graph,-1,-1,1,-1,-1),
	Set=Graph:predsRec(999999,T,N),
	Set:add(cmp("",[T,N])),
	Graph:includeSet(Set),
	EP=globalVars::get_s("exe_path"),
	FS=string::concat(EP,"\\exe\\VisioIR_Headers.txt"),
	checkColors(FS,FS2),
	fioExt::filCheckFile(-1,"Visio Stencil Header file ",FS2,FSr),
	SP=globalVars::get_s("std_path"),
	fioExt::makeFileName(Title,"txt",FileName),
	OS=string::concat(SP,"\\",Filename),
	xmlGeneric::timeNowXML(Tim),
	Kb=globalVars::get_s("kb_file"),
	Kbn=fileName::getName(Kb),
	Note2=string::concat(Note," ",Tim," ",Kbn),
    Graph:drwVisio(FSr,OS,Note2,irName,linkName),
	sx::concat(["VISIO export written to file ",OS,"!"],Mess),
	dlgIF::dlgNote(0,Mess),	
	!.
	
checkColors(F,Fc) :-
       globalVars::get_i("solidcol")=1,
       Fc=sx::replaceAll(F,".txt","c.txt"),
       !
;
       Fc=F,
       !.
% ----------------------------------------------------------------------------------------------
% filter
% ----------------------------------------------------------------------------------------------
class predicates
filterX : (dirgraph,integer,integer) determ.
clauses

% removes elements of the graph according to the selection flags (1=include -1=exclude)
%
filter(Graph,ST,SR,CR,FU,XP3F) :-
    removeP3F(Graph,XP3F,FU),
	filterX(Graph,1,ST),
	filterX(Graph,2,ST),
	filterX(Graph,3,SR),
	filterX(Graph,5,SR),
	filterX(Graph,15,CR),
	filterX(Graph,19,FU),
	!.

filterX(_,_,1) :- !.
filterX(Graph,Type,-1) :- Graph:subMergeType(int(Type)),!.
% ----------------------------------------------------------------------------------------------
% removeP3F
% ----------------------------------------------------------------------------------------------
class predicates
removeP3F_X : (dirgraph).
hasP3F : (dirgraph) determ.
clauses
% removes Pro/3 functions from the graph if opted for	
%	
removeP3F(Graph,FU,XP3F) :-
    FU=-1, 
    % All functions will be removed
    !
;    
    XP3F=1,
    hasP3F(Graph),
    removeP3F_X(Graph),
    removeP3F(Graph,FU,XP3F), % recursive removal required
    !
;
    !.
    
removeP3F_X(Graph) :-    
    Graph:get_nd(A1,A2,_,_),
        A1=int(19),
        A2=str(Fu),
        sx::frontstr(4,Fu,F,_),
        F="p3_f",
        Graph:subMergeP(A1,str(Fu)),
        fail
;
    Graph:get_nd(_,_,A1,A2),
        A1=int(19),
        A2=str(Fu),
        sx::frontstr(4,Fu,F,_),
        F="p3_f",
        Graph:subMergeP(A1,str(Fu)),
        fail
;
    !.
    
hasP3F(Graph) :-
    Graph:has(int(19),A2,_,_),
    A2=str(Fu),
	sx::frontstr(4,Fu,F,_),
	F="p3_f",
    !
;    
    Graph:has(_,_,int(19),B2),
    B2=str(Fu),
	sx::frontstr(4,Fu,F,_),
	F="p3_f",
	!.
% -----------------------------------------------------------------------------------------------
% color..
% -----------------------------------------------------------------------------------------------
class predicates
colorSR2 : (integer,string) procedure (i,o).
colorIR2 : (string,string) procedure (i,o).
clauses

colorFN(F,Col) :-
    dbBase::smClassDefF(F,"f",_,_,_,_,_),
    Col="dt",
    !
;
   Col="nd",
   !.
   
colorSR(R,Col) :-
    sx::sxUnpack(R,'|',L),
    L=[Chain,Rlm,N,M],
    Ni=sx::toInt(N),
    Mi=sx::toInt(M),
    Loc=dbBase::srLoc(Chain,Rlm,Ni,Mi),
	dbExtension::dbuSR_Type(Loc,No),
	colorSR2(No,Col),
	!.
	
colorSR2(1,"") :- !.
colorSR2(4,"") :- !.
colorSR2(21,"st") :- !.
colorSR2(22,"cr") :- !.
colorSR2(64,"ac") :- !.
colorSR2(_,"sl") :- !.

colorST(cmp(_,[_,str(N)]),Col) :-
	dep::isDeterminant("p3_pDP",2,N),
	dep::isDependent("p3_pDP",2,N),
	Col="",
	!
;
	dep::isDeterminant("p3_pDP",2,N),
	Col="st",
	!
;
	dep::isDependent("p3_pDP",2,N),
	Col="en",
	!
;
    Col="is",
    !.    

colorIR(C,Col) :-
	dbBase::irType(C,_,Typ),
	colorIR2(Typ,Col),
	!.

colorIR2("p3_iCqry","qr") :- !.
colorIR2("p3_iCqst","qs") :- !.
colorIR2(Typ,"") :- sx::frontstr(5,Typ,F,_), F= "p3_iZ",!.
colorIR2(_,"cr") :- !.
% -----------------------------------------------------------------------------------------------
% callback functions for visio drawing
% -----------------------------------------------------------------------------------------------
class predicates
graChainSuffix : (integer,integer,string,string) determ (i,i,i,o).
nodeLabel : (integer,string,string) determ (i,i,o).
shapeLines : (string,integer,integer,integer) determ (i,i,i,o).
countLines : (integer,integer,string_list,integer) determ (i,i,i,o).
graCR_Suffix : (string,string) determ (i,o).
graCR_Suffix2 : (string,string) procedure (i,o).
graSR_Suffix : (string,string) determ (i,o).
graSR_Suffix2 : (integer,string) procedure (i,o).
irLabel : (string,string) determ (i,o).
clauses

irName(_,str(Rule),Shape,Label) :-
	dbBase::irType(Rule,_,Typ),
    irLabel(Typ,SubTyp),
    dbBase::nlSing(Rule,Label),
	shapeLines(Label,14,4,L),
	Ls=toString(L),
	Shape=string::concat("IR",Ls,SubTyp),
	!.

irLabel("p3_iCqst","qst") :- !.
irLabel("p3_iCqry","qry") :- !.
irLabel("p3_iCswc","swi") :- !.
irLabel("p3_iCswp","swi") :- !.
irLabel("p3_iCmap","map") :- !.
irLabel("p3_iCbay","bay") :- !.
irLabel("p3_iCpar","par") :- !.
irLabel("p3_iCand","and") :- !.
irLabel("p3_iCor","or") :- !.
irLabel("p3_iCnot","not") :- !.
irLabel("p3_iZand","int") :- !.
irLabel("p3_iZor","uni") :- !.
irLabel("p3_iZnot","cmp") :- !.
irLabel("p3_iZowa","owa") :- !.

linkName(_,_,_,_,_,"") :- !.    

nodeName(int(Typ),str(Nk),Shape,Label) :-
	Typ=1,
	nodeLabel(Typ,Nk,Label),
	shapeLines(Label,14,4,L),
	Ls=toString(L),
	Shape=string::concat("SG",Ls),
	!
;
	Typ=2,
	nodeLabel(Typ,Nk,Label),
	shapeLines(Label,18,4,L),
	Ls=toString(L),
	colorST(cmp("n",[int(2),str(Nk)]),Col),
	Shape=string::concat("ST",Ls,Col),
	!
;
	Typ=3,
	nodeLabel(Typ,Nk,Label),
	shapeLines(Label,18,4,L),
	Ls=toString(L),
	colorSR(Nk,Col),
	Shape=string::concat("SR",Ls,Col),
	!
;
	Typ=5,
	nodeLabel(Typ,Nk,Label),
	shapeLines(Label,14,4,L),
	Ls=toString(L),
	Shape=string::concat("SG",Ls),
	!
;
	Typ=15,
	nodeLabel(Typ,Nk,Label),
	shapeLines(Label,12,5,L),
	Ls=toString(L),
	colorIR(Nk,Col),
	Shape=string::concat("IR",Ls,Col),
	!
;
	Typ=19,
	nodeLabel(Typ,Nk,Label),
	shapeLines(Label,12,5,L),
	Ls=toString(L),
	colorFN(Nk,Col),
	Shape=string::concat("FN",Ls,Col),
	!.
nodeName(T,N,_,_) :-
    S1=toString(T),
    S2=toString(N),
    Mess=string::concat("Invalid graph node:",S1," ",S2),
    dlgIF::dlgNote(3,Mess),!,fail.

shapeLines(Label,Width,Max,NLines) :-
	sx::sxUnpack(Label,' ',Words),
	countLines(0,Width,Words,L),
	set::setMin([Max,L],NLines),
	!.
	
countLines(0,_,[],0) :-
	!.
countLines(_,_,[],1) :-
	!.
countLines(Used,Width,[Word|Words],Lines) :-
	Used=0,
	W=string::length(Word),
	W>Width,
	NL=W div Width,
	Left=W mod Width,
	countLines(Left,Width,Words,L),
	Lines=NL+L,
	!
;
	Used>0,
	W=string::length(Word),
	W>Width,
	NL=W div Width,
	Left=W mod Width,
	countLines(Left,Width,Words,L),
	Lines=NL+L+1,
	!
;	
	W=string::length(Word),
	Total=Used+W+1,
	Total>Width,
	countLines(W,Width,Words,L),
	Lines=L+1,
	!
;		
	W=string::length(Word),
	Total=Used+W+1,
	countLines(Total,Width,Words,Lines),
	!.

nodeLabel(Typ,K,Label) :-
	Typ=1,
	dbBase::nlTry(K,Label3),
	dbExtension::dbuChainType(K,CTyp,RW,KB),
	graChainSuffix(CTyp,RW,KB,Label2),
	sx::concat([Label3,Label2],Label),
	!
;
	Typ=2,
	dbBase::nlTry(K,Label3),
	dbBase::stComps(K,_,P,_,_),
	dbExtension::dbuChainType(P,CTyp,RW,KB),
	graChainSuffix(CTyp,RW,KB,Label2),
	sx::concat([Label3,Label2],Label),
	!
;
	Typ=3,
	dbBase::nlTry(K,Label2),
	graSR_Suffix(K,Suffix),
	sx::concat([Label2," ",Suffix],Label),
	!
;
    Typ=5,
	dbBase::nlTry(K,Label3),
	sx::sxUnpack(K,'|',L),
	L=[P|_],
	dbExtension::dbuChainType(P,CTyp,RW,KB),
	graChainSuffix(CTyp,RW,KB,Label2),
	sx::concat([Label3,Label2],Label),
	!
;
	Typ=15,
	dbBase::nlTry(K,Label2),
	graCR_Suffix(K,Label3),
	sx::concat([Label2,Label3],Label),
	!
;
    Typ=19,
    dbBase::chainExists(K),
	dbBase::nlTry(K,Label2),
	dbExtension::dbuChainType(K,CTyp,RW,Id),
	graChainSuffix(CTyp,RW,Id,Label3),
	sx::concat([Label2,Label3],Label),
	!
;
    Typ=19,
	dbBase::nlTry(K,Label2),
	dbExtension::dbuChainType(K,CTyp,RW,Id),
	graChainSuffix(CTyp,RW,Id,Label3),
	sx::concat([Label2,"*",Label3],Label),
	!.

graChainSuffix(Typ,RW,KB,S) :-
	Typ=1,
	S="",
	!
;
	Typ=2,
	RWP=RW+1,
	set::setGet(["","w"],RWP,R),
	sx::concat(["!",R,"]"],S),
	!
;
	Typ=3,
	RWP=RW+1,
	set::setGet(["","w"],RWP,R),
	sx::concat(["+",KB," ",R],S),
	!.

graCR_Suffix(C,Suff) :-
    dbBase::irType(C,_,Typ),
	graCR_Suffix2(Typ,Suff),
	!.
	
graCR_Suffix2("p3_iCqry","[q]") :- !.
graCR_Suffix2("p3_iCqst","[?]") :- !.
graCR_Suffix2("p3_iCswc","[xc]") :- !.
graCR_Suffix2("p3_iCswp","[xp]") :- !.
graCR_Suffix2("p3_iCmap","[m]") :- !.
graCR_Suffix2("p3_iCpar","[p]") :- !.
graCR_Suffix2("p3_iCbay","[b]") :- !.
graCR_Suffix2("p3_iCand","[&]") :- !.
graCR_Suffix2("p3_iCor","[v]") :- !.
graCR_Suffix2("p3_iCnot","[~]") :- !.
graCR_Suffix2("p3_iCcmb","[c]") :- !.
graCR_Suffix2("p3_iZowa","[zo]") :- !.
graCR_Suffix2("p3_iZand","[za]") :- !.
graCR_Suffix2("p3_iZor","[zo]") :- !.
graCR_Suffix2("p3_iZnot","[z~]") :- !.
graCR_Suffix2(_,"[]") :- !.

graSR_Suffix(R,Suff) :-
    sx::sxUnpack(R,'|',L),
    L=[Chain,Rlm,N,M],
    Ni=sx::toInt(N),
    Mi=sx::toInt(M),
    Loc=dbBase::srLoc(Chain,Rlm,Ni,Mi),
	dbExtension::dbuSR_Type(Loc,No),
	graSR_Suffix2(No,Suff),
	!.
	
graSR_Suffix2(21,"[s]") :- !.
graSR_Suffix2(22,"[p]") :- !.
graSR_Suffix2(62,"[<]") :- !.
graSR_Suffix2(61,"[u]") :- !.
graSR_Suffix2(63,"[>]") :- !.
graSR_Suffix2(64,"[a]") :- !.
graSR_Suffix2(65,"[i]") :- !.
graSR_Suffix2(66,"[r]") :- !.
graSR_Suffix2(67,"[c]") :- !.
graSR_Suffix2(68,"[i]") :- !.
graSR_Suffix2(_,"") :- !.

end implement draw
