/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement filescan
open core
constants
className = "com/rudstrand/filescan/filescan".
classVersion = "1.0".
clauses
classInfo(className, classVersion).
% -------------------------------------------------------------------------------------	
% fscFileScan
% -------------------------------------------------------------------------------------	
class predicates
fscCheck : (string,string) determ (i,i).
fscCheckB : (string,string).
fscCheckNew : (string) determ (i).
fscFileScanOpt : (string,string) determ (i,o).
fscTrace : (string,string) procedure (i,o).
clauses

fscFileScan(Files) :-
	P=globalVars::get_s("std_path"),
	fioExt::filGenName(1,P,"fsc","tmp",InpFile),
	sx::sxlJoin(Files,"\n",Inp),
	file::writeString(InpFile,Inp,false),
	Log=string::concat(P,"\\fscanner.log"),
	Err=string::concat(P,"\\fscanner.err"),
	/* sx::concat(["java com.rudstrand.fileScanner.Main ",InpFile," 3FF ",Log," ",Err," "],Comm2), */
    Px=globalVars::get_s("exe_path"),
	sx::concat(["java -jar ",Px,"\\exe\\net.ligaya.p3.filescanner ",InpFile," 3FF ",Log," ",Err," "],Comm2), 
	fscFileScanOpt(Comm2,Comm3),
	fscTrace(Comm3,Comm4),
	Command=string::concat(Comm4,"\nEXIT"),
	fioExt::filGenName(1,P,"fsc","bat",BatFile),
	file::writeString(BatFile,Command,false),
	platformSupport5x::system(BatFile),
	fscCheck(Log,Err),
	!.

fscTrace(Comm,Command) :-
	tt::getLevel()>=4,
	Command=string::concat(Comm," /TR="),
	!
;
	Command=Comm,
	!.

fscFileScanOpt(Comm,Command) :-
	globalVars::get_i("fs_typ")=2,
	OT=globalVars::get_s("fs_ft"),
	globalVars::get_s("fs_of")="",
	FF=globalVars::get_s("std_path"),
	sx::concat([Comm,"/OT=",OT," /FF=",FF,"\\"],Command),
	!
;	
	globalVars::get_i("fs_typ")=2,
	OT=globalVars::get_s("fs_ft"),
	OF=globalVars::get_s("fs_of"),
	OFP=fioExt::setDefaultPath(OF),
	FF=globalVars::get_s("std_path"),
	sx::concat([Comm,"/OT=",OT," /OF=",OFP," /FF=",FF,"\\"],Command),
	!
;	
	globalVars::get_i("fs_typ")=3,
	OT=globalVars::get_s("fs_ft"),
	FF=globalVars::get_s("std_path"),
	sx::concat([Comm,"/OT=",OT," /FF=",FF,"\\"],Command),
	!.

fscCheck(Log,Err) :-
	programControl::repeat,
	   programControl::sleep(100),
	   file::existfile(Log),
	fscCheckB(Log,Err),
	!.
	
fscCheckB(Log,Err) :-
	file::existfile(Err),
	sx::concat(["Errors were encountered during scanning. Refer to ",Err],Mess),
	dlgIF::dlgNote(1,Mess),
	!
;	   
	sx::concat(["Scanning completed. Refer to output file(s) and ",Log],Mess),
	dlgIF::dlgNote(0,Mess),
	!.
% -------------------------------------------------------------------------------------	
% fscCheckNew
% -------------------------------------------------------------------------------------	
class predicates
fscCheckNewB : (string) determ (i).
clauses
fscCheckNew(File) :-
	programControl::repeat,
	   programControl::sleep(100),
	   file::existfile(File),
	fscCheckNewB(File),
	!.
	
fscCheckNewB(File) :-
	S=file::readString(File),
	S="ERROR",
	dlgIF::dlgNote(1,"Errors were encountered during file processing."),
	!
;	   
	S=file::readString(File),
	S="OK",
	dlgIF::dlgNote(0,"File processing completed"),
	!.
end implement filescan
