/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/
implement init
open core,resourceIdentifiers

constants
className = "com/rudstrand/init/init".
classVersion = "1.0".

class predicates
saveP3_Prefs : ().
saveKB_Prefs : ().

clauses
classInfo(className, classVersion).
% -------------------------------------------------------------------------------------	
% savePrefs
% -------------------------------------------------------------------------------------	
savePrefs() :-
    globalVars::get_i("prefsave")=1,
	AW=guix::getWinOfClas(4),
	OR=vpi::winGetOuterRect(AW),
	CR=vpi::rectGetClient([vpiDomains::wsf_TitleBar,vpiDomains::wsf_Minimize,vpiDomains::wsf_ClipSiblings],b_false,OR),
	NR=vpi::rectOffset(CR,2,2),
	NR=vpiDomains::rct(Xr,Yr,_,_),
	globalVars::set_i("awx",Xr),
	globalVars::set_i("awy",Yr),
    guix::lbxGetAll(AW,idc_query,Qlist),
    sx::sxlJoin(Qlist,";",Q),
    globalVars::set_s("last_query",Q),
    saveP3_Prefs,
    saveKB_Prefs,
    !
;
    !.
% -------------------------------------------------------------------------------------	
% loadP3_Prefs
% -------------------------------------------------------------------------------------	
loadP3_Prefs() :-
    P=globalVars::get_s("exe_path"),
    F=string::concat(P,"\\exe\\pro3.ini"),
	file::existfile(F),
	globalVars::load(F,
	[
	"exe_path",
	"recentK",
	"backup",
	"explain",
	"awx",
	"awy",
	"maxrow",
	"col_shead",
	"col_str",
	"col_int",
	"col_fix",
	"deltax",
	"deltay",
	"col_atom"
	]),
	RecentK=globalVars::getc_s("","recentK"),
	sx::sxUnpack(RecentK,';',Rk),
	fio::addRecentList("K",Rk),
	Dx=globalVars::get_i("deltax"),
	Dy=globalVars::get_i("deltay"),
	guix::setPixelAdjust(Dx,Dy),
	!
;
	!.
% -------------------------------------------------------------------------------------	
% saveP3_Prefs
% -------------------------------------------------------------------------------------	
saveP3_Prefs() :-
    P=globalVars::get_s("exe_path"),
    F=string::concat(P,"\\exe\\pro3.ini"),
    RecentK=fio::getRecent("K"),
    sx::sxlJoin(RecentK,";",RKj),
    globalVars::set_s("recentK",RKj),
	globalVars::save(F,
	[
	"exe_path",
	"recentK",
	"backup",
	"explain",
	"awx",
	"awy",
	"maxrow",
	"col_shead",
	"col_str",
	"col_int",
	"col_fix",
	"deltax",
	"deltay",
	"col_atom"
	]),
	!
;
	!.
% -------------------------------------------------------------------------------------	
% loadKB_Prefs
% -------------------------------------------------------------------------------------	
loadKB_Prefs() :-
    K=globalVars::get_s("kb_file"),
    F=fileName::setExtension(K,"ini"),
	file::existfile(F),
	globalVars::load(F,
	[
	"uc_3nl",
	"uc_3pr",
	"uc_3dl",
	"uc_xml",
	"lang",
	"std_path",
	"scan_path",
	"fscan",
	"fs_ft",
	"fs_of",
	"last_path",
	"last_stype",
	"recentE",
	"recentP",
	"browser",
	"delim",
	"solidcol",
	"last_query",
	"inex",
	"fs_typ",
	"tzonh",
	"tzonm",
	"sdbram",
	"dup_chk",
	"oth_chk",
	"wwwhlp",
	"domlax",
	"re_scan",
	"prefsave",
	"crlog",
	"crdet",
	"rulsta",
	"p3des",
	"idfpop",
	"f_outq",
	"f_wrap",
	"f_atom",
	"f_deeq",
 	"fxdec",
	"fxcom",
	"f_trcm",
	"pran",
	"tablin",
	"f_date",
	"f_daty",
	"f_datm",
	"f_yyyy",
	"f_dats",
	"traceLevel",
	"traceClose"
	]),
	Level=globalVars::getc_i(1,"traceLevel"),
	tt::setLevel(Level),
	Close=globalVars::getc_i(-1,"traceClose"),
	tt::setClose(Close),
	RecentE=globalVars::getc_s("","recentE"),
	RecentP=globalVars::getc_s("","recentP"),
	sx::sxUnpack(RecentE,';',Re),
	sx::sxUnpack(RecentP,';',Rp),
	fio::addRecentList("E",Re),
	fio::addRecentList("P",Rp),
	AW=guix::getWinOfClas(4),
    Q=globalVars::get_s("last_query"),
    sx::sxUnpack(Q,';',Qlist),
    guix::lbxPop(AW,idc_query,Qlist),
    guix::lbtSelectFirst(AW,idc_query),
	!
;
	!.
% -------------------------------------------------------------------------------------	
% saveKB_Prefs
% -------------------------------------------------------------------------------------	
saveKB_Prefs() :-
    K=globalVars::get_s("kb_file"),
    F=fileName::setExtension(K,"ini"),
    Close=tt::getClose(),
    globalVars::set_i("traceClose",Close),
    Level=tt::getLevel(),
    globalVars::set_i("traceLevel",Level),
    RecentE=fio::getRecent("E"),
    RecentP=fio::getRecent("P"),
    sx::sxlJoin(RecentE,";",REj),
    sx::sxlJoin(RecentP,";",RPj),
    globalVars::set_s("recentE",REj),
    globalVars::set_s("recentP",RPj),
	globalVars::save(F,
	[
	"uc_3nl",
	"uc_3pr",
	"uc_3dl",
	"uc_xml",
	"lang",
	"std_path",
	"scan_path",
	"fscan",
	"fs_ft",
	"fs_of",
	"last_path",
	"last_stype",
	"recentE",
	"recentP",
	"browser",
	"delim",
	"solidcol",
	"last_query",
	"inex",
	"fs_typ",
	"tzonh",
	"tzonm",
	"sdbram",
	"dup_chk",
	"oth_chk",
	"wwwhlp",
	"domlax",
	"re_scan",
	"prefsave",
	"crlog",
	"crdet",
	"rulsta",
	"p3des",
	"idfpop",
	"f_outq",
	"f_wrap",
	"f_atom",
	"f_deeq",
 	"fxdec",
	"fxcom",
	"f_trcm",
	"pran",
	"tablin",
	"f_date",
	"f_daty",
	"f_datm",
	"f_yyyy",
	"f_dats",
	"traceLevel",
	"traceClose"
	]),
	!
;
	!.
% -------------------------------------------------------------------------------------	
% globals
% -------------------------------------------------------------------------------------	
globals() :-
% save-able system globals
% 
	globalVars::set_s("exe_path","c:\\pro3"),	% pro/3 root dir
	globalVars::set_i("backup",-1), % 1/-1 on/off backup scheme
	globalVars::set_i("explain",1),   % -1/1 detailed explanations ON
	globalVars::set_i("maxrow",30),   % max. visible table rows
    globalVars::set_i("col_int",0x00DCF5F5),
    globalVars::set_i("col_str",0x00DCF5F5),
    globalVars::set_i("col_fix",0x00DCF5F5),
    globalVars::set_i("deltax",100), % pixel adjuster 
    globalVars::set_i("deltay",100), % pixel adjuster
    globalVars::set_i("col_atom",0x00DCF5F5),
    globalVars::set_i("col_shead",0x00D3D3D3),
%
% non-save-able system globals
%
	globalVars::set_i("p3v",1), % program version
	globalVars::set_i("p3r",1), % program sub-version
	globalVars::set_i("p3b",1), % program release
	globalVars::set_s("p3s","XP/W2K Beta"),
	globalVars::set_s("p3d","05-Apr-2007"),
	globalVars::set_i("assready",-1), % assistant window ready for guide-notes -1/1
	globalVars::set_i("server",-1), % -1/1 server-mode
	globalVars::set_i("request_no",0), % request no currently being processed
	globalVars::set_i("request_subno",0), % request subno currently being processed
	globalVars::set_i("request_sols",0), % request solution counter
%
% KB-GLOBALS
%
% save-able globals (text)
%
	globalVars::set_s("lang","p3_iEngl"),	     % current language
	globalVars::set_s("std_path",""),	  	          % source file dir
	globalVars::set_s("scan_path",""),	             % scan dir
	globalVars::set_s("fscan",""),	  % file scanner output file  
	globalVars::set_s("fs_ft",""),	% file scanner file output type (fs_typ=2) output file (fs_typ=3)
	globalVars::set_s("fs_of",""),	% output file path (only fs_typ=2)
	globalVars::set_s("last_path",""),	  % last used source file path
	globalVars::set_s("last_stype","3dl"),	  % last used scan file type
	globalVars::set_s("browser","C:\\Program Files\\Internet Explorer\\Iexplore.exe"), 	% browser dir
	globalVars::set_s("delim",";"),        % default delimited format delimiter
	globalVars::set_s("last_query",""),        % last query in KE asst window
	globalVars::set_s("inex","INEXACT_RULES"),  % default realm name for inexact rules
%
% non-save-able globals (text)
%
	globalVars::set_s("ms1",""),	     % status line component 1
	globalVars::set_s("ms2",""),	     % do. 2
	globalVars::set_s("kb_file",""),       	% KB file name (incl. path)
	globalVars::set_s("kb_id","A"),        	% KB id
	globalVars::set_s("kb_idf",""),        	% KB id (read from 3FL file)
%
% save-able globals (integers)
%
	globalVars::set_i("solidcol",1), % -1/1 solid colors in graphs
	globalVars::set_i("uc_3nl",1),	% unicode
	globalVars::set_i("uc_3pr",1),	% unicode
	globalVars::set_i("uc_3dl",1),	% unicode
	globalVars::set_i("uc_xml",1),	% unicode
	globalVars::set_i("fs_typ",2),	% file scanning to: 2=files, 3=file
	globalVars::set_i("tzonh",0),  % timezone (hours) signed 
	globalVars::set_i("tzonm",0),  % do. minutes 
	globalVars::set_i("sdbram",2),    % sdb loading: 0=disk, 1=dynamic, 2=ram,
	globalVars::set_i("dup_chk",1),   % duplicate fact checking ON/OFF (1/-1)
	globalVars::set_i("oth_chk",1),   % other error checking ON/OFF (1/-1)
	globalVars::set_i("wwwhlp",1),     % -1/1 use www help 
	globalVars::set_i("domlax",1),    % -1 strict domain compatibility check; 1=laxed
	globalVars::set_i("re_scan",1000),  % rescanning threshold
	globalVars::set_i("prefsave",1),      % -1/1 always save preferences upon exit
	globalVars::set_i("crlog",1),     % CR reasoning sentence tree log on/off (1/-1)
	globalVars::set_i("crdet",-1),     % CR reasoning sentence details log on/off (1/-1)
	globalVars::set_i("rulsta",1),    % save rules as active (1); inactive (-1)
	globalVars::set_i("p3des",1),   % include Pro/3 DEs in rule editor
	globalVars::set_i("idfpop",1),    % 1=populate rule editor IDF boxes only identifiers; -1=populate with all
	globalVars::set_i("f_outq",8),    % 0: no output
	                             % 1: NL
	                             % 2: NC 
				                 % 3: tabular with heading
				                 % 4: tabular without heading
				                 % 5: delimited with heading
				                 % 6: delimited without heading
				                 % 7: dde export to excel
				                 % 8: table window
				                 % 9: PR
				                 % 10: xml/nl
				                 % 11: xml/pr
				                 % Negative value if all multi-query output to one file only (only for 1,2,3,4,9,10,11). Otherwise, there will be one file per query.
				                 % 7-8 do not generate files.
	globalVars::set_i("f_wrap",1),    % -1/1: editor line wrap
	globalVars::set_i("f_atom",1),    % NL atomic format: 1=postDE  2=preDE  3=full
	globalVars::set_i("f_deeq",1),    % NL ET format: -1/1 use = operator for DEs
 	globalVars::set_i("fxdec",2),     % default no. of decimals in numbers
	globalVars::set_i("fxcom",1),     % 0/1: default comma indicator in numbers
	globalVars::set_i("f_trcm",1),    % -1/1 tree compression
	globalVars::set_i("pran",1),      % -1/1 include annotation in print-outs where relevant
	globalVars::set_i("tablin",15),   % max. no of rows in table windows
	% date options
	globalVars::set_i("f_date",1),	% 1=external date other than YYYYMMDD; 2=YYYYMMDD
	                                % 0=internal date (1.1.1970 is 1) (int)
	globalVars::set_i("f_daty",1),	% 1=yyyy; 0=yy
	globalVars::set_i("f_datm",1),	% 1=mmm; 0=mm
	globalVars::set_i("f_yyyy",50),	% YY<50 => 20YY
	globalVars::set_s("f_dats","-"),	% separation character
	globalVars::set_i("awx",15),
	globalVars::set_i("awy",45),
%
% non-save-able globals (integers)
%
	globalVars::set_i("p3up",-1), % -1/1 if KB was upgraded during opening
	globalVars::set_i("backup_active",-1), % -1/1 backup system is active
	globalVars::set_i("knowopen",0),  % 0=KB closed; 1=open; 2=open&updated
	globalVars::set_i("knowerr",0) ,  % 1=errors since last open/save; 0=else
	globalVars::set_i("nkbs",0),      % no of external KBs open
	globalVars::set_i("ixrg",-1),     % index regeneration required (1/-1)
	globalVars::set_i("sdbopen",0),   % 0=SDB closed; 1=SDB open in RAM; 2=SDB open on disk	
	globalVars::set_i("msgon",1),     % -1/1 normal messages on
	globalVars::set_i("inter",1),     % -1/1 interactive mode (-1 suppresses prompt-type messages) 
	globalVars::set_i("quit_flag",0), % set to 1 when quit is requested
	globalVars::set_i("error_flag",0),% set to 1 when an error has been detected. 
	globalVars::set_i("all_flag",-1), % set to 1 when 'yes all' has been selected - valid until next setting
	                               % all other values mean that the flag is off. this flag is used both in tne context of replacing 
	                               % existing records and in the context of deleting/suspending dependent records
	globalVars::set_i("all_del",-1),  % -1 suspension; 1 eletion of dependent records (if ALL flag is set)
	
	globalVars::set_i("sent_count",0),% input sentence counter (within dialog: 1,2,3,...)
	globalVars::set_i("syn_max",0),   % word counter for detecting syntax analysis point of failure
	globalVars::set_i("sub_no",0),    % sub sentence counter (within dialog: 1,2,3,...)
	globalVars::set_i("pre_cnt",0),   % - variable postfix used in syntax analysis
	                               % - prefix no. counter used in tbq parser
				       % - for generating pure variables in various constructions
	globalVars::set_i("ram_util",0),  % highest ram usage 
	globalVars::set_i("solref",0),     % counter for PIE solution set reference no's (external sets) (1,2,...)
	globalVars::set_i("solint",0),     % do. internal sets (-1,-2,...)
	globalVars::set_i("solcnt0",0),    % solution counter (current external set)
	globalVars::set_i("solcnt1",0),    % solution counter (current external set)
	globalVars::set_i("solcnt2",0),    % solution counter (current external set)
	globalVars::set_i("solcnt3",0),    % solution counter (current external set)
	globalVars::set_i("solcnt4",0),    % solution counter (current external set)
	globalVars::set_i("piercl",0),     % pie recursion level counter: 1=external level, 2,3,... internal levels
	globalVars::set_i("piecal",0),     % total no. of solution set re-uses
	globalVars::set_i("sol_comp",0),
	globalVars::set_i("intr_count",0),
	globalVars::set_i("crcnt",0),     % CR reasoning sentence tree node counter
	globalVars::set_i("max_tok",32),  % max. length of token
	globalVars::set_i("max_kbn",32),  % max. length of KB name 
	globalVars::set_i("max_rln",32),  % max. length of realm name
	H=vpi::getAttrVal(vpiDomains::attr_screen_height),
	Hi=H,
	W=vpi::getAttrVal(vpiDomains::attr_screen_width),
	Wi=W,
	globalVars::set_i("scrx",Wi),
	globalVars::set_i("scry",Hi),
%
% non-save-able globals (reals)
%
	globalVars::set_n("timer",0.0),    % -1.0: no timer, else timer stop-time
    !.
% -------------------------------------------------------------------------------------	
% exeDir
% -------------------------------------------------------------------------------------	
exeDir() :-
    D=globalVars::get_s("exe_path"),
    directory::existDirectory(D),
    F=string::concat(D,"\\exe\\pro3.exe"),
    file::existfile(F),
    !
;
    D=directory::getCurrentDirectory(),
    F=string::concat(D,"\\pro3.exe"),
    file::existfile(F),
    sx::sxTail(4,D,Fr,T),
    string::toLowercase(T)="\\exe",
    globalVars::set_s("exe_path",Fr),
    !
;
    D="c:\\pro3",
    directory::existDirectory(D),
    F=string::concat(D,"\\exe\\pro3.exe"),
    file::existfile(F),
    globalVars::set_s("exe_path",D),
    !
;
	S=vpiCommonDialogs::getString("Pro/3","Please enter Pro/3 root directory path",""),
	sx::sxRemoveTail(S,"\\",S2),
    globalVars::set_s("exe_path",S2),
	exeDir(),
	!.	
% -------------------------------------------------------------------------------------	
% dbaIxSetLengths
% -------------------------------------------------------------------------------------	
dbaIxSetLengths() :-
	M=globalVars::get_i("max_kbn"),
	N=globalVars::get_i("max_rln"),
	T=globalVars::get_i("max_tok"),
	L2=M*3+2,
	globalVars::set_i("ix_relarg",L2),
	L3=M+T+1,
	globalVars::set_i("ix_token",L3),
	L4=M*2+1,
	globalVars::set_i("ix_syn1",L4),
	L5=M*3+2,
	globalVars::set_i("ix_syn2",L5),
	L6=M*4+3,
	globalVars::set_i("ix_syn3",L6),
	L7=M+32+2+3+3,
	globalVars::set_i("ix_rule",L7),
	L8=3+M+1,
	globalVars::set_i("ix_rtyp",L8),
	L9=N+1+1,
	globalVars::set_i("ix_realm",L9),
	L10=M+2,
	globalVars::set_i("ix_crt",L10),
	globalVars::set_i("ix_dbrf",13), 
	!.
% -------------------------------------------------------------------------------------	
% adjustDirs
% -------------------------------------------------------------------------------------	
class predicates
adjDir : (string,string,string) procedure (i,i,o).
clauses

adjustDirs() :-
    D=globalVars::get_s("kb_file"),
    Pb=filename::getPath(D),
    sx::sxRemoveTail(Pb,"\\",P),
    Dst=globalVars::get_s("std_path"),
    Dsc=globalVars::get_s("scan_path"),
    Dla=globalVars::get_s("last_path"),
    adjDir(Dst,P,Dstx),
    adjDir(Dsc,P,Dscx),
    adjDir(Dla,P,Dlax),
    globalVars::set_s("std_path",Dstx),
    globalVars::set_s("scan_path",Dscx),
    globalVars::set_s("last_path",Dlax),
    !.
    
adjDir(D,Dd,Da) :-
        directory::existDirectory(D),
        Da=D,
        !
;
        Da=Dd,
        !.
end implement init
