/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement inputfacility
open core,termDomain,globalDomains

constants
className = "com/rudstrand/inputfacility/inputfacility".
classVersion = "1.0".

class predicates
getAnswers : (odbcConnection,string,string_list,string_list) determ (i,i,o,o).
makeClusterCtls : (integer,integer,integer,integer,integer,string_list,string_list,sterml,vpiDomains::windef_list) determ (i,i,i,i,i,i,i,i,o).
makeSeriesCtls : (integer,integer,integer,integer,integer,string,sterml,string,string,string,vpiDomains::windef_list) determ (i,i,i,i,i,i,i,i,i,i,o).
computeWidths : (string_list,string_list,sterml,integer,integer,integer) determ (i,i,i,o,o,o).    
storeSeries : (string_list,string,sterml,string,string,string,string,string,string_list,string_list) determ (i,i,i,i,i,i,i,i,o,o).

clauses
classInfo(className, classVersion).
% ---------------------------------------------------------------------------------------------------------------
% executeCluster
% ---------------------------------------------------------------------------------------------------------------
class predicates
executeClusterDirect : (string,string_list,string_list,sterml,string_list,string_list) determ (i,i,i,i,o,o).
executeClusterServer : (odbcConnection,string,integer,string,string_list,string_list,sterml,string_list,string_list) determ (i,i,i,i,i,i,i,o,o).
clauses

executeCluster(Prompt,Rules,SPars,APars,Questions,Answers) :-
    globalVars::get_i("server")=1,
    !,
	R=globalVars::get_i("request_no"),
	Rs=toString(R),
	ODBC=sqlBase::getConnection(),
    executeClusterServer(ODBC,Rs,1,Prompt,Rules,SPars,APars,Questions,Answers),
    !
;
    executeClusterDirect(Prompt,Rules,SPars,APars,Questions,Answers),
    !.

executeClusterDirect(Prompt,Rules,SPars,APars,Questions,Answers) :-
    computeWidths(Rules,SPars,APars,X1,X2,X3),
    X123=X1+X2+X3+110,
    set::setMax([X123,354],Xwin),
    set::size(Rules,N),
    Ywin=N*12+55,
    makeClusterCtls(6001,60,X1,X2,X3,Rules,SPars,APars,Ctls),
    W=guix::getWinOfClas(1),
    Dlg=questioncluster::new(),
    Dlg:show(W,Ctls,Prompt,Xwin,Ywin,Rules),
    L1=globalVars::popRetPars(),
    L1=["1"],
    Answers=globalVars::popRetPars(),
    Questions=globalVars::popRetPars(),
    !.        

executeClusterServer(ODBC,Rs,N,Prompt,[],_,_,Questions,Answers) :-
    M=N-1,
    Ns=toString(M),
    S=string::concatList(["insert into p3bridge.p3input_facility (request_no,facility_type,no_of_questions,status,prompt) values (",
                                    Rs,",2,",Ns,",1,'",Prompt,"')"]),
    sqlTools::executeDirect(ODBC,S),
    getAnswers(ODBC,Rs,Questions,Answers),
    !.
executeClusterServer(ODBC,Rs,N,Prompt,[R|Rules],SPars,APars,Questions,Answers) :-
    dbExtension::getQuestion(R,Question,QDom,Def),
  	nl::conValX(Def,QDom,"",DefS),
    irbase::unpackQuestion(Question,QDom,QuestionU,AltsNL),  
    dbBase::nlSing(R,Rn),
    dbBase::nlSing(QDom,DomNL),
    irbase::setInpFacPars(R,QuestionU,SPars,APars,Qn),
	dbExtension::kbGetAnnotationBlank("p3_iIR",R,Anno),
    Ns=toString(N),
    set::size(AltsNL,M),
    Ms=toString(M),
    S=string::concatList(["insert into p3bridge.p3question (request_no,question_no,question_type,question,status,default_answer,question_help,rule,domain) values (",
                                    Rs,",",Ns,",",Ms,",'",Qn,"',1,'",DefS,"','",Anno,"','",Rn,"','",DomNL,"')"]),
    sqlTools::executeDirect(ODBC,S),
    proc::storeAlts(ODBC,Rs,Ns,1,AltsNL),
    Next=N+1,
    executeClusterServer(ODBC,Rs,Next,Prompt,Rules,SPars,APars,Questions,Answers),
    !.        
% ---------------------------------------------------------------------------------------------------------------
% executeSeries
% ---------------------------------------------------------------------------------------------------------------
class predicates
executeSeriesDirect : (string,string,sterm,string,string,termSet,string,string_list,string,string_list,string_list) determ (i,i,i,i,i,i,i,i,i,o,o).
executeSeriesServer : (string,string,sterm,string,string,termSet,string,string_list,string,string_list,string_list) determ (i,i,i,i,i,i,i,i,i,o,o).
clauses

executeSeries(Prompt,QstRule,Default,QstPar,Dom,Set,QuestionU,AltsNL,QDom,Questions,Answers) :-
    globalVars::get_i("server")=1,
    !,
    executeSeriesServer(Prompt,QstRule,Default,QstPar,Dom,Set,QuestionU,AltsNL,QDom,Questions,Answers),
    !
;    
    executeSeriesDirect(Prompt,QstRule,Default,QstPar,Dom,Set,QuestionU,AltsNL,QDom,Questions,Answers),
    !.

executeSeriesDirect(Prompt,QstRule,Default,QstPar,Dom,Set,QuestionU,AltsNL,QDom,Questions,Answers) :-
    set::size(AltsNL,NAlts),
    NAlts>0,
    !,
    L=Set:get(),
    set::size(L,Ln),
    L=[H|_],
    irbase::setInpFacPars(QstRule,QuestionU,[QstPar],[H],QuestionSample),
 	X1=string::length(QuestionSample)+10,
 	X1P=(guix::pixelsUC(1,X1)*4) div 10,
    X2=sx::maxLength(AltsNL),
 	X2P=(guix::pixelsUC(1,X2)*5) div 10,
    X12=(X1P+X2P)+60,
    set::setMax([X12,355],Xwin),    
    nl::conValX(Default,QDom,"",DefaultS),
    makeSeriesCtls(6001,84,X1P,X2P,NAlts,QstRule,L,DefaultS,QuestionU,QstPar,Ctls),
    Ywin=80+12*Ln,    
    dbBase::nlSing(Dom,DomNL),
    dbBase::nlSing(QstRule,Rule),
	dbExtension::kbGetAnnotationBlank("p3_iIR",QstRule,Anno),
    W=guix::getWinOfClas(1),
    Dlg=questionseries::new(),
    Dlg:show(W,Ctls,Prompt,Ln,Xwin,Ywin,AltsNL,DefaultS,Rule,DomNL,Anno),
    L1=globalVars::popRetPars(),
    L1=["1"],
    Answers=globalVars::popRetPars(),
    Questions=globalVars::popRetPars(),
    !
;    
    L=Set:get(),
    set::size(L,Ln),
    L=[H|_],
    irbase::setInpFacPars(QstRule,QuestionU,[QstPar],[H],QuestionSample),
 	X1=string::length(QuestionSample)+10,
 	X1P=(guix::pixelsUC(1,X1)*4) div 10,
    nl::conValX(Default,QDom,"",DefaultS),
    X2=string::length(DefaultS)*3,
 	X2P=(guix::pixelsUC(1,X2)*5) div 10,
    X12=(X1P+X2P)+60,
    set::setMax([X12,355],Xwin),    
    makeSeriesCtls(6001,84,X1P,X2P,0,QstRule,L,DefaultS,QuestionU,QstPar,Ctls),
    Ywin=80+12*Ln,    
    dbBase::nlSing(Dom,DomNL),
    dbBase::nlSing(QstRule,Rule),
	dbExtension::kbGetAnnotationBlank("p3_iIR",QstRule,Anno),
    W=guix::getWinOfClas(1),
    Dlg=questionseries::new(),
    Dlg:show(W,Ctls,Prompt,Ln,Xwin,Ywin,[],DefaultS,Rule,DomNL,Anno),
    L1=globalVars::popRetPars(),
    L1=["1"],
    Answers=globalVars::popRetPars(),
    Questions=globalVars::popRetPars(),
    !.

executeSeriesServer(Prompt,QstRule,Default,QstPar,Dom,Set,QuestionU,AltsNL,QDom,Questions,Answers) :-
    L=Set:get(),
    nl::conValX(Default,QDom,"",DefaultS),
    dbBase::nlSing(Dom,DomNL),
    storeSeries(AltsNL,QstRule,L,DefaultS,QuestionU,DomNL,QstPar,Prompt,Questions,Answers),
    !.
% ---------------------------------------------------------------------------------------------------------------
% makeClusterCtls
% ---------------------------------------------------------------------------------------------------------------
% parameters:
% 0 in #alternatives (or 0 if no alts)
% 1 in question rule
% 2 in substitute values
% 3 in default answer
% 4 in question parameter to be substituted
% 5 out table rows
% 6 out question texts
%
makeClusterCtls(_,_,_,_,_,[],_,_,[]) :-
    !.
makeClusterCtls(No1,Y,X1,X2,X3,[R|Rules],SPars,APars,[Ctl1,Ctl2,Ctl3,Ctl4,Ctl5|Ctls]) :-
    dbExtension::getQuestion(R,Question,QDom,_),
    irbase::unpackQuestion(Question,QDom,QuestionU,AltsNL),  
    set::size(AltsNL,N),
    N>0,
    !,
    dbBase::nlSing(R,Rn),
    dbBase::nlSing(QDom,DomNL),
    irbase::setInpFacPars(R,QuestionU,SPars,APars,Qn),
    No2=No1+1,
    No3=No1+2,
    No4=No1+3,
    No5=No1+4,
    Y2=Y+10,       
    X22=17+X1,
    X31=X22+2,
    X32=X1+X2-1,
    X41=X32+2,
    X42=X41+X3-1,
    Y42=Y+11*N+10,
    X51=X42+2,
    X52=X51+49,
    Ctl1=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_PushButton,vpiDomains::rct(4,Y,16,Y2),"?",vpiDomains::u_DlgBase),No1,[vpiDomains::wsf_Group,vpiDomains::wsf_TabStop]),
    Ctl2=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(18,Y,X22,Y2),Rn,vpiDomains::u_DlgBase),No2,[vpiDomains::wsf_AlignLeft]),
    Ctl3=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(X31,Y,X32,Y2),Qn,vpiDomains::u_DlgBase),No3,[vpiDomains::wsf_AlignRight]),
    Ctl4=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_LBoxButton,vpiDomains::rct(X41,Y,X42,Y42),"",vpiDomains::u_DlgBase),No4,[vpiDomains::wsf_Group,vpiDomains::wsf_TabStop,vpiDomains::wsf_VScroll]),
    Ctl5=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(X51,Y,X52,Y2),DomNL,vpiDomains::u_DlgBase),No5,[vpiDomains::wsf_AlignLeft]),
    NextNo=No1+5,
    NextY=Y+12,
    makeClusterCtls(NextNo,NextY,X1,X2,X3,Rules,SPars,APars,Ctls),
    !
;    
    dbExtension::getQuestion(R,Question,QDom,Default),
	nl::conValX(Default,QDom,"",DefaultS),
    irbase::unpackQuestion(Question,QDom,QuestionU,_),  
    dbBase::nlSing(R,Rn),
    dbBase::nlSing(QDom,DomNL),
    irbase::setInpFacPars(R,QuestionU,SPars,APars,Qn),
    No2=No1+1,
    No3=No1+2,
    No4=No1+3,
    No5=No1+4,
    Y2=Y+10,       
    X22=17+X1,
    X31=X22+2,
    X32=X1+X2-1,
    X41=X32+2,
    X42=X41+X3-1,
    X51=X42+2,
    X52=X51+49,
    Ctl1=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_PushButton,vpiDomains::rct(4,Y,16,Y2),"?",vpiDomains::u_DlgBase),No1,[vpiDomains::wsf_Group,vpiDomains::wsf_TabStop]),
    Ctl2=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(18,Y,X22,Y2),Rn,vpiDomains::u_DlgBase),No2,[vpiDomains::wsf_AlignLeft]),
    Ctl3=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(X31,Y,X32,Y2),Qn,vpiDomains::u_DlgBase),No3,[vpiDomains::wsf_AlignRight]),
    Ctl4=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Edit,vpiDomains::rct(X41,Y,X42,Y2),DefaultS,vpiDomains::u_DlgBase),No4,[vpiDomains::wsf_Group,vpiDomains::wsf_TabStop,vpiDomains::wsf_HScroll,vpiDomains::wsf_AlignLeft]),
    Ctl5=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(X51,Y,X52,Y2),DomNL,vpiDomains::u_DlgBase),No5,[vpiDomains::wsf_AlignLeft]),
    NextNo=No1+5,
    NextY=Y+12,
    makeClusterCtls(NextNo,NextY,X1,X2,X3,Rules,SPars,APars,Ctls),
    !.
% ---------------------------------------------------------------------------------------------------------------
% storeSeries
% ---------------------------------------------------------------------------------------------------------------
class predicates
storeQuestionSeries : (odbcConnection,integer,string,sterml,string_list,string,string,string,string,string,string,string) determ.
clauses

storeSeries(AltsNL,Rule,L,Def,QuestionU,DomNL,QstPar,Prompt,Questions,Answers) :-
    set::size(L,N),
    Ns=toString(N),
	R=globalVars::get_i("request_no"),
	Rs=toString(R),
	dbExtension::kbGetAnnotationBlank("p3_iIR",Rule,Anno),
	dbBase::nlSing(Rule,RuleNL),
	ODBC=sqlBase::getConnection(),
    storeQuestionSeries(ODBC,1,Rs,L,AltsNL,Rule,RuleNL,Def,DomNL,Anno,QuestionU,QstPar),
    S=string::concatList(["insert into p3bridge.p3input_facility (request_no,facility_type,no_of_questions,status,prompt) values (",
                                    Rs,",1,",Ns,",1,'",Prompt,"')"]),
    sqlTools::executeDirect(ODBC,S),
    getAnswers(ODBC,Rs,Questions,Answers),
    !.

storeQuestionSeries(_,_,_,[],_,_,_,_,_,_,_,_) :-
    !.
storeQuestionSeries(ODBC,N,RNoS,[V|Vs],AltsNL,Rule,RuleNL,Def,DomNL,Anno,Q,Par) :-
    Ns=toString(N),
    irbase::setInpFacPars(Rule,Q,[Par],[V],Question),
    set::size(AltsNL,M),
    Ms=toString(M),
    S=string::concatList(["insert into p3bridge.p3question (request_no,question_no,question_type,question,status,default_answer,question_help,rule,domain) values (",
                                    RNoS,",",Ns,",",Ms,",'",Question,"',1,'",Def,"','",Anno,"','",RuleNL,"','",DomNL,"')"]),
    sqlTools::executeDirect(ODBC,S),
    proc::storeAlts(ODBC,RNoS,Ns,1,AltsNL),
    Next=N+1,
    storeQuestionSeries(ODBC,Next,RNoS,Vs,AltsNL,Rule,RuleNL,Def,DomNL,Anno,Q,Par),
    !.
% ---------------------------------------------------------------------------------------------------------------
% getAnswers
% ---------------------------------------------------------------------------------------------------------------
class predicates
checkAnswer : (count,odbcConnection,string,string_list,string_list) determ (i,i,i,o,o).        
checkBreak : (string,integer,odbcConnection,integer,integer,string_list,string_list) determ (i,i,i,i,i,o,o).    
clauses

getAnswers(ODBC,Rs,Questions,Answers) :-
    Counter=count::new(3),
    programControl::sleep(3000),
    programControl::repeat,
        programControl::sleep(1000),
        Counter:add(1,_),
        checkAnswer(Counter,ODBC,Rs,Questions,Answers),
        !.

checkAnswer(Counter,ODBC,Rs,Questions,Answers) :-
    S=string::concat("select request_status from p3bridge.p3request where request_no=",Rs),
    Sql=sqlSelect::new(ODBC,S),
    Status=Sql:getI(1,1),
    Status<0,
    % user break or other error 
    ir::setBreak(1),
    Questions=[],
    Answers=[],
    !
;
    Counter:get()>90,
    ir::setBreak(2),
    S5=string::concat("update p3bridge.p3request set request_status=-12 where request_no=",Rs),
    sqlTools::executeDirect(ODBC,S5),
    Questions=[],
    Answers=[],
    !
;    
    S=string::concat("select status,no_of_questions from p3bridge.p3input_facility where status>=3 and request_no=",Rs),
    Sql=sqlSelect::new(ODBC,S),
    Status=Sql:getI(1,1),
    N=Sql:getI(1,2),
    checkBreak(Rs,Status,ODBC,1,N,Questions,Answers),
    S3=string::concat("delete from p3bridge.p3question where question_no>0 and request_no=",Rs),
    sqlTools::executeDirect(ODBC,S3),
    S4=string::concat("delete from p3bridge.p3answer where question_no>0 and request_no=",Rs),
    sqlTools::executeDirect(ODBC,S4),
    S5=string::concat("delete from p3bridge.p3input_facility where request_no=",Rs),
    sqlTools::executeDirect(ODBC,S5),
    !.

checkBreak(Rs,Status,ODBC,N,Max,Questions,Answers) :-
    N>Max,
    Questions=[],
    Answers=[],
    !
/*
;    
    Status=4,
    ir::setBreak(1),
    Questions=[],
    Answers=[],
    !
*/    
;
    Ns=toString(N),
    S=string::concat("select question,answer from p3bridge.p3question where request_no=",Rs," and question_no=",Ns),
    Sql=sqlSelect::new(ODBC,S),
    Q=Sql:getS(1,1),
    A=Sql:getS(1,2),
    Next=N+1,
    checkBreak(Rs,Status,ODBC,Next,Max,Qs,As),
    Questions=[Q|Qs],
    Answers=[A|As],
    !.    
% ---------------------------------------------------------------------------------------------------------------
% makeSeriesCtls
% ---------------------------------------------------------------------------------------------------------------
% parameters:
% 0 in #alternatives (or 0 if no alts)
% 1 in question rule
% 2 in substitute values
% 3 in default answer
% 4 in question parameter to be substituted
% 5 out table rows
% 6 out question texts
%
makeSeriesCtls(_,_,_,_,_,_,[],_,_,_,[]) :-
    !.
makeSeriesCtls(No,Y,X1,X2,NAlts,Rule,[V|Vs],Default,Q,Par,[Ctl1,Ctl2|Ctls]) :-
    NAlts>0,
    irbase::setInpFacPars(Rule,Q,[Par],[V],Question),
    XP4=X1+4,
    YP10=Y+10,
    XP8=X1+8,
    XP8PX2=XP8+X2,
    Y2=Y+12*NAlts,
    NoP1=No+1,
    Ctl1=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(4,Y,XP4,YP10),Question,vpiDomains::u_DlgBase),No,[vpiDomains::wsf_AlignRight]),
    Ctl2=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_LBoxButton,vpiDomains::rct(XP8,Y,XP8PX2,Y2),"",vpiDomains::u_DlgBase),NoP1,[vpiDomains::wsf_Group,vpiDomains::wsf_TabStop,vpiDomains::wsf_VScroll]),
    Next=No+2,
    NextY=Y+12,
    makeSeriesCtls(Next,NextY,X1,X2,NAlts,Rule,Vs,Default,Q,Par,Ctls),
    !
;    
    NAlts=0,
    irbase::setInpFacPars(Rule,Q,[Par],[V],Question),
    XP4=X1+4,
    YP10=Y+10,
    XP8=X1+8,
    XP8PX2=XP8+X2,
    NoP1=No+1,
    Ctl1=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Text,vpiDomains::rct(4,Y,XP4,YP10),Question,vpiDomains::u_DlgBase),No,[vpiDomains::wsf_AlignRight]),
    Ctl2=vpiDomains::ctl(vpiDomains::wdef(vpiDomains::wc_Edit,vpiDomains::rct(XP8,Y,XP8PX2,YP10),Default,vpiDomains::u_DlgBase),NoP1,[vpiDomains::wsf_AlignLeft,vpiDomains::wsf_Group,vpiDomains::wsf_TabStop,vpiDomains::wsf_AutoHScroll]),
    Next=No+2,
    NextY=Y+12,
    makeSeriesCtls(Next,NextY,X1,X2,NAlts,Rule,Vs,Default,Q,Par,Ctls),
    !.
% ---------------------------------------------------------------------------------------------------------------
% computeWidths
% ---------------------------------------------------------------------------------------------------------------
computeWidths([],_,_,0,0,0) :-
    !.
computeWidths([R|Rules],SPars,APars,X1s,X2s,X3s) :-
    dbExtension::getQuestion(R,Question,QDom,_),
    irbase::unpackQuestion(Question,QDom,QuestionU,AltsNL),  
    irbase::setInpFacPars(R,QuestionU,SPars,APars,QuestionP),
    set::size(AltsNL,N),
    N>0,
    dbBase::nlSing(R,Rn),
    X1=(guix::pixels(1,Rn)*8) div 10,
    X2=(guix::pixels(1,QuestionP)*8) div 10,
    Max=sx::maxLength(AltsNL),
 	X3=(guix::pixelsUC(1,Max)*5) div 10,    
    computeWidths(Rules,SPars,APars,X1m,X2m,X3m),
    set::setMax([X1,X1m],X1s),
    set::setMax([X2,X2m],X2s),
    set::setMax([X3,X3m],X3s),
    !
;      
    dbExtension::getQuestion(R,Question,QDom,Default),
    irbase::unpackQuestion(Question,QDom,QuestionU,AltsNL),  
    irbase::setInpFacPars(R,QuestionU,SPars,APars,QuestionP),
    set::size(AltsNL,N),
    N=0,
    dbBase::nlSing(R,Rn),
    X1=(guix::pixels(1,Rn)*8) div 10,
    X2=(guix::pixels(1,QuestionP)*8) div 10,
    nl::conValX(Default,QDom,"",DefaultS),
 	X3=guix::pixels(1,DefaultS),    
    computeWidths(Rules,SPars,APars,X1m,X2m,X3m),
    set::setMax([X1,X1m],X1s),
    set::setMax([X2,X2m],X2s),
    set::setMax([X3,X3m],X3s),
    !.
end implement inputfacility
