/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class kbBase
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.
% returns the definition of an attribute type (given KB name)
kbDE_Def : (string,sterm) procedure (i,o).
kbDE_DefF : (string,sterm,chainDB::ref) determ (i,o,o).
kbDE_List : (sterml,string_list) determ (i,o).
% returns the definition of an entity type (given KB name)
kbEntityDef : (string,sterm,string_list) determ (i,o,o).
kbEntityDefF : (string,sterm,string_list,chainDB::ref) determ (i,o,o,o).
% returns the KB id/class/form of an un-tokenized NL string 
kbID_Ref : (string,string,string,string,chainDB::ref,string) determ (i,o,o,o,o,o).
kbID_RefF : (string,string,string,string,chainDB::ref,string) determ (i,o,o,o,o,o).
kbID_Refs : (string_list,string_list,string_list,string_list,ref_list) determ (i,o,o,o,o).
kbID_RefsF : (string_list,string_list,string_list,string_list,ref_list) determ (i,o,o,o,o).
kbID_Delete : (string NL).
% inexact rule definition
irDeclaration : (string,string,sterml,string_list,chainDB::ref) determ (i,o,o,o,o).
irDeclarationF : (string,string,sterml,string_list,chainDB::ref) determ (i,o,o,o,o).
% function definition
funcDef : (string,string,string,sterml,string_list,chainDB::ref) determ (i,o,o,o,o,o).
funcDefF : (string,string,string,sterml,string_list,chainDB::ref) determ (i,o,o,o,o,o).
% returns the definition of a predicate type (given KB name)
kbPredDef : (string KName,string Clas,integer Card,sterm Def,string_list DEs) determ (i,o,o,o,o).
kbPredDefF : (string,string,integer,sterm,string_list,chainDB::ref) determ (i,o,o,o,o,o).
% from NL string to (PRED|ENT1[|ENT2])
kbSM_Ref : (string,chainDB,chainDB::ref) determ (i,o,o).
kbSM_RefF : (string,chainDB,chainDB::ref) determ (i,o,o).
kbSM_ClassRef : (string,string,chainDB,chainDB::ref) determ (i,i,o,o).
kbSM_ClassRefF : (string,string,chainDB,chainDB::ref) determ (i,i,o,o).
% returns SM definitions
kbSM : (string,string,string,sterm,chainDB,chainDB::ref) determ (i,o,o,o,o,o).
kbSM_F : (string,string,string,sterm,chainDB,chainDB::ref) determ (i,o,o,o,o,o).
kbSMs : (sterm,string_list,string_list,sterml,chainDB_list,ref_list) determ (i,o,o,o,o,o).
kbSMsL : (string_list,string_list,string_list,sterml,chainDB_list,ref_list) determ (i,o,o,o,o,o).
kbNL_Ref : (string,string,string,chainDB::ref) determ (i,i,o,o).
kbNL_RefF : (string,string,string,chainDB::ref) determ (i,i,o,o).
kbNL_RefF2 : (string,string,string,string,chainDB::ref) determ (i,i,i,o,o).
kbST_Rec : (chainDB,chainDB::ref,string) determ (i,i,o).
kbST_Exists3kb : (chainDB,integer,integer,string,string,string) determ. 
kbST_CountX : (chainDB,integer,string,string,string,count,count) determ.
%
deleteKB_Name : (string) determ.
kbClass : (string KBname,string Clas) determ (i,o).
kbClassF : (string KBname,string Clas) determ (i,o).
smSegment : (string Clas,string KBname,string Segment) procedure (i,i,o).
end class kbBase