/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement opr
open core,termDomain

constants
className = "com/rudstrand/opr/opr".
classVersion = "1.0".

clauses
classInfo(className, classVersion).
% ----------------------------------------------------------------------------------------------
% opr_any
% ----------------------------------------------------------------------------------------------
opr_any(Opr,Card) :- 
	opr_cmpass(Opr),
	Card=2,!
;
	opr_expr(Opr,Card),!.	
% ----------------------------------------------------------------------------------------------
% opr_cmpass
% ----------------------------------------------------------------------------------------------
opr_cmpass(Opr) :- oprCmp(Opr),!.
opr_cmpass(Opr) :- oprEq(Opr),!.
% ----------------------------------------------------------------------------------------------
% oprEq
% ----------------------------------------------------------------------------------------------
oprEq("=") :- 
	!.
oprEq("=*") :- 
	!.
oprEq("is") :- 
	!.
oprEq("nis") :- 
	!.
oprEq(Opr) :-
	sx::frontstr(2,Opr,F,T),
	F="is",
	dom::domShortLong(T,_),
	!
;
	sx::frontstr(3,Opr,F,T),
	F="nis",
	dom::domShortLong(T,_),
	!
;
	sx::frontstr(2,Opr,F,T),
	F="=*",
	dom::domShortLong(T,_),
	!
;
	sx::frontstr(1,Opr,F,T),
	F="=",
	dom::domShortLong(T,_),
	!.
% ----------------------------------------------------------------------------------------------
% opr_expr
% ----------------------------------------------------------------------------------------------
opr_expr("/",2) :- !.
opr_expr("*",2) :- !.
opr_expr("+",2) :- !.
opr_expr("-",2) :- !.
opr_expr("-",1) :- !.
opr_expr("^",2) :- !.
opr_expr("div",2) :- !.
opr_expr("mod",2) :- !.
% ----------------------------------------------------------------------------------------------
% oprCmp
% ----------------------------------------------------------------------------------------------
oprCmp(">") :- !.
oprCmp("<") :- !.
oprCmp("<>") :- !.
oprCmp(">=") :- !.
oprCmp("<=") :- !.
oprCmp("like") :- !.
oprCmp("unlike") :- !.
oprCmp("inside") :- !.
oprCmp("outside") :- !.
% ----------------------------------------------------------------------------------------------
% oprDom; oprDomNL
% ----------------------------------------------------------------------------------------------
% parameters:
% 1	domain (KB name)
% 2	ass/eq operator
% 3	domain-qualified ass/eq operator
%
oprDom(Dk,E,Ex) :-
	oprDomF(Dk,E,Ex),
	!
;
	bound(Dk), bound(E), free(Ex),
	Mess=string::concat("Invalid domain '",Dk,"' or operator '",E,"' (in opr::oprDom)"),
	dlgIF::dlgNote(2,Mess),!,fail
;	
	free(Dk), free(E), bound(Ex),
	Mess=string::concat("Invalid operator '",Ex,"' (in opr::oprDom)"),
	dlgIF::dlgNote(2,Mess),!,fail.

oprDomF(Dk,E,Ex) :-
	bound(Dk), bound(E), free(Ex),
	Dk="p3_dany",
	set::member(E,["=","is"]),
	Ex="is",
	!
;
	bound(Dk), bound(E), free(Ex),
	dom::domAll(Dk),
	set::member(E,["=","is"]),
	dom::domShortLong(Du,Dk),
	Ex=string::concat("is",Du),
	!
;
	bound(Dk), bound(E), free(Ex),
	dom::domAll(Dk),
	set::member(E,["=*","nis"]),
	dom::domShortLong(Du,Dk),
	Ex=string::concat("nis",Du),
	!
;
	free(Dk), free(E), bound(Ex),
	set::member(Ex,["=","is"]),
	E="is",
	Dk="p3_dany",
	!
;
	free(Dk), free(E), bound(Ex),
	set::member(Ex,["=*","nis"]),
	E="nis",
	Dk="p3_dany",
	!
;	
	free(Dk), free(E), bound(Ex),
	sx::frontstr(3,Ex,E,T),
	E="nis",
	TL=string::toLowerCase(T),
	Dk=string::concat("p3_d",TL),
	dom::domAll(Dk),
	!
;	
	free(Dk), free(E), bound(Ex),
	sx::frontstr(2,Ex,E,T),
	E="is",
	TL=string::toLowerCase(T),
	Dk=string::concat("p3_d",TL),
	dom::domAll(Dk),
	!
;	
	free(Dk), free(E), bound(Ex),
	sx::frontstr(2,Ex,E2,T),
	E2="=*",
	E="nis",
	TL=string::toLowerCase(T),
	Dk=string::concat("p3_d",TL),
	dom::domAll(Dk),
	!
;	
	free(Dk), free(E), bound(Ex),
	sx::frontstr(1,Ex,E2,T),
	E2="=",
	E="is",
	TL=string::toLowerCase(T),
	Dk=string::concat("p3_d",TL),
	dom::domAll(Dk),
	!.	
% ----------------------------------------------------------------------------------------------
% oprIntExt
% ----------------------------------------------------------------------------------------------
oprIntExt(Int,Ext) :-
	bound(Int), free(Ext),
	sx::frontstr(3,Int,F,_),
	F="nis",
	Ext="=*",
	!
;
	bound(Int), free(Ext),
	sx::frontstr(2,Int,F,_),
	F="is",
	Ext="=",
	!
;
	free(Int), bound(Ext),
	sx::frontstr(2,Ext,F,T),
	F="=*",
	Int=string::concat("nis",T),
	!
;
	free(Int), bound(Ext),
	sx::frontstr(1,Ext,F,T),
	F="=",
	Int=string::concat("is",T),
	!.
oprIntExt(Op,Op) :-
	!.
end implement opr
