/******************************************************************************

    Copyright (C) 1999-2003, Prolog Development Center A/S

    FileName: TREEVIEW.PRO
    Purpose: Tree View custom control object

******************************************************************************/

implement p3TreeView
    open vpiDomains
    resolve
        api_InitCommonControls externally,
        api_ImageList_Create externally,
        api_ImageList_Destroy externally,
        api_ImageList_Add externally,
        api_CreateWindowExW externally,
        api_ResIdImage externally,
        api_StringImage externally,
        api_DeleteObject externally

     domains
         itemIndex = pointer.

    domains
        hImageList = pointer.

    class predicates % lib call
        api_InitCommonControls : ()
         procedure () language stdcall as "_InitCommonControls@0".

    class predicates % lib call
         /*HimageList*/ api_ImageList_Create : (
            integer Width,
            integer Height,
            unsigned Flags,
            integer Num,
            integer Growth) -> hImageList
         procedure (i,i,i,i,i) language stdcall as "_ImageList_Create@20".

    class predicates % lib call
        api_ImageList_Destroy : (hImageList HimageList)
         procedure (i) language stdcall as "_ImageList_Destroy@4".

    class predicates % lib call
         api_ImageList_Add : (
            hImageList HimageList,
            core::integer32 BitMap,
            core::integer32 Mask) -> integer
         procedure (i,i,i) language stdcall as "_ImageList_Add@12".

    class predicates % lib call
         api_CreateWindowExW : (
            core::unsigned32 WindowStyleEx,
            string WindowClass,
            string WindowName,
            core::unsigned32 WindowStyle,
            integer X,
            integer Y,
            integer Width,
            integer Height,
            vpiDomains::windowHandle Parent,
            pointer NativeMenu,
            core::integer32 HInstance,
            pointer CreationData) -> vpiDomains::windowHandle
         procedure (i,i,i,i,i,i,i,i,i,i,i,i) language stdcall as "_CreateWindowExW@48".

    constants
        imageType_bitmap : unsigned = 0.
    constants % load options
        lr_loadFromFile : unsigned = 0x0010.

    class predicates % lib call
         /* HbitMap */ api_ResIdImage : (
            core::integer32 Hinst,
            vpiDomains::resid Bitmap,
            unsigned ImageType,
            integer DesiredWidth,
            integer DesiredHeight,
            unsigned LoadOptions) -> core::integer32
         procedure (i,i,i,i,i,i) language stdcall as "_LoadImageW@24".

    class predicates % lib call
         /* HbitMap */ api_StringImage : (
            core::integer32 Hinst,
            string Bitmap,
            unsigned ImageType,
            integer DesiredWidth,
            integer DesiredHeight,
            unsigned LoadOptions) -> core::integer32
         procedure (i,i,i,i,i,i) language stdcall as "_LoadImageW@24".


    class predicates
        api_DeleteObject : (core::integer32 GDIObject)
         procedure (i) language stdcall as "_DeleteObject@4".

    constants
        imageList_initialSize : integer = 5.
        imageList_growth : integer = 10.

    constants % module Info
        className : string = "com/visual-prolog/vpi/vpiTreeView/vpiTreeView".
        classVersion : string = "Version 1.0".

    constants
        tvn_keydown : core::unsigned32 = 0xfffffe64.

    constants
        tvm_deleteitem : unsigned = 0x1101.
        tvm_expand : unsigned = 0x1102.
        tvm_getitemrect = 0x1104.
        tvm_getcount : unsigned = 0x1105.
        tvm_getindent : unsigned = 0x1106.
        tvm_setindent : unsigned = 0x1107.
        tvm_getimagelist = 0x1108.
        tvm_setimagelist : unsigned = 0x1109.
        tvm_getnextitem : unsigned = 0x110a.
        tvm_selectitem : unsigned = 0x110b.
        tvm_geteditcontrol = 0x110f.
        tvm_getvisiblecount = 0x1110.
        tvm_hittest : unsigned = 0x1111.
        tvm_dragimage = 0x1112.
        tvm_sortchildren : unsigned = 0x1113.
        tvm_ensurevisible : unsigned = 0x1114.
        tvm_sortchildrencb = 0x1115.
        tvm_endeditlabelnow : unsigned = 0x1116.
        tvm_settooltips = 0x1118.
        tvm_gettooltips = 0x1119.

    constants
        tvgn_root = 0x0000.
        tvgn_next : unsigned = 0x0001.
        tvgn_previous : unsigned = 0x0002.
        tvgn_parent : unsigned = 0x0003.
        tvgn_child : unsigned = 0x0004.
        tvgn_firstvisible : unsigned = 0x0005.
        tvgn_nextvisible = 0x0006.
        tvgn_previousvisible = 0x0007.
        tvgn_drophilite = 0x0008.
        tvgn_caret : unsigned = 0x0009.

    constants
        tvif_text = 0x0001.
        tvif_image = 0X0002.
        tvif_param = 0x0004.
        tvif_state = 0x0008.
        tvif_handle = 0x0010.
        tvif_selectedimage = 0x0020.
        tvif_children = 0x0040.

    constants
        tve_toggle : unsigned = 0x0003.

    constants
        null_itemIndex : itemIndex = null.

    constants
        tvi_root : itemIndex = uncheckedConvert(pointer, 0xffff0000).
        tvi_first : itemIndex = uncheckedConvert(pointer, 0xffff0001).
        tvi_last : itemIndex = uncheckedConvert(pointer, 0xffff0002).
        tvi_sorted : itemIndex = uncheckedConvert(pointer, 0xffff0003).

    constants
        wm_notify = 78.

    constants
        nm_outofmemory : core::unsigned32 = 0xffffffff.
        nm_click : core::unsigned32 = 0xfffffffe.
        nm_dblclk : core::unsigned32 = 0xfffffffd.
        nm_return : core::unsigned32 = 0xfffffffc.
        nm_rclick : core::unsigned32 = 0xfffffffb.
        nm_rdblclk : core::unsigned32 = 0xfffffffa.
        nm_setfocus : core::unsigned32 = 0xfffffff9.
        nm_killfocus : core::unsigned32 = 0xfffffff8.
        nm_customdraw : core::unsigned32 = 0xfffffff4.
        nm_hover : core::unsigned32 = 0xfffffff3.
        nm_nchittest : core::unsigned32 = 0xfffffff2.
        nm_keydown : core::unsigned32 = 0xfffffff1.
        nm_releasedcapture : core::unsigned32 = 0xfffffff0.
        nm_setcursor : core::unsigned32 = 0xffffffef.
        nm_char : core::unsigned32 = 0xffffffee.

    constants
        native_visible = 0x10000000.
        native_child = 0x40000000.
        native_border = 0x00800000.

        clauses
            moduleInfo(className, classVersion).

        constants
        tvn_selchangingA : core::unsigned32 = 0xfffffe6f.
        tvn_selchangedA : core::unsigned32 = 0xfffffe6e.
        tvn_getdispinfoA = 0xfffffe6d.
        tvn_setdispinfoA = 0xfffffe6c.
        tvn_itemexpandingA : core::unsigned32 = 0xfffffe6b.
        tvn_itemexpandedA : core::unsigned32 = 0xfffffe6a.
        tvn_begindragA = 0xfffffe69.
        tvn_beginrdragA = 0xfffffe68.
        tvn_deleteitemA = 0xfffffe67.
        tvn_beginlabeleditA : core::unsigned32 = 0xfffffe66.
        tvn_endlabeleditA : core::unsigned32 = 0xfffffe65.

        constants
        tvm_insertitemA : unsigned = 0x1100.
        tvm_getitemA : unsigned = 0x110c.
        tvm_setitemA : unsigned = 0x110d.
        tvm_editlabelA : unsigned = 0x110e.
        tvm_getisearchstringA = 0x1117.

        constants
        tvn_selchangingW : core::unsigned32 = 0xfffffe3e.
        tvn_selchangedW : core::unsigned32 = 0xfffffe3d.
        tvn_getdispinfoW = 0xfffffe3c.
        tvn_setdispinfoW = 0xfffffe3b.
        tvn_itemexpandingW : core::unsigned32 = 0xfffffe3a.
        tvn_itemexpandedW : core::unsigned32 = 0xfffffe39.
        tvn_begindragW = 0xfffffe38.
        tvn_beginrdragW = 0xfffffe37.
        tvn_deleteitemW = 0xfffffe36.
        tvn_beginlabeleditW : core::unsigned32 = 0xfffffe35.
        tvn_endlabeleditW : core::unsigned32 = 0xfffffe34.

        constants
        tvm_insertitemW : unsigned = 0x1132.
        tvm_getitemW : unsigned = 0x113e.
        tvm_setitemW : unsigned = 0x113f.
        tvm_editlabelW : unsigned = 0x1141.
        tvm_getisearchstringW = 0x1140.

        class predicates
            bitOr_flags : (core::integer_list Flags, integer In, integer Result)
             procedure (i,i,o).
        clauses
            bitOr_flags([], Flags, Flags).
            bitOr_flags([Flag|Flags], F1, F0) :-
                F2 = bit::bitor(Flag, F1),
                bitOr_flags(Flags, F2, F0).

        /***************************************************************************
        *  Index Mapping
        ***************************************************************************/
        class facts - db_item
            item_index_db : (
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId,
                itemIndex ItemIndex).
            parent_db : ( % parent_db is used to delete children
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId,
                itemId Parent).

        clauses
            itemIdExist(TreeWindow, ItemID):-
                item_index_db(TreeWindow, ItemID, _),
                !.

        class predicates
            clearDb_item : (vpiDomains::windowHandle TreeWindow)  procedure (i).
        clauses
            clearDb_item(TreeWindow) :-
                retractAll(item_index_db(TreeWindow, _, _)),
                retractAll(parent_db(TreeWindow, _, _)).

        class predicates
            clear_item : (vpiDomains::windowHandle TreeWindow, itemId ItemId)  procedure (i,i).
        clauses
            clear_item(TreeWindow, ItemId) :-
                parent_db(TreeWindow, Child, ItemId),
                    clear_item(TreeWindow, Child),
                fail.
            clear_item(TreeWindow, ItemId) :-
                retractAll(item_index_db(TreeWindow, ItemId, _)),
                retractAll(parent_db(TreeWindow, ItemId, _)).


        class predicates
            assert_parentId : (
                vpiDomains::windowHandle TreeWindow,
                itemId ParentId,
                itemId ItemIndex)
              procedure (i,i,i).
         clauses
            assert_parentId(_TreeWindow, _ItemId, wcc_null) :-
                !.
            assert_parentId(TreeWindow, ItemId, ParentId) :-
                assert(parent_db(TreeWindow, ItemId, ParentId)).

        class predicates
            assert_item_parent_and_index : (
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId,
                itemId ParentId,
                itemIndex ItemIndex)
              procedure (i,i,i,i).
         clauses
            assert_item_parent_and_index(TreeWindow, ItemId, ParentId, ItemIndex) :-
                assert(item_index_db(TreeWindow, ItemId, ItemIndex)),
                assert_parentId(TreeWindow, ItemId, ParentId).


        class predicates
            get_item_id : (
                vpiDomains::windowHandle TreeWindow,
                itemIndex ItemIndex,
                itemId ItemId)
             procedure (i,i,o).
        clauses
            get_item_id(TreeWindow, ItemIndex, ItemId):-
                item_index_db(TreeWindow, ItemId, ItemIndex),
                !.
            get_item_id(_, _, wcc_null).

        class predicates
            get_item_index : (
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId,
                itemIndex ItemIndex)
             procedure (i,i,o).
        clauses
            get_item_index(_, wcc_null, tvi_root) :-
                !.
            get_item_index(TreeWindow, ItemId, ItemIndex):-
                item_index_db(TreeWindow, ItemId, ItemIndex),
                !.
            get_item_index(_, _, _):-
                exception::raise(moduleInfo, badIdentifierException).

        class predicates
            get_insertParent_index : (
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId,
                itemIndex ItemIndex)
             procedure (i,i,o).
        clauses
            get_insertParent_index(_TreeWindow, wcc_null, tvi_root) :-
                !.
            get_insertParent_index(TreeWindow, ItemId, ItemIndex) :-
                get_item_index(TreeWindow, ItemId, ItemIndex).

        class predicates
            get_insertPrevious_index : (
                vpiDomains::windowHandle TreeWindow,
                insertPlace ItemId,
                itemIndex ItemIndex)
             procedure (i,i,o).
        clauses
            get_insertPrevious_index(_TreeWindow, first(), tvi_first).
            get_insertPrevious_index(_TreeWindow, last(), tvi_last).
            get_insertPrevious_index(_TreeWindow, sorted(), tvi_sorted).
            get_insertPrevious_index(TreeWindow, after(ItemId), ItemIndex) :-
                get_item_index(TreeWindow, ItemId, ItemIndex).

        class predicates
            checkItem_NotExist : (
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId)
             procedure (i,i).
        clauses
            checkItem_NotExist(TreeWindow, ItemId):-
                item_index_db(TreeWindow, ItemId, _),
                !,
                common_exception::raise_Error(moduleInfo,predicate_fullName(), "Item already exist").
            checkItem_NotExist(_TreeWindow, _ItemId).

        /*********************************************************************
        *  Native Window
        *********************************************************************/
        class facts - db_window
            nativeWindow_db : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::windowHandle NativeWindow).
            callback_db : (
                vpiDomains::windowHandle TreeWindow,
                callback Callback).
            subclass_handler_db : (vpiDomains::windowHandle TreeWindow, vpiDomains::ehandler SubclassHandler).
            bitmapDescr_db : (
                vpiDomains::windowHandle TreeWindow,
                unsigned Width,
                unsigned Height,
                hImageList HimageList).
            bitmap_index_db : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::bitmapId Bitmap,
                integer BitmapIndex).

        class predicates
            clearDb_window : (vpiDomains::windowHandle TreeWindow)  procedure (i).
        clauses
            clearDb_window(TreeWindow):-
                clearDb_item(TreeWindow),
                retractAll(nativeWindow_db(TreeWindow, _)),
                retractAll(callback_db(TreeWindow, _)),
                retractAll(subclass_handler_db(TreeWindow, _)),
                retractAll(bitmapDescr_db(TreeWindow, _, _, _)),
                retractAll(bitmap_index_db(TreeWindow, _, _)).

        class predicates
            tryGetNativeWindow : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::windowHandle NativeWindow)
             determ (i,o).
        clauses
            tryGetNativeWindow(TreeWindow, NativeWindow):-
                nativeWindow_db(TreeWindow, NativeWindow),
                !.

        class predicates
            getNativeWindow : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::windowHandle NativeWindow)
             procedure (i,o).
        clauses
            getNativeWindow(TreeWindow, NativeWindow):-
                nativeWindow_db(TreeWindow, NativeWindow),
                !.
            getNativeWindow(_, _):-
                common_exception::raise_Error(moduleInfo, predicate_FullName(), "Bad Window").

        class predicates
            setNativeWindow : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::windowHandle NativeWindow)
             procedure (i,i).
        clauses
            setNativeWindow(TreeWindow, _NativeWindow) :-
                nativeWindow_db(TreeWindow, _),
                common_exception::raise_Error(moduleInfo,predicate_fullName(), "Native window already exists").
            setNativeWindow(TreeWindow, NativeWindow) :-
                assert(nativeWindow_db(TreeWindow, NativeWindow)).

        clauses
            send_native(TreeWindow, Message, Wparam, Lparam) = Result :-
                getNativeWindow(TreeWindow, NativeWindow),
                Result = vpi::winSendEvent(NativeWindow, vpiDomains::e_native(Message, Wparam, Lparam)).

        /***************************************************************************
        *  User Subclass handler
        ***************************************************************************/
        class predicates
            invokeCallback : callback.
        clauses
            invokeCallback(TreeWindow, TV_Message) :-
                callback_db(TreeWindow, CallBack),
                !,
                trap(CallBack(TreeWindow, TV_Message),
                    TrapCode,
                    common_exception::continue_Unknown(TrapCode, moduleInfo, predicate_FullName())).

        class predicates
            setCallback : (
                vpiDomains::windowHandle TreeWindow,
                callback Callback)
             procedure (i,i).
        clauses
            setCallback(TreeWindow, CallBack) :-
                assert(callback_db(TreeWindow, CallBack)).

        /***************************************************************************
        *  User Subclass handler
        ***************************************************************************/
        class predicates
            invokeSubclassHandler : vpiDomains::ehandler.
        clauses
            invokeSubclassHandler(TreeWindow,  Event) = Return :-
                subclass_handler_db(TreeWindow, SubclassHandler),
                !,
                trap(Return = SubclassHandler(TreeWindow, Event),
                    TrapCode,
                    common_exception::continue_Unknown(TrapCode, moduleInfo, predicate_fullName())).

        clauses
            set_subclassHandler(TreeWindow, SubclassHandler) :-
                getNativeWindow(TreeWindow, _), % check for existence
                retractAll(subclass_handler_db(TreeWindow, _)),
                assert(subclass_handler_db(TreeWindow, SubclassHandler)).

        /*********************************************************************
        *  Domains
        *********************************************************************/
        domains
            itemW = itemW(
                unsigned Mask,
                itemIndex ItemIndex,
                unsigned State,
                unsigned StateMask,
                string Text,
                integer TextLength,
                integer ImageIndex,
                integer SelectImageId,
                integer Children,
                core::integer32 LParam).

        domains
            nmhdr = nmhdr(
                vpiDomains::windowHandle NativeWindow,
                unsigned IdFrom,
                unsigned CodeOperation).

        domains
            treeviewW = treeviewW(
                vpiDomains::windowHandle NativeWindow,
                unsigned IdFrom,
                unsigned CodeOperation,
                unsigned Action,
                unsigned MaskOld,
                itemIndex ItemIndexOld,
                unsigned StateOld,
                unsigned StateMaskOld,
                string TextOld,
                integer TextLengthOld,
                integer ImageIndexOld,
                integer SelectImageIdOld,
                integer ChildrenOld,
                core::integer32 LParamOld,
                unsigned MaskNew,
                itemIndex ItemIndexNew,
                unsigned StateNew,
                unsigned StateMaskNew,
                string TextNew,
                integer TextLengthNew,
                integer ImageIndexNew,
                integer SelectImageIdNew,
                integer ChildrenNew,
                core::integer32 LParamNew,
                core::integer32 PtDrag).

        domains
            treeviewA = treeviewA(
                vpiDomains::windowHandle NativeWindow,
                unsigned IdFrom,
                unsigned CodeOperation,
                unsigned Action,
                unsigned MaskOld,
                itemIndex ItemIndexOld,
                unsigned StateOld,
                unsigned StateMaskOld,
                string8 TextOld,
                integer TextLengthOld,
                integer ImageIndexOld,
                integer SelectImageIdOld,
                integer ChildrenOld,
                core::integer32 LParamOld,
                unsigned MaskNew,
                itemIndex ItemIndexNew,
                unsigned StateNew,
                unsigned StateMaskNew,
                string8 TextNew,
                integer TextLengthNew,
                integer ImageIndexNew,
                integer SelectImageIdNew,
                integer ChildrenNew,
                core::integer32 LParamNew,
                core::integer32 PtDrag).
                
        domains
            dispinfoW = dispinfoW(
                vpiDomains::windowHandle NativeWindow,
                unsigned IdFrom,
                unsigned CodeOperation,
                unsigned Mask,
                itemIndex ItemIndex,
                unsigned State,
                unsigned StateMask,
                string Text,
                integer TextLength,
                integer ImageIndex,
                integer SelectImageId,
                integer Children,
                core::integer32 LParam).

        domains
            hittestinfo = hittestinfo(
                integer X,
                integer Y,
                unsigned Flags,
                itemIndex ItemIndex).

        domains
            keydown = keydown(
                vpiDomains::windowHandle NativeWindow,
                unsigned IdFrom,
                unsigned CodeOperation,
                core::integer16 VKey,
                unsigned Flags).

        domains
            insertitemW = insertitemW(
                itemIndex Parent,
                itemIndex Previous,
                unsigned Mask,
                core::integer32 HItem,
                unsigned State,
                unsigned StateMask,
                string Text,
                integer TextLength,
                integer ImageIndex,
                integer SelectImageId,
                integer Children,
                core::integer32 LParam).

        class predicates
            itemStateFlag_table : (itemStateFlag FunctorFlag, unsigned Bit)
             procedure (i,o)
              determ (o,i)
              multi (o,o).
        clauses
            itemStateFlag_table(selected(), 0x0002).
            itemStateFlag_table(cut(), 0x0004).
            itemStateFlag_table(dropHilited(),0x0008).
            itemStateFlag_table(bold(), 0x0010).
            itemStateFlag_table(expanded(), 0x0020).

        class predicates
            itemState_toNative1 : (itemState State, unsigned NativeFlagIn, unsigned NativeFlagOut)
             procedure (i,i,o).
        clauses
            itemState_toNative1([], NativeFlag0, NativeFlag0).
            itemState_toNative1([Flag|Flags], NativeFlag1, NativeFlag0) :-
               itemStateFlag_table(Flag, Bit),
               NativeFlag2 = bit::bitor(NativeFlag1, Bit),
               itemState_toNative1(Flags, NativeFlag2, NativeFlag0).

        class predicates
             /* Flag */ itemState_toNative : (itemState State) -> unsigned
             procedure (i).
        clauses
            itemState_toNative(ItemState) = NativeFlag :-
               itemState_toNative1(ItemState, 0, NativeFlag).

        class predicates
            itemStateFlag_fromNative_nd : (unsigned Native, itemStateFlag ItemStateFlag)
             nondeterm (i,o).
        clauses
            itemStateFlag_fromNative_nd(Native, ItemStateFlag) :-
                itemStateFlag_table(ItemStateFlag, Bit),
                X = bit::bitand(Native, Bit),
                X <> 0.

        class predicates
             itemState_fromNative : (unsigned Native) -> itemState procedure (i).
        clauses
            itemState_fromNative(Native) = ItemState :-
                findall(ItemStateFlag, itemStateFlag_fromNative_nd(Native, ItemStateFlag), ItemState).


        class predicates
            position_table : (position Position, unsigned NativePosition)
                procedure (i,o)
                determ (o,i)
                multi (o,o).
        clauses
            position_table(nowhere(), 0x0001).
            position_table(onItemIcon(), 0x0002).
            position_table(onItemLabel(),0x0004).
            position_table(onItemIndent(), 0x0008).
            position_table(onItemButton(), 0x0010).
            position_table(onItemRight(), 0x0020).
            position_table(onItemStateIcon(), 0x0040).
            position_table(above(),0x0100).
            position_table(below(), 0x0200).
            position_table(toRight(), 0x0400).
            position_table(toLeft(), 0x0800).

        class predicates
             getPosition_fromNative : (unsigned NativePosition) -> position
             procedure (i).
        clauses
            getPosition_fromNative(NativePosition) = Position :-
                position_table(Position, NativePosition),
                !.
            getPosition_fromNative(NativePosition) = _Position :-
                common_exception::raise_Error(moduleInfo, predicate_fullName(),
                    "Unknown Native position:",NativePosition).

        /*********************************************************************
        *  Bitmaps
        *********************************************************************/
        class predicates
            int_max : (
                integer Arg1,
                integer Arg2,
                integer Res)
             procedure (i,i,o).
        clauses
            int_max(A, B, A):-
                A > B,
                !.
            int_max(_, B, B).

        class predicates
             pict_Get : (vpiDomains::bitmapId BitMap) -> vpiDomains::picture
             procedure (i).
        clauses
            pict_Get(vpiDomains::resid(ResId)) = Picture :-
                Picture = vpi::pictGetFromRes(ResId).
            pict_Get(vpiDomains::fileName(FileName)) = Picture :-
                Picture = vpi::pictLoad(FileName).
            pict_Get(vpiDomains::bmp(Picture)) = Picture.

        class predicates
            imageList_create : (vpiDomains::windowHandle TreeWindow, vpiDomains::bitmapId SizeBitmap)
             procedure (i,i).
        clauses
            imageList_create(TreeWindow, SizeBitmap) :-
                Pict = pict_Get(SizeBitmap),
                vpi::pictGetSize(Pict, Width, Height, _),
                vpi::pictDestroy(Pict),
                HImageList = api_ImageList_Create(Width, Height, 0, imageList_initialSize, imageList_growth),
                LParam_hImageList = uncheckedConvert(core::integer32, HImageList),
                _ = send_native(TreeWindow, tvm_setimagelist, 0, LParam_hImageList),
                assert(bitmapDescr_db(TreeWindow, Width, Height, HImageList)).

        class predicates
            loadBitmap : (
                core::integer32 Hinst,
                vpiDomains::bitmapId Bitmap,
                integer DesiredWidth,
                integer DesiredHeight,
                unsigned LoadOptions,
                core::integer32 HbitMap)
             procedure (i,i,i,i,i,o).
        clauses
            loadBitmap(Hinst, resid(ResId), DesiredWidth, DesiredHeight, LoadOptions, HbitMap) :-
                HbitMap = api_ResIdImage(Hinst, ResId, imageType_bitmap, DesiredWidth, DesiredHeight, LoadOptions).
            loadBitmap(Hinst, fileName(ResId), DesiredWidth, DesiredHeight, LoadOptions, HbitMap) :-
                LoadOptions1 = bit::bitor(LoadOptions, lr_loadFromFile),
                HbitMap = api_StringImage(Hinst, ResId, imageType_bitmap, DesiredWidth, DesiredHeight, LoadOptions1).
            loadBitmap(_Hinst, bmp(Picture), _DesiredWidth, _DesiredHeight, _LoadOptions, HbitMap) :-
                HbitMap = uncheckedConvert(integer, vpi::pictToBitmap(Picture)).
                

        class predicates
            get_bitmap_index : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::bitmapId Bitmap,
                core::integer32 BitmapIndex)
             procedure (i,i,o).
        clauses
            get_bitmap_index(TreeWindow, Bitmap,  BitmapIndex) :-
                bitmap_index_db(TreeWindow, Bitmap, BitmapIndex),
                !.
            get_bitmap_index(TreeWindow, Bitmap, BitmapIndex) :-
                bitmapDescr_db(TreeWindow, DesiredWidth, DesiredHeight, HimageList),
                !,
                LoadOptions = lr_loadtransparent,
                Hinst = vpi::winGetAttrVal(TreeWindow, attr_win_instance),
                loadBitmap(Hinst, Bitmap, DesiredWidth, DesiredHeight, LoadOptions, HbitMap),
                BitmapIndex = api_ImageList_Add(HimageList, HbitMap, 0),
                assertz(bitmap_index_db(TreeWindow, Bitmap, BitmapIndex)),
                api_DeleteObject(HbitMap).
            get_bitmap_index(_TreeWindow, _Bitmap, _BitmapIndex) :-
                common_exception::raise_Error(moduleInfo,predicate_fullName(), "ImageList does not exist").

        class predicates
            native_setItem : (vpiDomains::windowHandle TreeWindow, itemW Item)
             procedure (i,i).
        clauses
            native_setItem(TreeWindow, Item) :-
                ItemLong = uncheckedConvert(core::integer32, Item),
                _ = send_native(TreeWindow, tvm_setitemW, 0, ItemLong).

        class predicates
             /* ItemIndex */ native_insertItem : (vpiDomains::windowHandle TreeWindow, insertitemW InsertItem) -> itemIndex Index
             procedure (i,i).
        clauses
            native_insertItem(TreeWindow, InsertItem) = ItemIndex :-
                InsertItemLong = uncheckedConvert(core::integer32, InsertItem),
                ItemIndex = uncheckedConvert(itemIndex, send_native(TreeWindow, tvm_insertitemW, 0, InsertItemLong)).

        class predicates
            set_bitmap : (
                vpiDomains::windowHandle TreeWindow,
                itemId ItemId,
                vpiDomains::bitmapId NewBitmap,
                vpiDomains::bitmapId NewMaskBitmap,
                core::integer32 NewBitmapIndex)
             procedure(i,i,i,i,o).
        clauses
            set_bitmap(TreeWindow, ItemId, Bitmap, SelectedBitmap, BitmapIndex):-
                get_bitmap_index(TreeWindow, Bitmap, BitmapIndex),
                get_bitmap_index(TreeWindow, SelectedBitmap, SelectedBitmapIndex),
                get_item_index(TreeWindow, ItemId, ItemIndex),
                Mask = tvif_handle + tvif_image + tvif_selectedimage,
                native_setItem(TreeWindow, itemW(Mask, ItemIndex, 0, 0, "", 0, BitmapIndex, SelectedBitmapIndex, 0, 0)).



        /*********************************************************************
        *  Adding items
        *********************************************************************/
        class predicates
            getInsertIndex : (itemIndex InInsertIndex, itemIndex ItemIndex, itemIndex OutItemIndex)
             procedure (i,i,o).
        clauses
            getInsertIndex(tvi_sorted, _ItemIndex, tvi_sorted) :-
                !.
            getInsertIndex(_, ItemIndex, ItemIndex).

        class predicates
            add_item_list : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::windowHandle NativeWindow,
                itemId ParentId,
                itemIndex ParentIndex,
                itemIndex InsertIndex,
                tree_list TreeList)
             procedure (i,i,i,i,i,i).
             /* ItemIndex */ add_item : (
                vpiDomains::windowHandle TreeWindow,
                vpiDomains::windowHandle NativeWindow,
                itemId ParentId,
                itemIndex ParentIndex,
                itemIndex InsertIndex,
                tree Tree) -> itemIndex Index
             procedure (i,i,i,i,i,i).
        clauses
            add_item(TreeWindow, NativeWindow, ParentId, ParentIndex, InsertIndex,
                    tree(ItemId, ItemState, Bitmap, SelectedBitmap, Text, Children)) =
                    ItemIndex :-
                checkItem_NotExist(TreeWindow, ItemId),
                NativeState = itemState_toNative(ItemState),
                get_bitmap_index(TreeWindow, Bitmap, BitmapIndex),
                get_bitmap_index(TreeWindow, SelectedBitmap, SelectedBitmapIndex),
                TextLength = string::length(Text),
                Mask = tvif_text + tvif_image + tvif_selectedimage + tvif_param + tvif_state,
                ItemIndex = native_insertItem(TreeWindow,
                    insertitemW(ParentIndex, InsertIndex, Mask, 0, NativeState, 0xffff, Text, TextLength, BitmapIndex, SelectedBitmapIndex, 0, 0)),
                assert_item_parent_and_index(TreeWindow, ItemId, ParentId, ItemIndex),
                getInsertIndex(InsertIndex, tvi_last, InsertIndexChildren),
                add_item_list(TreeWindow, NativeWindow, ItemId, ItemIndex, InsertIndexChildren, Children).
        clauses
            add_item_list(_, _, _, _, _, []):-!.
            add_item_list(TreeWindow, NativeWindow, ParentId, ParentIndex, InsertIndex, [Item|Siblings]):-
                ItemIndex = add_item(TreeWindow, NativeWindow, ParentId, ParentIndex, InsertIndex, Item),
                getInsertIndex(InsertIndex, ItemIndex, InsertIndexSibling),
                add_item_list(TreeWindow, NativeWindow, ParentId, ParentIndex, InsertIndexSibling, Siblings).

        class predicates
            get_parW : (
                vpiDomains::windowHandle TreeWindow,
                core::integer32 LParam,
                itemId ItemIdOld,
                unsigned StateOld,
                itemId ItemIdNew,
                unsigned StateNew)
             procedure (i,i,o,o,o,o).
        clauses
            get_parW(TreeWindow, LParam, ItemIdOld, StateOld, ItemIdNew, StateNew):-
                Event = uncheckedConvert(treeviewW, LParam),
                Event = treeviewW(_, _, _, _, _, ItemIndexOld, StateOld, _, _, _, _, _, _, _, _, ItemIndexNew, StateNew, _, _, _, _, _, _, _, _),
                get_item_id(TreeWindow, ItemIndexOld, ItemIdOld),
                get_item_id(TreeWindow, ItemIndexNew, ItemIdNew).

        class predicates
            get_parA : (
                vpiDomains::windowHandle TreeWindow,
                core::integer32 LParam,
                itemId ItemIdOld,
                unsigned StateOld,
                itemId ItemIdNew,
                unsigned StateNew)
             procedure (i,i,o,o,o,o).
        clauses
            get_parA(TreeWindow, LParam, ItemIdOld, StateOld, ItemIdNew, StateNew):-
                Event = uncheckedConvert(treeviewA, LParam),
                Event = treeviewA(_, _, _, _, _, ItemIndexOld, StateOld, _, _, _, _, _, _, _, _, ItemIndexNew, StateNew, _, _, _, _, _, _, _, _),
                get_item_id(TreeWindow, ItemIndexOld, ItemIdOld),
                get_item_id(TreeWindow, ItemIndexNew, ItemIdNew).

        class predicates
            get_expanded : (
                unsigned State,
                core::booleanInt Expanded)
             procedure (i,o).
        clauses
            get_expanded(State, core::b_true):-
                itemStateFlag_table(expanded, ExpandedBit),
                bit::bitand(State, ExpandedBit) <> 0,
                !.
            get_expanded(_, core::b_false).

        class predicates
            get_state : (
                unsigned State,
                core::booleanInt Expanded)
             procedure (i,o).
        clauses
            get_state(State, Expanded):-
                get_expanded(State, Expanded).

        class predicates
            get_mouse_pos : (
                vpiDomains::windowHandle TreeWindow,
                integer X,
                integer Y)
             procedure (i,o,o).
        clauses
            get_mouse_pos(TreeWindow, X, Y):-
                getNativeWindow(TreeWindow, NativeWindow),
                Pnt = vpi::cursorGetPos(NativeWindow),
                Pnt = pnt(X, Y),
                !.
            get_mouse_pos(_, 0, 0).

        class predicates
            get_tree : (
                vpiDomains::windowHandle TreeWindow,
                itemId CurrId,
                tree TreeList)
             procedure (i,i,o).
            get_childTrees : (
                vpiDomains::windowHandle TreeWindow,
                itemId CurrId,
                tree_list TreeList)
             procedure (i,i,o).
            get_tree_list : (
                vpiDomains::windowHandle TreeWindow,
                itemId RootId,
                tree_list TreeList)
             procedure (i,i,o).
            get_tree_listTail : (
                vpiDomains::windowHandle TreeWindow,
                itemId RootId,
                tree_list TreeList)
             procedure (i,i,o).
        clauses
            get_tree(TreeWindow, CurrId, tree(CurrId, StateList, Bitmap, SelectedBitmap, Text, ChildList)):-
                get_childTrees(TreeWindow, CurrId, ChildList),
                get_item(TreeWindow, CurrId, Text, StateList, Bitmap, SelectedBitmap).

            get_childTrees(TreeWindow, CurrId, ChildList):-
                get_child(TreeWindow, CurrId, ChildId),
                not(ChildId = wcc_null),
                !,
                get_tree_list(TreeWindow, ChildId, ChildList).
            get_childTrees(_, _, []).

            get_tree_list(TreeWindow, CurrId, [Tree|TreeList]):-
                get_tree(TreeWindow, CurrId, Tree),
                get_tree_listTail(TreeWindow, CurrId, TreeList).

            get_tree_listTail(TreeWindow, CurrId, TreeList):-
                get_next(TreeWindow, CurrId, NextId),
                not(NextId = wcc_null),
                !,
                get_tree_list(TreeWindow, NextId, TreeList).
            get_tree_listTail(_TreeWindow, _CurrId,  []).


        class predicates
            check_code : (
                core::unsigned32 CodeOperation,
                vpiDomains::windowHandle TreeWindow,
                unsigned WParam,
                core::integer32 LParam,
                message Message)
                determ (i,i,i,i,o).
        clauses
            check_code(nm_outofmemory, _, _, _, outofmemory) :-
                !. % OutOfMemory
            check_code(nm_click, TreeWindow, _, _, click(pnt(X, Y))) :-
                !, % Click
                get_mouse_pos(TreeWindow, X, Y).
            check_code(nm_dblclk, TreeWindow, _, _, dblclick(pnt(X, Y))):-
                !, % double  Click
                get_mouse_pos(TreeWindow, X, Y).
            check_code(nm_return, TreeWindow, _, _, return(ItemId)) :-
                !, % Return
                get_selected(TreeWindow, ItemId).
            check_code(nm_rclick, TreeWindow, _, _, rclick(pnt(X, Y))) :-
                !, % RClick
                get_mouse_pos(TreeWindow, X, Y).
            check_code(nm_rdblclk, TreeWindow, _, _, rdblclick(pnt(X, Y))) :-
                !, % RDblClk
                get_mouse_pos(TreeWindow, X, Y).
            check_code(nm_setfocus, _, _, _, setfocus) :-
                !. % SetFocus
            check_code(nm_killfocus, _, _, _, losefocus) :-
                !. % KillFocus
            check_code(tvn_selchangingW, TreeWindow, _, LParam, selecting(ItemFrom, ItemTo)) :-
                !, % SelChanging
                get_parW(TreeWindow, LParam, ItemFrom, _, ItemTo,_).
            check_code(tvn_selchangedW, TreeWindow, _, LParam, selected(ItemFrom, ItemTo)) :-
                !, % SelChanged
                get_parW(TreeWindow, LParam, ItemFrom, _, ItemTo,_).
            check_code(tvn_selchangingA, TreeWindow, _, LParam, selecting(ItemFrom, ItemTo)) :-
                !, % SelChanging
                get_parA(TreeWindow, LParam, ItemFrom, _, ItemTo,_).
            check_code(tvn_selchangedA, TreeWindow, _, LParam, selected(ItemFrom, ItemTo)) :-
                !, % SelChanged
                get_parA(TreeWindow, LParam, ItemFrom, _, ItemTo,_).
            check_code(tvn_itemexpandingW, TreeWindow, _, LParam, expanding(Item, Expanded)) :-
                !, % ItemExpanding
                get_parW(TreeWindow, LParam, _, _, Item, State),
                get_state(State, Expanded).
            check_code(tvn_itemexpandedW, TreeWindow, _, LParam, expanded(Item, Expanded)) :-
                !, % ItemExpanded
                get_parW(TreeWindow, LParam, _, _, Item, State),
                get_state(State, Expanded).
            check_code(tvn_itemexpandedA, TreeWindow, _, LParam, expanded(Item, Expanded)) :-
                !, % ItemExpanded
                get_parW(TreeWindow, LParam, _, _, Item, State),
                get_state(State, Expanded).
            check_code(tvn_beginlabeleditW, TreeWindow, _, LParam, edit(ItemId)) :-
                !, % BeginLabelEdit
                Event = uncheckedConvert(dispinfoW,LParam),
                Event = dispinfoW(_, _, _, _, ItemIndex, _, _, _Text, _, _, _, _, _),
                get_item_id(TreeWindow, ItemIndex, ItemId).
            check_code(tvn_endlabeleditW, TreeWindow, _, LParam, Message) :-
                !,
                % EndLabelEdit
                Event = uncheckedConvert(dispinfoW,LParam),
                Event = dispinfoW(_, _, _, _, ItemIndex, _, _, Text, _, _, _, _, _),
                get_item_id(TreeWindow, ItemIndex, ItemId),
                getEndEditMessage(ItemId, Text, Message).
            check_code(tvn_keydown, _, _, LParam, keydown(Key)) :-
                % KeyDown
                Event = uncheckedConvert(keydown, LParam),
                Event = keydown(_, _, _, KeyS, _),
                Key = convert(integer, KeyS), !.

        class predicates
            getEndEditMessage : (
                itemId ItemId,
                string Text,
                message Message)
            procedure (i,i,o).
        clauses
            getEndEditMessage(ItemId,Text,endEdit(ItemId, Text)):-
                PointToText = uncheckedConvert(unsigned, Text),
                PointToText <> 0,
                !.
            getEndEditMessage(ItemId,_,endEditCanceled(ItemId)).


        /**GLOBAL PREDICATE*******************************************************
        * get_position
         *************************************************************************/
            get_position(TreeWindow, X, Y, ItemId, Position):-
                Point = hittestinfo(X, Y, 0, null_itemIndex),
                PointP = uncheckedConvert(core::integer32, Point),
                _ = send_native(TreeWindow, tvm_hittest, 0, PointP),
                Point1 = uncheckedConvert(hittestinfo,PointP),
                Point1 = hittestinfo(_, _, NativePosition, ItemIndex),
                get_item_id(TreeWindow, ItemIndex, ItemId),
                Position = getPosition_fromNative(NativePosition).

        class predicates
            send_native_index : (windowHandle TreeWindow, unsigned Message, unsigned Wparam, itemIndex Index) -> itemIndex Result procedure (i,i,i,i).
        clauses
            send_native_index(TreeWindow, Message, Wparam, Index) =
                uncheckedConvert(itemIndex,
                    send_native(TreeWindow, Message, Wparam, uncheckedConvert(core::integer32,Index))).

        /**GLOBAL PREDICATE*******************************************************
        * get_selected
         *************************************************************************/
            get_selected(TreeWindow, ItemId):-
                ItemIndex = send_native_index(TreeWindow, tvm_getnextitem, tvgn_caret, null_itemIndex),
                get_item_id(TreeWindow, ItemIndex, ItemId).

        /**GLOBAL PREDICATE*******************************************************
        * GET_PARENT
         *************************************************************************/
            get_parent(TreeWindow, ItemId, ParentId):-
                not(ItemId = wcc_null),
                !,
                get_item_index(TreeWindow, ItemId, ItemIndex),
                ParentIndex = send_native_index(TreeWindow, tvm_getnextitem, tvgn_parent, ItemIndex),
                get_item_id(TreeWindow, ParentIndex, ParentId).
            get_parent(_TreeWindow, _ItemId, _):-
                exception::raise(moduleInfo, badIdentifierException).
        /**GLOBAL PREDICATE*******************************************************
        * GET_CHILD
         *************************************************************************/
            get_child(TreeWindow, ItemId, ChildId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                ChildIndex = send_native_index(TreeWindow, tvm_getnextitem, tvgn_child, ItemIndex),
                get_item_id(TreeWindow, ChildIndex, ChildId).

        /**GLOBAL PREDICATE*******************************************************
        * GET_NEXT
         *************************************************************************/
            get_next(TreeWindow, ItemId, NextId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                NextIndex = send_native_index(TreeWindow, tvm_getnextitem, tvgn_next, ItemIndex),
                get_item_id(TreeWindow, NextIndex, NextId).

        /**GLOBAL PREDICATE*******************************************************
        * GET_PREVIOUS
         *************************************************************************/
            get_previous(TreeWindow, ItemId, PreviousId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                PreviousIndex = send_native_index(TreeWindow, tvm_getnextitem, tvgn_previous, ItemIndex),
                get_item_id(TreeWindow, PreviousIndex, PreviousId).

        /**GLOBAL PREDICATE*******************************************************
        * GET_ALL
         *************************************************************************/
            get_all(TreeWindow, TreeList):-
                get_child(TreeWindow, wcc_null, FirstId),
                not(FirstId = wcc_null),
                !,
                get_tree_list(TreeWindow, FirstId,TreeList).
            get_all(_, []).

        /**GLOBAL PREDICATE*******************************************************
        * GET_PART
         *************************************************************************/
            get_part(TreeWindow, ItemId, [Tree]):-
                not(ItemId = wcc_null),
                !,
                get_tree(TreeWindow, ItemId, Tree).
            get_part(_TreeWindow, _ItemId, _):-
                exception::raise(moduleInfo, badIdentifierException).

        /**GLOBAL PREDICATE*******************************************************
        * GET_COUNT
         *************************************************************************/
            get_count(TreeWindow, Count):-
                Count = send_native(TreeWindow, tvm_getcount, 0, 0).

        /**GLOBAL PREDICATE*******************************************************
        * GET_ITEM
         *************************************************************************/
        class predicates
            get_tvm_getitem : (itemIndex ItemIndex,core::integer32) -> unsigned   procedure (i,o).
            get_item_fields : (core::integer32,
                unsigned NativeItemState,
                string Text,
                integer BitmapIndex,
                integer SelectedImageIndex)
             procedure (i,o,o,o,o).

        clauses
            get_tvm_getitem(ItemIndex,PointP) = tvm_getitemW:-
                Mask = tvif_state + tvif_text + tvif_image + tvif_selectedimage,
                String = string::create(1000),
                Point = itemW(Mask, ItemIndex, 0, 0xffff, String, 1000, 0, 0, 0, 0),
                PointP = uncheckedConvert(core::integer32, Point).

        clauses
            get_item_fields(PointP,NativeItemState, TextOut, BitmapIndex, SelectedImageIndex):-
                Point1 = uncheckedConvert(itemW, PointP),
                Point1 = itemW(_, _, NativeItemState, _, Text, _, BitmapIndex, SelectedImageIndex, _, _),
                TextOut=Text.

        clauses
            get_item(TreeWindow, ItemId, Text, ItemState, Bitmap, SelectedBitMap):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                Tvm_getitem = get_tvm_getitem(ItemIndex,PointP),
                _ = send_native(TreeWindow, Tvm_getitem, 0, PointP),
                get_item_fields(PointP,NativeItemState, Text, BitmapIndex, SelectedImageIndex),
                ItemState = itemState_fromNative(NativeItemState),
                bitmap_index_db(TreeWindow, Bitmap, BitmapIndex),
                bitmap_index_db(TreeWindow, SelectedBitMap, SelectedImageIndex),
                !.
            get_item(_, _, _, _, _, _) :-
                common_exception::raise_Error(moduleInfo, predicate_FullName(), "bitmap_index_db did not have an entry").

        /**GLOBAL PREDICATE*******************************************************
        * EXPAND
        *************************************************************************/
        clauses
            expand(TreeWindow, ItemId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                !,
                _ = send_native_index(TreeWindow, tvm_expand, tve_toggle, ItemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * SELECT
        *************************************************************************/
        clauses
            select(TreeWindow, ItemId):-
                !,
                get_item_index(TreeWindow, ItemId, ItemIndex),
                _ = send_native_index(TreeWindow, tvm_selectitem, tvgn_caret, ItemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * SELECT
        *************************************************************************/
        clauses
            unselect(TreeWindow):-
                !,
                _ = send_native_index(TreeWindow, tvm_selectitem, tvgn_caret, null_itemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * SELECT
        *************************************************************************/
        clauses
            firstvisible(TreeWindow, ItemId):-
                !,
                get_item_index(TreeWindow, ItemId, ItemIndex),
                _ = send_native_index(TreeWindow, tvm_selectitem, tvgn_firstvisible, ItemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * SET_ITEM
        **************************************************************************/
        clauses
            set_item(TreeWindow, ItemId, Text, StateList, Bitmap, SelectedBitmap):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                set_bitmap(TreeWindow, ItemId, Bitmap, SelectedBitmap, _),
                Mask = tvif_state + tvif_text,
                TextLen = string::length(Text),
                NativeState = itemState_toNative(StateList),
                native_setItem(TreeWindow, itemW(Mask, ItemIndex, NativeState, 0xffff, Text, TextLen, 0, 0, 0, 0)).
        /**GLOBAL PREDICATE*******************************************************
        * insert_tree_list
        *************************************************************************/
        class predicates
            updateParentItem : (
                vpiDomains::windowHandle TreeWindow,
                itemId Id)
             procedure (i,i).
        clauses
            insert_tree_list(TreeWindow, Parent, InsertPlace, TreeList) :-
                get_insertParent_index(TreeWindow, Parent, ParentIndex),
                get_insertPrevious_index(TreeWindow, InsertPlace, InsertPlaceIndex),
                getNativeWindow(TreeWindow, NativeWindow),
                add_item_list(TreeWindow, NativeWindow, Parent, ParentIndex, InsertPlaceIndex, TreeList),
                updateParentItem(TreeWindow, Parent).

        clauses
            updateParentItem(_, wcc_null):-
                !.
            updateParentItem(TreeWindow, Parent):-
                get_item(TreeWindow,Parent,ParentText,ParentStateList,ParentBitmap,ParentSelectedBitmap),
                set_item(TreeWindow,Parent,ParentText,ParentStateList,ParentBitmap,ParentSelectedBitmap).

        /**GLOBAL PREDICATE*******************************************************
        * insert_tree
        *************************************************************************/
        clauses
            insert_tree(TreeWindow, Parent, InsertPlace, Tree) :-
                insert_tree_list(TreeWindow, Parent, InsertPlace, [Tree]).

        /**GLOBAL PREDICATE*******************************************************
        * INSERT_ITEM
        *************************************************************************/
        clauses
            insert_item(TreeWindow, ItemId, Parent, InsertPlace, Text, StateList, Bitmap, SelectedBitmap):-
                insert_tree(TreeWindow, Parent, InsertPlace, tree(ItemId, StateList, Bitmap, SelectedBitmap, Text, [])).

        /**GLOBAL PREDICATE*******************************************************
        * DELETE_ITEM
        *************************************************************************/
        clauses
            delete_item(TreeWindow, ItemId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                _ = send_native_index(TreeWindow, tvm_deleteitem, 0, ItemIndex),
                clear_item(TreeWindow, ItemId).

        /**GLOBAL PREDICATE*******************************************************
        * SORT_CHILDREN
        *************************************************************************/
        clauses
            sort_children(TreeWindow, ItemId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                _ = send_native_index(TreeWindow, tvm_sortchildren, 0, ItemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * EDIT_BEGIN
        *************************************************************************/
        clauses
            edit_begin(TreeWindow, ItemId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                _ = send_native_index(TreeWindow, tvm_editlabelW, 0, ItemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * EDIT_END
        *************************************************************************/
        clauses
            edit_end(TreeWindow):-
                _ = send_native(TreeWindow, tvm_endeditlabelnow, core::b_false, 0).

        /**GLOBAL PREDICATE*******************************************************
        * ENSURE_VISIBLE
        *************************************************************************/
        clauses
            ensure_visible(TreeWindow, ItemId):-
                get_item_index(TreeWindow, ItemId, ItemIndex),
                _ = send_native_index(TreeWindow, tvm_ensurevisible, 0, ItemIndex).

        /**GLOBAL PREDICATE*******************************************************
        * GET_INDENT
        *************************************************************************/
        clauses
            get_indent(TreeWindow, Indent):-
                Indent = send_native(TreeWindow, tvm_getindent, 0, 0).
        /**GLOBAL PREDICATE*******************************************************
        * SET_INDENT
        *************************************************************************/
        clauses
            set_indent(TreeWindow, Indent):-
                _ = send_native(TreeWindow, tvm_setindent, Indent, 0).

        /*************************************************************************
        * EVENT HANDLING
        *************************************************************************/
        class predicates
             getReturnValue : (message Message) -> integer   procedure (i).
        clauses
            getReturnValue(endEdit(_, _)) =0:-
                !.
            getReturnValue(_Message) = 1.

        class predicates
            onNotifyMessage : (vpiDomains::windowHandle TreeWindow, message Message, integer Return)  determ (i,i,o).
        clauses
            onNotifyMessage(TreeWindow, Message, Return) :-
                invokeCallback(TreeWindow, Message),
                !,
                vpi::winReleaseMouse(),
                vpi::cursorSet(TreeWindow, cursor_Arrow),
                Return = getReturnValue(Message).
            onNotifyMessage(_TreeWindow, endEdit(_, _), 1).  % if "callback" fails then accept modification

        class predicates
            onNotify : (vpiDomains::windowHandle TreeWindow, unsigned WParam, core::integer32 LParam, integer Return)  determ (i,i,i,o).
        clauses
            onNotify(TreeWindow, WParam, LParam, Result) :-
                Event = uncheckedConvert(nmhdr, LParam),
                Event = nmhdr(_, _, CodeOperation),
                check_code(CodeOperation, TreeWindow, WParam, LParam, Message),
                onNotifyMessage(TreeWindow, Message, Result).

        class predicates
            state_flag : (vpiDomains::stateInfo State, vpiDomains::wsflag Flag)  determ (i,o).
        clauses
                state_flag(disabled(), wsf_Disabled).
                state_flag(enabled(), wsf_Enabled).
                state_flag(invisible(), wsf_Invisible).
                state_flag(visible(), wsf_Visible).

        class predicates
            onState : (vpiDomains::windowHandle NativeWindow, vpiDomains::stateInfo State)  determ (i,i).
        clauses
            onState(NativeWindow, font(Font)) :-
                !,
                vpi::winSetFont(NativeWindow, Font).
            onState(NativeWindow, State) :-
                state_flag(State, Flag),
                vpi::winSetState(NativeWindow, [Flag]).

        class predicates
            onDestroy : (vpiDomains::windowHandle TreeWindow)  procedure (i).
        clauses
            onDestroy(TreeWindow):-
                bitmapDescr_db(TreeWindow, _, _, HimageList),
                    api_ImageList_Destroy(HimageList),
                fail.
            onDestroy(TreeWindow):-
                clearDb_window(TreeWindow).

        /**GLOBAL PREDICATE******************************************************
        * INIT
        *************************************************************************/
        class predicates
            handleEvent : vpiDomains::ehandler.
        clauses
            handleEvent(TreeWindow, Event) = Return :-
                Return = invokeSubclassHandler(TreeWindow, Event),
                !.
            handleEvent(TreeWindow, e_native(wm_notify, WParam, LParam)) = Return :-
                onNotify(TreeWindow, WParam, LParam, Return).
            handleEvent(TreeWindow, e_Size(Width, Height)) = 0 :-
                tryGetNativeWindow(TreeWindow, NativeWindow),
                vpi::winMove(NativeWindow, rct(0, 0, Width, Height)).
            handleEvent(TreeWindow, e_State(State)) = 0 :-
                tryGetNativeWindow(TreeWindow, NativeWindow),
                onState(NativeWindow, State).
            handleEvent(TreeWindow, e_GetFocus()) = 0 :-
                tryGetNativeWindow(TreeWindow, NativeWindow),
                vpi::winSetFocus(NativeWindow).
            handleEvent(TreeWindow, e_Destroy()) = 0 :-
                onDestroy(TreeWindow),
                fail.

        /**GLOBAL PREDICATE*******************************************************
        * register
        *************************************************************************/
        class facts - register
             registered_db : ()determ.
        clauses
            register():-
                registered_db(),
                !.
            register():-
                api_InitCommonControls(),
                vpi::classCreate(treeviewName, handleEvent),
                assert(registered_db()).

        class predicates
            check_register : ()  procedure ().
        clauses
            check_register() :-
                registered_db(),
                !.
            check_register() :-
                common_exception::raise_Error(moduleInfo,predicate_fullName(), "Tree window class has not been registred").

        class predicates
            create : (
                vpiDomains::windowHandle Parent,
                string WinName,
                vpiDomains::rct OuterRect,
                core::integer_list Flags,
                pointer CreationData)
             procedure (i,i,i,i,i).
        clauses
            create(TreeWindow, WinName, rct(X1, Y1, X2, Y2), Flags, CreationData) :-
                Hinst = vpi::getAttrVal(attr_win_instance),
                bitOr_flags([native_visible, native_child/*, native_border*/|Flags], 0, UIntFlags),
                NativeMenu = null,
                Width = X2-X1,
                Height = Y2-Y1,
                NativeWindow =
                    api_CreateWindowExW(0, "SysTreeView32",
                        WinName, UIntFlags,
                        X1, Y1, Width, Height,
                        TreeWindow, NativeMenu, Hinst, CreationData),
                setNativeWindow(TreeWindow, NativeWindow).

            init(TreeWindow, Flags, SizeBitMap, CallBack) :-
                check_register(),
                vpi::winEnableHook(TreeWindow, core::b_true),
                setCallback(TreeWindow, CallBack),
                ClientRect = vpi::winGetClientRect(TreeWindow),
                create(TreeWindow, "TreeWiev", ClientRect, Flags, null),
                imageList_create(TreeWindow, SizeBitmap),
                ParentWin = vpi::winGetParent(TreeWindow),
                trap(Font = vpi::winGetFont(ParentWin), Id, clear_and_fail(Id)), % Sometimes VPI can give error in this case
                trap(vpi::winSetFont(TreeWindow, Font), Id2, clear_and_fail(Id2)),
                !.
            init(_, _, _, _).

        clauses
            tryGetSubclassHandler(TreeWindow,SubclassHandler):-
                getNativeWindow(TreeWindow, _), % check for existence
                subclass_handler_db(TreeWindow, SubclassHandler),
                !.

        clauses
            badIdentifierException(moduleInfo, predicate_Name(), "bad Identifier").

    class predicates
        clear_and_fail : (exception::traceID ID) failure (i).
    clauses
        clear_and_fail(Id) :-
            trap(exception::clear(Id), _, fail),
            fail.

end implement p3TreeView