/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
/* 
24.7.5 made some efforts to optimize by removing clauses not used. also included the op-facts from pie_op.
24.7.5 removed reference to KB-identifier 'and', 'p3_iTrac', 'abs' and ';' which I believe is not used
25.7.5 removed the unpack-logic which I believe is not used any more (ref. pr::prUnpack and piex::plcRecursive)
27.10.5 used the term-string concept in set-rules (in place of to/fromTerm)
29.10.5 do. for DERF,NDERF,SSS and EX
*/

implement pie
open core,globalRefDomains

constants
className = "com/rudstrand/pie/pie".
classVersion = "1.0".

class facts
traceflag : integer:=-1.
current_var : (integer) determ.
externalChains : integer:=0.
op : (pie_scan::prior,pie_scan::xfy,pie_scan::op).

class predicates
% Pro/3 extensions:
pieCallFunc : (string,terml) nondeterm anyflow.
eval : (term,refint) nondeterm anyflow.
pieEval_L : (termDomain::sterm,refints) nondeterm anyflow. 	
pieEvalIF : (term,refsymb) nondeterm anyflow.		
pieEvalLI : (term,refstr) nondeterm anyflow.		
pieEvalLI_L : (termDomain::sterm,refstrs) nondeterm anyflow. 	
pieEvalNU : (term,refreal) nondeterm anyflow.		
pieEvalNU_L : (termDomain::sterm,refreals) nondeterm anyflow. 	
pieStrAdd : (refstr,refstr,refstr) determ anyflow.
pieStrSub : (refstr,refstr,refstr) determ anyflow.

checkRange : (string,string,string,term,term,term) determ.
checkRangeIN : (string,string,string,refint,refint,refint) determ.
checkRangeNU : (string,string,string,refreal,refreal,refreal) determ.

listMember : (term,integer,integer,term) determ anyflow.
listMember_nd : (term,term) nondeterm anyflow.
listTail : (term,term) determ anyflow.
listConcat : (term,term,term) determ anyflow.

pieLike : (refstr,refstr) determ anyflow.
pieRange : (string,string,integer,integer,integer) determ.
pieRange : (string,string,real,real,real) determ.
pieUnifVars : (env,termDomain::sterm,termDomain::sterm) anyflow.
pieUnifVarsX : (env,termDomain::sterml,termDomain::sterml) determ anyflow.
pt : (integer,termDomain::sterm) determ anyflow.
ptn : (integer,string) determ anyflow.

call : (string,terml) nondeterm anyflow.
callCompare : (string,terml) determ anyflow.
callCompareIN : (string,terml) determ anyflow.
callCompareNU : (string,terml) determ anyflow.
callCompareIF : (string,terml) determ anyflow.
callCompareLI : (string,terml) determ anyflow.
callIsOperator : (integer,string,terml) determ anyflow.
callIsOperator_nd : (integer,string,terml) nondeterm anyflow.
callIsEvalType : (string,terml) nondeterm anyflow.
callIsEvalTypeDirected : (string,terml) nondeterm anyflow.
callIsEvalTypeEqual : (string,terml) nondeterm anyflow.

unify_body : (termDomain::sterm,env,programControl::stackMark) nondeterm anyflow.
unify_term : (term,termDomain::sterm,env) nondeterm anyflow.
unify_terml : (terml,termDomain::sterml,env) nondeterm anyflow.
member : (e,env) determ anyflow.		
eeq : (term,term) nondeterm anyflow.	
eeqterml : (terml,terml) nondeterm anyflow.
handle_op : (refint,refsymb,refsymb) nondeterm anyflow.
named_clause : (string,termDomain::sterml,termDomain::sterm) nondeterm anyflow.
createVar : (term,env,string) determ anyflow.
lookup_termid : (term,env,string) determ anyflow.
get_next_unused : (env,integer,integer,string) determ anyflow.
vid_exist : (string,env) determ anyflow.
getTermStringComponent : (termDomain::sterm,integer,globalRefDomains::term) determ (i,i,o).

clauses

classInfo(className, classVersion).
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% pie
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
class predicates
% Pro/3 extensions:
setExternalChainFlag : ().
p3_SetTrace : () determ anyflow.
clauses

pie(SolRef,TERM) :-
    setExternalChainFlag,
	p3_setTrace,
  	free(ENV),
	BTOP=programControl::getbacktrack(),
	unify_body(TERM,ENV,BTOP),
                    %profileTime::start("solIns"),
	sol::solIns(SolRef,ENV),
                    %profileTime::stop("solIns"),
    programControl::cutbacktrack(BTOP),
	fail.
pie(_,_).

p3_SetTrace() :-
	tt::getLevel()<5,
	traceflag:=-1,
	!
;	
	tt::getLevel()=5,
	traceflag:=1,
	!.

setExternalChainFlag() :-
    dbaBase::database(_,_,_,N),
    N>0,
    externalChains:=1,
    !
;
    externalChains:=-1,
    !.
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% errorhnd
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
errorhnd(N) :- 
    dlgIF::feil_pie("INFERENCE ENGINE/errorhnd",[],[N],termDomain::nill),fail.
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% member
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
member(X,[X|_]) :-
    !.
member(X,[_|L]) :- 
    member(X,L).
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% named_clauses
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
named_clause(PID,TERML,B):-
      dbBase::kbIsSql,
      sqlBase::chainTermsDirect(PID,LT,B),
      LT=termDomain::cmp(_,TERML)
;
      not(dbBase::kbIsSql),
      externalChains=-1,!,
      dbaBase::database(KB,_,_,0),
	  KB:chain_terms(PID,Cls,_),
	  Cls=globalDomains::clause(RecType,_,_,_,_,termDomain::cmp(PID,TERML),B),
	  RecType>0,
	  RecType<6
;
      not(dbBase::kbIsSql),
	  dbaBase::dbaMap(PID,KB,_,No),
	  No=0,!,
	  KB:chain_terms(PID,Cls,_),
	  Cls=globalDomains::clause(RecType,_,_,_,_,termDomain::cmp(PID,TERML),B),
	  RecType>0,
	  RecType<6
;
      not(dbBase::kbIsSql),
	  dbaBase::dbaMap(PID,KB,_,No),
	  No>0,
	  KB:chain_terms(PID,Cls,_),
	  Cls=globalDomains::clause(RecType,_,_,_,_,termDomain::cmp(PID,TERML),B),
	  RecType<>3, % rules from external DBs are ignored!
	  RecType>0,
	  RecType<5. 

  eeq(T1,T2):-free(T1),free(T2),T1=int(0),T2=int(1),!,fail.
  eeq(T1,T2):-free(T1),free(T2),!.
  eeq(T1,T2):-free(T1),!,fail; free(T2),!,fail.
  eeq(cmp(ID,TERML1),cmp(ID,TERML2)):-!,eeqterml(TERML1,TERML2).
  eeq(list(H1,T1),list(H2,T2)):-!,eeq(H1,H2),eeq(T1,T2).
  eeq(X,X).

  eeqterml([],[]):-!.
  eeqterml([H1|T1],[H2|T2]):-
        eeq(H1,H2),eeqterml(T1,T2).

% @@@ could try to redesign the op-table to avoid all entries for same operator but different domain
%
  handle_op(PRIOR,XFY,OP):-
        bound(PRIOR),bound(XFY),bound(OP),
        !,
        %P1 = PRIOR, XFY1 = XFY, OP1=OP,
        %pie_op::setOp(P1,XFY1,OP1).
        retractall(op(_,_,OP)), % 24.7.5
        assert(op(PRIOR,XFY,OP)). % 24.7.5
  handle_op(PRIOR,XFY,OP):-
        %pie_op::getOp_nd(P1,A1,O1),
        op(PRIOR,XFY,OP). % 24.7.5
        %P1=PRIOR,A1=XFY,O1=OP.
  
  createVar(TERM,ENV,ID):-
        lookup_termid(TERM,ENV,ID),!.
  createVar(TERM,ENV,NEWID):-
        retract(current_var(NO)),
        NO1=NO+1,
        get_next_unused(ENV,NO1,NO2,NEWID),
        member(e(NEWID,TERM),ENV),
        assert(current_var(NO2)).
  
  lookup_termid(_,ENV,_):-free(ENV),!,fail.
  lookup_termid(TERM,[e(ID,TERM1)|_],ID):- eeq(TERM,TERM1),!.
  lookup_termid(TERM,[_|ENV],ID):- lookup_termid(TERM,ENV,ID).
  
  get_next_unused(ENV,NO,NO,NEWID):-
        ID=toString(NO),
        NEWID=string::concat("_",ID),
        not(vid_exist(NEWID,ENV)),!.
  get_next_unused(ENV,NO1,NO3,ID):-
        NO2=NO1+1,
        get_next_unused(ENV,NO2,NO3,ID).
  
  vid_exist(_,ENV):-free(ENV),!,fail.
  vid_exist(VID,[e(VID,_)|_]):-!.
  vid_exist(VID,[_|L]):-vid_exist(VID,L).
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% unify_terml
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
unify_terml([],[],_) :- 
	!.
unify_terml([TERM1|TL1],[TERM2|TL2],ENV):- 
	unify_term(TERM1,TERM2,ENV),
	unify_terml(TL1,TL2,ENV)
	.
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% unify_term
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
unify_term(TERM,termDomain::var(ID),ENV):-
	free(ID),
	free(TERM),
	!,
	createVar(TERM,ENV,ID).
unify_term(_,STerm,_):-
	bound(STerm),
	Sterm=termDomain::var("_"),
	!.
unify_term(Term,termDomain::var(ID),ENV):-
	bound(ID),
	!,
	member(e(ID,Term1),ENV),
	Term1=Term.
unify_term(int(I),termDomain::int(I),_):-
	!.
unify_term(atom(A),termDomain::atom(A),_):-
	!.
unify_term(str(S),termDomain::str(S),_):-
	!.
/* 24.7.5  unify_term(chr(C),termDomain::chr(C),_):-!. Pro/3: chr not used */	
unify_term(list(H1,T1),termDomain::list(H2,T2),ENV):-!,
	unify_term(H1,H2,ENV),
	unify_term(T1,T2,ENV).
unify_term(nill,termDomain::nill,_):-
	!.
unify_term(cmp(ID,L1),termDomain::cmp(ID,L2),ENV):-
	unify_terml(L1,L2,ENV),
	!.
% Pro/3 addition:	
unify_term(fix(F),termDomain::fix(F),_):-
	!. 	       
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% unify_body
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
unify_body(termDomain::atom("true"),_,_) :- 
                pt(12,termDomain::atom("true")),
    !.
unify_body(termDomain::cmp(",",[TERM1,TERM2]),ENV,BTOP):-
                pt(10,termDomain::cmp(",",[TERM1,TERM2])),
  	!,
  	unify_body(TERM1,ENV,BTOP),
	unify_body(TERM2,ENV,BTOP),
                pt(11,termDomain::cmp(",",[TERM1,TERM2])).
unify_body(termDomain::cmp("not",[TERM]),ENV,_):-
	BTOP=programControl::getbacktrack(),
                pt(13,TERM),
	unify_body(TERM,ENV,BTOP),
                pt(14,TERM),
 	!,fail.
unify_body(termDomain::cmp("not",[TERM]),_,_):-
                pt(15,TERM),
	!.
unify_body(termDomain::cmp("call",[TERM]),ENV,_):-
                pt(10,termDomain::cmp("call",[TERM])),
	!,
	BTOP=programControl::getbacktrack(),
	unify_body(TERM,ENV,BTOP),
                pt(11,termDomain::cmp("call",[TERM])).
%
% Pro/3: DDERF/NDERF/SSS/EX extensions
%
unify_body(termDomain::cmp("p3_iNdrf",[Val,termDomain::str(Var),termDomain::str(C)]),ENV,_):-
	!,
	unify_term(UVal,Val,ENV),
                pt(10,termDomain::cmp("p3_iNdrf",[Val,termDomain::str(Var),termDomain::str(C)])),
	Ct=termDomain::fromTermStringIndirect(C),
	% unify logically bound (i.e. with unified entries in the environment) variables in the DERF query
	pieUnifVars(ENV,Ct,Ctb),
	piex::plcNDERF(Var,Ctb,V1),		
	free(E),
	unify_term(UVal,V1,E),
                pt(11,termDomain::cmp("p3_iNdrf",[Val,termDomain::str(Var),termDomain::str(C)])).
unify_body(termDomain::cmp("p3_iDdrf",[Val,termDomain::str(Var),termDomain::str(C)]),ENV,_):-
	!,
	unify_term(UVal,Val,ENV),
                pt(10,termDomain::cmp("p3_iDdrf",[Val,termDomain::str(Var),termDomain::str(C)])),
	Ct=termDomain::fromTermStringIndirect(C),
	% unify logically bound (i.e. with unified entries in the environment) variables in the DERF query
	pieUnifVars(ENV,Ct,Ctb),
	piex::plcDDERF(Var,Ctb,V1),		
	free(E),
	unify_term(UVal,V1,E),
                pt(11,termDomain::cmp("p3_iDdrf",[Val,termDomain::str(Var),termDomain::str(C)])),
    !.
unify_body(termDomain::cmp("p3_iSSS",[Val,termDomain::str(C)]),ENV,_):-
	!,
	unify_term(UVal,Val,ENV),
                pt(10,termDomain::cmp("p3_iSSS",[Val,termDomain::str(C)])),
	Ct=termDomain::fromTermStringIndirect(C),
	% unify logically bound (i.e. with unified entries in the environment) variables in the sss query
	pieUnifVars(ENV,Ct,Ctb),
	piex::plcSSS(Ctb,V1),		
	free(E),
	unify_term(UVal,V1,E),
                pt(11,termDomain::cmp("p3_iSSS",[Val,termDomain::str(C)])),
    !.
unify_body(termDomain::cmp("p3_iExis",[termDomain::str(C)]),ENV,_):-
	!,
                pt(10,termDomain::cmp("p3_iExis",[termDomain::str(C)])),
	Ct=termDomain::fromTermStringIndirect(C),
	% unify logically bound (i.e. with unified entries in the environment) variables in the DERF query
	pieUnifVars(ENV,Ct,Ctb),
	piex::plcExists(Ctb),		
                pt(11,termDomain::cmp("p3_iExis",[termDomain::str(C)])),
    !.
unify_body(termDomain::cmp(PID,TERML),ENV,_):-
                pt(10,termDomain::cmp(PID,TERML)),
	unify_terml(CALL,TERML,ENV),
	call(PID,CALL),
                pt(11,termDomain::cmp(PID,TERML)).
unify_body(termDomain::var(ID),ENV,_):-
                pt(10,termDomain::var(ID)),
  	!,
  	member(e(ID,TERM),ENV),
	bound(TERM),
	TERM=cmp(PID,TERML), 
	call(PID,TERML),
                pt(11,termDomain::var(ID)).
unify_body(termDomain::atom(PID),_,_):-
                pt(10,termDomain::atom(PID)),
	call(PID,[]),
                pt(11,termDomain::atom(PID)).
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% callIsOperator/nd
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
callIsOperator(Length,Opr,L) :-
    Length=4, % isDD-type
    B=string::subString(Opr,2,2),
    callIsEvalType(B,L),
    !
;   
    Length=5, % isDDD-type
    B=string::subString(Opr,2,3),
    callIsEvalType(B,L),
    !.
callIsOperator(Length,Opr,[T1,T2]) :-
    Length>5,
    free(T1), % isDD_L-type or isDDD_L
    bound(T2),
    M=Length-2,
    B=string::subString(Opr,2,M),
    dom::domAllSuffix(B),
    T1=T2,
    !
;    
    Length>5,
    free(T2),
    bound(T1),
    M=Length-2,
    B=string::subString(Opr,2,M),
    dom::domAllSuffix(B),
    T2=T1,
    !.
    
callIsOperator_nd(Length,Opr,L) :-
    Length=5, % nisDD-type
    B=string::subString(Opr,3,2),
    callIsEvalType(B,L)
;
    Length=6, % nisDDD-type
    B=string::subString(Opr,3,3),
    callIsEvalType(B,L)
    .
callIsOperator_nd(Length,Opr,[T1,T2]) :-
    Length>5,
    free(T1), % isDD_L-type or isDDD_L
    bound(T2),
    M=Length-3,
    B=string::subString(Opr,3,M),
    dom::domAllSuffix(B),
    T1=T2
;    
    Length>5,
    free(T2),
    bound(T1),
    M=Length-3,
    B=string::subString(Opr,3,M),
    dom::domAllSuffix(B),
    T2=T1
    .
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% callIsEvalType/Directed/Equal
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
callIsEvalType(Dom,[T1,T2]) :-
    free(T1),
    bound(T2),
    callIsEvalTypeDirected(Dom,[T1,T2])
;
    free(T2),
    bound(T1),
    callIsEvalTypeDirected(Dom,[T2,T1])
;
    bound(T1),
    bound(T2),
    callIsEvalTypeEqual(Dom,[T1,T2])
;
    free(T1),
    free(T2),
    !,fail.
    
callIsEvalTypeDirected("IN",[T1,T2]) :-  
    eval(T2,Res),
    T1=int(Res)
;
	pieEvalNU(T2,Res2),
	Int=math::round(Res2),
	T1=int(Int)
	.
callIsEvalTypeDirected("NU",[T1,T2]) :- 
    pieEvalNU(T2,Res),
    T1=fix(Res)
	.
callIsEvalTypeDirected("LI",[T1,T2]) :- 
	pieEvalLI(T2,S),
	T1=str(S)
	.
callIsEvalTypeDirected("IF",[T1,T2]) :- 
	pieEvalIF(T2,S),
	T1=atom(S)
	.

callIsEvalTypeDirected("ID",L) :- callIsEvalTypeDirected("IN",L).
callIsEvalTypeDirected("CF",L) :- callIsEvalTypeDirected("NU",L).
callIsEvalTypeDirected("MG",L) :- callIsEvalTypeDirected("NU",L).
callIsEvalTypeDirected("PR",L) :- callIsEvalTypeDirected("NU",L).
callIsEvalTypeDirected("INC",L) :- callIsEvalTypeDirected("NU",L).
callIsEvalTypeDirected("DEC",L) :- callIsEvalTypeDirected("NU",L).
callIsEvalTypeDirected("IT",L) :- callIsEvalTypeDirected("NU",L).
callIsEvalTypeDirected("XD",L) :- callIsEvalTypeDirected("LI",L).
callIsEvalTypeDirected("XT",L) :- callIsEvalTypeDirected("LI",L).
callIsEvalTypeDirected("XDT",L) :- callIsEvalTypeDirected("LI",L).
callIsEvalTypeDirected("XDR",L) :- callIsEvalTypeDirected("LI",L).
    
callIsEvalTypeEqual("IN",[T1,T2]) :-  
    eval(T1,Res1),
    eval(T2,Res2),
    Res1=Res2
	.
callIsEvalTypeEqual("NU",[T1,T2]) :- 
    pieEvalNU(T1,Res1),
    pieEvalNU(T2,Res2),
    Res1=Res2
	.
callIsEvalTypeEqual("LI",[T1,T2]) :- 
	pieEvalLI(T1,S1),
	pieEvalLI(T2,S2),
	S1=S2
	.
callIsEvalTypeEqual("IF",[T1,T2]) :- 
	pieEvalIF(T1,S1),
	pieEvalIF(T2,S2),
	S1=S2
	.

callIsEvalTypeEqual("ID",L) :- callIsEvalTypeEqual("IN",L).
callIsEvalTypeEqual("CF",L) :- callIsEvalTypeEqual("NU",L).
callIsEvalTypeEqual("MG",L) :- callIsEvalTypeEqual("NU",L).
callIsEvalTypeEqual("PR",L) :- callIsEvalTypeEqual("NU",L).
callIsEvalTypeEqual("INC",L) :- callIsEvalTypeEqual("NU",L).
callIsEvalTypeEqual("DEC",L) :- callIsEvalTypeEqual("NU",L).
callIsEvalTypeEqual("IT",L) :- callIsEvalTypeEqual("NU",L).
callIsEvalTypeEqual("XD",L) :- callIsEvalTypeEqual("LI",L).
callIsEvalTypeEqual("XT",L) :- callIsEvalTypeEqual("LI",L).
callIsEvalTypeEqual("XDT",L) :- callIsEvalTypeEqual("LI",L).
callIsEvalTypeEqual("XDR",L) :- callIsEvalTypeEqual("LI",L).
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% callCompare/DD
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
callCompare(Opr,[int(X),int(Y)]) :- callCompareIN(Opr,[int(X),int(Y)]),!.
callCompare(Opr,[fix(X),fix(Y)]) :- callCompareNU(Opr,[fix(X),fix(Y)]),!.
callCompare(Opr,[int(X),fix(Y)]) :- callCompareNU(Opr,[int(X),fix(Y)]),!.
callCompare(Opr,[fix(X),int(Y)]) :- callCompareNU(Opr,[fix(X),int(Y)]),!.
callCompare(Opr,[atom(X),atom(Y)]) :- callCompareIF(Opr,[atom(X),atom(Y)]),!.
callCompare(Opr,[str(X),Y]) :- callCompareLI(Opr,[str(X),Y]),!.
callCompare(Opr,[X,str(Y)]) :- callCompareLI(Opr,[X,str(Y)]),!.

callCompare(Opr,[X,Y]) :-
    eval(X,Xi),   
    eval(Y,Yi),   
    callCompareIN(Opr,[int(Xi),int(Yi)]),
    !
;
    eval(X,Xi),   
    pieEvalNU(Y,Yn),
    callCompareNU(Opr,[int(Xi),fix(Yn)]),
    !
;
    eval(Y,Yi),   
    pieEvalNU(X,Xn),
    callCompareNU(Opr,[fix(Xn),int(Yi)]),
    !
;
    pieEvalNU(X,Xn),
    pieEvalNU(Y,Yn),
    callCompareNU(Opr,[fix(Xn),fix(Yn)]),
    !
;
    pieEvalIF(X,Xa),
    pieEvalIF(Y,Ya),
    callCompareIF(Opr,[atom(Xa),atom(Ya)]),
    !
;    
    pieEvalLI(X,Xa),
    pieEvalLI(Y,Ya),
    callCompareLI(Opr,[str(Xa),str(Ya)]),
    !.
    
callCompareIN("=",[TX,TY]) :- 
    eval(TX,X), eval(TY,Y), X=Y,!.
callCompareIN("<>",[TX,TY]) :- 
    eval(TX,X), eval(TY,Y), X<>Y,!.
callCompareIN(">",[TX,TY]) :- 
    eval(TX,X), eval(TY,Y), X>Y,!.
callCompareIN("<",[TX,TY]) :- 
    eval(TX,X), 
    eval(TY,Y), 
    X<Y,!.
callCompareIN(">=",[TX,TY]) :- 
    eval(TX,X), eval(TY,Y), X>=Y,!.
callCompareIN("<=",[TX,TY]) :- 
    eval(TX,X), eval(TY,Y), X<=Y,!.
callCompareIN("inside",[TX,TY]) :- 
    eval(TX,X), eval(TY,Y), X<=Y,!.

callCompareNU("=",[TX,TY]) :- pieEvalNU(TX,X), pieEvalNU(TY,Y), X=Y,!.
callCompareNU("<>",[TX,TY]) :- pieEvalNU(TX,X), pieEvalNU(TY,Y), X<>Y,!.
callCompareNU(">",[TX,TY]) :- pieEvalNU(TX,X), pieEvalNU(TY,Y), X>Y,!.
callCompareNU("<",[TX,TY]) :- pieEvalNU(TX,X), pieEvalNU(TY,Y), X<Y,!.
callCompareNU(">=",[TX,TY]) :- pieEvalNU(TX,X), pieEvalNU(TY,Y), X>=Y,!.
callCompareNU("<=",[TX,TY]) :- pieEvalNU(TX,X), pieEvalNU(TY,Y), X<=Y,!.

callCompareIF("=",[TX,TY]) :- pieEvalIF(TX,X), pieEvalIF(TY,Y), X=Y,!.
callCompareIF("<>",[TX,TY]) :- pieEvalIF(TX,X), pieEvalIF(TY,Y), X<>Y,!.

callCompareLI("=",[TX,TY]) :- pieEvalLI(TX,X), pieEvalLI(TY,Y), X=Y,!.
callCompareLI("<>",[TX,TY]) :- pieEvalLI(TX,X), pieEvalLI(TY,Y), X<>Y,!.

callCompareLI(">",[TX,TY]) :- 
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDate(X), 
    xmlGeneric::xmlValidDate(Y), 
    X>Y,
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDatetime(X), 
    xmlGeneric::xmlValidDatetime(Y),
    xmlGeneric::datetimeCompare(">",X,Y), 
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidTime(X), 
    xmlGeneric::xmlValidTime(Y), 
    xmlGeneric::timeCompare(">",X,Y), 
    !.   
callCompareLI("<",[TX,TY]) :- 
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDate(X), 
    xmlGeneric::xmlValidDate(Y), 
    X<Y,
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDatetime(X), 
    xmlGeneric::xmlValidDatetime(Y), 
    xmlGeneric::datetimeCompare("<",X,Y), 
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidTime(X), 
    xmlGeneric::xmlValidTime(Y), 
    xmlGeneric::timeCompare("<",X,Y), 
    !.   
callCompareLI(">=",[TX,TY]) :- 
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDate(X), 
    xmlGeneric::xmlValidDate(Y), 
    X>=Y,
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDatetime(X), 
    xmlGeneric::xmlValidDatetime(Y), 
    xmlGeneric::datetimeCompare(">=",X,Y), 
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidTime(X), 
    xmlGeneric::xmlValidTime(Y), 
    xmlGeneric::timeCompare(">=",X,Y), 
    !.   
callCompareLI("<=",[TX,TY]) :-
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDate(X), 
    xmlGeneric::xmlValidDate(Y), 
    X<=Y,
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidDatetime(X), 
    xmlGeneric::xmlValidDatetime(Y), 
    xmlGeneric::datetimeCompare("<=",X,Y), 
    !
;    
    pieEvalLI(TX,X), 
    pieEvalLI(TY,Y),
    xmlGeneric::xmlValidTime(X), 
    xmlGeneric::xmlValidTime(Y), 
    xmlGeneric::timeCompare("<=",X,Y), 
    !.   
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
% call
% --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
call(_,_):- 
    globalVars::get_i("quit_flag")=1,!,fail. % Pro/3 extension
call(Opr,[T1,T2]) :-
    Length=string::length(Opr),
    Length>3, 
    A=string::subString(Opr,0,2),
    A="is",
    callIsOperator(Length,Opr,[T1,T2]), % handles all is type operators
    !
;    
    Length=string::length(Opr),
    Length>4, 
    A=string::subString(Opr,0,3),
    A="nis",
    callIsOperator_nd(Length,Opr,[T1,T2]). % handles all nis... type operators
call("nis",_) :- 
    dlgIF::dlgNote(3,"Invalid nis-call in PIE"),!,fail.
call("is",B) :- 
    call("=",B),
    !. %dlgIF::dlgNote(3,"Invalid is-call in PIE"),!,fail.
call("=",[T1,T2]) :- 
    bound(T1),
    bound(T2),
    callCompare("=",[T1,T2]),
    !
;    
    free(T1),
    bound(T2),
    T2=int(V),
    T1=int(V),
    !
;    
    free(T1),
    bound(T2),
    T2=fix(V),
    T1=fix(V),
    !
;    
    free(T1),
    bound(T2),
    T2=atom(V),
    T1=atom(V),
    !
;    
    free(T1),
    bound(T2),
    T2=str(V),
    T1=str(V),
    !
;
    free(T1),
    bound(T2),
    eval(T2,V),
    T1=int(V),
    !
;
    free(T1),
    bound(T2),
    pieEvalNU(T2,V),
    T1=fix(V),
    !
;
    free(T1),
    bound(T2),
    pieEvalIF(T2,V),
    T1=atom(V),
    !
;
    free(T1),
    bound(T2),
    pieEvalLI(T2,V),
    T1=str(V),
    !.
call("=",[T2,T1]) :- 
    free(T1),
    bound(T2),
    T2=int(V),
    T1=int(V),
    !
;    
    free(T1),
    bound(T2),
    T2=fix(V),
    T1=fix(V),
    !
;    
    free(T1),
    bound(T2),
    T2=atom(V),
    T1=atom(V),
    !
;    
    free(T1),
    bound(T2),
    T2=str(V),
    T1=str(V),
    !
;
    free(T1),
    bound(T2),
    eval(T2,V),
    T1=int(V),
    !
;
    free(T1),
    bound(T2),
    pieEvalNU(T2,V),
    T1=fix(V),
    !
;
    free(T1),
    bound(T2),
    pieEvalIF(T2,V),
    T1=atom(V),
    !
;
    free(T1),
    bound(T2),
    pieEvalLI(T2,V),
    T1=str(V),
    !.   
call("<>",[T1,T2]) :- 
    callCompare("<>",[T1,T2]),
    !.
call("<",[T1,T2]) :- 
    callCompare("<",[T1,T2]),
    !.
call(">",[T1,T2]) :- 
    callCompare(">",[T1,T2]),
    !.
call("<=",[T1,T2]) :- 
    callCompare("<=",[T1,T2]),
    !.
call(">=",[T1,T2]) :- 
    callCompare(">=",[T1,T2]),
    !.
call("inside",[T1,T2]) :- 
    T2=cmp(_,[str(RangeType),atom(Domain),Low,High]),
    checkRange("inside",RangeType,Domain,T1,Low,High),
    !.
call("outside",[T1,T2]) :- 
    T2=cmp(_,[str(RangeType),atom(Domain),Low,High]),
    checkRange("outside",RangeType,Domain,T1,Low,High),
    !.
call("integer",[TERM]):-
    !,
    bound(TERM),TERM=int(_).
call("var",[TERM]):-
    !,
    free(TERM).
call("nonvar",[TERM]):-
    !,
    bound(TERM).
call("op",[int(PRIOR),atom(ASSOC),atom(OP)]):-
    !, 
    handle_op(PRIOR,ASSOC,OP).
%
% like/unlike
%
call("like",[T1,T2]) :- 
	pieEvalLI(T1,S1), 
	pieEvalLI(T2,S2),
	!,
	pieLike(S1,S2).
call("unlike",[T1,T2]) :-
	call("like",[T1,T2]),
	!,fail
;
	!.	
% Pro/3 procedures [profile:insignificant]
% 
call(Rule,[str(Query),str(AttrVars),str(Assignments)|ImpEnt]) :- 
	rub::rubRuleTypeSet(Rule),
	piex::procedureCall(Rule,Query,AttrVars,Assignments,ImpEntVals),
	free(E),
	unify_terml(ImpEnt,ImpEntVals,E).
call(Rule,[str(Query),str(AttrVars),str(Assignments)|ImpEnt]) :-
	rub::rubRuleTypeSel(Rule),
	piex::procedureCall(Rule,Query,AttrVars,Assignments,ImpEntVals),
	free(E),
	unify_terml(ImpEnt,ImpEntVals,E).
%	
% call to a deterministic function [profile:insignificant]
%
call(Function,[atom("p3_iDtFn")|TERML]) :- 
    builtInFunc(Function),
            ptn(22,Function),
	pieCallFunc(Function,TERML), % handles built-in functions only
            ptn(23,Function),
	!
;
            ptn(22,Function),
	call(Function,TERML), % handles non built-in functions
            ptn(23,Function),
	!.
%	
% call to a non-deterministic built-in function
%
call(Function,TERML) :- 
    builtInFunc(Function),
            ptn(24,Function),
	pieCallFunc(Function,TERML),
            ptn(25,Function).
%
% clauses (incl. functions)
%	
call(ID,TERML):-
	BTOP=programControl::getbacktrack(),
                    %profileTime::start("named_clause"),
	named_clause(ID,TERML1,BODY),
                    %profileTime::stop("named_clause"),
	% named_clause has retrieved: cmp(ID,TERML1),BODY) from the KB
	free(ENV),
                ptn(20,ID),
	unify_terml(TERML,TERML1,ENV),
	unify_body(BODY,ENV,BTOP),
                ptn(21,ID).
% ----------------------------------------------------------------------------------------
% pieCallFunc
% ----------------------------------------------------------------------------------------
% Handles all built-in functions.
%
% string functions
%
pieCallFunc("p3_fConc",[Ret,List]) :- 
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fConc(Val,List2),
	Ret=str(Val),
	!.
pieCallFunc("p3_fUpp",[Ret,T]) :-
	pieEvalLI(T,Te),
	piex::p3_fUpp(Val,Te),
	Ret=str(Val),
	!.
pieCallFunc("p3_fLow",[Ret,T]) :-
	pieEvalLI(T,Te),
	piex::p3_fLow(Val,Te),
	Ret=str(Val),
	!.
pieCallFunc("p3_fSubstr",[Ret,Str,Pos,Len]) :- 
	pieEvalLI(Str,StrE),
	eval(Pos,PosE),
	eval(Len,LenE),
	piex::p3_fSubstr(Val,StrE,PosE,LenE),
	Ret=str(Val),
	!.
pieCallFunc("p3_fNLsng",[Ret,Str]) :- 
	pieEvalLI(Str,StrE),
	dbBase::nlTry(StrE,Val),
	Ret=str(Val),
	!.
pieCallFunc("p3_fToStr",[str(S),atom(S)]) :- 
	!.
% date functions 
%
pieCallFunc("p3_fDay",[int(I),T]) :- 
	eval(T,N), 
	datetime::datI_to_DMY(N,D,_,_),
	I=D,
	!.
pieCallFunc("p3_fMon",[int(I),T]) :- 
	eval(T,N), 
	datetime::datI_to_DMY(N,_,M,_),
	I=M,
	!.
pieCallFunc("p3_fYr",[int(I),T]) :- 
	eval(T,N), 
	datetime::datI_to_DMY(N,_,_,Y),
	I=Y,
	!.
pieCallFunc("p3_fDat3",[str(S),T]) :- 
	eval(T,N),
	datetime::datI_to_DMY(N,D,M,Y),
	datetime::datS(D,M,Y,S1),
	S=S1,
	!.
pieCallFunc("p3_fDat4",[int(I),Td,Tm,Ty]) :- 
	eval(Td,D),
	eval(Tm,M),
	eval(Ty,Y), 
	datetime::datDMY_to_I(D,M,Y,I1),
	I=I1,
	!.
pieCallFunc("p3_fNow",[int(I)]) :-
	datetime::tsNow(Ts),
	Ts=[_,_,_,H,Mi,S,B],
	II=H*360000+Mi*6000+S*100+B,
	I=II,
	!.
pieCallFunc("p3_fToday",[int(I)]) :-
	datetime::tsNow(Ts),
	Ts=[Y,M,D|_],
	datetime::datDMY_to_I(D,M,Y,No),
	I=No,
	!.
pieCallFunc("p3_fWkDay",[int(I),T]) :- 
	eval(T,N), 
	datetime::datWeekDay(N,No),
	I=No,
	!.
% x-date functions 
%
pieCallFunc("p3_fXWkDay",[int(I),T]) :-
	pieEvalLI(T,S),
	xmlGeneric::xmlDayNoInWeek(S,No),
	I=No,
	!.
pieCallFunc("p3_fXDat1",[str(S),T]) :-
	pieEvalLI(T,TS),
	sx::substring(TS,1,4,Y),
	sx::substring(TS,5,2,M),
	sx::substring(TS,7,2,D),
	sx::concat([Y,"-",M,"-",D],X),
	xmlGeneric::xmlValidDate(X),
	S=X,
	!.
pieCallFunc("p3_fXDat2",[int(I),T]) :-
	pieEvalLI(T,TS),
	xmlGeneric::xmlValidDate(TS),
	sx::substring(TS,1,4,Y),
	sx::substring(TS,6,2,M),
	sx::substring(TS,9,2,D),
	Yi=sx::toInt(Y),
	Mi=sx::toInt(M),
	Di=sx::toInt(D),
	datetime::datDMY_to_I(Di,Mi,Yi,No),
	I=No,
	!.
pieCallFunc("p3_fXDat3",[str(S),T]) :- 
	eval(T,N), 
	xmlGeneric::xmlFromInternalDate(N,X),
	S=X,
	!.
pieCallFunc("p3_fXNDays",[int(I),D1,D2]) :-
	pieEvalLI(D1,D1s),
	xmlGeneric::xmlValidDate(D1s),
	sx::substring(D1s,1,4,Y1),
	sx::substring(D1s,6,2,M1),
	sx::substring(D1s,9,2,Da1),
	Y1i=sx::toInt(Y1),
	M1i=sx::toInt(M1),
	D1i=sx::toInt(Da1),
	datetime::datDMY_to_I(D1i,M1i,Y1i,No1),
	pieEvalLI(D2,D2s),
	xmlGeneric::xmlValidDate(D2s),
	sx::substring(D2s,1,4,Y2),
	sx::substring(D2s,6,2,M2),
	sx::substring(D2s,9,2,Da2),
	Y2i=sx::toInt(Y2),
	M2i=sx::toInt(M2),
	D2i=sx::toInt(Da2),
	datetime::datDMY_to_I(D2i,M2i,Y2i,No2),
	Diff=No2-No1,
	I=Diff,	
	!.
pieCallFunc("p3_fXTdNw",[str(S)]) :-
	datetime::tsNow(Ts),
	Ts=[Y,M,D,H,Mi,Sc,B],
	Zh=globalVars::get_i("tzonh"),
	Zm=globalVars::get_i("tzonm"),
	xmlGeneric::xmlDatetime(Y,M,D,H,Mi,Sc,B,Zh,Zm,Datetime),
	S=Datetime,
	!.
pieCallFunc("p3_fXNow",[str(S)]) :-
	datetime::tsNow(Ts),
	Ts=[_,_,_,H,Mi,Sc,B],
	Zh=globalVars::get_i("tzonh"),
	Zm=globalVars::get_i("tzonm"),
	xmlGeneric::xmlTime(H,Mi,Sc,B,Zh,Zm,Time),
	S=Time,
	!.
pieCallFunc("p3_fXToday",[str(S)]) :-
	datetime::tsNow(Ts),
	Ts=[Y,M,D|_],
	xmlGeneric::xmlDate(Y,M,D,Date),
	S=Date,
	!.
% list functions
%
pieCallFunc("p3_fLT_I",[Ret,List]) :- 
	free(ENV),
	unify_term(List,List1,ENV),
	pieEval_L(List1,List2),
	piex::p3_fLT_I(Val,List2),
	Ret=int(Val),!.
pieCallFunc("p3_fGT_I",[Ret,List]) :- 
	free(ENV),
	unify_term(List,List1,ENV),
	pieEval_L(List1,List2),
	piex::p3_fGT_I(Val,List2),
	Ret=int(Val),!.
pieCallFunc("p3_fLT_XD",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fLT_XD(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fGT_XD",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fGT_XD(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fLT_XT",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fLT_XT(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fGT_XT",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fGT_XT(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fLT_XDT",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fLT_XDT(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fGT_XDT",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fGT_XDT(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fLT_XR",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fLT_XR(Val,List2),
	Ret=str(Val),!.
pieCallFunc("p3_fGT_XR",[Ret,List]) :-
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalLI_L(List1,List2),
	piex::p3_fGT_XR(Val,List2),
	Ret=str(Val),
	!.
pieCallFunc("p3_fMax",[Ret,List]) :- 
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalNU_L(List1,List2),
	piex::p3_fMax(Val,List2),
	Ret=fix(Val),
	!.
pieCallFunc("p3_fMin",[Ret,List]) :- 
	free(ENV),
	unify_term(List,List1,ENV),
	pieEvalNU_L(List1,List2),
	piex::p3_fMin(Val,List2),
	Ret=fix(Val),
	!.
pieCallFunc("p3_fIxIN",[Ret,List,Elm]) :- 
	free(ENV),
	unify_term(List,List1,ENV),
	pieEval_L(List1,List2),
	eval(Elm,E),
	piex::p3_fIxIN(Val,1,List2,E),
	Ret=int(Val),
	!.
% generic list functions
%	
pieCallFunc("p3_fListNo",[Ret,List,No]) :- eval(No,N), listMember(List,1,N,Ret),!.
pieCallFunc("p3_fListHead",[Ret,List]) :- listMember(List,1,1,Ret),!.
pieCallFunc("p3_fListTail",[Ret,List]) :- listTail(List,Ret),!.
pieCallFunc("p3_fListMbs",[Ret,List]) :- listMember_nd(List,Ret).
pieCallFunc("p3_fListConc",[Ret,List1,List2]) :- listConcat(List1,List2,Ret),!.
% file functions
%	
pieCallFunc("p3_fKB_F",[str(S)]) :-
	FF=globalVars::get_s("kb_file"),
	fio::file_name(FF,_,F,T),
	sx::concat([F,".",T],FN),
	S=FN,!.
pieCallFunc("p3_fKB_P",[str(S)]) :-
	FF=globalVars::get_s("kb_file"),
	fio::file_name(FF,P,_,_),
	S=P,!.
% other functions
%
pieCallFunc("p3_fError",[str(S),Par]) :-
	pieEvalLI(Par,S),
  	dlgIF::feil_pie("p3_fError",["BUILT-IN ERROR FUNCTION CALLED",S],[],termDomain::nill),!,fail.
pieCallFunc("p3_fTrace",[str(S),str(Loc),Par]) :-
	pieEvalLI(Par,S),
	M=string::concat("Loc:",Loc,"=",S),
	tt::tt_s(1,"**TRACE: ",M),
	!.
pieCallFunc("p3_fSeq_I",[Ret,First,Last,Step]) :- 
	eval(First,Fe),
	eval(Last,Le),
	eval(Step,Se),
	piex::p3_fSeq_I(I,Fe,Le,Se),
	Ret=int(I).
pieCallFunc("p3_fSeq_N",[Ret,First,Last,Step]) :- 
	pieEvalNU(First,Fe),
	pieEvalNU(Last,Le),
	pieEvalNU(Step,Se),
	piex::p3_fSeq_N(I,Fe,Le,Se),
	Ret=fix(I).
pieCallFunc("p3_fSeq_D",[Ret,First,Last,Step]) :- 
	pieEvalLI(First,Fe),
	pieEvalLI(Last,Le),
	pieEvalLI(Step,Se),
	piex::p3_fSeq_D(S,Fe,Le,Se),
	Ret=str(S).
pieCallFunc("p3_fSeq_T",[Ret,First,Last,Step]) :- 
	pieEvalLI(First,Fe),
	pieEvalLI(Last,Le),
	pieEvalLI(Step,Se),
	piex::p3_fSeq_T(S,Fe,Le,Se),
	Ret=str(S).
pieCallFunc("p3_fSeq_DT",[Ret,First,Last,Step]) :- 
	pieEvalLI(First,Fe),
	pieEvalLI(Last,Le),
	pieEvalLI(Step,Se),
	piex::p3_fSeq_DT(S,Fe,Le,Se),
	Ret=str(S).
pieCallFunc("p3_fIRan",[Ret,X,Typ,Low,High]) :- 
	pieEvalLI(Typ,T),
	eval(X,Xe),
	eval(Low,L),
	eval(High,H),
	!,
	pieRange("p3_fIRan",T,Xe,L,H),
	Ret=int(Xe),
	!
;
	pieEvalLI(Typ,T),
	!,
	pieEvalNU(X,Xe),
	pieEvalNU(Low,L),
	pieEvalNU(High,H),
	pieRange("p3_fIRan",T,Xe,L,H),
	Ret=fix(Xe),
	!.
pieCallFunc("p3_fORan",[Ret,X,Typ,Low,High]) :- 
	pieEvalLI(Typ,T),
	eval(X,Xe),
	eval(Low,L),
	eval(High,H),
	!,
	pieRange("p3_fIRan",T,Xe,L,H),
	Ret=int(Xe),
	!
;
	pieEvalLI(Typ,T),
	pieEvalNU(X,Xe),
	pieEvalNU(Low,L),
	pieEvalNU(High,H),
	pieRange("p3_fORan",T,Xe,L,H),
	Ret=fix(Xe),
	!.
pieCallFunc("p3_fTsC",[Ret,TermString,CompNo]) :- 
	pieEvalLI(TermString,Ts),
	eval(CompNo,N),
	T=termDomain::fromTermStringIndirect(Ts),
	getTermStringComponent(T,N,Comp),
	Ret=Comp,
	!.
% ----------------------------------------------------------------------------------------
%                                    EXTENSIONS
% ----------------------------------------------------------------------------------------
% pieLike
% ----------------------------------------------------------------------------------------
pieLike(S,T) :-
	sx::frontchar(T,'%',T1),
	sx::sxTail(1,T1,Mid,Tail),
	Tail="%",
	!,sx::searchstring(S,Mid,_),!
;	
	sx::frontchar(T,'%',Tail),
	Nt=string::length(Tail),
	Ns=string::length(S),
	Nt>Ns,
	!,fail
;	
	sx::frontchar(T,'%',Tail),
	!,Nt=string::length(Tail),
	Ns=string::length(S),
	P=Ns-Nt+1,
	sx::substring(S,P,Nt,St),
	St=Tail,!
;	
	sx::sxTail(1,T,Front,Tail),
	Tail="%",
	Nf=string::length(Front),
	Ns=string::length(S),
	Nf>Ns,
	!,fail
;	
	sx::sxTail(1,T,Front,Tail),
	Tail="%",
	Nf=string::length(Front),
	sx::frontstr(Nf,S,Sf,_),
	Sf=Front,!.
% ----------------------------------------------------------------------------------------
% pieRange
% ----------------------------------------------------------------------------------------
pieRange("p3_fIRan","[]",X,L,H) :- X>=L, X<=H, !. 
pieRange("p3_fIRan","[>",X,L,H) :- X>=L, X<H, !. 
pieRange("p3_fIRan","<]",X,L,H) :- X>L, X<=H, !. 
pieRange("p3_fIRan","<>",X,L,H) :- X>L, X<H, !. 
pieRange("p3_fORan",Typ,X,L,H) :- 
	pieRange("p3_fIRan",Typ,X,L,H),
	!,fail
;
	!. 
% ----------------------------------------------------------------------------------------
% getTermStringComponent
% ----------------------------------------------------------------------------------------
class predicates
getTSC : (integer,integer,termDomain::sterml,globalRefDomains::term) determ (i,i,i,o).
clauses

getTermStringComponent(Ts,N,Comp) :-
    Ts=termDomain::cmp(_,L),
    getTSC(1,N,L,Comp),
    !
;
  	dlgIF::feil_pie("getTermStringComponent",["Not a basic term"],[],Ts),!,fail.

getTSC(N,N,[Comp|_],CompR) :- 
    Comp=termDomain::str(S),
    Sr=S,
    CompR=globalRefDomains::str(Sr),
    !
;    
    Comp=termDomain::atom(S),
    Sr=S,
    CompR=globalRefDomains::atom(Sr),
    !
;    
    Comp=termDomain::int(S),
    Sr=S,
    CompR=globalRefDomains::int(Sr),
    !
;    
    Comp=termDomain::fix(S),
    Sr=S,
    CompR=globalRefDomains::fix(Sr),
    !.
getTSC(N,M,[_|Comps],Comp) :-
    N<M,
    Next=N+1,
    getTSC(Next,M,Comps,Comp),
    !.
% ----------------------------------------------------------------------------------------
% evaluation
% ----------------------------------------------------------------------------------------
eval(T,_)                  :- free(T),!,fail.  % or 'exit(1040)' free var not allowed
eval(int(I),I).
eval(cmp("+",[T1,T2]),R)   :- 
	eval(T1,R1), 
	eval(T2,R2), 
	R=R1+R2.
eval(cmp("-",[T1,T2]),R)   :- 
	eval(T1,R1), 
	eval(T2,R2), 
	R=R1-R2.
eval(cmp("*",[T1,T2]),R)   :- 
	eval(T1,R1), 
	eval(T2,R2), 
	R=R1*R2.
eval(cmp("-",[T1]),R)      :- 
	eval(T1,R1), 
	R=-R1.
eval(cmp("mod",[T1,T2]),R) :- 
	eval(T1,R1), 
	eval(T2,R2), 
	R=R1 mod R2.
eval(cmp("div",[T1,T2]),R):-
	eval(T2,R2), 
	eval(T1,R1), 
	R=R1 div R2.
eval(cmp("/",[T1,T2]),R):-
	pieEvalNU(T2,R2), 
	pieEvalNU(T1,R1), 
	Rf=R1/R2,
	R=math::trunc(Rf).
eval(cmp("^",[T1,T2]),R) :- 
	eval(T1,I1), 
	eval(T2,I2),
	Res=math::power(I1,I2),
	R=math::round(Res).
eval(cmp(Func,[atom("p3_iDtFn")|Parms]),R) :- 
	call(Func,Parms),
	!,Parms=[H|_],
	eval(H,R),!.
eval(cmp(Func,Parms),R) :- 
	call(Func,Parms),
	Parms=[H|_],
	eval(H,R).
			
pieEval_L(termDomain::list(H,termDomain::nill),[He]) :- 
	conversion::sterm_term(H,Ht),
	eval(Ht,He).
pieEval_L(termDomain::list(H,T),[He|Te]) :-
	conversion::sterm_term(H,Ht),
	eval(Ht,He),
	pieEval_L(T,Te).
		
pieEvalIF(T,_):- free(T), !, fail.  % or 'exit(1040)' free var not allowed
pieEvalIF(atom(A),S) :- S=A.
pieEvalIF(cmp(Func,[atom("p3_iDtFn")|Parms]),R) :- 
	call(Func,Parms),
	!,Parms=[H|_],
	pieEvalIF(H,R).
pieEvalIF(cmp(Func,Parms),R) :- 
	call(Func,Parms),
	Parms=[H|_],
	pieEvalIF(H,R).

pieEvalLI(T,_):- free(T), !, fail.  % or 'exit(1040)' free var not allowed
pieEvalLI(str(S),S).
pieEvalLI(atom(A),S) :- dbBase::nlTry(A,NL), S=NL.
pieEvalLI(int(I),S) :- S=toString(I).
pieEvalLI(fix(F),S) :- S=toString(F).
pieEvalLI(cmp("*",[T1,T2]),R):-  % concatenation
	pieEvalLI(T1,R1), 
	pieEvalLI(T2,R2),
	R=string::concat(R1,R2).
pieEvalLI(cmp("+",[T1,T2]),R):-  % xml date/time/duration add
	pieEvalLI(T1,R1), 
	pieEvalLI(T2,R2), 
	pieStrAdd(R1,R2,Rx), %  [profile:insignificant]
	R=Rx.
pieEvalLI(cmp("-",[T1,T2]),R) :-  % xml date/time/duration subtraction
	pieEvalLI(T1,R1), 
	pieEvalLI(T2,R2), 
	pieStrSub(R1,R2,Rx), % [profile:insignificant]
	R=Rx.
pieEvalLI(cmp(Func,[atom("p3_iDtFn")|Parms]),R) :- 
	call(Func,Parms),
	!,Parms=[H|_],
	pieEvalLI(H,R).
pieEvalLI(cmp(Func,Parms),R) :- 
	call(Func,Parms),
	Parms=[H|_],
	pieEvalLI(H,R).

pieEvalLI_L(termDomain::list(H,termDomain::nill),[He]) :- 
	conversion::sterm_term(H,Ht),
	pieEvalLI(Ht,He).
	
pieEvalLI_L(termDomain::list(H,T),[He|Te]) :-
	conversion::sterm_term(H,Ht),
	pieEvalLI(Ht,He),
	pieEvalLI_L(T,Te).

pieEvalNU(T,_):- free(T), !, fail.  
pieEvalNU(fix(F),F).
pieEvalNU(int(I),F) :- F=convert(real,I). 
pieEvalNU(cmp("+",[T1,T2]),R):- pieEvalNU(T1,R1), pieEvalNU(T2,R2), R=R1+R2.
pieEvalNU(cmp("-",[T1,T2]),R):- pieEvalNU(T1,R1), pieEvalNU(T2,R2), R=R1-R2.
pieEvalNU(cmp("*",[T1,T2]),R):- 
    pieEvalNU(T1,R1), 
    pieEvalNU(T2,R2), 
    R=R1*R2.
pieEvalNU(cmp("/",[T1,T2]),R):- pieEvalNU(T2,R2), pieEvalNU(T1,R1), R=R1/R2.
pieEvalNU(cmp("div",[T1,T2]),R):- pieEvalNU(T2,R2), pieEvalNU(T1,R1), R=R1/R2.
pieEvalNU(cmp("-",[T1]),R):- pieEvalNU(T1,R1), R=-R1.
pieEvalNU(cmp("^",[T1,T2]),R):- pieEvalNU(T1,R1), pieEvalNU(T2,R2), R=math::power(R1,R2).
pieEvalNU(cmp(Func,[atom("p3_iDtFn")|Parms]),R) :- call(Func,Parms),!,Parms=[H|_], pieEvalNU(H,R).
pieEvalNU(cmp(Func,Parms),R) :- call(Func,Parms), Parms=[H|_], pieEvalNU(H,R).
	
pieEvalNU_L(termDomain::list(H,termDomain::nill),[He]) :- conversion::sterm_term(H,Ht), pieEvalNU(Ht,He).
pieEvalNU_L(termDomain::list(H,T),[He|Te]) :- conversion::sterm_term(H,Ht), pieEvalNU(Ht,He), pieEvalNU_L(T,Te).

pieUnifVars(E,termDomain::var(V),B) :-
	member(e(V,V1),E),
	Val=V1,
	bound(Val), 
	conversion::term_sterm(Val,B),
	!.
pieUnifVars(E,termDomain::cmp(H,T),termDomain::cmp(H,Tb)) :-  
    pieUnifVarsX(E,T,Tb),
    !.
pieUnifVars(_,C,C) :- 
    !.
pieUnifVarsX(_,[],[]) :- 
    !.
pieUnifVarsX(E,[H|T],[Hb|Tb]) :-
	pieUnifVars(E,H,Hb),
	pieUnifVarsX(E,T,Tb),
	!.
pieStrAdd(S,T,R) :-
	xmlGeneric::xmlValidDate(S),
	xmlGeneric::xmlValidDuration(T),
	xmlGeneric::xmlDateAdd(S,T,R),
	!.
pieStrAdd(S,T,R) :-
	xmlGeneric::xmlValidDatetime(S),
	xmlGeneric::xmlValidDuration(T),
	xmlGeneric::xmlDatetimeAdd(S,T,R),
	!.
pieStrAdd(S,T,R) :-
	xmlGeneric::xmlValidTime(S),
	xmlGeneric::xmlValidDuration(T),
	xmlGeneric::xmlTimeAdd(S,T,R),
	!.
pieStrSub(S,T,R) :-
	xmlGeneric::xmlValidDate(S),
	xmlGeneric::xmlValidDuration(T),
	xmlGeneric::xmlDateSub(S,T,R),
	!.
pieStrSub(S,T,R) :-
	xmlGeneric::xmlValidDatetime(S),
	xmlGeneric::xmlValidDuration(T),
	xmlGeneric::xmlDatetimeSub(S,T,R),
	!.
pieStrSub(S,T,R) :-
	xmlGeneric::xmlValidTime(S),
	xmlGeneric::xmlValidDuration(T),
	xmlGeneric::xmlTimeSub(S,T,R),
	!.
listMember(list(Ret,_),N,N,Ret) :- !.
listMember(list(_,L),N,M,Ret) :- Next=N+1, listMember(L,Next,M,Ret),!.
listMember_nd(list(H,T),Ret) :- Ret=H; listMember_nd(T,Ret).
listTail(list(_,Tail),Tail) :- !.
listConcat(nill,L,L) :- !.
listConcat(list(H,T),L,Ret) :- listConcat(T,L,R), Ret=list(H,R),!.	

/* ranges */

checkRange(RangeType,SubType,Domain,Val,Low,High) :-
    dom::domInt(Domain),
    eval(Val,V),
    eval(Low,L),
    eval(High,H),
    string::front(SubType,1,Lb,Hb),
    checkRangeIN(RangeType,Lb,Hb,V,L,H),
    !
;
    dom::domNum(Domain),
    pieEvalNU(Val,V),
    pieEvalNU(Low,L),
    pieEvalNU(High,H),
    string::front(SubType,1,Lb,Hb),
    checkRangeNU(RangeType,Lb,Hb,V,L,H),
    !.

checkRangeIN("inside","[","]",V,L,H) :- V>=L, V<=H,!.
checkRangeIN("inside","[",">",V,L,H) :- V>=L, V<H,!.
checkRangeIN("inside","<","]",V,L,H) :- V>L, V<=H,!.
checkRangeIN("inside","<",">",V,L,H) :- V>L, V<H,!.
checkRangeIN("outside","[",_,V,L,_) :- V<L,!.
checkRangeIN("outside","<",_,V,L,_) :- V<=L,!.
checkRangeIN("outside",_,"]",V,_,H) :- V>H,!.
checkRangeIN("outside",_,">",V,_,H) :- V>=H,!.

checkRangeNU("inside","[","]",V,L,H) :- V>=L, V<=H,!.
checkRangeNU("inside","[",">",V,L,H) :- V>=L, V<H,!.
checkRangeNU("inside","<","]",V,L,H) :- V>L, V<=H,!.
checkRangeNU("inside","<",">",V,L,H) :- V>L, V<H,!.
checkRangeNU("outside","[",_,V,L,_) :- V<L,!.
checkRangeNU("outside","<",_,V,L,_) :- V<=L,!.
checkRangeNU("outside",_,"]",V,_,H) :- V>H,!.
checkRangeNU("outside",_,">",V,_,H) :- V>=H,!.

/* string functions */

builtInFunc("p3_fConc").    
builtInFunc("p3_fUpp").   
builtInFunc("p3_fLow").     
builtInFunc("p3_fSubstr").     
builtInFunc("p3_fNLsng").     
builtInFunc("p3_fToStr").    

/* old date/time functions */

builtInFunc("p3_fDay").    
builtInFunc("p3_fMon").     
builtInFunc("p3_fYr").     
builtInFunc("p3_fDat3").     
builtInFunc("p3_fDat4").     
builtInFunc("p3_fNow").     
builtInFunc("p3_fToday").     
builtInFunc("p3_fWkDay").     

/* xml date/time functions */

builtInFunc("p3_fXDat1").     
builtInFunc("p3_fXDat2").     
builtInFunc("p3_fXDat3").    
builtInFunc("p3_fXNow").    
builtInFunc("p3_fXToday").     
builtInFunc("p3_fXTdNw").     
builtInFunc("p3_fXWkDay").     
builtInFunc("p3_fXNDays").     

/* list functions */

builtInFunc("p3_fLT_I").   
builtInFunc("p3_fGT_I").    
builtInFunc("p3_fLT_XD").   
builtInFunc("p3_fGT_XD").     
builtInFunc("p3_fLT_XT").     
builtInFunc("p3_fGT_XT").     
builtInFunc("p3_fLT_XDT").    
builtInFunc("p3_fGT_XDT").   
builtInFunc("p3_fLT_XR").     
builtInFunc("p3_fGT_XR").    
builtInFunc("p3_fMax").     
builtInFunc("p3_fMin").     
builtInFunc("p3_fIxIN").    

/* generic list functions */

builtInFunc("p3_fListNo").     
builtInFunc("p3_fListHead").    
builtInFunc("p3_fListTail").     
builtInFunc("p3_fListConc").     
builtInFunc("p3_fListMbs").     

/* file functions */

builtInFunc("p3_fKB_F").    
builtInFunc("p3_fKB_P").     

/* other functions */

builtInFunc("p3_fError").     
builtInFunc("p3_fTrace").   
builtInFunc("p3_fSeq_I").     
builtInFunc("p3_fSeq_N").     
builtInFunc("p3_fSeq_D").     
builtInFunc("p3_fSeq_T").     
builtInFunc("p3_fSeq_DT").     
builtInFunc("p3_fIRan").    
builtInFunc("p3_fORan").    
builtInFunc("p3_fTsC").    

% 24.7.5 from pie_op
%
op(1200,"xfx",":-").
op(1100,"xfy",";").
op(1000,"xfy",",").
op(900,"fy","not").
op(700,"xfx","=").
%op(700,"xfx","\\="). 
op(700,"xfx","is").
op(700,"xfx","<").
%op(700,"xfx","=<"). 
op(700,"xfx","<="). % Pro/3
op(700,"xfx",">").
op(700,"xfx",">=").
%op(700,"xfx","=="). 
%op(700,"xfx","\\=="). 
%op(700,"xfx","=..").
op(700,"xfx","<>").
%op(700,"xfx","><"). 
op(700,"xfx","inside").
op(700,"xfx","outside").
op(500,"yfx","+").
op(500,"yfx","-").
op(450,"yfx","^"). % Pro/3
op(400,"yfx","*").
op(400,"yfx","/").
op(400,"yfx","div").
op(300,"xfx","mod").
op(200,"fx","+").
op(200,"fx","-").
% Pro/3 domain-qualified 'is':
op(700,"xfx","isIN").
op(700,"xfx","isNU").
op(700,"xfx","isLI").
op(700,"xfx","isIF").
op(700,"xfx","isIT").
op(700,"xfx","isID").
op(700,"xfx","isSY").
op(700,"xfx","isCF").
op(700,"xfx","isMG").
op(700,"xfx","isKB").
op(700,"xfx","isINC").
op(700,"xfx","isDEC").
op(700,"xfx","isPR").
op(700,"xfx","isANY").
op(700,"xfx","isXT").
op(700,"xfx","isXD").
op(700,"xfx","isXDT").
op(700,"xfx","isXDR").
op(700,"xfx","isTS").
op(700,"xfx","isIN_L").
op(700,"xfx","isNU_L").
op(700,"xfx","isLI_L").
op(700,"xfx","isIF_L").
op(700,"xfx","isIT_L").
op(700,"xfx","isID_L").
op(700,"xfx","isSY_L").
op(700,"xfx","isCF_L").
op(700,"xfx","isMG_L").
op(700,"xfx","isKB_L").
op(700,"xfx","isINC_L").
op(700,"xfx","isDEC_L").
op(700,"xfx","isPR_L").
op(700,"xfx","isANY_L").
op(700,"xfx","isXT_L").
op(700,"xfx","isXD_L").
op(700,"xfx","isXDT_L").
op(700,"xfx","isXDR_L").
op(700,"xfx","isTS_L").
op(700,"xfx","nisIN").
op(700,"xfx","nisNU").
op(700,"xfx","nisLI").
op(700,"xfx","nisIF").
op(700,"xfx","nisIT").
op(700,"xfx","nisID").
op(700,"xfx","nisSY").
op(700,"xfx","nisCF").
op(700,"xfx","nisMG").
op(700,"xfx","nisKB").
op(700,"xfx","nisINC").
op(700,"xfx","nisDEC").
op(700,"xfx","nisPR").
op(700,"xfx","nisANY").
op(700,"xfx","nisXT").
op(700,"xfx","nisXD").
op(700,"xfx","nisXDT").
op(700,"xfx","nisXDR").
op(700,"xfx","nisTS").
op(700,"xfx","nisIN_L").
op(700,"xfx","nisNU_L").
op(700,"xfx","nisLI_L").
op(700,"xfx","nisIF_L").
op(700,"xfx","nisIT_L").
op(700,"xfx","nisID_L").
op(700,"xfx","nisSY_L").
op(700,"xfx","nisCF_L").
op(700,"xfx","nisMG_L").
op(700,"xfx","nisKB_L").
op(700,"xfx","nisINC_L").
op(700,"xfx","nisDEC_L").
op(700,"xfx","nisPR_L").
op(700,"xfx","nisANY_L").
op(700,"xfx","nisXT_L").
op(700,"xfx","nisXD_L").
op(700,"xfx","nisXDT_L").
op(700,"xfx","nisXDR_L").
op(700,"xfx","nisTS_L").

% Pro/3 additional trace
%
pt(_,_) :- traceflag=-1,!.
pt(10,Term) :- !,tt::ttPieT("enter_UNIFYBODY: ",Term).
pt(11,Term) :- !,tt::ttPieT("exit_UNIFYBODY: ",Term).
pt(12,Term) :- !,tt::ttPieT("enter&exit_UNIFYBODY: ",Term).
pt(13,Term) :- !,tt::ttPieT("UNIFYBODY in NOT(xxx):  ",Term).
pt(14,Term) :- !,tt::ttPieT("xxx in NOT(xxx) succeeded and outer clause failed: ",Term).
pt(15,Term) :- !,tt::ttPieT("xxx in NOT(xxx) failed and outer clause succeded: ",Term).

ptn(_,_) :- traceflag=-1,!.
ptn(20,Id) :- !, tt::ttPieS("enter_NAMEDCLAUSE: ",Id).
ptn(21,Id) :- !, tt::ttPieS("exit_NAMEDCLAUSE: ",Id).
ptn(22,Id) :- !, tt::ttPieS("enter_DETFUNCTIONCALL: ",Id).
ptn(23,Id) :- !, tt::ttPieS("exit_DETFUNCTIONCALL: ",Id).
ptn(24,Id) :- !, tt::ttPieS("enter_NONDET_BIFUNCTIONCALL: ",Id).
ptn(25,Id) :- !, tt::ttPieS("exit_NONDET_BIFUNCTIONCALL: ",Id).
end implement pie
