/*****************************************************************************

                        Copyright (c) Prolog Development Center A/S

******************************************************************************/

implement pie_par
open core,termDomain,pie_scan

constants
className = "com/visual-prolog/Parser/parser".
version = "$JustDate: 11.01.03 $$Revision: 3 $".

clauses
classInfo(className, version).

domains
assoc = x; y.		% the associavity to the left or the right

class predicates 
  s_lowerterm : (tokl,tokl,sterm) determ anyflow.
  s_lowerterm1 : (tokl,tokl,sterm,sterm) determ anyflow.
  s_priorterm : (prior,assoc,tokl,tokl,sterm) determ anyflow.
  s_basisterm : (prior,assoc,tokl,tokl,sterm) determ anyflow.
  s_higher : (prior,assoc,tokl,tokl,sterm,sterm) determ anyflow.
  s_higher_something : (prior,assoc,tokl,tokl,sterm,sterm) determ anyflow.
  treat_prefix : (prior,xfy,tokl,tokl,sterm) determ anyflow.
  treat_sufinfix : (prior,xfy,op,tokl,tokl,sterm,sterm) determ anyflow.
  s_list : (tokl,tokl,sterm) determ anyflow.
  s_list1 : (tokl,tokl,sterm) determ anyflow.
  s_terml : (tokl,tokl,sterml) determ anyflow.
  s_terml1 : (tokl,tokl,sterml) determ anyflow.
  s_term6 : (tokl,tokl,string,sterm) determ anyflow.
  is_op : (tok,prior,xfy,op) determ anyflow.
  ok_rightop : (prior,assoc,prior) determ anyflow.
  check_ok_rightop : (cursor_position,prior,assoc,prior) determ anyflow.
  is_prefix : (xfy) determ anyflow.
  prefix_op : (prior,xfy,op) determ anyflow.

clauses
  s_term(IL,OL,TERM):-s_lowerterm(IL,OL,TERM),!.
  % Pro/3 minimally changed from original
  s_term(_,_,_) :- !,fail.

  s_lowerterm(LL1,LL0,TERM_):-
	PRIOR=1201,
	s_basisterm(PRIOR,y,LL1,LL2,TERM1),
	s_higher(PRIOR,y,LL2,LL3,TERM1,TERM2),
	s_lowerterm1(LL3,LL0,TERM2,TERM_),!.
 
  s_basisterm(_,_,[t(pie_scan::atom("-"),_),t(pie_scan::int(X),_)|LL],LL,termDomain::int(I)):-!,I=-X.
  s_basisterm(_,_,[t(pie_scan::atom("-"),_),t(pie_scan::fix(X),_)|LL],LL,termDomain::fix(I)):-!,I=-X. % Pro/3
  s_basisterm(PRIOR,ASSOC,[t(pie_scan::atom(ID),CURSOR)|LL1],LL2,cmp(FID,[TERM])):-
	FID=ID, OP=FID,
	prefix_op(NEWPRIOR,XFY,OP),!,
	check_ok_rightop(CURSOR,PRIOR,ASSOC,NEWPRIOR),
	treat_prefix(NEWPRIOR,XFY,LL1,LL2,TERM).
  s_basisterm(_,_,[t(pie_scan::var(STRING),_)|LL],LL,termDomain::var(STRING)):-!.
  s_basisterm(_,_,[t(pie_scan::atom(STRING),_)|LL1],LL0,TERM_):-!,
	s_term6(LL1,LL0,STRING,TERM_).
  s_basisterm(_,_,[t(pie_scan::int(X),_)|LL],LL,termDomain::int(X)):-!.
  s_basisterm(_,_,[t(pie_scan::fix(X),_)|LL],LL,termDomain::fix(X)):-!. % Pro/3
  %s_basisterm(_,_,[t(pie_scan::chr(X),_)|LL],LL,termDomain::chr(X)):-!. not needed in Pro/3
  s_basisterm(_,_,[t(pie_scan::str(X),_)|LL],LL,termDomain::str(X)):-!.
  s_basisterm(_,_,[t(lbrack,_)|LL1],LL0,TERM):-!,
	s_list(LL1,LL0,TERM).
  s_basisterm(_,_,[t(lpar,_)|LL1],LL0,TERM):-!,
	s_priorterm(1201,y,LL1,LL2,TERM),
	LL2=[t(rpar,_)|LL0].

  s_list([t(rbrack,_)|IL],IL,nill):-!.
  s_list(IL,OL,list(TERM,REST)):-
	s_priorterm(1000,x,IL,OL1,TERM),
	s_list1(OL1,OL,REST).

  s_list1([t(rbrack,_)|IL],IL,nill):-!.
  s_list1([t(comma,_)|IL],OL,list(TERM,REST)):-
	s_priorterm(1000,x,IL,OL1,TERM),
	s_list1(OL1,OL,REST).
  s_list1([t(bar,_)|IL],OL,TERM):-
	s_priorterm(1000,x,IL,OL1,TERM),
	OL1=[t(rbrack,_)|OL].

  s_term6([t(lpar,_)|LL1],LL0,ID,cmp(FID,TERML)):-!,
	FID=ID,
	s_terml(LL1,LL2,TERML),
	LL2=[t(rpar,_)|LL0].
  s_term6(LL,LL,STRING,termDomain::atom(STRING)):-!.

  s_terml(LL1,LL0,[TERM|TERML]):-
	s_priorterm(999,y,LL1,LL2,TERM),!,
	s_terml1(LL2,LL0,TERML).
  s_terml(LL,LL,[]).

  s_terml1([t(comma,_)|LL1],LL2,TERML):-!,
	s_terml(LL1,LL2,TERML).
  s_terml1(LL,LL,[]).

  treat_prefix(PRIOR,"fx",LL1,LL2,TERM):-
	s_priorterm(PRIOR,x,LL1,LL2,TERM).
  treat_prefix(PRIOR,"fy",LL1,LL2,TERM):-
	s_priorterm(PRIOR,y,LL1,LL2,TERM).

  s_lowerterm1([],[],TERM,TERM):-!.
  s_lowerterm1([t(dot,_)|LL],LL,TERM,TERM):-!.
  s_lowerterm1(LL2,LL0,TERM1,TERM_):-
	PRIOR=1201,
	s_higher_something(PRIOR,y,LL2,LL3,TERM1,TERM2),
	s_lowerterm1(LL3,LL0,TERM2,TERM_),!.
/* Pro/3
  s_lowerterm1(_,_,TERM1,_):-
  	output::wsterm(output::write(),TERM1),file5x::nl,!,
  	fail.
*/
  s_priorterm(PRIOR,ASSOC,LL1,LL0,TERM_):-
	s_basisterm(PRIOR,ASSOC,LL1,LL2,TERM),
	s_higher(PRIOR,ASSOC,LL2,LL0,TERM,TERM_).

  prefix_op(NEWPRIOR,XFY,FID):-
	pie_op::getOp(NEWPRIOR,XFY,FID),
	is_prefix(XFY),!.

  is_prefix("fx").
  is_prefix("fy").

  ok_rightop(PRIOR,_,NEWPRIOR):-
	NEWPRIOR<PRIOR,!.
  ok_rightop(PRIOR,y,PRIOR).

  check_ok_rightop(_,PRIOR,ASSOC,NEWPRIOR):-
	ok_rightop(PRIOR,ASSOC,NEWPRIOR),!.
  check_ok_rightop(_,_,_,_):-dlgIF::feil("check_ok_rightop",["Parser priority error"],[],nill),!,fail.

  is_op(comma,PRIOR,XFY,OP):-
	OP=",",	pie_op::getOp(PRIOR,XFY,OP),!.
  is_op(dot,PRIOR,XFY,OP):-
	OP=".",	pie_op::getOp(PRIOR,XFY,OP),!.
  is_op(pie_scan::atom(ID),PRIOR,XFY,OP):-
	ID=OP, pie_op::getOp(PRIOR,XFY,OP),!.

  s_higher_something(PRIOR,ASSOC,[t(TOK,_)|LL1],LL0,TERM,TERM_):-
	is_op(TOK,NEWPRIOR,XFY,OP),
	ok_rightop(PRIOR,ASSOC,NEWPRIOR),
	treat_sufinfix(NEWPRIOR,XFY,OP,LL1,LL2,TERM,TERM1),
	s_higher(PRIOR,ASSOC,LL2,LL0,TERM1,TERM_).

  s_higher(PRIOR,ASSOC,[t(TOK,_)|LL1],LL0,TERM,TERM_):-
	is_op(TOK,NEWPRIOR,XFY,OP),
	ok_rightop(PRIOR,ASSOC,NEWPRIOR),!,
	treat_sufinfix(NEWPRIOR,XFY,OP,LL1,LL2,TERM,TERM1),
	s_higher(PRIOR,ASSOC,LL2,LL0,TERM1,TERM_).
  s_higher(_,_,LL,LL,TERM,TERM).

  treat_sufinfix(PRIOR,"yfx",OP,LL1,LL2,TERM1,cmp(FID,[TERM1,TERM2])):-
	OP=FID,	s_priorterm(PRIOR,x,LL1,LL2,TERM2).
  treat_sufinfix(PRIOR,"xfx",OP,LL1,LL2,TERM1,cmp(FID,[TERM1,TERM2])):-
	OP=FID,	s_priorterm(PRIOR,x,LL1,LL2,TERM2).
  treat_sufinfix(PRIOR,"xfy",OP,LL1,LL2,TERM1,cmp(FID,[TERM1,TERM2])):-
	OP=FID,	s_priorterm(PRIOR,y,LL1,LL2,TERM2).
  treat_sufinfix(_,"xf",OP,LL,LL,TERM,cmp(FID,[TERM])):-OP=FID.
  treat_sufinfix(_,"yf",OP,LL,LL,TERM,cmp(FID,[TERM])):-OP=FID.
  end implement pie_par
