/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement piex
open core,termDomain,globalDomains

constants
className = "com/rudstrand/piex/piex".
classVersion = "1.0".

class facts
currentVal : sterm :=nill.
currentRow : integer :=0.
proc : (string).

clauses
classInfo(className, classVersion).

class predicates
plcAccPars : (integer,sterm,integer_list,integer_list,integer) determ (i,i,o,o,o).
plcAccumulate : (integer,integer_list,integer_list,integer) determ (i,i,i,i).
plcAdjustComps : (integer_list,integer_list,integer_list) determ (i,i,o).
inexactRule : (string,integer,integer,string,sterml,sterm) determ (i,i,i,i,i,o).
plcCompXD : (string,sterm,sterm,sterm) determ (i,i,i,o).
plcCompute : (string,sterm,sterm,sterm) determ (i,i,i,o).
plcComputeNU : (string,sterm,sterm,sterm) determ (i,i,i,o).
plcComputeVal : (string,string,sterml,integer,integer,sterm,sterm,sterm) determ (i,i,i,i,i,i,i,o).
plcCorrPars : (integer,sterm,integer_list,integer_list) determ (i,i,o,o).
plcDeleteRows : (integer,chainDB::bt_selector,integer,integer) determ (i,i,i,i).
plcGenSentence : (integer,integer,integer,sterm,sterm,sterml) determ (i,i,i,i,i,o).
plcGetCompNos : (string,integer,sterm,integer_list,sterml) determ (i,i,i,o,o).
plcGetComps : (string,integer,sterm,string_list,sterml) determ (i,i,i,o,o).
plcIP_Pars : (integer,sterm,integer,sterm,sterm,sterm,integer,integer_list,integer_list,integer_list,integer_list,integer_list,sterml) determ (i,i,o,o,o,o,o,o,o,o,o,o,o).
plcMM : (integer,integer_list,string,integer) determ (i,i,i,i).
plcMM_Pars : (string,integer,sterm,integer_list,integer) determ (i,i,i,o,o).
plcProcComps : (integer,string_list,sterm,string_list_list) determ (i,i,i,o).
plcQueryComps : (sterm,sterml) procedure (i,o).
plcRankPars : (integer,sterm,integer,integer_list,integer_list,string) determ (i,i,o,o,o,o).
plcRank : (string,integer,integer,integer,integer_list,integer_list,integer) determ (i,i,i,i,i,i,i).
plcRelComps : (sterml,sterm,string_list) determ (i,i,o).
plcRequiredComps : (integer_list,sterml,sterml) determ (i,i,o).
plcInterpolate : (integer,integer,integer,sterm,sterm,sterm,integer,integer_list,integer_list,integer_list,integer_list,integer_list,sterml) determ (i,i,i,i,i,i,i,i,i,i,i,i,i).
selectionProcedure : (string,string,sterm,sterm,sterml) nondeterm (i,i,i,i,o).
selectionProcedure_Query : (string,string,integer,integer) determ (i,i,o,o).
plcStartCorr : (integer,integer,integer_list,integer_list) determ (i,i,i,i).
plcStartRank : (string,integer,integer,integer,integer_list,integer_list) determ (i,i,i,i,i,i).
plcStartUnique : (integer,integer,integer_list,integer_list) determ (i,i,i,i).
plcSolCompsEQ : (integer,integer,integer,integer_list) determ.
plcSolVarsEQ : (integer,integer,integer,string_list) determ.
processEqualitySet : (integer,integer,chainDB::bt_selector,integer,integer,string_list,string_list_list) determ.
plcSortComps : (string_list,string_list_list,string_list,string_list) determ (i,i,i,o).
plcStartAcc : (integer,integer,integer_list,integer_list,integer) determ (i,i,i,i,i).
plcStartIP : (integer,integer,integer,sterm,sterm,sterm,integer,integer_list,integer_list,integer_list,integer_list,integer_list,sterml) determ (i,i,i,i,i,i,i,i,i,i,i,i,i).
plcStatProcGen : (integer,integer,string_list,integer,string_list,string_list_list,string_list_list) determ (i,i,i,i,i,i,i).
plcTransPar : (integer,sterm,sterm) procedure (i,i,o).
plcUN_Pars : (integer,sterm,integer_list,integer_list) determ (i,i,o,o).
plcCorr : (integer,integer,integer_list,integer_list,integer) determ (i,i,i,i,i).
fixExp : (real,real,real) determ (i,i,o).
% ----------------------------------------------------------------------------------------------
clauses
% ----------------------------------------------------------------------------------------------
% procedureCall
% ----------------------------------------------------------------------------------------------
class predicates
plcAdjTimers : (integer,integer_list,integer_list_list,integer_list_list) determ (i,i,i,o).	
plcCountCheck : (string_list_list,integer) procedure (i,o).
plcCountOnly : (string_list_list) determ (i).	
plcCompOrgAdj : (integer_list,integer,integer) determ (i,i,o).
plcCOA : (integer_list,integer,integer,integer,integer) determ (i,i,i,i,o).
procedureCall_Trace : (integer,sterm,sterml,string_list) procedure (i,i,i,i).
plcProcReformat : (string,string,string,sterm,sterm,sterm,string_list,string_list_list) determ (i,i,i,o,o,o,o,o).
plcTimerComps : (sterml,sterml,sterm,string_list_list) determ (i,i,i,o).
plcTimerFind : (sterm,sterm,sterm) determ (i,i,o).
clauses

% parameters:
% 1	in	proc name
% 2	in	query which will generate the solution base from 
%               which the implied entity data element values are
%               generated [PR string format]
% 3	in	implied entity type [KB name]
% 4	in	implied entity's data element value expression
%		trees 
% 5 out	implied entity's data element variables (direct parameters to p3_rXxx)
%
procedureCall(Proc,Q,DEVs,Assg,Vals) :-
	rub::rubRuleTypeSel(Proc),
	% selection-type rules
	ImpDEVs=termDomain::fromTermStringIndirect(DEVs),
	Ass=termDomain::fromTermStringIndirect(Assg),
	!,
	selectionProcedure(Proc,Q,ImpDEVs,Ass,Vals)
;	
	rub::rubRuleTypeSet(Proc),
	% statistical, accumulation, ir-calls
	plcProcReformat(Q,DEVs,Assg,QTerm,ImpDEVs,Ass,RelComps,Timers),
				tt::tt_ss(2,"Condition query"),
	% note that only relevant solution components are generated in the solution set
	% the effect of this is that apparent duplicates can NOT be filtered out during solution insertion
	proc::pie3_InternalNew(QTerm,RelComps,SolRef),
				sol::tt_sors(4,"Condition set",SolRef),
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	plcGetComps("=",SolRef,Ass,EqAs,_),
				tt::tt_strings(3,"Equality DEs",EqAs),
	plcProcComps(SolRef,RelComps,Ass,ProcComps),			
				tt::tt_stringss(3,"Procedure components",ProcComps),
	plcCountCheck(ProcComps,CountOnly),
	plcSortComps(EqAs,Timers,RelComps,SortComps),
				tt::tt_strings(3,"Sorting components",SortComps),
	set::setNos(RelComps,SortComps,SortCompsNo),
	sol::solSort(SolRef,SortCompsNo),
				tt::tt_table(3,"Sorted table",SolRef),			
	plcStatProcGen(CountOnly,SolRef,EqAs,NSol,RelComps,ProcComps,Timers),
	%
	sol::solSetMarkAltered(SolRef),
				sol::tt_sors(3,"#12-set",SolRef),
	!,
	% generate the resulting sentences (until no more or quit)				
	sol::forallsol(SolRef,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef,SolNo,0,ImpDEVs,Ass,Vals)
	   .

% parameters:
% 1	in	adjusted solution component array with 0=non-relevant; 1=relevant and 2=simple varibale 
%		components
% 2	in	original (pre-adjustment component no)
% 3	out	actual solution set component no corresponding to par#2
%
plcCompOrgAdj(L,CompNo,AdjNo) :-
	plcCOA(L,1,1,CompNo,AdjNo),
	!.
plcCOA([],Norg,Nsol,CompNo,_) :-
	dlgIF::feil("plcCOA",[],[Norg,Nsol,CompNo],nill),!,fail.
plcCOA([H|L],Norg,Nsol,CompNo,AdjNo) :-
	H=1,
	Norg=CompNo,
	AdjNo=Nsol,
	!
;		
	H=1,
	Norg<CompNo,
	M=Norg+1,
	P=Nsol+1,
	plcCOA(L,M,P,CompNo,AdjNo),
	!
;		
	H=2,
	M=Nsol+1,
	plcCOA(L,Norg,M,CompNo,AdjNo),
	!
;
	H=0,
	M=Norg+1,
	plcCOA(L,M,Nsol,CompNo,AdjNo),
	!.
plcAdjTimers(_,_,[],[]) :-
	!.
plcAdjTimers(SolRef,L,[[Comp,TComp]|Timers],[[Na,Ta]|ATimers]) :-
	plcCompOrgAdj(L,Comp,Na),
	plcCompOrgAdj(L,TComp,Ta),
	plcAdjTimers(SolRef,L,Timers,ATimers),
	!.
% parameters:
% 1	in	condition-set query (PR) (as text using ` instead of ")
% 2	in	concluded DEVs (list(..)-format) (as text using ` instead of ")
% 3	in	assignment-expressions corr. to par#2 (as text using ` instead of ")
% 4	out	condition-set query (term) 
% 5	out	concluded DEVs (list(..)-format)
% 6	out	assignment-expressions corr. to par#5 (list(..)-format)
% 7	out	relevant components
% 8	out	component-timer pairs
%
plcProcReformat(Q,DEVs,Assg,QTerm,ImpDEVs,Ass,RelComps,Timers) :-
    QTerm=termDomain::fromTermStringIndirect(Q),
    ImpDEVs=termDomain::fromTermStringIndirect(DEVs),
				tt::tt_term(3,"Conclusion DEVs",ImpDEVs),
    Ass=termDomain::fromTermStringIndirect(Assg),
				tt::tt_term(3,"Assignments to conclusion DEVs",Ass),
	% determine required components, format:
	% list of var(DE_var) where DE_Var is from the query solution set
	plcQueryComps(QTerm,QComps), % format: [var(...),...]
				tt::tt_terms(3,"Condition set components",QComps),
	% determine relevant query solution set solution components on the basis QComps list, format:
	% integer list where each element corresponds to QComps and 1=relevant; 0=not relevant
	plcRelComps(QComps,Ass,RelComps2),
	set::distinct(RelComps2,RelComps),
				tt::tt_strings(3,"Components referred in conclusion",RelComps),
				% (Netcomps has the same format as QComps, but only relevant
				%  components are included)
				% 20.4.4 plcRequiredComps(RelComps,QComps,NetComps),
				% tt::tt_terms(3,"Required condition set components",NetComps),
	% determine value-timer component pairs
	plcTimerComps(QComps,QComps,Ass,Timers),
				tt::tt_stringss(3,"Component value-timer pairs",Timers),
	!.
	
procedureCall_Trace(1,Ass_B,QComps_B,RelComps) :-
	tt::getLevel()>2,
	tt::tt_term(3,"Values assigned to conclusion DEVs (2. partition)",Ass_B),
	tt::tt_terms(3,"2. partition solution components",QComps_B),
	tt::tt_strings(3,"Required-component flags",RelComps),
	!.
procedureCall_Trace(_,_,_,_) :-
	!.
	
plcCountCheck(ProcComps,CountOnly) :-
	plcCountOnly(ProcComps),
	CountOnly=1,
	!
;	
	CountOnly=0,
	!.
	
plcCountOnly([]) :-
	!.	
plcCountOnly([[]|T]) :-
	plcCountOnly(T),
	!.
% parameters:
% 1	in	list of condition set components (var(DE_Var) format) (original)
% 2	in	do. 
% 3	in
% 4	out	3.10.3: pairs of value-timer component names
%               pre 3.10.3 pairs of 'component no' and the corresponding 'timer component no'
%
plcTimerComps(_,[],_,[]) :-
	!.
plcTimerComps(QComps,[Comp|Comps],Ass,[[Sc,St]|Timers]) :-
	plcTimerFind(Comp,Ass,TComp),
	TComp=var(Vt),
	St=Vt,
	Comp=var(Vc),
	Sc=Vc,
	plcTimerComps(QComps,Comps,Ass,Timers),
	!.
plcTimerComps(QComps,[_|Comps],Ass,Timers) :-
	plcTimerComps(QComps,Comps,Ass,Timers),
	!.
% parameters:
% 1	in	
% 2	in
% 3	out	
%	
plcTimerFind(Comp,list(A,Ass),TComp) :-
	A=cmp(Proc,[Comp,TComp]),	
	set::member(Proc,["p3_rMat","p3_rMit","p3_rTS","p3_rStv","p3_rEtv"]),
	!
;	
	Comp=TComp,
	A=cmp(Proc,[TComp]),
	set::member(Proc,["p3_rStim","p3_rEtim"]),
	!
;	
	plcTimerFind(Comp,Ass,TComp),
	!.
% ----------------------------------------------------------------------------------------------
% proc
% ----------------------------------------------------------------------------------------------
% this information is also stored in the sentence model
%
proc("p3_rSum").
proc("p3_rStim").
proc("p3_rEtim").
proc("p3_rCnt").
proc("p3_rStv").
proc("p3_rEtv").
proc("p3_rMat").
proc("p3_rMit").
proc("p3_rAvg").
proc("p3_rMea").
proc("p3_rSdv").
proc("p3_rTS").
proc("p3_rCip").
proc("p3_rCipxd").
proc("p3_rUn").
proc("p3_rAcc").
proc("p3_rRank").
proc("p3_rRnks").
proc("p3_rSort").
proc("p3_rCorr").
proc("p3_rMax").
proc("p3_rMin").
proc("p3_rUpp").
proc("p3_rLow").
proc("p3_rMnVa").
proc("p3_rDf").
proc("p3_rAssg").
% ----------------------------------------------------------------------------------------------
% fixExp
% ----------------------------------------------------------------------------------------------
fixExp(0.0,_,0.0) :- 
	!.
fixExp(Base,Exp,Result) :-
	Base>0.0,
	Result=math::power(Base,Exp),
	!
;
	S1=toString(Base),
	S2=toString(Exp),
	sx::concat(["invalid exponentiation ",S1,"^",S2],Mess),
	dlgIF::feil("fixExp",[Mess],[],nill),!,fail.
% ----------------------------------------------------------------------------------------------
% plcBasicValue
% ----------------------------------------------------------------------------------------------
plcBasicValue(int(V),int(V)) :-
	!.	
plcBasicValue(fix(V),fix(V)) :-
	!.	
plcBasicValue(str(V),str(V)) :-
	!.	
plcBasicValue(atom(V),atom(V)) :-
	!.	
plcBasicValue(fint(V,_),int(V)) :-
	!.	
plcBasicValue(ffix(V,_),fix(V)) :-
	!.	
plcBasicValue(fstr(V,"p3_dif",_,_),atom(V)) :-
	!.	
plcBasicValue(fstr(V,_,_,_),str(V)) :-
	!.	
% ----------------------------------------------------------------------------------------------
% plcDDERF;NDERF
% ----------------------------------------------------------------------------------------------
class predicates
plcDDERF_X : (integer,string,sterm) determ (i,i,o).
plcNDERF_SetX : (termSet,string,sterm).
clauses

plcNDERF_Set(Var,Query)=Set :-
    Set=termSet::new(),
    plcNDERF_SetX(Set,Var,Query),
    !.
    
plcNDERF_SetX(Set,Var,Query) :-
    plcNDERF(Var,Query,Val),
            Set:add(Val),
            fail
;
    !.  
    
plcNDERF(Var,Query,Val) :-
				tt::tt_ss(3,"NDERF query"),
	proc::pie3_IF(Query,SolRef), 
				sol::tt_sors(4,"NDERF",SolRef),
	sol::solSetSize(SolRef,N),
	SolNo=programControl::sequence_nd(1,N,1),
	sol::solCompVar(SolRef,SolNo,Var,Val),
				tt::tt_term(3,"NDERF value",Val). % non-deterministic

plcDDERF(Var,Query,Val) :-
				tt::tt_ss(3,"DDERF query"),
	proc::pie3_IF(Query,SolRef),
				sol::tt_sors(4,"DDERF",SolRef),
	plcDDERF_X(SolRef,Var,Val),
	!.	

plcDDERF_X(SolRef,Var,Val) :-	
	sol::solSetSize(SolRef,N),
	N>0,
	sol::solCompVar(SolRef,1,Var,Val),
				tt::tt_term(3,"DDERF value",Val),
	sol::solSetDel(SolRef),
	!
;
	sol::solSetDel(SolRef),
				tt::tt_ss(3,"DDERF query failed"),!,fail.
% ----------------------------------------------------------------------------------------------
% plcDomVal
% ----------------------------------------------------------------------------------------------
% parameters:
% 1	in	source value
% 2	in	destination domain
% 3	out	validated destination value
% fails with error dialog if invalid combination
%
plcDomVal(H,Dom,Hn) :-
    Dom="p3_dts",
	H=cmp(Label,Comps),
	S=termDomain::toTermStringIndirect("z",cmp(Label,Comps)),
	Hn=str(S),
	!
;
	dom::domAdjustTerm(H,Dom,Hn),
	dom::domValCompatF(Dom,Hn),
	!
;
	dom::domAdjustTerm(H,Dom,Hn),
	dlgIF::feil_pie("plcDomVals",["Invalid value for domain: ",Dom],[],H),!,fail
;
	dlgIF::feil_pie("plcDomVals",["Invalid value for domain: ",Dom],[],H),!,fail.
% ----------------------------------------------------------------------------------------------
% plcExists
% ----------------------------------------------------------------------------------------------
% succeeds if the given query has at least one solution
%
plcExists(Query) :-
				tt::tt_ss(3,"EXISTS query"),
	proc::pie3_IF(Query,SolRef),
	sol::solSetSize(SolRef,N),
				tt::tt_i(3,"EXISTS query result",N),
	sol::solSetDel(SolRef),
	N>0,
	!.
% ----------------------------------------------------------------------------------------------
% plcRecursiveD;N
% ----------------------------------------------------------------------------------------------
class predicates
plcRetTyp : (string,sterm,sterm) determ (i,i,o).
clauses
% processes, through recursive IE entry, SSSs and DERFs used as values
% 
plcRecursiveD(1,Typ,_,PR,Res) :-
				tt::tt_s(2,"Recursive IE/SSS-call",PR),
	transpr::proPR_Term(PR,Q),
	plcSSS(Q,Val),
	plcRetTyp(Typ,Val,Res),!.
plcRecursiveD(2,Typ,Var,PR,Res) :-
				tt::tt_s(2,"Recursive IE/DDERF-call",PR),
	transpr::proPR_Term(PR,Q),
	plcDDERF(Var,Q,Val),
	plcRetTyp(Typ,Val,Res),!.
	
plcRecursiveN(2,Typ,Var,PR,Res) :-
				tt::tt_s(2,"Recursive IE/NDERF-call",PR),
	transpr::proPR_Term(PR,Q),
	plcNDERF(Var,Q,Val),
	plcRetTyp(Typ,Val,Res).
plcRetTyp("IF",atom(A),atom(A)) :- !.	
plcRetTyp("LI",str(S),str(S)) :- !.	
plcRetTyp("LI",int(I),str(S)) :- S=toString(I),!.	
plcRetTyp("LI",fix(F),str(S)) :- 
	NDec=globalVars::get_i("fxdec"),
	UseComma=globalVars::get_i("fxcom"),
	sx::fixFormatR(F,NDec,UseComma,S),
	!.	
plcRetTyp("LI",atom(A),str(S)) :- 
	dbBase::nlTry(A,S), 
	S=A,
	!.
plcRetTyp("IN",int(I),int(I)) :- !.	
plcRetTyp("NU",fix(F),fix(F)) :- !.	
plcRetTyp("NU",int(I),fix(F)) :- F=convert(real,I),!.	
% ----------------------------------------------------------------------------------------------
% plcRequiredComps
% ----------------------------------------------------------------------------------------------
plcRequiredComps([],[],[]) :-
	!.
plcRequiredComps([Flag|RelComps],[C|Comps],[C|NetComps]) :-
	Flag>0,
	plcRequiredComps(RelComps,Comps,NetComps),
	!.
plcRequiredComps([0|RelComps],[_|Comps],NetComps) :-
	plcRequiredComps(RelComps,Comps,NetComps),
	!.
plcRequiredComps(RelComps,Comps,_) :-
	dlgIF::feil_pie("plcRequiredComps",[],RelComps,cmp("",Comps)),!,fail.
% ----------------------------------------------------------------------------------------------
% plcSSS
% ----------------------------------------------------------------------------------------------
plcSSS(Query,Val) :-
				tt::tt_ss(2,"SSS query"),
	proc::pie3_IF(Query,SolRef),
				sol::tt_sors(3,"SSS",SolRef),
	sol::solSetSize(SolRef,N),
	Val=int(N),
	sol::solSetDel(SolRef),
				tt::tt_i(3,"SSS value",N),!
;
				tt::tt_term(2,"SSS query failed",Query),!,fail.
% ----------------------------------------------------------------------------------------------
% plcTraceIn/Nu/S
% ----------------------------------------------------------------------------------------------
plcTraceIn(I) :- tt::tt_co, Is=toString(I), tt::wrl(["INTEGER-TRACE:",Is]),tt::tt_cc, !.
plcTraceNu(F) :- tt::tt_co, Fs=toString(F), tt::wrl(["NUMBER-TRACE:",Fs]), tt::tt_cc, !.
plcTraceS("p3_dli",S) :- tt::tt_co, tt::wrl(["LITERAL-TRACE:\"",S,"\""]),tt::tt_cc, !.
plcTraceS("p3_dif",S) :- tt::tt_co, tt::wrl(["IDENTIFIER-TRACE:",S]),tt::tt_cc, !.
plcTraceS("p3_dsy",S) :- tt::tt_co, tt::wrl(["SYMBOL-TRACE:",S]),tt::tt_cc, !.
% ----------------------------------------------------------------------------------------------
% plcAccPars
% ----------------------------------------------------------------------------------------------
class predicates
plcAccSers : (integer_list,integer_list,integer) determ (i,o,o).
clauses
plcAccPars(SolRef,DE_Vals,EqComps,AccComps,SerComp) :-
	plcGetCompNos("=",SolRef,DE_Vals,EqComps2,_),
	plcGetCompNos("p3_rAcc",SolRef,DE_Vals,Comps,_),
	plcAccSers(Comps,AccComps,SerComp),
	set::setRemSub([SerComp],EqComps2,EqComps),
	set::size(AccComps,N),
	N>0,
	!
;
	dlgIF::feil_pie("plcAccPars",["Cannot find call to accumulation procedure"],[],nill),!,fail.
	
plcAccSers([Cac,Csr],[Cac],Csr) :-
	!.
plcAccSers([Cac,Csr|Vs],[Cac|Cs],Csr) :-
	plcAccSers(Vs,Cs,Csrx),
	Csr=Csrx,
	!
;
	dlgIF::feil_pie("plcAccSers",["More than one series-parameter used in accumulation procedure rule"],[],nill),!,fail.
% -----------------------------------------------------------------------------------------------
% plcAccumulate
% -----------------------------------------------------------------------------------------------
class predicates
plcAccCheck : (count,chainDB::bt_selector,integer,integer,integer,integer_list,integer_list) procedure (i,i,i,i,i,i,i).		
plcAcc : (integer,integer,integer,integer_list) determ (i,i,i,i).	
clauses
plcAccumulate(SolRef,Acc_Comps,Eq_Comps,NSol) :-
	sol::solFirstL(SolRef,First),
    LPredC=count::newCounter(First),    
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	Start=First+1,
	sol::forallsolsorted(SolRef,Start,LSucc,PSucc),
	   plcAccCheck(LPredC,XI,SolRef,LSucc,PSucc,Acc_Comps,Eq_Comps),
	   LSucc=NSol, % loop termination
	!.
% checks if two solutions are equal according to the equality components, and then if equal, accumulates
%
plcAccCheck(LPredC,XI,SolRef,LSucc,PSucc,Acc_Comps,Eq_Comps) :-
	LPred=LPredC:get(),
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolCompsEQ(SolRef,PSucc,PPred,Eq_Comps),
	% Pred and Succ are equal: accumulate
	plcAcc(SolRef,PPred,PSucc,Acc_Comps),
	LPredC:set(LSucc),
	!
;	
	% Pred and Succ are not equal
	LPredC:set(LSucc),
	!.
plcAcc(_,_,_,[]) :-
	!.
plcAcc(SolRef,PPred,PSucc,[C|Acc_Comps]) :-
	sol::solCompNo(SolRef,PPred,C,Vp),
	sol::solCompNo(SolRef,PSucc,C,Vs),
	plcCompute("+",Vp,Vs,V),
	sol::solCompNoReplace(SolRef,PSucc,C,V),
	plcAcc(SolRef,PPred,PSucc,Acc_Comps),
	!.
% -----------------------------------------------------------------------------------------------
% plcAdjustComps
% -----------------------------------------------------------------------------------------------
class predicates
plcAdjC : (integer,integer_list,integer,integer,integer) determ (i,i,i,i,o).
clauses
plcAdjustComps(_,[],[]) :-
	!.
plcAdjustComps(RelComps,[C|Cs],[Ca|Csa]) :-
	plcAdjC(1,RelComps,0,C,Ca),
	plcAdjustComps(RelComps,Cs,Csa),
	!.
plcAdjC(N,[],Counter,CompNo,_) :-
	dlgIF::feil_pie("plcAdjc/1",[],[N,Counter,CompNo],nill),!,fail.
plcAdjC(CompNo,[IsRel|_],Counter,CompNo,N) :-
	IsRel=1,
	N=Counter+1,
	!
;
	dlgIF::feil_pie("plcAdjC/2",[],[CompNo,IsRel,Counter],nill),!,fail.	
plcAdjC(N,[R|Rs],Counter,CompNo,Ca) :-
	Next=N+1,
	NextCount=Counter+R,
	plcAdjC(Next,Rs,NextCount,CompNo,Ca),
	!.
% -----------------------------------------------------------------------------------------------
% inexactRule
% -----------------------------------------------------------------------------------------------
inexactRule(DEv,SolRef,SolNo,Rule,APars,V) :-
				tt::tt_s(3,"inexactRule/1",Rule),
				tt::tt_terms(3,"inexactRule/1",APars),
	set::setCount(nill,APars,N), N>0,
	% returns value 'nill' since at least one of the parameters is 'nill'
				tt::tt_s(3,"inexactRule/1x",Rule),
	V=nill,
	!
;
	Rf=globalVars::get_i("solref"),
	sol::solSetHeader(Rf,_,_,_,Query,_),
	dbBase::querySt(Query,ST),
	dbExtension::dbuCR_Get(Rule,_,Pars,_),
	vars::varComps(DEv,Arg,ArgNo,DE),
	No=ArgNo mod 10,
    ir::evaluateNetwork(SolRef,SolNo,ST,Arg,No,DE,Rule,Pars,APars,V),
	!.	
% ----------------------------------------------------------------------------------------------
% processEqualitySet
% ----------------------------------------------------------------------------------------------
class predicates
plcInsStatSol : (integer,integer,integer,string_list,real_list,real_list,real_list,real_list,real_list,real_list,real_list,real_list,real_list,real_list) determ (i,i,i,i,i,i,i,i,i,i,i,i,i,i).
rowVals : (integer,integer,integer_list,real_list) determ (i,i,i,o).
loadMatrix : (rMatrix,integer,unsigned,integer,integer,string_list) determ.
averages : (real_list,integer,real_list) determ (i,i,o).
stdDevs : (real_list,integer,real_list) determ (i,i,o).
getTimerNos : (integer,string_list,string_list,string_list_list,integer_list) determ (i,i,i,i,o).
getCompTimer : (string,string_list_list,string) determ (i,i,o).
timerVals : (rMatrix,integer_list,integer_list,real_list) determ (i,i,i,o).
validateComps : (string_list) determ.
clauses

% computes the statistical #12-tuple for an equality set
% 1	in	0/1 counting of equality set only
% 2	in	sol.set
% 3	in	table index
% 4	in	first row in equality set
% 5	in	last	"
% 6	in	list of solution component DE-vars used for statistics
%    e.g. ["EArg_11aDeStat","EArg_11aDeStat2","EArg_11aDeTimer","EArg_11aDeTimer2"]
% 7	in	list of timer component no's corresponding to par#6 (0 means no timer for this component no)
%    e.g. [["EArg_11aDeStat","EArg_11aDeTimer"],["EArg_11aDeStat2","EArg_11aDeTimer2"]]
%
processEqualitySet(CountOnly,SolRef,XI,LFirst,LLast,StatComps,Timers) :-
	CountOnly=1,
	N=LLast-LFirst+1,
	LastDelete=LLast-1,
	plcDeleteRows(SolRef,XI,LFirst,LastDelete), 
	stb::stbGetRowL_P(XI,LLast,P),
	sol::solCompNo(SolRef,P,1,Original),
	Val=cmp("#12",[Original,nill,nill,nill,nill,int(N),nill,nill,nill,nill,nill,nill]),
	sol::solCompNoReplace(SolRef,P,1,Val),
	!
;	
 	CountOnly<>1,
	N=LLast-LFirst+1,
	set::size(StatComps,CompsN),
	Mx=rMatrix::new(CompsN),
	loadMatrix(Mx,SolRef,XI,LFirst,LLast,StatComps),
    getTimerNos(1,StatComps,StatComps,Timers,TimerNos), % TimerNos[N]=M means that matrix col N has col M as timer
	Starts=Mx:getRow(1),
	Ends=Mx:getRow(N),
	Sums=Mx:colSums(),
	Mx:colMinsRow(Mins,MinRowNos),
	Mx:colMaxsRow(Maxs,MaxRowNos),
    timerVals(Mx,MinRowNos,TimerNos,Tmins),
    timerVals(Mx,MaxRowNos,TimerNos,Tmaxs),
    set::initialize(CompsN,1,R1),
    timerVals(Mx,R1,TimerNos,Tfirsts),
    set::initialize(CompsN,N,Rn),
    timerVals(Mx,Rn,TimerNos,Tlasts),
    averages(Sums,N,Averages),
    Deviations=Mx:colDeviations(Averages),
    stdDevs(Deviations,N,StdDevs),
	stb::stbGetRowL_P(XI,LLast,P),
	plcInsStatSol(SolRef,P,N,StatComps,Sums,Mins,Maxs,StdDevs,Tmins,Tmaxs,Tfirsts,Tlasts,Starts,Ends),
	!.

% loads the statistical components into the matrix and deletes all rows except the last (in the equality set)
% parameters:
% 1 in matrix
% 2 in sol.ref.
% 3 in table access index
% 4 in first logical row in equality set
% 5 in last                 "
% 6 in statistical components (DE-variables)
%
loadMatrix(Mx,SolRef,XI,First,Last,StatComps) :-
    dlgIF::msgStatus("loading equality set..."),
    validateComps(StatComps),
	sol::solVarNos(SolRef,StatComps,StatCompNos),
    Row=programControl::sequence_nd(First,Last,1),
        stb::stbGetRowL_P(XI,Row,RowP),
        rowVals(SolRef,RowP,StatCompNos,Vals),
        N=Row-First+1,
        Mx:setRow(N,Vals),
        Row<Last,
        % delete row (Last will not be deleted)
        stb::stbSortDelRow(SolRef,1,Row),
        sol::solDel(SolRef,RowP),
        fail
;
    dlgIF::msgStatus(""),
    !.

validateComps([]) :-
    !.
validateComps([V|Vs]) :-
    vars::varComps(V,_,_,DE),
    dbBase::smClassDefTreeF(DE,"a",Def),
    Def=fstr(_,Dom,_,_),
    dom::domStatProc(Dom),
    validateComps(Vs),
    !
;
    vars::varComps(V,_,_,DE),
    dbBase::smClassDefTreeF(DE,"a",Def),
    Def=fstr(_,Dom,_,_),
    dbBase::nlSing(Dom,NL),
    Mess=string::concat("Domain ",NL," cannot be used in statistical-type procedure!"),    
    dlgIF::dlgNote(1,Mess),!,fail
;    
    !.
    
rowVals(_,_,[],[]) :-
	!.
rowVals(SolRef,P,[StatCompNo|StatCompNos],[Val|Vals]) :-
	sol::solCompNo(SolRef,P,StatCompNo,V),
	V=fix(Val),
	rowVals(SolRef,P,StatCompNos,Vals),
	!
;
	sol::solCompNo(SolRef,P,StatCompNo,V),
	V=int(Int),
	Val=Int,
	rowVals(SolRef,P,StatCompNos,Vals),
	!
;
	sol::solCompNo(SolRef,P,StatCompNo,V),
	V=str(S),
	xmlGeneric::xmlToInternalDate(S,IDate),
	Val=IDate,
	rowVals(SolRef,P,StatCompNos,Vals),
	!.

getTimerNos(_,[],_,_,[]) :-
    !.
getTimerNos(N,[Comp|Cs],Comps,Timers,[TimerNo|TimerNos]) :-
    getCompTimer(Comp,Timers,Timer),
    set::setGet(Comps,TimerNo,Timer),
    Next=N+1,
    getTimerNos(Next,Cs,Comps,Timers,TimerNos),
    !
;
    TimerNo=0, % no timer
    Next=N+1,
    getTimerNos(Next,Cs,Comps,Timers,TimerNos),
    !.
    
getCompTimer(Comp,[[Comp,Timer]|_],Timer) :-
	!.
getCompTimer(Comp,[_|Timers],Timer) :-
	getCompTimer(Comp,Timers,Timer),
	!.

averages([],_,[]) :-
    !.
averages([Sum|Sums],N,[Avg|Avgs]) :-
    Avg=Sum/N,
    averages(Sums,N,Avgs),
    !.
    
stdDevs([],_,[]) :-
    !.
stdDevs([Dev|Devs],N,[Std|Stds]) :-
    Std=math::sqrt(Dev)/N,
    stdDevs(Devs,N,Stds),
    !.

% parameters:
% 1 in matrix
% 2 in list of row-nos (one row-no per column)
% 3 in list of timer-col-nos (one timer-col-no per column, =0 if no timer for the column)
% 4 out value    
%
timerVals(_,[],_,[]) :-
    !.
timerVals(Mx,[RowNo|Rs],[TimerNo|Ts],[TimerVal|Vs]) :-
    TimerNo=0,
    TimerVal=0,
    timerVals(Mx,Rs,Ts,Vs),
    !
;    
    TimerVal=Mx:getCell(RowNo,TimerNo),
    timerVals(Mx,Rs,Ts,Vs),
    !.
    
% replaces solution record P with a type #12 record
%
plcInsStatSol(_,_,_,[],_,_,_,_,_,_,_,_,_,_) :-
	!.
plcInsStatSol(SolRef,P,N,[Comp|Comps],[Sum|Sums],[Min|Mins],[Max|Maxs],[StdDev|StdDevs],[Tmin|Tmins],[Tmax|Tmaxs],[Tf|Tfs],[Tl|Tls],[Start|Starts],[End|Ends]) :-
	sol::solCompVar(SolRef,P,Comp,Original), 
    % 12-tuple constituents:
	% 1=Original     2=Sum         3=MinVal         4=MaxVal        5=SDV          6=Count      
	% 7=MinPoint    8=MaxPoint   9=StartPoint   10=EndPoint    11=StartVal   12=EndVal
	Val=cmp("#12",[Original,fix(Sum),fix(Min),fix(Max),fix(StdDev),int(N),fix(Tmin),fix(Tmax),fix(Tf),fix(Tl),fix(Start),fix(End)]),
	sol::solVarReplace(SolRef,P,Comp,Val),
	plcInsStatSol(SolRef,P,N,Comps,Sums,Mins,Maxs,StdDevs,Tmins,Tmaxs,Tfs,Tls,Starts,Ends),
	!.
% -----------------------------------------------------------------------------------------------
% plcCompute
% -----------------------------------------------------------------------------------------------
class predicates
plcCompNU : (string,real,real,real) determ (i,i,i,o).
plcCompIN : (string,integer,integer,integer) determ (i,i,i,o).
plcCompLI : (string,string,string,string) determ (i,i,i,o).	
clauses
% parameters:
% 1	in	operator (>,>=,<,<=,=,+,-,*,/,div,sqrt,^,max,min)
% 2	in	operand 1
% 3	in	operand 2 (nill if N/A)
% 4	out	result (difference if comparison operator)
% Fails if comparison does not hold.
%
plcCompute("sqrt",R1,nill,fix(F)) :-
	termDomain::realType(R1,F1),
	plcCompNU("sqrt",F1,0.0,F),
	!.
plcCompute(Opr,R1,R2,V) :-
    Opr="/",
	termDomain::realType(R1,F1),
	termDomain::realType(R2,F2), 
	plcCompNU(Opr,F1,F2,F),
	V=fix(F),
	!
;
	termDomain::intType(R1,F1),
	termDomain::intType(R2,F2), 
	plcCompIN(Opr,F1,F2,F),
	V=int(F),
	!.
plcCompute(Opr,R1,R2,fix(F)) :-
	termDomain::realType(R1,F1),
	termDomain::realType(R2,F2), 
	plcCompNU(Opr,F1,F2,F),
	!.
plcCompute(Opr,str(S1),str(S2),str(S)) :- 
	plcCompLI(Opr,S1,S2,S),
	!.
plcCompute(Opr,atom(S1),atom(S2),str(S)) :- 
	plcCompLI(Opr,S1,S2,S),
	!.
% one of the operands is string - convert the other to string
%
plcCompute(Opr,str(S1),V,str(S)) :-
	plcDomVal(V,"p3_dli",Vs),
	Vs=str(S2),
	plcCompLI(Opr,S1,S2,S),
	!.
plcCompute(Opr,V,str(S1),str(S)) :-
	plcDomVal(V,"p3_dli",Vs),
	Vs=str(S2),
	plcCompLI(Opr,S2,S1,S),
	!.
% this predicate always return the result as fix - it should be used in situations where use of integer could give overflow
% 	
plcComputeNU(Opr,R1,R2,F) :-
	termDomain::realType(R1,F1),
	termDomain::realType(R2,F2), 
	plcCompute(Opr,fix(F1),fix(F2),F),
	!.
plcCompNU("<",F1,F2,F) :- 
	F1<F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompNU("<=",F1,F2,F) :- 
	F1<=F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompNU(">",F1,F2,F) :- 
	F1>F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompNU(">=",F1,F2,F) :- 
	F1>=F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompNU("=",F1,F2,F) :- 
	F1=F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompNU("+",F1,F2,F) :- 
	F=F1+F2,
	!.	
plcCompNU("-",F1,F2,F) :- 
	F=F1-F2,
	!.	
plcCompNU("*",F1,F2,F) :- 
	F=F1*F2,
	!.	
plcCompNU("/",F1,F2,F) :- 
	F2<>0.0,
	F=F1/F2,
	!
;
	dlgIF::msgS("Division by 0.0 - see trace file."),
	tt::tt_ss(1,"Division by 0.0"),
	S=toString(F1),
	tt::tt_s(1,"Dividend",S),
	F=999999999.9,
	!.
plcCompNU("^",F1,F2,F) :- 
	fixExp(F1,F2,F),
	!.
plcCompNU("sqrt",F1,_,F) :- 
	F=math::sqrt(F1),
	!.
plcCompNU("max",F1,F2,F) :- 
	F1>=F2,
	F=F1,
	!
;
	F=F2,
	!.	
plcCompNU("min",F1,F2,F) :- 
	F1<=F2,
	F=F1,
	!
;
	F=F2,
	!.	
plcCompNU(Opr,I1,I2,_) :- 
    I1i=convert(integer,I1),
    I2i=convert(integer,I2),
	dlgIF::feil_pie("plcCompNU",[Opr],[I1i,I2i],nill),!,fail.	

plcCompIN("<",F1,F2,F) :- 
	F1<F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompIN("<=",F1,F2,F) :- 
	F1<=F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompIN(">",F1,F2,F) :- 
	F1>F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompIN(">=",F1,F2,F) :- 
	F1>=F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompIN("=",F1,F2,F) :- 
	F1=F2,
	F=F1-F2,
	!
;
	!,fail.	
plcCompIN("+",F1,F2,F) :- 
	F=F1+F2,
	!.	
plcCompIN("-",F1,F2,F) :- 
	F=F1-F2,
	!.	
plcCompIN("*",F1,F2,F) :- 
	F=F1*F2,
	!.	
plcCompIN("div",F1,F2,F) :- 
	F2<>0,
	F=F1 div F2,
	!
;
	dlgIF::msgS("Division by 0 - see trace file."),
	tt::tt_ss(1,"Division by 0"),
	tt::tt_i(1,"Dividend",F1),
	F=9999999,
	!.
plcCompIN("^",I1,I2,I) :-
	F1=convert(real,I1),
	F2=convert(real,I2),
	fixExp(F1,F2,F),
	Fr=math::round(F),
	I=convert(integer,Fr),
	!.
plcCompIN("max",F1,F2,F) :- 
	F1>=F2,
	F=F1,
	!
;
	F=F2,
	!.	
plcCompIN("min",F1,F2,F) :- 
	F1<=F2,
	F=F1,
	!
;
	F=F2,
	!.	
plcCompIN(Opr,_,_,_) :- 
	dlgIF::feil_pie("plcCompIN",[Opr],[],nill),!,fail.	
plcCompLI("<",F1,F2,"") :- 
	F1<F2,
	!
;
	!,fail.	
plcCompLI("<=",F1,F2,"") :- 
	F1<=F2,
	!
;
	!,fail.	
plcCompLI(">",F1,F2,"") :- 
	F1>F2,
	!
;
	!,fail.	
plcCompLI(">=",F1,F2,"") :- 
	F1>=F2,
	!
;
	!,fail.	
plcCompLI("=",F1,F2,"") :- 
	F1=F2,
	!
;
	!,fail.	
plcCompLI("*",S1,S2,S) :- 
	S=string::concat(S1,S2),
	!.
plcCompLI(Opr,S1,S2,_) :- 
	dlgIF::feil_pie("plcCompLI",[Opr,S1,S2],[],nill),!,fail.	
	
plcCompXD("<",F1,F2,str("")) :- 
	F1=str(D1),
	F2=str(D2),
	xmlGeneric::xmlDateLess(D1,D2),
	!
;
	!,fail.	
plcCompXD("<=",F1,F2,str("")) :- 
	F1=str(D1),
	F2=str(D2),
	xmlGeneric::xmlDateLessOrEqual(D1,D2),
	!
;
	!,fail.	
plcCompXD(">",F1,F2,str("")) :- 
	F1=str(D1),
	F2=str(D2),
	not(xmlGeneric::xmlDateLessOrEqual(D1,D2)),
	!
;
	!,fail.	
plcCompXD(">=",F1,F2,str("")) :- 
	F1=str(D1),
	F2=str(D2),
	not(xmlGeneric::xmlDateLess(D1,D2)),
	!
;
	!,fail.	
plcCompXD("=",F1,F2,str("")) :- 
	F1=F2,
	!
;
	!,fail.	
plcCompXD("+",F1,F2,F) :- 
	F1=str(D1),
	F2=str(D2),
	xmlGeneric::xmlDateAdd(D1,D2,D),
	F=str(D),
	!.	
plcCompXD("-",F1,F2,F) :- 
	F1=str(D1),
	F2=str(D2),
	sx::frontstr(1,D2,_,D21),
	sx::frontstr(1,D21,Df,D22),
	Df="-",
	D3=string::concat("P",D22),
	xmlGeneric::xmlDateAdd(D1,D3,D),
	F=str(D),
	!
;
	F1=str(D1),
	F2=str(D2),
	sx::frontstr(1,D2,_,D21),
	D3=string::concat("P-",D21),
	xmlGeneric::xmlDateAdd(D1,D3,D),
	F=str(D),
	!.
plcCompXD("max",F1,F2,F) :- 
	F1=str(D1),
	F2=str(D2),
	xmlGeneric::xmlDateLess(D1,D2),
	F=str(D2),
	!
;
	F=F1,
	!.	
plcCompXD("min",F1,F2,F) :- 
	F1=str(D1),
	F2=str(D2),
	xmlGeneric::xmlDateLess(D1,D2),
	F=str(D1),
	!
;
	F=F2,
	!.	
plcCompXD(Opr,_,_,_) :- 
	dlgIF::feil_pie("plcCompIN",[Opr],[],nill),!,fail.	
% -----------------------------------------------------------------------------------------------
% plcComputeVal
% -----------------------------------------------------------------------------------------------
class predicates
plcComputeParams : (sterml,integer,integer,sterm,sterml,sterml) determ (i,i,i,i,i,o).
plcComputeUnary : (string,sterm,sterm) determ (i,i,o).
plcComputeValProc : (string,string,sterm,sterm) procedure (i,i,i,o).
plcGetCount : (integer,integer,integer,sterm) determ (i,i,i,o).	
getComputedDeValue : (string,sterm,sterml,sterm) determ (i,i,i,o).
isConclusionDe : (string,sterm) determ.
plcAdj12 : (sterml,sterml) procedure (i,o).
clauses

%
% parameters:
% 1	in	DE-variable which eventually will be assigned the computed value
% 2	in	blank or procedure name
% 3	in	computed values (so far) corresponding to par#5
% 4	in	sol.ref.
% 5	in	sol.no.
% 6	in	list(of de variables in the generated entity)
% 7	in	expression from which the value is computed
% 8	out	computed value
%
plcComputeVal(_,Prc,_,SolRef,SolNo,_,atom(Proc),V) :-
	Prc="",
	proc(Proc),
	plcGetCount(SolRef,SolNo,1,V),
	!
;
	Prc<>"",
	proc(Proc),
	dlgIF::feil_pie("plcComputeVal",["Nested procedure calls detected",Prc,Proc],[],nill),
	!,fail.
plcComputeVal(_,_,_,_,_,_,V,Vb) :-
	plcBasicValue(V,Vb),
	!.	
plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,var(Var),Val) :- 
	isConclusionDe(Var,AttrVars),
	% value is a data element in the generated entity
	!,getComputedDeValue(Var,AttrVars,CompVals,Val),
	!
;
	% value is a data element in the solution set
	sol::solCompVar(SolRef,SolNo,Var,ValX),
	plcComputeValProc(DE,Proc,ValX,Val),
	!.
plcComputeVal(DE,_,CompVals,SolRef,SolNo,AttrVars,cmp("p3_iIR",[atom(Rule)|Params]),V) :-
	% value is a certainty rule
	plcComputeParams(CompVals,SolRef,SolNo,AttrVars,Params,ParamVals),
                    profileTime::start("inexactRule"),
	inexactRule(DE,SolRef,SolNo,Rule,ParamVals,V),
                    profileTime::stop("inexactRule"),
	!
;	
	dlgIF::dlgNote(1,"Inference aborted by user break!"),
	globalVars::set_i("quit_flag",1), % to ensure termination of inference in server-mode
	!,fail.
plcComputeVal(DE,Prc,CompVals,SolRef,SolNo,AttrVars,cmp(Proc,[Exp|_]),V) :-
	Prc="",
	Proc="p3_rCorr",
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,var("P3_rCorr"),V),
	!	
;
	Prc="",
	Proc="p3_rRank",
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,var("P3_rRank"),V),
	!	
;
	Prc="",
	Proc="p3_rRnks",
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,var("P3_rRnks"),V),
	!	
;
	% this takes care of calls to p3_rAssg and p3_rSort (and other dummy calls?)
	Prc="",
	proc(Proc),
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,Exp,V),
	!
;
	Prc<>"",
	proc(Proc),
	dlgIF::feil_pie("plcComputeVal",["Nested procedure calls detected",Prc,Proc],[],nill),
	!,fail.
plcComputeVal(_,_,_,_,_,_,cmp(Derf,B),V) :-
	% value is a DERF
	set::member(Derf,["DDERF","NDERF"]),
	proc::pie3_Syn(cmp(Derf,B),SolRef),
				sol::tt_sors(3,Derf,SolRef),
	sol::solCompNo(SolRef,1,1,V),
	sol::solSetDel(SolRef),
				tt::tt_term(3,"DERF value",V),
	!.
plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,cmp(Opr,[Opn1,Opn2]),V) :-
	% value is a binary operator expression
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,Opn1,V1),
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,Opn2,V2),
	plcCompute(Opr,V1,V2,V),
	!.
plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,cmp(Opr,[Opn]),V) :-
	% value is a unary operator expression
	plcComputeVal(DE,Proc,CompVals,SolRef,SolNo,AttrVars,Opn,V1),
	plcComputeUnary(Opr,V1,V),
	!.
plcComputeValProc(_,"p3_rTS",cmp("#12",Vals2),Val) :- 
	%  1=Original    2=Sum        3=MinVal     4=MaxVal       5=SDV
	%  6=Count       7=MinPoint   8=MaxPoint   9=StartPoint  10=EndPoint
	% 11=StartVal   12=EndVal
	plcAdj12(Vals2,Vals),
	Vals=[_,Sum,MinV,MaxV,Sdv,Cnt,MiP,MaP,StP,EnP,StartV,EndV],
	plcCompute("-",MaxV,MinV,Diff),
	plcCompute("+",MaxV,MinV,Tot),
	plcCompute("/",Tot,int(2),Mean), 
	plcCompute("/",Sum,Cnt,Avg), 
	% all TS complex DEs must have the following member list and sequence (matching the definition of
	% a time series data element type)
	Stats=[Sum,Cnt,StartV,Avg,Mean,EndV,Sdv,MinV,MaxV,Diff,StP,EnP,MiP,MaP],
	plcDomVal(cmp("TIMESERIES",Stats),"p3_dts",Val),
	!.
plcComputeValProc(_,"p3_rSum",cmp("#12",[_,Val,_,_,_,_,_,_,_,_,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rMin",cmp("#12",[_,_,Val,_,_,_,_,_,_,_,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rMax",cmp("#12",[_,_,_,Val,_,_,_,_,_,_,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rSdv",cmp("#12",[_,_,_,_,Val,_,_,_,_,_,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rCnt",cmp("#12",[_,_,_,_,_,Val,_,_,_,_,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rMit",cmp("#12",[_,_,_,_,_,_,Vmit,Vmat,Stim,_,_,_]),Val) :- 
	Vmit=int(Mit),
	Vmat=int(Mat),
	Mit=Mat,
	Mit=0,
	Val=Stim,
	!
;
	Val=Vmit,
	!.	
plcComputeValProc(_,"p3_rMat",cmp("#12",[_,_,_,_,_,_,Vmit,Vmat,_,Etim,_,_]),Val) :- 
	Vmit=int(Mit),
	Vmat=int(Mat),
	Mit=Mat,
	Mit=0,
	Val=Etim,
	!
;
	Val=Vmat,
	!.	
plcComputeValProc(_,"p3_rStim",cmp("#12",[_,_,_,_,_,_,_,_,Val,_,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rEtim",cmp("#12",[_,_,_,_,_,_,_,_,_,Val,_,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rStv",cmp("#12",[_,_,_,_,_,_,_,_,_,_,Val,_]),Val) :- 
	!.
plcComputeValProc(_,"p3_rEtv",cmp("#12",[_,_,_,_,_,_,_,_,_,_,_,Val]),Val) :- 
	!.
plcComputeValProc(_,"p3_rAvg",cmp("#12",[_,Sum,_,_,_,N,_,_,_,_,_,_]),Val) :-
	plcCompute("/",Sum,N,Val), 
	!.
plcComputeValProc(_,"p3_rMea",cmp("#12",[_,_,Min,Max,_,_,_,_,_,_,_,_]),Val) :-
	plcCompute("+",Max,Min,Diff),
	plcCompute("/",Diff,int(2),Val), 
	!.
plcComputeValProc(_,_,cmp("#12",[Val,_,_,_,_,_,_,_,_,_,_,_]),Val) :-
	!.
plcComputeValProc(_,_,Val,Val) :- 
	!.
% computes the values of the parameters in a function call
%
plcComputeParams(_,_,_,_,[],[]) :- 
	!.
plcComputeParams(CompVals,SolRef,SolNo,AttrVars,[Par|Params],[V|Vals]) :-
	Par=var(P),
	plcComputeVal("","",CompVals,SolRef,SolNo,AttrVars,var(P),V),
	plcComputeParams(CompVals,SolRef,SolNo,AttrVars,Params,Vals),
	!
;
	dlgIF::feil_pie("plcComputeParams",[],[SolRef,SolNo],cmp("",[Par])),!,fail.
plcComputeUnary("-",int(I1),int(I2)) :- 
	I2=-I1,
	!.
plcComputeUnary("-",fix(I1),fix(I2)) :- 
	I2=-I1,
	!.
plcComputeUnary(Opr,Opn,_) :- 
	dlgIF::feil_pie("plcComputeUnary",[Opr],[],Opn),
	!,fail.	
	
plcGetCount(SolRef,SolNo,CompNo,Val) :-
	sol::solCompNo(SolRef,SolNo,CompNo,ValX), 
	ValX=cmp("#12",_),
	plcComputeValProc("","p3_rCnt",ValX,Val),
	!
;
	Next=CompNo+1,
	plcGetCount(SolRef,SolNo,Next,Val),
	!.
		
% parameters:
% 1	in	de variable (in the generated entity) 
% 2	in	all de variables   "
% 3	in	list of actual values corresponding to par#2
% 4	out	value for par#1
% fails if value not yet computed (or if error)
%	
getComputedDeValue(Var,list(fstr(Var,_,_,_),_),[Val|_],Val) :- 
	!.
getComputedDeValue(Var,list(_,L),[_|Vals],Val) :- 
	getComputedDeValue(Var,L,Vals,Val),
	!.
getComputedDeValue(T1,T2,T3,_) :- 
	dlgIF::feil_pie("getComputedDeValue",[T1],[],cmp("",[T2,cmp("",T3)])),!,fail.

isConclusionDe(Var,list(fstr(Var,_,_,_),_)) :- 
	!.
isConclusionDe(Var,list(_,L)) :- 
	isConclusionDe(Var,L),
	!.

% if actual min point is start point and actual max point is end point, then both have value 0.
% this needs to e corrected
%
plcAdj12(Vals,ValsA) :-
	Vals=[A,Sum,MinV,MaxV,Sdv,Cnt,MiP,MaP,StP,EnP,EndV,StartV],
	MiP=int(0),
	MaP=int(0),
	MiPA=StP,
	MaPA=EnP,
	ValsA=[A,Sum,MinV,MaxV,Sdv,Cnt,MiPA,MaPA,StP,EnP,EndV,StartV],
	!.
plcAdj12(Vals,Vals) :-
	!.
% -----------------------------------------------------------------------------------------------
% plcCorr
% -----------------------------------------------------------------------------------------------
class predicates
plcCorrCheck : (count,chainDB::bt_selector,integer,integer,integer,integer,integer_list,integer_list) determ.
plcCorrSet : (chainDB::bt_selector,integer,integer,integer,integer,integer_list) determ.
plcCorrSetX : (chainDB::bt_selector,integer,integer,integer,integer,integer,sterm,sterm,sterm,sterm,sterm) determ (i,i,i,i,i,i,o,o,o,o,o).
plcCorrX : (count,integer,integer,integer_list,integer_list,integer) determ.
plcCorrIns : (real,real,chainDB::bt_selector,integer,integer,integer) determ.
clauses
plcCorr(SolRef,SolRef2,CorrComps,Eq_Comps,NSol) :-
	sol::solFirstL(SolRef,First), % First logical table row
	CPred=count::newCounter(First),
	plcCorrX(CPred,SolRef,SolRef2,CorrComps,Eq_Comps,NSol),
	!.
	
plcCorrX(CPred,SolRef,SolRef2,CorrComps,Eq_Comps,NSol) :-
	set::size(Eq_Comps,SubSets),
	SubSets>0,!,
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	LPred=CPred:get(),
	sol::forallsolsorted(SolRef,LPred,LSucc,PSucc),
	   plcCorrCheck(CPred,XI,SolRef,SolRef2,LSucc,PSucc,CorrComps,Eq_Comps),
	   LSucc=NSol, % loop termination
	LastLPred=CPred:get(),
	% correlate the last equality-set [LastLPred,LSucc]
	plcCorrSet(XI,SolRef,SolRef2,LastLPred,LSucc,CorrComps),
	!
;
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	plcCorrSet(XI,SolRef,SolRef2,1,NSol,CorrComps),
	!.
plcCorrCheck(CPred,XI,SolRef,SolRef2,LSucc,PSucc,CorrComps,Eq_Comps) :-
	LPred=CPred:get(),
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolCompsEQ(SolRef,PSucc,PPred,Eq_Comps),
	% Pred and Succ are equal: continue looking for end of equality-set
	!
;	
	% Pred and Succ are not equal: compute correlation of the equality set [LPred,LSucc>
	LPred=CPred:get(),
	Last=LSucc-1,
	plcCorrSet(XI,SolRef,SolRef2,LPred,Last,CorrComps),
	CPred:set(LSucc),
	!.
plcCorrSet(XI,SolRef,SolRef2,L,Last,CorrComps) :-
	L=Last,
	stb::stbGetRowL_P(XI,L,P),
	sol::solGet(SolRef,P,Vals),
	sol::solCompsT(SolRef,_,Comps),
	set::conc([Comps,[str("P3_rCorr")]],IComps),
	set::conc([Vals,[fix(1.0)]],IVals),
	sol::solInsVals(SolRef2,IComps,IVals),
	!
;
	CorrComps=[CorrA,CorrB],
	plcCorrSetX(XI,SolRef,L,Last,CorrA,CorrB,SumX2,SumY2,SumXY,SumX,SumY),
	SumX2=fix(SmX2),
	SumY2=fix(SmY2),
	SumXY=fix(SmXY),
	SumX=fix(SmX),
	SumY=fix(SmY),
	N=Last-L+1,
	Sxx=SmX2-(SmX*SmX)/N,
	Syy=SmY2-(SmY*SmY)/N,
	Sxy=SmXY-(SmX*SmY)/N,
	Q=Sxx*Syy,
	plcCorrIns(Q,Sxy,XI,L,SolRef,SolRef2),
	!.
	
plcCorrIns(Q,Sxy,XI,L,SolRef,SolRef2) :-
	Q=0.0,
	S=toString(L),
	sx::concat(["Correlation for solution ",S," cannot be computed!"],Mess),
	dlgIF::msgS(Mess),
	!
;
	Sq=math::sqrt(Q),
	R=Sxy/Sq,
	stb::stbGetRowL_P(XI,L,P),
	sol::solGet(SolRef,P,Vals),
	sol::solCompsT(SolRef,_,Comps),
	set::conc([Comps,[str("P3_rCorr")]],IComps),
	set::conc([Vals,[fix(R)]],IVals),
	sol::solInsVals(SolRef2,IComps,IVals),
	!.
plcCorrSetX(_,_,L,Last,_,_,fix(0.0),fix(0.0),fix(0.0),fix(0.0),fix(0.0)) :-
	L>Last,
	!.
plcCorrSetX(XI,SolRef,L,Last,CorrA,CorrB,SumX2,SumY2,SumXY,SumX,SumY) :-
	Next=L+1,
	plcCorrSetX(XI,SolRef,Next,Last,CorrA,CorrB,MSumX2,MSumY2,MSumXY,MSumX,MSumY),
	stb::stbGetRowL_P(XI,L,P),
	sol::solCompNo(SolRef,P,CorrA,X),
	sol::solCompNo(SolRef,P,CorrB,Y),
	plcComputeNU("*",X,X,X2),
	plcComputeNU("*",Y,Y,Y2),
	plcComputeNU("*",X,Y,XY),
	plcComputeNU("+",MSumX2,X2,SumX2),
	plcComputeNU("+",MSumY2,Y2,SumY2),
	plcComputeNU("+",MSumXY,XY,SumXY),
	plcComputeNU("+",MSumX,X,SumX),
	plcComputeNU("+",MSumY,Y,SumY),
	!.
% ----------------------------------------------------------------------------------------------
% plcCorrPars
% ----------------------------------------------------------------------------------------------
plcCorrPars(SolRef,DE_Vals,CorrComps,Eq_Comps) :-
	plcGetCompNos("p3_rCorr",SolRef,DE_Vals,CorrComps,_),
	plcGetCompNos("=",SolRef,DE_Vals,Eq_Comps,_),
	!.
% -----------------------------------------------------------------------------------------------
% plcDeleteRows
% -----------------------------------------------------------------------------------------------
plcDeleteRows(SolRef,XI,N,Last) :-
	N>Last,
	!
;	
	stb::stbGetRowL_P(XI,N,P),
	stb::stbSortDelRow(SolRef,1,N),
	sol::solDel(SolRef,P),
	Next=N+1,
	plcDeleteRows(SolRef,XI,Next,Last),
	!.
% ----------------------------------------------------------------------------------------------
% plcFunc
% ----------------------------------------------------------------------------------------------
class predicates
plcFunc_X : (integer,string,sterm) determ (i,i,o).
clauses
plcFunc(Var,Query,Val) :-
				tt::tt_ss(3,"Function query"),
	proc::pie3_IF(Query,SolRef),
				sol::tt_sors(4,"Function result",SolRef),
	plcFunc_X(SolRef,Var,Val),
	!.	
plcFunc_X(SolRef,Var,Val) :-	
	sol::solSetSize(SolRef,N),
	N>0,
	sol::solCompVar(SolRef,1,Var,Val),
				tt::tt_term(3,"Function value",Val),
	sol::solSetDel(SolRef),
	!
;
	sol::solSetDel(SolRef),
				tt::tt_ss(3,"Function query failed"),!,fail.
% -----------------------------------------------------------------------------------------------
% plcGenSentence
% -----------------------------------------------------------------------------------------------
class predicates
plcGenSentence2 : (sterml,integer,integer,integer,sterm,sterm,sterml) determ (i,i,i,i,i,i,o).
plcGenSentence3 : (sterml,integer,integer,integer,sterm,sterm,sterml) determ (i,i,i,i,i,i,o).
plcGenSentenceCompare : (sterml,integer,integer) determ.		
plcGenSetNIL : (sterm,sterml) determ (i,o).
plcGenVals : (sterml,sterml,integer,integer,integer,sterm,sterm,sterml) determ (i,i,i,i,i,i,i,o).
clauses
% computes the current set of data element values
% parameters:
% 1	in	sol.ref
% 2	in	sol.no
% 3	in	generated sentence counter
% 4	in	list - implied data element variables
% 5	in	list - assignments expressions representing the values of par#4
% 6	out	values (each corresponding to an expression in par#4)
%
% Note that complex data elements both in par#4 and par#6 are on the compound form.
%
plcGenSentence(SolRef,SolNo,Current,AttrVars,Exps,Vals) :-
                    profileTime::start("plcGenSentence"),
	plcGenSetNIL(AttrVars,InitVals),
	plcGenVals(InitVals,InitVals,SolRef,SolNo,Current,AttrVars,Exps,Vals1),
                    profileTime::start("plcGenSentence2"),
	plcGenSentence2(Vals1,SolRef,SolNo,Current,AttrVars,Exps,Vals),
                    profileTime::stop("plcGenSentence2"),
                    tt::tt_i(4,"Gen.sent.",SolNo),
                    profileTime::stop("plcGenSentence"),
	!
;
	globalVars::get_i("error_flag")=1,
	!,fail.

plcGenSetNIL(nill,[]) :- 
	!.
plcGenSetNIL(list(_,L),[nill|T]) :- 
	plcGenSetNIL(L,T),
	!.
	
plcGenSentence2(ValsC,SolRef,SolNo,Current,AttrVars,Exps,ValsR) :-
	globalVars::get_i("error_flag")=1,
	!,fail
;
	set::member(nill,ValsC),% there are uncomputed values
                    profileTime::start("plcGenSentence3"),
	plcGenSentence3(ValsC,SolRef,SolNo,Current,AttrVars,Exps,ValsR),
                profileTime::stop("plcGenSentence3"),
	!.
plcGenSentence2(ValsC,_,_,_,_,_,ValsC) :-
	!.

% repeats computing data elements until all have been computed
%
plcGenSentence3(CompVals,SolRef,SolNo,Current,AttrVars,Exps,Vals) :-
	set::setCount(nill,CompVals,N1),
	N1>0, % one or more values have not yet been computed
	plcGenVals(CompVals,CompVals,SolRef,SolNo,Current,AttrVars,Exps,Vals1),
	set::setCount(nill,Vals1,N2),
	plcGenSentenceCompare(Vals1,N1,N2),
	plcGenSentence3(Vals1,SolRef,SolNo,Current,AttrVars,Exps,Vals),
	!
;
	globalVars::get_i("error_flag")=1,
			tt::tt_term(1,"DE variables",AttrVars),
			tt::tt_term(1,"Expressions",Exps),
	!,fail
;	
	% all values have been computed
	Vals=CompVals,
	!.

plcGenSentenceCompare(CompVals,N1,N2) :-
	N1>N2,
	!
;
	dlgIF::feil_pie("plcGenSentenceCompare",["unable to compute all data elements"],[],cmp("",CompVals)),
	!,fail.	
% tries to compute values for data elements which have value 'nill'
% parameters:
% 1	in	the tail part of par#2 which has not yet been processed
%               gen-values so far
% 2	in	values for implied de variables generated so far
%               nill signifies un-generated de variables
% 3	in	sol.rec.
% 4	in	generated entity counter
% 5	in	list - implied entity type's data element variables
% 6	in	list - assignments expressions representing the values of par_5
% 7	out	corresponding to par#1, but with nill-values in par#1 are
%               replaced by computed values (where these are computable at
%               this stage)
%
plcGenVals([],_,_,_,_,_,_,[]) :- 
	tt::tt_ss(3,"plcGenVals/a"),
	!.
plcGenVals(_,_,_,_,_,_,list(cmp("PROC",[atom(Proc)|_]),_),_) :-
	dlgIF::feil_pie("plcGenVals",["See code",Proc],[],nill),!,fail.
plcGenVals([nill|Vs],CompVals,SolRef,SolNo,Current,AttrVars,list(Exp,Exps),[Val|Vals]) :-
	% value has not yet been generated
	set::size(Vs,N2),
	termDomain::cl_listR(DEs,AttrVars),
	set::size(DEs,N3),
	N=N3-N2,
	set::setGet(DEs,N,DV2),
	DV2=fstr(DV,Dom,_,_),
                    profileTime::start("plcComputeVal"),
	plcComputeVal(DV,"",CompVals,SolRef,SolNo,AttrVars,Exp,Val2),
                    profileTime::stop("plcComputeVal"),
    not(Val2=nill),
	plcDomVal(Val2,Dom,Val),
	set::setReplace(CompVals,N,Val,CompValsM),
	plcGenVals(Vs,CompValsM,SolRef,SolNo,Current,AttrVars,Exps,Vals),
	!
;
	% value has not yet been generated
	set::size(Vs,N2),
	termDomain::cl_listR(DEs,AttrVars),
	set::size(DEs,N3),
	N=N3-N2,
	set::setGet(DEs,N,DV2),
	DV2=fstr(DV,Dom,_,_), 
                    profileTime::start("plcComputeVal"),
	plcComputeVal(DV,"",CompVals,SolRef,SolNo,AttrVars,Exp,Val2),
                    profileTime::stop("plcComputeVal"),
    not(Val2=nill),
	plcDomVal(Val2,Dom,Val),
	set::setReplace(CompVals,N,Val,CompValsM),
	plcGenVals(Vs,CompValsM,SolRef,SolNo,Current,AttrVars,Exps,Vals),
	!.
plcGenVals([nill|Vs],CompVals,SolRef,SolNo,Current,AttrVars,list(_,Exps),[nill|Vals]) :- 
	% value is not yet computable
	plcGenVals(Vs,CompVals,SolRef,SolNo,Current,AttrVars,Exps,Vals),
	!.
plcGenVals([Val|Vs],CompVals,SolRef,SolNo,Current,AttrVars,list(_,Exps),[Val|Vals]) :-
    not(Val=nill),
	% value has already been generated
	plcGenVals(Vs,CompVals,SolRef,SolNo,Current,AttrVars,Exps,Vals),
	!.
% -----------------------------------------------------------------------------------------------
% plcGetComps/SEL
% -----------------------------------------------------------------------------------------------
% gets the solution componens's for DE variables with 
% parameters:
% 1	in	=	get comp.no's for DE var with equality condition
%		Proc	do. with proc condition
% 2	in	sol.ref.
% 3	in	DE assignment list (right-side values)
% 4	out	returned component no's (1,2,...)
%
plcGetComps(_,_,nill,[],[]) :- 
	!.
plcGetComps("=",SolRef,list(var(DE_Var),L),[DE_Var|DE_Vars],[nill|Nills]) :-
	plcGetComps("=",SolRef,L,DE_Vars,Nills),
	!.
plcGetComps("=",SolRef,list(_,L),Vs,Nills) :- 
	plcGetComps("=",SolRef,L,Vs,Nills),
	!.
plcGetComps(Proc,SolRef,list(cmp(P,[var(DE_Var),var(DE_Var2)]),L),[DE_Var,DE_Var2|Vs],[nill,nill|Pars]) :-
	Proc=P, % procedure call with two DE-var parameters
	plcGetComps(Proc,SolRef,L,Vs,Pars),
	!.
plcGetComps(Proc,SolRef,list(cmp(P,[var(DE_Var)]),L),[DE_Var|Vs],[nill|Pars]) :-
	Proc=P, % procedure call with one DE-var parameter
	plcGetComps(Proc,SolRef,L,Vs,Pars),
	!.
plcGetComps(Proc,SolRef,list(cmp(P,[Par]),L),[""|Vs],[Par|Pars]) :-
	Proc=P, % procedure call with one parameter
	plcGetComps(Proc,SolRef,L,Vs,Pars),
	!.
plcGetComps(Proc,SolRef,list(cmp(P,[var(DE_Var),Par]),L),[DE_Var|Vs],[Par|Pars]) :-
	Proc=P, % procedure call with one DE-var parameter and one other parameter
	plcGetComps(Proc,SolRef,L,Vs,Pars),
	!.
plcGetComps(Proc,SolRef,list(_,L),Vs,Pars) :- 
	plcGetComps(Proc,SolRef,L,Vs,Pars),
	!.
% -----------------------------------------------------------------------------------------------
% plcGetCompNos/SEL
% -----------------------------------------------------------------------------------------------
% gets the solution component no's for DE variables with 
% parameters:
% 1	in	=	get comp.no's for DE var with equality condition
%		Proc	do. with proc condition
% 2	in	sol.ref.
% 3	in	DE assignment list (right-side values)
% 4	out	returned component no's (1,2,...)
%
plcGetCompNos(_,_,nill,[],[]) :- 
	!.
plcGetCompNos("=",SolRef,list(var(DE_Var),L),[No|Nos],[nill|Nills]) :-
	sol::solVarNo(SolRef,DE_Var,No),
	plcGetCompNos("=",SolRef,L,Nos,Nills),
	!.
plcGetCompNos("=",SolRef,list(_,L),Nos,Nills) :- 
	plcGetCompNos("=",SolRef,L,Nos,Nills),
	!.
plcGetCompNos(Proc,SolRef,list(cmp(P,[var(DE_Var),var(DE_Var2)]),L),[No,No2|Nos],[nill,nill|Pars]) :-
	Proc=P, % procedure call with two DE-var parameters
	sol::solVarNo(SolRef,DE_Var,No),
	sol::solVarNo(SolRef,DE_Var2,No2),
	plcGetCompNos(Proc,SolRef,L,Nos,Pars),
	!.
plcGetCompNos(Proc,SolRef,list(cmp(P,[var(DE_Var)]),L),[No|Nos],[nill|Pars]) :-
	Proc=P, % procedure call with one DE-var parameter
	sol::solVarNo(SolRef,DE_Var,No),
	plcGetCompNos(Proc,SolRef,L,Nos,Pars),
	!.
plcGetCompNos(Proc,SolRef,list(cmp(P,[Par]),L),[0|Nos],[Par|Pars]) :-
	Proc=P, % procedure call with one parameter
	plcGetCompNos(Proc,SolRef,L,Nos,Pars),
	!.
plcGetCompNos(Proc,SolRef,list(cmp(P,[var(DE_Var),Par]),L),[No|Nos],[Par|Pars]) :-
	Proc=P, % procedure call with one DE-var parameter and one other parameter
	sol::solVarNo(SolRef,DE_Var,No),
	plcGetCompNos(Proc,SolRef,L,Nos,Pars),
	!.
plcGetCompNos(Proc,SolRef,list(_,L),Nos,Pars) :- 
	plcGetCompNos(Proc,SolRef,L,Nos,Pars),
	!.
% ----------------------------------------------------------------------------------------------
% plcIP_Pars
% ----------------------------------------------------------------------------------------------
class predicates
plcIP_MainPars : (sterm,integer,sterm,sterm,sterm,string) determ (i,o,o,o,o,o).
clauses
plcIP_Pars(SolRef,DE_Vals,ExTyp,Start,End,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefVs) :-
	plcIP_MainPars(DE_Vals,ExTyp,Start,End,Step,IP_Var),
	sol::solVarNo(SolRef,IP_Var,IP_Comp),
	plcGetCompNos("=",SolRef,DE_Vals,Eq_Comps,_),
	plcGetCompNos("p3_rUpp",SolRef,DE_Vals,CompsU,_),
	plcGetCompNos("p3_rLow",SolRef,DE_Vals,CompsL,_),
	plcGetCompNos("p3_rMnVa",SolRef,DE_Vals,CompsM,_),
	plcGetCompNos("p3_rDf",SolRef,DE_Vals,CompsD,DefVs),
	!.
	
plcIP_MainPars(nill,_,_,_,_,_) :-
	dlgIF::feil_pie("plcIP_MainPars",["Cannot find call to interpolation procedure"],[],nill),!,fail.
plcIP_MainPars(list(cmp(Proc,[var(IP_Var),atom(Ex),Start,End,Step]),_),ExTyp,Start,End,Step,IP_Var) :-
	set::member(Proc,["p3_rCip","p3_rCipxd"]),
	set::setGet(["p3_iNone","p3_iBoth","p3_iStrt","p3_iEnd"],ExTyp,Ex),
	!.
plcIP_MainPars(list(_,T),ExTyp,Start,End,Step,IP_Var) :-
	plcIP_MainPars(T,ExTyp,Start,End,Step,IP_Var),
	!.
% ----------------------------------------------------------------------------------------------
% plcMM_Pars
% ----------------------------------------------------------------------------------------------
plcMM_Pars(Proc,SolRef,DE_Vals,EqComps,MaxComp) :-
	plcGetCompNos("=",SolRef,DE_Vals,EqComps,_),
	plcGetCompNos(Proc,SolRef,DE_Vals,MM_Comps,_),
	set::size(MM_Comps,N),
	N=1,
	MM_Comps=[MaxComp],
	!
;
	dlgIF::feil_pie("plcMM_Pars",["Cannot find call to min/max procedure, or more than one call"],[],nill),!,fail.
% ----------------------------------------------------------------------------------------------
% plcRankPars
% ----------------------------------------------------------------------------------------------
class predicates
plcOrderSort : (integer,integer,integer_list,sterml,integer_list) determ (i,i,i,i,o).
clauses
plcRankPars(SolRef,DE_Vals,RankOrder,SortComps,Eq_Comps,"p3_rRank") :-
	plcGetCompNos("p3_rRank",SolRef,DE_Vals,_,RankOrders),
	RankOrders=[Order],
	set::setGet([atom("p3_iDesc"),atom("p3_iAsc")],N,Order),
	set::setGet([-1,1],N,RankOrder),
	plcGetCompNos("p3_rSort",SolRef,DE_Vals,SComps,SNos),
	set::size(SComps,Ns),
	plcOrderSort(1,Ns,SComps,SNos,SortComps),
	plcGetCompNos("=",SolRef,DE_Vals,Eq_Comps,_),
	!.
plcRankPars(SolRef,DE_Vals,RankOrder,SortComps,Eq_Comps,"p3_rRnks") :-
	plcGetCompNos("p3_rRnks",SolRef,DE_Vals,_,RankOrders),
	RankOrders=[Order],
	set::setGet([atom("p3_iDesc"),atom("p3_iAsc")],N,Order),
	set::setGet([-1,1],N,RankOrder),
	plcGetCompNos("p3_rSort",SolRef,DE_Vals,SComps,SNos),
	set::size(SComps,Ns),
	plcOrderSort(1,Ns,SComps,SNos,SortComps),
	plcGetCompNos("=",SolRef,DE_Vals,Eq_Comps,_),
	!.
plcOrderSort(N,Max,_,_,[]) :-
	N>Max,
	!.
plcOrderSort(N,Max,SComps,SNos,[Comp|Comps]) :-
	set::setGet(SNos,Ix,int(N)),
	set::setGet(SComps,Ix,Comp),
	Next=N+1,
	plcOrderSort(Next,Max,SComps,SNos,Comps),
	!
;
	dlgIF::dlgExp(1018),
	dlgIF::feil_pie("plcOrderSort",["Error in Ranking-rule"],[N,Max|SComps],cmp("Sort Orders",SNos)),!,fail.
% ----------------------------------------------------------------------------------------------
% plcProcComps
% ----------------------------------------------------------------------------------------------
class predicates
plcPC : (sterm,sterm,string_list) determ (i,i,o).
plcPC_Exp : (sterm,sterm,string_list) procedure (i,i,o).	
plcPC_Exps : (sterm,sterml,string_list) determ (i,i,o).	
clauses
% returns a list of solution component procedure calls
% parameters:
% 1	in	sol.ref.
% 2	in	list of solution components [var(xxx),...
% 3	in	list of assignment expressions corresponding to par#2
% 4	out	list of procedures using solution component (corresponding to ar#2) as a parameter
%
plcProcComps(_,[],_,[]) :-
	!.
plcProcComps(SolRef,[C|Comps],AssExps,[Procs|Ps]) :-
	plcPC(var(C),AssExps,Procs),
	plcProcComps(SolRef,Comps,AssExps,Ps),
	!.
plcPC(_,nill,[]) :-
	!.	
plcPC(DV,list(Exp,Exps),Procs) :-
	plcPC_Exp(DV,Exp,ProcsA),
	plcPC(DV,Exps,ProcsB),
	set::conc([ProcsA,ProcsB],Procs),
	!.
	
plcPC_Exp(DV,cmp(Proc,[Arg]),Procs) :-
	proc(Proc),
	struc::treHasNode(Arg,DV),
	plcPC_Exp(DV,Arg,ProcsA),
	Procs=[Proc|ProcsA],
	!
;
	plcPC_Exp(DV,Arg,Procs),
	!.	
plcPC_Exp(DV,cmp(Proc,[ArgA,ArgB]),Procs) :-
	proc(Proc),
	struc::treHasNode(ArgA,DV),
	plcPC_Exp(DV,ArgA,ProcsA),
	plcPC_Exp(DV,ArgB,ProcsB),
	set::conc([ProcsA,ProcsB],ProcsC),
	Procs=[Proc|ProcsC],
	!
;
	proc(Proc),
	struc::treHasNode(ArgB,DV),
 	plcPC_Exp(DV,ArgA,ProcsA),
	plcPC_Exp(DV,ArgB,ProcsB),
	set::conc([ProcsA,ProcsB],ProcsC),
	Procs=[Proc|ProcsC],
	!
;
	plcPC_Exp(DV,ArgA,ProcsA),
	plcPC_Exp(DV,ArgB,ProcsB),
	set::conc([ProcsA,ProcsB],Procs),
	!.	
plcPC_Exp(DV,cmp(_,Args),Procs) :-
	plcPC_Exps(DV,Args,Procs),
	!.
plcPC_Exp(DV,list(Exp,Exps),Procs) :-
	plcPC_Exp(DV,Exp,ProcsA),
	plcPC_Exp(DV,Exps,ProcsB),	
	set::conc([ProcsA,ProcsB],Procs),
	!.
plcPC_Exp(_,_,[]) :-
	!.
plcPC_Exps(_,[],[]) :-
	!.
plcPC_Exps(DV,[Exp|Exps],Procs) :-
	plcPC_Exp(DV,Exp,ProcsA),
	plcPC_Exps(DV,Exps,ProcsB),
	set::conc([ProcsA,ProcsB],Procs),
	!.
% ----------------------------------------------------------------------------------------------
% plcQueryComps
% ----------------------------------------------------------------------------------------------
class predicates
plcQC : (sterml,sterml) determ (i,o).	
clauses

% returns the list of solution components corresponding to the given query
%
plcQueryComps(cmp(",",L),Comps) :-
	plcQC(L,Comps),
	!.
plcQueryComps(cmp(P,[cmp(_,Ca),cmp(_,Cb)|Cp]),Comps) :-
    dbBase::smClassDefF(P,"p",Card,_,_,_,_),
	Card=2,
	set::conc([Ca,Cb,Cp],Comps),
	!.
plcQueryComps(cmp(P,[cmp(_,Ca)|Cp]),Comps) :-
    dbBase::smClassDefF(P,"p",Card,_,_,_,_),
	Card=1,
	set::conc([Ca,Cp],Comps),
	!.
plcQueryComps(cmp(Opr,[var(X),_]),[var(X)]) :- % 29.4.4 to include simple variable components
	opr::oprEq(Opr),
	!.
plcQueryComps(cmp(F,[_,var(X),_]),[var(X)]) :- % 29.4.4 to include function return variable components
    dbBase::smDefF(F,Cls,_,_,_,_,_),
	set::member(Cls,["f","g"]),
	!.
plcQueryComps(cmp(_,L),Comps) :-
	plcQC(L,Comps),
	!.
plcQueryComps(_,[]) :-
	!.
plcQC([],[]) :-
	!.
plcQC([H|T],Comps) :-
	plcQueryComps(H,CompsA),
	plcQC(T,CompsB),
	set::conc([CompsA,CompsB],Comps),
	!.			
% -----------------------------------------------------------------------------------------------
% plcRank
% -----------------------------------------------------------------------------------------------
class predicates
plcRankCheck : (string,count,chainDB::bt_selector,integer,integer,integer,integer,integer_list,integer_list,integer).
plcRankSet : (string,chainDB::bt_selector,integer,integer,integer,integer,integer,integer_list).
plcRankX : (string,count,integer,integer,integer,integer_list,integer_list,integer) determ.
countTies : (integer,chainDB::bt_selector,integer,integer,integer,integer_list,integer) procedure (i,i,i,i,i,i,o).	
plcRankInsert : (string,integer,chainDB::bt_selector,integer,integer,integer,integer,integer,real) determ (i,i,i,i,i,i,i,i,i).
clauses
plcRank(RankType,SolRef,SolRef2,RankOrder,SortComps,Eq_Comps,NSol) :-
	sol::solFirstL(SolRef,First), % First logical table row
	CPred=count::newCounter(First),
	plcRankX(RankType,CPred,SolRef,SolRef2,RankOrder,SortComps,Eq_Comps,NSol),
	!.
	
plcRankX(RankType,CPred,SolRef,SolRef2,RankOrder,SortComps,Eq_Comps,NSol) :-
	set::size(Eq_Comps,SubSets),
	SubSets>0,!,
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	Start=CPred:get()+1,
	sol::forallsolsorted(SolRef,Start,LSucc,PSucc),
	   plcRankCheck(RankType,CPred,XI,SolRef,SolRef2,LSucc,PSucc,SortComps,Eq_Comps,RankOrder),
	   LSucc=NSol, % loop termination
	LastLPred=CPred:get(),
	% rank the last equality-set [LastLPred,LSucc]
	plcRankSet(RankType,XI,SolRef,SolRef2,RankOrder,LastLPred,LSucc,SortComps),
	!
;
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	plcRankSet(RankType,XI,SolRef,SolRef2,RankOrder,1,NSol,SortComps),
	!.
plcRankCheck(RankType,CPred,XI,SolRef,SolRef2,LSucc,PSucc,SortComps,Eq_Comps,RankOrder) :-
	LPred=CPred:get(),
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolCompsEQ(SolRef,PSucc,PPred,Eq_Comps),
	% Pred and Succ are equal: continue looking for end of equality-set
	!
;	
	% Pred and Succ are not equal: rank the equality set [LPred,LSucc>
	LPred=CPred:get(),
	Last=LSucc-1,
	plcRankSet(RankType,XI,SolRef,SolRef2,RankOrder,LPred,Last,SortComps),
	CPred:set(LSucc),
	!.
% ranks the sentences in an equality-group
% 
plcRankSet(RankType,XI,SolRef,SolRef2,RankOrder,LFirst,LLast,SortComps) :-
	CRank=count::newCounter(0),
	CNext=count::newCounter(0),
	Size=LLast-LFirst+1,
	% ascending rank: lowest value gets rank 1
	% descending rank: highest value gets rank 1
	set::setGetI([-1,1],Get,RankOrder),
	set::setGetI([LLast,LFirst],Get,StartL),
	set::setGetI([LFirst,LLast],Get,EndL),
	Counter=programControl::sequence_nd(1,Size,1),
	   Counter>=CNext:get(),
	   LRow=StartL+(Counter-1)*RankOrder,
	   countTies(RankOrder,XI,SolRef,LRow,EndL,SortComps,Ties),
	   Rank=CRank:get(),
	   NRank=Rank+1,
	   AvgRank=(NRank+Rank+Ties)/2.0,
	   plcRankInsert(RankType,RankOrder,XI,SolRef,SolRef2,LRow,Ties,NRank,AvgRank),
	   NextRow=Counter+Ties,
	   NextRank=Rank+Ties,
	   CNext:set(NextRow),
	   CRank:set(NextRank),
	   fail
;
	!.
% determines the number of ties (1,2,...) 1 means no ties
%
countTies(RankOrder,XI,SolRef,LRow,EndL,SortComps,Ties) :-
	LRow=EndL,
	Ties=1,
	!
;
	LNext=LRow+RankOrder,
	stb::stbGetRowL_P(XI,LNext,PNext),
	stb::stbGetRowL_P(XI,LRow,PRow),
	plcSolCompsEQ(SolRef,PRow,PNext,SortComps),
	countTies(RankOrder,XI,SolRef,LNext,EndL,SortComps,Ties2),
	Ties=Ties2+1,
	!
;
	Ties=1,
	!.
	
% inserts one sentence for each sentence in the tie-group
%	
plcRankInsert(_,_,_,_,_,_,0,_,_) :-
	!.
plcRankInsert(RankType,RankOrder,XI,SolRef,SolRef2,LRow,Ties,Rank,AvgRank) :-
	RankType="p3_rRank",
	stb::stbGetRowL_P(XI,LRow,PRow),
	sol::solGet(SolRef,PRow,Vals),
	sol::solCompsT(SolRef,_,Comps),
	set::conc([Comps,[str("P3_rRank")]],IComps),
	set::conc([Vals,[int(Rank)]],IVals),
	sol::solInsVals(SolRef2,IComps,IVals),
	NTies=Ties-1,
	NextRow=LRow+RankOrder,
	plcRankInsert(RankType,RankOrder,XI,SolRef,SolRef2,NextRow,NTies,Rank,AvgRank),
	!
;
	RankType="p3_rRnks",
	stb::stbGetRowL_P(XI,LRow,PRow),
	sol::solGet(SolRef,PRow,Vals),
	sol::solCompsT(SolRef,_,Comps),
	set::conc([Comps,[str("P3_rRnks")]],IComps),
	set::conc([Vals,[fix(AvgRank)]],IVals),
	sol::solInsVals(SolRef2,IComps,IVals),
	NTies=Ties-1,
	NextRow=LRow+RankOrder,
	plcRankInsert(RankType,RankOrder,XI,SolRef,SolRef2,NextRow,NTies,Rank,AvgRank),
	!.
% ----------------------------------------------------------------------------------------------
% plcRelComps
% ----------------------------------------------------------------------------------------------
class predicates
plcRelCompsX : (sterml,sterm,string_list) determ (i,i,o).
clauses
% returns the list of solution components which are relevant for (used in) the implied sentence. if none then
% make first component relevant (as dummy). 
% pre 3.10.3: returned a list [0,1,0,..] such that comp 1 not rel; comp 2 rel; comp 3 not rel. etc
% 3.10.3    : return a string list of relevant components
%
plcRelComps(Comps,AssExps,Rels) :-
	plcRelCompsX(Comps,AssExps,Rels),
	set::size(Rels,N),
	N>0,
	!
;
	Comps=[C|_],
	C=var(S),
	Rels=[S],
	!.
plcRelCompsX([],_,[]) :-
	!.
plcRelCompsX([C|Comps],AssExps,[RelComp|RelComps]) :-
	struc::treHasNode(AssExps,C),
	C=var(RelComp),
	plcRelCompsX(Comps,AssExps,RelComps),
	!.
plcRelCompsX([_|Comps],AssExps,RelComps) :-
	plcRelCompsX(Comps,AssExps,RelComps),
	!.
% ----------------------------------------------------------------------------------------------
% selectionProcedure
% ----------------------------------------------------------------------------------------------
selectionProcedure("p3_iRcor",Query,ImpDEs,DE_Vals,Vals) :- 
	selectionProcedure_Query("p3_iRcor",Query,SolRef,SolRef2),
    % correlation
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	plcCorrPars(SolRef,DE_Vals,CorrComps,Eq_Comps),
				sol::tt_sors(3,"CORRELATION",SolRef),
				tt::tt_is(3,"Correlation components",CorrComps),
				tt::tt_is(3,"Equality components",Eq_Comps),
	plcStartCorr(SolRef,SolRef2,CorrComps,Eq_Comps),
	sol::solSetEnumerate(SolRef2),
				sol::tt_sors(3,"Correlation condition set/after (final)",SolRef2),
	% generate the resulting sentences				
	!,
	sol::forallsol(SolRef2,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef2,SolNo,0,ImpDEs,DE_Vals,Vals)
	   .
selectionProcedure("p3_iRrnk",Query,ImpDEs,DE_Vals,Vals) :- 
	selectionProcedure_Query("p3_iRrnk",Query,SolRef,SolRef2),
	% ranking
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	plcRankPars(SolRef,DE_Vals,RankOrder,SortComps,Eq_Comps,RankType),
				sol::tt_sors(3,"RANKING",SolRef),
				tt::tt_s(3,"Rank type",RankType),
				tt::tt_i(3,"Rank order",RankOrder),
				tt::tt_is(3,"Sort components",SortComps),
				tt::tt_is(3,"Equality components",Eq_Comps),
	plcStartRank(RankType,SolRef,SolRef2,RankOrder,SortComps,Eq_Comps),
	sol::solSetEnumerate(SolRef2),
	% generate the resulting sentences				
	!,
	sol::forallsol(SolRef2,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef2,SolNo,0,ImpDEs,DE_Vals,Vals)
	   .
selectionProcedure(Proc,Query,ImpDEs,DE_Vals,Vals) :- 
	set::member(Proc,["p3_iRip","p3_iRipxd"]),
	% interpolation
	selectionProcedure_Query("p3_iRip",Query,SolRef,SolRef2),
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	plcIP_Pars(SolRef,DE_Vals,Open,Start,End,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefVs),
				sol::tt_sors(3,"INTERPOLATION",SolRef),
				tt::tt_i(3,"Extrapolation",Open),
				tt::tt_term(3,"IP Start",Start),
				tt::tt_term(3,"IP End",End),
				tt::tt_term(3,"IP Step",Step),
				tt::tt_i(3,"IP Comp",IP_Comp),
				tt::tt_is(3,"Equality components",Eq_Comps),
				tt::tt_is(3,"Upper components",CompsU),
				tt::tt_is(3,"Lower components",CompsL),
				tt::tt_is(3,"Mid components",CompsM),
				tt::tt_is(3,"Def components",CompsD),
				tt::tt_terms(3,"IP/Default values",DefVs),
	!,
	plcStartIP(SolRef,SolRef2,Open,Start,End,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefVs),
	sol::solSetEnumerate(SolRef2),
	% generate the resulting sentences				
	!,
	sol::forallsol(SolRef2,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef2,SolNo,0,ImpDEs,DE_Vals,Vals)
	   .
selectionProcedure("p3_iRacc",Query,ImpDEs,DE_Vals,Vals) :- 
	selectionProcedure_Query("p3_iRacc",Query,SolRef,_),
    % accumulation
				sol::tt_sors(3,"ACCUMULATION",SolRef),
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	plcAccPars(SolRef,DE_Vals,EqComps,AccComps,SerComp),
				tt::tt_is(3,"Accumulation components",AccComps),
				tt::tt_i(3,"Series component",SerComp),
				tt::tt_is(3,"Equality components",EqComps),
	%
	plcStartAcc(SolRef,SerComp,AccComps,EqComps,NSol),
	sol::solSetMarkAltered(SolRef),
	% generate the resulting sentences				
	!,
	sol::forallsol(SolRef,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef,SolNo,0,ImpDEs,DE_Vals,Vals)
	   .
selectionProcedure("p3_iRun",Query,ImpDEs,DE_Vals,Vals) :- 
	selectionProcedure_Query("p3_iRun",Query,SolRef,SolRef2),
    % unique selection
				sol::tt_sors(3,"UNIQUE",SolRef),
				sol::tt_sors(3,"UNIQUE",SolRef2),
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	plcUN_Pars(SolRef,DE_Vals,EqComps,UN_Comps),
				tt::tt_is(3,"Unique components",UN_Comps),
				tt::tt_is(3,"Equality components",EqComps),
	plcStartUnique(SolRef,SolRef2,UN_Comps,EqComps),
	sol::solSetEnumerate(SolRef2),
	% generate the resulting sentences				
	!,
	sol::forallsol(SolRef2,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef2,SolNo,0,ImpDEs,DE_Vals,Vals)
	   .
selectionProcedure(Proc,Query,ImpDEs,DE_Vals,Vals) :-
	set::member(Proc,["p3_iRmax","p3_iRmin"]),
	% max/min selection
	selectionProcedure_Query(Proc,Query,SolRef,_),
				sol::tt_sors(3,"MINMAX",SolRef),
	sol::solSetSize(SolRef,NSol),
				tt::tt_i(2,"#solutions",NSol),
	NSol>0,	
	set::setGet(["p3_iRmax","p3_iRmin"],PN,Proc),
	set::setGet(["p3_rMax","p3_rMin"],PN,Prc),
	plcMM_Pars(Prc,SolRef,DE_Vals,EqComps,MM_Comp),
				tt::tt_s(3,"Procedure",Proc),
				tt::tt_i(3,"MINMAX element",MM_Comp),
				sol::tt_sors(3,"Solutions",SolRef),
	set::conc([EqComps,[MM_Comp]],SortComps),
	sol::solSort(SolRef,SortComps),
				tt::tt_table(3,"Sort-table/before",SolRef),
	plcMM(SolRef,EqComps,Prc,NSol),
	sol::solSetMarkAltered(SolRef),
				sol::tt_sors(3,"Sort-table/after",SolRef),
	% generate the resulting sentences				
	!,
	sol::forallsol(SolRef,SolNo),
	   globalVars::get_i("quit_flag")=0,
	   plcGenSentence(SolRef,SolNo,0,ImpDEs,DE_Vals,Vals)
	   .
% -----------------------------------------------------------------------------------------------
% plcStartAcc
% -----------------------------------------------------------------------------------------------
plcStartAcc(SolRef,Seq_Comp,Acc_Comps,Eq_Comps,NSol) :-
	set::conc([Eq_Comps,[Seq_Comp]],SortComps),
	sol::solSort(SolRef,SortComps),
				tt::tt_table(3,"SEL/ACC sorted condition set",SolRef),
	plcAccumulate(SolRef,Acc_Comps,Eq_Comps,NSol),
				tt::tt_table(4,"SEL/ACC condition set/after",SolRef),
	!.
% -----------------------------------------------------------------------------------------------
% plcStartCorr
% -----------------------------------------------------------------------------------------------
plcStartCorr(SolRef,SolRef2,CorrComps,[]) :-
	CorrComps=[A,_], % dummy sort since no equality components exist - works, but waste of time (22.7.3)
	sol::solSort(SolRef,[A]),
				tt::tt_table(3,"Correlation dummy-sorted condition set",SolRef),
	sol::solSetSize(SolRef,NSol),
	plcCorr(SolRef,SolRef2,CorrComps,[],NSol),
				sol::tt_sors(4,"Correlation condition set/after",SolRef2),
	!.
plcStartCorr(SolRef,SolRef2,CorrComps,Eq_Comps) :-
	sol::solSort(SolRef,Eq_Comps),
				tt::tt_table(3,"Correlation sorted condition set",SolRef),
	sol::solSetSize(SolRef,NSol),
	plcCorr(SolRef,SolRef2,CorrComps,Eq_Comps,NSol),
				sol::tt_sors(4,"Correlation condition set/after",SolRef2),
	!.
% -----------------------------------------------------------------------------------------------
% plcStartRank
% -----------------------------------------------------------------------------------------------
plcStartRank(RankType,SolRef,SolRef2,RankOrder,SortComps,Eq_Comps) :-
	set::conc([Eq_Comps,SortComps],SComps),
	sol::solSort(SolRef,SComps),
				tt::tt_table(3,"RANK sorted condition set",SolRef),
	sol::solSetSize(SolRef,NSol),
	plcRank(RankType,SolRef,SolRef2,RankOrder,SortComps,Eq_Comps,NSol),
				tt::tt_table(3,"RANK condition set/after",SolRef2),
	!.
% -----------------------------------------------------------------------------------------------
% plcStartUnique
% -----------------------------------------------------------------------------------------------
class predicates
plcCheckUnique : (chainDB::bt_selector,integer,integer,integer,integer,integer_list) determ (i,i,i,i,i,i).
plcSkipNonUnique : (chainDB::bt_selector,integer,integer,integer,integer,integer_list) determ (i,i,i,i,i,i).
plcUnique : (chainDB::bt_selector,integer,integer,integer,integer,integer_list,integer_list,count) determ (i,i,i,i,i,i,i,i).
clauses
% parameters:
% 1	in	solref for original solset
% 2	in	solref for solset where unique solu'tions are inserted
% 3	in	list of unique components
% 4	in	list of equal components
%
plcStartUnique(_,_,[],_) :-
	!.
plcStartUnique(SolRef,SolRef2,UN_Comps,[]) :-
	sol::solSort(SolRef,UN_Comps),
				tt::tt_table(3,"SEL/UN sorted condition set",SolRef),
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	sol::solSetSize(SolRef,N),
	plcCheckUnique(XI,SolRef,SolRef2,1,N,UN_Comps),
				sol::tt_sors(4,"SEL/UN condition set/after",SolRef2),
	!.
plcStartUnique(SolRef,SolRef2,UN_Comps,EqComps) :-
	set::conc([EqComps,UN_Comps],SortComps),
	sol::solSort(SolRef,SortComps),
				tt::tt_table(3,"SEL/UN sorted condition set",SolRef),
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	sol::solSetSize(SolRef,NSol),
	LPred=1,
	SFirst=count::newCounter(LPred), % global for first-solution row (first in equality set)
	% goes through all solutions in the sorted set and looks for the end of each equality set in this
	% solution set. 
	sol::forallsolsorted(SolRef,LPred,LSucc,PSucc),
	   plcUnique(XI,SolRef,SolRef2,LSucc,PSucc,UN_Comps,EqComps,SFirst),
	LSucc=NSol,
	plcUnique(XI,SolRef,SolRef2,LSucc,PSucc,UN_Comps,EqComps,SFirst),
				sol::tt_sors(4,"SEL/UN condition set/after",SolRef2),
	!.
plcUnique(XI,SolRef,SolRef2,LSucc,PSucc,UN_Comps,EqComps,CFirst) :-
	LPred=LSucc-1,
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolCompsEQ(SolRef,PSucc,PPred,EqComps),
	% equal - continue looking for the end of the equality set
	!
;	
	LFirst=CFirst:get(),
	LPred=LSucc-1,
	LFirst=LPred, % equality set has only one member (LPred) and is thus per def unique
	stb::stbGetRowL_P(XI,LPred,PPred),
	sol::solCopyRec(SolRef,PPred,SolRef2),
    CFirst:set(LSucc), 
	!
;	
	% equality set has two or more members
	LFirst=CFirst:get(),
	LPred=LSucc-1,
	plcCheckUnique(XI,SolRef,SolRef2,LFirst,LPred,UN_Comps),
    CFirst:set(LSucc), 
	!.
	
plcCheckUnique(XI,SolRef,SolRef2,N,LLast,UN_Comps) :-
	N>LLast,
	!
;
	N=LLast,
	stb::stbGetRowL_P(XI,N,PN),
	sol::solCopyRec(SolRef,PN,SolRef2),
	!
;
	stb::stbGetRowL_P(XI,N,PN),
	M=N+1,
	stb::stbGetRowL_P(XI,M,PM),
	plcSolCompsEQ(SolRef,PN,PM,UN_Comps),
	% both rows are non-unique skip up to next potentially unique
	plcSkipNonUnique(XI,SolRef,SolRef2,M,LLast,UN_Comps),
	!
;
	M=N+1,
	M=LLast,
	stb::stbGetRowL_P(XI,N,PN),
	sol::solCopyRec(SolRef,PN,SolRef2),
	stb::stbGetRowL_P(XI,M,PM),
	sol::solCopyRec(SolRef,PM,SolRef2),
	!
;
	stb::stbGetRowL_P(XI,N,PN),
	sol::solCopyRec(SolRef,PN,SolRef2),
	Next=N+1,
	plcCheckUnique(XI,SolRef,SolRef2,Next,LLast,UN_Comps),
	!.
plcSkipNonUnique(XI,SolRef,SolRef2,N,LLast,UN_Comps) :-
	N=LLast,
	!
;
	M=N+1,
	M=LLast,
	stb::stbGetRowL_P(XI,N,PN),
	stb::stbGetRowL_P(XI,M,PM),
	plcSolCompsEQ(SolRef,PN,PM,UN_Comps),
	!
;
	M=N+1,
	M=LLast,
	stb::stbGetRowL_P(XI,M,PM),
	sol::solCopyRec(SolRef,PM,SolRef2),
	!
;
	stb::stbGetRowL_P(XI,N,PN),
	M=N+1,
	stb::stbGetRowL_P(XI,M,PM),
	plcSolCompsEQ(SolRef,PN,PM,UN_Comps),
	plcSkipNonUnique(XI,SolRef,SolRef2,M,LLast,UN_Comps),
	!
;	
	M=N+1,
	plcCheckUnique(XI,SolRef,SolRef2,M,LLast,UN_Comps),
	!.
% -----------------------------------------------------------------------------------------------
% plcInterpolate
% -----------------------------------------------------------------------------------------------
class predicates
plcInterpolateStart : (integer,integer,integer,sterm,sterm,sterm,integer,integer,integer,integer_list,integer_list,integer_list,integer_list,sterml) determ (i,i,i,i,i,i,i,i,i,i,i,i,i,i).
plcIP : (integer,integer,integer,integer,chainDB::bt_selector,sterm,sterm,sterm,integer,integer_list,integer_list,integer_list,integer_list,sterml) determ (i,i,i,i,i,i,i,i,i,i,i,i,i,i).
plcIP_Sets : (integer,integer,count,integer,chainDB::bt_selector,integer,integer,integer,sterm,sterm,sterm,integer,integer_list,integer_list,integer_list,integer_list,integer_list,sterml) determ (i,i,i,i,i,i,i,i,i,i,i,i,i,i,i,i,i,i).
plcIP_GetVals : (integer,integer,integer,integer,sterml) determ (i,i,i,i,o).
plcIP_SetVals : (integer,integer,integer,sterml) determ (i,i,i,i).
plcIP_SetFixed : (integer,integer,integer_list,sterml) determ (i,i,i,i).
plcIP_CompX : (integer,integer,integer,integer,integer,integer_list,integer_list,integer_list) determ (i,i,i,i,i,i,i,i).
plcIP_Compute : (integer,integer,integer,integer,sterm,integer,integer_list,integer_list,integer_list,integer_list,sterml) determ.
ipRow : (integer,integer,chainDB::bt_selector,sterm,integer,integer_list,integer_list,integer_list,integer_list,sterml) determ.
extraEnd : (integer,integer,integer,sterm,sterm,integer,integer_list,integer_list,integer_list,integer_list,sterml) determ.
rowBeforeCurrent : (integer,sterm,integer,sterm,integer) determ.
rowAtCurrent : (integer,sterm,integer,integer) determ.
stepUp : (sterm,sterm,sterm) determ (i,i,o).
clauses
plcInterpolate(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,[],CompsU,CompsL,CompsM,CompsD,DefV) :-
% 	no equality components
	sol::solSetSize(SolRef,NSol),
	plcInterpolateStart(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,1,NSol,CompsU,CompsL,CompsM,CompsD,DefV),
	!.
plcInterpolate(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefV) :-
% 	with equality components (which requires multiple interpolation rounds i.e. one for each equality set)
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	sol::solSetSize(SolRef,NSol),
	SetStart=count::newCounter(1),
	% goes through all solutions in the sorted set and look for equality sets
	sol::forallsolsorted(SolRef,1,LPred,PPred),
	   plcIP_Sets(SolRef,SolRef2,SetStart,NSol,XI,LPred,PPred,Open,StartV,EndV,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefV),
	LPred=(NSol-1),
	!.
plcIP_Sets(SolRef,SolRef2,SetStart,NSol,XI,LPred,PPred,Open,StartV,EndV,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefV) :-
	LPred<NSol,
	LNext=LPred+1,
	LNext=NSol,
	stb::stbGetRowL_P(XI,LNext,PNext),
	plcSolCompsEQ(SolRef,PPred,PNext,Eq_Comps),
	% the equality set from SetStart to the last row in the solution
	!,First=SetStart:get(),
	plcInterpolateStart(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,First,NSol,CompsU,CompsL,CompsM,CompsD,DefV),
	!
;	
	LPred<NSol,
	LNext=LPred+1,
	LNext<NSol,
	stb::stbGetRowL_P(XI,LNext,PNext),
	plcSolCompsEQ(SolRef,PPred,PNext,Eq_Comps),
	% the end of the equality set is not yet found: continue
	!
;	
	% the equality set from SetStart to LPred
	!,First=SetStart:get(),
	plcInterpolateStart(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,First,LPred,CompsU,CompsL,CompsM,CompsD,DefV),
	Next=LPred+1,
	SetStart:set(Next),
	!.
% performs the actual interpolations on a set (i.e. an equality set or the total set where no equality sets are used)
% parameters:
% 9	in	first record in query set (equality set)
% 10	in	last record in query set (equality set)
%
plcInterpolateStart(SolRef,SolRef2,Extra,StartV,EndV,Step,IP_Comp,First,Last,CompsU,CompsL,CompsM,CompsD,DefV) :-
	Extra=1, % interpolation only
	!,sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	% determine actual start and end values
	stb::stbGetRowL_P(XI,First,PFirst),
	sol::solCompNo(SolRef,PFirst,IP_Comp,AStartV),
	stb::stbGetRowL_P(XI,Last,PLast),
	sol::solCompNo(SolRef,PLast,IP_Comp,AEndV),
	%
	plcIP(SolRef,SolRef2,First,Last,XI,AStartV,AEndV,Step,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
	!
;
	Extra=2, % extrapolation with start and end
	!,sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	plcTransPar(SolRef,StartV,AStartV),
	plcTransPar(SolRef,EndV,AEndV),
	plcIP(SolRef,SolRef2,First,Last,XI,AStartV,AEndV,Step,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
	!
;
	Extra=4, % end only extrapolation
	!,sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	plcTransPar(SolRef,EndV,AEndV),
	% determine actual start value
	stb::stbGetRowL_P(XI,First,PFirst),
	sol::solCompNo(SolRef,PFirst,IP_Comp,AStartV),
	%
	plcIP(SolRef,SolRef2,First,Last,XI,AStartV,AEndV,Step,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
	!
;
	Extra=3, % start only extrapolation
	!,sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	plcTransPar(SolRef,StartV,AStartV),
	% determine actual end value
	stb::stbGetRowL_P(XI,Last,PLast),
	sol::solCompNo(SolRef,PLast,IP_Comp,AEndV),
	%
	plcIP(SolRef,SolRef2,First,Last,XI,AStartV,AEndV,Step,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
	!.
% performs the actual interpolations on a set of sentences
% parameters:
% 1 in  source set
% 2 in  result set
% 3 in  first sentence in source set
% 4 in  last sentence   do.
% 5 in  sdb-index
% 6 in  start value specified for the result set
% 7 in  end value   do.
% 8 in  step value: str(Duration) if interpolation over xml-dates, else int(Step).
% 9 in  interpolation component
% 10 in equality components
% 11 in upper-value components
% 12  in lower-value    do.
% 13 in mid-value   do.
% 14 in default-value   do.
% 15 in default value
%
plcIP(SolRef,SolRef2,First,Last,XI,StartV,EndV,StepV,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV) :-
    currentVal:=StartV,
    currentRow:=First,
    programControl::repeat,
       ipRow(SolRef,SolRef2,XI,StepV,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
       currentRow>Last,
       stb::stbGetRowL_P(XI,Last,PLast),
       extraEnd(PLast,SolRef,SolRef2,EndV,StepV,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
    !.
    
ipRow(SolRef,SolRef2,XI,StepV,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV) :-
	stb::stbGetRowL_P(XI,currentRow,PRow),
    rowBeforeCurrent(PRow,currentVal,SolRef,StepV,IP_Comp),
    % insert Row
	sol::solComps(SolRef,NComps,_),
	plcIP_GetVals(SolRef,PRow,1,NComps,OrigVals),
	plcIP_SetFixed(SolRef,PRow,CompsD,DefV),
	sol::solCopyRec(SolRef,PRow,SolRef2),
	plcIP_SetVals(SolRef,PRow,1,OrigVals),
	% increment row
	Row=currentRow,
	currentRow:=Row+1,
	!
;
	stb::stbGetRowL_P(XI,currentRow,PRow),
    rowAtCurrent(PRow,currentVal,SolRef,IP_Comp),
    % insert row
	sol::solComps(SolRef,NComps,_),
	plcIP_GetVals(SolRef,PRow,1,NComps,OrigVals),
	plcIP_SetFixed(SolRef,PRow,CompsD,DefV),
	sol::solCopyRec(SolRef,PRow,SolRef2),
	plcIP_SetVals(SolRef,PRow,1,OrigVals),
	% increment row
	Row=currentRow,
	currentRow:=Row+1,
	stepUp(currentVal,StepV,Next),
	currentVal:=Next,
	!
;    
    % generate row for currentV
    Pred=currentRow-1,
	stb::stbGetRowL_PZ(XI,Pred,PPred),
	stb::stbGetRowL_P(XI,currentRow,PSucc),
    plcIP_Compute(SolRef,SolRef2,PPred,PSucc,currentVal,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
	stepUp(currentVal,StepV,Next),
	currentVal:=Next,
    !.
stepUp(str(XD),StepV,Next) :- plcCompXD("+",str(XD),StepV,Next),!.
stepUp(CurrV,StepV,Next) :- plcCompute("+",CurrV,StepV,Next),!.
rowBeforeCurrent(PRow,CurrV,SolRef,StepV,IP_Comp) :-
    StepV=str(Dur),
	Sign=string::substring(Dur,1,1),
	Sign<>"-",
	!,
	% increasing xml-dates
	sol::solCompNo(SolRef,PRow,IP_Comp,Val),
	plcCompXD("<",Val,CurrV,_),
	!
;
    StepV=str(Dur),
	Sign=string::substring(Dur,1,1),
	Sign="-",
	!,
	% decreasing xml-dates
	sol::solCompNo(SolRef,PRow,IP_Comp,Val),
	plcCompXD(">",Val,CurrV,_),
	!
;
	plcCompute(">",StepV,int(0),_),
	% increasing numerics
	sol::solCompNo(SolRef,PRow,IP_Comp,Val),
	plcCompute("<",Val,CurrV,_),
	!
;
	plcCompute("<",StepV,int(0),_),
	% increasing numerics
	sol::solCompNo(SolRef,PRow,IP_Comp,Val),
	plcCompute(">",Val,CurrV,_),
	!.
    
rowAtCurrent(PRow,CurrV,SolRef,IP_Comp) :-
    CurrV=str(_),
    !,
    % xml-date
	sol::solCompNo(SolRef,PRow,IP_Comp,Val),
    plcCompXD("=",Val,CurrV,_),
    !
;
	sol::solCompNo(SolRef,PRow,IP_Comp,Val),
	plcCompute("=",Val,CurrV,_),
    !.
extraEnd(PPred,SolRef,SolRef2,EndV,str(Step),IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV) :-
    plcCompXD(">",currentVal,EndV,_),
    !
;    
    programControl::repeat,
        % generate row for Next
        plcIP_Compute(SolRef,SolRef2,PPred,0,currentVal,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
        % step up
        plcCompXD("+",currentVal,str(Step),Next),
        currentVal:=Next,
        plcCompXD(">",currentVal,EndV,_),
    !.        
extraEnd(PPred,SolRef,SolRef2,EndV,StepV,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV) :-
    plcCompute(">",currentVal,EndV,_),
    !
;    
    programControl::repeat,
        % generate row for Next
        plcIP_Compute(SolRef,SolRef2,PPred,0,currentVal,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV),
        % step up
        plcCompute("+",currentVal,StepV,Next),
        currentVal:=Next,
        plcCompute(">",currentVal,EndV,_),
    !.
    
plcIP_Compute(SolRef,SolRef2,Pred,Succ,CurrV,IP_Comp,CompsU,CompsL,CompsM,CompsD,DefV) :-
	Succ=0,
	sol::solComps(SolRef,NComps,_),
	plcIP_GetVals(SolRef,Pred,1,NComps,OrigVals),
	sol::solCompNoReplace(SolRef,Pred,IP_Comp,CurrV),
	plcIP_SetFixed(SolRef,Pred,CompsD,DefV),
	sol::solCopyRec(SolRef,Pred,SolRef2),
	plcIP_SetVals(SolRef,Pred,1,OrigVals),
	!
;
	Pred=0,
	sol::solComps(SolRef,NComps,_),
	plcIP_GetVals(SolRef,Succ,1,NComps,OrigVals),
	sol::solCompNoReplace(SolRef,Succ,IP_Comp,CurrV),
	plcIP_SetFixed(SolRef,Succ,CompsD,DefV),
	sol::solCopyRec(SolRef,Succ,SolRef2),
	plcIP_SetVals(SolRef,Succ,1,OrigVals),
	!
;
    Succ>0,
    Pred>0,
	sol::solComps(SolRef,NComps,_),
	plcIP_GetVals(SolRef,Succ,1,NComps,OrigVals),
	sol::solCompNoReplace(SolRef,Succ,IP_Comp,CurrV),
	plcIP_CompX(SolRef,Pred,Succ,1,NComps,CompsU,CompsL,CompsM),
	plcIP_SetFixed(SolRef,Succ,CompsD,DefV),
	sol::solCopyRec(SolRef,Succ,SolRef2),
	plcIP_SetVals(SolRef,Succ,1,OrigVals),
	!.
plcIP_CompX(_,_,_,N,Last,_,_,_) :-
	N>Last,
	!.
plcIP_CompX(SolRef,Pred,Succ,N,Last,CompsU,CompsL,CompsM) :-
	set::member(N,CompsL),
	sol::solCompNo(SolRef,Pred,N,V),
	sol::solCompNoReplace(SolRef,Succ,N,V),
	Next=N+1,
	plcIP_CompX(SolRef,Pred,Succ,Next,Last,CompsU,CompsL,CompsM),
	!
;
	set::member(N,CompsM),
	sol::solCompNo(SolRef,Pred,N,Va),
	sol::solCompNo(SolRef,Succ,N,Vb),
	plcCompute("+",Va,Vb,Vc),
	Vc=int(_),
	plcCompute("div",Vc,int(2),V),
	sol::solCompNoReplace(SolRef,Succ,N,V),
	Next=N+1,
	plcIP_CompX(SolRef,Pred,Succ,Next,Last,CompsU,CompsL,CompsM),
	!
;
	set::member(N,CompsM),
	sol::solCompNo(SolRef,Pred,N,Va),
	sol::solCompNo(SolRef,Succ,N,Vb),
	plcCompute("+",Va,Vb,Vc),
	plcCompute("/",Vc,int(2),V),
	sol::solCompNoReplace(SolRef,Succ,N,V),
	Next=N+1,
	plcIP_CompX(SolRef,Pred,Succ,Next,Last,CompsU,CompsL,CompsM),
	!
;
	Next=N+1,
	plcIP_CompX(SolRef,Pred,Succ,Next,Last,CompsU,CompsL,CompsM),
	!
;
	dlgIF::feil_pie("plcIP_CompX",[],[SolRef,Pred,Succ,N,Last],nill),!,fail.	
	
plcIP_GetVals(_,_,N,Last,[]) :-
	N>Last,
	!.
plcIP_GetVals(SolRef,SolNo,N,Last,[V|OrigVals]) :-
	sol::solCompNo(SolRef,SolNo,N,V),
	Next=N+1,
	plcIP_GetVals(SolRef,SolNo,Next,Last,OrigVals),
	!.
plcIP_SetVals(_,_,_,[]) :-
	!.
plcIP_SetVals(SolRef,SolNo,N,[V|OrigVals]) :-
	sol::solCompNoReplace(SolRef,SolNo,N,V),
	Next=N+1,
	plcIP_SetVals(SolRef,SolNo,Next,OrigVals),
	!.
plcIP_SetFixed(_,_,[],[]) :-
	!.
plcIP_SetFixed(SolRef,SolNo,[Comp|Comps],[Val|Vals]) :-
	sol::solCompNoReplace(SolRef,SolNo,Comp,Val),
	plcIP_SetFixed(SolRef,SolNo,Comps,Vals),
	!.
% -----------------------------------------------------------------------------------------------
% plcMM
% -----------------------------------------------------------------------------------------------
class predicates
plcSelCheck : (string,count,chainDB::bt_selector,integer,integer,integer,integer_list) determ.
plcMM_X : (count,integer,integer_list,string,integer) determ (i,i,i,i,i).	
clauses
%
% modifies the solution set by replacing solutions with the same value for the equality-components
% with one solution which is the solution with the min/max value.
%
% parameters:
% 1	in	sol.ref.
% 2	in	equality component no's
% 3	in	p3_rMin/p3_rMax
%
% Note: The sol.set must be sorted according to par#2 and par#3 before this predicate is called.
%
plcMM(SolRef,EqAs,MM,NSol) :-
	sol::solFirstL(SolRef,First),
	CPred=count::newCounter(First),
	plcMM_X(CPred,SolRef,EqAs,MM,NSol),
	!.
	
plcMM_X(CPred,SolRef,EqAs,MM,NSol) :-
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	Start=CPred:get()+1, 
	sol::forallsolsorted(SolRef,Start,LSucc,PSucc),
	   plcSelCheck(MM,CPred,XI,SolRef,LSucc,PSucc,EqAs),
	   LSucc=NSol, % loop termination
	!.
% checks if two solutions (Pred and Succ) are equal according to the equality components, and then if equal, 
% generates
%
plcSelCheck("p3_rMin",CPred,XI,SolRef,LSucc,PSucc,EqAs) :-
	LPred=CPred:get(),
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolCompsEQ(SolRef,PSucc,PPred,EqAs),
	% Pred and Succ are equal: Delete Succ
	stb::stbSortDelRow(SolRef,1,LSucc),
	sol::solDel(SolRef,PSucc),
	!
;	
	% Pred and Succ are not equal
	CPred:set(LSucc),
	!.
plcSelCheck("p3_rMax",CPred,XI,SolRef,LSucc,PSucc,EqAs) :-
	LPred=CPred:get(),
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolCompsEQ(SolRef,PSucc,PPred,EqAs),
	% Pred and Succ are equal: Delete Pred
	stb::stbSortDelRow(SolRef,1,LPred),
	sol::solDel(SolRef,PPred),
	CPred:set(LSucc),
	!
;	
	% Pred and Succ are not equal
	CPred:set(LSucc),
	!.
% -----------------------------------------------------------------------------------------------
% selectionProcedure_Query
% -----------------------------------------------------------------------------------------------
selectionProcedure_Query(Proc,Q,SolRef,SolRef2) :-
	set::member(Proc,["p3_iRip","p3_iRipxd","p3_iRun","p3_iRrnk","p3_iRcor"]),
	Query=termDomain::fromTermStringIndirect(Q),
			tt::tt_term(3,"Query",Query),
	proc::pie3_IF(Query,SolRef),
	% create a second empty set for insertion of original and interpolated/ranked/correlated records
	% solution ser header data will be updated upon actual insertion of solutions
	sol::solSetNew(nill,SolRef2),
	!
;
	set::member(Proc,["p3_iRmin","p3_iRmax","p3_iRacc"]), 	
	Query=termDomain::fromTermStringIndirect(Q),
			tt::tt_term(3,"Query",Query),
	proc::pie3_IF(Query,SolRef),
	SolRef2=0,
	!.
% -----------------------------------------------------------------------------------------------
% plcSolCompsEQ
% -----------------------------------------------------------------------------------------------
class predicates
plcSolCompEQ : (sterm,sterm) determ.
clauses
% succeeds if the two solutions are equal with respect to the given
% components, otherwise fails.
%
plcSolCompsEQ(_,_,_,[]) :- 
	!.
plcSolCompsEQ(SolRef,N1,N2,[C|Comps]) :-
	sol::solCompNo(SolRef,N1,C,V1),
	sol::solCompNo(SolRef,N2,C,V2),
	plcSolCompEQ(V1,V2),
	plcSolCompsEQ(SolRef,N1,N2,Comps),
	!.
	
plcSolVarsEQ(_,_,_,[]) :- 
	!.
plcSolVarsEQ(SolRef,N1,N2,[C|Comps]) :-
	sol::solCompVar(SolRef,N1,C,V1),
	sol::solCompVar(SolRef,N2,C,V2),
	plcSolCompEQ(V1,V2),
	plcSolVarsEQ(SolRef,N1,N2,Comps),
	!.
	
plcSolCompEQ(S,T) :- 
	S=cmp("#4",_),
	dlgIF::feil_pie("plcSolCompEQ",[],[],cmp("",[S,T])),
	!
;	
	T=cmp("#4",_),
	dlgIF::feil_pie("plcSolCompEQ",[],[],cmp("",[S,T])),
	!.
plcSolCompEQ(int(S1),int(S2)) :- 
	S1=S2,
	!.	
plcSolCompEQ(fix(S1),fix(S2)) :- 
	S1=S2,
	!.	
plcSolCompEQ(int(S1),fix(S2)) :- 
	S1=S2,
	!.	
plcSolCompEQ(fix(S1),int(S2)) :- 
	S1=S2,
	!.	
plcSolCompEQ(str(S1),str(S2)) :- 
	S1=S2,
	!.	
plcSolCompEQ(atom(S1),atom(S2)) :- 
	S1=S2,!.	
% ----------------------------------------------------------------------------------------------
% plcSortComps
% ----------------------------------------------------------------------------------------------
class predicates
plcSortCompsX : (string,string_list_list) determ (i,i).
plcSortCompsAdd : (string_list,string,string_list) procedure (i,i,o).
clauses
plcSortComps([],[],[C|_],[C]) :-
	% dummy sorting based on first component 
	!. 
plcSortComps(EqComps,[],_,EqComps) :-
	!.
plcSortComps(EqComps,TimerComps,_,SortComps) :-
	TimerComps=[Pair|Timers],
	Pair=[_,Timer],
	plcSortCompsX(Timer,Timers),
	plcSortCompsAdd(EqComps,Timer,SortComps),
	!.
plcSortCompsX(_,[]) :-
	!.
plcSortCompsX(Timer,[P|Ts]) :-
	P=[_,Tm],
	Timer=Tm,
	plcSortCompsX(Timer,Ts),
	!
;
	dlgIF::feil_pie("plcSortCompsX",["Detected set-rule using more than timer component. Refer to trace file."],[],nill),!,fail.
	
plcSortCompsAdd(EqComps,Timer,EqComps) :-	
	set::member(Timer,EqComps),
	!.
plcSortCompsAdd(EqComps,Timer,SortComps) :-
	set::conc([EqComps,[Timer]],SortComps),
	!.
% ----------------------------------------------------------------------------------------------
% plcStartIP
% ----------------------------------------------------------------------------------------------
plcStartIP(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefV) :-
	set::conc([Eq_Comps,[IP_Comp]],SortComps),
	sol::solSort(SolRef,SortComps),!,
				tt::tt_table(3,"SEL/IP sorted condition set",SolRef),
	plcInterpolate(SolRef,SolRef2,Open,StartV,EndV,Step,IP_Comp,Eq_Comps,CompsU,CompsL,CompsM,CompsD,DefV),
				tt::tt_table(4,"SEL/IP condition set/after",SolRef2),
	!.
% -----------------------------------------------------------------------------------------------
% plcStatProcGen
% -----------------------------------------------------------------------------------------------
class predicates
plcStatCheck : (integer,count,chainDB::bt_selector,integer,integer,integer,string_list,string_list,count,string_list_list) determ.
plcStatCompNos : (string_list,string_list_list,string_list,string_list_list) determ (i,i,o,o).
clauses
%
% modifies the solution set by replacing solutions with the same value for the equality-components
% with one solution which in place of the numeric components contains multivalue components with
% SUM, MIN and MAX values.
%
% parameters:
% 1	in	1=only COUNT-proc; 0=else
% 2	in	sol.ref.
% 3	in	equality component no's
% 7	in	timers: a list of solution component no pairs where the second component is a timer for the first
% Note: The sol.set must be sorted according to par#3 before this predicate is called.
%
plcStatProcGen(CountOnly,SolRef,EqAs,NSol,RelComps,ProcComps,Timers) :-
    NSol>1,
	plcStatCompNos(RelComps,ProcComps,StatComps,ProcsUsed),
				tt::tt_strings(3,"Procedure-argument components",StatComps),
				tt::tt_stringss(3,"Procedures used",ProcsUsed),
    SPred=count::newCounter(1),
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	LPred=SPred:get(),
	SFirst=count::newCounter(LPred),
	% goes through all solutions in the sorted set and looks for the end of each equality set in this
	% solution set. computes one statistical value #12-tuple for each equality set as soon as the end of
	% the set is determined. all computations are local to one equality set. 
	sol::forallsolsorted(SolRef,LPred,LSucc,PSucc),
        plcStatCheck(CountOnly,SPred,XI,SolRef,LSucc,PSucc,EqAs,StatComps,SFirst,Timers),
        LSucc=NSol,
	% stat computations for the last equality set in this sentence derivation
	LPredLast=SPred:get(),
	LFirstLast=SFirst:get(),
	processEqualitySet(CountOnly,SolRef,XI,LFirstLast,LPredLast,StatComps,Timers),
	!
;
    NSol=1,
	plcStatCompNos(RelComps,ProcComps,StatComps,ProcsUsed),
				tt::tt_strings(3,"Procedure-argument components",StatComps),
				tt::tt_stringss(3,"Procedures used",ProcsUsed),
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	processEqualitySet(CountOnly,SolRef,XI,1,1,StatComps,Timers),
	!.
% checks if two solutions are equal according to the equality components, and then 
% if equal:     updates SUM/MAX/MIN in solution PSucc and PPred and then marks PPred as deleted.
% if not equal: computes and adds AVG/MEAN/SDV/N to the completed equality set and continues 
%               with the next equality set.
%
plcStatCheck(CountOnly,CPred,XI,SolRef,LSucc,PSucc,EqAs,StatComps,CFirst,Timers) :-
	EqAs=[], % all solutions are considered unequal
	CPred:set(LSucc),
	!
;
	not(EqAs=[]),
	LPred=CPred:get(),
	stb::stbGetRowL_P(XI,LPred,PPred),
	plcSolVarsEQ(SolRef,PSucc,PPred,EqAs),
	% Pred and Succ are equal
	CPred:set(LSucc),
	!
;	
	% Pred and Succ are NOT equal 
	% CFirst to CPred forms an equality set
	LPred=CPred:get(),
	LFirst=CFirst:get(),
	processEqualitySet(CountOnly,SolRef,XI,LFirst,LPred,StatComps,Timers),
	% succ is the start of a new equality set
	CPred:set(LSucc),
	CFirst:set(LSucc), 
	!.
% parameters:
% 1	in	relevant components 
% 2	in	component is procedure argument (list of procs where argument) - corresponding to par.2
% 3	out	list of component where #12-type record must be generated
% 5	out	list of procs where argument - corresponding to par.4
%
plcStatCompNos([],[],[],[]) :-
	!.
plcStatCompNos([_|RelComps],[[]|ProcComps],StatComps,ProcsUsed) :-
	plcStatCompNos(RelComps,ProcComps,StatComps,ProcsUsed),
	!.
plcStatCompNos([RelComp|RelComps],[Procs|ProcComps],[RelComp|StatComps],[Procs|ProcsUsed]) :-
	plcStatCompNos(RelComps,ProcComps,StatComps,ProcsUsed),
	!.
% ----------------------------------------------------------------------------------------------
% plcTransPar
% ----------------------------------------------------------------------------------------------
plcTransPar(SolRef,FVal,AVal) :-
	FVal=var(V),
	vars::varComps(V,_,_,_),
	sol::solCompVar(SolRef,1,V,AVal),
	!
;
	AVal=FVal,
	!.
% ----------------------------------------------------------------------------------------------
% plcUN_Pars
% ----------------------------------------------------------------------------------------------
plcUN_Pars(SolRef,DE_Vals,EqComps,UN_Comps) :-
	plcGetCompNos("=",SolRef,DE_Vals,EqComps,_),
	plcGetCompNos("p3_rUn",SolRef,DE_Vals,UN_Comps,_),
	set::size(UN_Comps,N),
	N>=1,
	!
;
	dlgIF::feil_pie("plcUN_Pars",["Cannot find call to unique procedure"],[],nill),!,fail.
% ----------------------------------------------------------------------------------------------
% p3_fConc
% -----------------------------------------------------------------------------------------------
p3_fConc("",[]) :- 
	!.
p3_fConc(V,[H|T]) :- 
	p3_fConc(V1,T),
	V=string::concat(H,V1),
	!.
% -----------------------------------------------------------------------------------------------
% p3_fUpp/fLow
% -----------------------------------------------------------------------------------------------
p3_fUpp(Su,S) :- Su=string::toUpperCase(S),!.
p3_fLow(Sl,S) :- Sl=string::toLowerCase(S),!.
% ----------------------------------------------------------------------------------------------
% p3_fSubstr
% -----------------------------------------------------------------------------------------------
p3_fSubstr(T,S,P,L) :-
	P>=1,
	N=string::length(S),
	E=P+L-1,
	E<=N,
	Pa=P-1,
	T=string::substring(S,Pa,L),	
	!
;
	T="",
	!.
% -----------------------------------------------------------------------------------------------
% p3_fLT_I; p3_fGT_I
% -----------------------------------------------------------------------------------------------
class predicates
p3_fLT_IX : (globalRefDomains::refint,globalRefDomains::refint,globalRefDomains::refints) determ (o,i,i).
p3_fGT_IX : (globalRefDomains::refint,globalRefDomains::refint,globalRefDomains::refints) determ (o,i,i).
p3_fLT_XDX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fGT_XDX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fLT_XTX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fGT_XTX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fLT_XDTX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fGT_XDTX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fLT_XRX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
p3_fGT_XRX : (globalRefDomains::refstr,globalRefDomains::refstr,globalRefDomains::refstrs) determ (o,i,i).
clauses
p3_fLT_I(V,[H|T]) :- 
	p3_fLT_IX(A,H,T),
	V=A,!.
p3_fLT_IX(A,A,[]) :- !.
p3_fLT_IX(A,B,[H|T]) :-
	B<=H,
	p3_fLT_IX(A,B,T),!
;
	p3_fLT_IX(A,H,T),!.	
p3_fGT_I(V,[H|T]) :- 
	p3_fGT_IX(A,H,T),
	V=A,!.
p3_fGT_IX(A,A,[]) :- !.
p3_fGT_IX(A,B,[H|T]) :-
	B>=H,
	p3_fGT_IX(A,B,T),!
;
	p3_fGT_IX(A,H,T),!.	
p3_fLT_XD(V,[H|T]) :- 
	p3_fLT_XDX(A,H,T),
	V=A,!.
p3_fLT_XDX(A,A,[]) :- !.
p3_fLT_XDX(A,B,[H|T]) :-
	xmlGeneric::xmlDateLess(B,H),
	p3_fLT_XDX(A,B,T),!
;
	p3_fLT_XDX(A,H,T),!.	
p3_fGT_XD(V,[H|T]) :- 
	p3_fGT_XDX(A,H,T),
	V=A,!.
p3_fGT_XDX(A,A,[]) :- !.
p3_fGT_XDX(A,B,[H|T]) :-
	not(xmlGeneric::xmlDateLess(B,H)),
	p3_fGT_XDX(A,B,T),!
;
	p3_fGT_XDX(A,H,T),!.	
p3_fLT_XDT(V,[H|T]) :- 
	p3_fLT_XDTX(A,H,T),
	V=A,!.
p3_fLT_XDTX(A,A,[]) :- !.
p3_fLT_XDTX(A,B,[H|T]) :-
	xmlGeneric::xmlDatetimeLess(B,H),
	p3_fLT_XDTX(A,B,T),!
;
	p3_fLT_XDTX(A,H,T),!.	
p3_fGT_XDT(V,[H|T]) :- 
	p3_fGT_XDTX(A,H,T),
	V=A,!.
p3_fGT_XDTX(A,A,[]) :- !.
p3_fGT_XDTX(A,B,[H|T]) :-
	not(xmlGeneric::xmlDatetimeLess(B,H)),
	p3_fGT_XDTX(A,B,T),!
;
	p3_fGT_XDTX(A,H,T),!.	
p3_fLT_XT(V,[H|T]) :- 
	p3_fLT_XTX(A,H,T),
	V=A,!.
p3_fLT_XTX(A,A,[]) :- !.
p3_fLT_XTX(A,B,[H|T]) :-
	xmlGeneric::xmlTimeLess(B,H),
	p3_fLT_XTX(A,B,T),!
;
	p3_fLT_XTX(A,H,T),!.	
p3_fGT_XT(V,[H|T]) :- 
	p3_fGT_XTX(A,H,T),
	V=A,!.
p3_fGT_XTX(A,A,[]) :- !.
p3_fGT_XTX(A,B,[H|T]) :-
	not(xmlGeneric::xmlTimeLess(B,H)),
	p3_fGT_XTX(A,B,T),!
;
	p3_fGT_XTX(A,H,T),!.	
p3_fLT_XR(V,[H|T]) :- 
	p3_fLT_XRX(A,H,T),
	V=A,!.
p3_fLT_XRX(A,A,[]) :- !.
p3_fLT_XRX(A,B,[H|T]) :-
	xmlGeneric::xmlDurationLess(B,H),
	p3_fLT_XRX(A,B,T),!
;
	p3_fLT_XRX(A,H,T),!.	
p3_fGT_XR(V,[H|T]) :- 
	p3_fGT_XRX(A,H,T),
	V=A,!.
p3_fGT_XRX(A,A,[]) :- !.
p3_fGT_XRX(A,B,[H|T]) :-
	not(xmlGeneric::xmlDurationLess(B,H)),
	p3_fGT_XRX(A,B,T),!
;
	p3_fGT_XRX(A,H,T),!.	
% ----------------------------------------------------------------------------------------------
% p3_fMin/Max
% ----------------------------------------------------------------------------------------------
class predicates
p3_fMaxX : (globalRefDomains::refreal,globalRefDomains::refreal,globalRefDomains::refreals) determ (o,i,i).
p3_fMinX : (globalRefDomains::refreal,globalRefDomains::refreal,globalRefDomains::refreals) determ (o,i,i).
clauses
p3_fMax(M,[H|T]) :-
	p3_fMaxX(M,H,T),
	!
;
	M=H,
	!.	
p3_fMaxX(M,M,[]) :-
	!.
p3_fMaxX(M,N,[H|T]) :-
	N>H,
	p3_fMaxX(M,N,T),
	!
;
	p3_fMaxX(M,H,T),
	!.
			
p3_fMin(M,[H|T]) :-
	p3_fMinX(M,H,T),
	!
;
	M=H,
	!.	
p3_fMinX(M,M,[]) :-
	!.
p3_fMinX(M,N,[H|T]) :-
	N<H,
	p3_fMinX(M,N,T),
	!
;
	p3_fMinX(M,H,T),
	!.
% ----------------------------------------------------------------------------------------------
% p3_fIxIN
% ----------------------------------------------------------------------------------------------
p3_fIxIN(I,I,[V|_],V) :-
	!.
p3_fIxIN(I,X,[_|T],V) :-
	N=X+1,
	p3_fIxIN(I,N,T,V),
	!.
% ----------------------------------------------------------------------------------------------
% p3_fSeq_D;DF;T
% ----------------------------------------------------------------------------------------------
p3_fSeq_D(I,Start,Stop,_) :- 
	I=Start,
	xmlGeneric::xmlDateLessOrEqual(Start,Stop).
p3_fSeq_D(I,Start,Stop,Step) :- 
	xmlGeneric::xmlDateLess(Start,Stop),
	xmlGeneric::xmlDateAdd(Start,Step,Next),
	p3_fSeq_D(I,Next,Stop,Step).
p3_fSeq_T(I,Start,Stop,_) :- 
	I=Start,
	xmlGeneric::xmlTimeLessOrEqual(Start,Stop).
p3_fSeq_T(I,Start,Stop,Step) :- 
	xmlGeneric::xmlTimeLess(Start,Stop),
	xmlGeneric::xmlTimeAdd(Start,Step,Next),
	p3_fSeq_T(I,Next,Stop,Step).
p3_fSeq_DT(I,Start,Stop,_) :- 
	I=Start,
	xmlGeneric::xmlDatetimeLessOrEqual(Start,Stop).
p3_fSeq_DT(I,Start,Stop,Step) :- 
	xmlGeneric::xmlDatetimeLess(Start,Stop),
	xmlGeneric::xmlDatetimeAdd(Start,Step,Next),
	p3_fSeq_DT(I,Next,Stop,Step).
% ----------------------------------------------------------------------------------------------
% p3_fSeq_I;N
% ----------------------------------------------------------------------------------------------
p3_fSeq_I(Start,Start,Stop,_) :- 
	Start<=Stop.
p3_fSeq_I(I,Start,Stop,Step) :- 
	Start<Stop, 
	Next=Start+Step, 
	p3_fSeq_I(I,Next,Stop,Step).
p3_fSeq_N(Start,Start,Stop,_) :- 
	Start<=Stop.
p3_fSeq_N(I,Start,Stop,Step) :- 
	Start<Stop, 
	Next=Start+Step, 
	p3_fSeq_N(I,Next,Stop,Step).
end implement piex
