/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class pop
open core

/* db independent */

predicates
classInfo : core::classInfo.

getAnno : () -> string_list. % format NODECLASSif{NODENAMEif
getAnnoNL : () -> string_list. % format NODECLASSnl: NODENAMEnl

getCRs : () -> string_list.
getCRs : (string CR_Type) -> string_list.
getCRsNL : () -> string_list.
getCRsNL : (string CR_Type) -> string_list.
getCRsDomNL : () -> string_list determ. % RULENAME_NL :: DOMAIN_NL
getCRsDomNL : (string RuleType) -> string_list determ. % RULENAME_NL :: DOMAIN_NL

getChains : () -> string_list procedure. % all chains incl. external
getChainsNL_WithKB_File : () -> string_list procedure.
getChainsExt : (integer Rw) -> string_list procedure.
getChainsExtDB : (chainDB,integer Rw) -> string_list procedure.
getChainsExtAccessNL : () ->string_list determ. % chains are prefixed with DB-id and "READ: " or "WRITE: " e.g. "B READ: ..."
getChainsPub : (integer Rw) -> string_list procedure.
getChainsPubDB : (chainDB,integer Rw) -> string_list procedure.
getChainsPubDB_AccessNL : (chainDB) -> string_list procedure.% chains are prefixed with "READ: " or "WRITE: "
getDBs : () -> string_list.
getDB_Infos : () -> string_list determ.
getIdentifiers : (string Language,integer Synonyms) -> string_list.
getIdentifiers : (string Language,integer Synonyms,string_list Context) -> string_list.
getNodes : () -> string_list determ.
getNodesNL : () -> string_list determ.
getRealms : () -> string_list determ.
getSM : (string SM_Type,string_list Context) -> string_list. % SM-types are p,e,f,g,h,a,b
getSM : (string SM_Type) -> string_list.
getSM_NL : (string SM_Type,string_list Context) -> string_list.
getSM_NL : (string SM_Type) -> string_list.
getSM_All : () -> termSet.	% termSet members have format cmp("",[str(Type),str(Name),str(Segment)])
getSM_All : (string_list Context) -> termSet.	
getSegments : () -> string_list.
getSRs : (integer InclSusp) -> string_list determ.
getSentenceSTs : () -> string_list determ. % STs where sentences actually exist
getSentenceSTs : (string_list Context) -> string_list determ. 
getSentenceSTs : (string SG,string_list Context) -> string_list determ.
getRuleSTs : () -> string_list determ.  % STs concluded by rules
getRuleSTs : (string_list Context) -> string_list determ.  
getSTs : () -> string_list determ. % all STs
getSTs : (string_list Context) -> string_list determ.
getSTs : (string SG,string_list Context) -> string_list determ.

getKB_NameInfo : (string Language,integer Synonyms,string_list Context) -> string_list.
getNLs : (string Language,integer Synonyms) -> string_list.
getNLs : (string Language,integer Synonyms,string_list Context) -> string_list.
getClassNLs : (string Clas,string Language,integer Synonyms,string_list Context) -> string_list.
getTerminology : (string Language,integer Synonyms) -> string_list.
getTerminology : (string Language,integer Synonyms,string_list Context) -> string_list.
getTerminologies : () -> string_list.
getSyntaxClassesNL : (string,string_list,string_list) procedure (i,o,o).    

getUnaryPreds : () -> string_list.
getUnaryPreds : (string_list Context) -> string_list.
getBinaryPreds : () -> string_list.
getBinaryPreds : (string_list Context) -> string_list.

inContext : (string KBname,string SM_Type,string_list Context) determ.
filterSTs : (string_list,string_list,string_list) determ (i,i,o).

getStTablesNl : () -> string_list.

getQueries : (string Lang) -> string_list. % % KB-queries as a list where each element is a query: ID||Lang||Name||Format||Query||Menu
getMenus : (string Lang) -> string_list. % % KB-query menus as a list where each element is a query: ID||Lang||Name||Menu
getParameters : (string Lang) -> string_list. % % KB-query parameter as a list where each element is a query: Name||Lang||Domain||Title||Alt;;Alt;;...;;Alt
end class pop