/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement sentence
open core,termDomain,globalDomains

constants
className = "com/rudstrand/sentence/sentence".
classVersion = "1.0".

class predicates
getArgs : (string_list,string_list) determ (i,o).
fetchRec : (dbLoc,integer RT,integer Card,string_list DEske,string_list Vals,string_list Args,string RealmInfo,string Address) determ (i,i,i,i,o,o,o,o).
kbSentence : (dbLoc,integer,string,integer,string,sterm) determ (i,o,o,o,o,o).
makeRows : (string_list,string_list,string_list,string_list,string_list) determ (i,i,i,i,o).
makeRowsNew : (string_list,string_list,string_list,string_list) determ (i,i,i,o).
makeVals : (string_list,sterml,string_list) determ (i,i,o).
tbwTRR : (integer,integer,integer,integer,integer) procedure (i,i,i,i,o).

clauses
classInfo(className, classVersion).
% ---------------------------------------------------------------------------------------------------------------
% openWin
% ---------------------------------------------------------------------------------------------------------------
% opens a sentence window for a new sentence
%
openWin(STk,Cascade) :- 
    W=guix::getWinOfClas(1),
    ColTitles=["Argument","Data Element","Domain","Value"],
    ReadOnly=[1,1,1,0],
    Widths=[150,200,100,200],
    Aligns=[-1,-1,0,0],
    sx::sxUnpack(STk,'|',STL),
    getArgs(STL,Args),
    dbBase::kbST_DEs(STk,DEske),
    dbBase::nlSing(STk,ST),
    set::size(DEske,Nd),
    NRows=Nd+2,
    dbBase::nlSings(DEske,DEs),
    dbBase::getDomainsNL(DEske,Doms),
    set::conc([Doms,["-","-"]],Domsx),
    set::conc([DEs,["$DAT","-"]],DEsx),
    makeRowsNew(Args,DEsx,Domsx,Rows),
    Col4=globalVars::get_i("col_str"),
    Col1=globalVars::get_i("col_shead"),
    Colors=[Col1,Col1,Col1,Col4],
    ted::makeDataOfPackedStrings(Rows,Colors,Data),
    Wt=ted::createTableWin(W,ST,NRows,ReadOnly,ColTitles,Widths,Aligns,Data,["Save New"],-1,tedP3::ted_window_eh,Cascade),
    % modify win_db entry to include ST
    guix::getWinAll(_,_,Wt,_,_,No),
    guix::setWin(201,ST,Wt,0,0,No),
    !.
    
openWin(SolRef,TabNo,Cascade) :- 
	stb::stbH_Get(SolRef,TabNo,_,_,STk,_,_,_),
    W=guix::getWinOfClas(1),
    ColTitles=["Argument","Data Element","Domain","Value"],
    ReadOnly=[1,1,1,0],
    Widths=[150,200,100,200],
    Aligns=[-1,-1,0,0],
    sx::sxUnpack(STk,'|',STL),
    getArgs(STL,Args),
    dbBase::kbST_DEs(STk,DEske),
    dbBase::nlSing(STk,ST),
    set::size(DEske,Nd),
    NRows=Nd+2,
    dbBase::nlSings(DEske,DEs),
    dbBase::getDomainsNL(DEske,Doms),
    set::conc([Doms,["-","-"]],Domsx),
    set::conc([DEs,["$DAT","-"]],DEsx),
    makeRowsNew(Args,DEsx,Domsx,Rows),
    Col4=globalVars::get_i("col_str"),
    Col1=globalVars::get_i("col_shead"),
    Colors=[Col1,Col1,Col1,Col4],
    ted::makeDataOfPackedStrings(Rows,Colors,Data),
    Wt=ted::createTableWin(W,ST,NRows,ReadOnly,ColTitles,Widths,Aligns,Data,["Save New"],-1,tedP3::ted_window_eh,Cascade),
    % modify win_db entry to include ST
    guix::getWinAll(_,_,Wt,_,_,No),
    guix::setWin(201,ST,Wt,SolRef,TabNo,No),
    !.
    
%  returns the list of NL values and argument names corresponding to the DEs
%
getArgs([P,E1,E2],Args) :-
	dbBase::kbPredDEs(P,PDEs,_),
    dbBase::kbEntityDEs(E1,E1DEs,_),
    dbBase::kbEntityDEs(E2,E2DEs,_),
    dbBase::nlSing(P,Pn),
    dbBase::nlSing(E1,E1n),
    dbBase::nlSing(E2,E2n),
    set::size(PDEs,Np),
    set::size(E1DEs,Ne1),
    set::size(E2DEs,Ne2),
    set::initialize(Np,Pn,Lp),
    set::initialize(Ne1,E1n,Le1),
    set::initialize(Ne2,E2n,Le2),
    set::conc([Le1,Le2,Lp,["REALM","ADDRESS"]],Args),
	!.
getArgs([P,E1],Args) :-
	dbBase::kbPredDEs(P,PDEs,_),
    dbBase::kbEntityDEs(E1,E1DEs,_),
    dbBase::nlSing(P,Pn),
    dbBase::nlSing(E1,E1n),
    set::size(PDEs,Np),
    set::size(E1DEs,Ne1),
    set::initialize(Np,Pn,Lp),
    set::initialize(Ne1,E1n,Le1),
    set::conc([Le1,Lp,["REALM","ADDRESS"]],Args),
	!.
% ---------------------------------------------------------------------------------------------------------------
% display
% ---------------------------------------------------------------------------------------------------------------
% creates a sentence window for an existing sentence
%
displayRef(Loc) :- 
    kbSentence(Loc,RT,STk,Card,_,_),
    W=guix::getWinOfClas(1),
    ColTitles=["Argument","Data Element","Domain","Value"],
    ReadOnly=[1,1,1,0],
    Widths=[150,200,100,200],
    Aligns=[-1,-1,0,0],
    dbBase::kbST_DEs(STk,DEske),
    fetchRec(Loc,RT,Card,DEske,Vals,Args,Rlm,Add),
    dbBase::nlSing(STk,ST),
    set::size(DEske,Nd),
    NRows=Nd+2,
    dbBase::nlSings(DEske,DEs),
    dbBase::getDomainsNL(DEske,Doms),
    set::conc([Doms,["-","-"]],Domsx),
    set::conc([DEs,[Rlm,Add]],DEsx),
    makeRows(Args,DEsx,Domsx,Vals,Rows),
    Col4=globalVars::get_i("col_str"),
    Col1=globalVars::get_i("col_shead"),
    Colors=[Col1,Col1,Col1,Col4],
    ted::makeDataOfPackedStrings(Rows,Colors,Data),
    Wt=ted::createTableWin(W,ST,NRows,ReadOnly,ColTitles,Widths,Aligns,Data,["Save New","Update","Delete","Next","Previous"],-1,tedP3::ted_window_eh,-1),
    % modify win_db entry to include ST
    guix::getWinAll(_,_,Wt,_,_,No),
    guix::setWin(201,ST,Wt,0,0,No),
    !.

displayRow(SolRef,TabNo,Row) :- 
    fetchRow(SolRef,TabNo,Row,STk,Card,Loc,RT),
    W=guix::getWinOfClas(1),
    ColTitles=["Argument","Data Element","Domain","Value"],
    ReadOnly=[1,1,1,0],
    Widths=[150,200,100,200],
    Aligns=[-1,-1,0,0],
    dbBase::kbST_DEs(STk,DEske),
    fetchRec(Loc,RT,Card,DEske,Vals,Args,Rlm,Add),
    dbBase::nlSing(STk,ST),
    set::size(DEske,Nd),
    NRows=Nd+2,
    dbBase::nlSings(DEske,DEs),
    dbBase::getDomainsNL(DEske,Doms),
    set::conc([Doms,["-","-"]],Domsx),
    set::conc([DEs,[Rlm,Add]],DEsx),
    makeRows(Args,DEsx,Domsx,Vals,Rows),
    Col4=globalVars::get_i("col_str"),
    Col1=globalVars::get_i("col_shead"),
    Colors=[Col1,Col1,Col1,Col4],
    ted::makeDataOfPackedStrings(Rows,Colors,Data),
    Wt=ted::createTableWin(W,ST,NRows,ReadOnly,ColTitles,Widths,Aligns,Data,["Save New","Update","Delete","Next","Previous"],-1,tedP3::ted_window_eh,-1),
    % modify win_db entry to include ST
    guix::getWinAll(_,_,Wt,_,_,No),
    guix::setWin(201,ST,Wt,SolRef,TabNo,No),
    !.
    
fetchRow(SolRef,TabNo,Row,ST,Card,Loc,RT) :-
	stb::stbH_Get(SolRef,TabNo,_,_,ST,Sorted,_,_),
	sx::sxUnpack(ST,'|',L),
	set::size(L,N),
	Card=N-1,
	tbwTRR(SolRef,TabNo,Sorted,Row,PRow),
	stb::stbRef(SolRef,TabNo,PRow,Loc),
    dbBase::getRecord(Loc,RT,_,_,_,_,_,_,_,_,_,_),
    !.

%  returns the list of NL values and argument names corresponding to the DEs
%
fetchRec(Loc,RT,Card,DEs,Vals,Args,Realm,Add) :-
    Card=2,
    dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,Term,_),
	Term=cmp(P,[cmp(E1,Vs1),cmp(E2,Vs2)|PVs]),
	dbBase::kbPredDEs(P,PDEs,_),
    dbBase::kbEntityDEs(E1,E1DEs,_),
    dbBase::kbEntityDEs(E2,E2DEs,_),
    dbBase::nlSing(P,Pn),
    dbBase::nlSing(E1,E1n),
    dbBase::nlSing(E2,E2n),
    set::size(PDEs,Np),
    set::size(E1DEs,Ne1),
    set::size(E2DEs,Ne2),
    set::initialize(Np,Pn,Lp),
    set::initialize(Ne1,E1n,Le1),
    set::initialize(Ne2,E2n,Le2),
    set::conc([Le1,Le2,Lp,["REALM","ADDRESS"]],Args),
	set::conc([Vs1,Vs2,PVs],Vs),
	makeVals(DEs,Vs,Vals2),
	SRef=dbBase::dbRef(Loc),
	set::setGet(["DERIVED","INPUT"],RT,Typ),
	Add=string::concat("[",SRef,"] ",Typ),
	set::conc([Vals2,["-","-"]],Vals),
	!
;	
    Card=1,
    dbBase::getRecord(Loc,_,_,_,_,_,Realm,_,_,_,Term,_),
	Term=cmp(P,[cmp(E1,Vs1)|PVs]),
	dbBase::kbPredDEs(P,PDEs,_),
    dbBase::kbEntityDEs(E1,E1DEs,_),
    dbBase::nlSing(P,Pn),
    dbBase::nlSing(E1,E1n),
    set::size(PDEs,Np),
    set::size(E1DEs,Ne1),
    set::initialize(Np,Pn,Lp),
    set::initialize(Ne1,E1n,Le1),
    set::conc([Le1,Lp,["REALM","ADDRESS"]],Args),
	set::conc([Vs1,PVs],Vs),
	makeVals(DEs,Vs,Vals2),
	SRef=dbBase::dbRef(Loc),
	set::setGet(["DERIVED","INPUT"],RT,Typ),
	Add=string::concat("[",SRef,"] ",Typ),
	set::conc([Vals2,["-","-"]],Vals),
	!.

% generates the list of NL values corresponding to the DEs
%    
makeVals(_,[],[]) :- 
	!.
makeVals([D|Ds],[V|Vs],[Valu|Vals]) :-
    _=string::searchchar(D,'|',string::caseSensitive()),
    sx::sxUnpack(D,'|',L),
    L=[_,MDE],
    dbBase::smClassDef(MDE,"a",_,_,Dom,Form,_),
	nl::conValX(V,Dom,Form,Val),
	sx::sxUnquote(Val,Valu),
	makeVals(Ds,Vs,Vals),
	!
;
    dbBase::smClassDef(D,"a",_,_,Dom,Form,_),
	nl::conValX(V,Dom,Form,Val),
	sx::sxUnquote(Val,Valu),
	makeVals(Ds,Vs,Vals),
	!.
% ---------------------------------------------------------------------------------------------------------------
% tbwTRR
% ---------------------------------------------------------------------------------------------------------------
tbwTRR(SolRef,Table,Sorted,Row,PRow) :-
	Sorted=0,
	PRow=Row,
	!
;	
	Sorted=1,
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	stb::stbGetRowL_P(XI,Row,PRow),
	!
;		
	R=toString(Row),
	dlgIF::feil("tbwTRR",[R],[SolRef,Table],nill),
	PRow=0,
	!.
% ---------------------------------------------------------------------------------------------------------------
% makeRows
% ---------------------------------------------------------------------------------------------------------------
makeRows([],[],[],[],[]) :-
    !.
makeRows([A|Args],[D|DEs],[M|Ms],[V|Vals],[Row|Rows]) :-
    sx::sxlJoinB([A,D,M,V],"||",Row),
    makeRows(Args,DEs,Ms,Vals,Rows),
    !.
% ---------------------------------------------------------------------------------------------------------------
% makeRowsNew
% ---------------------------------------------------------------------------------------------------------------
makeRowsNew([],[],[],[]) :-
    !.
makeRowsNew([A|Args],[D|DEs],[M|Ms],[Row|Rows]) :-
    sx::sxlJoinB([A,D,M,""],"||",Row),
    makeRowsNew(Args,DEs,Ms,Rows),
    !.
% ---------------------------------------------------------------------------------------------------------------
% readCells
% ---------------------------------------------------------------------------------------------------------------
class predicates
readCellsX : (string_list,vpiDomains::windowHandle,integer,sterml) determ (i,i,i,o).
clauses

readCells(TW,[P,E1,E2],Term) :-
	dbBase::kbPredDEs(P,PDEs,_),
	dbBase::kbEntityDEs(E1,E1DEs,_),
	dbBase::kbEntityDEs(E2,E2DEs,_),
    set::size(E1DEs,Ne1),
    set::size(E2DEs,Ne2),
    readCellsX(E1DEs,TW,1,L1),
    N2=Ne1+1,
    readCellsX(E2DEs,TW,N2,L2),
    N3=N2+Ne2,
    readCellsX(PDEs,TW,N3,L3),
    Term=cmp(P,[cmp(E1,L1),cmp(E2,L2)|L3]),
    !.
readCells(TW,[P,E1],Term) :-
	dbBase::kbPredDEs(P,PDEs,_),
	dbBase::kbEntityDEs(E1,E1DEs,_),
    set::size(E1DEs,Ne1),
    readCellsX(E1DEs,TW,1,L1),
    N3=Ne1+1,
    readCellsX(PDEs,TW,N3,L3),
    Term=cmp(P,[cmp(E1,L1)|L3]),
    !.

readCellsX([],_,_,[]) :-
    !.
readCellsX([D|Ds],W,Row,[V|Vs]) :-
    dbBase::smClassDef(D,"a",_,_,Dom,_,_),
    Cell=vpiTableed::tableedit_getcelldata(W,Row,4),
    Cell=vpiTableed::sc(S,_),
    syn::sbGetDE_ValIF(Dom,S,V),
    Next=Row+1,
    readCellsX(Ds,W,Next,Vs),
    !.
% -------------------------------------------------------------------------------------
% kbSentence                             
% -------------------------------------------------------------------------------------
kbSentence(Loc,RT,ST,Card,Realm,LTerm) :-
    dbBase::getRecord(Loc,RT,_,_,_,_,Realm,_,_,ST,LTerm,_),
	sx::sxUnpack(ST,'|',L),
	set::size(L,N),
	Card=N-1,
    !.
end implement sentence
