/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class sqlBase
open core,termDomain,globalDomains

predicates

%
% sql/odbc main
%
classInfo : core::classInfo.
openConnection : () determ.
closeConnection : () determ.
getConnection : () -> odbcConnection determ.
hasConnection : () determ.
start : ().
commit : ().
rollback : ().
setMaxLength : (integer).
getMaxLength : () -> integer.
createDb : (string DB) determ.
createKb : (string KB) determ. 
names : (string FullName,string DB,string KB,string Path) determ (i,o,o,o). 
openDb :  (string DB) determ.
openKb :  (string KB) determ.
closeKb : () determ.
deleteKb : ().
getDb : () -> string determ.
getKb : () -> string determ.
getDbKb : () -> string determ.
getParameters : (integer Max,string ChainPrefix,string STprefix,string Usc,integer Case,string StDb,integer TermFormat,integer TermLength) procedure (o,o,o,o,o,o,o,o).
setParameters : (integer Max,string ChainPrefix,string STprefix,string Usc,integer Case,string StDb,integer TermFormat,integer TermLength).
setRef : () determ.
initRef : ().
getRef : (string Chain) -> integer determ.
currentRef : (string Chain) -> integer.
existKb : (string KB) -> integer determ.
getMainTable : () -> string.
chainTable : (string Chain) -> string TableName determ.
checkIE : (integer,integer) determ (i,o).
checkForEmptyChain : (string Chain).    
recordCount : () -> integer determ.
sqlToTerm : (string) -> sterm.
sqlToString : (sterm) -> string.
resetTable : (string).
%
% chain-related
%
chainDeleteOutright : (string Chain) determ.
chainDelete : (string Chain) determ.
chainDeleteSentences : (integer Type,string Chain,integer N) procedure (i,i,o).
%
chainCount : (string Chain) -> integer determ.
chainTypeCount : (integer BaseType,string Chain) -> integer determ.
chains : (string Chain) nondeterm (o).
chains : (string Chain,integer MaxRef,string Table) nondeterm (o,o,o).
chainSentencesDirect : (string,sterm) nondeterm (i,o).
chainSentencesDirect : (string,sterm,integer) nondeterm (i,o,o).
chainIRsDirect : (string,sterm) nondeterm (i,o).
chainIRsDirectAll : (string,sterm) nondeterm (i,o).
chainTermsDirect : (string,sterm,sterm) nondeterm (i,o,o).
chainTermsDirect : (string,sterm,sterm,integer) nondeterm (i,o,o,o).
chainTermsDirectAll : (string,sterm,sterm) nondeterm (i,o,o).
chainTermsDirectAll : (string,sterm,sterm,integer) nondeterm (i,o,o,o).
chainRefsAll : (string Chain) -> integer nondeterm.
chainBasetypeRefs : (integer Basetype,string Chain,integer Ref) nondeterm (i,i,o). 
chainBasetypeRefsAll : (integer Basetype,string Chain,integer Ref) nondeterm (i,i,o). 
existChain : (string Chain) determ.
%
% realm-related
%
realmDelete : (string Realm,integer N) determ (i,o).
realmDeleteNo : (string Realm,integer No) determ.
realmDeleteSubno : (string Realm,integer No,integer Subno) determ.
realmRename : (string From,string To,integer N) procedure (i,i,o).
%
realms : () -> string_list.
realmCount : (string Realm) -> integer determ.
realmNoCount : (string Realm,integer No) -> integer determ.
realmSubnoCount : (string Realm,integer No,integer Subno) -> integer determ.
realmRefListAll : (string Realm) -> lst. % format Ref|Chain 
realmRefsAll : (string Realm,string Chain,integer Ref) nondeterm (i,o,o). 
realmBasetypeRefsAll : (string Realm,integer Basetype,string Chain,integer Ref) nondeterm (i,i,o,o). 
realmBasetypeRefListAll : (string Realm,integer Basetype) -> lst. % format Ref|Chain 
%
% ST-related
%
stTypeDelete : (integer Basetype,string ST,integer N) determ (i,i,o).
%
stList : () -> string_list.
stBasetypes : (integer Basetype) -> string_list.
sentenceTypes : (string ST) nondeterm (o).
existSt : (string ST) -> integer determ.
existStI : (string ST) -> integer determ.
existStD : (string ST) -> integer determ.
stSentence_nd : (string St,sterm Lt,string Chain,integer Ref) nondeterm (i,o,o,o).
getST_Count : (string ST) -> integer determ.
getST_Count : (string ST,integer BaseType) -> integer determ.
%
% SR-related
%
getRuleRecordChain : (string Realm,integer No,integer SubNo,string Chain,integer Ref) determ (i,i,i,o,o).
getRuleRecord : (string Chain,string Realm,integer No,integer SubNo,integer Ref) determ (i,i,i,i,o).
%
% IR-related
%
getIrDef : (string Rule,sterm LTerm,string Chain,integer Ref) determ (i,o,o,o).
getIrDefF : (string Rule,sterm LTerm,string Chain,integer Ref) determ (i,o,o,o).
%
% Sentence-related
%
existSentence : (sterm LTerm) -> integer determ.
sentenceDelete : (sterm LTerm) determ.
%
% Record-related
%
recordInsert : (integer,string,integer,integer,sterm,sterm,integer) determ (i,i,i,i,i,i,o).
recordInsertOutright : (integer,string,integer,integer,sterm,sterm,integer) determ (i,i,i,i,i,i,o).
recordDelete : (string Chain,integer Ref) determ.
recordDeleteOutright : (string Chain,integer Ref) determ.
recordSuspend : (string Chain,integer Ref) determ.
recordSetType : (string Chain,integer Ref,integer RecType) determ.
%
getRecord : (integer Ref,string Chain,integer RT,integer BT,integer Active,integer Suspended,string Time,string Realm,integer No,integer SubNo,string ST,sterm LTerm,sterm RTerm) determ (i,i,o,o,o,o,o,o,o,o,o,o,o).
getMeta : (integer Ref,string Chain,integer RT,integer BT,integer Active,integer Suspended,string Time,string Realm,integer No,integer SubNo,string ST) determ (i,i,o,o,o,o,o,o,o,o,o).
getMetaS : (string SRef,string Chain,integer RT,integer BT,integer Active,integer Suspended,string Time,string Realm,integer No,integer SubNo,string ST) determ (i,i,o,o,o,o,o,o,o,o,o).
%
% record sets
%
typeCount : (integer RecordType) -> integer determ.
getSrs : (string Realm,integer No,integer Sub) -> dbLoc_list determ.
deleteBasetypeOutright : (integer).
recordDeletes : (dbLoc_list) determ.
basetypeRefList : (integer Basetype) -> lst. % format : Ref|Chain
basetypeRefListAll : (integer Basetype) -> lst.  % format : Ref|Chain
basetypeRefs : (integer Basetype,string Chain,integer Ref) nondeterm (i,o,o). 
basetypeRefsAll : (integer Basetype,string Chain,integer Ref) nondeterm (i,o,o). 
typeRefs : (integer Type,string Chain,integer Ref) nondeterm (i,o,o). 
recTypeLocs : (integer Type,dbLoc_list L) determ (i,o).
recBasetypeLocs : (integer Type,dbLoc_list L) determ (i,o).
recBasetypeLocsAll : (integer Type,dbLoc_list L) determ (i,o).
%
% terminology
%
nlClassForm : (string KbName,string Clas,string Form) -> string determ.
nlClassFormF : (string KbName,string Clas,string Form) -> string determ.
nlForm : (string KbName,string Form) -> string determ.
nlFormF : (string KbName,string Form) -> string determ.
nlAny : (string KbName) -> string determ.
nlAnyF : (string KbName) -> string determ.
nlTry : (string KbName) -> string.
nlSyntagm : (string KbName,string Clas,string Form,string NL) determ (i,o,o,o).
nlSyntagmF : (string KbName,string Clas,string Form,string NL) determ (i,o,o,o).
nlST_F : (string STk) -> string determ.
getSyntagmSet : (sterml,sterml) determ (i,o).
end class sqlBase