/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement sqlSelect
open core

constants
className = "com/rudstrand/sqlSelect/sqlSelect".
classVersion = "1.0".

facts
nRows : integer :=0. % error-state: <0, else #rows selected
nColumns : integer := 0. % #columns selected
vdb : (integer,integer,core::value) nondeterm. % row,column,value
predicates
getResult : (odbcStatement).
getRows : (odbcStatement,integer).
getColumns : (odbcStatement,integer,integer,integer).

clauses
classInfo(className, classVersion).
% ----------------------------------------------------------------------------------------------
%                                            C O N S T R U C T O R
% ----------------------------------------------------------------------------------------------
% ----------------------------------------------------------------------------------------------
% new
% ----------------------------------------------------------------------------------------------
new(Connection,Sql) :-
    retractall(vdb(_,_,_)),
    Stmt=odbcStatement::new(Connection),
    Stmt:execDirect(Sql),
    finally(getResult(Stmt),(Stmt:closeCursor(),Stmt:free())),
    !
;
    nRows:=-1000001,
    !.
new(Connection,Sql,MaxColSize) :-
    retractall(vdb(_,_,_)),
    Stmt=odbcStatement::new(Connection),
    Stmt:setColumnAutoSizeLimit(MaxColSize), 
    Stmt:execDirect(Sql),
    finally(getResult(Stmt),(Stmt:closeCursor(),Stmt:free())),
    !
;
    nRows:=-1000001,
    !.
% ----------------------------------------------------------------------------------------------
% getResult
% ----------------------------------------------------------------------------------------------
getResult(Stmt) :-    
    nColumns:=Stmt:numResultCols(),
    nColumns>0,
    nRows:=0,
    getRows(Stmt,nColumns),
    !
;
    nRows:=-1000002,
    !.
    
getRows(Stmt,Columns) :-    
    Stmt:fetch_nd(),
        N=nRows,
        nRows:=N+1,
        getColumns(Stmt,nRows,1,Columns),
        fail
;        
    !.
    
getColumns(_,_,Col,Columns) :-
    Col>Columns,
    !.
getColumns(Stmt,Row,Col,Columns) :-  
    V=Stmt:getcolumnValue(Col),
    assert(vdb(Row,Col,V)),
    Next=Col+1,
    getColumns(Stmt,Row,Next,Columns),
    !
;
    nRows:=-Row,
    !.
% ----------------------------------------------------------------------------------------------
% getNRows
% ----------------------------------------------------------------------------------------------
getNRows()=N:-N=nrows,!.
% ----------------------------------------------------------------------------------------------
% getI/S
% ----------------------------------------------------------------------------------------------
getI(Row,Col)=Int :-
    vdb(Row,Col,V),
    V=integer(Int),
    !.

getN(Row,Col)=Int :-
    vdb(Row,Col,V),
    V=real(Int),
    !.

getS(Row,Col)=S :-
    vdb(Row,Col,V),
    V=string(S),
    !
;    
    vdb(Row,Col,V),
    V=char(C),
    S=string::charToString(C),
    !.

getDT(Row,Col)=S :-
    vdb(Row,Col,V),
    V=localTimeValue(T),
    Tm=time::newFromLocalTime(T),
    Tm:getDate(Y,M,D),
    Tm:getTime(HH,MM,SS),
	ZH=globalVars::get_i("tzonh"),   
	ZM=globalVars::get_i("tzonm"),  
    xmlGeneric::xmlDatetime(Y,M,D,HH,MM,SS,0,ZH,ZM,S),
    !.
end implement sqlSelect
