/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class sqlSt
open core,termDomain

predicates
classInfo : core::classInfo.

modeCode : (string,integer) determ (i,o) (o,i).
formatCode : (string,integer) determ (i,o) (o,i).

createDb : () determ. % creates p3publications
createDbIfnotexists : () determ. % creates p3publications

createNet : (string Name,string DefDb) determ. % creates non-open share net
createNet : (string Name,integer OpenShare,string Table,string DefDb) determ. % creates open share net
defaultDb : (string Net) -> string determ.
deleteNet : (string Net) determ. % deletes net
getNet : (string Net,integer OpenShare,string ShareTable,string_list Pubs,string DefDb) determ (i,o,o,o,o).  % returns Net details: OpenShare>0:format,=0 no open share. Pubs/Subs: st|mode|kb (nl)
getNets : ()-> string_list. % returns all pub nets
getPub : (string Net,string St,string Table,integer Format,integer Mode) determ (i,i,o,o,o).
getPub : (string Kb,string Net,string St,string Table,integer Format,integer Mode) determ (i,i,i,o,o,o).
addPub : (string Net,string St,string Table,integer Format,integer Mode,string Pub) determ (i,i,i,i,i,o). % adds a publication. Mode 1=incr 2=repl
remPub : (string Kb,string Net,string St) determ. % removes a publication 
getShareTable : (string Net,string Table,integer Format) determ (i,o,o).

deleteKbNet : (string Net) determ.
getKbNetUse : (string Net,integer OpenPub,integer OpenSub,string_list Pubs,string_list Subs) procedure (i,o,o,o,o). % returns KB's net use details: OpenShare>0:format,=0 no open share. Pubs/Subs: st|mode|table (nl)
getSub : (string Net,string St,string Table,integer Format,integer Mode) determ (i,i,o,o,o).

addSub : (string Net,string St,integer Mode) determ. % adds a subscription
getSubMode : (string Net,string St,integer Mode) determ (i,i,o).
remSub : (string Net,string St) determ. % removes a subscription

publishOpen : (string Net) determ.
publishAll : ().
publishAll : (string Net).
publishSt : (string St).
publishSt : (string St,string Net,string TableName,integer Format,integer Mode).
subscribeAll : ().
subscribeAll : (string Net).
subscribeSt : (string St) determ.
subscribeSt : (string St,string Net,string TableName,integer Format,integer Mode).
subscribeOpen : (string Net) determ.
hasSubscriptions : () determ.

fullTablename : (string Net,string Table,string DbTable) procedure (i,i,o).

colType : (integer,string,string,string) procedure (i,i,i,o).
stTableName : (string St) -> string determ.
transSentence : (integer Format,string Sentence,sterm LTerm) determ (i,i,o).

end class sqlSt