/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement struc
open core,termDomain
constants
        className = "com/rudstrand/struc/struc".
        classVersion = "1.0".
clauses
        classInfo(className, classVersion).
class predicates
treMoveConclusionConds : (sterm,sterm,sterm,sterm) determ (i,i,o,o).
treAliasVars : (sterm,sterml,sterml,sterm) procedure (i,i,o,o).
treElimAlias : (sterm,sterm,sterm) procedure (i,i,o).
treElimProcVars : (sterm,sterm,sterm) procedure (i,i,o).
treVarVal : (sterm,string,sterm) determ (i,i,o).
treIsAlias : (sterml,string,string,string) determ (i,i,o,o).
treSubstAlias : (sterml,sterm,sterm) procedure (i,i,o).
treVarList : (sterm,sterml,sterml) procedure (i,i,o).
clauses
% ------------------------------------------------------------------------------------------------------------
% treCopies
% ------------------------------------------------------------------------------------------------------------
treCopies(T,N,_) :-
	N<0,
	dlgIF::feil("treCopies",[],[N],T),!,fail.
treCopies(_,0,[]) :-
	!.
treCopies(T,1,[T]) :-
	!.
treCopies(T,N,[T|Ts]) :-
	Rem=N-1,
	treCopies(T,Rem,Ts),!.
% ------------------------------------------------------------------------------------------------------------
% treElimDummyLogOpr; treElimDummyNIL
% ------------------------------------------------------------------------------------------------------------
class predicates
treEL : (sterm,sterm,integer) procedure (i,o,o).
treELs : (sterml,sterml,integer) procedure (i,o,o).
treEN : (sterm,sterm,integer) procedure (i,o,o).
treENs : (sterml,sterml,integer) procedure (i,o,o).
treRN : (sterml,sterml,integer) determ (i,o,o).
clauses
% eliminates unnecessary logical operators
%
treElimDummyLogOpr(T,Tr) :-
	treEL(T,T2,N),
	N>0,
	treElimDummyLogOpr(T2,Tr),
	!.
treElimDummyLogOpr(T,T) :-
	!.
treEL(cmp(LogOpr,[]),nill,1) :- 
	set::member(LogOpr,[",","&","v"]),
	!.
treEL(cmp(LogOpr,[B]),B,1) :- 
	set::member(LogOpr,[",","&","v"]),
	!.
treEL(cmp(LogOpr,B),cmp(LogOpr,Br),N) :-
	set::member(LogOpr,[",","&","v"]),
	treRN(B,B2,M),
	treELs(B2,Br,P),
	N=M+P,
	!.
treEL(cmp(H,T),cmp(H,Tm),N) :-
	treELs(T,Tm,N),
	!.
treEL(C,C,0) :-
	!.	
treELs([],[],0) :-
	!.
treELs([H|T],[Hm|Tm],N) :-
	treEL(H,Hm,M),
	treELs(T,Tm,P),
	N=M+P,
	!.
% eliminates unnecessary NILs
%
treElimDummyNIL(T,Tr) :-
	treEN(T,T2,N),
	N>0,
	treElimDummyNIL(T2,Tr),
	!.
treElimDummyNIL(T,T) :-
	!.
treEN(cmp(LogOpr,[]),nill,1) :- 
	set::member(LogOpr,[",","&","v"]),
	!.
treEN(cmp(LogOpr,B),cmp(LogOpr,Br),N) :- 
	set::member(LogOpr,[",","&","v"]),
	treRN(B,Br,N),
	!.
treEN(cmp(H,T),cmp(H,Tm),N) :-
	treENs(T,Tm,N),
	!.
treEN(C,C,0) :-
	!.	
treRN([],[],0) :-
	!.
treRN([nill|T],Tm,N) :-
	treRN(T,Tm,M),
	N=M+1,
	!.
treRN([H|T],[H|Tm],N) :-
	treRN(T,Tm,N),
	!.
	
treENs([],[],0) :-
	!.
treENs([H|T],[Hm|Tm],N) :-
	treEN(H,Hm,M),
	treENs(T,Tm,P),
	N=M+P,
	!.
% ------------------------------------------------------------------------------------------------------------
% treElimDummyEq
% ------------------------------------------------------------------------------------------------------------
class predicates
tede_x : (sterml,sterml) determ (i,o).
clauses
% eliminates dummy equality conditions
%
treElimDummyEq(cmp(Opr,[A,A]),nill) :- opr::oprEq(Opr),!.
treElimDummyEq(cmp(H,T),cmp(H,Te)) :- tede_x(T,Te),!.
treElimDummyEq(C,C) :- !.
tede_x([],[]) :- !.
tede_x([H|T],[He|Te]) :- 
	treElimDummyEq(H,He),
	tede_x(T,Te),!.
% ------------------------------------------------------------------------------------------------------------
% treElimNill                      
% ------------------------------------------------------------------------------------------------------------
class predicates
elim_nills : (sterml,sterml) procedure (i,o).
elim_nill : (sterm,sterm) procedure (i,o).
clauses
% eliminates nill-subtrees, i.e. nill-leaves or cmp(_,[])-subtrees
%
treElimNill(T,T) :- not(treHasNIL(T)),!.
treElimNill(Tc,Tr) :-
	elim_nill(Tc,T1),
	treElimNill(T1,Tr),!.
elim_nill(cmp(_,[]),nill) :- !.
elim_nill(cmp(H,T),cmp(H,Te)) :- elim_nills(T,Te),!.
elim_nill(C,C) :- !.
elim_nills([],[]) :- !.
elim_nills([nill|T],Te) :- elim_nills(T,Te),!.
elim_nills([H|T],[He|Te]) :- 
	elim_nill(H,He),
	elim_nills(T,Te),!.
% ------------------------------------------------------------------------------------------------------------
% treElimOR
% ------------------------------------------------------------------------------------------------------------
class predicates
treElimORs : (sterml,sterml) determ (i,o).
treRemFirstOR : (sterml,integer,sterml) determ (i,i,o).	
treKeep_Branch_N : (sterm,integer,sterm) determ (i,i,o).
treKeep_Branch_Nx : (sterml,integer,sterml) determ (i,i,o).
clauses
treElimOR(Tree,Trees) :-
	treHasHead(Tree,"v",N),	
	treCopies(Tree,N,Trees2),
	treRemFirstOR(Trees2,1,Trees3),
	treElimORs(Trees3,Trees),!.	
treElimOR(Tree,[Tree]) :-
	!.
treElimORs([],[]) :-
	!.
treElimORs([H|T],Trees) :-
	treElimOR(H,Hs),
	treElimORs(T,Ts),
	set::conc([Hs,Ts],Trees),!.
% parameters:
% 1	in	a list of identical trees with OR
% 2	in	branch counter: 1,2,...
% 3	in	a list of trees corresponding #1 where the first OR has been split up
%
treRemFirstOR([],_,[]) :-
	!.	
treRemFirstOR([H|T],N,[Hr|Tr]) :-
	treKeep_Branch_N(H,N,Hr),
	Next=N+1,
	treRemFirstOR(T,Next,Tr),!.
	
treKeep_Branch_N(cmp("v",B),N,Bs) :-
	set::setGet(B,N,Bs),!
;
	dlgIF::feil("treKeep_Branch",[],[N],cmp("",B)),!,fail.	
treKeep_Branch_N(cmp(H,B),N,cmp(H,Bs)) :-
	treKeep_Branch_Nx(B,N,Bs),!.	
treKeep_Branch_Nx([H|T],N,[Hr|T]) :-
	treHasHead(H,"v",_),
	treKeep_Branch_N(H,N,Hr),!.
treKeep_Branch_Nx([H|T],N,[H|Tr]) :-
	treKeep_Branch_Nx(T,N,Tr),!.
% ------------------------------------------------------------------------------------------------------------
% treHasString            
% ------------------------------------------------------------------------------------------------------------
class predicates
treHasStringX : (sterml,string) determ (i,i).
clauses
treHasString(Tree,S) :-
	Tree=cmp(T,_),
	_=string::search(T,S,string::caseSensitive()),
	!
;
	Tree=list(H,T),
	treHasStringX([H,T],S),
	!
;
	Tree=cmp(_,Trees),
	treHasStringX(Trees,S),
	!
;
	Tree=atom(T),
	_=string::search(T,S,string::caseSensitive()),
	!
;
	Tree=str(T),
	_=string::search(T,S,string::caseSensitive()),
	!
;
	Tree=var(T),
	_=string::search(T,S,string::caseSensitive()),
	!
;
	Tree=fstr(T,_,_,_),
	_=string::search(T,S,string::caseSensitive()),
	!
;
	Tree=fvar(T,_),
	_=string::search(T,S,string::caseSensitive()),
	!.
treHasStringX([H|T],S) :-
	treHasString(H,S),
	!
;
	treHasStringX(T,S),
	!.
% ------------------------------------------------------------------------------------------------------------
% treHasElement             
% ------------------------------------------------------------------------------------------------------------
treHasElement(Tree,E) :-
	treHasNode(Tree,E),
	!
;
	E=atom(A),
	treHasHead(Tree,A,_),
	!
;
	E=var(A),
	treHasHead(Tree,A,_),
	!
;
	E=str(A),
	treHasHead(Tree,A,_),
	!.
% ------------------------------------------------------------------------------------------------------------
% treHasHead             
% ------------------------------------------------------------------------------------------------------------
class predicates
treHasHeadX : (sterml,string,integer) determ (i,i,o).	
clauses
treHasHead(cmp(S,B),S,N) :-
	set::size(B,N),
	!.
treHasHead(cmp(_,B),S,N) :-
	treHasHeadX(B,S,N),
	!.
treHasHeadX([H|T],S,N) :-
	treHasHead(H,S,N),
	!
;
	treHasHeadX(T,S,N),
	!.
% ------------------------------------------------------------------------------------------------------------
% treHasNILs                               
% ------------------------------------------------------------------------------------------------------------
class predicates
treHasNILs : (sterml) determ.
clauses
% succeeds if at least one nill or cmp(_,[]) in the tree, else fails
%
treHasNIL(nill) :- 
	!.
treHasNIL(cmp(_,[])) :- 
	!.
treHasNIL(cmp(_,T)) :- 
	treHasNILs(T),!.
treHasNILs([H|T]) :-
	treHasNIL(H),!
;
	treHasNILs(T),!.
% ------------------------------------------------------------------------------------------------------------
% treHasNode                
% ------------------------------------------------------------------------------------------------------------
class predicates
treHasNodeX : (sterml,sterm) determ (i,i).
clauses
% succeeds if given node (actually sub-tree) occurs at least once in the tree
%
treHasNode(Node,Node) :-
	!.
treHasNode(cmp(_,L),Node) :-
	treHasNodeX(L,Node),
	!.
treHasNode(list(H,_),Node) :-
	treHasNode(H,Node),
	!.
treHasNode(list(_,L),Node) :-
	treHasNode(L,Node),
	!.
treHasNodeX([H|T],Node) :-
	treHasNode(H,Node),
	!
;
	treHasNodeX(T,Node),
	!.	
% ------------------------------------------------------------------------------------------------------------
% treTBQ_Simplification                               
% ------------------------------------------------------------------------------------------------------------
% simplifies the use of variables in the 3bq tree through five steps:
% 1/ alias variables of DE variables in the conclusion
% are substituted in the conditions (with the DE variables);
% 2/ DE conditions in the conclusion which are simple variable
% assignments/equality between DE variable and alias variable
% are eliminated (if there are no more references to the alias variable; 
% 3/ (1) above are then done for alias variables internal to the
% conditions if such variables only occurr at the right side of
% expressions;
% 4/ (2) above are done for DE conditions internal to the
% conditions;
% 5/ ALL-quantifications are generated for all elementary variables
% used.
%  
treTBQ_Simplification(Tc,Tr) :-
	Tc=cmp("RULE",[cmp(Impl,[Cond,Conc])]),
	treMoveConclusionConds(Cond,Conc,Cond2,Conc2),
	T0=cmp("RULE",[cmp(Impl,[Cond2,Conc2])]),
				tt::tt_term(2,"treMoveConclusionConds/x",T0), 
	treAliasVars(T0,[],Alias,T1),
				tt::tt_terms(2,"treAliasVars/x",Alias),
	treSubstAlias(Alias,T1,T2),
				tt::tt_term(2,"treSubstAlias/x",T2),
	treElimAlias(T2,T2,T3),
				tt::tt_term(2,"treElimAlias",T3),
	treElimDummyEq(T3,T4),
				tt::tt_term(2,"treElimDummyEq/x",T4),
	treElimNill(T4,T5),
				tt::tt_term(2,"treElimNill/x",T5),
	treElimProcVars(T5,T5,T6),				
				tt::tt_term(2,"treElimProcVars/x",T6),
	treVarList(T6,[],Vars),
	T6=cmp("RULE",[Rule]),
	treAndLinearize(Rule,T7),
				tt::tt_term(2,"treAndLinearize/x",T7),
	Tr=cmp("RULE",[cmp("ALL",Vars),T7]),!.
% ------------------------------------------------------------------------------------------------------------
% treReplace                              
% ------------------------------------------------------------------------------------------------------------
class predicates
treReplaceX : (sterml,sterm,sterm,sterml) determ (i,i,i,o).
clauses
% replaces subtree N1 with subtree N2 in Tree1, resulting in Tree2
%
treReplace(N1,N1,N2,N2) :- 
	!.
treReplace(cmp(H,T),N1,N2,cmp(H,Tr)) :- 
	treReplaceX(T,N1,N2,Tr),
	!.
treReplace(list(N1,T),N1,N2,list(N2,Tr)) :- 
	treReplace(T,N1,N2,Tr),
	!.
treReplace(list(H,T),N1,N2,list(H,Tr)) :- 
	treReplace(T,N1,N2,Tr),
	!.
treReplace(H,_,_,H) :- 
	!.
treReplaceX([],_,_,[]) :- 
	!.
treReplaceX([H|T],N1,N2,[Hr|Tr]) :-
	treReplace(H,N1,N2,Hr),
	treReplaceX(T,N1,N2,Tr),
	!.	
% ------------------------------------------------------------------------------------------------------------
% treReplaceHead                              
% ------------------------------------------------------------------------------------------------------------
% replaces head N1 with N2 in Tree1, resulting in Tree2
%
treReplaceHead(cmp(N1,T),N1,N2,cmp(N2,Tr)) :- treReplaceHeads(T,N1,N2,Tr),!.
treReplaceHead(cmp(H,T),N1,N2,cmp(H,Tr)) :- treReplaceHeads(T,N1,N2,Tr),!.
treReplaceHead(H,_,_,H) :- !.
treReplaceHeads([],_,_,[]) :- !.
treReplaceHeads([H|T],N1,N2,[Hr|Tr]) :-
	treReplaceHead(H,N1,N2,Hr),
	treReplaceHeads(T,N1,N2,Tr),!.	
% ------------------------------------------------------------------------------------------------------------
% treStr
% ------------------------------------------------------------------------------------------------------------
class predicates
treFS_GetChildren : (integer,string_list,string_list,sterml) procedure (i,i,o,o).
treFS_Tree : (string,sterml,sterm) procedure (i,i,o).
treToStr : (sterm,integer,string) procedure (i,i,o).
treToStrX : (sterml,integer,string) determ (i,i,o).
clauses
treStr(T,S) :-
	treToStr(T,0,S),!.
treStrR(T,S) :-
	free(T), bound(S),
	sx::sxUnpack(S,'\n',L),
	L=[A|R],
	treFS_GetChildren(3,R,Rm,B),
	Rm=[],
	sx::sxStrip(A,As),
	T=cmp(As,B),!.
treToStr(cmp(H,T),N,S) :-
	sx::sx_ini(N,' ',S2),
	S3=string::concat(S2,H),
	M=N+3,
	treToStrX(T,M,S4),
	sx::sxlJoin([S3,S4],"\n",S),!. 	
treToStr(T,N,S) :-
	sx::sx_ini(N,' ',S2),
	S3=toString(T),
	S=string::concat(S2,S3),!.
	
treToStrX([],_,"") :-
	!.
treToStrX([H|T],N,S) :-
	treToStr(H,N,S2),
	treToStrX(T,N,S3),
	sx::sxlJoin([S2,S3],"\n",S),!. 	
treFS_GetChildren(_,[],[],[]) :-
	!.
treFS_GetChildren(N,[A|R],Rm,[At|Rt]) :-
	As=string::trimFront(A),
	Na=string::length(A)-string::length(As),
	Na=N,	
	% A is a child - continue with A's children
	Next=N+3,
	treFS_GetChildren(Next,R,R2,C),
	treFS_Tree(A,C,At),
	% continue with A's siblings
	treFS_GetChildren(N,R2,Rm,Rt),!.
treFS_GetChildren(_,R,R,[]) :-
	!.
treFS_Tree(A,[],At) :-
	As=string::trim(A),
	At=toTerm(As),
	!.
treFS_Tree(A,C,cmp(As,C)) :-
	sx::sxStrip(A,As),!.
% ------------------------------------------------------------------------------------------------------------
% treSubstList
% ------------------------------------------------------------------------------------------------------------
class predicates
treSubstListX : (sterml,string_list,string_list,sterml) determ (i,i,i,o).
clauses
% parameters:
% 1	cmp-tree
% 2	list of replaceable strings
% 3	list of replacing strings
% 4	cmp-tree replaced according to p#2 and p#3
%
treSubstList(C,L,Ls,Tr) :-
	C=cmp(H,T),
	sx::sxSubstNR_List(H,L,Ls,Hm),
	treSubstListX(T,L,Ls,Tm),
	Tr=cmp(Hm,Tm),
	!
;
	C=str(H),
	sx::sxSubstNR_List(H,L,Ls,Hm),
	Tr=str(Hm),
	!
;
	C=var(H),
	sx::sxSubstNR_List(H,L,Ls,Hm),
	Tr=var(Hm),
	!
;
	C=atom(H),
	sx::sxSubstNR_List(H,L,Ls,Hm),
	Tr=atom(Hm),
	!
;
	Tr=C,
	!.
	
treSubstListX([],_,_,[]) :-
	!.
treSubstListX([H|T],L,Ls,[Hm|Tm]) :-
	treSubstList(H,L,Ls,Hm),
	treSubstListX(T,L,Ls,Tm),
	!.
% ------------------------------------------------------------------------------------------------------------
% treStringSubst
% ------------------------------------------------------------------------------------------------------------
class predicates
treSubstStringX : (sterml,string,string,sterml) determ (i,i,i,o).
clauses
% parameters:
% 1	cmp-tree
% 2	list of replaceable strings
% 3	list of replacing strings
% 4	cmp-tree replaced according to p#2 and p#3
%
treSubstString(C,From,To,Tr) :-
	C=cmp(H,T),
	treSubstStringX(T,From,To,Tm),
	Hm=sx::replaceAll(H,From,To),
	Tr=cmp(Hm,Tm),
	!
;
	C=str(H),
	Hm=sx::replaceAll(H,From,To),
	Tr=str(Hm),
	!
;
	C=var(H),
	Hm=sx::replaceAll(H,From,To),
	Tr=var(Hm),
	!
;
	C=atom(H),
	Hm=sx::replaceAll(H,From,To),
	Tr=atom(Hm),
	!
;
	Tr=C,
	!.
	
treSubstStringX([],_,_,[]) :-
	!.
treSubstStringX([H|T],From,To,[Hm|Tm]) :-
	treSubstString(H,From,To,Hm),
	treSubstStringX(T,From,To,Tm),
	!.
% ------------------------------------------------------------------------------------------------------------
%                                LOCAL class predicates                            
% ------------------------------------------------------------------------------------------------------------
% treAliasVars                               
% ------------------------------------------------------------------------------------------------------------
class predicates
treAliases : (sterm,sterml,sterml,sterm) determ (i,i,o,o).
treAliasesX : (sterml,sterml,sterml,sterml)  determ (i,i,o,o).
treAliasVarsX : (sterml,sterml,sterml,sterml) determ (i,i,o,o).
clauses
% - treAliasVars compiles a list of 'variables - alias-variable' pairs
%   from ATTR_CONDS sub-trees, using the format 
%   'cmp(Var,[fvar(Aliasvar,Dom)])'.
% - the leaves of the ATTR_CONDS sub-tree(s) are marked '*=" whenever
%   a pair is included in the list.
% - if an already listed alias occurrs in an ATTR_CONDS sub-tree then
%   the occurrence is replaced by a substitution for the alias according
%   to the list 
% - variables representing list-domain data elements are handled, but
%   NOT variables representing members of lists.
% parameters:
% 1	in	3bq tree at call
% 2	in	alias-var list at call
% 3	out	alias-var list at return
% 4	out	3bq tree at return
%			          
treAliasVars(cmp("ATTR_CONDS",As),Avc,Avr,cmp("ATTR_CONDS",Asm)) :- 
	treAliasesX(As,Avc,Avr,Asm),!.
	
treAliasVars(cmp(H,L),Avc,Avr,cmp(H,Lm)) :- treAliasVarsX(L,Avc,Avr,Lm),!.
treAliasVars(C,A,A,C) :- !.
treAliasesX([],A,A,[]) :- !.
treAliasesX([H|T],Avc,Avr,[Hm|Tm]) :-
	treAliases(H,Avc,A1,Hm),
	treAliasesX(T,A1,Avr,Tm),!.
	
treAliases(cmp(Opr,[fvar(Var,D1),fvar(Alias,_)]),Avc,Avc,cmp(Opr,[fvar(Var,D1),fvar(OrgVar,OrgDom)])) :- 
	% if the alias is listed already, then substitute
	opr::oprEq(Opr),
	treIsAlias(Avc,Alias,OrgVar,OrgDom),!.
	
treAliases(cmp(Opr,[fvar(Var,D1),cmp(ListDom,[fvar(Alias,Dom)])]),Avc,Avc,cmp(Opr,[fvar(Var,D1),fvar(OrgVar,OrgDom)])) :- 
	opr::oprEq(Opr),
        sx::sxTail(2,ListDom,Fr,Tl),
        Fr=Dom,
        Tl="_l",
	% if the alias is listed already, then substitute
	treIsAlias(Avc,Alias,OrgVar,OrgDom),!.
	
treAliases(cmp(Opr,[fvar(Var,D1),fvar(Alias,D2)]),Avc,Avr,cmp(MarkOpr,[fvar(Var,D1),fvar(Alias,D2)])) :- 
	% aliases must be listed in the same sequence as the occurr in the 3bq tree
	opr::oprEq(Opr),
        MarkOpr=string::concat("*",Opr),
	set::conc([Avc,[cmp(Var,[fvar(Alias,D1)])]],Avr),!.
	
treAliases(cmp(Opr,[fvar(Var,D1),cmp(ListDom,[fvar(Alias,D2)])]),Avc,Avr,cmp(MarkOpr,[fvar(Var,D1),fvar(Alias,D2)])) :- 
	opr::oprEq(Opr),
        MarkOpr=string::concat("*",Opr),
        sx::sxTail(2,ListDom,Fr,Tl),
        Fr=D2,
        Tl="_l",
	% aliases must be listed in the same sequence as the occurr in the 3bq tree
	set::conc([Avc,[cmp(Var,[fvar(Alias,D1)])]],Avr),!.
	
treAliases(cmp(Opr,[fvar(Var,_),var(Alias)]),_,_,_) :- 	
	opr::oprEq(Opr),
	dlgIF::feil("treAliases",["expected 'fvar' not 'var'",Var,Alias],[],nill),!,fail.
	
treAliases(T,A,A,T) :- !.
treAliasVarsX([],A,A,[]) :- !.
treAliasVarsX([H|T],Avc,Avr,[Hm|Tm]) :- 
	treAliasVars(H,Avc,A1,Hm),
	treAliasVarsX(T,A1,Avr,Tm),!.
% ------------------------------------------------------------------------------------------------------------
% treAndLinearize                              
% ------------------------------------------------------------------------------------------------------------
class predicates
treAndLinearizeX : (sterml,sterml) determ (i,o).
treChildrenOfAnd : (sterml,sterml) determ (i,o).
clauses
% changes AND-structures such that
%
% AND -- AND -- X            AND -- X
%     |      |                   |
%     |      +- Z                +- AND -- Z
%     |               --->              |
%     +- Y                              +- Y
%
treAndLinearize(cmp("&",C),cmp("&",Cm)) :-
	treChildrenOfAnd(C,Cm),
	!.
treAndLinearize(cmp(H,T),cmp(H,Tm)) :-
	treAndLinearizeX(T,Tm),
	!.
treAndLinearize(C,C) :-
	!.
	
treAndLinearizeX([],[]) :-
	!.
treAndLinearizeX([H|T],[Hm|Tm]) :-
	treAndLinearize(H,Hm),
	treAndLinearizeX(T,Tm),
	!.
	
treChildrenOfAnd([],[]) :-
	!.
treChildrenOfAnd([cmp("&",C)|Ps],PsM) :-
	set::conc([C,Ps],PsM2),
	treChildrenOfAnd(PsM2,PsM),
	!.
treChildrenOfAnd([H|T],[H|Tm]) :-
	treChildrenOfAnd(T,Tm),
	!.
% ------------------------------------------------------------------------------------------------------------
% treElimAlias                         
% ------------------------------------------------------------------------------------------------------------
class predicates
treElimAlias_c : (sterm,sterm,sterm) procedure (i,i,o).
treElimAlias_cs : (sterml,sterm,sterml) determ (i,i,o).
treElimAlias_x : (sterml,sterm,sterml) determ (i,i,o).
is_ref_in : (string,sterm) determ.
is_ref_in_x : (string,sterml) determ.
clauses
% eliminates DE conditions which are variable-to-alias-variable 
% equality/assignment conditions IF there are no more references to
% the alias variable in any part of the given tree (excluding the
% DE condition)
% parameters:
% 1	in	tree containing the attribute conditions to eventually be
%	        eliminated
% 2	in	tree where no reference to the alias variable must be found
% 3	out	(2) after elimination
%
treElimAlias(cmp("ATTR_CONDS",ACs),TRef,cmp("ATTR_CONDS",ElimACs)) :-
	treElimAlias_cs(ACs,TRef,ElimACs),!.
treElimAlias(cmp(H,L),TRef,cmp(H,Le)) :- treElimAlias_x(L,TRef,Le),!.
treElimAlias(T,_,T) :- !.
treElimAlias_x([],_,[]) :- !.
treElimAlias_x([H|T],TRef,[Hr|Tr]) :-
	treElimAlias(H,TRef,Hr),
	treElimAlias_x(T,TRef,Tr),!.
treElimAlias_cs([],_,[]) :- !.
treElimAlias_cs([H|T],TRef,[He|Te]) :-
	treElimAlias_c(H,TRef,He),
	treElimAlias_cs(T,TRef,Te),!.
treElimAlias_c(cmp(Opr,[fvar(_,_),fvar(Alias,_)]),TRef,nill) :-
	sx::frontchar(Opr,'*',ROpr),
	opr::oprEq(ROpr),
	not(is_ref_in(Alias,TRef)),!.	
treElimAlias_c(cmp(Opr,[fvar(Var,D1),fvar(Alias,D2)]),_,cmp(ROpr,[fvar(Var,D1),fvar(Alias,D2)])) :- 
	sx::frontchar(Opr,'*',ROpr),
	opr::oprEq(ROpr),!.
treElimAlias_c(C,_,C) :- !. 
is_ref_in(Alias,fvar(Alias,_)) :- !.
is_ref_in(Alias,var(Alias)) :- !. % not sure if var(Alias) will be found in any expression ?
is_ref_in(_,cmp("ATTR_CONDS",_)) :- !,fail.
is_ref_in(Alias,cmp(UOpr,[Exp])) :-
	opr::opr_any(UOpr,1),
	is_ref_in(Alias,Exp),!.
is_ref_in(Alias,cmp(BOpr,[Exp1,Exp2])) :-
	opr::opr_any(BOpr,2),
	is_ref_in(Alias,Exp1),!
;	
	opr::opr_any(BOpr,2),
	is_ref_in(Alias,Exp2),!.
is_ref_in(Alias,cmp(_,L)) :- is_ref_in_x(Alias,L),!.
is_ref_in_x(Alias,[H|T]) :-
	is_ref_in(Alias,H),!
;	
	is_ref_in_x(Alias,T),!.
% ------------------------------------------------------------------------------------------------------------
% treElimProcVars
% ------------------------------------------------------------------------------------------------------------
class predicates
treElimProcVarsX : (sterm,sterml,sterml) determ (i,i,o).
treEPV1 : (sterm,sterml,sterml) determ (i,i,o).
treEPV2 : (sterm,sterm,sterm) determ (i,i,o).
clauses
% replaces pure variables inside PROC sub-trees with the value/expression assigned to
% the pure variable (since pure variables cannot be handled inside procedure calls)
%
% @@ Is the cmp("PROC structure used anymore? (14.7.3)
treElimProcVars(Tree,cmp("PROC",[P|Args]),cmp("PROC",[P|ArgsM])) :- treEPV1(Tree,Args,ArgsM),!.
treElimProcVars(Tree,cmp(H,T),cmp(H,Tm)) :- treElimProcVarsX(Tree,T,Tm),!.
treElimProcVars(_,T,T) :- !.
treElimProcVarsX(_,[],[]) :- !.
treElimProcVarsX(Tree,[H|T],[Hm|Tm]) :-
	treElimProcVars(Tree,H,Hm),
	treElimProcVarsX(Tree,T,Tm),!.
	
treEPV1(_,[],[]) :- !.
treEPV1(Tree,[H|T],[Hm|Tm]) :-
	treEPV2(Tree,H,Hm),
	treEPV1(Tree,T,Tm),!.
treEPV2(_,fvar(Var,D),fvar(Var,D)) :-
	% DE Var - no substitution
	vars::varDE_Var(Var,_),
	!.
treEPV2(Tree,fvar(Var,_),Val) :-
	% the variable is a pure variable which has to be substituted
	treVarVal(Tree,Var,Val1),
	% replace pure variables in the substituting value
	treEPV2(Tree,Val1,Val),!
;
	sx::concat(["Variable '",Var,"' cannot be referred within a procedure call"],S1),
	dlgIF::feil("treEPV2",[S1,Var],[],Tree),
	!,fail.
treEPV2(Tree,cmp(H,T),cmp(H,Tm)) :- treEPV1(Tree,T,Tm),!.
treEPV2(_,T,T) :- !.
% ------------------------------------------------------------------------------------------------------------
% treIsAlias                         
% ------------------------------------------------------------------------------------------------------------
% parameters:
% 1	in	list of variable-alias pairs
% 2	in	alias
% 3	out	(2)'s original variable
% 4	out	the original variable's domain
% fails if (2) is not an alias variable
% 9.1.96
%
treIsAlias([cmp(V,[fvar(AV,Dom)])|_],AV,V,Dom) :- !.
treIsAlias([_|T],AV,V,Dom) :- treIsAlias(T,AV,V,Dom),!.			
% ------------------------------------------------------------------------------------------------------------
% treSubstAlias                         
% ------------------------------------------------------------------------------------------------------------
class predicates
treSubstAliasX : (sterml,sterml,sterml) determ (i,i,o).
%subst_exp(sterml,sterm,sterm)
clauses
% substitutes all occurrences in expressions (unconditionally) of a variable-alias with the original
% variable on the basis of the given alias list
%
treSubstAlias(Aliases,fvar(AV,_),fvar(V,Dom)) :- 
	treIsAlias(Aliases,AV,V,Dom),!.
treSubstAlias(_,fvar(V,D),fvar(V,D)) :- 
	!.
treSubstAlias(Aliases,cmp(UOpr,[Exp]),cmp(Uopr,[SExp])) :-
	opr::opr_any(UOpr,1),
	treSubstAlias(Aliases,Exp,SExp),!.
treSubstAlias(Aliases,cmp(BOpr,[Exp1,Exp2]),cmp(BOpr,[SExp1,SExp2])) :-
	opr::opr_any(BOpr,2),
	treSubstAlias(Aliases,Exp1,SExp1),
	treSubstAlias(Aliases,Exp2,SExp2),!.
treSubstAlias(Aliases,cmp("DFNC",[F|ParExps]),cmp("DFNC",[F|SParExps])) :-
	treSubstAliasX(Aliases,ParExps,SParExps),!.
treSubstAlias(Aliases,cmp("NFNC",[F|ParExps]),cmp("NFNC",[F|SParExps])) :-
	treSubstAliasX(Aliases,ParExps,SParExps),!.
treSubstAlias(Aliases,cmp("PROC",[P,V]),cmp("PROC",[P,Vs])) :-
	treSubstAlias(Aliases,V,Vs),!.
treSubstAlias(Aliases,cmp("PROC",[P,V1,V2]),cmp("PROC",[P,Vs1,Vs2])) :-
	treSubstAlias(Aliases,V1,Vs1),
	treSubstAlias(Aliases,V2,Vs2),!.
treSubstAlias(Aliases,cmp("PROC",[P,V1,V2,V3]),cmp("PROC",[P,Vs1,Vs2,Vs3])) :-
	treSubstAlias(Aliases,V1,Vs1),
	treSubstAlias(Aliases,V2,Vs2),
	treSubstAlias(Aliases,V3,Vs3),!.
treSubstAlias(Aliases,cmp(H,L),cmp(H,SL)) :- 
	treSubstAliasX(Aliases,L,SL),!.
treSubstAlias(_,T,T) :- 
	!.
treSubstAliasX(_,[],[]) :- 
	!.
treSubstAliasX(Aliases,[H|T],[SH|ST]) :-
	treSubstAlias(Aliases,H,SH),
	treSubstAliasX(Aliases,T,ST),!.
% ------------------------------------------------------------------------------------------------------------
% treMoveConclusionConds                       
% ------------------------------------------------------------------------------------------------------------
class predicates
add_conditions : (sterml,sterm) determ (i,o).
conditions : (sterm,sterml,sterml,sterm) procedure (i,i,o,o).
conditions_x : (sterml,sterml,sterml,sterml) determ (i,i,o,o).
clauses
% moves attribute conditions in the conclusion tree (if any) to the 
% condition tree.
%
treMoveConclusionConds(Cond,Conc,CondR,ConcR) :-
	conditions(Conc,[],Conds,Conc1),
	treElimNill(Conc1,ConcR),
	add_conditions([Cond|Conds],CondR),!.
	
conditions(cmp("ATTR_CONDS",A),Cc,Cr,nill) :- set::conc([A,Cc],Cr),!.
conditions(cmp("ATTR_VALS",A),Cc,Cr,nill) :- set::conc([A,Cc],Cr),!.
conditions(cmp(H,T),Cc,Cr,cmp(H,Tr)) :- conditions_x(T,Cc,Cr,Tr),!.
conditions(T,C,C,T) :- !.
conditions_x([],C,C,[]) :- !.
conditions_x([H|T],Cc,Cr,[Hr|Tr]) :-
	conditions(H,Cc,C1,Hr),
	conditions_x(T,C1,Cr,Tr),!.
add_conditions([Cond],Cond) :- !.
add_conditions([H|T],cmp("&",[H,Ta])) :- add_conditions(T,Ta),!.			
% ------------------------------------------------------------------------------------------------------------
% treStructText
% ------------------------------------------------------------------------------------------------------------
class predicates
treStructTexts : (string,sterml,string) determ (i,i,o).
treStructList : (string,sterm,string) determ (i,i,o).
clauses
% converts a tree-structure to structured text
%
treStructText(Ind,T,S) :-
	T=cmp(H,L),
	IndM=string::concat("     ",Ind),
	treStructTexts(IndM,L,S2),
	sx::concat([Ind,"cmp(\"",H,"\"\n",IndM,"[\n",S2],S),
	!
;
	T=list(H,L),
	IndM=string::concat("     ",Ind),
	treStructText(IndM,H,S2),
	treStructList(IndM,L,S3),
	sx::concat([Ind,"list(\n",S2,S3],S),
	!
;
	S2=toString(T),
	sx::concat([Ind,S2,"\n"],S),
	!.
treStructTexts(Ind,[],S) :-
	sx::concat([Ind,"]\n"],S),
	!.
treStructTexts(Ind,[H|T],S) :-
	treStructText(Ind,H,S2),
	treStructTexts(Ind,T,S3),
	sx::concat([S2,S3],S),
	!.
treStructList(Ind,nill,S) :-
	sx::concat([Ind,"nill)\n"],S),
	!.
treStructList(Ind,list(H,L),S) :-
	treStructText(Ind,H,S2),
	sx::sxTail(1,S2,S3,_),
	treStructList(Ind,L,S4),
	sx::concat([S3,",\n",S4],S),
	!.	
% ------------------------------------------------------------------------------------------------------------
% treVarVal
% ------------------------------------------------------------------------------------------------------------
class predicates
treVarValX : (sterml,string,sterm) determ (i,i,o).
clauses
% parameters:
% 1	in	3BQ (sub-)tree
% 2	in	variable
% 3	out	value assigned to P#2 in P#1
% returns the value/expression assigned to the given variable
% fails if no value is assigned to the given variable
%
treVarVal(cmp(Opr,[fvar(Var,_),Val]),Var,Val) :- opr::oprEq(Opr),!.
treVarVal(cmp(_,T),Var,Val) :- treVarValX(T,Var,Val),!.
treVarValX([H|T],Var,Val) :-
	treVarVal(H,Var,Val),!
;
	treVarValX(T,Var,Val),!.	
% ------------------------------------------------------------------------------------------------------------
% treVarList                       
% ------------------------------------------------------------------------------------------------------------
class predicates
treVarLists : (sterml,sterml,sterml) determ (i,i,o).
clauses
% generates a list of all variables occurring anywhere in the given tree
% 9.1.96
%	
treVarList(cmp(_,T),Vc,Vr) :- treVarLists(T,Vc,Vr),!.
treVarList(fvar(V,_),Vc,[str(V)|Vc]) :- not(set::member(str(V),Vc)),!.
treVarList(_,V,V) :- !.
treVarLists([],V,V) :- !.
treVarLists([H|T],Vc,Vr) :-
	treVarList(H,Vc,V1),
	treVarLists(T,V1,Vr),!.
end implement struc
