/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement syn
open core,termDomain,globalDomains

constants
className = "com/rudstrand/syn/syn".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

class predicates
adjustMDE_Vals : (sterml,sterml) determ (i,o).
synSSS : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synAbout : (pie_scan::wrd,sterm) determ (i,o).
synAtomEntityDefinition : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synBinaryPredicateFact : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synConclusion : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synCondition : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synConditionList : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synConditions : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synCR_Parameter : (string,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,o,o).
synEntityDefinition : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
synFact : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synFunctionDef : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synFunctionBody : (string,string,pie_scan::wrds,pie_scan::wrds,sterml) nondeterm (i,i,i,o,o).
synFunctionParameter : (string,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,o,o).
synFunctionStatement : (string,string,pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,i,i,o,o).
synImplicationRule : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synQuery : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synPredicateCondition : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synSRFQ : (char,pie_scan::wrds,sterm) determ (i,i,o).
synST : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synUnaryPredicateFact : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synAtomEntityCondition : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synDE_ValueList : (string,pie_scan::wrds,pie_scan::wrds,sterml) determ (i,i,o,o).
synDE_PureValueList : (string,pie_scan::wrds,pie_scan::wrds,sterml) determ (i,i,o,o).
synRange : (string,string,string,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,i,i,o,o).
synSSS_Val : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
synUnaryOpLiteral : (string,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,o,o).
sbGenDummyDE_Conds : (sterml,sterml,sterml) determ (i,i,o).
sbMonth : (string,integer) determ (i,o).
synBinaryOper : (pie_scan::wrds,pie_scan::wrds,string) determ (i,o,o).
synBinaryPredicateCondition : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synBracketedExpr : (string,pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,i,o,o).
derfDE : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
synDE_Cond : (sterml,pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,i,o,o).
synDE_CondList : (sterml,pie_scan::wrds,pie_scan::wrds,sterml) nondeterm (i,i,o,o).
synDERF : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synDE_PureValue : (string,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,o,o).
synExpression : (string,pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,i,o,o).
synFunctionCall : (string,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,o,o).
synPredicateArgument : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synPredicateTailUnary : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
synPredicateTailBinary : (sterm,pie_scan::wrds,pie_scan::wrds,sterm) determ (i,i,o,o).
synUnaryPredicateCondition : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
synVariableExpression : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
sbMatchAndRemove : (string,sterml,string,sterml) determ (i,i,o,o).
sbTokenMatch : (pie_scan::wrd,pie_scan::wrd) determ (i,i).
sbTokenOR : (pie_scan::wrds,pie_scan::wrds,pie_scan::wrds) determ (i,i,o).
sbTraceType : (string,string) determ (i,o) (o,i).
sbVarDomains : (sterm,sterm) procedure (i,o).
clauses
% ------------------------------------------------------------------------------------------------------------
% synAnalysis                                           
% ----------------------------------------------------------------------------------------------
synAnalysis(TermChar,P,SynTree) :- 
	synSRFQ(TermChar,P,SynTree2),
	sbVarDomains(SynTree2,SynTree),
	!
;
	N=globalVars::get_i("syn_max"),
	Ns=toString(N),
	sx::concat(["Syntax analysis which reached word triplet ",Ns," failed."],Mess),
	dlgIF::msgS(Mess),
	tt::tt_wrds(1,"Scanned word triplets",P),
	fail.	
% ------------------------------------------------------------------------------------------------------------
% synComponentAnalysis                                           
% ----------------------------------------------------------------------------------------------
synComponentAnalysis(P,Tree) :- 
	synCR_Parameter("",P,R,Tree2),
	R=[],
		sbVarDomains(Tree2,Tree),
	!.
% ----------------------------------------------------------------------------------------------
% synAbout                                                  
% ----------------------------------------------------------------------------------------------
synAbout(pie_scan::w(_,A,"p3_dts",_),str(A)) :- !.
synAbout(pie_scan::w(_,A,"p3_dli",_),str(A)) :- !.
synAbout(pie_scan::w(_,A,"p3_din",_),int(V)) :- V=sx::toInt(A),!.
synAbout(pie_scan::w(_,A,"p3_dnu",_),fix(V)) :- V=sx::toReal(A),!.
synAbout(pie_scan::w(_,A,"p3_dif",_),atom(A)) :- !.
synAbout(pie_scan::w(_,A,"p3_iET",_),atom(A)) :- !.
% @@ what about other syntax classes p3_iET, p3_iDET etc?
% ----------------------------------------------------------------------------------------------
% synAtomEntityDefinition                                                  
% ----------------------------------------------------------------------------------------------
synAtomEntityDefinition(T,Tr,cmp("ENT_ARG",[ET,cmp("ATTR_CONDS",DE_Defs)])) :-
    sbTokenOR_Opt([pie_scan::w(0,"p3_iA","@","@"),pie_scan::w(0,"p3_iThe","@","@")],T,T0),
    T0=[T1|T2],	 
	T1=pie_scan::w(N2,E,"p3_iET",_),
	globalVars::setMax_i("syn_max",N2),
    dbBase::smClassDefF(E,"e",_,DEs,_,_,_),
    DEs=[DE],
    dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
    dbBase::smClassDefTree(E,"e",ET),
	synDE_PureValue(Dom,T2,Tr,Val),
    opr::oprDom(Dom,"=",DOpr),
    DE_Defs=[cmp(DOpr,[fvar(DE,Dom),Val])].
		
synAtomEntityDefinition(T,Tr,cmp("ENT_ARG",[ET,cmp("ATTR_CONDS",DE_Defs)])) :-
    synDE_PureValue("p3_dany",T,T2,_),
    T2=[T3|_],
    T3=pie_scan::w(N2,E,"p3_iET",_),
    globalVars::setMax_i("syn_max",N2),
    dbBase::smClassDefF(E,"e",_,DEs,_,_,_),
    DEs=[DE],
    dbBase::smDefF(DE,_,_,_,Dom,_,_),
    dbBase::smClassDefTree(E,"e",ET),
	% redo parsing of the DE value (since the domain is now known)
	synDE_PureValue(Dom,T,T5,Val),
    T5=[T6|Tr],
	T6=pie_scan::w(_,E2,"p3_iET",_),
    E2=E,
    opr::oprDom(Dom,"=",DOpr),
    DE_Defs=[cmp(DOpr,[fvar(DE,Dom),Val])].
% ----------------------------------------------------------------------------------------------
% synBinaryPredicateFact                                                 
% ----------------------------------------------------------------------------------------------
synBinaryPredicateFact(Tc,Tr,Tree) :-
	% BR
	synEntityDefinition(Tc,T2,EntDef1),
	T2=[T3|T4],
	T3=pie_scan::w(N,RelRep,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
    dbBase::smClassDefF(RelRep,"p",Card,DEs,_,_,_),
    dbBase::smClassDefTree(RelRep,"p",RelDef),
	DEs=[],
	Card=2,
	synEntityDefinition(T4,Tr,EntDef2),
	Tree=cmp("REL_FACT",[RelDef,EntDef1,EntDef2])
;	
	% BRA
	synEntityDefinition(Tc,T2,EntDef1),
	T2=[T3|T4],
	T3=pie_scan::w(N,RelRep,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
    dbBase::smClassDefF(RelRep,"p",Card,DEs,_,_,_),
    dbBase::smClassDefTree(RelRep,"p",RelTyp),
	Card=2,
	synEntityDefinition(T4,T5,EntDef2),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T5,T6),
    dbBase::smDeDefs(DEs,DE_Defs),
	synDE_DefinitionList(-1,DE_Defs,T6,Tr,Vals),
	Tree=cmp("REL_FACT",[RelTyp,EntDef1,EntDef2,cmp("ATTR_CONDS",Vals)])
	.
% -------------------------------------------------------------------------------------------------------------
% synConclusion                       
% -------------------------------------------------------------------------------------------------------------
% the conclusion part of an implication rule
%
synConclusion(Tc,Tr,Tree) :-	
	synFact(Tc,Tr,Tree)
;
	synPredicateCondition(Tc,Tr,Tree)
	.	
% -------------------------------------------------------------------------------------------------------------
% synCondition                      
% -------------------------------------------------------------------------------------------------------------
synCondition([T1,T2|T3],Tr,Tree) :-
	T1=pie_scan::w(N2,"p3_iFals",_,_), 
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,"(",_,_), 
		globalVars::setMax_i("syn_max",N3),
	synPredicateCondition(T3,T4,Tree1),
		T4=[T5|Tr],
	T5=pie_scan::w(N4,")",_,_),
		globalVars::setMax_i("syn_max",N4),
		Tree=cmp("FALSE",[Tree1]).
synCondition([T1|T2],Tr,Tree) :-
	T1=pie_scan::w(N,"p3_iFals",_,_), 
		globalVars::setMax_i("syn_max",N),
	synPredicateCondition(T2,Tr,Tree1),
		Tree=cmp("FALSE",[Tree1]).
synCondition([T1,T2|T3],Tr,Tree) :-
	T1=pie_scan::w(N2,"p3_iTrue",_,_), 
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,"(",_,_), 
		globalVars::setMax_i("syn_max",N3),
	synPredicateCondition(T3,T4,Tree),
		T4=[T5|Tr],
	T5=pie_scan::w(N4,")",_,_),
		globalVars::setMax_i("syn_max",N4).
synCondition([T1|T2],Tr,Tree) :-
	T1=pie_scan::w(N,"p3_iTrue",_,_), 
		globalVars::setMax_i("syn_max",N),
	synPredicateCondition(T2,Tr,Tree).
synCondition(T,Tr,Tree) :-
	synPredicateCondition(T,Tr,Tree)
;
	synVariableExpression(T,Tr,Tree)
	.	
% -------------------------------------------------------------------------------------------------------------
% synConditions                       
% -------------------------------------------------------------------------------------------------------------
synConditions(T,Tr,Tree) :-
	synConditionList(T,T1,Tree1),
	T1=[T2,T3|T4],
	T2=pie_scan::w(N2,";",_,_), 
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,"p3_oOR",_,_),!, 
		globalVars::setMax_i("syn_max",N3),
	synConditions(T4,Tr,Tree2),
	Tree=cmp("OR",[Tree1,Tree2])
;
	synConditionList(T,Tr,Tree)
	.	
% -------------------------------------------------------------------------------------------------------------
% synConditionList                     
% -------------------------------------------------------------------------------------------------------------
synConditionList(T,Tr,Tree) :-
	synCondition(T,T1,Tree1),
		T1=[T2|T3],
	T2=pie_scan::w(N,",",_,_), 
		globalVars::setMax_i("syn_max",N),
	synConditionList(T3,Tr,Tree2),
		Tree=cmp("&",[Tree1,Tree2])
;
	synCondition(T,T1,Tree1),
		T1=[T2|T3],
	T2=pie_scan::w(N,"p3_iAnd",_,_), 
		globalVars::setMax_i("syn_max",N),
	synCondition(T3,Tr,Tree2),
		Tree=cmp("&",[Tree1,Tree2])
;
	synCondition(T,Tr,Tree)
	.
% ----------------------------------------------------------------------------------------------
% synCR_Parameter                                          
% ----------------------------------------------------------------------------------------------
synCR_Parameter(_,[T2,T3|Tr],Tr,Tree) :-
	T2=pie_scan::w(N2,"p3_iThis",_,_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		vars::varFuncPar("p3_iThis",DE,Par),
        dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		Tree=fvar(Par,Dom),
	!.
synCR_Parameter(CR,[T1,T2,T3|Tr],Tr,Tree) :-
	CR="", % no CR given
	T1=pie_scan::w(N1,C,"p3_iIR",_),
		globalVars::setMax_i("syn_max",N1),
	T2=pie_scan::w(N2,":",_,_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		vars::varFuncPar(C,DE,Par),
        dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		Tree=fvar(Par,Dom),
	!
;
	T1=pie_scan::w(N1,C,"p3_iIR",_),
	C=CR,
		globalVars::setMax_i("syn_max",N1),
	T2=pie_scan::w(N2,":",_,_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		vars::varFuncPar(CR,DE,Par),
        dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		Tree=fvar(Par,Dom),
	!.
% ----------------------------------------------------------------------------------------------
% synEntityDefinition                                                  
% ----------------------------------------------------------------------------------------------
% parses a complete entity (i.e. with values for all data elements - note however that list
% domain data elements can be left out when the value is the empty list).
%
synEntityDefinition(T,Tr,cmp("ENT_ARG",[ET,cmp("ATTR_CONDS",AttDefs)])) :-
    sbTokenOR_Opt([pie_scan::w(0,"p3_iA","@","@"),pie_scan::w(0,"p3_iThe","@","@")],T,T0),
    T0=[T1,T2|T3],	 
	T1=pie_scan::w(N2,E,"p3_iET",_),
	globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,"p3_iWith",_,_),
	globalVars::setMax_i("syn_max",N3),
    dbBase::smClassDefF(E,"e",_,DEs,_,_,_),
    dbBase::smDeDefs(DEs,DE_Defs),
	synDE_DefinitionList(-1,DE_Defs,T3,Tr,AttDefs),
	dbBase::smClassDefTree(E,"e",ET),
	!.
synEntityDefinition(T,Tr,Tree) :-
	synAtomEntityDefinition(T,Tr,Tree),
	!.
% -------------------------------------------------------------------------------------
% synFact                     
% -------------------------------------------------------------------------------------
synFact(T,Tr,Tree) :- 
	synBinaryPredicateFact(T,Tr,Tree)
;
	synUnaryPredicateFact(T,Tr,Tree)
	.
% -------------------------------------------------------------------------------------
% synFunctionBody                   
% -------------------------------------------------------------------------------------
synFunctionBody(Func,Dom,Tc,Tr,Trees) :- 
	synFunctionStatement(Func,Dom,Tc,T1,S1),
	T1=[T2|T3],
	T2=pie_scan::w(N,";",_,_),
		globalVars::setMax_i("syn_max",N),
	synFunctionBody(Func,Dom,T3,Tr,S2),
			Trees=[S1|S2].
synFunctionBody(Func,Dom,Tc,Tr,[S]) :- 
	synFunctionStatement(Func,Dom,Tc,Tr,S).
% -------------------------------------------------------------------------------------
% synFunctionDef                   
% -------------------------------------------------------------------------------------
synFunctionDef([T2|T3],Tr,Tree) :-
	T2=pie_scan::w(N2,F,"p3_iFunc",_),
		globalVars::setMax_i("syn_max",N2),
    dbBase::smDefF(F,Clas,_,_,Dom,_,_),
	set::member(Clas,["f","g"]),
    dbBase::smClassDefTree(F,Clas,PreDef),
		T3=[T5|T7],
	T5=pie_scan::w(N3,"p3_iIdefb",_,_),
		globalVars::setMax_i("syn_max",N3),
	synFunctionBody(F,Dom,T7,Tr,Body),
		Tree=cmp("FDEF",[PreDef,cmp("BODY",Body)]).
% ----------------------------------------------------------------------------------------------
% synFunctionParameter                                          
% ----------------------------------------------------------------------------------------------
synFunctionParameter(F,[T2,T3|Tr],Tr,Tree) :-
	F<>"",
	T2=pie_scan::w(N2,"p3_iThis",_,_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		vars::varFuncPar(F,DE,Par),
        dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		Tree=fvar(Par,Dom),
	!.
synFunctionParameter(F,[T1,T2,T3|Tr],Tr,Tree) :-
	F="", % no function given
	T1=pie_scan::w(N1,C,"p3_iFunc",_),
		globalVars::setMax_i("syn_max",N1),
	T2=pie_scan::w(N2,":",_,_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		vars::varFuncPar(C,DE,Par),
        dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		Tree=fvar(Par,Dom),
	!
;
	T1=pie_scan::w(N1,C,"p3_iFunc",_),
	C=CR,
		globalVars::setMax_i("syn_max",N1),
	T2=pie_scan::w(N2,":",_,_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		vars::varFuncPar(CR,DE,Par),
        dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		Tree=fvar(Par,Dom),
	!.
% ----------------------------------------------------------------------------------------------
% synFunctionStatement                                             
% ----------------------------------------------------------------------------------------------
synFunctionStatement(_,_,[T|Tr],Tr,Tree) :-
	T=pie_scan::w(N,"p3_iNdFn",_,_),
		globalVars::setMax_i("syn_max",N),
		Tree=atom("p3_iNdFn"),
	!.
synFunctionStatement(Func,_,T,Tr,Tree) :-
	synFunctionParameter(Func,T,T2,Par),
	synBinaryOper(T2,T3,Oper),
		Par=fvar(_,Dom),
	synDE_Value(Dom,T3,Tr,E),
		Tree=cmp(Oper,[Par,E]),
	!.
synFunctionStatement(Func,Dom,[T1|T2],Tr,Tree) :-
	T1=pie_scan::w(N,V,"p3_dvar",_),
		globalVars::setMax_i("syn_max",N),
	synBinaryOper(T2,T3,Oper),
	synDE_Value("p3_dany",T3,Tr,E),
		Tree=cmp(Oper,[var(V),E])
;
	% return-value statement	
	T1=pie_scan::w(N,"p3_iFRet",_,_),
		globalVars::setMax_i("syn_max",N),
	synBinaryOper(T2,T3,Oper),
	synDE_Value("p3_dany",T3,Tr,E),
		sx::frontchar(Func,Fr,Tail),
		Fs=string::charToString(Fr),
		Fu=string::toUpperCase(Fs),
		RetVar=string::concat(Fu,Tail),
		Tree=cmp(Oper,[fvar(RetVar,Dom),E]),
	!.
synFunctionStatement(Func,Dom,[T1,T2|T3],Tr,Tree) :-
	T1=pie_scan::w(N2,"p3_iFals",_,_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,"(",_,_),
		globalVars::setMax_i("syn_max",N3),
	synFunctionStatement(Func,Dom,T3,T4,Tree1),
		T4=[T5|Tr],
	T5=pie_scan::w(N4,")",_,_),
		globalVars::setMax_i("syn_max",N4),
		Tree=cmp("FALSE",[Tree1])
;	
	T1=pie_scan::w(N2,Typ,_,_),
		globalVars::setMax_i("syn_max",N2),
	sbTraceType(Typ,TDom),
	T2=pie_scan::w(N3,":",_,_),
		globalVars::setMax_i("syn_max",N3),
	synDE_Value(TDom,T3,Tr,E),
		Tree=cmp("TRACE",[atom(TDom),E]),
	!.
synFunctionStatement(_,_,T,Tr,Tree) :-
	synST(T,Tr,Tree)
	.
% -------------------------------------------------------------------------------------
% synImplicationRule                       
% -------------------------------------------------------------------------------------
synImplicationRule([T1|T],Tr,Tree) :-
	T1=pie_scan::w(N2,"p3_iOtp",_,_),
		globalVars::setMax_i("syn_max",N2),
	synConditions(T,T2,Tree1),
	T2=[T3,T4|T5],
	T3=pie_scan::w(N3,",",_,_),
		globalVars::setMax_i("syn_max",N3),
	T4=pie_scan::w(N4,"p3_iIbc",_,_),
		globalVars::setMax_i("syn_max",N4),
	synConclusion(T5,Tr,Tree2),
	Tree=cmp("=>",[Tree1,Tree2]).
/*
% ----------------------------------------------------------------------------------------------
% synSetImplicationRule                                                  
% ----------------------------------------------------------------------------------------------
nondeterm	synSetImplicationRule(pie_scan::wrds,pie_scan::wrds,sterm)
synSetImplicationRule([T1|T],Tr,Tree) :-
	T1=pie_scan::w(N2,"p3_iOsp",_,_),!,
		globalVars::setMax_i("syn_max",N2),
	synConditions(T,T2,Tree1),
		T2=[T4,T5|T6],
	T4=pie_scan::w(N3,",",_,_),
		globalVars::setMax_i("syn_max",N3),
	T5=pie_scan::w(N4,"p3_iIbc",_,_),
		globalVars::setMax_i("syn_max",N4),
	synPredicateCondition(T6,Tr,Tree2),
		Tree=cmp("N=>M",[Tree1,Tree2]).
*/
% ----------------------------------------------------------------------------------------------
% synPredicateCondition                                             
% ----------------------------------------------------------------------------------------------
synPredicateCondition(T,Tr,Tree) :- 
	synUnaryPredicateCondition(T,Tr,Tree)
;	
	synBinaryPredicateCondition(T,Tr,Tree).
% -------------------------------------------------------------------------------------
% synQuery                       
% -------------------------------------------------------------------------------------
% parses all queries
%
synQuery(T,Tr,Tree) :-
	% all about query
		T=[T1,T2],
	T1=pie_scan::w(N2,"p3_iAb","p3_iIntr",_),
		globalVars::setMax_i("syn_max",N2),
	synAbout(T2,W),
		Tree=cmp("ABOUT",[W]),
		Tr=[]
;
	% function call query
		T=[T1,T2|T3],
	T1=pie_scan::w(N2,_,"p3_iIntr",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Opr,Clas,_),
        	Clas<>"p3_dli",
		globalVars::setMax_i("syn_max",N3),
		opr::oprEq(Opr),
	synFunctionCall("p3_dany",T3,Tr,Tree) 
;	
	% sol set size query
		T=[T1,T2,T3|T4],
	T1=pie_scan::w(N2,_,"p3_iIntr",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Opr,Clas,_),
        	Clas<>"p3_dli",
		globalVars::setMax_i("syn_max",N3),
		opr::oprEq(Opr),
	T3=pie_scan::w(N4,"p3_iSSS",_,_),
		globalVars::setMax_i("syn_max",N4),
	synSSS(T4,Tr,Tree)
;	
	% DERF query
		T=[T1,T2|T3],
	T1=pie_scan::w(N2,_,"p3_iIntr",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Opr,Clas,_),
        	Clas<>"p3_dli",
		globalVars::setMax_i("syn_max",N3),
		opr::oprEq(Opr),
	synDERF(T3,Tr,Tree)
;
	% IS IT TRUE THAT query
		T=[T1|T2],
	T1=pie_scan::w(N,"p3_iIsTr",_,_),
		globalVars::setMax_i("syn_max",N),
	synPredicateCondition(T2,Tr,Cond), %replaced 1.2.6 synSentenceQuery(T2,Tr,Cond),
		Tree=cmp("EX",[Cond])
;	
	synPredicateCondition(T,Tr,Tree), %removed 1.2.6 synSentenceQuery(T,Tr,Tree),
	Tr=[],
	!
;
	synConditions(T,Tr,Tree),
	Tr=[],
	!. 	
% -------------------------------------------------------------------------------------------------------------
% synSRFQ                       
% -------------------------------------------------------------------------------------------------------------
synSRFQ('!',P,SynTree) :-
        sbTokenOR_Opt([pie_scan::w(0,"p3_iAs1","@","@")],P,P1), %@@ no syntagm for p3_iAs1?? 2.5.3
	synImplicationRule(P1,Pr,SynTree),
	Pr=[],
	!
/* will have to be revised 16.4.4
;
        sbTokenOR_Opt([pie_scan::w(0,"p3_iAs1","@","@")],P,P1),
	synSetImplicationRule(P1,Pr,SynTree),
	Pr=[],
	!		
*/
;			
        sbTokenOR_Opt([pie_scan::w(0,"p3_iAs1","@","@")],P,P1),
	synFact(P1,Pr,SynTree),
	Pr=[],
	!
;
	synFunctionDef(P,Pr,SynTree),
	Pr=[],
	!.	
synSRFQ('?',P,SynTree) :-
	synQuery(P,Pr,SynTree),
	Pr=[],
	!.
% ----------------------------------------------------------------------------------------------
% synSSS
% ----------------------------------------------------------------------------------------------
synSSS(T,Tr,Tree) :-
	synUnaryPredicateCondition(T,Tr,PredCond),
		Tree=cmp("#S",[PredCond])
;		
	synBinaryPredicateCondition(T,Tr,PredCond),
		Tree=cmp("#S",[PredCond]).
% ----------------------------------------------------------------------------------------------
% synST
% ----------------------------------------------------------------------------------------------
synST(T,Tr,Tree) :-
	synUnaryPredicateCondition(T,Tr,Tree1),
		Tree=cmp("EX",[Tree1]).
% ----------------------------------------------------------------------------------------------
% synUnaryPredicateFact
% ----------------------------------------------------------------------------------------------
synUnaryPredicateFact(Tc,Tr,Tree) :-
	% UR
	synEntityDefinition(Tc,T2,EntDef),
	T2=[T3|Tr],
	T3=pie_scan::w(N,RelRep,"p3_iPT",_),
    globalVars::setMax_i("syn_max",N),
    dbBase::smClassDefF(RelRep,"p",Card,DEs,_,_,_),
    Card=1,
    DEs=[],
    dbBase::smClassDefTree(RelRep,"p",RelDef),
	Tree=cmp("REL_FACT",[RelDef,EntDef])
;	
	% URA	
	synEntityDefinition(Tc,T2,EntDef),
	T2=[T3|T4],
	T3=pie_scan::w(N,RelRep,"p3_iPT",_),
    globalVars::setMax_i("syn_max",N),
    dbBase::smClassDefF(RelRep,"p",Card,DEs,_,_,_),
    Card=1,
    sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T4,T5),
    dbBase::smClassDefTree(RelRep,"p",RelDef),
    dbBase::smDeDefs(DEs,DE_Defs),
	synDE_DefinitionList(-1,DE_Defs,T5,Tr,Vals),
	Tree=cmp("REL_FACT",[RelDef,EntDef,cmp("ATTR_CONDS",Vals)]).
% ----------------------------------------------------------------------------------------------
% synAtomEntityCondition                                                  
% ----------------------------------------------------------------------------------------------
synAtomEntityCondition(T,Tr,Tree) :-
	T=[T2|T3],
	T2=pie_scan::w(N2,E,"p3_iET",_),
		globalVars::setMax_i("syn_max",N2),
        dbBase::smClassDefF(E,"e",_,DEs,_,_,_),
		DEs=[DE],
		dbBase::smClassDef(DE,"a",_,_,Dom,_,_),
		dbBase::smClassDefTree(E,"e",EntDef),
	synDE_Value(Dom,T3,Tr,Val),
		opr::oprDom(Dom,"=",Oper),
		Cond=[cmp(Oper,[fvar(DE,Dom),Val])],
        	Tree=cmp("ENT_ARG",[EntDef,cmp("ATTR_CONDS",Cond)]).
synAtomEntityCondition(T,Tr,Tree) :-
		synDE_Value("p3_dany",T,T2,_),
		T2=[T3|_],
		T3=pie_scan::w(N2,E,"p3_iET",_),
		globalVars::setMax_i("syn_max",N2),
        dbBase::smClassDefF(E,"e",_,DEs,_,_,_),
		DEs=[DE],
		dbBase::smClassDef(DE,"a",_,_,Dom,_,_),
		dbBase::smClassDefTree(E,"e",EntDef),
	synDE_Value(Dom,T,T4,Val),
		T4=[T5|Tr],
	T5=pie_scan::w(_,E2,"p3_iET",_),
		E=E2,
		opr::oprDom(Dom,"=",Oper),
		Cond=[cmp(Oper,[fvar(DE,Dom),Val])],
        	Tree=cmp("ENT_ARG",[EntDef,cmp("ATTR_CONDS",Cond)]).
% -------------------------------------------------------------------------------------------------------------
% synBinaryOper
% -------------------------------------------------------------------------------------------------------------
synBinaryOper([pie_scan::w(N,Oper,"p3_oBin",_)|T],T,Oper) :- 
		globalVars::setMax_i("syn_max",N),!.
synBinaryOper([pie_scan::w(N,Oper,"p3_oUnBn",_)|T],T,Oper) :- 
		globalVars::setMax_i("syn_max",N),!.
% ----------------------------------------------------------------------------------------------
% synBinaryPredicateCondition                                             
% ----------------------------------------------------------------------------------------------
synBinaryPredicateCondition(T,Tr,Tree) :-
	% BR 
	synPredicateArgument(T,T1,Tree1),
	sbTokenOR_Opt([pie_scan::w(0,"p3_iWhi","@","@")],T1,T1b),
    T1b=[T2|T3],
	T2=pie_scan::w(N,Rel,"p3_iPT",_),
    globalVars::setMax_i("syn_max",N),
    dbBase::smClassDef(Rel,"p",Card,_,_,_,Npds),
    Card=2,
    Npds=0,
    dbBase::smClassDefTree(Rel,"p",PDef),
	synPredicateArgument(T3,Tr,Tree2),
    Tree=cmp("REL_COND",[PDef,Tree1,Tree2])
;
	% BRA with conditions
	synPredicateArgument(T,T1,Tree1),
	sbTokenOR_Opt([pie_scan::w(0,"p3_iWhi","@","@")],T1,T1b),
		T1b=[T2|T3],
	T2=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
    dbBase::smClassDef(Rel,"p",Card,DEs,_,_,Npds),
    Card=2,
    Npds>0,
    dbBase::smClassDefTree(Rel,"p",PDef),
    dbBase::smDeDefs(DEs,DE_Defs),
	synPredicateArgument(T3,T4,Tree2),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T4,T5),
		synDE_CondList(DE_Defs,T5,Tr,DE_Conds),
		sbGenDummyDE_Conds(DE_Defs,DE_Conds,Conds),
		Tree=cmp("REL_COND",[PDef,Tree1,Tree2,cmp("ATTR_CONDS",Conds)])
;		
	% BRA without conditions
	synPredicateArgument(T,T1,Tree1),
	sbTokenOR_Opt([pie_scan::w(0,"p3_iWhi","@","@")],T1,T1b),
    T1b=[T2|T3],
	T2=pie_scan::w(N,Rel,"p3_iPT",_),
    globalVars::setMax_i("syn_max",N),
    dbBase::smClassDef(Rel,"p",Card,DEs,_,_,Npds),
    Card=2,
    Npds>0,
    dbBase::smClassDefTree(Rel,"p",PDef),
    dbBase::smDeDefs(DEs,DE_Defs),
	synPredicateArgument(T3,Tr,Tree2),
    sbGenDummyDE_Conds(DE_Defs,[],Conds),
    Tree=cmp("REL_COND",[PDef,Tree1,Tree2,cmp("ATTR_CONDS",Conds)]).
% ----------------------------------------------------------------------------------------------
% synBracketedExpr
% ----------------------------------------------------------------------------------------------
% parses a bracketed expression value 
% (left parenthesis is already parsed)
%
synBracketedExpr(Dom,[T1|T],Tr,Tree) :-
	T1=pie_scan::w(N2,"(",_,_),
		globalVars::setMax_i("syn_max",N2),
	synExpression(Dom,T,T2,Tree),
	T2=[pie_scan::w(N3,")",_,_)|Tr],
		globalVars::setMax_i("syn_max",N3).
% -------------------------------------------------------------------------------------------------------------
% derfDE
% -------------------------------------------------------------------------------------------------------------
class predicates
derfDE_qual : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
derfDE_unqual : (pie_scan::wrds,pie_scan::wrds,sterm) determ (i,o,o).
clauses

derfDE(T,Tr,Tree) :-
    derfDE_qual(T,Tr,Tree),
    !
;
    derfDE_unqual(T,Tr,Tree),
    !.
    
derfDE_qual(T,Tr,Tree) :-
    % dataelement[0] or complex's dataelement[1]
    derfDE_unqual(T,T2,Tree2),
    Tree2=atom(DE),
    T2=[T3,T4,T5|Tr],
	T3=pie_scan::w(N2,"[",_,_),
		globalVars::setMax_i("syn_max",N2),
	T4=pie_scan::w(N3,SNo,"p3_din",_),
	No=sx::toInt(SNo),
	No>=0,
	No<=2,
		globalVars::setMax_i("syn_max",N3),
	T5=pie_scan::w(N4,"]",_,_),
		globalVars::setMax_i("syn_max",N4),
    S=string::concat(SNo,".",DE),
    Tree=atom(S),
    !
;
    % entity's dataelement or entity's complex's dataelement
    T=[T2,T3|T4],
	T2=pie_scan::w(N2,ET,"p3_iET",_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,":",_,_),
		globalVars::setMax_i("syn_max",N3),
    derfDE_unqual(T4,Tr,Tree2),
    Tree2=atom(DE),
		sx::concat([ET,".",DE],S),
		Tree=atom(S),
	!
;
    % predicate
    T=[T2,T3|T4],
	T2=pie_scan::w(N2,PT,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N2),
	T3=pie_scan::w(N3,":",_,_),
		globalVars::setMax_i("syn_max",N3),
    derfDE_unqual(T4,Tr,Tree2),
    Tree2=atom(DE),
		sx::concat([PT,".",DE],S),
		Tree=atom(S),
	!.
    
derfDE_unqual(T,Tr,Tree) :-
	T=[T2|Tr],
	T2=pie_scan::w(N2,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N2),
		Tree=atom(DE),
	!.
% -------------------------------------------------------------------------------------------------------------
% synDE_Cond
% -------------------------------------------------------------------------------------------------------------
class predicates
match_att : (string,sterml,string) determ (i,i,o).
clauses

synDE_Cond(Attrs,[T1|T],Tr,Tree) :-
	T1=pie_scan::w(N,Att,"p3_iDET",_),
    globalVars::setMax_i("syn_max",N),
    match_att(Att,Attrs,Dom),
	synBinaryOper(T,T2,Oper),
    opr::oprEq(Oper),
    opr::oprDom(Dom,Oper,DOper),
	synDE_Value(Dom,T2,Tr,Val),
    Tree=cmp(DOper,[fvar(Att,Dom),Val])
;
	T1=pie_scan::w(N,Att,"p3_iDET",_),
    globalVars::setMax_i("syn_max",N),
    match_att(Att,Attrs,Dom),
	synBinaryOper(T,T2,Oper),
	synDE_Value(Dom,T2,Tr,Val),
    Tree=cmp(Oper,[fvar(Att,Dom),Val]).
synDE_Cond(Attrs,[T1,T2|T],Tr,Tree) :-
	T1=pie_scan::w(_,Att,"p3_iDET",_),
	T2=pie_scan::w(N,Rng,_,_),
	set::member(Rng,["inside","outside"]),
    globalVars::setMax_i("syn_max",N),
    match_att(Att,Attrs,Dom),
    Range=string::concat(Rng,"x"),
	synRange(Range,Att,Dom,T,Tr,Val),
    Tree=cmp(Rng,[fvar(Att,Dom),Val]).
synDE_Cond(Attrs,[T1|T],Tr,Tree) :-
% '=' is assumed if no operator is present
%
	T1=pie_scan::w(N,Att,"p3_iDET",_),
    globalVars::setMax_i("syn_max",N),
    match_att(Att,Attrs,Dom),
	synDE_Value(Dom,T,Tr,Val),
    opr::oprDom(Dom,"=",Oper),
    Tree=cmp(Oper,[fvar(Att,Dom),Val]).
	
match_att(Att,[fstr(Att,Dom,_,_)|_],Dom) :- !.
match_att(Att,[_|T],Dom) :- match_att(Att,T,Dom),!.
% -------------------------------------------------------------------------------------------------------------
% synDE_CondList
% -------------------------------------------------------------------------------------------------------------
synDE_CondList(Attrs,Tc,Tr,[H|AttDefs]) :-
	synDE_Cond(Attrs,Tc,T4,H),
	T4=[pie_scan::w(N,",",_,_)|T5],	
		globalVars::setMax_i("syn_max",N),
	synDE_CondList(Attrs,T5,Tr,AttDefs).
synDE_CondList(Attrs,Tc,Tr,[H1,H2]) :-
	synDE_Cond(Attrs,Tc,T4,H1),
	T4=[pie_scan::w(N,"p3_iAnd",_,_)|T5],	
		globalVars::setMax_i("syn_max",N),
	synDE_Cond(Attrs,T5,Tr,H2).
	
synDE_CondList(Attrs,Tc,Tr,[H]) :- 
	synDE_Cond(Attrs,Tc,Tr,H).
% ------------------------------------------------------------------------------------------------------------
% synDE_DefinitionList
% ------------------------------------------------------------------------------------------------------------
% parses data element/value pairs for:
% - entity definition data element values
% - predicate definition data element values
% - function call parameters
% data element/value pairs are parsed in the sequence they appear in the input sentence
% (i.e. not in the sequence of the entity DE definition list)
% parameters:
% 1	in	1=list of parameters; -1=list of entity/predicate DE
% 2	in	data element types (from definition)
% 3	in	token list (before parse) - does not need to follow order of p#2
% 4	out	"	   (after parse)
% 5	out	values corr. to p#2
%
class predicates
synDE_Definition : (integer,pie_scan::wrds,pie_scan::wrds,string,sterm) determ (i,i,o,o,o).
clauses

synDE_DefinitionList(1,[],T,T,[]) :-
	!. 
synDE_DefinitionList(-1,[],_,_,_) :-
	!,fail. 
synDE_DefinitionList(Flag,DEs,T,Tr,Vals) :-
	DEs=[DE],
	DE=fstr(Dk,_,_,_),
	synDE_Definition(Flag,T,Tr,D,V),
	D=Dk,
	Vals=[V],
	!
;
	set::size(DEs,Nd),
	Nd=2,
	synDE_Definition(Flag,T,T2,DE,V),
	sbMatchAndRemove(DE,DEs,_,DEsRem),
	T2=[pie_scan::w(N,"p3_iAnd",_,_)|T3],	
		globalVars::setMax_i("syn_max",N),
	synDE_DefinitionList(Flag,DEsRem,T3,Tr,Vs),
	Vals=[V|Vs],
	!
;
	set::size(DEs,Nd),
	Nd>2,
	synDE_Definition(Flag,T,T2,DE,V),
	sbMatchAndRemove(DE,DEs,_,DEsRem),
	T2=[pie_scan::w(N,",",_,_)|T3],	
		globalVars::setMax_i("syn_max",N),
	synDE_DefinitionList(Flag,DEsRem,T3,Tr,Vs),
	Vals=[V|Vs],
	!.
	
% parameter values can be expressions
%
synDE_Definition(1,[T1,T2|T3],Tr,DE,cmp(DOpr,[fvar(DE,Dom),Val])) :-	
	T1=pie_scan::w(N2,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N2),
		dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
	T2=pie_scan::w(N3,Opr,Clas,_),
	Clas<>"p3_dli",
	opr::oprEq(Opr),
		globalVars::setMax_i("syn_max",N3),
		opr::oprDom(Dom,"=",DOpr),
	synDE_Value(Dom,T3,Tr,Val),
	!.
	
synDE_Definition(1,[T1|T2],Tr,DE,cmp(DOpr,[fvar(DE,Dom),Val])) :-	
	T1=pie_scan::w(N,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N),
		dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
	synDE_Value(Dom,T2,Tr,Val),
		opr::oprDom(Dom,"=",DOpr),
	!.
% entity/predicate DE values can only be pure values
%
synDE_Definition(-1,[T1,T2|T3],Tr,DE,cmp(DOpr,[fvar(DE,Dom),Val])) :-	
	T1=pie_scan::w(N2,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N2),
		dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
	T2=pie_scan::w(N3,Opr,Clas,_),
	Clas<>"p3_dli",
	opr::oprEq(Opr),
		globalVars::setMax_i("syn_max",N3),
		opr::oprDom(Dom,"=",DOpr),
	synDE_PureValue(Dom,T3,Tr,Val),
	!.
synDE_Definition(-1,[T1|T2],Tr,DE,cmp(DOpr,[fvar(DE,Dom),Val])) :-	
	T1=pie_scan::w(N,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N),
		dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
	synDE_PureValue(Dom,T2,Tr,Val),
		opr::oprDom(Dom,"=",DOpr),
	!.
% value is an empty-list
%
synDE_Definition(_,[T1,T2|Tr],Tr,DE,cmp(DOpr,[fvar(DE,Dom),cmp(Dom,[])])) :-	
	T1=pie_scan::w(N2,"p3_iNon",_,_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,DE,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N3),
		dbBase::smClassDefF(DE,"a",_,_,Dom,_,_),
		sx::sxTail(2,Dom,GenDom,Tail),
		Tail="_l",
		opr::oprDom(GenDom,"=",DOpr),
	!.
% ----------------------------------------------------------------------------------------------
% synDERF
% ----------------------------------------------------------------------------------------------
% UP
% 
synDERF([T1|T2],Tr,Tree) :-
	% unary (non. det)
	T1=pie_scan::w(N2,"p3_iVal",_,_),
		globalVars::setMax_i("syn_max",N2),
	derfDE(T2,T3,DE),
	sbTokenOR([pie_scan::w(0,"p3_iFor","@","@"),pie_scan::w(0,"p3_iWhr","@","@"),pie_scan::w(0,"p3_iOf","@","@")],T3,T4),
	synUnaryPredicateCondition(T4,Tr,PredCond),
		Tree=cmp("NDERF",[DE,PredCond]).
synDERF([T1,T2|T3],Tr,Tree) :-
	% unary (det)
	T1=pie_scan::w(N2,"p3_iFst",_,_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,"p3_iVal",_,_),
		globalVars::setMax_i("syn_max",N3),
	derfDE(T3,T4,DE),
	sbTokenOR([pie_scan::w(0,"p3_iFor","@","@"),pie_scan::w(0,"p3_iWhr","@","@"),pie_scan::w(0,"p3_iOf","@","@")],T4,T5),
	synUnaryPredicateCondition(T5,Tr,PredCond),
		Tree=cmp("DDERF",[DE,PredCond]).
synDERF(Tc,Tr,Tree) :-
	% unary reverse (det) with prefixed predicate
	Tc=[T1,T2,T3,T4,T5,T6|T],
	T1=pie_scan::w(N3,"p3_iFst",_,_),
		globalVars::setMax_i("syn_max",N3),
	T2=pie_scan::w(N2,"p3_iVal",_,_),
		globalVars::setMax_i("syn_max",N2),
	% T3 pred
	% T4 ent
	T5=pie_scan::w(N4,":",_,_),
		globalVars::setMax_i("syn_max",N4),
	% T6 DE
		synDERF([T1,T2,T6,pie_scan::w(0,"p3_iOf","@","@"),T4,T3|T],Tr,Tree).
synDERF(Tc,Tr,Tree) :-
	% unary reverse (non. det) with prefixed predicate
	Tc=[T1,T2,T3,T4,T5|T],
	T1=pie_scan::w(N2,"p3_iVal",_,_),
		globalVars::setMax_i("syn_max",N2),
	% T2 pred
	% T3 ent
	T4=pie_scan::w(N3,":",_,_),
		globalVars::setMax_i("syn_max",N3),
	% T5 DE
		synDERF([T1,T5,pie_scan::w(0,"p3_iOf","@","@"),T3,T2|T],Tr,Tree).
synDERF([T1|T2],Tr,Tree) :-
	% binary (non det)
	T1=pie_scan::w(N2,"p3_iVal",_,_),
		globalVars::setMax_i("syn_max",N2),
	derfDE(T2,T3,DE),
	sbTokenOR([pie_scan::w(0,"p3_iFor","@","@"),pie_scan::w(0,"p3_iWhr","@","@"),pie_scan::w(0,"p3_iOf","@","@")],T3,T4),
	synBinaryPredicateCondition(T4,Tr,PredCond),
		Tree=cmp("NDERF",[DE,PredCond]).
synDERF([T1,T2|T3],Tr,Tree) :-
	% binary (det)
	T1=pie_scan::w(N3,"p3_iFst",_,_),
		globalVars::setMax_i("syn_max",N3),
	T2=pie_scan::w(N2,"p3_iVal",_,_),
		globalVars::setMax_i("syn_max",N2),
	derfDE(T3,T4,DE),
	sbTokenOR([pie_scan::w(0,"p3_iFor","@","@"),pie_scan::w(0,"p3_iWhr","@","@"),pie_scan::w(0,"p3_iOf","@","@")],T4,T5),
	synBinaryPredicateCondition(T5,Tr,PredCond),
		Tree=cmp("DDERF",[DE,PredCond]).
% ------------------------------------------------------------------------------------------------------------
% synDE_Value;synDE_PureValue
% ----------------------------------------------------------------------------------------------
% 1. par  i  attribute class domain
% 2. par  i  f3tm list being parsed
% 3. par  o  "         after parsing
% 4. par  o  parsed value
% Notes		lists or dates as right side of variable expressions
%		i.e. 1.par="any" is not supported
%
% synDE_PureValue only succeeds for literal values (i.e. such as can be used in facts).
% synDE_Value additionally succeeds for variables, expressions, calls and procedures.
%
synDE_Value(ListDom,Tc,Tr,List) :-
	sx::sxTail(2,ListDom,Dom,Tail),
	Tail="_l",
	synDE_ValueList(Dom,Tc,Tr,ValList),
	List=cmp(ListDom,ValList),
	!.
synDE_Value(_,T,Tr,Func) :- 
	synSSS_Val(T,Tr,Func),
	!.
synDE_Value(_,T,Tr,Func) :- 
	synDERF(T,Tr,Func),
	!.
synDE_Value(Dom,T,Tr,Func) :- 
	synFunctionCall(Dom,T,Tr,Func),
	!.
synDE_Value(Dom,T,Tr,Expr) :- 
	synUnaryOpLiteral(Dom,T,Tr,Expr),
	!.
synDE_Value(_,[pie_scan::w(N,DE,"p3_iDET",_)|T],T,atom(DE))   :- 
		globalVars::setMax_i("syn_max",N),
		!.
% all domains are compatible with variables
%
synDE_Value(Dom,[pie_scan::w(N,V,"p3_dvar",_)|T],T,fvar(V,Dom))   :- 
		globalVars::setMax_i("syn_max",N),
		!.
% value is a function/CR parameter (new as of 14.2.4)
%
synDE_Value(_,Tc,Tr,var(V)) :-
        	Tc=[E,S,DE|Tr],
	E=pie_scan::w(N2,Name,Clas,_),
		set::member(Clas,["p3_iFunc","p3_iIR"]),
		globalVars::setMax_i("syn_max",N2),
	S=pie_scan::w(N3,":",_,_),
		globalVars::setMax_i("syn_max",N3),
	DE=pie_scan::w(N4,D,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N4),
		vars::varFuncPar(Name,D,V),
	!
;
        	Tc=[S,DE|Tr],
	S=pie_scan::w(N3,"p3_iThis",_,_),
		globalVars::setMax_i("syn_max",N3),
	DE=pie_scan::w(N4,D,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N4),
		vars::varFuncPar("p3_iThis",D,V),
	!.
% value is an entity-qualified data element
%
synDE_Value(Dom,Tc,Tr,fvar(V,Dom)) :-
        	Tc=[E,S,DE|Tr],
	E=pie_scan::w(N2,Ent,"p3_iET",_),
		globalVars::setMax_i("syn_max",N2),
	S=pie_scan::w(N3,":",_,_),
		globalVars::setMax_i("syn_max",N3),
	DE=pie_scan::w(N4,Elm,"p3_iDET",_),
		globalVars::setMax_i("syn_max",N4),
		sx::concat([Ent,".",Elm],V),
	!.
% value is a bracketed expression
%
synDE_Value(Dom,Tc,Tr,Expr) :- 
	synBracketedExpr(Dom,Tc,Tr,Expr),!.
synDE_Value(Dom,Tc,Tr,V) :-
	synDE_PureValue(Dom,Tc,Tr,V),!.

% pure values
%
synDE_PureValue(ListDom,Tc,Tr,List) :-
	sx::sxTail(2,ListDom,Dom,Tail),
	Tail="_l",
	synDE_PureValueList(Dom,Tc,Tr,ValList),
	List=cmp(ListDom,ValList),
	!.
synDE_PureValue(Dom,Tc,Tr,List) :-
	synUnaryOpLiteral(Dom,Tc,Tr,List),
	!.
synDE_PureValue(_,[pie_scan::w(_,_,"p3_dvar",_)|_],_,_)   :- 
	!,fail. 
synDE_PureValue("p3_dli",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(S,"p3_dli","",0))   :-
	globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dts",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(S,"p3_dts","",0))   :-
	globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dxd",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(Sd,"p3_dxd","",0))   :- 
	xmlGeneric::xmlValidDate(S),
	Sd=S,
	globalVars::setMax_i("syn_max",N),
	!
;	
    % SQL stores dates as datetime
	xmlGeneric::xmlValidDatetime(S),
	Pos=string::searchchar(S,'T',string::caseSensitive),
	string::front(S,Pos,Sd,_),
	globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dxd",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(Sx,"p3_dxd","",0))   :- 
    % 31-12-01
    globalVars::get_i("f_date")=1,
    globalVars::get_i("f_daty")=0, % yy
    globalVars::get_i("f_datm")=0, % mm
    Y2K=globalVars::get_i("f_yyyy"),
    Delim=globalVars::get_s("f_dats"),
    sx::sxUnpackS(S,Delim,L),
    L=[D,M,Y],
    Yi=sx::toInt(Y),
    Yi<Y2K,
    sx::sxL_Pad(Y,"0",2,Yp),
    sx::sxL_Pad(M,"0",2,Mp),
    sx::sxL_Pad(D,"0",2,Dp),
    Sx=string::concat("20",Yp,"-",Mp,"-",Dp),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!
;	
    % 31-12-99
    globalVars::get_i("f_date")=1,
    globalVars::get_i("f_daty")=0, % yy
    globalVars::get_i("f_datm")=0, % mm
    Y2K=globalVars::get_i("f_yyyy"),
    Delim=globalVars::get_s("f_dats"),
    sx::sxUnpackS(S,Delim,L),
    L=[D,M,Y],
    Yi=sx::toInt(Y),
    Yi>=Y2K,
    sx::sxL_Pad(Y,"0",2,Yp),
    sx::sxL_Pad(M,"0",2,Mp),
    sx::sxL_Pad(D,"0",2,Dp),
    Sx=string::concat("19",Yp,"-",Mp,"-",Dp),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!
;	
    % 31-DEC-01
    globalVars::get_i("f_date")=1,
    globalVars::get_i("f_daty")=0, % yy
    globalVars::get_i("f_datm")=1, % mmm
    Y2K=globalVars::get_i("f_yyyy"),
    Delim=globalVars::get_s("f_dats"),
    sx::sxUnpackS(S,Delim,L),
    L=[D,M,Y],
    dbBase::kbID_F(M,Mk,_,_),
    string::length(Mk)>5,
    sx::frontstr(5,Mk,F,Ms),
    F="p3_iM",
    Yi=sx::toInt(Y),
    Yi<Y2K,
    sx::sxL_Pad(Y,"0",2,Yp),
    sx::sxL_Pad(Ms,"0",2,Mp),
    sx::sxL_Pad(D,"0",2,Dp),
    Sx=string::concat("20",Yp,"-",Mp,"-",Dp),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!
;	
    % 31-DEC-99
    globalVars::get_i("f_date")=1,
    globalVars::get_i("f_daty")=0, % yy
    globalVars::get_i("f_datm")=1, % mmm
    Y2K=globalVars::get_i("f_yyyy"),
    Delim=globalVars::get_s("f_dats"),
    sx::sxUnpackS(S,Delim,L),
    L=[D,M,Y],
    dbBase::kbID_F(M,Mk,_,_),
    string::length(Mk)>5,
    sx::frontstr(5,Mk,F,Ms),
    F="p3_iM",
    Yi=sx::toInt(Y),
    Yi>=Y2K,
    sx::sxL_Pad(Y,"0",2,Yp),
    sx::sxL_Pad(Ms,"0",2,Mp),
    sx::sxL_Pad(D,"0",2,Dp),
    Sx=string::concat("19",Yp,"-",Mp,"-",Dp),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!
;	
    % 31-12-2001
    globalVars::get_i("f_date")=1,
    globalVars::get_i("f_daty")=1, % yyyy
    globalVars::get_i("f_datm")=0, % mm
    Delim=globalVars::get_s("f_dats"),
    sx::sxUnpackS(S,Delim,L),
    L=[D,M,Y],
    sx::sxL_Pad(M,"0",2,Mp),
    sx::sxL_Pad(D,"0",2,Dp),
    Sx=string::concat(Y,"-",Mp,"-",Dp),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!
;	
    % 31-DEC-2001
    globalVars::get_i("f_date")=1,
    globalVars::get_i("f_daty")=1, % yyyy
    globalVars::get_i("f_datm")=0, % mmm
    Delim=globalVars::get_s("f_dats"),
    sx::sxUnpackS(S,Delim,L),
    L=[D,M,Y],
    dbBase::kbID_F(M,Mk,_,_),
    string::length(Mk)>5,
    sx::frontstr(5,Mk,F,Ms),
    F="p3_iM",
    sx::sxL_Pad(Ms,"0",2,Mp),
    sx::sxL_Pad(D,"0",2,Dp),
    Sx=string::concat(Y,"-",Mp,"-",Dp),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!.

synDE_PureValue("p3_dxd",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(Sx,"p3_dxd","",0))   :- 
    globalVars::get_i("f_date")=2,
    Y=string::subString(S,0,4),
    M=string::subString(S,4,2),
    D=string::subString(S,6,2),
    Sx=string::concat(Y,"-",M,"-",D),
	xmlGeneric::xmlValidDate(Sx),
		globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dxd",T,Tr,fstr(S,"p3_dxd","",0))   :- 
	synDE_PureValue("p3_did",T,Tr,V),
	V=fint(IDate,_),
	xmlGeneric::xmlFromInternalDate(IDate,S),
	!.
synDE_PureValue("p3_dxt",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(S,"p3_dxt","",0))   :- 
	xmlGeneric::xmlValidTime(S),
		globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dxt",T,Tr,fstr(S,"p3_dxt","",0))   :- 
	synDE_PureValue("p3_dit",T,Tr,V),
	V=fint(ITime,_),
	xmlGeneric::xmlFromInternalTime(ITime,S),
	!.
synDE_PureValue("p3_dxdt",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(S,"p3_dxdt","",0))   :- 
	xmlGeneric::xmlValidDatetime(S),
		globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dxdt",T,Tr,fstr(S,"p3_dxdt","",0))   :- 
	synDE_PureValue("p3_did",T,T2,V2),
	synDE_PureValue("p3_dit",T2,Tr,V3),
	V2=fint(IDate,_),
	datetime::datI_to_DMY(IDate,DD,MM,YY),
	V3=fint(ITime,_),
	H=ITime div 360000,
	M=(ITime-H*360000) div 6000,
	Sec=(ITime-H*360000-M*6000) div 100,
	F=ITime-H*360000-M*6000-Sec*100,
	xmlGeneric::xmlDatetime(YY,MM,DD,H,M,Sec,F,0,0,S),
	!.
synDE_PureValue("p3_dxdr",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(S,"p3_dxdr","",0))   :- 
	xmlGeneric::xmlValidDuration(S),
		globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dli",[pie_scan::w(N,Si,"p3_dsy",_)|T],T,fstr(S,"p3_dli","",0))  :- 
		globalVars::setMax_i("syn_max",N),
	dbBase::kbSym_to_IF(Si,S),
	!.
synDE_PureValue("p3_dli",[pie_scan::w(N,Si,"p3_dif",_)|T],T,fstr(S,"p3_dli","",0))  :- 
		globalVars::setMax_i("syn_max",N),
	dbBase::nlFormF(Si,"p3_iNIL",S),
	!.
synDE_PureValue("p3_dli",[pie_scan::w(N,S,Dom,_)|T],T,fstr(S,"p3_dli","",0))   :- 
		globalVars::setMax_i("syn_max",N),
	set::member(Dom,["p3_dnu","p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg","p3_din"]),
	!.
synDE_PureValue(Dom,[pie_scan::w(N,S,"p3_iDET",_)|T],T,fstr(S,Dom,"",0))   :- 
		globalVars::setMax_i("syn_max",N),
	!.
% symbol domain
%
synDE_PureValue("p3_dsy",[pie_scan::w(N,S,_,_)|T],T,fstr(Si,"p3_dsy","",0))         :- 
		globalVars::setMax_i("syn_max",N),
	dbBase::kbSym_to_IF(S,Si),
	!.
% identifier domain
%
synDE_PureValue("p3_dif",[pie_scan::w(N,S,_,_)|T],T,fstr(S,"p3_dif","",0))         :- 
		globalVars::setMax_i("syn_max",N),
	dbBase::kbNameExists(S),
	!.
% any domain
%
synDE_PureValue("p3_dany",[pie_scan::w(N,S,"p3_dnu",_)|T],T,ffix(F,"p3_dnu"))       :- 
		globalVars::setMax_i("syn_max",N),
	F=sx::toReal(S),
	!.
synDE_PureValue("p3_dany",[pie_scan::w(N,S,Dom,_)|T],T,ffix(F,Dom))       :- 
		globalVars::setMax_i("syn_max",N),
	set::member(Dom,["p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg"]),
	F=sx::toReal(S),
	dom::domInRange(Dom,F),
	!.
synDE_PureValue("p3_dany",[pie_scan::w(N,S,"p3_din",_)|T],T,fint(I,"p3_din"))       :- 
		globalVars::setMax_i("syn_max",N),
	I=sx::toInt(S),
	!.
synDE_PureValue("p3_dany",[pie_scan::w(N,S,"p3_dli",_)|T],T,fstr(S,"p3_dli","",0))  :- 
		globalVars::setMax_i("syn_max",N),
	!.
synDE_PureValue("p3_dany",[pie_scan::w(N,S,"p3_dif",_)|T],T,fstr(S,"p3_dif","",0))  :- 
		globalVars::setMax_i("syn_max",N),
	!.
% numeric domains
%
synDE_PureValue("p3_dnu",[pie_scan::w(N,S,"p3_dnu",_)|T],T,ffix(F,"p3_dnu"))   :- 
		globalVars::setMax_i("syn_max",N),
	F=sx::toReal(S),
	!.
synDE_PureValue("p3_dnu",[pie_scan::w(N,S,"p3_din",_)|T],T,ffix(F,"p3_dnu"))   :- 
		globalVars::setMax_i("syn_max",N),
	Sd=string::concat(S,".0"),
	F=sx::toReal(Sd),
	!.
synDE_PureValue(Dom,[pie_scan::w(N,S,Dom2,_)|T],T,ffix(F,Dom))   :- 
	set::member(Dom,["p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg"]),
	set::member(Dom2,["p3_din","p3_dnu","p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg"]),
		globalVars::setMax_i("syn_max",N),
	F=sx::toReal(S),
	dom::domInRange(Dom,F),
	!.
synDE_PureValue("p3_din",[pie_scan::w(N,S,"p3_din",_)|T],T,fint(I,"p3_din"))   :- 
		globalVars::setMax_i("syn_max",N),
	I=sx::toInt(S),
	!.
synDE_PureValue("p3_din",[pie_scan::w(N,S,"p3_dnu",_)|T],T,ffix(F,"p3_din"))   :- 
		globalVars::setMax_i("syn_max",N),
	F=sx::toReal(S),
	!.
synDE_PureValue("p3_dit",[T1,T2,T3,T4,T5,T6,T7|T],T,fint(Time,"p3_dit")) :- 
	T1=pie_scan::w(N2,HH,"p3_din",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,":",_,_),	
		globalVars::setMax_i("syn_max",N3),
	T3=pie_scan::w(N4,MM,"p3_din",_),
		globalVars::setMax_i("syn_max",N4),
	T4=pie_scan::w(N5,":",_,_),	
		globalVars::setMax_i("syn_max",N5),
	T5=pie_scan::w(N6,SS,"p3_din",_),
		globalVars::setMax_i("syn_max",N6),
	T6=pie_scan::w(N7,":",_,_),	
		globalVars::setMax_i("syn_max",N7),
	T7=pie_scan::w(N8,FF,"p3_din",_),
		globalVars::setMax_i("syn_max",N8),
	H=sx::toInt(HH),
	M=sx::toInt(MM),
	S=sx::toInt(SS),
	F=sx::toInt(FF),
	Time=H*360000+M*6000+S*100+F,
	!.
synDE_PureValue("p3_dit",[T1,T2,T3,T4,T5|T],T,fint(Time,"p3_dit")) :- 
	T1=pie_scan::w(N2,HH,"p3_din",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,":",_,_),	
		globalVars::setMax_i("syn_max",N3),
	T3=pie_scan::w(N4,MM,"p3_din",_),
		globalVars::setMax_i("syn_max",N4),
	T4=pie_scan::w(N5,":",_,_),	
		globalVars::setMax_i("syn_max",N5),
	T5=pie_scan::w(N6,SS,"p3_din",_),
		globalVars::setMax_i("syn_max",N6),
	H=sx::toInt(HH),
	M=sx::toInt(MM),
	S=sx::toInt(SS),
	Time=H*360000+M*6000+S+100,
	!.
synDE_PureValue("p3_dit",[T1,T2,T3|T],T,fint(Time,"p3_dit")) :- 
	T1=pie_scan::w(N2,HH,"p3_din",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,":",_,_),	
		globalVars::setMax_i("syn_max",N3),
	T3=pie_scan::w(N4,MM,"p3_din",_),
		globalVars::setMax_i("syn_max",N4),
	H=sx::toInt(HH),
	M=sx::toInt(MM),
	Time=H*360000+M*6000,
	!.
% date domain
% 
synDE_PureValue("p3_did",[T1|T],T,fint(IDate,"p3_did")) :- 
	% YYYYMMDD
	globalVars::get_i("f_date")=2,
	T1=pie_scan::w(N,YYYYMMDDs,"p3_din",_),
		globalVars::setMax_i("syn_max",N),
	YYYYMMDD=sx::toInt(YYYYMMDDs),
	YYYYMMDD>17750000,
	YYYY=YYYYMMDD div 10000,
	MM=(YYYYMMDD-(YYYY*10000)) div 100,
	DD=YYYYMMDD mod 100,
	datetime::datDMY_to_I(DD,MM,YYYY,IDate),
	!
;	
	% YYYYMMDD
	globalVars::get_i("f_date")=2,
	T1=pie_scan::w(N,YYYYMMDDs,"p3_din",_),
		globalVars::setMax_i("syn_max",N),
	YYYYMMDD=sx::toInt(YYYYMMDDs),
	YYYYMMDD=0,
	IDate=0,
	!.
synDE_PureValue("p3_did",[T1,T2,T3,T4,T5|T],T,fint(IDate,"p3_did")) :-
	%  DD-MM-YY[YY]
	globalVars::get_i("f_date")=1,
	globalVars::get_i("f_datm")=0,
	CSep=globalVars::get_s("f_dats"),
	T1=pie_scan::w(N2,Day,"p3_din",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Sep1,_,_),
		globalVars::setMax_i("syn_max",N3),
	Sep1=CSep,
	T3=pie_scan::w(N4,Month,"p3_din",_),
		globalVars::setMax_i("syn_max",N4),
	T4=pie_scan::w(N5,Sep2,_,_),
		globalVars::setMax_i("syn_max",N5),
	Sep2=CSep,
	T5=pie_scan::w(N6,Year,"p3_din",_),
		globalVars::setMax_i("syn_max",N6),
	Y=sx::toInt(Year),
	datetime::datYYYY(Y,YYYY),
	M=sx::toInt(Month),
	D=sx::toInt(Day),
	datetime::datDMY_to_I(D,M,YYYY,IDate),
	!
;
	%  DD-MMM-YY[YY]
	globalVars::get_i("f_date")=1,
	globalVars::get_i("f_datm")=1,
	CSep=globalVars::get_s("f_dats"),
	T1=pie_scan::w(N2,Day,"p3_din",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Sep1,_,_),
		globalVars::setMax_i("syn_max",N3),
	Sep1=CSep,
	T3=pie_scan::w(N4,Month,"p3_dif",_),
		globalVars::setMax_i("syn_max",N4),
	T4=pie_scan::w(N5,Sep2,_,_),
		globalVars::setMax_i("syn_max",N5),
	Sep2=CSep,
	T5=pie_scan::w(N6,Year,"p3_din",_),
		globalVars::setMax_i("syn_max",N6),
	Y=sx::toInt(Year),
	datetime::datYYYY(Y,YYYY),
	sbMonth(Month,M),
	D=sx::toInt(Day),
	datetime::datDMY_to_I(D,M,YYYY,IDate),
	!.
% ----------------------------------------------------------------------------------------------
% synDE_ValueList; synDE_PureValueList
% ----------------------------------------------------------------------------------------------
% parses a list-domain DE value
% 
synDE_ValueList(Dom,Tc,Tr,[Rep|Reps]) :-
	synDE_Value(Dom,Tc,T1,Rep),
	T1=[pie_scan::w(N,",",_,_)|T2],
		globalVars::setMax_i("syn_max",N),
	synDE_ValueList(Dom,T2,Tr,Reps),
	!.
synDE_ValueList(Dom,Tc,Tr,[Rep1,Rep2]) :-
	synDE_Value(Dom,Tc,T1,Rep1),
	T1=[pie_scan::w(N,"p3_iAnd",_,_)|T2],
		globalVars::setMax_i("syn_max",N),
	synDE_Value(Dom,T2,Tr,Rep2),
	!.
synDE_ValueList(Dom,Tc,Tr,[Rep]) :- 
	synDE_Value(Dom,Tc,Tr,Rep),
	!.
synDE_ValueList(Dom,T,_,_) :-
	sx::concat(["Invalid data element format/value for domain '",Dom,"'"],S),
	dlgIF::feil("synDE_ValueList",[S],[],nill),
	tt::tt_wrds(1,"error",T),
	!,fail.

synDE_PureValueList(Dom,Tc,Tr,[Rep|Reps]) :-
	synDE_PureValue(Dom,Tc,T1,Rep),
	T1=[pie_scan::w(N,",",_,_)|T2],
		globalVars::setMax_i("syn_max",N),
	synDE_PureValueList(Dom,T2,Tr,Reps),
	!.
synDE_PureValueList(Dom,Tc,Tr,[Rep1,Rep2]) :-
	synDE_PureValue(Dom,Tc,T1,Rep1),
	T1=[pie_scan::w(N,"p3_iAnd",_,_)|T2],
		globalVars::setMax_i("syn_max",N),
	synDE_PureValue(Dom,T2,Tr,Rep2),
	!.
synDE_PureValueList(Dom,Tc,Tr,[Rep]) :- 
	synDE_PureValue(Dom,Tc,Tr,Rep),
	!.
synDE_PureValueList(Dom,T,_,_) :-
	sx::concat(["Invalid data element format/value for domain '",Dom,"'"],S),
	dlgIF::feil("synDE_PureValueList",[S],[],nill),
	tt::tt_wrds(1,"error",T),
	!,fail.
% ----------------------------------------------------------------------------------------------
% synExpression
% ----------------------------------------------------------------------------------------------
synExpression(Dom,Tc,Tr,Tree) :- 
	synBracketedExpr(Dom,Tc,Tr,Tree).
synExpression(Dom,[T1|T],Tr,cmp(Oper,[Tree])) :- 
	T1=pie_scan::w(N,Oper,Type,_),
		globalVars::setMax_i("syn_max",N),
		Type="p3_oUnBn",
	synDE_Value(Dom,T,Tr,Tree).
synExpression(Dom,Tc,Tr,cmp(Oper,[LTree,RTree])) :-
	synDE_Value(Dom,Tc,T1,LTree),
	T1=[pie_scan::w(N,Oper,Type,_)|T2],
		globalVars::setMax_i("syn_max",N),
		set::member(Type,["p3_oBin","p3_oUnBn"]),
	synDE_Value(Dom,T2,Tr,RTree).	
synExpression(Dom,Tc,Tr,Tree) :- 
	synDE_Value(Dom,Tc,Tr,Tree).	
% ----------------------------------------------------------------------------------------------
% synFunctionCall
% ----------------------------------------------------------------------------------------------
% parses a function-call data element value or a function call query
%
synFunctionCall(_,[T2,T3|_],_,_) :-
	T2=pie_scan::w(_,_,"p3_iFunc",_),
	T3=pie_scan::w(_,":",_,_),
	!,fail.
synFunctionCall(Dom,Tc,Tr,Tree) :-
    Tc=[T2|T3],
	T2=pie_scan::w(N,Func,"p3_iFunc",_),
    globalVars::setMax_i("syn_max",N),
	dbBase::smClassDefF(Func,"f",_,DEs,FDom,_,_),
	dom::domCompat(Dom,FDom),
    sbTokenOR_Opt([pie_scan::w(0,"p3_iGivn","@","@"),pie_scan::w(0,"p3_iOf","@","@"),pie_scan::w(0,"p3_iWith","@","@")],T3,T4),
    sbTokenOR_Opt([pie_scan::w(0,"[","@","@")],T4,T5),
    dbBase::smDeDefs(DEs,DE_Defs),
	synDE_DefinitionList(1,DE_Defs,T5,T6,ParList),
    sbTokenOR_Opt([pie_scan::w(0,"]","@","@")],T6,Tr),
	Tree=cmp("DFNC",[atom(Func),atom(FDom)|ParList]),
	!
;			
    Tc=[T2|T3],
	T2=pie_scan::w(N,Func,"p3_iFunc",_),
    globalVars::setMax_i("syn_max",N),
	dbBase::smClassDefF(Func,"g",_,DEs,FDom,_,_),
	dom::domCompat(Dom,FDom),
    sbTokenOR_Opt([pie_scan::w(0,"p3_iGivn","@","@"),pie_scan::w(0,"p3_iOf","@","@"),pie_scan::w(0,"p3_iWith","@","@")],T3,T4),
    sbTokenOR_Opt([pie_scan::w(0,"[","@","@")],T4,T5),
    dbBase::smDeDefs(DEs,DE_Defs),
	synDE_DefinitionList(1,DE_Defs,T5,T6,ParList),
    sbTokenOR_Opt([pie_scan::w(0,"]","@","@")],T6,Tr),
	Tree=cmp("NFNC",[atom(Func),atom(FDom)|ParList]),
	!.
% ----------------------------------------------------------------------------------------------
% synPredicateArgument                                                 
% ----------------------------------------------------------------------------------------------
synPredicateArgument(T,Tr,Tree) :-
	synAtomEntityCondition(T,Tr,Tree).

synPredicateArgument(T,Tr,Arg) :-
	sbTokenOR_Opt([pie_scan::w(0,"p3_iA","@","@"),
    pie_scan::w(0,"p3_iDen","@","@"),
    pie_scan::w(0,"@","p3_iIntr","@")],T,T0),
    T0=[T1,T2|T3],
	T1=pie_scan::w(N2,Ent,"p3_iET",_),
	globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,"p3_iWith",_,_),
	globalVars::setMax_i("syn_max",N3),
    dbBase::smClassDefF(Ent,"e",_,DEs,_,_,_),
    dbBase::smDeDefs(DEs,DE_Defs),
	synDE_CondList(DE_Defs,T3,Tr,DE_Conds),
	sbGenDummyDE_Conds(DE_Defs,DE_Conds,Conds),
	dbBase::smClassDefTree(Ent,"e",EntDef),
	Arg=cmp("ENT_ARG",[EntDef,cmp("ATTR_CONDS",Conds)]).

synPredicateArgument([T1|T],T,Arg) :-
	T1=pie_scan::w(N,Ent,"p3_iET",_),
    globalVars::setMax_i("syn_max",N),
    dbBase::smClassDefF(Ent,"e",_,DEs,_,_,_),
    dbBase::smDeDefs(DEs,DE_Defs),
    sbGenDummyDE_Conds(DE_Defs,[],Conds),
    dbBase::smClassDefTree(Ent,"e",EntDef),
    Arg=cmp("ENT_ARG",[EntDef,cmp("ATTR_CONDS",Conds)]).

synPredicateArgument([T1,T2|T],T,Arg) :-
	T1=pie_scan::w(N2,_,"p3_iIntr",_),
	globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Ent,"p3_iET",_),
    globalVars::setMax_i("syn_max",N3),
    dbBase::smClassDefF(Ent,"e",_,DEs,_,_,_),
    dbBase::smDeDefs(DEs,DE_Defs),
    sbGenDummyDE_Conds(DE_Defs,[],Conds),
    dbBase::smClassDefTree(Ent,"e",EntDef),
    Arg=cmp("ENT_ARG",[EntDef,cmp("ATTR_CONDS",Conds)]).

synPredicateArgument([T1|T],T,var(V)) :-	
	T1=pie_scan::w(N,_,"p3_iIntr",_),
    globalVars::setMax_i("syn_max",N),
    vars::varGen(V).

synPredicateArgument([T1|T],T,var(V)) :- 
	T1=pie_scan::w(N,V,"p3_dvar",_),
    globalVars::setMax_i("syn_max",N).
% ----------------------------------------------------------------------------------------------
% synPredicateTailBinary                                          
% ----------------------------------------------------------------------------------------------
synPredicateTailBinary(PDef,T,Tr,Tree) :-
	% BPA
	PDef=cmp("REL_TYPE",[_,_,cmp("ATTRS",DEDefs)]),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T,T2),
	!,synDE_CondList(DEDefs,T2,Tr,DEConds),
	Tree=cmp("REL_COND",[PDef,cmp("ATTR_CONDS",DEConds)]),!.
synPredicateTailBinary(PDef,Tr,Tr,Tree) :-
	% BP
	PDef=cmp("REL_TYPE",[_,_]),
	Tree=cmp("REL_COND",[PDef]),!.
% ----------------------------------------------------------------------------------------------
% synPredicateTailUnary                                          
% ----------------------------------------------------------------------------------------------
synPredicateTailUnary(T,Tr,Tree) :-
	% UP/DE w/conditions
	sbTokenOR_Opt([pie_scan::w(0,"p3_iWhi","@","@")],T,T1),
	T1=[T2|T3],
	T2=pie_scan::w(N,P,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
	dbBase::smClassDefTreeF(P,"p",PDef),
	PDef=cmp("REL_TYPE",
	        [_,
	         cmp("CARD",[int(1)]),
	         cmp("ATTRS",DEDefs)]),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T3,T4),
	synDE_CondList(DEDefs,T4,Tr,DEConds),
	sbGenDummyDE_Conds(DEDefs,DEConds,Conds),
	Tree=cmp("REL_COND",[PDef,cmp("ATTR_CONDS",Conds)]),
	!
;	
	% UP/DE wout/conditions
	sbTokenOR_Opt([pie_scan::w(0,"p3_iWhi","@","@")],T,T1),
	T1=[T2|Tr],
	T2=pie_scan::w(N,P,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
	dbBase::smClassDefTreeF(P,"p",PDef),
	PDef=cmp("REL_TYPE",
	        [_,
	         cmp("CARD",[int(1)]),
	         cmp("ATTRS",DEDefs)]),
	sbGenDummyDE_Conds(DEDefs,[],Conds),
	Tree=cmp("REL_COND",[PDef,cmp("ATTR_CONDS",Conds)]),
	!
;	
	% UP
	sbTokenOR_Opt([pie_scan::w(0,"p3_iWhi","@","@")],T,T1),
	T1=[T2|Tr],
	T2=pie_scan::w(N,P,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
	dbBase::smClassDefTreeF(P,"p",PDef),
	PDef=cmp("REL_TYPE",
	        [_,
	         cmp("CARD",[int(1)])]),
	Tree=cmp("REL_COND",[PDef]),
	!.
% ----------------------------------------------------------------------------------------------
% synRange
% ----------------------------------------------------------------------------------------------
class predicates
synRangeVal : (string,pie_scan::wrds,string) determ (i,i,i).
clauses

synRange(Range,DE,Dom,[T1|T],Tr,Tree) :-
	T1=pie_scan::w(N,Br,_,_),
		set::member(Br,["[","<"]),
		globalVars::setMax_i("syn_max",N),
	synDE_Value(Dom,T,T2,Low),
	T2=[T3|T4],	
	T3=pie_scan::w(N3,",",_,_),
		globalVars::setMax_i("syn_max",N3),
	synDE_Value(Dom,T4,T5,High),
	T5=[T6|Tr],
	T6=pie_scan::w(N6,Br6,_,_),
		set::member(Br6,["]",">"]),
		globalVars::setMax_i("syn_max",N6),
	synRangeVal(Dom,[T1|T],DE),
	Typ=string::concat(Br,Br6),
	Tree=cmp(Range,[str(Typ),atom(Dom),Low,High]),
	!.

synRangeVal(Dom,T,DE) :-
	dom::domNum(Dom),
	!
;
	sx::concat(["Range cannot be specified for a non-numeric data element type (",DE,")!"],Mess),
	dlgIF::feil("synRangeVal",[Mess],[],nill),
	tt::tt_wrds(1,"error",T),
	!,fail.
% ----------------------------------------------------------------------------------------------
% synSSS_Val
% ----------------------------------------------------------------------------------------------
synSSS_Val([T1|T2],Tr,Tree) :-
	T1=pie_scan::w(N,"p3_iSSS",_,_),
		globalVars::setMax_i("syn_max",N),
	synSSS(T2,Tr,Tree),!. 
% ----------------------------------------------------------------------------------------------
% synUnaryPredicateCondition                                             
% ----------------------------------------------------------------------------------------------
synUnaryPredicateCondition(T,Tr,Tree) :-
	% UP/DE suffixed (w/out DE conditions)
	synPredicateArgument(T,T1,ArgTree),
	synPredicateTailUnary(T1,Tr,PredTree),
		PredTree=cmp("REL_COND",[PDef]),
		PDef=cmp("REL_TYPE",
	        	[_,
	         	cmp("CARD",[int(1)]),
	         	cmp("ATTRS",DEs)]),
		sbGenDummyDE_Conds(DEs,[],Conds),
		Tree=cmp("REL_COND",[PDef,ArgTree,cmp("ATTR_CONDS",Conds)])
;		
	% UP/DE suffixed (with DE conditions)
	synPredicateArgument(T,T1,ArgTree),
	synPredicateTailUnary(T1,Tr,PredTree),
		PredTree=cmp("REL_COND",[PDef,cmp("ATTR_CONDS",DE_Conds)]),
		PDef=cmp("REL_TYPE",
	        	[_,
	         	cmp("CARD",[int(1)]),
	         	cmp("ATTRS",DEs)]),
		sbGenDummyDE_Conds(DEs,DE_Conds,Conds),
		Tree=cmp("REL_COND",[PDef,ArgTree,cmp("ATTR_CONDS",Conds)])
;		
	% UP suffixed (without DEs)
	synPredicateArgument(T,T1,ArgTree),
	synPredicateTailUnary(T1,Tr,PredTree),
		PredTree=cmp("REL_COND",[PDef]),
		Tree=cmp("REL_COND",[PDef,ArgTree]).

synUnaryPredicateCondition(T,Tr,Tree) :-
	% UP/DE prefixed with conditions
        sbTokenOR_Opt([pie_scan::w(0,"p3_iDen","@","@")],T,T1),
        	T1=[T2|T3],
	T2=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefTreeF(Rel,"p",PDef),
		PDef=cmp("REL_TYPE",
	        	[_,
	         	cmp("CARD",[int(1)]),
	         	cmp("ATTRS",DEs)]),
	synPredicateArgument(T3,T5,ArgTree),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T5,T6),
		synDE_CondList(DEs,T6,Tr,DE_Conds),
		sbGenDummyDE_Conds(DEs,DE_Conds,Conds),
		Tree=cmp("REL_COND",[PDef,ArgTree,cmp("ATTR_CONDS",Conds)])
;
	% UP/DE prefixed without conditions 
        sbTokenOR_Opt([pie_scan::w(0,"p3_iDen","@","@")],T,T1),
        	T1=[T2|T3],
	T2=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefTreeF(Rel,"p",PDef),
		PDef=cmp("REL_TYPE",
	  	        [_,
	    	     cmp("CARD",[int(1)]),
	        	 cmp("ATTRS",DEs)]),
	synPredicateArgument(T3,Tr,ArgTree),
		sbGenDummyDE_Conds(DEs,[],Conds),
		Tree=cmp("REL_COND",[PDef,ArgTree,cmp("ATTR_CONDS",Conds)])
;
	% UP prefixed (no DEs),
        sbTokenOR_Opt([pie_scan::w(0,"p3_iDen","@","@")],T,T1),
        	T1=[T2|T3],
	T2=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefTreeF(Rel,"p",PDef),
		PDef=cmp("REL_TYPE",[_,cmp("CARD",[int(1)])]),
	synPredicateArgument(T3,Tr,ArgTree),
		Tree=cmp("REL_COND",[PDef,ArgTree]).
% ----------------------------------------------------------------------------------------------
% synUnaryOpLiteral
% ----------------------------------------------------------------------------------------------
% parses a unary plus/minus integer/numeric value (without parentheses)
%
synUnaryOpLiteral("p3_dnu",[pie_scan::w(_,"-",_,_),pie_scan::w(N,Sf,"p3_dnu",_)|T],T,ffix(F,"p3_dnu")) :- 
		globalVars::setMax_i("syn_max",N),
    F1=sx::toReal(Sf),
	F=-F1,!.
synUnaryOpLiteral("p3_dnu",[pie_scan::w(_,"-",_,_),pie_scan::w(N,Si,"p3_din",_)|T],T,ffix(F,"p3_dnu")) :- 
		globalVars::setMax_i("syn_max",N),
	S=string::concat(Si,".0"),
    F1=sx::toReal(S),
	F=-F1,!.
synUnaryOpLiteral("p3_dcf",[pie_scan::w(_,"-",_,_),pie_scan::w(N,Sf,"p3_dnu",_)|T],T,ffix(F,"p3_dcf")) :- 
		globalVars::setMax_i("syn_max",N),
    F1=sx::toReal(Sf),
	F=-F1,!.
synUnaryOpLiteral("p3_dcf",[pie_scan::w(_,"-",_,_),pie_scan::w(N,Si,"p3_din",_)|T],T,ffix(F,"p3_dcf")) :- 
		globalVars::setMax_i("syn_max",N),
	S=string::concat(Si,".0"),
    F1=sx::toReal(S),
	F=-F1,!.
synUnaryOpLiteral("p3_din",[pie_scan::w(_,"-",_,_),pie_scan::w(N,Si,"p3_din",_)|T],T,fint(I,"p3_din")) :- 
		globalVars::setMax_i("syn_max",N),
	I1=sx::toInt(Si),
	I=-I1,!.
synUnaryOpLiteral("p3_din",[pie_scan::w(_,"-",_,_),pie_scan::w(N,Si,"p3_dnu",_)|T],T,ffix(F,"p3_dnu")) :- 
		globalVars::setMax_i("syn_max",N),
    F1=sx::toReal(Si),
	F=-F1,!.
synUnaryOpLiteral("p3_dnu",[pie_scan::w(_,"+",_,_),pie_scan::w(N,S,"p3_dnu",_)|T],T,ffix(F,"p3_dnu")) :- 
		globalVars::setMax_i("syn_max",N),
    F=sx::toReal(S),
	!.
synUnaryOpLiteral("p3_dnu",[pie_scan::w(_,"+",_,_),pie_scan::w(N,Si,"p3_din",_)|T],T,ffix(F,"p3_dnu")) :- 
		globalVars::setMax_i("syn_max",N),
	sx::concat([Si,".0"],S),
    F=sx::toReal(S),
	!.
synUnaryOpLiteral(Dom,[pie_scan::w(_,"+",_,_),pie_scan::w(N,S,"p3_dnu",_)|T],T,ffix(F,Dom)) :- 
		globalVars::setMax_i("syn_max",N),
	set::member(Dom,["p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg"]),
    F=sx::toReal(S),
	!.
synUnaryOpLiteral(Dom,[pie_scan::w(_,"+",_,_),pie_scan::w(N,Si,"p3_din",_)|T],T,ffix(F,Dom)) :- 
		globalVars::setMax_i("syn_max",N),
	set::member(Dom,["p3_dcf","p3_dinc","p3_ddec","p3_dpr","p3_dmg"]),
	sx::concat([Si,".0"],S),
    F=sx::toReal(S),
	!.
synUnaryOpLiteral("p3_din",[pie_scan::w(_,"+",_,_),pie_scan::w(N,S,"p3_din",_)|T],T,fint(I,"p3_din")) :- 
		globalVars::setMax_i("syn_max",N),
	I=sx::toInt(S),
	!.
synUnaryOpLiteral("p3_din",[pie_scan::w(_,"+",_,_),pie_scan::w(N,S,"p3_dnu",_)|T],T,ffix(F,"p3_dnu")) :- 
		globalVars::setMax_i("syn_max",N),
    F=sx::toReal(S),
	!.
synUnaryOpLiteral(Dom,[pie_scan::w(N,Opr,"p3_oUnBn",_)|T],Tr,cmp(Opr,[Tree])) :- 
		globalVars::setMax_i("syn_max",N),
	synDE_PureValue(Dom,T,Tr,Tree),
	!.
% ----------------------------------------------------------------------------------------------
% synVariableExpression
% ----------------------------------------------------------------------------------------------
synVariableExpression([T1,T2|T],Tr,Tree) :-
	T1=pie_scan::w(N2,V,"p3_dvar",_),
		globalVars::setMax_i("syn_max",N2),
	T2=pie_scan::w(N3,Opr,"p3_oBin",_),
		globalVars::setMax_i("syn_max",N3),
	synDE_Value("p3_dany",T,Tr,Tree1),
	Tree=cmp(Opr,[fvar(V,"p3_dany"),Tree1]),
	!.
% ----------------------------------------------------------------------------------------------
% sbGetDE_Val/IF
% ----------------------------------------------------------------------------------------------
class predicates
clauses

% parameters:
% 1	in	value domain
% 2	in	value (NL)
% 3	out	value (IF)
%
sbGetDE_ValIF(Dom,NL,Term) :-
    dom::domStr(Dom),
    !,
    St=string::trim(NL),
    sx::sxQuote(St,Stq),
	pscan::pscNL(Stq,Toks),
	pscan::str_tokens(Toks,SToks),
	transnl::scnSyntagmSets(Toks,SToks,Sets),
	transnl::nl_tok_scan(Toks,SToks,Sets,Wrds), 
	synDE_PureValue(Dom,Wrds,WrdsLeft,FTerm),
	WrdsLeft=[],
	fSwitch(FTerm,Term),
	!
;
    St=string::trim(NL),
	pscan::pscNL(St,Toks),
	pscan::str_tokens(Toks,SToks),
	transnl::scnSyntagmSets(Toks,SToks,Sets),
	transnl::nl_tok_scan(Toks,SToks,Sets,Wrds), 
	synDE_PureValue(Dom,Wrds,WrdsLeft,FTerm),
	WrdsLeft=[],
	fSwitch(FTerm,Term),
	!.

% parameters:
% 1	in	value domain
% 2	in	value (NL)
% 3	out	value (PR)
%
sbGetDE_Val(Dom,NL,PR) :-
    sbGetDE_ValIF(Dom,NL,Term),
    nl::cprTerm(Term,PR),
    !.
% ----------------------------------------------------------------------------------------------
% sbMatchAndRemove
% ----------------------------------------------------------------------------------------------
sbMatchAndRemove(Att,[fstr(Att,Dom,_,_)|T],Dom,T) :- 
	!.
sbMatchAndRemove(Att,[H|T],Dom,[H|Tm]) :- 
	sbMatchAndRemove(Att,T,Dom,Tm),!.
% ----------------------------------------------------------------------------------------------
% sbGenDummyDE_Conds
% ----------------------------------------------------------------------------------------------
class predicates
sbGenDE_HasCond : (string,sterml,sterm) determ (i,i,o).
clauses
sbGenDummyDE_Conds([],_,[]) :- 
	!.
sbGenDummyDE_Conds([fstr(DE,Dom,_,_)|DEs],DE_Conds,[Cond|Conds]) :-
	sbGenDE_HasCond(DE,DE_Conds,Cond),
	sbGenDummyDE_Conds(DEs,DE_Conds,Conds),
	!
;
	opr::oprDom(Dom,"=",Opr),
	vars::varGenP("Dummy",V), 
	Cond=cmp(Opr,[fvar(DE,Dom),fvar(V,Dom)]),
	sbGenDummyDE_Conds(DEs,DE_Conds,Conds),
	!.
	
sbGenDE_HasCond(DE,[DE_Cond|DE_Conds],Cond) :-
	DE_Cond=cmp(_,[fvar(DE,_),_]),
	Cond=DE_Cond,
	!
;	
	sbGenDE_HasCond(DE,DE_Conds,Cond),
	!.
% ----------------------------------------------------------------------------------------------
% sbMonth
% ----------------------------------------------------------------------------------------------
sbMonth("p3_iM1",1) :- !.	
sbMonth("p3_iM2",2) :- !.	
sbMonth("p3_iM3",3) :- !.	
sbMonth("p3_iM4",4) :- !.	
sbMonth("p3_iM5",5) :- !.	
sbMonth("p3_iM6",6) :- !.	
sbMonth("p3_iM7",7) :- !.	
sbMonth("p3_iM8",8) :- !.	
sbMonth("p3_iM9",9) :- !.	
sbMonth("p3_iM10",10) :- !.	
sbMonth("p3_iM11",11) :- !.	
sbMonth("p3_iM12",12) :- !.	
sbMonth("1",1) :- !.	
sbMonth("2",2) :- !.	
sbMonth("3",3) :- !.	
sbMonth("4",4) :- !.	
sbMonth("5",5) :- !.	
sbMonth("6",6) :- !.	
sbMonth("7",7) :- !.	
sbMonth("8",8) :- !.	
sbMonth("9",9) :- !.	
sbMonth("10",10) :- !.	
sbMonth("11",11) :- !.	
sbMonth("12",12) :- !.	
% ----------------------------------------------------------------------------------------------
% sbTokenMatch
% ----------------------------------------------------------------------------------------------
sbTokenMatch(pie_scan::w(_,"@","@","@"),pie_scan::w(N,_,_,_)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,A,"@","@"),pie_scan::w(N,A,_,_)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,"@",B,"@"),pie_scan::w(N,_,B,_)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,"@","@",C),pie_scan::w(N,_,_,C)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,A,B,"@"),pie_scan::w(N,A,B,_)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,A,"@",C),pie_scan::w(N,A,_,C)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,"@",B,C),pie_scan::w(N,_,B,C)) :- 
		globalVars::setMax_i("syn_max",N),!.
sbTokenMatch(pie_scan::w(_,A,B,C),pie_scan::w(N,A,B,C)) :- 
		globalVars::setMax_i("syn_max",N),!.
% ----------------------------------------------------------------------------------------------
% sbTokenOR
% ----------------------------------------------------------------------------------------------
sbTokenOR([Wi],[Wm|T],T) :- 
	sbTokenMatch(Wi,Wm),!.
sbTokenOR([Wi1,Wi2],[Wm|T],T) :- 
	sbTokenMatch(Wi1,Wm),!
;	sbTokenMatch(Wi2,Wm),!.
sbTokenOR([Wi1,Wi2,Wi3],[Wm|T],T) :- 
	sbTokenMatch(Wi1,Wm),!
;	sbTokenMatch(Wi2,Wm),!
;	sbTokenMatch(Wi3,Wm),!.
sbTokenOR([Wi1,Wi2,Wi3,Wi4],[Wm|T],T) :- 
	sbTokenMatch(Wi1,Wm),!
;	sbTokenMatch(Wi2,Wm),!
;	sbTokenMatch(Wi3,Wm),!
;	sbTokenMatch(Wi4,Wm),!.
% ----------------------------------------------------------------------------------------------
% sbTokenOR_Opt
% ----------------------------------------------------------------------------------------------
sbTokenOR_Opt(Ws,Tc,Tr) :- 
	sbTokenOR(Ws,Tc,Tr),!.
sbTokenOR_Opt(_,T,T) :- 
	!.
% ----------------------------------------------------------------------------------------------
% sbTraceType
% ----------------------------------------------------------------------------------------------
sbTraceType("p3_iTri","p3_din") :- !.
sbTraceType("p3_iTrf","p3_dnu") :- !.
sbTraceType("p3_iTrs","p3_dli") :- !.
sbTraceType("p3_iTrs","p3_dts") :- !.
sbTraceType("p3_iTra","p3_dif") :- !.
sbTraceType("p3_iTry","p3_dsy") :- !.
% ----------------------------------------------------------------------------------------------
% sbVarDomains
% ----------------------------------------------------------------------------------------------
class predicates
sbVarDomainsX : (sterm,sterm,sterm) procedure (i,i,o).
sbVarDomainsY : (sterm,sterml,sterml) determ (i,i,o).
sbVarGetDom : (sterm,string,string) determ (i,i,o).
sbVarGetDomY : (sterml,string,string) determ (i,i,o).
clauses
% sets domains for pure variables wherever possible e.g. where fvar("X","p3_din") exists, then
% changes an occurrence like fvar("X","p3_dany") to fvar("X","p3_did") 
%
sbVarDomains(STc,STr) :-
	sbVarDomainsX(STc,STc,STr),
	!.
sbVarDomainsX(ST,fvar(V,"p3_dany"),fvar(V,Dom)) :-
	sbVarGetDom(ST,V,Dom),
	!
;
	Dom="p3_dany",
	!.
sbVarDomainsX(ST,cmp(H,B),cmp(H,Bm)) :-
	sbVarDomainsY(ST,B,Bm),
	!.
sbVarDomainsX(_,C,C) :-
	!.			
sbVarDomainsY(_,[],[]) :-
	!.
sbVarDomainsY(ST,[H|T],[Hm|Tm]) :-
	sbVarDomainsX(ST,H,Hm),
	sbVarDomainsY(ST,T,Tm),
	!.
sbVarGetDom(fvar(V,Dom),V,Dom) :-
	Dom<>"p3_dany",
	!.
sbVarGetDom(cmp(_,B),V,Dom) :-
	sbVarGetDomY(B,V,Dom),
	!.
sbVarGetDomY([H|T],V,Dom) :-
	sbVarGetDom(H,V,Dom),
	!
;	
	sbVarGetDomY(T,V,Dom),
	!.
% ----------------------------------------------------------------------------------------------
% adjustMDE_Vals
% ----------------------------------------------------------------------------------------------
adjustMDE_Vals([],[]) :-
    !.
adjustMDE_Vals([V|Vs],[Val|Vals]) :-
    V=cmp(_,[_,Val2]),
    fSwitch(Val2,Val),
    adjustMDE_Vals(Vs,Vals),
    !. 
end implement syn
/*
synSentenceQuery : (pie_scan::wrds,pie_scan::wrds,sterm) nondeterm (i,o,o).
% -------------------------------------------------------------------------------------------------------------
% synSentenceQuery                   
% -------------------------------------------------------------------------------------------------------------
synSentenceQuery(T,Tr,Tree) :-
	% UR
	synPredicateArgument(T,T2,Arg1),
		T2=[T3|Tr],
	T3=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefF(Rel,"p",Card,DEs,_,_,_),
		DEs=[],
		Card=1,
        dbBase::smClassDefTree(Rel,"p",RelDef),
		Tree=cmp("REL_COND",[RelDef,Arg1])
;	
	% URA w/out attribute conditions
	synPredicateArgument(T,T2,Arg1),
	T2=[T3|Tr],
	T3=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefF(Rel,"p",Card,_,_,_,_),
        Card=1,
        dbBase::smClassDefTree(Rel,"p",RelDef),
	Tree=cmp("REL_COND",[RelDef,Arg1])
;	
	% URA w/ attribute conditions
	synPredicateArgument(T,T2,Arg1),
	T2=[T3|T4],
	T3=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),

        dbBase::smClassDefF(Rel,"p",Card,DEs,_,_,_),
        Card=1,
        dbBase::smClassDefTree(Rel,"p",RelDef),
        dbBase::smDeDefs(DEs,DE_Defs),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T4,T5),
	synDE_CondList(DE_Defs,T5,Tr,Atts),
	Tree=cmp("REL_COND",[RelDef,Arg1,cmp("ATTR_CONDS",Atts)])
;	
	% UR/URA prefixed
	synPredicateTailUnary(T,T2,Tree1),
		Tree1=cmp(_,[PDef|Tail]),
	synPredicateArgument(T2,Tr,Arg1),
		Tree=cmp("REL_COND",[PDef,Arg1|Tail])
;
	% BR
	synPredicateArgument(T,T2,Arg1),
	T2=[T3|T4],
	T3=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefF(Rel,"p",Card,DEs,_,_,_),
        Card=2,
        DEs=[],
        dbBase::smClassDefTree(Rel,"p",RelDef),
	synPredicateArgument(T4,Tr,Arg2),
	Tree=cmp("REL_COND",[RelDef,Arg1,Arg2])
;	
	% BRA w/out attribute conditions
	synPredicateArgument(T,T2,Arg1),
	T2=[T3|T4],
	T3=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefF(Rel,"p",Card,_,_,_,_),
        Card=2,
        dbBase::smClassDefTree(Rel,"p",RelDef),
	synPredicateArgument(T4,Tr,Arg2),
	Tree=cmp("REL_COND",[RelDef,Arg1,Arg2])
;	
	% BRA w/ attribute conditions
	synPredicateArgument(T,T2,Arg1),
	T2=[T3|T4],
	T3=pie_scan::w(N,Rel,"p3_iPT",_),
		globalVars::setMax_i("syn_max",N),
        dbBase::smClassDefF(Rel,"p",Card,DEs,_,_,_),
        Card=1,
        dbBase::smClassDefTree(Rel,"p",RelDef),
        dbBase::smDeDefs(DEs,DE_Defs),
	synPredicateArgument(T4,T5,Arg2),
        sbTokenOR([pie_scan::w(0,"p3_iWith","@","@"),pie_scan::w(0,"p3_iFor","@","@")],T5,T6),
	synDE_CondList(DE_Defs,T6,Tr,Atts),
	Tree=cmp("REL_COND",[RelDef,Arg1,Arg2,cmp("ATTR_CONDS",Atts)]).
*/