/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement table
open core,termDomain,globalDomains

constants
className = "com/rudstrand/table/table".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

class predicates
tabDetermine : (integer,integer,string,integer,integer,sterml,integer,sterml) determ (i,i,i,i,i,i,o,o).
tabEdCols : (integer,integer,sterml) determ (i,i,o).
tabEdContents : (outFile,integer_list,integer,integer,integer,integer,integer,sterml).
tabGenArgsFixed : (integer,integer,string,integer,integer) determ (i,i,i,o,o).
tabGenArgsOpen : (integer,integer,string,string,integer,string_list,integer,integer) determ (i,i,i,i,i,i,o,o).
tabGenCellsFixed : (integer) procedure (i).
tabGenCellsOpen : (integer,string,integer,integer,sterml) procedure (i,i,i,i,i).
tabGetFormats : (integer,integer,integer,integer,sterml) determ (i,i,i,i,o).
tabGenSolArgs : (integer,integer,string,integer,integer,integer,integer,string_list,integer) determ (i,i,i,i,i,i,i,i,o) .
setSort : (integer SolRef,integer Table,string ST).

clauses
% ------------------------------------------------------------------------------------------------------------
% tabEditor
% ------------------------------------------------------------------------------------------------------------
class predicates
tabEdWrite : (outFile,integer,integer,integer,string,integer,integer,integer,integer,integer).
tabTRR : (integer,integer,integer,integer,integer) procedure (i,i,i,i,o).
adjustWidths : (integer,integer_list,integer_list) determ (i,i,o).
deHeader : (outFile,sterml,integer_list) determ.
deHeaderX : (outFile,sterml,integer_list,sterml) determ (i,i,i,o).
allOut : (sterml) determ.    
clauses

% print of table window
% parameters:
% 1	in	1=tabular/report; 2=form; -3/-4 output option 3/4
% 2 in  ST
% 3	in	sol.ref.
% 4	in	table#
% 5	in	from line (as table is displayed)
% 6	in	to line (as table is displayed)
%
tabEditor(File,Mode,ST,SolRef,Table,From,To,Header,Trailer,Anno) :-
    AMode=math::abs(Mode),
    set::member(AMode,[1,3]),
    stb::stbD_GetColWidths(SolRef,Table,Ws,_),
    adjustWidths(5,Ws,Ws2),
  	tabEdCols(SolRef,Table,Cols),
	deHeader(File,Cols,Ws2),
    tabEdContents(File,Ws2,-1,SolRef,Table,From,To,Cols),
	!
;
    AMode=math::abs(Mode),
    AMode=2,
	stb::stbH_Get(SolRef,Table,_,_,_,Sorted,_,_),
	tabEdWrite(File,SolRef,Table,Sorted,ST,From,To,Header,Trailer,Anno),
	!
;
    AMode=math::abs(Mode),
    AMode=4,
    stb::stbD_GetColWidths(SolRef,Table,Ws,_),
    adjustWidths(5,Ws,Ws2),
  	tabEdCols(SolRef,Table,Cols),
    tabEdContents(File,Ws2,-1,SolRef,Table,From,To,Cols),
	!
;
    AMode=math::abs(Mode),
    AMode=5,
    stb::stbD_GetColWidths(SolRef,Table,Ws,_),
    adjustWidths(5,Ws,Ws2),
  	tabEdCols(SolRef,Table,Cols),
	stb::stbH_Get(SolRef,Table,_,_,STk,_,_,_),
	Delim=globalVars::get_s("delim"),
	File:writenl(Delim),
	sx::sxUnpack(STk,'|',L),
	sx::sxlJoin(L,Delim,Sst),
	File:writenl(SSt),
    dbBase::kbST_DEs(STk,DEs),
    dbBase::nlSings(DEs,DEsN),
    sx::sxlJoin(DEsN,Delim,Sde),
    File:writenl(Sde),
    tabEdContents(File,Ws2,1,SolRef,Table,From,To,Cols),
	!
;
    AMode=math::abs(Mode),
    AMode=6,
    stb::stbD_GetColWidths(SolRef,Table,Ws,_),
    adjustWidths(5,Ws,Ws2),
  	tabEdCols(SolRef,Table,Cols),
    tabEdContents(File,Ws2,1,SolRef,Table,From,To,Cols),
	!
;
	dlgIF::feil("tabEditor",[ST],[Mode,SolRef,Table,From,To],nill),!,fail.

tabEdWrite(Rep,SolRef,Table,Sorted,ST,Row,Row,Header,Trailer,Anno) :-
	tabTRR(SolRef,Table,Sorted,Row,PRow),
	stb::stbRef(SolRef,Table,PRow,Loc),
	dbExtension::kbPrintSent(Header,Trailer,Anno,Loc,ST,S),
	Rep:writenl(S),
	!.
tabEdWrite(Rep,SolRef,Table,Sorted,ST,From,To,Header,Trailer,Anno) :-
    tabTRR(SolRef,Table,Sorted,From,FRow),
	stb::stbRef(SolRef,Table,FRow,Loc),
	dbExtension::kbPrintSent(Header,Trailer,Anno,Loc,ST,S),
	Rep:writenl(S),
	Row=programControl::sequence_nd(From,To,1),
	   tabTRR(SolRef,Table,Sorted,Row,PRow),
	   stb::stbRef(SolRef,Table,PRow,Loc2),
	   dbExtension::kbPrintSent(Header,Trailer,Anno,Loc2,ST,S2),
	   Rep:writenl(S2),
	   fail
;
	!.
sentencePrint(Loc,ST) :-
    Anno=globalVars::get_i("pran"),
	sx::makeIdentifier(1,3,2,ST,64,"",Name),
	Rep=rep::newReport(Name,70),
	p3rep::header(Rep),
	dbExtension::kbPrintSent(1,1,Anno,Loc,ST,S),
	Rep:repWL(0,S),
	Rep:close(),
    !.
% copy of tbwTRR
%
tabTRR(SolRef,Table,Sorted,Row,PRow) :-
	Sorted=0,
	PRow=Row,
	!
;	
	Sorted=1,
	sdb::tabName(SolRef,1,TabName),
	Ix=string::concat("X",TabName),
	XI=sdb::getIx(Ix),
	stb::stbGetRowL_P(XI,Row,PRow),
	!
;		
	dlgIF::feil("tabTRR",[],[SolRef,Table,Row],nill),
	PRow=0,
	!.	
adjustWidths(_,[],[]) :-
    !.
adjustWidths(Min,[W|Ws],[W2|W2s]) :-
    set::setMax([Min,W],W2),
    adjustWidths(5,Ws,W2s),
    !.
deHeader(Rep,Ds,Ws) :-
    allOut(Ds),
    !
;
    deHeaderX(Rep,Ds,Ws,Dr),
    Rep:writenl(""),
    deHeader(Rep,Dr,Ws),
    !.
    
deHeaderX(_,[],_,[]) :-
    !.
deHeaderX(Rep,[Dc|Ds],[W|Ws],[Dr|Drs]) :-
    Dc=cmp("",[A,str(D),B,C,E,F,G]),
    L=string::length(D),
    L=W,
    Rep:write(D," "),
    deHeaderX(Rep,Ds,Ws,Drs),
    Dr=cmp("",[A,str(""),B,C,E,F,G]),
    !
;    
    Dc=cmp("",[A,str(D),B,str(Domain),C,F,G]),
    dom::domInt(Domain),
    L=string::length(D),
    L<W,
    sx::sxL_Pad(D," ",W,S),
    Rep:write(S," "),
    deHeaderX(Rep,Ds,Ws,Drs),
    Dr=cmp("",[A,str(""),B,str(Domain),C,F,G]),
    !
;    
    Dc=cmp("",[A,str(D),B,str(Domain),C,F,G]),
    dom::domFix(Domain),
    L=string::length(D),
    L<W,
    sx::sxL_Pad(D," ",W,S),
    Rep:write(S," "),
    deHeaderX(Rep,Ds,Ws,Drs),
    Dr=cmp("",[A,str(""),B,str(Domain),C,F,G]),
    !
;    
    Dc=cmp("",[A,str(D),B,C,E,F,G]),
    L=string::length(D),
    L<W,
    sx::sxR_Pad(D," ",W,S),
    Rep:write(S," "),
    deHeaderX(Rep,Ds,Ws,Drs),
    Dr=cmp("",[A,str(""),B,C,E,F,G]),
    !
;    
    Dc=cmp("",[A,str(D),B,C,E,F,G]),
    L=string::length(D),
    L>W,
    sx::frontstr(W,D,Df,Dcr),
    Rep:write(Df," "),
    deHeaderX(Rep,Ds,Ws,Drs),
    Dr=cmp("",[A,str(Dcr),B,C,E,F,G]),
    !.
allOut([]) :-
    !.
allOut([cmp(_,[_,str(""),_,_,_,_,_])|Ds]) :-
    allOut(Ds),
    !.
% ------------------------------------------------------------------------------------------------------------
% tabGen
% ------------------------------------------------------------------------------------------------------------
class predicates
tabCheckFixed : (integer,sterml,integer,sterml) determ (i,i,o,o).
tabGenX : (integer,integer,string,integer,integer,sterml,sterml) determ (i,i,i,i,i,i,i).
tabGetPred : (sterm,string,sterml) determ (i,o,o).
tabST : (string,integer,sterml,string) determ (i,i,i,o).
clauses
% new table generation interface
%
generate(SolRef,ST) :-
	tabGenArgsFixed(SolRef,1,ST,NCols,_), 
	stb::stbH_Insert(SolRef,1,NCols,0,ST),
	tabGenCellsFixed(SolRef),
	setSort(SolRef,1,ST),
	!
;
	dlgIF::feil("table::generate",[ST],[SolRef],nill),!,fail.
% generates the table(s) corresponding to a solution set. tables are numbered 1,2,...
% parameters:
% 1	in	sol.set type (0=work set ie. in processing a proc.rule; 1=single or multi ST output set)
% 2	in	sol.ref.
% 3	in	query term
%
tabGen(Type,SolRef,Term) :-
	Type=1,
	sol::solSetSize(SolRef,N), N>0,
	tabGetPred(Term,Pred,Body),
	dbBase::smClassDef(Pred,"p",Card,DEs,_,_,_),
	DEs=[],
	NArgs=Card,
	tabCheckFixed(Card,Body,Fixed,Args), 
	tabGenX(Fixed,SolRef,Pred,Card,NArgs,Body,Args),
	!
;
	Type=1,
	sol::solSetSize(SolRef,N), N>0,
	tabGetPred(Term,Pred,Body),
	dbBase::smClassDef(Pred,"p",Card,_,_,_,_),
	NArgs=Card+1,
	tabCheckFixed(Card,Body,Fixed,Args),
	tabGenX(Fixed,SolRef,Pred,Card,NArgs,Body,Args),
	!
;
	Type=0,	
	sol::solSetSize(SolRef,N), N>0,
	sol::solComps(SolRef,NComps,Comps),
	tabGenSolArgs(SolRef,0,"",0,0,1,1,Comps,NArgs),
	stb::stbH_Insert(SolRef,1,NComps,0,""),
	stb::stbM_Insert(SolRef,1,"","",0,NArgs),	
	tabGenCellsFixed(SolRef),
	!
;
	dlgIF::feil("tabGen",[],[SolRef,Type],Term),!,fail.	
tabGenX(Fixed,SolRef,Pred,Card,NArgs,Body,Args) :-
	Fixed=1,	
	tabST(Pred,Card,Body,ST),
	tabGenArgsFixed(SolRef,1,ST,NCols,_), 
	stb::stbH_Insert(SolRef,1,NCols,0,ST),
	dbBase::nlSing(Pred,PredNL),
	stb::stbM_Insert(SolRef,1,Pred,PredNL,Card,NArgs),	
	tabGenCellsFixed(SolRef),
	setSort(SolRef,1,ST),
	!
;
	Fixed=-1,
	tabGenCellsOpen(SolRef,Pred,Card,NArgs,Args),
	!
;
	dlgIF::feil("tabGenX",[],[Fixed,SolRef,Card,NArgs],cmp("",[cmp("",Body),cmp("",Args)])),!,fail.
tabGetPred(cmp(",",[B|_]),Pred,Body) :- 
	tabGetPred(B,Pred,BOdy),
	!.
tabGetPred(cmp(Pred,Body),Pred,Body) :- 
	!.
tabCheckFixed(1,[var(_)|_],-1,[nill]) :- !.
tabCheckFixed(1,[cmp(E,B)|_],1,[cmp(E,B)]) :- !.
tabCheckFixed(2,[var(_),var(_)|_],-1,[nill,nill]) :- !.
tabCheckFixed(2,[var(_),cmp(E,B)|_],-1,[nill,cmp(E,B)]) :- !.
tabCheckFixed(2,[cmp(E,B),var(_)|_],-1,[cmp(E,B),nill]) :- !.
tabCheckFixed(2,[cmp(E1,B1),cmp(E2,B2)|_],1,[cmp(E1,B1),cmp(E2,B2)]) :- !.
tabCheckFixed(C,L,_,_) :- dlgIF::feil("tabCheckFixed",[],[C],cmp("",L)),!,fail.
tabST(P,1,[cmp(E,_)|_],ST) :- sx::concat([P,"|",E],ST),!.
tabST(P,2,[cmp(E1,_),cmp(E2,_)|_],ST) :- sx::concat([P,"|",E1,"|",E2],ST),!.
tabST(P,C,T,_) :- dlgIF::feil("tabST",[P],[C],cmp("",T)),!,fail.
% ------------------------------------------------------------------------------------------------------------
% tabGenSolArgs
% ------------------------------------------------------------------------------------------------------------
class predicates
tab_kbNL_Sing : (string,string) procedure (i,o).
tab_varComps : (string,string,integer,string) procedure (i,o,o,o).
tab_kbDE_Def : (string,sterm) determ (i,o).
clauses

tabGenSolArgs(SolRef,ArgNo,LastArg,_,DE_Count,_,_,[],1) :-
	tab_kbNL_Sing(LastArg,NLe),
	stb::stbA_Insert(SolRef,1,ArgNo,LastArg,NLe,DE_Count),
	!.
tabGenSolArgs(SolRef,ArgNo,LastArg,LastNo,DE_Count,ColNo,DE_No,[Comp|Comps],NArgs) :-
	tab_varComps(Comp,Ent,No,DE),
	Ent=LastArg,
	No=LastNo,
	% one more DE for current argument
	tab_kbDE_Def(DE,DE_Def),
	DE_Def=fstr(_,Domain,Frm,W),
	tab_kbNL_Sing(DE,NL),
	stb::stbD_Insert(SolRef,1,ArgNo,DE_No,ColNo,DE,NL,Domain,Frm,W,0),
	NextColNo=ColNo+1,
	NextDE_No=DE_No+1,
	DE_Cnt=DE_Count+1,
	tabGenSolArgs(SolRef,ArgNo,LastArg,LastNo,DE_Cnt,NextColNo,NextDE_No,Comps,NArgs),
	!
;	
	LastNo<>0,
	% first DE for this argument - insert previous argument first
	tab_kbNL_Sing(LastArg,NLe),
	stb::stbA_Insert(SolRef,1,ArgNo,LastArg,NLe,DE_Count),
	%
	tab_varComps(Comp,Ent,No,DE),
	NextArgNo=ArgNo+1,
	tab_kbDE_Def(DE,DE_Def),
	DE_Def=fstr(_,Domain,Frm,W),
	tab_kbNL_Sing(DE,NL),
	stb::stbD_Insert(SolRef,1,NextArgNo,1,ColNo,DE,NL,Domain,Frm,W,0),
	NextColNo=ColNo+1,
	tabGenSolArgs(SolRef,NextArgNo,Ent,No,1,NextColNo,2,Comps,NArgs2),
	NArgs=NArgs2+1,
	!
;
	LastNo=0,
	% first DE in first argument	
	tab_varComps(Comp,Ent,No,DE),
	NextArgNo=ArgNo+1,
	tab_kbDE_Def(DE,DE_Def),
	DE_Def=fstr(_,Domain,Frm,W),
	tab_kbNL_Sing(DE,NL),
	stb::stbD_Insert(SolRef,1,NextArgNo,1,ColNo,DE,NL,Domain,Frm,W,0),
	NextColNo=ColNo+1,
	tabGenSolArgs(SolRef,NextArgNo,Ent,No,1,NextColNo,2,Comps,NArgs),
	!.

% the tab_ predicates are introduced to handle table columns which are pure variables in internal
% solution sets rather than DE variables
%
tab_varComps(Comp,Ent,No,DE) :-
	vars::varComps(Comp,Ent,No,DE),
	!
;
	sx::frontchar(Ent,'_',Comp),
	sx::frontchar(DE,'_',Comp),
	No=1,
	!.	

tab_kbDE_Def(DE,DE_Def) :-
	sx::frontchar(DE,'_',_),
	DE_Def=fstr(DE,"p3_dany","",128), 
	%@@ 6.5.00 the problem here is that the domain and length of pure variable components are unknown.
	%this could possibly lead to problems of sorting is involved??
	!
;	
    dbBase::smDefTree(DE,Type,DE_Def),
    Type="a",
	!.

tab_kbNL_Sing(DE,NL) :-
	sx::frontchar(DE,'_',_),
	NL=DE,
	!
;
	dbBase::nlSing(DE,NL),
	!.
% ------------------------------------------------------------------------------------------------------------
% tbwGetRange
% ------------------------------------------------------------------------------------------------------------
tabGetRange(S,NRows,N1,N2) :-
	S="",
	N1=1,
	N2=NRows,!
;	
	L=string::length(S),
	L>0, L<3,
	dlgIF::dlgNote(2,"Range must have format e.g. '100-199'"),!,fail
;	
	sx::searchchar(S,'-',P),
	N=P-1,
	sx::frontstr(N,S,Fs,_),
	N1=sx::toInt(Fs),
	sx::frontstr(P,S,_,Ls),
	N2=sx::toInt(Ls),
	N1>=1,
	N2<=NRows,!
;
	dlgIF::dlgNote(2,"Range must have format e.g. '100-199'"),!,fail.	
% ------------------------------------------------------------------------------------------------------------
% tabSortIfRequired
% ------------------------------------------------------------------------------------------------------------
class predicates
tabHasSort : (integer,integer,integer,integer) determ.
clauses
% sorts or re-sorts a table if sorting key(s) are defined
%
tabSortIfRequired(SolRef,Table) :-
	vpi::cursorSetWait(),
	stb::stbH_Get(SolRef,Table,NCols,_,_,_,_,_),
	tabHasSort(SolRef,Table,1,NCols),
	% has sort key(s) - sort!
	stb::stbSort(SolRef,Table),
			tt::tt_table(3,"window sort-table",SolRef),
	W=guix::getWinOfClas(1),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	W=guix::getWinOfClas(1),
	vpi::cursorSet(W,vpiDomains::cursor_Arrow),
	!
;
	dlgIF::feil("tabSortIfRequired",[],[SolRef,Table],nill),
	!.	
% succeeds if sorting key(s) are defined for the table
%
tabHasSort(_,_,ColNo,NCols) :- 
	ColNo>NCols,
	!,fail.
tabHasSort(SolRef,Table,ColNo,NCols) :-
	stb::stbD_GetCol(SolRef,Table,ColNo,_,_,_,_,_,_,_,_,_,Sorted),
	Sorted>0,
	!
;		
	Next=ColNo+1,
	tabHasSort(SolRef,Table,Next,NCols),
	!.
% ------------------------------------------------------------------------------------------------------------
% tabDetermine
% ------------------------------------------------------------------------------------------------------------
class predicates
tabDetEnts : (integer,integer,integer,integer,sterml,string_list) determ (i,i,i,i,i,o).
tabM_Rec : (integer,string,integer,integer,integer) determ (i,i,i,i,o).
clauses
% used in multi-ST sol.sets to determine the appropriate table for a given solution. creates new table
% if appropriate table does not yet exist.
% parameters:
% 1	in	sol.ref.
% 2	in	sol.no.
% 3	in	sol.set predicate
% 4	in	sol.set predicate cardinality
% 5	in	#arguments
% 6	in	prelim. entity args (nill for open arguments)
% 7	out	table no (corresponding to input - a new table is created if not existing)
% 8	out	list of column formats for the table 
%	
tabDetermine(SolRef,SolNo,Pred,Card,NArgs,OpenArgs,Table,Formats) :-
	tabDetEnts(SolRef,SolNo,1,Card,OpenArgs,Ents),
	sx::sxlJoin([Pred|Ents],"|",ST),
	stb::stbST(SolRef,ST,Table),
	stb::stbH_Get(SolRef,Table,NCols,_,_,_,_,_),
	tabGetFormats(SolRef,Table,1,NCols,Formats),
	!
;
	% table does not exist - create it	
	tabDetEnts(SolRef,SolNo,1,Card,OpenArgs,Ents),
	sx::sxlJoin([Pred|Ents],"|",ST),	
	tabM_Rec(SolRef,Pred,Card,NArgs,Table),
	tabGenArgsOpen(SolRef,Table,ST,Pred,Card,Ents,NCols,_),
	stb::stbH_Insert(SolRef,Table,NCols,0,ST),
	setSort(SolRef,Table,ST),
	dbBase::nlSing(Pred,_),
	tabGetFormats(SolRef,Table,1,NCols,Formats),
	!
;
	dlgIF::feil("tabDetermine",[Pred],[SolRef,Card,NArgs],nill),!,fail.		
tabDetEnts(_,_,EntNo,Card,[],[]) :- 
	EntNo>Card,!.
tabDetEnts(SolRef,SolNo,EntNo,Card,[nill|Args],[Ent|Ents]) :-
	sol::solCompNo(SolRef,SolNo,EntNo,Val),
	Val=cmp(Ent,_),
	Next=EntNo+1,
	tabDetEnts(SolRef,SolNo,Next,Card,Args,Ents),!.
tabDetEnts(SolRef,SolNo,EntNo,Card,[Arg|OpenArgs],[Ent|Ents]) :-
	Arg=cmp(Ent,_),
	Next=EntNo+1,
	tabDetEnts(SolRef,SolNo,Next,Card,OpenArgs,Ents),!.
tabDetEnts(SolRef,SolNo,EntNo,Card,OpenArgs,_) :-
	dlgIF::feil("tabDetEnts",[],[SolRef,SolNo,EntNo,Card],cmp("",OpenArgs)),!,fail.	
	
tabM_Rec(SolRef,Pred,Card,NArgs,Table) :-
	stb::stbM_GetF(SolRef,NTables,_,_,_,_),
	% M-record exists	
	Table=NTables+1,
	stb::stbM_SetNTables(SolRef,Table),!
;	
	% create M-record
	Table=1,
	dbBase::nlSing(Pred,PredNL),
	stb::stbM_Insert(SolRef,1,Pred,PredNL,Card,NArgs),!.
% ------------------------------------------------------------------------------------------------------------
% tabEdCols
% ------------------------------------------------------------------------------------------------------------
class predicates
tabEdColsX : (integer,integer,integer,integer,sterml) determ (i,i,i,i,o).
clauses
% generates a sterm-list of column headers and formats on the format:
% cmp("",[int(ColNo),str(DE_NL),str(ArgNL),int(DE_NO),str(Domain),str(Format),int(Width),int(Pixels)])
%
tabEdCols(SolRef,Table,Cols) :-
	stb::stbH_Get(SolRef,Table,NCols,_,_,_,_,_),
	tabEdColsX(SolRef,Table,1,NCols,Cols),
	!
;
	dlgIF::feil("tabEdCols",[],[SolRef,Table],nill),!,fail.
	
tabEdColsX(_,_,ColNo,NCols,[]) :- 
	ColNo>NCols,
	!.		
tabEdColsX(SolRef,Table,ColNo,NCols,[Col|Cols]) :- 
	stb::stbD_GetCol(SolRef,Table,ColNo,ArgNo,DE_No,_,DE_NL,Domain,Form,Width,Pixels,Display,_),
	Display=1,
	DE_No=1,
	stb::stbA_Get(SolRef,Table,ArgNo,_,ArgNL,_),
	Col=cmp("",[int(ColNo),str(DE_NL),str(ArgNL),str(Domain),str(Form),int(Width),int(Pixels)]),
	Next=ColNo+1,
	tabEdColsX(SolRef,Table,Next,NCols,Cols),
	!
;	
	stb::stbD_GetCol(SolRef,Table,ColNo,_,DE_No,_,DE_NL,Domain,Form,Width,Pixels,Display,_),
	Display=1,
	DE_No>1,
	Col=cmp("",[int(ColNo),str(DE_NL),str(""),str(Domain),str(Form),int(Width),int(Pixels)]),
	Next=ColNo+1,
	tabEdColsX(SolRef,Table,Next,NCols,Cols),
	!.
tabEdColsX(SolRef,Table,ColNo,NCols,Cols) :- 
	Next=ColNo+1,
	tabEdColsX(SolRef,Table,Next,NCols,Cols),
	!.
% -------------------------------------------------------------------------------------------------------------
% tabEdContents
% -------------------------------------------------------------------------------------------------------------
class predicates
tabEdC : (outFile,integer_list,integer,integer,integer,integer,sterml) determ.
tabEdC_Adj : (string,integer,string,string) procedure (i,i,i,o).
tabExp_Adj : (string,string,string) procedure (i,i,o).
clauses

tabEdContents(Rep,Ws,Export,SolRef,Table,From,To,Cols) :-
	stb::foralltable(SolRef,Table,LRow,PRow),
	   LRow>=From,
	   tabEdC(Rep,Ws,Export,SolRef,Table,PRow,Cols),
	   LRow=To,
	!
;
    !.

tabEdC(Rep,_,-1,_,_,_,[]) :-
    Rep:writenl(""),
    !.
tabEdC(Rep,[W|Ws],-1,SolRef,Table,Row,[Col|Cols]) :-		   
	Col=cmp("",[int(ColNo),_,_,str(Domain),_,_,_]),
	stb::stbCellGet(SolRef,Table,Row,ColNo,ValNL,_),
	tabEdC_Adj(ValNL,W,Domain,S),
	Rep:write(S," "),
	tabEdC(Rep,Ws,-1,SolRef,Table,Row,Cols),
	!.
tabEdC(Rep,_,1,SolRef,Table,Row,[Col]) :-		   
	Col=cmp("",[int(ColNo),_,_,str(Domain),_,_,_]),
	stb::stbCellGet(SolRef,Table,Row,ColNo,ValNL,_),
	tabExp_Adj(ValNL,Domain,S),
	Rep:writenl(S),
	!.
tabEdC(Rep,Ws,1,SolRef,Table,Row,[Col|Cols]) :-		   
	Col=cmp("",[int(ColNo),_,_,str(Domain),_,_,_]),
	stb::stbCellGet(SolRef,Table,Row,ColNo,ValNL,_),
	tabExp_Adj(ValNL,Domain,S),
	Delim=globalVars::get_s("delim"),
	Rep:write(S,Delim),
	tabEdC(Rep,Ws,1,SolRef,Table,Row,Cols),
	!.
tabEdC(_,_,Export,SolRef,Table,Row,[Col|_]) :-		   
	dlgIF::feil("tabEdC",[],[Export,SolRef,Table,Row],Col),!,fail.	
	
tabEdC_Adj(NL,W,D,S) :-	
	dom::domInt(D),
	sx::sxL_Pad(NL," ",W,S),
	!
;
	dom::domFix(D),
	sx::sxL_Pad(NL," ",W,S),
	!
;
	sx::sxR_Pad(NL," ",W,S),
	!.	
tabExp_Adj(S,"p3_dli_l",R) :-
	sx::sxQuote(S,R),
	!.
tabExp_Adj(S,_,S) :- 
	!.	
% -------------------------------------------------------------------------------------------------------------
% tabGenArgsFixed;tabGenArgsOpen
% -------------------------------------------------------------------------------------------------------------
class predicates
tabGenArg : (integer,integer,integer,integer,string,integer_list,integer_list,string_list,integer,integer,integer) determ (i,i,i,i,i,i,i,i,i,o,o).
tabGenDEs : (integer,integer,integer,string_list,integer,integer,integer,integer_list,integer_list,string_list,integer) determ (i,i,i,i,i,i,i,i,i,i,o).
clauses
% parameters:
% 1	in	sol.ref.
% 2	in	table#
% 3	in	ST (KB-name)
% 4	out	#cols in table
% 5 out #pixels in table (width)
%
tabGenArgsFixed(SolRef,Table,ST,NCols,TotPix) :-
    sx::sxUnpack(ST,'|',STL),
    STL=[Pred,E1],
    layout::load(ST,_,Sorts,Ws,Fs,_) ,
	tabGenArg(SolRef,Table,1,1,E1,Sorts,Ws,Fs,1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,1,2,Pred,Sorts,Ws,Fs,ColNo1,ColNo2,Pix2),
	NCols=ColNo2-1,
	TotPix=Pix1+Pix2,
	!
;	
    sx::sxUnpack(ST,'|',STL),
    STL=[Pred,E1],
	tabGenArg(SolRef,Table,1,1,E1,[],[],[],1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,1,2,Pred,[],[],[],ColNo1,ColNo2,Pix2),
	NCols=ColNo2-1,
	TotPix=Pix1+Pix2,
	!.
tabGenArgsFixed(SolRef,Table,ST,NCols,TotPix) :-
    sx::sxUnpack(ST,'|',STL),
    STL=[Pred,E1,E2],
    layout::load(ST,_,Sorts,Ws,Fs,_) ,
	tabGenArg(SolRef,Table,2,1,E1,Sorts,Ws,Fs,1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,2,2,E2,Sorts,Ws,Fs,ColNo1,ColNo2,Pix2),
	tabGenArg(SolRef,Table,2,3,Pred,Sorts,Ws,Fs,ColNo2,ColNo3,Pix3),
	NCols=ColNo3-1,
	TotPix=Pix1+Pix2+Pix3,
	!
;	
    sx::sxUnpack(ST,'|',STL),
    STL=[Pred,E1,E2],
	tabGenArg(SolRef,Table,2,1,E1,[],[],[],1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,2,2,E2,[],[],[],ColNo1,ColNo2,Pix2),
	tabGenArg(SolRef,Table,2,3,Pred,[],[],[],ColNo2,ColNo3,Pix3),
	NCols=ColNo3-1,
	TotPix=Pix1+Pix2+Pix3,
	!.
tabGenArgsFixed(SolRef,Table,ST,_,_) :-
	dlgIF::feil("tabGenArgsFixed",[ST],[SolRef,Table],nill),!,fail.
tabGenArgsOpen(SolRef,Table,ST,Pred,1,[E1],NCols,TotPix) :-
    layout::load(ST,_,Sorts,Ws,Fs,_) ,
	tabGenArg(SolRef,Table,1,1,E1,Sorts,Ws,Fs,1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,1,2,Pred,Sorts,Ws,Fs,ColNo1,ColNo2,Pix2),
	NCols=ColNo2-1,
	TotPix=Pix1+Pix2,
	!
;	
	tabGenArg(SolRef,Table,1,1,E1,[],[],[],1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,1,2,Pred,[],[],[],ColNo1,ColNo2,Pix2),
	NCols=ColNo2-1,
	TotPix=Pix1+Pix2,
	!.
tabGenArgsOpen(SolRef,Table,ST,Pred,2,[E1,E2],NCols,TotPix) :-
    layout::load(ST,_,Sorts,Ws,Fs,_),
	tabGenArg(SolRef,Table,2,1,E1,Sorts,Ws,Fs,1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,2,2,E2,Sorts,Ws,Fs,ColNo1,ColNo2,Pix2),
	tabGenArg(SolRef,Table,2,3,Pred,Sorts,Ws,Fs,ColNo2,ColNo3,Pix3),
	TotPix=Pix1+Pix2+Pix3,
	NCols=ColNo3-1,
	!
;	
	tabGenArg(SolRef,Table,2,1,E1,[],[],[],1,ColNo1,Pix1),
	tabGenArg(SolRef,Table,2,2,E2,[],[],[],ColNo1,ColNo2,Pix2),
	tabGenArg(SolRef,Table,2,3,Pred,[],[],[],ColNo2,ColNo3,Pix3),
	TotPix=Pix1+Pix2+Pix3,
	NCols=ColNo3-1,
	!.
tabGenArgsOpen(SolRef,Table,ST,Pred,Card,Ents,_,_) :-
	dlgIF::feil("tabGenArgsOpen",[ST,Pred|Ents],[SolRef,Table,Card],nill),!,fail.
	
tabGenArg(SolRef,TabNo,Card,ArgNo,Ent,Sorts,Ws,Fs,FirstCol,NextCol,Pixs) :-	
	ArgNo<=Card,
	dbBase::nlSing(Ent,NL),
	dbBase::kbEntityDEs(Ent,DEs,_),
	set::size(DEs,N),	
	stb::stbA_Insert(SolRef,TabNo,ArgNo,Ent,NL,N),
	NextCol=FirstCol+N,
	tabGenDEs(SolRef,TabNo,ArgNo,DEs,1,FirstCol,NextCol,Sorts,Ws,Fs,Pixs),
	!
;
	ArgNo<=Card,
	dlgIF::feil("tabGenArg",[Ent],[SolRef,TabNo,ArgNo,Card,FirstCol],nill),!,fail.
tabGenArg(SolRef,TabNo,Card,ArgNo,Pred,Sorts,Ws,Fs,FirstCol,NextCol,Pixs) :-	
	ArgNo>Card,
	dbBase::kbPredDEs(Pred,DEs,_),
	DEs=[],
	NextCol=FirstCol,
	Pixs=0,
	!
;
	ArgNo>Card,
	dbBase::nlSing(Pred,NL),
	dbBase::kbPredDEs(Pred,DEs,_),
	set::size(DEs,N),	                         
	stb::stbA_Insert(SolRef,TabNo,ArgNo,Pred,NL,N),
	NextCol=FirstCol+N,
	tabGenDEs(SolRef,TabNo,ArgNo,DEs,1,FirstCol,NextCol,Sorts,Ws,Fs,Pixs),
	!
;
	ArgNo>Card,
	dlgIF::feil("tabGenArg",[Pred],[SolRef,TabNo,ArgNo,Card,FirstCol],nill),!,fail.

tabGenDEs(_,_,_,_,_,No,No,_,_,_,0) :- 
	!.
tabGenDEs(SolRef,TabNo,ArgNo,[D|DEs],DNo,ColNo,LastCol,[],[],[],TotPix) :-
    % simple DE
	dbBase::nlSing(D,NL),
	dbBase::smClassDef(D,"a",_,_,Domain,Frm,W),
	Pix=guix::pixelsDigits(1,W),
	set::setMin([500,Pix],Pixs),
	stb::stbD_Insert(SolRef,TabNo,ArgNo,DNo,ColNo,D,NL,Domain,Frm,W,Pixs),
	Next=ColNo+1,
	DNo2=DNo+1,
	tabGenDEs(SolRef,TabNo,ArgNo,DEs,DNo2,Next,LastCol,[],[],[],TPix),
	TotPix=TPix+Pixs,
	!.
tabGenDEs(SolRef,TabNo,ArgNo,[D|DEs],DNo,ColNo,LastCol,Sorts,Ws,Fs,TotPix) :-
	dbBase::nlSing(D,NL),
	dbBase::smClassDef(D,"a",_,_,Domain,_,_),
	set::setGet(Ws,ColNo,W),
	set::setGet(Fs,ColNo,Frm),
	Pixs=guix::pixelsDigits(1,W),
	stb::stbD_Insert(SolRef,TabNo,ArgNo,DNo,ColNo,D,NL,Domain,Frm,W,Pixs),
	set::setGet(Sorts,ColNo,SortNo),
	ASort=math::abs(SortNo),
    stb::stbD_SetSort(SolRef,TabNo,ColNo,ASort),
	Next=ColNo+1,
	DNo2=DNo+1,
	tabGenDEs(SolRef,TabNo,ArgNo,DEs,DNo2,Next,LastCol,Sorts,Ws,Fs,TPix),
	TotPix=TPix+Pixs,
	!.
tabGenDEs(SolRef,TabNo,ArgNo,DEs,DNo,FCol,LCol,_,_,_,_) :- 
	dlgIF::feil("tabGenDEs",DEs,[SolRef,TabNo,ArgNo,DNo,FCol,LCol],nill),!,fail.
% -------------------------------------------------------------------------------------------------------------
% tabGenCellsFixed
% -------------------------------------------------------------------------------------------------------------
class predicates
tabGenCell : (integer,integer,integer,integer,integer,integer,sterml) determ (i,i,i,i,i,i,i).
tabGenCellMDE : (integer,integer,integer,integer,integer,sterml,sterml) determ (i,i,i,i,i,i,i).
clauses
tabGenCellsFixed(SolRef) :-
	sol::solSetSize(SolRef,NSol),
	stb::stbH_SetNRows(SolRef,1,NSol),
	stb::stbH_Get(SolRef,1,NCol,_,_,_,_,_),
	tabGetFormats(SolRef,1,1,NCol,Formats),
	sol::forallsol(SolRef,SolNo),
	   tabGenCell(SolRef,1,SolNo,1,NCol,1,Formats),
	   fail
;
	!.
	
tabGenCell(_,_,_,ColNo,NCol,_,_) :- 
	ColNo>NCol,
	!.			   
tabGenCell(SolRef,Table,SolNo,ColNo,NCol,CompNo,Formats) :-
	Formats=[cmp("*",_)|_],
	sol::solCompNo(SolRef,SolNo,CompNo,Val),
	Val=cmp(_,Vals),
	tabGenCellMDE(SolRef,Table,SolNo,ColNo,NCol,Formats,Vals),
	set::size(Vals,N),
	Next=ColNo+N,
	NextComp=CompNo+1,
	set::setRemFront(Formats,N,NFormats),
	tabGenCell(SolRef,Table,SolNo,Next,NCol,NextComp,NFormats),
	!.
tabGenCell(SolRef,Table,SolNo,ColNo,NCol,CompNo,[cmp("",[str(Dom),str(Form),_])|Formats]) :-
	sol::solCompNo(SolRef,SolNo,CompNo,Val),
	nl::conValX(Val,Dom,Form,S1),
	sx::sxUnquote(S1,S),
	stb::stbCellInsert(SolRef,Table,SolNo,ColNo,S,Val),
	Next=ColNo+1,
	NextComp=CompNo+1,
	tabGenCell(SolRef,Table,SolNo,Next,NCol,NextComp,Formats),
	!.
tabGenCell(SolRef,Table,_,ColNo,NCol,CompNo,Formats) :- 
	dlgIF::feil("tabGenCell",[],[SolRef,Table,ColNo,NCol,CompNo],cmp("",Formats)),!,fail.
tabGenCellMDE(_,_,_,_,_,_,[]) :-
	!.
tabGenCellMDE(SolRef,Table,SolNo,ColNo,NCol,[cmp("*",[str(Dom),str(Form),_])|Formats],[Val|Vals]) :-
	nl::conValX(Val,Dom,Form,S1),
	sx::sxUnquote(S1,S),
	stb::stbCellInsert(SolRef,Table,SolNo,ColNo,S,Val),
	Next=ColNo+1,
	tabGenCellMDE(SolRef,Table,SolNo,Next,NCol,Formats,Vals),
	!.
% -------------------------------------------------------------------------------------------------------------
% tabGenCellsIF
% -------------------------------------------------------------------------------------------------------------
class predicates
tabGenCellIF : (integer,integer,integer,integer,integer,sterml,sterml) determ (i,i,i,i,i,i,i).
tabGenCellMDE_IF : (integer,integer,integer,integer,integer,sterml,sterml) determ (i,i,i,i,i,i,i).
tabGenCellArgs : (integer,integer,integer,integer,integer,sterml,sterml) determ (i,i,i,i,i,i,i).
clauses
% generates one table row from the given term
%
tabGenCellsIF(SolRef,Table,T) :-
	stb::stbH_Get(SolRef,Table,NCol,NRows,_,_,_,_),
	N=NRows+1,
	stb::stbH_SetNRows(SolRef,Table,N),
	tabGetFormats(SolRef,1,1,NCol,Formats),
	T=cmp(_,Args),
	tabGenCellArgs(SolRef,Table,N,1,NCol,Formats,Args),
	!.
tabGenCellArgs(SolRef,Table,NRow,ColNo,NCol,Formats,Args) :-
	Args=[cmp(_,Da),cmp(_,Db)|Dc],
	set::conc([Da,Db,Dc],Ds),
	tabGenCellIF(SolRef,Table,NRow,ColNo,NCol,Formats,Ds),
	!
;
	Args=[cmp(_,Da)|Dc],
	set::conc([Da,Dc],Ds),
	tabGenCellIF(SolRef,Table,NRow,ColNo,NCol,Formats,Ds),
	!
;
	dlgIF::feil("tabGenCellArgs",[],[SolRef,Table,NRow,ColNo,NCol],cmp("",Args)),!,fail.	
tabGenCellIF(_,_,_,ColNo,NCol,_,_) :- 
	ColNo>NCol,
	!.			   
tabGenCellIF(SolRef,Table,NRow,ColNo,NCol,Formats,[Val|Args]) :-
	Formats=[cmp("*",_)|_],
	Val=cmp(_,Vals),
	tabGenCellMDE(SolRef,Table,NRow,ColNo,NCol,Formats,Vals),
	set::size(Vals,N),
	Next=ColNo+N,
	set::setRemFront(Formats,N,NFormats),
	tabGenCellIF(SolRef,Table,NRow,Next,NCol,NFormats,Args),
	!.
tabGenCellIF(SolRef,Table,NRow,ColNo,NCol,[cmp("",[str(Dom),str(Form),_])|Formats],[Val|Args]) :-
	nl::conValX(Val,Dom,Form,S1),
	sx::sxUnquote(S1,S),
	stb::stbCellInsert(SolRef,Table,NRow,ColNo,S,Val),
	Next=ColNo+1,
	tabGenCellIF(SolRef,Table,NRow,Next,NCol,Formats,Args),
	!.
tabGenCellIF(SolRef,Table,NRow,ColNo,NCol,Formats,Args) :- 
	dlgIF::feil("tabGenCellIF",[],[SolRef,Table,NRow,ColNo,NCol],cmp("",[cmp("",Formats),cmp("",Args)])),!,fail.
tabGenCellMDE_IF(_,_,_,_,_,_,[]) :-
	!.
tabGenCellMDE_IF(SolRef,Table,NRow,ColNo,NCol,[cmp("*",[str(Dom),str(Form),_])|Formats],[Val|Vals]) :-
	nl::conValX(Val,Dom,Form,S1),
	sx::sxUnquote(S1,S),
	stb::stbCellInsert(SolRef,Table,NRow,ColNo,S,Val),
	Next=ColNo+1,
	tabGenCellMDE_IF(SolRef,Table,NRow,Next,NCol,Formats,Vals),
	!.
% -------------------------------------------------------------------------------------------------------------
% tabGenCellsOpen
% -------------------------------------------------------------------------------------------------------------
class predicates
tabGenCellOpen : (integer,integer,integer,integer,sterml,sterml) determ.
tabGenColValsE : (sterml,sterml,integer) determ (i,o,o).
tabGetColVals : (integer,integer,integer,integer,integer,sterml) determ (i,i,i,i,i,o).
clauses
tabGenCellsOpen(SolRef,Pred,Card,NArgs,Args) :-
	sol::forallsol(SolRef,SolNo),
	   tabDetermine(SolRef,SolNo,Pred,Card,NArgs,Args,Table,Formats),
	   stb::stbH_Get(SolRef,Table,NCols,_,_,_,_,_),
	   stb::stbH_IncRows(SolRef,Table,RowNo),
	   tabGetColVals(SolRef,SolNo,1,1,NCols,ColVals),
	   tabGenCellOpen(SolRef,Table,RowNo,1,ColVals,Formats),
	   fail
;
	!.
tabGetColVals(_,_,_,ColNo,NCols,[]) :- 
	ColNo>NCols,
	!.
tabGetColVals(SolRef,SolNo,ArgNo,ColNo,NCols,ColVals) :-
	sol::solCompNo(SolRef,SolNo,ArgNo,ArgVal),
	ArgVal=cmp(_,DVals),
	% entity argument w/ sub DE values
	tabGenColValsE(DVals,DValsM,N),
	NextCol=ColNo+N,
	NextArg=ArgNo+1,
	tabGetColVals(SolRef,SolNo,NextArg,NextCol,NCols,Vals),
	set::conc([DValsM,Vals],ColVals),
	!
;
	% predicate's DE values
	sol::solCompNo(SolRef,SolNo,ArgNo,Val),
	NextArg=ArgNo+1,
	NextCol=ColNo+1,
	tabGetColVals(SolRef,SolNo,NextArg,NextCol,NCols,Vals),
	ColVals=[Val|Vals],
	!.
	
tabGenColValsE([],[],0) :-
	!.
tabGenColValsE([Val|Vals],[Val|ValsM],N) :-
	tabGenColValsE(Vals,ValsM,M),
	N=M+1,
	!.

tabGenCellOpen(_,_,_,_,[],_) :- 
	!.			   
tabGenCellOpen(SolRef,Table,SolNo,ColNo,[Val|Vals],[cmp(_,[str(Dom),str(Form),_])|Formats]) :-
	nl::conValX(Val,Dom,Form,S2),
	sx::sxUnquote(S2,S),
	stb::stbCellInsert(SolRef,Table,SolNo,ColNo,S,Val),
	Next=ColNo+1,
	tabGenCellOpen(SolRef,Table,SolNo,Next,Vals,Formats),
	!.
tabGenCellOpen(SolRef,Table,_,ColNo,Vals,Formats) :- 
	dlgIF::feil("tabGenCellOpen",[],[SolRef,Table,ColNo],cmp("",[cmp("",Vals),cmp("",Formats)])),!,fail.
% -------------------------------------------------------------------------------------------------------------
% tabGenEmpty
% -------------------------------------------------------------------------------------------------------------
class predicates
tabPredHasDEs : (string,integer) procedure (i,o).
clauses

tabGenEmpty(SolRef,Table,ST) :-
	sx::sxUnpack(ST,'|',STL),
	STL=[P,Ea,Eb],
    layout::load(ST,_,Sorts,Ws,Fs,_),
	tabGenArg(SolRef,Table,2,1,Ea,Sorts,Ws,Fs,1,ColNo1,_),
	tabGenArg(SolRef,Table,2,2,Eb,Sorts,Ws,Fs,ColNo1,ColNo2,_),
	tabGenArg(SolRef,Table,2,3,P,Sorts,Ws,Fs,ColNo2,ColNo3,_),
	NCols=ColNo3-1,
	tabPredHasDEs(P,N),
	NArgs=2+N,
	stb::stbH_Insert(SolRef,Table,NCols,0,ST),
	dbBase::nlSing(P,PN),
	stb::stbM_Insert(SolRef,Table,P,PN,2,NArgs),
	!	
;
	sx::sxUnpack(ST,'|',STL),
	STL=[P,Ea,Eb],
	tabGenArg(SolRef,Table,2,1,Ea,[],[],[],1,ColNo1,_),
	tabGenArg(SolRef,Table,2,2,Eb,[],[],[],ColNo1,ColNo2,_),
	tabGenArg(SolRef,Table,2,3,P,[],[],[],ColNo2,ColNo3,_),
	NCols=ColNo3-1,
	tabPredHasDEs(P,N),
	NArgs=2+N,
	stb::stbH_Insert(SolRef,Table,NCols,0,ST),
	dbBase::nlSing(P,PN),
	stb::stbM_Insert(SolRef,Table,P,PN,2,NArgs),
	!	
;
	sx::sxUnpack(ST,'|',STL),
	STL=[P,Ea],
    layout::load(ST,_,Sorts,Ws,Fs,_),
	tabGenArg(SolRef,Table,1,1,Ea,Sorts,Ws,Fs,1,ColNo1,_),
	tabGenArg(SolRef,Table,1,2,P,Sorts,Ws,Fs,ColNo1,ColNo2,_),
	NCols=ColNo2-1,
	tabPredHasDEs(P,N),
	NArgs=1+N,
	stb::stbH_Insert(SolRef,Table,NCols,0,ST),
	dbBase::nlSing(P,PN),
	stb::stbM_Insert(SolRef,Table,P,PN,1,NArgs),
	!
;
	sx::sxUnpack(ST,'|',STL),
	STL=[P,Ea],
	tabGenArg(SolRef,Table,1,1,Ea,[],[],[],1,ColNo1,_),
	tabGenArg(SolRef,Table,1,2,P,[],[],[],ColNo1,ColNo2,_),
	NCols=ColNo2-1,
	tabPredHasDEs(P,N),
	NArgs=1+N,
	stb::stbH_Insert(SolRef,Table,NCols,0,ST),
	dbBase::nlSing(P,PN),
	stb::stbM_Insert(SolRef,Table,P,PN,1,NArgs),
	!.	
	
tabPredHasDEs(P,N) :-
	dbBase::smClassDef(P,"p",_,DEs,_,_,_),
	set::size(DEs,M),
	M>0,
	N=1,
	!
;
	N=0,
	!.
% -------------------------------------------------------------------------------------------------------------
% tabGetFormats
% -------------------------------------------------------------------------------------------------------------
% returns a list of table column formats.
%
tabGetFormats(_,_,ColNo,NCol,[]) :- 
	ColNo>NCol,
	!.	
tabGetFormats(SolRef,Table,ColNo,NCol,[cmp("",[str(Dom),str(Form),int(Width)])|Formats]) :-
	stb::stbD_GetCol(SolRef,Table,ColNo,_,_,_,_,Dom,Form,Width,_,_,_),
	NextCol=ColNo+1,
	tabGetFormats(SolRef,Table,NextCol,NCol,Formats),
	!.
tabGetFormats(SolRef,Table,ColNo,NCol,_) :- 
	dlgIF::feil("tabGetFormats",[],[SolRef,Table,ColNo,NCol],nill),!,fail.	
% --------------------------------------------------------------------------
% setSort
% --------------------------------------------------------------------------
class predicates
setSortX : (integer,integer,integer,integer) determ.
clauses

setSort(SolRef,Table,ST) :-
    layout::load(ST,_,Sorts,_,_,_),
    set::setMax(Sorts,Max),
    set::setMin(Sorts,Min),
    setSortX(Min,Max,SolRef,Table),
    !
;
    !.
    
setSortX(Min,Max,SolRef,Table) :-
    Min<0,
    %stb::stbH_SetSort(SolRef,Table,1),
    stb::stbH_SetSortOrder(SolRef,Table,-1),
    !
;    
    Max>0,
    %stb::stbH_SetSort(SolRef,Table,1),
    stb::stbH_SetSortOrder(SolRef,Table,1),
    !.
% --------------------------------------------------------------------------
% solSort
% --------------------------------------------------------------------------
class predicates
solSort1 : (integer,integer,integer_list) determ.
solSortSet : (integer,integer,integer_list) determ.
clauses
%
% a solution set is not sorted directly, it is sorted by the generation of a table
% corresponding to the solution  set. the table is then sorted, and the solution  set is 
% thereafter accessed in sorted order through this table. 
%
% sorting of sets are only used within the inf. engine when evaluating procedure rules.
% parameters:
% 1	in	solution ref.
% 2	in	list of solution  component nos corresponding to the sort keys.
%    		18.6.00 no longer supported:
%		this list can be empty in which case a dummy sorting is carried out based\on component#1
%
solSort(SolRef,[]) :- 
	% 18.6.00 solSort(SolRef,[1]),
	tt::tt_i(1,"Empty sorting key - set not sorted",SolRef),
	!.
solSort(SolRef,Keys) :-
	sol::solSetSize(SolRef,N),
	N=0,
	dlgIF::feil("solSort/1",[],[SolRef|Keys],nill),!,fail
;
	stb::stbM_GetF(SolRef,_,_,_,_,_), 
	% this is a re-sort
	stb::stbDeleteSolAll(SolRef),
	solSort(SolRef,Keys),
	!
;
	% tables are not generated 
	sol::solSetHeader(SolRef,_,_,_,Query,_),
	tabGen(0,SolRef,Query),
	stb::stbM_GetF(SolRef,NTables,_,_,_,_),
	solSort1(SolRef,NTables,Keys),
	!
;
	dlgIF::feil("solSort",[],[SolRef|Keys],nill),!,fail.	
solSort1(SolRef,1,Keys) :-
	solSortSet(SolRef,1,Keys),
			tt::tt_is(4,"sort-keys",Keys),
	stb::stbSort(SolRef,1),
	!.
solSort1(SolRef,N,Keys) :- 
	dlgIF::feil("solSort1",[],[SolRef,N|Keys],nill),!,fail.
solSortSet(_,_,[]) :- 
	!.
solSortSet(SolRef,N,[Key|Keys]) :-
	stb::stbD_SetSort(SolRef,1,Key,N),
	Next=N+1,
	solSortSet(SolRef,Next,Keys),
	!.
end implement table