/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement tedbutton
open core,termDomain,globalDomains

constants
className = "com/rudstrand/tedbutton/tedbutton".
classVersion = "1.0".

class predicates
checkValidSort : (string_list,string_list) determ.
collapseRows : (vpiTableed::tableedit_DATA,vpiTableed::tableedit_COLUMNDATA) determ (i,o).
readColData_s : (vpiDomains::windowHandle,integer,string_list) determ (i,i,o).
readCell_s : (vpiTableed::tableedit_CELLDATA,string) determ (i,o).
readCells_s : (vpiTableed::tableedit_COLUMNDATA,string_list) determ (i,o).

clauses
classInfo(className, classVersion).

% events for table layout windows (202):
% 20001 save + display (and close)
% 20002 delete (and close)
%
button(W,Button) :- 
    guix::getWinAll(Clas,ST,W,_,_,_),
    Clas=202,
    Button=20001,
    % save
    dbBase::stNL_KB(ST,STk),
    sx::sxQuote(STk,STkq),
    C=guix::succ(W),
    readColData_s(C,2,DEs),
    dbBase::kbIDs(DEs,DEsK),
    sx::sxlJoin(DEsK,",",SDEs),
    readColData_s(C,4,SortKeys),
    checkValidSort(DEsK,SortKeys),
    sx::sxlJoin(SortKeys,",",SSortKeys),
    readColData_s(C,5,Widths),
    sx::sxlJoin(Widths,",",SWidths),
    readColData_s(C,6,Formats),
    sx::quoteList(Formats,FormatsQ),
    sx::sxlJoin(FormatsQ,",",SFormats),
    PR=string::concatList(["y(p3_eTabLay(",STkq,",[",SDEs,"],[",SSortKeys,"],[",SWidths,"],[",SFormats,"]))."]),
    layout::insert(STk,PR),
    guix::getWinAll(203,ST,_,SolRef,TabNo,_),
    stb::reOpen(SolRef,TabNo),
    _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest()),
    !
;    
    guix::getWinAll(Clas,ST,W,_,_,_),
    Clas=202,
    Button=20002,
    % delete
    dbBase::stNL_KB(ST,STk),
    layout::load(STk,_,_,_,_,Loc),
    dbBase::recordDelete(Loc),
    _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest()),
    !
;    
    guix::getWinAll(Clas,_,W,_,_,_),
    Clas=202,
    Button=20002,
    % delete
    _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest()),
    !.
% events for sentence windows (201):
% 20001 save new
% 20002 update
% 20003 delete
% 20004 next
% 20005 prev
%
button(W,Button) :-    
    guix::getWinClas(W)=201,
    set::member(Button,[20002,20003]),
    ST=vpi::winGetText(W),
    dbBase::stNL_KB(ST,STk),
    dbBase::kbST_DEs(STk,DEs),
    set::size(DEs,N),
    Row=N+2,
    guix::getWin(W,No),
    No2=No+1,
    guix::getWin(TW,No2),
    Cell=vpiTableed::tableedit_getcelldata(TW,Row,2),
    Cell=vpiTableed::sc(S,_),
    sx::sxUnpackS(S,"] ",L),
    L=[_,Typ],
    Typ="DERIVED",
    dlgIF::dlgNote(1,"Cannot delete or update derived sentences!"),
    !
;
    guix::getWinClas(W)=201,
    Button=20001, 
    ST=vpi::winGetText(W),
    dbBase::stNL_KB(ST,STk),
    dbBase::kbST_DEs(STk,DEs),
    set::size(DEs,N),
    guix::getWin(W,No),
    No2=No+1,
    guix::getWin(TW,No2),
    % read the values
    sx::sxUnpack(STk,'|',Args),
    sentence::readCells(TW,Args,Term),
    dbBase::recordInsert(2,"$DAT",0,0,Term,atom("true"),Loc),
    Row=N+1,
    Cell=vpiTableed::tableedit_getcelldata(TW,Row,2),
    Cell=vpiTableed::sc(_,Color),
    vpiTableed::tableedit_setcelldata(TW,Row,2,vpiTableed::sc("$DAT",Color)),
    SRef2=dbBase::dbRef(Loc),
    S3=string::concat("[",SRef2,"] INPUT"),
    Row2=Row+1,
    vpiTableed::tableedit_setcelldata(TW,Row2,2,vpiTableed::sc(S3,Color)),
    dlgIF::dlgNote(0,"Sentence inserted!"),
    !
;
    guix::getWinClas(W)=201,
    Button=20001, 
    dlgIF::dlgNote(1,"New sentence NOT inserted!"),
    !
;
    guix::getWinClas(W)=201,
    Button=20002, 
    getAddress(W,Loc),
    ST=vpi::winGetText(W),
    dbBase::stNL_KB(ST,STk),
    dbBase::kbST_DEs(STk,DEs),
    set::size(DEs,N),
    Row=N+2,
    guix::getWin(W,No),
    No2=No+1,
    guix::getWin(TW,No2),
    % read the values
    sx::sxUnpack(STk,'|',Args),
    sentence::readCells(TW,Args,Term),
    Cell=vpiTableed::tableedit_getcelldata(TW,Row,2),
    Cell=vpiTableed::sc(_,Color),
    RRow=Row-1,
    Cell2=vpiTableed::tableedit_getcelldata(TW,RRow,2),
    Cell2=vpiTableed::sc(Realm,_),
    dbBase::recordDelete(Loc),
    dbBase::recordInsert(2,Realm,0,0,Term,atom("true"),Loc2),
    SRef2=dbBase::dbRef(Loc2),
    S3=string::concat("[",SRef2,"] INPUT"),
    vpiTableed::tableedit_setcelldata(TW,Row,2,vpiTableed::sc(S3,Color)),
    dlgIF::dlgNote(0,"Sentence updated!"),
    !
;
    guix::getWinClas(W)=201,
    Button=20002, 
    dlgIF::dlgNote(1,"Sentence NOT updated!"),
    !
;
    guix::getWinClas(W)=201,
    Button=20004, % next 
    getAddress(W,Loc),
    ST=vpi::winGetText(W),
    dbBase::stNL_KB(ST,STk),
    dbBase::stSentence_next(Stk,Loc,Loc2),
    sentence::displayRef(Loc2),
    _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest()),
    !
;
    guix::getWinClas(W)=201,
    Button=20005, % prev
    getAddress(W,Loc),
    ST=vpi::winGetText(W),
    dbBase::stNL_KB(ST,STk),
    dbBase::stSentence_prev(Stk,Loc,Loc2),
    sentence::displayRef(Loc2),
    _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest()),
    !
;
    guix::getWinClas(W)=201,
    Button=20003,
    getAddress(W,Loc),
    dbBase::recordDelete(Loc),
    dlgIF::dlgNote(0,"Sentence deleted!"),
    _=vpi::winSendEvent(W,vpiDomains::e_CloseRequest()),
    !.
% ----------------------------------------------------------------------------------------------
% getAddress
% ----------------------------------------------------------------------------------------------
getAddress(W,Loc) :-
    ST=vpi::winGetText(W),
    dbBase::stNL_KB(ST,STk),
    dbBase::kbST_DEs(STk,DEs),
    set::size(DEs,N),
    Row=N+2,
    guix::getWin(W,No),
    No2=No+1,
    guix::getWin(TW,No2),
    Cell=vpiTableed::tableedit_getcelldata(TW,Row,2),
    Cell=vpiTableed::sc(S,_),
    sx::sxGetInBrack(S,'[',']',SLoc),
    Loc=dbBase::dbRefR(SLoc),
    !.
% ----------------------------------------------------------------------------------------------
% readColData_s
% ----------------------------------------------------------------------------------------------
readColData_s(W,Col,L) :-
    Data=vpiTableed::tableedit_getdata(W,1,999999,Col,Col),
    collapseRows(Data,Cells),
    readCells_s(Cells,L),
    !.
% ----------------------------------------------------------------------------------------------
% collapseRows
% ----------------------------------------------------------------------------------------------
collapseRows([],[]) :-
    !.
collapseRows([Row|Rows],Cells) :-
    collapseRows(Rows,Cells2),
    set::conc([Row,Cells2],Cells),
    !.
% ----------------------------------------------------------------------------------------------
% readCell_s
% ----------------------------------------------------------------------------------------------
readCell_s(vpiTableed::ic(V,_),S) :- S=toString(V),!.
readCell_s(vpiTableed::sc(V,_),S) :- S=V,!.
readCell_s(vpiTableed::voidc(_),"") :- !.

readCells_s([],[]) :-
    !.
readCells_s([C|Cs],[S|L]) :-
    readCell_s(C,S),
    readCells_s(Cs,L),
    !.
% ----------------------------------------------------------------------------------------------
% checkValidSort
% ----------------------------------------------------------------------------------------------
class predicates
checkValidSort1 : (integer,integer_list) determ.
checkValidSort3 : (integer,string_list,integer_list) determ.
clauses

checkValidSort(DEs,Keys) :-
    sx::toIntList(Keys,Keys2),
    set::sort(Keys2,Keys3),
    checkValidSort1(0,Keys3),
     checkValidSort3(0,DEs,Keys2),
   !.
    
checkValidSort3(_,[],_) :-
    !.
checkValidSort3(Wi,[D|Ds],[Key|S]) :-
    Key=0,
    checkValidSort3(Wi,Ds,S),
    !
;    
    sx::sxUnpack(D,'|',L),
    L=[_,DE],
    dbBase::smClassDef(DE,"a",_,_,_,_,W),
    Wr=Wi+W,
    Wr>255,
    vpiCommonDialogs::note("Table sorting validation error","Sort-key length exceeds 255!"),
    !,fail
;    
    sx::sxUnpack(D,'|',L),
    L=[_,DE],
    dbBase::smClassDef(DE,"a",_,_,_,_,W),
    Wr=Wi+W,
    checkValidSort3(Wr,Ds,S),
    !
;    
    not(_=string::search(D,"|",string::caseSensitive())),
    dbBase::smClassDef(D,"a",_,_,_,_,W),
    Wr=Wi+W,
    Wr>255,
    vpiCommonDialogs::note("Table sorting validation error","Sort-key length exceeds 255!"),
    !,fail
;    
    not(_=string::search(D,"|",string::caseSensitive())),
    dbBase::smClassDef(D,"a",_,_,_,_,W),
    Wr=Wi+W,
    checkValidSort3(Wr,Ds,S),
    !.

checkValidSort1(_,[]) :-
    !.
checkValidSort1(RefKey,[0|Keys]) :-
    !,checkValidSort1(RefKey,Keys),
    !.
checkValidSort1(RefKey,[Key|Keys]) :-
    RefKey>0,
    Key<0,
    vpiCommonDialogs::note("Table sorting validation error","Sort-keys must either be all positive or all negative!"),
    !,
    fail
;
    RefKey<0,
    Key>0,
    vpiCommonDialogs::note("Table sorting validation error","Sort-keys must either be all positive or all negative!"),
    !,
    fail
;
    RefKey=Key,
    vpiCommonDialogs::note("Table sorting validation error","Sort-keys must be distinct!"),
    !,
    fail
;
    checkValidSort1(Key,Keys),
    !.
    
end implement tedbutton
