/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement transpr
open core,termDomain

constants
className = "com/rudstrand/transpr/transpr".
classVersion = "1.0".

clauses
classInfo(className, classVersion).
% ------------------------------------------------------------------------------------------------------------
% prStrToInt/Ext                                       
% ------------------------------------------------------------------------------------------------------------
% quotes are not used inside str() data in KB - apostophes are used instead
%
prStrToInt(S,T) :-
	Cq=string::charToString('"'),
	T=sx::replaceAll(S,Cq,"`"),
	!
;
    T=S,
	!.

prStrToExt(S,T) :-
	Cq=string::charToString('"'),
	T=sx::replaceAll(S,"`",Cq),
	!
;
    T=S,
	!.
% ----------------------------------------------------------------------------------------------
% proPR_Term                  
% ----------------------------------------------------------------------------------------------
class predicates
proPR_DummyVars : (integer,integer,sterm,sterm) procedure (i,o,i,o).	
proPR_DummyVarsX : (integer,integer,sterml,sterml) determ (i,o,i,o).	
clauses

% translates one sentence from PR to IF
% fails if token scanner or term_parser fails
% parameters:
% 1	in	PR
% 2	out	IF
%
proPR_Term(S,Term) :-
    sx::sxGiveTail(S,".",St),
	pscan::pscPR(St,Tokl),
                    tt::tt_tokl(3,"Token list (from PR)",Tokl),
	pie_par::s_term(Tokl,_,Term2),
	proPR_DummyVars(1,_,Term2,Term),
	!
;
	dlgIF::feil("proPR_Term",["Failed to parse PR-format string",S],[],nill),!,fail.	

proPR_DummyVars(N,M,cmp(H,B),cmp(H,Bd)) :-
	proPR_DummyVarsX(N,M,B,Bd),
	!.
proPR_DummyVars(N,M,var("_"),var(Dummy)) :-
	S=toString(N),
	Dummy=string::concat("_",S),
	M=N+1,
	!.
proPR_DummyVars(N,N,C,C) :-
	!.
proPR_DummyVarsX(N,N,[],[]) :-
	!.	
proPR_DummyVarsX(N,M,[H|T],[Hd|Td]) :-
	proPR_DummyVars(N,N2,H,Hd),
	proPR_DummyVarsX(N2,M,T,Td),
	!.
end implement transpr
