/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement trm
open core,termDomain

constants
className = "com/rudstrand/trm/trm".
classVersion = "1.0".

facts
list : (integer,sterm) nondeterm.
count : integer :=0.
unique : integer := 0.

clauses
classInfo(className, classVersion).

% ----------------------------------------------------------------------------------------------
% new
% ----------------------------------------------------------------------------------------------
new(Unique):-
    Unique=1,
    retractall(list(_,_)),
    count:=0,
    unique:=Unique,
    !
;
    retractall(list(_,_)),
    count:=0,
    unique:=-1,
    !.
    
newList() :- new (-1).    
% ----------------------------------------------------------------------------------------------
% add/Unique
% ----------------------------------------------------------------------------------------------:=
predicates
topX : (integer,sterm,integer) determ (i,o,o).
clauses

add(S) :-
    unique=1,
    addUnique(S),
    !
;
    N=count+1,
    assert(list(N,S)),
    count:=N,
    !.

addUnique(S) :- 
    list(_,S),
    !
;
    N=count+1,
    assert(list(N,S)),
    count:=N,
    !.
    
top()=Top :- 
    topX(count,Top,P),
    count:=P,
    !.

topX(0,_,_) :- 
    !,fail.
topX(N,Top,P) :-
    list(N,Top),
    P=N,
    !
;
    M=N-1,
    topX(M,Top,P),
    !.
% ----------------------------------------------------------------------------------------------
% delete/Top
% ----------------------------------------------------------------------------------------------
delete(S) :- retractall(list(_,S)),!.

deleteTop() :-
    not(list(_,_)),
    !,fail.
deleteTop() :-
    topX(count,Top,P),
    count:=P-1,
    retractall(list(P,Top)),
    !.
% ----------------------------------------------------------------------------------------------
% get
% ----------------------------------------------------------------------------------------------
predicates
getX : (integer,sterml) procedure (i,o).
clauses

get()=L :- getX(count,L),!.
   
getX(0,[]) :-
    !.
getX(N,[H|T]) :-
    list(N,H),
    M=N-1,
    getX(M,T),
    !.
getX(N,T) :-
    M=N-1,
    getX(M,T),
    !.
% ----------------------------------------------------------------------------------------------
% size
% ----------------------------------------------------------------------------------------------
predicates
sizeX : (integer,integer) procedure (i,o).
clauses

size()=N :- sizeX(count,N),!.

sizeX(0,0) :-
    !.
sizeX(N,Size) :-
    list(N,_),
    M=N-1,
    sizeX(M,RestSize),
    Size=RestSize+1,
    !
;    
    M=N-1,
    sizeX(M,Size),
    !.
end implement trm
