/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class xmlGeneric
open core,termDomain

predicates
classInfo : core::classInfo.
%
% DATE/TIME
%
% YYYY MM DD HH mm SS BBB [ZH  ZM] <---> "YYYY-MM-DDTHH:mm:SS.BBB+ZH:ZM"
timeNowXML : (string) procedure (o).
xmlDatetime : (integer,integer,integer,integer,integer,integer,integer,integer,integer,string) procedure (i,i,i,i,i,i,i,i,i,o).
xmlDatetimeR : (integer,integer,integer,integer,integer,integer,integer,integer,integer,string) determ (o,o,o,o,o,o,o,o,o,i).
% YYYY MM DD <---> "YYYY-MM-DD"
xmlDate : (integer,integer,integer,string) procedure (i,i,i,o).
xmlDateR : (integer,integer,integer,string) determ (o,o,o,i).
% HH  MM  SS  BBB [ ZH  ZM ] <---> "HH:MM:SS.BBB+ZH:ZM"
xmlTime : (integer,integer,integer,integer,integer,integer,string) procedure (i,i,i,i,i,i,o).	
xmlTimeR : (integer,integer,integer,integer,integer,integer,string) determ (o,o,o,o,o,o,i).	
% durations
xmlDuration : (integer,integer,integer,integer,integer,integer,integer,integer,string) procedure (i,i,i,i,i,i,i,i,o).
xmlDurationR : (integer,integer,integer,integer,integer,integer,integer,integer,string) determ (o,o,o,o,o,o,o,o,i).
durationShort : (string,string) determ (i,o).
durationNormalize : (string,string) determ (i,o).
% XML date, time, datetime and duration validation
xmlValidDate : (string) determ (i).
xmlValidDatetime : (string) determ (i).
xmlValidDuration : (string) determ (i).
xmlValidTime : (string) determ (i).
% Comparison
datetimeCompare : (string Oper,string Date1,string Date2) determ.
timeCompare : (string Oper,string Time1,string Time2) determ.
xmlDateEqual : (string,string) determ (i,i).
xmlDateLessOrEqual : (string,string) determ (i,i).
xmlDateLess : (string,string) determ (i,i).
xmlDatetimeEqual : (string,string) determ (i,i).
xmlDatetimeLessOrEqual : (string,string) determ (i,i).
xmlDatetimeLess : (string,string) determ (i,i).
xmlTimeEqual : (string,string) determ (i,i).
xmlTimeLessOrEqual : (string,string) determ (i,i).
xmlTimeLess : (string,string) determ (i,i).
xmlDurationEqual : (string,string) determ (i,i).
xmlDurationLessOrEqual : (string,string) determ (i,i).
xmlDurationLess : (string,string) determ (i,i).
% Addition/subtraction
xmlDateAdd : (string,string,string) determ (i,i,o).
xmlDatetimeAdd : (string,string,string) determ (i,i,o).
xmlTimeAdd : (string,string,string) determ (i,i,o).
xmlDateSub : (string,string,string) determ (i,i,o).
xmlDatetimeSub : (string,string,string) determ (i,i,o).
xmlTimeSub : (string,string,string) determ (i,i,o).
% xml date ---> day no in week
xmlDayNoInWeek : (string,integer) determ (i,o).
% internal date no <---> xml-date
xmlFromInternalDate : (integer,string) determ (i,o).
xmlToInternalDate : (string,integer) determ (i,o).
% internal time ---> xml-time
xmlFromInternalTime : (integer,string) procedure (i,o).

% STRING OPS

% converts general strings to xml-strings, e.g. '>' to '&gt;'
xmlAdjustString : (string,string) procedure (i,o).
% converts xml-strings to general strings, e.g. '&gt;' to '>' 
xmlReadjustString : (string,string) procedure (i,o).
% removes xml comments <!... and <?...
%xmlRemComments : (TOKL,TOKL) determ (i,o).
% gets the attribute value of a given attribute and an xml-trees attribute component
xmlGetAttr : (string,sterml,string) determ (i,i,o).	

% OTHER

xmlHeader : (string,string) procedure (i,o). % adds the standard xml first line to an an xml text
remHeader : (string,string) procedure (i,o). % removes      do.     (if present)
end class xmlGeneric