/*****************************************************************************
                        Copyright (c) Jens H. Holm
******************************************************************************/
implement xmlGeneric
open core,termDomain
constants
        className = "com/rudstrand/xmlGeneric/xmlGeneric".
        classVersion = "1.0".
clauses
classInfo(className, classVersion).
class predicates
xmlAttributes : (sterml,sterm) procedure (i,o).
% ------------------------------------------------------------------------------------------------------------
% 	                                     DATE AND TIME
% ------------------------------------------------------------------------------------------------------------
% ------------------------------------------------------------------------------------------------------------
% xmlDate/R; xmlTime/R
% ------------------------------------------------------------------------------------------------------------
class predicates
xmlDatetime2 : (integer,integer,integer,integer,string) procedure (i,i,i,i,o).
xmlDatetime3 : (integer,integer,string) procedure (i,i,o).
xmlTimeZ : (string,integer,integer) determ (i,o,o).
xmlTimeT : (string,integer,integer,integer,integer) determ (i,o,o,o,o).
clauses
xmlDatetime(Y,M,D,H,Mi,S,B,ZH,ZM,Time) :-
	xmlDate(Y,M,D,Date),
	xmlTime(H,Mi,S,B,ZH,Zm,Clock),
	sx::concat([Date,"T",Clock],Time),
	!.
xmlDatetimeR(Y,M,D,H,Mi,S,B,ZH,ZM,Time) :-
	sx::frontstr(10,Time,Date,_),
	xmlDateR(Y,M,D,Date),
	sx::frontstr(11,Time,_,Clock),
	xmlTimeR(H,Mi,S,B,ZH,Zm,Clock),
	!.
	
xmlDate(Y,M,D,Date) :-
	Ys=toString(Y),	
	Ms=toString(M),	
	Ds=toString(D),	
	sx::sxL_Pad(Ys,"0",4,Ysp),
	sx::sxL_Pad(Ms,"0",2,Msp),
	sx::sxL_Pad(Ds,"0",2,Dsp),
	sx::concat([Ysp,"-",Msp,"-",Dsp],Date),
	!.
xmlDateR(Y,M,D,Date) :-
	sx::substring(Date,1,4,Ys),
	sx::substring(Date,6,2,Ms),
	sx::substring(Date,9,2,Ds),
	Y=sx::toInt(Ys),
	M=sx::toInt(Ms),
	D=sx::toInt(Ds),
	!.
xmlTime(H,M,S,B,ZH,ZM,Time) :-
	xmlDatetime2(H,M,S,B,Time2),
	xmlDatetime3(ZH,ZM,Time3),
	Time=string::concat(Time2,Time3),
	!.
xmlTimeR(H,M,S,B,ZH,ZM,Time) :-
	sx::searchchar(Time,'-',_),
	sx::sxUnpack(Time,'-',L),
	L=[T,Z],
	xmlTimeT(T,H,M,S,B),
	xmlTimeZ(Z,ZH2,ZM),
	ZH2>0,
	ZH=-ZH2,
	!
;
	sx::searchchar(Time,'-',_),
	sx::sxUnpack(Time,'-',L),
	L=[T,Z],
	xmlTimeT(T,H,M,S,B),
	xmlTimeZ(Z,ZH,ZM2),
	ZH=0,
	ZM=-ZM2,
	!
;
	sx::searchchar(Time,'+',_),
	sx::sxUnpack(Time,'+',L),
	L=[T,Z],
	xmlTimeT(T,H,M,S,B),
	xmlTimeZ(Z,ZH,ZM),
	!
;
	xmlTimeT(Time,H,M,S,B),
	ZH=0,
	ZM=0,
	!.
xmlTimeZ(S,H,M) :-
	sx::searchchar(S,':',_),
	sx::sxUnpack(S,':',L),
	L=[Hs,Ms],
	H=sx::toInt(Hs),
	M=sx::toInt(Ms),
	!
;
	H=sx::toInt(S),
	M=0,
	!.
xmlTimeT(T,H,M,S,B) :-
	sx::searchchar(T,'.',_),
	sx::sxUnpack(T,'.',L),
	L=[T2,T3],
	sx::sxUnpack(T2,':',L2),
	L2=[Hs,Ms,Ss],
	H=sx::toInt(Hs),
	M=sx::toInt(Ms),
	S=sx::toInt(Ss),
	sx::sxL_Pad(T3,"0",3,Bs),
	B=sx::toInt(Bs),
	!
;
	sx::sxUnpack(T,':',L2),
	L2=[Hs,Ms,Ss],
	H=sx::toInt(Hs),
	M=sx::toInt(Ms),
	S=sx::toInt(Ss),
	B=0,
	!.
xmlDatetime2(H,Mi,S,B,Time) :-
	Hs=toString(H),	
	Mis=toString(Mi),	
	Ss=toString(S),	
	Bs=toString(B),
	sx::sxL_Pad(Hs,"0",2,Hsp),
	sx::sxL_Pad(Mis,"0",2,Misp),
	sx::sxL_Pad(Ss,"0",2,Ssp),
	sx::sxL_Pad(Bs,"0",3,Bsp),
	sx::concat([Hsp,":",Misp,":",Ssp,".",Bsp],Time),
	!.
xmlDatetime3(ZH,ZM,Time) :-
	Z=ZM+ZH,
	Z>=0,
	Hs=toString(ZH),
	sx::sxL_Pad(Hs,"0",2,Hsp),
	Ms=toString(ZM),
	sx::sxL_Pad(Ms,"0",2,Msp),
	sx::concat(["+",Hsp,":",Msp],Time),
	!
;
	AZH=-ZH,
	Hs=toString(AZH),
	sx::sxL_Pad(Hs,"0",2,Hsp),
	Ms=toString(ZM),
	sx::sxL_Pad(Ms,"0",2,Msp),
	sx::concat(["-",Hsp,":",Msp],Time),
	!.
% -------------------------------------------------------------------------- 
% xmlDate/Datetime/Time Less;LessOrEqual;Equal      
% -------------------------------------------------------------------------- 
xmlDateLess(Xa,Xb) :-
	xmlDateR(Ya,Ma,Da,Xa),
	xmlDateR(Yb,Mb,Db,Xb),
	datetime::datDMY_to_I(Da,Ma,Ya,Na),
	datetime::datDMY_to_I(Db,Mb,Yb,Nb),
	Na<Nb,
	!.
xmlDateLessOrEqual(Xa,Xb) :-
	xmlDateR(Ya,Ma,Da,Xa),
	xmlDateR(Yb,Mb,Db,Xb),
	datetime::datDMY_to_I(Da,Ma,Ya,Na),
	datetime::datDMY_to_I(Db,Mb,Yb,Nb),
	Na<=Nb,
	!.
xmlDateEqual(Xa,Xb) :-
	xmlDateR(Ya,Ma,Da,Xa),
	xmlDateR(Yb,Mb,Db,Xb),
	DatA=Ya*10000+Ma*100+Da,
	DatB=Yb*10000+Mb*100+Db,
	DatA=DatB,
	!.	
xmlDatetimeLess(Xa,Xb) :-
	xmlDatetimeR(Ya,Ma,Da,_,_,_,_,_,_,Xa),
	xmlDatetimeR(Yb,Mb,Db,_,_,_,_,_,_,Xb),
	datetime::datDMY_to_I(Da,Ma,Ya,Na),
	datetime::datDMY_to_I(Db,Mb,Yb,Nb),
	Na<Nb,
	!
;	
	xmlDatetimeR(Ya,Ma,Da,_,_,_,_,_,_,Xa),
	xmlDatetimeR(Yb,Mb,Db,_,_,_,_,_,_,Xb),
	datetime::datDMY_to_I(Da,Ma,Ya,Na),
	datetime::datDMY_to_I(Db,Mb,Yb,Nb),
	Na>Nb,
	!,fail
;
	xmlDatetimeR(_,_,_,HHa,MMa,SSa,BBa,ZHa,ZMa,Xa),
	xmlDatetimeR(_,_,_,HHb,MMb,SSb,BBb,ZHb,ZMb,Xb),
	TimA=(HHa+ZHa)*1000000+(MMa+ZMa)*10000+SSa*100+BBa,
	TimB=(HHb+ZHb)*1000000+(MMb+ZMb)*10000+SSb*100+BBb,
	TimA<TimB,
	!.
xmlDatetimeLessOrEqual(Xa,Xb) :-
	xmlDatetimeLess(Xa,Xb),
	!
;
	xmlDatetimeEqual(Xa,Xb),
	!.
xmlDatetimeEqual(Xa,Xb) :-
	xmlDatetimeR(Ya,Ma,Da,HHa,MMa,SSa,BBa,ZHa,ZMa,Xa),
	xmlDatetimeR(Yb,Mb,Db,HHb,MMb,SSb,BBb,ZHb,ZMb,Xb),
	TimA=(HHa+ZHa)*1000000+(MMa+ZMa)*10000+SSa*100+BBa,
	TimB=(HHb+ZHb)*1000000+(MMb+ZMb)*10000+SSb*100+BBb,
	TimA=TimB,
	DatA=Ya*10000+Ma*100+Da,
	DatB=Yb*10000+Mb*100+Db,
	DatA=DatB,
	!.
		
xmlTimeLess(Xa,Xb) :-
	xmlTimeR(HHa,MMa,SSa,BBa,ZHa,ZMa,Xa),
	xmlTimeR(HHb,MMb,SSb,BBb,ZHb,ZMb,Xb),
	TimA=(HHa+ZHa)*1000000+(MMa+ZMa)*10000+SSa*100+BBa,
	TimB=(HHb+ZHb)*1000000+(MMb+ZMb)*10000+SSb*100+BBb,
	TimA<TimB,
	!.	
xmlTimeLessOrEqual(Xa,Xb) :-
	xmlTimeLess(Xa,Xb),
	!
;
	xmlTimeEqual(Xa,Xb),
	!.
xmlTimeEqual(Xa,Xb) :-
	xmlTimeR(HHa,MMa,SSa,BBa,ZHa,ZMa,Xa),
	xmlTimeR(HHb,MMb,SSb,BBb,ZHb,ZMb,Xb),
	TimA=(HHa+ZHa)*1000000+(MMa+ZMa)*10000+SSa*100+BBa,
	TimB=(HHb+ZHb)*1000000+(MMb+ZMb)*10000+SSb*100+BBb,
	TimA=TimB,
	!.	
xmlDurationLess(Xa,Xb) :-
	xmlDurationR(SignA,Ya,Ma,Da,_,_,_,_,Xa),
	xmlDurationR(SignB,Yb,Mb,Db,_,_,_,_,Xb),
	DatA=(Ya*365.25+Ma*30.4375+Da)*SignA,
	DatB=(Yb*365.25+Mb*30.4375+Db)*SignB,
	DatA<DatB,
	!
;	
	xmlDurationR(SignA,Ya,Ma,Da,_,_,_,_,Xa),
	xmlDurationR(SignB,Yb,Mb,Db,_,_,_,_,Xb),
	DatA=(Ya*365.25+Ma*30.4375+Da)*SignA,
	DatB=(Yb*365.25+Mb*30.4375+Db)*SignB,
	DatA>DatB,
	!,fail
;
	xmlDurationR(SignA,_,_,_,Ha,Ma,Sa,Ba,Xa),
	xmlDurationR(SignB,_,_,_,Hb,Mb,Sb,Bb,Xb),
	TimA=(Ha*24*60000+Ma*60000+Sa*1000+Ba)*SignA,
	TimB=(Hb*24*60000+Mb*60000+Sb*1000+Bb)*SignB,
	TimA<TimB,
	!.
	
xmlDurationLessOrEqual(Xa,Xb) :-
	xmlDurationLess(Xa,Xb),
	!
;
	xmlDurationEqual(Xa,Xb),
	!.
xmlDurationEqual(Xa,Xb) :-
	xmlDurationR(SignA,Ya,Ma,Da,Ha,MnA,Sa,Ba,Xa),
	xmlDurationR(SignB,Yb,Mb,Db,Hb,MnB,Sb,Bb,Xb),
	DatA=(Ya*365.25+Ma*30.4375+Da)*SignA,
	DatB=(Yb*365.25+Mb*30.4375+Db)*SignB,
	DatA=DatB,
	TimA=(Ha*24*60000+MnA*60000+Sa*1000+Ba)*SignA,
	TimB=(Hb*24*60000+MnB*60000+Sb*1000+Bb)*SignB,
	TimA=TimB,
	!.
% -------------------------------------------------------------------------- 
% durationShort
% -------------------------------------------------------------------------- 
class predicates
durShort : (integer,integer,integer,integer,integer,integer,integer,real,string) procedure (i,i,i,i,i,i,i,o,o).
clauses

durationShort(Dur,DurS) :-
    durationNormalize(Dur,Dur2),
    xmlDurationR(Sign,Y,M,D,H,Mn,S,B,Dur2),
    durShort(Y,M,D,H,Mn,S,B,R,T),
    Rs=Sign*R,
    sx::fixFormatR(Rs,1,0,Rs2),
    DurS=string::concat(Rs2," ",T),
    !.
    
durShort(Y,M,D,H,Mn,S,_,R,T) :-  
    Y>0,
    R=Y+M/12.0,
    T="year(s)",
    !
;
    M>0,
    R=M+D/30.25,
    T="months(s)",
    !
;
    D>0,
    R=D+H/24.0,
    T="day(s)",
    !
;
    H>0,
    R=H+Mn/60.0,
    T="hour(s)",
    !
;
    Mn>0,
    R=Mn+S/60.0,
    T="minute(s)",
    !
;
    R=S,
    T="second(s)",
    !.
% -------------------------------------------------------------------------- 
% durationNormalize
% -------------------------------------------------------------------------- 
class predicates
remNonreq : (string,string) procedure (i,o).
clauses

durationNormalize(Dur,DurN) :-
    xmlDurationR(Sign,Y,M,D,H,Mn,S,B,Dur),
    Sx=S div 60,
    Sb=S mod 60,
    Mx=(Mn+Sx) div 60,
    Mb=(Mn+Sx) mod 60,
    Hx=(H+Mx) div 24,
    Hb=(H+Mx) mod 24,
    Db=D+Hx,
    xmlDuration(Sign,Y,M,Db,Hb,Mb,Sb,B,Dur2),
    Dur3=string::replace(Dur2,"P0Y0M0D","P0D",string::caseInsensitive()),
    Dur4=string::replace(Dur3,"P-0Y0M0D","P-0D",string::caseInsensitive()),
    Dur5=string::replace(Dur4,"P0DT","PT",string::caseInsensitive()),
    Dur6=string::replace(Dur5,"P-0DT","P-T",string::caseInsensitive()),
    remNonreq(Dur6,DurN),
    !.     
    
remNonreq(Dur,DurN) :-
    string::length(Dur)<3,
    DurN=Dur,
    !
;    
    string::front(Dur,3,F,T),
    F="P0Y",
    S=string::concat("P",T),
    remNonreq(S,DurN),
    !
;    
    string::front(Dur,3,F,T),
    F="P0M",
    S=string::concat("P",T),
    remNonreq(S,DurN),
    !
;   
    string::length(Dur)<4,
    DurN=Dur,
    !
;    
    string::front(Dur,4,F,T),
    F="P0DT",
    S=string::concat("PT",T),
    remNonreq(S,DurN),
    !
;    
    string::front(Dur,4,F,T),
    F="PT0H",
    S=string::concat("PT",T),
    remNonreq(S,DurN),
    !
;    
    string::front(Dur,4,F,T),
    F="PT0M",
    S=string::concat("PT",T),
    remNonreq(S,DurN),
    !
;    
    Dur="PT0.000S",
    DurN="PT0S",
    !
;    
    string::front(Dur,4,F,T),
    F="P-0Y",
    S=string::concat("P-",T),
    remNonreq(S,DurN),
    !
;    
    string::front(Dur,4,F,T),
    F="P-0M",
    S=string::concat("P-",T),
    remNonreq(S,DurN),
    !
; 
    string::length(Dur)<5,
    DurN=Dur,
    !
;    
    string::front(Dur,5,F,T),
    F="P-0DT",
    S=string::concat("P-T",T),
    remNonreq(S,DurN),
    !
;    
    string::front(Dur,5,F,T),
    F="P-T0H",
    S=string::concat("P-T",T),
    remNonreq(S,DurN),
    !
;    
    string::front(Dur,5,F,T),
    F="P-T0M",
    S=string::concat("P-T",T),
    remNonreq(S,DurN),
    !
;    
    Dur="P-T0.000S",
    DurN="P-T0S",
    !
;    
    DurN=Dur,
    !.
% -------------------------------------------------------------------------- 
% xmlDuration/R        
% -------------------------------------------------------------------------- 
class predicates
xmlDur2 : (string,integer_list) determ (i,o).
xmlDur3 : (string,string,integer_list) determ (i,i,o).
clauses

xmlDuration(Sign,Y,M,D,H,Mn,S,B,Dur) :-
	Sign=-1,
	H=0, Mn=0, S=0, B=0,

	% date only
	Ys=toString(Y),
	Ms=toString(M),
	Ds=toString(D),
	sx::concat(["P-",Ys,"Y",Ms,"M",Ds,"D"],Dur),
	!
;
	Sign=-1,
	Ys=toString(Y),
	Ms=toString(M),
	Ds=toString(D),
	Hs=toString(H),
	Mns=toString(Mn),
	Ss=toString(S),
	Bs=toString(B),
	sx::sxL_Pad(Bs,"0",3,Bs2),
	sx::concat(["P-",Ys,"Y",Ms,"M",Ds,"DT",Hs,"H",Mns,"M",Ss,".",Bs2,"S"],Dur),
	!
;
	H=0, Mn=0, S=0, B=0,
	% date only
	Ys=toString(Y),
	Ms=toString(M),
	Ds=toString(D),
	sx::concat(["P",Ys,"Y",Ms,"M",Ds,"D"],Dur),
	!
;
	Ys=toString(Y),
	Ms=toString(M),
	Ds=toString(D),
	Hs=toString(H),
	Mns=toString(Mn),
	Ss=toString(S),
	Bs=toString(B),
	sx::sxL_Pad(Bs,"0",3,Bs2),
	sx::concat(["P",Ys,"Y",Ms,"M",Ds,"DT",Hs,"H",Mns,"M",Ss,".",Bs2,"S"],Dur),
	!.

xmlDurationR(Sign,Y,M,D,H,Mn,S,B,Dur) :-
	not(xmlValidDuration(Dur)),
	!,fail
;
	sx::frontstr(2,Dur,F,R),
	F="P-",
	Sign=-1,
	xmlDur2(R,L),
	L=[Y,M,D,H,Mn,S,B],
	!
;
	sx::frontchar(Dur,_,R),
	Sign=1,
	xmlDur2(R,L),
	L=[Y,M,D,H,Mn,S,B],
	!.
	
xmlDur2(R,L) :-
	sx::searchchar(R,'T',_),
	!,sx::sxUnpack(R,'T',L2),
	L2=[D,T],
	xmlDur3("YMD",D,L3),
	xmlDur3("HMS",T,L4),
	set::conc([L3,L4],L),
	!
;
	xmlDur3("YMD",R,L3),
	set::conc([L3,[0,0,0,0]],L),
	!.
	
xmlDur3("",_,[]) :-
	!.
xmlDur3(Tags,S,[0,0|L]) :-
	sx::frontchar(Tags,Tag,R),
	not(sx::searchchar(S,Tag,_)),
	Tags="S",
	xmlDur3(R,S,L),
	!.
xmlDur3(Tags,S,[0|L]) :-
	sx::frontchar(Tags,Tag,R),
	not(sx::searchchar(S,Tag,_)),
	xmlDur3(R,S,L),
	!.
xmlDur3(Tags,S,[Si,Bi]) :-
	Tags="S",
	sx::sxUnpack(S,'S',L3),
	L3=[S2,_],
	sx::searchchar(S2,'.',_),
	sx::sxUnpack(S2,'.',L2),
	L2=[Sc,B],
	Si=sx::toInt(Sc),
	Bi=sx::toInt(B),
	!.
xmlDur3(Tags,S,[Si,0]) :-
	Tags="S",
	sx::sxUnpack(S,'S',L3),
	L3=[S2,_],
	Si=sx::toInt(S2),
	!.
xmlDur3(Tags,S,[N|L]) :-
	sx::frontchar(Tags,Tag,R),
	sx::searchchar(S,Tag,_),
	sx::sxUnpack(S,Tag,L2),
	L2=[S2,S3],
	N=sx::toInt(S2),
	xmlDur3(R,S3,L),
	!.
% -------------------------------------------------------------------------- 
% xmlDate/Datetime/Time Add           
% -------------------------------------------------------------------------- 
class predicates
xmlTimeNormalize : (integer_list,integer_list,integer_list) determ (i,i,o).
xmlDateAdd_YM : (integer,integer,integer,integer) procedure (i,i,o,o).
clauses
xmlDateSub(Dat,Dur,Res) :-
	xmlDurationR(Sign,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur),
	Sign2=(-1)*Sign,
	xmlDuration(Sign2,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur2),
	xmlDateAdd(Dat,Dur2,Res),
	!.
xmlDatetimeSub(Dat,Dur,Res) :-
	xmlDurationR(Sign,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur),
	Sign2=(-1)*Sign,
	xmlDuration(Sign2,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur2),
	xmlDatetimeAdd(Dat,Dur2,Res),
	!.
xmlTimeSub(Dat,Dur,Res) :-
	xmlDurationR(Sign,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur),
	Sign2=(-1)*Sign,
	xmlDuration(Sign2,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur2),
	xmlTimeAdd(Dat,Dur2,Res),
	!.
	
xmlDateAdd(Dat,Dur,Res) :-
	xmlDateR(Y,M,D,Dat),
	xmlDurationR(Sign,Yd,Md,Dd,_,_,_,_,Dur),
	M2=M+Sign*Md,
	Y2=Y+Sign*Yd,
	xmlDateAdd_YM(Y2,M2,Y3,M3),
	datetime::datDMY_to_I(D,M3,Y3,Date2),
	Date=Date2+Sign*Dd,
	datetime::datI_to_DMY(Date,D4,M4,Y4),
	xmlDate(Y4,M4,D4,Res),
	!.
	
xmlTimeAdd(Tim,Dur,Res) :-
	xmlTimeR(H,M,S,B,ZH,ZM,Tim),
	xmlDurationR(Sign,_,_,_,Hd,Md,Sd,Bd,Dur),
	HH=H+Sign*Hd,
	MM=M+Sign*Md,
	SS=S+Sign*Sd,
	BB=B+Sign*Bd,
	xmlTimeNormalize([1000,60,60],[BB,SS,MM,HH],L),
	L=[Br,Sr,Mr,Hr],
	xmlTime(Hr,Mr,Sr,Br,ZH,ZM,Res),
	!.
	
xmlDatetimeAdd(Dat,Dur,Res) :-
	xmlDatetimeR(Y,M,D,H,Mn,S,B,ZH,ZM,Dat),
	xmlDurationR(Sign,Yd,Md,Dd,Hd,Mnd,Sd,Bd,Dur),
	HH=H+Sign*Hd,
	MM=Mn+Sign*Mnd,
	SS=S+Sign*Sd,
	BB=B+Sign*Bd,
	xmlTimeNormalize([1000,60,60,24],[BB,SS,MM,HH,0],L),
	L=[Br,Sr,Mr,H2,Days2],
	xmlTime(H2,Mr,Sr,Br,ZH,ZM,Res2),
	M2=M+Sign*Md,
	Y2=Y+Sign*Yd,
	xmlDateAdd_YM(Y2,M2,Y3,M3),
	datetime::datDMY_to_I(D,M3,Y3,Date2),
	Date=Date2+Sign*Dd+Days2,
	datetime::datI_to_DMY(Date,D4,M4,Y4),
	xmlDate(Y4,M4,D4,Res3),
	sx::concat([Res3,"T",Res2],Res),
	!.
	
xmlTimeNormalize([],[V],[V]) :-
	!.
xmlTimeNormalize([Max|Ms],[V,V2|Vs],[W|Ws]) :-
	V<0,
	!,Borrow=((-V) div Max)+1,
	W=V+Borrow*Max,
	V2b=V2-Borrow,
	xmlTimeNormalize(Ms,[V2b|Vs],Ws),
	!
;
	Lend=V div Max,
	W=V-Lend*Max,
	V2b=V2+Lend,
	xmlTimeNormalize(Ms,[V2b|Vs],Ws),
	!.	
xmlDateAdd_YM(Y2,M2,Y3,M3) :-
	M2<=0,
	Sub=((-M2) div 12)+1,
	M3r=M2+Sub*12,
	M3r=0,
	M3=12,
	Y3=Y2-Sub+1,
	!
;
	M2<=0,
	Sub=((-M2) div 12)+1,
	M3=M2+Sub*12,
	Y3=Y2-Sub,
	!
;
	Add=M2 div 12,
	M3r=M2 mod 12,
	M3r=0,
	M3=12,
	Y3=Y2+Add-1,
	!
;
	Add=M2 div 12,
	M3=M2 mod 12,
	Y3=Y2+Add,
	!.
% -------------------------------------------------------------------------- 
% xmlDayNoInWeek           
% -------------------------------------------------------------------------- 
xmlDayNoInWeek(S,DayNo) :-
	xmlDateR(Y,M,D,S),
	datetime::datDMY_to_I(D,M,Y,Di),
	datetime::datWeekDay(Di,DayNo),
	!.
% -------------------------------------------------------------------------- 
% xmlFromInternalDate/Time             
% -------------------------------------------------------------------------- 
xmlFromInternalDate(IDate,S) :-
	datetime::datI_to_DMY(IDate,D,M,Y),
	xmlDate(Y,M,D,S),
	!.

xmlToInternalDate(S,IDate) :-
    % 0123 4 56 7 8
    % 2004 - 12 - 31
    Y=string::subString(S,0,4),
    M=string::subString(S,5,2),
    D=string::subString(S,8,2),
    Yi=sx::toInt(Y),
    Mi=sx::toInt(M),
    Di=sx::toInt(D),    
    datetime::datDMY_to_I(Di,Mi,Yi,IDate),
    !.

xmlFromInternalTime(ITime,S) :-
	H=ITime div 360000,
	M=(ITime-H*360000) div 6000,
	Sec=(ITime-H*360000-M*6000) div 100,
	F=ITime-H*360000-M*6000-Sec*100,
	xmlTime(H,M,Sec,F,0,0,S),
	!.
% -------------------------------------------------------------------------- 
% timeNowXML              
% -------------------------------------------------------------------------- 
timeNowXML(Time) :-
	Zh=globalVars::get_i("tzonh"),
	Zm=globalVars::get_i("tzonm"),
	Tc=time::new(),
	Tc:getDate(Y,M,D),
	Tc:getTime(H,Mi,S), B=0,
	xmlDatetime(Y,M,D,H,Mi,S,B,Zh,Zm,Time),
	!
;	
	Tc=time::new(),
	Tc:getDate(Y,M,D),
	Tc:getTime(H,Mi,S), B=0,
	xmlDatetime(Y,M,D,H,Mi,S,B,0,0,Time),
	!.
% -------------------------------------------------------------------------- 
% xmlValidDate/Time/Datetime           
% -------------------------------------------------------------------------- 
class predicates
xmlValidDate2 : (string) determ (i).
xmlValidTimeZone : (string) determ (i).
clauses

xmlValidDatetime(S) :-
	sx::sxUnpack(S,'T',L),
	L=[D,T],
	xmlValidDate(D),
	xmlValidTime(T),
	!.
	
xmlValidDate(S) :-
    string::length(S)<>10,
    !,fail
;
	sx::frontchar(S,'-',R),
	!,xmlValidDate2(R),
	!
;
	xmlValidDate2(S),
	!.
	
xmlValidDate2(S) :-
	sx::sxUnpack(S,'-',L),
	L=[Y,M,D],
	sx::sxUnsignedInteger(Y,Yi), Yi>0,
	sx::sxUnsignedInteger(M,Mi), Mi>0, Mi<13,
	sx::sxUnsignedInteger(D,Di), Di>0, Di<32,
	!.
	
xmlValidTime(S) :-
	% timezone
	sx::sxUnpack(S,'-',L2),
	L2=[T,Z],
	sx::sxUnpack(T,':',L),
	L=[H,M,R],
	sx::sxUnsignedInteger(H,Hi), Hi<25,
	sx::sxUnsignedInteger(M,Mi), Mi<61,
	sx::sxUnsignedFix(R,Ri), Ri<60.0,
	xmlValidTimeZone(Z),
	!
;
	% timezone
	sx::sxUnpack(S,'+',L2),
	L2=[T,Z],
	sx::sxUnpack(T,':',L),
	L=[H,M,R],
	sx::sxUnsignedInteger(H,Hi), Hi<25,
	sx::sxUnsignedInteger(M,Mi), Mi<61,
	sx::sxUnsignedFix(R,Ri), Ri<60.0,
	xmlValidTimeZone(Z),
	!
;
	% no timezone
	sx::sxUnpack(S,':',L),
	L=[H,M,R],
	sx::sxUnsignedInteger(H,Hi), Hi<25,
	sx::sxUnsignedInteger(M,Mi), Mi<61,
	sx::sxUnsignedFix(R,Ri), Ri<60.0,
	!.
	
xmlValidTimeZone(S) :-
	sx::searchchar(S,':',_),
	sx::sxUnpack(S,':',L2),
	L2=[H,M],
	sx::sxUnsignedInteger(H,Hi), Hi<25,
	sx::sxUnsignedInteger(M,Mi), Mi<61,
	!
;
	not(sx::searchchar(S,':',_)),
	sx::sxUnsignedInteger(S,Hi), Hi<25,
	!.
% -------------------------------------------------------------------------- 
% xmlValidDuration      
% -------------------------------------------------------------------------- 
class predicates
xmlValidDur2 : (string,string) determ (i,i).
clauses

xmlValidDuration(S) :-
	sx::frontchar(S,'P',S2),
	sx::frontchar(S2,'-',S3),
	sx::frontchar(S3,'T',T),
	!,xmlValidDur2("HMS",T),
	!
;
	sx::frontchar(S,'P',S2),
	sx::frontchar(S2,'-',S3),
	sx::searchchar(S3,'T',_),
	!,sx::sxUnpack(S2,'T',L),
	L=[D,T],
	xmlValidDur2("YMD",D),
	xmlValidDur2("HMS",T),
	!
;	
	sx::frontchar(S,'P',D2),
	sx::frontchar(D2,'-',D),
	!,xmlValidDur2("YMD",D),
	!
;
	sx::frontchar(S,'P',S2),
	sx::frontchar(S2,'T',T),
	!,xmlValidDur2("HMS",T),
	!
;
	sx::frontchar(S,'P',S2),
	sx::searchchar(S,'T',_),
	!,sx::sxUnpack(S2,'T',L),
	L=[D,T],
	xmlValidDur2("YMD",D),
	xmlValidDur2("HMS",T),
	!
;	
	sx::frontchar(S,'P',D),
	xmlValidDur2("YMD",D),
	!.

xmlValidDur2("","") :-
	!.
xmlValidDur2(Tags,S) :-
	sx::frontchar(Tags,Tag,R),
	not(sx::searchchar(S,Tag,_)),
	xmlValidDur2(R,S),
	!
;
	Tags="S",
	!,sx::sxTail(1,S,Sc,T),
	T="S",
	sx::sxUnsignedFix(Sc,_),
	!
;
	sx::frontchar(Tags,Tag,R),
	sx::sxUnpack(S,Tag,L),
	L=[S2,S3],
	sx::sxUnsignedInteger(S2,_),
	xmlValidDur2(R,S3),
	!.
% ------------------------------------------------------------------------------------------------------------
% datetime/timeCompare
% ------------------------------------------------------------------------------------------------------------
datetimeCompare("=",X,Y) :- X=Y,!.
datetimeCompare("<>",X,Y) :- X<>Y,!.
datetimeCompare("<",X,Y) :- xmlDatetimeLess(X,Y),!.
datetimeCompare("<=",X,Y) :- xmlDatetimeLessOrEqual(X,Y),!.
datetimeCompare(">",X,Y) :- not(xmlDatetimeLessOrEqual(X,Y)),!.
datetimeCompare(">=",X,Y) :- not(xmlDatetimeLess(X,Y)),!.

timeCompare("=",X,Y) :- X=Y,!.
timeCompare("<>",X,Y) :- X<>Y,!.
timeCompare("<",X,Y) :- xmlTimeLess(X,Y),!.
timeCompare("<=",X,Y) :- xmlTimeLessOrEqual(X,Y),!.
timeCompare(">",X,Y) :- not(xmlTimeLessOrEqual(X,Y)),!.
timeCompare(">=",X,Y) :- not(xmlTimeLess(X,Y)),!.
% ------------------------------------------------------------------------------------------------------------
% xmlGetAttr
% ------------------------------------------------------------------------------------------------------------
% gets the attribute value of a given attribute and an xml-trees attribute component
%
xmlGetAttr(Attr,[cmp(A,[W])|A2],S) :-
	A=Attr,
	W=str(X),
	xmlReadjustString(X,S),
	!
;
	xmlGetAttr(Attr,A2,S),
	!.
	
xmlGetAttr(Attr,L,_) :-
	dlgIF::feil("xmlGetAttr",["Cannot find attribute",Attr],[],cmp("",L)),!,fail.	
% ------------------------------------------------------------------------------------------------------------
% 	                                     OTHER
% ------------------------------------------------------------------------------------------------------------
% ------------------------------------------------------------------------------------------------------------
% xmlHeader
% ------------------------------------------------------------------------------------------------------------
xmlHeader(X,Xr) :-
    Q=string::charToString('"'),
    Xr=string::concatList(["<?xml version=",Q,"1.0",Q," ?>\n",X]),
    !.
% ------------------------------------------------------------------------------------------------------------
% remHeader
% ------------------------------------------------------------------------------------------------------------
remHeader(X,Xr) :-
    X2=string::trim(X),
    L=string::length(X2),
    L>21,
    string::subString(X2,0,5)="<?xml",
    P=string::search(X2,"?>",string::caseInsensitive()),
    NP=P+2,
    NL=L-NP,
    NL>0,
    X3=string::subString(X2,NP,NL),
    Xr=string::trim(X3),
    !
;
    Xr=X,
    !.
% ------------------------------------------------------------------------------------------------------------
% xmlAttributes
% ------------------------------------------------------------------------------------------------------------
xmlAttributes([],nill) :-
	!.
xmlAttributes(L,cmp("Attributes",L)) :-
	!.
% ------------------------------------------------------------------------------------------------------------
% xmlAdjustString/ReadjustString
% ------------------------------------------------------------------------------------------------------------
xmlAdjustString(S,T) :-
	S2=sx::replaceAll(S,"&","&amp;"),
	S3=sx::replaceAll(S2,"<","&lt;"),
	S4=sx::replaceAll(S3,">","&gt;"),
	S5=sx::replaceAll(S4,"'","&apos;"),
	Cq=string::charToString('"'),
	T=sx::replaceAll(S5,Cq,"&quot;"),
	!.	
	
xmlReadjustString(S,T) :-
	S2=sx::replaceAll(S,"&amp;","&"),
	S3=sx::replaceAll(S2,"&gt; =",">="),
	S4=sx::replaceAll(S3,"&lt; =","<="),
	S5=sx::replaceAll(S4,"&lt;","<"),
	S6=sx::replaceAll(S5,"&gt;",">"),
	S7=sx::replaceAll(S6,"&gt;=",">="),
	S8=sx::replaceAll(S7,"&lt;=","<="),
	S9=sx::replaceAll(S8,"&apos;","'"),
	Cq=string::charToString('"'),
	T=sx::replaceAll(S9,"&quot;",Cq),
	!.	
end implement xmlGeneric
