/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class xmlP3
open core,termDomain

predicates
classInfo : core::classInfo.

% loads XML-format knowledge into the KB
xmlProcess : (string,string).

% wraps a CR body xml text into a CR root element
xmlTreeFromCR : (string,string,sterm,sterm) determ (i,i,i,o).
% CR-term --> xml text
xmlFromCR : (string,string,sterm,string) determ (i,i,i,o).
% xml text --> CR-term
xmlToCR_Rule : (string,sterm,sterm,sterm) determ (i,i,o,o).
% xml-tree --> CR (term)
xmlToCR : (sterm,sterm,sterm,string) determ (i,o,o,o).

% function name --> xml text
xmlFromFunc : (string,string,string,string) determ (i,i,i,o).

% xml tree --> sentence-term
xmlToSentence : (sterm,sterm,string,integer) determ (i,o,o,o).
% sentence (IF) --> xml text
xmlFromSentence : (string,string,integer,sterm,string) determ (i,i,i,i,o).
xmlTreeFromSentence : (string,string,integer,sterm,sterm) determ (i,i,i,i,o).

% rule-tree (IF) --> xml text
xmlFromRule : (string,sterm,string) determ (i,i,o).
% processes a list of xml-trees (i.e. corr. to processable knowledge elements)
xmlProcessTrees : (string,sterml,integer,integer,integer,integer) determ (i,i,o,o,o,o).
% wraps a sentence rule body xml text into a sentence rule root element
xmlSentenceRule : (string,string,string,string,sterm,string) determ (i,i,i,i,i,o).
% xml-tree --> rule-tree (IF)
xmlToRule : (sterm,sterm) determ (i,o).

% wraps a pro3 script header on a script tree
scriptWrap : (string Format,sterml Trees,sterm WTree) determ (i,i,o).
 
% wraps pro3 knowledge xml text into the root element
xmlKnowledge : (string,string) determ (i,o).
xmlKnowA : (string) determ (o).
xmlKnowB : (string) procedure (o).
end class xmlP3