/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/
% an xml tree has the format:
%
% (a) complex elements with attributes:
% -------------------------------------------
% cmp(ELEMENT_NAME,
%       [
%	    cmp("Attributes",
%        	[
%		    cmp(ATTRIBUTE_NAME,[str(ATTRIBUTE_VALUE)]   ** list can be empty
%		    :
%		    ]
%	    cmp(ELEMENT_NAME,[...]),
%	    :
%	    ]
%
% (b) complex elements without attributes:
% -----------------------------------------------
% cmp(ELEMENT_NAME,
%       [
%       nill,
%	    cmp(ELEMENT_NAME,[...]),
%	    :
%	    ]
%
% (c) simple elements with attributes:
% -----------------------------------------
% cmp(ELEMENT_NAME,
%       [
%	    cmp("Attributes",
%        	[
%		    cmp(ATTRIBUTE_NAME,[str(ATTRIBUTE_VALUE)]   ** list can be empty
%		    :
%		    ]
%	    str(S)            ** optional
%	    ]
%
% (d) simple elements without attributes:
% --------------------------------------------
% cmp(ELEMENT_NAME,
%       [
%	    nill,
%	    str(S)            ** optional
%	    ]
%
% S are valid XML strings with the following exceptions:
% 1. quotes are used rather than &quot;
%
class xmlTree : xmlTree
open core,termDomain

constructors
newTree : (string X).
newTreeXML : (sterm XML).

predicates
classInfo : core::classInfo.
removeAmpersands : (sterm,sterm) procedure (i,o). % replaces &lt; and &gt; in all str...)
end class xmlTree