/*****************************************************************************

		Copyright (C) 1999-2003, Prolog Development Center A/S 

 FileName:	TAbLEEDIT.PRO
 Purpose:	Table Editor object
******************************************************************************/
implement vpiTableed
open core, vpiDomains, vpiGrid

    constants
        % class constants
        className = "com/visual-prolog/vpi/vpiTableed/vpiTableed".
        classVersion = "Version 1.0".

    clauses
        % current class description
        classInfo(
            className, classVersion).


constants
  tableedit_MenuId1 = 2001.
  tableedit_MenuId2 : vpidomains::menutag = 2002.
  tableedit_MenuId3 = 2003.
  tableedit_MenuId4 : vpidomains::menutag = 2004.
  tableedit_MenuId5 = 2005.
  tableedit_MenuId6 : vpidomains::menutag = 2006.
  tableedit_MenuId7 : vpidomains::menutag = 2007.
  tableedit_MenuId8 : vpidomains::menutag = 2008.
  tableedit_MenuId9 = 2009.
  tableedit_MenuId10 : vpidomains::menutag = 2010.
  tableedit_MenuId11 = 2011.
  tableedit_MenuId12 : vpidomains::menutag = 2012.
  tableedit_MenuId13 : vpidomains::menutag = 2013.
  tableedit_MenuId14 = 2014.
  tableedit_MenuId15 : vpidomains::menutag = 2015.
  tableedit_MenuId16 = 2016.
  tableedit_MenuId17 : vpidomains::menutag = 2017.
  tableedit_MenuId18 = 2018.
  tableedit_MenuId19 = 2019.
  tableedit_MenuId20 : vpidomains::menutag = 2020.
  tableedit_MenuId21 : vpidomains::menutag = 2021.
  tableedit_MenuId22 = 2022.
  tableedit_MenuId23 = 2023.

  dlg_find_DlgType = wd_Modal.
  dlg_find_Title = tableedit_con_find.
  dlg_find_RCT : vpidomains::rct = rct(50,40,250,150).
  dlg_find_Flags : vpidomains::wsflags = [wsf_DlgBorder,wsf_Close,wsf_TitleBar].
%  dlg_find_Help = contents.
  con_rb_entire		: integer = 1001.% it was used also as vpidomains::ctlid
  con_rb_from		: integer = 1002.% it was used also as vpidomains::ctlid
  con_rb_backward	: integer = 1003.% it was used also as vpidomains::ctlid
  con_rb_forward	: integer = 1004.% it was used also as vpidomains::ctlid
  con_fromstart		: integer = 1005.% it was used also as vpidomains::ctlid
  con_entirestring	: integer = 1006.% it was used also as vpidomains::ctlid
  con_anypart		: integer = 1007.% it was used also as vpidomains::ctlid
  con_findcolumn	: integer = 1008.% it was used also as vpidomains::ctlid
  con_Casesensitive	: integer = 1009.% it was used also as vpidomains::ctlid
  con_findstr		: integer = 1010.% it was used also as vpidomains::ctlid
  con_static_text	: vpidomains::ctlid = 1011.
  con_static_text1	: vpidomains::ctlid = 1012.
  con_groupbox		: vpidomains::ctlid = 1013.
  con_groupbox1		: vpidomains::ctlid = 1014.
  con_groupbox2		: vpidomains::ctlid = 1015.

domains
% Domains for undo, redo 
  tableedit_UNDOREDODATA = modified(integer Row,integer Column,
			   tableedit_celldata OldValue,tableedit_celldata NewValue);
			   marker(vpiGrid::marker);
			   row(integer Row,tableedit_columndata Old,tableedit_columndata New);
			   resize_column(integer Column,integer Width).
  tableedit_UNDOREDOLIST = tableedit_UNDOREDODATA*.

class facts - tableedit_db
% Visible data
  tableedit_db_Data_Info : (vpiDomains::windowHandle,tableedit_data).
% Buffer Row range
  tableedit_db_DataBufRange : (vpiDomains::windowHandle,integer FromRow,integer ToRow).
% GridAnswer 
  tableedit_db_AnswerRange : (vpiDomains::windowHandle,integer FromRow,integer ToRow,integer FromLolumn,integer ToColumn).
% Filtered data (invisible)
  tableedit_db_ShadowData_Info : (vpiDomains::windowHandle,tableedit_data).
% Table properties
  tableedit_db_Te_Info : (vpiDomains::windowHandle,tableedit_property).
% Column properties
  tableedit_db_Col_Info : (vpiDomains::windowHandle,integer Ncolumn,tableedit_columnproperty).
% Data for undo
  tableedit_db_UndoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST).
% Data for redo
  tableedit_db_RedoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST).
% Current UndoRedo action
  tableedit_db_CurrentUndoRedo : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST).
% Paste cannot be carried out (Not conformity of a clipboard data format to table format)
  tableedit_db_PasteError : (vpiDomains::windowHandle).
% Initialization is current action
  tableedit_db_InitMode : (vpiDomains::windowHandle).
% Undo,redo is current action
  tableedit_db_UndoAction : (vpiDomains::windowHandle).
% Find param
  tableedit_db_FindParam : (vpiDomains::windowHandle,string,tableedit_direction,integer Column,tableedit_match,core::booleanInt CaseSensitive).
% Find Dialog param
  tableedit_db_FindDlgParam : (vpiDomains::windowHandle,integer ColumnId,integer ColumnItemId).
% exist V Scroll
  tableedit_db_VScroll : (vpiDomains::windowHandle).

   tableedit_str_buffer : (string)determ.
   %tableedit_db_Stopmodified : (vpiDomains::windowHandle)determ.

class predicates
% Grid callback
  tableedit_GridCallback : vpiGrid::callback.		% Grid Callback
% Internal table editor callback
  tableedit_CallbackInternal : tableedit_callback.	% table editor internal dummy callback
% Table editor callback
  tableedit_SendCallback : tableedit_callback.      
% Internal table editor compare function
  tableedit_CompareInternal : tableedit_compare.		% table editor internal dummy comparation

% Set data to table editor (without sorting)
    tableedit_SetAllDataNoSort : (vpiDomains::windowHandle,tableedit_data)procedure anyflow.
% grid initialization
    tableedit_Grid_Init : (vpiDomains::windowHandle,tableedit_data)determ anyflow.
% number columns calculation 
    tableedit_CalcMaxCol : (vpiDomains::windowHandle,integer MaxColumn)procedure anyflow.
% number rows calculation
    tableedit_CalcMaxRows : (vpiDomains::windowHandle,tableedit_data,integer MaxRows)procedure anyflow.
    tableedit_CalcMaxCol1 : (vpiDomains::windowHandle,integer,integer MaxColumn)procedure anyflow.

    tableedit_listlength : (tableedit_data,integer)determ anyflow.
%  determ  tableedit_listlength(tableedit_columndata,INTEGER)

% GRID_CELLS_STYLE to TABLEEDIT_PROPERTY format data transformation
    tableedit_ConvGridCellsStyle : (vpiGrid::cellsStyle,tableedit_property)determ anyflow.

% Table editor initialization with table parameters by default
    tableedit_InitDefaultEditor : (vpiDomains::windowHandle)procedure anyflow.
% assert table property
    tableedit_AssertPropertyList : (vpiDomains::windowHandle,tableedit_properties)procedure anyflow.
    tableedit_ReAssertPropertyList : (vpiDomains::windowHandle,tableedit_properties)procedure anyflow.
    tableedit_ReAssert : (vpiDomains::windowHandle,tableedit_property)procedure anyflow.

% assert column property
    tableedit_InitColumns : (vpiDomains::windowHandle,integer Column,tableedit_columnlist)determ anyflow.
    tableedit_InitColumn : (vpiDomains::windowHandle,integer Column,tableedit_columnproperties)procedure anyflow.
    tableedit_ReAssertColumn : (vpiDomains::windowHandle,integer Column,tableedit_columnproperty)procedure anyflow.

    tableedit_CreateGridColumnList : (vpiDomains::windowHandle,vpiGrid::columnStyle)determ anyflow.
    tableedit_BuildGridColumns : (vpiDomains::windowHandle,integer Ncolumn,vpiGrid::column_list,vpiGrid::column_list)procedure anyflow.
    tableedit_BuildGridColumn : (vpiDomains::windowHandle,integer Ncolumn,vpiGrid::column)determ anyflow.
    tableedit_Append : (vpiGrid::column_list,vpiGrid::column_list,vpiGrid::column_list)determ anyflow.
    tableedit_Append : (vpiDomains::menuItem_list,vpiDomains::menuItem_list,vpiDomains::menuItem_list)determ anyflow.

% Get GRID_STYLE format data from table editor properties
    tableedit_GetGridStyle : (vpiDomains::windowHandle,vpiGrid::style)determ anyflow.

% Table editor data sorting
    tableedit_sort_data : (vpiDomains::windowHandle,tableedit_compare ComareFunc,
        core::booleanInt Ascendig,core::integer_list ColumnNumber,
        tableedit_data,tableedit_data)
        procedure (i,i,i,i,i,o).

% Insert default row
    tableedit_InsDefRow : (vpiDomains::windowHandle,integer Row)procedure anyflow.
% Create default row
    tableedit_CreateDefRow : (vpiDomains::windowHandle,integer,tableedit_columndata,tableedit_columndata)determ anyflow.

% Create void rows
    tableedit_CreateVoidRows : (vpiDomains::windowHandle,integer,tableedit_data,tableedit_data)determ anyflow.

    tableedit_InsDefRowZ : (vpiDomains::windowHandle)procedure anyflow.

% Cut rows from list
    tableedit_CutListRows : (vpiDomains::windowHandle,integer FromRow,integer ToRow,
  	tableedit_data Input,tableedit_data Empty,tableedit_data Out,
  	tableedit_data Empty,tableedit_data CutData)determ anyflow.

% Insert rows to list
    tableedit_InsListRows : (vpiDomains::windowHandle,integer FrRow,tableedit_data,tableedit_data,
  	tableedit_data,tableedit_data)determ anyflow. 

% Cut header and footer rows from list
    tableedit_CutHeadersFooters : (vpiDomains::windowHandle,tableedit_data Data,tableedit_data OutData,
  	tableedit_data HeadData,tableedit_data FootData)procedure anyflow.

% Insert header and footer rows to list
    tableedit_InsHeadersFooters : (vpiDomains::windowHandle,tableedit_data Data,tableedit_data OutData,
	tableedit_data HeadData,tableedit_data FootData)procedure anyflow.

% Cliar undo and redo data
    tableedit_CliarUndoRedoData : (vpiDomains::windowHandle)procedure anyflow.

% Check up a clipboard string on compatibility with a type of table editor data
    tableedit_ChkClipBoardStr : (vpiDomains::windowHandle,vpiGrid::areaList,string SourceStr,core::booleanInt)determ anyflow.

% To carry out a filtration according to current filters
    tableedit_ProcessFilter : (vpiDomains::windowHandle)determ anyflow.
    tableedit_CurWait : (vpiDomains::windowHandle,core::booleanInt WaitCursor)procedure anyflow.


clauses

  tableedit_CurWait(Win,b_true):- 
	vpi::cursorSet(Win,cursor_Wait),
	!.
  tableedit_CurWait(Win,_):-
	vpi::cursorSet(Win,cursor_Arrow),
	!.

% Internal table editor callback
  tableedit_CallbackInternal(_Win,_Event):- fail.

% data to data,footer data,header data convertion
  tableedit_CutHeadersFooters(Win,Data,Data,[],[]):-
	tableedit_db_Te_Info(Win,headers(0)),
	tableedit_db_Te_Info(Win,footers(0)),
	!.
  tableedit_CutHeadersFooters(Win,Data,OutData,HeadData,FootData):-
	tableedit_db_Te_Info(Win,headers(H)),
	tableedit_db_Te_Info(Win,footers(F)),
	tableedit_CutListRows(Win,1,H,Data,[],OutData1,[],HeadData),
	tableedit_CalcMaxRows(Win,OutData1,MaxRows), FootPos = MaxRows - F + 1,
	tableedit_CutListRows(Win,FootPos,MaxRows,OutData1,[],OutData,[],FootData),
	!.
  tableedit_CutHeadersFooters(_,Data,Data,[],[]).

% data,footer data,header data to data convertion
  tableedit_InsHeadersFooters(Win,Data,Data,_HeadData,_FootData):-
	tableedit_db_Te_Info(Win,headers(0)),
	tableedit_db_Te_Info(Win,footers(0)),
	!.
  tableedit_InsHeadersFooters(Win,Data,OutData,HeadData,FootData):-
	tableedit_InsListRows(Win,0,HeadData,Data,[],OutData1),
	tableedit_CalcMaxRows(Win,OutData1,MaxRows), FootPos = MaxRows + 1,
	tableedit_InsListRows(Win,FootPos,FootData,OutData1,[],OutData),
	!.
  tableedit_InsHeadersFooters(_Win,Data,Data,_HeadData,_FootData):-!.

class predicates
 tableedit_AssertStartData : (vpiDomains::windowHandle,tableedit_data)procedure anyflow.
 tableedit_RequestBuff : (vpiDomains::windowHandle,integer FromRow)procedure anyflow.
 tableedit_RequestBuff : (vpiDomains::windowHandle,integer FromRow,integer ToRow)procedure anyflow.
 tableedit_GetBuffCellData : (vpiDomains::windowHandle,integer Row,integer Column,tableedit_celldata)procedure anyflow.
 tableedit_SeparateAnswer : (vpiDomains::windowHandle)procedure anyflow.
 tableedit_HandleBuffAnswer : (vpiDomains::windowHandle)procedure anyflow.
 tableedit_HandleBuffAnswer1 : (vpiDomains::windowHandle,integer FromRow,integer ToRow,integer FromColumn,integer ToColumn)procedure anyflow.
  tableedit_BuffInvalidate : (vpiDomains::windowHandle)procedure anyflow.
  tableedit_BuffInvalidate : (vpiDomains::windowHandle,integer Row)procedure anyflow.

clauses

  tableedit_Grid_Init(Win,InputData):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_GetGridStyle(Win,GridStyle),
	tableedit_CalcMaxRows(Win,InputData,MaxRows),
	tableedit_db_Te_Info(Win,rowselector(RowSelector,RowWidth,M)),
	GridRowStyle = vpiGrid::grid_rowstyle_(RowWidth,MaxRows,1,RowSelector,M),	
	tableedit_CreateGridColumnList(Win,GridColumnStyle),
	tableedit_ProcessFilter(Win),
	tableedit_db_Te_Info(Win,sortedby(Col)),
	tableedit_sort(Win,Col),
	vpiGrid::init(Win,GridStyle,GridRowStyle,
	GridColumnStyle,
	tableedit_GridCallback),
	retractAll(tableedit_db_InitMode(Win)),
	!.
  tableedit_Grid_Init(Win,_InputData):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,MaxRows))),
	tableedit_GetGridStyle(Win,GridStyle),
	tableedit_db_Te_Info(Win,rowselector(RowSelector,RowWidth,M)),
	GridRowStyle = vpiGrid::grid_rowstyle_(RowWidth,MaxRows,1,RowSelector,M),	
	tableedit_CreateGridColumnList(Win,GridColumnStyle),
	vpiGrid::init(Win,GridStyle,GridRowStyle,
	GridColumnStyle,
	tableedit_GridCallback),
	retractAll(tableedit_db_InitMode(Win)),
	!.

% table properties to grid style convertion
  tableedit_GetGridStyle(Win,GridStyle):-
	tableedit_db_Te_Info(Win,raised(R)),
	tableedit_ConvGridCellsStyle(Cells_Style,raised(R)),
	tableedit_db_Te_Info(Win,backcolor_tab(BackColor)),
	tableedit_db_Te_Info(Win,emptycolor(EmptyCellColor)),
	tableedit_db_Te_Info(Win,titlebackcolor(BackTitleColor)),
	tableedit_db_Te_Info(Win,titleforecolor(ForeTitleColor)),
	tableedit_db_Te_Info(Win,defcellcolor(DefaultCellColor)),
	GridStyle = vpiGrid::grid_style_(Cells_Style,DefaultCellColor,BackColor,EmptyCellColor,
		BackTitleColor,ForeTitleColor),
	!.

% table properties to Grid Column Style convertion
  tableedit_CreateGridColumnList(Win,GridColumnStyle):-
	tableedit_BuildGridColumns(Win,1,[],ColList),
	tableedit_db_Te_Info(Win,nonscrollcol(NonScroll)),
	GridColumnStyle = vpiGrid::grid_columnStyle(NonScroll,ColList),
	!.
% Create grid column list from table properties
  tableedit_BuildGridColumns(Win,Ncolumn,InColumns,Columns):-
	tableedit_BuildGridColumn(Win,Ncolumn,GridCol),
        hasDomain(vpiGrid::column_list, CL),
        CL = [GridCol],
	tableedit_Append(InColumns,CL,OutColumns),
	NextCol = Ncolumn + 1,
	tableedit_BuildGridColumns(Win,NextCol,OutColumns,Columns),!.
  tableedit_BuildGridColumns(_,_,GridColumns,GridColumns):-!.

% table properties to grid column format converion
  tableedit_BuildGridColumn(Win,Ncolumn,GridCol):-
	tableedit_db_Col_Info(Win,Ncolumn,title(Title)),
	tableedit_db_Col_Info(Win,Ncolumn,width(Width)),
	tableedit_db_Col_Info(Win,Ncolumn,alignment(HorAlignment)),
	tableedit_db_Col_Info(Win,Ncolumn,maxlength(Length)),
	GridCol = vpiGrid::grid_col(Title,Width,HorAlignment,vpiGrid::grid_top_align,4,0,Length),
	!.

  tableedit_Append([],L,L).	
  tableedit_Append([N|L1],L2,[N|L3]):-
	tableedit_Append(L1,L2,L3).	

% number of columns calculation
  tableedit_CalcMaxCol(Win,Col):- tableedit_CalcMaxCol1(Win,1,Col),!.

  tableedit_CalcMaxCol1(Win,Col,ColRes):- 
	not(tableedit_db_Col_Info(Win,Col,_)),ColRes = Col - 1,!.
  tableedit_CalcMaxCol1(Win,Col,NC):-!,
	NextCol = Col + 1,
	tableedit_CalcMaxCol1(Win,NextCol,NC).

% number of rows calculation
  tableedit_CalcMaxRows(Win,Data,MaxRows):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_listlength(Data,MaxRows),!.
  tableedit_CalcMaxRows(Win,_Data,MaxRows):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,MaxRows))),!.
  tableedit_CalcMaxRows(_Win,_,0):-!.

  tableedit_listlength([],0):-!.
  tableedit_listlength([_|T],N1):-
	tableedit_listlength(T,N),
	N1=N+1.


% Table editor initialization with table parameters by default
  tableedit_InitDefaultEditor(Win):-
	tableedit_AssertPropertyList(Win,
			[raised(b_true),
			defcellcolor(color_LtGray),
			backcolor_tab(color_Gray),
			emptycolor(color_LtGray),
			titlebackcolor(color_LtGray),
			titleforecolor(color_Black),
			rowselector(vpiGrid::grid_number,50,b_false),
			nonscrollcol(0),
			sortedby(1),
			allmarker(b_false),
			areamarker(singular),
			colmarker(none),
			rowmarker(singular),
			insert_rows(b_true),
			delete_rows(b_true),
			undo_redo(b_true),
			paste(b_true),
			cut(b_true),
			menu([]),
		     	headers(0),
		     	footers(0),
			filter_tab(b_true),
			readonly_tab(b_false),
			callback(tableedit_CallbackInternal),
			compare(tableedit_CompareInternal),
			find(b_true),
			bufferingmode(nobuffering)
			]),
	!.

  tableedit_AssertPropertyList(_Win,[]):-!.
  tableedit_AssertPropertyList(Win,[L1|L2]):-!,
	assert(tableedit_db_Te_Info(Win,L1)),
	tableedit_AssertPropertyList(Win,L2).
  tableedit_AssertPropertyList(_Win,_):-!.

  tableedit_ReAssertPropertyList(_Win,[]):-!.
  tableedit_ReAssertPropertyList(Win,[L1|L2]):-!,
	tableedit_ReAssert(Win,L1),
	tableedit_ReAssertPropertyList(Win,L2).
  tableedit_ReAssertPropertyList(_Win,_):-!.

% Table editor initialization with column parameters by default
  tableedit_InitColumns(_Win,_,[]):-!.
  tableedit_InitColumns(Win,NCol,[L1|L2]):-
	NextCol = NCol + 1,
	L1 = column(ColumnProp),
	tableedit_db_Te_Info(Win,readonly_tab(R)),
	tableedit_InitColumn(Win,NextCol,[readonly(R)]),
	tableedit_db_Te_Info(Win,filter_tab(F)),
	tableedit_InitColumn(Win,NextCol,[filter(F)]),
	tableedit_InitColumn(Win,NextCol,
			[title(""),
			width(100),
			backcolor(color_LtGray),
			forecolor(color_Black),
			alignment(vpiGrid::grid_right_align),
			maxlength(0x7FFF),
			resizable(b_true),
			sortmode(ascending([])),
			filterlist([]),
			defaultvalue(void),
			validationrule([]),
			validationtext(""),
			column_type(te_string),
			control(edit),
			mandatory(b_false)
			]),
	tableedit_InitColumn(Win,NextCol,ColumnProp),!,
	tableedit_InitColumns(Win,NextCol,L2).

  tableedit_InitColumn(_Win,_,[]):-!.
  tableedit_InitColumn(Win,NextCol,[L1|L2]):-!,
	tableedit_ReAssertColumn(Win,NextCol,L1),
	tableedit_InitColumn(Win,NextCol,L2).
  tableedit_InitColumn(_Win,_,_):-!.
	
  tableedit_ReAssertColumn(Win,NextCol,filterlist(FL)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,filterlist(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,filterlist(FL))),!.
  tableedit_ReAssertColumn(Win,NextCol,filter(F)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,filter(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,filter(F))),!.
  tableedit_ReAssertColumn(Win,NextCol,mandatory(M)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,mandatory(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,mandatory(M))),!.
  tableedit_ReAssertColumn(Win,NextCol,control(C)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,control(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,control(C))),!.
  tableedit_ReAssertColumn(Win,NextCol,column_type(T)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,column_type(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,column_type(T))),!.
  tableedit_ReAssertColumn(Win,NextCol,title(T)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,title(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,title(T))),!.
  tableedit_ReAssertColumn(Win,NextCol,width(W)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,width(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,width(W))),!.
  tableedit_ReAssertColumn(Win,NextCol,backcolor(C)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,backcolor(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,backcolor(C))),!.
  tableedit_ReAssertColumn(Win,NextCol,forecolor(C)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,forecolor(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,forecolor(C))),!.
  tableedit_ReAssertColumn(Win,NextCol,alignment(A)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,alignment(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,alignment(A))),!.
  tableedit_ReAssertColumn(Win,NextCol,readonly(R)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,readonly(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,readonly(R))),!.
  tableedit_ReAssertColumn(Win,NextCol,resizable(R)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,resizable(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,resizable(R))),!.
  tableedit_ReAssertColumn(Win,NextCol,sortmode(S)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,sortmode(S))),!.
  tableedit_ReAssertColumn(Win,NextCol,defaultvalue(D)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,defaultvalue(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,defaultvalue(D))),!.
  tableedit_ReAssertColumn(Win,NextCol,validationrule(V)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,validationrule(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,validationrule(V))),!.
  tableedit_ReAssertColumn(Win,NextCol,validationtext(T)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,validationtext(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,validationtext(T))),!.
  tableedit_ReAssertColumn(Win,NextCol,maxlength(Value)):-
	retractAll(tableedit_db_Col_Info(Win,NextCol,maxlength(_))),
	assert(tableedit_db_Col_Info(Win,NextCol,maxlength(Value))),!.
  tableedit_ReAssertColumn(_Win,_,_).

  tableedit_ReAssert(Win,defcellcolor(C)):-
	retractAll(tableedit_db_Te_Info(Win,defcellcolor(_))),
	assert(tableedit_db_Te_Info(Win,defcellcolor(C))),!.
  tableedit_ReAssert(Win,areamarker(M)):-
	retractAll(tableedit_db_Te_Info(Win,areamarker(_))),
	assert(tableedit_db_Te_Info(Win,areamarker(M))),!.
  tableedit_ReAssert(Win,cut(C)):-
	retractAll(tableedit_db_Te_Info(Win,cut(_))),
	assert(tableedit_db_Te_Info(Win,cut(C))),!.
  tableedit_ReAssert(Win,paste(P)):-
	retractAll(tableedit_db_Te_Info(Win,paste(_))),
	assert(tableedit_db_Te_Info(Win,paste(P))),!.
  tableedit_ReAssert(Win,undo_redo(UR)):-
	retractAll(tableedit_db_Te_Info(Win,undo_redo(_))),
	assert(tableedit_db_Te_Info(Win,undo_redo(UR))),!.
  tableedit_ReAssert(Win,filter_tab(F)):-
	retractAll(tableedit_db_Te_Info(Win,filter_tab(_))),
	assert(tableedit_db_Te_Info(Win,filter_tab(F))),!.
  tableedit_ReAssert(Win,raised(R)):-
	retractAll(tableedit_db_Te_Info(Win,raised(_))),
	assert(tableedit_db_Te_Info(Win,raised(R))),!.
  tableedit_ReAssert(Win,headers(H)):-
	retractAll(tableedit_db_Te_Info(Win,headers(_))),
	assert(tableedit_db_Te_Info(Win,headers(H))),!.
  tableedit_ReAssert(Win,footers(F)):-
	retractAll(tableedit_db_Te_Info(Win,footers(_))),
	assert(tableedit_db_Te_Info(Win,footers(F))),!.
  tableedit_ReAssert(Win,backcolor_tab(Col)):-
	retractAll(tableedit_db_Te_Info(Win,backcolor_tab(_))),
	assert(tableedit_db_Te_Info(Win,backcolor_tab(Col))),!.
  tableedit_ReAssert(Win,emptycolor(Col)):-
	retractAll(tableedit_db_Te_Info(Win,emptycolor(_))),
	assert(tableedit_db_Te_Info(Win,emptycolor(Col))),!.
  tableedit_ReAssert(Win,titlebackcolor(Col)):-
	retractAll(tableedit_db_Te_Info(Win,titlebackcolor(_))),
	assert(tableedit_db_Te_Info(Win,titlebackcolor(Col))),!.
  tableedit_ReAssert(Win,titleforecolor(Col)):-
	retractAll(tableedit_db_Te_Info(Win,titleforecolor(_))),
	assert(tableedit_db_Te_Info(Win,titleforecolor(Col))),!.
  tableedit_ReAssert(Win,rowselector(Row_Sel,W,M)):-
	retractAll(tableedit_db_Te_Info(Win,rowselector(_,_,_))),
	assert(tableedit_db_Te_Info(Win,rowselector(Row_Sel,W,M))),!.
  tableedit_ReAssert(Win,nonscrollcol(NColumn)):-
	retractAll(tableedit_db_Te_Info(Win,nonscrollcol(_))),
	assert(tableedit_db_Te_Info(Win,nonscrollcol(NColumn))),!.
  tableedit_ReAssert(Win,sortedby(Col)):-
	retractAll(tableedit_db_Te_Info(Win,sortedby(_))),
	assert(tableedit_db_Te_Info(Win,sortedby(Col))),!.
  tableedit_ReAssert(Win,allmarker(Mark)):-
	retractAll(tableedit_db_Te_Info(Win,allmarker(_))),
	assert(tableedit_db_Te_Info(Win,allmarker(Mark))),!.
  tableedit_ReAssert(Win,colmarker(Mark)):-
	retractAll(tableedit_db_Te_Info(Win,colmarker(_))),
	assert(tableedit_db_Te_Info(Win,colmarker(Mark))),!.
  tableedit_ReAssert(Win,rowmarker(Mark)):-
	retractAll(tableedit_db_Te_Info(Win,rowmarker(_))),
	assert(tableedit_db_Te_Info(Win,rowmarker(Mark))),!.
  tableedit_ReAssert(Win,insert_rows(Row)):-
	retractAll(tableedit_db_Te_Info(Win,insert_rows(_))),
	assert(tableedit_db_Te_Info(Win,insert_rows(Row))),!.
  tableedit_ReAssert(Win,delete_rows(Row)):-
	retractAll(tableedit_db_Te_Info(Win,delete_rows(_))),
	assert(tableedit_db_Te_Info(Win,delete_rows(Row))),!.
  tableedit_ReAssert(Win,menu(M)):-
	retractAll(tableedit_db_Te_Info(Win,menu(_))),
	assert(tableedit_db_Te_Info(Win,menu(M))),!.
  tableedit_ReAssert(Win,readonly_tab(R)):-
	retractAll(tableedit_db_Te_Info(Win,readonly_tab(_))),
	assert(tableedit_db_Te_Info(Win,readonly_tab(R))),!.
  tableedit_ReAssert(Win,callback(CB)):-
	retractAll(tableedit_db_Te_Info(Win,callback(_))),
	assert(tableedit_db_Te_Info(Win,callback(CB))),!.
  tableedit_ReAssert(Win,compare(CO)):-
	retractAll(tableedit_db_Te_Info(Win,compare(_))),
	assert(tableedit_db_Te_Info(Win,compare(CO))),!.
  tableedit_ReAssert(Win,find(F)):-
	retractAll(tableedit_db_Te_Info(Win,find(_))),
	assert(tableedit_db_Te_Info(Win,find(F))),!.
  tableedit_ReAssert(Win,bufferingmode(Buf)):-
	retractAll(tableedit_db_Te_Info(Win,bufferingmode(_))),
	assert(tableedit_db_Te_Info(Win,bufferingmode(Buf))),!.
  tableedit_ReAssert(_Win,_).

  tableedit_ConvGridCellsStyle(vpiGrid::grid_raised,raised(b_true)):-!.
  tableedit_ConvGridCellsStyle(vpiGrid::grid_plain,raised(b_false)):-!.

class predicates
% Get possibility for Undo action
    tableedit_GetPossibilityUndo : (vpiDomains::windowHandle,core::booleanInt PossUndo)procedure  (i,o).
% Get possibility for Redo action
   tableedit_GetPossibilityRedo : (vpiDomains::windowHandle,core::booleanInt PossRedo)procedure  (i,o).
% Assert action to UndoRedo actions list
   tableedit_UpdateUndoRedoModified : (vpiDomains::windowHandle,tableedit_event)procedure anyflow.
% Undo actin
   tableedit_Undo : (vpiDomains::windowHandle)procedure anyflow.
% Redo actin
   tableedit_Redo : (vpiDomains::windowHandle)procedure anyflow.
% Set data to table editor with the notice on modifying
   tableedit_SetDataSendCallback : (vpiDomains::windowHandle,integer FrRow,integer ToRow,
				integer FRColumn,integer ToColumn,tableedit_data InData)procedure anyflow.
% Set clipboard format data to table editor with the notice on modifying
   tableedit_SetRowDataSendCallback : (vpiDomains::windowHandle,vpiGrid::areaList,string SourceStr)procedure anyflow.

   tableedit_ResetCurrentUndoRedoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST)procedure anyflow.

    tableedit_InsRows : (vpiDomains::windowHandle,integer Row,tableedit_data InsData)determ anyflow.

clauses
  tableedit_ResetCurrentUndoRedoData(Win,URData):-
	retractAll(tableedit_db_CurrentUndoRedo(Win,_)),
	assert(tableedit_db_CurrentUndoRedo(Win,URData)),
	!. 

  tableedit_SendCallback(Win,Event):-
	tableedit_db_Te_Info(Win,callback(CBack)),
	not(CBack(Win,Event)),!,
	tableedit_UpdateUndoRedoModified(Win,Event),fail.
  tableedit_SendCallback(_Win,_Event):-!.

  tableedit_CliarUndoRedoData(Win):-
	retractAll(tableedit_db_CurrentUndoRedo(Win,_)),
	retractAll(tableedit_db_UndoData(Win,_)),
	retractAll(tableedit_db_RedoData(Win,_)),!.

class predicates
  tableedit_assertUndoRedo : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST)procedure anyflow.
clauses

  tableedit_assertUndoRedo(Win,UR):-
	asserta(tableedit_db_UndoData(Win,UR)),!. %trap?! but fact nondeterm
  tableedit_assertUndoRedo(Win,_UR):-
	tableedit_CliarUndoRedoData(Win),!.
  tableedit_assertUndoRedo(_Win,_UR):-!.
class predicates
 tableedit_convertEditMarker : (vpiGrid::marker In,vpiGrid::marker Out)procedure anyflow.
clauses

  tableedit_convertEditMarker(InMark,OutMark):-
	InMark = vpiGrid::grid_edit_cell(Row,Col),
	OutMark = vpiGrid::grid_area_marker([ga(Row,Row,Col,Col)]),
	!.
  tableedit_convertEditMarker(Mark,Mark).

  tableedit_UpdateUndoRedoModified(Win,Event):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	not(tableedit_db_UndoAction(Win)),
	Event = marker(Marker,b_false),
	not(Marker = vpiGrid::grid_edit_cell(_,_)),
	retractAll(tableedit_db_RedoData(Win,_)),
	UR = [marker(Marker)],
	tableedit_assertUndoRedo(Win,UR),!.
  tableedit_UpdateUndoRedoModified(Win,Event):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	not(tableedit_db_UndoAction(Win)),
	Event = modified_event(Row,Column,CellData,NewValue),
	vpiGrid::marker(Win,Marker),
	tableedit_convertEditMarker(Marker,OutMarker),
	retractAll(tableedit_db_RedoData(Win,_)),
	UR = [marker(OutMarker),modified(Row,Column,CellData,NewValue)],
	tableedit_assertUndoRedo(Win,UR),!.
  tableedit_UpdateUndoRedoModified(Win,Event):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	not(tableedit_db_UndoAction(Win)),
	Event = insert_row(Row,NewValue),
	vpiGrid::marker(Win,Marker),
	retractAll(tableedit_db_RedoData(Win,_)),
	UR = [marker(Marker),row(Row,[],NewValue)],
	tableedit_assertUndoRedo(Win,UR),!.
  tableedit_UpdateUndoRedoModified(Win,Event):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	not(tableedit_db_UndoAction(Win)),
	Event = delete_row(Row,OldData),
	vpiGrid::marker(Win,Marker),
	retractAll(tableedit_db_RedoData(Win,_)),
	UR = [marker(Marker),row(Row,OldData,[])],
	tableedit_assertUndoRedo(Win,UR),!.
  tableedit_UpdateUndoRedoModified(Win,Event):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	not(tableedit_db_UndoAction(Win)),
	Event = action(ACT), ACT = resize_column_act(Column,Width),
	vpiGrid::marker(Win,Marker),
	retractAll(tableedit_db_RedoData(Win,_)),
	UR = [marker(Marker),resize_column(Column,Width)],
	tableedit_assertUndoRedo(Win,UR),!.
  tableedit_UpdateUndoRedoModified(_,_).

class predicates
% remove action from undo list
   tableedit_DelUndoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST  Removedaction)procedure anyflow.
% remove action from redo list
   tableedit_DelRedoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST Removedaction)procedure anyflow.
% add action to undo list
   tableedit_AddUndoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST Action)procedure anyflow.
% add action to redo list
   tableedit_AddRedoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST Action)procedure anyflow.
% get undo action
   tableedit_GetUndoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST Action)procedure anyflow.
% get redo action
   tableedit_GetRedoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST Action)procedure anyflow.
% get marker from UndRedo action
   tableedit_GetUndoRedoMarker : (tableedit_UNDOREDOLIST,tableedit_UNDOREDOLIST)procedure anyflow.
% Carry out undo action
   tableedit_SetUndoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST)procedure anyflow.
% Carry out redo action
   tableedit_SetRedoData : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST)procedure anyflow.
% Set marker from UndoRedo action
   tableedit_SetNewUndoRedoMarker : (vpiDomains::windowHandle,vpiGrid::marker)procedure anyflow.
% send ACTION callback
    tableedit_SendCallbackForAction : (vpiDomains::windowHandle,vpiGrid::userAction)determ anyflow.

   tableedit_member : (tableedit_UNDOREDODATA,tableedit_UNDOREDOLIST)determ anyflow.
   tableedit_member : (tableedit_columnproperty,tableedit_columnproperties)determ anyflow.
   tableedit_member : (tableedit_property,tableedit_properties)determ anyflow.

   tableedit_DeleteRowsSendCallback : (vpiDomains::windowHandle,vpiGrid::lineList)procedure anyflow.

clauses
  tableedit_member(S,[S|_]):-!.
  tableedit_member(S,[_|L]):-
	tableedit_member(S,L).

  tableedit_DelUndoData(Win,UndoData):-retract(tableedit_db_UndoData(Win,UndoData)),!.
  tableedit_DelUndoData(_Win,_UndoData):-!.
  
  tableedit_DelRedoData(Win,RedoData):-retract(tableedit_db_RedoData(Win,RedoData)),!.
  tableedit_DelRedoData(_Win,_RedoData):-!.
  
  tableedit_AddUndoData(Win,UndoData):-asserta(tableedit_db_UndoData(Win,UndoData)),!.

  tableedit_AddRedoData(Win,RedoData):-asserta(tableedit_db_RedoData(Win,RedoData)),!.

  tableedit_GetUndoData(Win,UndoData):-tableedit_db_UndoData(Win,UndoData),!.
  tableedit_GetUndoData(_Win,[]):-!.

  tableedit_GetRedoData(Win,RedoData):-tableedit_db_RedoData(Win,RedoData),!.
  tableedit_GetRedoData(_Win,[]):-!.
  
  tableedit_GetUndoRedoMarker(URData,M):-
	tableedit_member(marker(Marker),URData), M = [marker(Marker)],!.
  tableedit_GetUndoRedoMarker(_URData,[]):-!. 

  tableedit_SetNewUndoRedoMarker(Win,NewMarker):-
	vpiGrid::marker(Win,Marker), 
	not(Marker = NewMarker),
	tableedit_db_Te_Info(Win,callback(CBack)),
	not(CBack(Win,marker(NewMarker,b_true))),
	vpiGrid::marker(Win,NewMarker),
	!.
  tableedit_SetNewUndoRedoMarker(_Win,_NewMarker):-!.

  tableedit_SetUndoData(Win,UndoData):-
	tableedit_member(modified(Row,Column,OldValue,_NewValue),UndoData),
	tableedit_SetDataSendCallback(Win,Row,Row,Column,Column,[[OldValue]]),fail.
  tableedit_SetUndoData(Win,UndoData):-
	tableedit_member(marker(Marker),UndoData),
	tableedit_SetNewUndoRedoMarker(Win,Marker),fail.
  tableedit_SetUndoData(Win,UndoData):-
	tableedit_member(row(Row,[],_NewData),UndoData),
	tableedit_DeleteRowsSendCallback(Win,[vpiGrid::gl(Row,Row)]),fail.
  tableedit_SetUndoData(Win,UndoData):-
	tableedit_member(row(Row,OD,[]),UndoData),
	OldData = [OD],
	tableedit_InsRows(Win,Row,OldData),fail.
  tableedit_SetUndoData(Win,UndoData):-
	tableedit_member(RC,UndoData),
	resize_column(Column,Width) = RC,
	Wrevers =-Width,
	A = vpiGrid::grid_resize_column(Column,Wrevers),
	not(tableedit_SendCallbackForAction(Win,A)),
	ColProp = tableedit_getcolumnproperties(Win,Column),
	tableedit_member(width(W),ColProp),
	OldWidth = W - Width,
	retractAll(tableedit_db_Col_Info(Win,Column,width(_))),
	assert(tableedit_db_Col_Info(Win,Column,width(OldWidth))),
	tableedit_CreateGridColumnList(Win,NewGridColumnStyle),
	vpiGrid::columnStyle(Win,NewGridColumnStyle),
	fail.
  tableedit_SetUndoData(_Win,_UndoData):-!.

  tableedit_SetRedoData(Win,RedoData):-
	tableedit_member(modified(Row,Column,_OldValue,NewValue),RedoData),
	tableedit_SetDataSendCallback(Win,Row,Row,Column,Column,[[NewValue]]),fail.
  tableedit_SetRedoData(Win,RedoData):-
	tableedit_member(marker(Marker),RedoData),
	tableedit_SetNewUndoRedoMarker(Win,Marker),fail.
  tableedit_SetRedoData(Win,RedoData):-
	tableedit_member(row(Row,[],NewData),RedoData),
	ND = [NewData],
	tableedit_InsRows(Win,Row,ND),fail.
  tableedit_SetRedoData(Win,RedoData):-
	tableedit_member(row(Row,_OldData,[]),RedoData),
	tableedit_DeleteRowsSendCallback(Win,[vpiGrid::gl(Row,Row)]),fail.
  tableedit_SetRedoData(Win,RedoData):-
	tableedit_member(resize_column(Column,Width),RedoData),
	A = vpiGrid::grid_resize_column(Column,Width),
	not(tableedit_SendCallbackForAction(Win,A)),
	ColProp = tableedit_getcolumnproperties(Win,Column),
	tableedit_member(width(W),ColProp),
	NewWidth = W + Width,
	retractAll(tableedit_db_Col_Info(Win,Column,width(_))),
	assert(tableedit_db_Col_Info(Win,Column,width(NewWidth))),
	tableedit_CreateGridColumnList(Win,NewGridColumnStyle),
	vpiGrid::columnStyle(Win,NewGridColumnStyle),
	fail.
  tableedit_SetRedoData(_Win,_RedoData):-!.


class predicates
% Check : if UndoRedo action not yet was carried out
  tableedit_ChkCurrentUndoRedo : (vpiDomains::windowHandle,tableedit_UNDOREDOLIST)determ anyflow.
clauses

  tableedit_ChkCurrentUndoRedo(Win,URData):-
	not(tableedit_db_CurrentUndoRedo(Win,URData)),
	!.
  tableedit_ChkCurrentUndoRedo(Win,URData):-
	tableedit_db_CurrentUndoRedo(Win,URData),
	tableedit_member(modified(_,_,_,_),URData),
	!.

  tableedit_Undo(Win):-
	assert(tableedit_db_UndoAction(Win)),
	tableedit_db_UndoData(Win,UndoData),
	  tableedit_GetUndoRedoMarker(UndoData,UndoMarker),
	  tableedit_DelUndoData(Win,UndoData),
	  tableedit_AddRedoData(Win,UndoData),
	  tableedit_SetUndoData(Win,UndoData),
	tableedit_ChkCurrentUndoRedo(Win,UndoData),
	tableedit_ResetCurrentUndoRedoData(Win,UndoData),
	tableedit_GetUndoData(Win,NewUndoData),
	tableedit_GetUndoRedoMarker(NewUndoData,NewUndoMarker),
	not(UndoMarker = NewUndoMarker),
	retractAll(tableedit_db_UndoAction(Win)),
	!.
  tableedit_Undo(Win):-
	retractAll(tableedit_db_UndoAction(Win)),
	!.

  tableedit_Redo(Win):-
	assert(tableedit_db_UndoAction(Win)),
	tableedit_db_RedoData(Win,RedoData),
	  tableedit_GetUndoRedoMarker(RedoData,RedoMarker),
	  tableedit_DelRedoData(Win,RedoData),
	  tableedit_AddUndoData(Win,RedoData),
	  tableedit_SetRedoData(Win,RedoData),
	tableedit_ChkCurrentUndoRedo(Win,RedoData),
	tableedit_ResetCurrentUndoRedoData(Win,RedoData),
	tableedit_GetRedoData(Win,NewRedoData),
	tableedit_GetUndoRedoMarker(NewRedoData,NewRedoMarker),
	not(RedoMarker = NewRedoMarker),
	retractAll(tableedit_db_UndoAction(Win)),
	!.
  tableedit_Redo(Win):-
	retractAll(tableedit_db_UndoAction(Win)),
	!.

  tableedit_GetPossibilityUndo(Win,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	tableedit_db_UndoData(Win,UndoData),
	not(UndoData = []),
	!.
  tableedit_GetPossibilityUndo(Win,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	!.
  tableedit_GetPossibilityUndo(_Win,b_false):-!.

  tableedit_GetPossibilityRedo(Win,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering())),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	tableedit_db_RedoData(Win,RedoData),
	not(RedoData = []),
	!.
  tableedit_GetPossibilityRedo(Win,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_Te_Info(Win,undo_redo(b_true)),
	!.
  tableedit_GetPossibilityRedo(_Win,b_false):-!.

domains
  booleanlIST=core::booleanInt*.

class predicates
    tableedit_HandleEvent1 : (vpiDomains::windowHandle,vpiDomains::event)determ anyflow.
% Create menu
    tableedit_CreateMenu : (vpiDomains::windowHandle,integer,integer)procedure anyflow.
% Get possibility for "insert row" action
    tableedit_GetPossibilityInsRow : (vpiDomains::windowHandle,integer Row,core::booleanInt)procedure anyflow. 
% Get possibility for "delete row" action
    tableedit_GetPossibilityDelRow : (vpiDomains::windowHandle,core::booleanInt,vpiGrid::lineList)procedure anyflow.
% Get possibility for "cut" action
    tableedit_GetPossibilityCut : (vpiDomains::windowHandle,core::booleanInt,vpiGrid::areaList)procedure anyflow.
% Get possibility for "paste" action
    tableedit_GetPossibilityPaste : (vpiDomains::windowHandle,core::booleanInt,vpiGrid::areaList)procedure  (i,o,o).
% Get possibility for "copy" action
    tableedit_GetPossibilityCopy : (vpiDomains::windowHandle,core::booleanInt,vpiGrid::areaList)procedure  (i,o,o).
% Get possibility for "filter" action
    tableedit_GetPossibilityFilter : (vpiDomains::windowHandle,core::booleanInt Exclude,core::booleanInt,tableedit_filters)procedure  (i,i,o,o).
% Get possibility for "sort" action
    tableedit_GetPossibilitySort : (vpiDomains::windowHandle,core::booleanInt,integer Column)procedure  (i,o,o).
% Get possibility for "show all rows" action
    tableedit_GetPossibilityShowRow : (vpiDomains::windowHandle,core::booleanInt)procedure anyflow.
% Cell data to filter data transformation
    tableedit_CellDataToFilterData : (tableedit_celldata,core::booleanInt Excluding,tableedit_orfilterlist)procedure anyflow.
% Get SortList from "sortmode" property
    tableedit_GetSortList : (vpiDomains::windowHandle,integer Col,core::integer_list)procedure anyflow.
% Append custom item list to default item list
    tableedit_AppendToMenu : (vpiDomains::windowHandle,vpiDomains::menuItem_list,vpiDomains::menuItem_list)procedure anyflow.
% Create filter list from area list
    tableedit_CreateAreaFilter : (vpiDomains::windowHandle,core::booleanInt Exclude,vpiGrid::areaList,tableedit_filters)procedure anyflow.
% Create "Find" dialog
    tableedit_dlg_find_Create : (vpiDomains::windowHandle)procedure anyflow.
% Find next
    tableedit_find_next : (vpiDomains::windowHandle)procedure anyflow.

clauses
  tableedit_GetSortList(Win,Col,SortList):-
	tableedit_db_Col_Info(Win,Col,sortmode(ascending(SortList))),!.
  tableedit_GetSortList(Win,Col,SortList):-
	tableedit_db_Col_Info(Win,Col,sortmode(descending(SortList))),!.
  tableedit_GetSortList(_Win,_Col,[]):-!.


  tableedit_CellDataToFilterData(i(Val),b_false,[if_range(Val,Val)]):-!.
  tableedit_CellDataToFilterData(ic(Val,_),b_false,[if_range(Val,Val)]):-!.
  tableedit_CellDataToFilterData(l(Val),b_false,[lf_range(Val,Val)]):-!.
  tableedit_CellDataToFilterData(lc(Val,_),b_false,[lf_range(Val,Val)]):-!.
  tableedit_CellDataToFilterData(r(Val),b_false,[rf_range(Val,Val)]):-!.
  tableedit_CellDataToFilterData(rc(Val,_),b_false,[rf_range(Val,Val)]):-!.
  tableedit_CellDataToFilterData(s(Val),b_false,[s_f(Val)]):-!.
  tableedit_CellDataToFilterData(sc(Val,_),b_false,[s_f(Val)]):-!.
  tableedit_CellDataToFilterData(p(_,_,Val),b_false,[s_f(Val)]):-!.
  tableedit_CellDataToFilterData(void,b_false,[fvoid]):-!.
  tableedit_CellDataToFilterData(voidc(_),b_false,[fvoid]):-!.

  tableedit_CellDataToFilterData(i(Val),b_true,[if_not(Val)]):-!.
  tableedit_CellDataToFilterData(ic(Val,_),b_true,[if_not(Val)]):-!.
  tableedit_CellDataToFilterData(l(Val),b_true,[lf_not(Val)]):-!.
  tableedit_CellDataToFilterData(lc(Val,_),b_true,[lf_not(Val)]):-!.
  tableedit_CellDataToFilterData(r(Val),b_true,[rf_not(Val)]):-!.
  tableedit_CellDataToFilterData(rc(Val,_),b_true,[rf_not(Val)]):-!.
  tableedit_CellDataToFilterData(s(Val),b_true,[s_f_not(Val)]):-!.
  tableedit_CellDataToFilterData(p(_,_,Val),b_true,[s_f_not(Val)]):-!.
  tableedit_CellDataToFilterData(sc(Val,_),b_true,[s_f_not(Val)]):-!.
  tableedit_CellDataToFilterData(void,b_true,[fvoid_not]):-!.
  tableedit_CellDataToFilterData(voidc(_),b_true,[fvoid_not]):-!.
  tableedit_CellDataToFilterData(_,_,[]):-!.

  tableedit_GetPossibilityInsRow(Win,Row,b_true):-
	tableedit_db_Te_Info(Win,insert_rows(b_true)),
	tableedit_db_Te_Info(Win,footers(F)),
	MaxRows = tableedit_maxvisiblerows(Win),
	Row = MaxRows - F + 1,
	tableedit_CreateDefRow(Win,1,[],DefData),
	not(tableedit_SendCallback(Win,insert_row_beg(Row,DefData))),
	!.
  tableedit_GetPossibilityInsRow(_Win,0,b_false):-!.

class predicates
% Create line list from area list
    tableedit_ConvAreaToLine : (vpiGrid::areaList,vpiGrid::lineList,vpiGrid::lineList)procedure anyflow.

clauses  

  tableedit_ConvAreaToLine([],LList,LList):-!.
  tableedit_ConvAreaToLine([L1|L2],LList,OutLList):-!,
	L1 = vpiGrid::ga(FromRow,ToRow,_,_), L = vpiGrid::gl(FromRow,ToRow),
	tableedit_ConvAreaToLine(L2,[L | LList],OutLList).
  tableedit_ConvAreaToLine(_,_,[]):-!.

  tableedit_GetPossibilityDelRow(Win,b_true,RML):-
	tableedit_db_Te_Info(Win,delete_rows(b_true)),
	vpiGrid::marker(Win,M), M = vpiGrid::grid_area_marker(AML),
	tableedit_ConvAreaToLine(AML,[],RML),
	not(tableedit_SendCallback(Win,delete_row_beg(RML))),
	!.
  tableedit_GetPossibilityDelRow(Win,b_true,RML):-
	tableedit_db_Te_Info(Win,delete_rows(b_true)),
	vpiGrid::marker(Win,M), M = vpiGrid::grid_row_marker(RML),
	not(tableedit_SendCallback(Win,delete_row_beg(RML))),
	!.
  tableedit_GetPossibilityDelRow(Win,b_true,RML):-
	tableedit_db_Te_Info(Win,delete_rows(b_true)),
	vpiGrid::marker(Win,M), M = vpiGrid::grid_edit_Cell(Row,_Col), RML = [gl(Row,Row)],
	not(tableedit_SendCallback(Win,delete_row_beg(RML))),
	!.
  tableedit_GetPossibilityDelRow(_Win,b_false,[]):-!.

  tableedit_GetPossibilityShowRow(Win,b_false):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_ShadowData_Info(Win,[]),
	!.
  tableedit_GetPossibilityShowRow(Win,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	not(tableedit_SendCallback(Win,filter_beg([]))),
	!.
  tableedit_GetPossibilityShowRow(Win,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	not(tableedit_SendCallback(Win,filter_beg([]))),
	!.
  tableedit_GetPossibilityShowRow(_Win,b_false):-!.

  tableedit_GetPossibilityCut(Win,b_true,AML):-
	not(tableedit_db_Col_Info(Win,_,readonly(b_true))),
	tableedit_db_Te_Info(Win,cut(b_true)),
	vpiGrid::marker(Win,M), M = grid_row_marker(LML),
	LML = [gl(FromRow,ToRow)],
	ToCol = tableedit_maxcol(Win),
	AML = [ga(FromRow,ToRow,1,ToCol)],
	not(tableedit_SendCallback(Win,cut_beg(FromRow,ToRow,1,ToCol))),
	!.
  tableedit_GetPossibilityCut(Win,b_true,AML):-
	not(tableedit_db_Col_Info(Win,_,readonly(b_true))),
	tableedit_db_Te_Info(Win,cut(b_true)),
	vpiGrid::marker(Win,M), M = grid_area_marker(AML),
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	not(tableedit_SendCallback(Win,cut_beg(FromRow,ToRow,FromCol,ToCol))),
	!.
  tableedit_GetPossibilityCut(Win,b_true,AML):-
	not(tableedit_db_Col_Info(Win,_,readonly(b_true))),
	tableedit_db_Te_Info(Win,cut(b_true)),
	vpiGrid::marker(Win,M), M = grid_all_marker,
	ToRow = tableedit_maxvisiblerows(Win), ToRow >= 1,
	ToCol = tableedit_maxcol(Win),
	AML = [ga(1,ToRow,1,ToCol)],
	not(tableedit_SendCallback(Win,cut_beg(1,ToRow,1,ToCol))),
	!.
  tableedit_GetPossibilityCut(_Win,b_false,[]):-!.

  tableedit_GetPossibilityPaste(Win,b_true,AML):-
	not(tableedit_db_Col_Info(Win,_,readonly(b_true))),
	tableedit_db_Te_Info(Win,paste(b_true)),
	vpiGrid::marker(Win,M), M = grid_row_marker([gl(FromRow,ToRow)]),
	ToCol = tableedit_maxcol(Win),
	AML = [ga(FromRow,ToRow,1,ToCol)],
	SourceStr = vpi::cbGetString(),
	tableedit_ChkClipBoardStr(Win,AML,SourceStr,b_true),
	not(tableedit_SendCallback(Win,paste_beg(FromRow,ToRow,1,ToCol))),
	!.
  tableedit_GetPossibilityPaste(Win,b_true,AML):-
	not(tableedit_db_Col_Info(Win,_,readonly(b_true))),
	tableedit_db_Te_Info(Win,paste(b_true)),
	vpiGrid::marker(Win,M), M = grid_area_marker(AML),
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	SourceStr = vpi::cbGetString(),
	tableedit_ChkClipBoardStr(Win,AML,SourceStr,b_true),
	not(tableedit_SendCallback(Win,paste_beg(FromRow,ToRow,FromCol,ToCol))),
	!.
  tableedit_GetPossibilityPaste(Win,b_true,AML):-
	not(tableedit_db_Col_Info(Win,_,readonly(b_true))),
	tableedit_db_Te_Info(Win,paste(b_true)),
	vpiGrid::marker(Win,M), M = grid_all_marker,
	ToRow = tableedit_maxvisiblerows(Win), ToRow >= 1,
	ToCol = tableedit_maxcol(Win),
	AML = [ga(1,ToRow,1,ToCol)],
	SourceStr = vpi::cbGetString(),
	tableedit_ChkClipBoardStr(Win,AML,SourceStr,b_true),
	not(tableedit_SendCallback(Win,paste_beg(1,ToRow,1,ToCol))),
	!.
  tableedit_GetPossibilityPaste(_Win,b_false,[]):-!.

  tableedit_GetPossibilityCopy(Win,b_true,AML):-
	vpiGrid::marker(Win,M), M = grid_row_marker(LML),
	LML = [gl(FromRow,ToRow)],
	ToCol = tableedit_maxcol(Win),
	AML = [ga(FromRow,ToRow,1,ToCol)],
	not(tableedit_SendCallback(Win,copy_beg(FromRow,ToRow,1,ToCol))),
	!.
  tableedit_GetPossibilityCopy(Win,b_true,AML):-
	vpiGrid::marker(Win,M), M = grid_area_marker(AML),
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	not(tableedit_SendCallback(Win,copy_beg(FromRow,ToRow,FromCol,ToCol))),
	!.
  tableedit_GetPossibilityCopy(Win,b_true,AML):-
	vpiGrid::marker(Win,M), M = grid_all_marker,
	ToRow = tableedit_maxvisiblerows(Win), ToRow >= 1,
	ToCol = tableedit_maxcol(Win),
	AML = [ga(1,ToRow,1,ToCol)],
	not(tableedit_SendCallback(Win,copy_beg(1,ToRow,1,ToCol))),
	!.
  tableedit_GetPossibilityCopy(_Win,b_false,[]):-!.

  tableedit_GetPossibilitySort(Win,b_true,Col):-
	vpiGrid::marker(Win,M), M = grid_area_marker([ga(_,_,Col,ToCol)]), Col = ToCol,
	tableedit_db_Col_Info(Win,Col,sortmode(SortMode)),
	not(SortMode = none),
	not(tableedit_SendCallback(Win,sort_beg(Col))),
	!.
  tableedit_GetPossibilitySort(Win,b_true,Col):-
	vpiGrid::marker(Win,M), M = grid_col_marker([gl(Col,ToCol)]), Col = ToCol,
	tableedit_db_Col_Info(Win,Col,sortmode(SortMode)),
	not(SortMode = none),
	not(tableedit_SendCallback(Win,sort_beg(Col))),
	!.
  tableedit_GetPossibilitySort(Win,b_true,Col):-
	vpiGrid::marker(Win,M), M = grid_edit_Cell(_,Col),
	tableedit_db_Col_Info(Win,Col,sortmode(SortMode)),
	not(SortMode = none),
	not(tableedit_SendCallback(Win,sort_beg(Col))),
	!.
  tableedit_GetPossibilitySort(_Win,b_false,0):-!.

class predicates
% Check : if exist column with "filter(b_false)" property in area list, then - fail
    tableedit_ChkAreaListForFilter : (vpiDomains::windowHandle,vpiGrid::areaList)determ anyflow.
    tableedit_ChkAreaListForFilter1 : (vpiDomains::windowHandle,integer FromColumn,integer ToColumn)determ anyflow.
clauses

  tableedit_ChkAreaListForFilter(_Win,[]):-!.
  tableedit_ChkAreaListForFilter(Win,[L1|L2]):-!,
	L1 = ga(_FRow,_ToRow,FCol,ToCol),
	not(tableedit_ChkAreaListForFilter1(Win,FCol,ToCol)),
	tableedit_ChkAreaListForFilter(Win,L2).

  tableedit_ChkAreaListForFilter1(Win,FCol,ToCol):-
	tableedit_db_Col_Info(Win,Col,filter(b_false)),
	Col >= FCol, Col <= ToCol,!.
    
  tableedit_GetPossibilityFilter(Win,Exclude,b_true,FL):-
	vpiGrid::marker(Win,M), M = grid_area_marker(AREALIST),
	tableedit_ChkAreaListForFilter(Win,AREALIST),
	tableedit_CreateAreaFilter(Win,Exclude,AREALIST,FL),
	not(tableedit_SendCallback(Win,filter_beg(FL))),
	!.
  tableedit_GetPossibilityFilter(Win,Exclude,b_true,FL):-
	vpiGrid::marker(Win,M), M = grid_edit_Cell(Row,Col),
	tableedit_ChkAreaListForFilter(Win,[ga(Row,Row,Col,Col)]),
	tableedit_CreateAreaFilter(Win,Exclude,[ga(Row,Row,Col,Col)],FL),
	not(tableedit_SendCallback(Win,filter_beg(FL))),
	!.
  tableedit_GetPossibilityFilter(_Win,_,b_false,[]):-!.

  tableedit_AppendToMenu(Win,MenuList,MenuList):-
	tableedit_db_Te_Info(Win,menu([])),!.
  tableedit_AppendToMenu(Win,InMenuList,OutMenuList):-
	tableedit_db_Te_Info(Win,menu(MenuList)),
	tableedit_Append(InMenuList,[separator | MenuList],OutMenuList),!.
  tableedit_AppendToMenu(_,MenuList,MenuList).

class predicates
  tableedit_GetPossibilityFind : (vpiDomains::windowHandle TabWin,core::booleanInt PossFindNext)procedure anyflow.
  tableedit_GetPossibilityFindNext : (vpiDomains::windowHandle TabWin,core::booleanInt PossFindNext)procedure anyflow.
clauses
  tableedit_GetPossibilityFindNext(TabWin,b_true):-
	tableedit_db_Te_Info(TabWin,find(b_true)),
	tableedit_db_FindParam(TabWin,_Str,_Direction,Column,_Match,_CaseSens),
	tableedit_db_FindDlgParam(TabWin,Column,_),
	!.
  tableedit_GetPossibilityFindNext(_TabWin,b_false):-!.

  tableedit_GetPossibilityFind(Win,b_true):-
	tableedit_db_Te_Info(Win,find(b_true)),
	!.
  tableedit_GetPossibilityFind(_Win,b_false):-!.




class predicates
% reverse
    tableedit_reverse : (vpiDomains::menuItem_list,vpiDomains::menuItem_list,vpiDomains::menuItem_list)procedure anyflow.
    tableedit_reverse : (tableedit_data,tableedit_data,tableedit_data)procedure anyflow.
    tableedit_reverse : (tableedit_columndata,tableedit_columndata,tableedit_columndata)procedure anyflow.
    tableedit_reverse : (vpiGrid::list2d,vpiGrid::list2d,vpiGrid::list2d)procedure anyflow.
    tableedit_reverse : (vpiGrid::list,vpiGrid::list,vpiGrid::list)procedure anyflow.
    tableedit_DelMenuItems : (vpiDomains::menuItem_list,vpiDomains::menuItem_list,vpiDomains::menuItem_list)procedure anyflow.

clauses
  tableedit_DelMenuItems([],LOut1,LOut2):-
	LOut1 = [separator | Rest],
	hasDomain(vpiDomains::menuItem_list, L),
	L = [],
	tableedit_reverse(Rest,L,LOut2),
	!.
  tableedit_DelMenuItems([],LOut1,LOut2):-
	hasDomain(vpiDomains::menuItem_list, L),
	L = [],
	tableedit_reverse(LOut1,L,LOut2),
	!.
  tableedit_DelMenuItems([L1 | L2],LOut,L):-
	L1 = txt(_,_,_,b_true,_,_),!,
	tableedit_DelMenuItems(L2,[L1 | LOut],L).
  tableedit_DelMenuItems([L1 | L2],LOut,L):-
	L1 = separator,
	LOut = [X|_],
	not(X = separator),!,
	tableedit_DelMenuItems(L2,[L1 | LOut],L).
  tableedit_DelMenuItems([_L1 | L2],LOut,L):-!,
	tableedit_DelMenuItems(L2,LOut,L).
  tableedit_DelMenuItems(_,_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_CreateMenu(Win,X,Y):-
  	vpiGrid::getPos(Win,X,Y,Row,Column),
	not(tableedit_SendCallback(Win,menu_beg(Row,Column))),
	tableedit_CurWait(Win,b_true),
	tableedit_GetPossibilityCopy(Win,PossCopy,_),
	% Pro/3 changes
	%tableedit_GetPossibilityCut(Win,PossCut,_),
	%tableedit_GetPossibilityPaste(Win,PossPast,_),
	%tableedit_GetPossibilitySort(Win,PossS,_),
	%tableedit_GetPossibilityFilter(Win,b_true,PossFEx,_),
	%tableedit_GetPossibilityFilter(Win,b_false,PossFBy,_),
	tableedit_GetPossibilityInsRow(Win,_,PossIns),
	tableedit_GetPossibilityDelRow(Win,PossDel,_),
	%tableedit_GetPossibilityShowRow(Win,ShowAll),
	%tableedit_GetPossibilityUndo(Win,PossUndo),
	%tableedit_GetPossibilityRedo(Win,PossRedo),
	%tableedit_GetPossibilityFindNext(Win,PossFindNext),
	%tableedit_GetPossibilityFind(Win,PossFind),
	% Pro/3 changes:
	MList = [
	     %txt(tableedit_MenuId18,tableedit_con_undotext,key(3,0),PossUndo,mis_None,[]),
		 %txt(tableedit_MenuId19,tableedit_con_redotext,key(3,0),PossRedo,mis_None,[]),
		 %separator,
		 %%txt(tableedit_MenuId6,tableedit_con_copytext,key(3,0),PossCopy,mis_None,[]),
		 txt(tableedit_MenuId6,"Display sentence",key(3,0),PossCopy,mis_None,[]),
		 %%
		 %txt(tableedit_MenuId7,tableedit_con_pastetext,key(22,0),PossPast,mis_None,[]),
		 %txt(tableedit_MenuId8,tableedit_con_cuttext,key(24,0),PossCut,mis_None,[]),
		 %separator,
		 %txt(tableedit_MenuId9,tableedit_con_sortAtext,key(19,0),PossS,mis_None,[]),
		 %txt(tableedit_MenuId11,tableedit_con_sortDtext,key(19,0),PossS,mis_None,[]),
		 %separator,
		 %txt(tableedit_MenuId1,tableedit_con_filterStext,key(19,0),PossFBy,mis_None,[]),
		 %txt(tableedit_MenuId3,tableedit_con_filterEtext,key(19,0),PossFEx,mis_None,[]),
		 %txt(tableedit_MenuId5,tableedit_con_showRowstext,key(19,0),ShowAll,mis_None,[]),
		 %separator,
		 %%txt(tableedit_MenuId14,tableedit_con_insRowtext,key(k_insert,0),PossIns,mis_None,[]),
		 txt(tableedit_MenuId14,"Add new sentence",key(k_insert,0),PossIns,mis_None,[]),
		 %%
		 %%txt(tableedit_MenuId16,tableedit_con_delRowtext,key(k_del,0),PossDel,mis_None,[]),
		 txt(tableedit_MenuId16,"Delete sentence",key(k_del,0),PossDel,mis_None,[])
		 %%
		 %separator,
		 %txt(tableedit_MenuId22,tableedit_con_find,key(19,0),PossFind,mis_None,[]),
		 %txt(tableedit_MenuId23,tableedit_con_findnext,key(19,0),PossFindNext,mis_None,[])
		],
	tableedit_DelMenuItems(MList,[],OutMList),
	tableedit_AppendToMenu(Win,OutMList,OutMenuList),
	not(OutMenuList=[]),
	tableedit_CurWait(Win,b_false),
	vpi::menuPopUp(Win,dynMenu(OutMenuList),pnt(X,Y),align_Left),
	!.
  tableedit_CreateMenu(Win,_,_):-
	tableedit_CurWait(Win,b_false),!.

class predicates
%Create filter list from area list
    tableedit_CreateAreaFilter1 : (vpiDomains::windowHandle,core::booleanInt Exclude,vpiGrid::areaList,integer Column,integer MaxColumn,
			      tableedit_filters,tableedit_filters)procedure anyflow.
    tableedit_CreateAreaFilter2 : (vpiDomains::windowHandle,core::booleanInt Exclude,vpiGrid::areaList,integer Column,
			      tableedit_orfilterlist,tableedit_orfilterlist)procedure anyflow.
    tableedit_CreateAreaFilter3 : (vpiDomains::windowHandle,core::booleanInt Exclude,vpiGrid::area,integer Column,
			      tableedit_orfilterlist,tableedit_orfilterlist)procedure anyflow.
    tableedit_CreateAreaFilter4 : (vpiDomains::windowHandle,core::booleanInt Exclude,vpiGrid::area,integer Column,
			      tableedit_orfilterlist,tableedit_orfilterlist)procedure anyflow.

clauses

  tableedit_CreateAreaFilter(Win,Exclude,Gal,Filters):-
	MaxCol = tableedit_maxcol(Win),
	tableedit_CreateAreaFilter1(Win,Exclude,Gal,1,MaxCol,[],Filters),!.

  tableedit_CreateAreaFilter1(_Win,_Exclude,_Gal,Col,MaxCol,F,F):- Col > MaxCol,!.
  tableedit_CreateAreaFilter1(Win,Exclude,Gal,Col,MaxCol,IFL,OF):-!,
	tableedit_CreateAreaFilter2(Win,Exclude,Gal,Col,[],FL),
	IFL1 = [columnfilter(Col,FL) | IFL],
	NextCol = Col + 1,
	tableedit_CreateAreaFilter1(Win,Exclude,Gal,NextCol,MaxCol,IFL1,OF).

  tableedit_CreateAreaFilter2(_Win,_Exclude,[],_,F,F):-!.
  tableedit_CreateAreaFilter2(Win,Exclude,[L1|L2],Col,InFl,OF):-!,
	tableedit_CreateAreaFilter3(Win,Exclude,L1,Col,InFl,OutFL),
	tableedit_CreateAreaFilter2(Win,Exclude,L2,Col,OutFL,OF).
  tableedit_CreateAreaFilter2(_,_,_,_,_,[]):-!.

  tableedit_CreateAreaFilter3(Win,Exclude,Ga,Col,InFl,OutFL):-
	Ga = ga(_FromRow,_ToRow,FromCol,ToCol), Col >= FromCol, Col <= ToCol,
	tableedit_CreateAreaFilter4(Win,Exclude,Ga,Col,InFl,OutFL),!.
  tableedit_CreateAreaFilter3(_Win,_Exclude,_Ga,_Col,InFl,InFl):-!.
	
  tableedit_CreateAreaFilter4(_Win,_Exclude,ga(Row,ToRow,_FromCol,_ToCol),_Col,Fl,Fl):- Row > ToRow,!.
  tableedit_CreateAreaFilter4(Win,Exclude,ga(Row,ToRow,FromCol,ToCol),Col,InFl,OutFL):-
	CellData = tableedit_getcelldata(Win,Row,Col),
	tableedit_CellDataToFilterData(CellData,Exclude,FdataList), FdataList = [Fdata],!,
	InFl1 = [Fdata | InFl],
	Row1 = Row + 1,
	tableedit_CreateAreaFilter4(Win,Exclude,ga(Row1,ToRow,FromCol,ToCol),Col,InFl1,OutFL).
  tableedit_CreateAreaFilter4(_,_,_,_,_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

% e_CloseRequest() handling
  tableedit_HandleEvent1(Win,e_CloseRequest()):-!,
	tableedit_SendCallback(Win,closerequest()),
	!.
% e_Destroy() handling
  tableedit_HandleEvent1(Win,e_Destroy()):-
	retractAll(tableedit_db_Te_Info(Win,_)),
	retractAll(tableedit_db_Col_Info(Win,_,_)),
	retractAll(tableedit_db_Data_Info(Win,_)),
  	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	retractAll(tableedit_db_ShadowData_Info(Win,_)),
	tableedit_CliarUndoRedoData(Win),
  	retractAll(tableedit_db_PasteError(Win)),
	retractAll(tableedit_db_InitMode(Win)),
	retractAll(tableedit_db_UndoAction(Win)),
	!.
% e_MouseDown handling (create menu)
  tableedit_HandleEvent1(Win,e_MouseUp(pnt(X,Y),c_Nothing,mouse_button_right)):-
	tableedit_CreateMenu(Win,X,Y),
	!.
% win_PostEvent to "Undo"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId18,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId20,c_Nothing)),
	!.
% "Undo"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId20,_)):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	not(tableedit_SendCallback(Win,undo())),
	tableedit_CurWait(Win,b_true),
	tableedit_Undo(Win),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId20,_)):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	not(tableedit_SendCallback(Win,undo())),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId20,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% win_PostEvent to "Redo"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId19,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId21,c_Nothing)),
	!.
% "Redo"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId21,_)):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	not(tableedit_SendCallback(Win,redo())),
	tableedit_CurWait(Win,b_true),
	tableedit_Redo(Win),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId21,_)):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	not(tableedit_SendCallback(Win,redo())),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId21,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% win_PostEvent to "Filter by selection"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId1,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId2,c_Nothing)),
	!.
% "Filter by selection"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId2,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_CurWait(Win,b_true),
	tableedit_GetPossibilityFilter(Win,b_false,P,Fdata), P = b_true,
	not(tableedit_SendCallback(Win,filter(Fdata))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_resetfilters(Win,Fdata),
	tableedit_db_Te_Info(Win,sortedby(Col)),
	tableedit_sort(Win,Col),
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId2,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_CurWait(Win,b_true),
	tableedit_GetPossibilityFilter(Win,b_false,P,Fdata), P = b_true,
	not(tableedit_SendCallback(Win,filter(Fdata))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId2,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% win_PostEvent to "Filter excluding selection"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId3,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId4,c_Nothing)),
	!.
% "Filter excluding selection"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId4,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_CurWait(Win,b_true),
	tableedit_GetPossibilityFilter(Win,b_true,P,Fdata), P = b_true,
	not(tableedit_SendCallback(Win,filter(Fdata))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_resetfilters(Win,Fdata),
	tableedit_db_Te_Info(Win,sortedby(Col)),
	tableedit_sort(Win,Col),
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId4,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_CurWait(Win,b_true),
	tableedit_GetPossibilityFilter(Win,b_true,P,Fdata), P = b_true,
	not(tableedit_SendCallback(Win,filter(Fdata))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId4,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% "Show All rows"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId5,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_CurWait(Win,b_true),
	not(tableedit_SendCallback(Win,filter([]))),
	tableedit_resetfilters(Win,[]),
	tableedit_db_Te_Info(Win,sortedby(Col)),
	tableedit_sort(Win,Col),
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId5,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_CurWait(Win,b_true),
	not(tableedit_SendCallback(Win,filter([]))),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId5,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% Control 'c' - win_PostEvent to "Copy"
  tableedit_HandleEvent1(Win,e_Char(3,c_Control)):- 
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId6,c_Nothing)),
	!.
% "Copy"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId6,_)):-
	tableedit_GetPossibilityCopy(Win,P,AML), P = b_true,
	tableedit_CurWait(Win,b_true),
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	not(tableedit_SendCallback(Win,copy(FromRow,ToRow,FromCol,ToCol))),
	RowStringData = tableedit_getclipboarddata(Win,FromRow,ToRow,FromCol,ToCol),
	vpi::cbPutString(RowStringData),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId6,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% Control 'v' - win_PostEvent to "Paste"
  tableedit_HandleEvent1(Win,e_Char(22,c_Control)):- 
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId7,c_Nothing)),
	!.
% "Paste"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId7,_)):-
	tableedit_GetPossibilityPaste(Win,P,AML), P = b_true,
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	tableedit_CurWait(Win,b_true),
	not(tableedit_SendCallback(Win,paste(FromRow,ToRow,FromCol,ToCol))),
	SourceStr = vpi::cbGetString(),
	tableedit_ChkClipBoardStr(Win,AML,SourceStr,b_true),
	tableedit_SetRowDataSendCallback(Win,AML,SourceStr),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId7,_)):-
	tableedit_CurWait(Win,b_false),
	!.

  tableedit_HandleEvent1(Win,e_Char(24,c_Control)):- 
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId8,c_Nothing)),
	!.
% "Cut"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId8,_)):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_GetPossibilityCut(Win,P,AML), P = b_true,
	tableedit_CurWait(Win,b_true),
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	not(tableedit_SendCallback(Win,cut(FromRow,ToRow,FromCol,ToCol))),
	RowStringData = tableedit_getclipboarddata(Win,FromRow,ToRow,FromCol,ToCol),
	vpi::cbPutString(RowStringData),
	Nrows = ToRow - FromRow + 1,
	tableedit_CreateVoidRows(Win,Nrows,[],VoidData),
	tableedit_SetDataSendCallback(Win,FromRow,ToRow,FromCol,ToCol,VoidData),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId8,_)):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_GetPossibilityCut(Win,P,AML), P = b_true,
	tableedit_CurWait(Win,b_true),
	AML = [ga(FromRow,ToRow,FromCol,ToCol)],
	not(tableedit_SendCallback(Win,cut(FromRow,ToRow,FromCol,ToCol))),
	RowStringData = tableedit_getclipboarddata(Win,FromRow,ToRow,FromCol,ToCol),
	vpi::cbPutString(RowStringData),
	Nrows = ToRow - FromRow + 1,
	tableedit_CreateVoidRows(Win,Nrows,[],VoidData),
	tableedit_setdata(Win,FromRow,ToRow,FromCol,ToCol,VoidData),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId8,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% win_PostEvent to "Sort ascending"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId9,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId10,c_Nothing)),
	!.
% "Sort ascending"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId10,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_GetPossibilitySort(Win,P,FromCol), P = b_true,
	tableedit_CurWait(Win,b_true),
	tableedit_GetSortList(Win,FromCol,SortList),
	not(tableedit_SendCallback(Win,sort(FromCol,ascending(SortList)))),
	retract(tableedit_db_Col_Info(Win,FromCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,FromCol,sortmode(ascending([FromCol|SortList])))),
	retract(tableedit_db_Te_Info(Win,sortedby(_))),
	assert(tableedit_db_Te_Info(Win,sortedby(FromCol))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_sort(Win,FromCol),
	retract(tableedit_db_Col_Info(Win,FromCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,FromCol,sortmode(ascending(SortList)))),!,
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	fail.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId10,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_GetPossibilitySort(Win,P,FromCol), P = b_true,
	tableedit_CurWait(Win,b_true),
	tableedit_GetSortList(Win,FromCol,SortList),
	not(tableedit_SendCallback(Win,sort(FromCol,ascending(SortList)))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	retract(tableedit_db_Te_Info(Win,sortedby(_))),
	assert(tableedit_db_Te_Info(Win,sortedby(FromCol))),
	retract(tableedit_db_Col_Info(Win,FromCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,FromCol,sortmode(ascending(SortList)))),!,
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	fail.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId10,_)):-
	tableedit_CurWait(Win,b_false),
	!.

% win_PostEvent to "Sort descending"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId11,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId12,c_Nothing)),
	!.
% "Sort descending"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId12,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_GetPossibilitySort(Win,P,FromCol), P = b_true,
	tableedit_CurWait(Win,b_true),
	tableedit_GetSortList(Win,FromCol,SortList),
	not(tableedit_SendCallback(Win,sort(FromCol,descending(SortList)))),
	retract(tableedit_db_Col_Info(Win,FromCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,FromCol,sortmode(descending([FromCol|SortList])))),
	retract(tableedit_db_Te_Info(Win,sortedby(_))),
	assert(tableedit_db_Te_Info(Win,sortedby(FromCol))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_sort(Win,FromCol),
	retract(tableedit_db_Col_Info(Win,FromCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,FromCol,sortmode(descending(SortList)))),!,
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	fail.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId12,_)):- 
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_GetPossibilitySort(Win,P,FromCol), P = b_true,
	tableedit_CurWait(Win,b_true),
	tableedit_GetSortList(Win,FromCol,SortList),
	not(tableedit_SendCallback(Win,sort(FromCol,descending(SortList)))),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	retract(tableedit_db_Te_Info(Win,sortedby(_))),
	assert(tableedit_db_Te_Info(Win,sortedby(FromCol))),
	retract(tableedit_db_Col_Info(Win,FromCol,sortmode(_))),
	assert(tableedit_db_Col_Info(Win,FromCol,sortmode(descending(SortList)))),!,
	tableedit_CliarUndoRedoData(Win),
	tableedit_CurWait(Win,b_false),
	fail.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId12,_)):-
	tableedit_CurWait(Win,b_false),
	!.
% 'Ins' - win_PostEvent to "Insert Row"
  tableedit_HandleEvent1(Win,e_Char(k_insert,c_Nothing)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId13,c_Nothing)),
	!.
% win_PostEvent to "Insert Row"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId14,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId13,c_Nothing)),
	!.
% "Insert Row"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId13,_)):-
	tableedit_GetPossibilityInsRow(Win,Row,P), P = b_true,
	tableedit_CurWait(Win,b_true),
	tableedit_InsDefRowZ(Win),
	tableedit_BuffInvalidate(Win,Row),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId13,_)):-
	tableedit_CurWait(Win,b_false),
	!.
% 'Del' - win_PostEvent to "Delete Rows"
  tableedit_HandleEvent1(Win,e_Char(k_del,c_Nothing)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId15,c_Nothing)),
	!,fail.

% shift F3 - Find Next
  tableedit_HandleEvent1(Win,e_Char(k_f3,c_Shift)):-
	tableedit_GetPossibilityFindNext(Win,P), P = b_true,
	tableedit_find_Next(Win),
	!,fail.

% win_PostEvent to "Delete Rows"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId16,_)):-
	vpi::winPostEvent(Win,e_Menu(tableedit_MenuId15,c_Nothing)),
	!.
% "Delete Rows"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId15,_)):-
	tableedit_GetPossibilityDelRow(Win,P,LList), P = b_true,
	tableedit_CurWait(Win,b_true),
	_ = vpi::winSendEvent(Win,e_Menu(tableedit_MenuId17,c_Nothing)),
	tableedit_DeleteRowsSendCallback(Win,LList),
	tableedit_CurWait(Win,b_false),
	!.
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId15,_)):-
	tableedit_CurWait(Win,b_false),
	!.
% Set Marker - "grid_no_marker"
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId17,_)):-
	vpiGrid::marker(Win,grid_no_marker),
	!.
% Dialog "Find" create
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId22,_)):-
	tableedit_dlg_find_Create(Win),
	!.
% Dialog "Find" create
  tableedit_HandleEvent1(Win,e_Menu(tableedit_MenuId23,_)):-
	tableedit_GetPossibilityFindNext(Win,P), P = b_true,
	tableedit_find_Next(Win),
	!.

% Send Callback - "menu(..)" for custom items
  tableedit_HandleEvent1(Win,e_Menu(Tag,_)):-
	vpiGrid::marker(Win,M),
	not(tableedit_SendCallback(Win,menu(Tag,M))),
	!.
  tableedit_HandleEvent1(Win,e_User(6623,1)):-
	tableedit_HandleBuffAnswer(Win),
	!.
  tableedit_HandleEvent1(_,_):-!.


class predicates
    tableedit_member_index : (tableedit_columndata,tableedit_data,integer)determ anyflow.
    tableedit_member_index : (tableedit_celldata,tableedit_columndata,integer)determ anyflow.
% Get string,forecolor,backcolor from cell
    tableedit_GetGridData : (vpiDomains::windowHandle,integer Row,integer Column,string,
			vpiDomains::color Fg_Col,vpiDomains::color Bg_Col)determ anyflow.
% cell data to string,forecolor,backcolor transformation
    tableedit_CellDataToGridData : (vpiDomains::windowHandle,tableedit_celldata,integer Column,
  			string,vpiDomains::color Fg_Col,vpiDomains::color Bg_Col)determ anyflow.
% string data to cell data transformation and set it to database
    tableedit_ReplaceData : (vpiDomains::windowHandle,integer Row,integer Column,string String)procedure anyflow.
% get cell data from database
    tableedit_GetTbaleedData : (vpiDomains::windowHandle,integer Row,integer Column,tableedit_celldata)determ anyflow.
% get GRIDLIST2D format data from database
    tableedit_GetGridDataFromTo : (vpiDomains::windowHandle,integer FrRow,integer ToRow,integer FrColumn,integer ToColumn,
  	vpiGrid::list2d)determ anyflow.
% check string to validation rule
    tableedit_ChkValidation : (vpiDomains::windowHandle,integer Col,string)determ anyflow.
  tableedit_CorrectString : (vpiDomains::windowHandle,string,integer Col,string)procedure anyflow.
% send callback if cell data modified 
    tableedit_SendModifiedCallback : (vpiDomains::windowHandle,integer Row,integer Column,string NewData)determ anyflow.
    tableedit_SendDataModifiedCallback : (vpiDomains::windowHandle,core::booleanInt Possibility,integer Row,integer Column,
				     tableedit_celldata Old,tableedit_celldata New)determ anyflow.
% string data from cell to TABLEEDIT_CELLDATA transformation
    tableedit_GridDataToCellData : (vpiDomains::windowHandle,integer Column,string,tableedit_celldata Old,
  			       tableedit_celldata New)procedure anyflow.

    tableedit_CompareVoid : (tableedit_celldata,tableedit_celldata)determ anyflow.

clauses

  tableedit_SendDataModifiedCallback(Win,b_true,Row,Column,CellData,NewValue):-
	not(tableedit_CompareVoid(NewValue,CellData)),
	not(tableedit_SendCallback(Win,modified_event(Row,Column,CellData,NewValue))),
	!.
  tableedit_SendDataModifiedCallback(Win,b_false,Row,Column,CellData,NewValue):-
	not(tableedit_CompareVoid(NewValue,CellData)),
	not(NewValue = p(_,_,_)), not(CellData = p(_,_,_)),
	tableedit_UpdateUndoRedoModified(Win,modified_event(Row,Column,CellData,NewValue)),
	!.
  tableedit_SendDataModifiedCallback(_Win,b_false,_Row,_Column,_CellData,_NewValue):-
	!.

  tableedit_SendModifiedCallback(Win,Row,Column,ModStr):-
	trap(CellData = tableedit_getcelldata(Win,Row,Column), Id, clear_and_fail(Id)),
	tableedit_GridDataToCellData(Win,Column,ModStr,CellData,NewValue),!,
	not(tableedit_CompareVoid(NewValue,CellData)),
	not(tableedit_SendCallback(Win,modified_event(Row,Column,CellData,NewValue))),
	!.


  tableedit_CompareVoid(NewValue,CellData):-
	NewValue = s(""), CellData = void,!.
  tableedit_CompareVoid(NewValue,CellData):-
	NewValue = sc("",_), CellData = void,!.
  tableedit_CompareVoid(NewValue,CellData):-
	CellData = s(""), NewValue = void,!.
  tableedit_CompareVoid(NewValue,CellData):-
	CellData = sc("",_), NewValue = void,!.
  tableedit_CompareVoid(NewValue,CellData):-
	NewValue = s(""), CellData = voidc(_),!.
  tableedit_CompareVoid(NewValue,CellData):-
	NewValue = sc("",_), CellData = voidc(_),!.
  tableedit_CompareVoid(NewValue,CellData):-
	CellData = s(""), NewValue = voidc(_),!.
  tableedit_CompareVoid(NewValue,CellData):-
	CellData = sc("",_), NewValue = voidc(_),!.
  tableedit_CompareVoid(NewValue,CellData):-
	CellData = NewValue,!.
  
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_row_marker_beg(Row),
	A = row_marker_beg(Row),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_col_marker_beg(Column),
	A = col_marker_beg(Column),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_area_marker_beg(Row,Column),
	A = area_marker_beg(Row,Column),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_all_marker_beg,
	A = all_marker_beg(),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_edit_cell_beg(Row,Column),
	A = edit_cell_beg(Row,Column),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_resize_column_beg(Column),
	A = resize_column_beg(Column),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_resize_column(Column,Width),
	A = resize_column_act(Column,Width),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_hscroll_create,
	A = hscroll_create(),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_vscroll_create,
	A = vscroll_create(),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_hscroll_destroy,
	A = hscroll_destroy(),
	tableedit_SendCallback(Win,action(A)),
	!.
  tableedit_SendCallbackForAction(Win,GrinAct):-
	GrinAct = grid_vscroll_destroy,
	A = vscroll_destroy(),
	tableedit_SendCallback(Win,action(A)),
	!.
class predicates
  tableedit_ConvertSingleMarker : (vpiDomains::windowHandle,vpiGrid::marker)procedure anyflow.
clauses
  tableedit_ConvertSingleMarker(Win,_Mark):-
	vpiGrid::marker(Win,grid_no_marker),fail.
  tableedit_ConvertSingleMarker(Win,Mark):-
	vpiGrid::marker(Win,CurMar),
	CurMar = grid_no_marker,
	not(tableedit_GridCallback(Win,user_action(grid_marker_(Mark,b_true)),_)),
	vpiGrid::marker(Win,Mark),
	!.
  tableedit_ConvertSingleMarker(_Win,_Mark):-!.

% ========== Grid Callback ===========

% Control 'Y' - Redo
  tableedit_GridCallback(Win,
	event(e_Char(25,c_Control)),
	event_answer(stop)):-
		tableedit_GetPossibilityRedo(Win,P), P = b_true,
		vpiGrid::marker(Win,Marker),
		not(Marker = grid_edit_cell(_,_)),
		vpi::winPostEvent(Win,e_Menu(tableedit_MenuId21,c_Nothing)),!.
% Control 'Z' - Undo
  tableedit_GridCallback(Win,
	event(e_Char(26,c_Control)),
	event_answer(stop)):-
		tableedit_GetPossibilityUndo(Win,P), P = b_true, 
		vpiGrid::marker(Win,Marker),
		not(Marker = grid_edit_cell(_,_)),
		vpi::winPostEvent(Win,e_Menu(tableedit_MenuId20,c_Nothing)),!.

% stop on grid_all_marker_beg action
  tableedit_GridCallback(Win,
	user_action(grid_all_marker_beg),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,allmarker(b_false)),!.

% none for rowmarker
  tableedit_GridCallback(Win,
	user_action(grid_row_marker_beg(_Row)),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,rowmarker(none)),!.

% send row_marker_beg callback 
  tableedit_GridCallback(Win,
	user_action(A),
	event_answer(stop)):-
		A = grid_row_marker_beg(_Row),
		tableedit_SendCallbackForAction(Win,A),
		!.

% singular for rowmarker
  tableedit_GridCallback(Win,
	user_action(grid_row_marker_beg(Row)),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,rowmarker(singular)),
		Mark = grid_row_marker([gl(Row,Row)]),
		tableedit_ConvertSingleMarker(Win,Mark),
		!.
% singular for rowmarker
  tableedit_GridCallback(Win,
	        user_action(grid_marker_(GM,b_true)),
	        event_answer(continue)):-
		tableedit_db_Te_Info(Win,rowmarker(singular)),
		GM = grid_row_marker([gl(Row,Row1)]),
		GM1 = grid_row_marker([gl(Row,Row)]),
		not(GM1 = GM),		
		Mark = grid_row_marker([gl(Row1,Row1)]),
		tableedit_ConvertSingleMarker(Win,Mark),
		!.
% singlearea for rowmarker
  tableedit_GridCallback(Win,
	user_action(grid_row_marker_beg(_Row)),
	event_answer(continue)):-
		tableedit_db_Te_Info(Win,rowmarker(singlearea)),
		vpiGrid::marker(Win,Mark), Mark = grid_row_marker([gl(_,_)]),
		vpiGrid::marker(Win,grid_no_marker),!.

% none for colmarker
  tableedit_GridCallback(Win,
	user_action(grid_col_marker_beg(_Row)),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,colmarker(none)),!.

% send col_marker_beg callback 
  tableedit_GridCallback(Win,
	user_action(A),
	event_answer(stop)):-
		A = grid_col_marker_beg(_Col),
		tableedit_SendCallbackForAction(Win,A),
		!.

% singular for colmarker
  tableedit_GridCallback(Win,
	user_action(grid_col_marker_beg(Row)),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,colmarker(singular)),
		Mark = grid_col_marker([gl(Row,Row)]),
		tableedit_ConvertSingleMarker(Win,Mark),
		!.
% singular for colmarker
  tableedit_GridCallback(Win,
	user_action(grid_marker_(GM,b_true)),
	event_answer(continue)):-
		tableedit_db_Te_Info(Win,colmarker(singular)),
		GM = grid_col_marker([gl(Col,Col1)]),
		GM1 = grid_col_marker([gl(Col,Col)]),
		not(GM1 = GM),		
		Mark = grid_col_marker([gl(Col1,Col1)]),
		tableedit_ConvertSingleMarker(Win,Mark),
		!.

% singlearea for colmarker
  tableedit_GridCallback(Win,
	user_action(grid_col_marker_beg(_Row)),
	event_answer(continue)):-
		tableedit_db_Te_Info(Win,colmarker(singlearea)),
		vpiGrid::marker(Win,Mark), Mark = grid_col_marker([gl(_,_)]),
		vpiGrid::marker(Win,grid_no_marker),!.

% none for areamarker
  tableedit_GridCallback(Win,
	user_action(grid_area_marker_beg(_Row,_Col)),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,areamarker(none)),!.

% send area_marker_beg callback 
  tableedit_GridCallback(Win,
	user_action(A),
	event_answer(stop)):-
		A = grid_area_marker_beg(_Row,_Col),
		tableedit_SendCallbackForAction(Win,A),
		!.

% singular for areamarker
  tableedit_GridCallback(Win,
	user_action(grid_area_marker_beg(Row,Col)),
	event_answer(stop)):-
		tableedit_db_Te_Info(Win,areamarker(singular)),
		Mark = grid_area_marker([ga(Row,Row,Col,Col)]),
		tableedit_ConvertSingleMarker(Win,Mark),
		!.
% singular for areamarker
  tableedit_GridCallback(Win,
	user_action(grid_marker_(GM,b_true)),
	event_answer(continue)):-
		tableedit_db_Te_Info(Win,areamarker(singular)),
		GM = grid_area_marker([ga(Row,Row1,Col,Col1)]),
		GM1 = grid_area_marker([ga(Row,Row,Col,Col)]),
		not(GM1 = GM),		
		Mark = grid_area_marker([ga(Row1,Row1,Col1,Col1)]),
		tableedit_ConvertSingleMarker(Win,Mark),
		!.


% singlearea for areamarker
  tableedit_GridCallback(Win,
	user_action(grid_area_marker_beg(_Row,_Col)),
	event_answer(continue)):-
		tableedit_db_Te_Info(Win,areamarker(singlearea)),
		vpiGrid::marker(Win,Mark), Mark = grid_area_marker([ga(_,_,_,_)]),
		vpiGrid::marker(Win,grid_no_marker),
		!.

% stop on grid_edit_cell_beg action
  tableedit_GridCallback(Win,
	user_action(grid_edit_cell_beg(_Row,Column)),
	event_answer(stop)):-
		tableedit_db_Col_Info(Win,Column,readonly(b_true)),!.

% stop on resize column action
  tableedit_GridCallback(Win,user_action(ACTION),event_answer(stop)):-
	Action = grid_resize_column_beg(Column),
	tableedit_db_Col_Info(Win,Column,resizable(b_false)),!.

% send action callback
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_all_marker_beg, tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_edit_cell_beg(_Row,_Column), tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_resize_column_beg(_Column), tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_resize_column(_Column,_Width), tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_hscroll_create, tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_hscroll_destroy, tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_vscroll_create, tableedit_SendCallbackForAction(Win,A),!.
  tableedit_GridCallback(Win,user_action(A),event_answer(stop)):-
	A = grid_vscroll_destroy, tableedit_SendCallbackForAction(Win,A),!.

% send marker callback
  tableedit_GridCallback(Win,user_action(ACTION),event_answer(stop)):-
	Action = grid_marker_(Mark,M),
	tableedit_SendCallback(Win,marker(Mark,M)),
	!.

% edit control answer
  tableedit_GridCallback(Win,
	user_action(grid_marker_(grid_edit_cell(Row,Column),b_true)),
	event_answer(editCtrl(InitString))):-
		tableedit_db_Col_Info(Win,Column,control(edit)),
		tableedit_GetGridData(Win,Row,Column,InitString,_Fg_Col,_Bg_Col),
		!.

% listbutton control answer
  tableedit_GridCallback(Win,
	user_action(grid_marker_(grid_edit_cell(Row,Column),b_true)),
	event_answer(lBoxButton(SLIST,InitString))):-
		tableedit_db_Col_Info(Win,Column,control(listbutton(SLIST))),
		tableedit_GetGridData(Win,Row,Column,InitString,_Fg_Col,_Bg_Col),!.

% listedit control answer
  tableedit_GridCallback(Win,
	user_action(grid_marker_(grid_edit_cell(Row,Column),b_true)),
	event_answer(lBoxEdit(SLIST,InitString))):-
		tableedit_db_Col_Info(Win,Column,control(listedit(SLIST))),
		tableedit_GetGridData(Win,Row,Column,InitString,_Fg_Col,_Bg_Col),!.

% custom control answer
  tableedit_GridCallback(Win,
	user_action(grid_marker_(grid_edit_cell(Row,Column),b_true)),
	event_answer(custom_ctrl(ClassName,Flags,PutData,GetData,InitString))):-
		tableedit_db_Col_Info(Win,Column,control(CustCtrl)),
		CustCtrl = custom(ClassName,Flags,PutData,GetData),
		tableedit_GetGridData(Win,Row,Column,InitString,_Fg_Col,_Bg_Col),!.

% V Scroll Create
  tableedit_GridCallback(Win,user_action(grid_vscroll_create),event_answer(continue)):-
	assert(tableedit_db_VScroll(Win)),
	!.
% V Scroll Destroy
  tableedit_GridCallback(Win,user_action(grid_vscroll_destroy),event_answer(continue)):-
	retractAll(tableedit_db_VScroll(Win)),
	!.

  tableedit_GridCallback(Win,
	user_action(modified(_Row,Column,String)),
	event_answer(stop)):- % column type - all ; Vtext not ""
		not(tableedit_db_Col_Info(Win,Column,column_type(te_picture))),
		tableedit_db_Col_Info(Win,Column,validationtext(VText)),
		not(VText = ""),
		not(tableedit_ChkValidation(Win,Column,String)),
		!.
  tableedit_GridCallback(Win,
	user_action(modified(Row,Column,String)),
	event_answer(continue)):- % column type - string ; Vtext = ""
		tableedit_db_Col_Info(Win,Column,column_type(te_string)),
		tableedit_db_Col_Info(Win,Column,validationtext(VText)),
		VText = "",
		tableedit_CorrectString(Win,String,Column,String1),
		tableedit_ReplaceData(Win,Row,Column,String1),
		!.
  tableedit_GridCallback(Win,
	user_action(modified(_Row,Column,String)),
	event_answer(continue)):- % column type - all ; Vtext = ""
		not(tableedit_db_Col_Info(Win,Column,column_type(te_picture))),
		tableedit_db_Col_Info(Win,Column,validationtext(VText)),
		VText = "",
		not(tableedit_ChkValidation(Win,Column,String)),
		!.
  tableedit_GridCallback(Win,
	user_action(modified(Row,Column,String)),
	event_answer(continue)):-% column type - string ; Vtext - all
		tableedit_db_Col_Info(Win,Column,column_type(te_string)),
		tableedit_CorrectString(Win,String,Column,String1),
		tableedit_ReplaceData(Win,Row,Column,String1),
		!.
  tableedit_GridCallback(Win,
	user_action(modified(Row,Column,String)),
	event_answer(continue)):-
		tableedit_ReplaceData(Win,Row,Column,String),
		!.


% grid_area data request
  tableedit_GridCallback(Win,data_request(grid_area(From_Row,To_Row,From_Column,To_Column)),
	data_answer(grid_area_answer(CellList))):-
		tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
		tableedit_GetGridDataFromTo(Win,From_Row,To_Row,From_Column,To_Column,CellList),
		!.
  tableedit_GridCallback(Win,data_request(grid_area(FromRow,ToRow,FromColumn,ToColumn)),
	data_answer(empty_answer_data)):-
		tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
		assertz(tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn)),
		tableedit_SeparateAnswer(Win),
		vpi::winPostEvent(Win,e_User(6623,1)),
		!.


  tableedit_reverse([],IdList,IdList):-!.
  tableedit_reverse([Id|Rest],IL,IdList):-!,
	tableedit_reverse(Rest,[Id|IL],IdList).
  tableedit_reverse(_,_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

class predicates
    tableedit_Replace : (vpiDomains::windowHandle,integer Column,integer Row,string String,tableedit_data,tableedit_data,tableedit_data)procedure anyflow.
    tableedit_Replace1 : (vpiDomains::windowHandle,integer Column,integer Column,string String,tableedit_columndata,tableedit_columndata,tableedit_columndata)procedure anyflow.
clauses

% Replace data
  tableedit_ReplaceData(Win,Row,Column,String):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	not(tableedit_db_Col_Info(Win,Column,column_type(te_picture))),
	tableedit_SendModifiedCallback(Win,Row,Column,String),
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_Replace(Win,Column,Row,String,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),!.
  tableedit_ReplaceData(Win,Row,Column,String):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Col_Info(Win,Column,column_type(te_picture)),
	tableedit_SendModifiedCallback(Win,Row,Column,String),
	!.
  tableedit_ReplaceData(Win,Row,Column,String):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_,_,_))),
	tableedit_SendModifiedCallback(Win,Row,Column,String),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	!.
  tableedit_ReplaceData(_Win,_Row,_Column,_String):-!.

  tableedit_Replace(_Win,_,_,_,[],NewData1,NewData):-
	tableedit_reverse(NewData1,tableedit_data_empty_list,NewData),!.
  tableedit_Replace(Win,Col,1,String,[Data|Rest],ND,NewData):-!,
	tableedit_Replace1(Win,Col,Col,String,Data,[],ND1),
	tableedit_Replace(Win,Col,0,String,Rest,[ND1|ND],NewData).
  tableedit_Replace(Win,Col,Row,String,[Data|Rest],ND,NewData):-
	R = Row - 1,!,
	tableedit_Replace(Win,Col,R,String,Rest,[Data|ND],NewData).
  tableedit_Replace(_,_,_,_,_,_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_Replace1(_Win,_,_,_,[],NewData1,NewData):-
	tableedit_reverse(NewData1,tableedit_columndata_empty_list,NewData),!.
  tableedit_Replace1(Win,Col,1,String,[Data|Rest],ND,NewData):-
	tableedit_GridDataToCellData(Win,Col,String,Data,ND1),!,
	tableedit_Replace1(Win,Col,0,String,Rest,[ND1|ND],NewData).
  tableedit_Replace1(Win,Col,ColC,String,[Data|Rest],ND,NewData):-
	C = ColC - 1,!,
	tableedit_Replace1(Win,Col,C,String,Rest,[Data|ND],NewData).
  tableedit_Replace1(_,_,_,_,_,_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_GridDataToCellData(_Win,_Col,"",sc(_,C),voidc(C)):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",s(_),void):-!.
  tableedit_GridDataToCellData(Win,Col,"",void,void):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),!.
  tableedit_GridDataToCellData(Win,Col,"",voidc(C),voidc(C)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),!.
  tableedit_GridDataToCellData(_Win,_Col,String,s(_),s(String)):-!.
  tableedit_GridDataToCellData(_Win,_Col,String,sc(_,C),sc(String,C)):-!.
  tableedit_GridDataToCellData(Win,Col,String,void,s(String)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),!.
  tableedit_GridDataToCellData(Win,Col,String,voidc(C),sc(String,C)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),!.

  tableedit_GridDataToCellData(_Win,_Col,String,ic(_,C),ic(Dig,C)):-
	trap(Dig = toTerm(String), Id, clear_and_fail(Id)),!.
  tableedit_GridDataToCellData(Win,Col,String,voidc(C),ic(Dig,C)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_integer)),
	trap(Dig = toTerm(String), Id, clear_and_fail(Id)),!.
  tableedit_GridDataToCellData(Win,Col,String,_,i(Dig)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_integer)),
	trap(Dig = toTerm(String), Id, clear_and_fail(Id)),!.

  tableedit_GridDataToCellData(_Win,_Col,String,lc(_,C),lc(Dig,C)):-
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),!.
  tableedit_GridDataToCellData(Win,Col,String,voidc(C),lc(Dig,C)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_long)),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),!.
  tableedit_GridDataToCellData(Win,Col,String,_,l(Dig)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_long)),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),!.

  tableedit_GridDataToCellData(_Win,_Col,String,rc(_,C),rc(Dig,C)):-
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),!.
  tableedit_GridDataToCellData(Win,Col,String,voidc(C),rc(Dig,C)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_real)),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),!.
  tableedit_GridDataToCellData(Win,Col,String,_,r(Dig)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_real)),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),!.

  tableedit_GridDataToCellData(_Win,_Col,String,p(Pic,S,_Str),p(Pic,S,String)):-
	not(String = ""),
	!.
  tableedit_GridDataToCellData(Win,Col,String,void,p(none,b_false,String)):-
	tableedit_db_Col_Info(Win,Col,column_type(te_picture)),
	not(String = ""),
	!.
  tableedit_GridDataToCellData(Win,Col,"",_,void):-
	tableedit_db_Col_Info(Win,Col,column_type(te_picture)),
	!.

  tableedit_GridDataToCellData(_Win,_Col,"",i(_),void):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",ic(_,C),voidc(C)):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",l(_),void):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",lc(_,C),voidc(C)):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",r(_),void):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",rc(_,C),voidc(C)):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",void,void):-!.
  tableedit_GridDataToCellData(_Win,_Col,"",voidc(C),voidc(C)):-!.
  tableedit_GridDataToCellData(Win,_Col,_,X,X):-
	retractAll(tableedit_db_PasteError(Win)),
	assert(tableedit_db_PasteError(Win)),
	!.

class predicates
% VALIDATION RULE handling
% Create prompt string
    tableedit_InsertSubString : (string PromptStr,string SubStr,string InsertStr,string OutStr)procedure anyflow.
    tableedit_ChkListValidatin : (vpiDomains::windowHandle,tableedit_celldata,tableedit_rulelist)determ anyflow.
    tableedit_ChkValidation1 : (vpiDomains::windowHandle,tableedit_celldata,tableedit_rule)determ anyflow.
    tableedit_CorrectStringToValidatinList : (vpiDomains::windowHandle,string,tableedit_rulelist,string)determ anyflow.
    tableedit_ChkValidationString1 : (vpiDomains::windowHandle,string,tableedit_rule,string)determ anyflow.
    tableedit_frontstr3 : (integer Max,string StrIn,string StrOut)procedure anyflow.
clauses

  tableedit_ChkValidation(Win,Col,""):-
	not(tableedit_db_Col_Info(Win,Col,column_type(te_string))),
	tableedit_db_Col_Info(Win,Col,mandatory(b_false)),
	!.
  tableedit_ChkValidation(Win,Col,String):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),
	tableedit_db_Col_Info(Win,Col,validationrule(RuleList)),
	tableedit_db_Col_Info(Win,Col,mandatory(b_true)),
	not(String = ""),
	tableedit_ChkListValidatin(Win,s(String),RuleList),!.
  tableedit_ChkValidation(Win,Col,String):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),
	tableedit_db_Col_Info(Win,Col,validationrule(RuleList)),
	tableedit_db_Col_Info(Win,Col,mandatory(b_false)),
	tableedit_ChkListValidatin(Win,s(String),RuleList),!.
  tableedit_ChkValidation(Win,Col,String):-
	tableedit_db_Col_Info(Win,Col,column_type(te_integer)),
        hasDomain(integer, Dig),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),
	tableedit_db_Col_Info(Win,Col,validationrule(RuleList)),
	tableedit_ChkListValidatin(Win,i(Dig),RuleList),!.
  tableedit_ChkValidation(Win,Col,String):-
	tableedit_db_Col_Info(Win,Col,column_type(te_long)),
        hasDomain(core::integer32, Dig),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),
	tableedit_db_Col_Info(Win,Col,validationrule(RuleList)),
	tableedit_ChkListValidatin(Win,l(Dig),RuleList),!.
  tableedit_ChkValidation(Win,Col,String):-
	tableedit_db_Col_Info(Win,Col,column_type(te_real)),
        hasDomain(real, Dig),
	trap(Dig= toTerm(String), Id, clear_and_fail(Id)),
	tableedit_db_Col_Info(Win,Col,validationrule(RuleList)),
	tableedit_ChkListValidatin(Win,r(Dig),RuleList),!.
  tableedit_ChkValidation(Win,Col,String):-
	tableedit_db_Col_Info(Win,Col,validationtext(VText)),!,
	not(VText = ""),
	tableedit_InsertSubString(VText,"%",String,VText1), % create error messege
	vpiCommonDialogs::note(tableedit_con_noteTitle,VText1),fail.

  tableedit_InsertSubString(PromptStr,SubStr,InsertStr,OutStr):-
	OutStr = string::replace(PromptStr,SubStr,InsertStr,string::caseSensitive()), 
	!.
  tableedit_InsertSubString(PromptStr,_SubStr,_InsertStr,PromptStr).

  tableedit_ChkListValidatin(_Win,_Dig,[]):-!.
  tableedit_ChkListValidatin(Win,Dig,[L1|L2]):-!,
	tableedit_ChkValidation1(Win,Dig,L1),
	tableedit_ChkListValidatin(Win,Dig,L2).

  tableedit_ChkValidation1(_Win,i(Dig),i_min(Lim)):- Dig >= Lim,!.
  tableedit_ChkValidation1(_Win,i(Dig),i_max(Lim)):- Dig <= Lim,!.
  tableedit_ChkValidation1(_Win,l(Dig),l_min(Lim)):- Dig >= Lim,!.
  tableedit_ChkValidation1(_Win,l(Dig),l_max(Lim)):- Dig <= Lim,!.
  tableedit_ChkValidation1(_Win,r(Dig),r_min(Lim)):- Dig >= Lim,!.
  tableedit_ChkValidation1(_Win,r(Dig),r_max(Lim)):- Dig <= Lim,!.
  tableedit_ChkValidation1(_Win,s(Str),s_length(VLen)):- string::length(Str) = VLen,!.
  tableedit_ChkValidation1(_Win,s(Str),s_min(Lim)):- string::length(Str) >= Lim,!.
  tableedit_ChkValidation1(_Win,s(Str),s_max(Lim)):- string::length(Str) <= Lim,!.
  tableedit_ChkValidation1(_Win,s(_),s_upper):-!.
  tableedit_ChkValidation1(_Win,s(_),s_lower):-!.

  tableedit_CorrectString(Win,Str,Col,StrOut):-
	tableedit_db_Col_Info(Win,Col,column_type(te_string)),
	tableedit_db_Col_Info(Win,Col,validationrule(RuleList)),
	tableedit_CorrectStringToValidatinList(Win,Str,RuleList,StrOut),
	!.
  tableedit_CorrectString(_Win,Str,_Col,Str):-!.

  tableedit_CorrectStringToValidatinList(_Win,StrOut,[],StrOut):-!.
  tableedit_CorrectStringToValidatinList(Win,Str,[L1|L2],OS):-!,
	tableedit_ChkValidationString1(Win,Str,L1,Str1),
	tableedit_CorrectStringToValidatinList(Win,Str1,L2,OS).

  tableedit_ChkValidationString1(_Win,Str,s_length(VLen),Str1):- 
	Fstring = string::format("%s%ds","%-",VLen),
	StrOut = string::format(Fstring,Str),
	tableedit_frontstr3(VLen,StrOut,Str1),!.
  tableedit_ChkValidationString1(_Win,Str,s_min(VLen),Str1):- 
	Fstring = string::format("%s%ds","%-",VLen),
	Str1 = string::format(Fstring,Str),!.
  tableedit_ChkValidationString1(_Win,Str,s_max(VLen),Str1):- 
	tableedit_frontstr3(VLen,Str,Str1),!.
  tableedit_ChkValidationString1(_Win,Str,s_upper,Str1):- 
	Str1 = string::toupperCase(Str),!.
  tableedit_ChkValidationString1(_Win,Str,s_lower,Str1):- 
	Str1 = string::tolowerCase(Str),!.

  tableedit_frontstr3(Max,StrIn,StrOut):-
	string::length(StrIn)>Max,
	string::front(StrIn,Max,StrOut,_),
	!.
  tableedit_frontstr3(_,StrIn,StrIn).

  tableedit_GetGridData(Win,Row,Column,String,Fg_Col,Bg_Col):-
	tableedit_GetTbaleedData(Win,Row,Column,CellData),
	tableedit_CellDataToGridData(Win,CellData,Column,String,Fg_Col,Bg_Col),
	!.

  tableedit_GetTbaleedData(Win,Row,Column,CellData):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Data_Info(Win,Data),
	tableedit_member_index(ColumnData,Data,Row),
	tableedit_member_index(CellData,ColumnData,Column),
	!.
  tableedit_GetTbaleedData(Win,Row,Column,CellData):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_GetBuffCellData(Win,Row,Column,CellData),
	!.

class predicates
  tableedit_ReplaceString : (string Src,string Search,string Rep,string Out)procedure anyflow.
  tableedit_ReplaceString1 : (string Src,string Search,string Rep,string,string Out)procedure anyflow.
clauses

  tableedit_ReplaceString(Str1,SearchStr,Repstr,OS):-
	trap(tableedit_ReplaceString1(Str1,SearchStr,Repstr,"",OS), Id, clear_and_fail(Id)),!.
  tableedit_ReplaceString(_,_,_,""):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_ReplaceString1(Str1,SearchStr,Repstr,OurStr1,OS):-
	Pos1 = string::search(Str1,SearchStr,string::caseSensitive()),
	string::front(Str1,Pos1,STR11,STR12),
	string::front(STR12,string::length(SearchStr),_,STR22),
	OutStr3 = string::concat(OurStr1,STR11,Repstr),!,
	tableedit_ReplaceString1(STR22,SearchStr,Repstr,OutStr3,OS).
  tableedit_ReplaceString1(Str1,_SearchStr,_Repstr,OurStr1,string::concat(OurStr1,Str1)):-
	!.
  tableedit_ReplaceString1(_,_,_,_,""):-common_exception::raise_Error(classInfo, predicate_fullName()).



class predicates
    tableedit_GetGridDataFromToRow : (vpiDomains::windowHandle,integer Column,integer FrRow,integer ToRow,
	integer FrCol,integer ToCol,
  	tableedit_data,vpiGrid::list2d,vpiGrid::list2d)determ anyflow.

    tableedit_GetGridDataFromToCol : (vpiDomains::windowHandle,integer Column,
	integer FrCol,integer ToCol,
  	tableedit_columndata,vpiGrid::list,vpiGrid::list)determ anyflow.

    tableedit_ConvDataToAnswer : (vpiDomains::windowHandle,tableedit_celldata,integer Column,vpiGrid::text)procedure anyflow.

clauses

% Get answer list for grid
  tableedit_GetGridDataFromTo(Win,FrRow,ToRow,FRColumn,ToColumn,AnswerData):-
	tableedit_db_Data_Info(Win,Data),
	tableedit_GetGridDataFromToRow(Win,1,FrRow,ToRow,FRColumn,ToColumn,Data,[],AnswerData),!.

  tableedit_GetGridDataFromToRow(_Win,_Col,_FrRow,_ToRow,_FRColumn,_ToColumn,[],AData,ANewData):- 
        hasDomain(vpiGrid::list2d, L),
        L = [],
        tableedit_reverse(AData,L,ANewData),!.
  tableedit_GetGridDataFromToRow(_Win,_,_,0,_,_,_,AData,ANewData):-
        hasDomain(vpiGrid::list2d, L),
        L = [],
        tableedit_reverse(AData,L,ANewData),!.
  tableedit_GetGridDataFromToRow(Win,Column,FrRow,ToRow,FRColumn,ToColumn,[Data|Rest],AD,NewData):-
	FrRow <= 1, ToRow > 0,
	FR = FrRow - 1, TR = ToRow - 1,!,
	tableedit_GetGridDataFromToCol(Win,Column,FRColumn,ToColumn,Data,[],Answer),
	tableedit_GetGridDataFromToRow(Win,Column,FR,TR,FRColumn,ToColumn,Rest,[Answer|AD],NewData).
  tableedit_GetGridDataFromToRow(Win,Col,FrRow,ToRow,FRColumn,ToColumn,[_Data|Rest],AD,NewData):-
	FR = FrRow - 1, TR = ToRow - 1,!, 
	tableedit_GetGridDataFromToRow(Win,Col,FR,TR,FRColumn,ToColumn,Rest,AD,NewData).

  tableedit_GetGridDataFromToCol(_Win,_Col,_FrCol,_ToCol,[],AData,ANewData):-
        hasDomain(vpiGrid::list, L),
        L = [],
        tableedit_reverse(AData,L,ANewData),!.
  tableedit_GetGridDataFromToCol(Win,Column,FrCol,ToCol,[Data|Rest],AD,NewData):-
	FrCol <= 1, ToCol > 0,
	FC = FrCol - 1, TC = ToCol - 1,!,
	tableedit_ConvDataToAnswer(Win,Data,Column,Answer),
	C = Column + 1,
	tableedit_GetGridDataFromToCol(Win,C,FC,TC,Rest,[Answer|AD],NewData).
  tableedit_GetGridDataFromToCol(Win,Col,FrRow,ToRow,[_Data|Rest],AD,NewData):-
	FR = FrRow - 1, TR = ToRow - 1,!, C = Col + 1,
	tableedit_GetGridDataFromToCol(Win,C,FR,TR,Rest,AD,NewData).
	
  tableedit_ConvDataToAnswer(_Win,p(fromres(Id),Stretch,_String),_Column,picture(Pic,Stretch)):-
	trap(Pic = vpi::pictGetFromRes(Id), ErrId, clear_and_fail(ErrId)),
	!.
  tableedit_ConvDataToAnswer(_Win,p(fromfile(FilePath),Stretch,_String),_Column,picture(Pic,Stretch)):-
	trap(Pic = vpi::pictLoad(FilePath), Id, clear_and_fail(Id)),
	!.
  tableedit_ConvDataToAnswer(Win,CellData,Column,textatr(String,Fg_Col,Bg_Col)):-
	not(CellData = p(_,_,_)),
	tableedit_CellDataToGridData(Win,CellData,Column,String,Fg_Col,Bg_Col),!.
  tableedit_ConvDataToAnswer(_Win,_,_,empty_answer).

  tableedit_CellDataToGridData(_Win,p(_Pic,_Stretch,String),_Column,String,0,0):-!.
  tableedit_CellDataToGridData(Win,i(Int),Column,toString(Int),Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,backcolor(Bg_Col)),
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,ic(Int,Bg_Col),Column,toString(Int),Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,l(Long),Column,toString(Long),Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,backcolor(Bg_Col)),
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,lc(Long,Bg_Col),Column,toString(Long),Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,r(Real),Column,toString(Real),Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,backcolor(Bg_Col)),
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,rc(Real,Bg_Col),Column,toString(Real),Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,s(String),Column,String,Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,backcolor(Bg_Col)),
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,sc(String,Bg_Col),Column,String,Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,void,Column,"",Fg_Col,Bg_Col):-
	tableedit_db_Te_Info(Win,emptycolor(Bg_Col)),
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.
  tableedit_CellDataToGridData(Win,voidc(Bg_Col),Column,"",Fg_Col,Bg_Col):-
	tableedit_db_Col_Info(Win,Column,forecolor(Fg_Col)),!.

  tableedit_member_index(S,[S|_],1):-!.
  tableedit_member_index(S,[_|L],M):-
        bound(M),!,
        N = M - 1,
        tableedit_member_index(S,L,N),!.
  tableedit_member_index(S,[_|L],M):-
        tableedit_member_index(S,L,N),!,
        M = N + 1.

class predicates
    tableedit_GetDataFromToRow : (vpiDomains::windowHandle,integer Column,integer FrRow,integer ToRow,integer FrCol,integer ToCol,
  		tableedit_data,tableedit_data,tableedit_data)procedure anyflow.
    tableedit_GetDataFromToCol : (vpiDomains::windowHandle,integer Column,integer FrCol,integer ToCol,
  		tableedit_columndata,tableedit_columndata,tableedit_columndata)procedure anyflow.
    tableedit_SetDataFromToRow : (vpiDomains::windowHandle,core::booleanInt SendCallback,integer Row,integer FrRow,
			     integer ToRow,integer FrCol,integer ToCol,
			     tableedit_data,tableedit_data,tableedit_data,
			     tableedit_data)procedure anyflow.
    tableedit_SetDataFromToCol : (vpiDomains::windowHandle,core::booleanInt SendCallback,integer Row,
			     integer Column,integer FrCol,integer ToCol,
			     tableedit_columndata,tableedit_columndata,
			     tableedit_columndata,tableedit_columndata)procedure anyflow.
    tableedit_SortData : (vpiDomains::windowHandle,integer Col,tableedit_data,tableedit_data)procedure anyflow.
    tableedit_ResetColWidth : (vpiDomains::windowHandle,vpiGrid::column_list,integer Column)procedure anyflow.

clauses
% reset "column width" properties from grid
  tableedit_ResetColWidth(_Win,[],_Column):-!.
  tableedit_ResetColWidth(Win,[L1|L2],Column):-
	L1 = grid_col(_Ti,CW,_Ha,_Va,_DX,_DY,_ML),
	retract(tableedit_db_Col_Info(Win,Column,width(_))),!,
	assert(tableedit_db_Col_Info(Win,Column,width(CW))),
	Col1 = Column + 1,
	tableedit_ResetColWidth(Win,L2,Col1).
  tableedit_ResetColWidth(_,_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).
	
% sort data list
  tableedit_SortData(Win,Col,Data,OutData):-
	tableedit_db_Col_Info(Win,Col,sortmode(ascending(Ilist))),
	tableedit_db_Te_Info(Win,compare(CompareFunc)),
	tableedit_CutHeadersFooters(Win,Data,Data1,HeadData,FootData),
	tableedit_sort_data(Win,CompareFunc,b_true,[Col|Ilist],Data1,NewData),
	tableedit_InsHeadersFooters(Win,NewData,OutData,HeadData,FootData),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_SortData(Win,Col,Data,OutData):-
	tableedit_db_Col_Info(Win,Col,sortmode(descending(Ilist))),
	tableedit_db_Te_Info(Win,compare(CompareFunc)),
	tableedit_CutHeadersFooters(Win,Data,Data1,HeadData,FootData),
	tableedit_sort_data(Win,CompareFunc,b_false,[Col|Ilist],Data1,NewData),
	tableedit_InsHeadersFooters(Win,NewData,OutData,HeadData,FootData),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_SortData(_Win,_,Data,Data):-!.

% set new data
  tableedit_SetAllDataNoSort(Win,NewData):-
	not(tableedit_db_InitMode(Win)),
	retract(tableedit_db_Data_Info(Win,_Data)),
	assert(tableedit_db_Data_Info(Win,NewData)),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	trap(vpiGrid::rows(Win,MaxRows), Id1, clear_and_fail(Id1)),
	trap(vpiGrid::invalidate(Win,grid_all), Id2, clear_and_fail(Id2)),!.
  tableedit_SetAllDataNoSort(Win,NewData):-
	tableedit_db_InitMode(Win),
	retract(tableedit_db_Data_Info(Win,_Data)),
	assert(tableedit_db_Data_Info(Win,NewData)),!.
  tableedit_SetAllDataNoSort(_,_):-!.

  tableedit_GetDataFromToRow(_Win,_Col,_FrRow,_ToRow,_FRColumn,_ToColumn,[],AData,ANewData):-
        tableedit_reverse(AData,tableedit_data_empty_list,ANewData),!.
  tableedit_GetDataFromToRow(_Win,_,_,0,_,_,_,AData,ANewData):-
        tableedit_reverse(AData,tableedit_data_empty_list,ANewData),!.
  tableedit_GetDataFromToRow(Win,Column,FrRow,ToRow,FRColumn,ToColumn,[Data|Rest],AD,NewData):-
	FrRow <= 1, ToRow > 0,
	FR = FrRow - 1, TR = ToRow - 1,!,
	tableedit_GetDataFromToCol(Win,Column,FRColumn,ToColumn,Data,[],Answer),
	tableedit_GetDataFromToRow(Win,Column,FR,TR,FRColumn,ToColumn,Rest,[Answer|AD],NewData).
  tableedit_GetDataFromToRow(Win,Col,FrRow,ToRow,FRColumn,ToColumn,[_Data|Rest],AD,NewData):-
	FR = FrRow - 1, TR = ToRow - 1,!, 
	tableedit_GetDataFromToRow(Win,Col,FR,TR,FRColumn,ToColumn,Rest,AD,NewData).
  tableedit_GetDataFromToRow(_,_,_,_,_,_,_,_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_GetDataFromToCol(_Win,_Col,_FrCol,_ToCol,[],AData,ANewData):- 
        tableedit_reverse(AData,tableedit_columndata_empty_list,ANewData),!.
  tableedit_GetDataFromToCol(Win,Col,FrCol,ToCol,[Data|Rest],AD,NewData):-
	FrCol <= 1, ToCol > 0,
	FC = FrCol - 1, TC = ToCol - 1,!,
	tableedit_GetDataFromToCol(Win,Col,FC,TC,Rest,[Data|AD],NewData).
  tableedit_GetDataFromToCol(Win,Col,FrRow,ToRow,[_Data|Rest],AD,NewData):-
	FR = FrRow - 1, TR = ToRow - 1,!,
	tableedit_GetDataFromToCol(Win,Col,FR,TR,Rest,AD,NewData).
  tableedit_GetDataFromToCol(_,_,_,_,_,_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

% set new data and send "modified" callbacks on modified cells
  tableedit_SetDataSendCallback(Win,FrRow,ToRow,FRColumn,ToColumn,InData):-
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_SetDataFromToRow(Win,b_true,1,FrRow,ToRow,FRColumn,ToColumn,InData,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),
	vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,FRColumn,ToColumn)),
	!.
  tableedit_SetDataSendCallback(_,_,_,_,_,_).

  tableedit_SetDataFromToRow(_Win,_Send,_Row,_FrRow,_ToRow,_FRColumn,_ToColumn,_InData,[],AData,ANewData):- 
        tableedit_reverse(AData,tableedit_data_empty_list,ANewData),!.
  tableedit_SetDataFromToRow(Win,Send,Row,FrRow,ToRow,FRColumn,ToColumn,[InData|InRest],[Data|Rest],AD,NewData):-
	FrRow <= 1, ToRow > 0,
	FR = FrRow - 1, TR = ToRow - 1,!,
	tableedit_SetDataFromToCol(Win,Send,Row,1,FRColumn,ToColumn,InData,Data,[],NewOutData),
	Row1 = Row + 1,
	tableedit_SetDataFromToRow(Win,Send,Row1,FR,TR,FRColumn,ToColumn,InRest,Rest,[NewOutData|AD],NewData).
  tableedit_SetDataFromToRow(Win,Send,Row,FrRow,ToRow,FRColumn,ToColumn,InD,[Data|Rest],AD,NewData):-
	FR = FrRow - 1, TR = ToRow - 1,Row1 = Row + 1,!, 
	tableedit_SetDataFromToRow(Win,Send,Row1,FR,TR,FRColumn,ToColumn,InD,Rest,[Data|AD],NewData).
  tableedit_SetDataFromToRow(_,_,_,_,_,_,_,_,_,_,[]):-
        common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_SetDataFromToCol(_Win,_Send,_Row,_Col,_FrCol,_ToCol,_InData,[],AData,ANewData):-
        tableedit_reverse(AData,tableedit_columndata_empty_list,ANewData),!.
  tableedit_SetDataFromToCol(Win,Send,Row,Col,FrCol,ToCol,[InData|InRest],[Data|Rest],AD,NewData):-
	FrCol <= 1, ToCol > 0,
	tableedit_SendDataModifiedCallback(Win,Send,Row,Col,Data,InData),
	FC = FrCol - 1, TC = ToCol - 1, Col1 = Col + 1,!,
	tableedit_SetDataFromToCol(Win,Send,Row,Col1,FC,TC,InRest,Rest,[InData|AD],NewData).
  tableedit_SetDataFromToCol(Win,Send,Row,Col,FrCol,ToCol,[_InData|InRest],[Data|Rest],AD,NewData):-
	FrCol <= 1, ToCol > 0,
	FC = FrCol - 1, TC = ToCol - 1, Col1 = Col + 1,!,
	tableedit_SetDataFromToCol(Win,Send,Row,Col1,FC,TC,InRest,Rest,[Data|AD],NewData).
  tableedit_SetDataFromToCol(Win,Send,Row,Col,FrRow,ToRow,InD,[Data|Rest],AD,NewData):-
	FR = FrRow - 1, TR = ToRow - 1, Col1 = Col + 1,!,
	tableedit_SetDataFromToCol(Win,Send,Row,Col1,FR,TR,InD,Rest,[Data|AD],NewData).
  tableedit_SetDataFromToCol(_,_,_,_,_,_,_,_,_,[]):- common_exception::raise_Error(classInfo, predicate_fullName()).


class predicates
% create N rows containing void data
    tableedit_CreateVoidRow : (vpiDomains::windowHandle,integer,tableedit_columndata,tableedit_columndata)procedure anyflow.
    tableedit_ChkNotLineListForDel : (vpiGrid::lineList,integer Row)determ anyflow.
    tableedit_ChkLineForDel : (vpiGrid::line,integer Row)determ anyflow.
    tableedit_DelRows : (vpiDomains::windowHandle,core::booleanInt SendCallback,vpiGrid::lineList)procedure anyflow.
    tableedit_CutReverseLineListRows : (vpiDomains::windowHandle,core::booleanInt SendCallback,integer Row,vpiGrid::lineList,
			    tableedit_data,tableedit_data,tableedit_data,
			    tableedit_data,tableedit_data)procedure anyflow. 
   tableedit_SendDelCallback : (vpiDomains::windowHandle,integer Row,tableedit_columndata Data,core::booleanInt SendCallback)determ anyflow.

clauses
% fail if the line list contains Row 
  tableedit_ChkNotLineListForDel([],_Row):-!.
  tableedit_ChkNotLineListForDel([L1|L2],Row):-!,
	tableedit_ChkLineForDel(L1,Row),
	tableedit_ChkNotLineListForDel(L2,Row).

  tableedit_ChkLineForDel(Line,Row):- 
	Line = gl(FromRow,ToRow), Row >= FromRow, Row <= ToRow,!,fail.
  tableedit_ChkLineForDel(_,_):-!.

  tableedit_DeleteRowsSendCallback(Win,LList):-
	tableedit_DelRows(Win,b_true,LList),
	tableedit_db_Data_Info(Win,NewData),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	vpiGrid::rows(Win,MaxRows),!.
  tableedit_DeleteRowsSendCallback(_,_).
class predicates
  tableedit_DelBuffRows : (vpiDomains::windowHandle,core::booleanInt,integer MaxRows,vpiGrid::lineList)procedure anyflow.
clauses

  tableedit_DelRows(Win,Send,LList):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Data_Info(Win,Data),
	tableedit_reverse(Data,tableedit_data_empty_list,ReverseData),
	tableedit_CalcMaxRows(Win,Data,MaxRows),
	tableedit_CutReverseLineListRows(Win,Send,MaxRows,LList,ReverseData,[],NewData,[],_CND),
	retract(tableedit_db_Data_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,NewData)),!.
  tableedit_DelRows(Win,Send,LList):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,MaxRows))),
 	tableedit_DelBuffRows(Win,Send,MaxRows,LList),
	tableedit_BuffInvalidate(Win),
	!.
  tableedit_DelRows(_,_,_).

  tableedit_DelBuffRows(_Win,_Send,0,_LList):-!.
  tableedit_DelBuffRows(Win,Send,Row,LList):-
	not(tableedit_ChkNotLineListForDel(LList,Row)),
	FromRow = Row, ToRow = Row, FromColumn = 1, ToColumn = tableedit_maxcol(Win),
	Data1 = tableedit_getdata(Win,FromRow,ToRow,FromColumn,ToColumn),
	Data1 = [Data],
	tableedit_SendDelCallback(Win,Row,Data,Send),
	R = Row - 1,!,
	tableedit_DelBuffRows(Win,Send,R,LList).
  tableedit_DelBuffRows(Win,Send,Row,LList):-!,
	R = Row - 1,!,
	tableedit_DelBuffRows(Win,Send,R,LList).


  tableedit_CutReverseLineListRows(_Win,_Send,_Row,_LList,[],AData,AData,CutData,CutData):- !.
  tableedit_CutReverseLineListRows(Win,Send,Row,LList,[Data|Rest],AD,NewData,CD,CND):- 
	not(tableedit_ChkNotLineListForDel(LList,Row)),
	tableedit_SendDelCallback(Win,Row,Data,Send),
	R = Row - 1,!,
	tableedit_CutReverseLineListRows(Win,Send,R,LList,Rest,AD,NewData,[Data|CD],CND).
  tableedit_CutReverseLineListRows(Win,Send,Row,LList,[Data|Rest],AD,NewData,CD,CND):- 
	R = Row - 1,!, 
	tableedit_CutReverseLineListRows(Win,Send,R,LList,Rest,[Data|AD],NewData,CD,CND).
  tableedit_CutReverseLineListRows(_,_,_,_,_,_,[],_,[]):- common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_SendDelCallback(Win,Row,Data,b_true):-
	not(tableedit_SendCallback(Win,delete_row(Row,Data))),!.
  tableedit_SendDelCallback(Win,Row,Data,b_false):-
	tableedit_UpdateUndoRedoModified(Win,delete_row(Row,Data)),!.

  tableedit_CutListRows(_Win,_FrRow,_ToRow,[],AData,ANewData,CutData,CutNewData):- 
	tableedit_reverse(AData,tableedit_data_empty_list,ANewData),
	tableedit_reverse(CutData,tableedit_data_empty_list,CutNewData),!.
  tableedit_CutListRows(Win,FrRow,ToRow,[Data|Rest],AD,NewData,CD,CND):- 
	FrRow <= 1, ToRow > 0,
	FR = FrRow - 1, TR = ToRow - 1,!,
	tableedit_CutListRows(Win,FR,TR,Rest,AD,NewData,[Data|CD],CND).
  tableedit_CutListRows(Win,FrRow,ToRow,[Data|Rest],AD,NewData,CD,CND):- 
	FR = FrRow - 1, TR = ToRow - 1,!, 
	tableedit_CutListRows(Win,FR,TR,Rest,[Data|AD],NewData,CD,CND).

  tableedit_InsRows(Win,Row,InsData):-
	InsData = [InsD],
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	not(tableedit_SendCallback(Win,insert_row(Row,InsD))),
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_InsListRows(Win,Row,InsData,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	vpiGrid::rows(Win,MaxRows),
	!.
  tableedit_InsRows(Win,Row,InsData):-
	InsData = [InsD],
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	not(tableedit_SendCallback(Win,insert_row(Row,InsD))),
	tableedit_BuffInvalidate(Win),
	!.

  tableedit_InsDefRowZ(Win):-
	tableedit_db_Data_Info(Win,Data),
	tableedit_db_Te_Info(Win,footers(F)),
	tableedit_CalcMaxRows(Win,Data,MaxRows),
	Row = MaxRows - F + 1,
	tableedit_InsDefRow(Win,Row),
	tableedit_db_Data_Info(Win,NewData),
	tableedit_CalcMaxRows(Win,NewData,NewMax),
	not(NewMax = MaxRows),
	vpiGrid::rows(Win,NewMax),
	!.
  tableedit_InsDefRowZ(_Win):-!.

  tableedit_InsDefRow(Win,Row):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_CreateDefRow(Win,1,[],DefData),
	not(tableedit_SendCallback(Win,insert_row(Row,DefData))),
	retract(tableedit_db_Data_Info(Win,Data)), DD = [DefData],
	tableedit_InsListRows(Win,Row,DD,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),!.
  tableedit_InsDefRow(Win,Row):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_CreateDefRow(Win,1,[],DefData),
	not(tableedit_SendCallback(Win,insert_row(Row,DefData))),
	!.
  tableedit_InsDefRow(_Win,_Row):-!.

  tableedit_CreateVoidRows(_Win,Col,AData,AData):- Col <= 0,!. 
  tableedit_CreateVoidRows(Win,Col,AData,ANewData):- 
	C = Col - 1,
	tableedit_CreateVoidRow(Win,1,[],RowData),!,
	tableedit_CreateVoidRows(Win,C,[RowData|AData],ANewData). 


  tableedit_CreateVoidRow(Win,Col,AData,AData):- 
	not(tableedit_db_Col_Info(Win,Col,_)),!.
  tableedit_CreateVoidRow(Win,Col,Data,ND):-!,
	NextCol = Col + 1,
	tableedit_CreateVoidRow(Win,NextCol,[void|Data],ND).

class predicates
    tableedit_CreateDefRows : (vpiDomains::windowHandle,integer Nrows,tableedit_columndata DefData,
  	tableedit_data Data,tableedit_data NewData)procedure anyflow.
    tableedit_SaveInsDataForUndo : (vpiDomains::windowHandle,integer Row,tableedit_data)procedure anyflow.
clauses

  tableedit_CreateDefRows(_Win,Nrows,_DefData,Data,Data):- Nrows <= 0,!.
  tableedit_CreateDefRows(Win,Nrows,DefData,AData,ANewData):-!,
	R = Nrows - 1,
  	tableedit_CreateDefRows(Win,R,DefData,[DefData|AData],ANewData).

  tableedit_SaveInsDataForUndo(_,_,[]):-!.
  tableedit_SaveInsDataForUndo(Win,Row,[L1|L2]):-!,
	tableedit_UpdateUndoRedoModified(Win,insert_row(Row,L1)),
	R = Row + 1,
	tableedit_SaveInsDataForUndo(Win,R,L2).
  tableedit_SaveInsDataForUndo(_,_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_CreateDefRow(Win,Col,AData,ANewData):- 
	not(tableedit_db_Col_Info(Win,Col,_)),
	tableedit_reverse(AData,tableedit_columndata_empty_list,ANewData),!.
  tableedit_CreateDefRow(Win,Col,Data,ND):-
	tableedit_db_Col_Info(Win,Col,defaultvalue(DefVal)),!,
	NextCol = Col + 1,
	tableedit_CreateDefRow(Win,NextCol,[DefVal|Data],ND).

  tableedit_InsListRows(_Win,_FrRow,[],[],AData,ANewData):- 
        tableedit_reverse(AData,tableedit_data_empty_list,ANewData),!.
  tableedit_InsListRows(Win,FrRow,[Data1|Rest1],Data2,AD,NewData):- 
	FrRow <= 1,
	FR = FrRow - 1,!,
	tableedit_InsListRows(Win,FR,Rest1,Data2,[Data1|AD],NewData).
  tableedit_InsListRows(Win,FrRow,Data1,[Data2|Rest2],AD,NewData):- 
	FR = FrRow - 1,!, 
	tableedit_InsListRows(Win,FR,Data1,Rest2,[Data2|AD],NewData).

class predicates
   tableedit_ConvertDataToString : (tableedit_celldata,string String)procedure anyflow.
clauses
  tableedit_ConvertDataToString(p(_Pic,_Stretch,String),String):-!.
  tableedit_ConvertDataToString(i(Int),toString(Int)):-
	!.
  tableedit_ConvertDataToString(ic(Int,_Bg_Col),toString(Int)):-
	!.
  tableedit_ConvertDataToString(l(Long),toString(Long)):-
        !.
  tableedit_ConvertDataToString(lc(Long,_Bg_Col),toString(Long)):-
	!.
  tableedit_ConvertDataToString(r(Real),toString(Real)):-
	!.
  tableedit_ConvertDataToString(rc(Real,_Bg_Col),toString(Real)):-
	!.
  tableedit_ConvertDataToString(s(String),OString):-
	tableedit_ReplaceString(String,"\t"," ",OString1),
	tableedit_ReplaceString(OString1,"\r"," ",OString2),
	tableedit_ReplaceString(OString2,"\n"," ",OString),
	!.
  tableedit_ConvertDataToString(sc(String,_Bg_Col),OString):-
	tableedit_ReplaceString(String,"\t"," ",OString1),
	tableedit_ReplaceString(OString1,"\r"," ",OString2),
	tableedit_ReplaceString(OString2,"\n"," ",OString),
	!.
  tableedit_ConvertDataToString(void,""):-!.
  tableedit_ConvertDataToString(voidc(_Bg_Col),""):-!.
  tableedit_ConvertDataToString(_,""):-
	common_exception::raise_Error(classInfo, predicate_fullName()).


% Create clipboard format string from table editor data
class predicates
  tableedit_CreateStringRowsData : (tableedit_data,string OutString)procedure anyflow.
  tableedit_CreateStringRowsData1 : (tableedit_data)procedure anyflow.
  tableedit_CreateStringColumnData : (tableedit_columndata,string OutString)procedure anyflow.
  tableedit_retract : (string)procedure anyflow.
clauses


  tableedit_CreateStringRowsData(Data,OutString):-
	retractall(tableedit_str_buffer(_)),
	assert(tableedit_str_buffer("")),
	tableedit_CreateStringRowsData1(Data),
	retract(tableedit_str_buffer(OutString)),!.
  tableedit_CreateStringRowsData(_,""):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_retract(String):-
	retract(tableedit_str_buffer(String)),!.
  tableedit_retract(""):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_CreateStringRowsData1([Data|[]]):-
	tableedit_CreateStringColumnData(Data,OutStrX),
	tableedit_retract(TmpString),
	assert(tableedit_str_buffer(string::concat(TmpString,OutStrX))),!.
  tableedit_CreateStringRowsData1([Data|_]):-
	tableedit_CreateStringColumnData(Data,OutStrX),
	tableedit_retract(TmpString),
	assert(tableedit_str_buffer(string::concat(TmpString,OutStrX,"\r\n"))),
	fail.
  tableedit_CreateStringRowsData1([_|Rest]):-!,
	tableedit_CreateStringRowsData1(Rest).
  tableedit_CreateStringRowsData1(_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_CreateStringColumnData([],""):-!.
  tableedit_CreateStringColumnData([CellData|[]],OutStr):-
	tableedit_ConvertDataToString(CellData,OutStr),!.
  tableedit_CreateStringColumnData([CellData|Rest],OutStr):-
	tableedit_ConvertDataToString(CellData,Cell),
	tableedit_CreateStringColumnData(Rest,RestStr),!,
	OutStr = string::concat(Cell,"\t",RestStr).
  tableedit_CreateStringColumnData(_,""):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

class predicates
    tableedit_frontstr : (unsigned,string,string,string)procedure anyflow.
    tableedit_searchstring : (string,string,unsigned)procedure anyflow.

    tableedit_SetStrDataFromToRow : (vpiDomains::windowHandle,core::booleanInt SendCallback,integer FrRow,
		integer Row,integer FrPastLimit,integer ToPasteLimit,integer FrCol,integer ToCol,
		string SourceStr,tableedit_data,tableedit_data,tableedit_data,integer,integer NunmberToSetFromClipboard)determ anyflow.

    tableedit_SplitString : (vpiDomains::windowHandle,core::booleanInt SendCallback,integer Row,integer Col,
		integer FrCol,integer ToCol,string SourceStr,
		tableedit_columndata,tableedit_columndata,tableedit_columndata)determ anyflow.

    tableedit_CutTabString : (string,string,string)procedure anyflow.
    tableedit_CliarString : (string,string)procedure anyflow.

  
clauses

  tableedit_ChkClipBoardStr(Win,AML,SourceStr,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	AML = [ga(FrRow,ToRow,FrCol,ToCol)],
	retractAll(tableedit_db_PasteError(Win)),
	tableedit_db_Data_Info(Win,Data),
	assert(tableedit_db_UndoAction(Win)),
	tableedit_SetStrDataFromToRow(Win,b_false,FrRow,1,1,ToRow,FrCol,ToCol,SourceStr,Data,[],_NewData,0,_NSet),
	retractAll(tableedit_db_UndoAction(Win)),
	not(tableedit_db_PasteError(Win)),
	!.
  tableedit_ChkClipBoardStr(Win,AML,SourceStr,b_true):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	AML = [ga(FrRow,ToRow,FrCol,ToCol)],
	retractAll(tableedit_db_PasteError(Win)),
	assert(tableedit_db_UndoAction(Win)),
	Col = tableedit_maxcol(Win),
	Data = tableedit_getdata(Win,FrRow,ToRow,1,Col),
	tableedit_SetStrDataFromToRow(Win,b_false,1,FrRow,FrRow,ToRow,FrCol,ToCol,SourceStr,Data,[],_NewData,0,_NSet),
	retractAll(tableedit_db_UndoAction(Win)),
	not(tableedit_db_PasteError(Win)),
	!.
  tableedit_ChkClipBoardStr(_Win,_AML,_SourceStr,b_false):-!.

  tableedit_SetRowDataSendCallback(Win,AML,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	AML = [ga(FrRow,ToRow,FrCol,ToCol)],
	retractAll(tableedit_db_PasteError(Win)),
	tableedit_db_Data_Info(Win,Data),
	tableedit_SetStrDataFromToRow(Win,b_true,FrRow,1,1,ToRow,FrCol,ToCol,SourceStr,Data,[],NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	retract(tableedit_db_Data_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,NewData)),
	vpiGrid::invalidate(Win,grid_all),!.
  tableedit_SetRowDataSendCallback(Win,AML,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	AML = [ga(FrRow,ToRow,FrCol,ToCol)],
	retractAll(tableedit_db_PasteError(Win)),
	Col = tableedit_maxcol(Win),
	Data = tableedit_getdata(Win,FrRow,ToRow,1,Col),
	tableedit_SetStrDataFromToRow(Win,b_true,1,FrRow,FrRow,ToRow,FrCol,ToCol,SourceStr,Data,[],_NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,FrCol,ToCol)),!.
  tableedit_SetRowDataSendCallback(_,_,_):-!.

  tableedit_frontstr(LenStart,SourceStr,StartStr,EndString):-
	string::front(SourceStr,LenStart,StartStr,EndString),!.
  tableedit_frontstr(_,SourceStr,SourceStr,""):- string::length(SourceStr) > 0,!.
  tableedit_frontstr(_,"","",""):-!.

  tableedit_searchstring(SourceStr,SearchStr,Pos):-Pos = 1+string::search(SourceStr,SearchStr,string::caseSensitive()),!.
  tableedit_searchstring(SourceStr,_SearchStr,Pos):-Pos =string::length(SourceStr) + 1,!.


  tableedit_SetStrDataFromToRow(_Win,_Send,_FrRow,_Row,_FP,_TP,_FrCol,_ToCol,_Str,[],AData,ANewData,NSet,NSet):-
        tableedit_reverse(AData,tableedit_data_empty_list,ANewData),!.
  tableedit_SetStrDataFromToRow(Win,Send,FrRow,Row,FP,TP,FrCol,ToCol,SourceStr,[Data|Rest],AD,NewData,NSet1,NS):-
	FrRow <= 1, 
	FR = FrRow - 1, Row1 = Row + 1, Row >= FP, Row <= TP,!,
	tableedit_searchstring(SourceStr,"\n",Pos),
	tableedit_frontstr(Pos,SourceStr,StartStr,EndString),
	tableedit_SplitString(Win,Send,Row,1,FrCol,ToCol,StartStr,Data,[],NewOutData), NSet2 = NSet1 + 1,
	tableedit_SetStrDataFromToRow(Win,Send,FR,Row1,FP,TP,FrCol,ToCol,EndString,Rest,[NewOutData|AD],NewData,NSet2,NS).
  tableedit_SetStrDataFromToRow(Win,Send,FrRow,Row,FP,TP,FrCol,ToCol,InD,[Data|Rest],AD,NewData,NS1,NS2):-
	FR = FrRow - 1, Row1 = Row + 1,!, 
	tableedit_SetStrDataFromToRow(Win,Send,FR,Row1,FP,TP,FrCol,ToCol,InD,Rest,[Data|AD],NewData,NS1,NS2).

  tableedit_SplitString(_Win,_Send,_Row,_Col,_FrCol,_ToCol,_,[],AData,ANewData):- 
        tableedit_reverse(AData,tableedit_columndata_empty_list,ANewData),!.
  tableedit_SplitString(Win,Send,Row,Col,FrCol,ToCol,SourceStr,[Data|Rest],AD,NewData):-
	tableedit_CutTabString(SourceStr,StartStr,EndStr),
	tableedit_CliarString(StartStr,DataStr),
	Col >= FrCol, Col <= ToCol,
	tableedit_GridDataToCellData(Win,Col,DataStr,Data,NewOutData),
	tableedit_SendDataModifiedCallback(Win,Send,Row,Col,Data,NewOutData),!,
	C = Col + 1,
	tableedit_SplitString(Win,Send,Row,C,FrCol,ToCol,EndStr,Rest,[NewOutData|AD],NewData).
  tableedit_SplitString(Win,Send,Row,Col,FrCol,ToCol,SourceStr,[Data|Rest],AD,NewData):-
	tableedit_CutTabString(SourceStr,StartStr,EndStr),
	tableedit_CliarString(StartStr,DataStr),
	Col >= FrCol, Col <= ToCol,
	!,
	tableedit_GridDataToCellData(Win,Col,DataStr,Data,_NewOutData),
	C = Col + 1,
	tableedit_SplitString(Win,Send,Row,C,FrCol,ToCol,EndStr,Rest,[Data|AD],NewData).
  tableedit_SplitString(Win,Send,Row,Col,FrCol,ToCol,SourceStr,[Data|Rest],AD,NewData):-!,
	EndStr = SourceStr,
	C = Col + 1,
	tableedit_SplitString(Win,Send,Row,C,FrCol,ToCol,EndStr,Rest,[Data|AD],NewData).

  tableedit_CutTabString(SourceStr,StartStr,EndString):-
	tableedit_searchstring(SourceStr,"\t",Pos),
	tableedit_frontstr(Pos,SourceStr,StartStr,EndString),
	!.
  tableedit_CutTabString(SourceStr,SourceStr,"").

class predicates
   tableedit_CliarString1 : (string StartStr,string DataStr)procedure anyflow.

clauses
  tableedit_CliarString(StartStr,DataStr):-
	tableedit_CliarString1(StartStr,S1),
	tableedit_CliarString1(S1,S2),
	tableedit_CliarString1(S2,DataStr),!.

  tableedit_CliarString1(StartStr,DataStr):-
        "\r" = tryGetLastChar(StartStr,DataStr),!.
  tableedit_CliarString1(StartStr,DataStr):-
        "\t" = tryGetLastChar(StartStr,DataStr),!.
  tableedit_CliarString1(StartStr,DataStr):-
        "\n" = tryGetLastChar(StartStr,DataStr),!.
  tableedit_CliarString1(StartStr,StartStr):-!.

    class predicates
        tryGetLastChar : (string In,string Start) -> string LastChar determ (i,o).
    clauses
  	tryGetLastChar(In,Start) = LastChar:-
  		Len = string::length(In),
  		Len >= 1, %check
  		string::front(In, Len - 1,Start,LastChar).

class predicates
% cut the data according to the list of filters
    tableedit_CutFilterRows : (vpiDomains::windowHandle,tableedit_orfilterlist,tableedit_orfilterlist,integer Columnm,
		tableedit_data,tableedit_data,tableedit_data,tableedit_data,tableedit_data)procedure anyflow.
   tableedit_CutColumnsFilterRows : (vpiDomains::windowHandle,tableedit_data,tableedit_data,integer Column,integer MaxColumn,
		tableedit_data,tableedit_data)determ anyflow.
    tableedit_CliarFilters : (vpiDomains::windowHandle)procedure anyflow.
   tableedit_SetFilters : (vpiDomains::windowHandle,tableedit_filters)determ anyflow.
    tableedit_SeparateFilters : (vpiDomains::windowHandle,tableedit_orfilterlist,tableedit_orfilterlist,
		tableedit_orfilterlist,tableedit_orfilterlist,tableedit_orfilterlist)procedure anyflow.

clauses
% assert empty filter for columns
  tableedit_CliarFilters(Win):-
	tableedit_db_Col_Info(Win,Column,title(_)),
	assert(tableedit_db_Col_Info(Win,Column,filterlist([]))),
	fail.
  tableedit_CliarFilters(_Win):-!.

% Set filters from filter list
  tableedit_SetFilters(Win,[]):- 
	tableedit_ProcessFilter(Win),
	!.
  tableedit_SetFilters(Win,[L1|L2]):-
	L1 = columnfilter(Column,FilterList),
	retract(tableedit_db_Col_Info(Win,Column,filterlist(_))),
	assert(tableedit_db_Col_Info(Win,Column,filterlist(FilterList))),!,
	tableedit_SetFilters(Win,L2).

% filter handling
  tableedit_ProcessFilter(Win):-
	tableedit_db_ShadowData_Info(Win,ShadowData),
	tableedit_db_Data_Info(Win,Data),
	tableedit_CutHeadersFooters(Win,Data,Data1,HeadData,FootData),
	tableedit_InsListRows(Win,0,ShadowData,Data1,[],OutData1),
	trap(MaxColumn = tableedit_maxcol(Win), Id, clear_and_fail(Id)),
	tableedit_CutColumnsFilterRows(Win,OutData1,[],1,MaxColumn,ShadowData1,VisibleData1),
	tableedit_InsHeadersFooters(Win,VisibleData1,NewOutData,HeadData,FootData),
	tableedit_SetAllDataNoSort(Win,NewOutData),
	retractAll(tableedit_db_ShadowData_Info(Win,_)),
	assert(tableedit_db_ShadowData_Info(Win,ShadowData1)),
	!.
  
  tableedit_CutColumnsFilterRows(_Win,VisibleData,ShadowData,Column,MaxColumn,ShadowData,VisibleData):- Column > MaxColumn,!.
  tableedit_CutColumnsFilterRows(Win,Data,ShadowData,Column,MaxColumn,SH,VD):-
	tableedit_db_Col_Info(Win,Column,filterlist(FilterList)),!,
	NextCol = Column + 1,
	tableedit_SeparateFilters(Win,FilterList,[],[],FL,NF),
	tableedit_CutFilterRows(Win,FL,NF,Column,Data,[],ShadowData1,[],VisibleData),
	tableedit_InsListRows(Win,0,ShadowData,ShadowData1,[],ShadowData2),
	tableedit_CutColumnsFilterRows(Win,VisibleData,ShadowData2,NextCol,MaxColumn,SH,VD).

class predicates
% check data for filters
   tableedit_ChkCellDataForFilter : (vpiDomains::windowHandle,tableedit_celldata,tableedit_orfilter)determ anyflow.
   tableedit_ChkCellDataForFilterList : (vpiDomains::windowHandle,tableedit_celldata,tableedit_orfilterlist,tableedit_orfilterlist)determ anyflow.
   tableedit_ChkCellDataForNotFilter : (vpiDomains::windowHandle,tableedit_celldata,tableedit_orfilter)determ anyflow.
   tableedit_ChkCellDataForNotFilterList : (vpiDomains::windowHandle,tableedit_celldata,tableedit_orfilterlist)determ anyflow.
   tableedit_ChkNotFilters : (vpiDomains::windowHandle,tableedit_orfilter)determ anyflow.
clauses

  tableedit_CutFilterRows(_Win,_FilterList,_NotFilterList,_Column,[],AData,ANewData,CutData,CutNewData):- 
	tableedit_reverse(AData,tableedit_data_empty_list,ANewData),
	tableedit_reverse(CutData,tableedit_data_empty_list,CutNewData),!.
  tableedit_CutFilterRows(Win,FilterList,NotFilterList,Column,[Data|Rest],AD,NewData,CD,CND):-
	tableedit_member_index(CellData,Data,Column),
	tableedit_ChkCellDataForFilterList(Win,CellData,FilterList,FilterList),
	not(tableedit_ChkCellDataForNotFilterList(Win,CellData,NotFilterList)),!,
	tableedit_CutFilterRows(Win,FilterList,NotFilterList,Column,Rest,AD,NewData,[Data|CD],CND).
  tableedit_CutFilterRows(Win,FilterList,NotFilterList,Column,[Data|Rest],AD,NewData,CD,CND):- !, 
	tableedit_CutFilterRows(Win,FilterList,NotFilterList,Column,Rest,[Data|AD],NewData,CD,CND).
  tableedit_CutFilterRows(_,_,_,_,_,_,[],_,[]):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_ChkCellDataForFilterList(_Win,_Val,[],[]):-!.
  tableedit_ChkCellDataForFilterList(Win,Val,[L1|_L2],_):-
	tableedit_ChkCellDataForFilter(Win,Val,L1),!.
  tableedit_ChkCellDataForFilterList(Win,Val,[_L1|L2],Fl):-!,
	tableedit_ChkCellDataForFilterList(Win,Val,L2,Fl).

  tableedit_ChkCellDataForNotFilterList(_Win,_Val,[]):-!,fail.
  tableedit_ChkCellDataForNotFilterList(Win,Val,[L1|_L2]):-
	tableedit_ChkCellDataForNotFilter(Win,Val,L1),!.
  tableedit_ChkCellDataForNotFilterList(Win,Val,[_L1|L2]):-!,
	tableedit_ChkCellDataForNotFilterList(Win,Val,L2).

  tableedit_SeparateFilters(_Win,[],F,NF,F,NF):-!.
  tableedit_SeparateFilters(Win,[L1|L2],F,NF,FX,NFX):-
	not(tableedit_ChkNotFilters(Win,L1)),
	F1 = [L1|F],!,
	tableedit_SeparateFilters(Win,L2,F1,NF,FX,NFX).
  tableedit_SeparateFilters(Win,[L1|L2],F,NF,FX,NFX):-
	F1 = [L1|NF],!,
	tableedit_SeparateFilters(Win,L2,F,F1,FX,NFX).
  tableedit_SeparateFilters(_,_,_,_,[],[]):-common_exception::raise_Error(classInfo, predicate_fullName()).


  tableedit_ChkNotFilters(_Win,if_not(_)):-!.
  tableedit_ChkNotFilters(_Win,rf_not(_)):-!.
  tableedit_ChkNotFilters(_Win,lf_not(_)):-!.
  tableedit_ChkNotFilters(_Win,s_f_not(_)):-!.
  tableedit_ChkNotFilters(_Win,fvoid_not):-!.

  tableedit_ChkCellDataForFilter(_Win,i(Val),if_min(Min)):- Val >= Min,!.
  tableedit_ChkCellDataForFilter(_Win,i(Val),if_max(Max)):- Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,i(Val),if_range(Min,Max)):- Val >= Min, Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,ic(Val,_),if_min(Min)):- Val >= Min,!.
  tableedit_ChkCellDataForFilter(_Win,ic(Val,_),if_max(Max)):- Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,ic(Val,_),if_range(Min,Max)):- Val >= Min, Val <= Max,!.

  tableedit_ChkCellDataForFilter(_Win,l(Val),lf_min(Min)):- Val >= Min,!.
  tableedit_ChkCellDataForFilter(_Win,l(Val),lf_max(Max)):- Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,l(Val),lf_range(Min,Max)):- Val >= Min, Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,lc(Val,_),lf_min(Min)):- Val >= Min,!.
  tableedit_ChkCellDataForFilter(_Win,lc(Val,_),lf_max(Max)):- Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,lc(Val,_),lf_range(Min,Max)):- Val >= Min, Val <= Max,!.

  tableedit_ChkCellDataForFilter(_Win,r(Val),rf_min(Min)):- Val >= Min,!.
  tableedit_ChkCellDataForFilter(_Win,r(Val),rf_max(Max)):- Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,r(Val),rf_range(Min,Max)):- Val >= Min, Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,rc(Val,_),rf_min(Min)):- Val >= Min,!.
  tableedit_ChkCellDataForFilter(_Win,rc(Val,_),rf_max(Max)):- Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,rc(Val,_),rf_range(Min,Max)):- Val >= Min, Val <= Max,!.
  tableedit_ChkCellDataForFilter(_Win,s(Val),s_f(Str)):- Val = Str,!.
  tableedit_ChkCellDataForFilter(_Win,p(_,_,Val),s_f(Str)):- Val = Str,!.
  tableedit_ChkCellDataForFilter(_Win,sc(Val,_),s_f(Str)):- Val = Str,!.
  tableedit_ChkCellDataForFilter(_Win,void,s_f("")):-!.
  tableedit_ChkCellDataForFilter(_Win,voidc(_),s_f("")):-!.

  tableedit_ChkCellDataForFilter(_Win,s(""),fvoid):-!.
  tableedit_ChkCellDataForFilter(_Win,p(_,_,""),fvoid):-!.
  tableedit_ChkCellDataForFilter(_Win,sc("",_),fvoid):-!.
  tableedit_ChkCellDataForFilter(_Win,void,fvoid):-!.
  tableedit_ChkCellDataForFilter(_Win,voidc(_),fvoid):-!.

  tableedit_ChkCellDataForNotFilter(_Win,i(Val),if_not(EVal)):- Val = EVal,!.
  tableedit_ChkCellDataForNotFilter(_Win,ic(Val,_),if_not(EVal)):- Val = EVal,!.

  tableedit_ChkCellDataForNotFilter(_Win,l(Val),lf_not(EVal)):- Val = EVal,!.
  tableedit_ChkCellDataForNotFilter(_Win,lc(Val,_),lf_not(EVal)):- Val = EVal,!.

  tableedit_ChkCellDataForNotFilter(_Win,r(Val),rf_not(EVal)):- Val = EVal,!.
  tableedit_ChkCellDataForNotFilter(_Win,rc(Val,_),rf_not(EVal)):- Val = EVal,!.

  tableedit_ChkCellDataForNotFilter(_Win,s(Val),s_f_not(EVal)):- Val = EVal,!.
  tableedit_ChkCellDataForNotFilter(_Win,p(_,_,Val),s_f_not(EVal)):- Val = EVal,!.
  tableedit_ChkCellDataForNotFilter(_Win,sc(Val,_),s_f_not(EVal)):- Val = EVal,!.
  tableedit_ChkCellDataForNotFilter(_Win,void,s_f_not(EVal)):- EVal = "",!.
  tableedit_ChkCellDataForNotFilter(_Win,voidc(_),s_f_not(EVal)):- EVal = "",!.

  tableedit_ChkCellDataForNotFilter(_Win,Val,fvoid_not):- Val = void,!.
  tableedit_ChkCellDataForNotFilter(_Win,Val,fvoid_not):- Val = voidc(_),!.
  tableedit_ChkCellDataForNotFilter(_Win,Val,fvoid_not):- Val = s(""),!.
  tableedit_ChkCellDataForNotFilter(_Win,Val,fvoid_not):- Val = p(_,_,""),!.
  tableedit_ChkCellDataForNotFilter(_Win,Val,fvoid_not):- Val = sc("",_),!.

% ============  Sort operations =============

class predicates
  tableedit_convert_p : (tableedit_celldata,string)determ anyflow.
clauses
  tableedit_convert_p(p(_,_,Val),Val):-!.
class predicates
  tableedit_convert_s : (tableedit_celldata,string)determ anyflow.
clauses
  tableedit_convert_s(s(Val),Val):-!.
  tableedit_convert_s(sc(Val,_),Val):-!.
class predicates
  tableedit_convert_i : (tableedit_celldata,integer)determ anyflow.
clauses
  tableedit_convert_i(i(Val),Val):-!.
  tableedit_convert_i(ic(Val,_),Val):-!.
class predicates
  tableedit_convert_l : (tableedit_celldata,core::integer32)determ anyflow.
clauses
  tableedit_convert_l(l(Val),Val):-!.
  tableedit_convert_l(lc(Val,_),Val):-!.
class predicates
  tableedit_convert_r : (tableedit_celldata,real)determ anyflow.
clauses
  tableedit_convert_r(r(Val),Val):-!.
  tableedit_convert_r(rc(Val,_),Val):-!.

  tableedit_CompareInternal(_,_,_,_,_):-fail.

class predicates
   tableed_convert_answer : (core::booleanInt Ascending,tableedit_comparestatus,tableedit_comparestatus)determ anyflow.
clauses
  tableed_convert_answer(_,equal,equal):-!.
  tableed_convert_answer(b_true,Answer,Answer):-!.
  tableed_convert_answer(b_false,less,more):-!.
  tableed_convert_answer(b_false,more,less):-!.

class predicates
   tableed_compare1 : (tableedit_compare,vpiDomains::windowHandle,integer Column,core::booleanInt Ascending,tableedit_celldata,tableedit_celldata,tableedit_comparestatus Answer)procedure anyflow.
clauses
  tableed_compare1(CallBack,Win,Column,Ascending,First,Second,Answer):-
	CallBack(Win,Column,First,Second,Answer1),
	tableed_convert_answer(Ascending,Answer1,Answer),!.
  tableed_compare1(_,_,_,_,CD1,CD2,equal):-
	tableedit_convert_s(CD1,CD11),
	tableedit_convert_s(CD2,CD21),
	CD11 = CD21,!.
  tableed_compare1(_,_,_,_,CD1,CD2,equal):-
	tableedit_convert_p(CD1,CD11),
	tableedit_convert_p(CD2,CD21),
	CD11 = CD21,!.
  tableed_compare1(_,_,_,_,CD1,CD2,equal):-
	tableedit_convert_i(CD1,CD11),
	tableedit_convert_i(CD2,CD21),
	CD11 = CD21,!.
  tableed_compare1(_,_,_,_,CD1,CD2,equal):-
	tableedit_convert_l(CD1,CD11),
	tableedit_convert_l(CD2,CD21),
	CD11 = CD21,!.
  tableed_compare1(_,_,_,_,CD1,CD2,equal):-
	tableedit_convert_r(CD1,CD11),
	tableedit_convert_r(CD2,CD21),
	CD11 = CD21,!.
  tableed_compare1(_,_,_,b_true,CD1,CD2,less):-
	tableedit_convert_s(CD1,CD11),
	tableedit_convert_s(CD2,CD21),
	CD11 < CD21,!.
  tableed_compare1(_,_,_,b_true,CD1,CD2,less):-
	tableedit_convert_p(CD1,CD11),
	tableedit_convert_p(CD2,CD21),
	CD11 < CD21,!.
  tableed_compare1(_,_,_,b_true,CD1,CD2,less):-
	tableedit_convert_i(CD1,CD11),
	tableedit_convert_i(CD2,CD21),
	CD11 < CD21,!.
  tableed_compare1(_,_,_,b_true,CD1,CD2,less):-
	tableedit_convert_l(CD1,CD11),
	tableedit_convert_l(CD2,CD21),
	CD11 < CD21,!.
  tableed_compare1(_,_,_,b_true,CD1,CD2,less):-
	tableedit_convert_r(CD1,CD11),
	tableedit_convert_r(CD2,CD21),
	CD11 < CD21,!.
  tableed_compare1(_,_,_,b_false,CD1,CD2,less):-
	tableedit_convert_s(CD1,CD11),
	tableedit_convert_s(CD2,CD21),
	CD11 > CD21,!.
  tableed_compare1(_,_,_,b_false,CD1,CD2,less):-
	tableedit_convert_p(CD1,CD11),
	tableedit_convert_p(CD2,CD21),
	CD11 > CD21,!.
  tableed_compare1(_,_,_,b_false,CD1,CD2,less):-
	tableedit_convert_i(CD1,CD11),
	tableedit_convert_i(CD2,CD21),
	CD11 > CD21,!.
  tableed_compare1(_,_,_,b_false,CD1,CD2,less):-
	tableedit_convert_l(CD1,CD11),
	tableedit_convert_l(CD2,CD21),
	CD11 > CD21,!.
  tableed_compare1(_,_,_,b_false,CD1,CD2,less):-
	tableedit_convert_r(CD1,CD11),
	tableedit_convert_r(CD2,CD21),
	CD11 > CD21,!.
  tableed_compare1(_,_,_,_,_,_,more).

class predicates
   tableed_compare_list : (tableedit_compare,vpiDomains::windowHandle,integer Column,core::booleanInt Ascendig,core::integer_list ColumnNumber,tableedit_columndata,tableedit_columndata,tableedit_columndata,tableedit_columndata)determ anyflow.
   tableed_compare : (tableedit_compare,vpiDomains::windowHandle,tableedit_comparestatus Answer,core::booleanInt A,core::integer_list CR,tableedit_columndata CDF1,tableedit_columndata CDF2)determ anyflow.
clauses
  tableed_compare_list(_,_,_,_,[],_,_,_,_):-!.
  tableed_compare_list(CallBack,Win,Column,A,[1|CR],CDF1,CDF2,[CD1|_],[CD2|_]):-
	tableed_compare1(CallBack,Win,Column,A,CD1,CD2,Answer),!,
	tableed_compare(CallBack,Win,Answer,A,CR,CDF1,CDF2),!.
  tableed_compare_list(CallBack,Win,Column,A,[CN|CR],CDF1,CDF2,[_|CR1],[_|CR2]):-
	CN1 = CN - 1,!,
	tableed_compare_list(CallBack,Win,Column,A,[CN1|CR],CDF1,CDF2,CR1,CR2).

  tableed_compare(CallBack,Win,equal,A,[Column|Rest],CDF1,CDF2):-
	tableed_compare_list(CallBack,Win,Column,A,[Column|Rest],CDF1,CDF2,CDF1,CDF2),!.
  tableed_compare(_,_,less,_,_,_,_).

class predicates
   tableed_sort_list2d2 : (tableedit_compare,vpiDomains::windowHandle,core::booleanInt Ascending,core::integer_list ColumnNumber,tableedit_columndata A,tableedit_data Input,core::booleanInt Rev,tableedit_data,tableedit_data Output)determ anyflow.
clauses
  tableed_sort_list2d2(_,_,_,_,_,Output,b_true,[],Output):-!.
  tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,B,Curr,b_true,[A|Rest],Output):-!,
	tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,B,[A|Curr],b_true,Rest,Output).
  tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,A,[],b_false,Curr,Output):-!,
	tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,A,[A],b_true,Curr,Output).
  tableed_sort_list2d2(CallBack,Win,Ascending,[Column|ColumnRest],A,[B|Rest],b_false,Curr,Output):-
	tableed_compare_list(CallBack,Win,Column,Ascending,[Column|ColumnRest],A,B,A,B),!,
	tableed_sort_list2d2(CallBack,Win,Ascending,[Column|ColumnRest],A,[A,B|Rest],b_true,Curr,Output).
  tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,A,[B|Rest],Rev,Curr,Output):-!,
	tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,A,Rest,Rev,[B|Curr],Output).

class predicates
   tableed_sort_list2d1 : (
        tableedit_compare,
        vpiDomains::windowHandle,
        core::booleanInt Ascending,
        core::integer_list ColumnNumber) procedure.
clauses
    tableed_sort_list2d1(CallBack,Win,Ascending,ColumnNumber):-
        retract(input_sort_data_fact(A)),
	tableed_sort_list2d2(CallBack,Win,Ascending,ColumnNumber,A,output_sort_data_fact,b_false,[],Curr1),
        output_sort_data_fact := Curr1,
	fail.
    tableed_sort_list2d1(_,_,_,_).

  tableedit_sort_data(_,_,_,_,[],[]):-!.
  tableedit_sort_data(_,_,_,_,[A|[]],[A]):-!.
  tableedit_sort_data(Win,CompareFunc,Ascending,ColumnNumber,Input,Output):-
        retractall(input_sort_data_fact(_)),
        assert_input_sort_data_fact(Input),
        output_sort_data_fact := [],
	tableed_sort_list2d1(CompareFunc,Win,Ascending,ColumnNumber),
	Output = output_sort_data_fact,
        output_sort_data_fact := [].

class facts
    input_sort_data_fact : (tableedit_columndata) nondeterm.
    output_sort_data_fact : tableedit_data := [].

class predicates
    assert_input_sort_data_fact : (tableedit_data) procedure (i).
clauses
    assert_input_sort_data_fact([]).
    assert_input_sort_data_fact([X|Input]):-
        assert(input_sort_data_fact(X)),
        assert_input_sort_data_fact(Input).


constants
    tableedit_data_empty_list : tableedit_data = [].
    tableedit_columndata_empty_list : tableedit_columndata = [].

% ============ Find operations ===========
class predicates
 tableedit_FindString : (vpiDomains::windowHandle,string,tableedit_direction,integer Column,tableedit_match,core::booleanInt CaseSensitive,integer RowPos)determ anyflow.
 tableedit_FindRow : (tableedit_match,core::booleanInt CaseSensitive,string FindStr,tableedit_data DataString,integer,integer RowPosition)determ anyflow.
 tableedit_GetStringData : (vpiDomains::windowHandle,string,tableedit_direction,integer Column,tableedit_match,core::booleanInt,integer Position)determ anyflow.
clauses

  tableedit_FindString(Win,Str,Direction,Column,Match,CaseSens,RowPosition):-
	not(Column = 0),
	MaxCol = tableedit_maxcol(Win),
	Column <= MaxCol,
	tableedit_GetStringData(Win,Str,Direction,Column,Match,CaseSens,RowPosition),
	!.

  tableedit_GetStringData(Win,Str,alldown,Column,Match,CaseSens,RowPosition):-
	ToRow = tableedit_maxvisiblerows(Win),
	not(ToRow = 0),
	TEData = tableedit_getdata(Win,1,ToRow,Column,Column),
	tableedit_FindRow(Match,CaseSens,Str,TEData,1,RowPosition),
	!.
  tableedit_GetStringData(Win,Str,down,Column,Match,CaseSens,RowPosition):-
	ToRow = tableedit_maxvisiblerows(Win),
	not(ToRow = 0),
	ActRow = tableedit_getactiverow(Win),
	ActRow <= ToRow, ActRow > 0,
	TEData = tableedit_getdata(Win,ActRow,ToRow,Column,Column),
	tableedit_FindRow(Match,CaseSens,Str,TEData,1,RowPosition1),
	RowPosition = RowPosition1 + ActRow - 1,
	!.
  tableedit_GetStringData(Win,Str,up,Column,Match,CaseSens,RowPosition):-
	ToRow = tableedit_maxvisiblerows(Win),
	not(ToRow = 0),
	ActRow = tableedit_getactiverow(Win),
	ActRow <= ToRow, ActRow > 0,
	TEDataX = tableedit_getdata(Win,1,ActRow,Column,Column),
	tableedit_reverse(TEDataX,tableedit_data_empty_list,TEData),
	tableedit_FindRow(Match,CaseSens,Str,TEData,1,RowPosition1),
	RowPosition = ActRow - RowPosition1 + 1,
	!.
  tableedit_GetStringData(Win,Str,allup,Column,Match,CaseSens,RowPosition):-
	ToRow = tableedit_maxvisiblerows(Win),
	not(ToRow = 0),
	TEDataX = tableedit_getdata(Win,1,ToRow,Column,Column),
	tableedit_reverse(TEDataX,tableedit_data_empty_list,TEData),
	tableedit_FindRow(Match,CaseSens,Str,TEData,1,RowPosition1),
	RowPosition = ToRow - RowPosition1 + 1,
	!.

  tableedit_FindRow(_,_,_,[],_,_):-!,fail.
  tableedit_FindRow(from_start,b_true,Str,[[Data]|_],Pos,Pos):-
	tableedit_ConvertDataToString(Data,String),
	0 = string::search(String,Str,string::casesensitive()),
	!.
  tableedit_FindRow(from_start,b_false,Str,[[Data]|_],Pos,Pos):-
	tableedit_ConvertDataToString(Data,String),
	0 = string::search(String,Str,string::caseInsensitive()),
	!.
  tableedit_FindRow(any_part,b_true,Str,[[Data]|_],Pos,Pos):-
	tableedit_ConvertDataToString(Data,String),
	_ = string::search(String,Str,string::casesensitive()),
	!.
  tableedit_FindRow(any_part,b_false,Str,[[Data]|_],Pos,Pos):-
	tableedit_ConvertDataToString(Data,String),
	_ = string::search(String,Str,string::caseInsensitive()),!.
  tableedit_FindRow(entire,b_true,Str,[[Data]|_],Pos,Pos):-
	tableedit_ConvertDataToString(Data,String),
	String = Str,!.
  tableedit_FindRow(entire,b_false,Str,[[Data]|_],Pos,Pos):-
	tableedit_ConvertDataToString(Data,String),
	string::equalIgnoreCase(Str,String),
	!.
  tableedit_FindRow(Where,CaseSent,Str,[_|Rest],P,Pos):-
	NewP = P + 1,!,
	tableedit_FindRow(Where,CaseSent,Str,Rest,NewP,Pos).

%BEGIN_DLG Find
/**************************************************************************
	Creation and event handling for dialog: Find
**************************************************************************/
class predicates

  dlg_find_eh : vpiDomains::ehandler.
  tableedit_SetFindParam : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)procedure anyflow.
  tableedit_ReSetFindParam : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)determ anyflow.
  tableedit_SetStartFindParam : (vpiDomains::windowHandle TabWin)procedure anyflow.  
  tableedit_GetFindString : (vpiDomains::windowHandle TabWin,string)procedure anyflow.
  tableedit_GetFindColumn : (vpiDomains::windowHandle TabWin,integer Column)procedure anyflow.
clauses

  tableedit_GetFindString(TabWin,Str):-
	M = tableedit_getmarker(TabWin),
	M = grid_area_marker([ga(R1,R2,C1,C2)]),
	R1 = R2, C1 = C2,
	Str = tableedit_getclipboarddata(TabWin,R1,R2,C1,C2),
	!.
  tableedit_GetFindString(TabWin,Str):-
	tableedit_db_FindParam(TabWin,Str,_,_,_,_),
	!.
  tableedit_GetFindString(_TabWin,""):-!.

  tableedit_GetFindColumn(TabWin,C1):-
	M = tableedit_getmarker(TabWin),
	M = grid_area_marker([ga(R1,R2,C1,C2)]),
	R1 = R2, C1 = C2,
	!.
  tableedit_GetFindColumn(TabWin,C1):-
	M = tableedit_getmarker(TabWin),
	M = grid_col_marker([gl(C1,C2)]),
	C1 = C2,
	!.
  tableedit_GetFindColumn(TabWin,C1):-
	tableedit_db_FindParam(TabWin,_,_,C1,_,_),
	!.
  tableedit_GetFindColumn(_TabWin,1):-!.

  tableedit_SetStartFindParam(TabWin):-  
	not(tableedit_db_FindParam(TabWin,_,_,_,_,_)),
	tableedit_GetFindString(TabWin,Str),
	tableedit_GetFindColumn(TabWin,Column),
	retractAll(tableedit_db_FindParam(TabWin,_,_,_,_,_)),
	assert(tableedit_db_FindParam(TabWin,Str,alldown,Column,entire,b_false)),
	!.
  tableedit_SetStartFindParam(TabWin):-  
	tableedit_db_FindParam(TabWin,_,D,_,M,CS),
	tableedit_GetFindString(TabWin,Str),
	tableedit_GetFindColumn(TabWin,Column),
	retractAll(tableedit_db_FindParam(TabWin,_,_,_,_,_)),
	assert(tableedit_db_FindParam(TabWin,Str,D,Column,M,CS)),
	!.
  tableedit_SetStartFindParam(_TabWin):-common_exception::raise_Error(classInfo, predicate_fullName()).

class predicates
  tableedit_SetTitles : (vpiDomains::windowHandle TabWin,vpiDomains::windowHandle CtrlWin,integer,integer,integer MaxColumn)procedure anyflow.
clauses
  tableedit_SetTitles(_TabWin,_CtrlWin,_DlgItem,Col,MaxCol):-Col>MaxCol,!.
  tableedit_SetTitles(TabWin,CtrlWin,DlgItem1,Col1,MaxCol):-
	CProp = tableedit_getcolumnproperties(TabWin,Col1),
	tableedit_member(width(W),CProp), not(W = 0),
	tableedit_member(title(TitleStr),CProp),!,
	vpi::lboxAdd(CtrlWin,TitleStr),
	assert(tableedit_db_FindDlgParam(TabWin,Col1,DlgItem1)),
	Col2 = Col1 + 1,
	DlgItem2 = DlgItem1 + 1,
	tableedit_SetTitles(TabWin,CtrlWin,DlgItem2,Col2,MaxCol).
  tableedit_SetTitles(TabWin,CtrlWin,DlgItem,Col1,MaxCol):-
	Col2 = Col1 + 1,!,
	tableedit_SetTitles(TabWin,CtrlWin,DlgItem,Col2,MaxCol).
  tableedit_SetTitles(_,_,_,_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).
class predicates
  tableedit_GetDirection : (tableedit_direction,vpiDomains::winlist,vpiDomains::winlist,vpiDomains::winlist)determ anyflow.
  tableedit_GetMatchWin : (tableedit_match,vpiDomains::winlist,vpiDomains::windowHandle)determ anyflow.
clauses

  tableedit_GetDirection(allup,[W1,_W2],[W3,_W4],[W1,W3]):-!.
  tableedit_GetDirection(alldown,[W1,_W2],[_W3,W4],[W1,W4]):-!.
  tableedit_GetDirection(up,[_W1,W2],[W3,_W4],[W2,W3]):-!.
  tableedit_GetDirection(down,[_W1,W2],[_W3,W4],[W2,W4]):-!.

  tableedit_GetMatchWin(from_start,[W1,_W2,_W3],W1):-!.
  tableedit_GetMatchWin(entire,[_W1,W2,_W3],W2):-!.
  tableedit_GetMatchWin(any_part,[_W1,_W2,W3],W3):-!.

class predicates
 tableedit_ReSetFindStr : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)procedure anyflow.
 tableedit_ReSetFindColumn : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)determ anyflow.
 tableedit_ReSetFindCase : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)procedure anyflow.
 tableedit_ReSetFindDirection : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)procedure anyflow.
 tableedit_ReSetFindMatch : (vpiDomains::windowHandle DlgWin,vpiDomains::windowHandle TabWin)procedure anyflow.
clauses

  tableedit_ReSetFindStr(DlgWin,TabWin):-
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_findstr),
	Str = vpi::winGetText(CtrlWin),
	retract(tableedit_db_FindParam(TabWin,_,Direct,Column,Match,CaseSens)),
	assert(tableedit_db_FindParam(TabWin,Str,Direct,Column,Match,CaseSens)),
	!.
  tableedit_ReSetFindStr(_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_ReSetFindColumn(DlgWin,TabWin):-
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_findcolumn),
	vpi::lboxGetSel(CtrlWin,_,SelList), SelList = [Sel],
	tableedit_db_FindDlgParam(TabWin,Column,Sel),
	retract(tableedit_db_FindParam(TabWin,Str,Direct,_,Match,CaseSens)),
	assert(tableedit_db_FindParam(TabWin,Str,Direct,Column,Match,CaseSens)),
	!.

  tableedit_ReSetFindCase(DlgWin,TabWin):-
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_Casesensitive),
	CheckState = vpi::winIsChecked(CtrlWin),
	CaseSens = CheckState, %convert(core::booleanInt,
	retract(tableedit_db_FindParam(TabWin,Str,Direct,Column,Match,_)),
	assert(tableedit_db_FindParam(TabWin,Str,Direct,Column,Match,CaseSens)),
	!.
  tableedit_ReSetFindCase(_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

class predicates
 tableedit_GetCheckWins2 : (vpiDomains::winlist,vpiDomains::windowHandle)determ anyflow.
 tableedit_GetCheckWins3 : (vpiDomains::winlist,vpiDomains::windowHandle)determ anyflow.
clauses

  tableedit_ReSetFindDirection(DlgWin,TabWin):-
	CtrlWin1 = vpi::winGetCtlHandle(DlgWin,con_rb_entire),
	CtrlWin2 = vpi::winGetCtlHandle(DlgWin,con_rb_from),
	CtrlWin3 = vpi::winGetCtlHandle(DlgWin,con_rb_backward),
	CtrlWin4 = vpi::winGetCtlHandle(DlgWin,con_rb_forward),
	WinL1 = [CtrlWin1,CtrlWin2],
	WinL2 = [CtrlWin3,CtrlWin4],
	tableedit_GetCheckWins2(WinL1,CWin1),
	tableedit_GetCheckWins2(WinL2,CWin2),
	tableedit_GetDirection(Direction,WinL1,WinL2,[CWin1,CWin2]),
	retract(tableedit_db_FindParam(TabWin,Str,_,Column,Match,CaseSens)),
	assert(tableedit_db_FindParam(TabWin,Str,Direction,Column,Match,CaseSens)),
	!.
  tableedit_ReSetFindDirection(_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_GetCheckWins2([W1,_W2],W1):- CheckState = vpi::winIsChecked(W1), CheckState = checkbox_on,!.
  tableedit_GetCheckWins2([_W1,W2],W2):- CheckState = vpi::winIsChecked(W2), CheckState = checkbox_on,!.

  tableedit_GetCheckWins3([W1,_W2,_W3],W1):- CheckState = vpi::winIsChecked(W1), CheckState = checkbox_on,!.
  tableedit_GetCheckWins3([_W1,W2,_W3],W2):- CheckState = vpi::winIsChecked(W2), CheckState = checkbox_on,!.
  tableedit_GetCheckWins3([_W1,_W2,W3],W3):- CheckState = vpi::winIsChecked(W3), CheckState = checkbox_on,!.

  tableedit_ReSetFindMatch(DlgWin,TabWin):-
	CtrlWin1 = vpi::winGetCtlHandle(DlgWin,con_fromstart),
	CtrlWin2 = vpi::winGetCtlHandle(DlgWin,con_entirestring),
	CtrlWin3 = vpi::winGetCtlHandle(DlgWin,con_anypart),
	WinL = [CtrlWin1,CtrlWin2,CtrlWin3],
	tableedit_GetCheckWins3(WinL,CWin),
	tableedit_GetMatchWin(Match,WinL,CWin),
	retract(tableedit_db_FindParam(TabWin,Str,Direction,Column,_,CaseSens)),
	assert(tableedit_db_FindParam(TabWin,Str,Direction,Column,Match,CaseSens)),
	!.
  tableedit_ReSetFindMatch(_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).
	
  tableedit_ReSetFindParam(DlgWin,TabWin):-
	tableedit_ReSetFindStr(DlgWin,TabWin),
	tableedit_ReSetFindColumn(DlgWin,TabWin),
	tableedit_ReSetFindCase(DlgWin,TabWin),
	tableedit_ReSetFindDirection(DlgWin,TabWin),
	tableedit_ReSetFindMatch(DlgWin,TabWin),
	!.
  tableedit_ReSetFindParam(_,_):-
	vpiCommonDialogs::note(tableedit_con_find,tableedit_con_ColumnNote),
	!,fail.

  tableedit_SetFindParam(DlgWin,TabWin):-
	tableedit_db_FindParam(TabWin,Str,_,_,_,_),
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_findstr),
	vpi::winSetText(CtrlWin,Str),
	fail.
  tableedit_SetFindParam(DlgWin,TabWin):-
	tableedit_db_FindParam(TabWin,_,_,Column,_,_),
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_findcolumn),
	MaxCol = tableedit_maxcol(TabWin),
	retractAll(tableedit_db_FindDlgParam(TabWin,_,_)),
	tableedit_SetTitles(TabWin,CtrlWin,0,1,MaxCol),
	tableedit_db_FindDlgParam(TabWin,Column,Sel),
	vpi::lboxSetSel(CtrlWin,Sel,b_true),
	fail.
  tableedit_SetFindParam(DlgWin,TabWin):-
	tableedit_db_FindParam(TabWin,_,_,_,_,CaseSensitive),
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_Casesensitive),
	Check = CaseSensitive, %convert(integer,
	vpi::winCheck(CtrlWin,Check),
	fail.
  tableedit_SetFindParam(DlgWin,TabWin):-
	tableedit_db_FindParam(TabWin,_,Direction,_,_,_),
	CtrlWin1 = vpi::winGetCtlHandle(DlgWin,con_rb_entire),
	CtrlWin2 = vpi::winGetCtlHandle(DlgWin,con_rb_from),
	CtrlWin3 = vpi::winGetCtlHandle(DlgWin,con_rb_backward),
	CtrlWin4 = vpi::winGetCtlHandle(DlgWin,con_rb_forward),
	WinL1 = [CtrlWin1,CtrlWin2],
	WinL2 = [CtrlWin3,CtrlWin4],
	tableedit_GetDirection(Direction,WinL1,WinL2,[CWin1,CWin2]),
	vpi::winCheckRadioButton(CWin1,WinL1),
	vpi::winCheckRadioButton(CWin2,WinL2),
	fail.
  tableedit_SetFindParam(DlgWin,TabWin):-
	tableedit_db_FindParam(TabWin,_,_,_,Match,_),
	CtrlWin1 = vpi::winGetCtlHandle(DlgWin,con_fromstart),
	CtrlWin2 = vpi::winGetCtlHandle(DlgWin,con_entirestring),
	CtrlWin3 = vpi::winGetCtlHandle(DlgWin,con_anypart),
	WinL = [CtrlWin1,CtrlWin2,CtrlWin3],
	tableedit_GetMatchWin(Match,WinL,CtrlWin),
	vpi::winCheckRadioButton(CtrlWin,WinL),
	fail.
  tableedit_SetFindParam(_,_):-!.
class predicates
  tableedit_HandleFind : (vpiDomains::windowHandle TabWin)procedure anyflow.
  tableedit_CheckPermisionMarker : (vpiDomains::windowHandle TabWin,integer Row,integer Column)procedure anyflow.
clauses
  tableedit_HandleFind(TabWin):-
	tableedit_db_FindParam(TabWin,Str,Direction,Column,Match,CaseSens),
	tableedit_SendCallback(TabWin,find(Str,Direction,Column,Match,CaseSens,b_false)),
	!.
  tableedit_HandleFind(TabWin):-
	tableedit_db_Te_Info(TabWin,bufferingmode(nobuffering)),
	tableedit_db_FindParam(TabWin,Str,Direction,Column,Match,CaseSens),
	Row = tableedit_find(TabWin,Str,Direction,Column,Match,CaseSens),
	tableedit_setactiverow(TabWin,Row),
	tableedit_CheckPermisionMarker(TabWin,Row,Column),
	!.
  tableedit_HandleFind(TabWin):-
	tableedit_db_Te_Info(TabWin,bufferingmode(nobuffering)),
	tableedit_db_FindParam(TabWin,_Str,_Direction,_Column,_Match,_CaseSens),
	vpiCommonDialogs::note(tableedit_con_find,tableedit_con_Notfind),
	!.
  tableedit_HandleFind(_):-!.

  tableedit_CheckPermisionMarker(TabWin,Row,Column):-
	not(tableedit_db_Te_Info(TabWin,areamarker(none))),
	not(tableedit_SendCallback(TabWin,action(area_marker_beg(Row,Column)))),
	not(tableedit_SendCallback(TabWin,marker(grid_area_marker([ga(Row,Row,Column,Column)]),1))),
	tableedit_setmarker(TabWin,grid_area_marker([ga(Row,Row,Column,Column)])),
	!.
  tableedit_CheckPermisionMarker(TabWin,_Row,_Column):-
	tableedit_setmarker(TabWin,grid_no_marker),
	!. 

class predicates
  tableedit_GetNewNextDirecton : (tableedit_direction,tableedit_direction,integer Row,integer NewRow)procedure anyflow.
clauses

  tableedit_GetNewNextDirecton(alldown,down,Row,NewRow):-NewRow = Row + 1,!.
  tableedit_GetNewNextDirecton(allup,up,Row,NewRow):-NewRow = Row - 1,!.
  tableedit_GetNewNextDirecton(down,down,Row,NewRow):-NewRow = Row + 1,!.
  tableedit_GetNewNextDirecton(up,up,Row,NewRow):-NewRow = Row - 1,!.
  tableedit_GetNewNextDirecton(D,D,Row,Row):-common_exception::raise_Error(classInfo, predicate_fullName()).
	
  tableedit_find_Next(TabWin):-
	tableedit_db_FindParam(TabWin,Str,Direction,Column,Match,CaseSens),
	tableedit_db_FindDlgParam(TabWin,Column,_),
	tableedit_GetNewNextDirecton(Direction,NewDirection,1,_),
	tableedit_SendCallback(TabWin,find(Str,NewDirection,Column,Match,CaseSens,b_true)),
	!.
  tableedit_find_Next(TabWin):-
	tableedit_db_Te_Info(TabWin,bufferingmode(nobuffering)),
	tableedit_db_FindParam(TabWin,Str,Direction,Column,Match,CaseSens),
	tableedit_db_FindDlgParam(TabWin,Column,_),
	trap(vpi::winSetFocus(TabWin), Id, clear_and_fail(Id)),
	Row = tableedit_getactiverow(TabWin),
	tableedit_GetNewNextDirecton(Direction,NewDirection,Row,NextRow),
	MaxVisibleRow = tableedit_maxvisiblerows(TabWin),
	NextRow <= MaxVisibleRow, NextRow > 0,
	tableedit_setactiverow(TabWin,NextRow),
	FindRow = tableedit_find(TabWin,Str,NewDirection,Column,Match,CaseSens),
	tableedit_setactiverow(TabWin,FindRow),
	tableedit_CheckPermisionMarker(TabWin,FindRow,Column),
	!.
  tableedit_find_Next(TabWin):-
	tableedit_db_Te_Info(TabWin,bufferingmode(nobuffering)),
	tableedit_db_FindParam(TabWin,_Str,_Direction,Column,_Match,_CaseSens),
	tableedit_db_FindDlgParam(TabWin,Column,_),
	trap(vpi::winSetFocus(TabWin), Id, clear_and_fail(Id)),
	vpiCommonDialogs::note(tableedit_con_find,tableedit_con_Notfind),
	!.
  tableedit_find_Next(TabWin):-
	tableedit_db_Te_Info(TabWin,bufferingmode(nobuffering)),
	tableedit_db_FindParam(TabWin,_Str,_Direction,Column,_Match,_CaseSens),
	not(tableedit_db_FindDlgParam(TabWin,Column,_)),
	trap(vpi::winSetFocus(TabWin), Id, clear_and_fail(Id)),
	vpiCommonDialogs::note(tableedit_con_find,tableedit_con_ColumnNote),
	!.
  tableedit_find_Next(_):-!.
		
  tableedit_dlg_find_Create(TabWin):-
	tableedit_SetStartFindParam(TabWin),
	_ = vpi::winCreateDynDialog(TabWin,
		[
		 dlg(wdef(dlg_find_DlgType,dlg_find_RCT,dlg_find_Title,u_DlgBase),dlg_find_Flags),
		 ctl(wdef(wc_Edit,rct(60,5,190,17),"",u_DlgBase),con_findstr,[wsf_Group,wsf_TabStop,wsf_AutoHScroll,wsf_AlignLeft]),
		 ctl(wdef(wc_RadioButton,rct(9,29,64,39),tableedit_con_Scope,u_DlgBase),con_rb_entire,[wsf_TabStop,wsf_Auto,wsf_Group]),
		 ctl(wdef(wc_RadioButton,rct(9,40,64,50),tableedit_con_FromPoiter,u_DlgBase),con_rb_from,[wsf_TabStop,wsf_Auto]),
		 ctl(wdef(wc_RadioButton,rct(68,29,123,39),tableedit_con_Forward,u_DlgBase),con_rb_forward,[wsf_Auto,wsf_TabStop,wsf_Group]),
		 ctl(wdef(wc_RadioButton,rct(68,40,123,50),tableedit_con_Backward,u_DlgBase),con_rb_backward,[wsf_Auto,wsf_TabStop]),
		 ctl(wdef(wc_RadioButton,rct(129,30,189,40),tableedit_con_Entirestring,u_DlgBase),con_entirestring,[wsf_Auto,wsf_TabStop,wsf_Group]),
		 ctl(wdef(wc_RadioButton,rct(129,41,189,51),tableedit_con_Fromstart,u_DlgBase),con_fromstart,[wsf_TabStop,wsf_Auto]),
		 ctl(wdef(wc_RadioButton,rct(129,52,189,62),tableedit_con_Anypart,u_DlgBase),con_anypart,[wsf_TabStop,wsf_Auto]),
		 ctl(wdef(wc_LBoxButton,rct(6,72,121,140),"",u_DlgBase),con_findcolumn,[wsf_Group,wsf_TabStop,wsf_VScroll]),
		 ctl(wdef(wc_CheckBox,rct(126,72,200,82),tableedit_con_Casesensitive,u_DlgBase),con_Casesensitive,[wsf_Group,wsf_TabStop,wsf_Auto]),
		 ctl(wdef(wc_PushButton,rct(60,91,100,103),tableedit_con_find,u_DlgBase),idc_ok,[wsf_Default,wsf_Group,wsf_TabStop]),
		 ctl(wdef(wc_PushButton,rct(108,91,148,103),tableedit_con_Cancel,u_DlgBase),idc_cancel,[wsf_Group,wsf_TabStop]),
		 ctl(wdef(wc_Text,rct(6,58,54,68),tableedit_con_Columns,u_DlgBase),con_static_text,[wsf_AlignLeft]),
		 ctl(wdef(wc_Text,rct(6,6,56,16),tableedit_con_What,u_DlgBase),con_static_text1,[wsf_AlignLeft]),
		 ctl(wdef(wc_GroupBox,rct(6,19,65,55),tableedit_con_Origin,u_DlgBase),con_groupbox,[]),
		 ctl(wdef(wc_GroupBox,rct(67,19,125,55),tableedit_con_Diretion,u_DlgBase),con_groupbox1,[]),
		 ctl(wdef(wc_GroupBox,rct(127,19,190,66),tableedit_con_Match,u_DlgBase),con_groupbox2,[])
		],dlg_find_eh,0),
	!.
domains
  tableedit_CTLIDLIST = vpiDomains::ctlid*.
class predicates
   tableedit_set_FontList : (vpiDomains::winlist,vpiDomains::font)procedure anyflow.
    tableedit_get_CtlHandleList : (vpiDomains::windowHandle ParentWin,tableedit_CTLIDLIST) -> vpiDomains::winlist procedure anyflow.
clauses
  tableedit_get_CtlHandleList(_,[]) =[]:-!.
  tableedit_get_CtlHandleList(ParentWin,[CtrlId|T1]) =[CtrlWin|T2]:-
	CtrlWin = vpi::winGetCtlHandle(ParentWin,CtrlId),!,
	T2 = tableedit_get_CtlHandleList(ParentWin,T1).
  tableedit_get_CtlHandleList(_,_) =[]:-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_set_FontList([],_):-!.
  tableedit_set_FontList([CtrlWin|T],Font):-
	vpi::winSetFont(CtrlWin,Font),
	vpi::winSetState(CtrlWin,[wsf_Visible]),!,
	tableedit_set_FontList(T,Font).
  tableedit_set_FontList(_,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

  dlg_find_eh(DlgWin,e_Create(_)) =0:-!,
	TabWin=vpi::winGetParent(DlgWin),
	tableedit_SetFindParam(DlgWin,TabWin),
	CtrlWin = vpi::winGetCtlHandle(DlgWin,con_findstr),
	vpi::winSetFocus(CtrlWin),
	vpi::winSelectText (CtrlWin,0,500),
	trap(Font = vpi::winGetFont(TabWin), Id1, clear_and_fail(Id1)),
	FontSize = 9,
	trap(Font1 = vpi::fontSetAttrs(Font,[fs_Bold],FontSize), Id2, clear_and_fail(Id2)),
	CtlHandleList1 = tableedit_get_CtlHandleList(DlgWin,[con_findstr,con_rb_entire,con_rb_from,con_rb_forward,con_rb_backward,con_entirestring,con_fromstart,con_anypart,con_findcolumn,con_Casesensitive,idc_ok,idc_cancel,con_static_text,con_static_text1,con_groupbox,con_groupbox1,con_groupbox2]),
	tableedit_set_FontList(CtlHandleList1,Font1),
	!,fail.
  dlg_find_eh(DlgWin,e_Control(idc_ok,_CtrlType,_CtrlWin,_CtrlInfo)) =0:-!,
	TabWin=vpi::winGetParent(DlgWin),
	tableedit_ReSetFindParam(DlgWin,TabWin),
	tableedit_HandleFind(TabWin),
	vpi::winDestroy(DlgWin),
	trap(vpi::winSetFocus(TabWin), Id, clear_and_fail(Id)),
	!.
  dlg_find_eh(DlgWin,e_Control(idc_cancel,_CtrlType,_CtrlWin,_CtrlInfo)) =0:-!,
	vpi::winDestroy(DlgWin),
	!.
  dlg_find_eh(_,_) =_:-!,fail.



clauses

  tableedit_AssertStartData(Win,InputData):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	assert(tableedit_db_Data_Info(Win,InputData)),
	!.
  tableedit_AssertStartData(Win,_):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	assert(tableedit_db_Data_Info(Win,[])),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	!.
  tableedit_AssertStartData(_Win,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

% Request data for buffer, if Row not in RowRange
  tableedit_RequestBuff(Win,_Row):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	!.
  tableedit_RequestBuff(Win,Row):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_DataBufRange(Win,FromRow,ToRow),
	Row >= FromRow, Row<=ToRow,
	!.
  tableedit_RequestBuff(Win,FromRow):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,RowBuffSize,MaxRows))),
	Row = ((FromRow - 1) div RowBuffSize + 1) * RowBuffSize - RowBuffSize + 1,
	ToRow = Row + RowBuffSize - 1, ToRow <= MaxRows,
	AnsFunc(Win,Row,ToRow,Data),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,Row,ToRow)),
	retractAll(tableedit_db_Data_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,Data)),
	!.
  tableedit_RequestBuff(Win,FromRow):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,RowBuffSize,MaxRows))),
	Row = ((FromRow - 1) div RowBuffSize + 1) * RowBuffSize - RowBuffSize + 1,
	ToRow = Row + RowBuffSize - 1, ToRow > MaxRows,
	AnsFunc(Win,Row,MaxRows,Data),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,Row,MaxRows)),
	retractAll(tableedit_db_Data_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,Data)),
	!.
  tableedit_RequestBuff(_Win,_Row):-!.

% Request data for buffer, if FromRow - ToRow not in RowRange
  tableedit_RequestBuff(Win,_FromRow,_ToRow):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	!.
  tableedit_RequestBuff(Win,FromRow1,ToRow1):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_DataBufRange(Win,FromRow,ToRow),
	FromRow1 >= FromRow, ToRow1 <= ToRow,
	!.
  tableedit_RequestBuff(Win,FromRow,_ToRow1):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,RowBuffSize,MaxRows))),
	FromRow1 = ((FromRow - 1) div RowBuffSize + 1) * RowBuffSize - RowBuffSize + 1,
	ToRow = FromRow1 + RowBuffSize - 1, ToRow <= MaxRows,
	AnsFunc(Win,FromRow1,ToRow,Data),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,FromRow1,ToRow)),
	retractAll(tableedit_db_Data_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,Data)),
	!.
  tableedit_RequestBuff(Win,FromRow,_ToRow1):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,RowBuffSize,MaxRows))),
	FromRow1 = ((FromRow - 1) div RowBuffSize + 1) * RowBuffSize - RowBuffSize + 1,
	ToRow = FromRow1 + RowBuffSize - 1, ToRow > MaxRows,
	AnsFunc(Win,FromRow1,MaxRows,Data),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,FromRow1,MaxRows)),
	retractAll(tableedit_db_Data_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,Data)),
	!.
  tableedit_RequestBuff(_Win,_FromRow1,_ToRow1):-!.

  tableedit_GetBuffCellData(Win,Row,Column,CellData):-
	tableedit_RequestBuff(Win,Row),
	tableedit_db_DataBufRange(Win,FromRow,_ToRow),
	tableedit_db_Data_Info(Win,Data),
	XRow = Row - FromRow + 1,
	tableedit_member_index(ColumnData,Data,XRow),
	tableedit_member_index(CellData,ColumnData,Column),
	!.
  tableedit_GetBuffCellData(_,_,_,void):- common_exception::raise_Error(classInfo, predicate_fullName()).

class predicates
  tableedit_OptimAnswer : (vpiDomains::windowHandle)procedure anyflow.
clauses

  tableedit_OptimAnswer(Win):-
	tableedit_db_DataBufRange(Win,FromRow,_ToRow1),
	retract(tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn)),
	asserta(tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn)),
	!.
  tableedit_OptimAnswer(_Win):-!.

  tableedit_SeparateAnswer(Win):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,RowBuffSize,_MaxRows))),
	tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn),
	FromRow1 = ((FromRow - 1) div RowBuffSize + 1) * RowBuffSize - RowBuffSize + 1,
	RowBuffSize < ToRow - FromRow1 + 1,
	retract(tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn)),
	ToRow1 = FromRow1 + RowBuffSize - 1,
	FromRow2 = ToRow1 + 1,
	assertz(tableedit_db_AnswerRange(Win,FromRow1,ToRow1,FromColumn,ToColumn)),
	assertz(tableedit_db_AnswerRange(Win,FromRow2,ToRow,FromColumn,ToColumn)),!,
	tableedit_SeparateAnswer(Win).
  tableedit_SeparateAnswer(Win):- tableedit_OptimAnswer(Win),!.

  tableedit_HandleBuffAnswer(Win):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn),
	tableedit_RequestBuff(Win,FromRow,ToRow),
	tableedit_HandleBuffAnswer1(Win,FromRow,ToRow,FromColumn,ToColumn),
	!.
  tableedit_HandleBuffAnswer(_Win):-!.

class predicates
  tableedit_RepHandleNextAnswer : (vpiDomains::windowHandle)procedure anyflow.
clauses

  tableedit_HandleBuffAnswer1(Win,FromRow,ToRow,FromColumn,ToColumn):-
	retract(tableedit_db_AnswerRange(Win,FromRow,ToRow,FromColumn,ToColumn)),
	tableedit_db_DataBufRange(Win,From_Row,_To_Row),
	FromRow1 = FromRow - From_Row + 1,
	ToRow1 = ToRow - From_Row + 1,
	tableedit_GetGridDataFromTo(Win,FromRow1,ToRow1,FromColumn,ToColumn,AnswerList),
	AnswerData = data_answer(grid_area_answer(AnswerList)),
	vpiGrid::draw(Win,FromRow,ToRow,FromColumn,ToColumn,AnswerData),
	tableedit_RepHandleNextAnswer(Win),
	!.
  tableedit_HandleBuffAnswer1(_Win,_FromRow,_ToRow,_,_):-!.

  tableedit_RepHandleNextAnswer(Win):-
	tableedit_db_AnswerRange(Win,_FromRow,_ToRow,_,_),
	vpi::winPostEvent(Win,e_User(6623,1)),
	!.
  tableedit_RepHandleNextAnswer(_):-!.

  tableedit_BuffInvalidate(Win):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	trap(vpiGrid::invalidate(Win,grid_all), Id, clear_and_fail(Id)),
	!.
  tableedit_BuffInvalidate(_):-!.

  tableedit_BuffInvalidate(Win,Row):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_DataBufRange(Win,FromRow,ToRow),
	Row >= FromRow,	Row <= ToRow,
	tableedit_BuffInvalidate(Win),
	!.
  tableedit_BuffInvalidate(_,_):-!.

class predicates
  tableedit_SetRelativeWidth : (vpiDomains::windowHandle Win,core::booleanInt NotResizableResize,integer Col,integer MaxCol,integer ResizableW,integer Factor,integer AreaWidth,integer,integer)procedure anyflow.
  tableedit_GetScrollWidth : (vpiDomains::windowHandle Win,integer ScrollWidth)procedure anyflow.
  tableedit_CalcColSize : (vpiDomains::windowHandle Win,core::booleanInt Resizable,integer Col,integer Maxcol,integer,integer TotalWidth)procedure anyflow.
  tableedit_GetSelectorWidth : (vpiDomains::windowHandle Win,integer SelectorWidth)procedure anyflow.
  tableedit_CorrectWidth : (integer Old,integer New)procedure anyflow.
  tableedit_CalcNewWidth : (integer,integer,integer,integer)procedure anyflow.
  tableedit_CheckResizable : (tableedit_columnproperties,core::booleanInt NotResizableResize)determ anyflow.

clauses

  tableedit_CorrectWidth(Old,Old):- Old >= 1,!.
  tableedit_CorrectWidth(_Old,1):-!.

  tableedit_CalcNewWidth(W,WW1,ResizableW,NewW2):-
	not(ResizableW = 0),
	Factor = WW1/ResizableW,
	NewW2 = convert(integer,W * Factor),
	!.
  tableedit_CalcNewWidth(_W,_WW1,_ResizableW,0):-!.

  tableedit_CheckResizable(Cprop,NotResizableResize):-
	NotResizableResize = b_false,
	tableedit_member(resizable(b_true),Cprop),
	!.
  tableedit_CheckResizable(_Cprop,NotResizableResize):-
	NotResizableResize = b_true,
	!.

  tableedit_SetRelativeWidth(Win,NotResizableResize,Col,NCol,_ResizableW,_WW1,WW2,NewW,NewW):-
	Col = NCol,
	Cprop = tableedit_getcolumnproperties(Win,Col),
	tableedit_CheckResizable(Cprop,NotResizableResize),
	NewW2 = WW2 - NewW,
	tableedit_CorrectWidth(NewW2,Width),
	tableedit_setcolumnproperties(Win,Col,[width(Width)]),
	!.
  tableedit_SetRelativeWidth(Win,_,Col,NCol,_ResizableW,_WW1,_WW2,NewW,NewW):-
	Col = NCol,
	Cprop = tableedit_getcolumnproperties(Win,Col),
	tableedit_member(resizable(b_false),Cprop),
	!.
  tableedit_SetRelativeWidth(Win,NotResizableResize,Col1,NCol,ResizableW,WW1,WW2,NewW1,NewW):-
	Cprop = tableedit_getcolumnproperties(Win,Col1),
	tableedit_CheckResizable(Cprop,NotResizableResize),
	tableedit_member(width(W),Cprop),
	tableedit_CalcNewWidth(W,WW1,ResizableW,NewW2),
	tableedit_CorrectWidth(NewW2,Width),
	tableedit_setcolumnproperties(Win,Col1,[width(Width)]),
	NewW3 = NewW1 + Width, Col2 = Col1 + 1,!,
	tableedit_SetRelativeWidth(Win,NotResizableResize,Col2,NCol,ResizableW,WW1,WW2,NewW3,NewW).
  tableedit_SetRelativeWidth(Win,NotResizableResize,Col1,NCol,ResizableW,WW1,WW2,NewW1,NewW):-
	Cprop = tableedit_getcolumnproperties(Win,Col1),
	tableedit_member(resizable(b_false),Cprop),
	tableedit_member(width(W),Cprop),
	NewW3 = NewW1 + W, Col2 = Col1 + 1,!,
	tableedit_SetRelativeWidth(Win,NotResizableResize,Col2,NCol,ResizableW,WW1,WW2,NewW3,NewW).
  tableedit_SetRelativeWidth(_,_,_,_,_,_,_,_,0):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_GetScrollWidth(Win,ScrollW):-
	tableedit_db_VScroll(Win),
	ScrollW = vpi::getAttrVal(attr_ctl_vert_sbar_width),
	!.
  tableedit_GetScrollWidth(_Win,0):-!.

  tableedit_GetSelectorWidth(Win,SelW):-
	Prop = tableedit_getproperties(Win),
	tableedit_member(rowselector(_,SelW,_),Prop),
	!.
  tableedit_GetSelectorWidth(_Win,0):-!.
	
  tableedit_CalcColSize(_Win,_Resizable,Col,Ncol,TotalW,TotalW):- Col>Ncol,!.
  tableedit_CalcColSize(Win,Resizable,Col1,Ncol,TotalW1,TotalW):-
	Cprop = tableedit_getcolumnproperties(Win,Col1),
	tableedit_member(width(W),Cprop),
	tableedit_member(resizable(Resizable),Cprop),
	TotalW2 = TotalW1 + W, Col2 = Col1 + 1,!,
	tableedit_CalcColSize(Win,Resizable,Col2,Ncol,TotalW2,TotalW).
  tableedit_CalcColSize(Win,Resizable,Col1,Ncol,TotalW1,TotalW):-
	Col2 = Col1 + 1,!,
	tableedit_CalcColSize(Win,Resizable,Col2,Ncol,TotalW1,TotalW).
	


clauses
  tableedit_init(Win,TabProp,ColumnList,InputData):-
	retractAll(tableedit_db_Te_Info(Win,_)),
	retractAll(tableedit_db_Col_Info(Win,_,_)),
	retractAll(tableedit_db_Data_Info(Win,_)),
	retractAll(tableedit_db_ShadowData_Info(Win,_)),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	tableedit_CliarUndoRedoData(Win),
	assert(tableedit_db_InitMode(Win)),
	% assert default Property
	tableedit_InitDefaultEditor(Win),
	% reassert Property from list 
	tableedit_ReAssertPropertyList(Win,TabProp),
	% assert visible Data from list 
	tableedit_AssertStartData(Win,InputData),
	% assert shadow Data from list 
	assert(tableedit_db_ShadowData_Info(Win,[])),
	% assert default column property and reassert from list for columns
	tableedit_InitColumns(Win,0,ColumnList),
	trap(tableedit_Grid_Init(Win,InputData), Id, clear_and_fail(Id)),!.
  tableedit_init(_,_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getproperties(Win) =TabProperties:-
	tableedit_db_Te_Info(Win,_),
	findall(Prop,tableedit_db_Te_Info(Win,Prop),TabProperties),!.
  tableedit_getproperties(_) =[]:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setproperties(Win,TabProp):-
	vpiGrid::marker(Win,grid_no_marker),
	retractAll(tableedit_db_InitMode(Win)),
	assert(tableedit_db_InitMode(Win)),
	tableedit_ReAssertPropertyList(Win,TabProp),
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	trap(Data = tableedit_getalldata(Win), Id1, clear_and_fail(Id1)),
	retractAll(tableedit_db_Data_Info(Win,_)),
	retractAll(tableedit_db_ShadowData_Info(Win,_)),
	assert(tableedit_db_Data_Info(Win,Data)),
	assert(tableedit_db_ShadowData_Info(Win,[])),
	trap(tableedit_Grid_Init(Win,Data), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_setproperties(Win,_TabProp):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	trap(tableedit_Grid_Init(Win,[]), Id, clear_and_fail(Id)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_setproperties(_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getcolumnproperties(Win,Column) =ColProperties:-
	trap(vpiGrid::columnStyle(Win,CS), Id, clear_and_fail(Id)), 
	CS = grid_columnStyle(_NS,CLIst),
	tableedit_ResetColWidth(Win,CLIst,1),
	tableedit_db_Col_Info(Win,Column,_),
	findall(Prop,tableedit_db_Col_Info(Win,Column,Prop),ColProperties),!.
  tableedit_getcolumnproperties(_,_) =[]:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setcolumnproperties(Win,Column,ColProperties):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	vpiGrid::marker(Win,grid_no_marker),
	tableedit_InitColumn(Win,Column,ColProperties),
	tableedit_CreateGridColumnList(Win,GridColumnStyle),
	assert(tableedit_db_InitMode(Win)),
	tableedit_db_Col_Info(Win,Column,filterlist(FilterList)),
	tableedit_setcolumnfilter(Win,Column,FilterList),
	tableedit_db_Te_Info(Win,sortedby(Col)),
	tableedit_sort(Win,Col),
	retractAll(tableedit_db_InitMode(Win)),
	tableedit_db_Data_Info(Win,Data),
	tableedit_CalcMaxRows(Win,Data,MaxRows),
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),
	trap(vpiGrid::columnStyle(Win,GridColumnStyle), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_setcolumnproperties(Win,Column,ColProperties):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,MaxRows))),
	vpiGrid::marker(Win,grid_no_marker),
	tableedit_InitColumn(Win,Column,ColProperties),
	tableedit_CreateGridColumnList(Win,GridColumnStyle),
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),
	trap(vpiGrid::columnStyle(Win,GridColumnStyle), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_setcolumnproperties(_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getmarker(Win) =GridMarker:-
    trap(vpiGrid::marker(Win,GridMarker), Id, clear_and_fail(Id)),!.
  tableedit_getmarker(_) =grid_no_marker:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setmarker(Win,GridMarker):-
    trap(vpiGrid::marker(Win,GridMarker), Id, clear_and_fail(Id)),!.
  tableedit_setmarker(_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% Set all data for nobuffering mode
% Request data from database for buffering mode (ignore NewData)
  tableedit_setalldata(Win,NewData):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Data_Info(Win,_),
	retractAll(tableedit_db_ShadowData_Info(Win,_)),
	assert(tableedit_db_ShadowData_Info(Win,[])),
	retract(tableedit_db_Data_Info(Win,_)),
	tableedit_db_Te_Info(Win,sortedby(Col)),
	tableedit_SortData(Win,Col,NewData,NewData1),
	assert(tableedit_db_Data_Info(Win,NewData1)),
	tableedit_CalcMaxRows(Win,NewData1,MaxRows),
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),
	trap(vpiGrid::invalidate(Win,grid_all), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_setalldata(Win,_NewData):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,MaxRows))),
	tableedit_db_Data_Info(Win,_),
	retractAll(tableedit_db_ShadowData_Info(Win,_)),
	assert(tableedit_db_ShadowData_Info(Win,[])),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),
	trap(vpiGrid::invalidate(Win,grid_all), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_setalldata(_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getallvisibledata(Win) =Data:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Data_Info(Win,Data),!.
  tableedit_getallvisibledata(Win) =Data:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,_RowBuffSize,MaxRows))),
	AnsFunc(Win,1,MaxRows,Data),
	!.
  tableedit_getallvisibledata(_) =[]:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getalldata(Win) =OutData1:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_ShadowData_Info(Win,ShadowData),
	tableedit_db_Data_Info(Win,VisibleData),
	tableedit_db_Te_Info(Win,footers(F)),
	tableedit_CalcMaxRows(Win,VisibleData,MaxRows), FootPos = MaxRows - F + 1,
	tableedit_InsListRows(Win,FootPos,ShadowData,VisibleData,[],OutData1),
	!.
  tableedit_getalldata(Win) =Data:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,_RowBuffSize,MaxRows))),
	AnsFunc(Win,1,MaxRows,Data),
	!.
  tableedit_getalldata(_) =[]:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getdata(Win,FrRow,ToRow,FRColumn,ToColumn) =OutData:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Data_Info(Win,Data),
	tableedit_GetDataFromToRow(Win,1,FrRow,ToRow,FRColumn,ToColumn,Data,[],OutData),!.
  tableedit_getdata(Win,FrRow,ToRow,FRColumn,ToColumn) =OutData:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	tableedit_db_DataBufRange(Win,FromRowB,ToRowB),
	FrRow >= FromRowB, ToRow <= ToRowB,
	tableedit_db_Data_Info(Win,Data),
	FrRow1 = FrRow - FromRowB + 1,
	ToRow1 = ToRow - FromRowB + 1,
	tableedit_GetDataFromToRow(Win,1,FrRow1,ToRow1,FRColumn,ToColumn,Data,[],OutData),!.
  tableedit_getdata(Win,FrRow,ToRow,FRColumn,ToColumn) =OutData:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,_RowBuffSize,_MaxRows))),
	AnsFunc(Win,FrRow,ToRow,Data), FrRow1 = 1, ToRow1 = ToRow - FrRow + 1,
	tableedit_GetDataFromToRow(Win,1,FrRow1,ToRow1,FRColumn,ToColumn,Data,[],OutData),!.
  tableedit_getdata(_,_,_,_,_) =[]:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ---ignore for NObuffering mode
  tableedit_buff_invalidatearea(Win,FrRow,ToRow,FRColumn,ToColumn):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	trap(vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,FRColumn,ToColumn)), Id, clear_and_fail(Id)),
	!.	
  tableedit_buff_invalidatearea(_,_,_,_,_):-!.


  tableedit_setdata(Win,FrRow,ToRow,FRColumn,ToColumn,InData):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_SetDataFromToRow(Win,b_false,1,FrRow,ToRow,FRColumn,ToColumn,InData,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),
	trap(vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,FRColumn,ToColumn)), Id, clear_and_fail(Id)),
	!.
  tableedit_setdata(Win,FrRow,ToRow,FRColumn,ToColumn,InData):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	ToCol = tableedit_maxcol(Win),
	Data = tableedit_getdata(Win,FrRow,ToRow,1,ToCol),
	ToRow1 = ToRow - FrRow + 1,
	tableedit_SetDataFromToRow(Win,b_true,FrRow,1,ToRow1,FRColumn,ToColumn,InData,Data,[],_NewData),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	trap(vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,FRColumn,ToColumn)), Id, clear_and_fail(Id)),
	!.
  tableedit_setdata(_,_,_,_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setcelldata(Win,Row,Column,CellData):-
	trap(tableedit_setdata(Win,Row,Row,Column,Column,[[CellData]]), Id, clear_and_fail(Id)),!.
  tableedit_setcelldata(_,_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getcelldata(Win,Row,Column) =CellData:-
	trap(Data = tableedit_getdata(Win,Row,Row,Column,Column), Id, clear_and_fail(Id)),
	Data = [[CellData]],!.	
  tableedit_getcelldata(_,_,_) =void:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setactiverow(Win,ActiveRow):-
	MaxRows = tableedit_maxvisiblerows(Win),
	ActiveRow <= MaxRows,
	trap(vpiGrid::activeRow(Win,ActiveRow), Id, clear_and_fail(Id)),!.
  tableedit_setactiverow(_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getactiverow(Win) =ActiveRow:-
	trap(vpiGrid::activeRow(Win,ActiveRow), Id, clear_and_fail(Id)),!.
  tableedit_getactiverow(_) =0:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_maxcol(Win) =Col:- 
	tableedit_CalcMaxCol(Win,Col),
	not(Col = 0),!.
  tableedit_maxcol(_) =0:- 
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_maxvisiblerows(Win) =MaxRows:-
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),!.
  tableedit_maxvisiblerows(_) =0:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_maxrows(Win) =Rows:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),
	tableedit_db_ShadowData_Info(Win,ShadowData),
	tableedit_CalcMaxRows(Win,ShadowData,ShadowRows),
	Rows = MaxRows + ShadowRows,!.
  tableedit_maxrows(Win) =Rows:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	Rows = tableedit_maxvisiblerows(Win),!.
  tableedit_maxrows(_) =0:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ---ignore for NObuffering mode
  tableedit_buff_setmaxrows(Win,MaxRows):-
	retract(tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,RowBuffSize,_MaxRowsOld)))),
	assert(tableedit_db_Te_Info(Win,bufferingmode(buffering(AnsFunc,RowBuffSize,MaxRows)))),
	trap(vpiGrid::rows(Win,MaxRows), Id, clear_and_fail(Id)),!.
  tableedit_buff_setmaxrows(_Win,_MaxRows):-!.

  tableedit_getrowdata(Win,FrRow,ToRow) =String:-
	tableedit_CalcMaxCol(Win,MaxCol),
	Data = tableedit_getdata(Win,FrRow,ToRow,1,MaxCol),
	not(Data = []),
	tableedit_CreateStringRowsData(Data,String),
	!.
  tableedit_getrowdata(_,_,_) ="":-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getclipboarddata(Win,FrRow,ToRow,FromCol,ToCol) =String:-
	Data = tableedit_getdata(Win,FrRow,ToRow,FromCol,ToCol),
	not(Data = []),
	tableedit_CreateStringRowsData(Data,String),
	!.
  tableedit_getclipboarddata(_,_,_,_,_) ="":-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% Ignore for buffering mode
  tableedit_setrowdata(Win,FrRow,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retractAll(tableedit_db_PasteError(Win)),
	tableedit_db_Data_Info(Win,Data),
	tableedit_CalcMaxRows(Win,Data,MaxRows),
	trap(ToCol = tableedit_maxcol(Win), Id, clear_and_fail(Id)),
	tableedit_SetStrDataFromToRow(Win,b_false,FrRow,1,1,MaxRows,1,ToCol,SourceStr,Data,[],NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	retract(tableedit_db_Data_Info(Win,Data)),
	assert(tableedit_db_Data_Info(Win,NewData)),
	trap(vpiGrid::invalidate(Win,grid_all), Id2, clear_and_fail(Id2)),!.
  tableedit_setrowdata(Win,_FrRow,_SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_setrowdata(_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setrowdata(Win,FrRow,ToRow,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retractAll(tableedit_db_PasteError(Win)),
	tableedit_db_Data_Info(Win,Data),
	trap(ToCol = tableedit_maxcol(Win), Id, clear_and_fail(Id)),
	tableedit_SetStrDataFromToRow(Win,b_false,FrRow,1,1,ToRow,1,ToCol,SourceStr,Data,[],NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	retract(tableedit_db_Data_Info(Win,Data)),
	assert(tableedit_db_Data_Info(Win,NewData)),
	trap(vpiGrid::invalidate(Win,grid_all), Id2, clear_and_fail(Id2)),!.
  tableedit_setrowdata(Win,FrRow,ToRow,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	retractAll(tableedit_db_PasteError(Win)),
	ToCol = tableedit_maxcol(Win),
	Data = tableedit_getdata(Win,FrRow,ToRow,1,ToCol),
	tableedit_SetStrDataFromToRow(Win,b_true,1,FrRow,FrRow,ToRow,1,ToCol,SourceStr,Data,[],NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	not(Data = NewData),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	trap(vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,1,ToCol)), Id, clear_and_fail(Id)),
	!.
  tableedit_setrowdata(Win,_FrRow,_ToRow,_SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	not(tableedit_db_PasteError(Win)),
	!.
  tableedit_setrowdata(_,_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setclipboarddata(Win,FrRow,ToRow,FromCol,ToCol,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retractAll(tableedit_db_PasteError(Win)),
	tableedit_db_Data_Info(Win,Data),
	trap(ToCol = tableedit_maxcol(Win), Id, clear_and_fail(Id)),
	tableedit_SetStrDataFromToRow(Win,b_false,FrRow,1,1,ToRow,FromCol,ToCol,SourceStr,Data,[],NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	retract(tableedit_db_Data_Info(Win,Data)),
	assert(tableedit_db_Data_Info(Win,NewData)),
	trap(vpiGrid::invalidate(Win,grid_all), Id2, clear_and_fail(Id2)),!.
  tableedit_setclipboarddata(Win,FrRow,ToRow,FromCol,ToCol,SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	retractAll(tableedit_db_PasteError(Win)),
	Col = tableedit_maxcol(Win),
	Data = tableedit_getdata(Win,FrRow,ToRow,1,Col),
	tableedit_SetStrDataFromToRow(Win,b_true,1,FrRow,FrRow,ToRow,FromCol,ToCol,SourceStr,Data,[],NewData,0,_NSet),
	not(tableedit_db_PasteError(Win)),
	not(Data = NewData),
	retractAll(tableedit_db_DataBufRange(Win,_,_)),
	assert(tableedit_db_DataBufRange(Win,0,0)),
	trap(vpiGrid::invalidate(Win,grid_area(FrRow,ToRow,FromCol,ToCol)), Id, clear_and_fail(Id)),
	!.
  tableedit_setclipboarddata(Win,_FrRow,_ToRow,_FromCol,_ToCol,_SourceStr):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	not(tableedit_db_PasteError(Win)),
	!.
  tableedit_setclipboarddata(_,_,_,_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ignore for buffering mode
  tableedit_setcolumnfilter(Win,Column,FilterList):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retract(tableedit_db_Col_Info(Win,Column,filterlist(_))),
	assert(tableedit_db_Col_Info(Win,Column,filterlist(FilterList))),
	tableedit_ProcessFilter(Win),
	!.
  tableedit_setcolumnfilter(Win,_Column,_FilterList):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_setcolumnfilter(_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ignore for buffering mode
  tableedit_resetfilters(Win,Filters):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retractAll(tableedit_db_Col_Info(Win,_,filterlist(_))),
	tableedit_CliarFilters(Win),
	tableedit_SetFilters(Win,Filters),
	!.
  tableedit_resetfilters(Win,_Filters):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_resetfilters(_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ignore for buffering mode
  tableedit_sort(Win,Col):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Col_Info(Win,Col,sortmode(ascending(Ilist))),
	tableedit_db_Te_Info(Win,compare(CompareFunc)),
	trap(Data = tableedit_getallvisibledata(Win), Id, clear_and_fail(Id)),
	tableedit_CutHeadersFooters(Win,Data,Data1,HeadData,FootData),
	tableedit_sort_data(Win,CompareFunc,b_true,[Col|Ilist],Data1,NewData),
	tableedit_InsHeadersFooters(Win,NewData,OutData,HeadData,FootData),
	trap(tableedit_SetAllDataNoSort(Win,OutData), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_sort(Win,Col):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Col_Info(Win,Col,sortmode(descending(Ilist))),
	tableedit_db_Te_Info(Win,compare(CompareFunc)),
	trap(Data = tableedit_getallvisibledata(Win), Id, clear_and_fail(Id)),
	tableedit_CutHeadersFooters(Win,Data,Data1,HeadData,FootData),
	tableedit_sort_data(Win,CompareFunc,b_false,[Col|Ilist],Data1,NewData),
	tableedit_InsHeadersFooters(Win,NewData,OutData,HeadData,FootData),
	trap(tableedit_SetAllDataNoSort(Win,OutData), Id2, clear_and_fail(Id2)),
	tableedit_CliarUndoRedoData(Win),
	!.
  tableedit_sort(Win,Col):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_db_Col_Info(Win,Col,sortmode(_)),!.
  tableedit_sort(Win,_Col):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_sort(_Win,_):-!.

% ignore for buffering mode
% delete rows contains in line list
  tableedit_deleterows(Win,LList):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_DelRows(Win,b_false,LList),
	tableedit_db_Data_Info(Win,NewData),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	vpiGrid::rows(Win,MaxRows),!.
  tableedit_deleterows(Win,_):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_deleterows(_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ignore for buffering mode
  tableedit_insertrows(Win,Row,InsData):-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_SaveInsDataForUndo(Win,Row,InsData),
	tableedit_InsListRows(Win,Row,InsData,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	vpiGrid::rows(Win,MaxRows),!.
  tableedit_insertrows(Win,_Row,_InsData):-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_insertrows(_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ignore for buffering mode
  tableedit_insertrowstoend(Win,InsData) =FromRow:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_db_Te_Info(Win,footers(F)),
	tableedit_CalcMaxRows(Win,Data,MaxRowsOld),
	Row = MaxRowsOld - F + 1, FromRow = Row,
	tableedit_SaveInsDataForUndo(Win,Row,InsData),
	tableedit_InsListRows(Win,Row,InsData,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	vpiGrid::rows(Win,MaxRows),!.
  tableedit_insertrowstoend(Win,_InsData) =0:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_insertrowstoend(_,_) =0:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

% ignore for buffering mode
  tableedit_insertdefrowstoend(Win,Nrows) =FromRow:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	retract(tableedit_db_Data_Info(Win,Data)),
	tableedit_db_Te_Info(Win,footers(F)),
	tableedit_CalcMaxRows(Win,Data,MaxRowsOld),
	Row = MaxRowsOld - F + 1,  FromRow = Row,
	tableedit_CreateDefRow(Win,1,[],DefData),
	tableedit_CreateDefRows(Win,Nrows,DefData,[],InsData),
	tableedit_SaveInsDataForUndo(Win,Row,InsData),
	tableedit_InsListRows(Win,Row,InsData,Data,[],NewData),
	assert(tableedit_db_Data_Info(Win,NewData)),
	tableedit_CalcMaxRows(Win,NewData,MaxRows),
	vpiGrid::rows(Win,MaxRows),
	!.
  tableedit_insertdefrowstoend(Win,_Nrows) =0:-
	tableedit_db_Te_Info(Win,bufferingmode(buffering(_AnsFunc,_RowBuffSize,_MaxRows))),
	!.
  tableedit_insertdefrowstoend(_,_) =0:-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setvisitorder(Win,Key,ShiftCtlAlt,Key_Action):-
	vpiGrid::visitOrder(Win,Key,ShiftCtlAlt,Key_Action),!.
  tableedit_setvisitorder(_,_,_,_):-
	common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getvisitorder(Win,Key,ShiftCtlAlt) =Key_Action:-
	vpiGrid::visitOrder(Win,Key,ShiftCtlAlt,Key_Action),!.

% fail for buffering mode, fail for nobuffering mode,if string not find.
  tableedit_find(Win,Str,Direction,Column,Match,CaseSens) =RowPosition:-
	tableedit_db_Te_Info(Win,bufferingmode(nobuffering)),
	tableedit_FindString(Win,Str,Direction,Column,Match,CaseSens,RowPosition),
	!.

  tableedit_optimizecolumnswidth(Win,NotResizableResize):-
	NotResizableResize = b_false,
	Flags = vpi::winGetState(Win),
	vpi::winSetState(Win,[wsf_Invisible]),
	NCol = tableedit_maxcol(Win),
	tableedit_CalcColSize(Win,b_true,1,Ncol,0,ResizableW),
	tableedit_CalcColSize(Win,b_false,1,Ncol,0,NotResizableW),
	tableedit_GetScrollWidth(Win,ScrollWidth),
	tableedit_GetSelectorWidth(Win,SelectorWidth),
	SW = ScrollWidth + SelectorWidth,
	RCT = vpi::winGetClientRect(Win), RCT = rct(_,_,WW,_),
	WW1 = WW - NotResizableW - SW,
	WW2 = WW - SW,
	tableedit_SetRelativeWidth(Win,NotResizableResize,1,NCol,ResizableW,WW1,WW2,0,_),
	vpi::winSetState(Win,Flags),
	!.
  tableedit_optimizecolumnswidth(Win,NotResizableResize):-
	NotResizableResize = b_true,
	Flags = vpi::winGetState(Win),
	vpi::winSetState(Win,[wsf_Invisible]),
	NCol = tableedit_maxcol(Win),
	tableedit_CalcColSize(Win,b_true,1,Ncol,0,RW),
	tableedit_CalcColSize(Win,b_false,1,Ncol,0,NRW),
	ResizableW = RW + NRW,
	NotResizableW = 0,
	tableedit_GetScrollWidth(Win,ScrollWidth),
	tableedit_GetSelectorWidth(Win,SelectorWidth),
	SW = ScrollWidth + SelectorWidth,
	RCT = vpi::winGetClientRect(Win), RCT = rct(_,_,WW,_),
	WW1 = WW - NotResizableW - SW,
	WW2 = WW - SW,
	tableedit_SetRelativeWidth(Win,NotResizableResize,1,NCol,ResizableW,WW1,WW2,0,_),
	vpi::winSetState(Win,Flags),
	!.
  tableedit_optimizecolumnswidth(_Win,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_getinvisiblemarkers(Win) =InvisibleVisible:-
	trap(vpiGrid::invisibleMarkers(Win,InvisibleVisible), Id, clear_and_fail(Id)),
	!.
  tableedit_getinvisiblemarkers(_Win) =b_false:-common_exception::raise_Error(classInfo, predicate_fullName()).

  tableedit_setinvisiblemarkers(Win,InvisibleVisible):-
	trap(vpiGrid::invisibleMarkers(Win,InvisibleVisible), Id, clear_and_fail(Id)),
	!.
  tableedit_setinvisiblemarkers(_Win,_):-common_exception::raise_Error(classInfo, predicate_fullName()).

%procedure vpiGrid::invisibleMarkers(WINDOW GridWin,BOOLEAN InvisibleVisible) - (i,i), (i,o)


  tableedit_handleevent(GridWin,Event):-
	tableedit_HandleEvent1(GridWin,Event),
	vpiGrid::handleEvent(GridWin,EVENT).

    class predicates
        clear_and_fail : (exception::traceID ID) failure (i).
    clauses
        clear_and_fail(Id) :-
            trap(exception::clear(Id), _, fail),
            fail.

end implement vpiTableed